/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/terminal/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],Z=function(q){for(var e=[],w=0,n=q.length;w<n;w++)e[w]=J[q[w]];return e};define(J[105],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(n,R){if(!n)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=w}),define(J[106],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(M){return M?M.replace(/\$\((.*?)\)/g,(b,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=w;class n{constructor(b,m,y){this.id=b,this.definition=m,this.description=y,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function R(M,b){const m=["codicon","codicon-"+M];return b&&m.push("codicon-modifier-"+b),m}e.getClassNamesArray=R;var C;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function m(k){if(k instanceof n)return["codicon","codicon-"+k.id];const I=b.exec(k.id);if(!I)return m(n.error);let[,p,t]=I;const h=["codicon","codicon-"+p];return t&&h.push("codicon-modifier-"+t.substr(1)),h}M.asClassNameArray=m;function y(k){return m(k).join(" ")}M.asClassName=y;function E(k){return"."+m(k).join(".")}M.asCSSSelector=E})(C=e.CSSIcon||(e.CSSIcon={}))}),define(J[46],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(M){return(b,m,y)=>{let E=null,k=null;if(typeof y.value=="function"?(E="value",k=y.value):typeof y.get=="function"&&(E="get",k=y.get),!k)throw new Error("not supported");y[E]=M(k,m)}}e.createDecorator=w;function n(M,b,m){let y=null,E=null;if(typeof m.value=="function"?(y="value",E=m.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(y="get",E=m.get),!E)throw new Error("not supported");const k=`$memoize$${b}`;m[y]=function(...I){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,I)}),this[k]}}e.memoize=n;function R(M,b,m){return w((y,E)=>{const k=`$debounce$${E}`,I=`$debounce$result$${E}`;return function(...p){this[I]||(this[I]=m?m():void 0),clearTimeout(this[k]),b&&(this[I]=b(this[I],...p),p=[this[I]]),this[k]=setTimeout(()=>{y.apply(this,p),this[I]=m?m():void 0},M)}})}e.debounce=R;function C(M,b,m){return w((y,E)=>{const k=`$throttle$timer$${E}`,I=`$throttle$result$${E}`,p=`$throttle$lastRun$${E}`,t=`$throttle$pending$${E}`;return function(...h){if(this[I]||(this[I]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[I]=b(this[I],...h)),this[t])return;const g=this[p]+M;g<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[I]]),this[I]=m?m():void 0):(this[t]=!0,this[k]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),y.apply(this,[this[I]]),this[I]=m?m():void 0},g-Date.now()))}})}e.throttle=C}),define(J[15],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(u=>{u(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=w,e.errorHandler=new w;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function R(c){m(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function C(c){m(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=C;function M(c){if(c instanceof Error){let{name:o,message:u}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:o,message:u,stack:r}}return c}e.transformErrorForSerialization=M;const b="Canceled";function m(c){return c instanceof y?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=m;class y extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=y;function E(){const c=new Error(b);return c.name=c.message,c}e.canceled=E;function k(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=k;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class g extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=g;class v extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=v;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function d(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=d;function f(c,o=Object.create(null)){const u=new Error(c);return o.actions&&(u.actions=o.actions),u}e.createErrorWithActions=f}),define(J[30],Z([0,1,15]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(T,A=0){return T[T.length-(1+A)]}e.tail=n;function R(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=R;function C(T,A,O=(_,Y)=>_===Y){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let _=0,Y=T.length;_<Y;_++)if(!O(T[_],A[_]))return!1;return!0}e.equals=C;function M(T,A,O){let _=0,Y=T.length-1;for(;_<=Y;){const ie=(_+Y)/2|0,ae=O(T[ie],A);if(ae<0)_=ie+1;else if(ae>0)Y=ie-1;else return ie}return-(_+1)}e.binarySearch=M;function b(T,A){let O=0,_=T.length;if(_===0)return 0;for(;O<_;){const Y=Math.floor((O+_)/2);A(T[Y])?_=Y:O=Y+1}return O}e.findFirstInSorted=b;function m(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let _=A[Math.floor(A.length*Math.random())],Y=[],ie=[],ae=[];for(let ce of A){const ne=O(ce,_);ne<0?Y.push(ce):ne>0?ie.push(ce):ae.push(ce)}return T<Y.length?m(T,Y,O):T<Y.length+ae.length?ae[0]:m(T-(Y.length+ae.length),ie,O)}e.quickSelect=m;function y(T,A){const O=[];let _;for(const Y of T.slice(0).sort(A))!_||A(_[0],Y)!==0?(_=[Y],O.push(_)):_.push(Y);return O}e.groupBy=y;function E(T,A,O){const _=[];function Y(ce,ne,le){if(ne===0&&le.length===0)return;const he=_[_.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=ne,he.toInsert.push(...le)):_.push({start:ce,deleteCount:ne,toInsert:le})}let ie=0,ae=0;for(;;){if(ie===T.length){Y(ie,0,A.slice(ae));break}if(ae===A.length){Y(ie,T.length-ie,[]);break}const ce=T[ie],ne=A[ae],le=O(ce,ne);le===0?(ie+=1,ae+=1):le<0?(Y(ie,1,[]),ie+=1):le>0&&(Y(ie,0,[ne]),ae+=1)}return _}e.sortedDiff=E;function k(T,A,O){const _=E(T,A,O),Y=[],ie=[];for(const ae of _)Y.push(...T.slice(ae.start,ae.start+ae.deleteCount)),ie.push(...ae.toInsert);return{removed:Y,added:ie}}e.delta=k;function I(T,A,O){if(O===0)return[];const _=T.slice(0,O).sort(A);return t(T,A,_,O,T.length),_}e.top=I;function p(T,A,O,_,Y){return O===0?Promise.resolve([]):new Promise((ie,ae)=>{(async()=>{const ce=T.length,ne=T.slice(0,O).sort(A);for(let le=O,he=Math.min(O+_,ce);le<ce;le=he,he=Math.min(he+_,ce)){if(le>O&&await new Promise(me=>setTimeout(me)),Y&&Y.isCancellationRequested)throw(0,w.canceled)();t(T,A,ne,le,he)}return ne})().then(ie,ae)})}e.topAsync=p;function t(T,A,O,_,Y){for(const ie=O.length;_<Y;_++){const ae=T[_];if(A(ae,O[ie-1])<0){O.pop();const ce=b(O,ne=>A(ae,ne)<0);O.splice(ce,0,ae)}}}function h(T){return T.filter(A=>!!A)}e.coalesce=h;function g(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=g;function v(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=v;function P(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=P;function d(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=d;function f(T,A=O=>O){const O=new Set;return T.filter(_=>{const Y=A(_);return O.has(Y)?!1:(O.add(Y),!0)})}e.distinct=f;function c(T){const A=new Set;return O=>{const _=T(O);return A.has(_)?!1:(A.add(_),!0)}}e.uniqueFilter=c;function o(T,A){const O=u(T,A);if(O!==-1)return T[O]}e.findLast=o;function u(T,A){for(let O=T.length-1;O>=0;O--){const _=T[O];if(A(_))return O}return-1}e.lastIndex=u;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function i(T,A,O=(_,Y)=>_===Y){let _=0;for(let Y=0,ie=Math.min(T.length,A.length);Y<ie&&O(T[Y],A[Y]);Y++)_++;return _}e.commonPrefixLength=i;function s(T){return[].concat(...T)}e.flatten=s;function a(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const _=[];if(O<=A)for(let Y=O;Y<A;Y++)_.push(Y);else for(let Y=O;Y>A;Y--)_.push(Y);return _}e.range=a;function l(T,A,O){return T.reduce((_,Y)=>(_[A(Y)]=O?O(Y):Y,_),Object.create(null))}e.index=l;function S(T,A){return T.push(A),()=>D(T,A)}e.insert=S;function D(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=D;function L(T,A,O){const _=T.slice(0,A),Y=T.slice(A);return _.concat(O,Y)}e.arrayInsert=L;function W(T,A){let O;if(typeof A=="number"){let _=A;O=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const Y=Math.floor(O()*(_+1)),ie=T[_];T[_]=T[Y],T[Y]=ie}}e.shuffle=W;function U(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=U;function j(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=j;function ee(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ee;function x(T){return Array.isArray(T)?T:[T]}e.asArray=x;function N(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=N;function G(T,A){for(const O of T){const _=A(O);if(_!==void 0)return _}}e.mapFind=G;function z(T,A,O){const _=re(T,A),Y=T.length,ie=O.length;T.length=Y+ie;for(let ae=Y-1;ae>=_;ae--)T[ae+ie]=T[ae];for(let ae=0;ae<ie;ae++)T[ae+_]=O[ae]}e.insertInto=z;function X(T,A,O,_){const Y=re(T,A),ie=T.splice(Y,O);return z(T,Y,_),ie}e.splice=X;function re(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function V(T,A){return(O,_)=>A(T(O),T(_))}e.compareBy=V;const H=(T,A)=>T-A;e.numberComparator=H;function K(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const Y=T[_];A(Y,O)>0&&(O=Y)}return O}e.findMaxBy=K;function $(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const Y=T[_];A(Y,O)>=0&&(O=Y)}return O}e.findLastMaxBy=$;function F(T,A){return K(T,(O,_)=>-A(O,_))}e.findMinBy=F;class B{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const _=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,_}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const _=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,_}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=B}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(n){const R=this;let C=!1,M;return function(){return C||(C=!0,M=n.apply(R,arguments)),M}}e.once=w}),define(J[69],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(n){function R(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=R;const C=Object.freeze([]);function M(){return C}n.empty=M;function*b(c){yield c}n.single=b;function m(c){return c||C}n.from=m;function y(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=y;function E(c){return c[Symbol.iterator]().next().value}n.first=E;function k(c,o){for(const u of c)if(o(u))return!0;return!1}n.some=k;function I(c,o){for(const u of c)if(o(u))return u}n.find=I;function*p(c,o){for(const u of c)o(u)&&(yield u)}n.filter=p;function*t(c,o){let u=0;for(const r of c)yield o(r,u++)}n.map=t;function*h(...c){for(const o of c)for(const u of o)yield u}n.concat=h;function*g(c){for(const o of c)for(const u of o)yield u}n.concatNested=g;function v(c,o,u){let r=u;for(const i of c)r=o(r,i);return r}n.reduce=v;function*P(c,o,u=c.length){for(o<0&&(o+=c.length),u<0?u+=c.length:u>c.length&&(u=c.length);o<u;o++)yield c[o]}n.slice=P;function d(c,o=Number.POSITIVE_INFINITY){const u=[];if(o===0)return[u,c];const r=c[Symbol.iterator]();for(let i=0;i<o;i++){const s=r.next();if(s.done)return[u,n.empty()];u.push(s.value)}return[u,{[Symbol.iterator](){return r}}]}n.consume=d;function f(c,o,u=(r,i)=>r===i){const r=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const s=r.next(),a=i.next();if(s.done!==a.done)return!1;if(s.done)return!0;if(!u(s.value,a.value))return!1}}n.equals=f})(w=e.Iterable||(e.Iterable={}))}),define(J[44],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function M(o,u=!1){let r=0,i=o.length,s="",a=0,l=16,S=0;function D(N){let G=0,z=0;for(;G<N;){const X=o.charCodeAt(r);if(X>=48&&X<=57)z=z*16+X-48;else if(X>=65&&X<=70)z=z*16+X-65+10;else if(X>=97&&X<=102)z=z*16+X-97+10;else break;r++,G++}return G<N&&(z=-1),z}function L(N){r=N,s="",a=0,l=16,S=0}function W(){const N=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&y(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&y(o.charCodeAt(r)))for(r++;r<o.length&&y(o.charCodeAt(r));)r++;else return S=3,o.substring(N,r);let G=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&y(o.charCodeAt(r))){for(r++;r<o.length&&y(o.charCodeAt(r));)r++;G=r}else S=3;return o.substring(N,G)}function U(){let N="",G=r;for(;;){if(r>=i){N+=o.substring(G,r),S=2;break}const z=o.charCodeAt(r);if(z===34){N+=o.substring(G,r),r++;break}if(z===92){if(N+=o.substring(G,r),r++,r>=i){S=2;break}switch(o.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const re=D(4);re>=0?N+=String.fromCharCode(re):S=4;break}default:S=5}G=r;continue}if(z>=0&&z<=31)if(m(z)){N+=o.substring(G,r),S=2;break}else S=6;r++}return N}function j(){if(s="",S=0,a=r,r>=i)return a=i,l=17;let N=o.charCodeAt(r);if(b(N)){do r++,s+=String.fromCharCode(N),N=o.charCodeAt(r);while(b(N));return l=15}if(m(N))return r++,s+=String.fromCharCode(N),N===13&&o.charCodeAt(r)===10&&(r++,s+=`
`),l=14;switch(N){case 123:return r++,l=1;case 125:return r++,l=2;case 91:return r++,l=3;case 93:return r++,l=4;case 58:return r++,l=6;case 44:return r++,l=5;case 34:return r++,s=U(),l=10;case 47:{const G=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!m(o.charCodeAt(r));)r++;return s=o.substring(G,r),l=12}if(o.charCodeAt(r+1)===42){r+=2;const z=i-1;let X=!1;for(;r<z;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,X=!0;break}r++}return X||(r++,S=1),s=o.substring(G,r),l=13}return s+=String.fromCharCode(N),r++,l=16}case 45:if(s+=String.fromCharCode(N),r++,r===i||!y(o.charCodeAt(r)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=W(),l=11;default:for(;r<i&&ee(N);)r++,N=o.charCodeAt(r);if(a!==r){switch(s=o.substring(a,r),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(N),r++,l=16}}function ee(N){if(b(N)||m(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let N;do N=j();while(N>=12&&N<=15);return N}return{setPosition:L,getPosition:()=>r,scan:u?x:j,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>S}}e.createScanner=M;function b(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function m(o){return o===10||o===13||o===8232||o===8233}function y(o){return o>=48&&o<=57}var E;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(E||(E={}));function k(o,u){const r=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(D,L,W,U){a.value=D,a.offset=L,a.length=W,a.type=U,a.colonOffset=void 0,s=a}try{d(o,{onObjectBegin:(D,L)=>{if(u<=D)throw i;s=void 0,l=u>D,r.push("")},onObjectProperty:(D,L,W)=>{if(u<L||(S(D,L,W,"property"),r[r.length-1]=D,u<=L+W))throw i},onObjectEnd:(D,L)=>{if(u<=D)throw i;s=void 0,r.pop()},onArrayBegin:(D,L)=>{if(u<=D)throw i;s=void 0,r.push(0)},onArrayEnd:(D,L)=>{if(u<=D)throw i;s=void 0,r.pop()},onLiteralValue:(D,L,W)=>{if(u<L||(S(D,L,W,c(D)),u<=L+W))throw i},onSeparator:(D,L,W)=>{if(u<=L)throw i;if(D===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(D===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(l=!0,r[r.length-1]=""),s=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:s,isAtPropertyKey:l,matches:D=>{let L=0;for(let W=0;L<D.length&&W<r.length;W++)if(D[L]===r[W]||D[L]==="*")L++;else if(D[L]!=="**")return!1;return L===D.length}}}e.getLocation=k;function I(o,u=[],r=C.DEFAULT){let i=null,s=[];const a=[];function l(D){Array.isArray(s)?s.push(D):i!==null&&(s[i]=D)}return d(o,{onObjectBegin:()=>{const D={};l(D),a.push(s),s=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const D=[];l(D),a.push(s),s=D,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(D,L,W)=>{u.push({error:D,offset:L,length:W})}},r),s[0]}e.parse=I;function p(o,u=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function a(D){return i.children.push(D),D}d(o,{onObjectBegin:D=>{i=a({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,L,W)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:L,length:W,parent:i})},onObjectEnd:(D,L)=>{i.length=D+L-i.offset,i=i.parent,s(D+L)},onArrayBegin:(D,L)=>{i=a({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,L)=>{i.length=D+L-i.offset,i=i.parent,s(D+L)},onLiteralValue:(D,L,W)=>{a({type:c(D),offset:L,length:W,parent:i,value:D}),s(L+W)},onSeparator:(D,L,W)=>{i.type==="property"&&(D===":"?i.colonOffset=L:D===","&&s(L))},onError:(D,L,W)=>{u.push({error:D,offset:L,length:W})}},r);const S=i.children[0];return S&&delete S.parent,S}e.parseTree=p;function t(o,u){if(!o)return;let r=o;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function h(o){if(!o.parent||!o.parent.children)return[];const u=h(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;u.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&u.push(r)}return u}e.getNodePath=h;function g(o){switch(o.type){case"array":return o.children.map(g);case"object":{const u=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(u[r.children[0].value]=g(i))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=g;function v(o,u,r=!1){return u>=o.offset&&u<o.offset+o.length||r&&u===o.offset+o.length}e.contains=v;function P(o,u,r=!1){if(v(o,u,r)){const i=o.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=u;s++){const a=P(i[s],u,r);if(a)return a}return o}}e.findNodeAtOffset=P;function d(o,u,r=C.DEFAULT){const i=M(o,!1);function s(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(B){return B?T=>B(T,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),S=a(u.onObjectProperty),D=s(u.onObjectEnd),L=s(u.onArrayBegin),W=s(u.onArrayEnd),U=a(u.onLiteralValue),j=a(u.onSeparator),ee=s(u.onComment),x=a(u.onError),N=r&&r.disallowComments,G=r&&r.allowTrailingComma;function z(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:N||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(B){case 12:case 13:N?X(10):ee();break;case 16:X(1);break;case 15:case 14:break;default:return B}}}function X(B,T=[],A=[]){if(x(B),T.length+A.length>0){let O=i.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){z();break}else if(A.indexOf(O)!==-1)break;O=z()}}}function re(B){const T=i.getTokenValue();return B?U(T):S(T),z(),!0}function V(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(X(2),B=0)}catch{X(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return z(),!0}function H(){return i.getToken()!==10?(X(3,[],[2,5]),!1):(re(!1),i.getToken()===6?(j(":"),z(),F()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function K(){l(),z();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||X(4,[],[]),j(","),z(),i.getToken()===2&&G)break}else B&&X(6,[],[]);H()||X(4,[],[2,5]),B=!0}return D(),i.getToken()!==2?X(7,[2],[]):z(),!0}function $(){L(),z();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||X(4,[],[]),j(","),z(),i.getToken()===4&&G)break}else B&&X(6,[],[]);F()||X(4,[],[4,5]),B=!0}return W(),i.getToken()!==4?X(8,[4],[]):z(),!0}function F(){switch(i.getToken()){case 3:return $();case 1:return K();case 10:return re(!0);default:return V()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(X(4,[],[]),!1):F()?(i.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=d;function f(o,u){let r=M(o),i=[],s,a=0,l;do switch(l=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:a!==l&&i.push(o.substring(a,l)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),a=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=f;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[107],Z([0,1,44]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(y,E,k){let I,p,t,h,g;if(E){for(h=E.offset,g=h+E.length,t=h;t>0&&!m(y,t-1);)t--;let l=g;for(;l<y.length&&!m(y,l);)l++;p=y.substring(t,l),I=M(p,k)}else p=y,I=0,t=0,h=0,g=y.length;const v=b(k,y);let P=!1,d=0,f;k.insertSpaces?f=C(" ",k.tabSize||4):f="	";const c=(0,w.createScanner)(p,!1);let o=!1;function u(){return v+C(f,I+d)}function r(){let l=c.scan();for(P=!1;l===15||l===14;)P=P||l===14,l=c.scan();return o=l===16||c.getTokenError()!==0,l}const i=[];function s(l,S,D){!o&&S<g&&D>h&&y.substring(S,D)!==l&&i.push({offset:S,length:D-S,content:l})}let a=r();if(a!==17){const l=c.getTokenOffset()+t,S=C(f,I);s(S,t,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+t,S=r(),D="";for(;!P&&(S===12||S===13);){const W=c.getTokenOffset()+t;s(" ",l,W),l=c.getTokenOffset()+c.getTokenLength()+t,D=S===12?u():"",S=r()}if(S===2)a!==1&&(d--,D=u());else if(S===4)a!==3&&(d--,D=u());else{switch(a){case 3:case 1:d++,D=u();break;case 5:case 12:D=u();break;case 13:P?D=u():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(o=!0);break;case 16:o=!0;break}P&&(S===12||S===13)&&(D=u())}const L=c.getTokenOffset()+t;s(D,l,L),a=S}return i}e.format=n;function R(y,E){const k=JSON.stringify(y,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?k.replace(/\r\n|\r|\n/g,E.eol):k}e.toFormattedString=R;function C(y,E){let k="";for(let I=0;I<E;I++)k+=y;return k}function M(y,E){let k=0,I=0;const p=E.tabSize||4;for(;k<y.length;){const t=y.charAt(k);if(t===" ")I++;else if(t==="	")I+=p;else break;k++}return Math.floor(I/p)}function b(y,E){for(let k=0;k<E.length;k++){const I=E.charAt(k);if(I==="\r")return k+1<E.length&&E.charAt(k+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=b;function m(y,E){return`\r
`.indexOf(y.charAt(E))!==-1}e.isEOL=m}),define(J[108],Z([0,1,44,107]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(y,E,k){return C(y,E,void 0,k)}e.removeProperty=R;function C(y,E,k,I,p){const t=E.slice(),h=[],g=(0,w.parseTree)(y,h);let v,P;for(;t.length>0&&(P=t.pop(),v=(0,w.findNodeAtLocation)(g,t),v===void 0&&k!==void 0);)typeof P=="string"?k={[P]:k}:k=[k];if(v)if(v.type==="object"&&typeof P=="string"&&Array.isArray(v.children)){const d=(0,w.findNodeAtLocation)(v,[P]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const f=v.children.indexOf(d.parent);let c,o=d.parent.offset+d.parent.length;if(f>0){const u=v.children[f-1];c=u.offset+u.length}else c=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return M(y,{offset:c,length:o-c,content:""},I)}else return M(y,{offset:d.offset,length:d.length,content:JSON.stringify(k)},I);else{if(k===void 0)return[];const f=`${JSON.stringify(P)}: ${JSON.stringify(k)}`,c=p?p(v.children.map(u=>u.children[0].value)):v.children.length;let o;if(c>0){const u=v.children[c-1];o={offset:u.offset+u.length,length:0,content:","+f}}else v.children.length===0?o={offset:v.offset+1,length:0,content:f}:o={offset:v.offset+1,length:0,content:f+","};return M(y,o,I)}}else if(v.type==="array"&&typeof P=="number"&&Array.isArray(v.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let f;if(v.children.length===0||P===0)f={offset:v.offset+1,length:0,content:v.children.length===0?d:d+","};else{const c=P===-1||P>v.children.length?v.children.length:P,o=v.children[c-1];f={offset:o.offset+o.length,length:0,content:","+d}}return M(y,f,I)}else{const d=P,f=v.children[d];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===d){const o=v.children[d-1],u=o.offset+o.length,r=v.offset+v.length;c={offset:u,length:r-2-u,content:""}}else c={offset:f.offset,length:v.children[d+1].offset-f.offset,content:""};return M(y,c,I)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(k)},I)}}e.setProperty=C;function M(y,E,k){let I=b(y,E),p=E.offset,t=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;p>0&&!(0,n.isEOL)(I,p-1);)p--;for(;t<I.length&&!(0,n.isEOL)(I,t);)t++}const h=(0,n.format)(I,{offset:p,length:t-p},k);for(let v=h.length-1;v>=0;v--){const P=h[v];I=b(I,P),p=Math.min(p,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const g=y.length-(I.length-t)-p;return[{offset:p,length:g,content:I.substring(p,t)}]}e.withFormatting=M;function b(y,E){return y.substring(0,E.offset)+E.content+y.substring(E.offset+E.length)}e.applyEdit=b;function m(y,E){let k=E.slice(0).sort((p,t)=>{const h=p.offset-t.offset;return h===0?p.length-t.length:h}),I=y.length;for(let p=k.length-1;p>=0;p--){let t=k[p];if(t.offset+t.length<=I)y=b(y,t);else throw new Error("Overlapping edit");I=t.offset}return y}e.applyEdits=m}),define(J[83],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,g){this._keyCodeToStr[h]=g,this._strToKeyCode[g.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const C=new R,M=new R,b=new R;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],y=Object.create(null),E=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>E[t]||0,toEnum:t=>y[t]||0,toString:t=>m[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let g=[],v=[];for(const P of h){const[d,f,c,o,u,r,i,s,a,l]=P;if(v[c]||(v[c]=!0,m[c]=o,y[o]=c,E[o.toLowerCase()]=c,f&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=c))),!g[u]){if(g[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${o}`);C.define(u,r),M.define(u,a||r),b.define(u,l||a||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var k;(function(t){function h(c){return C.keyCodeToStr(c)}t.toString=h;function g(c){return C.strToKeyCode(c)}t.fromString=g;function v(c){return M.keyCodeToStr(c)}t.toUserSettingsUS=v;function P(c){return b.keyCodeToStr(c)}t.toUserSettingsGeneral=P;function d(c){return M.strToKeyCode(c)||b.strToKeyCode(c)}t.fromUserSettings=d;function f(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(c)}t.toElectronAccelerator=f})(k=e.KeyCodeUtils||(e.KeyCodeUtils={}));var I;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(I=e.KeyMod||(e.KeyMod={}));function p(t,h){const g=(h&65535)<<16>>>0;return(t|g)>>>0}e.KeyChord=p}),define(J[59],Z([0,1,15]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(k){k[k.CtrlCmd=2048]="CtrlCmd",k[k.Shift=1024]="Shift",k[k.Alt=512]="Alt",k[k.WinCtrl=256]="WinCtrl",k[k.KeyCode=255]="KeyCode"})(n||(n={}));function R(k,I){if(k===0)return null;const p=(k&65535)>>>0,t=(k&4294901760)>>>16;return t!==0?new b([C(p,I),C(t,I)]):new b([C(p,I)])}e.createKeybinding=R;function C(k,I){const p=!!(k&2048),t=!!(k&256),h=I===2?t:p,g=!!(k&1024),v=!!(k&512),P=I===2?p:t,d=k&255;return new M(h,g,v,P,d)}e.createSimpleKeybinding=C;class M{constructor(I,p,t,h,g){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyCode=g}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.keyCode===I.keyCode}getHashCode(){const I=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${I}${p}${t}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=M;class b{constructor(I){if(I.length===0)throw(0,w.illegalArgument)("parts");this.parts=I}getHashCode(){let I="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(I+=";"),I+=this.parts[p].getHashCode();return I}equals(I){if(I===null||this.parts.length!==I.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(I.parts[p]))return!1;return!0}}e.ChordKeybinding=b;class m{constructor(I,p,t,h,g){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.scanCode=g}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.scanCode===I.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=m;class y{constructor(I,p,t,h,g,v){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyLabel=g,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=y;class E{}e.ResolvedKeybinding=E}),define(J[109],Z([0,1,83,59]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(M){M=M.toLowerCase().trim();let b=!1,m=!1,y=!1,E=!1,k;do k=!1,/^ctrl(\+|\-)/.test(M)&&(b=!0,M=M.substr("ctrl-".length),k=!0),/^shift(\+|\-)/.test(M)&&(m=!0,M=M.substr("shift-".length),k=!0),/^alt(\+|\-)/.test(M)&&(y=!0,M=M.substr("alt-".length),k=!0),/^meta(\+|\-)/.test(M)&&(E=!0,M=M.substr("meta-".length),k=!0),/^win(\+|\-)/.test(M)&&(E=!0,M=M.substr("win-".length),k=!0),/^cmd(\+|\-)/.test(M)&&(E=!0,M=M.substr("cmd-".length),k=!0);while(k);let I;const p=M.indexOf(" ");return p>0?(I=M.substring(0,p),M=M.substring(p)):(I=M,M=""),{remains:M,ctrl:b,shift:m,alt:y,meta:E,key:I}}static parseSimpleKeybinding(M){const b=this._readModifiers(M),m=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,m),b.remains]}static parseKeybinding(M,b){if(!M)return null;const m=[];let y;do[y,M]=this.parseSimpleKeybinding(M),m.push(y);while(M.length>0);return new n.ChordKeybinding(m)}static parseSimpleUserBinding(M){const b=this._readModifiers(M),m=b.key.match(/^\[([^\]]+)\]$/);if(m){const E=m[1],k=w.ScanCodeUtils.lowerCaseToEnum(E);return[new n.ScanCodeBinding(b.ctrl,b.shift,b.alt,b.meta,k),b.remains]}const y=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,y),b.remains]}static parseUserBinding(M){if(!M)return[];const b=[];let m;for(;M.length>0;)[m,M]=this.parseSimpleUserBinding(M),b.push(m);return b}}e.KeybindingParser=R}),define(J[110],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new w(()=>R(this.getValue()))}}e.Lazy=w}),define(J[2],Z([0,1,43,69]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let C=null;function M(i){C=i}if(e.setDisposableTracker=M,R){const i="__is_disposable_tracked__";M(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function b(i){return C?.trackDisposable(i),i}function m(i){C?.markAsDisposed(i)}function y(i,s){C?.setParent(i,s)}function E(i,s){if(!!C)for(const a of i)C.setParent(a,s)}function k(i){return C?.markAsSingleton(i),i}e.markAsSingleton=k;class I extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=I;function p(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=p;function t(i){if(n.Iterable.is(i)){let s=[];for(const a of i)if(a)try{a.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new I(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function h(...i){const s=g(()=>t(i));return E(i,s),s}e.combinedDisposable=h;function g(i){const s=b({dispose:(0,w.once)(()=>{m(s),i()})});return s}e.toDisposable=g;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return y(s,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new v,b(this),y(this._store,this)}dispose(){m(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&y(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&y(s,null),s}}e.MutableDisposable=d;class f{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.references=new Map}acquire(s,...a){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,l));const{object:S}=l,D=(0,w.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:S,dispose:D}}}e.ReferenceCollection=c;class o{constructor(s){this.referenceCollection=s}async acquire(s,...a){const l=this.referenceCollection.acquire(s,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(S){throw l.dispose(),S}}}e.AsyncReferenceCollection=o;class u{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=u;function r(i){const s=new v;try{i(s)}finally{s.dispose()}}e.disposeOnReturn=r}),define(J[111],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(C){this.element=C,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class n{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let C=this._first;for(;C!==w.Undefined;){const M=C.next;C.prev=w.Undefined,C.next=w.Undefined,C=M}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,M){const b=new w(C);if(this._first===w.Undefined)this._first=b,this._last=b;else if(M){const y=this._last;this._last=b,b.prev=y,y.next=b}else{const y=this._first;this._first=b,b.next=y,y.prev=b}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(b))}}shift(){if(this._first!==w.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==w.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==w.Undefined&&C.next!==w.Undefined){const M=C.prev;M.next=C.next,C.next.prev=M}else C.prev===w.Undefined&&C.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):C.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):C.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==w.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function q(R){const C=[];typeof R=="number"&&C.push("code/timeOrigin",R);function M(m){C.push(m,Date.now())}function b(){const m=[];for(let y=0;y<C.length;y+=2)m.push({name:C[y],startTime:C[y+1]});return m}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))C.push({name:M.name,startTime:Math.round(R+M.startTime)});return C}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=w(n))}(),define(J[3],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let n=!1,R=!1,C=!1,M=!1,b=!1,m=!1,y=!1,E=!1,k=!1,I,p=w,t,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const v=typeof g?.versions?.electron=="string",P=v&&g?.type==="renderer";if(e.isElectronSandboxed=P&&g?.sandboxed,typeof navigator=="object"&&!P)h=navigator.userAgent,n=h.indexOf("Windows")>=0,R=h.indexOf("Macintosh")>=0,E=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,m=!0,I=navigator.language,p=I;else if(typeof g=="object"){n=g.platform==="win32",R=g.platform==="darwin",C=g.platform==="linux",M=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,y=v,k=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=w,p=w;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const l=JSON.parse(a),S=l.availableLanguages["*"];I=l.locale,p=S||w,t=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var d;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function f(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let c=0;R?c=1:n?c=3:C&&(c=2),e.isWindows=n,e.isMacintosh=R,e.isLinux=C,e.isLinuxSnap=M,e.isNative=b,e.isElectron=y,e.isWeb=m,e.isIOS=E,e.isCI=k,e.platform=c,e.userAgent=h,e.language=p;var o;(function(a){function l(){return e.language}a.value=l;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=S;function D(){return e.language==="en"}a.isDefault=D})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let D=0,L=a.length;D<L;D++){const W=a[D];if(W.id===S.data.vscodeScheduleAsyncWork){a.splice(D,1),W.callback();return}}});let l=0;return S=>{const D=++l;a.push({id:D,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:D},"*")}}return a=>setTimeout(a)})();var u;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:n?1:3;let r=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[36],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const R=w.globals.vscode.process;n={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(J[8],Z([0,1,36]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,R=97,C=90,M=122,b=46,m=47,y=92,E=58,k=63;class I extends Error{constructor(f,c,o){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const r=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${r} ${u} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function p(d,f){if(typeof d!="string")throw new I(f,"string",d)}function t(d){return d===m||d===y}function h(d){return d===m}function g(d){return d>=n&&d<=C||d>=R&&d<=M}function v(d,f,c,o){let u="",r=0,i=-1,s=0,a=0;for(let l=0;l<=d.length;++l){if(l<d.length)a=d.charCodeAt(l);else{if(o(a))break;a=m}if(o(a)){if(!(i===l-1||s===1))if(s===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==b||u.charCodeAt(u.length-2)!==b){if(u.length>2){const S=u.lastIndexOf(c);S===-1?(u="",r=0):(u=u.slice(0,S),r=u.length-1-u.lastIndexOf(c)),i=l,s=0;continue}else if(u.length!==0){u="",r=0,i=l,s=0;continue}}f&&(u+=u.length>0?`${c}..`:"..",r=2)}else u.length>0?u+=`${c}${d.slice(i+1,l)}`:u=d.slice(i+1,l),r=l-i-1;i=l,s=0}else a===b&&s!==-1?++s:s=-1}return u}function P(d,f){if(f===null||typeof f!="object")throw new I("pathObject","Object",f);const c=f.dir||f.root,o=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${o}`:`${c}${d}${o}`:o}e.win32={resolve(...d){let f="",c="",o=!1;for(let u=d.length-1;u>=-1;u--){let r;if(u>=0){if(r=d[u],p(r,"path"),r.length===0)continue}else f.length===0?r=w.cwd():(r=w.env[`=${f}`]||w.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==f.toLowerCase()&&r.charCodeAt(2)===y)&&(r=`${f}\\`));const i=r.length;let s=0,a="",l=!1;const S=r.charCodeAt(0);if(i===1)t(S)&&(s=1,l=!0);else if(t(S))if(l=!0,t(r.charCodeAt(1))){let D=2,L=D;for(;D<i&&!t(r.charCodeAt(D));)D++;if(D<i&&D!==L){const W=r.slice(L,D);for(L=D;D<i&&t(r.charCodeAt(D));)D++;if(D<i&&D!==L){for(L=D;D<i&&!t(r.charCodeAt(D));)D++;(D===i||D!==L)&&(a=`\\\\${W}\\${r.slice(L,D)}`,s=D)}}}else s=1;else g(S)&&r.charCodeAt(1)===E&&(a=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(l=!0,s=3));if(a.length>0)if(f.length>0){if(a.toLowerCase()!==f.toLowerCase())continue}else f=a;if(o){if(f.length>0)break}else if(c=`${r.slice(s)}\\${c}`,o=l,l&&f.length>0)break}return c=v(c,!o,"\\",t),o?`${f}\\${c}`:`${f}${c}`||"."},normalize(d){p(d,"path");const f=d.length;if(f===0)return".";let c=0,o,u=!1;const r=d.charCodeAt(0);if(f===1)return h(r)?"\\":d;if(t(r))if(u=!0,t(d.charCodeAt(1))){let s=2,a=s;for(;s<f&&!t(d.charCodeAt(s));)s++;if(s<f&&s!==a){const l=d.slice(a,s);for(a=s;s<f&&t(d.charCodeAt(s));)s++;if(s<f&&s!==a){for(a=s;s<f&&!t(d.charCodeAt(s));)s++;if(s===f)return`\\\\${l}\\${d.slice(a)}\\`;s!==a&&(o=`\\\\${l}\\${d.slice(a,s)}`,c=s)}}}else c=1;else g(r)&&d.charCodeAt(1)===E&&(o=d.slice(0,2),c=2,f>2&&t(d.charCodeAt(2))&&(u=!0,c=3));let i=c<f?v(d.slice(c),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(d.charCodeAt(f-1))&&(i+="\\"),o===void 0?u?`\\${i}`:i:u?`${o}\\${i}`:`${o}${i}`},isAbsolute(d){p(d,"path");const f=d.length;if(f===0)return!1;const c=d.charCodeAt(0);return t(c)||f>2&&g(c)&&d.charCodeAt(1)===E&&t(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let f,c;for(let r=0;r<d.length;++r){const i=d[r];p(i,"path"),i.length>0&&(f===void 0?f=c=i:f+=`\\${i}`)}if(f===void 0)return".";let o=!0,u=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++u;const r=c.length;r>1&&t(c.charCodeAt(1))&&(++u,r>2&&(t(c.charCodeAt(2))?++u:o=!1))}if(o){for(;u<f.length&&t(f.charCodeAt(u));)u++;u>=2&&(f=`\\${f.slice(u)}`)}return e.win32.normalize(f)},relative(d,f){if(p(d,"from"),p(f,"to"),d===f)return"";const c=e.win32.resolve(d),o=e.win32.resolve(f);if(c===o||(d=c.toLowerCase(),f=o.toLowerCase(),d===f))return"";let u=0;for(;u<d.length&&d.charCodeAt(u)===y;)u++;let r=d.length;for(;r-1>u&&d.charCodeAt(r-1)===y;)r--;const i=r-u;let s=0;for(;s<f.length&&f.charCodeAt(s)===y;)s++;let a=f.length;for(;a-1>s&&f.charCodeAt(a-1)===y;)a--;const l=a-s,S=i<l?i:l;let D=-1,L=0;for(;L<S;L++){const U=d.charCodeAt(u+L);if(U!==f.charCodeAt(s+L))break;U===y&&(D=L)}if(L!==S){if(D===-1)return o}else{if(l>S){if(f.charCodeAt(s+L)===y)return o.slice(s+L+1);if(L===2)return o.slice(s+L)}i>S&&(d.charCodeAt(u+L)===y?D=L:L===2&&(D=3)),D===-1&&(D=0)}let W="";for(L=u+D+1;L<=r;++L)(L===r||d.charCodeAt(L)===y)&&(W+=W.length===0?"..":"\\..");return s+=D,W.length>0?`${W}${o.slice(s,a)}`:(o.charCodeAt(s)===y&&++s,o.slice(s,a))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const f=e.win32.resolve(d);if(f.length<=2)return d;if(f.charCodeAt(0)===y){if(f.charCodeAt(1)===y){const c=f.charCodeAt(2);if(c!==k&&c!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(g(f.charCodeAt(0))&&f.charCodeAt(1)===E&&f.charCodeAt(2)===y)return`\\\\?\\${f}`;return d},dirname(d){p(d,"path");const f=d.length;if(f===0)return".";let c=-1,o=0;const u=d.charCodeAt(0);if(f===1)return t(u)?d:".";if(t(u)){if(c=o=1,t(d.charCodeAt(1))){let s=2,a=s;for(;s<f&&!t(d.charCodeAt(s));)s++;if(s<f&&s!==a){for(a=s;s<f&&t(d.charCodeAt(s));)s++;if(s<f&&s!==a){for(a=s;s<f&&!t(d.charCodeAt(s));)s++;if(s===f)return d;s!==a&&(c=o=s+1)}}}}else g(u)&&d.charCodeAt(1)===E&&(c=f>2&&t(d.charCodeAt(2))?3:2,o=c);let r=-1,i=!0;for(let s=f-1;s>=o;--s)if(t(d.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(c===-1)return".";r=c}return d.slice(0,r)},basename(d,f){f!==void 0&&p(f,"ext"),p(d,"path");let c=0,o=-1,u=!0,r;if(d.length>=2&&g(d.charCodeAt(0))&&d.charCodeAt(1)===E&&(c=2),f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let i=f.length-1,s=-1;for(r=d.length-1;r>=c;--r){const a=d.charCodeAt(r);if(t(a)){if(!u){c=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return c===o?o=s:o===-1&&(o=d.length),d.slice(c,o)}for(r=d.length-1;r>=c;--r)if(t(d.charCodeAt(r))){if(!u){c=r+1;break}}else o===-1&&(u=!1,o=r+1);return o===-1?"":d.slice(c,o)},extname(d){p(d,"path");let f=0,c=-1,o=0,u=-1,r=!0,i=0;d.length>=2&&d.charCodeAt(1)===E&&g(d.charCodeAt(0))&&(f=o=2);for(let s=d.length-1;s>=f;--s){const a=d.charCodeAt(s);if(t(a)){if(!r){o=s+1;break}continue}u===-1&&(r=!1,u=s+1),a===b?c===-1?c=s:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||u===-1||i===0||i===1&&c===u-1&&c===o+1?"":d.slice(c,u)},format:P.bind(null,"\\"),parse(d){p(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const c=d.length;let o=0,u=d.charCodeAt(0);if(c===1)return t(u)?(f.root=f.dir=d,f):(f.base=f.name=d,f);if(t(u)){if(o=1,t(d.charCodeAt(1))){let D=2,L=D;for(;D<c&&!t(d.charCodeAt(D));)D++;if(D<c&&D!==L){for(L=D;D<c&&t(d.charCodeAt(D));)D++;if(D<c&&D!==L){for(L=D;D<c&&!t(d.charCodeAt(D));)D++;D===c?o=D:D!==L&&(o=D+1)}}}}else if(g(u)&&d.charCodeAt(1)===E){if(c<=2)return f.root=f.dir=d,f;if(o=2,t(d.charCodeAt(2))){if(c===3)return f.root=f.dir=d,f;o=3}}o>0&&(f.root=d.slice(0,o));let r=-1,i=o,s=-1,a=!0,l=d.length-1,S=0;for(;l>=o;--l){if(u=d.charCodeAt(l),t(u)){if(!a){i=l+1;break}continue}s===-1&&(a=!1,s=l+1),u===b?r===-1?r=l:S!==1&&(S=1):r!==-1&&(S=-1)}return s!==-1&&(r===-1||S===0||S===1&&r===s-1&&r===i+1?f.base=f.name=d.slice(i,s):(f.name=d.slice(i,r),f.base=d.slice(i,s),f.ext=d.slice(r,s))),i>0&&i!==o?f.dir=d.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let f="",c=!1;for(let o=d.length-1;o>=-1&&!c;o--){const u=o>=0?d[o]:w.cwd();p(u,"path"),u.length!==0&&(f=`${u}/${f}`,c=u.charCodeAt(0)===m)}return f=v(f,!c,"/",h),c?`/${f}`:f.length>0?f:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===m,c=d.charCodeAt(d.length-1)===m;return d=v(d,!f,"/",h),d.length===0?f?"/":c?"./":".":(c&&(d+="/"),f?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===m},join(...d){if(d.length===0)return".";let f;for(let c=0;c<d.length;++c){const o=d[c];p(o,"path"),o.length>0&&(f===void 0?f=o:f+=`/${o}`)}return f===void 0?".":e.posix.normalize(f)},relative(d,f){if(p(d,"from"),p(f,"to"),d===f||(d=e.posix.resolve(d),f=e.posix.resolve(f),d===f))return"";const c=1,o=d.length,u=o-c,r=1,i=f.length-r,s=u<i?u:i;let a=-1,l=0;for(;l<s;l++){const D=d.charCodeAt(c+l);if(D!==f.charCodeAt(r+l))break;D===m&&(a=l)}if(l===s)if(i>s){if(f.charCodeAt(r+l)===m)return f.slice(r+l+1);if(l===0)return f.slice(r+l)}else u>s&&(d.charCodeAt(c+l)===m?a=l:l===0&&(a=0));let S="";for(l=c+a+1;l<=o;++l)(l===o||d.charCodeAt(l)===m)&&(S+=S.length===0?"..":"/..");return`${S}${f.slice(r+a)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===m;let c=-1,o=!0;for(let u=d.length-1;u>=1;--u)if(d.charCodeAt(u)===m){if(!o){c=u;break}}else o=!1;return c===-1?f?"/":".":f&&c===1?"//":d.slice(0,c)},basename(d,f){f!==void 0&&p(f,"ext"),p(d,"path");let c=0,o=-1,u=!0,r;if(f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let i=f.length-1,s=-1;for(r=d.length-1;r>=0;--r){const a=d.charCodeAt(r);if(a===m){if(!u){c=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(a===f.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return c===o?o=s:o===-1&&(o=d.length),d.slice(c,o)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===m){if(!u){c=r+1;break}}else o===-1&&(u=!1,o=r+1);return o===-1?"":d.slice(c,o)},extname(d){p(d,"path");let f=-1,c=0,o=-1,u=!0,r=0;for(let i=d.length-1;i>=0;--i){const s=d.charCodeAt(i);if(s===m){if(!u){c=i+1;break}continue}o===-1&&(u=!1,o=i+1),s===b?f===-1?f=i:r!==1&&(r=1):f!==-1&&(r=-1)}return f===-1||o===-1||r===0||r===1&&f===o-1&&f===c+1?"":d.slice(f,o)},format:P.bind(null,"/"),parse(d){p(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const c=d.charCodeAt(0)===m;let o;c?(f.root="/",o=1):o=0;let u=-1,r=0,i=-1,s=!0,a=d.length-1,l=0;for(;a>=o;--a){const S=d.charCodeAt(a);if(S===m){if(!s){r=a+1;break}continue}i===-1&&(s=!1,i=a+1),S===b?u===-1?u=a:l!==1&&(l=1):u!==-1&&(l=-1)}if(i!==-1){const S=r===0&&c?1:r;u===-1||l===0||l===1&&u===i-1&&u===r+1?f.base=f.name=d.slice(S,i):(f.name=d.slice(S,u),f.base=d.slice(S,i),f.ext=d.slice(u,i))}return r>0?f.dir=d.slice(0,r-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[84],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(C,...M){const b=M.reduce((E,k)=>(E[k]=!0,E),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(E=>!b[E]).forEach(E=>{for(let k=0;k<m.length;k++)if(E.search(m[k])!==-1){delete C[E];break}})}e.sanitizeProcessEnvironment=R}),define(J[85],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=w.globals.performance&&typeof w.globals.performance.now=="function";class R{constructor(M){this._highResolution=n&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new R(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=R}),define(J[4],Z([0,1,15,43,2,111,85]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.SafeDisposable=e.setGlobalLeakWarningThreshold=e.Event=void 0;var b;(function(u){u.None=()=>R.Disposable.None;function r(K){return($,F=null,B)=>{let T=!1,A;return A=K(O=>{if(!T)return A?A.dispose():T=!0,$.call(F,O)},null,B),T&&A.dispose(),A}}u.once=r;function i(K,$){return L((F,B=null,T)=>K(A=>F.call(B,$(A)),null,T))}u.map=i;function s(K,$){return L((F,B=null,T)=>K(A=>{$(A),F.call(B,A)},null,T))}u.forEach=s;function a(K,$){return L((F,B=null,T)=>K(A=>$(A)&&F.call(B,A),null,T))}u.filter=a;function l(K){return K}u.signal=l;function S(...K){return($,F=null,B)=>(0,R.combinedDisposable)(...K.map(T=>T(A=>$.call(F,A),null,B)))}u.any=S;function D(K,$,F){let B=F;return i(K,T=>(B=$(B,T),B))}u.reduce=D;function L(K){let $;const F=new h({onFirstListenerAdd(){$=K(F.fire,F)},onLastListenerRemove(){$.dispose()}});return F.event}function W(K,$,F,B=100,T=!1){let A,O,_=0;return K(Y=>{_++,A=F(A,Y),T&&!O&&($(A),A=void 0),clearTimeout(O),O=setTimeout(()=>{const ie=A;A=void 0,O=void 0,(!T||_>1)&&$(ie),_=0},B)})}u.debouncedListener=W;function U(K,$,F=100,B=!1,T){let A,O,_,Y=0;const ie=new h({leakWarningThreshold:T,onFirstListenerAdd(){A=K(ae=>{Y++,O=$(O,ae),B&&!_&&(ie.fire(O),O=void 0),clearTimeout(_),_=setTimeout(()=>{const ce=O;O=void 0,_=void 0,(!B||Y>1)&&ie.fire(ce),Y=0},F)})},onLastListenerRemove(){A.dispose()}});return ie.event}u.debounce=U;function j(K,$=(F,B)=>F===B){let F=!0,B;return a(K,T=>{const A=F||!$(T,B);return F=!1,B=T,A})}u.latch=j;function ee(K,$){return[u.filter(K,$),u.filter(K,F=>!$(F))]}u.split=ee;function x(K,$=!1,F=[]){let B=F.slice(),T=K(_=>{B?B.push(_):O.fire(_)});const A=()=>{B&&B.forEach(_=>O.fire(_)),B=null},O=new h({onFirstListenerAdd(){T||(T=K(_=>O.fire(_)))},onFirstListenerDidAdd(){B&&($?setTimeout(A):A())},onLastListenerRemove(){T&&T.dispose(),T=null}});return O.event}u.buffer=x;class N{constructor($){this.event=$}map($){return new N(i(this.event,$))}forEach($){return new N(s(this.event,$))}filter($){return new N(a(this.event,$))}reduce($,F){return new N(D(this.event,$,F))}latch(){return new N(j(this.event))}debounce($,F=100,B=!1,T){return new N(U(this.event,$,F,B,T))}on($,F,B){return this.event($,F,B)}once($,F,B){return r(this.event)($,F,B)}}function G(K){return new N(K)}u.chain=G;function z(K,$,F=B=>B){const B=(..._)=>O.fire(F(..._)),T=()=>K.on($,B),A=()=>K.removeListener($,B),O=new h({onFirstListenerAdd:T,onLastListenerRemove:A});return O.event}u.fromNodeEventEmitter=z;function X(K,$,F=B=>B){const B=(..._)=>O.fire(F(..._)),T=()=>K.addEventListener($,B),A=()=>K.removeEventListener($,B),O=new h({onFirstListenerAdd:T,onLastListenerRemove:A});return O.event}u.fromDOMEventEmitter=X;function re(K){return new Promise($=>r(K)($))}u.toPromise=re;function V(K,$){return $(void 0),K(F=>$(F))}u.runAndSubscribe=V;function H(K,$){let F=null;function B(A){F?.dispose(),F=new R.DisposableStore,$(A,F)}B(void 0);const T=K(A=>B(A));return(0,R.toDisposable)(()=>{T.dispose(),F?.dispose()})}u.runAndSubscribeWithStore=H})(b=e.Event||(e.Event={}));class m{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${m._idPool++}`}start(r){this._stopWatch=new M.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let y=-1;function E(u){const r=y;return y=u,{dispose(){y=r}}}e.setGlobalLeakWarningThreshold=E;class k{constructor(r,i=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r,i){let s=y;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||i<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(r.value)||0;if(this._stacks.set(r.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let l,S=0;for(const[D,L]of this._stacks)(!l||S<L)&&(l=D,S=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${S}):`),console.warn(l)}return()=>{const l=this._stacks.get(r.value)||0;this._stacks.set(r.value,l-1)}}}class I{constructor(r){this._error=r}static create(){return new I(new Error)}get value(){return this._error.stack??""}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(){this.dispose=p._noop,this.unset=p._noop}set(r){let i=r;return this.unset=()=>i=void 0,this.dispose=()=>i?.dispose(),this}}e.SafeDisposable=p,p._noop=()=>{};class t{constructor(r,i,s){this.callback=r,this.callbackThis=i,this.stack=s,this.subscription=new p}invoke(r){this.callback.call(this.callbackThis,r)}}class h{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=y>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(r,i,s)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let l,S;this._leakageMon&&(S=I.create(),l=this._leakageMon.check(S,this._listeners.size+1));const D=new t(r,i,S),L=this._listeners.push(D);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,i);const W=D.subscription.set((0,R.toDisposable)(()=>{l&&l(),this._disposed||(L(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return s instanceof R.DisposableStore?s.add(W):Array.isArray(s)&&s.push(W),W}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,r]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,s]=this._deliveryQueue.shift();try{i.invoke(s)}catch(a){(0,w.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(const r of this._listeners)r.subscription.dispose(),r.subscription.unset();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}e.Emitter=h;class g extends h{async fireAsync(r,i,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,r]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[a,l]=this._asyncDeliveryQueue.shift(),S=[],D={...l,token:i,waitUntil:L=>{if(Object.isFrozen(S))throw new Error("waitUntil can NOT be called asynchronous");s&&(L=s(L,a.callback)),S.push(L)}};try{a.invoke(D)}catch(L){(0,w.onUnexpectedError)(L);continue}Object.freeze(S),await Promise.allSettled(S).then(L=>{for(const W of L)W.status==="rejected"&&(0,w.onUnexpectedError)(W.reason)})}}}}e.AsyncEmitter=g;class v extends h{constructor(r){super(r);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}e.PauseableEmitter=v;class P extends v{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}e.DebounceEmitter=P;class d extends h{constructor(r){super(r);this._queuedEvents=[],this._mergeFn=r?.merge}fire(r){this._queuedEvents.push(r),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const i={event:r,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const s=()=>{this.hasListeners&&this.unhook(i);const a=this.events.indexOf(i);this.events.splice(a,1)};return(0,R.toDisposable)((0,n.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(i=>this.emitter.fire(i))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class c{constructor(){this.buffers=[]}wrapEvent(r){return(i,s,a)=>r(l=>{const S=this.buffers[this.buffers.length-1];S?S.push(()=>i.call(s,l)):i.call(s,l)},void 0,a)}bufferEvents(r){const i=[];this.buffers.push(i);const s=r();return this.buffers.pop(),i.forEach(a=>a()),s}}e.EventBufferer=c;class o{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=R.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(J[23],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(b,m){const y=setTimeout(b.bind(m),0);return{dispose(){clearTimeout(y)}}});var R;(function(b){function m(y){return y===b.None||y===b.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=m,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(R=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=M}),define(J[112],Z([0,1,23]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(M){this.task=M,this.result=null}get(){if(this.result)return this.result;const M=new w.CancellationTokenSource,b=this.task(M.token);return this.result={promise:b,dispose:()=>{this.result=null,M.cancel(),M.dispose()}},this.result}}e.Cache=n;class R{constructor(M){this.computeFn=M,this.lastCache=void 0,this.lastArgKey=void 0}get(M){const b=JSON.stringify(M);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.computeFn(M)),this.lastCache}}e.LRUCachedComputed=R}),define(J[48],Z([0,1,15,2]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(d){const f=d;return f?[f.on,f.pause,f.resume,f.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=R;function C(d){const f=d;return f?R(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=C;function M(d,f){return new b(d,f)}e.newWriteableStream=M;class b{constructor(f,c){this.reducer=f,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(c=>c(f))}emitError(f){this.listeners.error.length===0?(0,w.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(c=>c(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,c){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(f,c){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const u=o.indexOf(c);u>=0&&o.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(d,f){const c=[];let o;for(;(o=d.read())!==null;)c.push(o);return f(c)}e.consumeReadable=m;function y(d,f,c){const o=[];let u;for(;(u=d.read())!==null&&o.length<c;)o.push(u);return u===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return d.read()}}}e.peekReadable=y;function E(d,f){return new Promise((c,o)=>{const u=[];k(d,{onData:r=>{f&&u.push(r)},onError:r=>{f?o(r):c(void 0)},onEnd:()=>{c(f?f(u):void 0)}})})}e.consumeStream=E;function k(d,f){let c=!1;return d.on("error",o=>{c||f.onError(o)}),d.on("end",()=>{c||f.onEnd()}),d.on("data",o=>{c||f.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=k;function I(d,f){return new Promise((c,o)=>{const u=new n.DisposableStore,r=[],i=l=>{if(r.push(l),r.length>f)return u.dispose(),d.pause(),c({stream:d,buffer:r,ended:!1})},s=l=>o(l),a=()=>c({stream:d,buffer:r,ended:!0});u.add((0,n.toDisposable)(()=>d.removeListener("error",s))),d.on("error",s),u.add((0,n.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),u.add((0,n.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=I;function p(d,f){const c=M(f);return c.end(d),c}e.toStream=p;function t(){const d=M(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=t;function h(d){let f=!1;return{read:()=>f?null:(f=!0,d)}}e.toReadable=h;function g(d,f,c){const o=M(c);return k(d,{onData:u=>o.write(f.data(u)),onError:u=>o.error(f.error?f.error(u):u),onEnd:()=>o.end()}),o}e.transform=g;function v(d,f,c){let o=!1;return{read:()=>{const u=f.read();return o?u:(o=!0,u!==null?c([d,u]):d)}}}e.prefixedReadable=v;function P(d,f,c){let o=!1;const u=M(c);return k(f,{onData:r=>o?u.write(r):(o=!0,u.write(c([d,r]))),onError:r=>u.error(r),onEnd:()=>{o||(o=!0,u.write(d)),u.end()}}),u}e.prefixedStream=P}),define(J[17],Z([0,1,48]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let R,C;class M{constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}static alloc(S){return n?new M(Buffer.allocUnsafe(S)):new M(new Uint8Array(S))}static wrap(S){return n&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new M(S)}static fromString(S,D){return!(D?.dontUseNodeBuffer||!1)&&n?new M(Buffer.from(S)):(R||(R=new TextEncoder),new M(R.encode(S)))}static fromByteArray(S){const D=M.alloc(S.length);for(let L=0,W=S.length;L<W;L++)D.buffer[L]=S[L];return D}static concat(S,D){if(typeof D=="undefined"){D=0;for(let U=0,j=S.length;U<j;U++)D+=S[U].byteLength}const L=M.alloc(D);let W=0;for(let U=0,j=S.length;U<j;U++){const ee=S[U];L.set(ee,W),W+=ee.byteLength}return L}clone(){const S=M.alloc(this.byteLength);return S.set(this),S}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(S,D){return new M(this.buffer.subarray(S,D))}set(S,D){if(S instanceof M)this.buffer.set(S.buffer,D);else if(S instanceof Uint8Array)this.buffer.set(S,D);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),D);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return y(this.buffer,S)}writeUInt32BE(S,D){E(this.buffer,S,D)}readUInt32LE(S){return k(this.buffer,S)}writeUInt32LE(S,D){I(this.buffer,S,D)}readUInt8(S){return p(this.buffer,S)}writeUInt8(S,D){t(this.buffer,S,D)}}e.VSBuffer=M;function b(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0}e.readUInt16LE=b;function m(l,S,D){l[D+0]=S&255,S=S>>>8,l[D+1]=S&255}e.writeUInt16LE=m;function y(l,S){return l[S]*2**24+l[S+1]*2**16+l[S+2]*2**8+l[S+3]}e.readUInt32BE=y;function E(l,S,D){l[D+3]=S,S=S>>>8,l[D+2]=S,S=S>>>8,l[D+1]=S,S=S>>>8,l[D]=S}e.writeUInt32BE=E;function k(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0|l[S+2]<<16>>>0|l[S+3]<<24>>>0}e.readUInt32LE=k;function I(l,S,D){l[D+0]=S&255,S=S>>>8,l[D+1]=S&255,S=S>>>8,l[D+2]=S&255,S=S>>>8,l[D+3]=S&255}e.writeUInt32LE=I;function p(l,S){return l[S]}e.readUInt8=p;function t(l,S,D){l[D]=S}e.writeUInt8=t;function h(l){return w.consumeReadable(l,S=>M.concat(S))}e.readableToBuffer=h;function g(l){return w.toReadable(l)}e.bufferToReadable=g;function v(l){return w.consumeStream(l,S=>M.concat(S))}e.streamToBuffer=v;async function P(l){return l.ended?M.concat(l.buffer):M.concat([...l.buffer,await v(l.stream)])}e.bufferedStreamToBuffer=P;function d(l){return w.toStream(l,S=>M.concat(S))}e.bufferToStream=d;function f(l){return w.transform(l,{data:S=>typeof S=="string"?M.fromString(S):M.wrap(S)},S=>M.concat(S))}e.streamToBufferReadableStream=f;function c(l){return w.newWriteableStream(S=>M.concat(S),l)}e.newWriteableBufferStream=c;function o(l,S){return w.prefixedReadable(l,S,D=>M.concat(D))}e.prefixedBufferReadable=o;function u(l,S){return w.prefixedStream(l,S,D=>M.concat(D))}e.prefixedBufferStream=u;function r(l){let S=0,D=0,L=0;const W=new Uint8Array(Math.floor(l.length/4*3)),U=ee=>{switch(D){case 3:W[L++]=S|ee,D=0;break;case 2:W[L++]=S|ee>>>2,S=ee<<6,D=3;break;case 1:W[L++]=S|ee>>>4,S=ee<<4,D=2;break;default:S=ee<<2,D=1}};for(let ee=0;ee<l.length;ee++){const x=l.charCodeAt(ee);if(x>=65&&x<=90)U(x-65);else if(x>=97&&x<=122)U(x-97+26);else if(x>=48&&x<=57)U(x-48+52);else if(x===43||x===45)U(62);else if(x===47||x===95)U(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const j=L;for(;D>0;)U(0);return M.wrap(W).slice(0,j)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},S=!0,D=!1){const L=D?s:i;let W="";const U=l.byteLength%3;let j=0;for(;j<l.byteLength-U;j+=3){const ee=l[j+0],x=l[j+1],N=l[j+2];W+=L[ee>>>2],W+=L[(ee<<4|x>>>4)&63],W+=L[(x<<2|N>>>6)&63],W+=L[N&63]}if(U===1){const ee=l[j+0];W+=L[ee>>>2],W+=L[ee<<4&63],S&&(W+="==")}else if(U===2){const ee=l[j+0],x=l[j+1];W+=L[ee>>>2],W+=L[(ee<<4|x>>>4)&63],W+=L[x<<2&63],S&&(W+="=")}return W}e.encodeBase64=a}),define(J[27],Z([0,1,112,110]),function(q,e,w,n){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=C;const M=/{(\d+)}/g;function b(Q,...se){return se.length===0?Q:Q.replace(M,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=se.length?oe:se[ye]})}e.format=b;const m=/{([^}]+)}/g;function y(Q,se){return Q.replace(m,(oe,fe)=>se[fe]??oe)}e.format2=y;function E(Q){return Q.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=E;function k(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function I(Q,se){let oe=0;const fe=se.charCodeAt(0);for(let ye=Q.length-1;ye>=0;ye--)Q.charCodeAt(ye)===fe&&oe++;return oe}e.count=I;function p(Q,se,oe="\u2026"){return Q.length<=se?Q:`${Q.substr(0,se)}${oe}`}e.truncate=p;function t(Q,se=" "){const oe=h(Q,se);return g(oe,se)}e.trim=t;function h(Q,se){if(!Q||!se)return Q;const oe=se.length;if(oe===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(se,fe)===fe;)fe=fe+oe;return Q.substring(fe)}e.ltrim=h;function g(Q,se){if(!Q||!se)return Q;const oe=se.length,fe=Q.length;if(oe===0||fe===0)return Q;let ye=fe,Le=-1;for(;Le=Q.lastIndexOf(se,ye-1),!(Le===-1||Le+oe!==ye);){if(Le===0)return"";ye=Le}return Q.substring(0,ye)}e.rtrim=g;function v(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function P(Q){return Q.replace(/\*/g,"")}e.stripWildcards=P;function d(Q,se,oe={}){if(!Q)throw new Error("Cannot create regex from empty string");se||(Q=k(Q)),oe.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=d;function f(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=o;function u(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=u;function r(Q){for(let se=0,oe=Q.length;se<oe;se++){const fe=Q.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=r;function i(Q,se=0,oe=Q.length){for(let fe=se;fe<oe;fe++){const ye=Q.charCodeAt(fe);if(ye!==32&&ye!==9)return Q.substring(se,fe)}return Q.substring(se,oe)}e.getLeadingWhitespace=i;function s(Q,se=Q.length-1){for(let oe=se;oe>=0;oe--){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function a(Q,se){return Q<se?-1:Q>se?1:0}e.compare=a;function l(Q,se,oe=0,fe=Q.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Q.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He<Ae)return-1;if(He>Ae)return 1}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=l;function S(Q,se){return D(Q,se,0,Q.length,0,se.length)}e.compareIgnoreCase=S;function D(Q,se,oe=0,fe=Q.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Q.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He===Ae)continue;if(He>=128||Ae>=128)return l(Q.toLowerCase(),se.toLowerCase(),oe,fe,ye,Le);L(He)&&(He-=32),L(Ae)&&(Ae-=32);const $e=He-Ae;if($e!==0)return $e}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=D;function L(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=L;function W(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=W;function U(Q,se){return Q.length===se.length&&D(Q,se)===0}e.equalsIgnoreCase=U;function j(Q,se){const oe=se.length;return se.length>Q.length?!1:D(Q,se,0,oe)===0}e.startsWithIgnoreCase=j;function ee(Q,se){let oe,fe=Math.min(Q.length,se.length);for(oe=0;oe<fe;oe++)if(Q.charCodeAt(oe)!==se.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ee;function x(Q,se){let oe,fe=Math.min(Q.length,se.length);const ye=Q.length-1,Le=se.length-1;for(oe=0;oe<fe;oe++)if(Q.charCodeAt(ye-oe)!==se.charCodeAt(Le-oe))return oe;return fe}e.commonSuffixLength=x;function N(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=N;function G(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=G;function z(Q,se){return(Q-55296<<10)+(se-56320)+65536}e.computeCodePoint=z;function X(Q,se,oe){const fe=Q.charCodeAt(oe);if(N(fe)&&oe+1<se){const ye=Q.charCodeAt(oe+1);if(G(ye))return z(fe,ye)}return fe}e.getNextCodePoint=X;function re(Q,se){const oe=Q.charCodeAt(se-1);if(G(oe)&&se>1){const fe=Q.charCodeAt(se-2);if(N(fe))return z(fe,oe)}return oe}class V{constructor(se,oe=0){this._str=se,this._len=se.length,this._offset=oe}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=re(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=X(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class H{constructor(se,oe=0){this._iterator=new V(se,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.nextCodePoint());if(Ze(ye,Oe)){oe.setOffset(Le);break}ye=Oe}return oe.offset-fe}prevGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.prevCodePoint());if(Ze(Oe,ye)){oe.setOffset(Le);break}ye=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function K(Q,se){return new H(Q,se).nextGraphemeLength()}e.nextCharLength=K;function $(Q,se){return new H(Q,se).prevGraphemeLength()}e.prevCharLength=$;function F(Q,se){se>0&&G(Q.charCodeAt(se))&&se--;const oe=se+K(Q,se);return[oe-$(Q,oe),oe]}e.getCharContainingOffset=F;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(Q){return B.test(Q)}e.containsRTL=T;const A=/^[\t\n\r\x20-\x7E]*$/;function O(Q){return A.test(Q)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=_;function Y(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=Y;function ie(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=ie;function ae(Q,se){if(Q.length<se)return Q;const oe=/\b/g;let fe=0;for(;oe.test(Q)&&!(Q.length-oe.lastIndex<se);)fe=oe.lastIndex,oe.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=ae;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(ne,""),Q=Q.replace(le,"")),Q}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=me;function Pe(Q){return me(Q)?Q.substr(1):Q}e.stripUTF8BOM=Pe;function Ce(Q,se){if(!Q||!se||Q.length<se.length)return!1;const oe=se.length,fe=Q.toLowerCase();let ye=0,Le=-1;for(;ye<oe;){const Oe=fe.indexOf(se[ye],Le+1);if(Oe<0)return!1;Le=Oe,ye++}return!0}e.fuzzyContains=Ce;function Se(Q,se=!1){return Q?(se&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Se;function pe(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=pe;function be(Q,se=1){if(se===0)return"";let oe=-1;do oe=Q.indexOf(`
`,oe+1),se--;while(se>0&&oe>=0);return oe===-1?Q:(Q[oe-1]==="\r"&&oe--,Q.substr(0,oe))}e.getNLines=be;function Re(Q){const se=90-65+1;return Q=Q%(2*se),Q<se?String.fromCharCode(97+Q):String.fromCharCode(65+Q-se)}e.singleLetterHash=Re;function Ue(Q){return Be.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=Ue;function Ze(Q,se){return Q===0?se!==5&&se!==7:Q===2&&se===3?!1:Q===4||Q===2||Q===3||se===4||se===2||se===3?!0:!(Q===8&&(se===8||se===9||se===11||se===12)||(Q===11||Q===9)&&(se===9||se===10)||(Q===12||Q===10)&&se===10||se===5||se===13||se===7||Q===1||Q===13&&se===14||Q===6&&se===6)}var Fe;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ge()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(se<oe[3*ye])ye=2*ye;else if(se>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}Be._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Q,se){if(Q===0)return 0;const oe=pt(Q,se);if(oe!==void 0)return oe;const fe=new V(se,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=st;function pt(Q,se){const oe=new V(se,Q);let fe=oe.prevCodePoint();for(;ot(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ie(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function ot(Q){return 127995<=Q&&Q<=127999}var Ye;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class qe{constructor(se){this.confusableDictionary=se}static getInstance(se){return qe.cache.get(Array.from(se))}static getLocales(){return qe._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,R=qe,qe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new w.LRUCachedComputed(Q=>{function se(Ae){const $e=new Map;for(let Ve=0;Ve<Ae.length;Ve+=2)$e.set(Ae[Ve],Ae[Ve+1]);return $e}function oe(Ae,$e){const Ve=new Map(Ae);for(const[xe,it]of $e)Ve.set(xe,it);return Ve}function fe(Ae,$e){if(!Ae)return $e;const Ve=new Map;for(const[xe,it]of Ae)$e.has(xe)&&Ve.set(xe,it);return Ve}const ye=R.ambiguousCharacterData.getValue();let Le=Q.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Le.length===0&&(Le=["_default"]);let Oe;for(const Ae of Le){const $e=se(ye[Ae]);Oe=fe(Oe,$e)}const Ke=se(ye._common),He=oe(Ke,Oe);return new qe(He)}),qe._locales=new n.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(se){return Qe.getData().has(se)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe,Qe._data=void 0}),define(J[70],Z([0,1,27]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return R(v,0)}e.hash=n;function R(v,P){switch(typeof v){case"object":return v===null?C(349,P):Array.isArray(v)?m(v,P):y(v,P);case"string":return b(v,P);case"boolean":return M(v,P);case"number":return C(v,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=R;function C(v,P){return(P<<5)-P+v|0}e.numberHash=C;function M(v,P){return C(v?433:863,P)}function b(v,P){P=C(149417,P);for(let d=0,f=v.length;d<f;d++)P=C(v.charCodeAt(d),P);return P}e.stringHash=b;function m(v,P){return P=C(104579,P),v.reduce((d,f)=>R(f,d),P)}function y(v,P){return P=C(181387,P),Object.keys(v).sort().reduce((d,f)=>(d=b(f,d),R(v[f],d)),P)}class E{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=R(P,this._value),this._value}}e.Hasher=E;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function I(v,P,d=32){const f=d-P,c=~((1<<f)-1);return(v<<P|(c&v)>>>f)>>>0}function p(v,P=0,d=v.byteLength,f=0){for(let c=0;c<d;c++)v[P+c]=f}function t(v,P,d="0"){for(;v.length<P;)v=d+v;return v}function h(v,P=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(d=>d.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),P/4)}e.toHexString=h;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const d=P.length;if(d===0)return;const f=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,u,r;for(o!==0?(u=o,r=-1,o=0):(u=P.charCodeAt(0),r=0);;){let i=u;if(w.isHighSurrogate(u))if(r+1<d){const s=P.charCodeAt(r+1);w.isLowSurrogate(s)?(r++,i=w.computeCodePoint(u,s)):i=65533}else{o=u;break}else w.isLowSurrogate(u)&&(i=65533);if(c=this._push(f,c,i),r++,r<d)u=P.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(P,d,f){return f<128?P[d++]=f:f<2048?(P[d++]=192|(f&1984)>>>6,P[d++]=128|(f&63)>>>0):f<65536?(P[d++]=224|(f&61440)>>>12,P[d++]=128|(f&4032)>>>6,P[d++]=128|(f&63)>>>0):(P[d++]=240|(f&1835008)>>>18,P[d++]=128|(f&258048)>>>12,P[d++]=128|(f&4032)>>>6,P[d++]=128|(f&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=g._bigBlock32,d=this._buffDV;for(let l=0;l<64;l+=4)P.setUint32(l,d.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)P.setUint32(l,I(P.getUint32(l-12,!1)^P.getUint32(l-32,!1)^P.getUint32(l-56,!1)^P.getUint32(l-64,!1),1),!1);let f=this._h0,c=this._h1,o=this._h2,u=this._h3,r=this._h4,i,s,a;for(let l=0;l<80;l++)l<20?(i=c&o|~c&u,s=1518500249):l<40?(i=c^o^u,s=1859775393):l<60?(i=c&o|c&u|o&u,s=2400959708):(i=c^o^u,s=3395469782),a=I(f,5)+i+r+s+P.getUint32(l*4,!1)&4294967295,r=u,u=o,o=I(c,30),c=f,f=a;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(q,e,w,n,R){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!R:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?R.call(q,w):R?R.value=w:e.set(q,w),w},Je=this&&this.__classPrivateFieldGet||function(q,e,w,n){if(w==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!n:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?n:w==="a"?n.call(q):n?n.value:e.get(q)};define(J[35],Z([0,1,30,27]),function(q,e,w,n){"use strict";var R,C,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(r,i,s){let a=r.get(i);return a===void 0&&(a=s,r.set(i,a)),a}e.getOrSet=b;function m(r){const i=[];return r.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=m;function y(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=y;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=E;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class I{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(g||(g={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new I(void 0,!i))}static forStrings(){return new v(new E)}static forConfigKeys(){return new v(new k)}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,w.shuffle)(a);for(let l of a)this.set(l,i)}else{const a=i.slice(0);(0,w.shuffle)(a);for(let l of a)this.set(l[0],l[1])}}set(i,s){const a=this._iter.reset(i);let l;this._root||(this._root=new h,this._root.segment=a.value());const S=[];for(l=this._root;;){const L=a.cmp(l.segment);if(L>0)l.left||(l.left=new h,l.left.segment=a.value()),S.push([-1,l]),l=l.left;else if(L<0)l.right||(l.right=new h,l.right.segment=a.value()),S.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new h,l.mid.segment=a.value()),S.push([0,l]),l=l.mid;else break}const D=l.value;l.value=s,l.key=i;for(let L=S.length-1;L>=0;L--){const W=S[L][1];W.updateHeight();const U=W.balanceFactor();if(U<-1||U>1){const j=S[L][0],ee=S[L+1][0];if(j===1&&ee===1)S[L][1]=W.rotateLeft();else if(j===-1&&ee===-1)S[L][1]=W.rotateRight();else if(j===1&&ee===-1)W.right=S[L+1][1]=S[L+1][1].rotateRight(),S[L][1]=W.rotateLeft();else if(j===-1&&ee===1)W.left=S[L+1][1]=S[L+1][1].rotateLeft(),S[L][1]=W.rotateRight();else throw new Error;if(L>0)switch(S[L-1][0]){case-1:S[L-1][1].left=S[L][1];break;case 1:S[L-1][1].right=S[L][1];break;case 0:S[L-1][1].mid=S[L][1];break}else this._root=S[0][1]}}return D}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),l=[];let S=this._root;for(;S;){const D=a.cmp(S.segment);if(D>0)l.push([-1,S]),S=S.left;else if(D<0)l.push([1,S]),S=S.right;else if(a.hasNext())a.next(),l.push([0,S]),S=S.mid;else break}if(!!S){if(s?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const D=this._min(S.right),{key:L,value:W,segment:U}=D;this._delete(D.key,!1),S.key=L,S.value=W,S.segment=U}else{const D=S.left??S.right;if(l.length>0){const[L,W]=l[l.length-1];switch(L){case-1:W.left=D;break;case 0:W.mid=D;break;case 1:W.right=D;break}}else this._root=D}for(let D=l.length-1;D>=0;D--){const L=l[D][1];L.updateHeight();const W=L.balanceFactor();if(W>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),l[D][1]=L.rotateLeft()):W<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),l[D][1]=L.rotateRight()),D>0)switch(l[D-1][0]){case-1:l[D-1][1].left=l[D][1];break;case 1:l[D-1][1].right=l[D][1];break;case 0:l[D-1][1].mid=l[D][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,l;for(;a;){const S=s.cmp(a.segment);if(S>0)a=a.left;else if(S<0)a=a.right;else if(s.hasNext())s.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const l=s.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=v;class P{constructor(i,s){this.uri=i,this.value=s}}class d{constructor(i,s){this[R]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new P(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[a,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();var f;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let l=this._map.get(i);if(l)l.value=s,a!==0&&this.touch(l,a);else{switch(l={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let l=this._head;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.key,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.value,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:[a.key,a.value],done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,l=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=c;class o extends c{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class u{constructor(i){M.set(this,void 0),Ct(this,M,i,"f")}get size(){return Je(this,M,"f").size}forEach(i,s){Je(this,M,"f").forEach(i,s)}get(i){return Je(this,M,"f").get(i)}has(i){return Je(this,M,"f").has(i)}entries(){return Je(this,M,"f").entries()}keys(){return Je(this,M,"f").keys()}values(){return Je(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Je(this,M,"f").entries()}}e.ReadonlyMapView=u}),define(J[71],Z([0,1,35]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new w.LRUCache(1e4);function R(y){return m(y,"NFC",n)}e.normalizeNFC=R;const C=new w.LRUCache(1e4);function M(y){return m(y,"NFD",C)}e.normalizeNFD=M;const b=/[^\u0000-\u0080]/;function m(y,E,k){if(!y)return y;const I=k.get(y);if(I)return I;let p;return b.test(y)?p=y.normalize(E):p=y,k.set(y,p),p}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(E){return M(E).replace(y,"")}}()}),define(J[14],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(a){return Array.isArray(a)}e.isArray=w;function n(a){return typeof a=="string"}e.isString=n;function R(a){return Array.isArray(a)&&a.every(l=>n(l))}e.isStringArray=R;function C(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=C;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=b;function m(a){return a===!0||a===!1}e.isBoolean=m;function y(a){return typeof a=="undefined"}e.isUndefined=y;function E(a){return!k(a)}e.isDefined=E;function k(a){return y(a)||a===null}e.isUndefinedOrNull=k;function I(a,l){if(!a)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=I;function p(a){if(k(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=p;function t(...a){const l=[];for(let S=0;S<a.length;S++){const D=a[S];if(k(D))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);l.push(D)}return l}e.assertAllDefined=t;const h=Object.prototype.hasOwnProperty;function g(a){if(!C(a))return!1;for(let l in a)if(h.call(a,l))return!1;return!0}e.isEmptyObject=g;function v(a){return typeof a=="function"}e.isFunction=v;function P(...a){return a.length>0&&a.every(v)}e.areFunctions=P;function d(a,l){const S=Math.min(a.length,l.length);for(let D=0;D<S;D++)f(a[D],l[D])}e.validateConstraints=d;function f(a,l){if(n(l)){if(typeof a!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(v(l)){try{if(a instanceof l)return}catch{}if(!k(a)&&a.constructor===l||l.length===1&&l.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(a){let l=[],S=Object.getPrototypeOf(a);for(;Object.prototype!==S;)l=l.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return l}e.getAllPropertyNames=c;function o(a){const l=[];for(const S of c(a))typeof a[S]=="function"&&l.push(S);return l}e.getAllMethodNames=o;function u(a,l){const S=L=>function(){const W=Array.prototype.slice.call(arguments,0);return l(L,W)};let D={};for(const L of a)D[L]=S(L);return D}e.createProxyObject=u;function r(a){return a===null?void 0:a}e.withNullAsUndefined=r;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function s(a,l="Unreachable"){throw new Error(l)}e.assertNever=s}),define(J[28],Z([0,1,8,3,27,14]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function b(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=b;function m(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=m;function y(s,a=w.posix.sep){if(!s)return"";const l=s.length,S=s.charCodeAt(0);if(M(S)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let L=3;const W=L;for(;L<l&&!M(s.charCodeAt(L));L++);if(W!==L&&!M(s.charCodeAt(L+1))){for(L+=1;L<l;L++)if(M(s.charCodeAt(L)))return s.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(v(S)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<l;D++)if(M(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=y;function E(s){if(!n.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let l=2;const S=l;for(;l<s.length&&(a=s.charCodeAt(l),a!==92);l++);return!(S===l||(a=s.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=E;const k=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,a=n.isWindows){const l=a?k:I;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||a&&p.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function h(s,a,l){const S=s===a;return!l||S?S:!s||!a?!1:(0,R.equalsIgnoreCase)(s,a)}e.isEqual=h;function g(s,a,l,S=w.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let L=a.length;return a.charAt(a.length-1)===S&&L--,s.charAt(L)===S}return a.charAt(a.length-1)!==S&&(a+=S),s.indexOf(a)===0}e.isEqualOrParent=g;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function P(s,a){return n.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(a,s)),s=(0,w.normalize)(s),n.isWindows?(s=(0,R.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,R.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=P;function d(s){const a=(0,w.normalize)(s);return n.isWindows?s.length>3?!1:f(a)&&(s.length===2||a.charCodeAt(2)===92):a===w.posix.sep}e.isRootOrDriveLetter=d;function f(s,a){return(a!==void 0?a:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(s){return f(s)?s[0]:void 0}e.getDriveLetter=c;function o(s,a,l){return a.length>s.length?-1:s===a?0:(l&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=o;function u(s){const a=s.split(":");let l,S,D;for(const L of a){const W=Number(L);(0,C.isNumber)(W)?S===void 0?S=W:D===void 0&&(D=W):l=l?[l,L].join(":"):L}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:S!==void 0?S:void 0,column:D!==void 0?D:S!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,l=8){let S="";for(let L=0;L<l;L++)S+=r.charAt(Math.floor(Math.random()*r.length));let D;return a?D=`${a}-${S}`:D=S,s?(0,w.join)(s,D):D}e.randomPath=i}),define(J[49],Z([0,1,14]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?g[v]=n(h[v]):g[v]=h[v]}),g}e.deepClone=n;function R(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const P in v)if(C.call(v,P)){const d=v[P];typeof d=="object"&&!Object.isFrozen(d)&&g.push(d)}}return h}e.deepFreeze=R;const C=Object.prototype.hasOwnProperty;function M(h,g){return b(h,g,new Set)}e.cloneAndChange=M;function b(h,g,v){if((0,w.isUndefinedOrNull)(h))return h;const P=g(h);if(typeof P!="undefined")return P;if((0,w.isArray)(h)){const d=[];for(const f of h)d.push(b(f,g,v));return d}if((0,w.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const d={};for(let f in h)C.call(h,f)&&(d[f]=b(h[f],g,v));return v.delete(h),d}return h}function m(h,g,v=!0){return(0,w.isObject)(h)?((0,w.isObject)(g)&&Object.keys(g).forEach(P=>{P in h?v&&((0,w.isObject)(h[P])&&(0,w.isObject)(g[P])?m(h[P],g[P],v):h[P]=g[P]):h[P]=g[P]}),h):g}e.mixin=m;function y(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let v,P;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(v=0;v<h.length;v++)if(!y(h[v],g[v]))return!1}else{const d=[];for(P in h)d.push(P);d.sort();const f=[];for(P in g)f.push(P);if(f.sort(),!y(d,f))return!1;for(v=0;v<d.length;v++)if(!y(h[d[v]],g[d[v]]))return!1}return!0}e.equals=y;function E(h){const g=new Set;return JSON.stringify(h,(v,P)=>{if((0,w.isObject)(P)||Array.isArray(P)){if(g.has(P))return"[Circular]";g.add(P)}return P})}e.safeStringify=E;function k(h,g,v){const P=g(h);return typeof P=="undefined"?v:P}e.getOrDefault=k;function I(h,g){const v=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const f=h[d],c=g[d];y(f,c)||(v[d]=c)}),v}e.distinct=I;function p(h,g){const v=g.toLowerCase(),P=Object.keys(h).find(d=>d.toLowerCase()===v);return P?h[P]:h[g]}e.getCaseInsensitive=p;function t(h,g){const v=Object.create(null);for(const[P,d]of Object.entries(h))g(P,d)&&(v[P]=d);return v}e.filter=t}),define(J[7],Z([0,1,8,3]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,C=/^\//,M=/^\/\//;function b(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!R.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(r,i){return!r&&!i?"file":r}function y(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const E="",k="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,s,a,l,S,D=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=m(i,D),this.authority=s||E,this.path=y(this.scheme,a||E),this.query=l||E,this.fragment=S||E,b(this,D))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:l,query:S,fragment:D}=i;return s===void 0?s=this.scheme:s===null&&(s=E),a===void 0?a=this.authority:a===null&&(a=E),l===void 0?l=this.path:l===null&&(l=E),S===void 0?S=this.query:S===null&&(S=E),D===void 0?D=this.fragment:D===null&&(D=E),s===this.scheme&&a===this.authority&&l===this.path&&S===this.query&&D===this.fragment?this:new h(s,a,l,S,D)}static parse(i,s=!1){const a=I.exec(i);return a?new h(a[2]||E,u(a[4]||E),u(a[5]||E),u(a[7]||E),u(a[9]||E),s):new h(E,E,E,E,E)}static file(i){let s=E;if(n.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const a=i.indexOf(k,2);a===-1?(s=i.substring(2),i=k):(s=i.substring(2,a),i=i.substring(a)||k)}return new h("file",s,i,E,E)}static from(i){const s=new h(i.scheme,i.authority,i.path,i.query,i.fragment);return b(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=p.file(w.win32.join(d(i,!0),...s)).path:a=w.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const s=new h(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=p;const t=n.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let s,a=-1;for(let l=0;l<r.length;l++){const S=r.charCodeAt(l);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||i&&S===47)a!==-1&&(s+=encodeURIComponent(r.substring(a,l)),a=-1),s!==void 0&&(s+=r.charAt(l));else{s===void 0&&(s=r.substr(0,l));const D=g[S];D!==void 0?(a!==-1&&(s+=encodeURIComponent(r.substring(a,l)),a=-1),s+=D):a===-1&&(a=l)}}return a!==-1&&(s+=encodeURIComponent(r.substring(a))),s!==void 0?s:r}function P(r){let i;for(let s=0;s<r.length;s++){const a=r.charCodeAt(s);a===35||a===63?(i===void 0&&(i=r.substr(0,s)),i+=g[a]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function d(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function f(r,i){const s=i?P:v;let a="",{scheme:l,authority:S,path:D,query:L,fragment:W}=r;if(l&&(a+=l,a+=":"),(S||l==="file")&&(a+=k,a+=k),S){let U=S.indexOf("@");if(U!==-1){const j=S.substr(0,U);S=S.substr(U+1),U=j.indexOf(":"),U===-1?a+=s(j,!1):(a+=s(j.substr(0,U),!1),a+=":",a+=s(j.substr(U+1),!1)),a+="@"}S=S.toLowerCase(),U=S.indexOf(":"),U===-1?a+=s(S,!1):(a+=s(S.substr(0,U),!1),a+=S.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}a+=s(D,!0)}return L&&(a+="?",a+=s(L,!1)),W&&(a+="#",a+=i?W:v(W,!1)),a}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(o)?r.replace(o,i=>c(i)):r}}),define(J[113],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(y){const E=y;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function R(y){const E=[];let k;try{const I=JSON.parse(y.arguments),p=I[I.length-1];p&&p.__$stack&&(I.pop(),k=p.__$stack),E.push(...I)}catch{E.push("Unable to log remote console arguments",y.arguments)}return{args:E,stack:k}}e.parse=R;function C(y){if(typeof y!="string")return C(R(y).stack);const E=y;if(E){const k=M(E),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(I&&I.length===4)return{uri:w.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=C;function M(y){if(!y)return y;const E=y.indexOf(`
`);return E===-1?y:y.substring(0,E)}function b(y,E){const{args:k,stack:I}=R(y),p=typeof k[0]=="string"&&k.length===1;let t=M(I);t&&(t=`(${t.trim()})`);let h=[];if(typeof k[0]=="string"?t&&p?h=[`%c[${E}] %c${k[0]} %c${t}`,m("blue"),m(""),m("grey")]:h=[`%c[${E}] %c${k[0]}`,m("blue"),m(""),...k.slice(1)]:h=[`%c[${E}]%`,m("blue"),...k],t&&!p&&h.push(t),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,h)}e.log=b;function m(y){return`color: ${y}`}}),define(J[114],Z([0,1,17,27,7]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(E){return JSON.stringify(E,m)}e.stringify=C;function M(E){let k=JSON.parse(E);return k=y(k),k}e.parse=M;var b;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext",E[E.Date=14]="Date"})(b=e.MarshalledId||(e.MarshalledId={}));function m(E,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,n.regExpFlags)(k)}:k}function y(E,k=0){if(!E||k>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof w.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let I=0;I<E.length;++I)E[I]=y(E[I],k+1);else for(const I in E)Object.hasOwnProperty.call(E,I)&&(E[I]=y(E[I],k+1))}return E}e.revive=y}),define(J[10],Z([0,1,3,7]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.userData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,y,E){this._hosts[m]=y,this._ports[m]=E}setConnectionToken(m,y){this._connectionTokens[m]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const y=m.authority;let E=this._hosts[y];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const k=this._ports[y],I=this._connectionTokens[y];let p=`path=${encodeURIComponent(m.path)}`;return typeof I=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),n.URI.from({scheme:w.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${E}:${k}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new C;class M{asBrowserUri(m,y){const E=this.toUri(m,y);return E.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===R.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${R.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?E.with({scheme:R.vscodeFileResource,authority:E.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(m,y){const E=this.toUri(m,y);return E.scheme===R.vscodeFileResource?E.with({scheme:R.file,authority:E.authority!==M.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(m,y){return n.URI.isUri(m)?m:n.URI.parse(y.toUrl(m))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(J[16],Z([0,1,28,10,8,3,27,7]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(p){return(0,b.uriToFsPath)(p,!0)}e.originalFSPath=m;class y{constructor(t){this._ignorePathCasing=t}compare(t,h,g=!1){return t===h?0:(0,M.compare)(this.getComparisonKey(t,g),this.getComparisonKey(h,g))}isEqual(t,h,g=!1){return t===h?!0:!t||!h?!1:this.getComparisonKey(t,g)===this.getComparisonKey(h,g)}getComparisonKey(t,h=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,h,g=!1){if(t.scheme===h.scheme){if(t.scheme===n.Schemas.file)return w.isEqualOrParent(m(t),m(h),this._ignorePathCasing(t))&&t.query===h.query&&(g||t.fragment===h.fragment);if((0,e.isEqualAuthority)(t.authority,h.authority))return w.isEqualOrParent(t.path,h.path,this._ignorePathCasing(t),"/")&&t.query===h.query&&(g||t.fragment===h.fragment)}return!1}joinPath(t,...h){return b.URI.joinPath(t,...h)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return R.posix.basename(t.path)}extname(t){return R.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let h;return t.scheme===n.Schemas.file?h=b.URI.file(R.dirname(m(t))).path:(h=R.posix.dirname(t.path),t.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),h="/")),t.with({path:h})}normalizePath(t){if(!t.path.length)return t;let h;return t.scheme===n.Schemas.file?h=b.URI.file(R.normalize(m(t))).path:h=R.posix.normalize(t.path),t.with({path:h})}relativePath(t,h){if(t.scheme!==h.scheme||!(0,e.isEqualAuthority)(t.authority,h.authority))return;if(t.scheme===n.Schemas.file){const P=R.relative(m(t),m(h));return C.isWindows?w.toSlashes(P):P}let g=t.path||"/",v=h.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const d=Math.min(g.length,v.length);P<d&&!(g.charCodeAt(P)!==v.charCodeAt(P)&&g.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);g=v.substr(0,P)+g.substr(P)}return R.posix.relative(g,v)}resolvePath(t,h){if(t.scheme===n.Schemas.file){const g=b.URI.file(R.resolve(m(t),h));return t.with({authority:g.authority,path:g.path})}return h=w.toPosixPath(h),t.with({path:R.posix.resolve(t.path,h)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,h){return t===h||t!==void 0&&h!==void 0&&(0,M.equalsIgnoreCase)(t,h)}hasTrailingPathSeparator(t,h=R.sep){if(t.scheme===n.Schemas.file){const g=m(t);return g.length>w.getRoot(g).length&&g[g.length-1]===h}else{const g=t.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,h=R.sep){return(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,h=R.sep){let g=!1;if(t.scheme===n.Schemas.file){const v=m(t);g=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=t.path;g=v.length===1&&v.charCodeAt(v.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path+"/"}):t}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(p,t){const h=[];for(let g=0;g<p.length;g++){const v=t(p[g]);p.some((P,d)=>d===g?!1:(0,e.isEqualOrParent)(v,t(P)))||h.push(p[g])}return h}e.distinctParents=E;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[f,c]=d.split(":");f&&c&&g.set(f,c)});const P=h.path.substring(0,h.path.indexOf(";"));return P&&g.set(p.META_DATA_MIME,P),g}p.parseMetaData=t})(k=e.DataUri||(e.DataUri={}));function I(p,t,h){if(t){let g=p.path;return g&&g[0]!==R.posix.sep&&(g=R.posix.sep+g),p.with({scheme:h,authority:t,path:g})}return p.with({scheme:h})}e.toLocalResource=I}),define(J[9],Z([0,1,23,15,4,2,16,3]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(T){return!!T&&typeof T.then=="function"}e.isThenable=m;function y(T){const A=new w.CancellationTokenSource,O=T(A.token),_=new Promise((Y,ie)=>{const ae=A.token.onCancellationRequested(()=>{ae.dispose(),A.dispose(),ie(new n.CancellationError)});Promise.resolve(O).then(ce=>{ae.dispose(),A.dispose(),Y(ce)},ce=>{ae.dispose(),A.dispose(),ie(ce)})});return new class{cancel(){A.cancel()}then(Y,ie){return _.then(Y,ie)}catch(Y){return this.then(void 0,Y)}finally(Y){return _.finally(Y)}}}e.createCancelablePromise=y;function E(T,A,O){return new Promise((_,Y)=>{const ie=A.onCancellationRequested(()=>{ie.dispose(),_(O)});T.then(_,Y).finally(()=>ie.dispose())})}e.raceCancellation=E;function k(T,A){return new Promise((O,_)=>{const Y=A.onCancellationRequested(()=>{Y.dispose(),_(new n.CancellationError)});T.then(O,_).finally(()=>Y.dispose())})}e.raceCancellationError=k;async function I(T){let A=-1;const O=T.map((Y,ie)=>Y.then(ae=>(A=ie,ae))),_=await Promise.race(O);return T.forEach((Y,ie)=>{ie!==A&&Y.cancel()}),_}e.raceCancellablePromises=I;function p(T,A,O){let _;const Y=setTimeout(()=>{_?.(void 0),O?.()},A);return Promise.race([T.finally(()=>clearTimeout(Y)),new Promise(ie=>_=ie)])}e.raceTimeout=p;function t(T){return new Promise((A,O)=>{const _=T();m(_)?_.then(A,O):A(_)})}e.asPromise=t;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=A(),new Promise((O,_)=>{this.activePromise.then(Y=>{this.activePromise=null,O(Y)},Y=>{this.activePromise=null,_(Y)})})}}e.Throttler=h;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class v{constructor(){this.promiseMap=new Map}queue(A,O){const Y=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===Y&&this.promiseMap.delete(A)});return this.promiseMap.set(A,Y),Y}}e.SequencerByKey=v;const P=(T,A)=>{let O=!0;const _=setTimeout(()=>{O=!1,A()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},d=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,ie)=>{this.doResolve=Y,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(_):P(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(A){this.delayer=new f(A),this.throttler=new h}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class u extends o{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function r(T,A){return A?new Promise((O,_)=>{const Y=setTimeout(()=>{ie.dispose(),O()},T),ie=A.onCancellationRequested(()=>{clearTimeout(Y),ie.dispose(),_(new n.CancellationError)})}):y(O=>r(T,O))}e.timeout=r;function i(T,A=0){const O=setTimeout(T,A);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function s(T){const A=[];let O=0;const _=T.length;function Y(){return O<_?T[O++]():null}function ie(ae){ae!=null&&A.push(ae);const ce=Y();return ce?ce.then(ie):Promise.resolve(A)}return Promise.resolve(null).then(ie)}e.sequence=s;function a(T,A=_=>!!_,O=null){let _=0;const Y=T.length,ie=()=>{if(_>=Y)return Promise.resolve(O);const ae=T[_++];return Promise.resolve(ae()).then(ne=>A(ne)?Promise.resolve(ne):ie())};return ie()}e.first=a;function l(T,A=_=>!!_,O=null){if(T.length===0)return Promise.resolve(O);let _=T.length;const Y=()=>{_=-1;for(const ie of T)ie.cancel?.()};return new Promise((ie,ae)=>{for(const ce of T)ce.then(ne=>{--_>=0&&A(ne)?(Y(),ie(ne)):_===0&&ie(O)}).catch(ne=>{--_>=0&&(Y(),ae(ne))})})}e.firstParallel=l;class S{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:A,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=S;class D extends S{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new V;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=M.extUri){const _=O.getComparisonKey(A);let Y=this.queues.get(_);return Y||(Y=new D,R.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(_),this.onDidQueueFinish()}),this.queues.set(_,Y)),Y}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=U;class j{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=j;class ee{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ee;class x extends j{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class N extends C.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,b.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const O=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class G{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=G;async function z(T,A,O){let _;for(let Y=0;Y<O;Y++)try{return await T()}catch(ie){_=ie,await r(A)}throw _}e.retry=z;class X{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,_){return this._pending={taskId:A,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,_;const Y=new Promise((ie,ae)=>{O=ie,_=ae});this._next={run:A,promise:Y,promiseResolve:O,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=X;class re{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=re;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=V;var H;(function(T){async function A(_){let Y;const ie=await Promise.all(_.map(ae=>ae.then(ce=>ce,ce=>{Y||(Y=ce)})));if(typeof Y!="undefined")throw Y;return ie}T.settled=A;function O(_){return new Promise(async(Y,ie)=>{try{await _(Y,ie)}catch(ae){ie(ae)}})}T.withAsyncBody=O})(H=e.Promises||(e.Promises={}));var K;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(K||(K={}));class ${constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(A(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new $(O=>{O.emitMany(A)})}static fromPromise(A){return new $(async O=>{O.emitMany(await A)})}static fromPromises(A){return new $(async O=>{await Promise.all(A.map(async _=>O.emitOne(await _)))})}static merge(A){return new $(async O=>{await Promise.all(A.map(async _=>{for await(const Y of _)O.emitOne(Y)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new $(async _=>{for await(const Y of A)_.emitOne(O(Y))})}map(A){return $.map(this,A)}static filter(A,O){return new $(async _=>{for await(const Y of A)O(Y)&&_.emitOne(Y)})}filter(A){return $.filter(this,A)}static coalesce(A){return $.filter(A,O=>!!O)}coalesce(){return $.coalesce(this)}static async toPromise(A){const O=[];for await(const _ of A)O.push(_);return O}toPromise(){return $.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class F extends ${constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function B(T){const A=new w.CancellationTokenSource,O=T(A.token);return new F(A,async _=>{const Y=A.token.onCancellationRequested(()=>{Y.dispose(),A.dispose(),_.reject(new n.CancellationError)});try{for await(const ie of O){if(A.token.isCancellationRequested)return;_.emitOne(ie)}Y.dispose(),A.dispose()}catch(ie){Y.dispose(),A.dispose(),_.reject(ie)}})}e.createCancelableAsyncIterable=B}),define(J[115],Z([0,1,9,28,35,8,3,27]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",E="[^/\\\\]",k=/\//g;function I(V){switch(V){case 0:return"";case 1:return`${E}*?`;default:return`(?:${y}|${E}+${y}|${y}${E}+)*?`}}function p(V,H){if(!V)return[];const K=[];let $=!1,F=!1,B="";for(const T of V){switch(T){case H:if(!$&&!F){K.push(B),B="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":F=!0;break;case"]":F=!1;break}B+=T}return B&&K.push(B),K}e.splitGlobAware=p;function t(V){if(!V)return"";let H="";const K=p(V,e.GLOB_SPLIT);if(K.every($=>$===e.GLOBSTAR))H=".*";else{let $=!1;K.forEach((F,B)=>{if(F===e.GLOBSTAR){$||(H+=I(2),$=!0);return}let T=!1,A="",O=!1,_="";for(const Y of F){if(Y!=="}"&&T){A+=Y;continue}if(O&&(Y!=="]"||!_)){let ie;Y==="-"?ie=Y:(Y==="^"||Y==="!")&&!_?ie="^":Y===e.GLOB_SPLIT?ie="":ie=(0,b.escapeRegExpCharacters)(Y),_+=ie;continue}switch(Y){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{H+=`(?:${p(A,",").map(ce=>t(ce)).join("|")})`,T=!1,A="";break}case"]":H+="["+_+"]",O=!1,_="";break;case"?":H+=E;continue;case"*":H+=I(1);continue;default:H+=(0,b.escapeRegExpCharacters)(Y)}}B<K.length-1&&(K[B+1]!==e.GLOBSTAR||B+2<K.length)&&(H+=y),$=!1})}return H}const h=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new R.LRUCache(1e4),o=function(){return!1},u=function(){return null};function r(V,H){if(!V)return u;let K;typeof V!="string"?K=V.pattern:K=V,K=K.trim();const $=`${K}_${!!H.trimForExclusions}`;let F=c.get($);if(F)return i(F,V);let B;if(h.test(K)){const T=K.substr(4);F=function(A,O){return typeof A=="string"&&A.endsWith(T)?K:null}}else(B=g.exec(s(K,H)))?F=a(B[1],K):(H.trimForExclusions?P:v).test(K)?F=l(K,H):(B=d.exec(s(K,H)))?F=S(B[1].substr(1),K,!0):(B=f.exec(s(K,H)))?F=S(B[1],K,!1):F=D(K);return c.set($,F),i(F,V)}function i(V,H){return typeof H=="string"?V:function(K,$){return(0,n.isEqualOrParent)(K,H.base,!M.isLinux)?V(K.substr(H.base.length+1),$):null}}function s(V,H){return H.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function a(V,H){const K=`/${V}`,$=`\\${V}`,F=function(T,A){return typeof T!="string"?null:A?A===V?H:null:T===V||T.endsWith(K)||T.endsWith($)?H:null},B=[V];return F.basenames=B,F.patterns=[H],F.allBasenames=B,F}function l(V,H){const K=re(V.slice(1,-1).split(",").map(A=>r(A,H)).filter(A=>A!==u),V),$=K.length;if(!$)return u;if($===1)return K[0];const F=function(A,O){for(let _=0,Y=K.length;_<Y;_++)if(K[_](A,O))return V;return null},B=K.find(A=>!!A.allBasenames);B&&(F.allBasenames=B.allBasenames);const T=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function S(V,H,K){const $=C.sep===C.posix.sep,F=$?V:V.replace(k,C.sep),B=C.sep+F,T=C.posix.sep+V,A=K?function(O,_){return typeof O=="string"&&(O===F||O.endsWith(B)||!$&&(O===V||O.endsWith(T)))?H:null}:function(O,_){return typeof O=="string"&&(O===F||!$&&O===V)?H:null};return A.allPaths=[(K?"*/":"./")+V],A}function D(V){try{const H=new RegExp(`^${t(V)}$`);return function(K){return H.lastIndex=0,typeof K=="string"&&H.test(K)?V:null}}catch{return u}}function L(V,H,K){return!V||typeof H!="string"?!1:W(V)(H,void 0,K)}e.match=L;function W(V,H={}){if(!V)return o;if(typeof V=="string"||x(V)){const K=r(V,H);if(K===u)return o;const $=function(F,B){return!!K(F,B)};return K.allBasenames&&($.allBasenames=K.allBasenames),K.allPaths&&($.allPaths=K.allPaths),$}return z(V,H)}e.parse=W;function U(V){if(!V)return;let H;return K=>(H||(H=(V()||Promise.resolve([])).then($=>$?ee($):{})),H.then($=>!!$[K]))}e.hasSiblingPromiseFn=U;function j(V){if(!V)return;let H;return K=>{if(!H){const $=V();H=$?ee($):{}}return!!H[K]}}e.hasSiblingFn=j;function ee(V){const H={};for(const K of V)H[K]=!0;return H}function x(V){const H=V;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=x;function N(V){return V.allBasenames||[]}e.getBasenameTerms=N;function G(V){return V.allPaths||[]}e.getPathTerms=G;function z(V,H){const K=re(Object.getOwnPropertyNames(V).map(A=>X(A,V[A],H)).filter(A=>A!==u)),$=K.length;if(!$)return u;if(!K.some(A=>!!A.requiresSiblings)){if($===1)return K[0];const A=function(Y,ie){for(let ae=0,ce=K.length;ae<ce;ae++){const ne=K[ae](Y,ie);if(ne)return ne}return null},O=K.find(Y=>!!Y.allBasenames);O&&(A.allBasenames=O.allBasenames);const _=K.reduce((Y,ie)=>ie.allPaths?Y.concat(ie.allPaths):Y,[]);return _.length&&(A.allPaths=_),A}const F=function(A,O,_){let Y;for(let ie=0,ae=K.length;ie<ae;ie++){const ce=K[ie];ce.requiresSiblings&&_&&(O||(O=(0,C.basename)(A)),Y||(Y=O.substr(0,O.length-(0,C.extname)(A).length)));const ne=ce(A,O,Y,_);if(ne)return ne}return null},B=K.find(A=>!!A.allBasenames);B&&(F.allBasenames=B.allBasenames);const T=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function X(V,H,K){if(H===!1)return u;const $=r(V,K);if($===u)return u;if(typeof H=="boolean")return $;if(H){const F=H.when;if(typeof F=="string"){const B=(T,A,O,_)=>{if(!_||!$(T,A))return null;const Y=F.replace("$(basename)",O),ie=_(Y);return(0,w.isThenable)(ie)?ie.then(ae=>ae?V:null):ie?V:null};return B.requiresSiblings=!0,B}}return $}function re(V,H){const K=V.filter(A=>!!A.basenames);if(K.length<2)return V;const $=K.reduce((A,O)=>{const _=O.basenames;return _?A.concat(_):A},[]);let F;if(H){F=[];for(let A=0,O=$.length;A<O;A++)F.push(H)}else F=K.reduce((A,O)=>{const _=O.patterns;return _?A.concat(_):A},[]);const B=function(A,O){if(typeof A!="string")return null;if(!O){let Y;for(Y=A.length;Y>0;Y--){const ie=A.charCodeAt(Y-1);if(ie===47||ie===92)break}O=A.substr(Y)}const _=$.indexOf(O);return _!==-1?F[_]:null};B.basenames=$,B.patterns=F,B.allBasenames=$;const T=V.filter(A=>!A.basenames);return T.push(B),T}}),define(J[33],Z([0,1,28,10,8,3,16,27,7]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(i,s,a){if(typeof i=="string"&&(i=m.URI.file(i)),a){const S=a.getWorkspaceFolder(i);if(S){const D=a.getWorkspace().folders.length>1;let L;if((0,M.isEqual)(S.uri,i)?L="":L=(0,M.relativePath)(S.uri,i),D){const W=S.name?S.name:(0,M.basename)(S.uri);L=L?W+" \u2022 "+L:W}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(i.fsPath))return(0,R.normalize)(k(i.fsPath));let l=(0,R.normalize)(i.fsPath);return!C.isWindows&&s?.userHome&&(l=p(l,s.userHome.fsPath)),l}e.getPathLabel=y;function E(i){if(!i)return;typeof i=="string"&&(i=m.URI.file(i));const s=(0,M.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,w.isRootOrDriveLetter)(s)?k(s):s}e.getBaseLabel=E;function k(i,s){return(0,w.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let I=Object.create(null);function p(i,s){if(C.isWindows||!i||!s)return i;let a=I.original===s?I.normalized:void 0;return a||(a=`${(0,b.rtrim)(s,R.posix.sep)}${R.posix.sep}`,I={original:s,normalized:a}),(C.isLinux?i.startsWith(a):(0,b.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=p;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const h="\u2026",g="\\\\",v="~";function P(i,s=R.sep){const a=new Array(i.length);let l=!1;for(let S=0;S<i.length;S++){let D=i[S];if(D===""){a[S]=`.${s}`;continue}if(!D){a[S]=D;continue}l=!0;let L="";D.indexOf(g)===0?(L=D.substr(0,D.indexOf(g)+g.length),D=D.substr(D.indexOf(g)+g.length)):D.indexOf(s)===0?(L=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(v)===0&&(L=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length));const W=D.split(s);for(let U=1;l&&U<=W.length;U++)for(let j=W.length-U;l&&j>=0;j--){l=!1;let ee=W.slice(j,j+U).join(s);for(let x=0;!l&&x<i.length;x++)if(x!==S&&i[x]&&i[x].indexOf(ee)>-1){const N=j+U===W.length,G=j>0&&i[x].indexOf(s)>-1?s+ee:ee,z=i[x].endsWith(G);l=!N||z}if(!l){let x="";(W[0].endsWith(":")||L!=="")&&(j===1&&(j=0,U++,ee=W[0]+s+ee),j>0&&(x=W[0]+s),x=L+x),j>0&&(x=x+h+s),x=x+ee,j+U<W.length&&(x=x+s+h),a[S]=x}}l&&(a[S]=D)}return a}e.shorten=P;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function f(i,s=Object.create(null)){const a=[];let l=!1,S="";for(const D of i)if(D==="$"||l&&D==="{")S&&a.push({value:S,type:d.TEXT}),S="",l=!0;else if(D==="}"&&l){const L=s[S];if(typeof L=="string")L.length&&a.push({value:L,type:d.VARIABLE});else if(L){const W=a[a.length-1];(!W||W.type!==d.SEPARATOR)&&a.push({value:L.label,type:d.SEPARATOR})}S="",l=!1}else S+=D;return S&&!l&&a.push({value:S,type:d.TEXT}),a.filter((D,L)=>{if(D.type===d.SEPARATOR){const W=a[L-1],U=a[L+1];return[W,U].every(j=>j&&(j.type===d.VARIABLE||j.type===d.TEXT)&&j.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=f;function c(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const s=i.indexOf("/")!==-1?R.posix:R.win32,a=s.basename(i),l=s.dirname(i);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(J[116],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const I=this._uriTransformer.transformIncoming(k);return I===k?k:n(w.URI.from(I))}transformOutgoing(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:n(w.URI.from(I))}transformOutgoingURI(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:w.URI.from(I)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function C(E,k,I){if(!E||I>200)return null;if(typeof E=="object"){if(E instanceof w.URI)return k.transformOutgoing(E);for(let p in E)if(Object.hasOwnProperty.call(E,p)){const t=C(E[p],k,I+1);t!==null&&(E[p]=t)}}return null}function M(E,k){const I=C(E,k,0);return I===null?E:I}e.transformOutgoingURIs=M;function b(E,k,I,p){if(!E||p>200)return null;if(typeof E=="object"){if(E.$mid===1)return I?w.URI.revive(k.transformIncoming(E)):k.transformIncoming(E);for(let t in E)if(Object.hasOwnProperty.call(E,t)){const h=b(E[t],k,I,p+1);h!==null&&(E[t]=h)}}return null}function m(E,k){const I=b(E,k,!1,0);return I===null?E:I}e.transformIncomingURIs=m;function y(E,k){const I=b(E,k,!0,0);return I===null?E:I}e.transformAndReviveIncomingURIs=y}),define(J[31],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(m){return w.test(m)}e.isUUID=n;const R=new Uint8Array(16),C=[];for(let m=0;m<256;m++)C.push(m.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(m){for(let y=0;y<m.length;y++)m[y]=Math.floor(Math.random()*256);return m};function b(){M(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,y="";return y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y+="-",y+=C[R[m++]],y+=C[R[m++]],y+="-",y+=C[R[m++]],y+=C[R[m++]],y+="-",y+=C[R[m++]],y+=C[R[m++]],y+="-",y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y+=C[R[m++]],y}e.generateUuid=b}),define(J[117],Z([0,1,15,4,2,3,14,27]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const m="$initialize";let y=!1;function E(r){!C.isWeb||(y||(y=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=E;var k;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class I{constructor(i,s,a,l){this.vsWorker=i,this.req=s,this.method=a,this.args=l,this.type=0}}class p{constructor(i,s,a,l){this.vsWorker=i,this.seq=s,this.res=a,this.err=l,this.type=1}}class t{constructor(i,s,a,l){this.vsWorker=i,this.req=s,this.eventName=a,this.arg=l,this.type=2}}class h{constructor(i,s,a){this.vsWorker=i,this.req=s,this.event=a,this.type=3}}class g{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const a=String(++this._lastSentReq);return new Promise((l,S)=>{this._pendingReplies[a]={resolve:l,reject:S},this._send(new I(this._workerId,a,i,s))})}listen(i,s){let a=null;const l=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,l),this._send(new t(this._workerId,a,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new g(this._workerId,a)),a=null}});return l.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),s.reject(a);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(l=>{this._send(new p(this._workerId,s,l,void 0))},l=>{l.detail instanceof Error&&(l.detail=(0,w.transformErrorForSerialization)(l.detail)),this._send(new p(this._workerId,s,void 0,(0,w.transformErrorForSerialization)(l)))})}_handleSubscribeEventMessage(i){const s=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(l=>{this._send(new h(this._workerId,s,l))});this._pendingEvents.set(s,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&s.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class P extends R.Disposable{constructor(i,s,a){super();let l=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{l&&l(U)})),this._protocol=new v({sendMessage:(U,j)=>{this._worker.postMessage(U,j)},handleMessage:(U,j)=>{if(typeof a[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(a[U].apply(a,j))}catch(ee){return Promise.reject(ee)}},handleEvent:(U,j)=>{if(f(U)){const ee=a[U].call(a,j);if(typeof ee!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return ee}if(d(U)){const ee=a[U];if(typeof ee!="function")throw new Error(`Missing event ${U} on main thread host.`);return ee}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?S=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(S=C.globals.requirejs.s.contexts._.config);const D=M.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(m,[this._worker.getId(),JSON.parse(JSON.stringify(S)),s,D]);const L=(U,j)=>this._request(U,j),W=(U,j)=>this._protocol.listen(U,j);this._lazyProxy=new Promise((U,j)=>{l=j,this._onModuleLoaded.then(ee=>{U(c(ee,L,W))},ee=>{j(ee),this._onError("Worker failed to load "+s,ee)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((a,l)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(a,l)},l)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=P;function d(r){return r[0]==="o"&&r[1]==="n"&&b.isUpperAsciiLetter(r.charCodeAt(2))}function f(r){return/^onDynamic/.test(r)&&b.isUpperAsciiLetter(r.charCodeAt(9))}function c(r,i,s){const a=D=>function(){const L=Array.prototype.slice.call(arguments,0);return i(D,L)},l=D=>function(L){return s(D,L)};let S={};for(const D of r){if(f(D)){S[D]=l(D);continue}if(d(D)){S[D]=s(D,void 0);continue}S[D]=a(D)}return S}class o{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new v({sendMessage:(a,l)=>{i(a,l)},handleMessage:(a,l)=>this._handleMessage(a,l),handleEvent:(a,l)=>this._handleEvent(a,l)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===m)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(a){return Promise.reject(a)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(f(i)){const a=this._requestHandler[i].call(this._requestHandler,s);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(d(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,s,a,l){this._protocol.setWorkerId(i);const L=c(l,(W,U)=>this._protocol.sendMessage(W,U),(W,U)=>this._protocol.listen(W,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,C.globals.require.config(s)),new Promise((W,U)=>{(C.globals.require||q)([a],ee=>{if(this._requestHandler=ee.create(L),!this._requestHandler){U(new Error("No RequestHandler!"));return}W(M.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=o;function u(r){return new o(r,null)}e.create=u}),define(J[118],Z([0,1,60,29,43]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(M,b){if(await new Promise((E,k)=>{const I=n.createReadStream(M),p=w.createHash("sha1");I.pipe(p);const t=(0,R.once)((h,g)=>{I.removeAllListeners(),p.removeAllListeners(),h?k(h):E(g)});I.once("error",t),I.once("end",t),p.once("error",t),p.once("data",h=>t(void 0,h.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=C}),define(J[119],Z([0,1,247]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new w.StringDecoder(C),this.remaining=null}write(C){const M=[],b=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(b.length<1)return M;let m=0,y,E=m;for(;E<b.length;)if(y=b.charCodeAt(E),y===13||y===10){if(M.push(b.substring(m,E)),E++,E<b.length){const k=y;y=b.charCodeAt(E),(k===13&&y===10||k===10&&y===13)&&E++}m=E}else E++;return this.remaining=m<b.length?b.substr(m):null,M}end(){return this.remaining}}e.LineDecoder=n}),define(J[120],Z([0,1,26]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(M){const b=M.replace(/\-/g,":").toLowerCase();return!n.has(b)}function C(){const M=(0,w.networkInterfaces)();for(let b in M){const m=M[b];if(m){for(const{mac:y}of m)if(R(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(J[72],Z([0,1,26,15,35,31,120]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,k=0;const I=(0,w.networkInterfaces)();for(let p in I){const t=I[p];if(t)for(const{mac:h,internal:g}of t)g||(k+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(E+=1))}this._value=k>0?E/k:0}return this._value}};let b;async function m(){return b||(b=(async()=>await y()||C.generateUuid())()),b}e.getMachineId=m;async function y(){try{const E=await new Promise((I,p)=>{q(["crypto"],I,p)}),k=(0,M.getMac)();return E.createHash("sha256").update(k,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(J[24],Z([0,1,29,26,121,9,28,71,8,3,16,7]),function(q,e,w,n,R,C,M,b,m,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function p(N,G=I.UNLINK){if((0,M.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return G===I.UNLINK?h(N):t(N)}async function t(N){try{const G=(0,M.randomPath)((0,n.tmpdir)());try{await w.promises.rename(N,G)}catch{return h(N)}h(G).catch(z=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function h(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function g(N){if((0,M.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(N,{recursive:!0})}e.rimrafSync=g;async function v(N,G){return f(await(G?P(N):(0,R.promisify)(w.readdir)(N)))}async function P(N){try{return await(0,R.promisify)(w.readdir)(N,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const G=[],z=await v(N);for(const X of z){let re=!1,V=!1,H=!1;try{const K=await e.Promises.lstat((0,m.join)(N,X));re=K.isFile(),V=K.isDirectory(),H=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}G.push({name:X,isFile:()=>re,isDirectory:()=>V,isSymbolicLink:()=>H})}return G}function d(N){return f(w.readdirSync(N))}e.readdirSync=d;function f(N){return N.map(G=>typeof G=="string"?y.isMacintosh?(0,b.normalizeNFC)(G):G:(G.name=y.isMacintosh?(0,b.normalizeNFC)(G.name):G.name,G))}async function c(N){const G=await v(N),z=[];for(const X of G)await u.existsDirectory((0,m.join)(N,X))&&z.push(X);return z}function o(N,G=1e3){return new Promise(z=>{let X=!1;const re=setInterval(()=>{X||(X=!0,w.access(N,V=>{X=!1,V&&(clearInterval(re),z(void 0))}))},G)})}e.whenDeleted=o;var u;(function(N){async function G(re){let V;try{if(V=await e.Promises.lstat(re),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(re),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(y.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(re)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw K}throw H}}N.stat=G;async function z(re){try{const{stat:V,symbolicLink:H}=await N.stat(re);return V.isFile()&&H?.dangling!==!0}catch{}return!1}N.existsFile=z;async function X(re){try{const{stat:V,symbolicLink:H}=await N.stat(re);return V.isDirectory()&&H?.dangling!==!0}catch{}return!1}N.existsDirectory=X})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new C.ResourceQueue;function i(N,G,z){return r.queueFor(k.URI.file(N),E.extUriBiasedIgnorePathCase).queue(()=>{const X=S(z);return new Promise((re,V)=>a(N,G,X,H=>H?V(H):re()))})}let s=!0;function a(N,G,z,X){if(!s)return w.writeFile(N,G,{mode:z.mode,flag:z.flag},X);w.open(N,z.flag,z.mode,(re,V)=>{if(re)return X(re);w.writeFile(V,G,H=>{if(H)return w.close(V,()=>X(H));w.fdatasync(V,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),s=!1),w.close(V,$=>X($))))})})}function l(N,G,z){const X=S(z);if(!s)return w.writeFileSync(N,G,{mode:X.mode,flag:X.flag});const re=w.openSync(N,X.flag,X.mode);try{w.writeFileSync(re,G);try{w.fdatasyncSync(re)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),s=!1}}finally{w.closeSync(re)}}e.writeFileSync=l;function S(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function D(N,G){if(N===G)return;async function z(X){try{const re=await e.Promises.lstat(X);if(re.isDirectory()||re.isSymbolicLink())return;await e.Promises.utimes(X,re.atime,new Date)}catch{}}try{await e.Promises.rename(N,G),await z(G)}catch(X){if(N.toLowerCase()!==G.toLowerCase()&&X.code==="EXDEV"||N.endsWith("."))await L(N,G,{preserveSymlinks:!1}),await p(N,I.MOVE),await z(G);else throw X}}async function L(N,G,z){return U(N,G,{root:{source:N,target:G},options:z,handledSourcePaths:new Set})}const W=511;async function U(N,G,z){if(z.handledSourcePaths.has(N))return;z.handledSourcePaths.add(N);const{stat:X,symbolicLink:re}=await u.stat(N);if(re){if(z.options.preserveSymlinks)try{return await x(N,G,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(re.dangling)return}return X.isDirectory()?j(N,G,X.mode&W,z):ee(N,G,X.mode&W)}async function j(N,G,z,X){await e.Promises.mkdir(G,{recursive:!0,mode:z});const re=await v(N);for(const V of re)await U((0,m.join)(N,V),(0,m.join)(G,V),X)}async function ee(N,G,z){await e.Promises.copyFile(N,G),await e.Promises.chmod(G,z)}async function x(N,G,z){let X=await e.Promises.readlink(N);(0,M.isEqualOrParent)(X,z.root.source,!y.isLinux)&&(X=(0,m.join)(z.root.target,X.substr(z.root.source.length+1))),await e.Promises.symlink(X,G)}e.Promises=new class{get access(){return(0,R.promisify)(w.access)}get stat(){return(0,R.promisify)(w.stat)}get lstat(){return(0,R.promisify)(w.lstat)}get utimes(){return(0,R.promisify)(w.utimes)}get read(){return(N,G,z,X,re)=>new Promise((V,H)=>{w.read(N,G,z,X,re,(K,$,F)=>K?H(K):V({bytesRead:$,buffer:F}))})}get readFile(){return(0,R.promisify)(w.readFile)}get write(){return(N,G,z,X,re)=>new Promise((V,H)=>{w.write(N,G,z,X,re,(K,$,F)=>K?H(K):V({bytesWritten:$,buffer:F}))})}get appendFile(){return(0,R.promisify)(w.appendFile)}get fdatasync(){return(0,R.promisify)(w.fdatasync)}get truncate(){return(0,R.promisify)(w.truncate)}get rename(){return(0,R.promisify)(w.rename)}get copyFile(){return(0,R.promisify)(w.copyFile)}get open(){return(0,R.promisify)(w.open)}get close(){return(0,R.promisify)(w.close)}get symlink(){return(0,R.promisify)(w.symlink)}get readlink(){return(0,R.promisify)(w.readlink)}get chmod(){return(0,R.promisify)(w.chmod)}get mkdir(){return(0,R.promisify)(w.mkdir)}get unlink(){return(0,R.promisify)(w.unlink)}get rmdir(){return(0,R.promisify)(w.rmdir)}get realpath(){return(0,R.promisify)(w.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return p}get move(){return D}get copy(){return L}}}),define(J[86],Z([0,1,29,8,3,27,24]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(I){if(R.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const g=(0,M.readdirSync)(p).filter(v=>v.toLowerCase()===t);if(g.length===1){const v=b(p);if(v)return(0,n.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(t);if(v>=0){const P=b(p);if(P)return(0,n.join)(P,g[v])}}}catch{}return null}e.realcaseSync=b;async function m(I){if(R.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const g=(await M.Promises.readdir(p)).filter(v=>v.toLowerCase()===t);if(g.length===1){const v=await m(p);if(v)return(0,n.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(t);if(v>=0){const P=await m(p);if(P)return(0,n.join)(P,g[v])}}}catch{}return null}e.realcase=m;async function y(I){try{return await M.Promises.realpath(I)}catch{const t=k(I);return await M.Promises.access(t,w.constants.R_OK),t}}e.realpath=y;function E(I){try{return w.realpathSync(I)}catch{const t=k(I);return w.accessSync(t,w.constants.R_OK),t}}e.realpathSync=E;function k(I){return(0,C.rtrim)((0,n.normalize)(I),n.sep)}}),define(J[122],Z([0,1,61]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(b,m,y,E=1){let k=!1;return new Promise(I=>{const p=setTimeout(()=>{if(!k)return k=!0,I(0)},y);R(b,m,E,t=>{if(!k)return k=!0,clearTimeout(p),I(t)})})}e.findFreePort=n;function R(b,m,y,E){if(m===0)return E(0);const k=new w.Socket;k.once("connect",()=>(M(k),R(b+y,m-1,y,E))),k.once("data",()=>{}),k.once("error",I=>(M(k),I.code!=="ECONNREFUSED"?R(b+y,m-1,y,E):E(b))),k.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(b,m,y){let E=!1,k,I=1;const p=w.createServer({pauseOnConnect:!0});function t(h,g){E||(E=!0,p.removeAllListeners(),p.close(),k&&clearTimeout(k),g(h))}return new Promise(h=>{k=setTimeout(()=>{t(0,h)},y),p.on("listening",()=>{t(b,h)}),p.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&I<m?(b++,I++,p.listen(b,"127.0.0.1")):t(0,h)}),p.on("close",()=>{t(0,h)}),p.listen(b,"127.0.0.1")})}e.findFreePortFaster=C;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(m){console.error(m)}}}),define(J[123],Z([0,1,26,8,24]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,M=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var m;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(m||(m={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class k{constructor(c,o,u){this.exePath=c,this.displayName=o,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:f=!1}={}){return f?y===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:f=!1,findPreview:c=!1}={}){const o=I({useAlternateBitness:f});if(!o)return null;const u=n.join(o,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const l of await R.Promises.readdir(u)){let S=-1;if(c){const L=l.indexOf("-");if(L<0)continue;const W=l.substring(0,L);if(!C.test(W)||l.substring(L+1)!=="preview")continue;S=parseInt(W,10)}else{if(!C.test(l))continue;S=parseInt(l,10)}if(S<=r)continue;const D=n.join(u,l,"pwsh.exe");!await R.SymlinkSupport.existsFile(D)||(i=D,r=S)}if(!i)return null;const s=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new k(i,`PowerShell${a}${s}`,!0)}async function t({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:u}=f?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const r of await R.Promises.readdir(c))if(o.test(r)){const i=n.join(c,r,"pwsh.exe");return new k(i,u)}return null}function h(){const f=n.join(w.homedir(),".dotnet","tools","pwsh.exe");return new k(f,".NET Core PowerShell Global Tool")}function g(){const f=n.join(process.env.windir,y===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(f,"Windows PowerShell",!0)}async function*v(){let f=await p();f&&(yield f),f=await p({useAlternateBitness:!0}),f&&(yield f),f=await t(),f&&(yield f),f=h(),f&&(yield f),f=await p({findPreview:!0}),f&&(yield f),f=await t({findPreview:!0}),f&&(yield f),f=await p({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=g(),f&&(yield f)}async function*P(){for await(const f of v())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=P;async function d(){for await(const f of P())return f;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[87],Z([0,1,45,10]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(M){return new Promise((b,m)=>{let y;const E=new Map;function k(p,t,h,g,v){const P=E.get(t);if(p===M||P){const d={name:I(h),cmd:h,pid:p,ppid:t,load:g,mem:v};E.set(p,d),p===M&&(y=d),P&&(P.children||(P.children=[]),P.children.push(d),P.children.length>1&&(P.children=P.children.sort((f,c)=>f.pid-c.pid)))}}function I(p){const t=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,P=/--crashes-directory/,d=/\\pipe\\winpty-control/,f=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(P.exec(p))return"electron-crash-reporter";if(d.exec(p))return"winpty-process";if(f.exec(p))return"console-window-host (Windows internal process)";let o=c.exec(p);if(o&&o.length===2)return o[1]==="renderer"?t.exec(p)?"shared-process":h.exec(p)?"issue-reporter":g.exec(p)?"process-explorer":"window":o[1]==="utility"&&v.exec(p)?"utility-network-service":o[1];const u=/[a-zA-Z-]+\.js/g;let r="";do o=u.exec(p),o&&(r+=o+" ");while(o);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,h)=>{q(["windows-process-tree"],t,h)}).then(t=>{t.getProcessList(M,h=>{t.getProcessCpuUsage(h,g=>{const v=new Map;g.forEach(P=>{const d=p(P.commandLine||"");v.set(P.pid,{name:I(d),cmd:d,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),y=v.get(M),y?(v.forEach(P=>{const d=v.get(P.ppid);d&&(d.children||(d.children=[]),d.children.push(P))}),v.forEach(P=>{P.children&&(P.children=P.children.sort((d,f)=>d.pid-f.pid))}),b(y)):m(new Error(`Root process ${M} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[y];const h=[];for(;t.length;){const v=t.shift();v&&(h.push(v.pid),v.children&&(t=t.concat(v.children)))}let g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);g+=" "+h.join(" "),(0,w.exec)(g,{},(v,P,d)=>{if(v||d)m(v||new Error(d.toString()));else{const f=P.toString().split(`
`);for(let c=0;c<h.length;c++){const o=E.get(h[c]);o.load=parseFloat(f[c])}if(!y){m(new Error(`Root process ${M} not found`));return}b(y)}})};(0,w.exec)("which ps",{},(t,h,g)=>{if(t||g)if(process.platform!=="linux")m(t||new Error(g.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(v,{},(P,d,f)=>{P||f?m(P||new Error(f.toString())):(C(d,k),p())})}else{const v=h.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,f,c)=>{d||c&&!c.includes("screen size is bogus")?m(d||new Error(c.toString())):(C(f,k),process.platform==="linux"?p():y?b(y):m(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=R;function C(M,b){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const E of y){const k=m.exec(E.trim());k&&k.length===6&&b(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(J[124],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[125],Z([0,1,12,14,124]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){w.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(b,m,y,E,k)=>{const I=M(b,E,y);I.popup({window:(0,n.withNullAsUndefined)(w.BrowserWindow.fromWebContents(b.sender)),x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{I&&b.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=C;function M(b,m,y){const E=new w.Menu;return y.forEach(k=>{let I;k.type==="separator"?I=new w.MenuItem({type:k.type}):Array.isArray(k.submenu)?I=new w.MenuItem({submenu:M(b,m,k.submenu),label:k.label}):I=new w.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(p,t,h)=>b.sender.send(m,k.id,h)}),E.append(I)}),E}});var ue=this&&this.__decorate||function(q,e,w,n){var R=arguments.length,C=R<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,w):n,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(q,e,w,n);else for(var b=q.length-1;b>=0;b--)(M=q[b])&&(C=(R<3?M(C):R>3?M(e,w,C):M(e,w))||C);return R>3&&C&&Object.defineProperty(e,w,C),C};define(J[37],Z([0,1,30,9,17,23,46,15,4,2,114,27,14]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(v||(v={}));class P{constructor(H){this.buffer=H,this.pos=0}read(H){const K=this.buffer.slice(this.pos,this.pos+H);return this.pos+=K.byteLength,K}}class d{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var f;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(f||(f={}));function c(V){const H=R.VSBuffer.alloc(4);return H.writeUInt32BE(V,0),H}function o(V){return V.read(4).readUInt32BE(0)}function u(V){const H=R.VSBuffer.alloc(1);return H.writeUInt8(V,0),H}const r={Undefined:u(f.Undefined),String:u(f.String),Buffer:u(f.Buffer),VSBuffer:u(f.VSBuffer),Array:u(f.Array),Object:u(f.Object)},i=typeof Buffer!="undefined";function s(V,H){if(typeof H=="undefined")V.write(r.Undefined);else if(typeof H=="string"){const K=R.VSBuffer.fromString(H);V.write(r.String),V.write(c(K.byteLength)),V.write(K)}else if(i&&Buffer.isBuffer(H)){const K=R.VSBuffer.wrap(H);V.write(r.Buffer),V.write(c(K.byteLength)),V.write(K)}else if(H instanceof R.VSBuffer)V.write(r.VSBuffer),V.write(c(H.byteLength)),V.write(H);else if(Array.isArray(H)){V.write(r.Array),V.write(c(H.length));for(const K of H)s(V,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(H));V.write(r.Object),V.write(c(K.byteLength)),V.write(K)}}function a(V){switch(V.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return V.read(o(V)).toString();case f.Buffer:return V.read(o(V)).buffer;case f.VSBuffer:return V.read(o(V));case f.Array:{const K=o(V),$=[];for(let F=0;F<K;F++)$.push(a(V));return $}case f.Object:return JSON.parse(V.read(o(V)).toString())}}class l{constructor(H,K,$=null,F=1e3){this.protocol=H,this.ctx=K,this.logger=$,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(H,K){this.channels.set(H,K),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const K=this.send([H.type]);this.logger?.logOutgoing(K,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const K=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(K,H.id,1,g(H.type),H.data);return}}}send(H,K=void 0){const $=new d;return s($,H),s($,K),this.sendBuffer($.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const K=new P(H),$=a(K),F=a(K),B=$[0];switch(B){case 100:return this.logger?.logIncoming(H.byteLength,$[1],1,`${t(B)}: ${$[2]}.${$[3]}`,F),this.onPromise({type:B,id:$[1],channelName:$[2],name:$[3],arg:F});case 102:return this.logger?.logIncoming(H.byteLength,$[1],1,`${t(B)}: ${$[2]}.${$[3]}`,F),this.onEventListen({type:B,id:$[1],channelName:$[2],name:$[3],arg:F});case 101:return this.logger?.logIncoming(H.byteLength,$[1],1,`${t(B)}`),this.disposeActiveRequest({type:B,id:$[1]});case 103:return this.logger?.logIncoming(H.byteLength,$[1],1,`${t(B)}`),this.disposeActiveRequest({type:B,id:$[1]})}}onPromise(H){const K=this.channels.get(H.channelName);if(!K){this.collectPendingRequest(H);return}const $=new C.CancellationTokenSource;let F;try{F=K.call(this.ctx,H.name,H.arg,$.token)}catch(A){F=Promise.reject(A)}const B=H.id;F.then(A=>{this.sendResponse({id:B,data:A,type:201}),this.activeRequests.delete(H.id)},A=>{A instanceof Error?this.sendResponse({id:B,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:B,data:A,type:203}),this.activeRequests.delete(H.id)});const T=(0,y.toDisposable)(()=>$.cancel());this.activeRequests.set(H.id,T)}onEventListen(H){const K=this.channels.get(H.channelName);if(!K){this.collectPendingRequest(H);return}const $=H.id,B=K.listen(this.ctx,H.name,H.arg)(T=>this.sendResponse({id:$,data:T,type:204}));this.activeRequests.set(H.id,B)}disposeActiveRequest(H){const K=this.activeRequests.get(H.id);K&&(K.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let K=this.pendingRequests.get(H.channelName);K||(K=[],this.pendingRequests.set(H.channelName,K));const $=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:H,timeoutTimer:$})}flushPendingRequests(H){const K=this.pendingRequests.get(H);if(K){for(const $ of K)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var S;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(H,K=null){this.protocol=H,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=K}getChannel(H){const K=this;return{call($,F,B){return K.isDisposed?Promise.reject(b.canceled()):K.requestPromise(H,$,F,B)},listen($,F){return K.isDisposed?Promise.reject(b.canceled()):K.requestEvent(H,$,F)}}}requestPromise(H,K,$,F=C.CancellationToken.None){const B=this.lastRequestId++,A={id:B,type:100,channelName:H,name:K,arg:$};if(F.isCancellationRequested)return Promise.reject(b.canceled());let O;return new Promise((Y,ie)=>{if(F.isCancellationRequested)return ie(b.canceled());const ae=()=>{const he=me=>{switch(me.type){case 201:this.handlers.delete(B),Y(me.data);break;case 202:{this.handlers.delete(B);const Pe=new Error(me.data.message);Pe.stack=me.data.stack,Pe.name=me.data.name,ie(Pe);break}case 203:this.handlers.delete(B),ie(me.data);break}};this.handlers.set(B,he),this.sendRequest(A)};let ce=null;this.state===v.Idle?ae():(ce=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const ne=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:B,type:101}),ie(b.canceled())},le=F.onCancellationRequested(ne);O=(0,y.combinedDisposable)((0,y.toDisposable)(ne),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(H,K,$){const F=this.lastRequestId++,T={id:F,type:102,channelName:H,name:K,arg:$};let A=null;const O=new m.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(Y=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:F,type:103}))}}),_=Y=>O.fire(Y.data);return this.handlers.set(F,_),O.event}sendRequest(H){switch(H.type){case 100:case 102:{const K=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(K,H.id,0,`${t(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const K=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(K,H.id,0,t(H.type));return}}}send(H,K=void 0){const $=new d;return s($,H),s($,K),this.sendBuffer($.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const K=new P(H),$=a(K),F=a(K),B=$[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,g(B)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,$[1],0,g(B),F),this.onResponse({type:$[0],id:$[1],data:F})}}onResponse(H){if(H.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(H.id);K&&K(H)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class L{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:K,onDidClientDisconnect:$})=>{m.Event.once(K.onMessage)(B=>{const T=new P(B),A=a(T),O=new l(K,A),_=new D(K);this.channels.forEach((ie,ae)=>O.registerChannel(ae,ie));const Y={channelServer:O,channelClient:_,ctx:A};this._connections.add(Y),this._onDidAddConnection.fire(Y),$(()=>{O.dispose(),_.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)})})})}get connections(){const H=[];return this._connections.forEach(K=>H.push(K)),H}getChannel(H,K){const $=this;return{call(F,B,T){let A;if((0,I.isFunction)(K)){let _=(0,w.getRandomElement)($.connections.filter(K));A=_?Promise.resolve(_):m.Event.toPromise(m.Event.filter($.onDidAddConnection,K))}else A=K.routeCall($,F,B);const O=A.then(_=>_.channelClient.getChannel(H));return U(O).call(F,B,T)},listen(F,B){if((0,I.isFunction)(K))return $.getMulticastEvent(H,K,F,B);const T=K.routeEvent($,F,B).then(A=>A.channelClient.getChannel(H));return U(T).listen(F,B)}}}getMulticastEvent(H,K,$,F){const B=this;let T=new y.DisposableStore;const A=new m.Emitter({onFirstListenerAdd:()=>{T=new y.DisposableStore;const O=new m.EventMultiplexer,_=new Map,Y=ae=>{const ne=ae.channelClient.getChannel(H).listen($,F),le=O.add(ne);_.set(ae,le)},ie=ae=>{const ce=_.get(ae);!ce||(ce.dispose(),_.delete(ae))};B.connections.filter(K).forEach(Y),m.Event.filter(B.onDidAddConnection,K)(Y,void 0,T),B.onDidRemoveConnection(ie,void 0,T),O.event(A.fire,A,T),T.add(O)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(H,K){this.channels.set(H,K),this._connections.forEach($=>{$.channelServer.registerChannel(H,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class W{constructor(H,K,$=null){const F=new d;s(F,K),H.send(F.buffer),this.channelClient=new D(H,$),this.channelServer=new l(H,K,$)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,K){this.channelServer.registerChannel(H,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function U(V){return{call(H,K,$){return V.then(F=>F.call(H,K,$))},listen(H,K){const $=new m.Relay;return V.then(F=>$.input=F.listen(H,K)),$.event}}}e.getDelayedChannel=U;function j(V){let H=!1;return{call(K,$,F){return H?V.call(K,$,F):(0,n.timeout)(0).then(()=>H=!0).then(()=>V.call(K,$,F))},listen(K,$){if(H)return V.listen(K,$);const F=new m.Relay;return(0,n.timeout)(0).then(()=>H=!0).then(()=>F.input=V.listen(K,$)),F.event}}}e.getNextTickChannel=j;class ee{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const K of H.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await m.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=ee;var x;(function(V){function H(B,T){const A=B,O=T&&T.disableMarshalling,_=new Map;for(const Y in A)$(Y)&&_.set(Y,m.Event.buffer(A[Y],!0));return new class{listen(Y,ie,ae){const ce=_.get(ie);if(ce)return ce;if(F(ie)){const ne=A[ie];if(typeof ne=="function")return ne.call(A,ae)}throw new Error(`Event not found: ${ie}`)}call(Y,ie,ae){const ce=A[ie];if(typeof ce=="function"){if(!O&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,E.revive)(ae[ne]);return ce.apply(A,ae)}throw new Error(`Method not found: ${ie}`)}}}V.fromService=H;function K(B,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return T?.properties?.has(_)?T.properties.get(_):F(_)?function(Y){return B.listen(_,Y)}:$(_)?B.listen(_):async function(...Y){let ie;T&&!(0,I.isUndefinedOrNull)(T.context)?ie=[T.context,...Y]:ie=Y;const ae=await B.call(_,ie);return A?ae:(0,E.revive)(ae)};throw new Error(`Property not found: ${String(_)}`)}})}V.toService=K;function $(B){return B[0]==="o"&&B[1]==="n"&&k.isUpperAsciiLetter(B.charCodeAt(2))}function F(B){return/^onDynamic/.test(B)&&k.isUpperAsciiLetter(B.charCodeAt(9))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let H=V.toString();if(H!=="[object Object]")return H}return V}function z(V){return Array.isArray(V)?V.map(G):G(V)}function X(V,H,K,$,F,B,T){T=z(T);const A=N[F],O=A[$%A.length];let _=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String($).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat(T),_.push(")")):_.push(T),console.log.apply(console,_)}e.logWithColors=X;class re{constructor(H,K){this._outgoingPrefix=H,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,K,$,F,B){this._totalOutgoing+=H,X(this._outgoingPrefix,this._totalOutgoing,H,K,$,F,B)}logIncoming(H,K,$,F,B){this._totalIncoming+=H,X(this._incomingPrefix,this._totalIncoming,H,K,$,F,B)}}e.IPCLogger=re}),define(J[126],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(R,C){this.sender=R,this.onMessage=C}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[127],Z([0,1,17,4,37]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(m){this.port=m,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",y=>w.VSBuffer.wrap(y.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class M extends R.IPCClient{constructor(m,y){const E=new C(m);super(E,y);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[88],Z([0,1,17,4,2,37]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function l(D,L){if(!s.has(D)){const W=String(++a);s.set(D,W)}return s.get(D)}function S(D,L,W,U){if(!i.enableDiagnostics)return;const j=l(D,L);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ee=w.VSBuffer.alloc(U.byteLength);ee.set(U),i.records.push({timestamp:Date.now(),id:j,label:L,type:W,buff:ee})}else i.records.push({timestamp:Date.now(),id:j,label:L,type:W,data:U})}i.traceSocketEvent=S})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function E(){return y||(y=w.VSBuffer.alloc(0)),y}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return E();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),L}if(this._chunks[0].byteLength>s){const L=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),L}let l=w.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const L=this._chunks[D];if(L.byteLength>s){const W=L.slice(0,s);l.set(W,S),S+=s,a&&(this._chunks[D]=L.slice(s),this._totalLength-=s),s-=s}else l.set(L,S),S+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):D++,s-=L.byteLength}return l}}e.ChunkStream=k;var I;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(I||(I={}));function p(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,a,l,S){this.type=s,this.id=a,this.ack=l,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new h(l,S,D,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=w.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const l=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,l}_bufferTake(){const s=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class P extends R.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=P;class d extends C.IPCClient{constructor(s,a,l=null){super(s,a,l);this.protocol=s}static fromSocket(s,a){return new d(new P(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=d;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,l=this._first;for(;l;)s[a++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new c(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class u{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<u._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=u._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const s=Date.now(),a=(1+u._HISTORY_LENGTH)*1e3;let l=0;for(let S=0;S<u._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=a&&l++;return 1-l/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class r{constructor(s,a=null,l=u.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,E());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new h(7,0,0,E());this._socketWriter.write(s)}sendResume(){const s=new h(8,0,0,E());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,E());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let l=0,S=a.length;l<S;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,E())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,S=a.length;l<S;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const a=new h(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,S=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&S>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const D=Math.max(2e4-a,2e4-l,2e4-S,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,E());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(J[128],Z([0,1,12,17,4,2,37,126]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function m(E,k){const I=R.Event.fromNodeEventEmitter(w.ipcMain,k,(t,h)=>({event:t,message:h})),p=R.Event.filter(I,({event:t})=>t.sender.id===E);return R.Event.map(p,({message:t})=>t&&n.VSBuffer.wrap(t))}class y extends M.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const k=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:I})=>I);return R.Event.map(k,I=>{const p=I.id,t=y.Clients.get(p);t&&t.dispose();const h=new R.Emitter;y.Clients.set(p,(0,C.toDisposable)(()=>h.fire()));const g=m(p,"vscode:message"),v=R.Event.any(R.Event.signal(m(p,"vscode:disconnect")),h.event);return{protocol:new b.Protocol(I,g),onDidClientDisconnect:v}})}}e.Server=y,y.Clients=new Map}),define(J[89],Z([0,1,12,4,31,127]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends C.Client{constructor(y,E){super({addEventListener:(k,I)=>y.addListener(k,I),removeEventListener:(k,I)=>y.removeListener(k,I),postMessage:k=>y.postMessage(k),start:()=>y.start(),close:()=>y.close()},E)}}e.Client=M;async function b(m){if(m.isDestroyed()||m.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,R.generateUuid)();m.webContents.send("vscode:createMessageChannel",y);const E=n.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(I,p)=>({nonce:p,port:I.ports[0]})),{port:k}=await n.Event.toPromise(n.Event.once(n.Event.filter(E,I=>I.nonce===y)));return k}e.connect=b}),define(J[90],Z([0,1,9,4,2,14]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function b(k){const I=k;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var m;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(m||(m={}));class y extends R.Disposable{constructor(I,p=Object.create(null)){super();this.database=I,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((p,t)=>this.accept(t,p)),I.deleted?.forEach(p=>this.accept(p,void 0))}accept(I,p){if(this.state===m.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(p)?t=this.cache.delete(I):this.cache.get(I)!==p&&(this.cache.set(I,p),t=!0),t&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,p){const t=this.cache.get(I);return(0,C.isUndefinedOrNull)(t)?p:t}getBoolean(I,p){const t=this.get(I);return(0,C.isUndefinedOrNull)(t)?p:t==="true"}getNumber(I,p){const t=this.get(I);return(0,C.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(I,p){if(this.state===m.Closed)return;if((0,C.isUndefinedOrNull)(p))return this.delete(I);const t=String(p);if(this.cache.get(I)!==t)return this.cache.set(I,t),this.pendingInserts.set(I,t),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===m.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((p,t)=>this.items.set(t,p)),I.delete&&I.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=E}),define(J[129],Z([0,1,9,4,35,8,24]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(E,k=Object.create(null)){this.path=E,this.options=k,this.name=(0,C.basename)(this.path),this.logger=new m(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const E=await this.whenConnected,k=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(p=>k.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(E){const k=await this.whenConnected;return this.doUpdateItems(k,E)}doUpdateItems(E,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,R.mapToString)(k.insert):"0"}), delete(${k.delete?(0,R.setToString)(k.delete):"0"})`),this.transaction(E,()=>{const I=k.insert,p=k.delete;if(I&&I.size>0){const t=[];t.push([]);let h=0;I.forEach((g,v)=>{let P=t[h];P.length>b.MAX_HOST_PARAMETERS&&(h++,P=[],t.push(P)),P.push(v,g)}),t.forEach(g=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,v=>v.run(g),()=>{const v=[];let P=0;return I.forEach((d,f)=>{v.push(f),P+=d.length}),`Keys: ${v.join(", ")} Length: ${P}`})})}if(p&&p.size){const t=[];t.push([]);let h=0;p.forEach(g=>{let v=t[h];v.length>b.MAX_HOST_PARAMETERS&&(h++,v=[],t.push(v)),v.push(g)}),t.forEach(g=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,v=>v.run(g),()=>{const v=[];return p.forEach(P=>{v.push(P)}),`Keys: ${v.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,E)}doClose(E,k){return new Promise((I,p)=>{E.db.close(t=>(t&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${t}`),this.path===b.IN_MEMORY_PATH?I():!E.isErroneous&&!E.isInMemory?this.backup().then(I,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),I())):typeof k=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const g=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:k()}).then(()=>g(),v=>(g(),Promise.reject(v)))})).then(I,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return M.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const k=await this.whenConnected,I=await this.get(k,E?"PRAGMA integrity_check":"PRAGMA quick_check"),p=E?I.integrity_check:I.quick_check;return k.isErroneous?`${p} (last error: ${k.lastError})`:k.isInMemory?`${p} (in-memory!)`:p}async connect(E,k=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${k})`);try{return await this.doConnect(E)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&k)return await(0,w.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await M.Promises.unlink(E);try{await M.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(E,k){E.isErroneous=!0,E.lastError=k,this.logger.error(k)}doConnect(E){return new Promise((k,I)=>{new Promise((p,t)=>{q(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(E,h=>h?t.db?t.db.close(()=>I(h)):I(h):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(t),g=>t.db.close(()=>I(g)))),isInMemory:E===b.IN_MEMORY_PATH};t.db.on("error",h=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&t.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},I)})}exec(E,k){return new Promise((I,p)=>{E.db.exec(k,t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${t}`),p(t)):I())})}get(E,k){return new Promise((I,p)=>{E.db.get(k,(t,h)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${t}`),p(t)):I(h))})}all(E,k){return new Promise((I,p)=>{E.db.all(k,(t,h)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${t}`),p(t)):I(h))})}transaction(E,k){return new Promise((I,p)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),k(),E.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${t}`),p(t)):I())})})}prepare(E,k,I,p){const t=E.db.prepare(k),h=g=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${g} (${k}). Details: ${p()}`)};t.on("error",h),I(t),t.finalize(g=>{g&&h(g),t.removeListener("error",h)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class m{constructor(E){E&&typeof E.logTrace=="function"&&process.env[m.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}m.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[130],Z([13,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[131],Z([0,1,130]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,R=n*60,C=R*24,M=C*7,b=C*30,m=C*365;function y(k,I,p){typeof k!="number"&&(k=k.getTime());const t=Math.round((new Date().getTime()-k)/1e3);if(t<-30)return(0,w.localize)(0,null,y(new Date().getTime()+t*1e3,!1));if(t<30)return(0,w.localize)(1,null);let h;return t<n?(h=t,I?h===1?p?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):p?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h):h===1?p?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):p?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):t<R?(h=Math.floor(t/n),I?h===1?p?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):p?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h):h===1?p?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):p?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):t<C?(h=Math.floor(t/R),I?h===1?p?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):p?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h):h===1?p?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):p?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):t<M?(h=Math.floor(t/C),I?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h)):t<b?(h=Math.floor(t/M),I?h===1?p?(0,w.localize)(30,null,h):(0,w.localize)(31,null,h):p?(0,w.localize)(32,null,h):(0,w.localize)(33,null,h):h===1?p?(0,w.localize)(34,null,h):(0,w.localize)(35,null,h):p?(0,w.localize)(36,null,h):(0,w.localize)(37,null,h)):t<m?(h=Math.floor(t/b),I?h===1?p?(0,w.localize)(38,null,h):(0,w.localize)(39,null,h):p?(0,w.localize)(40,null,h):(0,w.localize)(41,null,h):h===1?p?(0,w.localize)(42,null,h):(0,w.localize)(43,null,h):p?(0,w.localize)(44,null,h):(0,w.localize)(45,null,h)):(h=Math.floor(t/m),I?h===1?p?(0,w.localize)(46,null,h):(0,w.localize)(47,null,h):p?(0,w.localize)(48,null,h):(0,w.localize)(49,null,h):h===1?p?(0,w.localize)(50,null,h):(0,w.localize)(51,null,h):p?(0,w.localize)(52,null,h):(0,w.localize)(53,null,h))}e.fromNow=y;function E(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(J[132],Z([13,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[39],Z([0,1,30,14,132]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,E){return E&&(y.stack||y.stacktrace)?R.localize(0,null,b(y),M(y.stack)||M(y.stacktrace)):b(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function b(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function m(y=null,E=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const k=w.coalesce(y),I=m(k[0],E);return k.length>1?R.localize(4,null,I,k.length):I}if(n.isString(y))return y;if(y.detail){const k=y.detail;if(k.error)return C(k.error,E);if(k.exception)return C(k.exception,E)}return y.stack?C(y,E):y.message?y.message:R.localize(5,null)}e.toErrorMessage=m}),define(J[133],Z([13,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(J[134],Z([0,1,133]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(M,b,m=b){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=b,this.modifierLabels[3]=m}toLabel(M,b,m){if(b.length===0)return null;const y=[];for(let E=0,k=b.length;E<k;E++){const I=b[E],p=m(I);if(p===null)return null;y[E]=R(I,p,this.modifierLabels[M])}return y.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(C,M,b){if(M===null)return"";const m=[];return C.ctrlKey&&m.push(b.ctrlKey),C.shiftKey&&m.push(b.shiftKey),C.altKey&&m.push(b.altKey),C.metaKey&&m.push(b.metaKey),M!==""&&m.push(M),m.join(b.separator)}}),define(J[135],Z([13,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(J[73],Z([0,1,45,28,10,49,8,3,36,84,14,119,24,135]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(o,u){if(b.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};u&&(r.cwd=u);const i=w.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(s=>{i.once("error",a=>{s({success:!1,error:a})}),i.once("exit",(a,l)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(b.isLinux||b.isMacintosh)try{const r=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{w.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,l)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o){!o||(delete o.DEBUG,b.isMacintosh&&delete o.DYLD_LIBRARY_PATH,b.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function v(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(u,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=u,this.args=r,this.shell=i,this.options=s;else{const a=u;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(m.env).forEach(l=>{a[l]=m.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const r=u.lastIndexOf(M.sep);return r!==-1&&(u=u.substring(r+1)),P.WellKnowCommands[u]?u:"other"}start(u){return b.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(m.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let i,s;const a=new Promise((l,S)=>{i=l,s=S});if(r){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=w.exec(l,this.options,(S,D,L)=>{this.childProcess=null;const W=S;W&&W.killed?s({killed:this.terminateRequested,stdout:D.toString(),stderr:L.toString()}):this.handleExec(i,u,S,D,L)})}else{let l=null;const S=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,i,u,s);const L={terminated:this.terminateRequested};E.isNumber(D)&&(L.cmdCode=D),i(L)};if(this.shell&&b.isWindows){const D=C.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let L=!1,W=!1;const U=[];let j=this.ensureQuotes(this.cmd);U.push(j.value),L=j.quoted,this.args&&this.args.forEach(x=>{j=this.ensureQuotes(x),U.push(j.value),W=W&&j.quoted});const ee=["/s","/c"];L?W?ee.push('"'+U.join(" ")+'"'):U.length>1?ee.push('"'+U[0]+'" '+U.slice(1).join(" ")):ee.push('"'+U[0]+'"'):ee.push(U.join(" ")),l=w.spawn(v(),ee,D)}else this.cmd&&(l=w.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(E.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",D=>{this.childProcess=null,s({terminated:this.terminateRequested,error:D})}),l.pid&&(this.childProcess.on("close",S),this.handleSpawn(l,i,u,s,!0)))}return a})}handleClose(u,r,i,s){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,h(u,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!b.isWindows)return u(!1);const r=w.spawn(v(),["/s","/c"]);r.on("error",i=>u(!0)),r.on("exit",i=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class d extends P{constructor(u,r,i,s){super(u,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,r,i,s,a){[s,a].forEach((l,S)=>{const D=new k.LineDecoder;D.write(l).forEach(U=>{r({line:U,source:S===0?0:1})});const W=D.end();W&&r({line:W,source:S===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,r,i,s,a){const l=new k.LineDecoder,S=new k.LineDecoder;u.stdout.on("data",D=>{l.write(D).forEach(W=>i({line:W,source:0}))}),u.stderr.on("data",D=>{S.write(D).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=S}handleClose(u,r,i,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=d;function f(o){let u=[],r=!1;const i=function(s){if(r){u.push(s);return}(!o.send(s,l=>{if(l&&console.error(l),r=!1,u.length>0){const S=u.slice(0);u=[],S.forEach(D=>i(D))}})||b.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=f;var c;(function(o){async function u(r,i,s){if(M.isAbsolute(r))return r;if(i===void 0&&(i=m.cwd()),M.dirname(r)!=="."||(s===void 0&&E.isString(m.env.PATH)&&(s=m.env.PATH.split(M.delimiter)),s===void 0||s.length===0))return M.join(i,r);async function l(S){if(await I.Promises.exists(S)){let D;try{D=await I.Promises.stat(S)}catch(L){L.message.startsWith("EACCES")&&(D=await I.Promises.lstat(S))}return D?!D.isDirectory():!1}return!1}for(let S of s){let D;if(M.isAbsolute(S)?D=M.join(S,r):D=M.join(i,S,r),await l(D))return D;let L=D+".com";if(await l(L)||(L=D+".exe",await l(L)))return L}return M.join(i,r)}o.findExecutable=u})(c=e.win32||(e.win32={}))}),define(J[136],Z([0,1,26,3,123,73]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(p,t){return p===1?n.isWindows?k():C.getWindowsShell(t):y(p,t)}e.getSystemShell=M;function b(p,t){return p===1?n.isWindows?I(t):C.getWindowsShell(t):y(p,t)}e.getSystemShellSync=b;let m=null;function y(p,t){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!m){let h;if(n.isWindows)h="/bin/bash";else{if(h=t.SHELL,!h)try{h=(0,w.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}m=h}return m}let E=null;async function k(){return E||(E=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),E}function I(p){if(E)return E;const t=n.isWindows&&parseFloat((0,w.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?g:C.getWindowsShell(p)}}),define(J[137],Z([0,1,45,9,17,23,113,15,4,2,49,73,37]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends I.ChannelServer{constructor(g){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",v=>R.VSBuffer.wrap(Buffer.from(v,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(g,v){this.modulePath=g,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(P),this.child=null,this._client=null}getChannel(g){const v=this;return{call(P,d,f){return v.requestPromise(g,P,d,f)},listen(P,d){return v.requestEvent(g,P,d)}}}requestPromise(g,v,P,d=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(g),c=(0,n.createCancelablePromise)(r=>f.call(v,P,r)),o=d.onCancellationRequested(()=>c.cancel()),u=(0,y.toDisposable)(()=>c.cancel());return this.activeRequests.add(u),c.finally(()=>{o.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(g,v,P){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let d;const f=new m.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(g).listen(v,P)(f.fire,f),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,k.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,g,v);const P=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(R.VSBuffer.wrap(Buffer.from(i,"base64")))});const f=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&f.send(i.buffer.toString("base64")),o=P.event,u={send:c,onMessage:o};this._client=new I.ChannelClient(u);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,y.dispose)(a)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(g){let v=this.channels.get(g);return v||(v=this.client.getChannel(g),this.channels.set(g,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(J[138],Z([13,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[139],Z([13,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[140],Z([13,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[141],Z([13,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[142],Z([13,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[143],Z([13,11]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[144],Z([13,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[145],Z([13,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[146],Z([13,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[147],Z([13,11]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[148],Z([13,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[149],Z([13,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[150],Z([13,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[151],Z([13,11]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[152],Z([13,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[153],Z([13,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[154],Z([13,11]),function(q,e){return q.create("vs/platform/terminal/node/shellEnv",e)}),define(J[155],Z([13,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[156],Z([13,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(J[157],Z([13,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[158],Z([13,11]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(J[159],Z([13,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[160],Z([13,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[161],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(J[162],Z([0,1,4,2]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(b,m,y){switch(m){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(b,m,y){switch(m){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,m,y){this.channel.call("attach",[b,m,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,m){this.channel.call("terminate",[b,m])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,m){return this.channel.call("openExtensionDevelopmentHostWindow",[b,m])}}e.ExtensionHostDebugChannelClient=C}),define(J[163],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(M){this.driver=M}listen(M,b){throw new Error(`No event found: ${b}`)}call(M,b,m){switch(b){case"click":return this.driver.click(m[0],m[1],m[2]);case"doubleClick":return this.driver.doubleClick(m);case"setValue":return this.driver.setValue(m[0],m[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(m);case"getElements":return this.driver.getElements(m[0],m[1]);case"getElementXY":return this.driver.getElementXY(m[0],m[1],m[2]);case"typeInEditor":return this.driver.typeInEditor(m[0],m[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(m);case"writeInTerminal":return this.driver.writeInTerminal(m[0],m[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=w;class n{constructor(M){this.channel=M}click(M,b,m){return this.channel.call("click",[M,b,m])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,b){return this.channel.call("setValue",[M,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,b){return this.channel.call("getElements",[M,b])}getElementXY(M,b,m){return this.channel.call("getElementXY",[M,b,m])}typeInEditor(M,b){return this.channel.call("typeInEditor",[M,b])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,b){return this.channel.call("writeInTerminal",[M,b])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class R{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=R}),define(J[164],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(R){this.machineId=R}encryption(){return new Promise((R,C)=>q(["vscode-encrypt"],R,C))}async encrypt(R){try{return(await this.encryption()).encrypt(this.machineId,R)}catch{return R}}async decrypt(R){try{return(await this.encryption()).decrypt(this.machineId,R)}catch{return R}}}e.EncryptionMainService=w}),define(J[165],Z([0,1,131,46,10,8,36,16,7]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(h,g,v){this._args=h,this.paths=g,this.productService=v}get appRoot(){return(0,C.dirname)(R.FileAccess.asFileUri("",q).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(m.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?m.URI.file((0,C.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,C.resolve)(h):(0,C.normalize)((0,C.join)(R.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,C.resolve)(h):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,C.resolve)(h);const g=M.env.VSCODE_EXTENSIONS;if(g)return g;const v=M.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,C.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?m.URI.parse(h):m.URI.file((0,C.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],y.prototype,"appRoot",null),ue([n.memoize],y.prototype,"userHome",null),ue([n.memoize],y.prototype,"userDataPath",null),ue([n.memoize],y.prototype,"appSettingsHome",null),ue([n.memoize],y.prototype,"tmpDir",null),ue([n.memoize],y.prototype,"cacheHome",null),ue([n.memoize],y.prototype,"userRoamingDataHome",null),ue([n.memoize],y.prototype,"settingsResource",null),ue([n.memoize],y.prototype,"userDataSyncHome",null),ue([n.memoize],y.prototype,"userDataSyncLogResource",null),ue([n.memoize],y.prototype,"sync",null),ue([n.memoize],y.prototype,"machineSettingsResource",null),ue([n.memoize],y.prototype,"globalStorageHome",null),ue([n.memoize],y.prototype,"workspaceStorageHome",null),ue([n.memoize],y.prototype,"keybindingsResource",null),ue([n.memoize],y.prototype,"keyboardLayoutResource",null),ue([n.memoize],y.prototype,"argvResource",null),ue([n.memoize],y.prototype,"snippetsHome",null),ue([n.memoize],y.prototype,"isExtensionDevelopment",null),ue([n.memoize],y.prototype,"untitledWorkspacesHome",null),ue([n.memoize],y.prototype,"installSourcePath",null),ue([n.memoize],y.prototype,"builtinExtensionsPath",null),ue([n.memoize],y.prototype,"extensionsPath",null),ue([n.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],y.prototype,"extensionDevelopmentKind",null),ue([n.memoize],y.prototype,"extensionTestsLocationURI",null),ue([n.memoize],y.prototype,"debugExtensionHost",null),ue([n.memoize],y.prototype,"serviceMachineIdResource",null),ue([n.memoize],y.prototype,"telemetryLogResource",null),ue([n.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function E(t,h){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,h,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=E;function k(t,h){return p(t["inspect-search"],t["inspect-brk-search"],5876,h,t.extensionEnvironment)}e.parseSearchPort=k;function I(t,h){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,h,t.extensionEnvironment)}e.parsePtyHostPort=I;function p(t,h,g,v,P,d){const c=Number(h||t)||(v?null:g),o=c?Boolean(!!h):!1;let u;if(d)try{u=JSON.parse(d)}catch{}return{port:c,break:o,debugId:P,env:u}}}),define(J[91],Z([0,1,248,3,141]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function b(t,h,g=M){const v={},P=[],d=[];for(let u in h){const r=h[u];r.alias&&(v[u]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(u),r.deprecates&&P.push(...r.deprecates)):r.type==="boolean"&&(d.push(u),r.deprecates&&d.push(...r.deprecates))}const f=w(t,{string:P,boolean:d,alias:v}),c={},o=f;c._=f._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(let u in h){const r=h[u];r.alias&&delete o[r.alias];let i=o[u];if(r.deprecates)for(const s of r.deprecates)o.hasOwnProperty(s)&&(i||(i=o[s],i&&g.onDeprecatedOption(s,r.deprecationMessage||(0,R.localize)(33,null))),delete o[s]);typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),g.onMultipleValues(u,i)),c[u]=i,r.deprecationMessage&&g.onDeprecatedOption(u,r.deprecationMessage)),delete o[u]}for(let u in o)g.onUnknownOption(u);return c}e.parseArgs=b;function m(t,h){let g="";return h.args&&(Array.isArray(h.args)?g=` <${h.args.join("> <")}>`:g=` <${h.args}>`),h.alias?`-${h.alias} --${t}${g}`:`--${t}${g}`}function y(t,h){let g=0,v=[];for(const c in t){const o=t[c],u=m(c,o);g=Math.max(g,u.length),v.push([u,o.description])}let P=g+2+1;if(h-P<25)return v.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let d=h-P-1,f=[];for(const c of v){let o=c[0],u=k(c[1],d),r=E(P-o.length-2);f.push("  "+o+r+u[0]);for(let i=1;i<u.length;i++)f.push(E(P)+u[i])}return f}e.formatOptions=y;function E(t){return" ".repeat(t)}function k(t,h){let g=[];for(;t.length;){let v=t.length<h?t.length:t.lastIndexOf(" ",h),P=t.slice(0,v).trim();t=t.slice(v),g.push(P)}return g}function I(t,h,g,v,P){const d=process.stdout.isTTY&&process.stdout.columns||80,f=P?.noInputFiles!==!0?`[${(0,R.localize)(34,null)}...]`:"",c=[`${t} ${g}`];c.push(""),c.push(`${(0,R.localize)(35,null)}: ${h} [${(0,R.localize)(36,null)}]${f}`),c.push(""),P?.noPipe!==!0&&(n.isWindows?c.push((0,R.localize)(37,null,h)):c.push((0,R.localize)(38,null,h)),c.push(""));const o={};for(const u in v){const r=v[u];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[u]=r}}for(let u in o){const r=u;let i=o[r];i&&(c.push(C[r]),c.push(...y(i,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function p(t,h){return`${t||(0,R.localize)(39,null)}
${h||(0,R.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[166],Z([0,1,61,162,91]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,m,y){return m==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1]):super.call(b,m,y)}async openExtensionDevelopmentHostWindow(b,m){const y=(0,R.parseArgs)(b,R.OPTIONS);y.debugRenderer=m;const E=y.extensionDevelopmentPath;if(!E)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:y});if(!m)return{success:!0};const I=k.win;if(!I)return{success:!0};const p=I.webContents.debugger;let t=p.isAttached()?1/0:0;const h=(0,w.createServer)(g=>{t++==0&&p.attach();let v=!1;const P=c=>{v||g.write(JSON.stringify(c)+"\0")},d=(c,o,u,r)=>P({method:o,params:u,sessionId:r});I.on("close",()=>{p.removeListener("message",d),g.end(),v=!0}),p.addListener("message",d);let f=Buffer.alloc(0);g.on("data",c=>{f=Buffer.concat([f,c]);for(let o=f.indexOf(0);o!==-1;o=f.indexOf(0)){let u;try{const r=f.slice(0,o).toString("utf8");f=f.slice(o+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}p.sendCommand(u.method,u.params,u.sessionId).then(r=>P({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>P({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),g.on("error",c=>{console.error("error on cdp pipe:",c)}),g.on("close",()=>{v=!0,--t==0&&p.detach()})});return await new Promise(g=>h.listen(0,g)),I.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),define(J[50],Z([0,1,249,142,91]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function M(I,p){const t={onUnknownOption:g=>{console.warn((0,n.localize)(0,null,g))},onMultipleValues:(g,v)=>{console.warn((0,n.localize)(1,null,g,v))},onDeprecatedOption:(g,v)=>{console.warn((0,n.localize)(2,null,g,v))}},h=(0,R.parseArgs)(I,R.OPTIONS,p?t:void 0);return h.goto&&h._.forEach(g=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,n.localize)(3,null))),h["max-memory"]&&w(parseInt(h["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),h}function b(I){const p=I.findIndex(t=>!/^-/.test(t));if(p>-1)return[...I.slice(0,p),...I.slice(p+1)]}function m(I){let[,...p]=I;process.env.VSCODE_DEV&&(p=b(p)||[]);const t=!k(process.env);return M(p,t)}e.parseMainProcessArgv=m;function y(I){const[,,...p]=I;return M(p,!0)}e.parseCLIProcessArgv=y;function E(I,...p){const t=I.indexOf("--");return t===-1?I.push(...p):I.splice(t,0,...p),I}e.addArg=E;function k(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function q(e,w,n,R){function C(b){const m=M(b),y=[m];return e.isAbsolute(m)||y.unshift(R),e.resolve(...y)}function M(b){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,n);const E=b["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(k,"AppData","Roaming")}break;case"darwin":y=e.join(w.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,n)}return{getUserDataPath:C}}if(typeof define=="function")define(J[167],Z([0,250,26,10,16,36]),function(e,w,n,R,C,M){const b=C.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(C.joinPath(b,"package.json").fsPath);return q(w,n,m.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),n=require("os");module.exports=q(w,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[168],Z([0,1,26,165,167]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(b,m){super(b,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,R.getUserDataPath)(b)},m)}}e.NativeEnvironmentService=C}),define(J[169],Z([0,1,29,26,28]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(M){const b=(0,R.randomPath)((0,n.tmpdir)());try{return(0,w.writeFileSync)(b,""),M&&console.log(`Marker file for --wait created: ${b}`),b}catch(m){M&&console.error(`Failed to create marker file for --wait: ${m}`);return}}e.createWaitMarkerFile=C}),define(J[170],Z([0,1,17,31]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(C,M,b){let m=b&&b.get("storage.serviceMachineId",0)||null;if(m)return m;try{const E=(await M.readFile(C.serviceMachineIdResource)).value.toString();m=(0,n.isUUID)(E)?E:null}catch{m=null}if(!m){m=(0,n.generateUuid)();try{await M.writeFile(C.serviceMachineIdResource,w.VSBuffer.fromString(m))}catch{}}return b&&b.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(J[74],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(R,C=[],M=!1){this.ctor=R,this.staticArguments=C,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=w}),define(J[171],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=w;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let M of this._nodes.values())M.outgoing.size===0&&C.push(M);return C}insertEdge(C,M){const b=this.lookupOrInsertNode(C),m=this.lookupOrInsertNode(M);b.outgoing.set(this._hashFn(M),m),m.incoming.set(this._hashFn(C),b)}removeNode(C){const M=this._hashFn(C);this._nodes.delete(M);for(let b of this._nodes.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(C){const M=this._hashFn(C);let b=this._nodes.get(M);return b||(b=new w(C),this._nodes.set(M,b)),b}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[M,b]of this._nodes)C.push(`${M}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,M]of this._nodes){const b=new Set([C]),m=this._findCycle(M,b);if(m)return m}}_findCycle(C,M){for(let[b,m]of C.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const y=this._findCycle(m,M);if(y)return y;M.delete(b)}}}e.Graph=n}),define(J[5],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(w=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function n(M,b,m,y){b[w.DI_TARGET]===b?b[w.DI_DEPENDENCIES].push({id:M,index:m,optional:y}):(b[w.DI_DEPENDENCIES]=[{id:M,index:m,optional:y}],b[w.DI_TARGET]=b)}function R(M){if(w.serviceIds.has(M))return w.serviceIds.get(M);const b=function(m,y,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,m,E,!1)};return b.toString=()=>M,w.serviceIds.set(M,b),b}e.createDecorator=R;function C(M){return M}e.refineServiceDecorator=C}),define(J[51],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(J[19],Z([0,1,14,7,5]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationOverrides=C;function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||w.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=M;var b;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function m(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=m;function y(g,v){const P=Object.create(null);for(let d in g)E(P,d,g[d],v);return P}e.toValuesTree=y;function E(g,v,P,d){const f=v.split("."),c=f.pop();let o=g;for(let u=0;u<f.length;u++){let r=f[u],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:d(`Ignoring ${v} as ${f.slice(0,u+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=P}catch{d(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=E;function k(g,v){const P=v.split(".");I(g,P)}e.removeFromValueTree=k;function I(g,v){const P=v.shift();if(v.length===0){delete g[P];return}if(Object.keys(g).indexOf(P)!==-1){const d=g[P];typeof d=="object"&&!Array.isArray(d)&&(I(d,v),Object.keys(d).length===0&&delete g[P])}}function p(g,v,P){function d(o,u){let r=o;for(const i of u){if(typeof r!="object"||r===null)return;r=r[i]}return r}const f=v.split("."),c=d(g,f);return typeof c=="undefined"?P:c}e.getConfigurationValue=p;function t(g,v,P){Object.keys(v).forEach(d=>{d!=="__proto__"&&(d in g?w.isObject(g[d])&&w.isObject(v[d])?t(g[d],v[d],P):P&&(g[d]=v[d]):g[d]=v[d])})}e.merge=t;function h(g,v,P){const d=g.inspect(v),f=g.inspect(P);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=h}),define(J[75],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(C,M){return this.secretVault[C]?.[M]??null}async setPassword(C,M,b){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][M]=b}async deletePassword(C,M){return this.secretVault[C]?.[M]?(delete this.secretVault[C][M],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const M=[];for(const b of Object.keys(this.secretVault[C]||{}))M.push({account:b,password:this.secretVault[C][b]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(J[76],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function n(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=n}),define(J[92],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(J[52],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[172],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[173],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[93],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[174],Z([0,1,45,10,8,3,84,24,73,143,93]),function(q,e,w,n,R,C,M,b,m,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=y.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends I{openTerminal(f,c){return this.spawnTerminal(w,f,m.getWindowsShell(),c)}spawnTerminal(f,c,o,u){const r=c.windowsExec||p.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=R.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return f.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((a,l)=>{const S=g(process),D=f.spawn(o,s,{cwd:u,env:S});D.on("error",l),D.on("exit",()=>a())})}runInTerminal(f,c,o,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((s,a)=>{const l=`"${c} - ${k}"`,S=`""${o.join('" "')}" & pause"`,D=["/c","start",l,"/wait",i,"/c",S],L=Object.assign({},g(process),u);Object.keys(L).filter(j=>L[j]===null).forEach(j=>delete L[j]);const W={cwd:c,env:L,windowsVerbatimArguments:!0};w.spawn(p.CMD,D,W).on("error",j=>{a(v(j))}),s(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends I{openTerminal(f,c){return this.spawnTerminal(w,f,c)}runInTerminal(f,c,o,u,r){const i=r.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(i===E.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const l=i===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,q).fsPath,"-t",f||k,"-w",c];for(let U of o)D.push("-a"),D.push(U);if(u){const U=Object.assign({},g(process),u);for(let j in U){const ee=U[j];ee===null?(D.push("-u"),D.push(j)):(D.push("-e"),D.push(`${j}=${ee}`))}}let L="";const W=w.spawn(t.OSASCRIPT,D);W.on("error",U=>{a(v(U))}),W.stderr.on("data",U=>{L+=U.toString()}),W.on("exit",U=>{if(U===0)s(void 0);else if(L){const j=L.split(`
`,1);a(new Error(j[0]))}else a(new Error(y.localize(1,null,l,U)))})}else a(new Error(y.localize(2,null,i)))})}spawnTerminal(f,c,o){const u=c.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",u];o&&s.push(o);const a=g(process),l=f.spawn("/usr/bin/open",s,{cwd:o,env:a});l.on("error",i),l.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class h extends I{openTerminal(f,c){return this.spawnTerminal(w,f,c)}runInTerminal(f,c,o,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{let l=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const D=`${P(o)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;l.push(`''${D}''`);const L=Object.assign({},g(process),u);Object.keys(L).filter(ee=>L[ee]===null).forEach(ee=>delete L[ee]);const W={cwd:c,env:L};let U="";const j=w.spawn(S,l,W);j.on("error",ee=>{a(v(ee))}),j.stderr.on("data",ee=>{U+=ee.toString()}),j.on("exit",ee=>{if(ee===0)s(void 0);else if(U){const x=U.split(`
`,1);a(new Error(x[0]))}else a(new Error(y.localize(4,null,S,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await b.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,c,o){const u=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(s=>{const a=g(process),l=f.spawn(s,[],{cwd:o,env:a});l.on("error",i),l.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=y.localize(3,null);function g(d){const f={...d.env};return(0,M.sanitizeProcessEnvironment)(f),f}function v(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(y.localize(5,null,d.path)):d}function P(d){let f="";for(let c of d)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(J[20],Z([0,1,35,8,27,14,7,145,5]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function y(z){return z.create===!0}e.isFileOpenForWriteOptions=y;var E;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var I;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=p;function t(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=t;function h(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=g;function v(z){return p(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var P;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(X,re){super(X);this.code=re}}e.FileSystemProviderError=d;function f(z,X){const re=new d(z.toString(),X);return o(re,X),re}e.createFileSystemProviderError=f;function c(z){return z||f((0,b.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=c;function o(z,X){return z.name=X?`${X} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=o;function u(z){if(!z)return P.Unknown;if(z instanceof d)return z.code;const X=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!X)return P.Unknown;switch(X[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=u;function r(z){if(z instanceof D)return z.fileOperationResult;switch(u(z)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(X,re,V){this.resource=X,this.operation=re,this.target=V}isOperation(X){return this.operation===X}}e.FileOperationEvent=s;var a;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(X,re){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=X;const V=new Map;for(const H of X){const K=V.get(H.type);switch(K?K.push([H.resource,H]):V.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,K]of V)switch(H){case 1:this.added=w.TernarySearchTree.forUris(()=>re),this.added.fill(K);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>re),this.updated.fill(K);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>re),this.deleted.fill(K);break}}contains(X,...re){return this.doContains(X,{includeChildren:!1},...re)}affects(X,...re){return this.doContains(X,{includeChildren:!0},...re)}doContains(X,re,...V){if(!X)return!1;const H=V.length>0;return!!((!H||V.includes(1))&&(this.added?.get(X)||re.includeChildren&&this.added?.findSuperstr(X))||(!H||V.includes(0))&&(this.updated?.get(X)||re.includeChildren&&this.updated?.findSuperstr(X))||(!H||V.includes(2))&&(this.deleted?.findSubstr(X)||re.includeChildren&&this.deleted?.findSuperstr(X)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function S(z,X,re){return!z||!X||z===X||X.length>z.length?!1:(X.charAt(X.length-1)!==n.sep&&(X+=n.sep),re?(0,R.startsWithIgnoreCase)(z,X):z.indexOf(X)===0)}e.isParent=S;class D extends Error{constructor(X,re,V){super(X);this.fileOperationResult=re,this.options=V}}e.FileOperationError=D;class L extends D{constructor(X,re,V){super(X,2,V);this.stat=re}}e.NotModifiedSinceFileOperationError=L;var W;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=j;async function ee(z,X){if(!X.hasProvider(M.URI.from({scheme:z.scheme})))return new Promise(re=>{const V=X.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===z.scheme&&H.added&&(V.dispose(),re())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(X){return(0,C.isNumber)(X)||(X=0),X<x.KB?(0,b.localize)(1,null,X.toFixed(0)):X<x.MB?(0,b.localize)(2,null,(X/x.KB).toFixed(2)):X<x.GB?(0,b.localize)(3,null,(X/x.MB).toFixed(2)):X<x.TB?(0,b.localize)(4,null,(X/x.GB).toFixed(2)):(0,b.localize)(5,null,(X/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var N;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function G(z){return{maxFileSize:z===0?300*x.MB:16*x.GB,maxHeapSize:z===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=G}),define(J[175],Z([0,1,17,39,15,4,2,48,7,31,20]),function(q,e,w,n,R,C,M,b,m,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends M.Disposable{constructor(p,t){super();this.channel=p,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,t){const{buffer:h}=await this.channel.call("readFile",[p,t]);return h}readFileStream(p,t,h){const g=(0,b.newWriteableStream)(P=>w.VSBuffer.concat(P.map(d=>w.VSBuffer.wrap(d))).buffer),v=this.channel.listen("readFileStream",[p,t])(P=>{if(P instanceof w.VSBuffer)g.write(P.buffer);else{if(P==="end")g.end();else{let d=P;d instanceof Error||(d=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(d),E.FileSystemProviderErrorCode.Unknown)),g.error(d),g.end()}v.dispose()}});return h.onCancellationRequested(()=>{g.error((0,R.canceled)()),g.end(),v.dispose()}),g}writeFile(p,t,h){return this.channel.call("writeFile",[p,w.VSBuffer.wrap(t),h])}open(p,t){return this.channel.call("open",[p,t])}close(p){return this.channel.call("close",[p])}async read(p,t,h,g,v){const[P,d]=await this.channel.call("read",[p,t,v]);return h.set(P.buffer.slice(0,d),g),d}write(p,t,h,g,v){return this.channel.call("write",[p,t,w.VSBuffer.wrap(h),g,v])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,t){return this.channel.call("delete",[p,t])}rename(p,t,h){return this.channel.call("rename",[p,t,h])}copy(p,t,h){return this.channel.call("copy",[p,t,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const t=p;this._onDidChange.fire(t.map(h=>({resource:m.URI.revive(h.resource),type:h.type})))}else{const t=p;this._onDidWatchError.fire(t)}}))}watch(p,t){const h=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,t]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=k}),define(J[94],Z([0,1,17,15,146,20]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(E,k,I,p,t,h){let g;try{await b(E,k,I,p,t,h)}catch(v){g=v}finally{g&&t.errorTransformer&&(g=t.errorTransformer(g)),typeof g!="undefined"&&I.error(g),I.end()}}e.readFileIntoStream=M;async function b(E,k,I,p,t,h){m(h);const g=await E.open(k,{create:!1});try{m(h);let v=0,P=0,d=t&&typeof t.length=="number"?t.length:void 0,f=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof d=="number"?d:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do P=await E.read(g,c,f.buffer,o,f.byteLength-o),c+=P,o+=P,v+=P,typeof d=="number"&&(d-=P),o===f.byteLength&&(await I.write(p(f)),f=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof d=="number"?d:t.bufferSize)),o=0);while(P>0&&(typeof d!="number"||d>0)&&m(h)&&y(v,t));if(o>0){let u=o;typeof d=="number"&&(u=Math.min(o,d)),I.write(p(f.slice(0,u)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await E.close(g)}}function m(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function y(E,k){if(k?.limits){if(typeof k.limits.memory=="number"&&E>k.limits.memory)throw(0,C.createFileSystemProviderError)((0,R.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&E>k.limits.size)throw(0,C.createFileSystemProviderError)((0,R.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[62],Z([0,1,2,3,7,20]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function M(p){return p.recursive===!0}e.isRecursiveWatchRequest=M;class b extends w.Disposable{constructor(t,h,g,v){super();this.onFileChanges=t,this.onLogMessage=h,this.verboseLogging=g,this.options=v,this.watcherDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new w.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),t.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),t.add(this.watcher.onDidError(h=>this.onError(h)))}onError(t){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class m extends b{constructor(t,h,g){super(t,h,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class y extends b{constructor(t,h,g){super(t,h,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function E(p){return p.map(t=>({type:t.type,resource:R.URI.file(t.path)}))}e.toFileChanges=E;function k(p){const t=new I;for(const h of p)t.processEvent(h);return t.coalesce()}e.coalesceEvents=k;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const h=this.mapPathToChange.get(this.toKey(t));let g=!1;if(h){const v=h.type,P=t.type;h.path!==t.path&&(t.type===2||t.type===1)?g=!0:v===1&&P===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(h)):v===2&&P===1?h.type=0:v===1&&P===0||(h.type=P)}else g=!0;g&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],h=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(t.push(g),!1):!0).sort((g,v)=>g.path.length-v.path.length).filter(g=>h.some(v=>(0,C.isParent)(g.path,v,!n.isLinux))?!1:(h.push(g.path),!0)).concat(t)}}}),define(J[176],Z([0,1,29,9,23,28,115,2,71,8,3,86,24,62]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends b.Disposable{constructor(v,P,d,f){super();this.request=v,this.onDidFilesChange=P,this.onLogMessage=d,this.verboseLogging=f,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,M.parse)(c)),this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const P=await I.Promises.stat(v);this._register(await this.doWatch(v,P.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let P=v.path;try{P=await I.Promises.realpath(v.path),v.path===P&&(P=await(0,k.realcase)(v.path)??v.path),v.path!==P&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${P})`)}catch{}return P}async doWatch(v,P){if(E.isMacintosh&&(0,C.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),b.Disposable.None;const d=new R.CancellationTokenSource(this.cts.token);let f=new b.DisposableStore;try{const c=(0,y.basename)(v),o=(0,w.watch)(v);f.add((0,b.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const u=new Set;if(P)try{for(const i of await I.Promises.readdir(v))u.add(i)}catch(i){this.error(i)}const r=new Map;f.add((0,b.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),o.on("error",(i,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),o.on("change",(i,s)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let a="";if(s&&(a=s.toString(),E.isMacintosh&&(a=(0,m.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(P)if(i==="rename"){r.get(a)?.dispose();const l=setTimeout(async()=>{if(r.delete(a),a===c&&!await I.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const S=await this.existsChildStrictCase((0,y.join)(v,a));if(d.token.isCancellationRequested)return;let D;S?u.has(a)?D=0:(D=1,u.add(a)):(u.delete(a),D=2),this.onFileChange({path:(0,y.join)(this.request.path,a),type:D})},t.FILE_DELETE_HANDLER_DELAY);r.set(a,(0,b.toDisposable)(()=>clearTimeout(l)))}else{let l;u.has(a)?l=0:(l=1,u.add(a)),this.onFileChange({path:(0,y.join)(this.request.path,a),type:l})}else if(i==="rename"||a!==c){const l=setTimeout(async()=>{const S=await I.Promises.exists(v);d.token.isCancellationRequested||(S?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,b.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await I.Promises.exists(v)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,b.toDisposable)(()=>{d.dispose(!0),f.dispose()})}async onFileChange(v,P=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!P&&this.excludes.some(d=>d(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,p.coalesceEvents)(d);if(f.length>0){if(this.verboseLogging)for(const o of f)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(E.isLinux)return I.Promises.exists(v);try{const P=(0,y.basename)(v);return(await I.Promises.readdir((0,y.dirname)(v))).some(f=>f===P)}catch(P){return this.trace(P),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function h(g,v,P,d,f=512){const c=await I.Promises.open(g,"r"),o=Buffer.allocUnsafe(f),u=new R.CancellationTokenSource(d);let r,i=!1;const s={path:g,excludes:[],recursive:!1},a=new t(s,l=>{(async()=>{for(const{type:S}of l)if(S===0){if(i)return;i=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:D}=await I.Promises.read(c,o,0,f,null);if(!D||u.token.isCancellationRequested)break;v(o.slice(0,D))}}catch(D){r=new Error(D),u.dispose(!0)}finally{i=!1}}})()});return await a.ready,P(),new Promise((l,S)=>{u.token.onCancellationRequested(async()=>{a.dispose();try{await I.Promises.close(c)}catch(D){r=new Error(D)}r?S(r):l()})})}e.watchFileContents=h}),define(J[177],Z([0,1,30,4,2,3,176]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends R.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const E=this.normalizeRequests(y),k=E.filter(p=>{const t=this.watchers.get(p.path);return t?!(0,w.equals)(t.request.excludes,p.excludes):!0}),I=Array.from(this.watchers.values()).filter(({request:p})=>!E.find(t=>t.path===p.path&&(0,w.equals)(t.excludes,p.excludes))).map(({request:p})=>p.path);k.length&&this.trace(`Request to start watching: ${k.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const p of I)this.stopWatching(p);for(const p of k)this.startWatching(p)}startWatching(y){const E=new M.NodeJSFileWatcherLibrary(y,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),k={request:y,instance:E};this.watchers.set(y.path,k)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const E=this.watchers.get(y);E&&(this.watchers.delete(y),E.instance.dispose())}normalizeRequests(y){const E=new Map;for(const k of y){const I=C.isLinux?k.path:k.path.toLowerCase();E.set(I,k)}return Array.from(E.values())}async setVerboseLogging(y){this.verboseLogging=y;for(const[,E]of this.watchers)E.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,E){return E?`[File Watcher (node.js)] ${y} (path: ${E.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=b}),define(J[178],Z([0,1,62,177]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends w.AbstractNonRecursiveWatcherClient{constructor(M,b,m){super(M,b,m);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(J[179],Z([0,1,10,37,137,62]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends C.AbstractUniversalWatcherClient{constructor(m,y,E){super(m,y,E);this.init()}createWatcher(m){const y=m.add(new R.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(y.onDidProcessExit(({code:E,signal:k})=>this.onError(`terminated by itself with code ${E}, signal: ${k}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(J[77],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...R){this._entries=new Map;for(let[C,M]of R)this.set(C,M)}set(R,C){const M=this._entries.get(R);return this._entries.set(R,C),M}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=w}),define(J[180],Z([0,1,9,15,74,171,5,77]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class y extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class E{constructor(t=new b.ServiceCollection,h=!1,g){this._activeInstantiations=new Set,this._services=t,this._strict=h,this._parent=g,this._services.set(M.IInstantiationService,this)}createChild(t){return new E(t,this._strict,this)}invokeFunction(t,...h){let g=I.traceInvocation(t),v=!1;try{return t({get:d=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(d,g);if(!f)throw new Error(`[invokeFunction] unknown service '${d}'`);return f}},...h)}finally{v=!0,g.stop()}}createInstance(t,...h){let g,v;return t instanceof R.SyncDescriptor?(g=I.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(h),g)):(g=I.traceCreation(t),v=this._createInstance(t,h,g)),g.stop(),v}_createInstance(t,h=[],g){let v=M._util.getServiceDependencies(t).sort((f,c)=>f.index-c.index),P=[];for(const f of v){let c=this._getOrCreateServiceInstance(f.id,g);if(!c&&this._strict&&!f.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${f.id}.`);P.push(c)}let d=v.length>0?v[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${t.name} at position ${d+1} conflicts with ${h.length} static arguments`);let f=d-h.length;f>0?h=h.concat(new Array(f)):h=h.slice(0,d)}return new t(...[...h,...P])}_setServiceInstance(t,h){if(this._services.get(t)instanceof R.SyncDescriptor)this._services.set(t,h);else if(this._parent)this._parent._setServiceInstance(t,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let h=this._services.get(t);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):h}_getOrCreateServiceInstance(t,h){let g=this._getServiceInstanceOrDescriptor(t);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,g,h.branch(t,!0)):(h.branch(t,!1),g)}_safeCreateAndCacheServiceInstance(t,h,g){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,h,g)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,h,g){const v=new C.Graph(f=>f.id.toString());let P=0;const d=[{id:t,desc:h,_trace:g}];for(;d.length;){const f=d.pop();if(v.lookupOrInsertNode(f),P++>1e3)throw new y(v);for(let c of M._util.getServiceDependencies(f.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof R.SyncDescriptor){const u={id:c.id,desc:o,_trace:f._trace.branch(c.id,!0)};v.insertEdge(f,u),d.push(u)}}}for(;;){const f=v.roots();if(f.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const u=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,u)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,h,g=[],v,P){if(this._services.get(t)instanceof R.SyncDescriptor)return this._createServiceInstance(h,g,v,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,h,g,v,P);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(t,h=[],g,v){if(g){const P=new w.IdleValue(()=>this._createInstance(t,h,v));return new Proxy(Object.create(null),{get(d,f){if(f in d)return d[f];let c=P.value,o=c[f];return typeof o!="function"||(o=o.bind(c),d[f]=o),o},set(d,f,c){return P.value[f]=c,!0}})}else return this._createInstance(t,h,v)}}e.InstantiationService=E;var k;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(k||(k={}));class I{constructor(t,h){this.type=t,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return m?new I(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(t){return m?new I(0,t.name):I._None}branch(t,h){let g=new I(2,t.toString());return this._dep.push([t,h,g]),g}stop(){let t=Date.now()-this._start;I._totals+=t;let h=!1;function g(P,d){let f=[],c=new Array(P+1).join("	");for(const[o,u,r]of d._dep)if(u&&r){h=!0,f.push(`${c}CREATES -> ${o}`);let i=g(P+1,r);i&&f.push(i)}else f.push(`${c}uses -> ${o}`);return f.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(t>2||h)&&console.log(v.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(J[181],Z([0,1,15,134,59]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends R.ResolvedKeybinding{constructor(b,m){super();if(m.length===0)throw(0,w.illegalArgument)("parts");this._os=b,this._parts=m}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,b=>this._getLabel(b))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,b=>this._getAriaLabel(b))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,b=>this._getElectronAccelerator(b))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,b=>this._getUserSettingsLabel(b))}isWYSIWYG(){return this._parts.every(b=>this._isWYSIWYG(b))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(b=>this._getPart(b))}_getPart(b){return new R.ResolvedKeybindingPart(b.ctrlKey,b.shiftKey,b.altKey,b.metaKey,this._getLabel(b),this._getAriaLabel(b))}getDispatchParts(){return this._parts.map(b=>this._getDispatchPart(b))}getSingleModifierDispatchParts(){return this._parts.map(b=>this._getSingleModifierDispatchPart(b))}}e.BaseResolvedKeybinding=C}),define(J[182],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(C,M,b,m,y,E,k){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=M?M.charCodeAt(0)===94:!1,this.command=this.bubble?M.substr(1):M,this.commandArgs=b,this.when=m,this.isDefault=y,this.extensionId=E,this.isBuiltinExtension=k}}e.ResolvedKeybindingItem=w;function n(R){let C=[];for(let M=0,b=R.length;M<b;M++){const m=R[M];if(!m)return C;C.push(m)}return C}e.removeElementsAfterNulls=n}),define(J[183],Z([0,1,83,59,181,182]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends R.BaseResolvedKeybinding{constructor(m,y){super(y,m.parts)}_keyCodeToUILabel(m){if(this._os===2)switch(m){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(m)}_getLabel(m){return m.isDuplicateModifierCase()?"":this._keyCodeToUILabel(m.keyCode)}_getAriaLabel(m){return m.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(m.keyCode)}_getElectronAccelerator(m){return w.KeyCodeUtils.toElectronAccelerator(m.keyCode)}_getUserSettingsLabel(m){if(m.isDuplicateModifierCase())return"";const y=w.KeyCodeUtils.toUserSettingsUS(m.keyCode);return y&&y.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(m){return M.getDispatchStr(m)}static getDispatchStr(m){if(m.isModifierKey())return null;let y="";return m.ctrlKey&&(y+="ctrl+"),m.shiftKey&&(y+="shift+"),m.altKey&&(y+="alt+"),m.metaKey&&(y+="meta+"),y+=w.KeyCodeUtils.toString(m.keyCode),y}_getSingleModifierDispatchPart(m){return m.keyCode===5&&!m.shiftKey&&!m.altKey&&!m.metaKey?"ctrl":m.keyCode===4&&!m.ctrlKey&&!m.altKey&&!m.metaKey?"shift":m.keyCode===6&&!m.ctrlKey&&!m.shiftKey&&!m.metaKey?"alt":m.keyCode===57&&!m.ctrlKey&&!m.shiftKey&&!m.altKey?"meta":null}static _scanCodeToKeyCode(m){const y=w.IMMUTABLE_CODE_TO_KEY_CODE[m];if(y!==-1)return y;switch(m){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(m){if(!m)return null;if(m instanceof n.SimpleKeybinding)return m;const y=this._scanCodeToKeyCode(m.scanCode);return y===0?null:new n.SimpleKeybinding(m.ctrlKey,m.shiftKey,m.altKey,m.metaKey,y)}static resolveUserBinding(m,y){const E=(0,C.removeElementsAfterNulls)(m.map(k=>this._resolveSimpleUserBinding(k)));return E.length>0?[new M(new n.ChordKeybinding(E),y)]:[]}}e.USLayoutResolvedKeybinding=M}),define(J[184],Z([0,1,9]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(R,C){if(R.length===0)return Promise.resolve(!1);const M=[];let b=!1;for(let m of R){if(m===!0)return Promise.resolve(!0);(0,w.isThenable)(m)&&M.push(m.then(y=>{y&&(b=!0)},y=>{C(y),b=!0}))}return w.Promises.settled(M).then(()=>b)}e.handleVetos=n}),define(J[6],Z([0,1,39,4,2,3,5]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function b(){return new Date().toISOString()}var m;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function y(u,r,i){switch(r){case m.Trace:u.trace(i);break;case m.Debug:u.debug(i);break;case m.Info:u.info(i);break;case m.Warning:u.warn(i);break;case m.Error:u.error(i);break;case m.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=y;function E(u){let r="";for(let i=0;i<u.length;i++){let s=u[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(i>0?" ":"")+s}return r}e.format=E;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class I extends k{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(m.Trace)&&this.log(m.Trace,E([r,...i]))}debug(r,...i){this.checkLogLevel(m.Debug)&&this.log(m.Debug,E([r,...i]))}info(r,...i){this.checkLogLevel(m.Info)&&this.log(m.Info,E([r,...i]))}warn(r,...i){this.checkLogLevel(m.Warning)&&this.log(m.Warning,E([r,...i]))}error(r,...i){if(this.checkLogLevel(m.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(m.Error,E(s))}else this.log(m.Error,E([r,...i]))}critical(r,...i){this.checkLogLevel(m.Critical)&&this.log(m.Critical,E([r,...i]))}flush(){}}e.AbstractMessageLogger=I;class p extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!C.isWindows}trace(r,...i){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}debug(r,...i){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}info(r,...i){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,r,...i):console.log(`[main ${b()}]`,r,...i))}warn(r,...i){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,r,...i):console.warn(`[main ${b()}]`,r,...i))}error(r,...i){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,r,...i):console.error(`[main ${b()}]`,r,...i))}critical(r,...i){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,r,...i):console.error(`[main ${b()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class h extends k{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,w.toErrorMessage)(r,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class g extends k{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=g;class v extends R.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=v;class P extends R.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?m.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class d{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return m.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=d;function f(u){if(u.verbose)return m.Trace;if(typeof u.logLevel=="string"){const r=c(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(u){switch(u){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=c;function o(u){switch(u){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(J[185],Z([0,1,30,9,15,4,2,8,62,6]),function(q,e,w,n,R,C,M,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends M.Disposable{constructor(I,p){super();this.logService=I,this.options=p,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(I,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,p):this.watchNonRecursive(I,p)}watchUniversal(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:p.recursive},h=(0,w.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,m.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const p of this.universalPathsToWatch)(0,m.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const p of this.universalPathsToWatch)(0,m.isRecursiveWatchRequest)(p)&&I.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:!1},h=(0,w.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,m.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,b.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=E});var te=this&&this.__param||function(q,e){return function(w,n){e(w,n,q)}};define(J[186],Z([0,1,30,9,17,23,4,70,69,2,35,10,63,16,48,144,20,94,6]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const u=new y.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),u.add(o.onDidChangeFile(r=>this._onDidFilesChange.fire(new g.FileChangesEvent(r,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&u.add(o.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),u.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,y.dispose)(u)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(u){o.push(u)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const u=this.provider.get(c.scheme);return!!(u&&u.capabilities&o)}listCapabilities(){return m.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,p.isAbsolutePath)(c))throw new g.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const u=new Error;throw u.name="ENOPRO",u.message=(0,h.localize)(1,null,c.toString()),u}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o)||(0,g.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(u){throw(0,g.toFileSystemProviderErrorCode)(u)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,g.ensureFileSystemProviderError)(u)}}async doResolveFile(c,o){const u=await this.withProvider(c),r=this.isPathCaseSensitive(u),i=o?.resolveTo,s=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,l=await u.stat(c);let S;return this.toFileStat(u,c,l,void 0,!!a,(D,L)=>(S||(S=E.TernarySearchTree.forUris(()=>!r),S.set(c,!0),i&&S.fill(!0,i)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?L===1:!1))}async toFileStat(c,o,u,r,i,s){const{providerExtUri:a}=this.getExtUri(c),l={resource:o,name:a.basename(o),isFile:(u.type&g.FileType.File)!=0,isDirectory:(u.type&g.FileType.Directory)!=0,isSymbolicLink:(u.type&g.FileType.SymbolicLink)!=0,mtime:u.mtime,ctime:u.ctime,size:u.size,readonly:Boolean((u.permissions??0)&g.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,g.etag)({mtime:u.mtime,size:u.size})};if(l.isDirectory&&s(l,r)){try{const S=await c.readdir(o),D=await n.Promises.settled(S.map(async([L,W])=>{try{const U=a.joinPath(o,L),j=i?await c.stat(U):{type:W};return await this.toFileStat(c,U,j,S.length,i,s)}catch(U){return this.logService.trace(U),null}}));l.children=(0,w.coalesce)(D)}catch(S){this.logService.trace(S),l.children=[]}return l}return l}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(u){return this.logService.trace(u),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(u){return u}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new g.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=R.VSBuffer.fromString(""),u){await this.doValidateCreateFile(c,u);const r=await this.writeFile(c,o);return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,r)),r}async writeFile(c,o,u){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,c,u)||await this.mkdirp(r,i.dirname(c));let a;if((0,g.hasReadWriteCapability)(r)&&!(o instanceof R.VSBuffer))if((0,t.isReadableStream)(o)){const l=await(0,t.peekStream)(o,3);l.ended?a=R.VSBuffer.concat(l.buffer):a=l}else a=(0,t.peekReadable)(o,l=>R.VSBuffer.concat(l),3);else a=o;!(0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r)&&a instanceof R.VSBuffer?await this.doWriteUnbuffered(r,c,u,a):await this.doWriteBuffered(r,c,u,a instanceof R.VSBuffer?(0,R.bufferToReadable)(a):a),this._onDidRunOperation.fire(new g.FileOperationEvent(c,4))}catch(s){throw new g.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),u)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,u){if(!!u?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,u);if(this.throwIfFileIsReadonly(o,i),typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==g.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&u.mtime<i.mtime&&u.etag!==(0,g.etag)({mtime:u.mtime,size:i.size}))throw new g.FileOperationError((0,h.localize)(7,null),3,u);return i}async readFile(c,o,u){const r=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(r,c,o,u):this.doReadFile(r,c,o,u)}async doReadFileAtomic(c,o,u,r){return new Promise((i,s)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,u,r);i(a)}catch(a){s(a)}})})}async doReadFile(c,o,u,r){const i=await this.doReadFileStream(c,o,{...u,preferUnbuffered:!0},r);return{...i,value:await(0,R.streamToBuffer)(i.value)}}async readFileStream(c,o,u){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,o,u)}async doReadFileStream(c,o,u,r){const i=new C.CancellationTokenSource(r),s=this.validateReadFile(o,u).then(l=>l,l=>{throw i.cancel(),l});let a;try{return typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&await s,u?.atomic&&(0,g.hasFileAtomicReadCapability)(c)||!((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasFileReadStreamCapability)(c))||(0,g.hasReadWriteCapability)(c)&&u?.preferUnbuffered?a=this.readFileUnbuffered(c,o,u):(0,g.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,i.token,u):a=this.readFileBuffered(c,o,i.token,u),{...await s,value:a}}catch(l){a&&await(0,t.consumeStream)(a);const S=(0,h.localize)(8,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(S,l.stat,u):new g.FileOperationError(S,(0,g.toFileOperationResult)(l),u)}}readFileStreamed(c,o,u,r=Object.create(null)){const i=c.readFileStream(o,r,u);return(0,t.transform)(i,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(c,o,u,r=Object.create(null)){const i=(0,R.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,o,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),r)},u),i}readFileUnbuffered(c,o,u){const r=(0,t.newWriteableStream)(i=>R.VSBuffer.concat(i));return(async()=>{try{let i;u?.atomic&&(0,g.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof u?.position=="number"&&(i=i.slice(u.position)),typeof u?.length=="number"&&(i=i.slice(0,u.length)),this.validateReadFileLimits(o,i.byteLength,u),r.end(R.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(c,o){const u=await this.resolve(c,{resolveMetadata:!0});if(u.isDirectory)throw new g.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==g.ETAG_DISABLED&&o.etag===u.etag)throw new g.NotModifiedSinceFileOperationError((0,h.localize)(12,null),u,o);return this.validateReadFileLimits(c,u.size,o),u}validateReadFileLimits(c,o,u){if(u?.limits){let r;if(typeof u.limits.memory=="number"&&o>u.limits.memory&&(r=9),typeof u.limits.size=="number"&&o>u.limits.size&&(r=7),typeof r=="number")throw new g.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),r)}}async canMove(c,o,u){return this.doCanMoveCopy(c,o,"move",u)}async canCopy(c,o,u){return this.doCanMoveCopy(c,o,"copy",u)}async doCanMoveCopy(c,o,u,r){if(c.toString()!==o.toString())try{const i=u==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,s,o,u,r)}catch(i){return i}return!0}async move(c,o,u){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,c,i,o,"move",!!u),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,s==="move"?2:3,a)),a}async copy(c,o,u){const r=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,c,i,o,"copy",!!u),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,s==="copy"?3:2,a)),a}async doMoveCopy(c,o,u,r,i,s){if(o.toString()===r.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,o,u,r,i,s);if(a&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(u,this.getExtUri(u).providerExtUri.dirname(r)),i==="copy"){if(c===u&&(0,g.hasFileFolderCopyCapability)(c))await c.copy(o,r,{overwrite:s});else{const S=await this.resolve(o);S.isDirectory?await this.doCopyFolder(c,S,u,r):await this.doCopyFile(c,o,u,r)}return i}else return c===u?(await c.rename(o,r,{overwrite:s}),i):(await this.doMoveCopy(c,o,u,r,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,u,r){if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(u))return this.doPipeBuffered(c,o,u,r);if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasReadWriteCapability)(u))return this.doPipeBufferedToUnbuffered(c,o,u,r);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(u))return this.doPipeUnbufferedToBuffered(c,o,u,r);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasReadWriteCapability)(u))return this.doPipeUnbuffered(c,o,u,r)}async doCopyFolder(c,o,u,r){await u.mkdir(r),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const s=this.getExtUri(u).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),u,s):this.doCopyFile(c,i.resource,u,s)}))}async doValidateMoveCopy(c,o,u,r,i,s){let a=!1;if(c===u){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(c);if(D||(a=S.isEqual(o,r)),a&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!a&&S.isEqualOrParent(r,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!a){if(!s)throw new g.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(c===u){const{providerExtUri:S}=this.getExtUri(c);if(S.isEqualOrParent(o,r))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,u)),u}async mkdirp(c,o){const u=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(o,r.dirname(o));)try{if(((await c.stat(o)).type&g.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileNotFound)throw i;u.push(r.basename(o)),o=r.dirname(o)}for(let i=u.length-1;i>=0;i--){o=r.joinPath(o,u[i]);try{await c.mkdir(o)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(u){return u}return!0}async doValidateDelete(c,o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(u.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await u.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new g.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return u}async del(c,o){const u=await this.doValidateDelete(c,o),r=!!o?.useTrash,i=!!o?.recursive;await u.delete(c,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new g.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const u=new y.DisposableStore;let r=!1,i=()=>{r=!0};return u.add((0,y.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(c,o);r?(0,y.dispose)(s):i=()=>(0,y.dispose)(s)}catch(s){this.logService.error(s)}})(),u}async doWatch(c,o){const u=await this.withProvider(c),r=(0,b.hash)([this.getExtUri(u).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:u.watch(c,o)},this.activeWatchers.set(r,i)),i.count+=1,(0,y.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,y.dispose)(i.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,u,r){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:u?.unlock??!1});try{(0,t.isReadableStream)(r)||(0,t.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(c,i,r):await this.doWriteReadableBufferedQueued(c,i,r)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,u){let r=0,i;if((0,t.isReadableBufferedStream)(u)){if(u.buffer.length>0){const s=R.VSBuffer.concat(u.buffer);await this.doWriteBuffer(c,o,s,s.byteLength,r,0),r+=s.byteLength}if(u.ended)return;i=u.stream}else i=u;return new Promise((s,a)=>{(0,t.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(c,o,l,l.byteLength,r,0)}catch(S){return a(S)}r+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>a(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,o,u){let r=0,i;for(;(i=u.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(c,o,u,r,i,s){let a=0;for(;a<r;)a+=await c.write(o,i+a,u.buffer,s+a,r-a)}async doWriteUnbuffered(c,o,u,r){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,u,r))}async doWriteUnbufferedQueued(c,o,u,r){let i;r instanceof R.VSBuffer?i=r:(0,t.isReadableStream)(r)?i=await(0,R.streamToBuffer)(r):(0,t.isReadableBufferedStream)(r)?i=await(0,R.bufferedStreamToBuffer)(r):i=(0,R.readableToBuffer)(r),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:u?.unlock??!1})}async doPipeBuffered(c,o,u,r){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,u,r))}async doPipeBufferedQueued(c,o,u,r){let i,s;try{i=await c.open(o,{create:!1}),s=await u.open(r,{create:!0,unlock:!1});const a=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,S=0,D=0;do D=await c.read(i,l,a.buffer,S,a.byteLength-S),await this.doWriteBuffer(u,s,a,D,l,S),l+=D,S+=D,S===a.byteLength&&(S=0);while(D>0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof s=="number"?u.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,o,u,r){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,u,r))}async doPipeUnbufferedQueued(c,o,u,r){return u.writeFile(r,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,u,r){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,u,r))}async doPipeUnbufferedToBufferedQueued(c,o,u,r){const i=await u.open(r,{create:!0,unlock:!1});try{const s=await c.readFile(o);await this.doWriteBuffer(u,i,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await u.close(i)}}async doPipeBufferedToUnbuffered(c,o,u,r){const i=await(0,R.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(u,r,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new g.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};d=ue([te(0,P.ILogService)],d),e.FileService=d}),define(J[78],Z([0,1,29,251,9,35,17,4,28,2,8,3,16,48,24,148,20,94,185,39,179,178]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(w)}catch(u){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(u)}`)}})();class o extends P.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new C.ResourceMap(s=>I.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await t.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,I.joinPath)(r,a.name))).type:l=this.toType(a),s.push([a.name,l])}catch(l){this.logService.trace(l)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let s;return i?.dangling?s=g.FileType.Unknown:r.isFile()?s=g.FileType.File:r.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,i&&(s|=g.FileType.SymbolicLink),s}async createResourceLock(r){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(r)})`);let i;for(;i=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(r)})`),await i.wait();const s=new R.Barrier;return this.resourceLocks.set(r,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(r)})`),(0,y.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(r)})`),this.resourceLocks.delete(r),s.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const a=this.toFilePath(r);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(r,i,s){const a=(0,p.newWriteableStream)(l=>M.VSBuffer.concat(l.map(S=>M.VSBuffer.wrap(S))).buffer);return(0,v.readFileIntoStream)(this,r,a,l=>l.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(r,i,s){let a;try{const l=this.toFilePath(r);if(!s.create||!s.overwrite){if(await t.Promises.exists(l)){if(!s.overwrite)throw(0,g.createFileSystemProviderError)((0,h.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.createFileSystemProviderError)((0,h.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(r,l)}finally{typeof a=="number"&&await this.close(a)}}async open(r,i){let s;(0,g.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(r));let a;try{const l=this.toFilePath(r);if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:D}=await t.SymlinkSupport.stat(l);D.mode&128||await t.Promises.chmod(l,D.mode|128)}catch(D){this.logService.trace(D)}let S;if((0,g.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await t.Promises.truncate(l,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}S||(S="w")}else S="r";a=await t.Promises.open(l,S)}catch(l){throw s?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}return this.mapHandleToPos.set(a,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,r),s&&this.mapHandleToLock.set(a,s),a}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await t.Promises.fdatasync(r)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(r);i&&(this.mapHandleToLock.delete(r),i.dispose())}}async read(r,i,s,a,l){const S=this.normalizePos(r,i);let D=null;try{const{bytesRead:L}=await t.Promises.read(r,s,a,l,S);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(r,S,D)}}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,s){const a=this.mapHandleToPos.get(r);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,a+s):this.mapHandleToPos.delete(r)))}async write(r,i,s,a,l){return(0,R.retry)(()=>this.doWrite(r,i,s,a,l),100,3)}async doWrite(r,i,s,a,l){const S=this.normalizePos(r,i);let D=null;try{const{bytesWritten:L}=await t.Promises.write(r,s,a,l,S);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),L)}finally{this.updatePos(r,S,D)}}async mkdir(r){try{await t.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const s=this.toFilePath(r);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,i,s){const a=this.toFilePath(r),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(r,i,"move",s.overwrite),await t.Promises.move(a,l)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(2,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(l)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(r,i,s){const a=this.toFilePath(r),l=this.toFilePath(i);if(a!==l)try{await this.validateTargetDeleted(r,i,"copy",s.overwrite),await t.Promises.copy(a,l,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(3,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(l)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(r,i,s,a){const l=this.toFilePath(r),S=this.toFilePath(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,m.isEqual)(l,S,!0)),D&&s==="copy")throw(0,g.createFileSystemProviderError)((0,h.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!D&&await t.Promises.exists(S)){if(!a)throw(0,g.createFileSystemProviderError)((0,h.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,i,s){return new f.UniversalWatcherClient(a=>r(a),a=>i(a),s)}createNonRecursiveWatcher(r,i,s){return new c.NodeJSWatcherClient(a=>r(a),a=>i(a),s)}toFileSystemProviderError(r){if(r instanceof g.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let s=this.toFileSystemProviderError(i);if(r&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(r));a.mode&128||(s=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=o}),define(J[187],Z([0,1,4,78,2,17,48,23]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class m extends R.Disposable{constructor(k,I){super();this.provider=k,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,I,p){const t=this.getUriTransformer(k);switch(I){case"stat":return this.stat(t,p[0]);case"readdir":return this.readdir(t,p[0]);case"open":return this.open(t,p[0],p[1]);case"close":return this.close(p[0]);case"read":return this.read(p[0],p[1],p[2]);case"readFile":return this.readFile(t,p[0],p[1]);case"write":return this.write(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.writeFile(t,p[0],p[1],p[2]);case"rename":return this.rename(t,p[0],p[1],p[2]);case"copy":return this.copy(t,p[0],p[1],p[2]);case"mkdir":return this.mkdir(t,p[0]);case"delete":return this.delete(t,p[0],p[1]);case"watch":return this.watch(t,p[0],p[1],p[2],p[3]);case"unwatch":return this.unwatch(p[0],p[1])}throw new Error(`IPC Command ${I} not found`)}listen(k,I,p){const t=this.getUriTransformer(k);switch(I){case"fileChange":return this.onFileChange(t,p[0]);case"readFileStream":return this.onReadFileStream(t,p[0],p[1])}throw new Error(`Unknown event ${I}`)}stat(k,I){const p=this.transformIncoming(k,I,!0);return this.provider.stat(p)}readdir(k,I){const p=this.transformIncoming(k,I);return this.provider.readdir(p)}async readFile(k,I,p){const t=this.transformIncoming(k,I,!0),h=await this.provider.readFile(t,p);return C.VSBuffer.wrap(h)}onReadFileStream(k,I,p){const t=this.transformIncoming(k,I,!0),h=new b.CancellationTokenSource,g=new w.Emitter({onLastListenerRemove:()=>{h.cancel()}}),v=this.provider.readFileStream(t,p,h.token);return(0,M.listenStream)(v,{onData:P=>g.fire(C.VSBuffer.wrap(P)),onError:P=>g.fire(P),onEnd:()=>{g.fire("end"),g.dispose(),h.dispose()}}),g.event}writeFile(k,I,p,t){const h=this.transformIncoming(k,I);return this.provider.writeFile(h,p.buffer,t)}open(k,I,p){const t=this.transformIncoming(k,I,!0);return this.provider.open(t,p)}close(k){return this.provider.close(k)}async read(k,I,p){const t=C.VSBuffer.alloc(p),h=0,g=await this.provider.read(k,I,t.buffer,h,p);return[t,g]}write(k,I,p,t,h){return this.provider.write(k,I,p.buffer,t,h)}mkdir(k,I){const p=this.transformIncoming(k,I);return this.provider.mkdir(p)}delete(k,I,p){const t=this.transformIncoming(k,I);return this.provider.delete(t,p)}rename(k,I,p,t){const h=this.transformIncoming(k,I),g=this.transformIncoming(k,p);return this.provider.rename(h,g,t)}copy(k,I,p,t){const h=this.transformIncoming(k,I),g=this.transformIncoming(k,p);return this.provider.copy(h,g,t)}onFileChange(k,I){const p=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(k,p))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return p.event}async watch(k,I,p,t,h){const g=this.sessionToWatcher.get(I);if(g){const v=this.transformIncoming(k,t),P=g.watch(p,v,h);this.watchRequests.set(I+p,P)}}async unwatch(k,I){const p=k+I,t=this.watchRequests.get(p);t&&((0,R.dispose)(t),this.watchRequests.delete(p))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=m;class y extends R.Disposable{constructor(k,I,p,t){super();this.uriTransformer=k,this.logService=p,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(k){const I=this._register(new w.Emitter);this._register(I.event(p=>{k.fire(p.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(p=>I.fire(p))),this._register(this.fileWatcher.onDidWatchError(p=>k.fire(p)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,I,p){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(p.excludes=[...p.excludes,...t]),this.watcherRequests.set(k,this.fileWatcher.watch(I,p)),(0,R.toDisposable)(()=>{(0,R.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=y}),define(J[188],Z([0,1,12,147,3,7,20,8,187,116]),function(q,e,w,n,R,C,M,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class E extends m.AbstractDiskFileSystemProviderChannel{constructor(p,t,h){super(p,t);this.environmentService=h}getUriTransformer(p){return y.DefaultURITransformer}transformIncoming(p,t){return C.URI.revive(t)}async delete(p,t,h){if(!h.useTrash)return super.delete(p,t,h);const g=this.transformIncoming(p,t),v=(0,b.normalize)(g.fsPath);try{await w.shell.trashItem(v)}catch{throw(0,M.createFileSystemProviderError)(R.isWindows?(0,n.localize)(0,null,(0,b.basename)(v)):(0,n.localize)(1,null,(0,b.basename)(v)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,t){return new k(p,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=E;class k extends m.AbstractSessionFileWatcher{watch(p,t,h){if(h.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(p,t,h)}}}),define(J[95],Z([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,M){switch(M){case w.LogLevel.Trace:return C.trace;case w.LogLevel.Debug:return C.debug;case w.LogLevel.Info:return C.info;case w.LogLevel.Warning:return C.warn;case w.LogLevel.Error:return C.error;case w.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class R extends w.AbstractLogger{constructor(M=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(M){this._logger=M;for(const{level:b,args:m}of this.buffer)n(M,b).apply(M,m);this.buffer=[]}_log(M,...b){this._logger?n(this._logger,M).apply(this._logger,b):this.getLevel()<=M&&this.buffer.push({level:M,args:b})}trace(M,...b){this._log(w.LogLevel.Trace,M,...b)}debug(M,...b){this._log(w.LogLevel.Debug,M,...b)}info(M,...b){this._log(w.LogLevel.Info,M,...b)}warn(M,...b){this._log(w.LogLevel.Warning,M,...b)}error(M,...b){this._log(w.LogLevel.Error,M,...b)}critical(M,...b){this._log(w.LogLevel.Critical,M,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(J[189],Z([0,1,9,17,16,20,5,95,6]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*C.ByteSize.MB;let E=class extends m.AbstractLogger{constructor(p,t,h,g,v){super();this.name=p,this.resource=t,this.donotUseFormatters=g,this.fileService=v,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,(0,m.format)(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,(0,m.format)(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,(0,m.format)(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,(0,m.format)(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(m.LogLevel.Error,(0,m.format)(t))}else this._log(m.LogLevel.Error,(0,m.format)(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,(0,m.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>y&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=t:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(h))})}getCurrentTimestamp(){const p=g=>g<10?`0${g}`:g,t=g=>g<10?`00${g}`:g<100?`0${g}`:g,h=new Date;return`${h.getFullYear()}-${p(h.getMonth()+1)}-${p(h.getDate())} ${p(h.getHours())}:${p(h.getMinutes())}:${p(h.getSeconds())}.${t(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,R.joinPath)((0,R.dirname)(this.resource),`${(0,R.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(p){switch(p){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}};E=ue([te(4,C.IFileService)],E),e.FileLogger=E;let k=class extends m.AbstractLoggerService{constructor(p,t,h){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=h}doCreateLogger(p,t,h){const g=new b.BufferLogService(t);return(0,C.whenProviderRegistered)(p,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(E,h?.name||(0,R.basename)(p),p,g.getLevel(),!!h?.donotUseFormatters)),g}};k=ue([te(0,m.ILogService),te(1,M.IInstantiationService),te(2,C.IFileService)],k),e.FileLoggerService=k}),define(J[190],Z([0,1,4,7,6]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(I){this.service=I,this.onDidChangeLogLevel=w.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=C;class M{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){M.setLevel(this.channel,I)}static setLevel(I,p){return I.call("setLevel",p)}}e.LogLevelChannelClient=M;class b{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,p){throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(I,p){this.loggers.set(I.toString(),this.loggerService.createLogger(I,p))}consoleLog(I,p){let t=console.log;switch(I){case R.LogLevel.Error:t=console.error;break;case R.LogLevel.Warning:t=console.warn;break;case R.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(I,p){const t=this.loggers.get(I.toString());if(!t)throw new Error("Create the logger before logging");for(const[h,g]of p)(0,R.log)(t,h,g)}}e.LoggerChannel=b;class m extends R.AbstractLoggerService{constructor(I,p,t){super(I,p);this.channel=t}createConsoleMainLogger(){return new R.AdapterLogger({log:(I,p)=>{this.channel.call("consoleLog",[I,p])}})}doCreateLogger(I,p,t){return new y(this.channel,I,p,t)}}e.LoggerChannelClient=m;class y extends R.AbstractMessageLogger{constructor(I,p,t,h){super(h?.always);this.channel=I,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,p){const t=[[I,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(I){this.channel.call("log",[this.file,I])}}class E extends R.LogService{constructor(I,p){super(p);this.parent=I,this._register(I.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=E}),define(J[96],Z([0,1,20,6]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function R(b,m,y,E,k){try{const I=await new Promise((t,h)=>{q(["spdlog"],t,h)});I.setFlushOn(n.LogLevel.Trace);const p=await I.createAsyncRotatingLogger(b,m,y,E);return k&&p.clearFormatters(),p}catch(I){console.error(I)}return null}function C(b,m,y){switch(m){case n.LogLevel.Trace:b.trace(y);break;case n.LogLevel.Debug:b.debug(y);break;case n.LogLevel.Info:b.info(y);break;case n.LogLevel.Warning:b.warn(y);break;case n.LogLevel.Error:b.error(y);break;case n.LogLevel.Critical:b.critical(y);break;default:throw new Error("Invalid log level")}}class M extends n.AbstractMessageLogger{constructor(m,y,E,k,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(m,y,E,k),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(m,y,E,k){const I=E?6:1,p=30/I*w.ByteSize.MB,t=await R(m,y,p,I,k);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:h,message:g}of this.buffer)C(this._logger,h,g);this.buffer=[]}}log(m,y){this._logger?C(this._logger,m,y):this.getLevel()<=m&&this.buffer.push({level:m,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(J[191],Z([0,1,10,16,31,20,189,6,96]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends b.AbstractLoggerService{constructor(k,I){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=I}doCreateLogger(k,I,p){return k.scheme===w.Schemas.file?new m.SpdLogLogger(p?.name||(0,R.generateUuid)(),k.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,I):new M.FileLogger(p?.name??(0,n.basename)(k),k,I,!!p?.donotUseFormatters,this.fileService)}};y=ue([te(0,b.ILogService),te(1,C.IFileService)],y),e.LoggerService=y}),define(J[192],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function n(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function R(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function C(M){return!w(M)&&!n(M)&&!R(M)}e.isMenubarMenuItemAction=C}),define(J[53],Z([0,1,10,3,36,16]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)M=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const b=(0,C.dirname)(w.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,C.joinPath)(b,"product.json").fsPath);const m=q.__$__nodeRequire((0,C.joinPath)(b,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:m.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=M}),define(J[21],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[193],Z([0,1,75,4,2,6,3,52,21]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let y=class mt extends R.Disposable{constructor(k,I,p,t){super();this.isRunningOnServer=k,this.logService=I,this.environmentMainService=p,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(k,I){const p=await this.withKeytar(),t=await p.getPassword(k,I);if(t)try{let{content:h,hasNextChunk:g}=JSON.parse(t);if(!h||!g)return t;let v=1;for(;g;){const P=await p.getPassword(k,`${I}-${v}`),d=JSON.parse(P);h+=d.content,g=d.hasNextChunk,v++}return h}catch{return t}return t}async setPassword(k,I,p){const t=await this.withKeytar(),h=3,g=async(v,P,d)=>{let f=0,c;for(;f<h;)try{await t.setPassword(v,P,d);return}catch(o){c=o,this.logService.warn("Error attempting to set a password: ",o),f++,await new Promise(u=>setTimeout(u,200))}throw c};if(M.isWindows&&p.length>mt.MAX_PASSWORD_LENGTH){let v=0,P=0,d=!0;for(;d;){const f=p.substring(v,v+mt.PASSWORD_CHUNK_SIZE);v+=mt.PASSWORD_CHUNK_SIZE,d=p.length-v>0;const c={content:f,hasNextChunk:d};await g(k,P?`${I}-${P}`:I,JSON.stringify(c)),P++}}else await g(k,I,p);this._onDidChangePassword.fire({service:k,account:I})}async deletePassword(k,I){const t=await(await this.withKeytar()).deletePassword(k,I);return t&&this._onDidChangePassword.fire({service:k,account:I}),t}async findPassword(k){return(await this.withKeytar()).findPassword(k)}async findCredentials(k){return(await this.withKeytar()).findCredentials(k)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((k,I)=>{q(["keytar"],k,I)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(k){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${k.message}`),this._keytarCache=new w.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ue([te(1,C.ILogService),te(2,b.INativeEnvironmentService),te(3,m.IProductService)],y),e.CredentialsMainService=y}),define(J[194],Z([0,1,60,6,21]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(b,m){this.productService=b,this.logService=m,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,m){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(m);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",m),!1;const[,E,k]=y;let I=this.trustedExtensionUrlPublicKeys.get(b);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[b],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...I])}const p=Buffer.from(decodeURIComponent(k),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",m),!1;const t=p.slice(0,6),h=p.readUIntBE(0,6),g=Date.now()-h;if(g<0||g>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",m),!1;const v=p.slice(6),P=w.createVerify("SHA256");P.write(t),P.write(Buffer.from(E)),P.end();for(let d=0;d<I.length;d++){let f=I[d];if(f!==null){if(typeof f=="string")try{f=w.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),I[d]=f}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${b}:`,c),I[d]=null;continue}if(P.verify(f,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",m),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",m),!1}};C=ue([te(0,R.IProductService),te(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(J[54],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[195],Z([0,1,12,2,35,10,3,16,7,31,52,6]),function(q,e,w,n,R,C,M,b,m,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends n.Disposable{constructor(t,h){super();this.logService=h,this.validRoots=R.TernarySearchTree.forUris(()=>!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(m.URI.file(t.appRoot)),this.addValidFileRoot(m.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(h,g)=>this.handleResourceRequest(h,g)),t.protocol.interceptFileProtocol(C.Schemas.file,(h,g)=>this.handleFileRequest(h,g)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,h){const g=m.URI.parse(t.url);return this.logService.error(`Refused to load resource ${g.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),h({error:-3})}handleResourceRequest(t,h){const g=this.requestToFileUri(t);return this.validRoots.findSubstr(g)?h({path:g.fsPath}):this.validExtensions.has((0,b.extname)(g))?h({path:g.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${g.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),h({error:-3}))}requestToFileUri(t){const h=m.URI.parse(t.url),g=C.FileAccess.asFileUri(h);return(0,b.normalizePath)(g)}createIPCObjectUrl(){let t;const h=m.URI.from({scheme:"vscode",path:(0,y.generateUuid)()}),g=h.toString(),v=async()=>t;return w.ipcMain.handle(g,v),this.logService.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:h,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${g}.`),w.ipcMain.removeHandler(g)}}}};I=ue([te(0,E.INativeEnvironmentService),te(1,k.ILogService)],I),e.ProtocolMainService=I}),define(J[40],Z([0,1,105,14]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(M,b){w.ok(n.isString(M)),w.ok(n.isObject(b)),w.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,b)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new R}),define(J[196],Z([0,1,4,40]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class C{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,y){this.schemasById[R(m)]=y,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new C;n.Registry.add(e.Extensions.JSONContribution,M)}),define(J[55],Z([0,1,30,4,14,139,196,40]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=b.Registry.as(M.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const u=this.doRegisterConfigurations(c,o);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(c,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(u)})}registerDefaultConfigurations(c){const o=[],u=[];for(const{overrides:r,source:i}of c)for(const s in r)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const a={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:a});const l={type:"object",default:a,description:C.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:R.isString(i)?void 0:i};u.push(...t(s)),this.configurationProperties[s]=l,this.defaultLanguageConfigurationOverridesNode.properties[s]=l}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:i});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:u,source:r}of c)for(const i in u){const s=this.configurationDefaultsOverrides.get(i),a=R.isString(r)?r:r?.id,l=R.isString(s?.source)?s?.source:s?.source?.id;if(a===l)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const S=this.configurationProperties[i];S&&(this.updatePropertyDefaultValue(i,S),this.updateSchema(i,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const u=[];return c.forEach(r=>{u.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),u}doDeregisterConfigurations(c){const o=[],u=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>u(i))};for(const r of c){u(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,u,r,i=3){i=R.isUndefinedOrNull(c.scope)?i:c.scope;let s=[],a=c.properties;if(a)for(let S in a){if(o&&P(S)){delete a[S];continue}const D=a[S];if(D.source=u,D.defaultDefaultValue=a[S].default,this.updatePropertyDefaultValue(S,D),e.OVERRIDE_PROPERTY_REGEX.test(S)?D.scope=void 0:(D.scope=R.isUndefinedOrNull(D.scope)?i:D.scope,D.restricted=R.isUndefinedOrNull(D.restricted)?!!r?.includes(S):D.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.excludedConfigurationProperties[S]=a[S],delete a[S];continue}else this.configurationProperties[S]=a[S];!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),s.push(S)}let l=c.allOf;if(l)for(let S of l)s.push(...this.validateAndRegisterProperties(S,o,u,r,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=u=>{let r=u.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let i=u.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,u={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const u=this.configurationDefaultsOverrides.get(c);let r=u?.value,i=u?.source;R.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),R.isUndefined(r)&&(r=g(o.type)),o.default=r,o.defaultValueSource=i}}const I="\\[([^\\]]+)\\]",p=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(f){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=p.exec(f);for(;o?.length;){const u=o[1].trim();u&&c.push(u),o=p.exec(f)}}return(0,w.distinct)(c)}e.overrideIdentifiersFromKey=t;function h(f){return f.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=h;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const v=new k;b.Registry.add(e.Extensions.Configuration,v);function P(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?C.localize(7,null,f):v.getConfigurationProperties()[f]!==void 0?C.localize(8,null,f):null:C.localize(6,null)}e.validateProperty=P;function d(){const f=[],c=v.getConfigurationProperties();for(const o of Object.keys(c))f.push([o,c[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=d}),define(J[197],Z([0,1,30,4,44,2,35,49,14,7,19,55,40]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,E.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=b.deepClone(this.contents),s=b.deepClone(this.overrides),a=[...this.keys];for(const l of r){this.mergeContents(i,l.contents);for(const S of l.overrides){const[D]=s.filter(L=>w.equals(L.identifiers,S.identifiers));D?(this.mergeContents(D.contents,S.contents),D.keys.push(...S.keys),D.keys=w.distinct(D.keys)):s.push(b.deepClone(S))}for(const S of l.keys)a.indexOf(S)===-1&&a.push(S)}return new p(i,a,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const a of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],S=i[a];S&&(typeof l=="object"&&typeof S=="object"?(l=b.deepClone(l),this.mergeContents(l,S)):l=S),s[a]=l}return new p(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&m.isObject(r[s])&&m.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=b.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const a=l=>{l&&(s?this.mergeContents(s,l):s=b.deepClone(l))};for(const l of this.overrides)w.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&a(l.contents);return a(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,E.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(r={}){const i=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),a=Object.create(null),l=[];for(const S in i){const D=r[S],L=D!==void 0?D:i[S].default;(0,E.addToValueTree)(a,S,L,W=>console.error(`Conflict in default settings: ${W}`))}for(const S of Object.keys(a))k.OVERRIDE_PROPERTY_REGEX.test(S)&&l.push({identifiers:(0,k.overrideIdentifiersFromKey)(S),keys:Object.keys(a[S]),contents:(0,E.toValuesTree)(a[S],D=>console.error(`Conflict in default settings file: ${D}`))});super(a,s,l)}}e.DefaultConfigurationModel=t;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!m.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:a,overrides:l,restricted:S}=this.doParseRaw(r,i);this._configurationModel=new p(s,a,l),this._restrictedConfigurations=S||[]}doParseContent(r){let i={},s=null,a=[],l=[],S=[];function D(W){Array.isArray(a)?a.push(W):s!==null&&(a[s]=W)}let L={onObjectBegin:()=>{let W={};D(W),l.push(a),a=W,s=null},onObjectProperty:W=>{s=W},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let W=[];D(W),l.push(a),a=W,s=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:D,onError:(W,U,j)=>{S.push({error:W,offset:U,length:j})}};if(r)try{R.visit(r,L),i=a[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(r,i){const s=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(r,s,!0,i);r=a.raw;const l=(0,E.toValuesTree)(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),S=Object.keys(r),D=this.toOverrides(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:l,keys:S,overrides:D,restricted:a.restricted}}filter(r,i,s,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[]};const l={},S=[];for(let D in r)if(k.OVERRIDE_PROPERTY_REGEX.test(D)&&s){const L=this.filter(r[D],i,!1,a);l[D]=L.raw,S.push(...L.restricted)}else{const L=i[D],W=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&S.push(D),(W===void 0||a.scopes===void 0||a.scopes.includes(W))&&(a.skipRestricted&&L?.restricted||(l[D]=r[D]))}return{raw:l,restricted:S}}toOverrides(r,i){const s=[];for(const a of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const l={};for(const S in r[a])l[S]=r[a][S];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,i)})}return s}}e.ConfigurationModelParser=h;class g extends C.Disposable{constructor(r,i,s,a){super();this.userSettingsResource=r,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(r,i,s=new p,a=new p,l=new M.ResourceMap,S=new p,D=new M.ResourceMap,L=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=S,this._memoryConfigurationByResource=D,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new p,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(r):a.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const a=this.getConsolidateConfigurationModel(i,s),l=this.getFolderConfigurationModelForResource(i.resource,s),S=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,D=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),j=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ee=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(r):l.freeze().getValue(r):void 0,x=i.overrideIdentifier?S.override(i.overrideIdentifier).getValue(r):S.getValue(r),N=a.getValue(r),G=w.distinct(w.flatten(a.overrides.map(z=>z.identifiers))).filter(z=>a.getOverrideValue(r,z)!==void 0);return{defaultValue:D,userValue:L,userLocalValue:W,userRemoteValue:U,workspaceValue:j,workspaceFolderValue:ee,memoryValue:x,value:N,default:D!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:l?.freeze().getValue(r),override:i.overrideIdentifier?l?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:S.getValue(r),override:i.overrideIdentifier?S.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:a,updated:l,removed:S}=c(this._defaultConfiguration,r);i=[...a,...l,...S]}for(const a of i)for(const l of(0,k.overrideIdentifiersFromKey)(a)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(l),D=r.getKeysForOverrideIdentifier(l),L=[...D.filter(W=>S.indexOf(W)===-1),...S.filter(W=>D.indexOf(W)===-1),...S.filter(W=>!b.equals(this._defaultConfiguration.override(l).getValue(W),r.override(l).getValue(W)))];s.push([l,L])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:a,overrides:l}=c(this.localUserConfiguration,r),S=[...i,...s,...a];return S.length&&this.updateLocalUserConfiguration(r),{keys:S,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:a,overrides:l}=c(this.remoteUserConfiguration,r);let S=[...i,...s,...a];return S.length&&this.updateRemoteUserConfiguration(r),{keys:S,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:a,overrides:l}=c(this.workspaceConfiguration,r);let S=[...i,...s,...a];return S.length&&this.updateWorkspaceConfiguration(r),{keys:S,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:a,updated:l,removed:S,overrides:D}=c(s,i);let L=[...a,...l,...S];return(L.length||!s)&&this.updateFolderConfiguration(r,i),{keys:L,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:a,removed:l,overrides:S}=c(i,void 0);return{keys:[...s,...a,...l],overrides:S}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const a=i.getFolder(r);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const l=this._memoryConfigurationByResource.get(r);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(r);a?(i=s.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:a,keys:l}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:a,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((S,D)=>(S.set(y.URI.revive(D[0]),this.parseConfigurationModel(D[1])),S),new M.ResourceMap);return new v(i,s,new p,a,l,new p,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=v;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const a of u)a.keys.forEach(l=>r.add(l)),a.overrides.forEach(([l,S])=>{const D=(0,M.getOrSet)(i,l,new Set);S.forEach(L=>D.add(L))});const s=[];return i.forEach((a,l)=>s.push([l,[...a.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=P;class d{constructor(r,i,s,a){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(D=>l.add(D)),r.overrides.forEach(([,D])=>D.forEach(L=>l.add(L))),this.affectedKeys=[...l.values()];const S=new p;this.affectedKeys.forEach(D=>S.setValue(D,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!b.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,E.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(r=r[a],!r)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=d;class f extends d{constructor(r,i,s,a){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=f;function c(u,r){const{added:i,removed:s,updated:a}=o(r,u),l=[],S=u?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const L=D.filter(W=>!S.includes(W));for(const W of L)l.push([W,r.getKeysForOverrideIdentifier(W)])}if(u){const L=S.filter(W=>!D.includes(W));for(const W of L)l.push([W,u.getKeysForOverrideIdentifier(W)])}if(r&&u){for(const L of S)if(D.includes(L)){const W=o({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});l.push([L,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:s,updated:a,overrides:l}}function o(u,r){const i=u?r?u.keys.filter(l=>r.keys.indexOf(l)===-1):[...u.keys]:[],s=r?u?r.keys.filter(l=>u.keys.indexOf(l)===-1):[...r.keys]:[],a=[];if(u&&r){for(const l of r.keys)if(u.keys.indexOf(l)!==-1){const S=(0,E.getConfigurationValue)(r.contents,l),D=(0,E.getConfigurationValue)(u.contents,l);b.equals(S,D)||a.push(l)}}return{added:i,removed:s,updated:a}}}),define(J[198],Z([0,1,9,4,2,16,19,197,55,40]),function(q,e,w,n,R,C,M,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends R.Disposable{constructor(I,p){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,p)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,p){const t=typeof I=="string"?I:void 0,h=(0,M.isConfigurationOverrides)(I)?I:(0,M.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,h,void 0)}updateValue(I,p,t,h){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(t,p,1)}onDidDefaultConfigurationChange(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,I);this.trigger(t,p,6)}trigger(I,p,t){const h=new b.ConfigurationChangeEvent(I,{data:p},this.configuration);h.source=t,h.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(J[199],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(M,b=n.Unknown,m){super(M);this._message=M,this._code=b,this._detail=m,this.isHandled=b===n.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(M){return M instanceof R&&M._code===n.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof R&&M._code===n.NoResolverFound}static isHandled(M){return M instanceof R&&M.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[200],Z([0,1,9,17,23,15,4,2,31,88,199]),function(q,e,w,n,R,C,M,b,m,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var I;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function p($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t($){const F=new R.CancellationTokenSource;return setTimeout(()=>F.cancel(),$),F.token}function h($,F){if($.isCancellationRequested||F.isCancellationRequested)return R.CancellationToken.Cancelled;const B=new R.CancellationTokenSource;return $.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class g{constructor(F){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((B,T)=>{this._resolvePromise=B,this._rejectPromise=T}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function v($,F){const B=new g(F);return B.registerDisposable($.onControlMessage(T=>{const A=JSON.parse(T.toString()),O=X(A);O?B.reject(O):B.resolve(A)})),B.promise}function P($,F,B,T,A,O,_){const Y=new g(_);return F.connect(B,T,A,O,(ie,ae)=>{Y.didTimeout?(ie&&$.error(ie),ae?.dispose()):ie||!ae?Y.reject(ie):Y.resolve(ae)}),Y.promise}function d($,F){const B=new g(F);return $.then(T=>{B.didTimeout||B.resolve(T)},T=>{B.didTimeout||B.reject(T)}),B.promise}async function f($,F,B,T){const A=H($,F);$.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await P($.logService,$.socketFactory,$.host,$.port,`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,`renderer-${p(F)}-${$.reconnectionToken}`,T)}catch(ce){throw $.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),$.logService.error(ce),ce}$.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let _,Y;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(O,null),_=$.reconnectionProtocol,Y=!1):(_=new y.PersistentProtocol(O,null),Y=!0),$.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ie=await d($.signService.createNewMessage((0,m.generateUuid)()),T),ae={type:"auth",auth:$.connectionToken||"00000000000000000000",data:ie.data};_.sendControl(n.VSBuffer.fromString(JSON.stringify(ae)));try{const ce=await v(_,h(T,t(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if($.logService.trace(`${A} 4/6. received SignRequest control message.`),!await d($.signService.validate(ie,ce.signedData),T)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const le=await d($.signService.sign(ce.data),T),he={type:"connectionType",commit:$.commit,signedData:le,desiredConnectionType:F};return B&&(he.args=B),$.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:_,ownsProtocol:Y}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&($.logService.error(`${A} the handshake timed out. Error:`),$.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${A} received error control message when negotiating connection. Error:`),$.logService.error(ce)),Y&&z(_),ce}}async function c($,F,B,T){const A=Date.now(),O=H($,F),{protocol:_,ownsProtocol:Y}=await f($,F,B,T),ie=new g(T);return ie.registerDisposable(_.onControlMessage(ae=>{const ce=JSON.parse(ae.toString()),ne=X(ce);ne?($.logService.error(`${O} received error control message when negotiating connection. Error:`),$.logService.error(ne),Y&&z(_),ie.reject(ne)):($.reconnectionProtocol&&$.reconnectionProtocol.endAcceptReconnection(),$.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${K(A)}!`),ie.resolve({protocol:_,firstMessage:ce}))})),ie.promise}async function o($,F){const{protocol:B}=await c($,1,void 0,F);return{protocol:B}}async function u($,F,B){const{protocol:T,firstMessage:A}=await c($,2,F,B),O=A&&A.debugPort;return{protocol:T,debugPort:O}}async function r($,F,B){const T=Date.now(),A=H($,3),{protocol:O}=await f($,3,F,B);return $.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${K(T)}!`),O}async function i($,F,B){const{host:T,port:A,connectionToken:O}=await $.addressProvider.getAddress();return{commit:$.commit,host:T,port:A,connectionToken:O,reconnectionToken:F,reconnectionProtocol:B,socketFactory:$.socketFactory,signService:$.signService,logService:$.logService}}async function s($,F,B){try{const T=(0,m.generateUuid)(),A=await i($,T,null),{protocol:O}=await o(A,R.CancellationToken.None);return new N($,F,B,T,O)}catch(T){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(T),x.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentManagement=s;async function a($,F){try{const B=(0,m.generateUuid)(),T=await i($,B,null),{protocol:A,debugPort:O}=await u(T,F,R.CancellationToken.None);return new G($,F,B,A,O)}catch(B){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(B),x.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=a;async function l($,F,B){const T=await i($,(0,m.generateUuid)(),null);return await r(T,{host:F,port:B},R.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function S($){return(0,w.createCancelablePromise)(F=>new Promise((B,T)=>{const A=setTimeout(B,$*1e3);F.onCancellationRequested(()=>{clearTimeout(A),B()})}))}var D;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(D=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=L;class W{constructor(F,B,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=T,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class U{constructor(F,B,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=U;class j{constructor(F,B,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=T,this.type=4}}e.ConnectionGainEvent=j;class ee{constructor(F,B,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=T,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class x extends b.Disposable{constructor(F,B,T,A){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=T,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new j(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const _=V(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),x._instances.push(this),x._permanentFailure&&this._gotoPermanentFailure(x._permanentFailureMillisSinceLastIncomingData,x._permanentFailureAttempt,x._permanentFailureHandled)}static triggerPermanentFailure(F,B,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=T,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(x._permanentFailure)return;const F=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const A=T<B.length?B[T]:B[B.length-1];try{if(A>0){const _=S(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,_)),this._options.logService.info(`${F} waiting for ${A} seconds before reconnecting...`);try{await _}catch{}}if(x._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${F} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(k)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,C.isCancellationError)(O)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,E.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!x._permanentFailure)}_gotoPermanentFailure(F,B,T){this._onDidStateChange.fire(new ee(this.reconnectionToken,F,B,T)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=x,x._permanentFailure=!1,x._permanentFailureMillisSinceLastIncomingData=0,x._permanentFailureAttempt=0,x._permanentFailureHandled=!1,x._instances=[];class N extends x{constructor(F,B,T,A,O){super(1,F,A,O);this.client=this._register(new y.Client(O,{remoteAuthority:B,clientId:T},F.ipcLogger))}async _reconnect(F,B){await o(F,B)}}e.ManagementPersistentConnection=N;class G extends x{constructor(F,B,T,A,O){super(2,F,T,A);this._startArguments=B,this.debugPort=O}async _reconnect(F,B){await u(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=G;function z($){try{$.acceptDisconnect();const F=$.getSocket();$.dispose(),F.dispose()}catch(F){(0,C.onUnexpectedError)(F)}}function X($){if($&&$.type==="error"){const F=new Error(`Connection error: ${$.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function re($,F){for(;$.length<F;)$+=" ";return $}function V($,F,B){return`[remote-connection][${re(p($),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function H($,F){return`${V(F,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.host}:${$.port}]`}function K($){return`${Date.now()-$} ms`}}),define(J[79],Z([0,1,10]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(C){return C.scheme===w.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=n;function R(C){if(!C)return;const M=C.indexOf("+");return M<0?C:C.substr(0,M)}e.getRemoteName=R}),define(J[56],Z([0,1,17,152,55,5,40]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function b(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=b;function m(t){return t.res.statusCode===204}async function y(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);return m(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=y;async function E(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);if(m(t))return null;const g=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(g)}catch(v){throw v.message+=`:
`+g,v}}e.asJson=E;function k(t){p(t)}e.updateProxyConfigurationsScope=k;let I;function p(t){const h=M.Registry.as(R.Extensions.Configuration),g=I;I={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[I],remove:g?[g]:[]})}p(2)}),define(J[201],Z([0,1,202,14]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(M,b){return M.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:M.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function C(M,b,m={}){const y=(0,w.parse)(M),E=m.proxyUrl||R(y,b);if(!E)return null;const k=(0,w.parse)(E);if(!/^https?:$/.test(k.protocol||""))return null;const I={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,n.isBoolean)(m.strictSSL)?m.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,t)=>{q(["http-proxy-agent"],p,t)}))(I):new(await new Promise((p,t)=>{q(["https-proxy-agent"],p,t)}))(I)}e.getProxyAgent=C}),define(J[80],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[203],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((R,C)=>q(["vsda"],R,C))}async createNewMessage(R){try{const C=await this.vsda(),M=new C.validator;if(M){const b=String(w._nextId++);return this.validators.set(b,M),{id:b,data:M.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,C){if(!R.id)return!0;const M=this.validators.get(R.id);if(!M)return!1;this.validators.delete(R.id);try{return M.validate(C)==="ok"}catch{return!1}}async sign(R){try{const C=await this.vsda(),M=new C.signer;if(M)return M.sign(R)}catch{}return R}}e.SignService=w,w._nextId=1}),define(J[38],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[18],Z([0,1,12,9,4,2,3,36,14,5,184,6,38]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var p;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class wt extends C.Disposable{constructor(g,v){super();this.logService=g,this.stateMainService=v,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new R.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(wt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(wt.QUIT_AND_RESTART_KEY)}registerListeners(){const g=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),M.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};w.app.addListener("before-quit",g);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!M.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",v),w.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",g),w.app.removeListener("window-all-closed",v),w.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const g=[];return this._onWillShutdown.fire({join(v){g.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(g)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===g)return;this.logService.trace(`lifecycle (main): phase changed (value: ${g})`),this._phase=g;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(g){if(g<=this._phase)return;let v=this.phaseWhen.get(g);v||(v=new n.Barrier,this.phaseWhen.set(g,v)),await v.wait()}registerWindow(g){const v=new C.DisposableStore;this.windowCounter++,v.add(g.onWillLoad(d=>this._onWillLoadWindow.fire({window:g,workspace:d.workspace,reason:d.reason})));const P=(0,m.assertIsDefined)(g.win);P.on("close",d=>{const f=g.id;if(this.windowToCloseRequest.has(f)){this.windowToCloseRequest.delete(f);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${g.id}`),d.preventDefault(),this.unload(g,1).then(c=>{if(c){this.windowToCloseRequest.delete(f);return}this.windowToCloseRequest.add(f),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${f}`),this._onBeforeCloseWindow.fire(g),g.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!M.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(g,v){await this.unload(g,3)||g.reload(v)}async unload(g,v){if(!g.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${g.id}`);const P=this._quitRequested?2:v;let d=await this.onBeforeUnloadWindowInRenderer(g,P);return d?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.handleWindowUnloadVeto(d)):(d=await this.onBeforeUnloadWindowInMain(g,P),d?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${g.id})`),this.handleWindowUnloadVeto(d)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${g.id})`),await this.onWillUnloadWindowInRenderer(g,P),!1))}handleWindowUnloadVeto(g){return g?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(g){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(g),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(g,v){return new Promise(P=>{const d=this.oneTimeListenerTokenGenerator++,f=`vscode:ok${d}`,c=`vscode:cancel${d}`;w.ipcMain.once(f,()=>{P(!1)}),w.ipcMain.once(c,()=>{P(!0)}),g.send("vscode:onBeforeUnload",{okChannel:f,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(g,v){const P=[];return this._onBeforeUnloadWindow.fire({reason:v,window:g,veto(d){P.push(d)}}),(0,E.handleVetos)(P,d=>this.logService.error(d))}onWillUnloadWindowInRenderer(g,v){return new Promise(P=>{const f=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(f,()=>P()),g.send("vscode:onWillUnload",{replyChannel:f,reason:v})})}quit(g){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${g}`),g&&this.stateMainService.setItem(wt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(g){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(g?.addArgs&&v.push(...g.addArgs),g?.removeArgs)for(const f of g.removeArgs){const c=v.indexOf(f);c>=0&&v.splice(c,1)}const P=()=>{try{if(M.isWindows){const f=(0,b.cwd)();f!==process.cwd()&&process.chdir(f)}}catch(f){this.logService.error(f)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:v})};w.app.once("quit",P),await this.quit(!0)&&w.app.removeListener("quit",P)}async kill(g){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of w.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let P;v.webContents&&!v.webContents.isDestroyed()?P=new Promise(d=>v.once("closed",d)):P=Promise.resolve(),v.destroy(),await P}})()]),w.app.exit(g)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([te(0,k.ILogService),te(1,I.IStateMainService)],t),e.LifecycleMainService=t}),define(J[204],Z([0,1,4,2,5,18]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let M=class extends n.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((E,k)=>{q(["native-keymap"],E,k)});this._keyboardLayoutData=b(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([te(0,C.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function b(m){const y=m.getKeyMap(),E=m.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:E}}}),define(J[97],Z([0,1,9,4,2,63,14,90,5]),function(q,e,w,n,R,C,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var E;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class p extends R.Disposable{constructor(v={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,P){P===y?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:P,target:this.getKeyTargets(v)[P]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,P,d){return this.getStorage(P)?.get(v,d)}getBoolean(v,P,d){return this.getStorage(P)?.getBoolean(v,d)}getNumber(v,P,d){return this.getStorage(P)?.getNumber(v,d)}store(v,P,d,f){if((0,M.isUndefinedOrNull)(P)){this.remove(v,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,d,f),this.getStorage(d)?.set(v,P)})}remove(v,P){this.withPausedEmitters(()=>{this.updateKeyTarget(v,P,void 0),this.getStorage(P)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,P){const d=[],f=this.getKeyTargets(v);for(const c of Object.keys(f))f[c]===P&&d.push(c);return d}updateKeyTarget(v,P,d){const f=this.getKeyTargets(P);typeof d=="number"?f[v]!==d&&(f[v]=d,this.getStorage(P)?.set(y,JSON.stringify(f))):typeof f[v]=="number"&&(delete f[v],this.getStorage(P)?.set(y,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const P=this.get(y,v);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=E.NONE){this._onWillSaveState.fire({reason:v});const P=this.getStorage(0),d=this.getStorage(1);switch(v){case E.NONE:await w.Promises.settled([P?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await w.Promises.settled([P?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return h(v,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function h(g,v,P,d){const f=a=>{try{return JSON.parse(a)}catch{return a}},c=new Map,o=new Map;g.forEach((a,l)=>{c.set(l,a),o.set(l,f(a))});const u=new Map,r=new Map;v.forEach((a,l)=>{u.set(l,a),r.set(l,f(a))}),console.group(`Storage: Global (path: ${P})`);let i=[];c.forEach((a,l)=>{i.push({key:l,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${d})`);let s=[];u.forEach((a,l)=>{s.push({key:l,value:a})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(J[205],Z([0,1,3,36,7,31]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(y){if(w.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function b(y,E,k,I,p,t,h,g,v,P){const d=Object.create(null);d["common.machineId"]=h,d.sessionID=(0,C.generateUuid)()+Date.now(),d.commitHash=p,d.version=t,d["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,w.PlatformToString)(w.platform),d["common.nodePlatform"]=n.platform,d["common.nodeArch"]=I,d["common.product"]=P||"desktop";const f=m(g||[]);f&&(d["common.msftInternal"]=f);let c=0;const o=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(d["common.snap"]="true");const u=M(k);u&&(d["common.platformDetail"]=u);try{const r=await y.readFile(R.URI.file(v));d["common.source"]=r.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=b;function m(y){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const k=E.toLowerCase();return y.some(I=>k===I)}e.verifyMicrosoftInternalDomain=m}),define(J[32],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[206],Z([0,1,26,69,9,44,10,8,3,7,72,24,87,76,20,21,32]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(o,u){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,s=new Map,a=2e4;function l(L,W,U,j){const ee=W.substring(L.length+1);return R.Promises.withAsyncBody(async x=>{let N;try{N=await k.Promises.readdir(W,{withFileTypes:!0})}catch{x();return}if(j.count>=a){j.count+=N.length,j.maxReached=!0,x();return}let G=N.length;if(G===0){x();return}let z=N;j.count+N.length>a&&(j.maxReached=!0,G=a-j.count,z=N.slice(0,G)),j.count+=N.length;for(const X of z)if(X.isDirectory()){if(U.includes(X.name)||await l(L,(0,b.join)(W,X.name),U,j),--G==0){x();return}}else{const re=X.name.lastIndexOf(".");if(re>=0){const V=X.name.substring(re+1);V&&i.set(V,(i.get(V)??0)+1)}for(const V of r)V.relativePathPattern?.test(ee)!==!1&&V.filePattern.test(X.name)&&s.set(V.tag,(s.get(V.tag)??0)+1);if(--G==0){x();return}}})}const S={count:0,maxReached:!1};await l(o,o,u,S);const D=await f(o);return{configFiles:P(s),fileTypes:P(i),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=v;function P(o){return[...n.Iterable.map(o.entries(),([u,r])=>({name:u,count:r}))].sort((u,r)=>r.count-u.count)}function d(){const o={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},u=w.cpus();return u&&u.length>0&&(o.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),o}e.getMachineInfo=d;async function f(o){try{const u=new Map,r=(0,b.join)(o,".vscode","launch.json"),i=await k.Promises.readFile(r),s=[],a=(0,C.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const S=l.type;S&&(u.has(S)?u.set(S,u.get(S)+1):u.set(S,1))}return P(u)}catch{return[]}}e.collectLaunchConfigs=f;let c=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),m.isWindows||r.push(`Load (avg):       ${w.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,I.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[s,a]=i,l=this.formatProcessList(u,s);return r.forEach(S=>{if((0,p.isRemoteDiagnosticError)(S))l+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if(l+=`

Remote: ${S.hostName}`,S.processes&&(l+=`
${this.formatProcessList(u,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const L=S.workspaceMetadata[D];let W=`${L.fileCount} files`;L.maxFilesReached&&(W=`more than ${W}`),a+=`|    Folder (${D}): ${W}`,a+=this.formatWorkspaceStats(L)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(u,r){const{memory:i,vmHint:s,os:a,cpus:l}=d(),S={os:a,memory:i,cpus:l,vmHint:s,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return m.isWindows||(S.load=`${w.loadavg().map(D=>Math.round(D)).join(", ")}`),m.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(u,r){const i=[];return(0,I.listProcesses)(u.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,s)),u.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),r.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(u,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[l];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${l}): ${D}`),i.push(this.formatWorkspaceStats(S))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const r=[],i=60;let s=0;const a=(L,W)=>{const U=` ${L}(${W})`;s+U.length>i?(r.push(l),l="|                 ",s=l.length):s+=U.length,l+=U};let l="|      File types:";const S=10;let D=u.fileTypes.length>S?S:u.fileTypes.length;for(let L=0;L<D;L++){const W=u.fileTypes[L];a(W.name,W.count)}if(r.push(l),u.configFiles.length>=0&&(l="|      Conf files:",s=0,u.configFiles.forEach(L=>{a(L.name,L.count)}),r.push(l)),u.launchConfigFiles.length>0){let L="|      Launch Configs:";u.launchConfigFiles.forEach(W=>{L+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),r.push(L)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],i=[];return u.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const l=y.URI.revive(a);if(l.scheme===M.Schemas.file){const S=l.fsPath;i.push(v(S,["node_modules",".git"]).then(D=>{let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${(0,b.basename)(S)}): ${L}`),r.push(this.formatWorkspaceStats(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else r.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(u,r){const i=new Map;u.windows.forEach(a=>i.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(u,r,i,s,a){const l=a===0;let S;l?S=s.pid===u?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(S=`${S} (${r.get(s.pid)})`));const D=process.platform==="win32"?s.mem:w.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(L=>this.formatProcessItem(u,r,i,L,a+1))}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=y.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const s=i.fsPath;try{const a=await v(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};c=ue([te(0,g.ITelemetryService),te(1,h.IProductService)],c),e.DiagnosticsService=c}),define(J[207],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(C){this.appenders=C}listen(C,M){throw new Error(`Event not found: ${M}`)}call(C,M,{eventName:b,data:m}){return this.appenders.forEach(y=>y.log(b,m)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class n{constructor(C){this.channel=C}log(C,M){return this.channel.call("log",{eventName:C,data:M}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(J[64],Z([0,1,49,14,19,32]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,P){return Promise.resolve(void 0)}publicLog2(v,P){return this.publicLog(v,P)}publicLogError(v,P){return Promise.resolve(void 0)}publicLogError2(v,P){return this.publicLogError(v,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class b{async publicLog(v,P,d){}async publicLogError(v,P,d){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(g,v){return v.onDidChangeConfiguration(P=>{P.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=m;function y(g,v){return!(v.disableTelemetry||!g.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=y;function E(g){const v=g.getValue(C.TELEMETRY_SETTING_ID),P=g.getValue("telemetry.enableCrashReporter");if(g.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function k(g){const v=Object.create(null),P=Object.create(null),d=Object.create(null);p(g,d);for(let f in d){f=f.length>150?f.substr(f.length-149):f;const c=d[f];typeof c=="number"?P[f]=c:typeof c=="boolean"?P[f]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${c.length}`),v[f]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[f]=c)}return{properties:v,measurements:P}}e.validateTelemetryData=k;function I(g){if(!g)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{g.indexOf(`${d}+`)===0&&(v=d)}),v}e.cleanRemoteAuthority=I;function p(g,v,P=0,d){if(!!g)for(let f of Object.getOwnPropertyNames(g)){const c=g[f],o=d?d+f:f;Array.isArray(c)?v[o]=(0,w.safeStringify)(c):c instanceof Date?v[o]=c.toISOString():(0,n.isObject)(c)?P<2?p(c,v,P+1,o+"."):v[o]=(0,w.safeStringify)(c):v[o]=c}}function t(g){if(!g)return[];const v=[];return h(v,"",g),v}function h(g,v,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(d=>h(g,v?`${v}.${d}`:d,P[d])):g.push(v)}}),define(J[208],Z([0,1,170,64]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(C,M,b,m,y,E){const k={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${M.nameShort})`},I=await(0,w.getServiceMachineId)(b,y,E);return(0,n.supportsTelemetry)(M,b)&&(0,n.getTelemetryLevel)(m)===3&&(k["X-Market-User-Id"]=I),k}e.resolveMarketplaceHeaders=R}),define(J[209],Z([0,1,2,49,3,27,153,19,55,53,40,32,64]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(g,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,v){this._experimentProperties[g]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,I.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let v=g.sessionID,P=g["common.machineId"],d=g["common.firstSessionDate"],f=g["common.msftInternal"];return{sessionId:v,machineId:P,firstSessionDate:d,msftInternal:f}}dispose(){this._disposables.dispose()}_log(g,v,P,d){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(f=>{P=(0,n.mixin)(P,f),P=(0,n.mixin)(P,this._experimentProperties),P=(0,n.cloneAndChange)(P,c=>{if(typeof c=="string")return this._cleanupInfo(c,d)}),this._appenders.forEach(c=>c.log(g,P))},f=>{console.error(f)})}publicLog(g,v,P){return this._log(g,3,v,P)}publicLog2(g,v,P){return this.publicLog(g,v,P)}publicLogError(g,v){return this.sendErrorTelemetry?this._log(g,2,v,!0):Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}_anonymizeFilePaths(g){let v=g;const P=[];for(let o of this._cleanupPatterns)for(;;){const u=o.exec(g);if(!u)break;P.push([u.index,o.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const o=f.exec(g);if(!o)break;!d.test(o[0])&&P.every(([u,r])=>o.index<u||o.index>=r)&&(v+=g.substring(c,o.index)+"<REDACTED: user-file-path>",c=f.lastIndex)}return c<g.length&&(v+=g.substr(c)),v}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const v=g.toLowerCase(),P=/@[a-zA-Z0-9-.]+/,d=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,f=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return d.test(v)?"<REDACTED: secret>":P.test(v)?"<REDACTED: email>":f.test(v)?"<REDACTED: token>":g}_cleanupInfo(g,v){let P=g;v&&(P=this._anonymizeFilePaths(P));for(let d of this._cleanupPatterns)P=P.replace(d,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([te(1,b.IConfigurationService)],p),e.TelemetryService=p;function t(){const h=(0,M.localize)(0,null,y.default.nameLong),g=y.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=R.isWeb?"":(0,M.localize)(3,null),P=(0,M.localize)(4,null),d=(0,M.localize)(5,null),f=(0,M.localize)(6,null),c=(0,M.localize)(7,null),o=`
|       | ${P} | ${d} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,M.localize)(8,null);return`
${h} ${g} ${v}

&nbsp;

${c}
${o}

&nbsp;

${u}
`}E.Registry.as(m.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[k.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(m.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[k.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,M.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,M.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${k.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[98],Z([0,1,45,8,154,23,39,15,3,31,136,50,9]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let t;async function h(v,P,d){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(d)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(d)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=I.Promises.withAsyncBody(async(f,c)=>{const o=new C.CancellationTokenSource,u=setTimeout(()=>{o.dispose(!0),c(new Error((0,R.localize)(0,null)))},p);try{f(await g(v,o.token))}catch(r){!(0,b.isCancellationError)(r)&&!o.token.isCancellationRequested?c(new Error((0,R.localize)(1,null,(0,M.toErrorMessage)(r)))):f({})}finally{clearTimeout(u),o.dispose()}})),t)}e.getResolvedShellEnv=h;async function g(v,P){const d=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",d);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",f);const c=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",u);const r=await(0,E.getSystemShell)(m.OS,u);return v.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(P.isCancellationRequested)return s((0,b.canceled)());const a=(0,n.basename)(r);let l,S;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,S=["-Login","-Command"]):(l=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?S=["-ic"]:S=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),l);const L=(0,w.spawn)(r,[...S,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});P.onCancellationRequested(()=>(L.kill(),s((0,b.canceled)()))),L.on("error",j=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(j)),s(j)});const W=[];L.stdout.on("data",j=>W.push(j));const U=[];L.stderr.on("data",j=>U.push(j)),L.on("close",(j,ee)=>{const x=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",x);const N=Buffer.concat(U).toString("utf8");if(N.trim()&&v.trace("getUnixShellEnvironment#stderr",N),j||ee)return s(new Error((0,R.localize)(2,null,j,ee)));const G=o.exec(x),z=G?G[1]:"{}";try{const X=JSON.parse(z);d?X.ELECTRON_RUN_AS_NODE=d:delete X.ELECTRON_RUN_AS_NODE,f?X.ELECTRON_NO_ATTACH_CONSOLE=f:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",X),i(X)}catch(X){v.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(X)),s(X)}})})}}),define(J[210],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(J[211],Z([0,1,106,4,2,5,40,210]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var m;(function(g){function v(P){return P&&typeof P=="object"&&typeof P.id=="string"}g.isThemeColor=v})(m=e.ThemeColor||(e.ThemeColor={}));function y(g){return{id:g}}e.themeColorFromId=y;var E;(function(g){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||m.isThemeColor(i.color))}g.isThemeIcon=v;const P=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const s=P.exec(i);if(!s)return;let[,a]=s;return{id:a}}g.fromString=d;function f(i){return{id:i}}g.fromId=f;function c(i,s){let a=i.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),s&&(a=`${a}~${s}`),{id:a}}g.modify=c;function o(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}g.getModifier=o;function u(i,s){return i.id===s.id&&i.color?.id===s.color?.id}g.isEqual=u;function r(i,s){return{id:i.id,color:s?y(s):void 0}}g.asThemeIcon=r,g.asClassNameArray=w.CSSIcon.asClassNameArray,g.asClassName=w.CSSIcon.asClassName,g.asCSSSelector=w.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function k(g){switch(g){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(v);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new I;M.Registry.add(e.Extensions.ThemingContribution,p);function t(g){return p.onColorThemeChange(g)}e.registerThemingParticipant=t;class h extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,P){let d=this.theme.getColor(v);return d&&P&&(d=P(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(J[65],Z([0,1,12,3,5,38]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",b="#1E1E1E",m="#000000",y="theme",E="themeBackground",k="windowSplash";e.IThemeMainService=(0,R.createDecorator)("themeMainService");let I=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return m;let t=this.stateMainService.getItem(E,null);if(!t){let h;(n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],t=h==="hc-black"?m:h==="vs"?M:b}return n.isMacintosh&&t.toUpperCase()===b&&(t="#171717"),t}saveWindowSplash(t,h){this.stateMainService.setItems([{key:y,data:h.baseTheme},{key:E,data:h.colorInfo.background},{key:k,data:h}]),typeof t=="number"&&this.updateBackgroundColor(t,h)}updateBackgroundColor(t,h){for(const g of w.BrowserWindow.getAllWindows())if(g.id===t){g.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(k)}};I=ue([te(0,C.IStateMainService)],I),e.ThemeMainService=I}),define(J[99],Z([0,1,4,3,5,6]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var M;(function(t){t.Http="http",t.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=k;function I(t,h){return h?h!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=I;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],g=Array.from(this._tunnels.values());for(let v of g){const P=Array.from(v.values());for(let d of P){const f=await d.value;f&&h.push(f)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,v,P,d=!1,f=b.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${P}.`),!h)return;g||(g="localhost");const o=this.retainOrCreateTunnel(h,g,v,P,d,f,c);return o?o.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(u);return(u.tunnelRemoteHost!==g||u.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const v=g.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const P=v.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),P}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const v=this._tunnels.get(h);if(v&&v.has(g)){const P=v.get(g);P.refcount=0,await this.tryDisposeTunnel(h,g,P)}}addTunnelToMap(h,g,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,g){const v=this._tunnels.get(h);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let v=[h];E(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const P=v.map(d=>this._tunnels.get(d));for(const d of P){const f=d?.get(g);if(f)return f}}canTunnel(h){return!!y(h)}createWithProvider(h,g,v,P,d,f,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${P}.`);const u={elevationRequired:d?I(P===void 0?v:P):!1},r={remoteAddress:{host:g,port:v},localAddressPort:P,privacy:f,public:f!==b.Private,protocol:c},i=h.forwardPort(r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(g,v,i),i}};p=ue([te(0,C.ILogService)],p),e.AbstractTunnelService=p}),define(J[41],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var R;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,M)=>({type:"idle",updateType:C,error:M}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[212],Z([0,1,3,155,55,40]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[213],Z([0,1,4,41]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(b){this.service=b}listen(b,m){switch(m){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${m}`)}call(b,m,y){switch(m){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${m}`)}}e.UpdateChannel=R;class C{constructor(b){this.channel=b,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(m=>this.state=m),this.channel.call("_getInitialState").then(m=>this.state=m)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(J[100],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[214],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(b){this.handler=b}listen(b,m){throw new Error(`Event not found: ${m}`)}call(b,m,y){switch(m){case"handleURL":return this.handler.handleURL(w.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${m}`)}}e.URLHandlerChannel=n;class R{constructor(b){this.channel=b}handleURL(b,m){return this.channel.call("handleURL",[b.toJSON(),m])}}e.URLHandlerChannelClient=R;class C{constructor(b){this.next=b}async routeCall(b,m,y,E){if(m!=="handleURL")throw new Error(`Call not found: ${m}`);if(y){const k=w.URI.revive(y);if(k&&k.query){const I=/\bwindowId=(\d+)/.exec(k.query);if(I){const p=I[1],t=new RegExp(`window:${p}`),h=b.connections.find(g=>t.test(g.ctx));if(h)return h}}}return this.next.routeCall(b,m,y,E)}routeEvent(b,m){throw new Error(`Event not found: ${m}`)}}e.URLHandlerRouter=C}),define(J[215],Z([0,1,9,2,7,21]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,E){const k=[...this.handlers.values()];return(0,w.first)(k.map(I=>()=>I.handleURL(y,E)),void 0,!1).then(I=>I||!1)}registerHandler(y){return this.handlers.add(y),(0,n.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let b=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:E,path:k,query:I,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&k&&k.indexOf("/")!==0&&(k=`/${k}`),R.URI.from({scheme:this.productService.urlProtocol,authority:E,path:k,query:I,fragment:p})}};b=ue([te(0,C.IProductService)],b),e.NativeURLService=b}),define(J[216],Z([0,1,12,9,4,2,3,7]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function m(E){try{return b.URI.parse(E)}catch{return null}}class y{constructor(k,I,p,t,h){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=k,M.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),w.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,P)}const g=R.Event.map(R.Event.fromNodeEventEmitter(w.app,"open-url",(P,d)=>({event:P,url:d})),({event:P,url:d})=>(P.preventDefault(),d));this.disposables.add(g(P=>{const d=m(P);!d||this.urlService.open(d,{originalUrl:P})})),p.getWindows().filter(P=>P.isReady).length>0?this.flush():R.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||k.push(I);k.length!==0&&(this.uris=k,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(J[217],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[218],Z([0,1,12,2,10,7]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends n.Disposable{constructor(){super();const m=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(R.Schemas.vscodeWebview,m)}handleWebviewRequest(m,y){try{const E=C.URI.parse(m.url),k=M.validWebviewFilePaths.get(E.path);if(typeof k=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${k}`,p=R.FileAccess.asFileUri(I,q);return y(decodeURIComponent(p.fsPath))}else return y({error:-10})}catch{}return y({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[66],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(y){return!!y.workspaceUri}e.isWorkspaceToOpen=n;function R(y){return!!y.folderUri}e.isFolderToOpen=R;function C(y){return!!y.fileUri}e.isFileToOpen=C;function M(y){const E=b(y),k=y.getValue("window.menuBarVisibility");return k==="default"||E==="native"&&k==="compact"||w.isMacintosh&&w.isNative?"classic":k}e.getMenuBarVisibility=M;function b(y){if(w.isWeb)return"custom";const E=y.getValue("window");if(E){if(w.isMacintosh&&E.nativeTabs===!0||w.isMacintosh&&E.nativeFullScreen===!1)return"native";const p=y.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=E.titleBarStyle;if(t==="native"||t==="custom")return t}return w.isLinux?"native":"custom"}e.getTitleBarStyle=b;function m(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=m}),define(J[34],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var R;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(R=e.UnloadReason||(e.UnloadReason={}));var C;(function(y){y[y.CLI=0]="CLI",y[y.DOCK=1]="DOCK",y[y.MENU=2]="MENU",y[y.DIALOG=3]="DIALOG",y[y.DESKTOP=4]="DESKTOP",y[y.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const M=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=M;var b;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var m;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(m=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(J[219],Z([0,1,12,23,4,70,2,31,75,92,6,21,34]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends M.Disposable{constructor(g,v,P,d,f){super();this.logService=g,this.windowsMainService=v,this.credentialsService=P,this.encryptionMainService=d,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const g=R.Event.fromNodeEventEmitter(w.app,"login",(v,P,d,f,c)=>({event:v,webContents:P,req:d,authInfo:f,callback:c}));this._register(g(this.onLogin,this))}async onLogin({event:g,authInfo:v,req:P,callback:d}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}g.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(f?.username,f?.password)}async resolveProxyCredentials(g){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(g);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(g){this.logService.trace("auth#doResolveProxyCredentials - enter",g);const v=String((0,C.hash)({scheme:g.scheme,host:g.host,port:g.port}));let P,d;try{const u=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(u){const r=JSON.parse(await this.encryptionMainService.decrypt(u));P=r.username,d=r.password}}catch(u){this.logService.error(u)}if(this.state!==p.StoredCredentialsUsed&&typeof P=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:P,password:d};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:g,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=p.LoginDialogShown;const o=await new Promise(u=>{const r=async(i,s,a)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",r),a){const l={username:a.username,password:a.password};try{if(a.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,S)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(S){this.logService.error(S)}u({username:l.username,password:l.password})}else u(void 0)};f.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=o,o}};t=ue([te(0,E.ILogService),te(1,I.IWindowsMainService),te(2,m.ICredentialsMainService),te(3,y.IEncryptionMainService),te(4,k.IProductService)],t),e.ProxyAuthHandler=t}),define(J[220],Z([0,1,12,4,2,218,34]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends R.Disposable{constructor(y){super();this.windowsMainService=y,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(y,E){let k;if(typeof y.windowId=="number"){const{windowId:I}=y,p=this.windowsMainService.getWindowById(I);if(!p?.win)throw new Error(`Invalid windowId: ${I}`);k=p.win.webContents}else{const{webContentsId:I}=y;if(k=w.webContents.fromId(I),!k)throw new Error(`Invalid webContentsId: ${I}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(E)}async findInFrame(y,E,k,I){const p=this.getFrameByName(y,E),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(k,{findNext:I.findNext,forward:I.forward});const h=(g,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),p.removeListener("found-in-frame",h))};p.on("found-in-frame",h)}}async stopFindInFrame(y,E,k){const p=this.getFrameByName(y,E);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(y,E){const k=this.windowsMainService.getWindowById(y.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${y}`);const I=k.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===E);if(!I)throw new Error(`Unknown frame: ${E}`);return I}};b=ue([te(0,M.IWindowsMainService)],b),e.WebviewMainService=b}),define(J[221],Z([0,1,9,4,2]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends R.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:m,getActiveWindowId:y}){super();this.disposables=this._register(new R.DisposableStore),n.Event.latch(n.Event.any(b,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>y()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(J[25],Z([0,1,158,8,35,16,7,5]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function m(c){const o=c;return typeof o?.id=="string"&&M.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=m;function y(c){if(c.configuration)return{id:c.id,configPath:c.configuration};if(c.folders.length===1)return{id:c.id,uri:c.folders[0].uri}}e.toWorkspaceIdentifier=y;function E(c){const o=c;return typeof o?.id=="string"&&M.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=E;function k(c){const o=c;if(o?.uri)return{id:o.id,uri:M.URI.revive(o.uri)};const u=c;if(u?.configPath)return{id:u.id,configPath:M.URI.revive(u.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=k;var I;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function p(c){const o=c;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=p;function t(c){const o=c;return!!(o&&typeof o=="object"&&M.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class h{constructor(o,u,r,i,s){this._id=o,this._transient=r,this._configuration=i,this._ignorePathCasing=s,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o.with({scheme:o.scheme,authority:o.authority,path:o.path}))||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,C.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function v(c){return new g({uri:c,index:0,name:(0,C.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const P=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(c,o){return C.extUriBiasedIgnorePathCase.isEqualOrParent(c,o.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function f(c){return(typeof c=="string"?(0,n.extname)(c):(0,C.extname)(c))===P}e.hasWorkspaceFileExtension=f}),define(J[47],Z([0,1,12,9,70,33,2,71,8,3,14,24,140,5,6,38,25]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let v=class St{constructor(d,f){this.stateMainService=d,this.logService=f,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(d,f){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},f)}pickFolder(d,f){return this.doPick({...d,pickFolders:!0,title:(0,I.localize)(1,null)},f)}pickFile(d,f){return this.doPick({...d,pickFiles:!0,title:(0,I.localize)(2,null)},f)}pickWorkspace(d,f){const c=(0,I.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,I.localize)(4,null)),u=g.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:c,filters:u,buttonLabel:o},f)}async doPick(d,f){const c={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters};c.defaultPath=d.defaultPath||this.stateMainService.getItem(St.workingDirPickerStorageKey),(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(c.properties=void 0,d.pickFiles&&d.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),y.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=f||w.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(c,(0,E.withNullAsUndefined)(o));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(St.workingDirPickerStorageKey,(0,m.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(d){if(d){let f=this.windowDialogQueues.get(d.id);return f||(f=new n.Queue,this.windowDialogQueues.set(d.id,f)),f}else return this.noWindowDialogueQueue}showMessageBox(d,f){return this.getWindowDialogQueue(f).queue(async()=>f?w.dialog.showMessageBox(f,d):w.dialog.showMessageBox(d))}async showSaveDialog(d,f){const c=this.acquireFileDialogLock(d,f);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await w.dialog.showSaveDialog(f,d):o=await w.dialog.showSaveDialog(d),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,M.dispose)(c)}}normalizePath(d){return d&&y.isMacintosh&&(d=(0,b.normalizeNFC)(d)),d}normalizePaths(d){return d.map(f=>this.normalizePath(f))}async showOpenDialog(d,f){d.defaultPath&&(await k.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const c=this.acquireFileDialogLock(d,f);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(f).queue(async()=>{let o;return f?o=await w.dialog.showOpenDialog(f,d):o=await w.dialog.showOpenDialog(d),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,M.dispose)(c)}}acquireFileDialogLock(d,f){if(!f)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let c=this.windowFileDialogLocks.get(f.id);c||(c=new Set,this.windowFileDialogLocks.set(f.id,c));const o=(0,R.hash)(d);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),c.add(o),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(f.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([te(0,h.IStateMainService),te(1,t.ILogService)],v),e.DialogMainService=v}),define(J[222],Z([0,1,4,2,25]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(b,m){super();this.logService=b,this.storageMainService=m,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,m)=>(b?b.push(m):b=[m],b),C.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const m=new Map,y=new Set;return b.forEach(E=>{const k=this.storageMainService.globalStorage.get(E.key);typeof k=="string"?m.set(E.key,k):y.add(E.key)}),{changed:Array.from(m.entries()),deleted:Array.from(y.values())}}listen(b,m){switch(m){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${m}`)}async call(b,m,y){const E=(0,R.reviveIdentifier)(y.workspace),k=await this.withStorageInitialized(E);switch(m){case"getItems":return Array.from(k.items.entries());case"updateItems":{const I=y;if(I.insert)for(const[p,t]of I.insert)k.set(p,t);I.delete&&I.delete.forEach(p=>k.delete(p));break}case"close":{if(E)return k.close();break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(b){const m=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await m.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${y}`)}return m}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[223],Z([0,1,9,4,2,8,24,90,129,6,97,32,25]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends R.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new w.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(d=>this._onDidChangeStorage.fire({key:d}))),await this.doInit(v);const P=v.getBoolean(E.IS_NEW_KEY);P===void 0?v.set(E.IS_NEW_KEY,!0):P&&v.set(E.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,P){return this._storage.get(v,P)}set(v,P){return this._storage.set(v,P)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends p{constructor(v,P,d){super(P);this.options=v,this.environmentService=d}async doCreate(){let v;return this.options.useInMemoryStorage?v=m.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new b.Storage(new m.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(k.firstSessionDateStorageKey,void 0)===void 0&&v.set(k.firstSessionDateStorageKey,new Date().toUTCString());const d=v.get(k.currentSessionDateStorageKey,void 0),f=new Date().toUTCString();v.set(k.lastSessionDateStorageKey,typeof d=="undefined"?null:d),v.set(k.currentSessionDateStorageKey,f)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class h extends p{constructor(v,P,d,f){super(d);this.workspace=v,this.options=P,this.environmentService=f}async doCreate(){const{storageFilePath:v,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new m.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:P?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,C.join)(v,h.WORKSPACE_STORAGE_NAME);return await M.Promises.exists(v)?{storageFilePath:P,wasCreated:!1}:(await M.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let P;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const d=(0,C.join)(v,h.WORKSPACE_META_NAME);await M.Promises.exists(d)||await M.Promises.writeFile(d,JSON.stringify(P,void 0,2))}catch(d){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${d}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json"}),define(J[101],Z([0,1,16,7,25]),function(q,e,w,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(m,y,E){for(const I of m){const p=I.openedWorkspace;if((0,R.isWorkspaceIdentifier)(p)){const t=E(p);if(t){if(t.folders.some(h=>w.extUriBiasedIgnorePathCase.isEqualOrParent(y,h.uri)))return I}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return I}}const k=m.filter(I=>(0,R.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(y,I.openedWorkspace.uri));if(k.length)return k.sort((I,p)=>-(I.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function M(m,y){for(const E of m)if((0,R.isWorkspaceIdentifier)(E.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,y)||(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,y))return E}e.findWindowOnWorkspaceOrFolder=M;function b(m,y){const E=k=>y.some(I=>w.extUriBiasedIgnorePathCase.isEqual(n.URI.file(I),n.URI.file(k)));for(const k of m)if(k.config?.extensionDevelopmentPath?.some(I=>E(I)))return k}e.findWindowOnExtensionDevelopmentPath=b}),define(J[224],Z([0,1,12,2,3,16,7,19,18,6,38,34,25]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class bt extends n.Disposable{constructor(d,f,c,o,u){super();this.windowsMainService=d,this.stateMainService=f,this.lifecycleMainService=c,this.logService=o,this.configurationService=u,this._state=t(this.stateMainService.getItem(bt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(d=>this.onBeforeCloseWindow(d)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(d=>this.onBeforeCloseWindow(d))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const d={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!d.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),o&&(d.lastActiveWindow=this.toWindowState(o))}const f=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);f&&(d.lastPluginDevelopmentHostWindow=this.toWindowState(f)),this.windowsMainService.getWindowCount()>1&&(d.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=g(d);this.stateMainService.setItem(bt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(d){if(this.lifecycleMainService.quitRequested)return;const f=this.toWindowState(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=f:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,I.isWorkspaceIdentifier)(d.openedWorkspace)&&c.workspace?.id===d.openedWorkspace.id,u=(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&c.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(c.folderUri,d.openedWorkspace.uri);(o||u)&&(c.uiState=f.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=f)}toWindowState(d){return{workspace:(0,I.isWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const f=this.doGetNewWindowState(d),c=this.configurationService.getValue("window");let o;return f.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&R.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(o=!1)),f.mode===3&&!o&&(f.mode=1),f}doGetNewWindowState(d){const f=this.windowsMainService.getLastActiveWindow();if(!d.extensionTestsPath){if(!!d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const s=d.workspace;if((0,I.isWorkspaceIdentifier)(s)){const l=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===s.id).map(S=>S.uiState);if(l.length)return l[0]}if((0,I.isSingleFolderWorkspaceIdentifier)(s)){const l=this.state.openedWindows.filter(S=>S.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(S.folderUri,s.uri)).map(S=>S.uiState);if(l.length)return l[0]}else if(d.backupPath){const l=this.state.openedWindows.filter(S=>S.backupPath===d.backupPath).map(S=>S.uiState);if(l.length)return l[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!f&&a)return a.uiState}let c;const o=w.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(R.isMacintosh){const s=w.screen.getCursorScreenPoint();c=w.screen.getDisplayNearestPoint(s)}!c&&f&&(c=w.screen.getDisplayMatching(f.getBounds())),c||(c=w.screen.getPrimaryDisplay()||o[0])}let u=(0,k.defaultWindowState)();u.x=Math.round(c.bounds.x+c.bounds.width/2-u.width/2),u.y=Math.round(c.bounds.y+c.bounds.height/2-u.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&f){const s=f.serializeWindowState();s.mode===3?u.mode=3:u=s,i=u.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(d){if(this.windowsMainService.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const f=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;f.some(c=>c.x===d.x||c.y===d.y);)d.x+=30,d.y+=30;return d}};p.windowsStateStorageKey="windowsState",p=ue([te(0,k.IWindowsMainService),te(1,E.IStateMainService),te(2,m.ILifecycleMainService),te(3,y.ILogService),te(4,b.IConfigurationService)],p),e.WindowsStateHandler=p;function t(P){const d={openedWindows:[]},f=P||{openedWindows:[]};return f.lastActiveWindow&&(d.lastActiveWindow=h(f.lastActiveWindow)),f.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=h(f.lastPluginDevelopmentHostWindow)),Array.isArray(f.openedWindows)&&(d.openedWindows=f.openedWindows.map(c=>h(c))),d}e.restoreWindowsState=t;function h(P){const d={uiState:P.uiState};return P.backupPath&&(d.backupPath=P.backupPath),P.remoteAuthority&&(d.remoteAuthority=P.remoteAuthority),P.folder&&(d.folderUri=M.URI.parse(P.folder)),P.workspaceIdentifier&&(d.workspace={id:P.workspaceIdentifier.id,configPath:M.URI.parse(P.workspaceIdentifier.configURIPath)}),d}function g(P){return{lastActiveWindow:P.lastActiveWindow&&v(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&v(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(d=>v(d))}}e.getWindowsStateStoreData=g;function v(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(J[67],Z([0,1,28,44,108,33,10,8,3,16,7,5,79,25]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function t(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function h(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=h;function g(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=g;function v(W){return W&&W.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function P(W){return W&&W.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=P;function d(W){return f(W)||c(W)}e.isStoredWorkspaceFolder=d;function f(W){const U=W;return typeof U?.path=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=f;function c(W){const U=W;return typeof U?.uri=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function o(W,U,j,ee,x=!m.isWindows,N){if(W.scheme!==ee.scheme)return{name:j,uri:W.toString(!0)};let G=U?void 0:N.relativePath(ee,W);if(G!==void 0)G.length===0?G=".":m.isWindows&&W.scheme===M.Schemas.file&&!x&&(G=G.replace(/\//g,"\\"));else if(W.scheme===M.Schemas.file)G=W.fsPath,m.isWindows&&(G=(0,C.normalizeDriveLetter)(G),x&&(G=(0,w.toSlashes)(G)));else{if(!N.isEqualAuthority(W.authority,ee.authority))return{name:j,uri:W.toString(!0)};G=W.path}return{name:j,path:G}}e.getStoredWorkspaceFolder=o;function u(W,U,j){let ee=[],x=new Set;const N=j.dirname(U);for(let G of W){let z;if(f(G))G.path&&(z=j.resolvePath(N,G.path));else if(c(G))try{z=E.URI.parse(G.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(X){console.warn(X)}if(z){let X=j.getComparisonKey(z);if(!x.has(X)){x.add(X);const re=G.name||j.basenameOrAuthority(z);ee.push(new p.WorkspaceFolder({uri:z,name:re,index:ee.length},G))}}}return ee}e.toWorkspaceFolders=u;function r(W,U,j,ee,x){let N=i(U,W);const G=x.dirname(U),z=x.dirname(ee),X=[],re=s(N.folders);for(const $ of N.folders){const F=f($)?x.resolvePath(G,$.path):E.URI.parse($.uri);let B;j?B=!1:B=!f($)||(0,b.isAbsolute)($.path),X.push(o(F,B,$.name,z,re,x))}const V={insertSpaces:!1,tabSize:4,eol:m.isLinux||m.isMacintosh?`
`:`\r
`},H=R.setProperty(W,["folders"],X,V);let K=R.applyEdits(W,H);return(0,y.isEqualAuthority)(N.remoteAuthority,(0,I.getRemoteAuthority)(ee))&&(K=R.applyEdits(K,R.removeProperty(K,["remoteAuthority"],V))),K}e.rewriteWorkspaceFileForNewLocation=r;function i(W,U){let j=n.parse(U);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(ee=>d(ee));else throw new Error(`${W} looks like an invalid workspace file.`);return j}function s(W){return m.isWindows?W.some(U=>f(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=s;function a(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function l(W){return typeof W.folderUri=="string"}function S(W){return typeof W.fileUri=="string"}function D(W,U){const j={workspaces:[],files:[]};if(W){const ee=function(N,G){for(let z=0;z<N.length;z++)try{G(N[z],z)}catch(X){U.warn(`Error restoring recent entry ${JSON.stringify(N[z])}: ${X.toString()}. Skip entry.`)}},x=W;if(Array.isArray(x.entries))ee(x.entries,N=>{const G=N.label,z=N.remoteAuthority;a(N)?j.workspaces.push({label:G,remoteAuthority:z,workspace:{id:N.workspace.id,configPath:E.URI.parse(N.workspace.configPath)}}):l(N)?j.workspaces.push({label:G,remoteAuthority:z,folderUri:E.URI.parse(N.folderUri)}):S(N)&&j.files.push({label:G,remoteAuthority:z,fileUri:E.URI.parse(N.fileUri)})});else{const N=W;Array.isArray(N.workspaces3)&&ee(N.workspaces3,(G,z)=>{const X=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[z]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?j.workspaces.push({label:X,workspace:{id:G.id,configPath:E.URI.parse(G.configURIPath)}}):typeof G=="string"&&j.workspaces.push({label:X,folderUri:E.URI.parse(G)})}),Array.isArray(N.files2)&&ee(N.files2,(G,z)=>{const X=Array.isArray(N.fileLabels)&&N.fileLabels[z]||void 0;typeof G=="string"&&j.files.push({label:X,fileUri:E.URI.parse(G)})})}}return j}e.restoreRecentlyOpened=D;function L(W){const U={entries:[]};for(const j of W.workspaces)h(j)?U.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):U.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of W.files)U.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return U}e.toStoreData=L}),define(J[102],Z([0,1,60,29,10,3,16]),function(q,e,w,n,R,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(y){function E(){let k=y.scheme===R.Schemas.file?(0,M.originalFSPath)(y):y.toString();return C.isLinux||(k=k.toLowerCase()),(0,w.createHash)("md5").update(k).digest("hex")}return{id:E(),configPath:y}}e.getWorkspaceIdentifier=b;function m(y,E){function k(){if(y.scheme!==R.Schemas.file)return(0,w.createHash)("md5").update(y.toString()).digest("hex");if(!E)try{E=(0,n.statSync)(y.fsPath)}catch{return}let p;return C.isLinux?p=E.ino:C.isMacintosh?p=E.birthtime.getTime():C.isWindows&&(typeof E.birthtimeMs=="number"?p=Math.floor(E.birthtimeMs):p=E.birthtime.getTime()),(0,w.createHash)("md5").update(y.fsPath).update(p?String(p):"").digest("hex")}const I=k();if(typeof I=="string")return{id:I,uri:y}}e.getSingleFolderWorkspaceIdentifier=m}),define(J[225],Z([0,1,15,4,10,6,252,117,18,85]),function(q,e,w,n,R,C,M,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class E{constructor(t,h){this._worker=new M.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",q).fsPath),this._worker.on("message",t),this._worker.on("error",h),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,h){this._worker.postMessage(t,h)}dispose(){this._worker.terminate()}}let k=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};k=ue([te(0,C.ILogService)],k);let I=class{constructor(t,h){this._logService=t,this._shutdown=!1,this._proxy=null;const g={create:(v,P,d)=>{const f=new E(P,d);return f.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),f.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),f.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),f.postMessage(v,[]),f}};this._worker=new b.SimpleWorkerClient(g,"vs/platform/extensions/node/extensionHostStarterWorker",new k(this._logService)),this._initialize(),h.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return t.createExtensionHost()}async start(t,h){const g=y.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();const P=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),d=await v.start(t,h),f=g.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${f} ms.`),clearTimeout(P),d}async enableInspectPort(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.enableInspectPort(t)}async kill(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.kill(t)}};I=ue([te(0,C.ILogService),te(1,m.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(J[57],Z([0,1,60,61,26,17,15,4,2,8,3,31,37,88,226]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(L,W=""){this.debugLabel=W,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,M.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,W){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const W=U=>{this.traceSocketEvent("read",U),L(C.VSBuffer.wrap(U))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(L){const W=U=>{this.traceSocketEvent("close",{hadError:U}),L({type:0,hadError:U,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(L){const W=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=h;var g;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var v;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(v||(v={}));class P extends m.Disposable{constructor(L,W,U,j){super();this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:U?.byteLength||0,recordInflateBytes:j}),this._flowManager=this._register(new d(this,W,U,j,this._onData,(ee,x)=>this._write(ee,x))),this._register(this._flowManager.onError(ee=>{console.error(ee),(0,M.onUnexpectedError)(ee),this._onClose.fire({type:0,hadError:!0,error:ee})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(ee=>this._acceptChunk(ee))),this._register(this.socket.onClose(ee=>this._onClose.fire(ee)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,W){this.socket.traceSocketEvent(L,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let U=2;L.byteLength<126?U+=0:L.byteLength<2**16?U+=2:U+=8;const j=C.VSBuffer.alloc(U);if(W?j.writeUInt8(194,0):j.writeUInt8(130,0),L.byteLength<126)j.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){j.writeUInt8(126,1);let ee=1;j.writeUInt8(L.byteLength>>>8&255,++ee),j.writeUInt8(L.byteLength>>>0&255,++ee)}else{j.writeUInt8(127,1);let ee=1;j.writeUInt8(0,++ee),j.writeUInt8(0,++ee),j.writeUInt8(0,++ee),j.writeUInt8(0,++ee),j.writeUInt8(L.byteLength>>>24&255,++ee),j.writeUInt8(L.byteLength>>>16&255,++ee),j.writeUInt8(L.byteLength>>>8&255,++ee),j.writeUInt8(L.byteLength>>>0&255,++ee)}this.socket.write(C.VSBuffer.concat([j,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),U=W.readUInt8(0),j=(U&128)>>>7,ee=(U&64)>>>6,x=W.readUInt8(1),N=(x&128)>>>7,G=x&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(G===126?2:0)+(G===127?8:0),this._state.fin=j,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ee)),this._state.firstFrameOfMessage=Boolean(j),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),U=W.readUInt8(1),j=(U&128)>>>7;let ee=U&127,x=1;ee===126?ee=W.readUInt8(++x)*2**8+W.readUInt8(++x):ee===127&&(ee=W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x));let N=0;j&&(N=W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x)),this._state.state=3,this._state.readLen=ee,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),o(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class d extends m.Disposable{constructor(L,W,U,j,ee,x){super();this._tracer=L,this._onData=ee,this._writeFn=x,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new f(this._tracer,j,U,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(W,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,W){return new Promise((U,j)=>{L.write(W),L.flush(ee=>U(ee))})}acceptFrame(L,W,U){this._readQueue.push({data:L,isCompressed:W,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,W,U){return new Promise((j,ee)=>{L.write(W),U&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(x=>j(x))})}}class f extends m.Disposable{constructor(L,W,U,j){super();this._tracer=L,this._recordInflateBytes=W,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(j),this._zlibInflate.on("error",ee=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this._onError.fire(ee)}),this._zlibInflate.on("data",ee=>{this._tracer.traceSocketEvent("zlibInflateData",ee),this._pendingInflateData.push(C.VSBuffer.wrap(ee))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(W)})}}class c extends m.Disposable{constructor(L,W){super();this._tracer=L,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(C.VSBuffer.wrap(U))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),L(W)})}}function o(D,L){if(L===0)return;let W=D.byteLength>>>2;for(let G=0;G<W;G++){const z=D.readUInt32BE(G*4);D.writeUInt32BE(z^L,G*4)}let U=W*4,j=D.byteLength-U;const ee=L>>>24&255,x=L>>>16&255,N=L>>>8&255;j>=1&&D.writeUInt8(D.readUInt8(U)^ee,U),j>=2&&D.writeUInt8(D.readUInt8(U+1)^x,U+1),j>=3&&D.writeUInt8(D.readUInt8(U+2)^N,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const D=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${D}.sock`):L=(0,y.join)((0,R.tmpdir)(),`vscode-ipc-${D}.sock`),s(L),L}e.createRandomIPCHandle=r;function i(D,L,W){const U=(0,w.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${W}-${L}-sock`;let j;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${W}-${L}.sock`):j=(0,y.join)(D,`${W}-${L}.sock`),s(j),j}e.createStaticIPCHandle=i;function s(D){const L=u[E.platform];typeof L=="number"&&D.length>=L&&console.warn(`WARNING: IPC handle "${D}" is longer than ${L} chars, try a shorter --user-data-dir`)}class a extends I.IPCServer{constructor(L){super(a.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const W=b.Event.fromNodeEventEmitter(L,"connection");return b.Event.map(W,U=>({protocol:new p.Protocol(new h(U,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function l(D){return new Promise((L,W)=>{const U=(0,n.createServer)();U.on("error",W),U.listen(D,()=>{U.removeListener("error",W),L(new a(U))})})}e.serve=l;function S(D,L){return new Promise((W,U)=>{const j=(0,n.createConnection)(D,()=>{j.removeListener("error",U),W(p.Client.fromSocket(new h(j,`ipc-client${L}`),L))});j.once("error",U)})}e.connect=S}),define(J[227],Z([0,1,57]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(m){this.driver=m}listen(m,y){throw new Error("No event found")}call(m,y,E){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(E);case"startTracing":return this.driver.startTracing(E[0],E[1]);case"stopTracing":return this.driver.stopTracing(E[0],E[1],E[2]);case"reloadWindow":return this.driver.reloadWindow(E);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(E[0],E[1]);case"click":return this.driver.click(E[0],E[1],E[2],E[3]);case"doubleClick":return this.driver.doubleClick(E[0],E[1]);case"setValue":return this.driver.setValue(E[0],E[1],E[2]);case"getTitle":return this.driver.getTitle(E[0]);case"isActiveElement":return this.driver.isActiveElement(E[0],E[1]);case"getElements":return this.driver.getElements(E[0],E[1],E[2]);case"getElementXY":return this.driver.getElementXY(E[0],E[1],E[2]);case"typeInEditor":return this.driver.typeInEditor(E[0],E[1],E[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(E[0],E[1]);case"writeInTerminal":return this.driver.writeInTerminal(E[0],E[1],E[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(E);case"getLocalizedStrings":return this.driver.getLocalizedStrings(E)}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=n;class R{constructor(m){this.channel=m}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(m){return this.channel.call("capturePage",m)}startTracing(m,y){return this.channel.call("startTracing",[m,y])}stopTracing(m,y,E){return this.channel.call("stopTracing",[m,y,E])}reloadWindow(m){return this.channel.call("reloadWindow",m)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(m,y){return this.channel.call("dispatchKeybinding",[m,y])}click(m,y,E,k){return this.channel.call("click",[m,y,E,k])}doubleClick(m,y){return this.channel.call("doubleClick",[m,y])}setValue(m,y,E){return this.channel.call("setValue",[m,y,E])}getTitle(m){return this.channel.call("getTitle",[m])}isActiveElement(m,y){return this.channel.call("isActiveElement",[m,y])}getElements(m,y,E){return this.channel.call("getElements",[m,y,E])}getElementXY(m,y,E,k){return this.channel.call("getElementXY",[m,y,E,k])}typeInEditor(m,y,E){return this.channel.call("typeInEditor",[m,y,E])}getTerminalBuffer(m,y){return this.channel.call("getTerminalBuffer",[m,y])}writeInTerminal(m,y,E){return this.channel.call("writeInTerminal",[m,y,E])}getLocaleInfo(m){return this.channel.call("getLocaleInfo",m)}getLocalizedStrings(m){return this.channel.call("getLocalizedStrings",m)}}e.DriverChannelClient=R;class C{constructor(m){this.registry=m}listen(m,y){throw new Error(`Event not found: ${y}`)}call(m,y,E){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(E);case"reloadWindowDriver":return this.registry.reloadWindowDriver(E)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=C;async function M(b){const m=await(0,w.connect)(b,"driverClient"),y=m.getChannel("driver"),E=new R(y);return{client:m,driver:E}}e.connect=M}),define(J[22],Z([0,1,46,8,57,52,168,5]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(C.IEnvironmentService);class m extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,R.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([w.memoize],m.prototype,"cachedLanguagesPath",null),ue([w.memoize],m.prototype,"backupHome",null),ue([w.memoize],m.prototype,"backupWorkspacesPath",null),ue([w.memoize],m.prototype,"mainIPCHandle",null),ue([w.memoize],m.prototype,"mainLockfile",null),ue([w.memoize],m.prototype,"sandbox",null),ue([w.memoize],m.prototype,"driverVerbose",null),ue([w.memoize],m.prototype,"disableUpdates",null),ue([w.memoize],m.prototype,"disableKeytar",null),ue([w.memoize],m.prototype,"codeCachePath",null),ue([w.memoize],m.prototype,"useCodeCache",null),e.EnvironmentMainService=m}),define(J[228],Z([0,1,60,29,28,10,8,3,16,7,24,161,19,22,20,6,67,25]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(f,c,o){this.configurationService=c,this.logService=o,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=m.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(u,r)=>(0,R.isEqual)(u,r,!b.isLinux)},this.backupHome=f.backupHome,this.workspacesJsonPath=f.backupWorkspacesPath}async initialize(){let f;try{f=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{f=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(f.emptyWorkspaceInfos);let c=[];try{Array.isArray(f.rootURIWorkspaces)&&(c=f.rootURIWorkspaces.map(u=>({workspace:{id:u.id,configPath:y.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let o=[];try{Array.isArray(f.folderWorkspaceInfos)?o=f.folderWorkspaceInfos.map(u=>({folderUri:y.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})):Array.isArray(f.folderURIWorkspaces)&&(o=f.folderURIWorkspaces.map(u=>({folderUri:y.URI.parse(u),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(o),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(f,c){this.workspaces.some(u=>f.workspace.id===u.workspace.id)||(this.workspaces.push(f),this.saveSync());const o=this.getBackupPath(f.workspace.id);return c&&this.moveBackupFolderSync(o,c),o}moveBackupFolderSync(f,c){if(n.existsSync(f)&&this.convertToEmptyWindowBackupSync(f),n.existsSync(c))try{n.renameSync(c,f)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}unregisterWorkspaceBackupSync(f){const c=f.id,o=this.workspaces.findIndex(u=>u.workspace.id===c);o!==-1&&(this.workspaces.splice(o,1),this.saveSync())}registerFolderBackupSync(f){return this.folders.some(c=>this.backupUriComparer.isEqual(f.folderUri,c.folderUri))||(this.folders.push(f),this.saveSync()),this.getBackupPath(this.getFolderHash(f))}unregisterFolderBackupSync(f){const c=this.folders.findIndex(o=>this.backupUriComparer.isEqual(f,o.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(f,c){const o=f||this.getRandomEmptyWindowId();return this.emptyWindows.some(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,o))||(this.emptyWindows.push({backupFolder:o,remoteAuthority:c}),this.saveSync()),this.getBackupPath(o)}unregisterEmptyWindowBackupSync(f){const c=this.emptyWindows.findIndex(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,f));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(f){return(0,M.join)(this.backupHome,f)}async validateWorkspaces(f){if(!Array.isArray(f))return[];const c=new Set,o=[];for(let u of f){const r=u.workspace;if(!(0,v.isWorkspaceIdentifier)(r))return[];if(!c.has(r.id)){c.add(r.id);const i=this.getBackupPath(r.id);await this.doHasBackups(i)?r.configPath.scheme!==C.Schemas.file||await E.Promises.exists(r.configPath.fsPath)?o.push(u):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return o}async validateFolders(f){if(!Array.isArray(f))return[];const c=[],o=new Set;for(let u of f){const r=u.folderUri,i=this.backupUriComparer.getComparisonKey(r);if(!o.has(i)){o.add(i);const s=this.getBackupPath(this.getFolderHash(u));await this.doHasBackups(s)?r.scheme!==C.Schemas.file||await E.Promises.exists(r.fsPath)?c.push(u):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(f){if(!Array.isArray(f))return[];const c=[],o=new Set;for(let u of f){const r=u.backupFolder;if(typeof r!="string")return[];if(!o.has(r)){o.add(r);const i=this.getBackupPath(r);await this.doHasBackups(i)?c.push(u):await this.deleteStaleBackup(i)}}return c}async deleteStaleBackup(f){try{await E.Promises.exists(f)&&await E.Promises.rm(f,E.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(f){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));)c=this.getRandomEmptyWindowId();const o=this.getBackupPath(c);try{await E.Promises.rename(f,o)}catch(u){return this.logService.error(`Backup: Could not rename backup folder: ${u.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(f){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));)c=this.getRandomEmptyWindowId();const o=this.getBackupPath(c);try{n.renameSync(f,o)}catch(u){return this.logService.error(`Backup: Could not rename backup folder: ${u.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const f=[];for(const c of this.workspaces)await this.hasBackups(c)&&f.push(c);for(const c of this.folders)await this.hasBackups(c)&&f.push(c);return f}hasBackups(f){let c;return(0,k.isEmptyWindowBackupInfo)(f)?c=f.backupFolder:(0,g.isFolderBackupInfo)(f)?c=this.getBackupPath(this.getFolderHash(f)):c=this.getBackupPath(f.workspace.id),this.doHasBackups(c)}async doHasBackups(f){try{const c=await E.Promises.readdir(f);for(const o of c)try{if((await E.Promises.readdir((0,M.join)(f,o))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(f){this.logService.error(`Backup: Could not save workspaces.json: ${f.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(f){this.logService.error(`Backup: Could not save workspaces.json: ${f.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(f=>({id:f.workspace.id,configURIPath:f.workspace.configPath.toString(),remoteAuthority:f.remoteAuthority})),folderWorkspaceInfos:this.folders.map(f=>({folderUri:f.folderUri.toString(),remoteAuthority:f.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(f){const c=f.folderUri;let o;return c.scheme===C.Schemas.file?o=b.isLinux?c.fsPath:c.fsPath.toLowerCase():o=c.toString().toLowerCase(),(0,w.createHash)("md5").update(o).digest("hex")}};P=ue([te(0,p.IEnvironmentMainService),te(1,I.IConfigurationService),te(2,h.ILogService)],P),e.BackupMainService=P}),define(J[229],Z([0,1,9,4,109,59,2,3,37,57,163,227,22,183,18,34,20,7,8,17,6]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(r){return r<21}let o=class{constructor(i,s,a,l,S,D,L){this.windowServer=i,this.options=s,this.windowsMainService=a,this.lifecycleMainService=l,this.fileService=S,this.environmentMainService=D,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(i){const s=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!s?.win)throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,s){}async stopTracing(i,s,a){if(!a)return;const l=await this.capturePage(i),S=Buffer.from(l,"base64");await this.fileService.writeFile(v.URI.file((0,P.join)(this.environmentMainService.logsPath,`${s}.png`)),d.VSBuffer.wrap(S))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const s=this.windowsMainService.getWindowById(i);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(s)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,s){await this.whenUnfrozen(i);const a=R.KeybindingParser.parseUserBinding(s);for(let l of a)await this._dispatchKeybinding(i,l)}async _dispatchKeybinding(i,s){if(s instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const l=a.win.webContents,S=new C.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),L=new p.USLayoutResolvedKeybinding(S.toChord(),b.OS).getElectronAccelerator(),W=[];s.ctrlKey&&W.push("ctrl"),s.metaKey&&W.push("meta"),s.shiftKey&&W.push("shift"),s.altKey&&W.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:L,modifiers:W}),c(s.keyCode)||l.sendInputEvent({type:"char",keyCode:L,modifiers:W}),l.sendInputEvent({type:"keyUp",keyCode:L,modifiers:W}),await(0,w.timeout)(100)}async click(i,s,a,l){await(await this.getWindowDriver(i)).click(s,a,l)}async doubleClick(i,s){await(await this.getWindowDriver(i)).doubleClick(s)}async setValue(i,s,a){await(await this.getWindowDriver(i)).setValue(s,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,s){return await(await this.getWindowDriver(i)).isActiveElement(s)}async getElements(i,s,a){return await(await this.getWindowDriver(i)).getElements(s,a)}async getElementXY(i,s,a,l){return await(await this.getWindowDriver(i)).getElementXY(s,a,l)}async typeInEditor(i,s,a){await(await this.getWindowDriver(i)).typeInEditor(s,a)}async getTerminalBuffer(i,s){return await(await this.getWindowDriver(i)).getTerminalBuffer(s)}async writeInTerminal(i,s,a){await(await this.getWindowDriver(i)).writeInTerminal(s,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const s=`window:${i}`,a=new m.StaticRouter(S=>S===s),l=this.windowServer.getChannel("windowDriver",a);return new E.WindowDriverChannelClient(l)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([te(2,h.IWindowsMainService),te(3,t.ILifecycleMainService),te(4,g.IFileService),te(5,I.IEnvironmentMainService),te(6,f.ILogService)],o),e.Driver=o;async function u(r,i,s,a){const l=s.driverVerbose,S=a.createInstance(o,r,{verbose:l}),D=new k.WindowDriverRegistryChannel(S);r.registerChannel("windowDriverRegistry",D);const L=await(0,y.serve)(i),W=new k.DriverChannel(S);return L.registerChannel("driver",W),(0,M.combinedDisposable)(L,r)}e.serve=u}),define(J[230],Z([0,1,61,57]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,C,M,b,m){const y=k=>m(k,void 0),E=w.createConnection({host:R,port:C},()=>{E.removeListener("error",y);const k=Buffer.alloc(16);for(let h=0;h<16;h++)k[h]=Math.round(Math.random()*256);const I=k.toString("base64"),p=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${C}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];E.write(p.join(`\r
`)+`\r
\r
`);const t=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",t),m(void 0,new n.NodeSocket(E,b)))};E.on("data",t)});E.setNoDelay(!0),E.once("error",y)}}}),define(J[231],Z([0,1,202,9,17,15,2,14,19,52,98,6,201,226]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends M.Disposable{constructor(g,v,P){super();this.environmentService=v,this.logService=P,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,v){this.logService.trace("RequestService#request",g.url);const{proxyUrl:P,strictSSL:d}=this;let f;try{f=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",u))}const c={...process.env,...f},o=g.agent?g.agent:await(0,I.getProxyAgent)(g.url||"",c,{proxyUrl:P,strictSSL:d});return g.agent=o,g.strictSSL=d,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,v)}async getNodeRequest(g){return((0,w.parse)(g.url).protocol==="https:"?await new Promise((d,f)=>{q(["https"],d,f)}):await new Promise((d,f)=>{q(["http"],d,f)})).request}_request(g,v){return n.Promises.withAsyncBody(async(P,d)=>{let f;const c=(0,w.parse)(g.url),o=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),u={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(u.auth=g.user+":"+g.password),f=o(u,r=>{const i=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...g,url:r.headers.location,followRedirects:i-1},v).then(P,d);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,p.createGunzip)())),P({res:r,stream:(0,R.streamToBufferReadableStream)(s)})}}),f.on("error",d),g.timeout&&f.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&f.write(g.data),f.end(),v.onCancellationRequested(()=>{f.abort(),d((0,C.canceled)())})})}async resolveProxy(g){}};t=ue([te(0,m.IConfigurationService),te(1,y.INativeEnvironmentService),te(2,k.ILogService)],t),e.RequestService=t}),define(J[232],Z([0,1,12,231]),function(q,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(M){return w.net.request}class C extends n.RequestService{request(b,m){return super.request({...b||{},getRawRequest:R},m)}}e.RequestMainService=C}),define(J[233],Z([0,1,12,9,4,2,10,14,89,22,18,6,53,54,65,39]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends C.Disposable{constructor(P,d,f,c,o,u,r){super();this.machineId=P,this.userEnv=d,this.environmentMainService=f,this.lifecycleMainService=c,this.logService=o,this.themeMainService=u,this.protocolMainService=r,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,d)=>this.onWindowConnection(P,d)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,d)=>this.onWorkerConnection(P,d)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,d){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const f=await this.connect();if(P.sender.isDestroyed())return f.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",d,[f])}onWorkerConnection(P,d){this.logService.trace("SharedProcess: onWorkerConnection",d);const f=new C.DisposableStore,c=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,d),f.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",d))},o=w.BrowserWindow.fromId(d.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!d.reply.channel){c("unavailable");return}f.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===o)(()=>c("load"))),f.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(d.reply.channel,d.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch{}this.window=void 0},0))}send(P,...d){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...d)}catch(f){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,h.toErrorMessage)(f)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,d)=>this._onDidError.fire({type:2,details:d})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,d,f)=>this._onDidError.fire({type:3,details:{reason:f,exitCode:d}})))}async connect(){await this.whenIpcReady;const P=(0,b.assertIsDefined)(this.window);return(0,m.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};g=ue([te(2,y.IEnvironmentMainService),te(3,E.ILifecycleMainService),te(4,k.ILogService),te(5,t.IThemeMainService),te(6,p.IProtocolMainService)],g),e.SharedProcess=g}),define(J[234],Z([0,1,9,17,8,14,7,22,20,6]),function(q,e,w,n,R,C,M,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class E{constructor(p,t,h){this.storagePath=p,this.logService=t,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const h=this.storage[p];return(0,C.isUndefinedOrNull)(h)?t:h}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:h,data:g}of p)this.storage[h]!==g&&((0,C.isUndefinedOrNull)(g)?(0,C.isUndefined)(this.storage[h])||(this.storage[h]=void 0,t=!0):(this.storage[h]=g,t=!0));t&&this.save()}removeItem(p){(0,C.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=E;let k=class Pt{constructor(p,t,h){this.fileStorage=new E(M.URI.file((0,R.join)(p.userDataPath,Pt.STATE_FILE)),t,h)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};k.STATE_FILE="storage.json",k=ue([te(0,b.IEnvironmentMainService),te(1,y.ILogService),te(2,m.IFileService)],k),e.StateMainService=k}),define(J[81],Z([0,1,43,2,52,22,5,18,6,97,223]),function(q,e,w,n,R,C,M,b,m,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let k=class extends n.Disposable{constructor(t,h,g){super();this.logService=t,this.environmentService=h,this.lifecycleMainService=g,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,h]of this.mapWorkspaceToStorage)t.join(h.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new E.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new E.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let h=this.mapWorkspaceToStorage.get(t.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),h=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,h),(0,w.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),h}};k=ue([te(0,m.ILogService),te(1,R.IEnvironmentService),te(2,b.ILifecycleMainService)],k),e.StorageMainService=k,e.IGlobalStorageMainService=(0,M.createDecorator)("globalStorageMainService");let I=class extends y.AbstractStorageService{constructor(t,h){super();this.environmentMainService=t,this.storageMainService=h,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};I=ue([te(0,C.IEnvironmentMainService),te(1,e.IStorageMainService)],I),e.GlobalStorageMainService=I}),define(J[235],Z([0,1,61,122,230,9,2,19,6,21,200,99,80]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(P,d,f,c,o){let u;for(let r=3;r&&(u&&u.dispose(),u=await new t(P,d,f,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));r--);return u}class t extends M.Disposable{constructor(d,f,c,o,u){super();this.defaultTunnelHost=f,this.suggestedLocalPort=u,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=w.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let d=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(d){d.pause();const f=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,E.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),o=c.getSocket().socket,u=c.readEntireBuffer();c.dispose(),u.byteLength>0&&d.write(u.buffer),d.on("end",()=>{this._socketsDispose.delete(d.localAddress),o.end()}),d.on("close",()=>o.end()),d.on("error",()=>{this._socketsDispose.delete(d.localAddress),o.destroy()}),o.on("end",()=>d.end()),o.on("close",()=>d.end()),o.on("error",()=>{d.destroy()}),d.pipe(o),o.pipe(d),this._socketsDispose.set(d.localAddress,()=>{d.end(),o.end()})}}let h=class extends k.AbstractTunnelService{constructor(d,f,c,o,u){super(f);this.socketFactory=d,this.signService=c,this.productService=o,this.configurationService=u}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,f,c,o,u,r,i){const s=this.getTunnelFromMap(f,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,o,u,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},l=p(a,this.defaultTunnelHost,f,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,l),l}}};h=ue([te(1,m.ILogService),te(2,I.ISignService),te(3,y.IProductService),te(4,b.IConfigurationService)],h),e.BaseTunnelService=h;let g=class extends h{constructor(d,f,c,o){super(R.nodeSocketFactory,d,f,c,o)}};g=ue([te(0,m.ILogService),te(1,I.ISignService),te(2,y.IProductService),te(3,b.IConfigurationService)],g),e.TunnelService=g;let v=class extends M.Disposable{constructor(d,f,c,o){super();this.logService=d,this.productService=f,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(d,f,c,o,u,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${u}.`),!this._tunnelServices.has(d)){const a=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(d,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(f,c,o,u,r,i,s)}};v=ue([te(0,m.ILogService),te(1,y.IProductService),te(2,I.ISignService),te(3,b.IConfigurationService)],v),e.SharedTunnelsService=v}),define(J[82],Z([0,1,9,23,4,19,22,18,6,21,56,41]),function(q,e,w,n,R,C,M,b,m,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(t,h,g){return`${g.updateUrl}/api/update/${t}/${h}/${g.commit}`}e.createUpdateURL=I;let p=class{constructor(h,g,v,P,d,f){this.lifecycleMainService=h,this.configurationService=g,this.environmentMainService=v,this.requestService=P,this.logService=d,this.productService=f,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),g=this.getProductQuality(h);if(!g){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(g),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,w.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([te(0,b.ILifecycleMainService),te(1,C.IConfigurationService),te(2,M.IEnvironmentMainService),te(3,E.IRequestService),te(4,m.ILogService),te(5,y.IProductService)],p),e.AbstractUpdateService=p}),define(J[236],Z([0,1,12,46,4,2,19,22,18,6,21,56,32,41,82]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends t.AbstractUpdateService{constructor(v,P,d,f,c,o,u){super(v,P,f,c,o,u);this.telemetryService=d,this.disposables=new C.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,P)=>P)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,P,d)=>({url:P,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,P,d,f)=>({releaseNotes:P,version:d,productVersion:d,date:f}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(p.State.Idle(1,d))}buildUpdateFeedUrl(v){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,t.createUpdateURL)(P,v,this.productService);try{w.autoUpdater.setFeedURL({url:d})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return d}doCheckForUpdates(v){this.setState(p.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(p.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],h.prototype,"onRawError",null),ue([n.memoize],h.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateDownloaded",null),h=ue([te(0,m.ILifecycleMainService),te(1,M.IConfigurationService),te(2,I.ITelemetryService),te(3,b.IEnvironmentMainService),te(4,k.IRequestService),te(5,y.ILogService),te(6,E.IProductService)],h),e.DarwinUpdateService=h}),define(J[237],Z([0,1,45,29,9,4,8,22,18,6,32,41]),function(q,e,w,n,R,C,M,b,m,y,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(h,g,v){if(this.lifecycleMainService=h,this.logService=v,this._state=k.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,g.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,R.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([te(0,m.ILifecycleMainService),te(1,b.IEnvironmentMainService),te(2,y.ILogService)],I);let p=class extends I{constructor(h,g,v,P,d,f){super(v,P,d);this.snap=h,this.snapRevision=g,this.telemetryService=f;const c=(0,n.watch)(M.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(c,"change",(s,a)=>a),u=C.Event.filter(o,s=>s==="current"),i=C.Event.debounce(u,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((v,P)=>(0,n.realpath)(`${M.dirname(this.snap)}/current`,(d,f)=>d?P(d):v(f))),g=M.basename(h);return this.snapRevision!==g}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([te(2,m.ILifecycleMainService),te(3,b.IEnvironmentMainService),te(4,y.ILogService),te(5,E.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[42],Z([0,1,12,29,4,44,33,2,10,8,3,16,14,24,160,51,47,22,5,6,21,101,25,67,102]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let i=class extends b.Disposable{constructor(a,l,S,D,L){super();this.environmentMainService=a,this.logService=l,this.backupMainService=S,this.dialogMainService=D,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,n.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>p.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===m.Schemas.file)try{const S=l(a.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(a,D),D=>{}):this.doResolveWorkspace(a,S)}catch{return}}isWorkspacePath(a){return(0,o.isUntitledWorkspace)(a,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const S=this.doParseStoredWorkspace(a,l),D=(0,r.getWorkspaceIdentifier)(a);return{id:D.id,configPath:D.configPath,folders:(0,u.toWorkspaceFolders)(S.folders,D.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(a,l){const S=(0,C.parse)(l);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,u.isStoredWorkspaceFolder)(D));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(a,l){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(a,l),L=S.configPath.fsPath;return await p.Promises.mkdir((0,y.dirname)(L),{recursive:!0}),await p.Promises.writeFile(L,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(a,l){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(a,l),L=S.configPath.fsPath;return(0,n.mkdirSync)((0,y.dirname)(L),{recursive:!0}),(0,p.writeFileSync)(L,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(a=[],l){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,k.joinPath)(this.untitledWorkspacesHome,S),L=(0,k.joinPath)(D,o.UNTITLED_WORKSPACE_NAME),W=[];for(const U of a)W.push((0,u.getStoredWorkspaceFolder)(U.uri,!0,U.name,D,!E.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(L),storedWorkspace:{folders:W,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,r.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,o.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,k.originalFSPath)(a.configPath);try{(0,p.rimrafSync)((0,y.dirname)(l));const S=(0,y.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,n.existsSync)(S)&&(0,p.writeFileSync)((0,y.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${l} (${S}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,k.joinPath)(this.untitledWorkspacesHome,S,o.UNTITLED_WORKSPACE_NAME));for(const S of l){const D=(0,r.getWorkspaceIdentifier)(S),L=this.resolveLocalWorkspaceSync(S);L?a.push({workspace:D,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,S){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,S))return;const L=this.doEnterWorkspace(a,(0,r.getWorkspaceIdentifier)(S));if(!!L)return this._onDidEnterWorkspace.fire({window:a,workspace:L.workspace}),L}async isValidTargetWorkspacePath(a,l,S){if(!S)return!0;if((0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,S))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,k.basename)(S)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let S;return a.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=S,{workspace:l,backupPath:S}}};i=ue([te(0,v.IEnvironmentMainService),te(1,d.ILogService),te(2,h.IBackupMainService),te(3,g.IDialogMainService),te(4,f.IProductService)],i),e.WorkspacesManagementMainService=i}),define(J[103],Z([0,1,12,23,5,34,25,42]),function(q,e,w,n,R,C,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let m=class{constructor(E,k){this.windowsMainService=E,this.workspacesManagementMainService=k}async getRemoteDiagnostics(E){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(p=>new Promise(t=>{const h=p.remoteAuthority;if(h){const g=`vscode:getDiagnosticInfoResponse${p.id}`,v={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?this.getFolderURIs(p):void 0};p.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:g,args:v}),w.ipcMain.once(g,(P,d)=>{d||t({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),t(d)}),setTimeout(()=>{t({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else t(void 0)})))).filter(p=>!!p)}getFolderURIs(E){const k=[],I=E.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(I))k.push(I.uri);else if((0,M.isWorkspaceIdentifier)(I)){const p=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);p&&p.folders.forEach(h=>{k.push(h.uri)})}return k}};m=ue([te(0,C.IWindowsMainService),te(1,b.IWorkspacesManagementMainService)],m),e.DiagnosticsMainService=m}),define(J[104],Z([0,1,12,30,3,14,7,24,19,50,5,6,100,34,25,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let g=class{constructor(P,d,f,c,o){this.logService=P,this.windowsMainService=d,this.urlService=f,this.workspacesManagementMainService=c,this.configurationService=o}async start(P,d){this.logService.trace("Received data from other instance: ",P,d),R.isMacintosh&&w.app.focus({steal:!0});const f=this.parseOpenUrl(P);if(f.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:o,url:u}of f)this.urlService.open(o,{originalUrl:u})})}else return this.startOpenWindow(P,d)}parseOpenUrl(P){return P["open-url"]&&P._urls&&P._urls.length>0?(0,n.coalesce)(P._urls.map(d=>{try{return{uri:M.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(P,d){const f=(0,y.isLaunchedFromCli)(d)?0:4;let c=[];const o=P.wait&&P.waitMarkerFilePath?M.URI.file(P.waitMarkerFilePath):void 0,u=P.remote||void 0,r={context:f,cli:P,userEnv:d,waitMarkerFileURI:o,remoteAuthority:u};if(P.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(P.extensionDevelopmentPath,r);else if(!P._.length&&!P["folder-uri"]&&!P["file-uri"]){let i=!1;if(P["new-window"]||P["unity-launch"])i=!0;else if(P["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!R.isMacintosh}if(i)c=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,r),c=[s]):c=this.windowsMainService.open({...r,forceEmpty:!0})}}else c=this.windowsMainService.open({...r,forceNewWindow:P["new-window"],preferNewWindow:!P["reuse-window"]&&!P.wait,forceReuseWindow:P["reuse-window"],diffMode:P.diff,addMode:P.add,noRecentEntry:!!P["skip-add-to-recently-opened"],gotoLineMode:P.goto});if(o&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,b.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const P=[];return w.BrowserWindow.getAllWindows().forEach(d=>{const f=this.windowsMainService.getWindowById(d.id);f?P.push(this.codeWindowToInfo(f)):P.push(this.browserWindowToInfo(d))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:P,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(P){const d=[],f=P.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(f))d.push(f.uri);else if((0,t.isWorkspaceIdentifier)(f)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.configPath);c&&c.folders.forEach(u=>{d.push(u.uri)})}return d}codeWindowToInfo(P){const d=this.getFolderURIs(P),f=(0,C.assertIsDefined)(P.win);return this.browserWindowToInfo(f,d,P.remoteAuthority)}browserWindowToInfo(P,d=[],f){return{pid:P.webContents.getOSProcessId(),title:P.getTitle(),folderURIs:d,remoteAuthority:f}}};g=ue([te(0,k.ILogService),te(1,p.IWindowsMainService),te(2,I.IURLService),te(3,h.IWorkspacesManagementMainService),te(4,m.IConfigurationService)],g),e.LaunchMainService=g}),define(J[58],Z([0,1,45,12,26,121,46,4,33,2,10,8,3,7,86,72,24,151,47,22,5,18,6,21,32,65,34,25,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r,i,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,f.createDecorator)("nativeHostMainService");let S=class extends y.Disposable{constructor(L,W,U,j,ee,x,N,G,z,X){super();this.sharedProcess=L,this.windowsMainService=W,this.dialogMainService=U,this.lifecycleMainService=j,this.environmentMainService=ee,this.telemetryService=x,this.logService=N,this.productService=G,this.themeMainService=z,this.workspacesManagementMainService=X,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,re=>re.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(re,V)=>V.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(re,V)=>V.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(re,V)=>V.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),re=>!!re),re=>re.id),b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(re,V)=>V.id),re=>!!this.windowsMainService.getWindowById(re))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new b.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(re,V,H)=>H),re=>!(Array.isArray(re)&&re.length===1&&re[0]==="workArea")),b.Event.fromNodeEventEmitter(n.screen,"display-added"),b.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(L,W,U){return Array.isArray(W)?this.doOpenWindow(L,W,U):this.doOpenEmptyWindow(L,W)}async doOpenWindow(L,W,U=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(L,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},W)}async toggleFullScreen(L){const W=this.windowById(L);W&&W.toggleFullScreen()}async handleTitleDoubleClick(L){const W=this.windowById(L);W&&W.handleTitleDoubleClick()}async isMaximized(L){const W=this.windowById(L);return W?.win?W.win.isMaximized():!1}async maximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.maximize()}async unmaximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.unmaximize()}async minimizeWindow(L){const W=this.windowById(L);W?.win&&W.win.minimize()}async focusWindow(L,W){W&&typeof W.windowId=="number"&&(L=W.windowId);const U=this.windowById(L);U&&U.focus({force:W?.force??!1})}async setMinimumSize(L,W,U){const j=this.windowById(L);if(j?.win){const[ee,x]=j.win.getSize(),[N,G]=j.win.getMinimumSize(),[z,X]=[W??N,U??G],[re,V]=[Math.max(ee,z),Math.max(x,X)];(N!==z||G!==X)&&j.win.setMinimumSize(z,X),(ee!==re||x!==V)&&j.win.setSize(re,V)}}async saveWindowSplash(L,W){this.themeMainService.saveWindowSplash(L,W)}async installShellCommand(L){const{source:W,target:U}=await this.getShellCommandLink();try{const{symbolicLink:j}=await g.SymlinkSupport.stat(W);if(j&&!j.dangling){const ee=await(0,t.realpath)(W);if(U===ee)return}await g.Promises.unlink(W)}catch(j){if(j.code!=="ENOENT")throw j}try{await g.Promises.symlink(U,W)}catch(j){if(j.code!=="EACCES"&&j.code!=="ENOENT")throw j;const{response:ee}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,m.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${W}'\\" with administrator privileges"`;await(0,C.promisify)(w.exec)(x)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(L){const{source:W}=await this.getShellCommandLink();try{await g.Promises.unlink(W)}catch(U){switch(U.code){case"EACCES":{const{response:j}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,m.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(j===0)try{const ee=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,C.promisify)(w.exec)(ee)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const L=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await g.Promises.exists(L))throw new Error((0,v.localize)(8,null,L));return{source:W,target:L}}async showMessageBox(L,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(L))}async showSaveDialog(L,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(L))}async showOpenDialog(L,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(L))}toBrowserWindow(L){const W=this.windowById(L);if(W?.win)return W.win}async pickFileFolderAndOpen(L,W){const U=await this.dialogMainService.pickFileFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async j=>await g.SymlinkSupport.existsDirectory(j)?{folderUri:p.URI.file(j)}:{fileUri:p.URI.file(j)})),W,L))}async pickFolderAndOpen(L,W){const U=await this.dialogMainService.pickFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(U.map(j=>({folderUri:p.URI.file(j)})),W,L))}async pickFileAndOpen(L,W){const U=await this.dialogMainService.pickFile(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(U.map(j=>({fileUri:p.URI.file(j)})),W,L))}async pickWorkspaceAndOpen(L,W){const U=await this.dialogMainService.pickWorkspace(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(U.map(j=>({workspaceUri:p.URI.file(j)})),W,L))}doOpenPicked(L,W,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(L,W,U){const j=L?L.length:0;this.telemetryService.publicLog(W,{...U,outcome:j?"success":"canceled",numberOfPaths:j})}async showItemInFolder(L,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(L,W){const U=this.windowById(L);U&&U.setRepresentedFilename(W)}async setDocumentEdited(L,W){const U=this.windowById(L);U&&U.setDocumentEdited(W)}async openExternal(L,W){return I.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(L){const W=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(L,W){return n.shell.trashItem(W)}async isAdmin(){let L;return I.isWindows?L=(await new Promise((W,U)=>{q(["native-is-elevated"],W,U)}))():L=process.getuid()===0,L}async writeElevated(L,W,U,j){const ee=await new Promise((x,N)=>{q(["@vscode/sudo-prompt"],x,N)});return new Promise((x,N)=>{const G=[`"${this.cliPath}"`];j?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${W.fsPath}"`,`"${U.fsPath}"`);const z={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ee.exec(G.join(" "),z,(X,re,V)=>{re&&this.logService.trace(`[sudo-prompt] received stdout: ${re}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),X?N(X):x(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,W,U){process.kill(W,U)}async readClipboardText(L,W){return n.clipboard.readText(W)}async writeClipboardText(L,W,U){return n.clipboard.writeText(W,U)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(L,W,U,j){return n.clipboard.writeBuffer(W,Buffer.from(U),j)}async readClipboardBuffer(L,W){return n.clipboard.readBuffer(W)}async hasClipboard(L,W,U){return n.clipboard.has(W,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,W){const U=this.windowById(L);U&&U.updateTouchBar(W)}async notifyReady(L){const W=this.windowById(L);W&&W.setReady()}async relaunch(L,W){return this.lifecycleMainService.relaunch(W)}async reload(L,W){const U=this.windowById(L);if(U){if((0,a.isWorkspaceIdentifier)(U.openedWorkspace)){const j=U.openedWorkspace.configPath;if(j.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(j))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,W){const U=this.windowById(W);if(U?.win)return U.win.close()}async quit(L){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(L,W){await this.lifecycleMainService.kill(W)}async resolveProxy(L,W){const j=this.windowById(L)?.win?.webContents?.session;if(j)return j.resolveProxy(W)}async openDevTools(L,W){const U=this.windowById(L);U?.win&&U.win.webContents.openDevTools(W)}async toggleDevTools(L){const W=this.windowById(L);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(L,W){const U=this.windowById(L);U?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&U.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,W,U,j){if(!I.isWindows)return;const ee=await new Promise((x,N)=>{q(["@vscode/windows-registry"],x,N)});try{return ee.GetStringRegKey(W,U,j)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};ue([M.memoize],S.prototype,"cliPath",null),S=ue([te(1,s.IWindowsMainService),te(2,P.IDialogMainService),te(3,c.ILifecycleMainService),te(4,d.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,o.ILogService),te(7,u.IProductService),te(8,i.IThemeMainService),te(9,l.IWorkspacesManagementMainService)],S),e.NativeHostMainService=S}),define(J[238],Z([0,1,12,26,33,2,10,3,87,149,76,103,47,22,5,104,6,58,53,21,54,66]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let o=class Mt{constructor(r,i,s,a,l,S,D,L,W,U){this.userEnv=r,this.environmentMainService=i,this.launchMainService=s,this.logService=a,this.diagnosticsService=l,this.diagnosticsMainService=S,this.dialogMainService=D,this.nativeHostMainService=L,this.protocolMainService=W,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[i,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(i,s);this.safeSend(r,"vscode:issueSystemInfoResponse",a)}),w.ipcMain.on("vscode:listProcesses",async r=>{const i=[];try{const s=await this.launchMainService.getMainProcessId();i.push({name:(0,y.localize)(0,null),rootProcess:await(0,m.listProcesses)(s)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(l=>{(0,E.isRemoteDiagnosticError)(l)?i.push({name:l.hostName,rootProcess:l}):l.processes&&i.push({name:l.hostName,rootProcess:l.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(r,"vscode:listProcessesResponse",i)}),w.ipcMain.on("vscode:issueReporterClipboard",async r=>{const i={title:this.productService.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",s.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const i=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",i)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(r,i)=>{const{id:s,from:a,args:l}=i;let S;switch(a){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:a,args:l})}),w.ipcMain.on("vscode:openExternal",(r,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),w.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async r=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",i.windows)})}safeSend(r,i,...s){r.sender.isDestroyed()||r.sender.send(i,...s)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:P.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:P.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,i,s,a){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:s.title,backgroundColor:s.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,i)}getWindowPosition(r,i,s){let a;const l=w.screen.getAllDisplays();if(l.length===1)a=l[0];else{if(b.isMacintosh){const L=w.screen.getCursorScreenPoint();a=w.screen.getDisplayNearestPoint(L)}!a&&r&&(a=w.screen.getDisplayMatching(r.getBounds())),a||(a=w.screen.getPrimaryDisplay()||l[0])}const S={width:i,height:s},D=a.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,i)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ue([te(1,p.IEnvironmentMainService),te(2,h.ILaunchMainService),te(3,g.ILogService),te(4,E.IDiagnosticsService),te(5,k.IDiagnosticsMainService),te(6,I.IDialogMainService),te(7,v.INativeHostMainService),te(8,f.IProtocolMainService),te(9,d.IProductService)],o),e.IssueMainService=o}),define(J[239],Z([0,1,23,19,22,18,6,58,21,56,32,41,82]),function(q,e,w,n,R,C,M,b,m,y,E,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends I.AbstractUpdateService{constructor(h,g,v,P,d,f,c,o){super(h,g,P,d,f,o);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,I.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(k.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},w.CancellationToken.None).then(y.asJson).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(g))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const v=h?g.message||g:void 0;this.setState(k.State.Idle(1,v))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(k.State.Idle(1))}};p=ue([te(0,C.ILifecycleMainService),te(1,n.IConfigurationService),te(2,E.ITelemetryService),te(3,R.IEnvironmentMainService),te(4,y.IRequestService),te(5,M.ILogService),te(6,b.INativeHostMainService),te(7,m.IProductService)],p),e.LinuxUpdateService=p}),define(J[240],Z([0,1,45,29,26,9,23,46,8,7,118,24,19,22,20,18,6,58,21,56,32,41,82]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(a,l=1e3){for(;!a();)await(0,C.timeout)(l)}let r;function i(){return typeof r=="undefined"&&(r=n.existsSync(m.join(m.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends o.AbstractUpdateService{constructor(l,S,D,L,W,U,j,ee,x){super(l,S,L,W,U,x);this.telemetryService=D,this.fileService=j,this.nativeHostMainService=ee}get cachePath(){const l=m.join((0,R.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(l,{recursive:!0}).then(()=>l)}initialize(){super.initialize()}buildUpdateFeedUrl(l){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),i()===1?S+="-archive":this.productService.target==="user"&&(S+="-user"),(0,o.createUpdateURL)(S,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},M.CancellationToken.None).then(d.asJson).then(S=>{const D=i();return!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(c.State.AvailableForDownload(S)),Promise.resolve(null)):(this.setState(c.State.Downloading(S)),this.cleanup(S.version).then(()=>this.getUpdatePackagePath(S.version).then(L=>k.Promises.exists(L).then(W=>{if(W)return Promise.resolve(L);const U=S.url,j=S.hash,ee=`${L}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(x=>this.fileService.writeFile(y.URI.file(ee),x.stream)).then(j?()=>(0,E.checksum)(ee,S.hash):()=>{}).then(()=>k.Promises.rename(ee,L)).then(()=>L)})).then(L=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},W&&S.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(S)):this.setState(c.State.Ready(S))})))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const D=l?S.message||S:void 0;this.setState(c.State.Idle(i(),D))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(l){const S=await this.cachePath;return m.join(S,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const S=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,D=await this.cachePath,W=(await k.Promises.readdir(D)).filter(S).map(async U=>{try{await k.Promises.unlink(m.join(D,U))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const S=await this.cachePath;this.availableUpdate.updateFilePath=m.join(S,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,W=await new Promise((U,j)=>{q(["windows-mutex"],U,j)});u(()=>W.isActive(L)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([b.memoize],s.prototype,"cachePath",null),s=ue([te(0,h.ILifecycleMainService),te(1,I.IConfigurationService),te(2,f.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,d.IRequestService),te(5,g.ILogService),te(6,t.IFileService),te(7,v.INativeHostMainService),te(8,P.IProductService)],s),e.Win32UpdateService=s}),define(J[241],Z([0,1,12,9,23,39,4,33,2,10,8,63,3,7,156,51,19,47,22,50,20,18,6,21,54,208,81,32,211,65,66,34,25,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r,i,s,a,l,S,D,L,W,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var j;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(j||(j={}));let ee=class extends m.Disposable{constructor(N,G,z,X,re,V,H,K,$,F,B,T,A,O,_){super();this.logService=G,this.environmentMainService=z,this.fileService=X,this.globalStorageMainService=re,this.configurationService=V,this.themeMainService=H,this.workspacesManagementMainService=K,this.backupMainService=$,this.telemetryService=F,this.dialogMainService=B,this.lifecycleMainService=T,this.productService=A,this.protocolMainService=O,this.windowsMainService=_,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Y,ie]=this.restoreWindowState(N.state);this.windowState=Y,this.logService.trace("window#ctor: using window state",Y);const ae=this.windowState.mode===0||this.windowState.mode===3,ce=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ae,title:this.productService.nameLong,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(ce?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?ne.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),I.isMacintosh&&(ne.acceptFirstMouse=!0,ce?.clickThroughInactive===!1&&(ne.acceptFirstMouse=!1));const le=I.isMacintosh&&ce?.nativeTabs===!0;le&&(ne.tabbingIdentifier=this.productService.nameShort);const he=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(he&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(ne.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(ne),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&he&&this._win.setSheetOffset(22),I.isMacintosh&&ie&&(!le||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}ae&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(N){I.isMacintosh?this._win.setRepresentedFilename(N):this.representedFilename=N}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(N){I.isMacintosh&&this._win.setDocumentEdited(N),this.documentEdited=N}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(N){I.isMacintosh&&N?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.whenReadyCallbacks.push(N)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(N=>{function G(){z.dispose(),X.dispose(),N()}const z=this.onDidClose(()=>G()),X=this.onWillLoad(()=>G())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(G,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(G,z,X)=>this.onWindowError(3,{reason:X,exitCode:z})),this._win.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",G,this._win)}),this._win.on("unmaximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",G,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(G=>this.onDidDeleteUntitledWorkspace(G)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(G,z)=>{const X=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,X)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(N,G){switch(N){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:N,reason:G?.reason,code:G?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(z.response!==1){const X=z.response===0;this.destroyWindow(X)}}else if(N===2){let z;G?z=(0,t.localize)(6,null,G.reason,G.exitCode??"<unknown>"):z=(0,t.localize)(5,null);const re=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(8,null))],message:z,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(re)}break}}destroyWindow(N){if(this._onDidDestroy.fire(),this._win?.destroy(),N&&this.config){let G,z;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?G={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?G={workspaceUri:this.openedWorkspace.configPath}:z=!0;const[X]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:G?[G]:void 0,forceEmpty:z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});X.focus()}}onDidDeleteUntitledWorkspace(N){this.openedWorkspace?.id===N.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N));let G=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;G?.endsWith("/")&&(G=G.substr(0,G.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((G||"").indexOf("@")===-1&&(G!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=G,this.currentNoProxy=z;const X=G||"",re=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${X}', bypassing '${re}'`),this._win.webContents.session.setProxy({proxyRules:X,proxyBypassRules:re,pacScript:""})}}addTabbedWindow(N){I.isMacintosh&&N.win&&this._win.addTabbedWindow(N.win)}load(N,G=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!G.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),G.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(N,G),this.readyState===0?this.currentConfig=N:this.pendingLoadConfig=N,this.readyState=1,this._win.loadURL(y.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:N.workspace,reason:G.isReload?3:z?2:1})}updateConfiguration(N,G){const z=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(z){const X=(0,d.isLaunchedFromCli)(z)&&!(0,d.isLaunchedFromCli)(N.userEnv),re=this.isExtensionDevelopmentHost;(X||re)&&(N.userEnv={...z,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),G.disableExtensions!==void 0&&(N["disable-extensions"]=G.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this._win.isMaximized(),N.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),N.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(N)}async reload(N){const G=Object.assign({},this.currentConfig);G.workspace=await this.validateWorkspaceBeforeReload(G),delete G.filesToOpenOrCreate,delete G.filesToDiff,delete G.filesToWait,this.isExtensionDevelopmentHost&&N&&(G.verbose=N.verbose,G.debugId=N.debugId,G.extensionEnvironment=N.extensionEnvironment,G["inspect-extensions"]=N["inspect-extensions"],G["inspect-brk-extensions"]=N["inspect-brk-extensions"],G["extensions-dir"]=N["extensions-dir"]),G.isInitialStartup=!1,this.load(G,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async validateWorkspaceBeforeReload(N){if((0,W.isWorkspaceIdentifier)(N.workspace)){const G=N.workspace.configPath;if(G.scheme===y.Schemas.file&&!await this.fileService.exists(G))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(N.workspace)){const G=N.workspace.uri;if(G.scheme===y.Schemas.file&&!await this.fileService.exists(G))return}return N.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let z;try{z=w.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,L.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||X.width,height:this.windowState.height||X.height,x:this.windowState.x||0,y:this.windowState.y||0}}const N=Object.create(null);let G;if(!I.isMacintosh&&this._win.isMaximized()?G=0:G=1,G===0?N.mode=0:N.mode=1,G===1||G===0){let z;G===1?z=this.getBounds():z=this._win.getNormalBounds(),N.x=z.x,N.y=z.y,N.width=z.width,N.height=z.height}return N}restoreWindowState(N){(0,k.mark)("code/willRestoreCodeWindowState");let G=!1;if(N)try{const z=w.screen.getAllDisplays();G=z.length>1,N=this.validateWindowState(N,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[N||(0,L.defaultWindowState)(),G]}validateWindowState(N,G){if(this.logService.trace(`window#validateWindowState: validating window state on ${G.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(G.length===1){const re=this.getWorkingArea(G[0]);if(re){let V=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!re||(N.x<re.x&&(N.x=re.x),N.y<re.y&&(N.y=re.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",re),V(),N.width>re.width&&(N.width=re.width),N.height>re.height&&(N.height=re.height),N.x>re.x+re.width-128&&(N.x=re.x+re.width-N.width),N.y>re.y+re.height-128&&(N.y=re.y+re.height-N.height),V()}return N}if(N.display&&N.mode===3){const re=G.find(V=>V.id===N.display);if(re&&typeof re.bounds?.x=="number"&&typeof re.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,L.defaultWindowState)(3);return V.x=re.bounds.x,V.y=re.bounds.y,V}}let z,X;try{z=w.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),X=this.getWorkingArea(z)}catch{}if(z&&X&&N.x+N.width>X.x&&N.y+N.height>X.y&&N.x<X.x+X.width&&N.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),N}getWorkingArea(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,G]=this._win.getPosition(),[z,X]=this._win.getSize();return{x:N,y:G,width:z,height:X}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(N){this.useNativeFullScreen()?this.setNativeFullScreen(N):this.setSimpleFullScreen(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(N){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(N)}setSimpleFullScreen(N){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(N),this._win.webContents.focus()}useNativeFullScreen(){const N=this.configurationService.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let N=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}setMenuBarVisibility(N,G=!0){I.isMacintosh||(N==="toggle"&&G&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),N==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(N)}):this.doSetMenuBarVisibility(N))}doSetMenuBarVisibility(N){const G=this.isFullScreen;switch(N){case"classic":this._win.setMenuBarVisibility(!G),this._win.autoHideMenuBar=G;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(N,G,...z){this.isReady?this.send(N,...z):this.ready().then(()=>{G.isCancellationRequested||this.send(N,...z)})}send(N,...G){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this._win.webContents.send(N,...G)}catch(z){this.logService.warn(`Error sending IPC message to channel '${N}' of window ${this._id}: ${(0,C.toErrorMessage)(z)}`)}}}updateTouchBar(N){!I.isMacintosh||this.touchBarGroups.forEach((G,z)=>{const X=N[z];G.segments=this.createTouchBarGroupSegments(X)})}createTouchBar(){if(!!I.isMacintosh){for(let N=0;N<10;N++){const G=this.createTouchBarGroup();this.touchBarGroups.push(G)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(N=[]){const G=this.createTouchBarGroupSegments(N),z=new w.TouchBar.TouchBarSegmentedControl({segments:G,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:z.segments[X].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(N=[]){return N.map(z=>{let X;z.icon&&!l.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===y.Schemas.file&&(X=w.nativeImage.createFromPath(p.URI.revive(z.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let re;return typeof z.title=="string"?re=z.title:re=z.title.value,{id:z.id,label:X?void 0:re,icon:X}})}dispose(){super.dispose(),this._win=null}};ee=ue([te(1,o.ILogService),te(2,P.IEnvironmentMainService),te(3,f.IFileService),te(4,s.IGlobalStorageMainService),te(5,g.IConfigurationService),te(6,S.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,h.IBackupMainService),te(9,a.ITelemetryService),te(10,v.IDialogMainService),te(11,c.ILifecycleMainService),te(12,u.IProductService),te(13,r.IProtocolMainService),te(14,L.IWindowsMainService)],ee),e.CodeWindow=ee}),define(J[68],Z([0,1,12,30,9,4,33,2,10,3,16,7,24,159,5,18,6,38,81,67,25,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let o=class ze extends b.Disposable{constructor(r,i,s,a,l){super();this.stateMainService=r,this.logService=i,this.workspacesManagementMainService=s,this.lifecycleMainService=a,this.globalStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new R.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(let a of r)if((0,d.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&this.indexOfWorkspace(i,a.workspace)===-1&&i.push(a);else if((0,d.isRecentFolder)(a))this.indexOfFolder(i,a.folderUri)===-1&&i.push(a);else{const l=this.indexOfFile(s,a.fileUri)>=0,S=a.fileUri.scheme===m.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,E.basename)(a.fileUri))>=0;!l&&!S&&(s.push(a),y.isWindows&&a.fileUri.scheme===m.Schemas.file&&w.app.addRecentDocument(a.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=ze.MAX_TOTAL_RECENT_ENTRIES),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=S=>{const D=this.location(S);for(const L of r)if(E.extUriBiasedIgnorePathCase.isEqual(L,D))return!1;return!0},s=await this.getRecentlyOpened(),a=s.workspaces.filter(i),l=s.files.filter(i);(a.length!==s.workspaces.length||l.length!==s.files.length)&&(await this.saveRecentlyOpened({files:l,workspaces:a}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const l=r.config?.workspace;(0,f.isWorkspaceIdentifier)(l)&&!this.workspacesManagementMainService.isUntitledWorkspace(l)?i.push({workspace:l,remoteAuthority:r.remoteAuthority}):(0,f.isSingleFolderWorkspaceIdentifier)(l)&&i.push({folderUri:l.uri,remoteAuthority:r.remoteAuthority})}const a=r?.config?.filesToOpenOrCreate;if(a)for(let l of a){const S=l.fileUri;S&&this.indexOfFile(s,S)===-1&&s.push({fileUri:S})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){let s=await this.getRecentlyOpenedFromStorage();for(let a of s.workspaces){let l=(0,d.isRecentFolder)(a)?this.indexOfFolder(r,a.folderUri):this.indexOfWorkspace(r,a.workspace);l>=0?r[l].label=r[l].label||a.label:r.push(a)}for(let a of s.files){let l=this.indexOfFile(i,a.fileUri);l>=0?i[l].label=i[l].label||a.label:i.push(a)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let r;const i=this.globalStorageMainService.get(ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}else r=this.stateMainService.getItem(ze.legacyRecentlyOpenedStorageKey),r&&(this.stateMainService.removeItem(ze.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(r),0,1));return(0,d.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(r)),0,1)}location(r){return(0,d.isRecentFolder)(r)?r.folderUri:(0,d.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,d.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,d.isRecentFolder)(s)&&E.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>E.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!y.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!y.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let l of w.app.getJumpListSettings().removedItems){const S=l.args;if(S){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);D&&i.push(k.URI.parse(D[2]))}}await this.removeRecentlyOpened(i);let s=!1;const a=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const S=(0,d.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:D,description:L}=this.getWindowsJumpListLabel(S,l.label);let W;return k.URI.isUri(S)?W=`--folder-uri "${S.toString()}"`:(s=!0,W=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:L.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&r.push({type:"custom",name:s?(0,p.localize)(2,null):(0,p.localize)(3,null),items:a})}r.push({type:"recent"});try{w.app.setJumpList(r)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(k.URI.isUri(r))return{title:(0,E.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,p.localize)(4,null),description:""};let s=(0,E.basename)(r.configPath);return s.endsWith(f.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;w.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let l=0;l<r.workspaces.length&&s<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const S=this.location(r.workspaces[l]);if(S.scheme===m.Schemas.file){const D=(0,E.originalFSPath)(S);await I.Promises.exists(D)&&(i.push(D),s++)}}const a=[];for(let l=0;l<r.files.length&&s<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const S=this.location(r.files[l]);if(S.scheme===m.Schemas.file){const D=(0,E.originalFSPath)(S);if(ze.COMMON_FILES_FILTER.includes((0,E.basename)(S))||i.includes(D))continue;await I.Promises.exists(D)&&(a.push(D),s++)}}a.reverse().forEach(l=>w.app.addRecentDocument(l)),i.reverse().forEach(l=>w.app.addRecentDocument(l))}};o.MAX_TOTAL_RECENT_ENTRIES=500,o.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",o.legacyRecentlyOpenedStorageKey="openedPathsList",o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o=ue([te(0,v.IStateMainService),te(1,g.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,h.ILifecycleMainService),te(4,P.IGlobalStorageMainService)],o),e.WorkspacesHistoryMainService=o}),define(J[242],Z([0,1,12,9,23,33,3,7,150,19,22,18,6,192,58,21,38,32,41,66,34,68]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let u=class Et{constructor(s,a,l,S,D,L,W,U,j,ee,x){this.updateService=s,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=S,this.telemetryService=D,this.workspacesHistoryMainService=L,this.stateMainService=W,this.lifecycleMainService=U,this.logService=j,this.nativeHostMainService=ee,this.productService=x,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Et.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,W,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,W,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const S=this.productService.licenseUrl;S&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=S.indexOf("?")>0?"&":"?";this.openUrl(`${S}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(S,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&S&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Et.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=w.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(M.isMacintosh?new w.Menu:null);return}const a=new w.Menu;let l;if(M.isMacintosh){const D=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),a.append(l)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new w.Menu;D.append(new w.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:D});this.setMenuById(D,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:D});this.setMenuById(D,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),a.append(L)}let S;if(this.shouldDrawMenu("Window")){const D=new w.Menu;S=new w.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(S&&a.append(S),this.shouldDrawMenu("Help")){const D=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),a.append(L)}a.items&&a.items.length>0?w.Menu.setApplicationMenu(a):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let S;if(this.shouldDrawMenu("Preferences")){const N=new w.Menu;this.setMenuById(N,"Preferences"),S=new w.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:N})}const D=new w.Menu,L=new w.MenuItem({label:m.localize(12,null),role:"services",submenu:D}),W=new w.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),j=new w.MenuItem({label:m.localize(15,null),role:"unhide"}),ee=new w.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const N=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||N?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),x=[a];x.push(...l),S&&x.push(r(),S),x.push(r(),L,r(),W,U,j,r(),ee),x.forEach(N=>s.append(N))}shouldDrawMenu(s){if(!M.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(l=>{if((0,p.isMenubarMenuItemSeparator)(l))s.append(r());else if((0,p.isMenubarMenuItemSubmenu)(l)){const S=new w.Menu,D=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:S});this.setMenu(S,l.submenu.items),s.append(D)}else(0,p.isMenubarMenuItemRecentAction)(l)?s.append(this.createOpenRecentMenuItem(l)):(0,p.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?s.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):s.append(this.createMenuItem(l.label,l.id,!1,l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>s.append(l)),s.append(r()))}createOpenRecentMenuItem(s){const a=b.URI.revive(s.uri),l=s.id,S=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new w.MenuItem(this.likeAction(l,{label:s.label,click:(D,L,W)=>{const U=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[S],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,a,l){const S={label:this.mnemonicLabel(s),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(a,S))}setMacWindowMenu(s){const a=new w.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),S=new w.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(r()),L.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,r(),D,...L,r(),S].forEach(W=>s.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,l,S){const D=this.mnemonicLabel(s),L=typeof a=="function"?a:(x,N,G)=>{const z=x?x.userSettingsLabel:null;let X=a;Array.isArray(a)&&(X=this.isOptionClick(G)?a[1]:a[0]),z&&G.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:X})},W=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof S=="boolean"?S:!1,j={label:D,click:L,enabled:W};U&&(j.type="checkbox",j.checked=U);let ee;return typeof a=="string"?ee=a:Array.isArray(a)&&(ee=a[0]),M.isMacintosh&&(ee==="editor.action.clipboardCutAction"?j.role="cut":ee==="editor.action.clipboardCopyAction"?j.role="copy":ee==="editor.action.clipboardPasteAction"&&(j.role="paste"),ee==="undo"?j.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?j.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(j.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ee,j))}makeContextAwareClickHandler(s,a){return(l,S,D)=>{const L=w.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);s(l,S||L,D)}}runActionInRenderer(s){let a=w.BrowserWindow.getFocusedWindow();if(!a){const S=this.windowsMainService.getLastActiveWindow();S?.isMinimized()&&(a=S.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const S={id:s.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",R.CancellationToken.None,S)}else{const S={userSettingsLabel:s.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",R.CancellationToken.None,S)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const l=typeof s=="string"?this.keybindings[s]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const S=a.label.indexOf("[");S>=0?a.label=`${a.label.substr(0,S)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,l=!a.accelerator){l&&(a=this.withKeybinding(s,a));const S=a.click;return a.click=(D,L,W)=>{this.reportMenuActionTelemetry(s),S&&S(D,L,W)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,C.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=ue([te(0,P.IUpdateService),te(1,y.IConfigurationService),te(2,f.IWindowsMainService),te(3,E.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,g.IStateMainService),te(7,k.ILifecycleMainService),te(8,I.ILogService),te(9,t.INativeHostMainService),te(10,h.IProductService)],u),e.Menubar=u;function r(){return new w.MenuItem({type:"separator"})}}),define(J[243],Z([0,1,5,18,6,242]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let M=class{constructor(m,y,E){this.instantiationService=m,this.lifecycleMainService=y,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(m,y){this.logService.trace("menubarService#updateMenubar",m),(await this.menubar).updateMenu(y,m)}};M=ue([te(0,w.IInstantiationService),te(1,n.ILifecycleMainService),te(2,R.ILogService)],M),e.MenubarMainService=M}),define(J[244],Z([0,1,12,29,26,30,23,4,28,43,33,2,10,8,63,3,36,16,14,7,157,51,19,47,22,20,5,18,6,53,21,54,79,38,66,241,101,224,25,102,68,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r,i,s,a,l,S,D,L,W,U,j,ee,x,N,G,z,X,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V($){return(0,G.isWorkspaceIdentifier)($?.workspace)}function H($){return(0,G.isSingleFolderWorkspaceIdentifier)($?.workspace)}let K=class rt extends k.Disposable{constructor(F,B,T,A,O,_,Y,ie,ae,ce,ne,le,he,me,Pe){super();this.machineId=F,this.initialUserEnv=B,this.logService=T,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=_,this.backupMainService=Y,this.configurationService=ie,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ce,this.instantiationService=ne,this.dialogMainService=le,this.fileService=he,this.productService=me,this.protocolMainService=Pe,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new N.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const B=new k.DisposableStore;if(B.add(b.Event.any(F.onDidClose,F.onDidDestroy)(()=>B.dispose())),F.config.extensionDevelopmentPath)for(const T of F.config.extensionDevelopmentPath)B.add(this.protocolMainService.addValidFileRoot(d.URI.file(T)));F.config.extensionTestsPath&&B.add(this.protocolMainService.addValidFileRoot(d.URI.file(F.config.extensionTestsPath)))}}))}openEmptyWindow(F,B){let T=this.environmentMainService.args;const A=B?.remoteAuthority||void 0,O=!0,_=B?.forceReuseWindow,Y=!_;return this.open({...F,cli:T,forceEmpty:O,forceNewWindow:Y,forceReuseWindow:_,remoteAuthority:A})}openExistingWindow(F,B){F.focus(),this.handleWaitMarkerFile(B,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const B=[],T=[],A=[],O=[],_=[];let Y,ie=0;const ae=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const he of ae)H(he)?F.addMode?B.push(he):T.push(he):V(he)?A.push(he):he.fileUri?(Y||(Y={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),Y.filesToOpenOrCreate.push(he)):he.backupPath?_.push({backupFolder:(0,p.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ie++;F.diffMode&&Y&&Y.filesToOpenOrCreate.length>=2&&(Y.filesToDiff=Y.filesToOpenOrCreate.slice(0,2),Y.filesToOpenOrCreate=[]),Y&&F.waitMarkerFileURI&&(Y.filesToWait={paths:[...Y.filesToDiff,...Y.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:ce,filesOpenedInWindow:ne}=this.doOpen(F,A,T,_,ie,Y,B);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${T.length}, emptyToRestore: ${_.length}, emptyToOpen: ${ie})`),ce.length>1)if(ne)ne.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let me=!0,Pe=!0;if(he){const Ce=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),me=!1,Pe=!1)}if(me)for(let Ce=ce.length-1;Ce>=0;Ce--){const Se=ce[Ce];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&_.some(pe=>Se.backupPath&&pe.backupFolder===(0,p.basename)(Se.backupPath)))){Se.focus(),Pe=!1;break}}Pe&&ce[ce.length-1].focus()}const le=Y&&Y.filesToDiff.length>0;if(!ce.some(he=>he.isExtensionDevelopmentHost)&&!le&&!F.noRecentEntry){const he=[];for(const me of ae)V(me)&&!me.transient?he.push({label:me.label,workspace:me.workspace,remoteAuthority:me.remoteAuthority}):H(me)?he.push({label:me.label,folderUri:me.workspace.uri,remoteAuthority:me.remoteAuthority}):me.fileUri&&he.push({label:me.label,fileUri:me.fileUri,remoteAuthority:me.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(F,ce),ce}handleWaitMarkerFile(F,B){const T=F.waitMarkerFileURI;F.context===0&&T&&B.length===1&&B[0]&&(async()=>{await B[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(F,B,T,A,O,_,Y){const ie=[];let ae;function ce(Se,pe){ie.push(Se),pe&&(ae=Se,_=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&Y.length>0){const Se=Y[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ce(this.doAddFoldersToExistingWindow(pe,Y.map(be=>be.workspace.uri)))}const he=T.length+B.length+A.length;if(_&&he===0){const Se=_.filesToOpenOrCreate[0]||_.filesToDiff[0],pe=this.getWindows().filter(Re=>_&&(0,v.isEqualAuthority)(Re.remoteAuthority,_.remoteAuthority));let be;Se?.fileUri&&!le&&((F.context===4||F.context===0||F.context===1)&&(be=(0,x.findWindowOnFile)(pe,Se.fileUri,Re=>Re.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),be||(be=this.doGetLastActiveWindow(pe))),be?(0,G.isWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,G.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?T.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(F,be,_),!0):ce(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const me=(0,C.distinct)(B,Se=>Se.workspace.id);if(me.length>0){const Se=(0,C.coalesce)(me.map(pe=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,be),!!be),ne=!0}me.forEach(pe=>{if(Se.some(Ue=>Ue.openedWorkspace&&Ue.openedWorkspace.id===pe.workspace.id))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(_?.remoteAuthority,be)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Re),!!Re),ne=!0})}const Pe=(0,C.distinct)(T,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(Pe.length>0){const Se=(0,C.coalesce)(Pe.map(pe=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,be),!!be),ne=!0}Pe.forEach(pe=>{if(Se.some(Ue=>(0,G.isSingleFolderWorkspaceIdentifier)(Ue.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ue.openedWorkspace.uri,pe.workspace.uri)))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(_?.remoteAuthority,be)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Re),!!Re),ne=!0})}const Ce=(0,C.distinct)(A,Se=>Se.backupFolder);if(Ce.length>0&&Ce.forEach(Se=>{const pe=Se.remoteAuthority,be=(0,v.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;ce(this.doOpenEmpty(F,!0,pe,be,Se),!!be),ne=!0}),ie.length===0||_){_&&!O&&O++;const Se=_?_.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<O;pe++)ce(this.doOpenEmpty(F,ne,Se,_),!!_),ne=!0}return{windows:(0,C.distinct)(ie),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(F,B,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),B.focus();const A={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return B.sendWhenReady("vscode:openFiles",M.CancellationToken.None,A),B}doAddFoldersToExistingWindow(F,B){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:B}),F.focus();const T={foldersToAdd:B};return F.sendWhenReady("vscode:addFolders",M.CancellationToken.None,T),F}doOpenEmpty(F,B,T,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:A,forceNewWindow:B});let _;return!B&&typeof F.contextWindowId=="number"&&(_=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:T,forceNewWindow:B,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:_,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(F,B,T,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:B,filesToOpen:A}),!T&&!O&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:B.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:B.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(F){let B,T=!1,A=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(F),T=!0):F.forceEmpty?B=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(B=this.doExtractPathsFromCLI(F.cli),B.length===0&&B.push(Object.create(null)),T=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),A=!0),!F.addMode&&T){const O=B.filter(_=>H(_));if(O.length>1){const _=O[0].remoteAuthority;if(O.every(Y=>(0,v.isEqualAuthority)(Y.remoteAuthority,_))){const Y=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ie=>({uri:ie.workspace.uri})));B.push({workspace:Y,remoteAuthority:_}),B=B.filter(ie=>!H(ie))}}}return F.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(O=>V(O)||H(O)||O.backupPath)),B}doExtractPathsFromAPI(F){const B=[],T={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const A of(0,C.coalesce)(F.urisToOpen||[])){const O=this.resolveOpenable(A,T);if(O)O.label=A.label,B.push(O);else{const _=this.resourceFromOpenable(A),Y={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:_.scheme===I.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:_.scheme===I.Schemas.file?(0,f.localize)(3,null,(0,E.getPathLabel)(_.fsPath,this.environmentMainService)):(0,f.localize)(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(Y,(0,P.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return B}doExtractPathsFromCLI(F){const B=[],T={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},A=F["folder-uri"];if(A)for(const Y of A){const ie=this.cliArgToUri(Y);if(ie){const ae=this.resolveOpenable({folderUri:ie},T);ae&&B.push(ae)}}const O=F["file-uri"];if(O)for(const Y of O){const ie=this.cliArgToUri(Y);if(ie){const ae=this.resolveOpenable((0,G.hasWorkspaceFileExtension)(Y)?{workspaceUri:ie}:{fileUri:ie},T);ae&&B.push(ae)}}const _=F._;for(const Y of _){const ie=T.remoteAuthority?this.doResolvePathRemote(Y,T):this.doResolveFilePath(Y,T);ie&&B.push(ie)}return B}cliArgToUri(F){try{const B=d.URI.parse(F);if(!B.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return B}catch(B){this.logService.error(`Invalid URI input string: ${F}, ${B.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const B=[];F!=="one"&&B.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&B.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const A of B)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});V(O)&&T.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});H(O)&&T.push(O)}else F!=="folders"&&A.backupPath&&T.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return T}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,B=Object.create(null)){let T=this.resourceFromOpenable(F);return T.scheme===I.Schemas.file?((0,j.isFileToOpen)(F)&&(B={...B,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,B)):this.doResolveRemoteOpenable(F,B)}doResolveRemoteOpenable(F,B){let T=this.resourceFromOpenable(F);const A=(0,W.getRemoteAuthority)(T)||B.remoteAuthority;if(T=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(T)),(0,j.isFileToOpen)(F)){if(B.gotoLineMode){const{path:O,line:_,column:Y}=(0,m.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),selection:_?{startLineNumber:_,startColumn:Y||1}:void 0,remoteAuthority:A}}return{fileUri:T,remoteAuthority:A}}else if((0,j.isWorkspaceToOpen)(F))return{workspace:(0,z.getWorkspaceIdentifier)(T),remoteAuthority:A};return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:A}}resourceFromOpenable(F){return(0,j.isWorkspaceToOpen)(F)?F.workspaceUri:(0,j.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,B){let T,A;B.gotoLineMode&&({path:F,line:T,column:A}=(0,m.parseLineAndColumnAware)(F)),F=(0,m.sanitizeFilePath)((0,p.normalize)(F),(0,g.cwd)());try{const O=(0,n.statSync)(F);if(O.isFile()){if(!B.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(F));if(_)return _.transient&&B.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:d.URI.file(F),type:i.FileType.File,exists:!0,selection:T?{startLineNumber:T,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(d.URI.file(F),O),type:i.FileType.Directory,exists:!0};if(!h.isWindows&&F==="/dev/null")return{fileUri:d.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const _=d.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),B.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,B){const T=F.charCodeAt(0),A=B.remoteAuthority;let O,_;B.gotoLineMode&&({path:F,line:O,column:_}=(0,m.parseLineAndColumnAware)(F)),T!==47&&((0,m.isWindowsDriveLetter)(T)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,m.toSlashes)(F)),F=`/${F}`);const Y=d.URI.from({scheme:I.Schemas.vscodeRemote,authority:A,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,G.hasWorkspaceFileExtension)(F))return B.forceOpenWorkspaceAsFile?{fileUri:Y,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:B.remoteAuthority}:{workspace:(0,z.getWorkspaceIdentifier)(Y),remoteAuthority:A};if(B.gotoLineMode||p.posix.basename(F).indexOf(".")!==-1)return{fileUri:Y,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:A}}return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(Y),remoteAuthority:A}}shouldOpenNewWindow(F){const B=this.configurationService.getValue("window"),T=B?.openFoldersInNewWindow||"default",A=B?.openFilesInNewWindow||"off";let O=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let _=!1;return F.forceNewWindow||F.forceReuseWindow?_=!!F.forceNewWindow&&!F.forceReuseWindow:(h.isMacintosh?F.context===1&&(_=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!F.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(_=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(F,B){const T=(0,x.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(T)return this.lifecycleMainService.reload(T,B.cli),T.focus(),[T];let A=B.cli["folder-uri"]||[],O=B.cli["file-uri"]||[],_=B.cli._;if(!_.length&&!A.length&&!O.length&&!B.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=ce&&(ce.workspace||ce.folderUri);ne&&(d.URI.isUri(ne)?ne.scheme===I.Schemas.file?_=[ne.fsPath]:A=[ne.toString()]:ne.configPath.scheme===I.Schemas.file?_=[(0,v.originalFSPath)(ne.configPath)]:O=[ne.configPath.toString()])}let Y=B.remoteAuthority;for(const ce of F)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=d.URI.parse(ce),le=(0,W.getRemoteAuthority)(ne);le&&(Y?(0,v.isEqualAuthority)(le,Y)||this.logService.error("more than one extension development path authority"):Y=le)}_=_.filter(ce=>{const ne=d.URI.file(ce);return(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),Y)}),A=A.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),Y):!1}),O=O.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),Y):!1}),B.cli._=_,B.cli["folder-uri"]=A,B.cli["file-uri"]=O;const ie=!_.length&&!A.length&&!O.length,ae={context:B.context,cli:B.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:B.userEnv,noRecentEntry:!0,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:Y};return this.open(ae)}openInBrowserWindow(F){const B=this.configurationService.getValue("window"),T={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:S.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof B?.zoomLevel=="number"?B.zoomLevel:void 0,autoDetectHighContrast:B?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let A;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(A=F.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,t.mark)("code/willCreateCodeWindow");const _=A=this.instantiationService.createInstance(ee.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(_)}rt.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,y.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,y.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,y.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_));const Y=(0,P.assertIsDefined)(_.win?.webContents);Y.removeAllListeners("devtools-reload-page"),Y.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return T.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,T,F)}):this.doOpenInBrowserWindow(A,T,F),A}doOpenInBrowserWindow(F,B,T){if(!B.extensionDevelopmentPath)if((0,G.isWorkspaceIdentifier)(B.workspace))B.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:B.workspace,remoteAuthority:B.remoteAuthority});else if((0,G.isSingleFolderWorkspaceIdentifier)(B.workspace))B.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:B.workspace.uri,remoteAuthority:B.remoteAuthority});else{const A=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;B.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,B.remoteAuthority)}F.load(B)}onWindowClosed(F){const B=rt.WINDOWS.indexOf(F);rt.WINDOWS.splice(B,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=w.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(B=>(0,v.isEqualAuthority)(B.remoteAuthority,F)))}doGetLastActiveWindow(F){const B=Math.max.apply(Math,F.map(T=>T.lastFocusTime));return F.find(T=>T.lastFocusTime===B)}sendToFocused(F,...B){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(F,M.CancellationToken.None,...B)}sendToAll(F,B,T){for(const A of this.getWindows())T&&T.indexOf(A.id)>=0||A.sendWhenReady(F,M.CancellationToken.None,B)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(F){const B=this.getWindows().filter(T=>T.id===F);return(0,C.firstOrDefault)(B)}getWindowByWebContents(F){const B=w.BrowserWindow.fromWebContents(F);if(!!B)return this.getWindowById(B.id)}};K.WINDOWS=[],K=ue([te(2,l.ILogService),te(3,U.IStateMainService),te(4,r.IEnvironmentMainService),te(5,a.ILifecycleMainService),te(6,c.IBackupMainService),te(7,o.IConfigurationService),te(8,X.IWorkspacesHistoryMainService),te(9,re.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,u.IDialogMainService),te(12,i.IFileService),te(13,D.IProductService),te(14,L.IProtocolMainService)],K),e.WindowsMainService=K}),define(J[245],Z([0,1,51,34,68,42]),function(q,e,w,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(m,y,E,k){this.workspacesManagementMainService=m,this.windowsMainService=y,this.workspacesHistoryMainService=E,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(m,y){const E=this.windowsMainService.getWindowById(m);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(m,y,E){return this.workspacesManagementMainService.createUntitledWorkspace(y,E)}deleteUntitledWorkspace(m,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(m,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}getRecentlyOpened(m){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(m))}addRecentlyOpened(m,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}removeRecentlyOpened(m,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}clearRecentlyOpened(m){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([te(0,C.IWorkspacesManagementMainService),te(1,n.IWindowsMainService),te(2,R.IWorkspacesHistoryMainService),te(3,w.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[246],Z([0,1,12,29,26,17,39,15,28,43,44,33,2,10,8,3,14,7,31,72,125,37,128,89,219,138,51,228,19,75,193,166,76,103,47,229,92,164,22,50,98,172,194,173,225,93,174,175,20,188,78,74,5,77,238,204,104,18,6,190,243,58,21,79,233,80,38,222,81,205,32,207,209,64,41,213,236,239,237,240,100,214,215,216,217,220,34,244,221,25,67,68,245,42]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r,i,s,a,l,S,D,L,W,U,j,ee,x,N,G,z,X,re,V,H,K,$,F,B,T,A,O,_,Y,ie,ae,ce,ne,le,he,me,Pe,Ce,Se,pe,be,Re,Ue,Ze,Fe,Be,Ge,st,pt,ot,Ye,qe,Qe,Q,se,oe,fe,ye,Le,Oe,Ke,He,Ae,$e,Ve,xe,it,It,Dt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let vt=class extends I.Disposable{constructor(de,we,ve,ge,ke,De,Me,Ee,Ie,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=we,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ee,this.fileService=Ie,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ee=>Ee?.startsWith(`${p.Schemas.vscodeWebview}://`),we=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?We(we.has(Ie)):We(!1)),w.session.defaultSession.setPermissionCheckHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?we.has(Ie):!1);const ve=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,"devtools"]),ge=Ee=>{for(let Ie=Ee;Ie;Ie=Ie.parent)if(Ie.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},ke=Ee=>Ee.resourceType==="xhr"||ge(Ee.frame),De=Ee=>{const Ie=Ee.frame;if(!Ie||!this.windowsMainService)return!1;const We=w.BrowserWindow.getAllWindows();for(const Ne of We)if(Ie.processId===Ne.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ee,Ie)=>{const We=v.URI.parse(Ee.url);return We.scheme===p.Schemas.vscodeFileResource&&!De(Ee)?(this.logService.error("Blocked vscode-file request",Ee.url),Ie({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?Ie({cancel:!ke(Ee)}):Ie({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ee,Ie)=>{const We=Ee.responseHeaders,Ne=We["content-type"]||We["Content-Type"];if(Ne&&Array.isArray(Ne)){const Xe=v.URI.parse(Ee.url);if(Xe.path.endsWith(".svg")&&ve.has(Xe.scheme))return We["Content-Type"]=["image/svg+xml"],Ie({cancel:!1,responseHeaders:We});if(!Xe.path.includes(p.Schemas.vscodeRemoteResource)&&Ne.some(tt=>tt.toLowerCase().includes("image/svg")))return Ie({cancel:!ke(Ee)})}return Ie({cancel:!1})});const Me=w.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,b.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,b.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),w.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),ge.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let de=[],we;w.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),we!==void 0&&(clearTimeout(we),we=void 0),we=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],we=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let ke,De;return ge?.config?(ke=ge.config,De={...process.env,...ge.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),w.ipcMain.handle("vscode:writeNlsFile",(ve,ge,ke)=>{const De=this.validateNlsPath([ge]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(ke))}),w.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const ke=this.validateNlsPath(ge);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let we;for(const ve of de)typeof ve=="string"&&(typeof we!="string"?we=ve:we=(0,t.join)(we,ve));if(!(typeof we!="string"||!(0,t.isAbsolute)(we)||!(0,m.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return v.URI.file(we)}onUnexpectedError(de){if(de){const we={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(we))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;h.isWindows&&de&&w.app.setAppUserModelId(de);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ie){this.logService.error(Ie)}const we=new o.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(ve),Me=await this.initServices(ve,ge,ke);if(this.environmentMainService.driverHandle){const Ie=await(0,ee.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ie)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Ie=>this.initChannels(Ie,we,De));const Ee=Me.invokeFunction(Ie=>this.openFirstWindow(Ie,we));Me.invokeFunction(Ie=>this.afterWindowOpen(Ie,ge)),this.environmentMainService.args.trace&&Me.invokeFunction(Ie=>this.stopTracingEventually(Ie,Ee))}async resolveMachineId(){let de=this.stateMainService.getItem(Ge.machineIdKey);return(!de||h.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,d.getMachineId)(),this.stateMainService.setItem(Ge.machineIdKey,de)),de}setupSharedProcess(de){const we=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new u.Client(ke,"main")})(),ge=(async()=>(await we.whenReady(),ve))();return{sharedProcess:we,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,we,ve){const ge=new ie.ServiceCollection;switch(process.platform){case"win32":ge.set(Ye.IUpdateService,new _.SyncDescriptor(oe.Win32UpdateService));break;case"linux":h.isLinuxSnap?ge.set(Ye.IUpdateService,new _.SyncDescriptor(se.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Ye.IUpdateService,new _.SyncDescriptor(Q.LinuxUpdateService));break;case"darwin":ge.set(Ye.IUpdateService,new _.SyncDescriptor(Qe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new _.SyncDescriptor($e.WindowsMainService,[de,this.userEnv])),ge.set(j.IDialogMainService,new _.SyncDescriptor(j.DialogMainService)),ge.set(ne.ILaunchMainService,new _.SyncDescriptor(ne.LaunchMainService)),ge.set(U.IDiagnosticsMainService,new _.SyncDescriptor(U.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ae.IIssueMainService,new _.SyncDescriptor(ae.IssueMainService,[this.userEnv])),ge.set(x.IEncryptionMainService,new _.SyncDescriptor(N.EncryptionMainService,[de])),ge.set(ce.IKeyboardLayoutMainService,new _.SyncDescriptor(ce.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new _.SyncDescriptor(Ce.NativeHostMainService,[we])),ge.set(S.ICredentialsMainService,new _.SyncDescriptor(D.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new _.SyncDescriptor(He.WebviewMainService)),ge.set(it.IWorkspacesService,new _.SyncDescriptor(Dt.WorkspacesMainService)),ge.set(kt.IWorkspacesManagementMainService,new _.SyncDescriptor(kt.WorkspacesManagementMainService)),ge.set(It.IWorkspacesHistoryMainService,new _.SyncDescriptor(It.WorkspacesHistoryMainService)),ge.set(Pe.IMenubarMainService,new _.SyncDescriptor(Pe.MenubarMainService)),ge.set(re.IExtensionUrlTrustService,new _.SyncDescriptor(V.ExtensionUrlTrustService)),ge.set(H.IExtensionHostStarter,new _.SyncDescriptor(K.WorkerMainProcessExtensionHostStarter)),ge.set(Fe.IStorageMainService,new _.SyncDescriptor(Fe.StorageMainService)),ge.set(Fe.IGlobalStorageMainService,new _.SyncDescriptor(Fe.GlobalStorageMainService)),h.isWindows?ge.set($.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):h.isMacintosh?ge.set($.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):h.isLinux&&ge.set($.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const ke=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(s.IBackupMainService,ke),ge.set(fe.IURLService,new _.SyncDescriptor(Le.NativeURLService)),(0,ot.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(Ne=>Ne.getChannel("telemetryAppender"))),Me=new st.TelemetryAppenderClient(De),Ee=(0,Be.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ie=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[Me],commonProperties:Ee,piiPaths:Ie,sendErrorTelemetry:!0};ge.set(Ge.ITelemetryService,new _.SyncDescriptor(pt.TelemetryService,[We]))}else ge.set(Ge.ITelemetryService,ot.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,we,ve){const ge=c.ProxyChannel.fromService(de.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const ke=c.ProxyChannel.fromService(de.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const De=this.fileService.getProvider(p.Schemas.file);(0,g.assertType)(De instanceof O.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);we.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ve.then(je=>je.registerChannel(B.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ee=new qe.UpdateChannel(de.get(Ye.IUpdateService));we.registerChannel("update",Ee);const Ie=c.ProxyChannel.fromService(de.get(ae.IIssueMainService));we.registerChannel("issue",Ie);const We=c.ProxyChannel.fromService(de.get(x.IEncryptionMainService));we.registerChannel("encryption",We);const Ne=c.ProxyChannel.fromService(de.get(S.ICredentialsMainService));we.registerChannel("credentials",Ne);const Xe=c.ProxyChannel.fromService(de.get(Re.ISignService));we.registerChannel("sign",Xe);const tt=c.ProxyChannel.fromService(de.get(ce.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",tt),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const dt=c.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",dt),ve.then(je=>je.registerChannel("nativeHost",dt));const _e=c.ProxyChannel.fromService(de.get(it.IWorkspacesService));we.registerChannel("workspaces",_e);const ft=c.ProxyChannel.fromService(de.get(Pe.IMenubarMainService));we.registerChannel("menubar",ft);const at=c.ProxyChannel.fromService(de.get(fe.IURLService));we.registerChannel("url",at);const ct=c.ProxyChannel.fromService(de.get(re.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",ct);const gt=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));we.registerChannel("webview",gt);const lt=this._register(new Ze.StorageDatabaseChannel(this.logService,de.get(Fe.IStorageMainService)));we.registerChannel("storage",lt),ve.then(je=>je.registerChannel("storage",lt));const ut=c.ProxyChannel.fromService(de.get($.IExternalTerminalMainService));we.registerChannel("externalTerminal",ut);const nt=new me.LogLevelChannel(de.get(he.ILogService));we.registerChannel("logLevel",nt),ve.then(je=>je.registerChannel("logLevel",nt));const ht=new me.LoggerChannel(de.get(he.ILoggerService));we.registerChannel("logger",ht),ve.then(je=>je.registerChannel("logger",ht));const Te=new L.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));we.registerChannel("extensionhostdebugservice",Te);const et=c.ProxyChannel.fromService(de.get(H.IExtensionHostStarter));we.registerChannel(H.ipcExtensionHostStarterChannelName,et)}openFirstWindow(de,we){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),ke=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:v.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const et=this.getWindowOpenableFromProtocolLink(Te.uri);return et?(De.push(et),!1):!0}),Ee=this,Ie=this.environmentMainService,We=this.productService;ge.registerHandler({async handleURL(Te,et){if(Te.scheme===We.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:v.URI.parse(Te.query).path,query:""})),Ee.shouldBlockURI(Te))return!0;const je=Ee.getWindowOpenableFromProtocolLink(Te);if(je){const[yt]=ve.open({context:5,cli:{...Ie.args},urisToOpen:[je],gotoLineMode:!0});return yt.focus(),!0}if(h.isMacintosh&&ve.getWindowCount()===0){const[yt]=ve.open({context:5,cli:{...Ie.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Te)});return await yt.ready(),ge.open(Te,et)}return!1}});const Ne=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Xe=new c.StaticRouter(Te=>Ne.getActiveClientId().then(et=>Te===et)),tt=new ye.URLHandlerRouter(Xe),dt=we.getChannel("urlHandler",tt);ge.registerHandler(new ye.URLHandlerChannelClient(dt)),this._register(new Oe.ElectronURLListener(Me,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,ft=global.macOpenFiles,at=(0,z.isLaunchedFromCli)(process.env)?0:4,ct=_e._.length,gt=!!_e["folder-uri"],lt=!!_e["file-uri"],ut=_e["skip-add-to-recently-opened"]===!0,nt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,ht=_e.remote||void 0;return De.length>0?ve.open({context:at,cli:_e,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!ct&&!gt&&!lt?ve.open({context:at,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ht}):ft.length&&!ct&&!gt&&!lt?ve.open({context:1,cli:_e,urisToOpen:ft.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0}):ve.open({context:at,cli:_e,forceNewWindow:_e["new-window"]||!ct&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:ut,waitMarkerFileURI:nt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(de){return!!(de.authority===p.Schemas.file&&h.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,k.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===p.Schemas.file){const we=v.URI.file(de.fsPath);return(0,xe.hasWorkspaceFileExtension)(we)?{workspaceUri:we}:{fileUri:we}}else if(de.authority===p.Schemas.vscodeRemote){const we=de.path.indexOf(t.posix.sep,1);if(we!==-1){const ve=de.path.substring(1,we),ge=de.path.substring(we),ke=v.URI.from({scheme:p.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,xe.hasWorkspaceFileExtension)(ge)?{workspaceUri:ke}:/:[\d]+$/.test(ge)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,xe.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,we){this.lifecycleMainService.phase=3;let ve=!1;(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ge.ITelemetryService);this._register(we.onDidError(({type:Me,details:Ee})=>{let Ie;switch(Me){case 1:Ie="SharedProcess: detected unresponsive window";break;case 2:Ie=`SharedProcess: crashed (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break;case 3:Ie=`SharedProcess: failed to load (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Ie)),ge.publicLog2("sharedprocesserror",{type:Me,reason:Ee?.reason,code:Ee?.exitCode,visible:we.isVisible(),shuttingdown:ve})}));const ke=this.productService.win32MutexName;if(h.isWindows&&ke)try{const Me=q.__$__nodeRequire("windows-mutex").Mutex,Ee=new Me(ke);(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee.release())}catch(Me){this.logService.error(Me)}w.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Me,Ee)=>{Ee({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=de.get(Ye.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof Q.LinuxUpdateService||De instanceof Qe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ee=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,E.stripComments)(Ee))["enable-crash-reporter"]===void 0){const Ne=(0,ot.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ne},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,P.generateUuid)()}"`,"}"],tt=Ee.substring(0,Ee.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(tt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,we,ve){try{return await(0,X.getResolvedShellEnv)(this.logService,de,we)}catch(ge){const ke=(0,M.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(de,we){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(j.IDialogMainService);let ge=!1;const ke=async Me=>{if(ge)return;ge=!0;const Ee=await w.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ee}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ee),buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,g.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(we.map(Me=>Me.ready())).then(()=>{clearTimeout(De),ke(!1)})}};vt=ue([te(2,Y.IInstantiationService),te(3,he.ILogService),te(4,G.IEnvironmentMainService),te(5,le.ILifecycleMainService),te(6,l.IConfigurationService),te(7,Ue.IStateMainService),te(8,T.IFileService),te(9,Se.IProductService)],vt),e.CodeApplication=vt}),define(J[253],Z([0,1,12,29,30,9,39,15,28,43,33,10,8,63,3,36,27,24,37,57,246,11,19,198,206,22,50,169,20,186,78,74,180,77,18,95,6,191,96,53,21,54,195,99,235,56,232,80,203,38,234,64,65,212]),function(q,e,w,n,R,C,M,b,m,y,E,k,I,p,t,h,g,v,P,d,f,c,o,u,r,i,s,a,l,S,D,L,W,U,j,ee,x,N,G,z,X,re,V,H,K,$,F,B,T,A,O,_,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),w.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(pe=>console.error(pe));const[ne,le,he,me,Pe,Ce,Se]=this.createServices();try{try{await this.initServices(he,me,Pe)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await ne.invokeFunction(async pe=>{const be=pe.get(x.ILogService),Re=pe.get(j.ILifecycleMainService),Ue=pe.get(l.IFileService),Ze=await this.claimInstance(be,he,Re,ne,Se,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Fe=>{be.warn(`Error writing main lockfile: ${Fe.stack}`)}),Ce.logger=new G.SpdLogLogger("main",(0,I.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,y.once)(Re.onWillShutdown)(Fe=>{Ue.dispose(),me.dispose(),Fe.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),ne.createInstance(f.CodeApplication,Ze,le).startup()})}catch(pe){ne.invokeFunction(this.quit,pe)}}createServices(){const ne=new U.ServiceCollection,le={_serviceBrand:void 0,...z.default};ne.set(X.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),me=this.patchEnvironment(he);ne.set(i.IEnvironmentMainService,he);const Pe=new ee.BufferLogService,Ce=new x.MultiplexLogService([new x.ConsoleMainLogger((0,x.getLogLevel)(he)),Pe]);process.once("exit",()=>Ce.dispose()),ne.set(x.ILogService,Ce);const Se=new S.FileService(Ce);ne.set(l.IFileService,Se);const pe=new D.DiskFileSystemProvider(Ce);Se.registerProvider(k.Schemas.file,pe),ne.set(x.ILoggerService,new N.LoggerService(Ce,Se));const be=new u.ConfigurationService(he.settingsResource,Se);ne.set(o.IConfigurationService,be),ne.set(j.ILifecycleMainService,new L.SyncDescriptor(j.LifecycleMainService));const Re=new O.StateMainService(he,Ce,Se);return ne.set(A.IStateMainService,Re),ne.set($.IRequestService,new L.SyncDescriptor(F.RequestMainService)),ne.set(Y.IThemeMainService,new L.SyncDescriptor(Y.ThemeMainService)),ne.set(B.ISignService,new L.SyncDescriptor(T.SignService)),ne.set(H.ITunnelService,new L.SyncDescriptor(K.TunnelService)),ne.set(re.IProtocolMainService,new L.SyncDescriptor(V.ProtocolMainService)),[new W.InstantiationService(ne,!0),me,he,be,Re,Pe,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const me=process.env[he];typeof me=="string"&&(le[he]=me)}),Object.assign(process.env,le),le}initServices(ne,le,he){return C.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(me=>me?v.Promises.mkdir(me,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(ne,le,he,me,Pe,Ce){let Se;try{(0,p.mark)("code/willStartMainServer"),Se=await(0,d.serve)(le.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,y.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,Pe.nameLong,pe),pe;let be;try{be=await(0,d.connect)(le.mainIPCHandle,"main")}catch(Fe){if(!Ce||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,Pe.nameShort),(0,c.localize)(1,null),Pe.nameLong),Fe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(Be){throw ne.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(ne,le,he,me,Pe,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Fe),be.dispose(),new Error(Fe)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,Pe.nameShort),(0,c.localize)(3,null),Pe.nameLong)},1e4));const Ue=P.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0}),Ze=P.ProxyChannel.toService(be.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return me.invokeFunction(async()=>{const Fe=new r.DiagnosticsService(_.NullTelemetryService,Pe),Be=await Ue.getMainProcessInfo(),Ge=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),st=await Fe.getDiagnostics(Be,Ge);throw console.log(st),new b.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ue,ne),ne.trace("Sending env to running instance..."),await Ue.start(le.args,process.env),be.dispose(),Re&&clearTimeout(Re),new b.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(ne,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const me=(0,R.coalesce)([ne.userDataPath,ne.extensionsPath,d.XDG_RUNTIME_DIR]).map(Pe=>(0,E.getPathLabel)(Pe,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,M.toErrorMessage)(he),me.join(`
`)),le)}}showStartupWarningDialog(ne,le,he){w.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(t.isWindows){const he=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((me,Pe)=>{q(["windows-foreground-love"],me,Pe)})).allowSetForegroundWindow(he)}catch(me){le.error(me)}}}quit(ne,le){const he=ne.get(x.ILogService),me=ne.get(j.ILifecycleMainService);let Pe=0;le&&(le.isExpected?le.message&&he.trace(le.message):(Pe=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),me.kill(Pe)}resolveArgs(){const ne=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,a.createWaitMarkerFile)(ne.verbose);le&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const he=(0,h.cwd)(),me=ne.map(Se=>{let pe=String(Se),be;le&&(be=(0,m.parseLineAndColumnAware)(pe),pe=be.path),pe&&(pe=this.preparePath(he,pe));const Re=(0,m.sanitizeFilePath)(pe,he),Ue=(0,I.basename)(Re);return Ue&&!(0,m.isValidBasename)(Ue)?null:le&&be?(be.path=Re,this.toPath(be)):Re}),Pe=t.isWindows||t.isMacintosh,Ce=(0,R.distinct)(me,Se=>Se&&Pe?Se.toLowerCase():Se||"");return(0,R.coalesce)(Ce)}preparePath(ne,le){return t.isWindows&&(le=(0,g.rtrim)(le,'"')),le=(0,g.trim)((0,g.trim)(le," "),"	"),t.isWindows&&(le=(0,I.resolve)(ne,le),le=(0,g.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8c36556a2c305327f5417dc7f93220f39ed608f/core/vs/code/electron-main/main.js.map
