/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],be=function(te){for(var e=[],h=0,t=te.length;h<t;h++)e[h]=we[te[h]];return e};define(we[55],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(t,k){if(!t)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=h}),define(we[73],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function h(S){return S?S.replace(/\$\((.*?)\)/g,(D,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=h;class t{constructor(D,_,R){this.id=D,this.definition=_,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(S,D){const _=["codicon","codicon-"+S];return D&&_.push("codicon-modifier-"+D),_}e.getClassNamesArray=k;var A;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function _(I){if(I instanceof t)return["codicon","codicon-"+I.id];const p=D.exec(I.id);if(!p)return _(t.error);let[,E,v]=p;const d=["codicon","codicon-"+E];return v&&d.push("codicon-modifier-"+v.substr(1)),d}S.asClassNameArray=_;function R(I){return _(I).join(" ")}S.asClassName=R;function F(I){return"."+_(I).join(".")}S.asCSSSelector=F})(A=e.CSSIcon||(e.CSSIcon={}))}),define(we[74],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function t(F){const I=[];for(let p in F)h.call(F,p)&&I.push(F[p]);return I}e.values=t;function k(F,I){for(let p in F)if(h.call(F,p)&&I({key:p,value:F[p]},function(){delete F[p]})===!1)return}e.forEach=k;function A(F,I){const p=Object.create(null);for(const E of F){const v=I(E);let d=p[v];d||(d=p[v]=[]),d.push(E)}return p}e.groupBy=A;function S(F){const I=Object.create(null);return F&&F.forEach((p,E)=>{I[E]=p}),I}e.fromMap=S;function D(F,I){const p=[],E=[];for(let v of F)I.has(v)||p.push(v);for(let v of I)F.has(v)||E.push(v);return{removed:p,added:E}}e.diffSets=D;function _(F,I){const p=[],E=[];for(let[v,d]of F)I.has(v)||p.push(d);for(let[v,d]of I)F.has(v)||E.push(d);return{removed:p,added:E}}e.diffMaps=_;class R{constructor(){this.map=new Map}add(I,p){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(p)}delete(I,p){const E=this.map.get(I);!E||(E.delete(p),E.size===0&&this.map.delete(I))}forEach(I,p){const E=this.map.get(I);!E||E.forEach(p)}}e.SetMap=R}),define(we[56],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(S){return(D,_,R)=>{let F=null,I=null;if(typeof R.value=="function"?(F="value",I=R.value):typeof R.get=="function"&&(F="get",I=R.get),!I)throw new Error("not supported");R[F]=S(I,_)}}e.createDecorator=h;function t(S,D,_){let R=null,F=null;if(typeof _.value=="function"?(R="value",F=_.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(R="get",F=_.get),!F)throw new Error("not supported");const I=`$memoize$${D}`;_[R]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,p)}),this[I]}}e.memoize=t;function k(S,D,_){return h((R,F)=>{const I=`$debounce$${F}`,p=`$debounce$result$${F}`;return function(...E){this[p]||(this[p]=_?_():void 0),clearTimeout(this[I]),D&&(this[p]=D(this[p],...E),E=[this[p]]),this[I]=setTimeout(()=>{R.apply(this,E),this[p]=_?_():void 0},S)}})}e.debounce=k;function A(S,D,_){return h((R,F)=>{const I=`$throttle$timer$${F}`,p=`$throttle$result$${F}`,E=`$throttle$lastRun$${F}`,v=`$throttle$pending$${F}`;return function(...d){if(this[p]||(this[p]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),D&&(this[p]=D(this[p],...d)),this[v])return;const w=this[E]+S;w<=Date.now()?(this[E]=Date.now(),R.apply(this,[this[p]]),this[p]=_?_():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),R.apply(this,[this[p]]),this[p]=_?_():void 0},w-Date.now()))}})}e.throttle=A}),define(we[16],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(b=>{b(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=h,e.errorHandler=new h;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function k(f){_(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=k;function A(f){_(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=A;function S(f){if(f instanceof Error){let{name:s,message:b}=f;const o=f.stacktrace||f.stack;return{$isError:!0,name:s,message:b,stack:o}}return f}e.transformErrorForSerialization=S;const D="Canceled";function _(f){return f instanceof R?!0:f instanceof Error&&f.name===D&&f.message===D}e.isCancellationError=_;class R extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=R;function F(){const f=new Error(D);return f.name=f.message,f}e.canceled=F;function I(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=I;function p(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=p;function E(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function v(f){const s=new Error(`${f} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function d(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=d;class w extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=w;class C extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=C;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(f){const s=f;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=l;function c(f,s=Object.create(null)){const b=new Error(f);return s.actions&&(b.actions=s.actions),b}e.createErrorWithActions=c}),define(we[17],be([1,0,16]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Z,Y=0){return Z[Z.length-(1+Y)]}e.tail=t;function k(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=k;function A(Z,Y,se=(de,ve)=>de===ve){if(Z===Y)return!0;if(!Z||!Y||Z.length!==Y.length)return!1;for(let de=0,ve=Z.length;de<ve;de++)if(!se(Z[de],Y[de]))return!1;return!0}e.equals=A;function S(Z,Y,se){let de=0,ve=Z.length-1;for(;de<=ve;){const Te=(de+ve)/2|0,Me=se(Z[Te],Y);if(Me<0)de=Te+1;else if(Me>0)ve=Te-1;else return Te}return-(de+1)}e.binarySearch=S;function D(Z,Y){let se=0,de=Z.length;if(de===0)return 0;for(;se<de;){const ve=Math.floor((se+de)/2);Y(Z[ve])?de=ve:se=ve+1}return se}e.findFirstInSorted=D;function _(Z,Y,se){if(Z=Z|0,Z>=Y.length)throw new TypeError("invalid index");let de=Y[Math.floor(Y.length*Math.random())],ve=[],Te=[],Me=[];for(let _e of Y){const Ee=se(_e,de);Ee<0?ve.push(_e):Ee>0?Te.push(_e):Me.push(_e)}return Z<ve.length?_(Z,ve,se):Z<ve.length+Me.length?Me[0]:_(Z-(ve.length+Me.length),Te,se)}e.quickSelect=_;function R(Z,Y){const se=[];let de;for(const ve of Z.slice(0).sort(Y))!de||Y(de[0],ve)!==0?(de=[ve],se.push(de)):de.push(ve);return se}e.groupBy=R;function F(Z,Y,se){const de=[];function ve(_e,Ee,$){if(Ee===0&&$.length===0)return;const U=de[de.length-1];U&&U.start+U.deleteCount===_e?(U.deleteCount+=Ee,U.toInsert.push(...$)):de.push({start:_e,deleteCount:Ee,toInsert:$})}let Te=0,Me=0;for(;;){if(Te===Z.length){ve(Te,0,Y.slice(Me));break}if(Me===Y.length){ve(Te,Z.length-Te,[]);break}const _e=Z[Te],Ee=Y[Me],$=se(_e,Ee);$===0?(Te+=1,Me+=1):$<0?(ve(Te,1,[]),Te+=1):$>0&&(ve(Te,0,[Ee]),Me+=1)}return de}e.sortedDiff=F;function I(Z,Y,se){const de=F(Z,Y,se),ve=[],Te=[];for(const Me of de)ve.push(...Z.slice(Me.start,Me.start+Me.deleteCount)),Te.push(...Me.toInsert);return{removed:ve,added:Te}}e.delta=I;function p(Z,Y,se){if(se===0)return[];const de=Z.slice(0,se).sort(Y);return v(Z,Y,de,se,Z.length),de}e.top=p;function E(Z,Y,se,de,ve){return se===0?Promise.resolve([]):new Promise((Te,Me)=>{(async()=>{const _e=Z.length,Ee=Z.slice(0,se).sort(Y);for(let $=se,U=Math.min(se+de,_e);$<_e;$=U,U=Math.min(U+de,_e)){if($>se&&await new Promise(N=>setTimeout(N)),ve&&ve.isCancellationRequested)throw(0,h.canceled)();v(Z,Y,Ee,$,U)}return Ee})().then(Te,Me)})}e.topAsync=E;function v(Z,Y,se,de,ve){for(const Te=se.length;de<ve;de++){const Me=Z[de];if(Y(Me,se[Te-1])<0){se.pop();const _e=D(se,Ee=>Y(Me,Ee)<0);se.splice(_e,0,Me)}}}function d(Z){return Z.filter(Y=>!!Y)}e.coalesce=d;function w(Z){let Y=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[Y]=Z[se],Y+=1);Z.length=Y}e.coalesceInPlace=w;function C(Z,Y,se){Z.splice(se,0,Z.splice(Y,1)[0])}e.move=C;function P(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=P;function l(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=l;function c(Z,Y=se=>se){const se=new Set;return Z.filter(de=>{const ve=Y(de);return se.has(ve)?!1:(se.add(ve),!0)})}e.distinct=c;function f(Z){const Y=new Set;return se=>{const de=Z(se);return Y.has(de)?!1:(Y.add(de),!0)}}e.uniqueFilter=f;function s(Z,Y){const se=b(Z,Y);if(se!==-1)return Z[se]}e.findLast=s;function b(Z,Y){for(let se=Z.length-1;se>=0;se--){const de=Z[se];if(Y(de))return se}return-1}e.lastIndex=b;function o(Z,Y){return Z.length>0?Z[0]:Y}e.firstOrDefault=o;function i(Z,Y,se=(de,ve)=>de===ve){let de=0;for(let ve=0,Te=Math.min(Z.length,Y.length);ve<Te&&se(Z[ve],Y[ve]);ve++)de++;return de}e.commonPrefixLength=i;function r(Z){return[].concat(...Z)}e.flatten=r;function n(Z,Y){let se=typeof Y=="number"?Z:0;typeof Y=="number"?se=Z:(se=0,Y=Z);const de=[];if(se<=Y)for(let ve=se;ve<Y;ve++)de.push(ve);else for(let ve=se;ve>Y;ve--)de.push(ve);return de}e.range=n;function a(Z,Y,se){return Z.reduce((de,ve)=>(de[Y(ve)]=se?se(ve):ve,de),Object.create(null))}e.index=a;function g(Z,Y){return Z.push(Y),()=>u(Z,Y)}e.insert=g;function u(Z,Y){const se=Z.indexOf(Y);if(se>-1)return Z.splice(se,1),Y}e.remove=u;function m(Z,Y,se){const de=Z.slice(0,Y),ve=Z.slice(Y);return de.concat(se,ve)}e.arrayInsert=m;function T(Z,Y){let se;if(typeof Y=="number"){let de=Y;se=()=>{const ve=Math.sin(de++)*179426549;return ve-Math.floor(ve)}}else se=Math.random;for(let de=Z.length-1;de>0;de-=1){const ve=Math.floor(se()*(de+1)),Te=Z[de];Z[de]=Z[ve],Z[ve]=Te}}e.shuffle=T;function O(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.unshift(Y))}e.pushToStart=O;function L(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.push(Y))}e.pushToEnd=L;function y(Z,Y){return Array.isArray(Z)?Z.map(Y):Y(Z)}e.mapArrayOrNot=y;function H(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=H;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function z(Z,Y){for(const se of Z){const de=Y(se);if(de!==void 0)return de}}e.mapFind=z;function x(Z,Y,se){const de=B(Z,Y),ve=Z.length,Te=se.length;Z.length=ve+Te;for(let Me=ve-1;Me>=de;Me--)Z[Me+Te]=Z[Me];for(let Me=0;Me<Te;Me++)Z[Me+de]=se[Me]}e.insertInto=x;function K(Z,Y,se,de){const ve=B(Z,Y),Te=Z.splice(ve,se);return x(Z,ve,de),Te}e.splice=K;function B(Z,Y){return Y<0?Math.max(Y+Z.length,0):Math.min(Y,Z.length)}function G(Z,Y){return(se,de)=>Y(Z(se),Z(de))}e.compareBy=G;const X=(Z,Y)=>Z-Y;e.numberComparator=X;function q(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ve=Z[de];Y(ve,se)>0&&(se=ve)}return se}e.findMaxBy=q;function ee(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ve=Z[de];Y(ve,se)>=0&&(se=ve)}return se}e.findLastMaxBy=ee;function ae(Z,Y){return q(Z,(se,de)=>-Y(se,de))}e.findMinBy=ae;class ue{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let se=this.firstIdx;for(;se<this.items.length&&Y(this.items[se]);)se++;const de=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,de}takeFromEndWhile(Y){let se=this.lastIdx;for(;se>=0&&Y(this.items[se]);)se--;const de=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,de}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const se=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,se}}e.ArrayQueue=ue}),define(we[75],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(t){const k=this;let A=!1,S;return function(){return A||(A=!0,S=t.apply(k,arguments)),S}}e.once=h}),define(we[76],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(we[77],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(t){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function S(){return A}t.empty=S;function*D(f){yield f}t.single=D;function _(f){return f||A}t.from=_;function R(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=R;function F(f){return f[Symbol.iterator]().next().value}t.first=F;function I(f,s){for(const b of f)if(s(b))return!0;return!1}t.some=I;function p(f,s){for(const b of f)if(s(b))return b}t.find=p;function*E(f,s){for(const b of f)s(b)&&(yield b)}t.filter=E;function*v(f,s){let b=0;for(const o of f)yield s(o,b++)}t.map=v;function*d(...f){for(const s of f)for(const b of s)yield b}t.concat=d;function*w(f){for(const s of f)for(const b of s)yield b}t.concatNested=w;function C(f,s,b){let o=b;for(const i of f)o=s(o,i);return o}t.reduce=C;function*P(f,s,b=f.length){for(s<0&&(s+=f.length),b<0?b+=f.length:b>f.length&&(b=f.length);s<b;s++)yield f[s]}t.slice=P;function l(f,s=Number.POSITIVE_INFINITY){const b=[];if(s===0)return[b,f];const o=f[Symbol.iterator]();for(let i=0;i<s;i++){const r=o.next();if(r.done)return[b,t.empty()];b.push(r.value)}return[b,{[Symbol.iterator](){return o}}]}t.consume=l;function c(f,s,b=(o,i)=>o===i){const o=f[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const r=o.next(),n=i.next();if(r.done!==n.done)return!1;if(r.done)return!0;if(!b(r.value,n.value))return!1}}t.equals=c})(h=e.Iterable||(e.Iterable={}))}),define(we[141],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(s,b=!1){let o=0,i=s.length,r="",n=0,a=16,g=0;function u(M){let z=0,x=0;for(;z<M;){const K=s.charCodeAt(o);if(K>=48&&K<=57)x=x*16+K-48;else if(K>=65&&K<=70)x=x*16+K-65+10;else if(K>=97&&K<=102)x=x*16+K-97+10;else break;o++,z++}return z<M&&(x=-1),x}function m(M){o=M,r="",n=0,a=16,g=0}function T(){const M=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&R(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&R(s.charCodeAt(o)))for(o++;o<s.length&&R(s.charCodeAt(o));)o++;else return g=3,s.substring(M,o);let z=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&R(s.charCodeAt(o))){for(o++;o<s.length&&R(s.charCodeAt(o));)o++;z=o}else g=3;return s.substring(M,z)}function O(){let M="",z=o;for(;;){if(o>=i){M+=s.substring(z,o),g=2;break}const x=s.charCodeAt(o);if(x===34){M+=s.substring(z,o),o++;break}if(x===92){if(M+=s.substring(z,o),o++,o>=i){g=2;break}switch(s.charCodeAt(o++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=u(4);B>=0?M+=String.fromCharCode(B):g=4;break}default:g=5}z=o;continue}if(x>=0&&x<=31)if(_(x)){M+=s.substring(z,o),g=2;break}else g=6;o++}return M}function L(){if(r="",g=0,n=o,o>=i)return n=i,a=17;let M=s.charCodeAt(o);if(D(M)){do o++,r+=String.fromCharCode(M),M=s.charCodeAt(o);while(D(M));return a=15}if(_(M))return o++,r+=String.fromCharCode(M),M===13&&s.charCodeAt(o)===10&&(o++,r+=`
`),a=14;switch(M){case 123:return o++,a=1;case 125:return o++,a=2;case 91:return o++,a=3;case 93:return o++,a=4;case 58:return o++,a=6;case 44:return o++,a=5;case 34:return o++,r=O(),a=10;case 47:{const z=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<i&&!_(s.charCodeAt(o));)o++;return r=s.substring(z,o),a=12}if(s.charCodeAt(o+1)===42){o+=2;const x=i-1;let K=!1;for(;o<x;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,K=!0;break}o++}return K||(o++,g=1),r=s.substring(z,o),a=13}return r+=String.fromCharCode(M),o++,a=16}case 45:if(r+=String.fromCharCode(M),o++,o===i||!R(s.charCodeAt(o)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),a=11;default:for(;o<i&&y(M);)o++,M=s.charCodeAt(o);if(n!==o){switch(r=s.substring(n,o),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(M),o++,a=16}}function y(M){if(D(M)||_(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let M;do M=L();while(M>=12&&M<=15);return M}return{setPosition:m,getPosition:()=>o,scan:b?H:L,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>n,getTokenLength:()=>o-n,getTokenError:()=>g}}e.createScanner=S;function D(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function _(s){return s===10||s===13||s===8232||s===8233}function R(s){return s>=48&&s<=57}var F;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(F||(F={}));function I(s,b){const o=[],i=new Object;let r;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(u,m,T,O){n.value=u,n.offset=m,n.length=T,n.type=O,n.colonOffset=void 0,r=n}try{l(s,{onObjectBegin:(u,m)=>{if(b<=u)throw i;r=void 0,a=b>u,o.push("")},onObjectProperty:(u,m,T)=>{if(b<m||(g(u,m,T,"property"),o[o.length-1]=u,b<=m+T))throw i},onObjectEnd:(u,m)=>{if(b<=u)throw i;r=void 0,o.pop()},onArrayBegin:(u,m)=>{if(b<=u)throw i;r=void 0,o.push(0)},onArrayEnd:(u,m)=>{if(b<=u)throw i;r=void 0,o.pop()},onLiteralValue:(u,m,T)=>{if(b<m||(g(u,m,T,f(u)),b<=m+T))throw i},onSeparator:(u,m,T)=>{if(b<=m)throw i;if(u===":"&&r&&r.type==="property")r.colonOffset=m,a=!1,r=void 0;else if(u===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(a=!0,o[o.length-1]=""),r=void 0}}})}catch(u){if(u!==i)throw u}return{path:o,previousNode:r,isAtPropertyKey:a,matches:u=>{let m=0;for(let T=0;m<u.length&&T<o.length;T++)if(u[m]===o[T]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.getLocation=I;function p(s,b=[],o=A.DEFAULT){let i=null,r=[];const n=[];function a(u){Array.isArray(r)?r.push(u):i!==null&&(r[i]=u)}return l(s,{onObjectBegin:()=>{const u={};a(u),n.push(r),r=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const u=[];a(u),n.push(r),r=u,i=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:a,onError:(u,m,T)=>{b.push({error:u,offset:m,length:T})}},o),r[0]}e.parse=p;function E(s,b=[],o=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function n(u){return i.children.push(u),u}l(s,{onObjectBegin:u=>{i=n({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,m,T)=>{i=n({type:"property",offset:m,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:m,length:T,parent:i})},onObjectEnd:(u,m)=>{i.length=u+m-i.offset,i=i.parent,r(u+m)},onArrayBegin:(u,m)=>{i=n({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,m)=>{i.length=u+m-i.offset,i=i.parent,r(u+m)},onLiteralValue:(u,m,T)=>{n({type:f(u),offset:m,length:T,parent:i,value:u}),r(m+T)},onSeparator:(u,m,T)=>{i.type==="property"&&(u===":"?i.colonOffset=m:u===","&&r(m))},onError:(u,m,T)=>{b.push({error:u,offset:m,length:T})}},o);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=E;function v(s,b){if(!s)return;let o=s;for(let i of b)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let r=!1;for(const n of o.children)if(Array.isArray(n.children)&&n.children[0].value===i){o=n.children[1],r=!0;break}if(!r)return}else{const r=i;if(o.type!=="array"||r<0||!Array.isArray(o.children)||r>=o.children.length)return;o=o.children[r]}return o}e.findNodeAtLocation=v;function d(s){if(!s.parent||!s.parent.children)return[];const b=d(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;b.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&b.push(o)}return b}e.getNodePath=d;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const b=Object.create(null);for(let o of s.children){const i=o.children[1];i&&(b[o.children[0].value]=w(i))}return b}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=w;function C(s,b,o=!1){return b>=s.offset&&b<s.offset+s.length||o&&b===s.offset+s.length}e.contains=C;function P(s,b,o=!1){if(C(s,b,o)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=b;r++){const n=P(i[r],b,o);if(n)return n}return s}}e.findNodeAtOffset=P;function l(s,b,o=A.DEFAULT){const i=S(s,!1);function r(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function n(ue){return ue?Z=>ue(Z,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=r(b.onObjectBegin),g=n(b.onObjectProperty),u=r(b.onObjectEnd),m=r(b.onArrayBegin),T=r(b.onArrayEnd),O=n(b.onLiteralValue),L=n(b.onSeparator),y=r(b.onComment),H=n(b.onError),M=o&&o.disallowComments,z=o&&o.allowTrailingComma;function x(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:M||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ue){case 12:case 13:M?K(10):y();break;case 16:K(1);break;case 15:case 14:break;default:return ue}}}function K(ue,Z=[],Y=[]){if(H(ue),Z.length+Y.length>0){let se=i.getToken();for(;se!==17;){if(Z.indexOf(se)!==-1){x();break}else if(Y.indexOf(se)!==-1)break;se=x()}}}function B(ue){const Z=i.getTokenValue();return ue?O(Z):g(Z),x(),!0}function G(){switch(i.getToken()){case 11:{let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(K(2),ue=0)}catch{K(2)}O(ue);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function X(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(L(":"),x(),ae()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function q(){a(),x();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||K(4,[],[]),L(","),x(),i.getToken()===2&&z)break}else ue&&K(6,[],[]);X()||K(4,[],[2,5]),ue=!0}return u(),i.getToken()!==2?K(7,[2],[]):x(),!0}function ee(){m(),x();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||K(4,[],[]),L(","),x(),i.getToken()===4&&z)break}else ue&&K(6,[],[]);ae()||K(4,[],[4,5]),ue=!0}return T(),i.getToken()!==4?K(8,[4],[]):x(),!0}function ae(){switch(i.getToken()){case 3:return ee();case 1:return q();case 10:return B(!0);default:return G()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(K(4,[],[]),!1):ae()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=l;function c(s,b){let o=S(s),i=[],r,n=0,a;do switch(a=o.getPosition(),r=o.scan(),r){case 12:case 13:case 17:n!==a&&i.push(s.substring(n,a)),b!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,b)),n=o.getPosition();break}while(r!==17);return i.join("")}e.stripComments=c;function f(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(we[89],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new h(()=>k(this.getValue()))}}e.Lazy=h}),define(we[6],be([1,0,75,77]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function S(i){A=i}if(e.setDisposableTracker=S,k){const i="__is_disposable_tracked__";S(new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(n)},3e3)}setParent(r,n){if(r&&r!==P.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==P.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function D(i){return A?.trackDisposable(i),i}function _(i){A?.markAsDisposed(i)}function R(i,r){A?.setParent(i,r)}function F(i,r){if(!!A)for(const n of i)A.setParent(n,r)}function I(i){return A?.markAsSingleton(i),i}e.markAsSingleton=I;class p extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=p;function E(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=E;function v(i){if(t.Iterable.is(i)){let r=[];for(const n of i)if(n)try{n.dispose()}catch(a){r.push(a)}if(r.length===1)throw r[0];if(r.length>1)throw new p(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=v;function d(...i){const r=w(()=>v(i));return F(i,r),r}e.combinedDisposable=d;function w(i){const r=D({dispose:(0,h.once)(()=>{_(r),i()})});return r}e.toDisposable=w;class C{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return R(r,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=C,C.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new C,D(this),R(this._store,this)}dispose(){_(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&R(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&R(r,null),r}}e.MutableDisposable=l;class c{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class f{constructor(){this.references=new Map}acquire(r,...n){let a=this.references.get(r);a||(a={counter:0,object:this.createReferencedObject(r,...n)},this.references.set(r,a));const{object:g}=a,u=(0,h.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(r,a.object),this.references.delete(r))});return a.counter++,{object:g,dispose:u}}}e.ReferenceCollection=f;class s{constructor(r){this.referenceCollection=r}async acquire(r,...n){const a=this.referenceCollection.acquire(r,...n);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(g){throw a.dispose(),g}}}e.AsyncReferenceCollection=s;class b{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=b;function o(i){const r=new C;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=o}),define(we[90],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(A){this.element=A,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class t{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let A=this._first;for(;A!==h.Undefined;){const S=A.next;A.prev=h.Undefined,A.next=h.Undefined,A=S}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const D=new h(A);if(this._first===h.Undefined)this._first=D,this._last=D;else if(S){const R=this._last;this._last=D,D.prev=R,R.next=D}else{const R=this._first;this._first=D,D.next=R,R.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==h.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==h.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==h.Undefined&&A.next!==h.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===h.Undefined&&A.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):A.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):A.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==h.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[142],be([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(_e,Ee){for(var $=0;$<Ee.length;$++){var U=Ee[$];U.enumerable=U.enumerable||!1,U.configurable=!0,"value"in U&&(U.writable=!0),Object.defineProperty(_e,U.key,U)}}function h(_e,Ee,$){return Ee&&e(_e.prototype,Ee),$&&e(_e,$),Object.defineProperty(_e,"prototype",{writable:!1}),_e}function t(_e,Ee){if(!!_e){if(typeof _e=="string")return k(_e,Ee);var $=Object.prototype.toString.call(_e).slice(8,-1);if($==="Object"&&_e.constructor&&($=_e.constructor.name),$==="Map"||$==="Set")return Array.from(_e);if($==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($))return k(_e,Ee)}}function k(_e,Ee){(Ee==null||Ee>_e.length)&&(Ee=_e.length);for(var $=0,U=new Array(Ee);$<Ee;$++)U[$]=_e[$];return U}function A(_e,Ee){var $=typeof Symbol!="undefined"&&_e[Symbol.iterator]||_e["@@iterator"];if($)return($=$.call(_e)).next.bind($);if(Array.isArray(_e)||($=t(_e))||Ee&&_e&&typeof _e.length=="number"){$&&(_e=$);var U=0;return function(){return U>=_e.length?{done:!0}:{done:!1,value:_e[U++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function D(_e){te.defaults=_e}var _=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Ee){return p[Ee]};function v(_e,Ee){if(Ee){if(_.test(_e))return _e.replace(R,E)}else if(F.test(_e))return _e.replace(I,E);return _e}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(_e){return _e.replace(d,function(Ee,$){return $=$.toLowerCase(),$==="colon"?":":$.charAt(0)==="#"?$.charAt(1)==="x"?String.fromCharCode(parseInt($.substring(2),16)):String.fromCharCode(+$.substring(1)):""})}var C=/(^|[^\[])\^/g;function P(_e,Ee){_e=_e.source||_e,Ee=Ee||"";var $={replace:function(N,W){return W=W.source||W,W=W.replace(C,"$1"),_e=_e.replace(N,W),$},getRegex:function(){return new RegExp(_e,Ee)}};return $}var l=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(_e,Ee,$){if(_e){var U;try{U=decodeURIComponent(w($)).replace(l,"").toLowerCase()}catch{return null}if(U.indexOf("javascript:")===0||U.indexOf("vbscript:")===0||U.indexOf("data:")===0)return null}Ee&&!c.test($)&&($=r(Ee,$));try{$=encodeURI($).replace(/%25/g,"%")}catch{return null}return $}var s={},b=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(_e,Ee){s[" "+_e]||(b.test(_e)?s[" "+_e]=_e+"/":s[" "+_e]=u(_e,"/",!0)),_e=s[" "+_e];var $=_e.indexOf(":")===-1;return Ee.substring(0,2)==="//"?$?Ee:_e.replace(o,"$1")+Ee:Ee.charAt(0)==="/"?$?Ee:_e.replace(i,"$1")+Ee:_e+Ee}var n={exec:function(){}};function a(_e){for(var Ee=1,$,U;Ee<arguments.length;Ee++){$=arguments[Ee];for(U in $)Object.prototype.hasOwnProperty.call($,U)&&(_e[U]=$[U])}return _e}function g(_e,Ee){var $=_e.replace(/\|/g,function(W,j,re){for(var he=!1,Ce=j;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),U=$.split(/ \|/),N=0;if(U[0].trim()||U.shift(),U[U.length-1].trim()||U.pop(),U.length>Ee)U.splice(Ee);else for(;U.length<Ee;)U.push("");for(;N<U.length;N++)U[N]=U[N].trim().replace(/\\\|/g,"|");return U}function u(_e,Ee,$){var U=_e.length;if(U===0)return"";for(var N=0;N<U;){var W=_e.charAt(U-N-1);if(W===Ee&&!$)N++;else if(W!==Ee&&$)N++;else break}return _e.substr(0,U-N)}function m(_e,Ee){if(_e.indexOf(Ee[1])===-1)return-1;for(var $=_e.length,U=0,N=0;N<$;N++)if(_e[N]==="\\")N++;else if(_e[N]===Ee[0])U++;else if(_e[N]===Ee[1]&&(U--,U<0))return N;return-1}function T(_e){_e&&_e.sanitize&&!_e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(_e,Ee){if(Ee<1)return"";for(var $="";Ee>1;)Ee&1&&($+=_e),Ee>>=1,_e+=_e;return $+_e}function L(_e,Ee,$,U){var N=Ee.href,W=Ee.title?v(Ee.title):null,j=_e[1].replace(/\\([\[\]])/g,"$1");if(_e[0].charAt(0)!=="!"){U.state.inLink=!0;var re={type:"link",raw:$,href:N,title:W,text:j,tokens:U.inlineTokens(j,[])};return U.state.inLink=!1,re}else return{type:"image",raw:$,href:N,title:W,text:v(j)}}function y(_e,Ee){var $=_e.match(/^(\s+)(?:```)/);if($===null)return Ee;var U=$[1];return Ee.split(`
`).map(function(N){var W=N.match(/^\s+/);if(W===null)return N;var j=W[0];return j.length>=U.length?N.slice(U.length):N}).join(`
`)}var H=function(){function _e($){this.options=$||te.defaults}var Ee=_e.prototype;return Ee.space=function(U){var N=this.rules.block.newline.exec(U);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(U){var N=this.rules.block.code.exec(U);if(N){var W=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?W:u(W,`
`)}}},Ee.fences=function(U){var N=this.rules.block.fences.exec(U);if(N){var W=N[0],j=y(W,N[3]||"");return{type:"code",raw:W,lang:N[2]?N[2].trim():N[2],text:j}}},Ee.heading=function(U){var N=this.rules.block.heading.exec(U);if(N){var W=N[2].trim();if(/#$/.test(W)){var j=u(W,"#");(this.options.pedantic||!j||/ $/.test(j))&&(W=j.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:W,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(U){var N=this.rules.block.hr.exec(U);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(U){var N=this.rules.block.blockquote.exec(U);if(N){var W=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},Ee.list=function(U){var N=this.rules.block.list.exec(U);if(N){var W,j,re,he,Ce,Ae,We,ze,je,$e,Ue,Qe,et=N[1].trim(),Re=et.length>1,tt={type:"list",raw:"",ordered:Re,start:Re?+et.slice(0,-1):"",loose:!1,items:[]};et=Re?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Re?et:"[*+-]");for(var ne=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");U&&(Qe=!1,!(!(N=ne.exec(U))||this.rules.block.hr.test(U)));){if(W=N[0],U=U.substring(W.length),ze=N[2].split(`
`,1)[0],je=U.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=ze.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=ze.slice(he),he+=N[1].length),Ae=!1,!ze&&/^ *$/.test(je)&&(W+=je+`
`,U=U.substring(je.length+1),Qe=!0),!Qe)for(var oe=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");U&&($e=U.split(`
`,1)[0],ze=$e,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!oe.test(ze));){if(ze.search(/[^ ]/)>=he||!ze.trim())Ue+=`
`+ze.slice(he);else if(!Ae)Ue+=`
`+ze;else break;!Ae&&!ze.trim()&&(Ae=!0),W+=$e+`
`,U=U.substring($e.length+1)}tt.loose||(We?tt.loose=!0:/\n *\n *$/.test(W)&&(We=!0)),this.options.gfm&&(j=/^\[[ xX]\] /.exec(Ue),j&&(re=j[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),tt.items.push({type:"list_item",raw:W,task:!!j,checked:re,loose:!1,text:Ue}),tt.raw+=W}tt.items[tt.items.length-1].raw=W.trimRight(),tt.items[tt.items.length-1].text=Ue.trimRight(),tt.raw=tt.raw.trimRight();var J=tt.items.length;for(Ce=0;Ce<J;Ce++){this.lexer.state.top=!1,tt.items[Ce].tokens=this.lexer.blockTokens(tt.items[Ce].text,[]);var pe=tt.items[Ce].tokens.filter(function(Ne){return Ne.type==="space"}),Se=pe.every(function(Ne){for(var He=Ne.raw.split(""),Ye=0,st=A(He),pt;!(pt=st()).done;){var mt=pt.value;if(mt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!tt.loose&&pe.length&&Se&&(tt.loose=!0,tt.items[Ce].loose=!0)}return tt}},Ee.html=function(U){var N=this.rules.block.html.exec(U);if(N){var W={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&(W.type="paragraph",W.text=this.options.sanitizer?this.options.sanitizer(N[0]):v(N[0]),W.tokens=[],this.lexer.inline(W.text,W.tokens)),W}},Ee.def=function(U){var N=this.rules.block.def.exec(U);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var W=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(U){var N=this.rules.block.table.exec(U);if(N){var W={type:"table",header:g(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=N[0];var j=W.align.length,re,he,Ce,Ae;for(re=0;re<j;re++)/^ *-+: *$/.test(W.align[re])?W.align[re]="right":/^ *:-+: *$/.test(W.align[re])?W.align[re]="center":/^ *:-+ *$/.test(W.align[re])?W.align[re]="left":W.align[re]=null;for(j=W.rows.length,re=0;re<j;re++)W.rows[re]=g(W.rows[re],W.header.length).map(function(We){return{text:We}});for(j=W.header.length,he=0;he<j;he++)W.header[he].tokens=[],this.lexer.inlineTokens(W.header[he].text,W.header[he].tokens);for(j=W.rows.length,he=0;he<j;he++)for(Ae=W.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=[],this.lexer.inlineTokens(Ae[Ce].text,Ae[Ce].tokens);return W}}},Ee.lheading=function(U){var N=this.rules.block.lheading.exec(U);if(N){var W={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.paragraph=function(U){var N=this.rules.block.paragraph.exec(U);if(N){var W={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.text=function(U){var N=this.rules.block.text.exec(U);if(N){var W={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.escape=function(U){var N=this.rules.inline.escape.exec(U);if(N)return{type:"escape",raw:N[0],text:v(N[1])}},Ee.tag=function(U){var N=this.rules.inline.tag.exec(U);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):v(N[0]):N[0]}},Ee.link=function(U){var N=this.rules.inline.link.exec(U);if(N){var W=N[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var j=u(W.slice(0,-1),"\\");if((W.length-j.length)%2==0)return}else{var re=m(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Ae=N[2],We="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);ze&&(Ae=ze[1],We=ze[3])}else We=N[3]?N[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(W)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),L(N,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(U,N){var W;if((W=this.rules.inline.reflink.exec(U))||(W=this.rules.inline.nolink.exec(U))){var j=(W[2]||W[1]).replace(/\s+/g," ");if(j=N[j.toLowerCase()],!j||!j.href){var re=W[0].charAt(0);return{type:"text",raw:re,text:re}}return L(W,j,W[0],this.lexer)}},Ee.emStrong=function(U,N,W){W===void 0&&(W="");var j=this.rules.inline.emStrong.lDelim.exec(U);if(!!j&&!(j[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=j[1]||j[2]||"";if(!re||re&&(W===""||this.rules.inline.punctuation.exec(W))){var he=j[0].length-1,Ce,Ae,We=he,ze=0,je=j[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(je.lastIndex=0,N=N.slice(-1*U.length+he);(j=je.exec(N))!=null;)if(Ce=j[1]||j[2]||j[3]||j[4]||j[5]||j[6],!!Ce){if(Ae=Ce.length,j[3]||j[4]){We+=Ae;continue}else if((j[5]||j[6])&&he%3&&!((he+Ae)%3)){ze+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+ze),Math.min(he,Ae)%2){var $e=U.slice(1,he+j.index+Ae);return{type:"em",raw:U.slice(0,he+j.index+Ae+1),text:$e,tokens:this.lexer.inlineTokens($e,[])}}var Ue=U.slice(2,he+j.index+Ae-1);return{type:"strong",raw:U.slice(0,he+j.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(U){var N=this.rules.inline.code.exec(U);if(N){var W=N[2].replace(/\n/g," "),j=/[^ ]/.test(W),re=/^ /.test(W)&&/ $/.test(W);return j&&re&&(W=W.substring(1,W.length-1)),W=v(W,!0),{type:"codespan",raw:N[0],text:W}}},Ee.br=function(U){var N=this.rules.inline.br.exec(U);if(N)return{type:"br",raw:N[0]}},Ee.del=function(U){var N=this.rules.inline.del.exec(U);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(U,N){var W=this.rules.inline.autolink.exec(U);if(W){var j,re;return W[2]==="@"?(j=v(this.options.mangle?N(W[1]):W[1]),re="mailto:"+j):(j=v(W[1]),re=j),{type:"link",raw:W[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.url=function(U,N){var W;if(W=this.rules.inline.url.exec(U)){var j,re;if(W[2]==="@")j=v(this.options.mangle?N(W[0]):W[0]),re="mailto:"+j;else{var he;do he=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(he!==W[0]);j=v(W[0]),W[1]==="www."?re="http://"+j:re=j}return{type:"link",raw:W[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.inlineText=function(U,N){var W=this.rules.inline.text.exec(U);if(W){var j;return this.lexer.state.inRawBlock?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):v(W[0]):W[0]:j=v(this.options.smartypants?N(W[0]):W[0]),{type:"text",raw:W[0],text:j}}},_e}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=P(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=P(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=P(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=P(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=P(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=P(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=a({},M),M.gfm=a({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=P(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=P(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=a({},M.normal,{html:P(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:P(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=P(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=P(M._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=P(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=P(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=P(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=P(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=P(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=P(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=P(z.reflink).replace("label",z._label).replace("ref",M._label).getRegex(),z.nolink=P(z.nolink).replace("ref",M._label).getRegex(),z.reflinkSearch=P(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=a({},z),z.pedantic=a({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:P(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:P(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=a({},z.normal,{escape:P(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=P(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=a({},z.gfm,{br:P(z.br).replace("{2,}","*").getRegex(),text:P(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(_e){return _e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(_e){var Ee="",$,U,N=_e.length;for($=0;$<N;$++)U=_e.charCodeAt($),Math.random()>.5&&(U="x"+U.toString(16)),Ee+="&#"+U+";";return Ee}var B=function(){function _e($){this.tokens=[],this.tokens.links=Object.create(null),this.options=$||te.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var U={block:M.normal,inline:z.normal};this.options.pedantic?(U.block=M.pedantic,U.inline=z.pedantic):this.options.gfm&&(U.block=M.gfm,this.options.breaks?U.inline=z.breaks:U.inline=z.gfm),this.tokenizer.rules=U}_e.lex=function(U,N){var W=new _e(N);return W.lex(U)},_e.lexInline=function(U,N){var W=new _e(N);return W.inlineTokens(U)};var Ee=_e.prototype;return Ee.lex=function(U){U=U.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(U,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(U,N){var W=this;N===void 0&&(N=[]),this.options.pedantic&&(U=U.replace(/^ +$/gm,""));for(var j,re,he,Ce;U;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(j=We.call({lexer:W},U,N))?(U=U.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.space(U)){U=U.substring(j.raw.length),j.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(j);continue}if(j=this.tokenizer.code(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(j=this.tokenizer.fences(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.heading(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.hr(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.blockquote(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.list(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.html(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.def(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[j.tag]||(this.tokens.links[j.tag]={href:j.href,title:j.title});continue}if(j=this.tokenizer.table(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.lheading(U)){U=U.substring(j.raw.length),N.push(j);continue}if(he=U,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,ze=U.slice(1),je=void 0;W.options.extensions.startBlock.forEach(function($e){je=$e.call({lexer:this},ze),typeof je=="number"&&je>=0&&(We=Math.min(We,je))}),We<1/0&&We>=0&&(he=U.substring(0,We+1))}(),this.state.top&&(j=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j),Ce=he.length!==U.length,U=U.substring(j.raw.length);continue}if(j=this.tokenizer.text(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(U){var Ae="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,N},Ee.inline=function(U,N){this.inlineQueue.push({src:U,tokens:N})},Ee.inlineTokens=function(U,N){var W=this;N===void 0&&(N=[]);var j,re,he,Ce=U,Ae,We,ze;if(this.tokens.links){var je=Object.keys(this.tokens.links);if(je.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)je.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+O("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+O("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;U;)if(We||(ze=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(j=Ue.call({lexer:W},U,N))?(U=U.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.escape(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.tag(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.link(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.reflink(U,this.tokens.links)){U=U.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.emStrong(U,Ce,ze)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.codespan(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.br(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.del(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.autolink(U,K)){U=U.substring(j.raw.length),N.push(j);continue}if(!this.state.inLink&&(j=this.tokenizer.url(U,K))){U=U.substring(j.raw.length),N.push(j);continue}if(he=U,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Qe=U.slice(1),et=void 0;W.options.extensions.startInline.forEach(function(Re){et=Re.call({lexer:this},Qe),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=U.substring(0,Ue+1))}(),j=this.tokenizer.inlineText(he,x)){U=U.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(ze=j.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(U){var $e="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return N},h(_e,null,[{key:"rules",get:function(){return{block:M,inline:z}}}]),_e}(),G=function(){function _e($){this.options=$||te.defaults}var Ee=_e.prototype;return Ee.code=function(U,N,W){var j=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(U,j);re!=null&&re!==U&&(W=!0,U=re)}return U=U.replace(/\n$/,"")+`
`,j?'<pre><code class="'+this.options.langPrefix+v(j,!0)+'">'+(W?U:v(U,!0))+`</code></pre>
`:"<pre><code>"+(W?U:v(U,!0))+`</code></pre>
`},Ee.blockquote=function(U){return`<blockquote>
`+U+`</blockquote>
`},Ee.html=function(U){return U},Ee.heading=function(U,N,W,j){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+j.slug(W)+'">'+U+"</h"+N+`>
`:"<h"+N+">"+U+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(U,N,W){var j=N?"ol":"ul",re=N&&W!==1?' start="'+W+'"':"";return"<"+j+re+`>
`+U+"</"+j+`>
`},Ee.listitem=function(U){return"<li>"+U+`</li>
`},Ee.checkbox=function(U){return"<input "+(U?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(U){return"<p>"+U+`</p>
`},Ee.table=function(U,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+U+`</thead>
`+N+`</table>
`},Ee.tablerow=function(U){return`<tr>
`+U+`</tr>
`},Ee.tablecell=function(U,N){var W=N.header?"th":"td",j=N.align?"<"+W+' align="'+N.align+'">':"<"+W+">";return j+U+"</"+W+`>
`},Ee.strong=function(U){return"<strong>"+U+"</strong>"},Ee.em=function(U){return"<em>"+U+"</em>"},Ee.codespan=function(U){return"<code>"+U+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(U){return"<del>"+U+"</del>"},Ee.link=function(U,N,W){if(U=f(this.options.sanitize,this.options.baseUrl,U),U===null)return W;var j='<a href="'+v(U)+'"';return N&&(j+=' title="'+N+'"'),j+=">"+W+"</a>",j},Ee.image=function(U,N,W){if(U=f(this.options.sanitize,this.options.baseUrl,U),U===null)return W;var j='<img src="'+U+'" alt="'+W+'"';return N&&(j+=' title="'+N+'"'),j+=this.options.xhtml?"/>":">",j},Ee.text=function(U){return U},_e}(),X=function(){function _e(){}var Ee=_e.prototype;return Ee.strong=function(U){return U},Ee.em=function(U){return U},Ee.codespan=function(U){return U},Ee.del=function(U){return U},Ee.html=function(U){return U},Ee.text=function(U){return U},Ee.link=function(U,N,W){return""+W},Ee.image=function(U,N,W){return""+W},Ee.br=function(){return""},_e}(),q=function(){function _e(){this.seen={}}var Ee=_e.prototype;return Ee.serialize=function(U){return U.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(U,N){var W=U,j=0;if(this.seen.hasOwnProperty(W)){j=this.seen[U];do j++,W=U+"-"+j;while(this.seen.hasOwnProperty(W))}return N||(this.seen[U]=j,this.seen[W]=0),W},Ee.slug=function(U,N){N===void 0&&(N={});var W=this.serialize(U);return this.getNextSafeSlug(W,N.dryrun)},_e}(),ee=function(){function _e($){this.options=$||te.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new q}_e.parse=function(U,N){var W=new _e(N);return W.parse(U)},_e.parseInline=function(U,N){var W=new _e(N);return W.parseInline(U)};var Ee=_e.prototype;return Ee.parse=function(U,N){N===void 0&&(N=!0);var W="",j,re,he,Ce,Ae,We,ze,je,$e,Ue,Qe,et,Re,tt,ne,oe,J,pe,Se,Ne=U.length;for(j=0;j<Ne;j++){if(Ue=U[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){W+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,w(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(je="",ze="",Ce=Ue.header.length,re=0;re<Ce;re++)ze+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(je+=this.renderer.tablerow(ze),$e="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],ze="",Ae=We.length,he=0;he<Ae;he++)ze+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});$e+=this.renderer.tablerow(ze)}W+=this.renderer.table(je,$e);continue}case"blockquote":{$e=this.parse(Ue.tokens),W+=this.renderer.blockquote($e);continue}case"list":{for(Qe=Ue.ordered,et=Ue.start,Re=Ue.loose,Ce=Ue.items.length,$e="",re=0;re<Ce;re++)ne=Ue.items[re],oe=ne.checked,J=ne.task,tt="",ne.task&&(pe=this.renderer.checkbox(oe),Re?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=pe+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=pe+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:pe}):tt+=pe),tt+=this.parse(ne.tokens,Re),$e+=this.renderer.listitem(tt,J,oe);W+=this.renderer.list($e,Qe,et);continue}case"html":{W+=this.renderer.html(Ue.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for($e=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;j+1<Ne&&U[j+1].type==="text";)Ue=U[++j],$e+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);W+=N?this.renderer.paragraph($e):$e;continue}default:{var He='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return W},Ee.parseInline=function(U,N){N=N||this.renderer;var W="",j,re,he,Ce=U.length;for(j=0;j<Ce;j++){if(re=U[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){W+=he||"";continue}switch(re.type){case"escape":{W+=N.text(re.text);break}case"html":{W+=N.html(re.text);break}case"link":{W+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{W+=N.image(re.href,re.title,re.text);break}case"strong":{W+=N.strong(this.parseInline(re.tokens,N));break}case"em":{W+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{W+=N.codespan(re.text);break}case"br":{W+=N.br();break}case"del":{W+=N.del(this.parseInline(re.tokens,N));break}case"text":{W+=N.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return W},_e}();function ae(_e,Ee,$){if(typeof _e=="undefined"||_e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");if(typeof Ee=="function"&&($=Ee,Ee=null),Ee=a({},ae.defaults,Ee||{}),T(Ee),$){var U=Ee.highlight,N;try{N=B.lex(_e,Ee)}catch(he){return $(he)}var W=function(Ce){var Ae;if(!Ce)try{Ee.walkTokens&&ae.walkTokens(N,Ee.walkTokens),Ae=ee.parse(N,Ee)}catch(We){Ce=We}return Ee.highlight=U,Ce?$(Ce):$(null,Ae)};if(!U||U.length<3||(delete Ee.highlight,!N.length))return W();var j=0;ae.walkTokens(N,function(he){he.type==="code"&&(j++,setTimeout(function(){U(he.text,he.lang,function(Ce,Ae){if(Ce)return W(Ce);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),j--,j===0&&W()})},0))}),j===0&&W();return}try{var re=B.lex(_e,Ee);return Ee.walkTokens&&ae.walkTokens(re,Ee.walkTokens),ee.parse(re,Ee)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+v(he.message+"",!0)+"</pre>";throw he}}ae.options=ae.setOptions=function(_e){return a(ae.defaults,_e),D(ae.defaults),ae},ae.getDefaults=S,ae.defaults=te.defaults,ae.use=function(){for(var _e=arguments.length,Ee=new Array(_e),$=0;$<_e;$++)Ee[$]=arguments[$];var U=a.apply(void 0,[{}].concat(Ee)),N=ae.defaults.extensions||{renderers:{},childTokens:{}},W;Ee.forEach(function(j){if(j.extensions&&(W=!0,j.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),ze=0;ze<Ae;ze++)We[ze]=arguments[ze];var je=he.renderer.apply(this,We);return je===!1&&(je=Ce.apply(this,We)),je}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),j.renderer&&function(){var he=ae.defaults.renderer||new G,Ce=function(ze){var je=he[ze];he[ze]=function(){for(var $e=arguments.length,Ue=new Array($e),Qe=0;Qe<$e;Qe++)Ue[Qe]=arguments[Qe];var et=j.renderer[ze].apply(he,Ue);return et===!1&&(et=je.apply(he,Ue)),et}};for(var Ae in j.renderer)Ce(Ae);U.renderer=he}(),j.tokenizer&&function(){var he=ae.defaults.tokenizer||new H,Ce=function(ze){var je=he[ze];he[ze]=function(){for(var $e=arguments.length,Ue=new Array($e),Qe=0;Qe<$e;Qe++)Ue[Qe]=arguments[Qe];var et=j.tokenizer[ze].apply(he,Ue);return et===!1&&(et=je.apply(he,Ue)),et}};for(var Ae in j.tokenizer)Ce(Ae);U.tokenizer=he}(),j.walkTokens){var re=ae.defaults.walkTokens;U.walkTokens=function(he){j.walkTokens.call(this,he),re&&re.call(this,he)}}W&&(U.extensions=N),ae.setOptions(U)})},ae.walkTokens=function(_e,Ee){for(var $=function(){var j=N.value;switch(Ee.call(ae,j),j.type){case"table":{for(var re=A(j.header),he;!(he=re()).done;){var Ce=he.value;ae.walkTokens(Ce.tokens,Ee)}for(var Ae=A(j.rows),We;!(We=Ae()).done;)for(var ze=We.value,je=A(ze),$e;!($e=je()).done;){var Ue=$e.value;ae.walkTokens(Ue.tokens,Ee)}break}case"list":{ae.walkTokens(j.items,Ee);break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[j.type]?ae.defaults.extensions.childTokens[j.type].forEach(function(Qe){ae.walkTokens(j[Qe],Ee)}):j.tokens&&ae.walkTokens(j.tokens,Ee)}},U=A(_e),N;!(N=U()).done;)$()},ae.parseInline=function(_e,Ee){if(typeof _e=="undefined"||_e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");Ee=a({},ae.defaults,Ee||{}),T(Ee);try{var $=B.lexInline(_e,Ee);return Ee.walkTokens&&ae.walkTokens($,Ee.walkTokens),ee.parseInline($,Ee)}catch(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+v(U.message+"",!0)+"</pre>";throw U}},ae.Parser=ee,ae.parser=ee.parse,ae.Renderer=G,ae.TextRenderer=X,ae.Lexer=B,ae.lexer=B.lex,ae.Tokenizer=H,ae.Slugger=q,ae.parse=ae;var ue=ae.options,Z=ae.setOptions,Y=ae.use,se=ae.walkTokens,de=ae.parseInline,ve=ae,Te=ee.parse,Me=B.lex;te.Lexer=B,te.Parser=ee,te.Renderer=G,te.Slugger=q,te.TextRenderer=X,te.Tokenizer=H,te.getDefaults=S,te.lexer=Me,te.marked=ae,te.options=ue,te.parse=ve,te.parseInline=de,te.parser=Te,te.setOptions=Z,te.use=Y,te.walkTokens=se,Object.defineProperty(te,"__esModule",{value:!0})}),define(we[91],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(D,_,R){return Math.min(Math.max(D,_),R)}e.clamp=h;function t(D,_){return(_+D%_)%_}e.rot=t;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class S{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const R=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=S}),function(){function te(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function S(_){A.push(_,Date.now())}function D(){const _=[];for(let R=0;R<A.length;R+=2)_.push({name:A[R],startTime:A[R+1]});return _}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(k+S.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function h(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=h(t))}(),define(we[12],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const h="en";let t=!1,k=!1,A=!1,S=!1,D=!1,_=!1,R=!1,F=!1,I=!1,p,E=h,v,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const C=typeof w?.versions?.electron=="string",P=C&&w?.type==="renderer";if(e.isElectronSandboxed=P&&w?.sandboxed,typeof navigator=="object"&&!P)d=navigator.userAgent,t=d.indexOf("Windows")>=0,k=d.indexOf("Macintosh")>=0,F=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,_=!0,p=navigator.language,E=p;else if(typeof w=="object"){t=w.platform==="win32",k=w.platform==="darwin",A=w.platform==="linux",S=A&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,R=C,I=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=h,E=h;const n=w.env.VSCODE_NLS_CONFIG;if(n)try{const a=JSON.parse(n),g=a.availableLanguages["*"];p=a.locale,E=g||h,v=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var l;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function c(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let f=0;k?f=1:t?f=3:A&&(f=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=S,e.isNative=D,e.isElectron=R,e.isWeb=_,e.isIOS=F,e.isCI=I,e.platform=f,e.userAgent=d,e.language=E;var s;(function(n){function a(){return e.language}n.value=a;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=g;function u(){return e.language==="en"}n.isDefault=u})(s=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=v,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let u=0,m=n.length;u<m;u++){const T=n[u];if(T.id===g.data.vscodeScheduleAsyncWork){n.splice(u,1),T.callback();return}}});let a=0;return g=>{const u=++a;n.push({id:u,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return n=>setTimeout(n)})();var b;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(b=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||F?2:t?1:3;let o=!0,i=!1;function r(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,o=new Uint16Array(n.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[41],be([1,0,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const k=h.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[9],be([1,0,41]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,S=122,D=46,_=47,R=92,F=58,I=63;class p extends Error{constructor(c,f,s){let b;typeof f=="string"&&f.indexOf("not ")===0?(b="must not be",f=f.replace(/^not /,"")):b="must be";const o=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${o} ${b} of type ${f}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function E(l,c){if(typeof l!="string")throw new p(c,"string",l)}function v(l){return l===_||l===R}function d(l){return l===_}function w(l){return l>=t&&l<=A||l>=k&&l<=S}function C(l,c,f,s){let b="",o=0,i=-1,r=0,n=0;for(let a=0;a<=l.length;++a){if(a<l.length)n=l.charCodeAt(a);else{if(s(n))break;n=_}if(s(n)){if(!(i===a-1||r===1))if(r===2){if(b.length<2||o!==2||b.charCodeAt(b.length-1)!==D||b.charCodeAt(b.length-2)!==D){if(b.length>2){const g=b.lastIndexOf(f);g===-1?(b="",o=0):(b=b.slice(0,g),o=b.length-1-b.lastIndexOf(f)),i=a,r=0;continue}else if(b.length!==0){b="",o=0,i=a,r=0;continue}}c&&(b+=b.length>0?`${f}..`:"..",o=2)}else b.length>0?b+=`${f}${l.slice(i+1,a)}`:b=l.slice(i+1,a),o=a-i-1;i=a,r=0}else n===D&&r!==-1?++r:r=-1}return b}function P(l,c){if(c===null||typeof c!="object")throw new p("pathObject","Object",c);const f=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return f?f===c.root?`${f}${s}`:`${f}${l}${s}`:s}e.win32={resolve(...l){let c="",f="",s=!1;for(let b=l.length-1;b>=-1;b--){let o;if(b>=0){if(o=l[b],E(o,"path"),o.length===0)continue}else c.length===0?o=h.cwd():(o=h.env[`=${c}`]||h.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===R)&&(o=`${c}\\`));const i=o.length;let r=0,n="",a=!1;const g=o.charCodeAt(0);if(i===1)v(g)&&(r=1,a=!0);else if(v(g))if(a=!0,v(o.charCodeAt(1))){let u=2,m=u;for(;u<i&&!v(o.charCodeAt(u));)u++;if(u<i&&u!==m){const T=o.slice(m,u);for(m=u;u<i&&v(o.charCodeAt(u));)u++;if(u<i&&u!==m){for(m=u;u<i&&!v(o.charCodeAt(u));)u++;(u===i||u!==m)&&(n=`\\\\${T}\\${o.slice(m,u)}`,r=u)}}}else r=1;else w(g)&&o.charCodeAt(1)===F&&(n=o.slice(0,2),r=2,i>2&&v(o.charCodeAt(2))&&(a=!0,r=3));if(n.length>0)if(c.length>0){if(n.toLowerCase()!==c.toLowerCase())continue}else c=n;if(s){if(c.length>0)break}else if(f=`${o.slice(r)}\\${f}`,s=a,a&&c.length>0)break}return f=C(f,!s,"\\",v),s?`${c}\\${f}`:`${c}${f}`||"."},normalize(l){E(l,"path");const c=l.length;if(c===0)return".";let f=0,s,b=!1;const o=l.charCodeAt(0);if(c===1)return d(o)?"\\":l;if(v(o))if(b=!0,v(l.charCodeAt(1))){let r=2,n=r;for(;r<c&&!v(l.charCodeAt(r));)r++;if(r<c&&r!==n){const a=l.slice(n,r);for(n=r;r<c&&v(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&!v(l.charCodeAt(r));)r++;if(r===c)return`\\\\${a}\\${l.slice(n)}\\`;r!==n&&(s=`\\\\${a}\\${l.slice(n,r)}`,f=r)}}}else f=1;else w(o)&&l.charCodeAt(1)===F&&(s=l.slice(0,2),f=2,c>2&&v(l.charCodeAt(2))&&(b=!0,f=3));let i=f<c?C(l.slice(f),!b,"\\",v):"";return i.length===0&&!b&&(i="."),i.length>0&&v(l.charCodeAt(c-1))&&(i+="\\"),s===void 0?b?`\\${i}`:i:b?`${s}\\${i}`:`${s}${i}`},isAbsolute(l){E(l,"path");const c=l.length;if(c===0)return!1;const f=l.charCodeAt(0);return v(f)||c>2&&w(f)&&l.charCodeAt(1)===F&&v(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let c,f;for(let o=0;o<l.length;++o){const i=l[o];E(i,"path"),i.length>0&&(c===void 0?c=f=i:c+=`\\${i}`)}if(c===void 0)return".";let s=!0,b=0;if(typeof f=="string"&&v(f.charCodeAt(0))){++b;const o=f.length;o>1&&v(f.charCodeAt(1))&&(++b,o>2&&(v(f.charCodeAt(2))?++b:s=!1))}if(s){for(;b<c.length&&v(c.charCodeAt(b));)b++;b>=2&&(c=`\\${c.slice(b)}`)}return e.win32.normalize(c)},relative(l,c){if(E(l,"from"),E(c,"to"),l===c)return"";const f=e.win32.resolve(l),s=e.win32.resolve(c);if(f===s||(l=f.toLowerCase(),c=s.toLowerCase(),l===c))return"";let b=0;for(;b<l.length&&l.charCodeAt(b)===R;)b++;let o=l.length;for(;o-1>b&&l.charCodeAt(o-1)===R;)o--;const i=o-b;let r=0;for(;r<c.length&&c.charCodeAt(r)===R;)r++;let n=c.length;for(;n-1>r&&c.charCodeAt(n-1)===R;)n--;const a=n-r,g=i<a?i:a;let u=-1,m=0;for(;m<g;m++){const O=l.charCodeAt(b+m);if(O!==c.charCodeAt(r+m))break;O===R&&(u=m)}if(m!==g){if(u===-1)return s}else{if(a>g){if(c.charCodeAt(r+m)===R)return s.slice(r+m+1);if(m===2)return s.slice(r+m)}i>g&&(l.charCodeAt(b+m)===R?u=m:m===2&&(u=3)),u===-1&&(u=0)}let T="";for(m=b+u+1;m<=o;++m)(m===o||l.charCodeAt(m)===R)&&(T+=T.length===0?"..":"\\..");return r+=u,T.length>0?`${T}${s.slice(r,n)}`:(s.charCodeAt(r)===R&&++r,s.slice(r,n))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const c=e.win32.resolve(l);if(c.length<=2)return l;if(c.charCodeAt(0)===R){if(c.charCodeAt(1)===R){const f=c.charCodeAt(2);if(f!==I&&f!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(w(c.charCodeAt(0))&&c.charCodeAt(1)===F&&c.charCodeAt(2)===R)return`\\\\?\\${c}`;return l},dirname(l){E(l,"path");const c=l.length;if(c===0)return".";let f=-1,s=0;const b=l.charCodeAt(0);if(c===1)return v(b)?l:".";if(v(b)){if(f=s=1,v(l.charCodeAt(1))){let r=2,n=r;for(;r<c&&!v(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&v(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&!v(l.charCodeAt(r));)r++;if(r===c)return l;r!==n&&(f=s=r+1)}}}}else w(b)&&l.charCodeAt(1)===F&&(f=c>2&&v(l.charCodeAt(2))?3:2,s=f);let o=-1,i=!0;for(let r=c-1;r>=s;--r)if(v(l.charCodeAt(r))){if(!i){o=r;break}}else i=!1;if(o===-1){if(f===-1)return".";o=f}return l.slice(0,o)},basename(l,c){c!==void 0&&E(c,"ext"),E(l,"path");let f=0,s=-1,b=!0,o;if(l.length>=2&&w(l.charCodeAt(0))&&l.charCodeAt(1)===F&&(f=2),c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let i=c.length-1,r=-1;for(o=l.length-1;o>=f;--o){const n=l.charCodeAt(o);if(v(n)){if(!b){f=o+1;break}}else r===-1&&(b=!1,r=o+1),i>=0&&(n===c.charCodeAt(i)?--i==-1&&(s=o):(i=-1,s=r))}return f===s?s=r:s===-1&&(s=l.length),l.slice(f,s)}for(o=l.length-1;o>=f;--o)if(v(l.charCodeAt(o))){if(!b){f=o+1;break}}else s===-1&&(b=!1,s=o+1);return s===-1?"":l.slice(f,s)},extname(l){E(l,"path");let c=0,f=-1,s=0,b=-1,o=!0,i=0;l.length>=2&&l.charCodeAt(1)===F&&w(l.charCodeAt(0))&&(c=s=2);for(let r=l.length-1;r>=c;--r){const n=l.charCodeAt(r);if(v(n)){if(!o){s=r+1;break}continue}b===-1&&(o=!1,b=r+1),n===D?f===-1?f=r:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||b===-1||i===0||i===1&&f===b-1&&f===s+1?"":l.slice(f,b)},format:P.bind(null,"\\"),parse(l){E(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const f=l.length;let s=0,b=l.charCodeAt(0);if(f===1)return v(b)?(c.root=c.dir=l,c):(c.base=c.name=l,c);if(v(b)){if(s=1,v(l.charCodeAt(1))){let u=2,m=u;for(;u<f&&!v(l.charCodeAt(u));)u++;if(u<f&&u!==m){for(m=u;u<f&&v(l.charCodeAt(u));)u++;if(u<f&&u!==m){for(m=u;u<f&&!v(l.charCodeAt(u));)u++;u===f?s=u:u!==m&&(s=u+1)}}}}else if(w(b)&&l.charCodeAt(1)===F){if(f<=2)return c.root=c.dir=l,c;if(s=2,v(l.charCodeAt(2))){if(f===3)return c.root=c.dir=l,c;s=3}}s>0&&(c.root=l.slice(0,s));let o=-1,i=s,r=-1,n=!0,a=l.length-1,g=0;for(;a>=s;--a){if(b=l.charCodeAt(a),v(b)){if(!n){i=a+1;break}continue}r===-1&&(n=!1,r=a+1),b===D?o===-1?o=a:g!==1&&(g=1):o!==-1&&(g=-1)}return r!==-1&&(o===-1||g===0||g===1&&o===r-1&&o===i+1?c.base=c.name=l.slice(i,r):(c.name=l.slice(i,o),c.base=l.slice(i,r),c.ext=l.slice(o,r))),i>0&&i!==s?c.dir=l.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let c="",f=!1;for(let s=l.length-1;s>=-1&&!f;s--){const b=s>=0?l[s]:h.cwd();E(b,"path"),b.length!==0&&(c=`${b}/${c}`,f=b.charCodeAt(0)===_)}return c=C(c,!f,"/",d),f?`/${c}`:c.length>0?c:"."},normalize(l){if(E(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===_,f=l.charCodeAt(l.length-1)===_;return l=C(l,!c,"/",d),l.length===0?c?"/":f?"./":".":(f&&(l+="/"),c?`/${l}`:l)},isAbsolute(l){return E(l,"path"),l.length>0&&l.charCodeAt(0)===_},join(...l){if(l.length===0)return".";let c;for(let f=0;f<l.length;++f){const s=l[f];E(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(l,c){if(E(l,"from"),E(c,"to"),l===c||(l=e.posix.resolve(l),c=e.posix.resolve(c),l===c))return"";const f=1,s=l.length,b=s-f,o=1,i=c.length-o,r=b<i?b:i;let n=-1,a=0;for(;a<r;a++){const u=l.charCodeAt(f+a);if(u!==c.charCodeAt(o+a))break;u===_&&(n=a)}if(a===r)if(i>r){if(c.charCodeAt(o+a)===_)return c.slice(o+a+1);if(a===0)return c.slice(o+a)}else b>r&&(l.charCodeAt(f+a)===_?n=a:a===0&&(n=0));let g="";for(a=f+n+1;a<=s;++a)(a===s||l.charCodeAt(a)===_)&&(g+=g.length===0?"..":"/..");return`${g}${c.slice(o+n)}`},toNamespacedPath(l){return l},dirname(l){if(E(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===_;let f=-1,s=!0;for(let b=l.length-1;b>=1;--b)if(l.charCodeAt(b)===_){if(!s){f=b;break}}else s=!1;return f===-1?c?"/":".":c&&f===1?"//":l.slice(0,f)},basename(l,c){c!==void 0&&E(c,"ext"),E(l,"path");let f=0,s=-1,b=!0,o;if(c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let i=c.length-1,r=-1;for(o=l.length-1;o>=0;--o){const n=l.charCodeAt(o);if(n===_){if(!b){f=o+1;break}}else r===-1&&(b=!1,r=o+1),i>=0&&(n===c.charCodeAt(i)?--i==-1&&(s=o):(i=-1,s=r))}return f===s?s=r:s===-1&&(s=l.length),l.slice(f,s)}for(o=l.length-1;o>=0;--o)if(l.charCodeAt(o)===_){if(!b){f=o+1;break}}else s===-1&&(b=!1,s=o+1);return s===-1?"":l.slice(f,s)},extname(l){E(l,"path");let c=-1,f=0,s=-1,b=!0,o=0;for(let i=l.length-1;i>=0;--i){const r=l.charCodeAt(i);if(r===_){if(!b){f=i+1;break}continue}s===-1&&(b=!1,s=i+1),r===D?c===-1?c=i:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===f+1?"":l.slice(c,s)},format:P.bind(null,"/"),parse(l){E(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const f=l.charCodeAt(0)===_;let s;f?(c.root="/",s=1):s=0;let b=-1,o=0,i=-1,r=!0,n=l.length-1,a=0;for(;n>=s;--n){const g=l.charCodeAt(n);if(g===_){if(!r){o=n+1;break}continue}i===-1&&(r=!1,i=n+1),g===D?b===-1?b=n:a!==1&&(a=1):b!==-1&&(a=-1)}if(i!==-1){const g=o===0&&f?1:o;b===-1||a===0||a===1&&b===i-1&&b===o+1?c.base=c.name=l.slice(g,i):(c.name=l.slice(g,b),c.base=l.slice(g,i),c.ext=l.slice(b,i))}return o>0?c.dir=l.slice(0,o-1):f&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[92],be([1,0,9]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(I){I.text="text/plain",I.binary="application/octet-stream",I.unknown="application/unknown",I.markdown="text/markdown",I.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(I){const p=(0,h.extname)(I),E=k[p.toLowerCase()];return E!==void 0?E:D(I)}e.getMediaOrTextMime=S;function D(I){const p=(0,h.extname)(I);return A[p.toLowerCase()]}e.getMediaMime=D;function _(I){for(const p in A)if(A[p]===I)return p}e.getExtensionForMimeType=_;const R=/^(.+)\/(.+?)(;.+)?$/;function F(I,p){const E=R.exec(I);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:p?void 0:I}e.normalizeMimeType=F}),define(we[93],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var t;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(A,...S){const D=S.reduce((F,I)=>(F[I]=!0,F),{}),_=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(F=>!D[F]).forEach(F=>{for(let I=0;I<_.length;I++)if(F.search(_[I])!==-1){delete A[F];break}})}e.sanitizeProcessEnvironment=k}),define(we[46],be([1,0,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=h.globals.performance&&typeof h.globals.performance.now=="function";class k{constructor(S){this._highResolution=t&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new k(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=k}),define(we[3],be([1,0,16,75,6,90,46]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.SafeDisposable=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(b){b.None=()=>k.Disposable.None;function o(q){return(ee,ae=null,ue)=>{let Z=!1,Y;return Y=q(se=>{if(!Z)return Y?Y.dispose():Z=!0,ee.call(ae,se)},null,ue),Z&&Y.dispose(),Y}}b.once=o;function i(q,ee){return m((ae,ue=null,Z)=>q(Y=>ae.call(ue,ee(Y)),null,Z))}b.map=i;function r(q,ee){return m((ae,ue=null,Z)=>q(Y=>{ee(Y),ae.call(ue,Y)},null,Z))}b.forEach=r;function n(q,ee){return m((ae,ue=null,Z)=>q(Y=>ee(Y)&&ae.call(ue,Y),null,Z))}b.filter=n;function a(q){return q}b.signal=a;function g(...q){return(ee,ae=null,ue)=>(0,k.combinedDisposable)(...q.map(Z=>Z(Y=>ee.call(ae,Y),null,ue)))}b.any=g;function u(q,ee,ae){let ue=ae;return i(q,Z=>(ue=ee(ue,Z),ue))}b.reduce=u;function m(q){let ee;const ae=new d({onFirstListenerAdd(){ee=q(ae.fire,ae)},onLastListenerRemove(){ee.dispose()}});return ae.event}function T(q,ee,ae,ue=100,Z=!1){let Y,se,de=0;return q(ve=>{de++,Y=ae(Y,ve),Z&&!se&&(ee(Y),Y=void 0),clearTimeout(se),se=setTimeout(()=>{const Te=Y;Y=void 0,se=void 0,(!Z||de>1)&&ee(Te),de=0},ue)})}b.debouncedListener=T;function O(q,ee,ae=100,ue=!1,Z){let Y,se,de,ve=0;const Te=new d({leakWarningThreshold:Z,onFirstListenerAdd(){Y=q(Me=>{ve++,se=ee(se,Me),ue&&!de&&(Te.fire(se),se=void 0),clearTimeout(de),de=setTimeout(()=>{const _e=se;se=void 0,de=void 0,(!ue||ve>1)&&Te.fire(_e),ve=0},ae)})},onLastListenerRemove(){Y.dispose()}});return Te.event}b.debounce=O;function L(q,ee=(ae,ue)=>ae===ue){let ae=!0,ue;return n(q,Z=>{const Y=ae||!ee(Z,ue);return ae=!1,ue=Z,Y})}b.latch=L;function y(q,ee){return[b.filter(q,ee),b.filter(q,ae=>!ee(ae))]}b.split=y;function H(q,ee=!1,ae=[]){let ue=ae.slice(),Z=q(de=>{ue?ue.push(de):se.fire(de)});const Y=()=>{ue&&ue.forEach(de=>se.fire(de)),ue=null},se=new d({onFirstListenerAdd(){Z||(Z=q(de=>se.fire(de)))},onFirstListenerDidAdd(){ue&&(ee?setTimeout(Y):Y())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return se.event}b.buffer=H;class M{constructor(ee){this.event=ee}map(ee){return new M(i(this.event,ee))}forEach(ee){return new M(r(this.event,ee))}filter(ee){return new M(n(this.event,ee))}reduce(ee,ae){return new M(u(this.event,ee,ae))}latch(){return new M(L(this.event))}debounce(ee,ae=100,ue=!1,Z){return new M(O(this.event,ee,ae,ue,Z))}on(ee,ae,ue){return this.event(ee,ae,ue)}once(ee,ae,ue){return o(this.event)(ee,ae,ue)}}function z(q){return new M(q)}b.chain=z;function x(q,ee,ae=ue=>ue){const ue=(...de)=>se.fire(ae(...de)),Z=()=>q.on(ee,ue),Y=()=>q.removeListener(ee,ue),se=new d({onFirstListenerAdd:Z,onLastListenerRemove:Y});return se.event}b.fromNodeEventEmitter=x;function K(q,ee,ae=ue=>ue){const ue=(...de)=>se.fire(ae(...de)),Z=()=>q.addEventListener(ee,ue),Y=()=>q.removeEventListener(ee,ue),se=new d({onFirstListenerAdd:Z,onLastListenerRemove:Y});return se.event}b.fromDOMEventEmitter=K;function B(q){return new Promise(ee=>o(q)(ee))}b.toPromise=B;function G(q,ee){return ee(void 0),q(ae=>ee(ae))}b.runAndSubscribe=G;function X(q,ee){let ae=null;function ue(Y){ae?.dispose(),ae=new k.DisposableStore,ee(Y,ae)}ue(void 0);const Z=q(Y=>ue(Y));return(0,k.toDisposable)(()=>{Z.dispose(),ae?.dispose()})}b.runAndSubscribeWithStore=X})(D=e.Event||(e.Event={}));class _{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${_._idPool++}`}start(o){this._stopWatch=new S.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let R=-1;function F(b){const o=R;return R=b,{dispose(){R=o}}}e.setGlobalLeakWarningThreshold=F;class I{constructor(o,i=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,i){let r=R;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||i<r)return;this._stacks||(this._stacks=new Map);const n=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let a,g=0;for(const[u,m]of this._stacks)(!a||g<m)&&(a=u,g=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${g}):`),console.warn(a)}return()=>{const a=this._stacks.get(o.value)||0;this._stacks.set(o.value,a-1)}}}class p{constructor(o){this._error=o}static create(){return new p(new Error)}get value(){return this._error.stack??""}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(){this.dispose=E._noop,this.unset=E._noop}set(o){let i=o;return this.unset=()=>i=void 0,this.dispose=()=>i?.dispose(),this}}e.SafeDisposable=E,E._noop=()=>{};class v{constructor(o,i,r){this.callback=o,this.callbackThis=i,this.stack=r,this.subscription=new E}invoke(o){this.callback.call(this.callbackThis,o)}}class d{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=R>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(o,i,r)=>{this._listeners||(this._listeners=new A.LinkedList);const n=this._listeners.isEmpty();n&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let a,g;this._leakageMon&&(g=p.create(),a=this._leakageMon.check(g,this._listeners.size+1));const u=new v(o,i,g),m=this._listeners.push(u);n&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,i);const T=u.subscription.set((0,k.toDisposable)(()=>{a&&a(),this._disposed||(m(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return r instanceof k.DisposableStore?r.add(T):Array.isArray(r)&&r.push(T),T}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,r]=this._deliveryQueue.shift();try{i.invoke(r)}catch(n){(0,h.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(const o of this._listeners)o.subscription.dispose(),o.subscription.unset();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}e.Emitter=d;class w extends d{async fireAsync(o,i,r){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,o]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[n,a]=this._asyncDeliveryQueue.shift(),g=[],u={...a,token:i,waitUntil:m=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");r&&(m=r(m,n.callback)),g.push(m)}};try{n.invoke(u)}catch(m){(0,h.onUnexpectedError)(m);continue}Object.freeze(g),await Promise.allSettled(g).then(m=>{for(const T of m)T.status==="rejected"&&(0,h.onUnexpectedError)(T.reason)})}}}}e.AsyncEmitter=w;class C extends d{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=C;class P extends C{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=P;class l extends d{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const i={event:o,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const r=()=>{this.hasListeners&&this.unhook(i);const n=this.events.indexOf(i);this.events.splice(n,1)};return(0,k.toDisposable)((0,t.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(i=>this.emitter.fire(i))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class f{constructor(){this.buffers=[]}wrapEvent(o){return(i,r,n)=>o(a=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>i.call(r,a)):i.call(r,a)},void 0,n)}bufferEvents(o){const i=[];this.buffers.push(i);const r=o();return this.buffers.pop(),i.forEach(n=>n()),r}}e.EventBufferer=f;class s{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(we[21],be([1,0,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(D,_){const R=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(R)}}});var k;(function(D){function _(R){return R===D.None||R===D.Cancelled||R instanceof A?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=S}),define(we[143],be([1,0,21]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new h.CancellationTokenSource,D=this.task(S.token);return this.result={promise:D,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class k{constructor(S){this.computeFn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const D=JSON.stringify(S);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this.computeFn(S)),this.lastCache}}e.LRUCachedComputed=k}),define(we[94],be([1,0,16,6]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(l){const c=l;return c?[c.on,c.pause,c.resume,c.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=k;function A(l){const c=l;return c?k(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function S(l,c){return new D(l,c)}e.newWriteableStream=S;class D{constructor(c,f){this.reducer=c,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(f=>f(c))}emitError(c){this.listeners.error.length===0?(0,h.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(f=>f(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,f){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(c,f){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const b=s.indexOf(f);b>=0&&s.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(l,c){const f=[];let s;for(;(s=l.read())!==null;)f.push(s);return c(f)}e.consumeReadable=_;function R(l,c,f){const s=[];let b;for(;(b=l.read())!==null&&s.length<f;)s.push(b);return b===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof b!="undefined"){const o=b;return b=void 0,o}return l.read()}}}e.peekReadable=R;function F(l,c){return new Promise((f,s)=>{const b=[];I(l,{onData:o=>{c&&b.push(o)},onError:o=>{c?s(o):f(void 0)},onEnd:()=>{f(c?c(b):void 0)}})})}e.consumeStream=F;function I(l,c){let f=!1;return l.on("error",s=>{f||c.onError(s)}),l.on("end",()=>{f||c.onEnd()}),l.on("data",s=>{f||c.onData(s)}),(0,t.toDisposable)(()=>f=!0)}e.listenStream=I;function p(l,c){return new Promise((f,s)=>{const b=new t.DisposableStore,o=[],i=a=>{if(o.push(a),o.length>c)return b.dispose(),l.pause(),f({stream:l,buffer:o,ended:!1})},r=a=>s(a),n=()=>f({stream:l,buffer:o,ended:!0});b.add((0,t.toDisposable)(()=>l.removeListener("error",r))),l.on("error",r),b.add((0,t.toDisposable)(()=>l.removeListener("end",n))),l.on("end",n),b.add((0,t.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=p;function E(l,c){const f=S(c);return f.end(l),f}e.toStream=E;function v(){const l=S(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=v;function d(l){let c=!1;return{read:()=>c?null:(c=!0,l)}}e.toReadable=d;function w(l,c,f){const s=S(f);return I(l,{onData:b=>s.write(c.data(b)),onError:b=>s.error(c.error?c.error(b):b),onEnd:()=>s.end()}),s}e.transform=w;function C(l,c,f){let s=!1;return{read:()=>{const b=c.read();return s?b:(s=!0,b!==null?f([l,b]):l)}}}e.prefixedReadable=C;function P(l,c,f){let s=!1;const b=S(f);return I(c,{onData:o=>s?b.write(o):(s=!0,b.write(f([l,o]))),onError:o=>b.error(o),onEnd:()=>{s||(s=!0,b.write(l)),b.end()}}),b}e.prefixedStream=P}),define(we[22],be([1,0,94]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,A;class S{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return t?new S(Buffer.allocUnsafe(g)):new S(new Uint8Array(g))}static wrap(g){return t&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new S(g)}static fromString(g,u){return!(u?.dontUseNodeBuffer||!1)&&t?new S(Buffer.from(g)):(k||(k=new TextEncoder),new S(k.encode(g)))}static fromByteArray(g){const u=S.alloc(g.length);for(let m=0,T=g.length;m<T;m++)u.buffer[m]=g[m];return u}static concat(g,u){if(typeof u=="undefined"){u=0;for(let O=0,L=g.length;O<L;O++)u+=g[O].byteLength}const m=S.alloc(u);let T=0;for(let O=0,L=g.length;O<L;O++){const y=g[O];m.set(y,T),T+=y.byteLength}return m}clone(){const g=S.alloc(this.byteLength);return g.set(this),g}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(g,u){return new S(this.buffer.subarray(g,u))}set(g,u){if(g instanceof S)this.buffer.set(g.buffer,u);else if(g instanceof Uint8Array)this.buffer.set(g,u);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),u);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return R(this.buffer,g)}writeUInt32BE(g,u){F(this.buffer,g,u)}readUInt32LE(g){return I(this.buffer,g)}writeUInt32LE(g,u){p(this.buffer,g,u)}readUInt8(g){return E(this.buffer,g)}writeUInt8(g,u){v(this.buffer,g,u)}}e.VSBuffer=S;function D(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=D;function _(a,g,u){a[u+0]=g&255,g=g>>>8,a[u+1]=g&255}e.writeUInt16LE=_;function R(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=R;function F(a,g,u){a[u+3]=g,g=g>>>8,a[u+2]=g,g=g>>>8,a[u+1]=g,g=g>>>8,a[u]=g}e.writeUInt32BE=F;function I(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=I;function p(a,g,u){a[u+0]=g&255,g=g>>>8,a[u+1]=g&255,g=g>>>8,a[u+2]=g&255,g=g>>>8,a[u+3]=g&255}e.writeUInt32LE=p;function E(a,g){return a[g]}e.readUInt8=E;function v(a,g,u){a[u]=g}e.writeUInt8=v;function d(a){return h.consumeReadable(a,g=>S.concat(g))}e.readableToBuffer=d;function w(a){return h.toReadable(a)}e.bufferToReadable=w;function C(a){return h.consumeStream(a,g=>S.concat(g))}e.streamToBuffer=C;async function P(a){return a.ended?S.concat(a.buffer):S.concat([...a.buffer,await C(a.stream)])}e.bufferedStreamToBuffer=P;function l(a){return h.toStream(a,g=>S.concat(g))}e.bufferToStream=l;function c(a){return h.transform(a,{data:g=>typeof g=="string"?S.fromString(g):S.wrap(g)},g=>S.concat(g))}e.streamToBufferReadableStream=c;function f(a){return h.newWriteableStream(g=>S.concat(g),a)}e.newWriteableBufferStream=f;function s(a,g){return h.prefixedReadable(a,g,u=>S.concat(u))}e.prefixedBufferReadable=s;function b(a,g){return h.prefixedStream(a,g,u=>S.concat(u))}e.prefixedBufferStream=b;function o(a){let g=0,u=0,m=0;const T=new Uint8Array(Math.floor(a.length/4*3)),O=y=>{switch(u){case 3:T[m++]=g|y,u=0;break;case 2:T[m++]=g|y>>>2,g=y<<6,u=3;break;case 1:T[m++]=g|y>>>4,g=y<<4,u=2;break;default:g=y<<2,u=1}};for(let y=0;y<a.length;y++){const H=a.charCodeAt(y);if(H>=65&&H<=90)O(H-65);else if(H>=97&&H<=122)O(H-97+26);else if(H>=48&&H<=57)O(H-48+52);else if(H===43||H===45)O(62);else if(H===47||H===95)O(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${a[y]}`)}}const L=m;for(;u>0;)O(0);return S.wrap(T).slice(0,L)}e.decodeBase64=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:a},g=!0,u=!1){const m=u?r:i;let T="";const O=a.byteLength%3;let L=0;for(;L<a.byteLength-O;L+=3){const y=a[L+0],H=a[L+1],M=a[L+2];T+=m[y>>>2],T+=m[(y<<4|H>>>4)&63],T+=m[(H<<2|M>>>6)&63],T+=m[M&63]}if(O===1){const y=a[L+0];T+=m[y>>>2],T+=m[y<<4&63],g&&(T+="==")}else if(O===2){const y=a[L+0],H=a[L+1];T+=m[y>>>2],T+=m[(y<<4|H>>>4)&63],T+=m[H<<2&63],g&&(T+="=")}return T}e.encodeBase64=n}),define(we[8],be([1,0,143,89]),function(te,e,h,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=A;const S=/{(\d+)}/g;function D(J,...pe){return pe.length===0?J:J.replace(S,function(Se,Ne){const He=parseInt(Ne,10);return isNaN(He)||He<0||He>=pe.length?Se:pe[He]})}e.format=D;const _=/{([^}]+)}/g;function R(J,pe){return J.replace(_,(Se,Ne)=>pe[Ne]??Se)}e.format2=R;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function I(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function p(J,pe){let Se=0;const Ne=pe.charCodeAt(0);for(let He=J.length-1;He>=0;He--)J.charCodeAt(He)===Ne&&Se++;return Se}e.count=p;function E(J,pe,Se="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Se}`}e.truncate=E;function v(J,pe=" "){const Se=d(J,pe);return w(Se,pe)}e.trim=v;function d(J,pe){if(!J||!pe)return J;const Se=pe.length;if(Se===0||J.length===0)return J;let Ne=0;for(;J.indexOf(pe,Ne)===Ne;)Ne=Ne+Se;return J.substring(Ne)}e.ltrim=d;function w(J,pe){if(!J||!pe)return J;const Se=pe.length,Ne=J.length;if(Se===0||Ne===0)return J;let He=Ne,Ye=-1;for(;Ye=J.lastIndexOf(pe,He-1),!(Ye===-1||Ye+Se!==He);){if(Ye===0)return"";He=Ye}return J.substring(0,He)}e.rtrim=w;function C(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=C;function P(J){return J.replace(/\*/g,"")}e.stripWildcards=P;function l(J,pe,Se={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=I(J)),Se.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ne="";return Se.global&&(Ne+="g"),Se.matchCase||(Ne+="i"),Se.multiline&&(Ne+="m"),Se.unicode&&(Ne+="u"),new RegExp(J,Ne)}e.createRegExp=l;function c(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function f(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function s(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=s;function b(J){return J.split(/\r\n|\r|\n/)}e.splitLines=b;function o(J){for(let pe=0,Se=J.length;pe<Se;pe++){const Ne=J.charCodeAt(pe);if(Ne!==32&&Ne!==9)return pe}return-1}e.firstNonWhitespaceIndex=o;function i(J,pe=0,Se=J.length){for(let Ne=pe;Ne<Se;Ne++){const He=J.charCodeAt(Ne);if(He!==32&&He!==9)return J.substring(pe,Ne)}return J.substring(pe,Se)}e.getLeadingWhitespace=i;function r(J,pe=J.length-1){for(let Se=pe;Se>=0;Se--){const Ne=J.charCodeAt(Se);if(Ne!==32&&Ne!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function n(J,pe){return J<pe?-1:J>pe?1:0}e.compare=n;function a(J,pe,Se=0,Ne=J.length,He=0,Ye=pe.length){for(;Se<Ne&&He<Ye;Se++,He++){let mt=J.charCodeAt(Se),Ve=pe.charCodeAt(He);if(mt<Ve)return-1;if(mt>Ve)return 1}const st=Ne-Se,pt=Ye-He;return st<pt?-1:st>pt?1:0}e.compareSubstring=a;function g(J,pe){return u(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=g;function u(J,pe,Se=0,Ne=J.length,He=0,Ye=pe.length){for(;Se<Ne&&He<Ye;Se++,He++){let mt=J.charCodeAt(Se),Ve=pe.charCodeAt(He);if(mt===Ve)continue;if(mt>=128||Ve>=128)return a(J.toLowerCase(),pe.toLowerCase(),Se,Ne,He,Ye);m(mt)&&(mt-=32),m(Ve)&&(Ve-=32);const ot=mt-Ve;if(ot!==0)return ot}const st=Ne-Se,pt=Ye-He;return st<pt?-1:st>pt?1:0}e.compareSubstringIgnoreCase=u;function m(J){return J>=97&&J<=122}e.isLowerAsciiLetter=m;function T(J){return J>=65&&J<=90}e.isUpperAsciiLetter=T;function O(J,pe){return J.length===pe.length&&u(J,pe)===0}e.equalsIgnoreCase=O;function L(J,pe){const Se=pe.length;return pe.length>J.length?!1:u(J,pe,0,Se)===0}e.startsWithIgnoreCase=L;function y(J,pe){let Se,Ne=Math.min(J.length,pe.length);for(Se=0;Se<Ne;Se++)if(J.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Ne}e.commonPrefixLength=y;function H(J,pe){let Se,Ne=Math.min(J.length,pe.length);const He=J.length-1,Ye=pe.length-1;for(Se=0;Se<Ne;Se++)if(J.charCodeAt(He-Se)!==pe.charCodeAt(Ye-Se))return Se;return Ne}e.commonSuffixLength=H;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function z(J){return 56320<=J&&J<=57343}e.isLowSurrogate=z;function x(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=x;function K(J,pe,Se){const Ne=J.charCodeAt(Se);if(M(Ne)&&Se+1<pe){const He=J.charCodeAt(Se+1);if(z(He))return x(Ne,He)}return Ne}e.getNextCodePoint=K;function B(J,pe){const Se=J.charCodeAt(pe-1);if(z(Se)&&pe>1){const Ne=J.charCodeAt(pe-2);if(M(Ne))return x(Ne,Se)}return Se}class G{constructor(pe,Se=0){this._str=pe,this._len=pe.length,this._offset=Se}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=B(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=K(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class X{constructor(pe,Se=0){this._iterator=new G(pe,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=$e.getInstance(),Se=this._iterator,Ne=Se.offset;let He=pe.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,st=pe.getGraphemeBreakType(Se.nextCodePoint());if(ze(He,st)){Se.setOffset(Ye);break}He=st}return Se.offset-Ne}prevGraphemeLength(){const pe=$e.getInstance(),Se=this._iterator,Ne=Se.offset;let He=pe.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,st=pe.getGraphemeBreakType(Se.prevCodePoint());if(ze(st,He)){Se.setOffset(Ye);break}He=st}return Ne-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function q(J,pe){return new X(J,pe).nextGraphemeLength()}e.nextCharLength=q;function ee(J,pe){return new X(J,pe).prevGraphemeLength()}e.prevCharLength=ee;function ae(J,pe){pe>0&&z(J.charCodeAt(pe))&&pe--;const Se=pe+q(J,pe);return[Se-ee(J,Se),Se]}e.getCharContainingOffset=ae;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(J){return ue.test(J)}e.containsRTL=Z;const Y=/^[\t\n\r\x20-\x7E]*$/;function se(J){return Y.test(J)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=de;function ve(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=ve;function Te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=Te;function Me(J,pe){if(J.length<pe)return J;const Se=/\b/g;let Ne=0;for(;Se.test(J)&&!(J.length-Se.lastIndex<pe);)Ne=Se.lastIndex,Se.lastIndex+=1;return J.substring(Ne).replace(/^\s/,"")}e.lcut=Me;const _e=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,$=/\x1b\[0?m/g;function U(J){return J&&(J=J.replace(_e,""),J=J.replace(Ee,""),J=J.replace($,"")),J}e.removeAnsiEscapeCodes=U,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function W(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=W;function j(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Se=pe.length,Ne=J.toLowerCase();let He=0,Ye=-1;for(;He<Se;){const st=Ne.indexOf(pe[He],Ye+1);if(st<0)return!1;Ye=st,He++}return!0}e.fuzzyContains=j;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function he(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=he;function Ce(J,pe=1){if(pe===0)return"";let Se=-1;do Se=J.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?J:(J[Se-1]==="\r"&&Se--,J.substr(0,Se))}e.getNLines=Ce;function Ae(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Ae;function We(J){return $e.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function ze(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var je;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ue()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Ne=Se.length/3;let He=1;for(;He<=Ne;)if(pe<Se[3*He])He=2*He;else if(pe>Se[3*He+1])He=2*He+1;else return Se[3*He+2];return 0}}$e._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(J,pe){if(J===0)return 0;const Se=et(J,pe);if(Se!==void 0)return Se;const Ne=new G(pe,J);return Ne.prevCodePoint(),Ne.offset}e.getLeftDeleteOffset=Qe;function et(J,pe){const Se=new G(pe,J);let Ne=Se.prevCodePoint();for(;Re(Ne)||Ne===65039||Ne===8419;){if(Se.offset===0)return;Ne=Se.prevCodePoint()}if(!Te(Ne))return;let He=Se.offset;return He>0&&Se.prevCodePoint()===8205&&(He=Se.offset),He}function Re(J){return 127995<=J&&J<=127999}var tt;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0";class ne{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ne.cache.get(Array.from(pe))}static getLocales(){return ne._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,k=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new h.LRUCachedComputed(J=>{function pe(Ve){const ot=new Map;for(let _t=0;_t<Ve.length;_t+=2)ot.set(Ve[_t],Ve[_t+1]);return ot}function Se(Ve,ot){const _t=new Map(Ve);for(const[it,lt]of ot)_t.set(it,lt);return _t}function Ne(Ve,ot){if(!Ve)return ot;const _t=new Map;for(const[it,lt]of Ve)ot.has(it)&&_t.set(it,lt);return _t}const He=k.ambiguousCharacterData.getValue();let Ye=J.filter(Ve=>!Ve.startsWith("_")&&Ve in He);Ye.length===0&&(Ye=["_default"]);let st;for(const Ve of Ye){const ot=pe(He[Ve]);st=Ne(st,ot)}const pt=pe(He._common),mt=Se(pt,st);return new ne(mt)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(pe){return oe.getData().has(pe)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(we[57],be([1,0,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(C){return k(C,0)}e.hash=t;function k(C,P){switch(typeof C){case"object":return C===null?A(349,P):Array.isArray(C)?_(C,P):R(C,P);case"string":return D(C,P);case"boolean":return S(C,P);case"number":return A(C,P);case"undefined":return A(937,P);default:return A(617,P)}}e.doHash=k;function A(C,P){return(P<<5)-P+C|0}e.numberHash=A;function S(C,P){return A(C?433:863,P)}function D(C,P){P=A(149417,P);for(let l=0,c=C.length;l<c;l++)P=A(C.charCodeAt(l),P);return P}e.stringHash=D;function _(C,P){return P=A(104579,P),C.reduce((l,c)=>k(c,l),P)}function R(C,P){return P=A(181387,P),Object.keys(C).sort().reduce((l,c)=>(l=D(c,l),k(C[c],l)),P)}class F{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=k(P,this._value),this._value}}e.Hasher=F;var I;(function(C){C[C.BLOCK_SIZE=64]="BLOCK_SIZE",C[C.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(C,P,l=32){const c=l-P,f=~((1<<c)-1);return(C<<P|(f&C)>>>c)>>>0}function E(C,P=0,l=C.byteLength,c=0){for(let f=0;f<l;f++)C[P+f]=c}function v(C,P,l="0"){for(;C.length<P;)C=l+C;return C}function d(C,P=32){return C instanceof ArrayBuffer?Array.from(new Uint8Array(C)).map(l=>l.toString(16).padStart(2,"0")).join(""):v((C>>>0).toString(16),P/4)}e.toHexString=d;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const c=this._buff;let f=this._buffLen,s=this._leftoverHighSurrogate,b,o;for(s!==0?(b=s,o=-1,s=0):(b=P.charCodeAt(0),o=0);;){let i=b;if(h.isHighSurrogate(b))if(o+1<l){const r=P.charCodeAt(o+1);h.isLowSurrogate(r)?(o++,i=h.computeCodePoint(b,r)):i=65533}else{s=b;break}else h.isLowSurrogate(b)&&(i=65533);if(f=this._push(c,f,i),o++,o<l)b=P.charCodeAt(o);else break}this._buffLen=f,this._leftoverHighSurrogate=s}_push(P,l,c){return c<128?P[l++]=c:c<2048?(P[l++]=192|(c&1984)>>>6,P[l++]=128|(c&63)>>>0):c<65536?(P[l++]=224|(c&61440)>>>12,P[l++]=128|(c&4032)>>>6,P[l++]=128|(c&63)>>>0):(P[l++]=240|(c&1835008)>>>18,P[l++]=128|(c&258048)>>>12,P[l++]=128|(c&4032)>>>6,P[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=w._bigBlock32,l=this._buffDV;for(let a=0;a<64;a+=4)P.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)P.setUint32(a,p(P.getUint32(a-12,!1)^P.getUint32(a-32,!1)^P.getUint32(a-56,!1)^P.getUint32(a-64,!1),1),!1);let c=this._h0,f=this._h1,s=this._h2,b=this._h3,o=this._h4,i,r,n;for(let a=0;a<80;a++)a<20?(i=f&s|~f&b,r=1518500249):a<40?(i=f^s^b,r=1859775393):a<60?(i=f&s|f&b|s&b,r=2400959708):(i=f^s^b,r=3395469782),n=p(c,5)+i+o+r+P.getUint32(a*4,!1)&4294967295,o=b,b=s,s=p(f,30),f=c,c=n;this._h0=this._h0+c&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[24],be([1,0,17,8]),function(te,e,h,t){"use strict";var k,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(o,i,r){let n=o.get(i);return n===void 0&&(n=r,o.set(i,n)),n}e.getOrSet=D;function _(o){const i=[];return o.forEach((r,n)=>{i.push(`${n} => ${r}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=_;function R(o){const i=[];return o.forEach(r=>{i.push(r)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=F;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class p{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const n=this._value.charCodeAt(r);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var E;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(E||(E={}));class v{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(w||(w={}));class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new v(i))}static forPaths(i=!1){return new C(new p(void 0,!i))}static forStrings(){return new C(new F)}static forConfigKeys(){return new C(new I)}clear(){this._root=void 0}fill(i,r){if(r){const n=r.slice(0);(0,h.shuffle)(n);for(let a of n)this.set(a,i)}else{const n=i.slice(0);(0,h.shuffle)(n);for(let a of n)this.set(a[0],a[1])}}set(i,r){const n=this._iter.reset(i);let a;this._root||(this._root=new d,this._root.segment=n.value());const g=[];for(a=this._root;;){const m=n.cmp(a.segment);if(m>0)a.left||(a.left=new d,a.left.segment=n.value()),g.push([-1,a]),a=a.left;else if(m<0)a.right||(a.right=new d,a.right.segment=n.value()),g.push([1,a]),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new d,a.mid.segment=n.value()),g.push([0,a]),a=a.mid;else break}const u=a.value;a.value=r,a.key=i;for(let m=g.length-1;m>=0;m--){const T=g[m][1];T.updateHeight();const O=T.balanceFactor();if(O<-1||O>1){const L=g[m][0],y=g[m+1][0];if(L===1&&y===1)g[m][1]=T.rotateLeft();else if(L===-1&&y===-1)g[m][1]=T.rotateRight();else if(L===1&&y===-1)T.right=g[m+1][1]=g[m+1][1].rotateRight(),g[m][1]=T.rotateLeft();else if(L===-1&&y===1)T.left=g[m+1][1]=g[m+1][1].rotateLeft(),g[m][1]=T.rotateRight();else throw new Error;if(m>0)switch(g[m-1][0]){case-1:g[m-1][1].left=g[m][1];break;case 1:g[m-1][1].right=g[m][1];break;case 0:g[m-1][1].mid=g[m][1];break}else this._root=g[0][1]}}return u}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const n=this._iter.reset(i),a=[];let g=this._root;for(;g;){const u=n.cmp(g.segment);if(u>0)a.push([-1,g]),g=g.left;else if(u<0)a.push([1,g]),g=g.right;else if(n.hasNext())n.next(),a.push([0,g]),g=g.mid;else break}if(!!g){if(r?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const u=this._min(g.right),{key:m,value:T,segment:O}=u;this._delete(u.key,!1),g.key=m,g.value=T,g.segment=O}else{const u=g.left??g.right;if(a.length>0){const[m,T]=a[a.length-1];switch(m){case-1:T.left=u;break;case 0:T.mid=u;break;case 1:T.right=u;break}}else this._root=u}for(let u=a.length-1;u>=0;u--){const m=a[u][1];m.updateHeight();const T=m.balanceFactor();if(T>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),a[u][1]=m.rotateLeft()):T<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),a[u][1]=m.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let n=this._root,a;for(;n;){const g=r.cmp(n.segment);if(g>0)n=n.left;else if(g<0)n=n.right;else if(r.hasNext())r.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[r,n]of this)i(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const n=r.balanceFactor();return n<-1||n>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=C;class P{constructor(i,r){this.uri=i,this.value=r}}class l{constructor(i,r){this[k]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=r??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new P(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[n,a]of this.map)i(a.value,a.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=o=>o.toString();var c;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class f{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const n=this._map.get(i);if(!!n)return r!==0&&this.touch(n,r),n.value}set(i,r,n=0){let a=this._map.get(i);if(a)a.value=r,n!==0&&this.touch(a,n);else{switch(a={key:i,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const n=this._state;let a=this._head;for(;a;){if(r?i.bind(r)(a.value,a.key,this):i(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:n.key,done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return a}values(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:n.value,done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return a}entries(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const g={value:[n.key,n.value],done:!1};return n=n.next,g}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>i;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,n=i.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const n=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const n=i.next,a=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,n)=>{i.push([n,r])}),i}fromJSON(i){this.clear();for(const[r,n]of i)this.set(r,n)}}e.LinkedMap=f;class s extends f{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class b{constructor(i){S.set(this,void 0),Ke(this,S,i,"f")}get size(){return Pe(this,S,"f").size}forEach(i,r){Pe(this,S,"f").forEach(i,r)}get(i){return Pe(this,S,"f").get(i)}has(i){return Pe(this,S,"f").has(i)}entries(){return Pe(this,S,"f").entries()}keys(){return Pe(this,S,"f").keys()}values(){return Pe(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Pe(this,S,"f").entries()}}e.ReadonlyMapView=b}),define(we[95],be([1,0,24,8]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...N){return function(W,j){for(let re=0,he=N.length;re<he;re++){const Ce=N[re](W,j);if(Ce)return Ce}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(N,W,j){if(!j||j.length<W.length)return null;let re;return N?re=t.startsWithIgnoreCase(j,W):re=j.indexOf(W)===0,re?W.length>0?[{start:0,end:W.length}]:[]:null}function S(N,W){const j=W.toLowerCase().indexOf(N.toLowerCase());return j===-1?null:[{start:j,end:j+N.length}]}e.matchesContiguousSubString=S;function D(N,W){return _(N.toLowerCase(),W.toLowerCase(),0,0)}e.matchesSubString=D;function _(N,W,j,re){if(j===N.length)return[];if(re===W.length)return null;if(N[j]===W[re]){let he=null;return(he=_(N,W,j+1,re+1))?C({start:re,end:re+1},he):null}return _(N,W,j,re+1)}function R(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function I(N){return 48<=N&&N<=57}function p(N){return N===32||N===9||N===10||N===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>E.add(N.charCodeAt(0)));function v(N){return p(N)||E.has(N)}function d(N,W){return N===W||v(N)&&v(W)}function w(N){return R(N)||F(N)||I(N)}function C(N,W){return W.length===0?W=[N]:N.end===W[0].start?W[0].start=N.start:W.unshift(N),W}function P(N,W){for(let j=W;j<N.length;j++){const re=N.charCodeAt(j);if(F(re)||I(re)||j>0&&!w(N.charCodeAt(j-1)))return j}return N.length}function l(N,W,j,re){if(j===N.length)return[];if(re===W.length)return null;if(N[j]!==W[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=l(N,W,j+1,re+1);!he&&(Ce=P(W,Ce))<W.length;)he=l(N,W,j+1,Ce),Ce++;return he===null?null:C({start:re,end:re+1},he)}}function c(N){let W=0,j=0,re=0,he=0,Ce=0;for(let $e=0;$e<N.length;$e++)Ce=N.charCodeAt($e),F(Ce)&&W++,R(Ce)&&j++,w(Ce)&&re++,I(Ce)&&he++;const Ae=W/N.length,We=j/N.length,ze=re/N.length,je=he/N.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:ze,numericPercent:je}}function f(N){const{upperPercent:W,lowerPercent:j}=N;return j===0&&W>.6}function s(N){const{upperPercent:W,lowerPercent:j,alphaPercent:re,numericPercent:he}=N;return j>.2&&W<.8&&re>.6&&he<.2}function b(N){let W=0,j=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),F(re)&&W++,R(re)&&j++,p(re)&&he++;return(W===0||j===0)&&he===0?N.length<=30:W<=5}function o(N,W){if(!W||(W=W.trim(),W.length===0)||!b(N)||W.length>60)return null;const j=c(W);if(!s(j)){if(!f(j))return null;W=W.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<W.length&&(re=l(N,W,0,he))===null;)he=P(W,he+1);return re}e.matchesCamelCase=o;function i(N,W,j=!1){if(!W||W.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),W=W.toLowerCase();he<W.length&&(re=r(N,W,0,he,j))===null;)he=n(W,he+1);return re}e.matchesWords=i;function r(N,W,j,re,he){if(j===N.length)return[];if(re===W.length)return null;if(d(N.charCodeAt(j),W.charCodeAt(re))){let Ce=null,Ae=re+1;if(Ce=r(N,W,j+1,re+1,he),!he)for(;!Ce&&(Ae=n(W,Ae))<W.length;)Ce=r(N,W,j+1,Ae,he),Ae++;return Ce===null?null:C({start:re,end:re+1},Ce)}else return null}function n(N,W){for(let j=W;j<N.length;j++)if(v(N.charCodeAt(j))||j>0&&v(N.charCodeAt(j-1)))return j;return N.length}const a=k(e.matchesPrefix,o,S),g=k(e.matchesPrefix,o,D),u=new h.LRUCache(1e4);function m(N,W,j=!1){if(typeof N!="string"||typeof W!="string")return null;let re=u.get(N);re||(re=new RegExp(t.convertSimple2RegExpPattern(N),"i"),u.set(N,re));const he=re.exec(W);return he?[{start:he.index,end:he.index+he[0].length}]:j?g(N,W):a(N,W)}e.matchesFuzzy=m;function T(N,W){const j=ve(N,N.toLowerCase(),0,W,W.toLowerCase(),0,!0);return j?L(j):null}e.matchesFuzzy2=T;function O(N,W,j,re,he,Ce){const Ae=Math.min(13,N.length);for(;j<Ae;j++){const We=ve(N,W,j,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=O;function L(N){if(typeof N=="undefined")return[];const W=[],j=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+j,Ce=W[W.length-1];Ce&&Ce.end===he?Ce.end=he+1:W.push({start:he,end:he+1})}return W}e.createMatches=L;const y=128;function H(){const N=[],W=[];for(let j=0;j<=y;j++)W[j]=0;for(let j=0;j<=y;j++)N.push(W.slice(0));return N}function M(N){const W=[];for(let j=0;j<=N;j++)W[j]=0;return W}const z=M(2*y),x=M(2*y),K=H(),B=H(),G=H(),X=!1;function q(N,W,j,re,he){function Ce(We,ze,je=" "){for(;We.length<ze;)We=je+We;return We}let Ae=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=j;We++)We===0?Ae+=" |":Ae+=`${W[We-1]}|`,Ae+=N[We].slice(0,he+1).map(ze=>Ce(ze.toString(),3)).join("|")+`
`;return Ae}function ee(N,W,j,re){N=N.substr(W),j=j.substr(re),console.log(q(B,N,N.length,j,j.length)),console.log(q(G,N,N.length,j,j.length)),console.log(q(K,N,N.length,j,j.length))}function ae(N,W){if(W<0||W>=N.length)return!1;const j=N.codePointAt(W);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(j)}}function ue(N,W){if(W<0||W>=N.length)return!1;switch(N.charCodeAt(W)){case 32:case 9:return!0;default:return!1}}function Z(N,W,j){return W[N]!==j[N]}function Y(N,W,j,re,he,Ce,Ae=!1){for(;W<j&&he<Ce;)N[W]===re[he]&&(Ae&&(z[W]=he),W+=1),he+=1;return W===j}e.isPatternInWord=Y;var se;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(se||(se={}));var de;(function(N){N.Default=[-100,0];function W(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}N.isDefault=W})(de=e.FuzzyScore||(e.FuzzyScore={}));function ve(N,W,j,re,he,Ce,Ae){const We=N.length>y?y:N.length,ze=re.length>y?y:re.length;if(j>=We||Ce>=ze||We-j>ze-Ce||!Y(W,j,We,he,Ce,ze,!0))return;Te(We,ze,j,Ce,W,he);let je=1,$e=1,Ue=j,Qe=Ce;const et=[!1];for(je=1,Ue=j;Ue<We;je++,Ue++){const J=z[Ue],pe=x[Ue],Se=Ue+1<We?x[Ue+1]:ze;for($e=J-Ce+1,Qe=J;Qe<Se;$e++,Qe++){let Ne=Number.MIN_SAFE_INTEGER,He=!1;Qe<=pe&&(Ne=Me(N,W,Ue,j,re,he,Qe,ze,Ce,K[je-1][$e-1]===0,et));let Ye=0;Ne!==Number.MAX_SAFE_INTEGER&&(He=!0,Ye=Ne+B[je-1][$e-1]);const st=Qe>J,pt=st?B[je][$e-1]+(K[je][$e-1]>0?-5:0):0,mt=Qe>J+1&&K[je][$e-1]>0,Ve=mt?B[je][$e-2]+(K[je][$e-2]>0?-5:0):0;if(mt&&(!st||Ve>=pt)&&(!He||Ve>=Ye))B[je][$e]=Ve,G[je][$e]=3,K[je][$e]=0;else if(st&&(!He||pt>=Ye))B[je][$e]=pt,G[je][$e]=2,K[je][$e]=0;else if(He)B[je][$e]=Ye,G[je][$e]=1,K[je][$e]=K[je-1][$e-1]+1;else throw new Error("not possible")}}if(X&&ee(N,j,re,Ce),!et[0]&&!Ae)return;je--,$e--;const Re=[B[je][$e],Ce];let tt=0,ne=0;for(;je>=1;){let J=$e;do{const pe=G[je][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);tt>1&&W[j+je-1]===he[Ce+$e-1]&&!Z(J+Ce-1,re,he)&&tt+1>K[je][J]&&(J=$e),J===$e?tt++:tt=1,ne||(ne=J),je--,$e=J-1,Re.push($e)}ze===We&&(Re[0]+=2);const oe=ne-We;return Re[0]-=oe,Re}e.fuzzyScore=ve;function Te(N,W,j,re,he,Ce){let Ae=N-1,We=W-1;for(;Ae>=j&&We>=re;)he[Ae]===Ce[We]&&(x[Ae]=We,Ae--),We--}function Me(N,W,j,re,he,Ce,Ae,We,ze,je,$e){if(W[j]!==Ce[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Qe=!1;return Ae===j-re?Ue=N[j]===he[Ae]?7:5:Z(Ae,he,Ce)&&(Ae===0||!Z(Ae-1,he,Ce))?(Ue=N[j]===he[Ae]?7:5,Qe=!0):ae(Ce,Ae)&&(Ae===0||!ae(Ce,Ae-1))?Ue=5:(ae(Ce,Ae-1)||ue(Ce,Ae-1))&&(Ue=5,Qe=!0),Ue>1&&j===re&&($e[0]=!0),Qe||(Qe=Z(Ae,he,Ce)||ae(Ce,Ae-1)||ue(Ce,Ae-1)),j===re?Ae>ze&&(Ue-=Qe?3:5):je?Ue+=Qe?2:0:Ue+=Qe?0:1,Ae+1===We&&(Ue-=Qe?3:5),Ue}function _e(N,W,j,re,he,Ce,Ae){return $(N,W,j,re,he,Ce,!0,Ae)}e.fuzzyScoreGracefulAggressive=_e;function Ee(N,W,j,re,he,Ce,Ae){return $(N,W,j,re,he,Ce,!1,Ae)}e.fuzzyScoreGraceful=Ee;function $(N,W,j,re,he,Ce,Ae,We){let ze=ve(N,W,j,re,he,Ce,We);if(ze&&!Ae)return ze;if(N.length>=3){const je=Math.min(7,N.length-1);for(let $e=j+1;$e<je;$e++){const Ue=U(N,$e);if(Ue){const Qe=ve(Ue,Ue.toLowerCase(),j,re,he,Ce,We);Qe&&(Qe[0]-=3,(!ze||Qe[0]>ze[0])&&(ze=Qe))}}}return ze}function U(N,W){if(W+1>=N.length)return;const j=N[W],re=N[W+1];if(j!==re)return N.slice(0,W)+re+j+N.slice(W+2)}}),define(we[144],be([1,0,73,95,8]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(h.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${A.source}`,"g");function _(w){return w.replace(D,(C,P)=>P?C:`\\${C}`)}e.escapeIcons=_;const R=new RegExp(`\\\\${A.source}`,"g");function F(w){return w.replace(R,C=>`\\${C}`)}e.markdownEscapeEscapedIcons=F;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(I,(C,P,l,c)=>l?C:P||c||"")}e.stripIcons=p;function E(w){const C=w.indexOf(e.iconStartMarker);return C===-1?{text:w}:v(w,C)}e.parseLabelWithIcons=E;function v(w,C){const P=[];let l="";function c(a){if(a){l+=a;for(const g of a)P.push(b)}}let f=-1,s="",b=0,o,i,r=C;const n=w.length;for(c(w.substr(0,C));r<n;)o=w[r],i=w[r+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=r,c(s),s=e.iconStartMarker,r++):o===")"&&f!==-1?(b+=r-f+1,f=-1,s=""):f!==-1?S.test(o)?s+=o:(c(s),f=-1,s=""):c(o),r++;return c(s),{text:l,iconOffsets:P}}function d(w,C,P=!1){const{text:l,iconOffsets:c}=C;if(!c||c.length===0)return(0,t.matchesFuzzy)(w,l,P);const f=(0,k.ltrim)(l," "),s=l.length-f.length,b=(0,t.matchesFuzzy)(w,f,P);if(b)for(const o of b){const i=c[o.start+s]+s;o.start+=i,o.end+=i}return b}e.matchesFuzzyIconAware=d}),define(we[78],be([1,0,24]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new h.LRUCache(1e4);function k(R){return _(R,"NFC",t)}e.normalizeNFC=k;const A=new h.LRUCache(1e4);function S(R){return _(R,"NFD",A)}e.normalizeNFD=S;const D=/[^\u0000-\u0080]/;function _(R,F,I){if(!R)return R;const p=I.get(R);if(p)return p;let E;return D.test(R)?E=R.normalize(F):E=R,I.set(R,E),E}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(F){return S(F).replace(R,"")}}()}),define(we[47],be([1,0,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",S="warning",D="warn",_="info",R="ignore";function F(p){return p?h.equalsIgnoreCase(A,p)?k.Error:h.equalsIgnoreCase(S,p)||h.equalsIgnoreCase(D,p)?k.Warning:h.equalsIgnoreCase(_,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=F;function I(p){switch(p){case k.Error:return A;case k.Warning:return S;case k.Info:return _;default:return R}}k.toString=I}(t||(t={})),e.default=t}),define(we[18],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(n){return Array.isArray(n)}e.isArray=h;function t(n){return typeof n=="string"}e.isString=t;function k(n){return Array.isArray(n)&&n.every(a=>t(a))}e.isStringArray=k;function A(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=A;function S(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=S;function D(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=D;function _(n){return n===!0||n===!1}e.isBoolean=_;function R(n){return typeof n=="undefined"}e.isUndefined=R;function F(n){return!I(n)}e.isDefined=F;function I(n){return R(n)||n===null}e.isUndefinedOrNull=I;function p(n,a){if(!n)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=p;function E(n){if(I(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=E;function v(...n){const a=[];for(let g=0;g<n.length;g++){const u=n[g];if(I(u))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);a.push(u)}return a}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function w(n){if(!A(n))return!1;for(let a in n)if(d.call(n,a))return!1;return!0}e.isEmptyObject=w;function C(n){return typeof n=="function"}e.isFunction=C;function P(...n){return n.length>0&&n.every(C)}e.areFunctions=P;function l(n,a){const g=Math.min(n.length,a.length);for(let u=0;u<g;u++)c(n[u],a[u])}e.validateConstraints=l;function c(n,a){if(t(a)){if(typeof n!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(C(a)){try{if(n instanceof a)return}catch{}if(!I(n)&&n.constructor===a||a.length===1&&a.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function f(n){let a=[],g=Object.getPrototypeOf(n);for(;Object.prototype!==g;)a=a.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return a}e.getAllPropertyNames=f;function s(n){const a=[];for(const g of f(n))typeof n[g]=="function"&&a.push(g);return a}e.getAllMethodNames=s;function b(n,a){const g=m=>function(){const T=Array.prototype.slice.call(arguments,0);return a(m,T)};let u={};for(const m of n)u[m]=g(m);return u}e.createProxyObject=b;function o(n){return n===null?void 0:n}e.withNullAsUndefined=o;function i(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=i;function r(n,a="Unreachable"){throw new Error(a)}e.assertNever=r}),define(we[30],be([1,0,9,12,8,18]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(r){return r===47||r===92}e.isPathSeparator=S;function D(r){return r.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=D;function _(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function R(r,n=h.posix.sep){if(!r)return"";const a=r.length,g=r.charCodeAt(0);if(S(g)){if(S(r.charCodeAt(1))&&!S(r.charCodeAt(2))){let m=3;const T=m;for(;m<a&&!S(r.charCodeAt(m));m++);if(T!==m&&!S(r.charCodeAt(m+1))){for(m+=1;m<a;m++)if(S(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,n)}}return n}else if(C(g)&&r.charCodeAt(1)===58)return S(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(S(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=R;function F(r){if(!t.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let a=2;const g=a;for(;a<r.length&&(n=r.charCodeAt(a),n!==92);a++);return!(g===a||(n=r.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=F;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,n=t.isWindows){const a=n?I:p;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||n&&E.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function d(r,n,a){const g=r===n;return!a||g?g:!r||!n?!1:(0,k.equalsIgnoreCase)(r,n)}e.isEqual=d;function w(r,n,a,g=h.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let m=n.length;return n.charAt(n.length-1)===g&&m--,r.charAt(m)===g}return n.charAt(n.length-1)!==g&&(n+=g),r.indexOf(n)===0}e.isEqualOrParent=w;function C(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=C;function P(r,n){return t.isWindows&&r.endsWith(":")&&(r+=h.sep),(0,h.isAbsolute)(r)||(r=(0,h.join)(n,r)),r=(0,h.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,h.sep),r.endsWith(":")&&(r+=h.sep)):(r=(0,k.rtrim)(r,h.sep),r||(r=h.sep)),r}e.sanitizeFilePath=P;function l(r){const n=(0,h.normalize)(r);return t.isWindows?r.length>3?!1:c(n)&&(r.length===2||n.charCodeAt(2)===92):n===h.posix.sep}e.isRootOrDriveLetter=l;function c(r,n){return(n!==void 0?n:t.isWindows)?C(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function f(r){return c(r)?r[0]:void 0}e.getDriveLetter=f;function s(r,n,a){return n.length>r.length?-1:r===n?0:(a&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=s;function b(r){const n=r.split(":");let a,g,u;for(const m of n){const T=Number(m);(0,A.isNumber)(T)?g===void 0?g=T:u===void 0&&(u=T):a=a?[a,m].join(":"):m}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:u!==void 0?u:g!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,n,a=8){let g="";for(let m=0;m<a;m++)g+=o.charAt(Math.floor(Math.random()*o.length));let u;return n?u=`${n}-${g}`:u=g,r?(0,h.join)(r,u):u}e.randomPath=i}),define(we[25],be([1,0,18]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(C=>{d[C]&&typeof d[C]=="object"?w[C]=t(d[C]):w[C]=d[C]}),w}e.deepClone=t;function k(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const C=w.shift();Object.freeze(C);for(const P in C)if(A.call(C,P)){const l=C[P];typeof l=="object"&&!Object.isFrozen(l)&&w.push(l)}}return d}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function S(d,w){return D(d,w,new Set)}e.cloneAndChange=S;function D(d,w,C){if((0,h.isUndefinedOrNull)(d))return d;const P=w(d);if(typeof P!="undefined")return P;if((0,h.isArray)(d)){const l=[];for(const c of d)l.push(D(c,w,C));return l}if((0,h.isObject)(d)){if(C.has(d))throw new Error("Cannot clone recursive data-structure");C.add(d);const l={};for(let c in d)A.call(d,c)&&(l[c]=D(d[c],w,C));return C.delete(d),l}return d}function _(d,w,C=!0){return(0,h.isObject)(d)?((0,h.isObject)(w)&&Object.keys(w).forEach(P=>{P in d?C&&((0,h.isObject)(d[P])&&(0,h.isObject)(w[P])?_(d[P],w[P],C):d[P]=w[P]):d[P]=w[P]}),d):w}e.mixin=_;function R(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let C,P;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(C=0;C<d.length;C++)if(!R(d[C],w[C]))return!1}else{const l=[];for(P in d)l.push(P);l.sort();const c=[];for(P in w)c.push(P);if(c.sort(),!R(l,c))return!1;for(C=0;C<l.length;C++)if(!R(d[l[C]],w[l[C]]))return!1}return!0}e.equals=R;function F(d){const w=new Set;return JSON.stringify(d,(C,P)=>{if((0,h.isObject)(P)||Array.isArray(P)){if(w.has(P))return"[Circular]";w.add(P)}return P})}e.safeStringify=F;function I(d,w,C){const P=w(d);return typeof P=="undefined"?C:P}e.getOrDefault=I;function p(d,w){const C=Object.create(null);return!d||!w||Object.keys(w).forEach(l=>{const c=d[l],f=w[l];R(c,f)||(C[l]=f)}),C}e.distinct=p;function E(d,w){const C=w.toLowerCase(),P=Object.keys(d).find(l=>l.toLowerCase()===C);return P?d[P]:d[w]}e.getCaseInsensitive=E;function v(d,w){const C=Object.create(null);for(const[P,l]of Object.entries(d))w(P,l)&&(C[P]=l);return C}e.filter=v}),define(we[96],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(we[2],be([1,0,9,12]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function D(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(o,i){return!o&&!i?"file":o}function R(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const F="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(i,r,n,a,g,u=!1){typeof i=="object"?(this.scheme=i.scheme||F,this.authority=i.authority||F,this.path=i.path||F,this.query=i.query||F,this.fragment=i.fragment||F):(this.scheme=_(i,u),this.authority=r||F,this.path=R(this.scheme,n||F),this.query=a||F,this.fragment=g||F,D(this,u))}static isUri(i){return i instanceof E?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:n,path:a,query:g,fragment:u}=i;return r===void 0?r=this.scheme:r===null&&(r=F),n===void 0?n=this.authority:n===null&&(n=F),a===void 0?a=this.path:a===null&&(a=F),g===void 0?g=this.query:g===null&&(g=F),u===void 0?u=this.fragment:u===null&&(u=F),r===this.scheme&&n===this.authority&&a===this.path&&g===this.query&&u===this.fragment?this:new d(r,n,a,g,u)}static parse(i,r=!1){const n=p.exec(i);return n?new d(n[2]||F,b(n[4]||F),b(n[5]||F),b(n[7]||F),b(n[9]||F),r):new d(F,F,F,F,F)}static file(i){let r=F;if(t.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const n=i.indexOf(I,2);n===-1?(r=i.substring(2),i=I):(r=i.substring(2,n),i=i.substring(n)||I)}return new d("file",r,i,F,F)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return D(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&i.scheme==="file"?n=E.file(h.win32.join(l(i,!0),...r)).path:n=h.posix.join(i.path,...r),i.with({path:n})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof E)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===v?i.fsPath:null,r}}else return i}}e.URI=E;const v=t.isWindows?1:void 0;class d extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=v),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function C(o,i){let r,n=-1;for(let a=0;a<o.length;a++){const g=o.charCodeAt(a);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||i&&g===47)n!==-1&&(r+=encodeURIComponent(o.substring(n,a)),n=-1),r!==void 0&&(r+=o.charAt(a));else{r===void 0&&(r=o.substr(0,a));const u=w[g];u!==void 0?(n!==-1&&(r+=encodeURIComponent(o.substring(n,a)),n=-1),r+=u):n===-1&&(n=a)}}return n!==-1&&(r+=encodeURIComponent(o.substring(n))),r!==void 0?r:o}function P(o){let i;for(let r=0;r<o.length;r++){const n=o.charCodeAt(r);n===35||n===63?(i===void 0&&(i=o.substr(0,r)),i+=w[n]):i!==void 0&&(i+=o[r])}return i!==void 0?i:o}function l(o,i){let r;return o.authority&&o.path.length>1&&o.scheme==="file"?r=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?r=o.path.substr(1):r=o.path[1].toLowerCase()+o.path.substr(2):r=o.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=l;function c(o,i){const r=i?P:C;let n="",{scheme:a,authority:g,path:u,query:m,fragment:T}=o;if(a&&(n+=a,n+=":"),(g||a==="file")&&(n+=I,n+=I),g){let O=g.indexOf("@");if(O!==-1){const L=g.substr(0,O);g=g.substr(O+1),O=L.indexOf(":"),O===-1?n+=r(L,!1):(n+=r(L.substr(0,O),!1),n+=":",n+=r(L.substr(O+1),!1)),n+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?n+=r(g,!1):(n+=r(g.substr(0,O),!1),n+=g.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}n+=r(u,!0)}return m&&(n+="?",n+=r(m,!1)),T&&(n+="#",n+=i?T:C(T,!1)),n}function f(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+f(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(o){return o.match(s)?o.replace(s,i=>f(i)):o}}),define(we[58],be([1,0,22,8,2]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(F){return JSON.stringify(F,_)}e.stringify=A;function S(F){let I=JSON.parse(F);return I=R(I),I}e.parse=S;var D;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(D=e.MarshalledId||(e.MarshalledId={}));function _(F,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function R(F,I=0){if(!F||I>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return k.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof h.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let p=0;p<F.length;++p)F[p]=R(F[p],I+1);else for(const p in F)Object.hasOwnProperty.call(F,p)&&(F[p]=R(F[p],I+1))}return F}e.revive=R}),define(we[10],be([1,0,12,2]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,R,F){this._hosts[_]=R,this._ports[_]=F}setConnectionToken(_,R){this._connectionTokens[_]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(_){if(this._delegate)return this._delegate(_);const R=_.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const I=this._ports[R],p=this._connectionTokens[R];let E=`path=${encodeURIComponent(_.path)}`;return typeof p=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:h.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${F}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new A;class S{asBrowserUri(_,R){const F=this.toUri(_,R);return F.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===k.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${k.vscodeFileResource}://${S.FALLBACK_AUTHORITY}`)?F.with({scheme:k.vscodeFileResource,authority:F.authority||S.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(_,R){const F=this.toUri(_,R);return F.scheme===k.vscodeFileResource?F.with({scheme:k.file,authority:F.authority!==S.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(_,R){return t.URI.isUri(_)?_:t.URI.parse(R.toUrl(_))}}S.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new S}),define(we[23],be([1,0,30,10,9,12,8,2]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,D.uriToFsPath)(E,!0)}e.originalFSPath=_;class R{constructor(v){this._ignorePathCasing=v}compare(v,d,w=!1){return v===d?0:(0,S.compare)(this.getComparisonKey(v,w),this.getComparisonKey(d,w))}isEqual(v,d,w=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,w)===this.getComparisonKey(d,w)}getComparisonKey(v,d=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,d,w=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return h.isEqualOrParent(_(v),_(d),this._ignorePathCasing(v))&&v.query===d.query&&(w||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return h.isEqualOrParent(v.path,d.path,this._ignorePathCasing(v),"/")&&v.query===d.query&&(w||v.fragment===d.fragment)}return!1}joinPath(v,...d){return D.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=D.URI.file(k.dirname(_(v))).path:(d=k.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=D.URI.file(k.normalize(_(v))).path:d=k.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const P=k.relative(_(v),_(d));return A.isWindows?h.toSlashes(P):P}let w=v.path||"/",C=d.path||"/";if(this._ignorePathCasing(v)){let P=0;for(const l=Math.min(w.length,C.length);P<l&&!(w.charCodeAt(P)!==C.charCodeAt(P)&&w.charAt(P).toLowerCase()!==C.charAt(P).toLowerCase());P++);w=C.substr(0,P)+w.substr(P)}return k.posix.relative(w,C)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const w=D.URI.file(k.resolve(_(v),d));return v.with({authority:w.authority,path:w.path})}return d=h.toPosixPath(d),v.with({path:k.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,S.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=k.sep){if(v.scheme===t.Schemas.file){const w=_(v);return w.length>h.getRoot(w).length&&w[w.length-1]===d}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=k.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=k.sep){let w=!1;if(v.scheme===t.Schemas.file){const C=_(v);w=C!==void 0&&C.length===h.getRoot(C).length&&C[C.length-1]===d}else{d="/";const C=v.path;w=C.length===1&&C.charCodeAt(C.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(E=>E.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new R(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(E,v){const d=[];for(let w=0;w<E.length;w++){const C=v(E[w]);E.some((P,l)=>l===w?!1:(0,e.isEqualOrParent)(C,v(P)))||d.push(E[w])}return d}e.distinctParents=F;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(d){const w=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,f]=l.split(":");c&&f&&w.set(c,f)});const P=d.path.substring(0,d.path.indexOf(";"));return P&&w.set(E.META_DATA_MIME,P),w}E.parseMetaData=v})(I=e.DataUri||(e.DataUri={}));function p(E,v,d){if(v){let w=E.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),E.with({scheme:d,authority:v,path:w})}return E.with({scheme:d})}e.toLocalResource=p}),define(we[13],be([1,0,21,16,3,6,23,12]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=_;function R(Z){const Y=new h.CancellationTokenSource,se=Z(Y.token),de=new Promise((ve,Te)=>{const Me=Y.token.onCancellationRequested(()=>{Me.dispose(),Y.dispose(),Te(new t.CancellationError)});Promise.resolve(se).then(_e=>{Me.dispose(),Y.dispose(),ve(_e)},_e=>{Me.dispose(),Y.dispose(),Te(_e)})});return new class{cancel(){Y.cancel()}then(ve,Te){return de.then(ve,Te)}catch(ve){return this.then(void 0,ve)}finally(ve){return de.finally(ve)}}}e.createCancelablePromise=R;function F(Z,Y,se){return new Promise((de,ve)=>{const Te=Y.onCancellationRequested(()=>{Te.dispose(),de(se)});Z.then(de,ve).finally(()=>Te.dispose())})}e.raceCancellation=F;function I(Z,Y){return new Promise((se,de)=>{const ve=Y.onCancellationRequested(()=>{ve.dispose(),de(new t.CancellationError)});Z.then(se,de).finally(()=>ve.dispose())})}e.raceCancellationError=I;async function p(Z){let Y=-1;const se=Z.map((ve,Te)=>ve.then(Me=>(Y=Te,Me))),de=await Promise.race(se);return Z.forEach((ve,Te)=>{Te!==Y&&ve.cancel()}),de}e.raceCancellablePromises=p;function E(Z,Y,se){let de;const ve=setTimeout(()=>{de?.(void 0),se?.()},Y);return Promise.race([Z.finally(()=>clearTimeout(ve)),new Promise(Te=>de=Te)])}e.raceTimeout=E;function v(Z){return new Promise((Y,se)=>{const de=Z();_(de)?de.then(Y,se):Y(de)})}e.asPromise=v;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const se=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(se,se).then(de)})}return new Promise((se,de)=>{this.queuedPromise.then(se,de)})}return this.activePromise=Y(),new Promise((se,de)=>{this.activePromise.then(ve=>{this.activePromise=null,se(ve)},ve=>{this.activePromise=null,de(ve)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=w;class C{constructor(){this.promiseMap=new Map}queue(Y,se){const ve=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get(Y)===ve&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ve),ve}}e.SequencerByKey=C;const P=(Z,Y)=>{let se=!0;const de=setTimeout(()=>{se=!1,Y()},Z);return{isTriggered:()=>se,dispose:()=>{clearTimeout(de),se=!1}}},l=Z=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Z())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,se=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ve,Te)=>{this.doResolve=ve,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ve=this.task;return this.task=null,ve()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===e.MicrotaskDelay?l(de):P(se,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class f{constructor(Y){this.delayer=new c(Y),this.throttler=new d}trigger(Y,se){return this.delayer.trigger(()=>this.throttler.queue(Y),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Y,se)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class b extends s{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function o(Z,Y){return Y?new Promise((se,de)=>{const ve=setTimeout(()=>{Te.dispose(),se()},Z),Te=Y.onCancellationRequested(()=>{clearTimeout(ve),Te.dispose(),de(new t.CancellationError)})}):R(se=>o(Z,se))}e.timeout=o;function i(Z,Y=0){const se=setTimeout(Z,Y);return(0,A.toDisposable)(()=>clearTimeout(se))}e.disposableTimeout=i;function r(Z){const Y=[];let se=0;const de=Z.length;function ve(){return se<de?Z[se++]():null}function Te(Me){Me!=null&&Y.push(Me);const _e=ve();return _e?_e.then(Te):Promise.resolve(Y)}return Promise.resolve(null).then(Te)}e.sequence=r;function n(Z,Y=de=>!!de,se=null){let de=0;const ve=Z.length,Te=()=>{if(de>=ve)return Promise.resolve(se);const Me=Z[de++];return Promise.resolve(Me()).then(Ee=>Y(Ee)?Promise.resolve(Ee):Te())};return Te()}e.first=n;function a(Z,Y=de=>!!de,se=null){if(Z.length===0)return Promise.resolve(se);let de=Z.length;const ve=()=>{de=-1;for(const Te of Z)Te.cancel?.()};return new Promise((Te,Me)=>{for(const _e of Z)_e.then(Ee=>{--de>=0&&Y(Ee)?(ve(),Te(Ee)):de===0&&Te(se)}).catch(Ee=>{--de>=0&&(ve(),Me(Ee))})})}e.firstParallel=a;class g{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((se,de)=>{this.outstandingPromises.push({factory:Y,c:se,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const se=Y.factory();se.then(Y.c,Y.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class u extends g{constructor(){super(1)}}e.Queue=u;class m{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new G;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,se=S.extUri){const de=se.getComparisonKey(Y);let ve=this.queues.get(de);return ve||(ve=new u,k.Event.once(ve.onFinished)(()=>{ve?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,ve)),ve}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=m;class T{constructor(Y,se){this._token=-1,typeof Y=="function"&&typeof se=="number"&&this.setIfNotSet(Y,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},se)}setIfNotSet(Y,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},se))}}e.TimeoutTimer=T;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setInterval(()=>{Y()},se)}}e.IntervalTimer=O;class L{constructor(Y,se){this.timeoutToken=-1,this.runner=Y,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class y{constructor(Y,se){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class H extends L{constructor(Y,se){super(Y,se);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class M extends A.Disposable{constructor(Y,se){super();this.options=Y,this.handler=se,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,D.setTimeout0)(()=>{if(Y)return;const se=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(Z,Y)=>{const se=requestIdleCallback(Z,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(se))}}}}();class z{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(se){this._error=se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function x(Z,Y,se){let de;for(let ve=0;ve<se;ve++)try{return await Z()}catch(Te){de=Te,await o(Y)}throw de}e.retry=x;class K{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,se,de){return this._pending={taskId:Y,cancel:()=>de?.(),promise:se},se.then(()=>this.donePending(Y),()=>this.donePending(Y)),se}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let se,de;const ve=new Promise((Te,Me)=>{se=Te,de=Me});this._next={run:Y,promise:ve,promiseResolve:se,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=K;class B{constructor(Y,se=()=>Date.now()){this.interval=Y,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,se)=>{this.completeCallback=Y,this.errorCallback=se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(se=>{this.completeCallback(Y),this.resolved=!0,se()})}error(Y){return new Promise(se=>{this.errorCallback(Y),this.rejected=!0,se()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=G;var X;(function(Z){async function Y(de){let ve;const Te=await Promise.all(de.map(Me=>Me.then(_e=>_e,_e=>{ve||(ve=_e)})));if(typeof ve!="undefined")throw ve;return Te}Z.settled=Y;function se(de){return new Promise(async(ve,Te)=>{try{await de(ve,Te)}catch(Me){Te(Me)}})}Z.withAsyncBody=se})(X=e.Promises||(e.Promises={}));var q;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(q||(q={}));class ee{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const se={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Y(se)),this.resolve()}catch(de){this.reject(de)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}static fromArray(Y){return new ee(se=>{se.emitMany(Y)})}static fromPromise(Y){return new ee(async se=>{se.emitMany(await Y)})}static fromPromises(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>se.emitOne(await de)))})}static merge(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>{for await(const ve of de)se.emitOne(ve)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,se){return new ee(async de=>{for await(const ve of Y)de.emitOne(se(ve))})}map(Y){return ee.map(this,Y)}static filter(Y,se){return new ee(async de=>{for await(const ve of Y)se(ve)&&de.emitOne(ve)})}filter(Y){return ee.filter(this,Y)}static coalesce(Y){return ee.filter(Y,se=>!!se)}coalesce(){return ee.coalesce(this)}static async toPromise(Y){const se=[];for await(const de of Y)se.push(de);return se}toPromise(){return ee.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ae extends ee{constructor(Y,se){super(se);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function ue(Z){const Y=new h.CancellationTokenSource,se=Z(Y.token);return new ae(Y,async de=>{const ve=Y.token.onCancellationRequested(()=>{ve.dispose(),Y.dispose(),de.reject(new t.CancellationError)});try{for await(const Te of se){if(Y.token.isCancellationRequested)return;de.emitOne(Te)}ve.dispose(),Y.dispose()}catch(Te){ve.dispose(),Y.dispose(),de.reject(Te)}})}e.createCancelableAsyncIterable=ue}),define(we[97],be([1,0,13,9]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new h.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(u,m,T=!1){const O=u||"",L=m||"",y=k.value.collator.compare(O,L);return k.value.collatorIsNumeric&&y===0&&O!==L?O<L?-1:1:y}e.compareFileNames=D;function _(u,m){const T=A.value.collator;return u=u||"",m=m||"",f(T,u,m)}e.compareFileNamesDefault=_;function R(u,m){const T=A.value.collator;return u=u||"",m=m||"",i(u,m)||f(T,u,m)}e.compareFileNamesUpper=R;function F(u,m){const T=A.value.collator;return u=u||"",m=m||"",o(u,m)||f(T,u,m)}e.compareFileNamesLower=F;function I(u,m){return u=u||"",m=m||"",u===m?0:u<m?-1:1}e.compareFileNamesUnicode=I;function p(u,m,T=!1){T||(u=u&&u.toLowerCase(),m=m&&m.toLowerCase());const[O,L]=l(u),[y,H]=l(m);return O!==y?O<y?-1:1:L===H?0:L<H?-1:1}e.noIntlCompareFileNames=p;function E(u,m){const[T,O]=l(u),[L,y]=l(m);let H=k.value.collator.compare(O,y);if(H===0){if(k.value.collatorIsNumeric&&O!==y)return O<y?-1:1;if(H=k.value.collator.compare(T,L),k.value.collatorIsNumeric&&H===0&&T!==L)return T<L?-1:1}return H}e.compareFileExtensions=E;function v(u,m){u=u||"",m=m||"";const T=c(u),O=c(m),L=A.value.collator,y=S.value.collator;return f(y,T,O)||f(L,u,m)}e.compareFileExtensionsDefault=v;function d(u,m){u=u||"",m=m||"";const T=c(u),O=c(m),L=A.value.collator,y=S.value.collator;return f(y,T,O)||i(u,m)||f(L,u,m)}e.compareFileExtensionsUpper=d;function w(u,m){u=u||"",m=m||"";const T=c(u),O=c(m),L=A.value.collator,y=S.value.collator;return f(y,T,O)||o(u,m)||f(L,u,m)}e.compareFileExtensionsLower=w;function C(u,m){u=u||"",m=m||"";const T=c(u).toLowerCase(),O=c(m).toLowerCase();return T!==O?T<O?-1:1:u!==m?u<m?-1:1:0}e.compareFileExtensionsUnicode=C;const P=/^(.*?)(\.([^.]*))?$/;function l(u,m=!1){const T=u?P.exec(u):[];let O=[T&&T[1]||"",T&&T[3]||""];return m&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function c(u){const m=u?P.exec(u):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function f(u,m,T){let O=u.compare(m,T);return O!==0?O:m.length!==T.length?m.length<T.length?-1:1:0}function s(u){const m=u.charAt(0);return m.toLocaleUpperCase()!==m}function b(u){const m=u.charAt(0);return m.toLocaleLowerCase()!==m}function o(u,m){return s(u)&&b(m)?-1:b(u)&&s(m)?1:0}function i(u,m){return b(u)&&s(m)?-1:s(u)&&b(m)?1:0}function r(u,m,T=!1){return T||(u=u&&u.toLowerCase(),m=m&&m.toLowerCase()),u===m?0:u<m?-1:1}function n(u,m,T=!1){const O=u.split(t.sep),L=m.split(t.sep),y=O.length-1,H=L.length-1;let M,z;for(let x=0;;x++){if(M=y===x,z=H===x,M&&z)return D(O[x],L[x],T);if(M)return-1;if(z)return 1;const K=r(O[x],L[x],T);if(K!==0)return K}}e.comparePaths=n;function a(u,m,T){const O=u.toLowerCase(),L=m.toLowerCase(),y=g(u,m,T);if(y)return y;const H=O.endsWith(T),M=L.endsWith(T);if(H!==M)return H?-1:1;const z=D(O,L);return z!==0?z:O.localeCompare(L)}e.compareAnything=a;function g(u,m,T){const O=u.toLowerCase(),L=m.toLowerCase(),y=O.startsWith(T),H=L.startsWith(T);if(y!==H)return y?-1:1;if(y&&H){if(O.length<L.length)return-1;if(O.length>L.length)return 1}return 0}e.compareByPrefix=g}),define(we[98],be([1,0,97,95,57,9,12,8]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,R=[_,[]];function F(K,B,G,X){if(!K||!B)return R;const q=K.length,ee=B.length;if(q<ee)return R;const ae=K.toLowerCase();return I(B,G,ee,K,ae,q,X)}e.scoreFuzzy=F;function I(K,B,G,X,q,ee,ae){const ue=[],Z=[];for(let ve=0;ve<G;ve++){const Te=ve*ee,Me=Te-ee,_e=ve>0,Ee=K[ve],$=B[ve];for(let U=0;U<ee;U++){const N=U>0,W=Te+U,j=W-1,re=Me+U-1,he=N?ue[j]:0,Ce=_e&&N?ue[re]:0,Ae=_e&&N?Z[re]:0;let We;!Ce&&_e?We=0:We=p(Ee,$,X,q,U,Ae),We&&Ce+We>=he&&(ae||_e||q.startsWith(B,U))?(Z[W]=Ae+1,ue[W]=Ce+We):(Z[W]=_,ue[W]=he)}}const Y=[];let se=G-1,de=ee-1;for(;se>=0&&de>=0;){const ve=se*ee+de;Z[ve]===_||(Y.push(de),se--),de--}return[ue[G*ee-1],Y.reverse()]}function p(K,B,G,X,q,ee){let ae=0;if(!E(B,X[q]))return ae;if(ae+=1,ee>0&&(ae+=ee*5),K===G[q]&&(ae+=1),q===0)ae+=8;else{const ue=v(G.charCodeAt(q-1));ue?ae+=ue:(0,t.isUpper)(G.charCodeAt(q))&&ee===0&&(ae+=2)}return ae}function E(K,B){return K===B?!0:K==="/"||K==="\\"?B==="/"||B==="\\":!1}function v(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function w(K,B,G=0,X=0){const q=B;return q.values&&q.values.length>1?C(K,q.values,G,X):P(K,B,G,X)}e.scoreFuzzy2=w;function C(K,B,G,X){let q=0;const ee=[];for(const ae of B){const[ue,Z]=P(K,ae,G,X);if(typeof ue!="number")return d;q+=ue,ee.push(...Z)}return[q,g(ee)]}function P(K,B,G,X){const q=(0,t.fuzzyScore)(B.original,B.originalLowercase,G,K,K.toLowerCase(),X,!0);return q?[q[0],(0,t.createMatches)(q)]:d}const l=Object.freeze({score:0}),c=1<<18,f=1<<17,s=1<<16;function b(K,B,G,X){const q=X.values?X.values:[X];return(0,k.hash)({[X.normalized]:{values:q.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:K,description:B,allowNonContiguousMatches:G}})}function o(K,B,G,X,q){if(!K||!B.normalized)return l;const ee=X.getItemLabel(K);if(!ee)return l;const ae=X.getItemDescription(K),ue=b(ee,ae,G,B),Z=q[ue];if(Z)return Z;const Y=i(ee,ae,X.getItemPath(K),B,G);return q[ue]=Y,Y}e.scoreItemFuzzy=o;function i(K,B,G,X,q){const ee=!G||!X.containsPathSeparator;return G&&(S.isLinux?X.pathNormalized===G:(0,D.equalsIgnoreCase)(X.pathNormalized,G))?{score:c,labelMatch:[{start:0,end:K.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:X.values&&X.values.length>1?r(K,B,G,X.values,ee,q):n(K,B,G,X,ee,q)}function r(K,B,G,X,q,ee){let ae=0;const ue=[],Z=[];for(const Y of X){const{score:se,labelMatch:de,descriptionMatch:ve}=n(K,B,G,Y,q,ee);if(se===_)return l;ae+=se,de&&ue.push(...de),ve&&Z.push(...ve)}return{score:ae,labelMatch:g(ue),descriptionMatch:g(Z)}}function n(K,B,G,X,q,ee){if(q||!B){const[ae,ue]=F(K,X.normalized,X.normalizedLowercase,ee&&!X.expectContiguousMatch);if(ae){const Z=(0,t.matchesPrefix)(X.normalized,K);let Y;return Z?(Y=f,Y+=Math.round(X.normalized.length/K.length*100)):Y=s,{score:Y+ae,labelMatch:Z||a(ue)}}}if(B){let ae=B;G&&(ae=`${B}${A.sep}`);const ue=ae.length,Z=`${ae}${K}`,[Y,se]=F(Z,X.normalized,X.normalizedLowercase,ee&&!X.expectContiguousMatch);if(Y){const de=a(se),ve=[],Te=[];return de.forEach(Me=>{Me.start<ue&&Me.end>ue?(ve.push({start:0,end:Me.end-ue}),Te.push({start:Me.start,end:ue})):Me.start>=ue?ve.push({start:Me.start-ue,end:Me.end-ue}):Te.push(Me)}),{score:Y,labelMatch:ve,descriptionMatch:Te}}}return l}function a(K){const B=[];if(!K)return B;let G;for(const X of K)G&&G.end===X?G.end+=1:(G={start:X,end:X+1},B.push(G));return B}function g(K){const B=K.sort((q,ee)=>q.start-ee.start),G=[];let X;for(const q of B)!X||!u(X,q)?(X=q,G.push(q)):(X.start=Math.min(X.start,q.start),X.end=Math.max(X.end,q.end));return G}function u(K,B){return!(K.end<B.start||B.end<K.start)}function m(K,B,G,X,q,ee){const ae=o(K,G,X,q,ee),ue=o(B,G,X,q,ee),Z=ae.score,Y=ue.score;if((Z===c||Y===c)&&Z!==Y)return Z===c?-1:1;if(Z>s||Y>s){if(Z!==Y)return Z>Y?-1:1;if(Z<f&&Y<f){const Ee=O(ae.labelMatch,ue.labelMatch);if(Ee!==0)return Ee}const Me=q.getItemLabel(K)||"",_e=q.getItemLabel(B)||"";if(Me.length!==_e.length)return Me.length-_e.length}if(Z!==Y)return Z>Y?-1:1;const se=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,de=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(se&&!de)return-1;if(de&&!se)return 1;const ve=T(K,ae,q),Te=T(B,ue,q);return ve&&Te&&ve!==Te?Te>ve?-1:1:L(K,B,G,q)}e.compareItemsByFuzzyScore=m;function T(K,B,G){let X=-1,q=-1;if(B.descriptionMatch&&B.descriptionMatch.length?X=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(X=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(q=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const ee=G.getItemDescription(K);ee&&(q+=ee.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(q=B.descriptionMatch[B.descriptionMatch.length-1].end);return q-X}function O(K,B){if(!K&&!B||(!K||!K.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!K||!K.length)return 1;const G=K[0].start,q=K[K.length-1].end-G,ee=B[0].start,ue=B[B.length-1].end-ee;return q===ue?0:ue<q?1:-1}function L(K,B,G,X){const q=X.getItemLabel(K)||"",ee=X.getItemLabel(B)||"",ae=X.getItemDescription(K),ue=X.getItemDescription(B),Z=q.length+(ae?ae.length:0),Y=ee.length+(ue?ue.length:0);if(Z!==Y)return Z-Y;const se=X.getItemPath(K),de=X.getItemPath(B);return se&&de&&se.length!==de.length?se.length-de.length:q!==ee?(0,h.compareAnything)(q,ee,G.normalized):ae&&ue&&ae!==ue?(0,h.compareAnything)(ae,ue,G.normalized):se&&de&&se!==de?(0,h.compareAnything)(se,de,G.normalized):0}function y(K){return K.startsWith('"')&&K.endsWith('"')}const H=" ";function M(K){typeof K!="string"&&(K="");const B=K.toLowerCase(),{pathNormalized:G,normalized:X,normalizedLowercase:q}=z(K),ee=G.indexOf(A.sep)>=0,ae=y(K);let ue;const Z=K.split(H);if(Z.length>1)for(const Y of Z){const se=y(Y),{pathNormalized:de,normalized:ve,normalizedLowercase:Te}=z(Y);ve&&(ue||(ue=[]),ue.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:de,normalized:ve,normalizedLowercase:Te,expectContiguousMatch:se}))}return{original:K,originalLowercase:B,pathNormalized:G,normalized:X,normalizedLowercase:q,values:ue,containsPathSeparator:ee,expectContiguousMatch:ae}}e.prepareQuery=M;function z(K){let B;S.isWindows?B=K.replace(/\//g,A.sep):B=K.replace(/\\/g,A.sep);const G=(0,D.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:G,normalizedLowercase:G.toLowerCase()}}function x(K){return Array.isArray(K)?M(K.map(B=>B.original).join(H)):M(K.original)}e.pieceToQuery=x}),define(we[32],be([1,0,13,30,24,9,12,8]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",F="[^/\\\\]",I=/\//g;function p(G){switch(G){case 0:return"";case 1:return`${F}*?`;default:return`(?:${R}|${F}+${R}|${R}${F}+)*?`}}function E(G,X){if(!G)return[];const q=[];let ee=!1,ae=!1,ue="";for(const Z of G){switch(Z){case X:if(!ee&&!ae){q.push(ue),ue="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ue+=Z}return ue&&q.push(ue),q}e.splitGlobAware=E;function v(G){if(!G)return"";let X="";const q=E(G,e.GLOB_SPLIT);if(q.every(ee=>ee===e.GLOBSTAR))X=".*";else{let ee=!1;q.forEach((ae,ue)=>{if(ae===e.GLOBSTAR){ee||(X+=p(2),ee=!0);return}let Z=!1,Y="",se=!1,de="";for(const ve of ae){if(ve!=="}"&&Z){Y+=ve;continue}if(se&&(ve!=="]"||!de)){let Te;ve==="-"?Te=ve:(ve==="^"||ve==="!")&&!de?Te="^":ve===e.GLOB_SPLIT?Te="":Te=(0,D.escapeRegExpCharacters)(ve),de+=Te;continue}switch(ve){case"{":Z=!0;continue;case"[":se=!0;continue;case"}":{X+=`(?:${E(Y,",").map(_e=>v(_e)).join("|")})`,Z=!1,Y="";break}case"]":X+="["+de+"]",se=!1,de="";break;case"?":X+=F;continue;case"*":X+=p(1);continue;default:X+=(0,D.escapeRegExpCharacters)(ve)}}ue<q.length-1&&(q[ue+1]!==e.GLOBSTAR||ue+2<q.length)&&(X+=R),ee=!1})}return X}const d=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,f=new k.LRUCache(1e4),s=function(){return!1},b=function(){return null};function o(G,X){if(!G)return b;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const ee=`${q}_${!!X.trimForExclusions}`;let ae=f.get(ee);if(ae)return i(ae,G);let ue;if(d.test(q)){const Z=q.substr(4);ae=function(Y,se){return typeof Y=="string"&&Y.endsWith(Z)?q:null}}else(ue=w.exec(r(q,X)))?ae=n(ue[1],q):(X.trimForExclusions?P:C).test(q)?ae=a(q,X):(ue=l.exec(r(q,X)))?ae=g(ue[1].substr(1),q,!0):(ue=c.exec(r(q,X)))?ae=g(ue[1],q,!1):ae=u(q);return f.set(ee,ae),i(ae,G)}function i(G,X){return typeof X=="string"?G:function(q,ee){return(0,t.isEqualOrParent)(q,X.base,!S.isLinux)?G(q.substr(X.base.length+1),ee):null}}function r(G,X){return X.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function n(G,X){const q=`/${G}`,ee=`\\${G}`,ae=function(Z,Y){return typeof Z!="string"?null:Y?Y===G?X:null:Z===G||Z.endsWith(q)||Z.endsWith(ee)?X:null},ue=[G];return ae.basenames=ue,ae.patterns=[X],ae.allBasenames=ue,ae}function a(G,X){const q=B(G.slice(1,-1).split(",").map(Y=>o(Y,X)).filter(Y=>Y!==b),G),ee=q.length;if(!ee)return b;if(ee===1)return q[0];const ae=function(Y,se){for(let de=0,ve=q.length;de<ve;de++)if(q[de](Y,se))return G;return null},ue=q.find(Y=>!!Y.allBasenames);ue&&(ae.allBasenames=ue.allBasenames);const Z=q.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(ae.allPaths=Z),ae}function g(G,X,q){const ee=A.sep===A.posix.sep,ae=ee?G:G.replace(I,A.sep),ue=A.sep+ae,Z=A.posix.sep+G,Y=q?function(se,de){return typeof se=="string"&&(se===ae||se.endsWith(ue)||!ee&&(se===G||se.endsWith(Z)))?X:null}:function(se,de){return typeof se=="string"&&(se===ae||!ee&&se===G)?X:null};return Y.allPaths=[(q?"*/":"./")+G],Y}function u(G){try{const X=new RegExp(`^${v(G)}$`);return function(q){return X.lastIndex=0,typeof q=="string"&&X.test(q)?G:null}}catch{return b}}function m(G,X,q){return!G||typeof X!="string"?!1:T(G)(X,void 0,q)}e.match=m;function T(G,X={}){if(!G)return s;if(typeof G=="string"||H(G)){const q=o(G,X);if(q===b)return s;const ee=function(ae,ue){return!!q(ae,ue)};return q.allBasenames&&(ee.allBasenames=q.allBasenames),q.allPaths&&(ee.allPaths=q.allPaths),ee}return x(G,X)}e.parse=T;function O(G){if(!G)return;let X;return q=>(X||(X=(G()||Promise.resolve([])).then(ee=>ee?y(ee):{})),X.then(ee=>!!ee[q]))}e.hasSiblingPromiseFn=O;function L(G){if(!G)return;let X;return q=>{if(!X){const ee=G();X=ee?y(ee):{}}return!!X[q]}}e.hasSiblingFn=L;function y(G){const X={};for(const q of G)X[q]=!0;return X}function H(G){const X=G;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.isRelativePattern=H;function M(G){return G.allBasenames||[]}e.getBasenameTerms=M;function z(G){return G.allPaths||[]}e.getPathTerms=z;function x(G,X){const q=B(Object.getOwnPropertyNames(G).map(Y=>K(Y,G[Y],X)).filter(Y=>Y!==b)),ee=q.length;if(!ee)return b;if(!q.some(Y=>!!Y.requiresSiblings)){if(ee===1)return q[0];const Y=function(ve,Te){for(let Me=0,_e=q.length;Me<_e;Me++){const Ee=q[Me](ve,Te);if(Ee)return Ee}return null},se=q.find(ve=>!!ve.allBasenames);se&&(Y.allBasenames=se.allBasenames);const de=q.reduce((ve,Te)=>Te.allPaths?ve.concat(Te.allPaths):ve,[]);return de.length&&(Y.allPaths=de),Y}const ae=function(Y,se,de){let ve;for(let Te=0,Me=q.length;Te<Me;Te++){const _e=q[Te];_e.requiresSiblings&&de&&(se||(se=(0,A.basename)(Y)),ve||(ve=se.substr(0,se.length-(0,A.extname)(Y).length)));const Ee=_e(Y,se,ve,de);if(Ee)return Ee}return null},ue=q.find(Y=>!!Y.allBasenames);ue&&(ae.allBasenames=ue.allBasenames);const Z=q.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(ae.allPaths=Z),ae}function K(G,X,q){if(X===!1)return b;const ee=o(G,q);if(ee===b)return b;if(typeof X=="boolean")return ee;if(X){const ae=X.when;if(typeof ae=="string"){const ue=(Z,Y,se,de)=>{if(!de||!ee(Z,Y))return null;const ve=ae.replace("$(basename)",se),Te=de(ve);return(0,h.isThenable)(Te)?Te.then(Me=>Me?G:null):Te?G:null};return ue.requiresSiblings=!0,ue}}return ee}function B(G,X){const q=G.filter(Y=>!!Y.basenames);if(q.length<2)return G;const ee=q.reduce((Y,se)=>{const de=se.basenames;return de?Y.concat(de):Y},[]);let ae;if(X){ae=[];for(let Y=0,se=ee.length;Y<se;Y++)ae.push(X)}else ae=q.reduce((Y,se)=>{const de=se.patterns;return de?Y.concat(de):Y},[]);const ue=function(Y,se){if(typeof Y!="string")return null;if(!se){let ve;for(ve=Y.length;ve>0;ve--){const Te=Y.charCodeAt(ve-1);if(Te===47||Te===92)break}se=Y.substr(ve)}const de=ee.indexOf(se);return de!==-1?ae[de]:null};ue.basenames=ee,ue.patterns=ae,ue.allBasenames=ee;const Z=G.filter(Y=>!Y.basenames);return Z.push(ue),Z}}),define(we[99],be([1,0,16,144,23,2]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",w=!1){if(this.value=d,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(d,w=0){return this.value+=I(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(C,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,w){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}}e.MarkdownString=D;function _(v){return R(v)?!v.value:Array.isArray(v)?v.every(_):!0}e.isEmptyMarkdownString=_;function R(v){return v instanceof D?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function F(v,d){return v===d?!0:!v||!d?!1:v.value===d.value&&v.isTrusted===d.isTrusted&&v.supportThemeIcons===d.supportThemeIcons&&v.supportHtml===d.supportHtml&&(v.baseUri===d.baseUri||!!v.baseUri&&!!d.baseUri&&(0,k.isEqual)(A.URI.from(v.baseUri),A.URI.from(d.baseUri)))}e.markdownStringEqual=F;function I(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function p(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function E(v){const d=[],w=v.split("|").map(P=>P.trim());v=w[0];const C=w[1];if(C){const P=/height=(\d+)/.exec(C),l=/width=(\d+)/.exec(C),c=P?P[1]:"",f=l?l[1]:"",s=isFinite(parseInt(f)),b=isFinite(parseInt(c));s&&d.push(`width="${f}"`),b&&d.push(`height="${c}"`)}return{href:v,dimensions:d}}e.parseHrefAndDimensions=E}),define(we[100],be([1,0,30,10,9,12,23,8,2]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,r,n){if(typeof i=="string"&&(i=_.URI.file(i)),n){const g=n.getWorkspaceFolder(i);if(g){const u=n.getWorkspace().folders.length>1;let m;if((0,S.isEqual)(g.uri,i)?m="":m=(0,S.relativePath)(g.uri,i),u){const T=g.name?g.name:(0,S.basename)(g.uri);m=m?T+" \u2022 "+m:T}return m}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(i.fsPath))return(0,k.normalize)(I(i.fsPath));let a=(0,k.normalize)(i.fsPath);return!A.isWindows&&r?.userHome&&(a=E(a,r.userHome.fsPath)),a}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=_.URI.file(i));const r=(0,S.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return A.isWindows&&(0,h.isRootOrDriveLetter)(r)?I(r):r}e.getBaseLabel=F;function I(i,r){return(0,h.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let p=Object.create(null);function E(i,r){if(A.isWindows||!i||!r)return i;let n=p.original===r?p.normalized:void 0;return n||(n=`${(0,D.rtrim)(r,k.posix.sep)}${k.posix.sep}`,p={original:r,normalized:n}),(A.isLinux?i.startsWith(n):(0,D.startsWithIgnoreCase)(i,n))&&(i=`~/${i.substr(n.length)}`),i}e.tildify=E;function v(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=v;const d="\u2026",w="\\\\",C="~";function P(i,r=k.sep){const n=new Array(i.length);let a=!1;for(let g=0;g<i.length;g++){let u=i[g];if(u===""){n[g]=`.${r}`;continue}if(!u){n[g]=u;continue}a=!0;let m="";u.indexOf(w)===0?(m=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length)):u.indexOf(r)===0?(m=u.substr(0,u.indexOf(r)+r.length),u=u.substr(u.indexOf(r)+r.length)):u.indexOf(C)===0&&(m=u.substr(0,u.indexOf(C)+C.length),u=u.substr(u.indexOf(C)+C.length));const T=u.split(r);for(let O=1;a&&O<=T.length;O++)for(let L=T.length-O;a&&L>=0;L--){a=!1;let y=T.slice(L,L+O).join(r);for(let H=0;!a&&H<i.length;H++)if(H!==g&&i[H]&&i[H].indexOf(y)>-1){const M=L+O===T.length,z=L>0&&i[H].indexOf(r)>-1?r+y:y,x=i[H].endsWith(z);a=!M||x}if(!a){let H="";(T[0].endsWith(":")||m!=="")&&(L===1&&(L=0,O++,y=T[0]+r+y),L>0&&(H=T[0]+r),H=m+H),L>0&&(H=H+d+r),H=H+y,L+O<T.length&&(H=H+r+d),n[g]=H}}a&&(n[g]=u)}return n}e.shorten=P;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(i,r=Object.create(null)){const n=[];let a=!1,g="";for(const u of i)if(u==="$"||a&&u==="{")g&&n.push({value:g,type:l.TEXT}),g="",a=!0;else if(u==="}"&&a){const m=r[g];if(typeof m=="string")m.length&&n.push({value:m,type:l.VARIABLE});else if(m){const T=n[n.length-1];(!T||T.type!==l.SEPARATOR)&&n.push({value:m.label,type:l.SEPARATOR})}g="",a=!1}else g+=u;return g&&!a&&n.push({value:g,type:l.TEXT}),n.filter((u,m)=>{if(u.type===l.SEPARATOR){const T=n[m-1],O=n[m+1];return[T,O].every(L=>L&&(L.type===l.VARIABLE||L.type===l.TEXT)&&L.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=c;function f(i,r){return A.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function s(i,r){return A.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,n=>n==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function b(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=b;function o(i){const r=i.indexOf("/")!==-1?k.posix:k.win32,n=r.basename(i),a=r.dirname(i);return n.length?{name:n,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(we[101],be([1,0,2]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const p=this._uriTransformer.transformIncoming(I);return p===I?I:t(h.URI.from(p))}transformOutgoing(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:t(h.URI.from(p))}transformOutgoingURI(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:h.URI.from(p)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,I,p){if(!F||p>200)return null;if(typeof F=="object"){if(F instanceof h.URI)return I.transformOutgoing(F);for(let E in F)if(Object.hasOwnProperty.call(F,E)){const v=A(F[E],I,p+1);v!==null&&(F[E]=v)}}return null}function S(F,I){const p=A(F,I,0);return p===null?F:p}e.transformOutgoingURIs=S;function D(F,I,p,E){if(!F||E>200)return null;if(typeof F=="object"){if(F.$mid===1)return p?h.URI.revive(I.transformIncoming(F)):I.transformIncoming(F);for(let v in F)if(Object.hasOwnProperty.call(F,v)){const d=D(F[v],I,p,E+1);d!==null&&(F[v]=d)}}return null}function _(F,I){const p=D(F,I,!1,0);return p===null?F:p}e.transformIncomingURIs=_;function R(F,I){const p=D(F,I,!0,0);return p===null?F:p}e.transformAndReviveIncomingURIs=R}),define(we[33],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(_){return h.test(_)}e.isUUID=t;const k=new Uint8Array(16),A=[];for(let _=0;_<256;_++)A.push(_.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(_){for(let R=0;R<_.length;R++)_[R]=Math.floor(Math.random()*256);return _};function D(){S(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let _=0,R="";return R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R+="-",R+=A[k[_++]],R+=A[k[_++]],R+="-",R+=A[k[_++]],R+=A[k[_++]],R+="-",R+=A[k[_++]],R+=A[k[_++]],R+="-",R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R+=A[k[_++]],R}e.generateUuid=D}),define(we[145],be([1,0,102]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(A="utf8"){this.stringDecoder=new h.StringDecoder(A),this.remaining=null}write(A){const S=[],D=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(D.length<1)return S;let _=0,R,F=_;for(;F<D.length;)if(R=D.charCodeAt(F),R===13||R===10){if(S.push(D.substring(_,F)),F++,F<D.length){const I=R;R=D.charCodeAt(F),(I===13&&R===10||I===10&&R===13)&&F++}_=F}else F++;return this.remaining=_<D.length?D.substr(_):null,S}end(){return this.remaining}}e.LineDecoder=t}),define(we[28],be([1,0,59,60,291,13,30,78,9,12,23,2]),function(te,e,h,t,k,A,S,D,_,R,F,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function E(M,z=p.UNLINK){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?d(M):v(M)}async function v(M){try{const z=(0,S.randomPath)((0,t.tmpdir)());try{await h.promises.rename(M,z)}catch{return d(M)}d(z).catch(x=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function d(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function w(M){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");h.rmdirSync(M,{recursive:!0})}e.rimrafSync=w;async function C(M,z){return c(await(z?P(M):(0,k.promisify)(h.readdir)(M)))}async function P(M){try{return await(0,k.promisify)(h.readdir)(M,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const z=[],x=await C(M);for(const K of x){let B=!1,G=!1,X=!1;try{const q=await e.Promises.lstat((0,_.join)(M,K));B=q.isFile(),G=q.isDirectory(),X=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}z.push({name:K,isFile:()=>B,isDirectory:()=>G,isSymbolicLink:()=>X})}return z}function l(M){return c(h.readdirSync(M))}e.readdirSync=l;function c(M){return M.map(z=>typeof z=="string"?R.isMacintosh?(0,D.normalizeNFC)(z):z:(z.name=R.isMacintosh?(0,D.normalizeNFC)(z.name):z.name,z))}async function f(M){const z=await C(M),x=[];for(const K of z)await b.existsDirectory((0,_.join)(M,K))&&x.push(K);return x}function s(M,z=1e3){return new Promise(x=>{let K=!1;const B=setInterval(()=>{K||(K=!0,h.access(M,G=>{K=!1,G&&(clearInterval(B),x(void 0))}))},z)})}e.whenDeleted=s;var b;(function(M){async function z(B){let G;try{if(G=await e.Promises.lstat(B),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(R.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw q}throw X}}M.stat=z;async function x(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isFile()&&X?.dangling!==!0}catch{}return!1}M.existsFile=x;async function K(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isDirectory()&&X?.dangling!==!0}catch{}return!1}M.existsDirectory=K})(b=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function i(M,z,x){return o.queueFor(I.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const K=g(x);return new Promise((B,G)=>n(M,z,K,X=>X?G(X):B()))})}let r=!0;function n(M,z,x,K){if(!r)return h.writeFile(M,z,{mode:x.mode,flag:x.flag},K);h.open(M,x.flag,x.mode,(B,G)=>{if(B)return K(B);h.writeFile(G,z,X=>{if(X)return h.close(G,()=>K(X));h.fdatasync(G,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),r=!1),h.close(G,ee=>K(ee))))})})}function a(M,z,x){const K=g(x);if(!r)return h.writeFileSync(M,z,{mode:K.mode,flag:K.flag});const B=h.openSync(M,K.flag,K.mode);try{h.writeFileSync(B,z);try{h.fdatasyncSync(B)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),r=!1}}finally{h.closeSync(B)}}e.writeFileSync=a;function g(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function u(M,z){if(M===z)return;async function x(K){try{const B=await e.Promises.lstat(K);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(K,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,z),await x(z)}catch(K){if(M.toLowerCase()!==z.toLowerCase()&&K.code==="EXDEV"||M.endsWith("."))await m(M,z,{preserveSymlinks:!1}),await E(M,p.MOVE),await x(z);else throw K}}async function m(M,z,x){return O(M,z,{root:{source:M,target:z},options:x,handledSourcePaths:new Set})}const T=511;async function O(M,z,x){if(x.handledSourcePaths.has(M))return;x.handledSourcePaths.add(M);const{stat:K,symbolicLink:B}=await b.stat(M);if(B){if(x.options.preserveSymlinks)try{return await H(M,z,x)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(B.dangling)return}return K.isDirectory()?L(M,z,K.mode&T,x):y(M,z,K.mode&T)}async function L(M,z,x,K){await e.Promises.mkdir(z,{recursive:!0,mode:x});const B=await C(M);for(const G of B)await O((0,_.join)(M,G),(0,_.join)(z,G),K)}async function y(M,z,x){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,x)}async function H(M,z,x){let K=await e.Promises.readlink(M);(0,S.isEqualOrParent)(K,x.root.source,!R.isLinux)&&(K=(0,_.join)(x.root.target,K.substr(x.root.source.length+1))),await e.Promises.symlink(K,z)}e.Promises=new class{get access(){return(0,k.promisify)(h.access)}get stat(){return(0,k.promisify)(h.stat)}get lstat(){return(0,k.promisify)(h.lstat)}get utimes(){return(0,k.promisify)(h.utimes)}get read(){return(M,z,x,K,B)=>new Promise((G,X)=>{h.read(M,z,x,K,B,(q,ee,ae)=>q?X(q):G({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,k.promisify)(h.readFile)}get write(){return(M,z,x,K,B)=>new Promise((G,X)=>{h.write(M,z,x,K,B,(q,ee,ae)=>q?X(q):G({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,k.promisify)(h.appendFile)}get fdatasync(){return(0,k.promisify)(h.fdatasync)}get truncate(){return(0,k.promisify)(h.truncate)}get rename(){return(0,k.promisify)(h.rename)}get copyFile(){return(0,k.promisify)(h.copyFile)}get open(){return(0,k.promisify)(h.open)}get close(){return(0,k.promisify)(h.close)}get symlink(){return(0,k.promisify)(h.symlink)}get readlink(){return(0,k.promisify)(h.readlink)}get chmod(){return(0,k.promisify)(h.chmod)}get mkdir(){return(0,k.promisify)(h.mkdir)}get unlink(){return(0,k.promisify)(h.unlink)}get rmdir(){return(0,k.promisify)(h.rmdir)}get realpath(){return(0,k.promisify)(h.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return f}get writeFile(){return i}get rm(){return E}get move(){return u}get copy(){return m}}}),define(we[103],be([1,0,59,9,12,8,28]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(p){if(k.isLinux)return p;const E=(0,t.dirname)(p);if(p===E)return p;const v=((0,t.basename)(p)||p).toLowerCase();try{const w=(0,S.readdirSync)(E).filter(C=>C.toLowerCase()===v);if(w.length===1){const C=D(E);if(C)return(0,t.join)(C,w[0])}else if(w.length>1){const C=w.indexOf(v);if(C>=0){const P=D(E);if(P)return(0,t.join)(P,w[C])}}}catch{}return null}e.realcaseSync=D;async function _(p){if(k.isLinux)return p;const E=(0,t.dirname)(p);if(p===E)return p;const v=((0,t.basename)(p)||p).toLowerCase();try{const w=(await S.Promises.readdir(E)).filter(C=>C.toLowerCase()===v);if(w.length===1){const C=await _(E);if(C)return(0,t.join)(C,w[0])}else if(w.length>1){const C=w.indexOf(v);if(C>=0){const P=await _(E);if(P)return(0,t.join)(P,w[C])}}}catch{}return null}e.realcase=_;async function R(p){try{return await S.Promises.realpath(p)}catch{const v=I(p);return await S.Promises.access(v,h.constants.R_OK),v}}e.realpath=R;function F(p){try{return h.realpathSync(p)}catch{const v=I(p);return h.accessSync(v,h.constants.R_OK),v}}e.realpathSync=F;function I(p){return(0,A.rtrim)((0,t.normalize)(p),t.sep)}});var Be=this&&this.__decorate||function(te,e,h,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,h):t,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,h,t);else for(var D=te.length-1;D>=0;D--)(S=te[D])&&(A=(k<3?S(A):k>3?S(e,h,A):S(e,h))||A);return k>3&&A&&Object.defineProperty(e,h,A),A};define(we[104],be([1,0,17,13,22,21,56,16,3,6,58,8,18]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function v(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function w(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var C;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(C||(C={}));class P{constructor(X){this.buffer=X,this.pos=0}read(X){const q=this.buffer.slice(this.pos,this.pos+X);return this.pos+=q.byteLength,q}}class l{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(c||(c={}));function f(G){const X=k.VSBuffer.alloc(4);return X.writeUInt32BE(G,0),X}function s(G){return G.read(4).readUInt32BE(0)}function b(G){const X=k.VSBuffer.alloc(1);return X.writeUInt8(G,0),X}const o={Undefined:b(c.Undefined),String:b(c.String),Buffer:b(c.Buffer),VSBuffer:b(c.VSBuffer),Array:b(c.Array),Object:b(c.Object)},i=typeof Buffer!="undefined";function r(G,X){if(typeof X=="undefined")G.write(o.Undefined);else if(typeof X=="string"){const q=k.VSBuffer.fromString(X);G.write(o.String),G.write(f(q.byteLength)),G.write(q)}else if(i&&Buffer.isBuffer(X)){const q=k.VSBuffer.wrap(X);G.write(o.Buffer),G.write(f(q.byteLength)),G.write(q)}else if(X instanceof k.VSBuffer)G.write(o.VSBuffer),G.write(f(X.byteLength)),G.write(X);else if(Array.isArray(X)){G.write(o.Array),G.write(f(X.length));for(const q of X)r(G,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(X));G.write(o.Object),G.write(f(q.byteLength)),G.write(q)}}function n(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(s(G)).toString();case c.Buffer:return G.read(s(G)).buffer;case c.VSBuffer:return G.read(s(G));case c.Array:{const q=s(G),ee=[];for(let ae=0;ae<q;ae++)ee.push(n(G));return ee}case c.Object:return JSON.parse(G.read(s(G)).toString())}}class a{constructor(X,q,ee=null,ae=1e3){this.protocol=X,this.ctx=q,this.logger=ee,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(X,q){this.channels.set(X,q),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const q=this.send([X.type]);this.logger?.logOutgoing(q,0,1,w(X.type));return}case 201:case 202:case 204:case 203:{const q=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(q,X.id,1,w(X.type),X.data);return}}}send(X,q=void 0){const ee=new l;return r(ee,X),r(ee,q),this.sendBuffer(ee.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const q=new P(X),ee=n(q),ae=n(q),ue=ee[0];switch(ue){case 100:return this.logger?.logIncoming(X.byteLength,ee[1],1,`${v(ue)}: ${ee[2]}.${ee[3]}`,ae),this.onPromise({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:ae});case 102:return this.logger?.logIncoming(X.byteLength,ee[1],1,`${v(ue)}: ${ee[2]}.${ee[3]}`,ae),this.onEventListen({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:ae});case 101:return this.logger?.logIncoming(X.byteLength,ee[1],1,`${v(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]});case 103:return this.logger?.logIncoming(X.byteLength,ee[1],1,`${v(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]})}}onPromise(X){const q=this.channels.get(X.channelName);if(!q){this.collectPendingRequest(X);return}const ee=new A.CancellationTokenSource;let ae;try{ae=q.call(this.ctx,X.name,X.arg,ee.token)}catch(Y){ae=Promise.reject(Y)}const ue=X.id;ae.then(Y=>{this.sendResponse({id:ue,data:Y,type:201}),this.activeRequests.delete(X.id)},Y=>{Y instanceof Error?this.sendResponse({id:ue,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ue,data:Y,type:203}),this.activeRequests.delete(X.id)});const Z=(0,R.toDisposable)(()=>ee.cancel());this.activeRequests.set(X.id,Z)}onEventListen(X){const q=this.channels.get(X.channelName);if(!q){this.collectPendingRequest(X);return}const ee=X.id,ue=q.listen(this.ctx,X.name,X.arg)(Z=>this.sendResponse({id:ee,data:Z,type:204}));this.activeRequests.set(X.id,ue)}disposeActiveRequest(X){const q=this.activeRequests.get(X.id);q&&(q.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let q=this.pendingRequests.get(X.channelName);q||(q=[],this.pendingRequests.set(X.channelName,q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:X,timeoutTimer:ee})}flushPendingRequests(X){const q=this.pendingRequests.get(X);if(q){for(const ee of q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(X,q=null){this.protocol=X,this.isDisposed=!1,this.state=C.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=q}getChannel(X){const q=this;return{call(ee,ae,ue){return q.isDisposed?Promise.reject(D.canceled()):q.requestPromise(X,ee,ae,ue)},listen(ee,ae){return q.isDisposed?Promise.reject(D.canceled()):q.requestEvent(X,ee,ae)}}}requestPromise(X,q,ee,ae=A.CancellationToken.None){const ue=this.lastRequestId++,Y={id:ue,type:100,channelName:X,name:q,arg:ee};if(ae.isCancellationRequested)return Promise.reject(D.canceled());let se;return new Promise((ve,Te)=>{if(ae.isCancellationRequested)return Te(D.canceled());const Me=()=>{const U=N=>{switch(N.type){case 201:this.handlers.delete(ue),ve(N.data);break;case 202:{this.handlers.delete(ue);const W=new Error(N.data.message);W.stack=N.data.stack,W.name=N.data.name,Te(W);break}case 203:this.handlers.delete(ue),Te(N.data);break}};this.handlers.set(ue,U),this.sendRequest(Y)};let _e=null;this.state===C.Idle?Me():(_e=(0,t.createCancelablePromise)(U=>this.whenInitialized()),_e.then(()=>{_e=null,Me()}));const Ee=()=>{_e?(_e.cancel(),_e=null):this.sendRequest({id:ue,type:101}),Te(D.canceled())},$=ae.onCancellationRequested(Ee);se=(0,R.combinedDisposable)((0,R.toDisposable)(Ee),$),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(X,q,ee){const ae=this.lastRequestId++,Z={id:ae,type:102,channelName:X,name:q,arg:ee};let Y=null;const se=new _.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ve=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(se),this.sendRequest(Z)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(se),this.sendRequest({id:ae,type:103}))}}),de=ve=>se.fire(ve.data);return this.handlers.set(ae,de),se.event}sendRequest(X){switch(X.type){case 100:case 102:{const q=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger&&this.logger.logOutgoing(q,X.id,0,`${v(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const q=this.send([X.type,X.id]);this.logger&&this.logger.logOutgoing(q,X.id,0,v(X.type));return}}}send(X,q=void 0){const ee=new l;return r(ee,X),r(ee,q),this.sendBuffer(ee.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const q=new P(X),ee=n(q),ae=n(q),ue=ee[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(X.byteLength,0,0,w(ue)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(X.byteLength,ee[1],0,w(ue),ae),this.onResponse({type:ee[0],id:ee[1],data:ae})}}onResponse(X){if(X.type===200){this.state=C.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(X.id);q&&q(X)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===C.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([S.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class m{constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,X(({protocol:q,onDidClientDisconnect:ee})=>{_.Event.once(q.onMessage)(ue=>{const Z=new P(ue),Y=n(Z),se=new a(q,Y),de=new u(q);this.channels.forEach((Te,Me)=>se.registerChannel(Me,Te));const ve={channelServer:se,channelClient:de,ctx:Y};this._connections.add(ve),this._onDidAddConnection.fire(ve),ee(()=>{se.dispose(),de.dispose(),this._connections.delete(ve),this._onDidRemoveConnection.fire(ve)})})})}get connections(){const X=[];return this._connections.forEach(q=>X.push(q)),X}getChannel(X,q){const ee=this;return{call(ae,ue,Z){let Y;if((0,p.isFunction)(q)){let de=(0,h.getRandomElement)(ee.connections.filter(q));Y=de?Promise.resolve(de):_.Event.toPromise(_.Event.filter(ee.onDidAddConnection,q))}else Y=q.routeCall(ee,ae,ue);const se=Y.then(de=>de.channelClient.getChannel(X));return O(se).call(ae,ue,Z)},listen(ae,ue){if((0,p.isFunction)(q))return ee.getMulticastEvent(X,q,ae,ue);const Z=q.routeEvent(ee,ae,ue).then(Y=>Y.channelClient.getChannel(X));return O(Z).listen(ae,ue)}}}getMulticastEvent(X,q,ee,ae){const ue=this;let Z=new R.DisposableStore;const Y=new _.Emitter({onFirstListenerAdd:()=>{Z=new R.DisposableStore;const se=new _.EventMultiplexer,de=new Map,ve=Me=>{const Ee=Me.channelClient.getChannel(X).listen(ee,ae),$=se.add(Ee);de.set(Me,$)},Te=Me=>{const _e=de.get(Me);!_e||(_e.dispose(),de.delete(Me))};ue.connections.filter(q).forEach(ve),_.Event.filter(ue.onDidAddConnection,q)(ve,void 0,Z),ue.onDidRemoveConnection(Te,void 0,Z),se.event(Y.fire,Y,Z),Z.add(se)},onLastListenerRemove:()=>{Z.dispose()}});return Y.event}registerChannel(X,q){this.channels.set(X,q),this._connections.forEach(ee=>{ee.channelServer.registerChannel(X,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class T{constructor(X,q,ee=null){const ae=new l;r(ae,q),X.send(ae.buffer),this.channelClient=new u(X,ee),this.channelServer=new a(X,q,ee)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,q){this.channelServer.registerChannel(X,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(G){return{call(X,q,ee){return G.then(ae=>ae.call(X,q,ee))},listen(X,q){const ee=new _.Relay;return G.then(ae=>ee.input=ae.listen(X,q)),ee.event}}}e.getDelayedChannel=O;function L(G){let X=!1;return{call(q,ee,ae){return X?G.call(q,ee,ae):(0,t.timeout)(0).then(()=>X=!0).then(()=>G.call(q,ee,ae))},listen(q,ee){if(X)return G.listen(q,ee);const ae=new _.Relay;return(0,t.timeout)(0).then(()=>X=!0).then(()=>ae.input=G.listen(q,ee)),ae.event}}}e.getNextTickChannel=L;class y{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const q of X.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await _.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=y;var H;(function(G){function X(ue,Z){const Y=ue,se=Z&&Z.disableMarshalling,de=new Map;for(const ve in Y)ee(ve)&&de.set(ve,_.Event.buffer(Y[ve],!0));return new class{listen(ve,Te,Me){const _e=de.get(Te);if(_e)return _e;if(ae(Te)){const Ee=Y[Te];if(typeof Ee=="function")return Ee.call(Y,Me)}throw new Error(`Event not found: ${Te}`)}call(ve,Te,Me){const _e=Y[Te];if(typeof _e=="function"){if(!se&&Array.isArray(Me))for(let Ee=0;Ee<Me.length;Ee++)Me[Ee]=(0,F.revive)(Me[Ee]);return _e.apply(Y,Me)}throw new Error(`Method not found: ${Te}`)}}}G.fromService=X;function q(ue,Z){const Y=Z&&Z.disableMarshalling;return new Proxy({},{get(se,de){if(typeof de=="string")return Z?.properties?.has(de)?Z.properties.get(de):ae(de)?function(ve){return ue.listen(de,ve)}:ee(de)?ue.listen(de):async function(...ve){let Te;Z&&!(0,p.isUndefinedOrNull)(Z.context)?Te=[Z.context,...ve]:Te=ve;const Me=await ue.call(de,Te);return Y?Me:(0,F.revive)(Me)};throw new Error(`Property not found: ${String(de)}`)}})}G.toService=q;function ee(ue){return ue[0]==="o"&&ue[1]==="n"&&I.isUpperAsciiLetter(ue.charCodeAt(2))}function ae(ue){return/^onDynamic/.test(ue)&&I.isUpperAsciiLetter(ue.charCodeAt(9))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let X=G.toString();if(X!=="[object Object]")return X}return G}function x(G){return Array.isArray(G)?G.map(z):z(G)}function K(G,X,q,ee,ae,ue,Z){Z=x(Z);const Y=M[ae],se=Y[ee%Y.length];let de=[`%c[${G}]%c[${String(X).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(ue)?(de=de.concat(Z),de.push(")")):de.push(Z),console.log.apply(console,de)}e.logWithColors=K;class B{constructor(X,q){this._outgoingPrefix=X,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,q,ee,ae,ue){this._totalOutgoing+=X,K(this._outgoingPrefix,this._totalOutgoing,X,q,ee,ae,ue)}logIncoming(X,q,ee,ae,ue){this._totalIncoming+=X,K(this._incomingPrefix,this._totalIncoming,X,q,ee,ae,ue)}}e.IPCLogger=B}),define(we[105],be([1,0,22,3,6,104]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(S=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let n=0;function a(u,m){if(!r.has(u)){const T=String(++n);r.set(u,T)}return r.get(u)}function g(u,m,T,O){if(!i.enableDiagnostics)return;const L=a(u,m);if(O instanceof h.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const y=h.VSBuffer.alloc(O.byteLength);y.set(O),i.records.push({timestamp:Date.now(),id:L,label:m,type:T,buff:y})}else i.records.push({timestamp:Date.now(),id:L,label:m,type:T,data:O})}i.traceSocketEvent=g})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function F(){return R||(R=h.VSBuffer.alloc(0)),R}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,n){if(r===0)return F();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const m=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=r),m}if(this._chunks[0].byteLength>r){const m=this._chunks[0].slice(0,r);return n&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),m}let a=h.VSBuffer.alloc(r),g=0,u=0;for(;r>0;){const m=this._chunks[u];if(m.byteLength>r){const T=m.slice(0,r);a.set(T,g),g+=r,n&&(this._chunks[u]=m.slice(r),this._totalLength-=r),r-=r}else a.set(m,g),g+=m.byteLength,n?(this._chunks.shift(),this._totalLength-=m.byteLength):u++,r-=m.byteLength}return a}}e.ChunkStream=I;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(p||(p={}));function E(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,n,a,g){this.type=r,this.id=n,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,g=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new d(a,g,u,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class C{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=h.VSBuffer.alloc(13);n.writeUInt8(r.type,0),n.writeUInt32BE(r.id,1),n.writeUInt32BE(r.ack,5),n.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(n,r.data)}_bufferAdd(r,n){const a=this._totalLength===0;return this._data.push(r,n),this._totalLength+=r.byteLength+n.byteLength,a}_bufferTake(){const r=h.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,n){this._bufferAdd(r,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class P extends k.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new C(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=P;class l extends A.IPCClient{constructor(r,n,a=null){super(r,n,a);this.protocol=r}static fromSocket(r,n){return new l(new P(r),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=l;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class f{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],n=0,a=this._first;for(;a;)r[n++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const n=new f(r);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class b{constructor(){this.lastRuns=[];const r=Date.now();for(let n=0;n<b._HISTORY_LENGTH;n++)this.lastRuns[n]=r-1e3*n;setInterval(()=>{for(let n=b._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return b._INSTANCE||(b._INSTANCE=new b),b._INSTANCE}load(){const r=Date.now(),n=(1+b._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<b._HISTORY_LENGTH;g++)r-this.lastRuns[g]<=n&&a++;return 1-a/b._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}b._HISTORY_LENGTH=10,b._INSTANCE=null;class o{constructor(r,n=null,a=b.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new C(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),n&&this._socketReader.acceptChunk(n)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,F());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,F());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,F());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,n){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new C(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r);const n=this._outgoingUnackMsg.toArray();for(let a=0,g=n.length;a<g;a++)this._socketWriter.write(n[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new d(6,0,0,F())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let a=0,g=n.length;a<g;a++)this._socketWriter.write(n[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new d(1,n,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const n=new d(2,0,0,r);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),n=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&a>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const u=Math.max(2e4-n,2e4-a,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},u)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r)}}e.PersistentProtocol=o}),define(we[106],be([1,0,96]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(D){const _=(0,h.toUint8)(D);this._defaultValue=_,this._asciiMap=t._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){const _=new Uint8Array(256);for(let R=0;R<256;R++)_[R]=D;return _}set(D,_){const R=(0,h.toUint8)(_);D>=0&&D<256?this._asciiMap[D]=R:this._map.set(D,R)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=t;var k;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(k||(k={}));class A{constructor(){this._actual=new t(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(we[48],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new h(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return h.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return h.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return h.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const S=k.lineNumber|0,D=A.lineNumber|0;if(S===D){const _=k.column|0,R=A.column|0;return _-R}return S-D}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new h(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=h}),define(we[37],be([1,0,48]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,S,D,_){A>D||A===D&&S>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}static strictContainsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<=A.startColumn||S.lineNumber===A.endLineNumber&&S.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,S){let D,_,R,F;return S.startLineNumber<A.startLineNumber?(D=S.startLineNumber,_=S.startColumn):S.startLineNumber===A.startLineNumber?(D=S.startLineNumber,_=Math.min(S.startColumn,A.startColumn)):(D=A.startLineNumber,_=A.startColumn),S.endLineNumber>A.endLineNumber?(R=S.endLineNumber,F=S.endColumn):S.endLineNumber===A.endLineNumber?(R=S.endLineNumber,F=Math.max(S.endColumn,A.endColumn)):(R=A.endLineNumber,F=A.endColumn),new t(D,_,R,F)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,S){let D=A.startLineNumber,_=A.startColumn,R=A.endLineNumber,F=A.endColumn,I=S.startLineNumber,p=S.startColumn,E=S.endLineNumber,v=S.endColumn;return D<I?(D=I,_=p):D===I&&(_=Math.max(_,p)),R>E?(R=E,F=v):R===E&&(F=Math.min(F,v)),D>R||D===R&&_>F?null:new t(D,_,R,F)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new h.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new h.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new t(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new t(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new t(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const R=A.startLineNumber|0,F=S.startLineNumber|0;if(R===F){const I=A.startColumn|0,p=S.startColumn|0;if(I===p){const E=A.endLineNumber|0,v=S.endLineNumber|0;if(E===v){const d=A.endColumn|0,w=S.endColumn|0;return d-w}return E-v}return I-p}return R-F}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[146],be([1,0,48,37]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(D,_,R,F){super(D,_,R,F);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=R,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,_):new A(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,_){return this.getDirection()===0?new A(D,_,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new A(D.lineNumber,D.column,_.lineNumber,_.column)}static fromRange(D,_){return _===0?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new A(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let R=0,F=D.length;R<F;R++)if(!this.selectionsEqual(D[R],_[R]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,R,F,I){return I===0?new A(D,_,R,F):new A(R,F,D,_)}}e.Selection=A}),define(we[147],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(we[148],be([1,0,106]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends h.CharacterClassifier{constructor(D){super(0);for(let _=0,R=D.length;_<R;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(S){const D={};return _=>(D.hasOwnProperty(_)||(D[_]=S(_)),D[_])}e.getMapForWordSeparators=A(S=>new k(S))}),define(we[107],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const R of e.USUAL_WORD_SEPARATORS)D.indexOf(R)>=0||(_+="\\"+R);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=h();function t(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let R="g";D.ignoreCase&&(R+="i"),D.multiline&&(R+="m"),D.unicode&&(R+="u"),_=new RegExp(D.source,R)}return _.lastIndex=0,_}e.ensureValidWordDefinition=t;const k={maxLen:1e3,windowSize:15,timeBudget:150};function A(D,_,R,F,I=k){if(R.length>I.maxLen){let w=D-I.maxLen/2;return w<0?w=0:F+=w,R=R.substring(w,D+I.maxLen/2),A(D,_,R,F,I)}const p=Date.now(),E=D-1-F;let v=-1,d=null;for(let w=1;!(Date.now()-p>=I.timeBudget);w++){const C=E-I.windowSize*w;_.lastIndex=Math.max(0,C);const P=S(_,R,E,v);if(!P&&d||(d=P,C<=0))break;v=C}if(d){const w={word:d[0],startColumn:F+1+d.index,endColumn:F+1+d.index+d[0].length};return _.lastIndex=0,w}return null}e.getWordAtText=A;function S(D,_,R,F){let I;for(;I=D.exec(_);){const p=I.index||0;if(p<=R&&D.lastIndex>=R)return I;if(F>0&&p>F)return null}return null}}),define(we[108],be([1,0,32,9]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,S,D,_){if(Array.isArray(A)){let R=0;for(const F of A){const I=k(F,S,D,_);if(I===10)return I;I>R&&(R=I)}return R}else{if(typeof A=="string")return _?A==="*"?5:A===D?10:0:0;if(A){const{language:R,pattern:F,scheme:I,hasAccessToAllModels:p}=A;if(!_&&!p)return 0;let E=0;if(I)if(I===S.scheme)E=10;else if(I==="*")E=5;else return 0;if(R)if(R===D)E=10;else if(R==="*")E=Math.max(E,5);else return 0;if(F){let v;if(typeof F=="string"?v=F:v={...F,base:(0,t.normalize)(F.base)},v===S.fsPath||(0,h.match)(v,S.fsPath))E=10;else return 0}return E}else return 0}}e.score=k}),define(we[149],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class t{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let _=0,R=D.notIn.length;_<R;_++)switch(D.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,_){if(D.getTokenCount()===0)return!0;const R=D.findTokenIndexAtOffset(_-2),F=D.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(D,_){for(let R=D;R<=_;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class k{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)A(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),A(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),A(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),A(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&A(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=k;function A(S,D,_){S.has(D)?S.get(D).push(_):S.set(D,[_])}}),define(we[150],be([1,0,106]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(v,d,w){const C=new Uint8Array(v*d);for(let P=0,l=v*d;P<l;P++)C[P]=w;this._data=C,this.rows=v,this.cols=d}get(v,d){return this._data[v*this.cols+d]}set(v,d,w){this._data[v*this.cols+d]=w}}e.Uint8Matrix=k;class A{constructor(v){let d=0,w=0;for(let P=0,l=v.length;P<l;P++){const[c,f,s]=v[P];f>d&&(d=f),c>w&&(w=c),s>w&&(w=s)}d++,w++;const C=new k(w,d,0);for(let P=0,l=v.length;P<l;P++){const[c,f,s]=v[P];C.set(c,f,s)}this._states=C,this._maxCharCode=d}nextState(v,d){return d<0||d>=this._maxCharCode?0:this._states.get(v,d)}}e.StateMachine=A;let S=null;function D(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var _;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let R=null;function F(){if(R===null){R=new h.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<E.length;d++)R.set(E.charCodeAt(d),1);const v=".,;";for(let d=0;d<v.length;d++)R.set(v.charCodeAt(d),2)}return R}class I{static _createLink(v,d,w,C,P){let l=P-1;do{const c=d.charCodeAt(l);if(v.get(c)!==2)break;l--}while(l>C);if(C>0){const c=d.charCodeAt(C-1),f=d.charCodeAt(l);(c===40&&f===41||c===91&&f===93||c===123&&f===125)&&l--}return{range:{startLineNumber:w,startColumn:C+1,endLineNumber:w,endColumn:l+2},url:d.substring(C,l+1)}}static computeLinks(v,d=D()){const w=F(),C=[];for(let P=1,l=v.getLineCount();P<=l;P++){const c=v.getLineContent(P),f=c.length;let s=0,b=0,o=0,i=1,r=!1,n=!1,a=!1,g=!1;for(;s<f;){let u=!1;const m=c.charCodeAt(s);if(i===13){let T;switch(m){case 40:r=!0,T=0;break;case 41:T=r?0:1;break;case 91:a=!0,n=!0,T=0;break;case 93:a=!1,T=n?0:1;break;case 123:g=!0,T=0;break;case 125:T=g?0:1;break;case 39:T=o===34||o===96?0:1;break;case 34:T=o===39||o===96?0:1;break;case 96:T=o===39||o===34?0:1;break;case 42:T=o===42?1:0;break;case 124:T=o===124?1:0;break;case 32:T=a?0:1;break;default:T=w.get(m)}T===1&&(C.push(I._createLink(w,c,P,b,s)),u=!0)}else if(i===12){let T;m===91?(n=!0,T=0):T=w.get(m),T===1?u=!0:i=13}else i=d.nextState(i,m),i===0&&(u=!0);u&&(i=1,r=!1,n=!1,g=!1,b=s+1,o=m),s++}i===13&&C.push(I._createLink(w,c,P,b,f))}return C}}e.LinkComputer=I;function p(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:I.computeLinks(E)}e.computeLinks=p}),define(we[109],be([1,0,25]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(P){P[P.Left=1]="Left",P[P.Center=2]="Center",P[P.Right=4]="Right",P[P.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(P){P[P.Inline=1]="Inline",P[P.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(P){P[P.Both=0]="Both",P[P.Right=1]="Right",P[P.Left=2]="Left",P[P.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var S;(function(P){P[P.TextDefined=0]="TextDefined",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(P){P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(P){P[P.LF=0]="LF",P[P.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class R{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class F{constructor(l,c){this._findMatchBrand=void 0,this.range=l,this.matches=c}}e.FindMatch=F;var I;(function(P){P[P.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",P[P.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",P[P.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",P[P.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var p;(function(P){P[P.Left=0]="Left",P[P.Right=1]="Right",P[P.None=2]="None"})(p=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(P){P[P.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class v{constructor(l,c,f,s,b,o){this.identifier=l,this.range=c,this.text=f,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=b,this._isTracked=o}}e.ValidAnnotatedEditOperation=v;class d{constructor(l,c,f){this.regex=l,this.wordSeparators=c,this.simpleSearch=f}}e.SearchData=d;class w{constructor(l,c,f){this.reverseEdits=l,this.changes=c,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=w;function C(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=C}),define(we[110],be([1,0,17,96]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,R){_=(0,t.toUint32)(_);const F=this.values,I=this.prefixSum,p=R.length;return p===0?!1:(this.values=new Uint32Array(F.length+p),this.values.set(F.subarray(0,_),0),this.values.set(F.subarray(_),_+p),this.values.set(R,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,R){return _=(0,t.toUint32)(_),R=(0,t.toUint32)(R),this.values[_]===R?!1:(this.values[_]=R,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,R){_=(0,t.toUint32)(_),R=(0,t.toUint32)(R);const F=this.values,I=this.prefixSum;if(_>=F.length)return!1;const p=F.length-_;return R>=p&&(R=p),R===0?!1:(this.values=new Uint32Array(F.length-R),this.values.set(F.subarray(0,_),0),this.values.set(F.subarray(_+R),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,t.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let R=this.prefixSumValidIndex[0]+1;R===0&&(this.prefixSum[0]=this.values[0],R++),_>=this.values.length&&(_=this.values.length-1);for(let F=R;F<=_;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let R=0,F=this.values.length-1,I=0,p=0,E=0;for(;R<=F;)if(I=R+(F-R)/2|0,p=this.prefixSum[I],E=p-this.values[I],_<E)F=I-1;else if(_>=p)R=I+1;else break;return new S(I,_-E)}}e.PrefixSumComputer=k;class A{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const R=this._indexBySum[_],F=R>0?this._prefixSum[R-1]:0;return new S(R,_-F)}removeValues(_,R){this._values.splice(_,R),this._invalidate(_)}insertValues(_,R){this._values=(0,h.arrayInsert)(this._values,_,R),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,R=this._values.length;_<R;_++){const F=this._values[_],I=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=I+F;for(let p=0;p<F;p++)this._indexBySum[I+p]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,R){this._values[_]!==R&&(this._values[_]=R,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=A;class S{constructor(_,R){this.index=_,this.remainder=R,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=R}}e.PrefixSumIndexOfResult=S}),define(we[151],be([1,0,8,48,110]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,_,R,F){this._uri=D,this._lines=_,this._eol=R,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const R of _)this._acceptDeleteRange(R.range),this._acceptInsertText(new t.Position(R.range.startLineNumber,R.range.startColumn),R.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,R=new Uint32Array(_);for(let F=0;F<_;F++)R[F]=this._lines[F].length+D;this._lineStarts=new k.PrefixSumComputer(R)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;const R=(0,h.splitLines)(_);if(R.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+R[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}R[R.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+R[0]);const F=new Uint32Array(R.length-1);for(let I=1;I<R.length;I++)this._lines.splice(D.lineNumber+I-1,0,R[I]),F[I-1]=R[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,F)}}e.MirrorTextModel=A}),define(we[152],be([1,0,8,148,48,37,109]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(P,l,c,f){this.searchString=P,this.isRegex=l,this.matchCase=c,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let P;this.isRegex?P=R(this.searchString):P=this.searchString.indexOf(`
`)>=0;let l=null;try{l=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:P,global:!0,unicode:!0})}catch{return null}if(!l)return null;let c=!this.isRegex&&!P;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new S.SearchData(l,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=_;function R(C){if(!C||C.length===0)return!1;for(let P=0,l=C.length;P<l;P++)if(C.charCodeAt(P)===92){if(P++,P>=l)break;const f=C.charCodeAt(P);if(f===110||f===114||f===87)return!0}return!1}e.isMultilineRegexSource=R;function F(C,P,l){if(!l)return new S.FindMatch(C,null);const c=[];for(let f=0,s=P.length;f<s;f++)c[f]=P[f];return new S.FindMatch(C,c)}e.createFindMatch=F;class I{constructor(P){const l=[];let c=0;for(let f=0,s=P.length;f<s;f++)P.charCodeAt(f)===10&&(l[c++]=f);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(P){const l=this._lineFeedsOffsets;let c=0,f=l.length-1;if(f===-1||P<=l[0])return 0;for(;c<f;){const s=c+((f-c)/2>>0);l[s]>=P?f=s-1:l[s+1]>=P?(c=s,f=s):c=s+1}return c+1}}class p{static findMatches(P,l,c,f,s){const b=l.parseSearchRequest();return b?b.regex.multiline?this._doFindMatchesMultiline(P,c,new w(b.wordSeparators,b.regex),f,s):this._doFindMatchesLineByLine(P,c,b,f,s):[]}static _getMultilineMatchRange(P,l,c,f,s,b){let o,i=0;f?(i=f.findLineFeedCountBeforeOffset(s),o=l+s+i):o=l+s;let r;if(f){const u=f.findLineFeedCountBeforeOffset(s+b.length)-i;r=o+b.length+u}else r=o+b.length;const n=P.getPositionAt(o),a=P.getPositionAt(r);return new A.Range(n.lineNumber,n.column,a.lineNumber,a.column)}static _doFindMatchesMultiline(P,l,c,f,s){const b=P.getOffsetAt(l.getStartPosition()),o=P.getValueInRange(l,1),i=P.getEOL()===`\r
`?new I(o):null,r=[];let n=0,a;for(c.reset(0);a=c.next(o);)if(r[n++]=F(this._getMultilineMatchRange(P,b,o,i,a.index,a[0]),a,f),n>=s)return r;return r}static _doFindMatchesLineByLine(P,l,c,f,s){const b=[];let o=0;if(l.startLineNumber===l.endLineNumber){const r=P.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return o=this._findMatchesInLine(c,r,l.startLineNumber,l.startColumn-1,o,b,f,s),b}const i=P.getLineContent(l.startLineNumber).substring(l.startColumn-1);o=this._findMatchesInLine(c,i,l.startLineNumber,l.startColumn-1,o,b,f,s);for(let r=l.startLineNumber+1;r<l.endLineNumber&&o<s;r++)o=this._findMatchesInLine(c,P.getLineContent(r),r,0,o,b,f,s);if(o<s){const r=P.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);o=this._findMatchesInLine(c,r,l.endLineNumber,0,o,b,f,s)}return b}static _findMatchesInLine(P,l,c,f,s,b,o,i){const r=P.wordSeparators;if(!o&&P.simpleSearch){const g=P.simpleSearch,u=g.length,m=l.length;let T=-u;for(;(T=l.indexOf(g,T+u))!==-1;)if((!r||d(r,l,m,T,u))&&(b[s++]=new S.FindMatch(new A.Range(c,T+1+f,c,T+1+u+f),null),s>=i))return s;return s}const n=new w(P.wordSeparators,P.regex);let a;n.reset(0);do if(a=n.next(l),a&&(b[s++]=F(new A.Range(c,a.index+1+f,c,a.index+1+a[0].length+f),a,o),s>=i))return s;while(a);return s}static findNextMatch(P,l,c,f){const s=l.parseSearchRequest();if(!s)return null;const b=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(P,c,b,f):this._doFindNextMatchLineByLine(P,c,b,f)}static _doFindNextMatchMultiline(P,l,c,f){const s=new k.Position(l.lineNumber,1),b=P.getOffsetAt(s),o=P.getLineCount(),i=P.getValueInRange(new A.Range(s.lineNumber,s.column,o,P.getLineMaxColumn(o)),1),r=P.getEOL()===`\r
`?new I(i):null;c.reset(l.column-1);let n=c.next(i);return n?F(this._getMultilineMatchRange(P,b,i,r,n.index,n[0]),n,f):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(P,new k.Position(1,1),c,f):null}static _doFindNextMatchLineByLine(P,l,c,f){const s=P.getLineCount(),b=l.lineNumber,o=P.getLineContent(b),i=this._findFirstMatchInLine(c,o,b,l.column,f);if(i)return i;for(let r=1;r<=s;r++){const n=(b+r-1)%s,a=P.getLineContent(n+1),g=this._findFirstMatchInLine(c,a,n+1,1,f);if(g)return g}return null}static _findFirstMatchInLine(P,l,c,f,s){P.reset(f-1);const b=P.next(l);return b?F(new A.Range(c,b.index+1,c,b.index+1+b[0].length),b,s):null}static findPreviousMatch(P,l,c,f){const s=l.parseSearchRequest();if(!s)return null;const b=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(P,c,b,f):this._doFindPreviousMatchLineByLine(P,c,b,f)}static _doFindPreviousMatchMultiline(P,l,c,f){const s=this._doFindMatchesMultiline(P,new A.Range(1,1,l.lineNumber,l.column),c,f,10*D);if(s.length>0)return s[s.length-1];const b=P.getLineCount();return l.lineNumber!==b||l.column!==P.getLineMaxColumn(b)?this._doFindPreviousMatchMultiline(P,new k.Position(b,P.getLineMaxColumn(b)),c,f):null}static _doFindPreviousMatchLineByLine(P,l,c,f){const s=P.getLineCount(),b=l.lineNumber,o=P.getLineContent(b).substring(0,l.column-1),i=this._findLastMatchInLine(c,o,b,f);if(i)return i;for(let r=1;r<=s;r++){const n=(s+b-r-1)%s,a=P.getLineContent(n+1),g=this._findLastMatchInLine(c,a,n+1,f);if(g)return g}return null}static _findLastMatchInLine(P,l,c,f){let s=null,b;for(P.reset(0);b=P.next(l);)s=F(new A.Range(c,b.index+1,c,b.index+1+b[0].length),b,f);return s}}e.TextModelSearch=p;function E(C,P,l,c,f){if(c===0)return!0;const s=P.charCodeAt(c-1);if(C.get(s)!==0||s===13||s===10)return!0;if(f>0){const b=P.charCodeAt(c);if(C.get(b)!==0)return!0}return!1}function v(C,P,l,c,f){if(c+f===l)return!0;const s=P.charCodeAt(c+f);if(C.get(s)!==0||s===13||s===10)return!0;if(f>0){const b=P.charCodeAt(c+f-1);if(C.get(b)!==0)return!0}return!1}function d(C,P,l,c,f){return E(C,P,l,c,f)&&v(C,P,l,c,f)}e.isValidMatch=d;class w{constructor(P,l){this._wordSeparators=P,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(P){this._searchRegex.lastIndex=P,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(P){const l=P.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(c=this._searchRegex.exec(P),!c))return null;const f=c.index,s=c[0].length;if(f===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){h.getNextCodePoint(P,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=f,this._prevMatchLength=s,!this._wordSeparators||d(this._wordSeparators,P,l,f,s))return c}while(c);return null}}e.Searcher=w}),define(we[111],be([1,0,22,12]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function A(I){for(let p=0,E=I.length;p<E;p+=4){const v=I[p+0],d=I[p+1],w=I[p+2],C=I[p+3];I[p+0]=C,I[p+1]=w,I[p+2]=d,I[p+3]=v}}function S(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return t.isLittleEndian()||A(p),h.VSBuffer.wrap(p)}function D(I){const p=I.buffer;if(t.isLittleEndian()||A(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const E=new Uint8Array(p.byteLength);return E.set(p),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(I){const p=new Uint32Array(R(I));let E=0;if(p[E++]=I.id,I.type==="full")p[E++]=1,p[E++]=I.data.length,p.set(I.data,E),E+=I.data.length;else{p[E++]=2,p[E++]=I.deltas.length;for(const v of I.deltas)p[E++]=v.start,p[E++]=v.deleteCount,v.data?(p[E++]=v.data.length,p.set(v.data,E),E+=v.data.length):p[E++]=0}return S(p)}e.encodeSemanticTokensDto=_;function R(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const E of I.deltas)E.data&&(p+=E.data.length)}return p}function F(I){const p=D(I);let E=0;const v=p[E++];if(p[E++]===1){const P=p[E++],l=p.subarray(E,E+P);return E+=P,{id:v,type:"full",data:l}}const w=p[E++],C=[];for(let P=0;P<w;P++){const l=p[E++],c=p[E++],f=p[E++];let s;f>0&&(s=p.subarray(E,E+f),E+=f),C[P]={start:l,deleteCount:c,data:s}}return{id:v,type:"delta",deltas:C}}e.decodeSemanticTokensDto=F}),define(we[153],be([1,0,3,6]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,_){return this._map.set(D,_),this.fire([D]),(0,t.toDisposable)(()=>{this._map.get(D)===_&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,_){this._factories.get(D)?.dispose();const R=new A(this,D,_);return this._factories.set(D,R),(0,t.toDisposable)(()=>{const F=this._factories.get(D);!F||F!==R||(this._factories.delete(D),F.dispose())})}async getOrCreate(D){const _=this.get(D);if(_)return _;const R=this._factories.get(D);return!R||R.isResolved?null:(await R.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const R=this._factories.get(D);return!!(!R||R.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{constructor(D,_,R){super();this._registry=D,this._languageId=_,this._factory=R,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(we[79],be([1,0,2,37,153,73]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var S;(function(L){L[L.Null=0]="Null",L[L.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));var D;(function(L){L[L.NotSet=-1]="NotSet",L[L.None=0]="None",L[L.Italic=1]="Italic",L[L.Bold=2]="Bold",L[L.Underline=4]="Underline",L[L.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var _;(function(L){L[L.None=0]="None",L[L.DefaultForeground=1]="DefaultForeground",L[L.DefaultBackground=2]="DefaultBackground"})(_=e.ColorId||(e.ColorId={}));var R;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(L){L[L.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",L[L.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",L[L.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",L[L.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",L[L.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",L[L.ITALIC_MASK=1024]="ITALIC_MASK",L[L.BOLD_MASK=2048]="BOLD_MASK",L[L.UNDERLINE_MASK=4096]="UNDERLINE_MASK",L[L.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",L[L.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",L[L.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",L[L.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",L[L.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",L[L.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",L[L.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",L[L.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",L[L.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",L[L.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",L[L.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",L[L.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class I{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&768)>>>8}static getFontStyle(y){return(y&15360)>>>10}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){const H=this.getForeground(y);let M="mtk"+H;const z=this.getFontStyle(y);return z&1&&(M+=" mtki"),z&2&&(M+=" mtkb"),z&4&&(M+=" mtku"),z&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(y,H){const M=this.getForeground(y),z=this.getFontStyle(y);let x=`color: ${H[M]};`;z&1&&(x+="font-style: italic;"),z&2&&(x+="font-weight: bold;");let K="";return z&4&&(K+=" underline"),z&8&&(K+=" line-through"),K&&(x+=`text-decoration:${K};`),x}static getPresentationFromMetadata(y){const H=this.getForeground(y),M=this.getFontStyle(y);return{foreground:H,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=I;class p{constructor(y,H,M){this._tokenBrand=void 0,this.offset=y,this.type=H,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class E{constructor(y,H){this._tokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.TokenizationResult=E;class v{constructor(y,H){this._encodedTokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.EncodedTokenizationResult=v;var d;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={}));var w;(function(L){const y=new Map;y.set(0,A.Codicon.symbolMethod),y.set(1,A.Codicon.symbolFunction),y.set(2,A.Codicon.symbolConstructor),y.set(3,A.Codicon.symbolField),y.set(4,A.Codicon.symbolVariable),y.set(5,A.Codicon.symbolClass),y.set(6,A.Codicon.symbolStruct),y.set(7,A.Codicon.symbolInterface),y.set(8,A.Codicon.symbolModule),y.set(9,A.Codicon.symbolProperty),y.set(10,A.Codicon.symbolEvent),y.set(11,A.Codicon.symbolOperator),y.set(12,A.Codicon.symbolUnit),y.set(13,A.Codicon.symbolValue),y.set(15,A.Codicon.symbolEnum),y.set(14,A.Codicon.symbolConstant),y.set(15,A.Codicon.symbolEnum),y.set(16,A.Codicon.symbolEnumMember),y.set(17,A.Codicon.symbolKeyword),y.set(27,A.Codicon.symbolSnippet),y.set(18,A.Codicon.symbolText),y.set(19,A.Codicon.symbolColor),y.set(20,A.Codicon.symbolFile),y.set(21,A.Codicon.symbolReference),y.set(22,A.Codicon.symbolCustomColor),y.set(23,A.Codicon.symbolFolder),y.set(24,A.Codicon.symbolTypeParameter),y.set(25,A.Codicon.account),y.set(26,A.Codicon.issues);function H(x){let K=y.get(x);return K||(console.info("No codicon found for CompletionItemKind "+x),K=A.Codicon.symbolProperty),K}L.toIcon=H;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function z(x,K){let B=M.get(x);return typeof B=="undefined"&&!K&&(B=9),B}L.fromString=z})(w=e.CompletionItemKinds||(e.CompletionItemKinds={}));var C;(function(L){L[L.Deprecated=1]="Deprecated"})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var P;(function(L){L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(P=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var l;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(c=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var b;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(b=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(L){return L&&h.URI.isUri(L.uri)&&t.Range.isIRange(L.range)&&(t.Range.isIRange(L.originSelectionRange)||t.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=o;var i;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var r;(function(L){L[L.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(L){const y=new Map;y.set(0,A.Codicon.symbolFile),y.set(1,A.Codicon.symbolModule),y.set(2,A.Codicon.symbolNamespace),y.set(3,A.Codicon.symbolPackage),y.set(4,A.Codicon.symbolClass),y.set(5,A.Codicon.symbolMethod),y.set(6,A.Codicon.symbolProperty),y.set(7,A.Codicon.symbolField),y.set(8,A.Codicon.symbolConstructor),y.set(9,A.Codicon.symbolEnum),y.set(10,A.Codicon.symbolInterface),y.set(11,A.Codicon.symbolFunction),y.set(12,A.Codicon.symbolVariable),y.set(13,A.Codicon.symbolConstant),y.set(14,A.Codicon.symbolString),y.set(15,A.Codicon.symbolNumber),y.set(16,A.Codicon.symbolBoolean),y.set(17,A.Codicon.symbolArray),y.set(18,A.Codicon.symbolObject),y.set(19,A.Codicon.symbolKey),y.set(20,A.Codicon.symbolNull),y.set(21,A.Codicon.symbolEnumMember),y.set(22,A.Codicon.symbolStruct),y.set(23,A.Codicon.symbolEvent),y.set(24,A.Codicon.symbolOperator),y.set(25,A.Codicon.symbolTypeParameter);function H(M){let z=y.get(M);return z||(console.info("No codicon found for SymbolKind "+M),z=A.Codicon.symbolProperty),z}L.toIcon=H})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(y){this.value=y}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var g;(function(L){function y(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}L.is=y})(g=e.Command||(e.Command={}));var u;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var T;(function(L){L[L.Other=0]="Other",L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(T=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new k.TokenizationRegistry;var O;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(O=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[154],be([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(we[155],be([1,0,154]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,S=A*7,D=A*30,_=A*365;function R(I,p,E){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,h.localize)(0,null,R(new Date().getTime()+v*1e3,!1));if(v<30)return(0,h.localize)(1,null);let d;return v<t?(d=v,p?d===1?E?(0,h.localize)(2,null,d):(0,h.localize)(3,null,d):E?(0,h.localize)(4,null,d):(0,h.localize)(5,null,d):d===1?E?(0,h.localize)(6,null,d):(0,h.localize)(7,null,d):E?(0,h.localize)(8,null,d):(0,h.localize)(9,null,d)):v<k?(d=Math.floor(v/t),p?d===1?E?(0,h.localize)(10,null,d):(0,h.localize)(11,null,d):E?(0,h.localize)(12,null,d):(0,h.localize)(13,null,d):d===1?E?(0,h.localize)(14,null,d):(0,h.localize)(15,null,d):E?(0,h.localize)(16,null,d):(0,h.localize)(17,null,d)):v<A?(d=Math.floor(v/k),p?d===1?E?(0,h.localize)(18,null,d):(0,h.localize)(19,null,d):E?(0,h.localize)(20,null,d):(0,h.localize)(21,null,d):d===1?E?(0,h.localize)(22,null,d):(0,h.localize)(23,null,d):E?(0,h.localize)(24,null,d):(0,h.localize)(25,null,d)):v<S?(d=Math.floor(v/A),p?d===1?(0,h.localize)(26,null,d):(0,h.localize)(27,null,d):d===1?(0,h.localize)(28,null,d):(0,h.localize)(29,null,d)):v<D?(d=Math.floor(v/S),p?d===1?E?(0,h.localize)(30,null,d):(0,h.localize)(31,null,d):E?(0,h.localize)(32,null,d):(0,h.localize)(33,null,d):d===1?E?(0,h.localize)(34,null,d):(0,h.localize)(35,null,d):E?(0,h.localize)(36,null,d):(0,h.localize)(37,null,d)):v<_?(d=Math.floor(v/D),p?d===1?E?(0,h.localize)(38,null,d):(0,h.localize)(39,null,d):E?(0,h.localize)(40,null,d):(0,h.localize)(41,null,d):d===1?E?(0,h.localize)(42,null,d):(0,h.localize)(43,null,d):E?(0,h.localize)(44,null,d):(0,h.localize)(45,null,d)):(d=Math.floor(v/_),p?d===1?E?(0,h.localize)(46,null,d):(0,h.localize)(47,null,d):E?(0,h.localize)(48,null,d):(0,h.localize)(49,null,d):d===1?E?(0,h.localize)(50,null,d):(0,h.localize)(51,null,d):E?(0,h.localize)(52,null,d):(0,h.localize)(53,null,d))}e.fromNow=R;function F(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(we[156],be([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(we[49],be([1,0,17,18,156]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(R,F){return F&&(R.stack||R.stacktrace)?k.localize(0,null,D(R),S(R.stack)||S(R.stacktrace)):D(R)}function S(R){return Array.isArray(R)?R.join(`
`):R}function D(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?k.localize(1,null,R.message):R.message||k.localize(2,null)}function _(R=null,F=!1){if(!R)return k.localize(3,null);if(Array.isArray(R)){const I=h.coalesce(R),p=_(I[0],F);return I.length>1?k.localize(4,null,p,I.length):p}if(t.isString(R))return R;if(R.detail){const I=R.detail;if(I.error)return A(I.error,F);if(I.exception)return A(I.exception,F)}return R.stack?A(R,F):R.message?R.message:k.localize(5,null)}e.toErrorMessage=_}),define(we[157],be([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(we[112],be([1,0,38,30,10,25,9,12,41,93,18,145,28,157]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function v(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,b){if(D.isWindows)try{const o={stdio:["pipe","pipe","ignore"]};b&&(o.cwd=b);const i=h.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],o);return new Promise(r=>{i.once("error",n=>{r({success:!1,error:n})}),i.once("exit",(n,a)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(o){return Promise.resolve({success:!1,error:o,code:o.status?v(o.status):1})}else if(D.isLinux||D.isMacintosh)try{const o=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(i=>{h.execFile(o,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,n,a)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(o){return Promise.resolve({success:!1,error:o})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function w(s){!s||(delete s.DEBUG,D.isMacintosh&&delete s.DYLD_LIBRARY_PATH,D.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=w;function C(s=_.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class P{constructor(b,o,i,r){if(o!==void 0&&i!==void 0&&r!==void 0)this.cmd=b,this.args=o,this.shell=i,this.options=r;else{const n=b;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(_.env).forEach(a=>{n[a]=_.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let b=this.cmd.toLowerCase();const o=b.lastIndexOf(S.sep);return o!==-1&&(b=b.substring(o+1)),P.WellKnowCommands[b]?b:"other"}start(b){return D.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(_.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(o=>{let i,r;const n=new Promise((a,g)=>{i=a,r=g});if(o){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=h.exec(a,this.options,(g,u,m)=>{this.childProcess=null;const T=g;T&&T.killed?r({killed:this.terminateRequested,stdout:u.toString(),stderr:m.toString()}):this.handleExec(i,b,g,u,m)})}else{let a=null;const g=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,i,b,r);const m={terminated:this.terminateRequested};F.isNumber(u)&&(m.cmdCode=u),i(m)};if(this.shell&&D.isWindows){const u=A.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let m=!1,T=!1;const O=[];let L=this.ensureQuotes(this.cmd);O.push(L.value),m=L.quoted,this.args&&this.args.forEach(H=>{L=this.ensureQuotes(H),O.push(L.value),T=T&&L.quoted});const y=["/s","/c"];m?T?y.push('"'+O.join(" ")+'"'):O.length>1?y.push('"'+O[0]+'" '+O.slice(1).join(" ")):y.push('"'+O[0]+'"'):y.push(O.join(" ")),a=h.spawn(C(),y,u)}else this.cmd&&(a=h.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(F.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",u=>{this.childProcess=null,r({terminated:this.terminateRequested,error:u})}),a.pid&&(this.childProcess.on("close",g),this.handleSpawn(a,i,b,r,!0)))}return n})}handleClose(b,o,i,r){}ensureQuotes(b){return P.regexp.test(b)?{value:'"'+b+'"',quoted:!0}:{value:b,quoted:b.length>0&&b[0]==='"'&&b[b.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(b=>b.pid,b=>-1):new Promise(b=>{this.pidResolve=b})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(b=>(this.terminateRequested=!0,d(b,this.options.cwd).then(o=>(o.success&&(this.childProcess=null),o))),b=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(b=>{if(!this.shell||!D.isWindows)return b(!1);const o=h.spawn(C(),["/s","/c"]);o.on("error",i=>b(!0)),o.on("exit",i=>b(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class l extends P{constructor(b,o,i,r){super(b,o,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(b,o,i,r,n){[r,n].forEach((a,g)=>{const u=new I.LineDecoder;u.write(a).forEach(O=>{o({line:O,source:g===0?0:1})});const T=u.end();T&&o({line:T,source:g===0?0:1})}),b({terminated:this.terminateRequested,error:i})}handleSpawn(b,o,i,r,n){const a=new I.LineDecoder,g=new I.LineDecoder;b.stdout.on("data",u=>{a.write(u).forEach(T=>i({line:T,source:0}))}),b.stderr.on("data",u=>{g.write(u).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=g}handleClose(b,o,i,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=l;function c(s){let b=[],o=!1;const i=function(r){if(o){b.push(r);return}(!s.send(r,a=>{if(a&&console.error(a),o=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(u=>i(u))}})||D.isWindows)&&(o=!0)};return{send:i}}e.createQueuedSender=c;var f;(function(s){async function b(o,i,r){if(S.isAbsolute(o))return o;if(i===void 0&&(i=_.cwd()),S.dirname(o)!=="."||(r===void 0&&F.isString(_.env.PATH)&&(r=_.env.PATH.split(S.delimiter)),r===void 0||r.length===0))return S.join(i,o);async function a(g){if(await p.Promises.exists(g)){let u;try{u=await p.Promises.stat(g)}catch(m){m.message.startsWith("EACCES")&&(u=await p.Promises.lstat(g))}return u?!u.isDirectory():!1}return!1}for(let g of r){let u;if(S.isAbsolute(g)?u=S.join(g,o):u=S.join(i,g,o),await a(u))return u;let m=u+".com";if(await a(m)||(m=u+".exe",await a(m)))return m}return S.join(i,o)}s.findExecutable=b})(f=e.win32||(e.win32={}))}),define(we[158],be([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(we[113],be([1,0,158,12,107,17,25,147]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class I{constructor(oe,J,pe,Se){this.id=oe,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(oe,J){return E(oe,J)}compute(oe,J,pe){return pe}}class p{constructor(oe,J){this.newValue=oe,this.didChange=J}}e.ApplyUpdateResult=p;function E(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new p(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const pe=Array.isArray(ne)&&Array.isArray(oe)&&A.equals(ne,oe);return new p(oe,pe)}let J=!1;for(const pe in oe)if(oe.hasOwnProperty(pe)){const Se=E(ne[pe],oe[pe]);Se.didChange&&(ne[pe]=Se.newValue,J=!0)}return new p(ne,J)}class v{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,J){return E(oe,J)}validate(oe){return this.defaultValue}}class d{constructor(oe,J,pe,Se){this.id=oe,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(oe,J){return E(oe,J)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,J,pe){return pe}}function w(ne,oe){return typeof ne=="undefined"?oe:ne==="false"?!1:Boolean(ne)}e.boolean=w;class C extends d{constructor(oe,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=pe);super(oe,J,pe,Se)}validate(oe){return w(oe,this.defaultValue)}}function P(ne,oe,J,pe){if(typeof ne=="undefined")return oe;let Se=parseInt(ne,10);return isNaN(Se)?oe:(Se=Math.max(J,Se),Se=Math.min(pe,Se),Se|0)}e.clampedInt=P;class l extends d{constructor(oe,J,pe,Se,Ne,He=void 0){typeof He!="undefined"&&(He.type="integer",He.default=pe,He.minimum=Se,He.maximum=Ne);super(oe,J,pe,He);this.minimum=Se,this.maximum=Ne}static clampedInt(oe,J,pe,Se){return P(oe,J,pe,Se)}validate(oe){return l.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class c extends d{constructor(oe,J,pe,Se,Ne){typeof Ne!="undefined"&&(Ne.type="number",Ne.default=pe);super(oe,J,pe,Ne);this.validationFn=Se}static clamp(oe,J,pe){return oe<J?J:oe>pe?pe:oe}static float(oe,J){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return J;const pe=parseFloat(oe);return isNaN(pe)?J:pe}validate(oe){return this.validationFn(c.float(oe,this.defaultValue))}}class f extends d{static string(oe,J){return typeof oe!="string"?J:oe}constructor(oe,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=pe);super(oe,J,pe,Se)}validate(oe){return f.string(oe,this.defaultValue)}}function s(ne,oe,J){return typeof ne!="string"||J.indexOf(ne)===-1?oe:ne}e.stringSet=s;class b extends d{constructor(oe,J,pe,Se,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=Se,Ne.default=pe);super(oe,J,pe,Ne);this._allowedValues=Se}validate(oe){return s(oe,this.defaultValue,this._allowedValues)}}class o extends I{constructor(oe,J,pe,Se,Ne,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Ne,Ye.default=Se);super(oe,J,pe,Ye);this._allowedValues=Ne,this._convert=He}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function i(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,J,pe){return pe===0?oe.accessibilitySupport:pe}}class n extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:h.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{insertSpace:w(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function m(ne){switch(ne){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function T(ne){switch(ne){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class O extends v{constructor(){super(128)}compute(oe,J,pe){const Se=["monaco-editor"];return J.get(33)&&Se.push(J.get(33)),oe.extraEditorClassName&&Se.push(oe.extraEditorClassName),J.get(66)==="default"?Se.push("mouse-default"):J.get(66)==="copy"&&Se.push("mouse-copy"),J.get(100)&&Se.push("showUnused"),J.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class L extends C{constructor(){super(32,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(oe,J,pe){return pe&&oe.emptySelectionClipboard}}class y extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:h.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:h.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{cursorMoveOnType:w(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":s(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":s(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(J.loop,this.defaultValue.loop)}}}class H extends I{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?H.OFF:oe==="true"?H.ON:oe:Boolean(oe)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class M extends v{constructor(){super(44)}compute(oe,J,pe){return oe.fontInfo}}class z extends d{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(oe){const J=c.float(oe,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(J,6,100)}compute(oe,J,pe){return oe.fontInfo.fontSize}}class x extends I{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(l.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class K extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:pe,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:pe,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:pe,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:pe,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:pe,description:h.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{multiple:s(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??s(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??s(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??s(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??s(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??s(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends I{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:h.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:h.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:w(J.enabled,this.defaultValue.enabled),delay:l.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:w(J.sticky,this.defaultValue.sticky),above:w(J.above,this.defaultValue.above)}}}var G;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class X extends v{constructor(){super(131)}compute(oe,J,pe){return X.computeLayout(J,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const J=oe.height/oe.lineHeight,pe=oe.scrollBeyondLastLine?J-1:0,Se=(oe.viewLineCount+pe)/(oe.pixelRatio*oe.height),Ne=Math.floor(oe.viewLineCount/Se);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Se,minimapLineCount:Ne}}static _computeMinimapLayout(oe,J){const pe=oe.outerWidth,Se=oe.outerHeight,Ne=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const He=J.stableMinimapLayoutInput,Ye=He&&oe.outerHeight===He.outerHeight&&oe.lineHeight===He.lineHeight&&oe.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&oe.pixelRatio===He.pixelRatio&&oe.scrollBeyondLastLine===He.scrollBeyondLastLine&&oe.minimap.enabled===He.minimap.enabled&&oe.minimap.side===He.minimap.side&&oe.minimap.size===He.minimap.size&&oe.minimap.showSlider===He.minimap.showSlider&&oe.minimap.renderCharacters===He.minimap.renderCharacters&&oe.minimap.maxColumn===He.minimap.maxColumn&&oe.minimap.scale===He.minimap.scale&&oe.verticalScrollbarWidth===He.verticalScrollbarWidth&&oe.isViewportWrapping===He.isViewportWrapping,st=oe.lineHeight,pt=oe.typicalHalfwidthCharacterWidth,mt=oe.scrollBeyondLastLine,Ve=oe.minimap.renderCharacters;let ot=Ne>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const _t=oe.minimap.maxColumn,it=oe.minimap.size,lt=oe.minimap.side,Rt=oe.verticalScrollbarWidth,It=oe.viewLineCount,kt=oe.remainingWidth,dt=oe.isViewportWrapping,Ot=Ve?2:3;let Mt=Math.floor(Ne*Se);const Ft=Mt/Ne;let fe=!1,Ie=!1,ge=Ot*ot,ie=ot/Ne,ye=1;if(it==="fill"||it==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:ut,minimapLineCount:wt}=X.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:mt,height:Se,lineHeight:st,pixelRatio:Ne});if(It/wt>1)fe=!0,Ie=!0,ot=1,ge=1,ie=ot/Ne;else{let ht=!1,Pt=ot+1;if(it==="fit"){const Ut=Math.ceil((It+rt)*ge);dt&&Ye&&kt<=J.stableFitRemainingWidth?(ht=!0,Pt=J.stableFitMaxMinimapScale):ht=Ut>Mt}if(it==="fill"||ht){fe=!0;const Ut=ot;ge=Math.min(st*Ne,Math.max(1,Math.floor(1/ut))),dt&&Ye&&kt<=J.stableFitRemainingWidth&&(Pt=J.stableFitMaxMinimapScale),ot=Math.min(Pt,Math.max(1,Math.floor(ge/Ot))),ot>Ut&&(ye=Math.min(2,ot/Ut)),ie=ot/Ne/ye,Mt=Math.ceil(Math.max(Et,It+rt)*ge),dt?(J.stableMinimapLayoutInput=oe,J.stableFitRemainingWidth=kt,J.stableFitMaxMinimapScale=ot):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Le=Math.floor(_t*ie),xe=Math.min(Le,Math.max(0,Math.floor((kt-Rt-2)*ie/(pt+ie)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Ne*xe);const ct=Ge/Ne;Ge=Math.floor(Ge*ye);const vt=Ve?1:2,St=lt==="left"?0:pe-xe-Rt;return{renderMinimap:vt,minimapLeft:St,minimapWidth:xe,minimapHeightIsEditorHeight:fe,minimapIsSampling:Ie,minimapScale:ot,minimapLineHeight:ge,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:ct,minimapCanvasOuterHeight:Ft}}static computeLayout(oe,J){const pe=J.outerWidth|0,Se=J.outerHeight|0,Ne=J.lineHeight|0,He=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,st=J.maxDigitWidth,pt=J.pixelRatio,mt=J.viewLineCount,Ve=oe.get(123),ot=Ve==="inherit"?oe.get(122):Ve,_t=ot==="inherit"?oe.get(118):ot,it=oe.get(121),lt=oe.get(2),Rt=J.isDominatedByLongLines,It=oe.get(50),kt=oe.get(60).renderType!==0,dt=oe.get(61),Ot=oe.get(94),Mt=oe.get(65),Ft=oe.get(92),fe=Ft.verticalScrollbarSize,Ie=Ft.verticalHasArrows,ge=Ft.arrowSize,ie=Ft.horizontalScrollbarSize,ye=oe.get(58),Le=oe.get(37);let xe;if(typeof ye=="string"&&/^\d+(\.\d+)?ch$/.test(ye)){const xt=parseFloat(ye.substr(0,ye.length-2));xe=l.clampedInt(xt*Ye,0,0,1e3)}else xe=l.clampedInt(ye,0,0,1e3);Le&&(xe+=16);let Ge=0;if(kt){const xt=Math.max(He,dt);Ge=Math.round(xt*st)}let ct=0;It&&(ct=Ne);let vt=0,St=vt+ct,Et=St+Ge,rt=Et+xe;const ut=pe-ct-Ge-xe;let wt=!1,Nt=!1,ht=-1;lt!==2&&(ot==="inherit"&&Rt?(wt=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(ht=it));const Pt=X._computeMinimapLayout({outerWidth:pe,outerHeight:Se,lineHeight:Ne,typicalHalfwidthCharacterWidth:Ye,pixelRatio:pt,scrollBeyondLastLine:Ot,minimap:Mt,verticalScrollbarWidth:fe,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:Nt},J.memory||new F);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(vt+=Pt.minimapWidth,St+=Pt.minimapWidth,Et+=Pt.minimapWidth,rt+=Pt.minimapWidth);const Ut=ut-Pt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-fe-2)/Ye)),Bt=Ie?ge:0;return Nt&&(ht=Math.max(1,Ct),_t==="bounded"&&(ht=Math.min(ht,it))),{width:pe,height:Se,glyphMarginLeft:vt,glyphMarginWidth:ct,lineNumbersLeft:St,lineNumbersWidth:Ge,decorationsLeft:Et,decorationsWidth:xe,contentLeft:rt,contentWidth:Ut,minimap:Pt,viewportColumn:Ct,isWordWrapMinified:wt,isViewportWrapping:Nt,wrappingColumn:ht,verticalScrollbarWidth:fe,horizontalScrollbarHeight:ie,overviewRuler:{top:Bt,width:fe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=X;class q extends I{constructor(){const oe={enabled:!0};super(57,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:h.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:w(oe.enabled,this.defaultValue.enabled)}}}class ee extends I{constructor(){const oe={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"boolean",default:oe.enabled,description:h.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:h.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:h.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:w(J.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(J.fontFamily,this.defaultValue.fontFamily)}}}class ae extends c{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>c.clamp(oe,0,150),{markdownDescription:h.localize(47,null)})}compute(oe,J,pe){return oe.fontInfo.lineHeight}}class ue extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:h.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(49,null),h.localize(50,null),h.localize(51,null)],default:oe.size,description:h.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:h.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:h.localize(54,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:h.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:h.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:w(J.enabled,this.defaultValue.enabled),size:s(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(J.side,this.defaultValue.side,["right","left"]),showSlider:s(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(J.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(J.scale,1,1,3),maxColumn:l.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Z(ne){return ne==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends I{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(59,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{top:l.clampedInt(J.top,0,0,1e3),bottom:l.clampedInt(J.bottom,0,0,1e3)}}}class se extends I{constructor(){const oe={enabled:!0,cycle:!1};super(76,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:h.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:h.localize(61,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:w(J.enabled,this.defaultValue.enabled),cycle:w(J.cycle,this.defaultValue.cycle)}}}class de extends v{constructor(){super(129)}compute(oe,J,pe){return oe.pixelRatio}}class ve extends I{constructor(){const oe={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",oe,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:oe.strings,description:h.localize(62,null)},comments:{type:"boolean",default:oe.comments,description:h.localize(63,null)},other:{type:"boolean",default:oe.other,description:h.localize(64,null)}}}],default:oe,description:h.localize(65,null)});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean")return oe;if(oe&&typeof oe=="object"){const J=oe,pe={other:w(J.other,this.defaultValue.other),comments:w(J.comments,this.defaultValue.comments),strings:w(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var Te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends I{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null),h.localize(69,null)],default:"on",description:h.localize(70,null)})}validate(oe){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(J=4,pe=oe):oe==="interval"?J=3:oe==="relative"?J=2:oe==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function _e(ne){const oe=ne.get(87);return oe==="editable"?ne.get(81):oe!=="on"}e.filterValidationDecorations=_e;class Ee extends I{constructor(){const oe=[],J={type:"number",description:h.localize(71,null)};super(91,"rulers",oe,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:h.localize(72,null),format:"color-hex"}}}]},default:oe,description:h.localize(73,null)})}validate(oe){if(Array.isArray(oe)){const J=[];for(let pe of oe)if(typeof pe=="number")J.push({column:l.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Se=pe;J.push({column:l.clampedInt(Se.column,0,0,1e4),color:Se.color})}return J.sort((pe,Se)=>pe.column-Se.column),J}return this.defaultValue}}function $(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(74,null),h.localize(75,null),h.localize(76,null)],default:"auto",description:h.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)],default:"auto",description:h.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:h.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:h.localize(84,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe,pe=l.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=l.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(J.vertical,this.defaultValue.vertical),horizontal:$(J.horizontal,this.defaultValue.horizontal),useShadows:w(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:l.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:l.clampedInt(J.verticalSliderSize,Se,0,1e3),scrollByPage:w(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:h.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:h.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:h.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:h.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:h.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:h.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:h.localize(91,null)}})}applyUpdate(oe,J){let pe=!1;J.allowedCharacters&&(S.equals(oe.allowedCharacters,J.allowedCharacters)||(oe={...oe,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(S.equals(oe.allowedLocales,J.allowedLocales)||(oe={...oe,allowedLocales:J.allowedLocales},pe=!0));const Se=super.applyUpdate(oe,J);return pe?new p(Se.newValue,!0):Se}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{nonBasicASCII:he(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,J){if(typeof oe!="object"||!oe)return J;const pe={};for(const[Se,Ne]of Object.entries(oe))Ne===!0&&(pe[Se]=!0);return pe}}class W extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:h.localize(92,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:w(J.enabled,this.defaultValue.enabled),mode:s(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends I{constructor(){const oe={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,description:h.localize(93,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:w(oe.enabled,this.defaultValue.enabled)}}}class re extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:oe.bracketPairs,description:h.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:oe.bracketPairsHorizontal,description:h.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:h.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:h.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:oe.highlightActiveIndentation,description:h.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{bracketPairs:he(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:w(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ne,oe,J){const pe=J.indexOf(ne);return pe===-1?oe:J[pe]}class Ce extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(105,null),h.localize(106,null)],default:oe.insertMode,description:h.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:h.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:h.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:h.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:h.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:h.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:h.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:h.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:h.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(146,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{insertMode:s(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(J.showIcons,this.defaultValue.showIcons),showStatusBar:w(J.showStatusBar,this.defaultValue.showStatusBar),preview:w(J.preview,this.defaultValue.preview),previewMode:s(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(J.showMethods,this.defaultValue.showMethods),showFunctions:w(J.showFunctions,this.defaultValue.showFunctions),showConstructors:w(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(J.showDeprecated,this.defaultValue.showDeprecated),showFields:w(J.showFields,this.defaultValue.showFields),showVariables:w(J.showVariables,this.defaultValue.showVariables),showClasses:w(J.showClasses,this.defaultValue.showClasses),showStructs:w(J.showStructs,this.defaultValue.showStructs),showInterfaces:w(J.showInterfaces,this.defaultValue.showInterfaces),showModules:w(J.showModules,this.defaultValue.showModules),showProperties:w(J.showProperties,this.defaultValue.showProperties),showEvents:w(J.showEvents,this.defaultValue.showEvents),showOperators:w(J.showOperators,this.defaultValue.showOperators),showUnits:w(J.showUnits,this.defaultValue.showUnits),showValues:w(J.showValues,this.defaultValue.showValues),showConstants:w(J.showConstants,this.defaultValue.showConstants),showEnums:w(J.showEnums,this.defaultValue.showEnums),showEnumMembers:w(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(J.showKeywords,this.defaultValue.showKeywords),showWords:w(J.showWords,this.defaultValue.showWords),showColors:w(J.showColors,this.defaultValue.showColors),showFiles:w(J.showFiles,this.defaultValue.showFiles),showReferences:w(J.showReferences,this.defaultValue.showReferences),showFolders:w(J.showFolders,this.defaultValue.showFolders),showTypeParameters:w(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(J.showSnippets,this.defaultValue.showSnippets),showUsers:w(J.showUsers,this.defaultValue.showUsers),showIssues:w(J.showIssues,this.defaultValue.showIssues)}}}class Ae extends I{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(147,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends v{constructor(){super(130)}compute(oe,J,pe){return J.get(81)?!0:oe.tabFocusMode}}var ze;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));function je(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class $e extends v{constructor(){super(132)}compute(oe,J,pe){const Se=J.get(131);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Qe:t.isLinux?et:Ue,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var tt;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new C(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(148,null)})),acceptSuggestionOnEnter:Re(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(149,null),""],markdownDescription:h.localize(150,null)})),accessibilitySupport:Re(new r),accessibilityPageSize:Re(new l(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(151,null)})),ariaLabel:Re(new f(4,"ariaLabel",h.localize(152,null))),autoClosingBrackets:Re(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(153,null),h.localize(154,null),""],description:h.localize(155,null)})),autoClosingDelete:Re(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(156,null),""],description:h.localize(157,null)})),autoClosingOvertype:Re(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(158,null),""],description:h.localize(159,null)})),autoClosingQuotes:Re(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(160,null),h.localize(161,null),""],description:h.localize(162,null)})),autoIndent:Re(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[h.localize(163,null),h.localize(164,null),h.localize(165,null),h.localize(166,null),h.localize(167,null)],description:h.localize(168,null)})),automaticLayout:Re(new C(10,"automaticLayout",!1)),autoSurround:Re(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(169,null),h.localize(170,null),h.localize(171,null),""],description:h.localize(172,null)})),bracketPairColorization:Re(new j),bracketPairGuides:Re(new re),stickyTabStops:Re(new C(104,"stickyTabStops",!1,{description:h.localize(173,null)})),codeLens:Re(new C(14,"codeLens",!0,{description:h.localize(174,null)})),codeLensFontFamily:Re(new f(15,"codeLensFontFamily","",{description:h.localize(175,null)})),codeLensFontSize:Re(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(176,null)})),colorDecorators:Re(new C(17,"colorDecorators",!0,{description:h.localize(177,null)})),columnSelection:Re(new C(18,"columnSelection",!1,{description:h.localize(178,null)})),comments:Re(new n),contextmenu:Re(new C(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new C(21,"copyWithSyntaxHighlighting",!0,{description:h.localize(179,null)})),cursorBlinking:Re(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:h.localize(180,null)})),cursorSmoothCaretAnimation:Re(new C(23,"cursorSmoothCaretAnimation",!1,{description:h.localize(181,null)})),cursorStyle:Re(new o(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:h.localize(182,null)})),cursorSurroundingLines:Re(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(183,null)})),cursorSurroundingLinesStyle:Re(new b(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(184,null),h.localize(185,null)],description:h.localize(186,null)})),cursorWidth:Re(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(187,null)})),disableLayerHinting:Re(new C(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new C(29,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new C(30,"domReadOnly",!1)),dragAndDrop:Re(new C(31,"dragAndDrop",!0,{description:h.localize(188,null)})),emptySelectionClipboard:Re(new L),extraEditorClassName:Re(new f(33,"extraEditorClassName","")),fastScrollSensitivity:Re(new c(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:h.localize(189,null)})),find:Re(new y),fixedOverflowWidgets:Re(new C(36,"fixedOverflowWidgets",!1)),folding:Re(new C(37,"folding",!0,{description:h.localize(190,null)})),foldingStrategy:Re(new b(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(191,null),h.localize(192,null)],description:h.localize(193,null)})),foldingHighlight:Re(new C(39,"foldingHighlight",!0,{description:h.localize(194,null)})),foldingImportsByDefault:Re(new C(40,"foldingImportsByDefault",!1,{description:h.localize(195,null)})),foldingMaximumRegions:Re(new l(41,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(196,null)})),unfoldOnClickAfterEndOfLine:Re(new C(42,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(197,null)})),fontFamily:Re(new f(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(198,null)})),fontInfo:Re(new M),fontLigatures2:Re(new H),fontSize:Re(new z),fontWeight:Re(new x),formatOnPaste:Re(new C(48,"formatOnPaste",!1,{description:h.localize(199,null)})),formatOnType:Re(new C(49,"formatOnType",!1,{description:h.localize(200,null)})),glyphMargin:Re(new C(50,"glyphMargin",!0,{description:h.localize(201,null)})),gotoLocation:Re(new K),hideCursorInOverviewRuler:Re(new C(52,"hideCursorInOverviewRuler",!1,{description:h.localize(202,null)})),hover:Re(new B),inDiffEditor:Re(new C(54,"inDiffEditor",!1)),letterSpacing:Re(new c(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:h.localize(203,null)})),lightbulb:Re(new q),lineDecorationsWidth:Re(new d(58,"lineDecorationsWidth",10)),lineHeight:Re(new ae),lineNumbers:Re(new Me),lineNumbersMinChars:Re(new l(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new C(62,"linkedEditing",!1,{description:h.localize(204,null)})),links:Re(new C(63,"links",!0,{description:h.localize(205,null)})),matchBrackets:Re(new b(64,"matchBrackets","always",["always","near","never"],{description:h.localize(206,null)})),minimap:Re(new ue),mouseStyle:Re(new b(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new c(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:h.localize(207,null)})),mouseWheelZoom:Re(new C(68,"mouseWheelZoom",!1,{markdownDescription:h.localize(208,null)})),multiCursorMergeOverlapping:Re(new C(69,"multiCursorMergeOverlapping",!0,{description:h.localize(209,null)})),multiCursorModifier:Re(new o(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[h.localize(210,null),h.localize(211,null)],markdownDescription:h.localize(212,null)})),multiCursorPaste:Re(new b(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(213,null),h.localize(214,null)],markdownDescription:h.localize(215,null)})),occurrencesHighlight:Re(new C(72,"occurrencesHighlight",!0,{description:h.localize(216,null)})),overviewRulerBorder:Re(new C(73,"overviewRulerBorder",!0,{description:h.localize(217,null)})),overviewRulerLanes:Re(new l(74,"overviewRulerLanes",3,0,3)),padding:Re(new Y),parameterHints:Re(new se),peekWidgetDefaultFocus:Re(new b(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),definitionLinkOpensInPeek:Re(new C(78,"definitionLinkOpensInPeek",!1,{description:h.localize(221,null)})),quickSuggestions:Re(new ve),quickSuggestionsDelay:Re(new l(80,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(222,null)})),readOnly:Re(new C(81,"readOnly",!1)),renameOnType:Re(new C(82,"renameOnType",!1,{description:h.localize(223,null),markdownDeprecationMessage:h.localize(224,null)})),renderControlCharacters:Re(new C(83,"renderControlCharacters",!0,{description:h.localize(225,null),restricted:!0})),renderFinalNewline:Re(new C(84,"renderFinalNewline",!0,{description:h.localize(226,null)})),renderLineHighlight:Re(new b(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(227,null)],description:h.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Re(new C(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(229,null)})),renderValidationDecorations:Re(new b(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new b(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(230,null),h.localize(231,null),h.localize(232,null),""],description:h.localize(233,null)})),revealHorizontalRightPadding:Re(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Re(new C(90,"roundedSelection",!0,{description:h.localize(234,null)})),rulers:Re(new Ee),scrollbar:Re(new U),scrollBeyondLastColumn:Re(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(235,null)})),scrollBeyondLastLine:Re(new C(94,"scrollBeyondLastLine",!0,{description:h.localize(236,null)})),scrollPredominantAxis:Re(new C(95,"scrollPredominantAxis",!0,{description:h.localize(237,null)})),selectionClipboard:Re(new C(96,"selectionClipboard",!0,{description:h.localize(238,null),included:t.isLinux})),selectionHighlight:Re(new C(97,"selectionHighlight",!0,{description:h.localize(239,null)})),selectOnLineNumbers:Re(new C(98,"selectOnLineNumbers",!0)),showFoldingControls:Re(new b(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),showUnused:Re(new C(100,"showUnused",!0,{description:h.localize(243,null)})),showDeprecated:Re(new C(126,"showDeprecated",!0,{description:h.localize(244,null)})),inlayHints:Re(new ee),snippetSuggestions:Re(new b(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(245,null),h.localize(246,null),h.localize(247,null),h.localize(248,null)],description:h.localize(249,null)})),smartSelect:Re(new Ae),smoothScrolling:Re(new C(103,"smoothScrolling",!1,{description:h.localize(250,null)})),stopRenderingLineAfter:Re(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Ce),inlineSuggest:Re(new W),suggestFontSize:Re(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(251,null)})),suggestLineHeight:Re(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(252,null)})),suggestOnTriggerCharacters:Re(new C(109,"suggestOnTriggerCharacters",!0,{description:h.localize(253,null)})),suggestSelection:Re(new b(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),tabCompletion:Re(new b(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null)],description:h.localize(261,null)})),tabIndex:Re(new l(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new N),unusualLineTerminators:Re(new b(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(262,null),h.localize(263,null),h.localize(264,null)],description:h.localize(265,null)})),useShadowDOM:Re(new C(115,"useShadowDOM",!0)),useTabStops:Re(new C(116,"useTabStops",!0,{description:h.localize(266,null)})),wordSeparators:Re(new f(117,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:h.localize(267,null)})),wordWrap:Re(new b(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(268,null),h.localize(269,null),h.localize(270,null),h.localize(271,null)],description:h.localize(272,null)})),wordWrapBreakAfterCharacters:Re(new f(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new f(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new l(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(273,null)})),wordWrapOverride1:Re(new b(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new b(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Re(new o(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[h.localize(274,null),h.localize(275,null),h.localize(276,null),h.localize(277,null)],description:h.localize(278,null)})),wrappingStrategy:Re(new b(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(279,null),h.localize(280,null)],description:h.localize(281,null)})),editorClassName:Re(new O),pixelRatio:Re(new de),tabFocusMode:Re(new We),layoutInfo:Re(new X),wrappingInfo:Re(new $e)}}),define(we[159],be([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[160],be([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[161],be([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[162],be([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(we[163],be([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(we[164],be([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(we[165],be([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(we[166],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[167],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[168],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(we[169],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[170],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[171],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[172],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[173],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(we[174],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(we[175],be([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(we[176],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[177],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(we[178],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(we[179],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[180],be([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[181],be([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(we[182],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var t;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var k;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var S;(function(D){D.DEFAULT="api",D.NAVIGATION="navigation"})(S=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[183],be([1,0,161]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(p){return p=p.trim(),p==="*"||t.test(p)}e.isValidVersionStr=A;function S(p){if(!A(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=p.match(t);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=S;function D(p){if(!p)return null;let E=p.majorBase,v=p.majorMustEqual,d=p.minorBase,w=p.minorMustEqual,C=p.patchBase,P=p.patchMustEqual;p.hasCaret&&(E===0||(w=!1),P=!1);let l=0;if(p.preRelease){const c=k.exec(p.preRelease);if(c){const[,f,s,b]=c;l=Date.UTC(Number(f),Number(s)-1,Number(b))}}return{majorBase:E,majorMustEqual:v,minorBase:d,minorMustEqual:w,patchBase:C,patchMustEqual:P,isMinimum:p.hasGreaterEquals,notBefore:l}}e.normalizeVersion=D;function _(p,E,v){let d;typeof p=="string"?d=D(S(p)):d=p;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let C;if(typeof v=="string"?C=D(S(v)):C=v,!d||!C)return!1;let P=d.majorBase,l=d.minorBase,c=d.patchBase,f=C.majorBase,s=C.minorBase,b=C.patchBase,o=C.notBefore,i=C.majorMustEqual,r=C.minorMustEqual,n=C.patchMustEqual;return C.isMinimum?P>f?!0:P<f?!1:l>s?!0:l<s||w&&w<o?!1:c>=b:(P===1&&f===0&&(!i||!r||!n)&&(f=1,s=0,b=0,i=!0,r=!1,n=!1),P<f?!1:P>f?!i:l<s?!1:l>s?!r:c<b?!1:c>b?!n:!(w&&w<o))}e.isValidVersion=_;function R(p,E,v,d){return v.isBuiltin||typeof v.main=="undefined"?!0:I(p,E,v.engines.vscode,d)}e.isValidExtensionVersion=R;function F(p,E,v){return p==="*"||I(E,v,p)}e.isEngineValid=F;function I(p,E,v,d=[]){let w=D(S(v));if(!w)return d.push(h.localize(0,null,v)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return d.push(h.localize(1,null,v)),!1}else if(!w.majorMustEqual)return d.push(h.localize(2,null,v)),!1;return _(p,E,w)?!0:(d.push(h.localize(3,null,p,v)),!1)}}),define(we[114],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(k,A=[],S=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=h}),define(we[61],be([1,0,114]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(S,D,_){D instanceof h.SyncDescriptor||(D=new h.SyncDescriptor(D,[],_)),t.push([S,D])}e.registerSingleton=k;function A(){return t}e.getSingletonServiceDescriptors=A}),define(we[184],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=h;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const D=this.lookupOrInsertNode(A),_=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),_),_.incoming.set(this._hashFn(A),D)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let D=this._nodes.get(S);return D||(D=new h(A),this._nodes.set(S,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,D]of this._nodes)A.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,S]of this._nodes){const D=new Set([A]),_=this._findCycle(S,D);if(_)return _}}_findCycle(A,S){for(let[D,_]of A.outgoing){if(S.has(D))return[...S,D].join(" -> ");S.add(D);const R=this._findCycle(_,S);if(R)return R;S.delete(D)}}}e.Graph=t}),define(we[4],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function D(_){return _[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=D})(h=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(S,D,_,R){D[h.DI_TARGET]===D?D[h.DI_DEPENDENCIES].push({id:S,index:_,optional:R}):(D[h.DI_DEPENDENCIES]=[{id:S,index:_,optional:R}],D[h.DI_TARGET]=D)}function k(S){if(h.serviceIds.has(S))return h.serviceIds.get(S);const D=function(_,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(D,_,F,!1)};return D.toString=()=>S,h.serviceIds.set(S,D),D}e.createDecorator=k;function A(S){return S}e.refineServiceDecorator=A}),define(we[115],be([1,0,18,2,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=A;function S(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||h.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=S;var D;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function R(w,C){const P=Object.create(null);for(let l in w)F(P,l,w[l],C);return P}e.toValuesTree=R;function F(w,C,P,l){const c=C.split("."),f=c.pop();let s=w;for(let b=0;b<c.length;b++){let o=c[b],i=s[o];switch(typeof i){case"undefined":i=s[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${C} as ${c.slice(0,b+1).join(".")} is ${JSON.stringify(i)}`);return}s=i}if(typeof s=="object"&&s!==null)try{s[f]=P}catch{l(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(s)}`)}else l(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=F;function I(w,C){const P=C.split(".");p(w,P)}e.removeFromValueTree=I;function p(w,C){const P=C.shift();if(C.length===0){delete w[P];return}if(Object.keys(w).indexOf(P)!==-1){const l=w[P];typeof l=="object"&&!Array.isArray(l)&&(p(l,C),Object.keys(l).length===0&&delete w[P])}}function E(w,C,P){function l(s,b){let o=s;for(const i of b){if(typeof o!="object"||o===null)return;o=o[i]}return o}const c=C.split("."),f=l(w,c);return typeof f=="undefined"?P:f}e.getConfigurationValue=E;function v(w,C,P){Object.keys(C).forEach(l=>{l!=="__proto__"&&(l in w?h.isObject(w[l])&&h.isObject(C[l])?v(w[l],C[l],P):P&&(w[l]=C[l]):w[l]=C[l])})}e.merge=v;function d(w,C,P){const l=w.inspect(C),c=w.inspect(P);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:l.defaultValue}e.getMigratedSettingValue=d}),define(we[62],be([1,0,12,8,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",h.isMacintosh),A.set("isLinux",h.isLinux),A.set("isWindows",h.isWindows),A.set("isWeb",h.isWeb),A.set("isMacNative",h.isMacintosh&&!h.isWeb),A.set("isEdge",h.isEdge),A.set("isFirefox",h.isFirefox),A.set("isChrome",h.isChrome),A.set("isSafari",h.isSafari);const S=Object.prototype.hasOwnProperty;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class _{static false(){return I.INSTANCE}static true(){return p.INSTANCE}static has(y){return E.create(y)}static equals(y,H){return v.create(y,H)}static notEquals(y,H){return C.create(y,H)}static regex(y,H){return o.create(y,H)}static in(y,H){return d.create(y,H)}static not(y){return P.create(y)}static and(...y){return n.create(y,null)}static or(...y){return a.create(y,null,!0)}static greater(y,H){return c.create(y,H)}static greaterEquals(y,H){return f.create(y,H)}static smaller(y,H){return s.create(y,H)}static smallerEquals(y,H){return b.create(y,H)}static deserialize(y,H=!1){if(!!y)return this._deserializeOrExpression(y,H)}static _deserializeOrExpression(y,H){let M=y.split("||");return a.create(M.map(z=>this._deserializeAndExpression(z,H)),null,!0)}static _deserializeAndExpression(y,H){let M=y.split("&&");return n.create(M.map(z=>this._deserializeOne(z,H)),null)}static _deserializeOne(y,H){if(y=y.trim(),y.indexOf("!=")>=0){let M=y.split("!=");return C.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("==")>=0){let M=y.split("==");return v.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("=~")>=0){let M=y.split("=~");return o.create(M[0].trim(),this._deserializeRegexValue(M[1],H))}if(y.indexOf(" in ")>=0){let M=y.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return f.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return b.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?P.create(y.substr(1).trim()):E.create(y)}static _deserializeValue(y,H){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static _deserializeRegexValue(y,H){if((0,t.isFalsyOrWhitespace)(y)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=y.indexOf("/"),z=y.lastIndexOf("/");if(M===z||M<0){if(H)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let x=y.slice(M+1,z),K=y[z+1]==="i"?"i":"";try{return new RegExp(x,K)}catch(B){if(H)throw new Error(`bad regexp-value '${y}', parse error: ${B}`);return console.warn(`bad regexp-value '${y}', parse error: ${B}`),null}}}e.ContextKeyExpr=_;function R(L,y){const H=L?L.substituteConstants():void 0,M=y?y.substituteConstants():void 0;return!H&&!M?!0:!H||!M?!1:H.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function F(L,y){return L.cmp(y)}class I{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class p{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class E{constructor(y,H){this.key=y,this.negated=H,this.type=2}static create(y,H=null){const M=A.get(y);return typeof M=="boolean"?M?p.INSTANCE:I.INSTANCE:new E(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:u(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=A.get(this.key);return typeof y=="boolean"?y?p.INSTANCE:I.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class v{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=4}static create(y,H,M=null){if(typeof H=="boolean")return H?E.create(y,M):P.create(y,M);const z=A.get(y);return typeof z=="boolean"?H===(z?"true":"false")?p.INSTANCE:I.INSTANCE:new v(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=A.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?p.INSTANCE:I.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class d{constructor(y,H){this.key=y,this.valueKey=H,this.type=10,this.negated=null}static create(y,H){return new d(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const H=y.getValue(this.valueKey),M=y.getValue(this.key);return Array.isArray(H)?H.indexOf(M)>=0:typeof M=="string"&&typeof H=="object"&&H!==null?S.call(H,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=d;class w{constructor(y){this._actual=y,this.type=11}static create(y){return new w(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new w(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class C{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=5}static create(y,H,M=null){if(typeof H=="boolean")return H?P.create(y,M):E.create(y,M);const z=A.get(y);return typeof z=="boolean"?H===(z?"true":"false")?I.INSTANCE:p.INSTANCE:new C(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=A.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?I.INSTANCE:p.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class P{constructor(y,H){this.key=y,this.negated=H,this.type=3}static create(y,H=null){const M=A.get(y);return typeof M=="boolean"?M?I.INSTANCE:p.INSTANCE:new P(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:u(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=A.get(this.key);return typeof y=="boolean"?y?I.INSTANCE:p.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function l(L,y){if(typeof L=="string"){const H=parseFloat(L);isNaN(H)||(L=H)}return typeof L=="string"||typeof L=="number"?y(L):I.INSTANCE}class c{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=12}static create(y,H,M=null){return l(H,z=>new c(y,z,M))}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class f{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=13}static create(y,H,M=null){return l(H,z=>new f(y,z,M))}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class s{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=14}static create(y,H,M=null){return l(H,z=>new s(y,z,M))}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class b{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=15}static create(y,H,M=null){return l(H,z=>new b(y,z,M))}cmp(y){return y.type!==this.type?this.type-y.type:m(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=b;class o{constructor(y,H){this.key=y,this.regexp=H,this.type=7,this.negated=null}static create(y,H){return new o(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return H<M?-1:H>M?1:0}equals(y){if(y.type===this.type){const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return this.key===y.key&&H===M}return!1}substituteConstants(){return this}evaluate(y){let H=y.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class i{constructor(y){this._actual=y,this.type=8}static create(y){return new i(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new i(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(L){let y=null;for(let H=0,M=L.length;H<M;H++){const z=L[H].substituteConstants();if(L[H]!==z&&y===null){y=[];for(let x=0;x<H;x++)y[x]=L[x]}y!==null&&(y[H]=z)}return y===null?L:y}class n{constructor(y,H){this.expr=y,this.negated=H,this.type=6}static create(y,H){return n._normalizeArr(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const z=F(this.expr[H],y.expr[H]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:n.create(y,this.negated)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].evaluate(y))return!1;return!0}static _normalizeArr(y,H){const M=[];let z=!1;for(const x of y)if(!!x){if(x.type===1){z=!0;continue}if(x.type===0)return I.INSTANCE;if(x.type===6){M.push(...x.expr);continue}M.push(x)}if(M.length===0&&z)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let x=1;x<M.length;x++)M[x-1].equals(M[x])&&(M.splice(x,1),x--);if(M.length===1)return M[0];for(;M.length>1;){const x=M[M.length-1];if(x.type!==9)break;M.pop();const K=M.pop(),B=M.length===0,G=a.create(x.expr.map(X=>n.create([X,K],null)),null,B);G&&(M.push(G),M.sort(F))}return M.length===1?M[0]:new n(M,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new n(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){const y=[];for(let H of this.expr)y.push(H.negate());this.negated=a.create(y,this,!0)}return this.negated}}class a{constructor(y,H){this.expr=y,this.negated=H,this.type=9}static create(y,H,M){return a._normalizeArr(y,H,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const z=F(this.expr[H],y.expr[H]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:a.create(y,this.negated,!1)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(this.expr[H].evaluate(y))return!0;return!1}static _normalizeArr(y,H,M){let z=[],x=!1;if(y){for(let K=0,B=y.length;K<B;K++){const G=y[K];if(!!G){if(G.type===0){x=!0;continue}if(G.type===1)return p.INSTANCE;if(G.type===9){z=z.concat(G.expr);continue}z.push(G)}}if(z.length===0&&x)return I.INSTANCE;z.sort(F)}if(z.length!==0){if(z.length===1)return z[0];for(let K=1;K<z.length;K++)z[K-1].equals(z[K])&&(z.splice(K,1),K--);if(z.length===1)return z[0];if(M){for(let K=0;K<z.length;K++)for(let B=K+1;B<z.length;B++)T(z[K],z[B])&&(z.splice(B,1),B--);if(z.length===1)return z[0]}return new a(z,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new a(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){let y=[];for(let H of this.expr)y.push(H.negate());for(;y.length>1;){const H=y.shift(),M=y.shift(),z=[];for(const K of O(H))for(const B of O(M))z.push(n.create([K,B],null));const x=y.length===0;y.unshift(a.create(z,null,x))}this.negated=y[0]}return this.negated}}class g extends E{constructor(y,H,M){super(y,null);this._defaultValue=H,typeof M=="object"?g._info.push({...M,key:y}):M!==!0&&g._info.push({key:y,description:M,type:H!=null?typeof H:void 0})}static all(){return g._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return v.create(this.key,y)}notEqualsTo(y){return C.create(this.key,y)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(L,y){return L<y?-1:L>y?1:0}function m(L,y,H,M){return L<H?-1:L>H?1:y<M?-1:y>M?1:0}function T(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const z of y.expr)if(L.equals(z))return!0}const H=L.negate(),M=O(H).concat(O(y));M.sort(F);for(let z=0;z<M.length;z++){const K=M[z].negate();for(let B=z+1;B<M.length;B++){const G=M[B];if(K.equals(G))return!0}}return!1}e.implies=T;function O(L){return L.type===9?L.expr:[L]}}),define(we[185],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(we[186],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,h.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,h.createDecorator)("externalTerminal")}),define(we[187],be([1,0,38,10,9,12,93,28,112,162,186]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=R.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends p{openTerminal(c,f){return this.spawnTerminal(h,c,_.getWindowsShell(),f)}spawnTerminal(c,f,s,b){const o=f.windowsExec||E.getDefaultTerminalWindows();b&&b[1]===":"&&(b=b[0].toUpperCase()+b.substr(1));const i=k.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return c.spawn(o,b?[b]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return o.indexOf(" ")>=0&&r.push('""'),r.push(o),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((n,a)=>{const g=w(process),u=c.spawn(s,r,{cwd:b,env:g});u.on("error",a),u.on("exit",()=>n())})}runInTerminal(c,f,s,b,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:E.getDefaultTerminalWindows();return new Promise((r,n)=>{const a=`"${f} - ${I}"`,g=`""${s.join('" "')}" & pause"`,u=["/c","start",a,"/wait",i,"/c",g],m=Object.assign({},w(process),b);Object.keys(m).filter(L=>m[L]===null).forEach(L=>delete m[L]);const T={cwd:f,env:m,windowsVerbatimArguments:!0};h.spawn(E.CMD,u,T).on("error",L=>{n(C(L))}),r(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class v extends p{openTerminal(c,f){return this.spawnTerminal(h,c,f)}runInTerminal(c,f,s,b,o){const i=o.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{if(i===F.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const a=i===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,te).fsPath,"-t",c||I,"-w",f];for(let O of s)u.push("-a"),u.push(O);if(b){const O=Object.assign({},w(process),b);for(let L in O){const y=O[L];y===null?(u.push("-u"),u.push(L)):(u.push("-e"),u.push(`${L}=${y}`))}}let m="";const T=h.spawn(v.OSASCRIPT,u);T.on("error",O=>{n(C(O))}),T.stderr.on("data",O=>{m+=O.toString()}),T.on("exit",O=>{if(O===0)r(void 0);else if(m){const L=m.split(`
`,1);n(new Error(L[0]))}else n(new Error(R.localize(1,null,a,O)))})}else n(new Error(R.localize(2,null,i)))})}spawnTerminal(c,f,s){const b=f.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const r=["-a",b];s&&r.push(s);const n=w(process),a=c.spawn("/usr/bin/open",r,{cwd:s,env:n});a.on("error",i),a.on("exit",()=>o())})}}e.MacExternalTerminalService=v,v.OSASCRIPT="/usr/bin/osascript";class d extends p{openTerminal(c,f){return this.spawnTerminal(h,c,f)}runInTerminal(c,f,s,b,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{let a=[];i.then(g=>{g.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const u=`${P(s)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;a.push(`''${u}''`);const m=Object.assign({},w(process),b);Object.keys(m).filter(y=>m[y]===null).forEach(y=>delete m[y]);const T={cwd:f,env:m};let O="";const L=h.spawn(g,a,T);L.on("error",y=>{n(C(y))}),L.stderr.on("data",y=>{O+=y.toString()}),L.on("exit",y=>{if(y===0)r(void 0);else if(O){const H=O.split(`
`,1);n(new Error(H[0]))}else n(new Error(R.localize(4,null,g,y)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await D.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(f=>{c?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,f,s){const b=f.linuxExec?Promise.resolve(f.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{b.then(r=>{const n=w(process),a=c.spawn(r,[],{cwd:s,env:n});a.on("error",i),a.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=R.localize(3,null);function w(l){const c={...l.env};return(0,S.sanitizeProcessEnvironment)(c),c}function C(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(R.localize(5,null,l.path)):l}function P(l){let c="";for(let f of l)f.indexOf(" ")>=0?c+='"'+f+'"':c+=f,c+=" ";return c}}),define(we[42],be([1,0,24,9,8,18,2,163,4]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function R(x){return x.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var I;(function(x){x[x.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var p;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=E;function v(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=w;function C(x){return E(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var P;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(K,B){super(K);this.code=B}}e.FileSystemProviderError=l;function c(x,K){const B=new l(x.toString(),K);return s(B,K),B}e.createFileSystemProviderError=c;function f(x){return x||c((0,D.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=f;function s(x,K){return x.name=K?`${K} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=s;function b(x){if(!x)return P.Unknown;if(x instanceof l)return x.code;const K=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!K)return P.Unknown;switch(K[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=b;function o(x){if(x instanceof u)return x.fileOperationResult;switch(b(x)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(K,B,G){this.resource=K,this.operation=B,this.target=G}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var n;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class a{constructor(K,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const G=new Map;for(const X of K){const q=G.get(X.type);switch(q?q.push([X.resource,X]):G.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,q]of G)switch(X){case 1:this.added=h.TernarySearchTree.forUris(()=>B),this.added.fill(q);break;case 0:this.updated=h.TernarySearchTree.forUris(()=>B),this.updated.fill(q);break;case 2:this.deleted=h.TernarySearchTree.forUris(()=>B),this.deleted.fill(q);break}}contains(K,...B){return this.doContains(K,{includeChildren:!1},...B)}affects(K,...B){return this.doContains(K,{includeChildren:!0},...B)}doContains(K,B,...G){if(!K)return!1;const X=G.length>0;return!!((!X||G.includes(1))&&(this.added?.get(K)||B.includeChildren&&this.added?.findSuperstr(K))||(!X||G.includes(0))&&(this.updated?.get(K)||B.includeChildren&&this.updated?.findSuperstr(K))||(!X||G.includes(2))&&(this.deleted?.findSubstr(K)||B.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function g(x,K,B){return!x||!K||x===K||K.length>x.length?!1:(K.charAt(K.length-1)!==t.sep&&(K+=t.sep),B?(0,k.startsWithIgnoreCase)(x,K):x.indexOf(K)===0)}e.isParent=g;class u extends Error{constructor(K,B,G){super(K);this.fileOperationResult=B,this.options=G}}e.FileOperationError=u;class m extends u{constructor(K,B,G){super(K,2,G);this.stat=B}}e.NotModifiedSinceFileOperationError=m;var T;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=L;async function y(x,K){if(!K.hasProvider(S.URI.from({scheme:x.scheme})))return new Promise(B=>{const G=K.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===x.scheme&&X.added&&(G.dispose(),B())})})}e.whenProviderRegistered=y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(K){return(0,A.isNumber)(K)||(K=0),K<H.KB?(0,D.localize)(1,null,K.toFixed(0)):K<H.MB?(0,D.localize)(2,null,(K/H.KB).toFixed(2)):K<H.GB?(0,D.localize)(3,null,(K/H.MB).toFixed(2)):K<H.TB?(0,D.localize)(4,null,(K/H.GB).toFixed(2)):(0,D.localize)(5,null,(K/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var M;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function z(x){return{maxFileSize:x===0?300*H.MB:16*H.GB,maxHeapSize:x===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=z}),define(we[80],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...k){this._entries=new Map;for(let[A,S]of k)this.set(A,S)}set(k,A){const S=this._entries.get(k);return this._entries.set(k,A),S}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=h}),define(we[188],be([1,0,13,16,114,184,4,80]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const _=!1;class R extends Error{constructor(v){super("cyclic dependency between services");this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class F{constructor(v=new D.ServiceCollection,d=!1,w){this._activeInstantiations=new Set,this._services=v,this._strict=d,this._parent=w,this._services.set(S.IInstantiationService,this)}createChild(v){return new F(v,this._strict,this)}invokeFunction(v,...d){let w=p.traceInvocation(v),C=!1;try{return v({get:l=>{if(C)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(l,w);if(!c)throw new Error(`[invokeFunction] unknown service '${l}'`);return c}},...d)}finally{C=!0,w.stop()}}createInstance(v,...d){let w,C;return v instanceof k.SyncDescriptor?(w=p.traceCreation(v.ctor),C=this._createInstance(v.ctor,v.staticArguments.concat(d),w)):(w=p.traceCreation(v),C=this._createInstance(v,d,w)),w.stop(),C}_createInstance(v,d=[],w){let C=S._util.getServiceDependencies(v).sort((c,f)=>c.index-f.index),P=[];for(const c of C){let f=this._getOrCreateServiceInstance(c.id,w);if(!f&&this._strict&&!c.optional)throw new Error(`[createInstance] ${v.name} depends on UNKNOWN service ${c.id}.`);P.push(f)}let l=C.length>0?C[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${v.name} at position ${l+1} conflicts with ${d.length} static arguments`);let c=l-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,l)}return new v(...[...d,...P])}_setServiceInstance(v,d){if(this._services.get(v)instanceof k.SyncDescriptor)this._services.set(v,d);else if(this._parent)this._parent._setServiceInstance(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){let d=this._services.get(v);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):d}_getOrCreateServiceInstance(v,d){let w=this._getServiceInstanceOrDescriptor(v);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,w,d.branch(v,!0)):(d.branch(v,!1),w)}_safeCreateAndCacheServiceInstance(v,d,w){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,d,w)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,d,w){const C=new A.Graph(c=>c.id.toString());let P=0;const l=[{id:v,desc:d,_trace:w}];for(;l.length;){const c=l.pop();if(C.lookupOrInsertNode(c),P++>1e3)throw new R(C);for(let f of S._util.getServiceDependencies(c.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(f.id);if(!s&&!f.optional&&console.warn(`[createInstance] ${v} depends on ${f.id} which is NOT registered.`),s instanceof k.SyncDescriptor){const b={id:f.id,desc:s,_trace:c._trace.branch(f.id,!0)};C.insertEdge(c,b),l.push(b)}}}for(;;){const c=C.roots();if(c.length===0){if(!C.isEmpty())throw new R(C);break}for(const{data:f}of c){if(this._getServiceInstanceOrDescriptor(f.id)instanceof k.SyncDescriptor){const b=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,b)}C.removeNode(f)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,d,w=[],C,P){if(this._services.get(v)instanceof k.SyncDescriptor)return this._createServiceInstance(d,w,C,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,d,w,C,P);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(v,d=[],w,C){if(w){const P=new h.IdleValue(()=>this._createInstance(v,d,C));return new Proxy(Object.create(null),{get(l,c){if(c in l)return l[c];let f=P.value,s=f[c];return typeof s!="function"||(s=s.bind(f),l[c]=s),s},set(l,c,f){return P.value[c]=f,!0}})}else return this._createInstance(v,d,C)}}e.InstantiationService=F;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class p{constructor(v,d){this.type=v,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(v){return _?new p(1,v.name||v.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(v){return _?new p(0,v.name):p._None}branch(v,d){let w=new p(2,v.toString());return this._dep.push([v,d,w]),w}stop(){let v=Date.now()-this._start;p._totals+=v;let d=!1;function w(P,l){let c=[],f=new Array(P+1).join("	");for(const[s,b,o]of l._dep)if(b&&o){d=!0,c.push(`${f}CREATES -> ${s}`);let i=w(P+1,o);i&&c.push(i)}else c.push(`${f}uses -> ${s}`);return c.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(v>2||d)&&console.log(C.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(we[11],be([1,0,49,3,6,12,4]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function D(){return new Date().toISOString()}var _;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function R(b,o,i){switch(o){case _.Trace:b.trace(i);break;case _.Debug:b.debug(i);break;case _.Info:b.info(i);break;case _.Warning:b.warn(i);break;case _.Error:b.error(i);break;case _.Critical:b.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function F(b){let o="";for(let i=0;i<b.length;i++){let r=b[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}o+=(i>0?" ":"")+r}return o}e.format=F;class I extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class p extends I{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,F([o,...i]))}debug(o,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,F([o,...i]))}info(o,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,F([o,...i]))}warn(o,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,F([o,...i]))}error(o,...i){if(this.checkLogLevel(_.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(_.Error,F(r))}else this.log(_.Error,F([o,...i]))}critical(o,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,F([o,...i]))}flush(){}}e.AbstractMessageLogger=p;class E extends I{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}debug(o,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}info(o,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,o,...i):console.log(`[main ${D()}]`,o,...i))}warn(o,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,o,...i):console.warn(`[main ${D()}]`,o,...i))}error(o,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,o,...i):console.error(`[main ${D()}]`,o,...i))}critical(o,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,o,...i):console.error(`[main ${D()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class v extends I{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=v;class d extends I{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,h.toErrorMessage)(o,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class w extends I{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const r of this.logServices)r.trace(o,...i)}debug(o,...i){for(const r of this.logServices)r.debug(o,...i)}info(o,...i){for(const r of this.logServices)r.info(o,...i)}warn(o,...i){for(const r of this.logServices)r.warn(o,...i)}error(o,...i){for(const r of this.logServices)r.error(o,...i)}critical(o,...i){for(const r of this.logServices)r.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=w;class C extends k.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=C;class P extends k.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let r=this.loggers.get(o.toString());return r||(r=this.doCreateLogger(o,i?.always?_.Trace:this.logLevel,i),this.loggers.set(o.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return _.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=l;function c(b){if(b.verbose)return _.Trace;if(typeof b.logLevel=="string"){const o=f(b.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function f(b){switch(b){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=f;function s(b){switch(b){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=s}),define(we[189],be([1,0,42,11]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(D,_,R,F,I){try{const p=await new Promise((v,d)=>{te(["spdlog"],v,d)});p.setFlushOn(t.LogLevel.Trace);const E=await p.createAsyncRotatingLogger(D,_,R,F);return I&&E.clearFormatters(),E}catch(p){console.error(p)}return null}function A(D,_,R){switch(_){case t.LogLevel.Trace:D.trace(R);break;case t.LogLevel.Debug:D.debug(R);break;case t.LogLevel.Info:D.info(R);break;case t.LogLevel.Warning:D.warn(R);break;case t.LogLevel.Error:D.error(R);break;case t.LogLevel.Critical:D.critical(R);break;default:throw new Error("Invalid log level")}}class S extends t.AbstractMessageLogger{constructor(_,R,F,I,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(_,R,F,I),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(_,R,F,I){const p=F?6:1,E=30/p*h.ByteSize.MB,v=await k(_,R,E,p,I);if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:d,message:w}of this.buffer)A(this._logger,d,w);this.buffer=[]}}log(_,R){this._logger?A(this._logger,_,R):this.getLevel()<=_&&this.buffer.push({level:_,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(we[116],be([1,0,47,164,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function R(v,d){return d-v}_.compare=R;const F=Object.create(null);F[_.Error]=(0,t.localize)(0,null),F[_.Warning]=(0,t.localize)(1,null),F[_.Info]=(0,t.localize)(2,null);function I(v){return F[v]||""}_.toString=I;function p(v){switch(v){case h.default.Error:return _.Error;case h.default.Warning:return _.Warning;case h.default.Info:return _.Info;case h.default.Ignore:return _.Hint}}_.fromSeverity=p;function E(v){switch(v){case _.Error:return h.default.Error;case _.Warning:return h.default.Warning;case _.Info:return h.default.Info;case _.Hint:return h.default.Ignore}}_.toSeverity=E}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const R="";function F(p){return I(p,!0)}_.makeKey=F;function I(p,E){let v=[R];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(R),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(R),p.severity!==void 0&&p.severity!==null?v.push(S.toString(p.severity)):v.push(R),p.message&&E?v.push(p.message.replace("\xA6","\\\xA6")):v.push(R),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(R),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(R),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(R),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(R),v.push(R),v.join("\xA6")}_.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(we[190],be([1,0,3,47,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=_}),define(we[117],be([1,0,6,8,2,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function S(R,F){return k.URI.isUri(R)?(0,t.equalsIgnoreCase)(R.scheme,F):(0,t.startsWithIgnoreCase)(R,F+":")}e.matchesScheme=S;function D(R,...F){return F.some(I=>S(R,I))}e.matchesSomeScheme=D;function _(R){let F;const I=/^L?(\d+)(?:,(\d+))?/.exec(R.fragment);return I&&(F={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1}),F}e.selectionFragment=_}),define(we[191],be([1,0,10,12,41,23]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const D=t.globals.vscode.context.configuration();if(D)S=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const D=(0,A.dirname)(h.FileAccess.asFileUri("",te));S=te.__$__nodeRequire((0,A.joinPath)(D,"product.json").fsPath);const _=te.__$__nodeRequire((0,A.joinPath)(D,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),Object.assign(S,{version:_.version})}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=S});var Fe=this&&this.__param||function(te,e){return function(h,t){e(h,t,te)}};define(we[118],be([1,0,13,21,6,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var S;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends k.Disposable{constructor(I,p){super();this.deferred=new h.DeferredPromise,p.withProgress(I,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Be([Fe(1,e.IProgressService)],_),e.UnmanagedProgress=_;class R extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const p=++this.currentOperationId,E=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:E.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[50],be([1,0,55,18]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(S,D){h.ok(t.isString(S)),h.ok(t.isObject(D)),h.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new k}),define(we[192],be([1,0,3,50]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,R){this.schemasById[k(_)]=R,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;t.Registry.add(e.Extensions.JSONContribution,S)}),define(we[119],be([1,0,17,3,18,159,192,50]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=D.Registry.as(S.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(f,s=!0){this.registerConfigurations([f],s)}registerConfigurations(f,s=!0){const b=this.doRegisterConfigurations(f,s);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:b})}deregisterConfigurations(f){const s=this.doDeregisterConfigurations(f);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:f,remove:s}){const b=[];b.push(...this.doDeregisterConfigurations(s)),b.push(...this.doRegisterConfigurations(f,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,h.distinct)(b)})}registerDefaultConfigurations(f){const s=[],b=[];for(const{overrides:o,source:i}of f)for(const r in o)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const n={...this.configurationDefaultsOverrides.get(r)?.value||{},...o[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:n});const a={type:"object",default:n,description:A.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:n,source:k.isString(i)?void 0:i};b.push(...v(r)),this.configurationProperties[r]=a,this.defaultLanguageConfigurationOverridesNode.properties[r]=a}else{this.configurationDefaultsOverrides.set(r,{value:o[r],source:i});const n=this.configurationProperties[r];n&&(this.updatePropertyDefaultValue(r,n),this.updateSchema(r,n))}this.registerOverrideIdentifiers(b),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(f){const s=[];for(const{overrides:b,source:o}of f)for(const i in b){const r=this.configurationDefaultsOverrides.get(i),n=k.isString(o)?o:o?.id,a=k.isString(r?.source)?r?.source:r?.source?.id;if(n===a)if(s.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const s of f)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,s){const b=[];return f.forEach(o=>{b.push(...this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),b}doDeregisterConfigurations(f){const s=[],b=o=>{if(o.properties)for(const i in o.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>b(i))};for(const o of f){b(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(f,s=!0,b,o,i=3){i=k.isUndefinedOrNull(f.scope)?i:f.scope;let r=[],n=f.properties;if(n)for(let g in n){if(s&&P(g)){delete n[g];continue}const u=n[g];if(u.source=b,u.defaultDefaultValue=n[g].default,this.updatePropertyDefaultValue(g,u),e.OVERRIDE_PROPERTY_REGEX.test(g)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?i:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!o?.includes(g):u.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.excludedConfigurationProperties[g]=n[g],delete n[g];continue}else this.configurationProperties[g]=n[g];!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),r.push(g)}let a=f.allOf;if(a)for(let g of a)r.push(...this.validateAndRegisterProperties(g,s,b,o,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(f){const s=b=>{let o=b.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let i=b.allOf;i&&i.forEach(s)};s(f)}updateSchema(f,s){switch(e.allSettings.properties[f]=s,s.scope){case 1:e.applicationSettings.properties[f]=s;break;case 2:e.machineSettings.properties[f]=s;break;case 6:e.machineOverridableSettings.properties[f]=s;break;case 3:e.windowSettings.properties[f]=s;break;case 4:e.resourceSettings.properties[f]=s;break;case 5:e.resourceSettings.properties[f]=s,this.resourceLanguageSettingsSchema.properties[f]=s;break}}removeFromSchema(f,s){switch(delete e.allSettings.properties[f],s.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f],delete this.resourceLanguageSettingsSchema.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const s=`[${f}]`,b={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,b),e.allSettings.properties[s]=b,e.applicationSettings.properties[s]=b,e.machineSettings.properties[s]=b,e.machineOverridableSettings.properties[s]=b,e.windowSettings.properties[s]=b,e.resourceSettings.properties[s]=b}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const f={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=f,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,s){const b=this.configurationDefaultsOverrides.get(f);let o=b?.value,i=b?.source;k.isUndefined(o)&&(o=s.defaultDefaultValue,i=void 0),k.isUndefined(o)&&(o=w(s.type)),s.default=o,s.defaultValueSource=i}}const p="\\[([^\\]]+)\\]",E=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(c){const f=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=E.exec(c);for(;s?.length;){const b=s[1].trim();b&&f.push(b),s=E.exec(c)}}return(0,h.distinct)(f)}e.overrideIdentifiersFromKey=v;function d(c){return c.reduce((f,s)=>`${f}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function w(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const C=new I;D.Registry.add(e.Extensions.Configuration,C);function P(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?A.localize(7,null,c):C.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):null:A.localize(6,null)}e.validateProperty=P;function l(){const c=[],f=C.getConfigurationProperties();for(const s of Object.keys(f))c.push([s,f[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=l}),define(we[193],be([1,0,17,3,141,6,24,25,18,2,115,119,50]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(o={},i=[],r=[]){this._contents=o,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,F.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const r=this.getContentsForOverrideIdentifer(i);return r?o?(0,F.getConfigurationValue)(r,o):r:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const r of this.overrides)r.identifiers.includes(o)&&i.push(...r.keys);return h.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return h.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=D.deepClone(this.contents),r=D.deepClone(this.overrides),n=[...this.keys];for(const a of o){this.mergeContents(i,a.contents);for(const g of a.overrides){const[u]=r.filter(m=>h.equals(m.identifiers,g.identifiers));u?(this.mergeContents(u.contents,g.contents),u.keys.push(...g.keys),u.keys=h.distinct(u.keys)):r.push(D.deepClone(g))}for(const g of a.keys)n.indexOf(g)===-1&&n.push(g)}return new E(i,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const n of h.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[n],g=i[n];g&&(typeof a=="object"&&typeof g=="object"?(a=D.deepClone(a),this.mergeContents(a,g)):a=g),r[n]=a}return new E(r,this.keys,this.overrides)}mergeContents(o,i){for(const r of Object.keys(i)){if(r in o&&_.isObject(o[r])&&_.isObject(i[r])){this.mergeContents(o[r],i[r]);continue}o[r]=D.deepClone(i[r])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?D.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,r=null;const n=a=>{a&&(r?this.mergeContents(r,a):r=D.deepClone(a))};for(const a of this.overrides)h.equals(a.identifiers,[o])?i=a.contents:a.identifiers.includes(o)&&n(a.contents);return n(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,F.addToValueTree)(this.contents,o,i,r=>{throw new Error(r)})}removeValue(o){this.removeKey(o)&&(0,F.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let r=0;r<i;r++)o.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=E;class v extends E{constructor(o={}){const i=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),n=Object.create(null),a=[];for(const g in i){const u=o[g],m=u!==void 0?u:i[g].default;(0,F.addToValueTree)(n,g,m,T=>console.error(`Conflict in default settings: ${T}`))}for(const g of Object.keys(n))I.OVERRIDE_PROPERTY_REGEX.test(g)&&a.push({identifiers:(0,I.overrideIdentifiersFromKey)(g),keys:Object.keys(n[g]),contents:(0,F.toValuesTree)(n[g],u=>console.error(`Conflict in default settings file: ${u}`))});super(n,r,a)}}e.DefaultConfigurationModel=v;class d{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!_.isUndefinedOrNull(o)){const r=this.doParseContent(o);this.parseRaw(r,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:r,keys:n,overrides:a,restricted:g}=this.doParseRaw(o,i);this._configurationModel=new E(r,n,a),this._restrictedConfigurations=g||[]}doParseContent(o){let i={},r=null,n=[],a=[],g=[];function u(T){Array.isArray(n)?n.push(T):r!==null&&(n[r]=T)}let m={onObjectBegin:()=>{let T={};u(T),a.push(n),n=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let T=[];u(T),a.push(n),n=T,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:u,onError:(T,O,L)=>{g.push({error:T,offset:O,length:L})}};if(o)try{k.visit(o,m),i=n[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(o,i){const r=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(o,r,!0,i);o=n.raw;const a=(0,F.toValuesTree)(o,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),g=Object.keys(o),u=this.toOverrides(o,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:a,keys:g,overrides:u,restricted:n.restricted}}filter(o,i,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:o,restricted:[]};const a={},g=[];for(let u in o)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&r){const m=this.filter(o[u],i,!1,n);a[u]=m.raw,g.push(...m.restricted)}else{const m=i[u],T=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&g.push(u),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&(n.skipRestricted&&m?.restricted||(a[u]=o[u]))}return{raw:a,restricted:g}}toOverrides(o,i){const r=[];for(const n of Object.keys(o))if(I.OVERRIDE_PROPERTY_REGEX.test(n)){const a={};for(const g in o[n])a[g]=o[n][g];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(a),contents:(0,F.toValuesTree)(a,i)})}return r}}e.ConfigurationModelParser=d;class w extends A.Disposable{constructor(o,i,r,n){super();this.userSettingsResource=o,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class C{constructor(o,i,r=new E,n=new E,a=new S.ResourceMap,g=new E,u=new S.ResourceMap,m=!0){this._defaultConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=u,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(o,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(o)}updateValue(o,i,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new E,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(o):n.setValue(o,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,r){const n=this.getConsolidateConfigurationModel(i,r),a=this.getFolderConfigurationModelForResource(i.resource,r),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),m=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),L=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,y=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(o):a.freeze().getValue(o):void 0,H=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(o):g.getValue(o),M=n.getValue(o),z=h.distinct(h.flatten(n.overrides.map(x=>x.identifiers))).filter(x=>n.getOverrideValue(o,x)!==void 0);return{defaultValue:u,userValue:m,userLocalValue:T,userRemoteValue:O,workspaceValue:L,workspaceFolderValue:y,memoryValue:H,value:M,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:a?.freeze().getValue(o),override:i.overrideIdentifier?a?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(o),override:i.overrideIdentifier?g.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const r=[];if(!i){const{added:n,updated:a,removed:g}=f(this._defaultConfiguration,o);i=[...n,...a,...g]}for(const n of i)for(const a of(0,I.overrideIdentifiersFromKey)(n)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=o.getKeysForOverrideIdentifier(a),m=[...u.filter(T=>g.indexOf(T)===-1),...g.filter(T=>u.indexOf(T)===-1),...g.filter(T=>!D.equals(this._defaultConfiguration.override(a).getValue(T),o.override(a).getValue(T)))];r.push([a,m])}return this.updateDefaultConfiguration(o),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:r,removed:n,overrides:a}=f(this.localUserConfiguration,o),g=[...i,...r,...n];return g.length&&this.updateLocalUserConfiguration(o),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:r,removed:n,overrides:a}=f(this.remoteUserConfiguration,o);let g=[...i,...r,...n];return g.length&&this.updateRemoteUserConfiguration(o),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:r,removed:n,overrides:a}=f(this.workspaceConfiguration,o);let g=[...i,...r,...n];return g.length&&this.updateWorkspaceConfiguration(o),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(o,i){const r=this.folderConfigurations.get(o),{added:n,updated:a,removed:g,overrides:u}=f(r,i);let m=[...n,...a,...g];return(m.length||!r)&&this.updateFolderConfiguration(o,i),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:r,updated:n,removed:a,overrides:g}=f(i,void 0);return{keys:[...r,...n,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,i){let r=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier?r.override(o.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:o},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const n=i.getFolder(o);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(o);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(o);n?(i=r.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=r}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const r=i.getFolder(o);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(i);return o.push([i,{contents:r,overrides:n,keys:a}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>o.add(r))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>o.add(r))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),r=this.parseConfigurationModel(o.user),n=this.parseConfigurationModel(o.workspace),a=o.folders.reduce((g,u)=>(g.set(R.URI.revive(u[0]),this.parseConfigurationModel(u[1])),g),new S.ResourceMap);return new C(i,r,new E,n,a,new E,new S.ResourceMap,!1)}static parseConfigurationModel(o){return new E(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=C;function P(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const o=new Set,i=new Map;for(const n of b)n.keys.forEach(a=>o.add(a)),n.overrides.forEach(([a,g])=>{const u=(0,S.getOrSet)(i,a,new Set);g.forEach(m=>u.add(m))});const r=[];return i.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...o.values()],overrides:r}}e.mergeChanges=P;class l{constructor(o,i,r,n){this.change=o,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;o.keys.forEach(u=>a.add(u)),o.overrides.forEach(([,u])=>u.forEach(m=>a.add(m))),this.affectedKeys=[...a.values()];const g=new E;this.affectedKeys.forEach(u=>g.setValue(u,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!D.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let r=(0,F.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(o=o[n],!o)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=l;class c extends l{constructor(o,i,r,n){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=c;function f(b,o){const{added:i,removed:r,updated:n}=s(o,b),a=[],g=b?.getAllOverrideIdentifiers()||[],u=o?.getAllOverrideIdentifiers()||[];if(o){const m=u.filter(T=>!g.includes(T));for(const T of m)a.push([T,o.getKeysForOverrideIdentifier(T)])}if(b){const m=g.filter(T=>!u.includes(T));for(const T of m)a.push([T,b.getKeysForOverrideIdentifier(T)])}if(o&&b){for(const m of g)if(u.includes(m)){const T=s({contents:b.getOverrideValue(void 0,m)||{},keys:b.getKeysForOverrideIdentifier(m)},{contents:o.getOverrideValue(void 0,m)||{},keys:o.getKeysForOverrideIdentifier(m)});a.push([m,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:r,updated:n,overrides:a}}function s(b,o){const i=b?o?b.keys.filter(a=>o.keys.indexOf(a)===-1):[...b.keys]:[],r=o?b?o.keys.filter(a=>b.keys.indexOf(a)===-1):[...o.keys]:[],n=[];if(b&&o){for(const a of o.keys)if(b.keys.indexOf(a)!==-1){const g=(0,F.getConfigurationValue)(o.contents,a),u=(0,F.getConfigurationValue)(b.contents,a);D.equals(g,u)||n.push(a)}}return{added:i,removed:r,updated:n}}}),define(we[120],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(S,D=t.Unknown,_){super(S);this._message=S,this._code=D,this._detail=_,this.isHandled=D===t.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===t.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===t.NoResolverFound}static isHandled(S){return S instanceof k&&S.isHandled}}e.RemoteAuthorityResolverError=k}),define(we[121],be([1,0,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===h.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function k(A){if(!A)return;const S=A.indexOf("+");return S<0?A:A.substr(0,S)}e.getRemoteName=k}),define(we[27],be([1,0,8,4,121]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=A;function S(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class _{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,v){if(typeof E=="undefined"||E===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof E=="string"||typeof v=="string"){let d=typeof E=="string"?E:E.value,w=typeof v=="string"?v:v.value;return h.equalsIgnoreCase(d,w)}return E._lower===v._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=_;function R(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function I(p,E){if(E){const v=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return p.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[122],be([1,0,8,27]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(v,d){return v.uuid&&d.uuid?v.uuid===d.uuid:v.id===d.id?!0:(0,h.compareIgnoreCase)(v.id,d.id)===0}e.areSameExtensions=k;class A{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof A?k(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(v,d){return`${v}.${d}`}e.getExtensionId=S;function D(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(v,d){return D(S(v,d))}e.getGalleryExtensionId=_;function R(v,d){const w=[],C=P=>{for(const l of w)if(l.some(c=>k(d(c),d(P))))return l;return null};for(const P of v){const l=C(P);l?l.push(P):w.push([P])}return w}e.groupByExtension=R;function F(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function I(v){return{id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,isPreReleaseVersion:v.properties.isPreReleaseVersion,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0),...v.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function p(v){const d=new Set;if(v.malicious)for(const w of v.malicious)d.add(w.id);return d}e.getMaliciousExtensionsSet=p;function E(v,d){const w=[],C=d.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const P=C.shift();if(P&&w.every(l=>!k(l.identifier,{id:P}))){const l=v.filter(c=>k(c.identifier,{id:P}));l.length===1&&(w.push(l[0]),C.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=E}),define(we[194],be([1,0,10,160,122,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const S=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function D(s){const b=S.exec(s);return b&&b[1]?[(0,k.adoptToGalleryExtensionId)(b[1]),b[2]]:[(0,k.adoptToGalleryExtensionId)(s),void 0]}e.getIdAndVersion=D;var _;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function R(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function F(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function I(s,b){switch(s){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function p(s,b){return b==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=p;function E(s,b,o){return p(b,o)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===o?!0:v(o).includes(s)}e.isTargetPlatformCompatible=E;function v(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function d(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=d;var w;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var P;(function(s){s.Install="install",s.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var l;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(l=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var c;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(b,o){super(b);this.code=o,this.name=o}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=h.FileAccess.asBrowserUri("./media/defaultIcon.png",te).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(we[195],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class h{constructor(){this.validators=new Map}vsda(){return new Promise((k,A)=>te(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.vsda(),S=new A.validator;if(S){const D=String(h._nextId++);return this.validators.set(D,S),{id:D,data:S.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const S=this.validators.get(k.id);if(!S)return!1;this.validators.delete(k.id);try{return S.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.vsda(),S=new A.signer;if(S)return S.sign(k)}catch{}return k}}e.SignService=h,h._nextId=1}),define(we[196],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,A,S=5){let D;return D=A(_=>{const R=typeof _=="string"?_:_.data;let F=this._terminalBufferMap.get(k);if(F){F.data.push(R);return}const I=setTimeout(()=>this.flushBuffer(k),S);F={data:[R],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),D.dispose()}},this._terminalBufferMap.set(k,F)}),D}stopBuffering(k){const A=this._terminalBufferMap.get(k);A&&A.dispose()}flushBuffer(k){const A=this._terminalBufferMap.get(k);A&&(this._terminalBufferMap.delete(k),this._callback(k,A.data.join("")))}}e.TerminalDataBufferer=h}),define(we[197],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(we[81],be([1,0,73,3,6,4,50,197]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var _;(function(w){function C(P){return P&&typeof P=="object"&&typeof P.id=="string"}w.isThemeColor=C})(_=e.ThemeColor||(e.ThemeColor={}));function R(w){return{id:w}}e.themeColorFromId=R;var F;(function(w){function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||_.isThemeColor(i.color))}w.isThemeIcon=C;const P=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const r=P.exec(i);if(!r)return;let[,n]=r;return{id:n}}w.fromString=l;function c(i){return{id:i}}w.fromId=c;function f(i,r){let n=i.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}w.modify=f;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}w.getModifier=s;function b(i,r){return i.id===r.id&&i.color?.id===r.color?.id}w.isEqual=b;function o(i,r){return{id:i.id,color:r?R(r):void 0}}w.asThemeIcon=o,w.asClassNameArray=h.CSSIcon.asClassNameArray,w.asClassName=h.CSSIcon.asClassName,w.asCSSSelector=h.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function I(w){switch(w){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(C){return this.themingParticipants.push(C),this.onThemingParticipantAddedEmitter.fire(C),(0,k.toDisposable)(()=>{const P=this.themingParticipants.indexOf(C);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new p;S.Registry.add(e.Extensions.ThemingContribution,E);function v(w){return E.onColorThemeChange(w)}e.registerThemingParticipant=v;class d extends k.Disposable{constructor(C){super();this.themeService=C,this.theme=C.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(C){this.theme=C,this.updateStyles()}updateStyles(){}getColor(C,P){let l=this.theme.getColor(C);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=d}),define(we[123],be([1,0,3,12,4,11]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var S;(function(v){v.Http="http",v.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=I;function p(v,d){return d?d!==1&&v<1024:!t.isWindows&&v<1024}e.isPortPrivileged=p;let E=class{constructor(d){this.logService=d,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],w=Array.from(this._tunnels.values());for(let C of w){const P=Array.from(C.values());for(let l of P){const c=await l.value;c&&d.push(c)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:w}of d.values())await w.then(C=>C?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,w,C,P,l=!1,c=D.Private,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${C} on local port ${P}.`),!d)return;w||(w="localhost");const s=this.retainOrCreateTunnel(d,w,C,P,l,c,f);return s?s.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,C);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(b);return(b.tunnelRemoteHost!==w||b.tunnelRemotePort!==C)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const w=this._tunnels.get(d.tunnelRemoteHost);if(w){const C=w.get(d.tunnelRemotePort);C&&(C.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,C))}}}}async tryDisposeTunnel(d,w,C){if(C.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${w}.`);const P=C.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(w),P}}async closeTunnel(d,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${w} `);const C=this._tunnels.get(d);if(C&&C.has(w)){const P=C.get(w);P.refcount=0,await this.tryDisposeTunnel(d,w,P)}}addTunnelToMap(d,w,C){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(w,{refcount:1,value:C})}async removeEmptyTunnelFromMap(d,w){const C=this._tunnels.get(d);C&&(await C.get(w)||C.delete(w),C.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,w){let C=[d];F(d)?(C.push(...e.LOCALHOST_ADDRESSES),C.push(...e.ALL_INTERFACES_ADDRESSES)):I(d)&&C.push(...e.ALL_INTERFACES_ADDRESSES);const P=C.map(l=>this._tunnels.get(l));for(const l of P){const c=l?.get(w);if(c)return c}}canTunnel(d){return!!R(d)}createWithProvider(d,w,C,P,l,c,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${C} on local port ${P}.`);const b={elevationRequired:l?p(P===void 0?C:P):!1},o={remoteAddress:{host:w,port:C},localAddressPort:P,privacy:c,public:c!==D.Private,protocol:f},i=d.forwardPort(o,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(w,C,i),i}};E=Be([Fe(0,A.ILogService)],E),e.AbstractTunnelService=E}),define(we[198],be([1,0,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(D){return D.scheme!==h.Schemas.file&&D.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=t;function k(D){if(D.folders.length)return D.folders.every(_=>t(_.uri))?D.folders[0].uri:void 0;if(D.configuration&&t(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=k;function A(D){return k(D)?.scheme}e.getVirtualWorkspaceScheme=A;function S(D){return k(D)!==void 0}e.isVirtualWorkspace=S}),define(we[43],be([1,0,165,9,24,23,2,4]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function _(f){const s=f;return typeof s?.id=="string"&&S.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=_;function R(f){if(f.configuration)return{id:f.id,configPath:f.configuration};if(f.folders.length===1)return{id:f.id,uri:f.folders[0].uri}}e.toWorkspaceIdentifier=R;function F(f){const s=f;return typeof s?.id=="string"&&S.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=F;function I(f){const s=f;if(s?.uri)return{id:s.id,uri:S.URI.revive(s.uri)};const b=f;if(b?.configPath)return{id:b.id,configPath:S.URI.revive(b.configPath)};if(f?.id)return{id:f.id}}e.reviveIdentifier=I;var p;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function E(f){const s=f;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function v(f){const s=f;return!!(s&&typeof s=="object"&&S.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=v;class d{constructor(s,b,o,i,r){this._id=s,this._transient=o,this._configuration=i,this._ignorePathCasing=r,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=b}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class w{constructor(s,b){this.raw=b,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function C(f){return new w({uri:f,index:0,name:(0,A.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace";const P=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,h.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(f,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(f,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function c(f){return(typeof f=="string"?(0,t.extname)(f):(0,A.extname)(f))===P}e.hasWorkspaceFileExtension=c}),define(we[82],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const A=this._idPool++;return this._data.set(A,k),this.logDebugInfo(),A}get(k,A){return this._data.has(k)?this._data.get(k)[A]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(we[44],be([1,0,10,23,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(D=>{const _=this._providerInfo.get(D.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(D,_){_===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,_)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(we[26],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(we[199],be([1,0,13]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(S,D,_){this._deferredPromises=new Map,this._id=S,this._shared=D,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const I of R.values())I.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(S,D){let _=this._value[S];return typeof _=="undefined"&&(_=D),_}update(S,D){this._value[S]=D;let _=this._deferredPromises.get(S);if(_!==void 0)return _.p;const R=new h.DeferredPromise;return this._deferredPromises.set(S,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class k extends t{constructor(S,D){super(S.identifier.value,!0,D);this._extension=S}setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}}e.ExtensionGlobalMemento=k}),define(we[200],be([1,0,3,2,11]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(_.value,R)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(D));R.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};A=Be([Fe(0,k.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[14],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[201],be([1,0,27,3]),function(te,e,h,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,_){k.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(D.identifier),Ke(this,k,_,"f"),Pe(this,k,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(D){return Pe(this,k,"f").get(this._id,D)}store(D,_){return Pe(this,k,"f").store(this._id,D,_)}delete(D){return Pe(this,k,"f").delete(this._id,D)}}e.ExtensionSecrets=A,k=new WeakMap}),define(we[124],be([1,0,4,3]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(S){this._level=S}$onDidChangeTelemetryLevel(S){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=S,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(we[63],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,k=(P,l)=>{const c={controllerId:l};return t.set(P,c),c};e.createPrivateApiFor=k;const A=P=>t.get(P);e.getPrivateApiFor=A;const S=(P,l,c,f)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(b){if(!f(s,b)){const o=s;s=b,P.listener?.({op:3,key:l,value:b,previous:o})}}}},D=(P,l)=>P===l,_={range:(P,l)=>P===l?!0:!P||!l?!1:P.isEqual(l),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(P,l)=>!(P.length!==l.length||P.some(c=>!l.find(f=>c.id===f.id)))},R=Object.keys(_),F=(P,l)=>({range:S(P,"range",void 0,_.range),label:S(P,"label",l,_.label),description:S(P,"description",void 0,_.description),sortText:S(P,"sortText",void 0,_.sortText),canResolveChildren:S(P,"canResolveChildren",!1,_.canResolveChildren),busy:S(P,"busy",!1,_.busy),error:S(P,"error",void 0,_.error),tags:S(P,"tags",[],_.tags)}),I=(P,l)=>{const c=new Map;for(const f of R)_[f](P[f],l[f])||c.set(f,l[f]);return c};e.diffTestItems=I;class p extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=p;class E extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class v extends Error{constructor(l,c,f){super(`TestItem with ID "${l}" is from controller "${c}" and cannot be added as a child of an item from controller "${f}".`)}}e.MixedTestItemController=v;const d=P=>{const l=(0,e.getPrivateApiFor)(P);let c=new Map;return{get size(){return c.size},forEach(f,s){for(const b of c.values())f.call(s,b,this)},replace(f){const s=new Map,b=new Set(c.keys()),o={op:4,ops:[]};for(const i of f){if(!(i instanceof w))throw new E(i.id);const r=(0,e.getPrivateApiFor)(i).controllerId;if(r!==l.controllerId)throw new v(i.id,r,l.controllerId);if(s.has(i.id))throw new p(i.id);s.set(i.id,i),b.delete(i.id),o.ops.push({op:0,item:i})}for(const i of b.keys())o.ops.push({op:1,id:i});l.listener?.(o),c=s},add(f){if(!(f instanceof w))throw new E(f.id);c.set(f.id,f),l.listener?.({op:0,item:f})},delete(f){c.delete(f)&&l.listener?.({op:1,id:f})},get(f){return c.get(f)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class w{constructor(l,c,f,s){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const b=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof C?void 0:b.parent}},children:{value:d(this),enumerable:!0,writable:!1},...F(b,f)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class C extends w{constructor(l,c){super(l,l,c,void 0)}}e.TestItemRootImpl=C}),define(we[51],be([1,0,4,123,3,14]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(_){function R(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:I.protocol}}_.fromApiTunnel=R;function F(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==t.TunnelPrivacyId.ConstantPrivate&&I.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}_.fromServiceTunnel=F})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let D=class{constructor(R){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,I,p,E){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=Be([Fe(0,A.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[7],be([1,0,17,16,99,24,92,8,18,2,33,42,120]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";var E,v,d,w,C,P,l,c,f,s,b,o,i,r,n,a,g,u,m,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(Q){function V(){return Reflect.construct(Q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(Q,"name")),Object.setPrototypeOf(V,Q),Object.setPrototypeOf(V.prototype,Q.prototype),V}let L=C=class{constructor(V){E.set(this,void 0),Ke(this,E,V,"f")}static from(...V){let ce=V;return new C(function(){if(ce){for(const De of ce)De&&typeof De.dispose=="function"&&De.dispose();ce=void 0}})}dispose(){typeof Pe(this,E,"f")=="function"&&(Pe(this,E,"f").call(this),Ke(this,E,void 0,"f"))}};E=new WeakMap,L=C=Be([O],L),e.Disposable=L;let y=P=class{constructor(V,ce){if(V<0)throw(0,t.illegalArgument)("line must be non-negative");if(ce<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=V,this._character=ce}static Min(...V){if(V.length===0)throw new TypeError;let ce=V[0];for(let De=1;De<V.length;De++){const qe=V[De];qe.isBefore(ce)&&(ce=qe)}return ce}static Max(...V){if(V.length===0)throw new TypeError;let ce=V[0];for(let De=1;De<V.length;De++){const qe=V[De];qe.isAfter(ce)&&(ce=qe)}return ce}static isPosition(V){if(!V)return!1;if(V instanceof P)return!0;let{line:ce,character:De}=V;return typeof ce=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,ce=0){if(V===null||ce===null)throw(0,t.illegalArgument)();let De;return typeof V=="undefined"?De=0:typeof V=="number"?De=V:(De=typeof V.lineDelta=="number"?V.lineDelta:0,ce=typeof V.characterDelta=="number"?V.characterDelta:0),De===0&&ce===0?this:new P(this.line+De,this.character+ce)}with(V,ce=this.character){if(V===null||ce===null)throw(0,t.illegalArgument)();let De;return typeof V=="undefined"?De=this.line:typeof V=="number"?De=V:(De=typeof V.line=="number"?V.line:this.line,ce=typeof V.character=="number"?V.character:this.character),De===this.line&&ce===this.character?this:new P(De,ce)}toJSON(){return{line:this.line,character:this.character}}};y=P=Be([O],y),e.Position=y;let H=l=class{constructor(V,ce,De,qe){let Xe,Ze;if(typeof V=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new y(V,ce),Ze=new y(De,qe)):V instanceof y&&ce instanceof y&&(Xe=V,Ze=ce),!Xe||!Ze)throw new Error("Invalid arguments");Xe.isBefore(Ze)?(this._start=Xe,this._end=Ze):(this._start=Ze,this._end=Xe)}static isRange(V){return V instanceof l?!0:V?y.isPosition(V.start)&&y.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof l?this.contains(V._start)&&this.contains(V._end):V instanceof y?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const ce=y.Max(V.start,this._start),De=y.Min(V.end,this._end);if(!ce.isAfter(De))return new l(ce,De)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ce=y.Min(V.start,this._start),De=y.Max(V.end,this.end);return new l(ce,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,ce=this.end){if(V===null||ce===null)throw(0,t.illegalArgument)();let De;return V?y.isPosition(V)?De=V:(De=V.start||this.start,ce=V.end||this.end):De=this.start,De.isEqual(this._start)&&ce.isEqual(this.end)?this:new l(De,ce)}toJSON(){return[this.start,this.end]}};H=l=Be([O],H),e.Range=H;let M=c=class extends H{constructor(V,ce,De,qe){let Xe,Ze;if(typeof V=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new y(V,ce),Ze=new y(De,qe)):V instanceof y&&ce instanceof y&&(Xe=V,Ze=ce),!Xe||!Ze)throw new Error("Invalid arguments");super(Xe,Ze);this._anchor=Xe,this._active=Ze}static isSelection(V){return V instanceof c?!0:V?H.isRange(V)&&y.isPosition(V.anchor)&&y.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=c=Be([O],M),e.Selection=M;class z{constructor(V,ce,De){if(typeof V!="string"||V.length===0)throw(0,t.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,t.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,t.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(ce),this.connectionToken=De}}e.ResolvedAuthority=z;class x extends Error{constructor(V,ce=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(V);this._message=V,this._code=ce,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(V,ce){return new x(V,p.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(V){return new x(V,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var K;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var B;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=f=class{constructor(V,ce){this._range=V,this._newText=ce}static isTextEdit(V){return V instanceof f?!0:V?H.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ce){return new f(V,ce)}static insert(V,ce){return f.replace(new H(V,V),ce)}static delete(V){return f.replace(V,"")}static setEndOfLine(V){const ce=new f(new H(new y(0,0),new y(0,0)),"");return ce.newEol=V,ce}get range(){return this._range}set range(V){if(V&&!H.isRange(V))throw(0,t.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,t.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,t.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=f=Be([O],G),e.TextEdit=G;var X;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace"})(X=e.FileEditType||(e.FileEditType={}));let q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,ce,De,qe){this._edits.push({_type:1,from:V,to:ce,options:De,metadata:qe})}createFile(V,ce,De){this._edits.push({_type:1,from:void 0,to:V,options:ce,metadata:De})}deleteFile(V,ce,De){this._edits.push({_type:1,from:V,to:void 0,options:ce,metadata:De})}replaceNotebookMetadata(V,ce,De){this._edits.push({_type:3,metadata:De,uri:V,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(V,ce,De,qe,Xe){let Ze,nt,yt=[],At;if(Qt.isNotebookRange(ce)&&Ht.isNotebookCellDataArray(De)&&!Ht.isNotebookCellDataArray(qe)?(Ze=ce.start,nt=ce.end,yt=De,At=qe):typeof ce=="number"&&typeof De=="number"&&Ht.isNotebookCellDataArray(qe)&&(Ze=ce,nt=De,yt=qe,At=Xe),Ze===void 0||nt===void 0)throw new Error("Invalid arguments");(Ze!==nt||yt.length>0)&&this._edits.push({_type:5,uri:V,index:Ze,count:nt-Ze,cells:yt,metadata:At})}replaceNotebookCellMetadata(V,ce,De,qe){this._edits.push({_type:3,metadata:qe,uri:V,edit:{editType:8,index:ce,metadata:De}})}replace(V,ce,De,qe){this._edits.push({_type:2,uri:V,edit:new G(ce,De),metadata:qe})}insert(V,ce,De,qe){this.replace(V,new H(ce,ce),De,qe)}delete(V,ce,De){this.replace(V,ce,"",De)}has(V){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===V.toString())}set(V,ce){if(ce)for(const De of ce)De&&this._edits.push({_type:2,uri:V,edit:De});else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];qe._type===2&&qe.uri.toString()===V.toString()&&(this._edits[De]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(V){const ce=[];for(let De of this._edits)De._type===2&&De.uri.toString()===V.toString()&&ce.push(De.edit);return ce}entries(){const V=new A.ResourceMap;for(let ce of this._edits)if(ce._type===2){let De=V.get(ce.uri);De||(De=[ce.uri,[]],V.set(ce.uri,De)),De[1].push(ce.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};q=Be([O],q),e.WorkspaceEdit=q;let ee=s=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof s?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=s._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ce=this._tabstop++){if(typeof V=="function"){const De=new s;De._tabstop=this._tabstop,V(De),this._tabstop=De._tabstop,V=De.value}else V=s._escape(V);return this.value+="${",this.value+=ce,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ce=this._tabstop++){const De=V.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(V,ce){if(typeof ce=="function"){const De=new s;De._tabstop=this._tabstop,ce(De),this._tabstop=De._tabstop,ce=De.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ee=s=Be([O],ee),e.SnippetString=ee;var ae;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(ae=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=b=class{constructor(V,ce){if(this.uri=V,ce)if(ce instanceof H)this.range=ce;else if(ce instanceof y)this.range=new H(ce,ce);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof b?!0:V?H.isRange(V.range)&&R.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=b=Be([O],Z),e.Location=Z;let Y=class{constructor(V,ce){this.location=V,this.message=ce}static is(V){return V?typeof V.message=="string"&&V.location&&H.isRange(V.location.range)&&R.URI.isUri(V.location.uri):!1}static isEqual(V,ce){return V===ce?!0:!V||!ce?!1:V.message===ce.message&&V.location.range.isEqual(ce.location.range)&&V.location.uri.toString()===ce.location.uri.toString()}};Y=Be([O],Y),e.DiagnosticRelatedInformation=Y;let se=class{constructor(V,ce,De=ue.Error){if(!H.isRange(V))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=V,this.message=ce,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ce){return V===ce?!0:!V||!ce?!1:V.message===ce.message&&V.severity===ce.severity&&V.code===ce.code&&V.severity===ce.severity&&V.source===ce.source&&V.range.isEqual(ce.range)&&(0,h.equals)(V.tags,ce.tags)&&(0,h.equals)(V.relatedInformation,ce.relatedInformation,Y.isEqual)}};se=Be([O],se),e.Diagnostic=se;let de=class{constructor(V,ce){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ce}};de=Be([O],de),e.Hover=de;var ve;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(V,ce=ve.Text){this.range=V,this.kind=ce}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Te=Be([O],Te),e.DocumentHighlight=Te;var Me;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Me=e.SymbolKind||(e.SymbolKind={}));var _e;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(_e=e.SymbolTag||(e.SymbolTag={}));let Ee=o=class{constructor(V,ce,De,qe,Xe){this.name=V,this.kind=ce,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),qe instanceof Z?this.location=qe:De instanceof H&&(this.location=new Z(qe,De)),o.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};Ee=o=Be([O],Ee),e.SymbolInformation=Ee;let $=i=class{constructor(V,ce,De,qe,Xe){this.name=V,this.detail=ce,this.kind=De,this.range=qe,this.selectionRange=Xe,this.children=[],i.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(i.validate)}};$=i=Be([O],$),e.DocumentSymbol=$;var U;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(U=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(V,ce){this.title=V,this.kind=ce}};N=Be([O],N),e.CodeAction=N;let W=r=class{constructor(V){this.value=V}append(V){return new r(this.value?this.value+r.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+r.sep)}};W.sep=".",W=r=Be([O],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let j=class{constructor(V,ce){if(this.range=V,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=Be([O],j),e.SelectionRange=j;class re{constructor(V,ce,De,qe,Xe,Ze){this.kind=V,this.name=ce,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(V,ce){this.fromRanges=ce,this.from=V}}e.CallHierarchyIncomingCall=he;class Ce{constructor(V,ce){this.fromRanges=ce,this.to=V}}e.CallHierarchyOutgoingCall=Ce;var Ae;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(V,ce){this.range=V,this.command=ce}get isResolved(){return!!this.command}};We=Be([O],We),e.CodeLens=We;let ze=n=class{constructor(V,ce=!1){v.set(this,void 0),Ke(this,v,new k.MarkdownString(V,{supportThemeIcons:ce}),"f")}static isMarkdownString(V){return V instanceof n?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Pe(this,v,"f").value}set value(V){Pe(this,v,"f").value=V}get isTrusted(){return Pe(this,v,"f").isTrusted}set isTrusted(V){Pe(this,v,"f").isTrusted=V}get supportThemeIcons(){return Pe(this,v,"f").supportThemeIcons}set supportThemeIcons(V){Pe(this,v,"f").supportThemeIcons=V}get supportHtml(){return Pe(this,v,"f").supportHtml}set supportHtml(V){Pe(this,v,"f").supportHtml=V}get baseUri(){return Pe(this,v,"f").baseUri}set baseUri(V){Pe(this,v,"f").baseUri=V}appendText(V){return Pe(this,v,"f").appendText(V),this}appendMarkdown(V){return Pe(this,v,"f").appendMarkdown(V),this}appendCodeblock(V,ce){return Pe(this,v,"f").appendCodeblock(ce??"",V),this}};v=new WeakMap,ze=n=Be([O],ze),e.MarkdownString=ze;let je=class{constructor(V,ce){this.label=V,this.documentation=ce}};je=Be([O],je),e.ParameterInformation=je;let $e=class{constructor(V,ce){this.label=V,this.documentation=ce,this.parameters=[]}};$e=Be([O],$e),e.SignatureInformation=$e;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([O],Ue),e.SignatureHelp=Ue;var Qe;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(Q){Q[Q.Other=0]="Other",Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Re=class{constructor(V){this.value=V}};Re=Be([O],Re),e.InlayHintLabelPart=Re;let tt=class{constructor(V,ce,De){this.position=V,this.label=ce,this.kind=De}};tt=Be([O],tt),e.InlayHint=tt;var ne;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(V,ce){this.label=V,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([O],pe),e.CompletionItem=pe;let Se=class{constructor(V=[],ce=!1){this.items=V,this.isIncomplete=ce}};Se=Be([O],Se),e.CompletionList=Se;let Ne=class{constructor(V,ce,De){this.text=V,this.range=ce,this.command=De}};Ne=Be([O],Ne),e.InlineSuggestion=Ne;let He=class{constructor(V){this.items=V}};He=Be([O],He),e.InlineSuggestions=He;var Ye;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var st;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var mt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(mt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(Ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ot;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var it;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(it=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(Q){function V(ce){switch(ce){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=V}(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor(V,ce){if(ce&&!R.URI.isUri(ce))throw(0,t.illegalArgument)("target");if(!H.isRange(V)||V.isEmpty)throw(0,t.illegalArgument)("range");this.range=V,this.target=ce}};lt=Be([O],lt),e.DocumentLink=lt;let Rt=class{constructor(V,ce,De,qe){this.red=V,this.green=ce,this.blue=De,this.alpha=qe}};Rt=Be([O],Rt),e.Color=Rt;let It=class{constructor(V,ce){if(ce&&!(ce instanceof Rt))throw(0,t.illegalArgument)("color");if(!H.isRange(V)||V.isEmpty)throw(0,t.illegalArgument)("range");this.range=V,this.color=ce}};It=Be([O],It),e.ColorInformation=It;let kt=class{constructor(V){if(!V||typeof V!="string")throw(0,t.illegalArgument)("label");this.label=V}};kt=Be([O],kt),e.ColorPresentation=kt;var dt;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(V,ce,De){if(this.startIndex=V,this.length=ce,this.tooltip=De,typeof V!="number"||V<0)throw(0,t.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,t.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(V){this.options=V,typeof V!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=fe;var Ie;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(Ie=e.TaskRevealKind||(e.TaskRevealKind={}));var ge;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ge=e.TaskPanelKind||(e.TaskPanelKind={}));let ie=a=class{constructor(V,ce){if(this.label=ce,typeof V!="string"||typeof ce!="string")throw(0,t.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};ie.Clean=new a("clean","Clean"),ie.Build=new a("build","Build"),ie.Rebuild=new a("rebuild","Rebuild"),ie.Test=new a("test","Test"),ie=a=Be([O],ie),e.TaskGroup=ie;function ye(Q){let V="";for(let ce=0;ce<Q.length;ce++)V+=Q[ce].replace(/,/g,",,")+",";return V}let Le=class{constructor(V,ce,De){if(typeof V!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=V,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=De):this._options=ce)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,t.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)V.push(ce);return ye(V)}};Le=Be([O],Le),e.ProcessExecution=Le;let xe=class{constructor(V,ce,De){if(this._args=[],Array.isArray(ce)){if(!V)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,t.illegalArgument)("command");this._command=V,this._args=ce,this._options=De}else{if(typeof V!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=V,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,t.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)V.push(typeof ce=="string"?ce:ce.value);return ye(V)}};xe=Be([O],xe),e.ShellExecution=xe;var Ge;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(Ge=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class vt{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=vt;let St=g=class{constructor(V,ce,De,qe,Xe,Ze){this.__deprecated=!1,this._definition=this.definition=V;let nt;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=De,this.execution=qe,nt=Xe,this.__deprecated=!0):ce===ct.Global||ce===ct.Workspace?(this.target=ce,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,nt=Ze):(this.target=ce,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,nt=Ze),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const ce=this._definition.type;(g.EmptyType===ce||g.ProcessType===ce||g.ShellType===ce||g.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};St.ExtensionCallbackType="customExecution",St.ProcessType="process",St.ShellType="shell",St.EmptyType="$empty",St=g=Be([O],St),e.Task=St;var Et;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(V,ce=ut.None){this.collapsibleState=ce,R.URI.isUri(V)?this.resourceUri=V:this.label=V}};rt=Be([O],rt),e.TreeItem=rt;var ut;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(V){this.value=V}async asString(){return JSON.stringify(this.value)}};wt=Be([O],wt),e.TreeDataTransferItem=wt;let Nt=class{constructor(){this._items=new Map}get(V){return this._items.get(V)}set(V,ce){this._items.set(V,ce)}forEach(V){this._items.forEach(V)}};Nt=Be([O],Nt),e.TreeDataTransfer=Nt;let ht=class{constructor(V,ce){this.id=V,this.color=ce}};ht=Be([O],ht),e.ThemeIcon=ht,ht.File=new ht("file"),ht.Folder=new ht("folder");let Pt=class{constructor(V){this.id=V}};Pt=Be([O],Pt),e.ThemeColor=Pt;var Ut;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(V,ce){if(typeof V!="string"&&(!V||!R.URI.isUri(V)&&!R.URI.isUri(V.uri)))throw(0,t.illegalArgument)("base");if(typeof ce!="string")throw(0,t.illegalArgument)("pattern");typeof V=="string"?this.baseUri=R.URI.file(V):R.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ce}get base(){return this._base}set base(V){this._base=V,this._baseUri=R.URI.file(V)}get baseUri(){return this._baseUri}set baseUri(V){this._baseUri=V,this._base=V.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([O],Ct),e.RelativePattern=Ct;let Bt=class{constructor(V,ce,De,qe){this.enabled=typeof V=="boolean"?V:!0,typeof ce=="string"&&(this.condition=ce),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([O],Bt),e.Breakpoint=Bt;let xt=class extends Bt{constructor(V,ce,De,qe,Xe){super(ce,De,qe,Xe);if(V===null)throw(0,t.illegalArgument)("location");this.location=V}};xt=Be([O],xt),e.SourceBreakpoint=xt;let gt=class extends Bt{constructor(V,ce,De,qe,Xe){super(ce,De,qe,Xe);this.functionName=V}};gt=Be([O],gt),e.FunctionBreakpoint=gt;let ei=class extends Bt{constructor(V,ce,De,qe,Xe,Ze,nt){super(qe,Xe,Ze,nt);if(!ce)throw(0,t.illegalArgument)("dataId");this.label=V,this.dataId=ce,this.canPersist=De}};ei=Be([O],ei),e.DataBreakpoint=ei;let Yt=class{constructor(V,ce,De){this.command=V,this.args=ce||[],this.options=De}};Yt=Be([O],Yt),e.DebugAdapterExecutable=Yt;let ti=class{constructor(V,ce){this.port=V,this.host=ce}};ti=Be([O],ti),e.DebugAdapterServer=ti;let oi=class{constructor(V){this.path=V}};oi=Be([O],oi),e.DebugAdapterNamedPipeServer=oi;let Tt=class{constructor(V){this.implementation=V}};Tt=Be([O],Tt),e.DebugAdapterInlineImplementation=Tt;let ii=class{constructor(V,ce){this.range=V,this.expression=ce}};ii=Be([O],ii),e.EvaluatableExpression=ii;var _i;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.Explicit=1]="Explicit"})(_i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Kt=class{constructor(V,ce){this.range=V,this.text=ce}};Kt=Be([O],Kt),e.InlineValueText=Kt;let Xt=class{constructor(V,ce,De=!0){this.range=V,this.variableName=ce,this.caseSensitiveLookup=De}};Xt=Be([O],Xt),e.InlineValueVariableLookup=Xt;let at=class{constructor(V,ce){this.range=V,this.expression=ce}};at=Be([O],at),e.InlineValueEvaluatableExpression=at;let ai=class{constructor(V,ce){this.frameId=V,this.stoppedLocation=ce}};ai=Be([O],ai),e.InlineValueContext=ai;var Vt;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=u=class extends Error{constructor(V,ce=I.FileSystemProviderErrorCode.Unknown,De){super(R.URI.isUri(V)?V.toString(!0):V);this.code=De?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(V){return new u(V,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(V){return new u(V,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(V){return new u(V,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(V){return new u(V,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};jt=u=Be([O],jt),e.FileSystemError=jt;let ni=class{constructor(V,ce,De){this.start=V,this.end=ce,this.kind=De}};ni=Be([O],ni),e.FoldingRange=ni;var Si;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gi;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(gi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ci;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(Ci=e.CommentMode||(e.CommentMode={}));class pi{constructor(V,ce=[]){this.tokenTypes=V,this.tokenModifiers=ce}}e.SemanticTokensLegend=pi;function ri(Q){return typeof Q=="undefined"||(0,_.isStringArray)(Q)}class li{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let ce=0,De=V.tokenTypes.length;ce<De;ce++)this._tokenTypeStrToInt.set(V.tokenTypes[ce],ce);for(let ce=0,De=V.tokenModifiers.length;ce<De;ce++)this._tokenModifierStrToInt.set(V.tokenModifiers[ce],ce)}}push(V,ce,De,qe,Xe){if(typeof V=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(V,ce,De,qe,Xe);if(H.isRange(V)&&typeof ce=="string"&&ri(De))return this._push(V,ce,De);throw(0,t.illegalArgument)()}_push(V,ce,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const qe=V.start.line,Xe=V.start.character,Ze=V.end.character-V.start.character,nt=this._tokenTypeStrToInt.get(ce);let yt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);yt|=1<<Wt>>>0}this._pushEncoded(qe,Xe,Ze,nt,yt)}_pushEncoded(V,ce,De,qe,Xe){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Wt=0;for(let $t=0;$t<yt;$t++){let qt=this._data[5*$t],fi=this._data[5*$t+1];qt===0?(qt=At,fi+=Wt):qt+=At,this._data[5*$t]=qt,this._data[5*$t+1]=fi,At=qt,Wt=fi}}let Ze=V,nt=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Xe,this._prevLine=V,this._prevChar=ce}static _sortAndDeltaEncode(V){let ce=[];const De=V.length/5|0;for(let nt=0;nt<De;nt++)ce[nt]=nt;ce.sort((nt,yt)=>{const At=V[5*nt],Wt=V[5*yt];if(At===Wt){const $t=V[5*nt+1],qt=V[5*yt+1];return $t-qt}return At-Wt});const qe=new Uint32Array(V.length);let Xe=0,Ze=0;for(let nt=0;nt<De;nt++){const yt=5*ce[nt],At=V[yt+0],Wt=V[yt+1],$t=V[yt+2],qt=V[yt+3],fi=V[yt+4],$i=At-Xe,Yi=$i===0?Wt-Ze:Wt,mi=5*nt;qe[mi+0]=$i,qe[mi+1]=Yi,qe[mi+2]=$t,qe[mi+3]=qt,qe[mi+4]=fi,Xe=At,Ze=Wt}return qe}build(V){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),V):new Jt(li._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=li;class Jt{constructor(V,ce){this.resultId=ce,this.data=V}}e.SemanticTokens=Jt;class ci{constructor(V,ce,De){this.start=V,this.deleteCount=ce,this.data=De}}e.SemanticTokensEdit=ci;class yi{constructor(V,ce){this.resultId=ce,this.edits=V}}e.SemanticTokensEdits=yi;var Di;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(Di=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new ht("arrow-left")},zt=Be([O],zt),e.QuickInputButtons=zt;var Ii;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(V,ce,De){this.badge=V,this.tooltip=ce,this.color=De}static validate(V){if(V.badge){let ce=(0,D.nextCharLength)(V.badge,0);if(ce<V.badge.length&&(ce+=(0,D.nextCharLength)(V.badge,ce)),V.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let ui=class{constructor(V){this.kind=V}};ui=Be([O],ui),e.ColorTheme=ui;var di;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(V,ce){if(V<0)throw(0,t.illegalArgument)("start must be positive");if(ce<0)throw(0,t.illegalArgument)("end must be positive");V<=ce?(this._start=V,this._end=ce):(this._start=ce,this._end=V)}static isNotebookRange(V){return V instanceof Qt?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let ce=this._start,De=this._end;return V.start!==void 0&&(ce=V.start),V.end!==void 0&&(De=V.end),ce===this._start&&De===this._end?this:new Qt(ce,De)}}e.NotebookRange=Qt;class Ht{constructor(V,ce,De,qe,Xe,Ze,nt){this.kind=V,this.value=ce,this.languageId=De,this.mime=qe,this.outputs=Xe??[],this.metadata=Ze,this.executionSummary=nt,Ht.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ce=>Ht.isNotebookCellData(ce))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Ht;class Oe{constructor(V){this.cells=V}}e.NotebookData=Oe;class Lt{constructor(V,ce){this.data=V,this.mime=ce;const De=(0,S.normalizeMimeType)(ce,!0);if(!De)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(V){return V instanceof Lt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ce={name:V.name,message:V.message,stack:V.stack};return Lt.json(ce,"application/vnd.code.notebook.error")}static stdout(V){return Lt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Lt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ce="application/octet-stream"){return new Lt(V,ce)}static text(V,ce=S.Mimes.text){const De=Pe(Lt,d,"f",w).encode(String(V));return new Lt(De,ce)}static json(V,ce="application/json"){const De=JSON.stringify(V,void 0,"	");return Lt.text(De,ce)}}e.NotebookCellOutputItem=Lt,d=Lt,w={value:new TextEncoder};class Zt{constructor(V,ce,De){this.items=Zt.ensureUniqueMimeTypes(V,!0),typeof ce=="string"?(this.id=ce,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ce??De)}static isNotebookCellOutput(V){return V instanceof Zt?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,_.isArray)(V.items)}static ensureUniqueMimeTypes(V,ce=!1){const De=new Set,qe=new Set;for(let Xe=0;Xe<V.length;Xe++){const Ze=V[Xe],nt=(0,S.normalizeMimeType)(Ze.mime);if(!De.has(nt)){De.add(nt);continue}qe.add(Xe),ce&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return qe.size===0?V:V.filter((Xe,Ze)=>!qe.has(Ze))}}e.NotebookCellOutput=Zt;var ft;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var Ti;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(Ti=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class wi{constructor(V,ce){this.text=V,this.alignment=ce}}e.NotebookCellStatusBarItem=wi;var Ri;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(Ri=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Li{constructor(V,ce=[]){this.uri=V,this.provides=(0,h.asArray)(ce)}}e.NotebookRendererScript=Li;let hi=class{constructor(V,ce){this.label=V,this.timestamp=ce}};hi=Be([O],hi),e.TimelineItem=hi;var Oi;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var bi;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(bi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fi;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Fi=e.StandardTokenType||(e.StandardTokenType={}));class Ni{constructor(V,ce){this.ranges=V,this.wordPattern=ce}}e.LinkedEditingRanges=Ni;class Mi{constructor(V,ce){this._port=V,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Ui;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(Ui=e.TestResultState||(e.TestResultState={}));var Bi;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Bi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let le=class{constructor(V=void 0,ce=void 0,De=void 0){this.include=V,this.exclude=ce,this.profile=De}};le=Be([O],le),e.TestRunRequest=le;let me=m=class{constructor(V){this.message=V}static diff(V,ce,De){const qe=new m(V);return qe.expectedOutput=ce,qe.actualOutput=De,qe}};me=m=Be([O],me),e.TestMessage=me;let ke=class{constructor(V){this.id=V}};ke=Be([O],ke),e.TestTag=ke;let Je=class{constructor(V,ce){this.covered=V,this.total=ce}};Je=Be([O],Je),e.CoveredCount=Je;let bt=T=class{constructor(V,ce,De,qe){this.uri=V,this.statementCoverage=ce,this.branchCoverage=De,this.functionCoverage=qe}static fromDetails(V,ce){const De=new Je(0,0),qe=new Je(0,0),Xe=new Je(0,0);for(const nt of ce)if("branches"in nt){De.total+=1,De.covered+=nt.executionCount>0?1:0;for(const yt of nt.branches)qe.total+=1,qe.covered+=yt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=nt.executionCount>0?1:0;const Ze=new T(V,De,qe.total>0?qe:void 0,Xe.total>0?Xe:void 0);return Ze.detailedCoverage=ce,Ze}};bt=T=Be([O],bt),e.FileCoverage=bt;let Dt=class{constructor(V,ce,De=[]){this.executionCount=V,this.location=ce,this.branches=De}};Dt=Be([O],Dt),e.StatementCoverage=Dt;let Wi=class{constructor(V,ce){this.executionCount=V,this.location=ce}};Wi=Be([O],Wi),e.BranchCoverage=Wi;let zi=class{constructor(V,ce){this.executionCount=V,this.location=ce}};zi=Be([O],zi),e.FunctionCoverage=zi;var Gi;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(V,ce,De,qe,Xe,Ze){this.kind=V,this.name=ce,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.TypeHierarchyItem=Qi}),define(we[125],be([1,0,55,10,8,151,107,7,17]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(v,d){d?R.set(v,d):R.delete(v)}e.setWordDefinitionFor=F;function I(v){return R.get(v)}e.getWordDefinitionFor=I;class p extends A.MirrorTextModel{constructor(d,w,C,P,l,c,f,s){super(w,C,P,l);this._proxy=d,this._languageId=c,this._isDirty=f,this._notebook=s,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,_.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===t.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(w){return w?d._getTextInRange(w):d.getText()},get eol(){return d._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(w){return d._lineAt(w)},offsetAt(w){return d._offsetAt(w)},positionAt(w){return d._positionAt(w)},validateRange(w){return d._validateRange(w)},validatePosition(w){return d._validatePosition(w)},getWordRangeAtPosition(w,C){return d._getWordRangeAtPosition(w,C)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,h.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,h.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const w=this._validateRange(d);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const C=this._eol,P=w.start.line,l=w.end.line,c=[];c.push(this._lines[P].substring(w.start.character));for(let f=P+1;f<l;f++)c.push(this._lines[f]);return c.push(this._lines[l].substring(0,w.end.character)),c.join(C)}_lineAt(d){let w;if(d instanceof D.Position?w=d.line:typeof d=="number"&&(w=d),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new E(w,this._lines[w],w===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(d),C=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,C))}_validateRange(d){if(!(d instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(d.start),C=this._validatePosition(d.end);return w===d.start&&C===d.end?d:new D.Range(w.line,w.character,C.line,C.character)}_validatePosition(d){if(!(d instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:w,character:C}=d,P=!1;if(w<0)w=0,C=0,P=!0;else if(w>=this._lines.length)w=this._lines.length-1,C=this._lines[w].length,P=!0;else{const l=this._lines[w].length;C<0?(C=0,P=!0):C>l&&(C=l,P=!0)}return P?new D.Position(w,C):d}_getWordRangeAtPosition(d,w){const C=this._validatePosition(d);if(!w)w=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const P=(0,S.getWordAtText)(C.character+1,(0,S.ensureValidWordDefinition)(w),this._lines[C.line],0);if(P)return new D.Range(C.line,P.startColumn-1,C.line,P.endColumn-1)}}e.ExtHostDocumentData=p;class E{constructor(d,w,C){this._line=d,this._text=w,this._isLastLine=C}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(we[202],be([1,0,7,3,110,6,108,24,2,33]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(p,E,v,d){this._notebook=v,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(C=>{const P=this._cellUris.get(C.document.uri);P!==void 0&&(this._cellLengths.setValue(P,this._cells[P].document.getText().length+1),this._cellLines.setValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=C=>{C===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(p.onDidChangeNotebookCells(C=>w(C.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const p=[],E=[];for(const v of this._notebook.getCells())v.kind===h.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,v.document.uri,v.document.languageId,!0))&&(this._cellUris.set(v.document.uri,this._cells.length),this._cells.push(v),p.push(v.document.getText().length+1),E.push(v.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(p)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(p){if(!p){let P="";for(const l of this._cells)P+=l.document.getText()+`
`;return P=P.slice(0,-1),P}if(p.isEmpty)return"";const E=this.locationAt(p.start),v=this.locationAt(p.end),d=this._cellUris.get(E.uri),w=this._cellUris.get(v.uri);if(d===void 0||w===void 0)return"";if(d===w)return this._cells[d].document.getText(new h.Range(E.range.start,v.range.end));const C=[this._cells[d].document.getText(new h.Range(E.range.start,new h.Position(this._cells[d].document.lineCount,0)))];for(let P=d+1;P<w;P++)C.push(this._cells[P].document.getText());return C.push(this._cells[w].document.getText(new h.Range(new h.Position(0,0),v.range.end))),C.join(`
`)}offsetAt(p){const E=this._cellLines.getIndexOf(p.line),v=this._cellLengths.getPrefixSum(E.index-1),d=this._cells[E.index].document.offsetAt(p.with(E.remainder));return v+d}positionAt(p){if(typeof p=="number"){const v=this._cellLengths.getIndexOf(p),d=this._cellLines.getPrefixSum(v.index-1);return this._cells[v.index].document.positionAt(v.remainder).translate(d)}const E=this._cellUris.get(p.uri);if(E!==void 0){const v=this._cellLines.getPrefixSum(E-1);return new h.Position(v+p.range.start.line,p.range.start.character)}return new h.Position(0,0)}locationAt(p){h.Range.isRange(p)||(p=new h.Range(p,p));const E=this._cellLines.getIndexOf(p.start.line);let v=E;p.isEmpty||(v=this._cellLines.getIndexOf(p.end.line));const d=new h.Position(E.remainder,p.start.character),w=new h.Position(v.remainder,p.end.character),C=new h.Range(d,w),P=this._cells[E.index];return new h.Location(P.document.uri,P.document.validateRange(C))}contains(p){return this._cellUris.has(p)}validateRange(p){const E=this.validatePosition(p.start),v=this.validatePosition(p.end);return p.with(E,v)}validatePosition(p){const E=this._cellLines.getIndexOf(p.line),v=new h.Position(E.remainder,p.character),d=this._cells[E.index].document.validatePosition(v),w=this._cellLines.getPrefixSum(E.index-1);return new h.Position(w+d.line,d.character)}}e.ExtHostNotebookConcatDocument=F}),define(we[203],be([1,0,7,14,3]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?h.ColorThemeKind.Light:D==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[64],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=t}),define(we[204],be([1,0,22]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(_){let R=this.buffers.indexOf(_);return R<0&&(R=this.buffers.length,this.buffers.push(_)),R}}function k(D,_){if(_.serializeBuffersForPostMessage){const R=new t,F=(E,v)=>{if(v instanceof ArrayBuffer){const d=R.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const w=R.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},I=JSON.stringify(D,F),p=R.buffers.map(E=>{const v=new Uint8Array(E);return h.VSBuffer.wrap(v)});return{message:I,buffers:p}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=k;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,_){const R=_.map(p=>{const E=new ArrayBuffer(p.byteLength);return new Uint8Array(E).set(p.buffer),E}),F=_.length?(p,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:d}=v,w=R[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(w,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return E}:void 0;return{message:JSON.parse(D,F),arrayBuffers:R}}e.deserializeWebviewMessage=S}),define(we[205],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(t){function k(S){const D=new Map;return S.types.forEach((_,R)=>{D.set(_,{asString:async()=>S.items[R].asString,value:void 0})}),D}t.toITreeDataTransfer=k;async function A(S){const D={types:[],items:[]},_=Array.from(S.entries());for(const R of _)D.types.push(R[0]),D.items.push({asString:await R[1].asString()});return D}t.toTreeDataTransferDTO=A})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[206],be([1,0,101]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:A,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function k(A){return new h.URITransformer(t(A))}e.createURITransformer=k}),define(we[207],be([1,0,175,18,2,6,4,50,42,17,10]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(z){z[z.API=1]="API",z[z.USER=2]="USER",z[z.EDIT=3]="EDIT",z[z.NAVIGATION=4]="NAVIGATION"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(z){z[z.IDENTICAL=1]="IDENTICAL",z[z.SIMILAR=2]="SIMILAR",z[z.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(z){const x=z;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=E;function v(z,x,K){for(const B of K.visibleEditorPanes)if(B.group.id===x&&z.matches(B.input))return B.getViewState()}e.findViewStateForEditor=v;function d(z){if(b(z))return!1;const x=z;return k.URI.isUri(x?.resource)}e.isResourceEditorInput=d;function w(z){if(b(z))return!1;const x=z;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=w;function C(z){if(b(z)||w(z))return!1;const x=z;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=C;function P(z){if(b(z))return!1;const x=z;return x?x.resource===void 0||x.resource.scheme===F.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;var l;(function(z){z[z.SHORT=0]="SHORT",z[z.MEDIUM=1]="MEDIUM",z[z.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var c;(function(z){z[z.EXPLICIT=1]="EXPLICIT",z[z.AUTO=2]="AUTO",z[z.FOCUS_CHANGE=3]="FOCUS_CHANGE",z[z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));var f;(function(z){z[z.None=0]="None",z[z.Readonly=2]="Readonly",z[z.Untitled=4]="Untitled",z[z.Singleton=8]="Singleton",z[z.RequiresTrust=16]="RequiresTrust",z[z.CanSplitInGroup=32]="CanSplitInGroup",z[z.ForceDescription=64]="ForceDescription"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends A.Disposable{}e.AbstractEditorInput=s;function b(z){return z instanceof s}e.isEditorInput=b;function o(z){const x=z;return k.URI.isUri(x?.preferredResource)}function i(z){const x=z;return b(x?.primary)&&b(x?.secondary)}e.isSideBySideEditorInput=i;function r(z){const x=z;return b(x?.modified)&&b(x?.original)}e.isDiffEditorInput=r;function n(z){return b(z?.editor)}e.isEditorInputWithOptions=n;function a(z){const x=z;return n(z)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function g(z){const x=z;return typeof x?.groupId=="number"&&b(x.editor)}e.isEditorIdentifier=g;var u;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.REPLACE=1]="REPLACE",z[z.MOVE=2]="MOVE",z[z.UNPIN=3]="UNPIN"})(u=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(z){z[z.GROUP_ACTIVE=0]="GROUP_ACTIVE",z[z.GROUP_INDEX=1]="GROUP_INDEX",z[z.GROUP_LOCKED=2]="GROUP_LOCKED",z[z.EDITOR_OPEN=3]="EDITOR_OPEN",z[z.EDITOR_CLOSE=4]="EDITOR_CLOSE",z[z.EDITOR_MOVE=5]="EDITOR_MOVE",z[z.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",z[z.EDITOR_LABEL=7]="EDITOR_LABEL",z[z.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",z[z.EDITOR_PIN=9]="EDITOR_PIN",z[z.EDITOR_STICKY=10]="EDITOR_STICKY",z[z.EDITOR_DIRTY=11]="EDITOR_DIRTY",z[z.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(m=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(z){z[z.PRIMARY=1]="PRIMARY",z[z.SECONDARY=2]="SECONDARY",z[z.BOTH=3]="BOTH",z[z.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(x,K){if(!x)return;if(K?.supportSideBySide){const{primary:G,secondary:X}=this.getSideEditors(x);if(G&&X){if(K?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:K.filterByScheme}),secondary:this.getOriginalUri(X,{filterByScheme:K.filterByScheme})};if(K?.supportSideBySide===T.ANY)return this.getOriginalUri(G,{filterByScheme:K.filterByScheme})??this.getOriginalUri(X,{filterByScheme:K.filterByScheme});x=K.supportSideBySide===T.PRIMARY?G:X}}if(w(x)||C(x))return;const B=o(x)?x.preferredResource:x.resource;return!B||!K||!K.filterByScheme?B:this.filterUri(B,K.filterByScheme)}getSideEditors(x){return i(x)||C(x)?{primary:x.primary,secondary:x.secondary}:r(x)||w(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,K){if(!x)return;if(K?.supportSideBySide){const{primary:G,secondary:X}=this.getSideEditors(x);if(G&&X){if(K?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:K.filterByScheme}),secondary:this.getCanonicalUri(X,{filterByScheme:K.filterByScheme})};if(K?.supportSideBySide===T.ANY)return this.getCanonicalUri(G,{filterByScheme:K.filterByScheme})??this.getCanonicalUri(X,{filterByScheme:K.filterByScheme});x=K.supportSideBySide===T.PRIMARY?G:X}}if(w(x)||C(x))return;const B=x.resource;return!B||!K||!K.filterByScheme?B:this.filterUri(B,K.filterByScheme)}filterUri(x,K){if(Array.isArray(K)){if(K.some(B=>x.scheme===B))return x}else if(K===x.scheme)return x}}e.EditorResourceAccessor=new O;var L;(function(z){z[z.LEFT=0]="LEFT",z[z.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const K=this.instantiationService=x.get(S.IInstantiationService);for(const[B,G]of this.editorSerializerConstructors)this.createEditorSerializer(B,G,K);this.editorSerializerConstructors.clear()}createEditorSerializer(x,K,B){const G=B.createInstance(K);this.editorSerializerInstances.set(x,G)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,K){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,K,this.instantiationService):this.editorSerializerConstructors.set(x,K),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new y);async function H(z,x){if(!z||!z.length)return[];const K=await Promise.all(z.map(async B=>{const G=k.URI.revive(B.fileUri);if(!G||!await x.canHandleResource(G))return;let q=B.exists,ee=B.type;if(typeof q!="boolean"||typeof ee!="number")try{ee=(await x.resolve(G)).isDirectory?_.FileType.Directory:_.FileType.Unknown,q=!0}catch{q=!1}if(!q&&B.openOnlyIfExists||ee===_.FileType.Directory)return;const ae={selection:q?B.selection:void 0,pinned:!0,override:B.editorOverrideId};let ue;return q?ue={resource:G,options:ae}:ue={resource:G,options:ae,forceUntitled:!0},ue}));return(0,R.coalesce)(K)}e.pathsToEditors=H;var M;(function(z){z[z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",z[z.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[83],be([1,0,10,2]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(D,_){return D.scheme===h.Schemas.http||D.scheme===h.Schemas.https?D:(_&&_.authority&&_.isRemote&&D.scheme===h.Schemas.file&&(D=t.URI.from({scheme:h.Schemas.vscodeRemote,authority:_.authority,path:D.path})),t.URI.from({scheme:h.Schemas.https,authority:`${D.scheme}+${A(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=k;function A(D){return D.replace(/./g,_=>{const R=_.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?_:"-"+R.toString(16).padStart(4,"0")})}function S(D){return D.replace(/-([0-9a-f]{4})/g,(_,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=S}),define(we[208],be([1,0,3,6,83]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(D,_,R){this._proxy=D,this._editors=_,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const F=_.getVisibleTextEditors();for(const I of this._insets.values())F.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,R,F,I){let p;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){p=l;break}if(!p)throw new Error("not a visible editor");const E=this,v=this._handlePool++,d=new h.Emitter,w=new h.Emitter,C=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,k.asWebviewUri)(l,E._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(l){this._options=l,E._proxy.$setOptions(v,l)}get options(){return this._options}set html(l){this._html=l,E._proxy.$setHtml(v,l)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(l){return E._proxy.$postMessage(v,l)}},P=new class{constructor(){this.editor=D,this.line=_,this.height=R,this.webview=C,this.onDidDispose=w.event}dispose(){E._insets.has(v)&&(E._insets.delete(v),E._proxy.$disposeEditorInset(v),w.fire(),w.dispose(),d.dispose())}};return this._proxy.$createEditorInset(v,p.id,p.value.document.uri,_+1,R,F||{},I.identifier,I.extensionLocation),this._insets.set(v,{editor:D,inset:P,onDidReceiveMessage:d}),P}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const R=this._insets.get(D);R&&R.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=A}),define(we[126],be([1,0,3,13,176]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,R,F){const I={command:D};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof F=="number"){const p=setTimeout(()=>{clearTimeout(p);const E=this.pendingRequests.get(I.seq);if(E){this.pendingRequests.delete(I.seq);const v={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,k.localize)(0,null,F,D)};E(v)}},F)}return R&&this.pendingRequests.set(I.seq,R),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,t.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":{const _=D,R=this.pendingRequests.get(_.request_seq);R&&(this.pendingRequests.delete(_.request_seq),R(_));break}}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,R)=>D.set(R,_)),await(0,t.timeout)(500),D.forEach((_,R)=>{_({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[209],be([1,0,177,62,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:h.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:h.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:h.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:h.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:h.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:h.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:h.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:h.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:h.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:h.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:h.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:h.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:h.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:h.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:h.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:h.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:h.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:h.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:h.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:h.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:h.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:h.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:h.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(49,null)});const A=I=>h.localize(50,null,I);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(51,null)};var S;(function(I){I[I.Inactive=0]="Inactive",I[I.Initializing=1]="Initializing",I[I.Stopped=2]="Stopped",I[I.Running=3]="Running"})(S=e.State||(e.State={}));function D(I){switch(I){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var _;(function(I){I[I.Valid=0]="Valid",I[I.Unreadable=1]="Unreadable",I[I.Error=2]="Error"})(_=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(I){I[I.Initial=1]="Initial",I[I.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,k.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(I){I[I.CONDITION=0]="CONDITION",I[I.HIT_COUNT=1]="HIT_COUNT",I[I.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(we[210],be([1,0,8,2,9,25,10]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(o,i,r){return o.replace(D,function(n,a){return i&&a.length>0&&a[0]!=="_"?n:r&&r.hasOwnProperty(a)?r[a]:n})}e.formatPII=_;function R(o){const i={};for(const r of Object.keys(o))r.startsWith("!")||(i[r]=o[r]);return i}e.filterExceptionsFromTelemetry=R;function F(o){return o.configuration.request==="attach"&&!I(o)&&(!o.parentSession||F(o.parentSession))}e.isSessionAttach=F;function I(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(i,"extensionhost")||(0,h.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?I(o.parentSession):void 0}e.getExtensionHostDebugSession=I;function p(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=p;function E(o,i,r){let n,a=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let u=null;for(;u=g.exec(o);){const m=u.index+1,T=m+u[0].length;if(m<=i&&T>=r){n=u[0],a=m;break}}if(n){const m=/\w+/g;let T=null;for(;(T=m.exec(n))&&!(T.index+1+a+T[0].length>=r););T&&(n=n.substring(0,m.lastIndex))}return n?{start:a,end:a+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(o){return!!(o&&o.match(v))}e.isUri=d;function w(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(d(o.path))return t.URI.parse(o.path);if((0,k.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function C(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===S.Schemas.file?i.fsPath:i.toString()}return o.path}function P(o,i){const r=i?w:C,n=(0,A.deepClone)(o);return c(n,(a,g)=>{a&&g&&(g.path=r(g))}),n}e.convertToDAPaths=P;function l(o,i){const r=i?w:C,n=(0,A.deepClone)(o);return c(n,(a,g)=>{!a&&g&&(g.path=r(g))}),n}e.convertToVSCPaths=l;function c(o,i){switch(o.type){case"event":{const r=o;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=o;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(n=>i(!1,n));break;default:break}break}case"response":{const r=o;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(n=>i(!1,n.source));break;case"loadedSources":r.body.sources.forEach(n=>i(!1,n));break;case"scopes":r.body.scopes.forEach(n=>i(!1,n.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"setBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"disassemble":{const n=r;n.body&&n.body.instructions.forEach(a=>i(!1,a.location))}break;default:break}break}}}function f(o){return o.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=f;function s(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function b(o,i){const r=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const n=i.activeEditorPane;n&&n.input.resource?.scheme===S.Schemas.untitled&&await i.save({editor:n.input,groupId:n.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(we[211],be([1,0,28,38,178,127,9,8,25,12,194,126]),function(te,e,h,t,k,A,S,D,_,R,F,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class p extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",c=>this.handleData(c))}sendMessage(P){if(this.outputStream){const l=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${p.TWO_CRLF}${l}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+l))}continue}}else{const l=this.rawData.indexOf(p.TWO_CRLF);if(l!==-1){const f=this.rawData.toString("utf8",0,l).split(p.HEADER_LINESEPARATOR);for(const s of f){const b=s.split(p.HEADER_FIELDSEPARATOR);b[0]==="Content-Length"&&(this.contentLength=Number(b[1]))}this.rawData=this.rawData.slice(l+p.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=p,p.TWO_CRLF=`\r
\r
`,p.HEADER_LINESEPARATOR=/\r?\n/,p.HEADER_FIELDSEPARATOR=/: */;class E extends p{startSession(){return new Promise((P,l)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",f=>{c?this._onError.fire(f):l(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class v extends E{constructor(P){super();this.adapterServer=P}createConnection(P){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=v;class d extends E{constructor(P){super();this.adapterServer=P}createConnection(P){return A.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=d;class w extends p{constructor(P,l,c){super();this.adapterExecutable=P,this.debugType=l,this.outputService=c}async startSession(){const P=this.adapterExecutable.command,l=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(P)if(S.isAbsolute(P)){if(!await h.Promises.exists(P))throw new Error(k.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let f=process.env;if(c.env&&Object.keys(c.env).length>0&&(f=_.mixin(_.deepClone(process.env),c.env)),P==="node")if(Array.isArray(l)&&l.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:f,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(o.cwd=c.cwd);const i=t.fork(l[0],l.slice(1),o);if(!i.pid)throw new Error(k.localize(2,null,l[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const b={env:f};c.cwd&&(b.cwd=c.cwd),this.serverProcess=t.spawn(P,l,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,o)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)});const s=this.outputService;if(s){const b=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=s.getChannel(F.ExtensionsChannelId);i&&i.append(b(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((P,l)=>{const c=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,s,b){if(f)return l(f)});c.on("exit",P),c.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,l){if(!P)return;const c=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?c.runtime=S.join(l,P.runtime):c.runtime=P.runtime),P.runtimeArgs&&(c.runtimeArgs=P.runtimeArgs),P.program&&(S.isAbsolute(P.program)?c.program=P.program:c.program=S.join(l,P.program)),P.args&&(c.args=P.args);const f=P;return f.win&&(c.win=w.extract(f.win,l)),f.winx86&&(c.winx86=w.extract(f.winx86,l)),f.windows&&(c.windows=w.extract(f.windows,l)),f.osx&&(c.osx=w.extract(f.osx,l)),f.linux&&(c.linux=w.extract(f.linux,l)),c}static platformAdapterExecutable(P,l){let c=Object.create(null);l=l.toLowerCase();for(const r of P)if(r.contributes){const n=r.contributes.debuggers;n&&n.length>0&&n.filter(a=>typeof a.type=="string"&&D.equalsIgnoreCase(a.type,l)).forEach(a=>{const g=w.extract(a,r.extensionLocation.fsPath);c=_.mixin(c,g,r.isBuiltin)})}let f;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=c.winx86||c.win||c.windows:R.isWindows?f=c.win||c.windows:R.isMacintosh?f=c.osx:R.isLinux&&(f=c.linux),f=f||c;const s=f.program||c.program,b=f.args||c.args,o=f.runtime||c.runtime,i=f.runtimeArgs||c.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof s=="string"?[s]:[]).concat(b||[])};if(s)return{type:"executable",command:s,args:b||[]}}}e.ExecutableDebugAdapter=w}),define(we[212],be([1,0,38,30,12]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(R,F){return new Promise((I,p)=>{let E="";const v=h.spawn(R,F);v.pid&&v.stdout.on("data",d=>{E+=d.toString()}),v.on("error",d=>{p(d)}),v.on("close",d=>{I(E)})})}async function S(R){if(R)if(k.isWindows){const F=await new Promise((I,p)=>{te(["windows-process-tree"],I,p)});return new Promise(I=>{F.getProcessTree(R,p=>{I(p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(R)]).then(F=>{const I=F.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=S;var D;(function(R){R[R.cmd=0]="cmd",R[R.powershell=1]="powershell",R[R.bash=2]="bash"})(D||(D={}));function _(R,F,I,p){R=R.trim().toLowerCase();let E;R.indexOf("powershell")>=0||R.indexOf("pwsh")>=0?E=1:R.indexOf("cmd.exe")>=0?E=0:R.indexOf("bash")>=0?E=2:k.isWindows?E=0:E=2;let v,d=" ";switch(E){case 1:if(v=w=>(w=w.replace(/\'/g,"''"),w.length>0&&w.charAt(w.length-1)==="\\"?`'${w}\\'`:`'${w}'`),I){const w=(0,t.getDriveLetter)(I);w&&(d+=`${w}:; `),d+=`cd ${v(I)}; `}if(p)for(const w in p){const C=p[w];C===null?d+=`Remove-Item env:${w}; `:d+=`\${env:${w}}='${C}'; `}if(F.length>0){const w=v(F.shift());d+=w[0]==="'"?`& ${w} `:`${w} `;for(const C of F)d+=`${v(C)} `}break;case 0:if(v=w=>(w=w.replace(/\"/g,'""'),w.indexOf(" ")>=0||w.indexOf('"')>=0||w.length===0?`"${w}"`:w),I){const w=(0,t.getDriveLetter)(I);w&&(d+=`${w}: && `),d+=`cd ${v(I)} && `}if(p){d+='cmd /C "';for(const w in p){let C=p[w];C===null?d+=`set "${w}=" && `:(C=C.replace(/[\^\&\|\<\>]/g,P=>`^${P}`),d+=`set "${w}=${C}" && `)}}for(const w of F)d+=`${v(w)} `;p&&(d+='"');break;case 2:{v=C=>(C=C.replace(/(["'\\\$])/g,"\\$1"),C.indexOf(" ")>=0||C.indexOf(";")>=0||C.length===0?`"${C}"`:C);const w=C=>/[^\w@%\/+=,.:^-]/.test(C)?`'${C.replace(/'/g,"'\\''")}'`:C;if(I&&(d+=`cd ${v(I)} ; `),p){d+="/usr/bin/env";for(const C in p){const P=p[C];P===null?d+=` -u ${w(C)}`:d+=` ${w(`${C}=${P}`)}`}d+=" "}for(const C of F)d+=`${v(C)} `;break}}return d}e.prepareCommand=_}),define(we[128],be([1,0,32,77,92,10,9,12,62]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(m){m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var v;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(v=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var C;(function(m){m.scheme=A.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function O(x,K){return x.with({scheme:m.scheme,fragment:`ch${K.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}m.generate=O;function L(x){if(x.scheme!==m.scheme)return;const K=T.exec(x.fragment);return K?{handle:Number(K[1]),notebook:x.with({scheme:x.fragment.substring(K[0].length)||A.Schemas.file,fragment:null})}:void 0}m.parse=L;function y(x,K,B){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${K.toString().padStart(7,"0")},${B??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}m.generateCellOutputUri=y;function H(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const K=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!K)return;const B=Number(K[1]),G=K[2]&&K[2]!==""?K[2]:void 0,X=K[3];return{handle:B,outputId:G,notebook:x.with({scheme:X||A.Schemas.file,fragment:null})}}m.parseCellOutputUri=H;function M(x,K,B){return x.with({scheme:B,fragment:`ch${K.toString().padStart(7,"0")}${x.scheme!==A.Schemas.file?x.scheme:""}`})}m.generateCellUri=M;function z(x,K){if(x.scheme!==K)return;const B=T.exec(x.fragment);return B?{handle:Number(B[1]),notebook:x.with({scheme:x.fragment.substring(B[0].length)||A.Schemas.file,fragment:null})}:void 0}m.parseCellUri=z})(C=e.CellUri||(e.CellUri={}));const P=new Map([["image/git",{alwaysSecure:!0,supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function l(m){return P.get(m)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=l;function c(m){return P.get(m)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function f(m){return P.get(m)?.mergeable??!1}e.mimeTypeIsMergeable=f;const s=m=>D.isWindows?m.replace(/\//g,"\\"):m;class b{constructor(T=[],O=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=O,this.order=[...new Set(T)].map(L=>({pattern:L,matches:h.parse(s(L))}))}sort(T){const O=new Map(t.Iterable.map(T,y=>[y,s(y)]));let L=[];for(const{matches:y}of this.order)for(const[H,M]of O)if(y(M)){L.push(H),O.delete(H);break}return O.size&&(L=L.concat([...O.keys()].sort((y,H)=>this.defaultOrder.indexOf(y)-this.defaultOrder.indexOf(H)))),L}prioritize(T,O){const L=this.findIndex(T);if(L===-1){this.order.unshift({pattern:T,matches:h.parse(s(T))});return}const y=new Set(O.map(M=>this.findIndex(M,L)));y.delete(-1);const H=Array.from(y).sort();this.order.splice(L+1,0,...H.map(M=>this.order[M]));for(let M=H.length-1;M>=0;M--)this.order.splice(H[M],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,O=this.order.length){const L=s(T);for(let y=0;y<O;y++)if(this.order[y].matches(L))return y;return-1}}e.MimeTypeDisplayOrder=b;function o(m,T,O,L=(y,H)=>y===H){const y=[];function H(x,K,B){if(K===0&&B.length===0)return;const G=y[y.length-1];G&&G.start+G.deleteCount===x?(G.deleteCount+=K,G.toInsert.push(...B)):y.push({start:x,deleteCount:K,toInsert:B})}let M=0,z=0;for(;;){if(M===m.length){H(M,0,T.slice(z));break}if(z===T.length){H(M,m.length-M,[]);break}const x=m[M],K=T[z];if(L(x,K)){M+=1,z+=1;continue}O(K)?(H(M,1,[]),M+=1):(H(M,0,[K]),z+=1)}return y}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(m){m.default="default",m.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(m){const T=m;return!!((typeof T.include=="string"||h.isRelativePattern(T.include))&&(typeof T.exclude=="string"||h.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=r;function n(m,T,O){if(Array.isArray(m.viewType)&&m.viewType.indexOf(T)>=0||m.viewType===T)return!0;if(m.filenamePattern){const L=r(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,y=r(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(h.match(L,(0,S.basename)(O.fsPath).toLowerCase()))return!(y&&h.match(y,(0,S.basename)(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n;class a{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)T[O]=this.textModel.cells[O].getHashValue();return T}}e.CellSequence=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var g;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(T){return`${u._prefix}${T}`}static parse(T){if(T.startsWith(u._prefix))return T.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(we[213],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(we[214],be([1,0,4,62]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,h.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[215],be([1,0,179,4,62]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[216],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=h;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t}),define(we[84],be([1,0,2,37]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var k;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(k=e.TestResultState||(e.TestResultState={}));var A;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:t.Range.lift(n.range),uri:h.URI.revive(n.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var _;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&S.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&S.deserialize(n.location)})})(_=e.ITestErrorMessage||(e.ITestErrorMessage={}));var R;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&S.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&S.deserialize(n.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var F;(function(r){r.serialize=n=>n.type===0?_.serialize(n):R.serialize(n),r.deserialize=n=>n.type===0?_.deserialize(n):R.deserialize(n)})(F=e.ITestMessage||(e.ITestMessage={}));var I;(function(r){r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(F.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(F.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",E=(r,n)=>r+p+n;e.namespaceTestTag=E;const v=r=>{const n=r.indexOf(p);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=v;var d;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?h.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(d=e.ITestItem||(e.ITestItem={}));var w;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(r){r.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:d.serialize(n.item)}),r.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:d.deserialize(n.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var P;(function(r){r.serialize=n=>{let a;return n.item&&(a={},n.item.label!==void 0&&(a.label=n.item.label),n.item.tags!==void 0&&(a.tags=n.item.tags),n.item.busy!==void 0&&(a.busy=n.item.busy),n.item.uri!==void 0&&(a.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(a.range=n.item.range?.toJSON()),n.item.description!==void 0&&(a.description=n.item.description),n.item.error!==void 0&&(a.error=n.item.error),n.item.sortText!==void 0&&(a.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:a}},r.deserialize=n=>{let a;return n.item&&(a={},n.item.label!==void 0&&(a.label=n.item.label),n.item.tags!==void 0&&(a.tags=n.item.tags),n.item.busy!==void 0&&(a.busy=n.item.busy),n.item.range!==void 0&&(a.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(a.description=n.item.description),n.item.error!==void 0&&(a.error=n.item.error),n.item.sortText!==void 0&&(a.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:a}}})(P=e.ITestItemUpdate||(e.ITestItemUpdate={}));const l=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=l;var c;(function(r){r.serialize=(n,a)=>({...C.serialize(n),children:a,ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(I.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var f;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var b;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:C.deserialize(n.item)}:n.op===1?{op:n.op,item:P.deserialize(n.item)}:n,r.serialize=n=>n.op===0?{op:n.op,item:C.serialize(n.item)}:n.op===1?{op:n.op,item:P.serialize(n.item)}:n})(b=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(n){}update(n){}remove(n,a){}complete(){}}e.IncrementalChangeCollector=o;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const a=this.createChangeCollector();for(const g of n)switch(g.op){case 0:{const u=C.deserialize(g.item);if(u.parent){if(this.items.has(u.parent)){const m=this.items.get(u.parent);m.children.add(u.item.extId);const T=this.createItem(u,m);this.items.set(u.item.extId,T),a.add(T)}}else{const m=this.createItem(u);this.roots.add(m),this.items.set(u.item.extId,m),a.add(m)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=P.deserialize(g.item),m=this.items.get(u.extId);if(!m)break;u.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,u),a.update(m);break}case 2:{const u=this.items.get(g.itemId);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const m=[[g.itemId]];for(;m.length;)for(const T of m.pop()){const O=this.items.get(T);O&&(m.push(O.children),this.items.delete(T),a.remove(O,O!==u),O.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}a.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=i}),define(we[85],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(A){A.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{constructor(S,D=S.length){if(this.path=S,this.viewEnd=D,S.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(S,D,_=S.parent){if(S.id===D)return new k([D]);let R=[S.id];for(let F=_;F&&F.id!==D;F=F.parent)R.push(F.id);return R.push(D),new k(R.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const D=S.indexOf("\0");return D===-1?S:S.slice(0,D)}static fromString(S){return new k(S.split("\0"))}static join(S,D){return new k([...S.path,D])}static joinToString(S,D){return S.toString()+"\0"+D}static compare(S,D){return S===D?0:D.startsWith(S+"\0")?2:S.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let S=1;S<=this.viewEnd;S++)yield new k(this.path,S)}compare(S){if(typeof S=="string")return k.compare(this.toString(),S);for(let D=0;D<S.viewEnd&&D<this.viewEnd;D++)if(S.path[D]!==this.path[D])return 1;return S.viewEnd>this.viewEnd?2:S.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let S=1;S<this.viewEnd;S++)this.stringifed+="\0",this.stringifed+=this.path[S]}return this.stringifed}}e.TestId=k}),define(we[217],be([1,0,9,41,18,25,12,100,180]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(I,p,E,v){this._contributedVariables=new Map,this._context=I,this._labelService=p,this._userHomePromise=E,v&&(this._envVariablesPromise=v.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(S.isWindows){const p=Object.create(null);return Object.keys(I).forEach(E=>{p[E.toLowerCase()]=I[E]}),p}return I}resolveWithEnvironment(I,p,E){return this.recursiveResolve(this.prepareEnv(I),p?p.uri:void 0,E)}async resolveAsync(I,p){const E={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(E,I?I.uri:void 0,p)}async resolveAnyBase(I,p,E,v){const d=A.deepClone(p);S.isWindows&&d.windows?Object.keys(d.windows).forEach(C=>d[C]=d.windows[C]):S.isMacintosh&&d.osx?Object.keys(d.osx).forEach(C=>d[C]=d.osx[C]):S.isLinux&&d.linux&&Object.keys(d.linux).forEach(C=>d[C]=d.linux[C]),delete d.windows,delete d.osx,delete d.linux;const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,I?I.uri:void 0,d,E,v)}async resolveAnyAsync(I,p,E){return this.resolveAnyBase(I,p,E)}async resolveAnyMap(I,p,E){const v=new Map;return{newConfig:await this.resolveAnyBase(I,p,E,v),resolvedVariables:v}}resolveWithInteractionReplace(I,p,E,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,p,E,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,p){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,p)}recursiveResolve(I,p,E,v,d){if(k.isString(E))return this.resolveString(I,p,E,v,d);if(k.isArray(E))return E.map(w=>this.recursiveResolve(I,p,w,v,d));if(k.isObject(E)){let w=Object.create(null);return Object.keys(E).forEach(C=>{const P=this.resolveString(I,p,C,v,d);w[P]=this.recursiveResolve(I,p,E[C],v,d)}),w}return E}resolveString(I,p,E,v,d){return E.replace(R.VARIABLE_REGEXP,(C,P)=>{if(P.includes(R.VARIABLE_LHS))return C;let l=this.evaluateSingleVariable(I,C,P,p,v);return d&&d.set(P,l),l!==C&&k.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=this.resolveString(I,p,l,v,d)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,p,E,v,d){let w;const C=E.split(":");C.length>1&&(E=C[0],w=C[1]);const P=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,_.localize)(0,null,p))},l=()=>{const f=P();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,_.localize)(1,null,p,h.basename(f)))},c=()=>{if(w){const f=this._context.getFolderUri(w);if(f)return f;throw new Error((0,_.localize)(2,null,p,w))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,p)):new Error((0,_.localize)(4,null,p))};switch(E){case"env":if(w){if(I.env){const f=I.env[S.isWindows?w.toLowerCase():w];if(k.isString(f))return f}return""}throw new Error((0,_.localize)(5,null,p));case"config":if(w){const f=this._context.getConfigurationValue(v,w);if(k.isUndefinedOrNull(f))throw new Error((0,_.localize)(6,null,p,w));if(k.isObject(f))throw new Error((0,_.localize)(7,null,p,w));return f}throw new Error((0,_.localize)(8,null,p));case"command":return this.resolveFromMap(p,w,d,"command");case"input":return this.resolveFromMap(p,w,d,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return v||w?(0,D.normalizeDriveLetter)(this.fsPath(c())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(c()));case"userHome":{if(I.userHome)return I.userHome;throw new Error((0,_.localize)(9,null,p))}case"lineNumber":{const f=this._context.getLineNumber();if(f)return f;throw new Error((0,_.localize)(10,null,p))}case"selectedText":{const f=this._context.getSelectedText();if(f)return f;throw new Error((0,_.localize)(11,null,p))}case"file":return P();case"fileWorkspaceFolder":return l();case"relativeFile":return v||w?h.relative(this.fsPath(c()),P()):P();case"relativeFileDirname":{const f=h.dirname(P());if(v||w){const s=h.relative(this.fsPath(c()),f);return s.length===0?".":s}return f}case"fileDirname":return h.dirname(P());case"fileExtname":return h.extname(P());case"fileBasename":return h.basename(P());case"fileBasenameNoExtension":{const f=h.basename(P());return f.slice(0,f.length-h.extname(f).length)}case"fileDirnameBasename":return h.basename(h.dirname(P()));case"execPath":{const f=this._context.getExecPath();return f||p}case"execInstallFolder":{const f=this._context.getAppRoot();return f||p}case"pathSeparator":return h.sep;default:try{const f=w?`${E}:${w}`:E;return this.resolveFromMap(p,f,d,void 0)}catch{return p}}}}resolveFromMap(I,p,E,v){if(p&&E){const d=v===void 0?E[p]:E[v+":"+p];if(typeof d=="string")return d;throw new Error((0,_.localize)(12,null,I))}return I}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[129],be([1,0,4,207]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var D;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function R(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=R;var F;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function p(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=p;function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(we[218],be([1,0,4,129]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const S=A;return typeof A=="number"||(0,t.isEditorGroup)(S)}e.isPreferredGroup=k}),define(we[15],be([1,0,17,22,99,142,58,25,18,2,37,79,182,116,63,128,84,85,218,7]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(fe){function Ie(ie){const{selectionStartLineNumber:ye,selectionStartColumn:Le,positionLineNumber:xe,positionColumn:Ge}=ie,ct=new l.Position(ye-1,Le-1),vt=new l.Position(xe-1,Ge-1);return new l.Selection(ct,vt)}fe.to=Ie;function ge(ie){const{anchor:ye,active:Le}=ie;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}fe.from=ge})(c=e.Selection||(e.Selection={}));var f;(function(fe){function Ie(ie){if(!ie)return;const{start:ye,end:Le}=ie;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}fe.from=Ie;function ge(ie){if(!ie)return;const{startLineNumber:ye,startColumn:Le,endLineNumber:xe,endColumn:Ge}=ie;return new l.Range(ye-1,Le-1,xe-1,Ge-1)}fe.to=ge})(f=e.Range||(e.Range={}));var s;(function(fe){function Ie(ge){switch(ge){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}fe.to=Ie})(s=e.TokenType||(e.TokenType={}));var b;(function(fe){function Ie(ie){return new l.Position(ie.lineNumber-1,ie.column-1)}fe.to=Ie;function ge(ie){return{lineNumber:ie.line+1,column:ie.character+1}}fe.from=ge})(b=e.Position||(e.Position={}));var o;(function(fe){function Ie(ye,Le){return(0,h.coalesce)((0,h.asArray)(ye).map(xe=>ge(xe,Le)))}fe.from=Ie;function ge(ye,Le){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:ie(ye.scheme,Le),pattern:J.from(ye.pattern)??void 0,exclusive:ye.exclusive}}function ie(ye,Le){return Le&&typeof ye=="string"?Le.transformOutgoingScheme(ye):ye}})(o=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(fe){function Ie(ie){switch(ie){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}fe.from=Ie;function ge(ie){switch(ie){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}fe.to=ge})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(fe){function Ie(ie){let ye;return ie.code&&((0,_.isString)(ie.code)||(0,_.isNumber)(ie.code)?ye=String(ie.code):ye={value:String(ie.code.value),target:ie.code.target}),{...f.from(ie.range),message:ie.message,source:ie.source,code:ye,severity:a.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(n.from),tags:Array.isArray(ie.tags)?(0,h.coalesce)(ie.tags.map(i.from)):void 0}}fe.from=Ie;function ge(ie){const ye=new l.Diagnostic(f.to(ie),ie.message,a.to(ie.severity));return ye.source=ie.source,ye.code=(0,_.isString)(ie.code)?ie.code:ie.code?.value,ye.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(n.to),ye.tags=ie.tags&&(0,h.coalesce)(ie.tags.map(i.to)),ye}fe.to=ge})(r=e.Diagnostic||(e.Diagnostic={}));var n;(function(fe){function Ie(ie){return{...f.from(ie.location.range),message:ie.message,resource:ie.location.uri}}fe.from=Ie;function ge(ie){return new l.DiagnosticRelatedInformation(new l.Location(ie.resource,f.to(ie)),ie.message)}fe.to=ge})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(fe){function Ie(ie){switch(ie){case l.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}fe.from=Ie;function ge(ie){switch(ie){case E.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}fe.to=ge})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var g;(function(fe){function Ie(ie){return typeof ie=="number"&&ie>=l.ViewColumn.One?ie-1:ie===l.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}fe.from=Ie;function ge(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}fe.to=ge})(g=e.ViewColumn||(e.ViewColumn={}));function u(fe){return typeof fe.range!="undefined"}function m(fe){return fe.length===0?!0:!!u(fe[0])}e.isDecorationOptionsArr=m;var T;(function(fe){function Ie(Ge){return Ge.map(fe.from)}fe.fromMany=Ie;function ge(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ie(Ge){let ct;if(ge(Ge)){const{language:rt,value:ut}=Ge;ct={value:"```"+rt+`
`+ut+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const vt=Object.create(null);ct.uris=vt;const St=rt=>{try{let ut=R.URI.parse(rt,!0);ut=ut.with({query:ye(ut.query,vt)}),vt[rt]=ut}catch{}return""},Et=new A.marked.Renderer;return Et.link=St,Et.image=rt=>typeof rt=="string"?St(k.parseHrefAndDimensions(rt).href):"",(0,A.marked)(ct.value,{renderer:Et}),ct}fe.from=ie;function ye(Ge,ct){if(!Ge)return Ge;let vt;try{vt=(0,S.parse)(Ge)}catch{}if(!vt)return Ge;let St=!1;return vt=(0,D.cloneAndChange)(vt,Et=>{if(R.URI.isUri(Et)){const rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[rt]=Et,St=!0,rt}else return}),St?JSON.stringify(vt):Ge}function Le(Ge){const ct=new l.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?R.URI.from(Ge.baseUri):void 0,ct}fe.to=Le;function xe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:fe.from(Ge)}fe.fromStrict=xe})(T=e.MarkdownString||(e.MarkdownString={}));function O(fe){return m(fe)?fe.map(Ie=>({range:f.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?T.fromMany(Ie.hoverMessage):Ie.hoverMessage?T.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):fe.map(Ie=>({range:f.from(Ie)}))}e.fromRangeOrRangeWithMessage=O;function L(fe){return typeof fe=="undefined"?fe:typeof fe=="string"?R.URI.file(fe):fe}e.pathOrURIToURI=L;var y;(function(fe){function Ie(ge){return typeof ge=="undefined"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?L(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}fe.from=Ie})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(fe){function Ie(ge){return typeof ge=="undefined"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?y.from(ge.before):void 0,after:ge.after?y.from(ge.after):void 0}}fe.from=Ie})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(fe){function Ie(ge){if(typeof ge=="undefined")return ge;switch(ge){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}fe.from=Ie})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(fe){function Ie(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?M.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?H.from(ge.light):void 0,dark:ge.dark?H.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?y.from(ge.before):void 0,after:ge.after?y.from(ge.after):void 0}}fe.from=Ie})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(fe){function Ie(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:f.from(ie.range)}}fe.from=Ie;function ge(ie){const ye=new l.TextEdit(f.to(ie.range),ie.text);return ye.newEol=typeof ie.eol=="undefined"?void 0:et.to(ie.eol),ye}fe.to=ge})(x=e.TextEdit||(e.TextEdit={}));var K;(function(fe){function Ie(ie,ye){const Le={edits:[]};if(ie instanceof l.WorkspaceEdit)for(let xe of ie._allEntries())xe._type===1?Le.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata}):xe._type===2?Le.edits.push({_type:2,resource:xe.uri,edit:x.from(xe.edit),modelVersionId:ye?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Le.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Le.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ye?.getNotebookDocumentVersion(xe.uri),edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(st.from)}});return Le}fe.from=Ie;function ge(ie){const ye=new l.WorkspaceEdit;for(const Le of ie.edits)Le.edit?ye.replace(R.URI.revive(Le.resource),f.to(Le.edit.range),Le.edit.text):ye.renameFile(R.URI.revive(Le.oldUri),R.URI.revive(Le.newUri),Le.options);return ye}fe.to=ge})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(fe){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function ge(ye){return typeof Ie[ye]=="number"?Ie[ye]:6}fe.from=ge;function ie(ye){for(const Le in Ie)if(Ie[Le]===ye)return Number(Le);return l.SymbolKind.Property}fe.to=ie})(B=e.SymbolKind||(e.SymbolKind={}));var G;(function(fe){function Ie(ie){switch(ie){case l.SymbolTag.Deprecated:return 1}}fe.from=Ie;function ge(ie){switch(ie){case 1:return l.SymbolTag.Deprecated}}fe.to=ge})(G=e.SymbolTag||(e.SymbolTag={}));var X;(function(fe){function Ie(ie){return{name:ie.name,kind:B.from(ie.kind),tags:ie.tags&&ie.tags.map(G.from),containerName:ie.containerName,location:Z.from(ie.location)}}fe.from=Ie;function ge(ie){const ye=new l.SymbolInformation(ie.name,B.to(ie.kind),ie.containerName,Z.to(ie.location));return ye.tags=ie.tags&&ie.tags.map(G.to),ye}fe.to=ge})(X=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(fe){function Ie(ie){const ye={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:f.from(ie.range),selectionRange:f.from(ie.selectionRange),kind:B.from(ie.kind),tags:ie.tags?.map(G.from)??[]};return ie.children&&(ye.children=ie.children.map(Ie)),ye}fe.from=Ie;function ge(ie){const ye=new l.DocumentSymbol(ie.name,ie.detail,B.to(ie.kind),f.to(ie.range),f.to(ie.selectionRange));return(0,h.isNonEmptyArray)(ie.tags)&&(ye.tags=ie.tags.map(G.to)),ie.children&&(ye.children=ie.children.map(ge)),ye}fe.to=ge})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(fe){function Ie(ie){const ye=new l.CallHierarchyItem(B.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),f.to(ie.range),f.to(ie.selectionRange));return ye._sessionId=ie._sessionId,ye._itemId=ie._itemId,ye}fe.to=Ie;function ge(ie,ye,Le){if(ye=ye??ie._sessionId,Le=Le??ie._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,name:ie.name,detail:ie.detail,kind:B.from(ie.kind),uri:ie.uri,range:f.from(ie.range),selectionRange:f.from(ie.selectionRange),tags:ie.tags?.map(G.from)}}fe.from=ge})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ae;(function(fe){function Ie(ge){return new l.CallHierarchyIncomingCall(ee.to(ge.from),ge.fromRanges.map(ie=>f.to(ie)))}fe.to=Ie})(ae=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(fe){function Ie(ge){return new l.CallHierarchyOutgoingCall(ee.to(ge.to),ge.fromRanges.map(ie=>f.to(ie)))}fe.to=Ie})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Z;(function(fe){function Ie(ie){return{range:ie.range&&f.from(ie.range),uri:ie.uri}}fe.from=Ie;function ge(ie){return new l.Location(R.URI.revive(ie.uri),f.to(ie.range))}fe.to=ge})(Z=e.location||(e.location={}));var Y;(function(fe){function Ie(ie){const ye=ie,Le=ie;return{originSelectionRange:ye.originSelectionRange?f.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Le.uri,range:f.from(ye.targetRange?ye.targetRange:Le.range),targetSelectionRange:ye.targetSelectionRange?f.from(ye.targetSelectionRange):void 0}}fe.from=Ie;function ge(ie){return{targetUri:R.URI.revive(ie.uri),targetRange:f.to(ie.range),targetSelectionRange:ie.targetSelectionRange?f.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?f.to(ie.originSelectionRange):void 0}}fe.to=ge})(Y=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(fe){function Ie(ie){return{range:f.from(ie.range),contents:T.fromMany(ie.contents)}}fe.from=Ie;function ge(ie){return new l.Hover(ie.contents.map(T.to),f.to(ie.range))}fe.to=ge})(se=e.Hover||(e.Hover={}));var de;(function(fe){function Ie(ie){return{range:f.from(ie.range),expression:ie.expression}}fe.from=Ie;function ge(ie){return new l.EvaluatableExpression(f.to(ie.range),ie.expression)}fe.to=ge})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(fe){function Ie(ie){if(ie instanceof l.InlineValueText)return{type:"text",range:f.from(ie.range),text:ie.text};if(ie instanceof l.InlineValueVariableLookup)return{type:"variable",range:f.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}fe.from=Ie;function ge(ie){switch(ie.type){case"text":return{range:f.to(ie.range),text:ie.text};case"variable":return{range:f.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:f.to(ie.range),expression:ie.expression}}}fe.to=ge})(ve=e.InlineValue||(e.InlineValue={}));var Te;(function(fe){function Ie(ie){return{frameId:ie.frameId,stoppedLocation:f.from(ie.stoppedLocation)}}fe.from=Ie;function ge(ie){return new l.InlineValueContext(ie.frameId,f.to(ie.stoppedLocation))}fe.to=ge})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(fe){function Ie(ie){return{range:f.from(ie.range),kind:ie.kind}}fe.from=Ie;function ge(ie){return new l.DocumentHighlight(f.to(ie.range),ie.kind)}fe.to=ge})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var _e;(function(fe){function Ie(ge){switch(ge){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}fe.to=Ie})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(fe){function Ie(ge){return{triggerKind:_e.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}fe.to=Ie})(Ee=e.CompletionContext||(e.CompletionContext={}));var $;(function(fe){function Ie(ie){switch(ie){case l.CompletionItemTag.Deprecated:return 1}}fe.from=Ie;function ge(ie){switch(ie){case 1:return l.CompletionItemTag.Deprecated}}fe.to=ge})($=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(fe){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ge(Le){return Ie.get(Le)??9}fe.from=ge;const ie=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function ye(Le){return ie.get(Le)??l.CompletionItemKind.Property}fe.to=ye})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(fe){function Ie(ge,ie){const ye=new l.CompletionItem(ge.label);return ye.insertText=ge.insertText,ye.kind=U.to(ge.kind),ye.tags=ge.tags?.map($.to),ye.detail=ge.detail,ye.documentation=k.isMarkdownString(ge.documentation)?T.to(ge.documentation):ge.documentation,ye.sortText=ge.sortText,ye.filterText=ge.filterText,ye.preselect=ge.preselect,ye.commitCharacters=ge.commitCharacters,F.Range.isIRange(ge.range)?ye.range=f.to(ge.range):typeof ge.range=="object"&&(ye.range={inserting:f.to(ge.range.insert),replacing:f.to(ge.range.replace)}),ye.keepWhitespace=typeof ge.insertTextRules=="undefined"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules!="undefined"&&ge.insertTextRules&4?ye.insertText=new l.SnippetString(ge.insertText):(ye.insertText=ge.insertText,ye.textEdit=ye.range instanceof l.Range?new l.TextEdit(ye.range,ye.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(ye.additionalTextEdits=ge.additionalTextEdits.map(Le=>x.to(Le))),ye.command=ie&&ge.command?ie.fromInternal(ge.command):void 0,ye}fe.to=Ie})(N=e.CompletionItem||(e.CompletionItem={}));var W;(function(fe){function Ie(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation)}}fe.from=Ie;function ge(ie){return{label:ie.label,documentation:k.isMarkdownString(ie.documentation)?T.to(ie.documentation):ie.documentation}}fe.to=ge})(W=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(fe){function Ie(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.from):[],activeParameter:ie.activeParameter}}fe.from=Ie;function ge(ie){return{label:ie.label,documentation:k.isMarkdownString(ie.documentation)?T.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.to):[],activeParameter:ie.activeParameter}}fe.to=ge})(j=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(fe){function Ie(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(j.from):[]}}fe.from=Ie;function ge(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(j.to):[]}}fe.to=ge})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(fe){function Ie(ge,ie){const ye=new l.InlayHint(b.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Ce.to.bind(void 0,ge)),Ae.to(ie.kind));return ye.tooltip=k.isMarkdownString(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,ye.command=ie.command&&ge.fromInternal(ie.command),ye.paddingLeft=ie.paddingLeft,ye.paddingRight=ie.paddingRight,ye}fe.to=Ie})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(fe){function Ie(ge,ie){const ye=new l.InlayHintLabelPart(ie.label);return ye.tooltip=k.isMarkdownString(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,I.Command.is(ie.command)&&(ye.command=ge.fromInternal(ie.command)),ie.location&&(ye.location=Z.to(ie.location)),ye}fe.to=Ie})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ae;(function(fe){function Ie(ie){return ie}fe.from=Ie;function ge(ie){return ie}fe.to=ge})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(fe){function Ie(ie){return{range:f.from(ie.range),url:ie.target,tooltip:ie.tooltip}}fe.from=Ie;function ge(ie){let ye;if(ie.url)try{ye=typeof ie.url=="string"?R.URI.parse(ie.url,!0):R.URI.revive(ie.url)}catch{}return new l.DocumentLink(f.to(ie.range),ye)}fe.to=ge})(We=e.DocumentLink||(e.DocumentLink={}));var ze;(function(fe){function Ie(ie){const ye=new l.ColorPresentation(ie.label);return ie.textEdit&&(ye.textEdit=x.to(ie.textEdit)),ie.additionalTextEdits&&(ye.additionalTextEdits=ie.additionalTextEdits.map(Le=>x.to(Le))),ye}fe.to=Ie;function ge(ie){return{label:ie.label,textEdit:ie.textEdit?x.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(ye=>x.from(ye)):void 0}}fe.from=ge})(ze=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(fe){function Ie(ie){return new l.Color(ie[0],ie[1],ie[2],ie[3])}fe.to=Ie;function ge(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}fe.from=ge})(je=e.Color||(e.Color={}));var $e;(function(fe){function Ie(ie){return{range:f.from(ie.range)}}fe.from=Ie;function ge(ie){return new l.SelectionRange(f.to(ie.range))}fe.to=ge})($e=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(fe){function Ie(ge){switch(ge){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}fe.to=Ie})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(fe){function Ie(ie){switch(ie){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}fe.from=Ie;function ge(ie){switch(ie){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}fe.to=ge})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(fe){function Ie(ie){if(ie===l.EndOfLine.CRLF)return 1;if(ie===l.EndOfLine.LF)return 0}fe.from=Ie;function ge(ie){if(ie===1)return l.EndOfLine.CRLF;if(ie===0)return l.EndOfLine.LF}fe.to=ge})(et=e.EndOfLine||(e.EndOfLine={}));var Re;(function(fe){function Ie(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}fe.from=Ie})(Re=e.ProgressLocation||(e.ProgressLocation={}));var tt;(function(fe){function Ie(ge){const ie={start:ge.start+1,end:ge.end+1};return ge.kind&&(ie.kind=ne.from(ge.kind)),ie}fe.from=Ie})(tt=e.FoldingRange||(e.FoldingRange={}));var ne;(function(fe){function Ie(ge){if(ge)switch(ge){case l.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}fe.from=Ie})(ne=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(fe){function Ie(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?f.from(ge.selection):void 0,override:typeof ge.override=="boolean"?p.EditorResolution.DISABLED:void 0}}fe.from=Ie})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(fe){function Ie(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:ge(Le)||ie(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}fe.from=Ie;function ge(Le){const xe=Le;return xe?R.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ie(Le){const xe=Le;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function ye(Le){return typeof Le=="string"?Le:new l.RelativePattern(R.URI.revive(Le.baseUri),Le.pattern)}fe.to=ye})(J=e.GlobPattern||(e.GlobPattern={}));var pe;(function(fe){function Ie(ge){if(ge){if(Array.isArray(ge))return ge.map(Ie);if(typeof ge=="string")return ge;{const ie=ge;return{language:ie.language,scheme:ie.scheme,pattern:J.from(ie.pattern),exclusive:ie.exclusive}}}else return}fe.from=Ie})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(fe){function Ie(ie){return{start:ie.start,end:ie.end}}fe.from=Ie;function ge(ie){return new l.NotebookRange(ie.start,ie.end)}fe.to=ge})(Se=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(fe){function Ie(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}fe.to=Ie;function ge(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}fe.from=ge})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var He;(function(fe){function Ie(ie){switch(ie){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}fe.from=Ie;function ge(ie){switch(ie){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}fe.to=ge})(He=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(fe){function Ie(ie){const ye={metadata:ie.metadata??Object.create(null),cells:[]};for(let Le of ie.cells)l.NotebookCellData.validate(Le),ye.cells.push(st.from(Le));return ye}fe.from=Ie;function ge(ie){const ye=new l.NotebookData(ie.cells.map(st.to));return(0,_.isEmptyObject)(ie.metadata)||(ye.metadata=ie.metadata),ye}fe.to=ge})(Ye=e.NotebookData||(e.NotebookData={}));var st;(function(fe){function Ie(ie){return{cellKind:He.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ne.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(mt.from):[]}}fe.from=Ie;function ge(ie){return new l.NotebookCellData(He.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(mt.to):void 0,ie.metadata,ie.internalMetadata?Ne.to(ie.internalMetadata):void 0)}fe.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(fe){function Ie(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}fe.from=Ie;function ge(ie){return new l.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}fe.to=ge})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var mt;(function(fe){function Ie(ie){return{outputId:ie.id,items:ie.items.map(pt.from),metadata:ie.metadata}}fe.from=Ie;function ge(ie){const ye=ie.items.map(pt.to);return new l.NotebookCellOutput(ye,ie.outputId,ie.metadata)}fe.to=ge})(mt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ve;(function(fe){function Ie(ye){return ie(ye)?{include:(0,_.withNullAsUndefined)(J.from(ye.include)),exclude:(0,_.withNullAsUndefined)(J.from(ye.exclude))}:(0,_.withNullAsUndefined)(J.from(ye))}fe.from=Ie;function ge(ye){return ie(ye)?{include:J.to(ye.include),exclude:J.to(ye.exclude)}:J.to(ye)}fe.to=ge;function ie(ye){const Le=ye;return Le?!!Le.include&&!!Le.exclude:!1}})(Ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ot;(function(fe){function Ie(ge){return{backgroundColor:ge.backgroundColor,borderColor:ge.borderColor,top:ge.top?y.from(ge.top):void 0}}fe.from=Ie})(ot=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var _t;(function(fe){function Ie(ge,ie,ye){const Le=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Le,ye),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}fe.from=Ie})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(fe){function Ie(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{}}}fe.from=Ie})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(fe){function Ie(ie){return{uri:ie.uri,provides:ie.provides}}fe.from=Ie;function ge(ie){return new l.NotebookRendererScript(R.URI.revive(ie.uri),ie.provides)}fe.to=ge})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(fe){function Ie(ie){return{message:T.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:f.from(ie.location.range),uri:ie.location.uri}}}fe.from=Ie;function ge(ie){const ye=new l.TestMessage(typeof ie.message=="string"?ie.message:T.to(ie.message));return ye.actualOutput=ie.actual,ye.expectedOutput=ie.expected,ye.location=ie.location?Z.to(ie.location):void 0,ye}fe.to=ge})(Rt=e.TestMessage||(e.TestMessage={}));var It;(function(fe){fe.namespace=w.namespaceTestTag,fe.denamespace=w.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var kt;(function(fe){function Ie(Le){const xe=(0,v.getPrivateApiFor)(Le).controllerId;return{extId:C.TestId.fromExtHostTestItem(Le,xe).toString(),label:Le.label,uri:R.URI.revive(Le.uri),busy:!1,tags:Le.tags.map(Ge=>It.namespace(xe,Ge.id)),range:F.Range.lift(f.from(Le.range)),description:Le.description||null,sortText:Le.sortText||null,error:Le.error&&T.fromStrict(Le.error)||null}}fe.from=Ie;function ge(Le){return{parent:void 0,error:void 0,id:C.TestId.fromString(Le.extId).localId,label:Le.label,uri:R.URI.revive(Le.uri),tags:(Le.tags||[]).map(xe=>{const{tagId:Ge}=It.denamespace(xe);return new l.TestTag(Ge)}),range:f.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0,sortText:Le.sortText||void 0}}fe.toPlain=ge;function ie(Le){const xe=C.TestId.fromString(Le.extId),Ge=new v.TestItemImpl(xe.controllerId,xe.localId,Le.label,R.URI.revive(Le.uri)||void 0);return Ge.range=f.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge.sortText=Le.sortText||void 0,Ge}function ye(Le){let xe;for(const Ge of Le.tests){const ct=ie(Ge.item);(0,v.getPrivateApiFor)(ct).parent=xe,xe=ct}return xe}fe.toItemFromContext=ye})(kt=e.TestItem||(e.TestItem={})),function(fe){function Ie(ie){return{id:ie.id}}fe.from=Ie;function ge(ie){return new l.TestTag(ie.id)}fe.to=ge}(It=e.TestTag||(e.TestTag={}));var dt;(function(fe){const Ie=(ie,ye)=>{const Le={...kt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(Ge=>Ge.type===0).map(Rt.to)})),children:ie.children.map(xe=>ye.get(xe)).filter(_.isDefined).map(xe=>Ie(xe,ye))};for(const xe of Le.children)xe.parent=Le;return Le};function ge(ie){const ye=[],Le=new Map;for(const xe of ie.items)Le.set(xe.item.extId,xe),ie.request.targets.some(Ge=>Ge.controllerId===xe.controllerId&&Ge.testIds.includes(xe.item.extId))&&ye.push(xe);return{completedAt:ie.completedAt,results:ye.map(xe=>Ie(xe,Le))}}fe.to=ge})(dt=e.TestResults||(e.TestResults={}));var Ot;(function(fe){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function ge(Le){return"line"in Le?b.from(Le):f.from(Le)}function ie(Le){return"branches"in Le?{count:Le.executionCount,location:ge(Le.location),type:1,branches:Le.branches.length?Le.branches.map(xe=>({count:xe.executionCount,location:xe.location&&ge(xe.location)})):void 0}:{type:0,count:Le.executionCount,location:ge(Le.location)}}fe.fromDetailed=ie;function ye(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(ie)}}fe.fromFile=ye})(Ot=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(fe){function Ie(ge){switch(ge){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}fe.to=Ie})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(fe){function Ie(ie){const ye=new l.TypeHierarchyItem(B.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),f.to(ie.range),f.to(ie.selectionRange));return ye._sessionId=ie._sessionId,ye._itemId=ie._itemId,ye}fe.to=Ie;function ge(ie,ye,Le){if(ye=ye??ie._sessionId,Le=Le??ie._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,kind:B.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:f.from(ie.range),selectionRange:f.from(ie.selectionRange),tags:ie.tags?.map(G.from)}}fe.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[219],be([1,0,2,16,7,15,90]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(R,F,I,p={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=I,this._thresholds=p,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,I,p)=>{const v={dispose:this._callbacks.push([F,I,R])};return Array.isArray(p)&&p.push(v),v}}async $participateInSave(R,F){const I=h.URI.revive(R);let p=!1;const E=setTimeout(()=>p=!0,this._thresholds.timeout),v=[];try{for(let d of[...this._callbacks]){if(p)break;const w=this._documents.getDocument(I),C=await this._deliverEventAsyncAndBlameBadListeners(d,{document:w,reason:A.TextDocumentSaveReason.to(F)});v.push(C)}}finally{clearTimeout(E)}return v}_deliverEventAsyncAndBlameBadListeners([R,F,I],p){const E=this._badListeners.get(R);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,R,F,p).then(()=>!0,v=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this._badListeners.get(R);this._badListeners.set(R,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,I,p){const E=[],v=Date.now(),{document:d,reason:w}=p,{version:C}=d,P=Object.freeze({document:d,reason:w,waitUntil(l){if(Object.isFrozen(E))throw(0,t.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(l))}});try{F.apply(I,[P])}catch(l){return Promise.reject(l)}return Object.freeze(E),new Promise((l,c)=>{const f=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(f),l(s)}).catch(s=>{clearTimeout(f),c(s)})}).then(l=>{const c={edits:[]};for(const f of l)if(Array.isArray(f)&&f.every(s=>s instanceof k.TextEdit))for(const{newText:s,newEol:b,range:o}of f)c.edits.push({_type:2,resource:d.uri,edit:{range:o&&A.Range.from(o),text:s,eol:b&&A.EndOfLine.from(b)}});if(c.edits.length!==0)return C===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[220],be([1,0,10,25,2,15,128]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(I,p,E,v){this.start=I,this.deletedCount=p,this.deletedItems=E,this.items=v}static asApiEvents(I){return I.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(E=>E.apiCell)}))}}class _{constructor(I,p,E){this.notebook=I,this._extHostDocument=p,this._cellData=E,this.handle=E.handle,this.uri=k.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return I._mime},set mime(E){I._mime=E},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}})}return this._apiCell}setOutputs(I){this._outputs=I.map(A.NotebookCellOutput.to)}setOutputItems(I,p,E){const v=E.map(A.NotebookCellOutputItem.to),d=this._outputs.find(w=>w.id===I);d&&(p||(d.items.length=0),d.items.push(...v))}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=_;class R{constructor(I,p,E,v,d,w){this._proxy=I,this._textDocumentsAndEditors=p,this._textDocuments=E,this._emitter=v,this.uri=d,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this;this._notebook={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===h.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(p){return p=I._validateIndex(p),I._cells[p].apiCell},getCells(p){return(p?I._getCells(p):I._cells).map(v=>v.apiCell)},save(){return I._save()}}}return this._notebook}updateBackup(I){this._backup?.delete(),this._backup=I}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,p){this._versionId=I.versionId,this._isDirty=p;for(const E of I.rawEvents)E.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(E.changes,!1):E.kind===S.NotebookCellsChangeType.Move?this._moveCell(E.index,E.newIdx):E.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(E.index,E.outputs):E.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(E.index,E.outputId,E.append,E.outputItems):E.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(E.index,E.language):E.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(E.index,E.mime):E.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(E.index,E.metadata):E.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(E.index,E.internalMetadata)}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let p=I.start|0,E=I.end|0;return p<0&&(p=0),E>this._cells.length&&(E=this._cells.length),I.with({start:p,end:E})}_getCells(I){I=this._validateRange(I);const p=[];for(let E=I.start;E<I.end;E++)p.push(this._cells[E]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,p){if(this._disposed)return;const E=[],v=[],d=[];I.reverse().forEach(w=>{const P=w[2].map(f=>{const s=new _(this,this._textDocumentsAndEditors,f);return p||v.push(_.asModelAddData(this.apiNotebook,f)),s}),l=new D(w[0],w[1],[],P),c=this._cells.splice(w[0],w[1],...P);for(const f of c)d.push(f.uri),l.deletedItems.push(f.apiCell);E.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:d}),p||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(E)}))}_moveCell(I,p){const E=this._cells.splice(I,1);this._cells.splice(p,0,...E);const v=[new D(I,1,E.map(d=>d.apiCell),[]),new D(p,0,[],E)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(v)}))}_setCellOutputs(I,p){const E=this._cells[I];E.setOutputs(p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_setCellOutputItems(I,p,E,v){const d=this._cells[I];d.setOutputItems(p,E,v),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(I,p){const E=this._cells[I];E.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(E.uri,p)}_changeCellMime(I,p){const E=this._cells[I];E.apiCell.mime=p}_changeCellMetadata(I,p){const E=this._cells[I],v=E.apiCell.metadata;E.setMetadata(p);const d=E.apiCell.metadata;(0,t.equals)(v,d)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:E.apiCell}))}_changeCellInternalMetadata(I,p){this._cells[I].setInternalMetadata(p)}getCellFromApiCell(I){return this._cells.find(p=>p.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(p=>p.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(we[130],be([1,0,7,15,16]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:R})}replaceCells(_,R,F){this._throwIfFinalized(),!(_===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:_,count:R-_,cells:F.map(t.NotebookCellData.from)})}}class S{constructor(_,R,F,I,p,E){this.id=_,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._visibleRanges=I,this._viewColumn=E}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(R){if(!Array.isArray(R)||!R.every(h.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");_._selections=R,_._trySetSelections(R)},get visibleRanges(){return _._visibleRanges},revealRange(R,F){_._proxy.$tryRevealRange(_.id,t.NotebookRange.from(R),F??h.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(R){const F=new A(this.document.version);return R(F),_._applyEdit(F.finalize())},setDecorations(R,F){return _.setDecorations(R,F)}},S.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(t.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let I=0;I<_.cellEdits.length;I++){if(F<0){R.push(_.cellEdits[I]),F++;continue}const E=R[F],v=_.cellEdits[I];if(E.editType===1&&v.editType===1&&E.index===v.index){E.cells.push(..._.cellEdits[I].cells),E.count+=_.cellEdits[I].count;continue}R.push(_.cellEdits[I]),F++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,R)}setDecorations(_,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return R.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),_.key)}}e.ExtHostNotebookEditor=S,S.apiEditorsToExtHost=new WeakMap}),define(we[221],be([1,0,15,118,168,21,56,16]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,E,v){const d=this._handles++,{title:w,location:C,cancellable:P}=E,l={label:(0,k.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(d,{location:h.ProgressLocation.from(C),title:w,source:l,cancellable:P},p.isUnderDevelopment?void 0:p.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(d,v,!!P)}_withProgress(p,E,v){let d;v&&(d=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,d));const w=P=>{this._proxy.$progressEnd(P),this._mapHandleToCancellationSource.delete(P),d&&d.dispose()};let C;try{C=E(new F(this._proxy,p),v&&d?d.token:A.CancellationToken.None)}catch(P){throw w(p),P}return C.then(P=>w(p),P=>w(p)),C}$acceptProgressCanceled(p){const E=this._mapHandleToCancellationSource.get(p);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=_;function R(I,p){return I.message=p.message,typeof p.increment=="number"&&(typeof I.increment=="number"?I.increment+=p.increment:I.increment=p.increment),I}class F extends t.Progress{constructor(p,E){super(v=>this.throttledReport(v));this._proxy=p,this._handle=E}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}Be([(0,S.throttle)(100,(I,p)=>R(I,p),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(we[131],be([1,0,55,16,76,15,7]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(p,E,v){const d=D._Keys.nextId();p.$registerTextEditorDecorationType(E.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){p.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=D,D._Keys=new k.IdGenerator("TextEditorDecorationType");class _{constructor(p,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,E){this._throwIfFinalized();let v=null;if(p instanceof S.Position)v=new S.Range(p,p);else if(p instanceof S.Range)v=p;else throw new Error("Unrecognized location");this._pushEdit(v,E,!1)}insert(p,E){this._throwIfFinalized(),this._pushEdit(new S.Range(p,p),E,!0)}delete(p){this._throwIfFinalized();let E=null;if(p instanceof S.Range)E=p;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(p,E,v){const d=this._document.validateRange(p);this._collectedEdits.push({range:d,text:E,forceMoveMarkers:v})}setEndOfLine(p){if(this._throwIfFinalized(),p!==S.EndOfLine.LF&&p!==S.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=_;class R{constructor(p,E,v,d){this._proxy=p,this._id=E,this._accept(v),this._logService=d;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(C){w._setTabSize(C)},get insertSpaces(){return w._insertSpaces},set insertSpaces(C){w._setInsertSpaces(C)},get cursorStyle(){return w._cursorStyle},set cursorStyle(C){w._setCursorStyle(C)},get lineNumbers(){return w._lineNumbers},set lineNumbers(C){w._setLineNumbers(C)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(p){const E=this._validateTabSize(p);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const E=this._validateInsertSpaces(p);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const E={};let v=!1;if(typeof p.tabSize!="undefined"){const d=this._validateTabSize(p.tabSize);d==="auto"?(v=!0,E.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,v=!0,E.tabSize=d)}if(typeof p.insertSpaces!="undefined"){const d=this._validateInsertSpaces(p.insertSpaces);d==="auto"?(v=!0,E.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,v=!0,E.insertSpaces=d)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,v=!0,E.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,v=!0,E.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(p,E){E.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=R;class F{constructor(p,E,v,d,w,C,P,l){this.id=p,this._proxy=E,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new R(this._proxy,this.id,C,v),this._visibleRanges=P,this._viewColumn=l;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(f){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(f){if(!(f instanceof S.Selection))throw(0,t.illegalArgument)("selection");c._selections=[f],c._trySetSelection()},get selections(){return c._selections},set selections(f){if(!Array.isArray(f)||f.some(s=>!(s instanceof S.Selection)))throw(0,t.illegalArgument)("selections");c._selections=f,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(f){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(f){c._disposed||c._options.assign(f)},get viewColumn(){return c._viewColumn},set viewColumn(f){throw(0,t.readonly)("viewColumn")},edit(f,s={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new _(d.getValue(),s);return f(b),c._applyEdit(b)},insertSnippet(f,s,b={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=c._selections.map(i=>A.Range.from(i));else if(s instanceof S.Position){const{lineNumber:i,column:r}=A.Position.from(s);o=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof S.Range)o=[A.Range.from(s)];else{o=[];for(const i of s)if(i instanceof S.Range)o.push(A.Range.from(i));else{const{lineNumber:r,column:n}=A.Position.from(i);o.push({startLineNumber:r,startColumn:n,endLineNumber:r,endColumn:n})}}return E.$tryInsertSnippet(p,f.value,o,b)},setDecorations(f,s){const b=s.length===0;b&&!c._hasDecorationsForKey.has(f.key)||(b?c._hasDecorationsForKey.delete(f.key):c._hasDecorationsForKey.add(f.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(s))return E.$trySetDecorations(p,f.key,A.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const n=s[i];o[4*i]=n.start.line+1,o[4*i+1]=n.start.character+1,o[4*i+2]=n.end.line+1,o[4*i+3]=n.end.character+1}return E.$trySetDecorationsFast(p,f.key,o)}}))},revealRange(f,s){c._runOnProxy(()=>E.$tryRevealRange(p,A.Range.from(f),s||S.TextEditorRevealType.Default))},show(f){E.$tryShowEditor(p,A.ViewColumn.from(f))},hide(){E.$tryHideEditor(p)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,h.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,h.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,h.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,h.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const E=p.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(w=>w.range);v.sort((w,C)=>w.end.line===C.end.line?w.end.character===C.end.character?w.start.line===C.start.line?w.start.character-C.start.character:w.start.line-C.start.line:w.end.character-C.end.character:w.end.line-C.end.line);for(let w=0,C=v.length-1;w<C;w++){const P=v[w].end;if(v[w+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=E.edits.map(w=>({range:A.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,d,{setEndOfLine:typeof E.setEndOfLine=="number"?A.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=F}),define(we[222],be([1,0,13,3,6,18,63,15,84,85]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends k.Disposable{constructor(p){super();this.controllerId=p,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new S.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(p){this._resolveHandler=p;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const E=this.diff[this.diff.length-1];if(E&&p.op===1){if(E.op===1&&E.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(E.item,p.item);return}if(E.op===0&&E.item.item.extId===p.item.extId){(0,_.applyTestItemUpdate)(E.item,p.item);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,E){const v=this.tree.get(p);if(!!v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const d=this.resolveChildren(v);return d.isOpen()?this.expandChildren(v,E-1):d.wait().then(()=>this.expandChildren(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,E-1)):this.expandChildren(v,E-1)}}dispose(){for(const p of this.tree.values())(0,S.getPrivateApiFor)(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,E){switch(E.op){case 2:this.pushDiff({op:4,itemId:p.fullId.toString()});break;case 1:this.removeItem(R.TestId.joinToString(p.fullId,E.id));break;case 0:this.upsertItem(E.item,p);break;case 4:for(const v of E.ops)this.onTestItemEvent(p,v);break;case 3:{const{key:v,value:d,previous:w}=E,C=p.fullId.toString();switch(v){case"canResolveChildren":this.updateExpandability(p);break;case"tags":this.diffTagRefs(d,w,C);break;case"range":this.pushDiff({op:1,item:{extId:C,item:{range:D.Range.from(d)}}});break;case"error":this.pushDiff({op:1,item:{extId:C,item:{error:D.MarkdownString.fromStrict(d)||null}}});break;default:this.pushDiff({op:1,item:{extId:C,item:{[v]:d??null}}});break}break}default:(0,A.assertNever)(E)}}upsertItem(p,E){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);const v=R.TestId.fromExtHostTestItem(p,this.root.id,E?.actual),d=(0,S.getPrivateApiFor)(p);d.parent&&d.parent!==E?.actual&&d.parent.children.delete(p.id);let w=this.tree.get(v.toString());if(!w){w={fullId:v,actual:p,parent:E?v.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(p,E),this.pushDiff({op:0,item:{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:D.TestItem.from(p)}}),this.connectItemAndChildren(p,w,E);return}if(w.actual===p){this.connectItem(p,w,E);return}const C=w.actual.children,P=w.actual,l=(0,S.diffTestItems)(P,p);(0,S.getPrivateApiFor)(P).listener=void 0,w.actual=p,w.expand=0;for(const[c,f]of l)this.onTestItemEvent(w,{op:3,key:c,value:f,previous:P[c]});this.connectItemAndChildren(p,w,E);for(const c of C)p.children.get(c.id)||this.removeItem(R.TestId.joinToString(v,c.id))}diffTagRefs(p,E,v){const d=new Set(E.map(w=>w.id));for(const w of p)d.delete(w.id)||this.incrementTagRefs(w);this.pushDiff({op:1,item:{extId:v,item:{tags:p.map(w=>D.TestTag.namespace(this.controllerId,w.id))}}}),d.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const E=this.tags.get(p.id);E?E.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:5,tag:{id:D.TestTag.namespace(this.controllerId,p.id),ctrlLabel:this.root.label}}))}decrementTagRefs(p){const E=this.tags.get(p);E&&!--E.refCount&&(this.tags.delete(p),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.controllerId,p)}))}setItemParent(p,E){(0,S.getPrivateApiFor)(p).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(p,E,v){this.setItemParent(p,v);const d=(0,S.getPrivateApiFor)(p);d.parent=v?.actual,d.listener=w=>this.onTestItemEvent(E,w),this.updateExpandability(E)}connectItemAndChildren(p,E,v){this.connectItem(p,E,v);for(const d of p.children)this.upsertItem(d,E)}updateExpandability(p){let E;this._resolveHandler?p.resolveBarrier?E=p.resolveBarrier.isOpen()?3:2:E=p.actual.canResolveChildren?1:0:E=0,E!==p.expand&&(p.expand=E,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:E}}),E===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,E){if(E<0)return;const v=[];for(const d of p.actual.children){const w=this.expand(R.TestId.joinToString(p.fullId,d.id),E);(0,h.isThenable)(w)&&v.push(w)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const w=new h.Barrier;return w.open(),w}p.expand=2,this.pushExpandStateUpdate(p);const E=p.resolveBarrier=new h.Barrier,v=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),p.actual!==this.root&&(p.actual.error=w.stack||w.message||String(w))};let d;try{d=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(w){v(w)}return(0,h.isThenable)(d)?d.catch(v).then(()=>{E.open(),this.updateExpandability(p)}):(E.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const E=this.tree.get(p);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:p});const v=[E];for(;v.length;){const d=v.pop();if(!!d){(0,S.getPrivateApiFor)(d.actual).listener=void 0;for(const w of d.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(d.fullId.toString());for(const w of d.actual.children)v.push(this.tree.get(R.TestId.joinToString(d.fullId,w.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.SingleUseTestCollection=F}),define(we[223],be([1,0,4,185]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(t.IEnvironmentService)}),define(we[224],be([1,0,27,3,9]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class S{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let I of F.activationEvents)I==="onUri"&&(I=`onUri:${h.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(F)}}keepOnly(F){const I=new Set;F.forEach(p=>I.add(h.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>I.has(h.ExtensionIdentifier.toKey(p.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,I){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const p=S._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(p.map(E=>E.identifier)),I.length>0){const E=new Set;I.forEach(v=>E.add(h.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>!E.has(h.ExtensionIdentifier.toKey(v.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(p)}static _findLoopingExtensions(F){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,C){this.addNode(w),this.addNode(C),this._arcs.has(w)?this._arcs.get(w).push(C):this._arcs.set(w,[C])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,C){const P=I.getArcs(w);for(let l=0;l<P.length;l++)if(!C.has(P[l]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let w of F){const C=h.ExtensionIdentifier.toKey(w.identifier);if(p.set(C,w),w.extensionDependencies)for(let P of w.extensionDependencies){const l=h.ExtensionIdentifier.toKey(P);I.addArc(C,l)}}let E=new Set;I.getNodes().filter(w=>I.getArcs(w).length===0).forEach(w=>E.add(w));let v=I.getNodes().filter(w=>!E.has(w)),d;do{d=!1;for(let w=0;w<v.length;w++){const C=v[w];I.hasOnlyGoodArcs(C,E)&&(v.splice(w,1),w--,E.add(C),d=!0)}}while(d);return v.map(w=>p.get(w))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const I=this._activationMap.get(F);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const I=this._extensionsMap.get(h.ExtensionIdentifier.toKey(F));return I||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(D||(D={}));function _(R,F){const I=R.isBuiltin?0:R.isUnderDevelopment?2:1,p=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(I!==p)return I-p;const E=k.posix.basename(R.extensionLocation.path),v=k.posix.basename(F.extensionLocation.path);return E<v?-1:E>v?1:0}}),define(we[132],be([1,0,22]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(_){_[_.Desktop=1]="Desktop",_[_.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function S(_){const R=h.VSBuffer.alloc(1);switch(_){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=S;function D(_,R){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=D}),define(we[29],be([1,0,3,2,4,27,122]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var D;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class R{constructor(f){this.dependency=f}}e.MissingExtensionDependency=R;var F;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function p(c,f){return c.enabledApiProposals?c.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=p;function E(c,f){if(!p(c,f))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=E;class v{constructor(f,s,b,o){this.codeLoadingTime=f,this.activateCallTime=s,this.activateResolvedTime=b,this.activationReason=o}}e.ActivationTimes=v;class d{constructor(f,s){this.description=f,this.value=s}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var w;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(w=e.ActivationKind||(e.ActivationKind={}));function C(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=C;function P(c,f){return{identifier:new A.ExtensionIdentifier((0,S.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!f,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=P;class l{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(f){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,s){return Promise.resolve()}}e.NullExtensionService=l}),define(we[225],be([1,0,16,27,29,11]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(d,w,C,P){this.startup=d,this.codeLoadingTime=w,this.activateCallTime=C,this.activateResolvedTime=P}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class _{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,w){return d===-1||w===-1?-1:w-d}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class R{constructor(d,w,C,P,l,c){this.activationFailed=d,this.activationFailedError=w,this.activationTimes=C,this.module=P,this.exports=l,this.subscriptions=c}}e.ActivatedExtension=R;class F extends R{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class I extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class p extends R{constructor(d){super(!0,d,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let E=class{constructor(d,w,C,P,l){this._logService=l,this._isDisposed=!1,this._registry=d,this._resolvedExtensionsSet=new Set,w.forEach(c=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,C.forEach(c=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(c),c)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(d){const w=t.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(w)}getActivatedExtension(d){const w=t.ExtensionIdentifier.toKey(d),C=this._activatedExtensions.get(w);if(!C)throw new Error("Extension `"+d.value+"` is not known or not activated");return C}activateByEvent(d,w){if(this._alreadyActivatedEvents[d])return S;const C=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(C.map(P=>({id:P.identifier,reason:{startup:w,extensionId:P.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,w){const C=this._registry.getExtensionDescription(d);if(!C)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:C.identifier,reason:w}])}_handleActivateRequest(d,w,C){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(d.id))){w[t.ExtensionIdentifier.toKey(d.id)]=d;return}const P=this._registry.getExtensionDescription(d.id);if(!P){const f=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,f,new k.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(d.id),new p(f));return}const l=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let c=!0;for(let f=0,s=l.length;f<s;f++){const b=l[f];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(b)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(b));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const a=P.displayName||P.identifier.value,g=this._registry.getExtensionDescription(b),u=g&&g.displayName||b,m=new Error(`Cannot activate the '${a}' extension because its dependency '${u}' failed to activate`);m.detail=o.activationFailedError,this._host.onExtensionActivationError(P.identifier,m,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(P.identifier),new p(m));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(b))){c=!1,w[t.ExtensionIdentifier.toKey(b)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(b)),reason:d.reason};continue}const i=this._registry.getExtensionDescription(b);if(i){if(!i.main&&!i.browser)continue;c=!1,w[t.ExtensionIdentifier.toKey(b)]={id:i.identifier,reason:d.reason};continue}const r=P.displayName||P.identifier.value,n=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${b}'`);this._host.onExtensionActivationError(P.identifier,n,new k.MissingExtensionDependency(b)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(P.identifier),new p(n));return}c?w[t.ExtensionIdentifier.toKey(P.identifier)]=d:C.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(l=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(l.id))),d.length===0))return Promise.resolve(void 0);const w=Object.create(null),C=[];for(let l=0,c=d.length;l<c;l++)this._handleActivateRequest(d[l],w,C);for(let l=0,c=C.length;l<c;l++){const f=t.ExtensionIdentifier.toKey(C[l].id);w[f]&&delete w[f]}const P=Object.keys(w).map(l=>w[l]);return C.length===0?Promise.all(P.map(l=>this._activateExtension(l.id,l.reason))).then(l=>{}):this._activateExtensions(P).then(l=>this._activateExtensions(C))}_activateExtension(d,w){const C=t.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(C))return Promise.resolve(void 0);const P=this._activatingExtensions.get(C);if(P)return P;const l=this._host.actualActivateExtension(d,w).then(void 0,c=>{const f=new Error;return c&&c.name&&(f.name=c.name),c&&c.message?f.message=`Activating extension '${d.value}' failed: ${c.message}.`:f.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(f.stack=c.stack),this._isDisposed&&h.isCancellationError(c)?new p(c):(this._host.onExtensionActivationError(d,f,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new p(c))}).then(c=>{this._activatedExtensions.set(C,c),this._activatingExtensions.delete(C)});return this._activatingExtensions.set(C,l),l}};E=Be([Fe(4,A.ILogService)],E),e.ExtensionsActivator=E}),define(we[226],be([1,0,11,26,29]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends h.LogService{constructor(D,_){super(D.createLogger(_.logFile,{name:k.ExtensionHostLogFileName}))}};A=Be([Fe(0,h.ILoggerService),Fe(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(we[227],be([1,0,16]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,h.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(we[52],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(_){this._proxyIdentifierBrand=void 0,this.sid=_,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const t=[];function k(D){const _=new h(D);return t[_.nid]=_,_}e.createProxyIdentifier=k;function A(D){return t[D].sid}e.getStringIdentifierForProxy=A;class S{constructor(_){this.value=_}}e.SerializableObjectWithBuffers=S}),define(we[5],be([1,0,58,2,52]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var A;(function(C){C[C.Default=0]="Default",C[C.InCenter=1]="InCenter",C[C.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",C[C.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(C){C[C.Editable=0]="Editable",C[C.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(C){C[C.Int8Array=1]="Int8Array",C[C.Uint8Array=2]="Uint8Array",C[C.Uint8ClampedArray=3]="Uint8ClampedArray",C[C.Int16Array=4]="Int16Array",C[C.Uint16Array=5]="Uint16Array",C[C.Int32Array=6]="Int32Array",C[C.Uint32Array=7]="Uint32Array",C[C.Float32Array=8]="Float32Array",C[C.Float64Array=9]="Float64Array",C[C.BigInt64Array=10]="BigInt64Array",C[C.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var _;(function(C){C[C.Text=1]="Text",C[C.Error=2]="Error",C[C.Rich=3]="Rich"})(_=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(C){C[C.Default=0]="Default",C[C.InCenter=1]="InCenter",C[C.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",C[C.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var F;(function(C){C[C.None=0]="None",C[C.Process=1]="Process",C[C.Output=2]="Output"})(F=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(P){return P._id=I._n++,P}}e.IdObject=I,I._n=0;var p;(function(C){C.label="a",C.kind="b",C.detail="c",C.documentation="d",C.sortText="e",C.filterText="f",C.preselect="g",C.insertText="h",C.insertTextRules="i",C.range="j",C.commitCharacters="k",C.additionalTextEdits="l",C.command="m",C.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(C){C.defaultRanges="a",C.completions="b",C.isIncomplete="c",C.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(C){C[C.File=1]="File",C[C.Text=2]="Text",C[C.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function d(C){if(C&&C.edits)for(const P of C.edits)typeof P.resource=="object"?P.resource=t.URI.revive(P.resource):(P.newUri=t.URI.revive(P.newUri),P.oldUri=t.URI.revive(P.oldUri)),P.metadata&&P.metadata.iconPath&&(P.metadata=(0,h.revive)(P.metadata));return C}e.reviveWorkspaceEditDto=d;var w;(function(C){C[C.Workspace=0]="Workspace",C[C.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createProxyIdentifier)("ExtHostTelemetry")}}),define(we[86],be([1,0,5,3,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,R){return this._proxy.$setPassword(D,_,R)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(we[65],be([1,0,4,11,5,14]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(_,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(k.MainContext.MainThreadTelemetry)}report(_,R,F){const I=this.getUsageKey(_,R);this._reportedUsages.has(I)||(this._reportedUsages.add(I),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:_}))}getUsageKey(_,R){return`${_}-${R.identifier.value}`}};S=Be([Fe(0,A.IExtHostRpcService),Fe(1,t.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,R){}})}),define(we[228],be([1,0,3,5,7,27]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,R,F,I={}){const p=A.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(p)||[],v=[...F].sort().join(" ");let d=E.find(w=>w.scopes===v);if(d)return d.result;{const w=this._getSession(_,p,R,F,I);d={scopes:v,result:w},E.push(d),this._inFlightRequests.set(p,E);try{await w}finally{const C=E.findIndex(P=>P.scopes===v);C>-1&&(E.splice(C),this._inFlightRequests.set(p,E))}return w}}async _getSession(_,R,F,I,p={}){await this._proxy.$ensureProvider(F);const E=_.displayName||_.name;return this._proxy.$getSession(F,I,R,E,p)}async removeSession(_,R){const F=this._authenticationProviders.get(_);return F?F.provider.removeSession(R):this._proxy.$removeSession(_,R)}registerAuthenticationProvider(_,R,F,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:R,provider:F,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:R});const p=F.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,R,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(v=>v.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,R){const F=this._authenticationProviders.get(_);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,R){const F=this._authenticationProviders.get(_);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,R){const F=this._authenticationProviders.get(_);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,R){return this._onDidChangeSessions.fire({provider:{id:_,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(we[229],be([1,0,5,14,15]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,_){this._proxy=D.getProxy(h.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>_.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(D){const _=k.WorkspaceEdit.from(D,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(_)}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[230],be([1,0,5]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const S=A.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[39],be([1,0,18,7,15,25,5,17,11,58,37,48,2,6,4,14,63,22,52,49]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(n,a){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ke(this,c,n.getProxy(S.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new s(this,g=>{const u=this._apiCommands.get(g);return u?.result===o.Void?u:void 0},a),this._argumentProcessors=[{processArgument(g){return(0,R.revive)(g)}},{processArgument(g){return(0,A.cloneAndChange)(g,function(u){if(F.Range.isIRange(u))return k.Range.to(u);if(I.Position.isIPosition(u))return k.Position.to(u);if(F.Range.isIRange(u.range)&&p.URI.isUri(u.uri))return k.location.to(u);if(u instanceof C.VSBuffer)return u.buffer.buffer;if(!Array.isArray(u))return u})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const a=this.registerCommand(!1,n.id,async(...g)=>{const u=n.args.map((T,O)=>{if(!T.validate(g[O]))throw new Error(`Invalid argument '${T.name}' when running '${n.id}', received: ${g[O]}`);return T.convert(g[O])}),m=await this.executeCommand(n.internalId,...u);return n.result.convert(m,g,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,a,g,u,m,T){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:g,thisArg:u,description:m,extension:T}),n&&Pe(this,c,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&n&&Pe(this,c,"f").$unregisterCommand(a)})}executeCommand(n,...a){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,a,!0)}async _doExecuteCommand(n,a,g){if(this._commands.has(n))return this._executeContributedCommand(n,a,!1);{let u=!1;const m=(0,A.cloneAndChange)(a,function(T){if(T instanceof t.Position)return k.Position.from(T);if(T instanceof t.Range)return k.Range.from(T);if(T instanceof t.Location)return k.location.from(T);if(t.NotebookRange.isNotebookRange(T))return k.NotebookRange.from(T);if(T instanceof ArrayBuffer)return u=!0,C.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return u=!0,C.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await Pe(this,c,"f").$executeCommand(n,u?new P.SerializableObjectWithBuffers(m):m,g);return(0,R.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(n,a,!1);throw T}}}async _executeContributedCommand(n,a,g){const u=this._commands.get(n);if(!u)throw new Error("Unknown command");let{callback:m,thisArg:T,description:O}=u;if(O)for(let L=0;L<O.args.length;L++)try{(0,h.validateConstraint)(a[L],O.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${O.args[L].name}' - ${O.args[L].description}`)}try{return await m.apply(T,a)}catch(L){if(n===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...a);y&&(n=y.command)}throw this._logService.error(L,n,u.extension?.identifier),g?new class extends Error{constructor(){super((0,l.toErrorMessage)(L));this.id=n,this.source=u.extension?.displayName??u.extension?.name}}:L}}$executeContributedCommand(n,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(a=a.map(g=>this._argumentProcessors.reduce((u,m)=>m.processArgument(u),g)),this._executeContributedCommand(n,a,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Pe(this,c,"f").$getCommands().then(a=>(n&&(a=a.filter(g=>g[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[a,g]of this._commands){let{description:u}=g;u&&(n[a]=u)}return Promise.resolve(n)}};c=new WeakMap,f=Be([Fe(0,d.IExtHostRpcService),Fe(1,_.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class s{constructor(n,a,g){this._commands=n,this._lookupApiCommand=a,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,a){if(!n)return;const g={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return g;const u=this._lookupApiCommand(n.command);if(u)g.id=u.internalId,g.arguments=u.args.map((m,T)=>m.convert(n.arguments&&n.arguments[T]));else if((0,D.isNonEmptyArray)(n.arguments)){const m=++this._cachIdPool;this._cache.set(m,n),a.add((0,E.toDisposable)(()=>{this._cache.delete(m),this._logService.trace("CommandsConverter#DISPOSE",m)})),g.$ident=m,g.id=this.delegatingCommandId,g.arguments=[m],this._logService.trace("CommandsConverter#CREATE",n.command,m)}return g}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const a=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class b{constructor(n,a,g,u){this.name=n,this.description=a,this.validate=g,this.convert=u}optional(){return new b(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,a){return new b(n??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",r=>p.URI.isUri(r),r=>r),b.Position=new b("position","A position in a text document",r=>t.Position.isPosition(r),k.Position.from),b.Range=new b("range","A range in a text document",r=>t.Range.isRange(r),k.Range.from),b.Selection=new b("selection","A selection in a text document",r=>t.Selection.isSelection(r),k.Selection.from),b.Number=new b("number","",r=>typeof r=="number",r=>r),b.String=new b("string","",r=>typeof r=="string",r=>r),b.CallHierarchyItem=new b("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),b.TestItem=new b("testItem","A VS Code TestItem",r=>r instanceof w.TestItemImpl,k.TestItem.from);class o{constructor(n,a){this.description=n,this.convert=a}}e.ApiCommandResult=o,o.Void=new o("no result",r=>r);class i{constructor(n,a,g,u,m){this.id=n,this.internalId=a,this.description=g,this.args=u,this.result=m}}e.ApiCommand=i}),define(we[231],be([1,0,2,15,7,79,39,17,111,117,10]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(t.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,w)=>{if((0,D.isFalsyOrEmpty)(d))return;class C extends k.SymbolInformation{static to(l){const c=new C(l.name,t.SymbolKind.to(l.kind),l.containerName||"",new k.Location(w[0],t.Range.to(l.range)));return c.detail=l.detail,c.range=c.location.range,c.selectionRange=t.Range.to(l.selectionRange),c.children=l.children?l.children.map(C.to):[],c}}return d.map(C.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new S.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(t.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(t.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(w=>k.Position.isPosition(w)),d=>d.map(t.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(w=>{let C;for(const P of w.reverse())C=new k.SelectionRange(t.Range.to(P),C);return C}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const w=(0,_.decodeSemanticTokensDto)(d);if(w.type==="full")return new k.SemanticTokens(w.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const w=(0,_.decodeSemanticTokensDto)(d);if(w.type==="full")return new k.SemanticTokens(w.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,w,C)=>{if(!d)return new k.CompletionList([]);const P=d.suggestions.map(l=>t.CompletionItem.to(l,C));return new k.CompletionList(P,d.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,w,C)=>E(P=>new k.CodeLens(t.Range.to(P.range),P.command&&C.fromInternal(P.command)))(d))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>k.Range.isRange(d),d=>k.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,w,C)=>E(P=>{if(P._isSynthetic){if(!P.command)throw new Error("Synthetic code actions must have a command");return C.fromInternal(P.command)}else{const l=new k.CodeAction(P.title,P.kind?new k.CodeActionKind(P.kind):void 0);return P.edit&&(l.edit=t.WorkspaceEdit.to(P.edit)),P.command&&(l.command=C.fromInternal(P.command)),l.isPreferred=P.isPreferred,l}})(d))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(w=>new k.ColorInformation(t.Range.to(w.range),t.Color.to(w.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",d=>d instanceof k.Color,t.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,w,C)=>d.map(t.InlayHint.to.bind(void 0,C)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(w=>t.NotebookExclusiveDocumentPattern.to(w))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>h.URI.isUri(d)||typeof d=="string"&&(0,R.matchesSomeScheme)(d,F.Schemas.http,F.Schemas.https),d=>d),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class p{static register(w){I.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=p;function E(d){return w=>{if(Array.isArray(w))return w.map(d)}}function v(d){if(!Array.isArray(d))return;const w=[];for(const C of d)A.isLocationLink(C)?w.push(t.DefinitionLink.to(C)):w.push(t.location.to(C));return w}}),define(we[232],be([1,0,13,56,3,6,2,79,27,15,7,29,5]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(v,d,w){const C=v.getProxy(p.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const n=this._commentControllers.get(r.handle);return n||r}else if(r&&r.$mid===7){const n=this._commentControllers.get(r.commentControlHandle);if(!n)return r;const a=n.getCommentThread(r.commentThreadHandle);return a||r}else if(r&&r.$mid===8){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const a=n.getCommentThread(r.thread.commentThreadHandle);return a?{thread:a,text:r.text}:r}else if(r&&r.$mid===9){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const a=n.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let g=r.commentUniqueId,u=a.getCommentByUniqueId(g);return u||r}else if(r&&r.$mid===10){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const a=n.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let g=r.text,u=r.commentUniqueId,m=a.getCommentByUniqueId(u);return m?(m.body=g,m):r}return r}})}createCommentController(r,n,a){const g=P.handlePool++,u=new c(r,g,n,a);this._commentControllers.set(u.handle,u);const m=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(r.identifier))||[];return m.push(u),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(r.identifier),m),u.value}$createCommentThreadTemplate(r,n,a){const g=this._commentControllers.get(r);!g||g.$createCommentThreadTemplate(n,a)}async $updateCommentThreadTemplate(r,n,a){const g=this._commentControllers.get(r);!g||g.$updateCommentThreadTemplate(n,a)}$deleteCommentThread(r,n){const a=this._commentControllers.get(r);a&&a.$deleteCommentThread(n)}$provideCommentingRanges(r,n,a){const g=this._commentControllers.get(r);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const u=w.getDocument(S.URI.revive(n));return(0,h.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(u,a)).then(m=>m?m.map(T=>R.Range.from(T)):void 0)}$toggleReaction(r,n,a,g,u){const m=this._commentControllers.get(r);return!m||!m.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const T=m.getCommentThread(n);if(T){const O=T.getCommentByUniqueId(g.uniqueIdInThread);if(m!==void 0&&O&&m.reactionHandler)return m.reactionHandler(O,b(u))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class l{constructor(r,n,a,g,u,m,T){this._commentControllerHandle=n,this._id=a,this._uri=g,this._range=u,this._comments=m,this.extensionDescription=T,this.handle=l._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),C.$createCommentThread(n,this.handle,this._id,this._uri,R.Range.from(this._range),T.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=m,this._localDisposables.push({dispose:()=>{C.$deleteCommentThread(n,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(L){O.range=L},get comments(){return O.comments},set comments(L){O.comments=L},get collapsibleState(){return O.collapsibleState},set collapsibleState(L){O.collapsibleState=L},get canReply(){return O.canReply},set canReply(L){O.canReply=L},get contextValue(){return O.contextValue},set contextValue(L){O.contextValue=L},get label(){return O.label},set label(L){O.label=L},dispose:()=>{O.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),n={};r("range")&&(n.range=R.Range.from(this._range)),r("label")&&(n.label=this.label),r("contextValue")&&(n.contextValue=this.contextValue??null),r("comments")&&(n.comments=this._comments.map(a=>f(this,a,this._commentsMap))),r("collapsibleState")&&(n.collapseState=o(this._collapseState)),r("canReply")&&(n.canReply=this.canReply),this.modifications={},C.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(r){for(let n of this._commentsMap){let a=n[0],g=n[1];if(r===g)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}l._handlePool=0,Be([(0,t.debounce)(100)],l.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(r,n,a,g){this._extension=r,this._handle=n,this._id=a,this._label=g,this._threads=new Map,C.$registerCommentController(this.handle,a,g);const u=this;this.value=Object.freeze({id:u.id,label:u.label,get options(){return u.options},set options(m){u.options=m},get commentingRangeProvider(){return u.commentingRangeProvider},set commentingRangeProvider(m){u.commentingRangeProvider=m},get reactionHandler(){return u.reactionHandler},set reactionHandler(m){u.reactionHandler=m},createCommentThread(m,T,O){return u.createCommentThread(m,T,O).value},dispose:()=>{u.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{C.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,C.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,C.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,C.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,n,a,g){if(typeof r=="string"){const u=new l(this.id,this.handle,r,n,a,g,this._extension);return this._threads.set(u.handle,u),u}else{const u=new l(this.id,this.handle,void 0,r,n,a,this._extension);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(r,n){const a=new l(this.id,this.handle,void 0,S.URI.revive(r),R.Range.to(n),[],this._extension);return a.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(r,n){let a=this._threads.get(r);a&&(a.range=R.Range.to(n))}$deleteCommentThread(r){let n=this._threads.get(r);n&&n.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function f(i,r,n){let a=n.get(r);a||(a=++i.commentHandle,n.set(r,a));const g=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;r.timestamp&&(0,I.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let u;return r.timestamp&&(u={source:r.timestamp,$mid:14}),{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:a,body:typeof r.body=="string"?r.body:R.MarkdownString.from(r.body),userName:r.author.name,userIconPath:g,label:r.label,commentReactions:r.reactions?r.reactions.map(m=>s(m)):void 0,timestamp:u}}function s(i){return{label:i.label,iconPath:i.iconPath?R.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function b(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?S.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function o(i){if(i!==void 0)switch(i){case F.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=E}),define(we[133],be([1,0,2,5,7,4,14,11,17,8,9]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Ei{constructor(E,v){this._logService=v,this._provider=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,v){const d=Ei._handlePool++;this._provider.set(d,{provider:E,extensionId:v}),this._proxy.$registerDecorationProvider(d,v.value);const w=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(C=>{if(!C){this._proxy.$onDidChange(d,null);return}let P=(0,_.asArray)(C);if(P.length<=Ei._maxEventSize){this._proxy.$onDidChange(d,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.value,P.length);const l=P.map(s=>({uri:s,rank:(0,R.count)(s.path,"/")})),c=(0,_.groupBy)(l,(s,b)=>s.rank-b.rank||(0,R.compare)(s.uri.path,b.uri.path));let f=[];e:for(let s of c){let b;for(let o of s){let i=(0,F.dirname)(o.uri.path);if(b!==i&&(b=i,f.push(o.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(d,f)});return new k.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(E,v,d){if(!this._provider.has(E))return Object.create(null);const w=Object.create(null),{provider:C,extensionId:P}=this._provider.get(E);return await Promise.all(v.map(async l=>{try{const{uri:c,id:f}=l,s=await Promise.resolve(C.provideFileDecoration(h.URI.revive(c),d));if(!s)return;try{k.FileDecoration.validate(s),w[f]=[s.propagate,s.tooltip,s.badge,s.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${P.value}': ${b}`)}}catch(c){this._logService.error(c)}})),w}};I._handlePool=0,I._maxEventSize=250,I=Be([Fe(0,S.IExtHostRpcService),Fe(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[233],be([1,0,166,116,2,5,7,15,3,11,24,44]),function(te,e,h,t,k,A,S,D,_,R,F,I){"use strict";var p,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(P,l,c,f,s,b){this._name=P,this._owner=l,this._maxDiagnosticsPerFile=c,p.set(this,void 0),E.set(this,void 0),v.set(this,void 0),this._isDisposed=!1,Ke(this,v,new F.ResourceMap(o=>f.getComparisonKey(o)),"f"),Ke(this,p,s,"f"),Ke(this,E,b,"f")}dispose(){this._isDisposed||(Pe(this,E,"f").fire([...Pe(this,v,"f").keys()]),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner),Pe(this,v,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(P,l){if(!P){this.clear();return}this._checkDisposed();let c=[];if(k.URI.isUri(P)){if(!l){this.delete(P);return}Pe(this,v,"f").set(P,l.slice()),c=[P]}else if(Array.isArray(P)){c=[];let s;P=[...P].sort(d._compareIndexedTuplesByUri);for(const b of P){const[o,i]=b;if((!s||o.toString()!==s.toString())&&(s&&Pe(this,v,"f").get(s).length===0&&Pe(this,v,"f").delete(s),s=o,c.push(o),Pe(this,v,"f").set(o,[])),i){const r=Pe(this,v,"f").get(o);r&&r.push(...i)}else{const r=Pe(this,v,"f").get(o);r&&(r.length=0)}}}if(Pe(this,E,"f").fire(c),!Pe(this,p,"f"))return;const f=[];for(let s of c){let b=[];const o=Pe(this,v,"f").get(s);if(o)if(o.length>this._maxDiagnosticsPerFile){b=[];const i=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let n of o)if(n.severity===i[r]&&b.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;b.push({severity:t.MarkerSeverity.Info,message:(0,h.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=o.map(i=>D.Diagnostic.from(i));f.push([s,b])}Pe(this,p,"f").$changeMany(this._owner,f)}delete(P){this._checkDisposed(),Pe(this,E,"f").fire([P]),Pe(this,v,"f").delete(P),Pe(this,p,"f")&&Pe(this,p,"f").$changeMany(this._owner,[[P,void 0]])}clear(){this._checkDisposed(),Pe(this,E,"f").fire([...Pe(this,v,"f").keys()]),Pe(this,v,"f").clear(),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner)}forEach(P,l){this._checkDisposed();for(let c of Pe(this,v,"f").keys())P.apply(l,[c,this.get(c),this])}get(P){this._checkDisposed();const l=Pe(this,v,"f").get(P);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(P){return this._checkDisposed(),Array.isArray(Pe(this,v,"f").get(P))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(P,l){return P[0].toString()<l[0].toString()?-1:P[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=d,p=new WeakMap,E=new WeakMap,v=new WeakMap;let w=class si{constructor(P,l,c){this._logService=l,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=P.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(P){const l=new F.ResourceMap;for(const c of P)l.set(c,c);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(P,l){const{_collections:c,_proxy:f,_onDidChangeDiagnostics:s,_logService:b,_fileSystemInfoService:o}=this,i=new class{$changeMany(a,g){f.$changeMany(a,g),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",P.value,a,g.length===0?"CLEARING":g)}$clear(a){f.$clear(a),b.trace("[DiagnosticCollection] remove all (extension, owner)",P.value,a)}dispose(){f.dispose()}};let r;if(!l)l="_generated_diagnostic_collection_name_#"+si._idPool++,r=l;else if(!c.has(l))r=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do r=l+si._idPool++;while(c.has(r))}return new class extends d{constructor(){super(l,r,si._maxDiagnosticsPerFile,o.extUri,i,s);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(P){if(P)return this._getDiagnostics(P);{const l=new Map,c=[];for(const f of this._collections.values())f.forEach((s,b)=>{let o=l.get(s.toString());typeof o=="undefined"&&(o=c.length,l.set(s.toString(),o),c.push([s,[]])),c[o][1]=c[o][1].concat(...b)});return c}}_getDiagnostics(P){let l=[];for(let c of this._collections.values())c.has(P)&&(l=l.concat(c.get(P)));return l}$acceptMarkersChange(P){if(!this._mirrorCollection){const l="_generated_mirror",c=new d(l,l,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,c),this._mirrorCollection=c}for(const[l,c]of P)this._mirrorCollection.set(k.URI.revive(l),c.map(D.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=Be([Fe(1,R.ILogService),Fe(2,I.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(we[234],be([1,0,2,5]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(S){this._proxy=S.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(_=>h.URI.revive(_)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?h.URI.revive(D):void 0)}}e.ExtHostDialogs=k}),define(we[235],be([1,0,16,2,7,5,10,21,8]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(I,p,E){this._documentsAndEditors=p,this._logService=E,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(S.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const E=R._handlePool++;this._documentContentProviders.set(E,p),this._proxy.$registerTextContentProvider(E,I);let v;return typeof p.onDidChange=="function"&&(v=p.onDidChange(d=>{if(d.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(E,d).then(w=>{if(!w&&typeof w!="string")return;const C=this._documentsAndEditors.getDocument(d);if(!C)return;const P=(0,_.splitLines)(w);if(!C.equalLines(P))return this._proxy.$onVirtualDocumentChange(d,w)},h.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(I,p){const E=this._documentContentProviders.get(I);return E?Promise.resolve(E.provideTextDocumentContent(t.URI.revive(p),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(we[236],be([1,0,3,6,2,5,125,15,18,25,7]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(E,v){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=v,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const w of d)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const w of d)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const v=this._documentsAndEditors.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this._documentsAndEditors.getDocument(E);if(v)return Promise.resolve(v);let d=this._documentLoader.get(E.toString());return d||(d=this._proxy.$tryOpenDocument(E).then(w=>{this._documentLoader.delete(E.toString());const C=k.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(C))},w=>(this._documentLoader.delete(E.toString()),Promise.reject(w))),this._documentLoader.set(E.toString(),d)),d}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(v=>k.URI.revive(v))}$acceptModelLanguageChanged(E,v){const d=k.URI.revive(E),w=this._documentsAndEditors.getDocument(d);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(v),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(E){const v=k.URI.revive(E),d=this._documentsAndEditors.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(E,v){const d=k.URI.revive(E),w=this._documentsAndEditors.getDocument(d);if(!w)throw new Error("unknown document");w._acceptIsDirty(v),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,d){const w=k.URI.revive(E),C=this._documentsAndEditors.getDocument(w);if(!C)throw new Error("unknown document");C._acceptIsDirty(d),C.onEvents(v);let P;v.isUndoing?P=F.TextDocumentChangeReason.Undo:v.isRedoing&&(P=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:C.document,contentChanges:v.changes.map(l=>({range:D.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:P}))}setWordDefinitionFor(E,v){(0,S.setWordDefinitionFor)(E,v)}}e.ExtHostDocuments=I}),define(we[45],be([1,0,55,3,6,2,4,5,125,14,131,15,11,24,10,77,89]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class C{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(c,f){this._extHostRpc=c,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const f=[],s=[],b=[];if(c.removedDocuments)for(const o of c.removedDocuments){const i=A.URI.revive(o),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),f.push(r.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const i=A.URI.revive(o.uri);let r=this._documents.get(i);if(r&&i.scheme!==v.Schemas.vscodeNotebookCell&&i.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new C(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(c.removedEditors)for(const o of c.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&b.push(i)}if(c.addedEditors)for(const o of c.addedEditors){const i=A.URI.revive(o.documentUri);h.ok(this._documents.has(i),`document '${i}' does not exist`),h.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const r=this._documents.get(i).value,n=new F.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>r.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(a=>I.Range.to(a)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,n)}c.newActiveEditor!==void 0&&(h.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,k.dispose)(f),(0,k.dispose)(b),c.removedDocuments&&this._onDidRemoveDocuments.fire(f),c.addedDocuments&&this._onDidAddDocuments.fire(s),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return c?f:f?.value}allEditors(){return[...this._editors.values()]}};P=Be([Fe(0,R.IExtHostRpcService),Fe(1,p.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[53],be([1,0,15,5,2,3,4,14,13]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");let R=class{constructor(I){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let p=-1;this._tabs=I.map((v,d)=>(v.isActive&&(p=d),Object.freeze({label:v.label,viewColumn:h.ViewColumn.to(v.viewColumn),index:d,resource:k.URI.revive(v.resource),additionalResourcesAndViewIds:v.additionalResourcesAndViewIds.map(({resource:w,viewId:C})=>({resource:k.URI.revive(w),viewId:C})),viewId:v.editorId,isActive:v.isActive,move:async(w,C)=>{this._proxy.$moveTab(v,w,h.ViewColumn.from(C)),await(0,_.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(v),await(0,_.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((v,d)=>v.viewColumn===d.viewColumn?v.index-d.index:v.viewColumn-d.viewColumn);const E=this._activeTab;this._activeTab=p===-1?void 0:this._tabs[p],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Be([Fe(0,D.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(we[237],be([1,0,2,5,6,7,15,150,8,22,29]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(v){this._stateMachine=void 0,this._schemes.push(v)}delete(v){const d=this._schemes.indexOf(v);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const v=this._schemes.sort(),d=[];let w,C,P=14,l=14;for(const c of v){let f=w?(0,_.commonPrefixLength)(w,c):0;for(f===0?C=1:C=l;f<c.length;f++)f+1===c.length?(P=l,l=9):l+=1,d.push([C,c.toUpperCase().charCodeAt(f),l]),d.push([C,c.toLowerCase().charCodeAt(f),l]),C=l;w=c,l=P}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new D.StateMachine(d)}}provideDocumentLinks(v){this._initStateMachine();const d=[],w=D.LinkComputer.computeLinks({getLineContent(C){return v.lineAt(C-1).text},getLineCount(){return v.lineCount}},this._stateMachine);for(const C of w){const P=S.DocumentLink.to(C);P.target&&d.push(P)}return d}}class p{constructor(v,d){this._extHostLanguageFeatures=d,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(v,d,w,C={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(v,"*",this._linkProvider));const P=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(P,w);let l=2;C.isCaseSensitive&&(l+=1024),C.isReadonly&&(l+=2048),typeof w.copy=="function"&&(l+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,F.checkProposedApiEnabled)(v,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(P,d,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(f)});const c=w.onDidChangeFile(f=>{const s=[];for(const b of f){let{uri:o,type:i}=b;if(o.scheme!==d)continue;let r;switch(i){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:r})}this._proxy.$onFileSystemChange(P,s)});return(0,k.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(v){const{type:d,ctime:w,mtime:C,size:P,permissions:l}=v;return{type:d,ctime:w,mtime:C,size:P,permissions:l}}$stat(v,d){return Promise.resolve(this._getFsProvider(v).stat(h.URI.revive(d))).then(w=>p._asIStat(w))}$readdir(v,d){return Promise.resolve(this._getFsProvider(v).readDirectory(h.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this._getFsProvider(v).readFile(h.URI.revive(d))).then(w=>R.VSBuffer.wrap(w))}$writeFile(v,d,w,C){return Promise.resolve(this._getFsProvider(v).writeFile(h.URI.revive(d),w.buffer,C))}$delete(v,d,w){return Promise.resolve(this._getFsProvider(v).delete(h.URI.revive(d),w))}$rename(v,d,w,C){return Promise.resolve(this._getFsProvider(v).rename(h.URI.revive(d),h.URI.revive(w),C))}$copy(v,d,w,C){const P=this._getFsProvider(v);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(h.URI.revive(d),h.URI.revive(w),C))}$mkdir(v,d){return Promise.resolve(this._getFsProvider(v).createDirectory(h.URI.revive(d)))}$watch(v,d,w,C){const P=this._getFsProvider(v).watch(h.URI.revive(w),C);this._watches.set(d,P)}$unwatch(v,d){const w=this._watches.get(d);w&&(w.dispose(),this._watches.delete(d))}$open(v,d,w){const C=this._getFsProvider(v);if(!C.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(C.open(h.URI.revive(d),w))}$close(v,d){const w=this._getFsProvider(v);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(d))}$read(v,d,w,C){const P=this._getFsProvider(v);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const l=R.VSBuffer.alloc(C);return Promise.resolve(P.read(d,w,l.buffer,0,C)).then(c=>l.slice(0,c))}$write(v,d,w,C){const P=this._getFsProvider(v);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(d,w,C.buffer,0,C.byteLength))}_getFsProvider(v){const d=this._fsProvider.get(v);if(!d){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return d}}e.ExtHostFileSystem=p}),define(we[66],be([1,0,5,42,7,22,4,14,44,6]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Gt{constructor(p,E){this._fileSystemProvider=new Map,this._proxy=p.getProxy(h.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const w=v._fileSystemProvider.get(d.scheme);if(!w)return await v._proxy.$stat(d);await v._proxy.$ensureActivation(d.scheme);const C=await w.stat(d);return{type:C.type,ctime:C.ctime,mtime:C.mtime,size:C.size,permissions:C.permissions}}catch(w){Gt._handleError(w)}},async readDirectory(d){try{const w=v._fileSystemProvider.get(d.scheme);return w?(await v._proxy.$ensureActivation(d.scheme),(await w.readDirectory(d)).slice()):await v._proxy.$readdir(d)}catch(w){return Gt._handleError(w)}},async createDirectory(d){try{return await v._proxy.$mkdir(d)}catch(w){return Gt._handleError(w)}},async readFile(d){try{const w=v._fileSystemProvider.get(d.scheme);return w?(await v._proxy.$ensureActivation(d.scheme),(await w.readFile(d)).slice()):(await v._proxy.$readFile(d)).buffer}catch(w){return Gt._handleError(w)}},async writeFile(d,w){try{return await v._proxy.$writeFile(d,A.VSBuffer.wrap(w))}catch(C){return Gt._handleError(C)}},async delete(d,w){try{const C=v._fileSystemProvider.get(d.scheme);return C?(await v._proxy.$ensureActivation(d.scheme),await C.delete(d,{recursive:!1,...w})):await v._proxy.$delete(d,{recursive:!1,useTrash:!1,...w})}catch(C){return Gt._handleError(C)}},async rename(d,w,C){try{return await v._proxy.$rename(d,w,{overwrite:!1,...C})}catch(P){return Gt._handleError(P)}},async copy(d,w,C){try{return await v._proxy.$copy(d,w,{overwrite:!1,...C})}catch(P){return Gt._handleError(P)}},isWritableFileSystem(d){const w=E.getCapabilities(d);if(typeof w=="number")return!(w&2048)}})}static _handleError(p){if(p instanceof k.FileSystemError)throw p;if(!(p instanceof Error))throw new k.FileSystemError(String(p));if(p.name==="ENOPRO")throw k.FileSystemError.Unavailable(p.message);switch(p.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(p.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(p.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(p.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(p.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(p.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(p.message);default:throw new k.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,E){return this._fileSystemProvider.set(p,E),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(p))}};F=Be([Fe(0,D.IExtHostRpcService),Fe(1,_.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(we[238],be([1,0,3,32,2,5,15,7]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,p,E,v,d,w,C,P){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter;const l=this.ensureWatching(I,E,d);this._config=0,w&&(this._config+=1),C&&(this._config+=2),P&&(this._config+=4);const c=(0,t.parse)(d),f=typeof d=="string",s=v(b=>{if(!w)for(let o of b.created){const i=k.URI.revive(o);c(i.fsPath)&&(!f||p.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!C)for(let o of b.changed){const i=k.URI.revive(o);c(i.fsPath)&&(!f||p.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!P)for(let o of b.deleted){const i=k.URI.revive(o);c(i.fsPath)&&(!f||p.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=D.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(I,p,E){let v=D.Disposable.from();if(typeof E=="string")return v;const d=I.getProxy(A.MainContext.MainThreadFileSystem);let w=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(w=!0);const C=Math.random();return d.$watch(p.identifier.value,C,E.baseUri,{recursive:w,excludes:[]}),D.Disposable.from({dispose:()=>d.$unwatch(C)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(I,p,E){this._mainContext=I,this._logService=p,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,p,E,v,d,w){return new _(this._mainContext,I,p,this._onFileSystemEvent.event,S.GlobPattern.from(E),v,d,w)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,p){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(E=>({oldUri:k.URI.revive(E.source),newUri:k.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(E=>k.URI.revive(E.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:p.map(E=>k.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,p){return(E,v,d)=>{const w=function(P){E.call(v,P)};return w.extension=I,p.event(w,void 0,d)}}async $onWillRunFileOperation(I,p,E,v){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},E,v);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(d=>k.URI.revive(d.target))},E,v);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(d=>k.URI.revive(d.target))},E,v)}}async _fireWillEvent(I,p,E,v){const d=new Set,w=[];if(await I.fireAsync(p,v,async(P,l)=>{const c=Date.now(),f=await Promise.resolve(P);f instanceof D.WorkspaceEdit&&(w.push(f),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-c>E&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),v.isCancellationRequested||w.length===0)return;const C={edits:[]};for(let P of w){let{edits:l}=S.WorkspaceEdit.from(P,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});C.edits=C.edits.concat(l)}return{edit:C,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=R}),define(we[239],be([1,0,2,39]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(S,D,_,R){this._extHostNotebooks=D,this._textDocumentsAndEditors=_,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new t.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new t.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new t.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new t.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:h.URI.revive(I.notebookUri),inputUri:h.URI.revive(I.inputUri),notebookEditor:p.apiEditor}}return{notebookUri:h.URI.revive(I.notebookUri),inputUri:h.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(S,D,_,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:_,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=k}),define(we[240],be([1,0,6,5]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(S){this._handlePool=0,this._proxy=S.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=k}),define(we[241],be([1,0,2,25,15,7,5,8,37,17,18,146,21,6,111,76,82,46,16,3,13]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor($,U){this._documents=$,this._provider=U}async provideDocumentSymbols($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentSymbols(N,U);if(!(0,R.isFalsyOrEmpty)(W))return W[0]instanceof A.DocumentSymbol?W.map(k.DocumentSymbol.from):f._asDocumentSymbolTree(W)}static _asDocumentSymbolTree($){$=$.slice(0).sort((W,j)=>{let re=W.location.range.start.compareTo(j.location.range.start);return re===0&&(re=j.location.range.end.compareTo(W.location.range.end)),re});const U=[],N=[];for(const W of $){const j={name:W.name||"!!MISSING: name!!",kind:k.SymbolKind.from(W.kind),tags:W.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:k.Range.from(W.location.range),selectionRange:k.Range.from(W.location.range),children:[]};for(;;){if(N.length===0){N.push(j),U.push(j);break}const re=N[N.length-1];if(_.Range.containsRange(re.range,j.range)&&!_.Range.equalsRange(re.range,j.range)){re.children&&re.children.push(j),N.push(j);break}N.pop()}}return U}}class s{constructor($,U,N){this._documents=$,this._commands=U,this._provider=N,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,U){const N=this._documents.getDocument($),W=await this._provider.provideCodeLenses(N,U);if(!W||U.isCancellationRequested)return;const j=this._cache.add(W),re=new E.DisposableStore;this._disposables.set(j,re);const he={cacheId:j,lenses:[]};for(let Ce=0;Ce<W.length;Ce++)he.lenses.push({cacheId:[j,Ce],range:k.Range.from(W[Ce].range),command:this._commands.toInternal(W[Ce].command,re)});return he}async resolveCodeLens($,U){const N=$.cacheId&&this._cache.get(...$.cacheId);if(!N)return;let W;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?W=N:W=await this._provider.resolveCodeLens(N,U),W||(W=N),U.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(W.command??s._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(Ee){return Array.isArray(Ee)?Ee.map(k.DefinitionLink.from):Ee?[k.DefinitionLink.from(Ee)]:[]}class o{constructor($,U){this._documents=$,this._provider=U}async provideDefinition($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideDefinition(W,j,N);return b(re)}}class i{constructor($,U){this._documents=$,this._provider=U}async provideDeclaration($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideDeclaration(W,j,N);return b(re)}}class r{constructor($,U){this._documents=$,this._provider=U}async provideImplementation($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideImplementation(W,j,N);return b(re)}}class n{constructor($,U){this._documents=$,this._provider=U}async provideTypeDefinition($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideTypeDefinition(W,j,N);return b(re)}}class a{constructor($,U){this._documents=$,this._provider=U}async provideHover($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideHover(W,j,N);if(!(!re||(0,R.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=W.getWordRangeAtPosition(j)),re.range||(re.range=new A.Range(j,j)),k.Hover.from(re)}}class g{constructor($,U){this._documents=$,this._provider=U}async provideEvaluatableExpression($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideEvaluatableExpression(W,j,N);if(re)return k.EvaluatableExpression.from(re)}}class u{constructor($,U){this._documents=$,this._provider=U}async provideInlineValues($,U,N,W){const j=this._documents.getDocument($),re=await this._provider.provideInlineValues(j,k.Range.to(U),k.InlineValueContext.to(N),W);if(Array.isArray(re))return re.map(he=>k.InlineValue.from(he))}}class m{constructor($,U){this._documents=$,this._provider=U}async provideDocumentHighlights($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideDocumentHighlights(W,j,N);if(Array.isArray(re))return re.map(k.DocumentHighlight.from)}}class T{constructor($,U){this._documents=$,this._provider=U}async provideLinkedEditingRanges($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.provideLinkedEditingRanges(W,j,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,R.coalesce)(re.ranges.map(k.Range.from)),wordPattern:re.wordPattern}}}class O{constructor($,U){this._documents=$,this._provider=U}async provideReferences($,U,N,W){const j=this._documents.getDocument($),re=k.Position.to(U),he=await this._provider.provideReferences(j,re,N,W);if(Array.isArray(he))return he.map(k.location.from)}}class L{constructor($,U,N,W,j,re,he){this._documents=$,this._commands=U,this._diagnostics=N,this._provider=W,this._logService=j,this._extension=re,this._apiDeprecation=he,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,U,N,W){const j=this._documents.getDocument($),re=I.Selection.isISelection(U)?k.Selection.to(U):k.Range.to(U),he=[];for(const $e of this._diagnostics.getDiagnostics($))if(re.intersection($e.range)&&he.push($e)>L._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new A.CodeActionKind(N.only):void 0,triggerKind:k.CodeActionTriggerKind.to(N.trigger)},Ae=await this._provider.provideCodeActions(j,re,Ce,W);if(!(0,R.isNonEmptyArray)(Ae)||W.isCancellationRequested)return;const We=this._cache.add(Ae),ze=new E.DisposableStore;this._disposables.set(We,ze);const je=[];for(let $e=0;$e<Ae.length;$e++){const Ue=Ae[$e];!Ue||(L._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,ze)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[We,$e],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,ze),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(k.Diagnostic.from),edit:Ue.edit&&k.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:je}}async resolveCodeAction($,U){const[N,W]=$,j=this._cache.get(N,W);if(!j||L._isCommand(j)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(j,U)??j;return re?.edit?k.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}L._maxCodeActionsPerFile=1e3;class y{constructor($,U){this._documents=$,this._provider=U}async provideDocumentFormattingEdits($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(W,U,N);if(Array.isArray(j))return j.map(k.TextEdit.from)}}class H{constructor($,U){this._documents=$,this._provider=U}async provideDocumentRangeFormattingEdits($,U,N,W){const j=this._documents.getDocument($),re=k.Range.to(U),he=await this._provider.provideDocumentRangeFormattingEdits(j,re,N,W);if(Array.isArray(he))return he.map(k.TextEdit.from)}}class M{constructor($,U){this._documents=$,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,U,N,W,j){const re=this._documents.getDocument($),he=k.Position.to(U),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,W,j);if(Array.isArray(Ce))return Ce.map(k.TextEdit.from)}}class z{constructor($,U){this._provider=$,this._logService=U,this._cache=new w.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols($,U){const N=await this._provider.provideWorkspaceSymbols($,U);if(!(0,R.isNonEmptyArray)(N))return{symbols:[]};const W=this._cache.add(N),j={cacheId:W,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}j.symbols.push({...k.WorkspaceSymbol.from(he),cacheId:[W,re]})}return j}async resolveWorkspaceSymbol($,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!$.cacheId)return $;const N=this._cache.get(...$.cacheId);if(N){const W=await this._provider.resolveWorkspaceSymbol(N,U);return W&&(0,t.mixin)($,k.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols($){this._cache.delete($)}}class x{constructor($,U,N){this._documents=$,this._provider=U,this._logService=N}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,U,N,W){const j=this._documents.getDocument($),re=k.Position.to(U);try{const he=await this._provider.provideRenameEdits(j,re,N,W);return he?k.WorkspaceEdit.from(he):void 0}catch(he){const Ce=x._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,U,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument($),j=k.Position.to(U);try{const re=await this._provider.prepareRename(W,j,N);let he,Ce;if(A.Range.isRange(re)?(he=re,Ce=W.getText(re)):(0,F.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(he),text:Ce}}catch(re){const he=x._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class K{constructor($,U){this.resultId=$,this.tokens=U}}class B{constructor($,U){this._documents=$,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,U,N){const W=this._documents.getDocument($),j=U!==0?this._previousResults.get(U):null;let re=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,j.resultId,N):await this._provider.provideDocumentSemanticTokens(W,N);return j&&this._previousResults.delete(U),re?(re=B._fixProvidedSemanticTokens(re),this._send(B._convertToEdits(j,re),re)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return B._isSemanticTokens($)?B._isCorrectSemanticTokens($)?$:new A.SemanticTokens(new Uint32Array($.data),$.resultId):B._isSemanticTokensEdits($)?B._isCorrectSemanticTokensEdits($)?$:new A.SemanticTokensEdits($.edits.map(U=>new A.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const U of $.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,U){if(!B._isSemanticTokens(U)||!$||!$.tokens)return U;const N=$.tokens,W=N.length,j=U.data,re=j.length;let he=0;const Ce=Math.min(W,re);for(;he<Ce&&N[he]===j[he];)he++;if(he===W&&he===re)return new A.SemanticTokensEdits([],U.resultId);let Ae=0;const We=Ce-he;for(;Ae<We&&N[W-Ae-1]===j[re-Ae-1];)Ae++;return new A.SemanticTokensEdits([{start:he,deleteCount:W-he-Ae,data:j.subarray(he,re-Ae)}],U.resultId)}_send($,U){if(B._isSemanticTokens($)){const N=this._nextResultId++;return this._previousResults.set(N,new K($.resultId,$.data)),(0,v.encodeSemanticTokensDto)({id:N,type:"full",data:$.data})}if(B._isSemanticTokensEdits($)){const N=this._nextResultId++;return B._isSemanticTokens(U)?this._previousResults.set(N,new K(U.resultId,U.data)):this._previousResults.set(N,new K($.resultId)),(0,v.encodeSemanticTokensDto)({id:N,type:"delta",deltas:($.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class G{constructor($,U){this._documents=$,this._provider=U}async provideDocumentRangeSemanticTokens($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(W,k.Range.to(U),N);return j?this._send(j):null}_send($){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=G;class X{constructor($,U,N,W,j){this._documents=$,this._commands=U,this._provider=N,this._apiDeprecation=W,this._extension=j,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,U,N,W){const j=this._documents.getDocument($),re=k.Position.to(U),he=j.getWordRangeAtPosition(re)||new A.Range(re,re),Ce=he.with({end:re}),Ae=new C.StopWatch(!0),We=await this._provider.provideCompletionItems(j,re,W,k.CompletionContext.to(N));if(!We||W.isCancellationRequested)return;const ze=Array.isArray(We)?new A.CompletionList(We):We,je=X.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),$e=new E.DisposableStore;this._disposables.set(je,$e);const Ue=[],Qe={x:je,b:Ue,a:{replace:k.Range.from(he),insert:k.Range.from(Ce)},c:ze.isIncomplete||void 0,d:Ae.elapsed()};for(let et=0;et<ze.items.length;et++){const Re=ze.items[et],tt=this._convertCompletionItem(Re,[je,et],Ce,he);Ue.push(tt)}return Qe}async resolveCompletionItem($,U){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveCompletionItem(N,U);if(!!W)return this._convertCompletionItem(W,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,U,N,W){const j=this._disposables.get(U[0]);if(!j)throw Error("DisposableStore is missing...");const re={x:U,a:$.label,b:$.kind!==void 0?k.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(k.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:k.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=$.textEdit.newText):typeof $.insertText=="string"?re.h=$.insertText:$.insertText instanceof A.SnippetString&&(re.h=$.insertText.value,re.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),A.Range.isRange(he)?re.j=k.Range.from(he):he&&(!N?.isEqual(he.inserting)||!W?.isEqual(he.replacing))&&(re.j={insert:k.Range.from(he.inserting),replace:k.Range.from(he.replacing)}),re}}class q{constructor($,U,N){this._documents=$,this._provider=U,this._commands=N,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,U,N,W){const j=this._documents.getDocument($),re=k.Position.to(U),he=await this._provider.provideInlineCompletionItems(j,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:k.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},W);if(!he||W.isCancellationRequested)return;const Ce=(0,F.isArray)(he)?{items:he}:he,Ae=this._cache.add(Ce.items);let We;return{pid:Ae,items:Ce.items.map((ze,je)=>{let $e;return ze.command&&(We||(We=new E.DisposableStore,this._disposables.set(Ae,We)),$e=this._commands.toInternal(ze.command,We)),{text:ze.text,range:ze.range?k.Range.from(ze.range):void 0,command:$e,idx:je,completeBracketPairs:ze.completeBracketPairs}})}}disposeCompletions($){this._cache.delete($);const U=this._disposables.get($);U&&U.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,U){const N=this._cache.get($,U);N&&ee.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class ee{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let U=ee.map.get($);return U||(U=new ee,ee.map.set($,U)),U}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=ee,ee.map=new WeakMap;class ae{constructor($,U){this._documents=$,this._provider=U,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp($,U,N,W){const j=this._documents.getDocument($),re=k.Position.to(U),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(j,re,W,he);if(Ce){const Ae=this._cache.add([Ce]);return{...k.SignatureHelp.from(Ce),id:Ae}}}reviveContext($){let U;if($.activeSignatureHelp){const N=k.SignatureHelp.to($.activeSignatureHelp),W=this._cache.get($.activeSignatureHelp.id,0);W?(U=W,U.activeSignature=N.activeSignature,U.activeParameter=N.activeParameter):U=N}return{...$,activeSignatureHelp:U}}releaseSignatureHelp($){this._cache.delete($)}}class ue{constructor($,U,N,W,j){this._documents=$,this._commands=U,this._provider=N,this._logService=W,this._extension=j,this._cache=new w.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints($,U,N){const W=this._documents.getDocument($),j=k.Range.to(U),re=await this._provider.provideInlayHints(W,j,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new E.DisposableStore);const Ce={hints:[],cacheId:he};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],j)&&Ce.hints.push(this._convertInlayHint(re[Ae],[he,Ae]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),Ce}async resolveInlayHint($,U){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveInlayHint(N,U);if(!!W&&!!this._isValidInlayHint(W))return this._convertInlayHint(W,$)}releaseHints($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_isValidInlayHint($,U){return $.label.length===0||Array.isArray($.label)&&$.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",$),!1):!(U&&!U.contains($.position))}_convertInlayHint($,U){const N=this._disposables.get(U[0]);if(!N)throw Error("DisposableStore is missing...");const W={label:"",cacheId:U,tooltip:k.MarkdownString.fromStrict($.tooltip),command:$.command&&this._commands.toInternal($.command,N),position:k.Position.from($.position),kind:k.InlayHintKind.from($.kind??A.InlayHintKind.Other),paddingLeft:$.paddingLeft,paddingRight:$.paddingRight};return typeof $.label=="string"?W.label=$.label:W.label=$.label.map(j=>{let re={label:j.value};return re.tooltip=k.MarkdownString.fromStrict(j.tooltip),A.Location.isLocation(j.location)&&(re.location=k.location.from(j.location)),j.command&&(re.command=this._commands.toInternal(j.command,N)),re}),W}}class Z{constructor($,U){this._documents=$,this._provider=U,this._cache=new w.Cache("DocumentLink")}async provideLinks($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentLinks(N,U);if(!(!Array.isArray(W)||W.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(Z._validateLink).map(k.DocumentLink.from)};{const j=this._cache.add(W),re={links:[],cacheId:j};for(let he=0;he<W.length;he++){if(!Z._validateLink(W[he]))continue;const Ce=k.DocumentLink.from(W[he]);Ce.cacheId=[j,he],re.links.push(Ce)}return re}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,U){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveDocumentLink(N,U);if(!(!W||!Z._validateLink(W)))return k.DocumentLink.from(W)}releaseLinks($){this._cache.delete($)}}class Y{constructor($,U){this._documents=$,this._provider=U}async provideColors($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentColors(N,U);return Array.isArray(W)?W.map(re=>({color:k.Color.from(re.color),range:k.Range.from(re.range)})):[]}async provideColorPresentations($,U,N){const W=this._documents.getDocument($),j=k.Range.to(U.range),re=k.Color.to(U.color),he=await this._provider.provideColorPresentations(re,{document:W,range:j},N);if(!!Array.isArray(he))return he.map(k.ColorPresentation.from)}}class se{constructor($,U){this._documents=$,this._provider=U}async provideFoldingRanges($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(W,U,N);if(!!Array.isArray(j))return j.map(k.FoldingRange.from)}}class de{constructor($,U,N){this._documents=$,this._provider=U,this._logService=N}async provideSelectionRanges($,U,N){const W=this._documents.getDocument($),j=U.map(k.Position.to),re=await this._provider.provideSelectionRanges(W,j,N);if(!(0,R.isNonEmptyArray)(re))return[];if(re.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<j.length;Ce++){const Ae=[];he.push(Ae);let We=j[Ce],ze=re[Ce];for(;;){if(!ze.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(k.SelectionRange.from(ze)),!ze.parent)break;We=ze.range,ze=ze.parent}}return he}}class ve{constructor($,U){this._documents=$,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.prepareCallHierarchy(W,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(W,N);if(!!j)return j.map(re=>({from:this._cacheAndConvertItem($,re.from),fromRanges:re.fromRanges.map(he=>k.Range.from(he))}))}async provideCallsFrom($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(W,N);if(!!j)return j.map(re=>({to:this._cacheAndConvertItem($,re.to),fromRanges:re.fromRanges.map(he=>k.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,U){const N=this._cache.get($),W=k.CallHierarchyItem.from(U,$,N.size.toString(36));return N.set(W._itemId,U),W}_itemFromCache($,U){return this._cache.get($)?.get(U)}}class Te{constructor($,U){this._documents=$,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,U,N){const W=this._documents.getDocument($),j=k.Position.to(U),re=await this._provider.prepareTypeHierarchy(W,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(W,N);if(!!j)return j.map(re=>this._cacheAndConvertItem($,re))}async provideSubtypes($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(W,N);if(!!j)return j.map(re=>this._cacheAndConvertItem($,re))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,U){const N=this._cache.get($),W=k.TypeHierarchyItem.from(U,$,N.size.toString(36));return N.set(W._itemId,U),W}_itemFromCache($,U){return this._cache.get($)?.get(U)}}class Me{constructor($,U){this.adapter=$,this.extension=U}}class _e{constructor($,U,N,W,j,re,he){this._adapter=new Map,this._uriTransformer=U,this._proxy=$.getProxy(S.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=W,this._diagnostics=j,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector($){return k.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new A.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return _e._handlePool++}async _withAdapter($,U,N,W,j){const re=this._adapter.get($);if(!re||!(re.adapter instanceof U))return W;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Ae=>{(0,P.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),p.CancellationToken.isCancellationToken(j)?(0,c.raceCancellationError)(Ce,j):Ce}_addNewAdapter($,U){const N=this._nextHandle();return this._adapter.set(N,new Me($,U)),N}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,U,N,W){const j=this._addNewAdapter(new f(this._documents,N),$),re=W&&W.label||_e._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(U),re),this._createDisposable(j)}$provideDocumentSymbols($,U,N){return this._withAdapter($,f,W=>W.provideDocumentSymbols(h.URI.revive(U),N),void 0,N)}registerCodeLensProvider($,U,N){const W=this._nextHandle(),j=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new Me(new s(this._documents,this._commands.converter,N),$)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(U),j);let re=this._createDisposable(W);if(j!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(j));re=A.Disposable.from(re,he)}return re}$provideCodeLenses($,U,N){return this._withAdapter($,s,W=>W.provideCodeLenses(h.URI.revive(U),N),void 0,N)}$resolveCodeLens($,U,N){return this._withAdapter($,s,W=>W.resolveCodeLens(U,N),void 0,void 0)}$releaseCodeLenses($,U){this._withAdapter($,s,N=>Promise.resolve(N.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider($,U,N){const W=this._addNewAdapter(new o(this._documents,N),$);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDefinition($,U,N,W){return this._withAdapter($,o,j=>j.provideDefinition(h.URI.revive(U),N,W),[],W)}registerDeclarationProvider($,U,N){const W=this._addNewAdapter(new i(this._documents,N),$);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDeclaration($,U,N,W){return this._withAdapter($,i,j=>j.provideDeclaration(h.URI.revive(U),N,W),[],W)}registerImplementationProvider($,U,N){const W=this._addNewAdapter(new r(this._documents,N),$);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideImplementation($,U,N,W){return this._withAdapter($,r,j=>j.provideImplementation(h.URI.revive(U),N,W),[],W)}registerTypeDefinitionProvider($,U,N){const W=this._addNewAdapter(new n(this._documents,N),$);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideTypeDefinition($,U,N,W){return this._withAdapter($,n,j=>j.provideTypeDefinition(h.URI.revive(U),N,W),[],W)}registerHoverProvider($,U,N,W){const j=this._addNewAdapter(new a(this._documents,N),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideHover($,U,N,W){return this._withAdapter($,a,j=>j.provideHover(h.URI.revive(U),N,W),void 0,W)}registerEvaluatableExpressionProvider($,U,N,W){const j=this._addNewAdapter(new g(this._documents,N),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideEvaluatableExpression($,U,N,W){return this._withAdapter($,g,j=>j.provideEvaluatableExpression(h.URI.revive(U),N,W),void 0,W)}registerInlineValuesProvider($,U,N,W){const j=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new u(this._documents,N),$);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(U),j);let he=this._createDisposable(re);if(j!==void 0){const Ce=N.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(j));he=A.Disposable.from(he,Ce)}return he}$provideInlineValues($,U,N,W,j){return this._withAdapter($,u,re=>re.provideInlineValues(h.URI.revive(U),N,W,j),void 0,j)}registerDocumentHighlightProvider($,U,N){const W=this._addNewAdapter(new m(this._documents,N),$);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentHighlights($,U,N,W){return this._withAdapter($,m,j=>j.provideDocumentHighlights(h.URI.revive(U),N,W),void 0,W)}registerLinkedEditingRangeProvider($,U,N){const W=this._addNewAdapter(new T(this._documents,N),$);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideLinkedEditingRanges($,U,N,W){return this._withAdapter($,T,async j=>{const re=await j.provideLinkedEditingRanges(h.URI.revive(U),N,W);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?_e._serializeRegExp(re.wordPattern):void 0}},void 0,W)}registerReferenceProvider($,U,N){const W=this._addNewAdapter(new O(this._documents,N),$);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideReferences($,U,N,W,j){return this._withAdapter($,O,re=>re.provideReferences(h.URI.revive(U),N,W,j),void 0,j)}registerCodeActionProvider($,U,N,W){const j=new E.DisposableStore,re=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,N,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(U),{providedKinds:W?.providedCodeActionKinds?.map(he=>he.value),documentation:W?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},_e._extLabel($),Boolean(N.resolveCodeAction)),j.add(this._createDisposable(re)),j}$provideCodeActions($,U,N,W,j){return this._withAdapter($,L,re=>re.provideCodeActions(h.URI.revive(U),N,W,j),void 0,j)}$resolveCodeAction($,U,N){return this._withAdapter($,L,W=>W.resolveCodeAction(U,N),void 0,void 0)}$releaseCodeActions($,U){this._withAdapter($,L,N=>Promise.resolve(N.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider($,U,N){const W=this._addNewAdapter(new y(this._documents,N),$);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(U),$.identifier,$.displayName||$.name),this._createDisposable(W)}$provideDocumentFormattingEdits($,U,N,W){return this._withAdapter($,y,j=>j.provideDocumentFormattingEdits(h.URI.revive(U),N,W),void 0,W)}registerDocumentRangeFormattingEditProvider($,U,N){const W=this._addNewAdapter(new H(this._documents,N),$);return this._proxy.$registerRangeFormattingSupport(W,this._transformDocumentSelector(U),$.identifier,$.displayName||$.name),this._createDisposable(W)}$provideDocumentRangeFormattingEdits($,U,N,W,j){return this._withAdapter($,H,re=>re.provideDocumentRangeFormattingEdits(h.URI.revive(U),N,W,j),void 0,j)}registerOnTypeFormattingEditProvider($,U,N,W){const j=this._addNewAdapter(new M(this._documents,N),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(U),W,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,U,N,W,j,re){return this._withAdapter($,M,he=>he.provideOnTypeFormattingEdits(h.URI.revive(U),N,W,j,re),void 0,re)}registerWorkspaceSymbolProvider($,U){const N=this._addNewAdapter(new z(U,this._logService),$);return this._proxy.$registerNavigateTypeSupport(N,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols($,U,N){return this._withAdapter($,z,W=>W.provideWorkspaceSymbols(U,N),{symbols:[]},N)}$resolveWorkspaceSymbol($,U,N){return this._withAdapter($,z,W=>W.resolveWorkspaceSymbol(U,N),void 0,void 0)}$releaseWorkspaceSymbols($,U){this._withAdapter($,z,N=>N.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider($,U,N){const W=this._addNewAdapter(new x(this._documents,N,this._logService),$);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(U),x.supportsResolving(N)),this._createDisposable(W)}$provideRenameEdits($,U,N,W,j){return this._withAdapter($,x,re=>re.provideRenameEdits(h.URI.revive(U),N,W,j),void 0,j)}$resolveRenameLocation($,U,N,W){return this._withAdapter($,x,j=>j.resolveRenameLocation(h.URI.revive(U),N,W),void 0,W)}registerDocumentSemanticTokensProvider($,U,N,W){const j=this._addNewAdapter(new B(this._documents,N),$),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(U),W,re);let he=this._createDisposable(j);if(re){const Ce=N.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=A.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens($,U,N,W){return this._withAdapter($,B,j=>j.provideDocumentSemanticTokens(h.URI.revive(U),N,W),null,W)}$releaseDocumentSemanticTokens($,U){this._withAdapter($,B,N=>N.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider($,U,N,W){const j=this._addNewAdapter(new G(this._documents,N),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(U),W),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,U,N,W){return this._withAdapter($,G,j=>j.provideDocumentRangeSemanticTokens(h.URI.revive(U),N,W),null,W)}registerCompletionItemProvider($,U,N,W){const j=this._addNewAdapter(new X(this._documents,this._commands.converter,N,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(U),W,X.supportsResolving(N),`${$.identifier.value}(${W.join("")})`),this._createDisposable(j)}$provideCompletionItems($,U,N,W,j){return this._withAdapter($,X,re=>re.provideCompletionItems(h.URI.revive(U),N,W,j),void 0,j)}$resolveCompletionItem($,U,N){return this._withAdapter($,X,W=>W.resolveCompletionItem(U,N),void 0,N)}$releaseCompletionItems($,U){this._withAdapter($,X,N=>N.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider($,U,N){const W=this._addNewAdapter(new q(this._documents,N,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideInlineCompletions($,U,N,W,j){return this._withAdapter($,q,re=>re.provideInlineCompletions(h.URI.revive(U),N,W,j),void 0,j)}$handleInlineCompletionDidShow($,U,N){this._withAdapter($,q,async W=>{W.handleDidShowCompletionItem(U,N)},void 0,void 0)}$freeInlineCompletionsList($,U){this._withAdapter($,q,async N=>{N.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider($,U,N,W){const j=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,re=this._addNewAdapter(new ae(this._documents,N),$);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(U),j),this._createDisposable(re)}$provideSignatureHelp($,U,N,W,j){return this._withAdapter($,ae,re=>re.provideSignatureHelp(h.URI.revive(U),N,W,j),void 0,j)}$releaseSignatureHelp($,U){this._withAdapter($,ae,N=>N.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider($,U,N){const W=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new ue(this._documents,this._commands.converter,N,this._logService,$),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(U),typeof N.resolveInlayHint=="function",W,_e._extLabel($));let re=this._createDisposable(j);if(W!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(W));re=A.Disposable.from(re,he)}return re}$provideInlayHints($,U,N,W){return this._withAdapter($,ue,j=>j.provideInlayHints(h.URI.revive(U),N,W),void 0,W)}$resolveInlayHint($,U,N){return this._withAdapter($,ue,W=>W.resolveInlayHint(U,N),void 0,N)}$releaseInlayHints($,U){this._withAdapter($,ue,N=>N.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider($,U,N){const W=this._addNewAdapter(new Z(this._documents,N),$);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(U),typeof N.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks($,U,N){return this._withAdapter($,Z,W=>W.provideLinks(h.URI.revive(U),N),void 0,N)}$resolveDocumentLink($,U,N){return this._withAdapter($,Z,W=>W.resolveLink(U,N),void 0,void 0)}$releaseDocumentLinks($,U){this._withAdapter($,Z,N=>N.releaseLinks(U),void 0,void 0)}registerColorProvider($,U,N){const W=this._addNewAdapter(new Y(this._documents,N),$);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentColors($,U,N){return this._withAdapter($,Y,W=>W.provideColors(h.URI.revive(U),N),[],N)}$provideColorPresentations($,U,N,W){return this._withAdapter($,Y,j=>j.provideColorPresentations(h.URI.revive(U),N,W),void 0,W)}registerFoldingRangeProvider($,U,N){const W=this._nextHandle(),j=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new Me(new se(this._documents,N),$)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(U),j);let re=this._createDisposable(W);if(j!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));re=A.Disposable.from(re,he)}return re}$provideFoldingRanges($,U,N,W){return this._withAdapter($,se,j=>j.provideFoldingRanges(h.URI.revive(U),N,W),void 0,W)}registerSelectionRangeProvider($,U,N){const W=this._addNewAdapter(new de(this._documents,N,this._logService),$);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideSelectionRanges($,U,N,W){return this._withAdapter($,de,j=>j.provideSelectionRanges(h.URI.revive(U),N,W),[],W)}registerCallHierarchyProvider($,U,N){const W=this._addNewAdapter(new ve(this._documents,N),$);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareCallHierarchy($,U,N,W){return this._withAdapter($,ve,j=>Promise.resolve(j.prepareSession(h.URI.revive(U),N,W)),void 0,W)}$provideCallHierarchyIncomingCalls($,U,N,W){return this._withAdapter($,ve,j=>j.provideCallsTo(U,N,W),void 0,W)}$provideCallHierarchyOutgoingCalls($,U,N,W){return this._withAdapter($,ve,j=>j.provideCallsFrom(U,N,W),void 0,W)}$releaseCallHierarchy($,U){this._withAdapter($,ve,N=>Promise.resolve(N.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider($,U,N){const W=this._addNewAdapter(new Te(this._documents,N),$);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareTypeHierarchy($,U,N,W){return this._withAdapter($,Te,j=>Promise.resolve(j.prepareSession(h.URI.revive(U),N,W)),void 0,W)}$provideTypeHierarchySupertypes($,U,N,W){return this._withAdapter($,Te,j=>j.provideSupertypes(U,N,W),void 0,W)}$provideTypeHierarchySubtypes($,U,N,W){return this._withAdapter($,Te,j=>j.provideSubtypes(U,N,W),void 0,W)}$releaseTypeHierarchy($,U){this._withAdapter($,Te,N=>Promise.resolve(N.releaseSession(U)),void 0,void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,D.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:_e._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:_e._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?_e._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?_e._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:_e._serializeRegExp($.beforeText),afterText:$.afterText?_e._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?_e._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(_e._serializeOnEnterRule)}setLanguageConfiguration($,U,N){let{wordPattern:W}=N;if(W&&(0,D.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(U,W):this._documents.setWordDefinitionFor(U,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?_e._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?_e._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?_e._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,U,re),this._createDisposable(j)}$setWordDefinitions($){for(const U of $)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=_e,_e._handlePool=0}),define(we[242],be([1,0,5,15,7,47,13,6]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(F,I,p,E){this._documents=I,this._commands=p,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,I){await this._proxy.$changeLanguage(F,I);const p=this._documents.getDocumentData(F);if(!p)throw new Error(`document '${F.toString}' NOT found`);return p.document}async tokenAtPosition(F,I){const p=F.version,E=t.Position.from(I),v=await this._proxy.$tokensAtPosition(F.uri,E),d={type:k.StandardTokenType.Other,range:F.getWordRangeAtPosition(I)??new k.Range(I.line,I.character,I.line,I.character)};if(!v)return d;const w={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!w.range.contains(I)||p!==F.version?d:w}createLanguageStatusItem(F,I,p){const E=this._handlePool++,v=this._proxy,d=this._ids,w=`${F.identifier.value}/${I}`;if(d.has(w))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);d.add(w);const C={selector:p,id:I,name:F.displayName??F.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let P,l=new D.DisposableStore;const c=()=>{P?.dispose(),P=(0,S.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(E,{id:w,name:C.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(C.selector,this._uriTransformer),label:C.text,detail:C.detail??"",severity:C.severity===k.LanguageStatusSeverity.Error?A.default.Error:C.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:C.command&&this._commands.toInternal(C.command,l),accessibilityInfo:C.accessibilityInformation,busy:C.busy})},0)},f={dispose(){l.dispose(),P?.dispose(),v.$removeLanguageStatus(E),d.delete(w)},get id(){return C.id},get name(){return C.name},set name(s){C.name=s,c()},get selector(){return C.selector},set selector(s){C.selector=s,c()},get text(){return C.text},set text(s){C.text=s,c()},get detail(){return C.detail},set detail(s){C.detail=s,c()},get severity(){return C.severity},set severity(s){C.severity=s,c()},get accessibilityInformation(){return C.accessibilityInformation},set accessibilityInformation(s){C.accessibilityInformation=s,c()},get command(){return C.command},set command(s){C.command=s,c()},get busy(){return C.busy},set busy(s){C.busy=s,c()}};return c(),f}}e.ExtHostLanguages=_}),define(we[134],be([1,0,11,5,26,14,3]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends h.AbstractLoggerService{constructor(F,I){const p=new S.Emitter;super(I.logLevel,p.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(p)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,I,p){return new _(this._proxy,F,I,p)}};D=Be([Fe(0,A.IExtHostRpcService),Fe(1,k.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class _ extends h.AbstractMessageLogger{constructor(F,I,p,E){super(E?.always);this.proxy=F,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(I,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,I){const p=[[F,I]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(F){this.proxy.$log(this.file,F)}}}),define(we[243],be([1,0,5,11,29]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let S=class{constructor(_,R){this._logService=R,this._proxy=_.getProxy(h.MainContext.MainThreadMessageService)}showMessage(_,R,F,I,p){const E={source:{identifier:_.identifier,label:_.displayName||_.name}};let v;typeof I=="string"||A(I)?v=[I,...p]:(E.modal=I?.modal,E.useCustom=I?.useCustom,E.detail=I?.detail,v=p),E.useCustom&&(0,k.checkProposedApiEnabled)(_,"resolvers");const d=[];for(let w=0;w<v.length;w++){const C=v[w];if(typeof C=="string")d.push({title:C,handle:w,isCloseAffordance:!1});else if(typeof C=="object"){let{title:P,isCloseAffordance:l}=C;d.push({title:P,isCloseAffordance:!!l,handle:w})}else this._logService.warn("Invalid message item:",C)}return this._proxy.$showMessage(R,F,E,d).then(w=>{if(typeof w=="number")return v[w]})}};S=Be([Fe(1,t.ILogService)],S),e.ExtHostMessageService=S}),define(we[244],be([1,0,22,3,57,6,24,8,18,2,82,5,15,7,52,220,130]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class C{constructor(l,c,f,s,b){this._textDocumentsAndEditors=f,this._textDocuments=s,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new S.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,r=o.cell.handle,a=this._documents.get(i)?.getCell(r);if(a)return a.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const c=this._editors.get(l);if(!c)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(l){for(const[c,f]of this._editors)if(f.apiEditor===l)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,c){const f=this._documents.get(l);if(!f&&!c)throw new Error(`NO notebook document for '${l}'`);return f}_getProviderData(l){const c=this._notebookContentProviders.get(l);if(!c)throw new Error(`NO provider for '${l}'`);return c}registerNotebookContentProvider(l,c,f,s,b){if((0,D.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:l,provider:f});let o;return f.onDidChangeNotebookContentOptions&&(o=f.onDidChangeNotebookContentOptions(()=>{const i=p.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(c,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},c,p.NotebookDocumentContentOptions.from(s),C._convertNotebookRegistrationData(l,b)),new E.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(l,c){if(!c)return;const f=c.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(c.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:c.displayName,filenamePattern:f,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,c,f){const s=C._notebookStatusBarItemProviderHandlePool++,b=typeof f.onDidChangeCellStatusBarItems=="function"?C._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,b,c);let o;return b!==void 0&&(o=f.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(b))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,b),o&&o.dispose()})}async createNotebookDocument(l){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&p.NotebookData.from(l.content)});return R.URI.revive(c)}async openNotebookDocument(l){const c=this._documents.get(l);if(c)return c.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(l),s=this._documents.get(R.URI.revive(f));return(0,_.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(l,c){R.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let f;typeof c=="object"?f={position:p.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(p.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:f={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,f),b=s&&this._editors.get(s)?.apiEditor;if(b)return b;throw s?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,c,f,s){const b=this._notebookStatusBarItemProviders.get(l),o=R.URI.revive(c),i=this._documents.get(o);if(!i||!b)return;const r=i.getCellFromIndex(f);if(!r)return;const n=await b.provideCellStatusBarItems(r.apiCell,s);if(!n)return;const a=new A.DisposableStore,g=this._statusBarCache.add([a]),m=(Array.isArray(n)?n:[n]).map(T=>p.NotebookStatusBarItem.from(T,this._commandsConverter,a));return{cacheId:g,items:m}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,c,f,s,b){if((0,D.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,f),this._notebookProxy.$registerNotebookSerializer(o,{id:l.identifier,location:l.extensionLocation},c,p.NotebookDocumentContentOptions.from(s),C._convertNotebookRegistrationData(l,b)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(l,c,f){const s=this._notebookSerializer.get(l);if(!s)throw new Error("NO serializer found");const b=await s.deserializeNotebook(c.buffer,f);return new v.SerializableObjectWithBuffers(p.NotebookData.from(b))}async $notebookToData(l,c,f){const s=this._notebookSerializer.get(l);if(!s)throw new Error("NO serializer found");const b=await s.serializeNotebook(p.NotebookData.to(c.value),f);return h.VSBuffer.wrap(b)}async $openNotebook(l,c,f,s,b){const{provider:o}=this._getProviderData(l),i=await o.openNotebook(R.URI.revive(c),{backupId:f,untitledDocumentData:s?.buffer},b);return new v.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(p.NotebookCellData.from)})}async $saveNotebook(l,c,f){const s=this.getNotebookDocument(R.URI.revive(c)),{provider:b}=this._getProviderData(l);return await b.saveNotebook(s.apiNotebook,f),!0}async $saveNotebookAs(l,c,f,s){const b=this.getNotebookDocument(R.URI.revive(c)),{provider:o}=this._getProviderData(l);return await o.saveNotebookAs(R.URI.revive(f),b.apiNotebook,s),!0}async $backupNotebook(l,c,f){const s=this.getNotebookDocument(R.URI.revive(c)),b=this._getProviderData(l),o=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),i=String((0,k.hash)([s.uri.toString(),this._backupIdPool++])),r=R.URI.joinPath(o,i),n=await b.provider.backupNotebook(s.apiNotebook,{destination:r},f);return s.updateBackup(n),n.id}_createExtHostEditor(l,c,f){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const s=new w.ExtHostNotebookEditor(c,this._notebookEditorsProxy,l,f.visibleRanges.map(p.NotebookRange.to),f.selections.map(p.NotebookRange.to),typeof f.viewColumn=="number"?p.ViewColumn.to(f.viewColumn):void 0);this._editors.set(c,s)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const f of l.value.removedDocuments){const s=R.URI.revive(f),b=this._documents.get(s);b&&(b.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(l.value.addedDocuments){const f=[];for(const s of l.value.addedDocuments){const b=R.URI.revive(s.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const o=this,i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){o._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){o._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){o._onDidChangeCellMetadata.fire(r)}},b,s);f.push(...s.cells.map(r=>d.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(b)?.dispose(),this._documents.set(b,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const f of l.value.addedEditors){if(this._editors.has(f.id))return;const s=R.URI.revive(f.documentUri),b=this._documents.get(s);b&&this._createExtHostEditor(b,f.id,f)}const c=[];if(l.value.removedEditors)for(const f of l.value.removedEditors){const s=this._editors.get(f);s&&(this._editors.delete(f),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),c.push(s))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const f=new Set;this._visibleNotebookEditors.forEach(s=>f.add(s.id));for(const s of this._editors.values()){const b=f.has(s.id);s._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=C,C._notebookStatusBarItemProviderHandlePool=0}),define(we[245],be([1,0,3,76,11,5,14,15]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,p){const E=_._Keys.nextId();I.$registerNotebookEditorDecorationType(E,D.NotebookDecorationRenderOptions.from(p)),this.value={key:E,dispose(){I.$removeNotebookEditorDecorationType(E)}}}}_._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(I,p,E){this._logService=I,this._extHostRpc=p,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,p);const E=this._notebooksAndEditors.getEditorById(I);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(D.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(D.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const p in I)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(D.ViewColumn.to(I[p]))}};R=Be([Fe(0,k.ILogService),Fe(1,S.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(we[246],be([1,0,17,13,21,3,6,24,2,27,11,5,39,15,7,83,213,29,52]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(i,r,n,a,g){this._initData=r,this._extHostNotebook=n,this._commands=a,this._logService=g,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(I.MainContext.MainThreadNotebookKernels);const u=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",m=>!0,m=>{if(m&&"notebookEditor"in m&&"id"in m){const T=this._extHostNotebook.getIdByEditor(m.notebookEditor);return{id:m.id,extension:m.extension,notebookEditorId:T}}else if(m&&"notebookEditor"in m){const T=this._extHostNotebook.getIdByEditor(m.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${m.notebookEditor.document.uri.toString()}`);return{notebookEditorId:T}}return m})],p.ApiCommandResult.Void);this._commands.registerApiCommand(u)}createNotebookController(i,r,n,a,g,u){for(const ee of this._kernelData.values())if(ee.controller.id===r&&R.ExtensionIdentifier.equals(i.identifier,ee.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const m=this._handlePool++,T=this;this._logService.trace(`NotebookController[${m}], CREATED by ${i.identifier.value}, ${r}`);const O=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${i.identifier}'`);let L=!1;const y=new S.DisposableStore,H=new A.Emitter,M=new A.Emitter,z={id:b(i,r),notebookType:n,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:u?u.map(E.NotebookRendererScript.from):[]};let x=g??O,K;this._proxy.$addKernel(m,z).catch(ee=>{console.log(ee),L=!0});let B=0;const G=()=>{if(L)return;const ee=++B;Promise.resolve().then(()=>{ee===B&&this._proxy.$updateKernel(m,z)})},X=new D.ResourceMap,q={get id(){return r},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return z.label},set label(ee){z.label=ee??i.displayName??i.name,G()},get detail(){return z.detail??""},set detail(ee){z.detail=ee,G()},get description(){return z.description??""},set description(ee){z.description=ee,G()},get kind(){return(0,C.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind??""},set kind(ee){(0,C.checkProposedApiEnabled)(i,"notebookControllerKind"),z.kind=ee,G()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ee){z.supportedLanguages=ee,G()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){z.supportsExecutionOrder=ee,G()},get rendererScripts(){return z.preloads?z.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(ee){x=ee??O},get interruptHandler(){return K},set interruptHandler(ee){K=ee,z.supportsInterrupt=Boolean(ee),G()},createNotebookCellExecution(ee){if(L)throw new Error("notebook controller is DISPOSED");if(!X.has(ee.notebook.uri))throw T._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return T._createNotebookCellExecution(ee,b(i,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${m}], DISPOSED`),L=!0,this._kernelData.delete(m),y.dispose(),H.dispose(),M.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(ee,ae){T._proxy.$updateNotebookPriority(m,ee.uri,ae)},onDidReceiveMessage:M.event,postMessage(ee,ae){return(0,C.checkProposedApiEnabled)(i,"notebookMessaging"),T._proxy.$postMessage(m,ae&&T._extHostNotebook.getIdByEditor(ae),ee)},asWebviewUri(ee){return(0,C.checkProposedApiEnabled)(i,"notebookMessaging"),(0,d.asWebviewUri)(ee,T._initData.remote)}};return this._kernelData.set(m,{extensionId:i.identifier,controller:q,onDidReceiveMessage:M,onDidChangeSelection:H,associatedNotebooks:X}),q}$acceptNotebookAssociation(i,r,n){const a=this._kernelData.get(i);if(a){const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));n?a.associatedNotebooks.set(g.uri,!0):a.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,g.uri.toString(),n),a.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(i,r,n){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(r)),u=[];for(const m of n){const T=g.getCell(m);T&&u.push(T.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,g.uri.toString(),u.length),await a.controller.executeHandler.call(a.controller,u,g.apiNotebook,a.controller)}catch(m){this._logService.error(`NotebookController[${i}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(i,r,n){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,g.apiNotebook);else for(const u of n){const m=g.getCell(u);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,n){const a=this._kernelData.get(i);if(!a)return;const g=this._extHostNotebook.getEditorById(r);a.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(i,r,n){const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(i)).getCell(r);g&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:n??v.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const g=new f(r,a,this._proxy);this._activeExecutions.set(a.uri,g);const u=g.onDidChangeState(()=>{g.state===c.Resolved&&(g.dispose(),u.dispose(),this._activeExecutions.delete(a.uri))});return g.asApiObject()}};l=Be([Fe(4,F.ILogService)],l),e.ExtHostNotebookKernels=l;var c;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(c||(c={}));class f extends S.Disposable{constructor(i,r,n){super();this._cell=r,this._proxy=n,this._handle=f.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new s(10,a=>this.update(a)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new P.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(r=>{const n=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return n===r.items?E.NotebookCellOutput.from(r):E.NotebookCellOutput.from({items:n,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,n){const a=this.validateAndConvertOutputs((0,h.asArray)(i));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,append:n,outputs:a})}async updateOutputItems(i,r,n){return i=v.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(i),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,items:i.map(E.NotebookCellOutputItem.from),outputId:r.id,append:n})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(n){i._executionOrder=n,i.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(n){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:w.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,a){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new P.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:n}))},clearOutput(n){return i.verifyStateForOutput(),i.updateOutputs([],n,!1)},appendOutput(n,a){return i.verifyStateForOutput(),i.updateOutputs(n,a,!0)},replaceOutput(n,a){return i.verifyStateForOutput(),i.updateOutputs(n,a,!1)},appendOutputItems(n,a){return i.verifyStateForOutput(),i.updateOutputItems(n,a,!0)},replaceOutputItems(n,a){return i.verifyStateForOutput(),i.updateOutputItems(n,a,!1)}})}}f.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function b(o,i){return`${o.identifier.value}/${i}`}}),define(we[247],be([1,0,3,5,130,29]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(_,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,R,F){const I=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(R)?.fire({editor:I.apiEditor,message:F})}createRendererMessaging(_,R){if(!_.contributes?.notebookRenderer?.some(E=>E.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,A.isProposedApiEnabled)(_,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(E,v,d)=>{const w=F?E:C=>{const P={};I.set(P,C.editor),E({editor:P,message:C.message})};return this.getOrCreateEmitterFor(R).event(w,v,d)},postMessage:(E,v)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,v]=[v,E]);const d=F?v:I.get(v),w=d&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(w?.id,R,E)}}}getOrCreateEmitterFor(_){let R=this._rendererMessageEmitters.get(_);return R||(R=new h.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,R),R)}}e.ExtHostNotebookRenderers=S}),define(we[135],be([1,0,5,6,4,14,11,214,66,26,44,155,22]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(w,C,P,l){super();this.id=w,this.name=C,this.logger=P,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(w){this.append(w+`
`)}append(w){this.write(w),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const w=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,w)}replace(w){const C=this.offset;this.write(w),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,C),this.visible&&this.logger.flush()}show(w,C){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof w=="boolean"?w:C))}hide(){this.proxy.$close(this.id)}write(w){this.offset+=p.VSBuffer.fromString(w).byteLength,this.logger.info(w)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let v=class{constructor(w,C,P,l,c){this.extHostFileSystem=P,this.extHostFileSystemInfo=l,this.loggerService=c,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=w.getProxy(h.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(C.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.visibleChannelId=w;for(const[C,P]of this.channels)P.visible=C===this.visibleChannelId}createOutputChannel(w,C){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const P=this.doCreateOutputChannel(w,C);return P.then(l=>{this.channels.set(l.id,l),l.visible=l.id===this.visibleChannelId}),this.createExtHostOutputChannel(w,P)}async doCreateOutputChannel(w,C){const P=await this.createOutputDirectory(),l=this.extHostFileSystemInfo.extUri.joinPath(P,`${this.namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),f=await this.proxy.$register(w,!1,l,C.identifier.value);return new E(f,w,c,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(w,C){let P=!1;const l=()=>{if(P)throw new Error("Channel has been closed")};return{get name(){return w},append(c){l(),C.then(f=>f.append(c))},appendLine(c){l(),C.then(f=>f.appendLine(c))},clear(){l(),C.then(c=>c.clear())},replace(c){l(),C.then(f=>f.replace(c))},show(c,f){l(),C.then(s=>s.show(c,f))},hide(){l(),C.then(c=>c.hide())},dispose(){P=!0,C.then(c=>c.dispose())}}}};v=Be([Fe(0,A.IExtHostRpcService),Fe(1,R.IExtHostInitDataService),Fe(2,_.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,S.ILoggerService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(we[248],be([1,0,13,21,3,6,5,2,7,16,17,47,81]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(v,d,w){const C=v.getProxy(S.MainContext.MainThreadQuickOpen);class P{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,g=t.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(n),m=++this._instances,T=C.$show(m,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},g),O={},L=T.then(()=>O);return Promise.race([L,u]).then(y=>{if(y!==O)return u.then(H=>{const M=[];for(let z=0;z<H.length;z++){const x=H[z];typeof x=="string"?M.push({label:x,handle:z}):x.kind===_.QuickPickItemKind.Separator?M.push({type:"separator",label:x.label}):M.push({label:x.label,description:x.description,detail:x.detail,picked:x.picked,alwaysShow:x.alwaysShow,handle:z})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{a.onDidSelectItem(H[z])}),C.$setItems(m,M),T.then(z=>{if(typeof z=="number")return H[z];if(Array.isArray(z))return z.map(x=>H[x])})})}).then(void 0,y=>{if(!(0,R.isCancellationError)(y))return C.$setError(m,y),Promise.reject(y)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=t.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,C.$input(n,typeof this._validateInput=="function",a).then(void 0,g=>{if(!(0,R.isCancellationError)(g))return Promise.reject(g)})}$validateInput(n){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=t.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!g)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(m=>m.uri.toString()===g.uri.toString())}createQuickPick(n){const a=new o(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(n){const a=new i(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const g=this._sessions.get(n);g&&g._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const g=this._sessions.get(n);g instanceof o&&g._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const g=this._sessions.get(n);g instanceof o&&g._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const g=this._sessions.get(n);g&&g._fireDidTriggerButton(a)}$onDidTriggerItemButton(n,a,g){const u=this._sessions.get(n);u instanceof o&&u._fireDidTriggerItemButton(a,g)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class l{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,g)=>{const u=a===_.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(u,a)}),this.update({buttons:n.map((a,g)=>({...b(a),tooltip:a.tooltip,handle:a===_.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const g=n[a];this._pendingUpdate[a]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function c(r){if(r instanceof _.ThemeIcon)return{id:r.id};const n=s(r),a=f(r);return{dark:typeof n=="string"?D.URI.file(n):n,light:typeof a=="string"?D.URI.file(a):a}}function f(r){return typeof r=="object"&&"light"in r?r.light:r}function s(r){return typeof r=="object"&&"dark"in r?r.dark:r}function b(r){const n=c(r.iconPath);let a,g;return"id"in n?g=p.ThemeIcon.asClassName(n):a=n,{iconPath:a,iconClass:g}}class o extends l{constructor(n,a){super(n.identifier,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((g,u)=>{this._handlesToItems.set(u,g),this._itemsToHandles.set(g,u)});const a=[];for(let g=0;g<n.length;g++){const u=n[g];u.kind===_.QuickPickItemKind.Separator?a.push({type:"separator",label:u.label}):a.push({handle:g,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((m,T)=>({...b(m),tooltip:m.tooltip,handle:T}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=(0,F.coalesce)(n.map(g=>this._handlesToItems.get(g)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=(0,F.coalesce)(n.map(g=>this._handlesToItems.get(g)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(n,a){const g=this._handlesToItems.get(n);if(!g||!g.buttons||!g.buttons.length)return;const u=g.buttons[a];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:g})}}class i extends l{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new P(d,w)}e.createExtHostQuickOpen=E});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[249],be([1,0,2,3,56,6,13,5,17,97,11,27,81,15,29]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v){"use strict";var d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function C(g){if(g)return typeof g.iconPath=="string"?h.URI.file(g.iconPath):h.URI.isUri(g.iconPath)||p.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function P(g,u){if(!g.iconPath&&!u.iconPath)return 0;if(g.iconPath){if(!u.iconPath)return 1}else return-1;const m=typeof g.iconPath=="string"?g.iconPath:h.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,T=typeof u.iconPath=="string"?u.iconPath:h.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,R.comparePaths)(m,T)}function l(g,u){let m=0;if(g.strikeThrough!==u.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==u.faded)return g.faded?1:-1;if(g.tooltip!==u.tooltip)return(g.tooltip||"").localeCompare(u.tooltip||"");if(m=P(g,u),m!==0)return m;if(g.light&&u.light)m=P(g.light,u.light);else{if(g.light)return 1;if(u.light)return-1}if(m!==0)return m;if(g.dark&&u.dark)m=P(g.dark,u.dark);else{if(g.dark)return 1;if(u.dark)return-1}return m}function c(g,u){if(g.command!==u.command)return g.command<u.command?-1:1;if(g.title!==u.title)return g.title<u.title?-1:1;if(g.tooltip!==u.tooltip){if(g.tooltip!==void 0&&u.tooltip!==void 0)return g.tooltip<u.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(g.arguments===u.arguments)return 0;if(g.arguments)if(u.arguments){if(g.arguments.length!==u.arguments.length)return g.arguments.length-u.arguments.length}else return 1;else return-1;for(let m=0;m<g.arguments.length;m++){const T=g.arguments[m],O=u.arguments[m];if(T!==O)return T<O?-1:1}return 0}function f(g,u){let m=(0,R.comparePaths)(g.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(m!==0)return m;if(g.command&&u.command)m=c(g.command,u.command);else{if(g.command)return 1;if(u.command)return-1}if(m!==0)return m;if(g.decorations&&u.decorations)m=l(g.decorations,u.decorations);else{if(g.decorations)return 1;if(u.decorations)return-1}return m}function s(g,u){for(let m=0;m<g.length;m++)if(g[m]!==u[m])return!1;return!0}function b(g,u){return g.command===u.command&&g.title===u.title&&g.tooltip===u.tooltip&&(g.arguments&&u.arguments?s(g.arguments,u.arguments):g.arguments===u.arguments)}function o(g,u){return(0,_.equals)(g,u,b)}class i{constructor(u,m,T){this._extension=u,this._sourceControlHandle=T,d.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ke(this,d,m,"f")}get value(){return this._value}set value(u){u=u??"",Pe(this,d,"f").$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){Pe(this,d,"f").$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,Pe(this,d,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,Pe(this,d,"f").$setInputBoxVisibility(this._sourceControlHandle,u))}showValidationMessage(u,m){(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),Pe(this,d,"f").$showValidationMessage(this._sourceControlHandle,u,m)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=i,d=new WeakMap;class r{constructor(u,m,T,O,L){this._proxy=u,this._commands=m,this._sourceControlHandle=T,this._id=O,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,m){const T=this._resourceStatesCommandsMap.get(u);return T?(0,S.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(f),T=(0,_.sortedDiff)(this._resourceSnapshot,u,f).map(y=>{const H=y.toInsert.map(M=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,M);const x=M.resourceUri;let K;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const se=new A.DisposableStore;K=this._commands.converter.toInternal(M.command,se),this._resourceStatesDisposablesMap.set(z,se)}else this._resourceStatesCommandsMap.set(z,M.command);const B=C(M.decorations),G=M.decorations&&C(M.decorations.light)||B,X=M.decorations&&C(M.decorations.dark)||B,q=[G,X],ee=M.decorations&&M.decorations.tooltip||"",ae=M.decorations&&!!M.decorations.strikeThrough,ue=M.decorations&&!!M.decorations.faded,Z=M.contextValue||"";return{rawResource:[z,x,q,ee,ae,ue,Z,K],handle:z}});return{start:y.start,deleteCount:y.deleteCount,toInsert:H}}),O=T.map(({start:y,deleteCount:H,toInsert:M})=>[y,H,M.map(z=>z.rawResource)]),L=T.reverse();for(const{start:y,deleteCount:H,toInsert:M}of L){const z=M.map(K=>K.handle),x=this._handlesSnapshot.splice(y,H,...z);for(const K of x)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=u,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class n{constructor(u,m,T,O,L,y){this._extension=u,this._commands=T,this._id=O,this._label=L,this._rootUri=y,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ke(this,w,m,"f"),this._inputBox=new i(u,Pe(this,w,"f"),this.handle),Pe(this,w,"f").$registerSourceControl(this.handle,O,L,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,Pe(this,w,"f").$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,Pe(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,Pe(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const m=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);Pe(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=u;const m=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),description:u.description}:void 0;Pe(this,w,"f").$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&o(this._statusBarCommands,u))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const m=(u||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));Pe(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(u,m){const T=new r(Pe(this,w,"f"),this._commands,this.handle,u,m),O=t.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,O),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const u=[],m=[];for(const[T,O]of this.createdResourceGroups){O.dispose();const L=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});t.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),L.dispose(),this._groups.delete(T.handle),Pe(this,w,"f").$unregisterGroup(this.handle,T.handle)}),u.push([T.handle,T.id,T.label,T.features]);const y=T._takeResourceStateSnapshot();y.length>0&&m.push([T.handle,y]),this._groups.set(T.handle,T)}Pe(this,w,"f").$registerGroups(this.handle,u,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(m=>{const T=m._takeResourceStateSnapshot();T.length!==0&&u.push([m.handle,T])}),u.length>0&&Pe(this,w,"f").$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),Pe(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,n._handlePool=0,Be([(0,k.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Be([(0,k.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class xi{constructor(u,m,T){this._commands=m,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const L=this._sourceControls.get(O.sourceControlHandle);if(!L)return O;const y=L.getResourceGroup(O.groupHandle);return y?y.getResourceState(O.handle):O}else if(O&&O.$mid===4){const L=this._sourceControls.get(O.sourceControlHandle);return L?L.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const L=this._sourceControls.get(O.handle);return L||O}return O}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,m,T,O){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,m,T,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const L=xi._handlePool++,y=new n(u,this._proxy,this._commands,m,T,O);this._sourceControls.set(L,y);const H=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return H.push(y),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),H),y}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),T=m&&m[m.length-1];return T&&T.inputBox}$provideOriginalResource(u,m,T){const O=h.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,O.toString());const L=this._sourceControls.get(u);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(O,T)).then(y=>y||null)}$onInputBoxValueChange(u,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const T=this._sourceControls.get(u);return T&&T.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(u,m,T,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,m,T);const L=this._sourceControls.get(u);if(!L)return Promise.resolve(void 0);const y=L.getResourceGroup(m);return y?y.$executeResourceCommand(T,O):Promise.resolve(void 0)}$validateInput(u,m,T){this.logService.trace("ExtHostSCM#$validateInput",u);const O=this._sourceControls.get(u);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>O.inputBox.validateInput(m,T)).then(L=>{if(!L)return Promise.resolve(void 0);const y=E.MarkdownString.fromStrict(L.message);return y?Promise.resolve([y,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=Be([Fe(2,F.ILogService)],a),e.ExtHostSCM=a});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[250],be([1,0,7,5,169,6,15,18]),function(te,e,h,t,k,A,S,D){"use strict";var _,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(v,d,w,C,P=h.StatusBarAlignment.Left,l){_.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ke(this,_,v,"f"),Ke(this,R,d,"f"),this._entryId=F.ID_GEN++,this._extension=w,this._id=C,this._alignment=P,this._priority=this.validatePriority(l)}validatePriority(v){if(!!(0,D.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!F.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:Pe(this,R,"f").toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:Pe(this,R,"f").toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Pe(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let d;this._name?d=this._name:d=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const C=S.MarkdownString.fromStrict(this._tooltip);Pe(this,_,"f").$setEntry(this._entryId,v,d,this._text,C,this._command?.internal,w,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,_=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const d={message:v};return this._messages.unshift(d),this._update(),new h.Disposable(()=>{const w=this._messages.indexOf(d);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(v,d){this._proxy=v.getProxy(t.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new I(this)}createStatusBarEntry(v,d,w,C){return new F(this._proxy,this._commands,v,d,w,C)}setStatusBarMessage(v,d){const w=this._statusMessage.setMessage(v);let C;return typeof d=="number"?C=setTimeout(()=>w.dispose(),d):typeof d!="undefined"&&d.then(()=>w.dispose(),()=>w.dispose()),new h.Disposable(()=>{w.dispose(),clearTimeout(C)})}}e.ExtHostStatusBar=p}),define(we[87],be([1,0,5,3,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}initializeExtensionStorage(D,_,R){return this._proxy.$initializeExtensionStorage(D,_).then(F=>F||R)}setValue(D,_,R){return this._proxy.$setValue(D,_,R)}$acceptValue(D,_,R){this._onDidChangeStorage.fire({shared:D,key:_,value:R})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(we[67],be([1,0,4,26,11,66,2]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let D=class{constructor(R,F,I){this._logService=F,this._extHostFileSystem=I,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(R){return S.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:S.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(R){if(this._value)return S.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return S.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Be([Fe(0,t.IExtHostInitDataService),Fe(1,k.ILogService),Fe(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[34],be([1,0,3,5,4,2,14,6,7,170,16,216,21,33,196,81,18,13]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class P{constructor(n,a,g,u){this._proxy=n,this._id=a,this._creationOptions=g,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},get state(){return m._state},sendText(T,O=!0){m._checkDisposed(),m._proxy.$sendText(m._id,T,O)},show(T){m._checkDisposed(),m._proxy.$show(m._id,T)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(n,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,w.withNullAsUndefined)(n.shellPath),shellArgs:(0,w.withNullAsUndefined)(n.shellArgs),cwd:(0,w.withNullAsUndefined)(n.cwd),env:(0,w.withNullAsUndefined)(n.env),icon:(0,w.withNullAsUndefined)(o(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,w.withNullAsUndefined)(n.message),strictEnv:(0,w.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(n.location,a?.resolvedExtHostIdentifier),isTransient:(0,w.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,a,g,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:d.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(n,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,a){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,a){return n===this._cols&&a===this._rows||n===0||a===0?!1:(this._cols=n,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=P;class l{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new h.Emitter,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,a){this._pty.setDimensions?.({columns:n,rows:a})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let c=1,f=class extends D.Disposable{constructor(n,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[g,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,a){const g=new P(this._proxy,(0,E.generateUuid)(),n,n.name),u=new l(n.pty);return g.createExtensionTerminal(n.location,this._serializeParentTerminal(n,a).resolvedExtHostIdentifier,o(n.iconPath),i(n.color)).then(m=>{const T=this._setupExtHostProcessListeners(m,u);this._terminalProcessDisposables[m]=T}),this._terminals.push(g),g.value}_serializeParentTerminal(n,a){if(a=a||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const u=this._terminals.find(m=>m.value===g);u&&(a.resolvedExtHostIdentifier=u._id)}}else n.location&&typeof n.location!="object"?a.location=n.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(n,a){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const u=new l(a),m=this._setupExtHostProcessListeners(n,u);this._terminalProcessDisposables[n]=m}async $acceptActiveTerminalChanged(n){const a=this._activeTerminal;if(n===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(n);g&&(this._activeTerminal=g,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,a){const g=this._getTerminalById(n);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:a})}async $acceptTerminalDimensions(n,a,g){const u=this._getTerminalById(n);u&&u.setDimensions(a,g)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(n,a,g){this._terminalProcesses.get(n)?.resize(a,g)}async $acceptTerminalTitleChange(n,a){const g=this._getTerminalById(n);g&&(g.name=a)}async $acceptTerminalClosed(n,a){const g=this._getTerminalObjectIndexById(this._terminals,n);if(g!==null){const u=this._terminals.splice(g,1)[0];u.setExitCode(a),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(n,a,g,u){if(a){const O=this._getTerminalObjectIndexById(this._terminals,a);if(O!==null){this._terminals[O]._id=n,this._onDidOpenTerminal.fire(this.terminals[O]),this._terminals[O].isOpen=!0;return}}const m={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:A.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},T=new P(this._proxy,n,m,g);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(n,a){const g=this._getTerminalById(n);g&&g._setProcessId(a)}async $startExtensionTerminal(n,a){const g=this._getTerminalById(n);if(!g)return{message:(0,R.localize)(0,null,n)};g.isOpen||await new Promise(m=>{const T=this.onDidOpenTerminal(async O=>{O===g.value&&(T.dispose(),m())})});const u=this._terminalProcesses.get(n);u?u.startSendingEvents(a):this._extensionTerminalAwaitingStart[n]={initialDimensions:a}}_setupExtHostProcessListeners(n,a){const g=new D.DisposableStore;g.add(a.onProcessReady(m=>this._proxy.$sendProcessReady(n,m.pid,m.cwd))),g.add(a.onDidChangeProperty(m=>this._proxy.$sendProcessProperty(n,m))),this._bufferer.startBuffering(n,a.onProcessData),g.add(a.onProcessExit(m=>this._onProcessExit(n,m))),this._terminalProcesses.set(n,a);const u=this._extensionTerminalAwaitingStart[n];return u&&a instanceof l&&(a.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),g}$acceptProcessAckDataEvent(n,a){this._terminalProcesses.get(n)?.acknowledgeDataEvent(a)}$acceptProcessInput(n,a){this._terminalProcesses.get(n)?.input(a)}$acceptTerminalInteraction(n){const a=this._getTerminalById(n);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(n,a,g){try{this._terminalProcesses.get(n)?.resize(a,g)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(n,a){this._terminalProcesses.get(n)?.shutdown(a)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(a=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:a}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,a,g){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,g),this._proxy.$registerProfileProvider(a,n.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(n,a){const g=new p.CancellationTokenSource().token;let u=await this._profileProviders.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,a);return}this.createTerminalFromOptions(u.options,a)}}async $provideLinks(n,a){const g=this._getTerminalById(n);if(!g)return[];this._terminalLinkCache.delete(n);const u=this._terminalLinkCancellationSource.get(n);u&&u.dispose(!0);const m=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,m);const T=[],O={terminal:g.value,line:a},L=[];for(const M of this._linkProviders)L.push(C.Promises.withAsyncBody(async z=>{m.token.onCancellationRequested(()=>z({provider:M,links:[]}));const x=await M.provideTerminalLinks(O,m.token)||[];m.token.isCancellationRequested||z({provider:M,links:x})}));const y=await Promise.all(L);if(m.token.isCancellationRequested)return[];const H=new Map;for(const M of y)M&&M.links.length>0&&T.push(...M.links.map(z=>{const x={id:c++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return H.set(x.id,{provider:M.provider,link:z}),x}));return this._terminalLinkCache.set(n,H),T}$activateLink(n,a){const g=this._terminalLinkCache.get(n)?.get(a);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(n,a){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const g=this._terminalProcessDisposables[n];g&&(g.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,a)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,a){const g=this._getTerminalObjectIndexById(n,a);return g!==null?n[g]:null}_getTerminalObjectIndexById(n,a){let g=null;return n.some((u,m)=>u._id===a?(g=m,!0):!1),g}getEnvironmentVariableCollection(n){let a=this._environmentVariableCollections.get(n.identifier.value);return a||(a=new s,this._setEnvironmentVariableCollection(n.identifier.value,a)),a}_syncEnvironmentVariableCollection(n,a){const g=(0,I.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(n,a.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(a=>{const g=a[0],u=new s(a[1]);this._setEnvironmentVariableCollection(g,u)})}$acceptDefaultProfile(n,a){this._defaultProfile=n,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(n,a){this._environmentVariableCollections.set(n,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,a)})}};f=Be([Fe(1,S.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class s{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,a){this._setIfDiffers(n,{value:a,type:_.EnvironmentVariableMutatorType.Replace})}append(n,a){this._setIfDiffers(n,{value:a,type:_.EnvironmentVariableMutatorType.Append})}prepend(n,a){this._setIfDiffers(n,{value:a,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,a){const g=this.map.get(n);(!g||g.value!==a.value||g.type!==a.type)&&(this.map.set(n,a),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,a){this.map.forEach((g,u)=>n.call(a,u,g,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let b=class extends f{constructor(n){super(!1,n)}createTerminal(n,a,g){throw new F.NotSupportedError}createTerminalFromOptions(n,a){throw new F.NotSupportedError}};b=Be([Fe(0,S.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function o(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return d.ThemeColor.isThemeColor(r)?r:void 0}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[251],be([1,0,17,22,21,3,75,57,6,25,18,33,5,14,63,15,7,222,84,85]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let f=class{constructor(O,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(p.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new b(this.proxy),L.registerArgumentProcessor({processArgument:y=>y?.$mid===13?d.TestItem.toItemFromContext(y):y})}createTestController(O,L,y){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const H=new _.DisposableStore,M=H.add(new C.SingleUseTestCollection(O));M.root.label=L;const z=new Map,x=this.proxy,K={items:M.root.children,get label(){return L},set label(G){L=G,M.root.label=G,x.$updateController(O,{label:L})},get refreshHandler(){return y},set refreshHandler(G){y=G,x.$updateController(O,{canRefresh:!!G})},get id(){return O},createRunProfile:(G,X,q,ee,ae)=>{let ue=(0,D.hash)(G);for(;z.has(ue);)ue++;const Z=new u(this.proxy,O,ue,G,X,q,ee,ae);return z.set(ue,Z),Z},createTestItem(G,X,q){return new v.TestItemImpl(O,G,X,q)},createTestRun:(G,X,q=!0)=>this.runTracker.createTestRun(O,M,G,X,q),set resolveHandler(G){M.resolveHandler=G},get resolveHandler(){return M.resolveHandler},dispose:()=>{H.dispose()}};x.$registerTestController(O,L,!!y),H.add((0,_.toDisposable)(()=>x.$unregisterTestController(O)));const B={controller:K,collection:M,profiles:z};return this.controllers.set(O,B),H.add((0,_.toDisposable)(()=>this.controllers.delete(O))),H.add(M.onDidGenerateDiff(G=>x.$publishDiff(O,G.map(P.TestsDiffOp.serialize)))),K}createTestObserver(){return this.observer.checkout()}async runTests(O,L=k.CancellationToken.None){const y=o(O);if(!y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(y.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(M=>M.id)??[H.collection.root.id],profileGroup:m[y.kind],profileId:y.profileId,controllerId:y.controllerId}],exclude:O.exclude?.map(M=>M.id)},L)}$provideFileCoverage(O,L,y){return(0,h.mapFind)(this.runTracker.trackers,M=>M.id===O?M.getCoverage(L):void 0)?.provideFileCoverage(y)??Promise.resolve([])}$resolveFileCoverage(O,L,y,H){return(0,h.mapFind)(this.runTracker.trackers,z=>z.id===O?z.getCoverage(L):void 0)?.resolveFileCoverage(y,H)??Promise.resolve([])}$configureRunProfile(O,L){this.controllers.get(O)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(O,L){await this.controllers.get(O)?.controller.refreshHandler?.(L)}$publishTestResults(O){this.results=Object.freeze(O.map(L=>(0,R.deepFreeze)(d.TestResults.to(L))).concat(this.results).sort((L,y)=>y.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,L){const y=this.controllers.get(l.TestId.fromString(O).controllerId)?.collection;y&&(await y.expand(O,L<0?1/0:L),y.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O.map(P.TestsDiffOp.deserialize))}async $runControllerTests(O,L){const y=this.controllers.get(O.controllerId);if(!y)return;const{collection:H,profiles:M}=y,z=M.get(O.profileId);if(!z)return;const x=O.testIds.map(X=>H.tree.get(X)).filter(F.isDefined),K=O.excludeExtIds.map(X=>y.collection.tree.get(X)).filter(F.isDefined).filter(X=>x.some(q=>q.fullId.compare(X.fullId)===2));if(!x.length)return;const B=new w.TestRunRequest(x.some(X=>X.actual instanceof v.TestItemRootImpl)?void 0:x.map(X=>X.actual),K.map(X=>X.actual),z),G=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(O,y.collection),L);try{await z.runHandler(B,L)}finally{G.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(G.onEnd),G.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};f=Be([Fe(0,E.IExtHostRpcService)],f),e.ExtHostTesting=f;class s extends _.Disposable{constructor(O,L,y){super();this.dto=O,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const L=this.dto.id,y=this.dto.controllerId,H=(0,I.generateUuid)(),M=new r(this.proxy,L,H),z=G=>(X,...q)=>{if(K){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(X)||(this.ensureTestIsKnown(X),G(X,...q))},x=(G,X)=>{const q=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(G.uri&&G.range){const ee={range:d.Range.from(G.range),uri:G.uri};for(const ae of q)ae.location=ae.location||ee}this.proxy.$appendTestMessagesInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),q)};let K=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return M.coverageProvider},set coverageProvider(G){M.coverageProvider=G},enqueued:z(G=>{this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),1)}),skipped:z(G=>{this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),5)}),started:z(G=>{this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),2)}),errored:z((G,X,q)=>{x(G,X),this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),6,q)}),failed:z((G,X,q)=>{x(G,X),this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,y).toString(),4,q)}),passed:z((G,X)=>{this.proxy.$updateTestStateInRun(L,H,l.TestId.fromExtHostTestItem(G,this.dto.controllerId).toString(),3,X)}),appendOutput:(G,X,q)=>{K||(q&&(this.dto.isIncluded(q)?this.ensureTestIsKnown(q):q=void 0),this.proxy.$appendOutputToRun(L,H,t.VSBuffer.fromString(G),X&&d.location.from(X),q&&l.TestId.fromExtHostTestItem(q,y).toString()))},end:()=>{K||(K=!0,this.proxy.$finishedTestRunTask(L,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:B,coverage:M}),this.proxy.$startedTestRunTask(L,{id:H,name:O,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof v.TestItemImpl))throw new v.InvalidTestItemError(O.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const L=[],y=this.dto.colllection.root;for(;;){const H=d.TestItem.from(O);if(L.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),O===y))break;O=O.parent||y}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class b{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,L,y){return this.getTracker(O,L,y)}cancelRunById(O){for(const L of this.tracked.values())if(L.id===O){L.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,L,y,H,M){const z=this.tracked.get(y);if(z)return z.createRun(H);const x=i.fromPublic(O,L,y,M),K=o(y);this.proxy.$startedExtensionTestRun({controllerId:O,profile:K&&{group:m[K.kind],id:K.profileId},exclude:y.exclude?.map(G=>G.id)??[],id:x.id,include:y.include?.map(G=>G.id)??[L.root.id],persist:M});const B=this.getTracker(y,x);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),B.createRun(H)}getTracker(O,L,y){const H=new s(L,this.proxy,y);return this.tracked.set(O,H),H.onEnd(()=>this.tracked.delete(O)),H}}e.TestRunCoordinator=b;const o=T=>{if(!!T.profile){if(!(T.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(O,L,y,H,M,z){this.controllerId=O,this.id=L,this.isPersisted=M,this.colllection=z,this.includePrefix=y.map(x=>x+"\0"),this.excludePrefix=H.map(x=>x+"\0")}static fromPublic(O,L,y,H){return new i(O,(0,I.generateUuid)(),y.include?.map(M=>l.TestId.fromExtHostTestItem(M,O).toString())??[O],y.exclude?.map(M=>l.TestId.fromExtHostTestItem(M,O).toString())??[],H,L)}static fromInternal(O,L){return new i(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,L)}isIncluded(O){const L=l.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const y of this.excludePrefix)if(L===y||L.startsWith(y))return!1;for(const y of this.includePrefix)if(L===y||L.startsWith(y))return!0;return!1}}e.TestRunDto=i;class r{constructor(O,L,y){this.proxy=O,this.runId=L,this.taskId=y}set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(O,L){const y=await this.fileCoverage;let H=y?.[O];return!this._coverageProvider||!y||!H?[]:(H.detailedCoverage||(H=y[O]=await this._coverageProvider.resolveFileCoverage?.(H,L)??H),H.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class n extends P.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:L,removed:y}=this;return{get added(){return[...O].map(H=>H.revived)},get updated(){return[...L].map(H=>H.revived)},get removed(){return[...y].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,L){return{...O,revived:d.TestItem.toPlain(O.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=a;class g{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(L=>L.revived)},dispose:(0,S.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class u{constructor(O,L,y,H,M,z,x=!1,K=void 0){this.controllerId=L,this.profileId=y,this._label=H,this.kind=M,this.runHandler=z,this._isDefault=x,this._tag=K,c.set(this,void 0),Ke(this,c,O,"f");const B=m[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Pe(this,c,"f").$publishTestRunProfile({profileId:y,controllerId:L,tag:K?d.TestTag.namespace(this.controllerId,K.id):null,label:H,group:B,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}dispose(){Pe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,c=new WeakMap;const m={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(we[252],be([1,0,3,17,5,131,15,7]),function(te,e,h,t,k,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(F,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const I=this._extHostDocumentsAndEditors.allEditors();return F?I:I.map(p=>p.value)}async showTextDocument(F,I,p){let E;typeof I=="number"?E={position:S.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?E={position:S.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?S.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:E={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(F.uri,E),d=v&&this._extHostDocumentsAndEditors.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,I){return new A.TextEditorDecorationType(this._proxy,F,I).value}$acceptEditorPropertiesChanged(F,I){const p=this._extHostDocumentsAndEditors.getEditor(F);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const E=I.selections.selections.map(S.Selection.to);p._acceptSelections(E)}if(I.visibleRanges){const E=t.coalesce(I.visibleRanges.map(S.Range.to));p._acceptVisibleRanges(E)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...I.options,lineNumbers:S.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const E=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),v=I.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:v,kind:E})}if(I.visibleRanges){const E=t.coalesce(I.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(F){for(const I in F){const p=this._extHostDocumentsAndEditors.getEditor(I);if(!p)throw new Error("Unknown text editor");const E=S.ViewColumn.to(F[I]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=_}),define(we[253],be([1,0,2,4,5,6,7]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class D{constructor(F,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===11){const E=p.uri===void 0?void 0:h.URI.revive(p.uri);return this._itemsBySourceAndUriMap.get(p.source)?.get(_(E))?.get(p.handle)}return p}})}async $getTimeline(F,I,p,E,v){return this._providers.get(F)?.provideTimeline(h.URI.revive(I),p,E,v)}registerTimelineProvider(F,I,p,E){const v=new A.DisposableStore,d=this.convertTimelineItem(I.id,E,v).bind(this);let w;I.onDidChange&&(w=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:F,onDidChange:void 0,async provideTimeline(P,l,c,f){f?.resetCache&&(v.clear(),C.get(I.id)?.clear());const s=await I.provideTimeline(P,l,c);if(s==null)return;const b=d(P,f);return{...s,source:I.id,items:s.items.map(b)}},dispose(){for(const P of C.values())P.get(I.id)?.clear();w?.dispose(),v.dispose()}})}convertTimelineItem(F,I,p){return(E,v)=>{let d;if(v?.cacheResults){let w=this._itemsBySourceAndUriMap.get(F);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(F,w));const C=_(E);d=w.get(C),d===void 0&&(d=new Map,w.set(C,d))}return w=>{const{iconPath:C,...P}=w,l=`${F}|${w.id??w.timestamp}`;d?.set(l,w);let c,f,s;return w.iconPath&&(C instanceof S.ThemeIcon?s={id:C.id,color:C.color}:h.URI.isUri(C)?(c=C,f=C):{light:c,dark:f}=C),{...P,id:P.id??void 0,handle:l,source:F,command:w.command?I.toInternal(w.command,p):void 0,icon:c,iconDark:f,themeIcon:s,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,A.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=D;function _(R){return R?.toString()}}),define(we[254],be([1,0,6,10,2,5]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(_){this._openers=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,R,F,I){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const p=I.schemes.find(E=>!S.supportedSchemes.has(E));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,I.schemes,_,I.label),(0,h.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(_,R,F){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const p=k.URI.revive(R);return I.canOpenExternalUri(p,F)}async $openUri(_,R,F){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(k.URI.revive(R.resolvedUri),{sourceUri:k.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(we[255],be([1,0,5,2,6,16,27]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(S.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const I=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(R)),this.handlers.set(I,F),this._proxy.$registerUriHandler(I,R),(0,k.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(R)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(R,F){const I=this.handlers.get(R);if(!I)return Promise.resolve(void 0);try{I.handleUri(t.URI.revive(F))}catch(p){(0,A.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=D,D.HandlePool=0});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[68],be([1,0,3,10,2,183,204,83,5]),function(te,e,h,t,k,A,S,D,_){"use strict";var R,F,I,p,E,v,d,w,C,P,l,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(g,u,m,T,O,L,y){R.set(this,void 0),F.set(this,void 0),I.set(this,void 0),p.set(this,void 0),E.set(this,void 0),v.set(this,void 0),d.set(this,""),w.set(this,void 0),C.set(this,!1),P.set(this,!1),l.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new h.Emitter),this._onDidDispose=Pe(this,c,"f").event,Ke(this,R,g,"f"),Ke(this,F,u,"f"),Ke(this,w,m,"f"),Ke(this,p,T,"f"),Ke(this,E,O,"f"),Ke(this,v,L,"f"),Ke(this,l,s(L),"f"),Ke(this,I,y,"f")}dispose(){Ke(this,C,!0,"f"),Pe(this,c,"f").fire(),Pe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Ke(this,P,!0,"f"),(0,D.asWebviewUri)(g,Pe(this,p,"f").remote)}get cspSource(){const g=Pe(this,v,"f").extensionLocation;if(g.scheme===t.Schemas.https||g.scheme===t.Schemas.http){let u=g.toString();return u.endsWith("/")||(u+="/"),u+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Pe(this,d,"f")}set html(g){this.assertNotDisposed(),Pe(this,d,"f")!==g&&(Ke(this,d,g,"f"),!Pe(this,P,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Ke(this,P,!0,"f"),Pe(this,I,"f").report("Webview vscode-resource: uris",Pe(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Pe(this,F,"f").$setHtml(Pe(this,R,"f"),g))}get options(){return this.assertNotDisposed(),Pe(this,w,"f")}set options(g){this.assertNotDisposed(),Pe(this,F,"f").$setOptions(Pe(this,R,"f"),i(Pe(this,v,"f"),Pe(this,E,"f"),g)),Ke(this,w,g,"f")}async postMessage(g){if(Pe(this,C,"f"))return!1;const u=(0,S.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Pe(this,l,"f")});return Pe(this,F,"f").$postMessage(Pe(this,R,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Pe(this,C,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,R=new WeakMap,F=new WeakMap,I=new WeakMap,p=new WeakMap,E=new WeakMap,v=new WeakMap,d=new WeakMap,w=new WeakMap,C=new WeakMap,P=new WeakMap,l=new WeakMap,c=new WeakMap;function s(a){try{const g=(0,A.normalizeVersion)((0,A.parseVersion)(a.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class b{constructor(g,u,m,T,O){this.initData=u,this.workspace=m,this._logService=T,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=g.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(g,u,m){const T=this.getWebview(g);if(T){const{message:O}=(0,S.deserializeWebviewMessage)(u,m.value);T._onMessageEmitter.fire(O)}}$onMissingCsp(g,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,u,m){const T=new f(g,this._webviewProxy,r(u),this.initData,this.workspace,m,this._deprecationService);return this._webviews.set(g,T),T._onDidDispose(()=>{this._webviews.delete(g)}),T}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=b;function o(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=o;function i(a,g,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(a,g)}}e.serializeWebviewOptions=i;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(g=>k.URI.from(g))}}e.reviveOptions=r;function n(a,g){return[...(g?.getWorkspaceFolders()||[]).map(u=>u.uri),a.extensionLocation]}}),define(we[256],be([1,0,21,57,6,10,23,2,15,68,82,5,7]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(s,b){this.document=s,this._storagePath=b,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,b){await this.getEdit(s).undo(),b||this.disposeBackup()}async redo(s,b){await this.getEdit(s).redo(),b||this.disposeBackup()}disposeEdits(s){for(const b of s)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const b=this._edits.get(s,0);if(!b)throw new Error("No edit found");return b}}class v{constructor(){this._documents=new Map}get(s,b){return this._documents.get(this.key(s,b))}add(s,b,o){const i=this.key(s,b.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${b.uri}`);const r=new E(b,o);return this._documents.set(i,r),r}delete(s,b){const o=this.key(s,b.uri);this._documents.delete(o)}key(s,b){return`${s}@@@${b}`}}var d;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(d||(d={}));class w{constructor(){this._providers=new Map}addTextProvider(s,b,o){return this.add(0,s,b,o)}addCustomProvider(s,b,o){return this.add(1,s,b,o)}get(s){return this._providers.get(s)}add(s,b,o,i){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:s,extension:o,provider:i}),new p.Disposable(()=>this._providers.delete(b))}}class C{constructor(s,b,o,i,r){this._extHostDocuments=b,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new w,this._documents=new v,this._proxy=s.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,b,o,i){const r=new k.DisposableStore;return P(o)?(r.add(this._editorProviders.addTextProvider(b,s,o)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(s),b,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(b,s,o)),this.supportEditing(o)&&r.add(o.onDidChangeCustomDocument(n=>{const a=this.getCustomDocumentEntry(b,n.document.uri);if(l(n)){const g=a.addEdit(n);this._proxy.$onDidEdit(n.document.uri,b,g,n.label)}else this._proxy.$onContentChange(n.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(s),b,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(s))),p.Disposable.from(r,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(s,b,o,i,r){const n=this._editorProviders.get(b);if(!n)throw new Error(`No provider found for '${b}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${b}'`);const a=D.URI.revive(s),g=await n.provider.openCustomDocument(a,{backupId:o,untitledDocumentData:i?.buffer},r);let u;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(b,g,u),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(s,b){const o=this._editorProviders.get(b);if(!o)throw new Error(`No provider found for '${b}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${b}'`);const i=D.URI.revive(s),{document:r}=this.getCustomDocumentEntry(b,i);this._documents.delete(b,r),r.dispose()}async $resolveWebviewEditor(s,b,o,i,r,n){const a=this._editorProviders.get(o);if(!a)throw new Error(`No provider found for '${o}'`);const g=_.ViewColumn.to(r),u=this._extHostWebview.createNewWebview(b,i.webviewOptions,a.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(b,o,i.title,g,i.panelOptions,u),T=D.URI.revive(s);switch(a.type){case 1:{const{document:O}=this.getCustomDocumentEntry(o,T);return a.provider.resolveCustomEditor(O,m,n)}case 0:{const O=this._extHostDocuments.getDocument(T);return a.provider.resolveCustomTextEditor(O,m,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,b,o){this.getCustomDocumentEntry(b,s).disposeEdits(o)}async $onMoveCustomEditor(s,b,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const n=D.URI.revive(b),a=this._extHostDocuments.getDocument(n);await i.provider.moveCustomTextEditor(a,r,h.CancellationToken.None)}async $undo(s,b,o,i){return this.getCustomDocumentEntry(b,s).undo(o,i)}async $redo(s,b,o,i){return this.getCustomDocumentEntry(b,s).redo(o,i)}async $revert(s,b,o){const i=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(s,b,o){const i=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(s,b,o,i){const r=this.getCustomDocumentEntry(b,s);return this.getCustomEditorProvider(b).saveCustomDocumentAs(r.document,D.URI.revive(o),i)}async $backup(s,b,o){const i=this.getCustomDocumentEntry(b,s),n=await this.getCustomEditorProvider(b).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(n),n.id}getCustomDocumentEntry(s,b){const o=this._documents.get(s,D.URI.revive(b));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(s){const o=this._editorProviders.get(s)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=C;function P(f){return typeof f.resolveCustomTextEditor=="function"}function l(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function c(f){const s=f.scheme===A.Schemas.file||f.scheme===A.Schemas.untitled?f.fsPath:f.toString();return(0,t.hash)(s)+""}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[257],be([1,0,3,6,2,33,15,68,5,7]),function(te,e,h,t,k,A,S,D,_,R){"use strict";var F,I,p,E,v,d,w,C,P,l,c,f,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends t.Disposable{constructor(n,a,g,u,m,T,O){super();F.set(this,void 0),I.set(this,void 0),p.set(this,void 0),E.set(this,void 0),v.set(this,void 0),d.set(this,void 0),w.set(this,void 0),C.set(this,void 0),P.set(this,!0),l.set(this,!0),c.set(this,!1),f.set(this,this._register(new h.Emitter)),this.onDidDispose=Pe(this,f,"f").event,s.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Pe(this,s,"f").event,Ke(this,F,n,"f"),Ke(this,I,a,"f"),Ke(this,p,g,"f"),Ke(this,v,T,"f"),Ke(this,C,m,"f"),Ke(this,d,u,"f"),Ke(this,E,O,"f")}dispose(){Pe(this,c,"f")||(Ke(this,c,!0,"f"),Pe(this,f,"f").fire(),Pe(this,I,"f").$disposeWebview(Pe(this,F,"f")),Pe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Pe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Pe(this,p,"f")}get title(){return this.assertNotDisposed(),Pe(this,d,"f")}set title(n){this.assertNotDisposed(),Pe(this,d,"f")!==n&&(Ke(this,d,n,"f"),Pe(this,I,"f").$setTitle(Pe(this,F,"f"),n))}get iconPath(){return this.assertNotDisposed(),Pe(this,w,"f")}set iconPath(n){this.assertNotDisposed(),Pe(this,w,"f")!==n&&(Ke(this,w,n,"f"),Pe(this,I,"f").$setIconPath(Pe(this,F,"f"),k.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Pe(this,v,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Pe(this,C,"f")=="number"&&Pe(this,C,"f")<0))return Pe(this,C,"f")}get active(){return this.assertNotDisposed(),Pe(this,l,"f")}get visible(){return this.assertNotDisposed(),Pe(this,P,"f")}_updateViewState(n){Pe(this,c,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(Ke(this,l,n.active,"f"),Ke(this,P,n.visible,"f"),Ke(this,C,n.viewColumn,"f"),Pe(this,s,"f").fire({webviewPanel:this}))}reveal(n,a){this.assertNotDisposed(),Pe(this,I,"f").$reveal(Pe(this,F,"f"),{viewColumn:typeof n=="undefined"?void 0:S.ViewColumn.from(n),preserveFocus:!!a})}assertNotDisposed(){if(Pe(this,c,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,I=new WeakMap,p=new WeakMap,E=new WeakMap,v=new WeakMap,d=new WeakMap,w=new WeakMap,C=new WeakMap,P=new WeakMap,l=new WeakMap,c=new WeakMap,f=new WeakMap,s=new WeakMap;class o{constructor(n,a,g){this.webviews=a,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(n,a,g,u,m={}){const T=typeof u=="object"?u.viewColumn:u,O={viewColumn:S.ViewColumn.from(T),preserveFocus:typeof u=="object"&&!!u.preserveFocus},L=(0,D.shouldSerializeBuffersForPostMessage)(n),y=o.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(n),y,a,{title:g,panelOptions:i(m),webviewOptions:(0,D.serializeWebviewOptions)(n,this.workspace,m),serializeBuffersForPostMessage:L},O);const H=this.webviews.createNewWebview(y,m,n);return this.createNewWebviewPanel(y,a,g,T,m,H)}$onDidChangeWebviewPanelViewStates(n){const a=Object.keys(n);a.sort((g,u)=>{const m=n[g],T=n[u];return m.active?1:T.active?-1:+m.visible-+T.visible});for(const g of a){const u=this.getWebviewPanel(g);if(!u)continue;const m=n[g];u._updateViewState({active:m.active,visible:m.visible,viewColumn:S.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,a,g){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:g,extension:n}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(n)}),new R.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(n,a,g,u){const m=this._serializers.get(a);if(!m)throw new Error(`No serializer found for '${a}'`);const{serializer:T,extension:O}=m,L=this.webviews.createNewWebview(n,g.webviewOptions,O),y=this.createNewWebviewPanel(n,a,g.title,u,g.panelOptions,L);await T.deserializeWebviewPanel(y,g.state)}createNewWebviewPanel(n,a,g,u,m,T){const O=new b(n,this._proxy,a,g,u,m,T);return this._webviewPanels.set(n,O),O}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=o;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[258],be([1,0,3,6,68,5,7]),function(te,e,h,t,k,A,S){"use strict";var D,_,R,F,I,p,E,v,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends t.Disposable{constructor(c,f,s,b,o,i){super();D.set(this,void 0),_.set(this,void 0),R.set(this,void 0),F.set(this,void 0),I.set(this,!1),p.set(this,void 0),E.set(this,void 0),v.set(this,void 0),d.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Pe(this,d,"f").event,w.set(this,this._register(new h.Emitter)),this.onDidDispose=Pe(this,w,"f").event,Ke(this,R,s,"f"),Ke(this,E,b,"f"),Ke(this,D,c,"f"),Ke(this,_,f,"f"),Ke(this,F,o,"f"),Ke(this,p,i,"f")}dispose(){Pe(this,I,"f")||(Ke(this,I,!0,"f"),Pe(this,w,"f").fire(),Pe(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Pe(this,E,"f")}set title(c){this.assertNotDisposed(),Pe(this,E,"f")!==c&&(Ke(this,E,c,"f"),Pe(this,_,"f").$setWebviewViewTitle(Pe(this,D,"f"),c))}get description(){return this.assertNotDisposed(),Pe(this,v,"f")}set description(c){this.assertNotDisposed(),Pe(this,v,"f")!==c&&(Ke(this,v,c,"f"),Pe(this,_,"f").$setWebviewViewDescription(Pe(this,D,"f"),c))}get visible(){return Pe(this,p,"f")}get webview(){return Pe(this,F,"f")}get viewType(){return Pe(this,R,"f")}_setVisible(c){c===Pe(this,p,"f")||Pe(this,I,"f")||(Ke(this,p,c,"f"),Pe(this,d,"f").fire())}show(c){this.assertNotDisposed(),Pe(this,_,"f").$show(Pe(this,D,"f"),!!c)}assertNotDisposed(){if(Pe(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,R=new WeakMap,F=new WeakMap,I=new WeakMap,p=new WeakMap,E=new WeakMap,v=new WeakMap,d=new WeakMap,w=new WeakMap;class P{constructor(c,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,f,s,b){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:s,extension:c}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(c),f,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(c,f,s,b,o){const i=this._viewProviders.get(f);if(!i)throw new Error(`No view provider found for '${f}'`);const{provider:r,extension:n}=i,a=this._extHostWebview.createNewWebview(c,{},n),g=new C(c,this._proxy,f,s,a,!0);this._webviewViews.set(c,g),await r.resolveWebviewView(g,{state:b},o)}async $onDidChangeWebviewViewVisibility(c,f){this.getWebviewView(c)._setVisible(f)}async $disposeWebviewView(c){const f=this.getWebviewView(c);this._webviewViews.delete(c),f.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const f=this._webviewViews.get(c);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=P}),define(we[136],be([1,0,3,5,2,10,8,4,14]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Vi{constructor(I){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Vi.InitialState,this._proxy=I.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,p){let E;if(typeof I=="string"){E=I;try{I=k.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,S.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,E,p)}async asExternalUri(I,p){if((0,S.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(I,p);return k.URI.from(E)}};R.InitialState={focused:!0},R=Be([Fe(0,_.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(we[259],be([1,0,9,60,33,39,6,5,2,14]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends S.Disposable{constructor(p,E){super();const v=p.getProxy(D.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async d=>{const w=_.URI.file((0,h.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await v.$download(d,w),w})}};F=Be([Fe(0,R.IExtHostRpcService),Fe(1,A.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(we[260],be([1,0,134,10,189,33]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class S extends h.ExtHostLoggerService{doCreateLogger(_,R,F){return _.scheme===t.Schemas.file?new k.SpdLogLogger(F?.name||(0,A.generateUuid)(),_.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,R):super.doCreateLogger(_,R,F)}}e.ExtHostLoggerService=S}),define(we[261],be([1,0,59,9,2,67,6,10,13,28]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const b=await super._getWorkspaceStorageURI(s);if(b.scheme!==D.Schemas.file)return b;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${b.fsPath}.`),b;const o=b.fsPath;let i=0;do{let r;i===0?r=o:r=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await I(r);const n=t.join(r,"vscode.lock"),a=await d(this._logService,n,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),k.URI.file(r);i++}while(i<10);return b}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function I(f){try{await R.Promises.stat(f);return}catch{}try{await R.Promises.mkdir(f,{recursive:!0})}catch{}}const p=1e3,E=10*60*1e3;class v extends S.Disposable{constructor(s,b){super();this.logService=s,this.filename=b,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await w(s,b);(!o||o.pid!==process.pid)&&(s.info(`Lock '${b}': The lock was lost unexpectedly.`),this._timer.cancel());try{await R.Promises.utimes(b,new Date,new Date)}catch(i){s.error(i),s.info(`Lock '${b}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{h.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const b={pid:process.pid,willReleaseAt:Date.now()+s};await R.Promises.writeFile(this.filename,JSON.stringify(b),{flag:"w"})}catch(b){this.logService.error(b)}}}async function d(f,s,b){try{const i={pid:process.pid,willReleaseAt:0};await R.Promises.writeFile(s,JSON.stringify(i),{flag:"wx"})}catch(i){f.error(i)}const o=await w(f,s);return!o||o.pid!==process.pid?b?(f.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),l(f,s)):(f.info(`Lock '${s}': Lock acquired.`),new v(f,s))}async function w(f,s){let b;try{b=await R.Promises.readFile(s)}catch(o){return f.error(o),null}try{return JSON.parse(String(b))}catch(o){return f.error(o),null}}async function C(f,s){let b;try{b=await R.Promises.stat(s)}catch(o){return f.error(o),0}return b.mtime.getTime()}function P(f){try{return process.kill(f,0),!0}catch{return!1}}async function l(f,s){const b=await w(f,s);if(!b)return f.info(`Lock '${s}': Could not read pid of lock holder.`),c(f,s);if(b.willReleaseAt){let a=b.willReleaseAt-Date.now();if(a<5e3){for(a>0?f.info(`Lock '${s}': The lockfile is scheduled to be released in ${a} ms.`):f.info(`Lock '${s}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,_.timeout)(Math.min(100,a)),await C(f,s)===0)return c(f,s);a=b.willReleaseAt-Date.now()}return c(f,s)}}if(!P(b.pid))return f.info(`Lock '${s}': The pid ${b.pid} appears to be gone.`),c(f,s);const o=await C(f,s),i=Date.now()-o;if(i<=E)return f.info(`Lock '${s}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;f.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const r=await C(f,s),n=Date.now()-r;return n<=E?(f.info(`Lock '${s}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(f.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),c(f,s))}async function c(f,s){f.info(`Lock '${s}': Deleting a stale lock.`);try{await R.Promises.unlink(s)}catch{}return d(f,s,!0)}}),define(we[262],be([1,0,33,14,34]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,_,R){return this.createTerminalFromOptions({name:D,shellPath:_,shellArgs:R})}createTerminalFromOptions(D,_){const R=new k.ExtHostTerminal(this._proxy,(0,h.generateUuid)(),D,D.name);return this._terminals.push(R),R.create(D,this._serializeParentTerminal(D,_)),R.value}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(we[263],be([1,0,5,14,174,6,26,2,38,23,28,7,12,51,3,123,91,11]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class P{constructor(g,u,m){this.remoteAddress=g,this.localAddress=u,this._dispose=m,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(a){const g=a.trim().split(`
`),u=[];return g.forEach(T=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);O&&O.length>=3&&u.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),u.reduce((T,O)=>(T[O.socket]=O,T),{})}e.getSockets=l;function c(...a){const g=[].concat(...a.map(s));return[...new Map(g.filter(u=>u.st==="0A").map(u=>{const m=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:f(m[0]),port:parseInt(m[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=c;function f(a){let g="";if(a.length===8)for(let u=a.length-2;u>=0;u-=2)g+=parseInt(a.substr(u,2),16),u!==0&&(g+=".");else for(let u=a.length-4;u>=0;u-=4)g+=parseInt(a.substr(u,4),16).toString(16),u!==0&&(g+=":");return g}e.parseIpAddress=f;function s(a){const g=a.trim().split(`
`),u=g.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return g.map(T=>T.trim().split(/\s+/).reduce((O,L,y)=>(O[u[y]||y]=L,O),{}))}e.loadConnectionTable=s;function b(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/server-main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function o(a){const g=a.trim().split(`
`),u=[];return g.forEach(m=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(m);T&&T.length>=4&&u.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),u}e.getRootProcesses=o;async function i(a,g,u){const m=u.reduce((O,L)=>(O[L.pid]=L,O),{}),T=[];return a.forEach(({socket:O,ip:L,port:y})=>{const H=g[O]?g[O].pid:void 0,M=H?m[H]?.cmd:void 0;H&&M&&!b(M)&&T.push({host:L,port:y,detail:M,pid:H})}),T}e.findPorts=i;function r(a,g,u){const m=new Map,T=o(g);for(const O of a){const L=u.get(O.port);if(L){m.set(O.port,L);continue}const y=T.find(H=>H.cmd.includes(`${O.port}`));if(y){let H=y,M;do M=T.find(z=>z.ppid===H.pid),M&&(H=M);while(M);m.set(O.port,{host:O.ip,port:O.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else m.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return m}e.tryFindRootPorts=r;let n=class extends A.Disposable{constructor(g,u,m){super();this.logService=m,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new v.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(h.MainContext.MainThreadTunnelService),p.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const m=await this._proxy.$openTunnel(u,g.displayName);if(m){const T=new P(m.remoteAddress,m.localAddress,()=>this._proxy.$closeTunnel(m.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,u){const m=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(m,{selector:g,provider:u}),this._proxy.$registerPortsAttributesProvider(g,m),new I.Disposable(()=>{this._portAttributesProviders.delete(m),this._proxy.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(g,u,m,T,O){const L=[];for(const H of g){const M=this._portAttributesProviders.get(H);if(!M)return[];L.push(...await Promise.all(u.map(async z=>M.provider.providePortAttributes(z,m,T,O))))}const y=L.filter(H=>!!H);return y.length>0?y.map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let u=new w.MovingAverage,m;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),O=(await this.findCandidatePorts()).filter(y=>(0,d.isLocalhost)(y.host)||(0,d.isAllInterfaces)(y.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(y=>y.port).join(", ")}`);const L=new Date().getTime()-T;u.update(L),(!m||JSON.stringify(m)!==JSON.stringify(O))&&(m=O,await this._proxy.$onFoundNewCandidates(m)),await new Promise(y=>setTimeout(()=>y(),this.calculateDelay(u.value)))}}async setTunnelFactory(g){if(g){if(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory){this._forwardPortProvider=g.tunnelFactory;let u=g.tunnelFeatures?.privacyOptions??[];g.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const m=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,public:!!g.tunnelFeatures?.public,privacyOptions:u}:void 0;this._proxy.$setTunnelProvider(m)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,u){if(this._extensionTunnels.has(g.host)){const m=this._extensionTunnels.get(g.host);m.has(g.port)&&(u&&m.get(g.port).disposeListener.dispose(),await m.get(g.port).tunnel.dispose(),m.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this._forwardPortProvider(g,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const T=await m;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const O=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:T,disposeListener:O}),E.TunnelDtoConverter.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const u=await Promise.all(g.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),m=g.filter((T,O)=>u[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(T=>T.port).join(", ")} to ${m.map(T=>T.port).join(", ")}`),m}async findCandidatePorts(){let g="",u="";try{g=await F.Promises.readFile("/proc/net/tcp","utf8"),u=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const m=c(g,u),T=await new Promise(K=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,G,X)=>{K(G)})}),O=l(T),L=await F.Promises.readdir("/proc"),y=[];for(let K of L)try{const B=Number(K),G=R.joinPath(D.URI.file("/proc"),K);if((await F.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(B)){const q=await F.Promises.readlink(R.joinPath(G,"cwd").fsPath),ee=await F.Promises.readFile(R.joinPath(G,"cmdline").fsPath,"utf8");y.push({pid:B,cwd:q,cmd:ee})}}catch{}const H=[],M=m.filter(K=>{const B=O[K.socket];return B||H.push(K),B}),z=i(M,O,y);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const K=await new Promise(B=>{(0,_.exec)("ps -F -A -l | grep root",(G,X,q)=>{B(X)})});this._foundRootPorts=r(H,K,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.join(", ")}`)}return z.then(K=>x?K.concat(x):K)}};n=Be([Fe(0,t.IExtHostRpcService),Fe(1,S.IExtHostInitDataService),Fe(2,C.ILogService)],n),e.ExtHostTunnelService=n}),define(we[264],be([1,0,13,22,21,16,3,6,101,227,52]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(m,T){try{return JSON.stringify(m,T)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class d{constructor(T,O){this.jsonString=T,this.referencedBuffers=O}}function w(m,T=null,O=!1){const L=[];return{jsonString:(O?p:JSON.stringify)(m,(H,M)=>{if(typeof M=="undefined")return v;if(typeof M=="object"){if(M instanceof t.VSBuffer){const z=L.push(M)-1;return{[E]:z}}if(T)return T(H,M)}return M}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=w;function C(m,T,O){return JSON.parse(m,(L,y)=>{if(y){const H=y[E];if(typeof H=="number")return T[H];if(O&&y.$mid===1)return O.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=C;function P(m,T){return JSON.stringify(m,T)}function l(m){return m?(T,O)=>O&&O.$mid===1?m.transformOutgoing(O):O:null}var c;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var f;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(f=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},b=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends D.Disposable{constructor(T,O=null,L=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=O,this._uriTransformer=L,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,H=F.ProxyIdentifier.count;y<H;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,_.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:O,sid:L}=T;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,L)),this._proxies[O]}_createProxy(T,O){let L={get:(y,H)=>(typeof H=="string"&&!y[H]&&H.charCodeAt(0)===36&&(y[H]=(...M)=>this._remoteCall(T,H,M)),H===o?O:y[H])};return new Proxy(Object.create(null),L)}set(T,O){return this._locals[T.nid]=O,O}assertRegistered(T){for(let O=0,L=T.length;O<L;O++){const y=T[O];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const O=T.byteLength,L=r.read(T,0),y=L.readUInt8(),H=L.readUInt32();switch(y){case 1:case 2:{let{rpcId:M,method:z,args:x}=a.deserializeRequestJSONArgs(L);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(O,H,M,z,x,y===2);break}case 3:case 4:{let{rpcId:M,method:z,args:x}=a.deserializeRequestMixedArgs(L);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(O,H,M,z,x,y===4);break}case 5:{this._logger&&this._logger.logIncoming(O,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(O,H);break}case 7:{this._receiveReply(O,H,void 0);break}case 9:{let M=a.deserializeReplyOKJSON(L);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(O,H,M);break}case 10:{const M=a.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(O,H,M);break}case 8:{let M=a.deserializeReplyOKVSBuffer(L);this._receiveReply(O,H,M);break}case 11:{let M=a.deserializeReplyErrError(L);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(O,H,M);break}case 12:{this._receiveReplyErr(O,H,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,O,L,y,H,M){this._logger&&this._logger.logIncoming(T,O,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(L)}.${y}(`,H);const z=String(O);let x,K;if(M){const G=new k.CancellationTokenSource;H.push(G.token),x=this._invokeHandler(L,y,H),K=()=>G.cancel()}else x=this._invokeHandler(L,y,H),K=s;this._cancelInvokedHandlers[z]=K;const B=a.serializeAcknowledged(O);this._logger&&this._logger.logOutgoing(B.byteLength,O,1,"ack"),this._protocol.send(B),x.then(G=>{delete this._cancelInvokedHandlers[z];const X=a.serializeReplyOK(O,G,this._uriReplacer);this._logger&&this._logger.logOutgoing(X.byteLength,O,1,"reply:",G),this._protocol.send(X)},G=>{delete this._cancelInvokedHandlers[z];const X=a.serializeReplyErr(O,G);this._logger&&this._logger.logOutgoing(X.byteLength,O,1,"replyErr:",G),this._protocol.send(X)})}_receiveCancel(T,O){this._logger&&this._logger.logIncoming(T,O,1,"receiveCancel");const L=String(O);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(T,O,L){this._logger&&this._logger.logIncoming(T,O,0,"receiveReply:",L);const y=String(O);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],H.resolveOk(L)}_receiveReplyErr(T,O,L){this._logger&&this._logger.logIncoming(T,O,0,"receiveReplyErr:",L);const y=String(O);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let M;L&&(L.$isError?(M=new Error,M.name=L.name,M.message=L.message,M.stack=L.stack):M=L),H.resolveErr(M)}_invokeHandler(T,O,L){try{return Promise.resolve(this._doInvokeHandler(T,O,L))}catch(y){return Promise.reject(y)}}_doInvokeHandler(T,O,L){const y=this._locals[T];if(!y)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(T));let H=y[O];if(typeof H!="function")throw new Error("Unknown method "+O+" on actor "+(0,F.getStringIdentifierForProxy)(T));return H.apply(y,L)}_remoteCall(T,O,L){if(this._isDisposed)return Promise.reject(A.canceled());let y=null;if(L.length>0&&k.CancellationToken.isCancellationToken(L[L.length-1])&&(y=L.pop()),y&&y.isCancellationRequested)return Promise.reject(A.canceled());const H=a.serializeRequestArguments(L,this._uriReplacer),M=++this._lastMessageId,z=String(M),x=new R.LazyPromise;y&&y.onCancellationRequested(()=>{const B=a.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(a.serializeCancel(M))}),this._pendingRPCReplies[z]=x,this._onWillSendRequest(M);const K=a.serializeRequest(M,T,O,H,!!y);return this._logger&&this._logger.logOutgoing(K.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(T)}.${O}(`,L),this._protocol.send(K),x}}e.RPCProtocol=i,I=b,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(T,O){this._buff=T,this._offset=O}static alloc(T,O,L){let y=new r(t.VSBuffer.alloc(L+1+4),0);return y.writeUInt8(T),y.writeUInt32(O),y}static read(T,O){return new r(T,O)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,L}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,L}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,O}static sizeMixedArray(T){let O=0;O+=1;for(let L=0,y=T.length;L<y;L++){const H=T[L];switch(O+=1,H.type){case 1:O+=this.sizeLongString(H.value);break;case 2:O+=this.sizeVSBuffer(H.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(H.value);for(let M=0;M<H.buffers.length;++M)O+=this.sizeVSBuffer(H.buffers[M]);break;case 4:break}}return O}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let O=0,L=T.length;O<L;O++){const y=T[O];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let H=0;H<y.buffers.length;++H)this.writeBuffer(y.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let O=new Array(T);for(let L=0;L<T;L++)switch(this.readUInt8()){case 1:O[L]=this.readLongString();break;case 2:O[L]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),M=this.readLongString(),z=[];for(let x=0;x<H;++x)z.push(this.readVSBuffer());O[L]=new F.SerializableObjectWithBuffers(C(M,z,null));break}case 4:O[L]=void 0;break}return O}}r.sizeUInt32=4;var n;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(n||(n={}));class a{static _useMixedArgSerialization(T){for(let O=0,L=T.length;O<L;O++)if(T[O]instanceof t.VSBuffer||T[O]instanceof F.SerializableObjectWithBuffers||typeof T[O]=="undefined")return!0;return!1}static serializeRequestArguments(T,O){if(this._useMixedArgSerialization(T)){const L=[];for(let y=0,H=T.length;y<H;y++){const M=T[y];if(M instanceof t.VSBuffer)L[y]={type:2,value:M};else if(typeof M=="undefined")L[y]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:x}=w(M.value,O);L[y]={type:3,value:t.VSBuffer.fromString(z),buffers:x}}else L[y]={type:1,value:t.VSBuffer.fromString(P(M,O))}}return{type:1,args:L}}return{type:0,args:P(T,O)}}static serializeRequest(T,O,L,y,H){switch(y.type){case 0:return this._requestJSONArgs(T,O,L,y.args,H);case 1:return this._requestMixedArgs(T,O,L,y.args,H)}}static _requestJSONArgs(T,O,L,y,H){const M=t.VSBuffer.fromString(L),z=t.VSBuffer.fromString(y);let x=0;x+=r.sizeUInt8(),x+=r.sizeShortString(M),x+=r.sizeLongString(z);let K=r.alloc(H?2:1,T,x);return K.writeUInt8(O),K.writeShortString(M),K.writeLongString(z),K.buffer}static deserializeRequestJSONArgs(T){const O=T.readUInt8(),L=T.readShortString(),y=T.readLongString();return{rpcId:O,method:L,args:JSON.parse(y)}}static _requestMixedArgs(T,O,L,y,H){const M=t.VSBuffer.fromString(L);let z=0;z+=r.sizeUInt8(),z+=r.sizeShortString(M),z+=r.sizeMixedArray(y);let x=r.alloc(H?4:3,T,z);return x.writeUInt8(O),x.writeShortString(M),x.writeMixedArray(y),x.buffer}static deserializeRequestMixedArgs(T){const O=T.readUInt8(),L=T.readShortString(),y=T.readMixedArray(),H=new Array(y.length);for(let M=0,z=y.length;M<z;M++){const x=y[M];typeof x=="string"?H[M]=JSON.parse(x):H[M]=x}return{rpcId:O,method:L,args:H}}static serializeAcknowledged(T){return r.alloc(5,T,0).buffer}static serializeCancel(T){return r.alloc(6,T,0).buffer}static serializeReplyOK(T,O,L){if(typeof O=="undefined")return this._serializeReplyOKEmpty(T);if(O instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(T,O);if(O instanceof F.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:H}=w(O.value,L,!0);return this._serializeReplyOKJSONWithBuffers(T,y,H)}else return this._serializeReplyOKJSON(T,p(O,L))}static _serializeReplyOKEmpty(T){return r.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,O){let L=0;L+=r.sizeVSBuffer(O);let y=r.alloc(8,T,L);return y.writeVSBuffer(O),y.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,O){const L=t.VSBuffer.fromString(O);let y=0;y+=r.sizeLongString(L);let H=r.alloc(9,T,y);return H.writeLongString(L),H.buffer}static _serializeReplyOKJSONWithBuffers(T,O,L){const y=t.VSBuffer.fromString(O);let H=0;H+=r.sizeUInt32,H+=r.sizeLongString(y);for(const z of L)H+=r.sizeVSBuffer(z);let M=r.alloc(10,T,H);M.writeUInt32(L.length),M.writeLongString(y);for(const z of L)M.writeBuffer(z);return M.buffer}static deserializeReplyOKJSON(T){const O=T.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(T,O){const L=T.readUInt32(),y=T.readLongString(),H=[];for(let M=0;M<L;++M)H.push(T.readVSBuffer());return new F.SerializableObjectWithBuffers(C(y,H,O))}static serializeReplyErr(T,O){return O?this._serializeReplyErrEror(T,O):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,O){const L=t.VSBuffer.fromString(p(A.transformErrorForSerialization(O),null));let y=0;y+=r.sizeLongString(L);let H=r.alloc(11,T,y);return H.writeLongString(L),H.buffer}static deserializeReplyErrError(T){const O=T.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(T){return r.alloc(12,T,0).buffer}}var g;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var u;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(u||(u={}))}),define(we[265],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(we[266],be([1,0,30,10,9,12,23,2,4,198,43,223,265]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let E=class ji{constructor(d,w,C,P){this.localUserHome=d,this.remoteAgentService=w,this.environmentService=C,this.contextService=P,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=l?.userHome||d})()}hasValidBasename(d,w,C){return typeof w=="string"||typeof w=="undefined"?this.resolveOS.then(P=>this.doHasValidBasename(d,P,w)):this.doHasValidBasename(d,w,C)}doHasValidBasename(d,w,C){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,h.isValidBasename)(C??(0,S.basename)(d),w===1):!0}get defaultUriScheme(){return ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,w){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const C=(0,R.getVirtualWorkspaceScheme)(w.getWorkspace());if(C)return C;const P=w.getWorkspace().folders[0];if(P)return P.uri.scheme;const l=w.getWorkspace().configuration;return l?l.scheme:t.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let w="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const P=d.indexOf("/",2);P===-1?(w=d.substring(2),d="/"):(w=d.substring(2,P),d=d.substring(P)||"/")}return D.URI.from({scheme:t.Schemas.file,authority:w,path:d,query:"",fragment:""})}};E=Be([Fe(1,p.IRemoteAgentService),Fe(2,I.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(we[69],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(S,D){this.line=S,this.character=D}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,D){return new h(0,0)}with(S){return new h(0,0)}}e.Position=h;class t{constructor(S,D,_,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(S,D),this.end=new h(_,R)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new t(0,0,0,0)}with(S){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[31],be([1,0,17,32,25,30,8,4,9,16,69,13]),function(te,e,h,t,k,A,S,D,_,R,F,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",E=" characters skipped \u27EB",v=(p.length+E.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var d;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function C(B){return!!B.preview}e.resultIsMatch=C;function P(B){return!!B.resource}e.isFileMatch=P;function l(B){return!!B.message}e.isProgressMessage=l;var c;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(G){this.resource=G,this.results=[]}}e.FileMatch=f;class s{constructor(G,X,q){this.ranges=X;const ee=Array.isArray(X)?X:[X];if(q&&q.matchLines===1&&b(ee)){G=(0,S.getNLines)(G,q.matchLines);let ae="",ue=0,Z=0;const Y=Math.floor(q.charsPerLine/5),se=[];for(const de of ee){const ve=Math.max(de.startColumn-Y,0),Te=de.startColumn+q.charsPerLine;if(ve>Z+Y+v){const Me=p+(ve-Z)+E;ae+=Me+G.slice(ve,Te),ue+=ve-(Z+Me.length)}else ae+=G.slice(Z,Te);se.push(new i(0,de.startColumn-ue,de.endColumn-ue)),Z=Te}this.preview={text:ae,matches:Array.isArray(this.ranges)?se:se[0]}}else{const ae=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:G,matches:(0,h.mapArrayOrNot)(X,ue=>new o(ue.startLineNumber-ae,ue.startColumn,ue.endLineNumber-ae,ue.endColumn))}}}}e.TextSearchMatch=s;function b(B){const G=B[0].startLineNumber;for(const X of B)if(X.startLineNumber!==G||X.endLineNumber!==G)return!1;return!0}class o{constructor(G,X,q,ee){this.startLineNumber=G,this.startColumn=X,this.endLineNumber=q,this.endColumn=ee}}e.SearchRange=o;class i extends o{constructor(G,X,q){super(G,X,G,q)}}e.OneLineRange=i;var r;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function n(B,G=!0){const X=B&&B.files&&B.files.exclude,q=G&&B&&B.search&&B.search.exclude;if(!X&&!q)return;if(!X||!q)return X||q;let ee=Object.create(null);return ee=k.mixin(ee,k.deepClone(X)),ee=k.mixin(ee,k.deepClone(q),!0),ee}e.getExcludes=n;function a(B,G){return B.excludePattern&&t.match(B.excludePattern,G)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,G)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(X=>{const q=X.folder.fsPath;if(A.isEqualOrParent(G,q)){const ee=_.relative(q,G);return!X.includePattern||!!t.match(X.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var g;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(G,X){super(G);this.code=X}}e.SearchError=u;function m(B){const G=B.message;if((0,R.isCancellationError)(B))return new u(G,g.canceled);try{const X=JSON.parse(G);return new u(X.message,X.code)}catch{return new u(G,g.other)}}e.deserializeSearchError=m;function T(B){const G={message:B.message,code:B.code};return new Error(JSON.stringify(G))}e.serializeSearchError=T;function O(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=O;function L(B){return B.type==="success"}e.isSerializedSearchSuccess=L;function y(B){return!!B.path}e.isSerializedFileMatch=y;function H(B,G){const X=B.searchPath?B.searchPath:B.relativePath;return(0,S.fuzzyContains)(X,G)}e.isFilePatternMatch=H;class M{constructor(G){this.path=G,this.results=[]}addMatch(G){this.results.push(G)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function z(B,G){const X={...B||{},...G||{}};return Object.keys(X).filter(q=>{const ee=X[q];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=z;class x{constructor(G,X){this._parsedIncludeExpression=null,this._excludeExpression={...G.excludePattern||{},...X.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let q=G.includePattern;X.includePattern&&(q?q={...q,...X.includePattern}:q=X.includePattern),q&&(this._parsedIncludeExpression=t.parse(q))}matchesExcludesSync(G,X,q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,X,q))}includedInQuerySync(G,X,q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,X,q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(G,X,q))}includedInQuery(G,X,q){const ee=this._parsedExcludeExpression(G,X,q),ae=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(G,X,q):!0;return(0,I.isThenable)(ee)?ee.then(ue=>ue?!1:ae()):ae()}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=x;function K(B){for(const G in B)if(typeof B[G]!="boolean")return!0;return!1}}),define(we[35],be([1,0,17,13,21,3,24,10,91,23,8,18,2,172,4,11,190,43,44,26,14,15,7,31,5]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c,f,s,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(O,L,y){return new R.ExtUri(H=>g(H,y)).isEqual(O,L)}function r(O,L,y){return i(O.uri,L.uri,y)?0:(0,F.compare)(O.uri.toString(),L.uri.toString())}function n(O,L,y){return O.index!==L.index?O.index<L.index?-1:1:i(O.uri,L.uri,y)?(0,F.compare)(O.name,L.name):(0,F.compare)(O.uri.toString(),L.uri.toString())}function a(O,L,y,H){const M=O.slice(0).sort((x,K)=>y(x,K,H)),z=L.slice(0).sort((x,K)=>y(x,K,H));return(0,h.delta)(M,z,(x,K)=>y(x,K,H))}function g(O,L){const y=L.getCapabilities(O.scheme);return!(y&&y&1024)}class u extends C.Workspace{constructor(L,y,H,M,z,x,K){super(L,H.map(B=>new C.WorkspaceFolder(B)),M,z,K);this._name=y,this._isUntitled=x,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(K),H.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(L,y,H,M){if(!L)return{workspace:null,added:[],removed:[]};const{id:z,name:x,folders:K,configuration:B,transient:G,isUntitled:X}=L,q=[],ee=y;y?K.forEach((Y,se)=>{const de=p.URI.revive(Y.uri),ve=u._findFolder(H||y,de,M);ve?(ve.name=Y.name,ve.index=Y.index,q.push(ve)):q.push({uri:de,name:Y.name,index:se})}):q.push(...K.map(({uri:Y,name:se,index:de})=>({uri:p.URI.revive(Y),name:se,index:de}))),q.sort((Y,se)=>Y.index<se.index?-1:1);const ae=new u(z,x,q,!!G,B?p.URI.revive(B):null,!!X,Y=>g(Y,M)),{added:ue,removed:Z}=a(ee?ee.workspaceFolders:[],ae.workspaceFolders,r,M);return{workspace:ae,added:ue,removed:Z}}static _findFolder(L,y,H){for(let M=0;M<L.folders.length;M++){const z=L.workspaceFolders[M];if(i(z.uri,y,H))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,y){return y&&this._structure.get(L)&&(L=(0,R.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let m=class{constructor(L,y,H,M){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=H,this._requestIdProvider=new _.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(o.MainContext.MainThreadMessageService);const z=y.workspace;this._confirmedWorkspace=z?new u(z.id,z.name,[],!!z.transient,z.configuration?p.URI.revive(z.configuration):null,!!z.isUntitled,x=>g(x,H)):void 0}$initializeWorkspace(L,y){this._trusted=y,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:D.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,y,H,...M){const z=[];if(Array.isArray(M)&&M.forEach(X=>{p.URI.isUri(X.uri)&&!z.some(q=>i(q.uri,X.uri,this._extHostFileSystemInfo))&&z.push({uri:X.uri,name:X.name||(0,R.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[y,H].some(X=>typeof X!="number"||X<0)||H===0&&z.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(y+H>x.length)return!1;const K=x.slice(0);K.splice(y,H,...z.map(X=>({uri:X.uri,name:X.name||(0,R.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<K.length;X++){const q=K[X];if(K.some((ee,ae)=>ae!==X&&i(q.uri,ee.uri,this._extHostFileSystemInfo)))return!1}K.forEach((X,q)=>X.index=q);const{added:B,removed:G}=a(x,K,n,this._extHostFileSystemInfo);if(B.length===0&&G.length===0)return!1;if(this._proxy){const X=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(X,y,H,z).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(w.Severity.Error,(0,E.localize)(0,null,X,q.toString()),ee,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(L,y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,y)}async getWorkspaceFolder2(L,y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,y)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,y){let H,M="";if(typeof L=="string"?(H=p.URI.file(L),M=L):typeof L!="undefined"&&(H=L,M=L.fsPath),!H)return M;const z=this.getWorkspaceFolder(H,!0);if(!z)return M;typeof y=="undefined"&&this._actualWorkspace&&(y=this._actualWorkspace.folders.length>1);let x=(0,R.relativePath)(z.uri,H);return y&&z.name&&(x=`${z.name}/${x}`),x}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=u.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:y,added:H,removed:M}=u.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:M}))}findFiles(L,y,H,M,z=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let x;if(y===null?x=!1:y&&(typeof y=="string"?x=y:x=y.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:B}=T(f.GlobPattern.from(L));return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(K),(0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(H),z).then(G=>Array.isArray(G)?G.map(X=>p.URI.revive(X)):[])}async findTextInFiles(L,y,H,M,z=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),K=typeof y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:y.previewOptions,{includePattern:B,folder:G}=T(f.GlobPattern.from(y.include)),X=typeof y.exclude=="string"?y.exclude:y.exclude?y.exclude.pattern:void 0,q={ignoreSymlinks:typeof y.followSymlinks=="boolean"?!y.followSymlinks:void 0,disregardIgnoreFiles:typeof y.useIgnoreFiles=="boolean"?!y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof y.useGlobalIgnoreFiles=="boolean"?!y.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof y.useParentIgnoreFiles=="boolean"?!y.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof y.useDefaultExcludes=="boolean"?!y.useDefaultExcludes:!0,fileEncoding:y.encoding,maxResults:y.maxResults,previewOptions:K,afterContext:y.afterContext,beforeContext:y.beforeContext,includePattern:B,excludePattern:X},ee=!1;if(this._activeSearchCallbacks[x]=ae=>{if(ee)return;const ue=p.URI.revive(ae.resource);ae.results.forEach(Z=>{(0,b.resultIsMatch)(Z)?H({uri:ue,preview:{text:Z.preview.text,matches:(0,h.mapArrayOrNot)(Z.preview.matches,Y=>new s.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,h.mapArrayOrNot)(Z.ranges,Y=>new s.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):H({uri:ue,text:Z.text,lineNumber:Z.lineNumber})})},z.isCancellationRequested)return{};try{const ae=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(G),q,x,z);return delete this._activeSearchCallbacks[x],ae||{}}catch(ae){throw delete this._activeSearchCallbacks[x],ae}}$handleTextSearchResult(L,y){this._activeSearchCallbacks[y]&&this._activeSearchCallbacks[y](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};m=Be([Fe(0,c.IExtHostRpcService),Fe(1,l.IExtHostInitDataService),Fe(2,P.IExtHostFileSystemInfo),Fe(3,d.ILogService)],m),e.ExtHostWorkspace=m,e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function T(O){let L,y;return O&&(typeof O=="string"?L=O:(L=O.pattern,y=p.URI.revive(O.baseUri))),{includePattern:L,folder:y}}}),define(we[36],be([1,0,25,3,35,5,7,193,119,18,13,4,14,11,2]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(b,o){if(o){const i=o.split(".");let r=b;for(let n=0;r&&n<i.length;n++)r=r[i[n]];return r}}function w(b){return b instanceof v.URI}function C(b){return b&&b.uri instanceof v.URI&&b.languageId&&typeof b.languageId=="string"}function P(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function l(b){return b&&b.uri instanceof v.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function c(b){if(w(b))return{resource:b};if(C(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(P(b))return{overrideIdentifier:b.languageId};if(l(b))return{resource:b.uri};if(b===null)return{resource:null}}let f=class{constructor(o,i,r){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new s(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(o,i))}};f=Be([Fe(0,p.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,E.ILogService)],f),e.ExtHostConfiguration=f;class s{constructor(o,i,r,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=n,this._extHostWorkspace=i,this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(o,i,r){const n=c(i)||{},a=this._toReadonlyValue(o?d(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,n,r?.identifier);function g(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(m){return typeof d(a,m)!="undefined"},get:(m,T)=>{this._validateConfigurationAccess(o?`${o}.${m}`:m,n,r?.identifier);let O=d(a,m);if(typeof O=="undefined")O=T;else{let L;const y=(H,M)=>{let z;const x=()=>{L=L||(0,h.deepClone)(a),z=z||d(L,M)};return(0,R.isObject)(H)?new Proxy(H,{get:(K,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return x(),()=>z;if(L)return z=z||d(L,M),z[B];const G=K[B];return typeof B=="string"?y(G,`${M}.${B}`):G},set:(K,B,G)=>(x(),z&&(z[B]=G),!0),deleteProperty:(K,B)=>(x(),z&&delete z[B],!0),defineProperty:(K,B,G)=>(x(),z&&Object.defineProperty(z,B,G),!0)}):H};O=y(O,m)}return O},update:(m,T,O,L)=>{m=o?`${o}.${m}`:m;const y=g(O);return T!==void 0?this._proxy.$updateConfigurationOption(y,m,T,n,L):this._proxy.$removeConfigurationOption(y,m,n,L)},inspect:m=>{m=o?`${o}.${m}`:m;const T=(0,h.deepClone)(this._configuration.inspect(m,n,this._extHostWorkspace.workspace));if(T)return{key:m,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof a=="object"&&(0,h.mixin)(u,a,!1),Object.freeze(u)}_toReadonlyValue(o){const i=r=>(0,R.isObject)(r)?new Proxy(r,{get:(n,a)=>i(n[a]),set:(n,a,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(n,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(n,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(o)}_validateConfigurationAccess(o,i,r){const n=_.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),a=r?`[${r.value}] `:"";if(n===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const r=new D.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,a)=>r.affectsConfiguration(n,c(a))})}_toMap(o){return o.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[70],be([1,0,2,13,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,215,16]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(M){function z(K){if(K!=null)return K}M.from=z;function x(K){if(K!=null)return K}M.to=x})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function(M){function z(K){if(K!=null)return K}M.from=z;function x(K){if(K!=null)return K}M.to=x})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(M){function z(K){if(K!=null)return K}M.from=z;function x(K){if(K!=null)return K}M.to=x})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function z(B){if(B){const G=B;return G&&!!G.process}else return!1}M.is=z;function x(B){if(B==null)return;const G={process:B.process,args:B.args};return B.options&&(G.options=o.from(B.options)),G}M.from=x;function K(B){if(B!=null)return new S.ProcessExecution(B.process,B.args,B.options)}M.to=K})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function z(K){if(K!=null)return K}M.from=z;function x(K){if(K!=null)return K}M.to=x})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function(M){function z(B){if(B){const G=B;return G&&(!!G.commandLine||!!G.command)}else return!1}M.is=z;function x(B){if(B==null)return;const G={};return B.commandLine!==void 0?G.commandLine=B.commandLine:(G.command=B.command,G.args=B.args),B.options&&(G.options=r.from(B.options)),G}M.from=x;function K(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new S.ShellExecution(B.commandLine,B.options):new S.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=K})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(M){function z(B){if(B){let G=B;return G&&G.customExecution==="customExecution"}else return!1}M.is=z;function x(B){return{customExecution:"customExecution"}}M.from=x;function K(B,G){return G.get(B)}M.to=K})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(M){function z(x,K){let B;return x.scope!==void 0&&typeof x.scope!="number"?B=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===S.TaskScope.Workspace&&K&&K.workspaceFile?B=K.workspaceFile:B=l.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:B}}M.from=z})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(M){function z(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}M.from=z})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function(M){function z(B,G){if(B==null)return[];const X=[];for(let q of B){const ee=x(q,G);ee&&X.push(ee)}return X}M.fromMany=z;function x(B,G){if(B==null)return;let X;B.execution instanceof S.ProcessExecution?X=i.from(B.execution):B.execution instanceof S.ShellExecution?X=n.from(B.execution):B.execution&&B.execution instanceof S.CustomExecution&&(X=a.from(B.execution));const q=s.from(B.definition);let ee;return B.scope?typeof B.scope=="number"?ee=B.scope:ee=B.scope.uri:ee=S.TaskScope.Workspace,!q||!ee?void 0:{_id:B._id,definition:q,name:B.name,source:{extensionId:G.identifier.value,label:B.source,scope:ee},execution:X,isBackground:B.isBackground,group:u.from(B.group),presentationOptions:b.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=x;async function K(B,G,X){if(B==null)return;let q;i.is(B.execution)?q=i.to(B.execution):n.is(B.execution)?q=n.to(B.execution):a.is(B.execution)&&(q=a.to(B._id,X));const ee=s.to(B.definition);let ae;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ae=B.source.scope:ae=await G.resolveWorkspaceFolder(h.URI.revive(B.source.scope)):ae=S.TaskScope.Workspace),!ee||!ae)return;const ue=new S.Task(ee,ae,B.name,B.source.label,q,B.problemMatchers);return B.isBackground!==void 0&&(ue.isBackground=B.isBackground),B.group!==void 0&&(ue.group=S.TaskGroup.from(B.group._id),ue.group&&B.group.isDefault&&(ue.group=new S.TaskGroup(ue.group.id,ue.group.label),B.group.isDefault&&(ue.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ue.presentationOptions=b.to(B.presentationOptions)),B._id&&(ue._id=B._id),B.detail&&(ue.detail=B.detail),ue}M.to=K})(m=e.TaskDTO||(e.TaskDTO={}));var T;(function(M){function z(K){return K}M.from=z;function x(K){if(!!K)return Object.assign(Object.create(null),K)}M.to=x})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(z,x,K){this._id=x,this._task=K,f.set(this,void 0),Ke(this,f,z,"f")}get task(){return this._task}terminate(){Pe(this,f,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}f=new WeakMap;var L;(function(M){function z(x){return{id:x._id,task:void 0}}M.from=z})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(z,x,K,B,G,X,q,ee){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=z.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=B,this._configurationService=G,this._terminalService=X,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,x,K){if(!K)return new S.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:x,provider:K,extension:z}),this._proxy.$registerTaskProvider(B,x),new S.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(z,x){this._proxy.$registerTaskSystem(z,x)}fetchTasks(z){return this._proxy.$fetchTasks(T.from(z)).then(async x=>{const K=[];for(let B of x){const G=await m.to(B,this._workspaceProvider,this._providedCustomExecutions2);G&&K.push(G)}return K})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(x=>z.push(x)),z}terminateTask(z){if(!(z instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,x,K){const B=this._providedCustomExecutions2.get(z.id);B&&(this._activeCustomExecutions2.set(z.id,B),this._terminalService.attachPtyToTerminal(x,await B.callback(K))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const x=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:x,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const x=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:z.exitCode})}$provideTasks(z,x){const K=this._handlers.get(z);if(!K)return Promise.reject(new Error("no handler found"));const B=[],G=(0,t.asPromise)(()=>K.provider.provideTasks(F.CancellationToken.None)).then(X=>this.provideTasksInternal(x,B,K,X));return new Promise(X=>{G.then(q=>{Promise.all(B).then(()=>{X(q)})})})}async $resolveTask(z,x){const K=this._handlers.get(z);if(!K)return Promise.reject(new Error("no handler found"));if(x.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${K.type}].`);const B=await m.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const G=await K.provider.resolveTask(B,F.CancellationToken.None);if(!G)return;this.checkDeprecation(G,K);const X=m.from(G,K.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(X.execution)&&await this.addCustomExecution(X,G,!0),await this.resolveTaskInternal(X)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,x,K){const B=await this._proxy.$createTaskId(z);!K&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,x.execution)),this._providedCustomExecutions2.set(B,x.execution)}async getTaskExecution(z,x){if(typeof z=="string"){const G=this._taskExecutionPromises.get(z);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let K=this._taskExecutionPromises.get(z.id);if(K)return K;const B=new Promise((G,X)=>{function q(ee,ae,ue){ue?G(new O(ee,ae.id,ue)):X("Unexpected: Task does not exist.")}x?q(this,z,x):m.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(ee=>q(this,z,ee))});return this._taskExecutionPromises.set(z.id,B),B.then(G=>(this._taskExecutions.set(z.id,G),G),G=>Promise.reject(G))}checkDeprecation(z,x){z._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let K=this._notProvidedCustomExecutions.values(),B=K.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=K.next()}};y=Be([Fe(0,p.IExtHostRpcService),Fe(1,E.IExtHostInitDataService),Fe(2,D.IExtHostWorkspace),Fe(3,_.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,I.IExtHostTerminalService),Fe(6,C.ILogService),Fe(7,P.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let H=class extends y{constructor(z,x,K,B,G,X,q,ee){super(z,x,K,B,G,X,q,ee);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(z,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const K=m.from(x,z);if(K===void 0)throw new Error("Task is not valid");if(a.is(K.execution))await this.addCustomExecution(K,x,!1);else throw new c.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),x);return this._proxy.$executeTask(K).catch(G=>{throw new Error(G)}),B}provideTasksInternal(z,x,K,B){const G=[];if(B)for(let X of B){this.checkDeprecation(X,K),(!X.definition||!z[X.definition.type])&&this._logService.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const q=m.from(X,K.extension);q&&a.is(q.execution)?(G.push(q),x.push(this.addCustomExecution(q,X,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:K.extension}}async resolveTaskInternal(z){if(a.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,x,K){}};H=Be([Fe(0,p.IExtHostRpcService),Fe(1,E.IExtHostInitDataService),Fe(2,D.IExtHostWorkspace),Fe(3,_.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,I.IExtHostTerminalService),Fe(6,C.ILogService),Fe(7,P.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(we[267],be([1,0,9,21,49,32,23,46,31]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(p,E,v){this.config=p,this.provider=E,this.sessionToken=v,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&A.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&A.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const E=this.config.folderQueries||[];return new Promise((v,d)=>{const w=C=>{this.resultCount++,p(C)};if(this.isCanceled)return v({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(C=>{const P=C.toString(),l=h.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,l)||this.matchFile(w,{base:C,basename:l})}),Promise.all(E.map(C=>this.searchInFolder(C,w))).then(C=>{v({limitHit:this.isLimitHit,stats:C[0]||void 0})},C=>{d(new Error((0,k.toErrorMessage)(C)))})})}async searchInFolder(p,E){const v=new t.CancellationTokenSource,d=this.getSearchOptionsForFolder(p),w=this.initDirectoryTree(),C=new _.QueryGlobTester(this.config,p),P=!C.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(v),l=D.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,v.token),f=l.elapsed(),s=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(b=>{const o=h.posix.relative(p.folder.path,b.path);if(P){const i=h.basename(b.path);this.matchFile(E,{base:p.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(w,p.folder,o,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,C,E),{providerTime:f,postProcessTime:s.elapsed()})}finally{v.dispose(),this.activeCancellationTokens.delete(v)}}getSearchOptionsForFolder(p){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),v=(0,_.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},E,v,d){if(v===this.filePattern){const C=h.basename(this.filePattern);this.matchFile(d,{base:E,relativePath:this.filePattern,basename:C})}function w(C){const P=h.basename(C),l=h.dirname(C);let c=p[l];c||(c=p[l]=[],w(l)),c.push({base:E,relativePath:C,basename:P})}w(v)}matchDirectoryTree({rootEntries:p,pathToEntries:E},v,d){const w=this,C=this.filePattern;function P(l){const c=A.hasSiblingFn(()=>l.map(f=>f.basename));for(let f=0,s=l.length;f<s;f++){const b=l[f],{relativePath:o,basename:i}=b;if(v.matchesExcludesSync(o,i,C!==i?c:void 0))continue;const r=E[o];if(r)P(r);else{if(o===C)continue;w.matchFile(d,b)}if(w.isLimitHit)break}}P(p)}matchFile(p,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(E))}}class F{constructor(){this.sessions=new Map}fileSearch(p,E,v,d){const w=this.getSessionTokenSource(p.cacheKey),C=new R(p,E,w&&w.token);let P=0;const l=c=>{P+=c.length,v(c.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(C,F.BATCH_SIZE,l,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:c.stats}}))}clearCache(p){const E=this.getSessionTokenSource(p);E&&E.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new t.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:S.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,E,v,d){d.onCancellationRequested(()=>{p.cancel()});const w=P=>{P&&(C.push(P),E>0&&C.length>=E&&(v(C),C=[]))};let C=[];return p.search(w).then(P=>(C.length&&v(C),P),P=>(C.length&&v(C),Promise.reject(P)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(we[268],be([1,0,17,74,32,100,24,10,9,23,8,18,2,152,181,115,11,43,129,266,31]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(u,m,T,O,L){this.configurationService=u,this.workspaceContextService=m,this.editorGroupsService=T,this.logService=O,this.pathService=L}text(u,m,T={}){u=this.getContentPattern(u,T);const O=this.configurationService.getValue(),L=m&&m.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(m?.map(C.toWorkspaceFolder),T),type:2,contentPattern:u,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:O.search.usePCRE2||L||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(u,m){const T=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const O={...u,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(u,m)&&(O.isCaseSensitive=!0),this.isMultiline(u)&&(O.isMultiline=!0),O}file(u,m={}){return{...this.commonQuery(u,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(u,m){return u?(u=Array.isArray(u)?u.map(r):r(u),m?this.parseSearchPaths(u):{pattern:b(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],m={}){const T=this.handleIncludeExclude(m.includePattern,m.expandPatterns),O=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),L=u.length>1,y=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,m,O)):u.map(z=>this.getFolderQueryForRoot(z,m,O,L))).filter(z=>!!z),H={_reason:m._reason,folderQueries:y,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:O.pattern,includePattern:T.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const z=h.coalesce(h.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const x=z.filter(B=>(0,c.pathIncludedInQuery)(H,B.fsPath)),K=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...H,...K}}const M=m.extraFileResources&&m.extraFileResources.filter(z=>(0,c.pathIncludedInQuery)(H,z.fsPath));return H.extraFileResources=M&&M.length?M:void 0,H}commonQueryFromFileList(u){const m=[],T=new S.ResourceMap,O={};let L=!1;return u.forEach(y=>{if(y.scheme===D.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(y)){const M=this.workspaceContextService.getWorkspaceFolder(y)?.uri??y.with({path:_.dirname(y.fsPath)});let z=T.get(M);z||(L=!0,z={folder:M,includePattern:{}},m.push(z),T.set(M,z));const x=_.relative(M.fsPath,y.fsPath);(0,I.assertIsDefined)(z.includePattern)[x.replace(/\\/g,"/")]=!0}else y.fsPath&&(L=!0,O[y.fsPath]=!0)}),{folderQueries:m,includePattern:O,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(u,m){if(m.isSmartCase){if(u.isRegExp){if(F.containsUppercaseCharacter(u.pattern,!0))return!0}else if(F.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,E.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const m=K=>_.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),O=(Array.isArray(u)?u:o(u)).map(K=>{const B=this.pathService.resolvedUserHome;return B?(0,A.untildify)(K,B.scheme===D.Schemas.file?B.fsPath:B.path):K}),L=t.groupBy(O,K=>m(K)?"searchPaths":"exprSegments"),y=(L.exprSegments||[]).map(K=>F.rtrim(K,"/")).map(K=>F.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),i(K))),H={},M=this.expandSearchPathPatterns(L.searchPaths||[]);M&&M.length&&(H.searchPaths=M);const z=h.flatten(y),x=b(...z);return x&&(H.pattern=x),H}getExcludesForFolder(u,m){return m.disregardExcludeSettings?void 0:(0,c.getExcludes)(u,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const m=h.flatten(u.map(O=>{let{pathPortion:L,globPortion:y}=s(O);y&&(y=n(y));const H=this.expandOneSearchPath(L);return h.flatten(H.map(M=>this.resolveOneSearchPathPattern(M,y)))})),T=new Map;return m.forEach(O=>{const L=O.searchPath.toString(),y=T.get(L);y?O.pattern&&(y.pattern=y.pattern||{},y.pattern[O.pattern]=!0):T.set(L,{searchPath:O.searchPath,pattern:O.pattern?b(O.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(u){if(_.isAbsolute(u)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==D.Schemas.file?[{searchPath:m[0].uri.with({path:u})}]:[{searchPath:p.URI.file(_.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=r(u),u.startsWith("../")||u===".."){const O=_.posix.resolve(m.path,u);return[{searchPath:m.with({path:O})}]}const T=n(u);return[{searchPath:m,pattern:T}]}else{if(u==="./"||u===".\\")return[];{const m=u.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(L=>{const y=m.match(new RegExp(`^${F.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return y?{match:y,folder:L}:null}).filter(I.isDefined);if(O.length)return O.map(L=>{const y=L.match[1];return{searchPath:L.folder.uri,pattern:y&&n(y)}});{const L=u.match(/\.[\/\\](.+)[\/\\]?/),y=L?L[1]:u,H=v.localize(0,null,y);throw new Error(H)}}}}resolveOneSearchPathPattern(u,m){const T=u.pattern&&m?`${u.pattern}/${m}`:u.pattern||m,O=[{searchPath:u.searchPath,pattern:T}];return T&&!T.endsWith("**")&&O.push({searchPath:u.searchPath,pattern:T+"/**"}),O}getFolderQueryForSearchPath(u,m,T){const O=this.getFolderQueryForRoot((0,C.toWorkspaceFolder)(u.searchPath),m,T,!1);return O?{...O,includePattern:u.pattern}:null}getFolderQueryForRoot(u,m,T,O){let L;const y=p.URI.isUri(u)?u:u.uri;if(T.searchPaths){const K=T.searchPaths.filter(B=>(0,R.isEqual)(B.searchPath,y))[0];if(K&&!K.pattern)return null;K&&(L=K.pattern)}const H=this.configurationService.getValue({resource:y}),z={...this.getExcludesForFolder(H,m)||{},...L||{}},x=p.URI.isUri(u)?(0,R.basename)(u):u.name;return{folder:y,folderName:O?x:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!H.search.followSymlinks}}};f=Be([Fe(0,d.IConfigurationService),Fe(1,C.IWorkspaceContextService),Fe(2,P.IEditorGroupsService),Fe(3,w.ILogService),Fe(4,l.IPathService)],f),e.QueryBuilder=f;function s(g){const u=g.match(/[\*\{\}\(\)\[\]\?]/);if(u){const m=u.index,T=g.substr(0,m).match(/[/|\\][^/\\]*$/);if(T){let O=g.substr(0,T.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:g.substr((T.index||0)+1)}}}return{pathPortion:g}}function b(...g){return g.length?g.reduce((u,m)=>(u[m]=!0,u),Object.create(null)):void 0}function o(g){return k.splitGlobAware(g,",").map(u=>u.trim()).filter(u=>!!u.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function r(g){return g.replace(/\\/g,"/")}function n(g){return r(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(g,u){g=h.distinct(g,O=>O.toString());const m=[],T=u.getWorkspace();return g&&g.forEach(O=>{let L;if(u.getWorkbenchState()===2)L=(0,R.relativePath)(T.folders[0].uri,O),L&&L!=="."&&(L="./"+L);else{const y=u.getWorkspaceFolder(O);if(y){const H=y.name;if(T.folders.filter(z=>z.name===H).length===1){const z=(0,R.relativePath)(y.uri,O);z===""?L=`./${y.name}`:L=`./${y.name}/${z}`}else L=O.fsPath}}L&&m.push(L)}),m}e.resolveResourcesForSearchIncludes=a}),define(we[269],be([1,0,23,2,21,16,4,268,31,43]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function I(d,w){const C=w.activationEvents;if(!C)return Promise.resolve(void 0);const P=[],l=[];for(const i of C)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?l.push(r):P.push(r)}if(P.length===0&&l.length===0)return Promise.resolve(void 0);let c;const f=new Promise((i,r)=>{c=i}),s=i=>c({activationEvent:i}),b=Promise.all(P.map(i=>p(d,i,s))).then(()=>{}),o=E(d,w.identifier,l,s);return Promise.all([b,o]).then(()=>{c(void 0)}),f}e.checkActivateWorkspaceContainsExtension=I;async function p(d,w,C){for(const P of d.folders)if(await d.exists(h.joinPath(t.URI.revive(P),w))){C(`workspaceContains:${w}`);return}}async function E(d,w,C,P){if(C.length===0)return Promise.resolve(void 0);const l=new k.CancellationTokenSource,c=d.checkExists(d.folders,C,l.token),f=setTimeout(async()=>{l.cancel(),d.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${C.join(",")}`)},F);let s=!1;try{s=await c}catch(b){A.isCancellationError(b)||A.onUnexpectedError(b)}l.dispose(),clearTimeout(f),s&&P(`workspaceContains:${C.join(",")}`)}function v(d,w,C,P){const l=d.get(S.IInstantiationService),c=d.get(_.ISearchService),s=l.createInstance(D.QueryBuilder).file(w.map(b=>(0,R.toWorkspaceFolder)(t.URI.revive(b))),{_reason:"checkExists",includePattern:C,exists:!0});return c.fileSearch(s,P).then(b=>!!b.limitHit,b=>A.isCancellationError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=v});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Pe=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[40],be([1,0,167,9,71,23,13,6,24,2,11,5,36,225,87,35,29,224,16,27,22,199,7,120,4,26,67,14,80,51,34,3,269,86,201,10]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c,f,s,b,o,i,r,n,a,g,u,m,T,O,L,y){"use strict";var H,M,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let x=class qi extends D.Disposable{constructor(q,ee,ae,ue,Z,Y,se,de,ve,Te){super();this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=ae,this._initData=se,this._extHostWorkspace=ue,this._extHostConfiguration=Z,this._logService=Y,this._extHostTunnelService=ve,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new C.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new v.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=q.createChild(new a.ServiceCollection([v.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Me=new Set;this._initData.hostExtensions.forEach(_e=>Me.add(l.ExtensionIdentifier.toKey(_e))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(_e,Ee,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(_e,P.transformErrorForSerialization(Ee),$)},actualActivateExtension:async(_e,Ee)=>{if(Me.has(l.ExtensionIdentifier.toKey(_e)))return await this._mainThreadExtensionsProxy.$activateExtension(_e,Ee),new E.HostExtension;const $=this._registry.getExtensionDescription(_e);return this._activateExtension($,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(q){P.onUnexpectedError(q)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let q=[];try{q=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(q)}isActivated(q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(q):!1}_activateByEvent(q,ee){return this._activator.activateByEvent(q,ee)}_activateById(q,ee){return this._activator.activateById(q,ee)}activateByIdWithErrors(q,ee){return this._activateById(q,ee).then(()=>{const ae=this._activator.getActivatedExtension(q);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(q=>this._registry)}getExtensionExports(q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(q).exports:null}async _realPathExtensionUri(q){if(q.scheme!==y.Schemas.file)return q;const ee=await this._hostUtils.realpath(q.fsPath);return R.URI.file(ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const q=_.TernarySearchTree.forUris(ee=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ee));for(const ee of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ee)){const ae=await this._realPathExtensionUri(ee.extensionLocation);q.set(ae,ee)}return q})()),this._extensionPathIndex}_deactivate(q){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(q))return ee;const ae=this._activator.getActivatedExtension(q);if(!ae)return ee;try{typeof ae.module.deactivate=="function"&&(ee=Promise.resolve(ae.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${q.value}':`),this._logService.error(ue)}try{(0,D.dispose)(ae.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this._logService.error(ue)}return ee}async _activateExtension(q,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier),this._doActivateExtension(q,ee).then(ae=>{const ue=ae.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(q.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,ee),this._logExtensionActivationTimes(q,ee,"success",ue),ae},ae=>{throw this._logExtensionActivationTimes(q,ee,"failure"),ae})}_logExtensionActivationTimes(q,ee,ae,ue){const Z=K(q,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ue||{},outcome:ae})}_doActivateExtension(q,ee){const ae=K(q,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ae);const ue=this._getEntryPoint(q);if(!ue)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${q.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this._logService.flush();const Z=new E.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(q.identifier,(0,A.joinPath)(q.extensionLocation,ue),Z),this._loadExtensionContext(q)]).then(Y=>(k.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),qi._callActivate(this._logService,q.identifier,Y[0],Y[1],Z))).then(Y=>(k.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),Y))}_loadExtensionContext(q){const ee=new f.ExtensionGlobalMemento(q,this._storage),ae=new f.ExtensionMemento(q.identifier.value,!1,this._storage),ue=new L.ExtensionSecrets(q,this._secretState),Z=q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Y=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([ee.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const se=this;let de,ve;const Te=(0,w.isProposedApiEnabled)(q,"ipc")?this._initData.messagePorts?.get(l.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:ee,workspaceState:ae,secrets:ue,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(Me){return t.join(q.extensionLocation.fsPath,Me)},get storagePath(){return se._storagePath.workspaceValue(q)?.fsPath},get globalStoragePath(){return se._storagePath.globalValue(q).fsPath},get logPath(){return t.join(se._initData.logsLocation.fsPath,q.identifier.value)},get logUri(){return R.URI.joinPath(se._initData.logsLocation,q.identifier.value)},get storageUri(){return se._storagePath.workspaceValue(q)},get globalStorageUri(){return se._storagePath.globalValue(q)},get extensionMode(){return Z},get extension(){return de===void 0&&(de=new B(se,q.identifier,q,Y)),de},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(q,"extensionRuntime"),se.extensionRuntime},get environmentVariableCollection(){return se._extHostTerminalService.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ve){if(!Te)return;const Me=m.Event.buffer(m.Event.fromDOMEventEmitter(Te,"message",_e=>_e.data));Te.start(),ve={onDidReceiveMessage:Me,postMessage:Te.postMessage.bind(Te)}}return ve}})})}static _callActivate(q,ee,ae,ue,Z){return ae=ae||{activate:void 0,deactivate:void 0},this._callActivateOptional(q,ee,ae,ue,Z).then(Y=>new E.ActivatedExtension(!1,null,Z.build(),ae,Y,ue.subscriptions))}static _callActivateOptional(q,ee,ae,ue,Z){if(typeof ae.activate=="function")try{Z.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Y=typeof global=="object"?global:self,se=ae.activate.apply(Y,[ue]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(se).then(de=>(Z.activateResolveStop(),de))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(ae)}_activateOneStartupFinished(q,ee){this._activateById(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:ee}).then(void 0,ae=>{this._logService.error(ae)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const q of this._registry.getAllExtensionDescriptions())if(q.activationEvents)for(const ee of q.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(q,ee)}_handleEagerExtensions(){const q=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ae=this._handleWorkspaceContainsEagerExtensions(ee),ue=Promise.all([q,ae]).then(()=>{});return Promise.race([ue,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(q){return q.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(q,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(q,ee){if(this.isActivated(ee.identifier))return;const ae=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:q.map(Y=>Y.uri),forceUsingSearch:ae,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,se,de)=>this._mainThreadWorkspaceProxy.$checkExists(Y,se,de)},Z=await(0,T.checkActivateWorkspaceContainsExtension)(ue,ee);if(!!Z)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Z.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(q){throw console.error(q),q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:ee}=this._initData.environment;if(!q||!ee)throw new Error(h.localize(0,null));const ae=await this._loadCommonJSModule(null,ee,new E.ExtensionActivationTimesBuilder(!1));if(!ae||typeof ae.run!="function")throw new Error(h.localize(1,null,ee.toString()));return new Promise((ue,Z)=>{const Y=(ve,Te)=>{ve?Z(ve):ue(typeof Te=="number"&&Te>0?1:0)},se=(0,A.originalFSPath)(ee),de=ae.run(se,Y);de&&de.then&&de.then(()=>{ue(0)}).catch(ve=>{Z(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}async $extensionTestsExit(q){this._logService.info(`Extension host terminating: test runner requested exit with code ${q}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${q}`),this._logService.flush(),this._hostUtils.exit(q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,ee){return this._resolvers[q]=ee,(0,D.toDisposable)(()=>{delete this._resolvers[q]})}async _activateAndGetResolver(q){const ee=q.indexOf("+");if(ee===-1)throw new Error("Not an authority that can be resolved!");const ae=q.substr(0,ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this._resolvers[ae]}}async $resolveAuthority(q,ee){this._logService.info(`$resolveAuthority invoked for authority (${G(q)})`);const{authorityPrefix:ae,resolver:ue}=await this._activateAndGetResolver(q);if(!ue)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ae}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ue)),k.mark(`code/extHost/willResolveAuthority/${ae}`);const Z=await ue.resolve(q,{resolveAttempt:ee});k.mark(`code/extHost/didResolveAuthorityOK/${ae}`);const Y={authority:q,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},se={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:se,tunnelInformation:{environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures}}}}catch(Z){if(k.mark(`code/extHost/didResolveAuthorityError/${ae}`),Z instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(q,ee){this._logService.info(`$getCanonicalURI invoked for authority (${G(q)})`);const{authorityPrefix:ae,resolver:ue}=await this._activateAndGetResolver(q);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ae}`);const Z=R.URI.revive(ee);if(typeof ue.getCanonicalURI=="undefined")return Z;const Y=await(0,S.asPromise)(()=>ue.getCanonicalURI(Z));return Y||Z}$startExtensionHost(q){return this._registry.keepOnly(q),this._startExtensionHost()}$activateByEvent(q,ee){return ee===1?this._activateByEvent(q,!1):this._readyToRunExtensions.wait().then(ae=>this._activateByEvent(q,!1))}async $activate(q,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(q)?(await this._activateById(q,ee),!0):!1}async $deltaExtensions(q,ee){q.forEach(ue=>ue.extensionLocation=R.URI.revive(ue.extensionLocation));const ae=await this.getExtensionPathIndex();return await Promise.all(ee.map(async ue=>{const Z=this._registry.getExtensionDescription(ue);Z&&ae.delete(await this._realPathExtensionUri(Z.extensionLocation))})),await Promise.all(q.map(async ue=>{const Z=await this._realPathExtensionUri(ue.extensionLocation);ae.set(Z,ue)})),this._registry.deltaExtensions(q,ee),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){let ee=c.VSBuffer.alloc(q),ae=Math.random()%256;for(let ue=0;ue<q;ue++)ee.writeUInt8(ae,ue);return ee}async $updateRemoteConnectionData(q){this._remoteConnectionData=q,this._onDidChangeRemoteConnectionData.fire()}};x=Be([Fe(0,o.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,n.IExtHostRpcService),Fe(3,d.IExtHostWorkspace),Fe(4,p.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,i.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,g.IExtHostTunnelService),Fe(9,u.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function K(X,q){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class B{constructor(q,ee,ae,ue){H.set(this,void 0),M.set(this,void 0),z.set(this,void 0),Ke(this,H,q,"f"),Ke(this,M,ee,"f"),Ke(this,z,ae.identifier,"f"),this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=ue}get isActive(){return Pe(this,H,"f").isActivated(Pe(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Pe(this,H,"f").getExtensionExports(Pe(this,z,"f"))}activate(){return Pe(this,H,"f").activateByIdWithErrors(Pe(this,z,"f"),{startup:!1,extensionId:Pe(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,H=new WeakMap,M=new WeakMap,z=new WeakMap;function G(X){const q=X.indexOf("+");return q===-1?X:X.substring(0,q)}}),define(we[54],be([1,0,9,2,3,13,5,7,126,35,40,45,217,36,210,14,4,18,41,53]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let c=class{constructor(a,g,u,m,T,O){this._workspaceService=g,this._extensionService=u,this._editorsService=m,this._configurationService=T,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=a.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(y=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,g){const u=a;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let m=`debug:${encodeURIComponent(u.path||"")}`,T="?";return g&&(m+=`${T}session=${encodeURIComponent(g.id)}`,T="&"),m+=`${T}ref=${u.sourceReference}`,t.URI.parse(m)}else{if(u.path)return t.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const g=[];for(const u of a.getAllExtensionDescriptions())if(u.contributes){const m=u.contributes.debuggers;if(m&&m.length>0)for(const T of m)(0,v.isDebuggerMainContribution)(T)&&g.push(T.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(g=>a.push(g)),a}addBreakpoints(a){this.startBreakpoints();const g=a.filter(T=>{const O=T.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,T),!0)});this.fireBreakpointChanges(g,[],[]);const u=[],m=new Map;for(const T of g)if(T instanceof D.SourceBreakpoint){let O=m.get(T.location.uri.toString());O||(O={type:"sourceMulti",uri:T.location.uri,lines:[]},m.set(T.location.uri.toString(),O),u.push(O)),O.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof D.FunctionBreakpoint&&u.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(a){this.startBreakpoints();const g=a.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],g,[]);const u=g.filter(O=>O instanceof D.SourceBreakpoint).map(O=>O.id),m=g.filter(O=>O instanceof D.FunctionBreakpoint).map(O=>O.id),T=g.filter(O=>O instanceof D.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(u,m,T)}startDebugging(a,g,u){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,g,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,g,u){if(!g)return new D.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:m,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,u,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,m),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(a,g,u){if(!u)return new D.Disposable(()=>{});if(!this.definesDebugType(a,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:m,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,m),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(a,g){if(!g)return new D.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:u,factory:g}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==g)})}async $runInTerminal(a,g){return Promise.resolve(void 0)}async $substituteVariables(a,g){if(!this._variableResolver){const[T,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,O)}let u;const m=await this.getFolder(a);return m&&(u={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,g)}createDebugAdapter(a,g){if(a.type==="implementation")return new i(a.implementation)}createSignService(){}async $startDASession(a,g){const u=this,m=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const O=this.convertToDto(T),L=this.createDebugAdapter(O,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const y=L;return this._debugAdapters.set(a,y),this.getDebugAdapterTrackers(m).then(H=>(H&&this._debugAdaptersTrackers.set(a,H),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const z=M,x={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const K=await this._signService.sign(z.arguments.value);x.body={signature:K},y.sendResponse(x)}else throw new Error("no signer")}catch(K){x.success=!1,x.message=K.message,y.sendResponse(x)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(M),M=(0,v.convertToVSCPaths)(M,!0),u._debugServiceProxy.$acceptDAMessage(a,M)}),y.onError(M=>{H&&H.onError&&H.onError(M),this._debugServiceProxy.$acceptDAError(a,M.name,M.message,M.stack)}),y.onExit(M=>{H&&H.onExit&&H.onExit((0,C.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,C.withNullAsUndefined)(M),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),y.startSession()))})}$sendDAMessage(a,g){g=(0,v.convertToDAPaths)(g,!1);const u=this._debugAdaptersTrackers.get(a);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(g);const m=this._debugAdapters.get(a);m&&m.sendMessage(g)}$stopDASession(a){const g=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),g&&g.onWillStopSession&&g.onWillStopSession();const u=this._debugAdapters.get(a);return this._debugAdapters.delete(a),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const g=[],u=[],m=[];if(a.added)for(const T of a.added){const O=T.id;if(O&&!this._breakpoints.has(O)){let L;if(T.type==="function")L=new D.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")L=new D.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const y=t.URI.revive(T.uri);L=new D.SourceBreakpoint(new D.Location(y,new D.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}L._id=O,this._breakpoints.set(O,L),g.push(L)}}if(a.removed)for(const T of a.removed){const O=this._breakpoints.get(T);O&&(this._breakpoints.delete(T),u.push(O))}if(a.changed){for(const T of a.changed)if(T.id){const O=this._breakpoints.get(T.id);if(O){if(O instanceof D.FunctionBreakpoint&&T.type==="function"){const L=O;L.enabled=T.enabled,L.condition=T.condition,L.hitCondition=T.hitCondition,L.logMessage=T.logMessage,L.functionName=T.functionName}else if(O instanceof D.SourceBreakpoint&&T.type==="source"){const L=O;L.enabled=T.enabled,L.condition=T.condition,L.hitCondition=T.hitCondition,L.logMessage=T.logMessage,L.location=new D.Location(t.URI.revive(T.uri),new D.Position(T.line,T.character))}m.push(O)}}}this.fireBreakpointChanges(g,u,m)}$provideDebugConfigurations(a,g,u){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(a);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(g);return m.provideDebugConfigurations(T,u)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(a,g,u,m){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(a);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(g);return T.resolveDebugConfiguration(O,u,m)})}$resolveDebugConfigurationWithSubstitutedVariables(a,g,u,m){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(a);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(g);return T.resolveDebugConfigurationWithSubstitutedVariables(O,u,m)})}async $provideDebugAdapter(a,g){const u=this.getAdapterDescriptorFactoryByHandle(a);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(g);return this.getAdapterDescriptor(u,m).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(a){const g=await this.getSession(a);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(a){const g=await this.getSession(a);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,g){const u=await this.getSession(a);u&&u._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(a,g){const m={session:await this.getSession(a),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const g=this._adapterFactories.filter(u=>u.type===a);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(a){const g=this._adapterFactories.filter(u=>u.handle===a);if(g.length>0)return g[0].factory}getConfigProviderByHandle(a){const g=this._configProviders.filter(u=>u.handle===a);if(g.length>0)return g[0].provider}definesDebugType(a,g){if(a.contributes){const u=a.contributes.debuggers;if(u&&u.length>0){for(const m of u)if(m.label&&m.type&&m.type===g)return!0}}return!1}getDebugAdapterTrackers(a){const u=a.configuration.type,m=this._trackerFactories.filter(T=>T.type===u||T.type==="*").map(T=>(0,A.asPromise)(()=>T.factory.createDebugAdapterTracker(a)).then(O=>O,O=>null));return Promise.race([Promise.all(m).then(T=>{const O=T.filter(L=>!!L);if(O.length>0)return new o(O)}),new Promise((T,O)=>{const L=setTimeout(()=>{clearTimeout(L),O(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(a,g){const u=g.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new D.DebugAdapterServer(u));if(a){const T=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>a.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,T))).then(O=>{if(O)return O})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,m))}daExecutableFromPackage(a,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,g,u){(a.length>0||g.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:g,changed:u}))}async getSession(a){if(a)if(typeof a=="string"){const g=this._debugSessions.get(a);if(g)return g}else{let g=this._debugSessions.get(a.id);if(!g){const u=await this.getFolder(a.folderUri),m=a.parent?this._debugSessions.get(a.parent):void 0;g=new f(this._debugServiceProxy,a.id,a.type,a.name,u,a.configuration,m),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(a){if(a){const g=t.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};c=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,I.IExtHostDocumentsAndEditors),Fe(4,E.IExtHostConfiguration),Fe(5,l.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class f{constructor(a,g,u,m,T,O,L){this._debugServiceProxy=a,this._id=g,this._type=u,this._name=m,this._workspaceFolder=T,this._configuration=O,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,g)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=f;class s{constructor(a){this.value=Object.freeze({append(g){a.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=s;class b extends p.AbstractVariableResolverService{constructor(a,g,u,m,T,O){function L(){if(g){const y=g.activeEditor();if(y)return y.document.uri;const H=m.tabs.filter(M=>M.isActive);if(H.length>0){const M=H[0].resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:H[0].resource}}}super({getFolderUri:y=>{const H=a.filter(M=>M.name===y);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(y,H)=>u.getConfiguration(void 0,y).get(H),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const y=L();if(y)return h.normalize(y.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const y=L();if(y){const H=T.getWorkspaceFolder(y);if(H)return h.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(g){const y=g.activeEditor();if(y&&!y.selection.isEmpty)return y.document.getText(y.selection)}},getLineNumber:()=>{if(g){const y=g.activeEditor();if(y)return String(y.selection.end.line+1)}}},void 0,O?Promise.resolve(O):void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=b;class o{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(g=>g.onError?g.onError(a):void 0)}onExit(a,g){this.trackers.forEach(u=>u.onExit?u.onExit(a,g):void 0)}}class i extends _.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(a,g,u,m,T,O){super(a,g,u,m,T,O)}createVariableResolver(a,g,u){return new b(a,g,u,this._editorTabs)}};r=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,I.IExtHostDocumentsAndEditors),Fe(4,E.IExtHostConfiguration),Fe(5,l.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(we[270],be([1,0,71,2,5,36,29,27,14,26,4,40,41,11,8]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(f,s,b,o,i,r,n){this._apiFactory=f,this._extensionRegistry=s,this._instaService=b,this._extHostConfiguration=o,this._extHostExtensionService=i,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new C(this._apiFactory,s,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(P,s)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(l,s,this._initData.environment.appUriScheme))}register(f){if("nodeModuleName"in f)if(Array.isArray(f.nodeModuleName))for(let s of f.nodeModuleName)this._factories.set(s,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(s=>f.alternativeModuleName(s))}};d=Be([Fe(2,F.IInstantiationService),Fe(3,A.IExtHostConfiguration),Fe(4,I.IExtHostExtensionService),Fe(5,R.IExtHostInitDataService),Fe(6,E.ILogService)],d),e.RequireInterceptor=d;let w=class Hi{constructor(f){if(f.environment.appRoot&&Hi.aliased.size){const s=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(f.environment.appRoot.fsPath)),b="[a-z0-9_.-]",o=`@${b}+\\/${b}+|${b}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(f){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(f));if(!s)return;const[,b,o,i]=s,r=Hi.aliased.get(o);if(r!==void 0)return console.warn(`${o} as been renamed to ${r}, please update your imports`),b+r+i}forceForwardSlashes(f){return f.replace(/\\/g,"/")}};w.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),w=Be([Fe(0,R.IExtHostInitDataService)],w);class C{constructor(f,s,b,o,i){this._apiFactory=f,this._extensionPaths=s,this._extensionRegistry=b,this._configProvider=o,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,s){const b=this._extensionPaths.findSubstr(s);if(b){let o=this._extApiImpl.get(D.ExtensionIdentifier.toKey(b.identifier));return o||(o=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(b.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((i,r)=>o+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let P=class{constructor(f,s,b){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(k.MainContext.MainThreadTelemetry);const{environment:o}=b,i=s.getProxy(k.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;p.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>i.$getPassword(r,n),setPassword:(r,n,a)=>i.$setPassword(r,n,a),deletePassword:(r,n)=>i.$deletePassword(r,n),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(f,s){const b=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:b?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const s=f.length;if(s<=7||!this.alternativeNames)return;const b=s-7;if((f.charAt(b)==="/"||f.charAt(b)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};P=Be([Fe(1,_.IExtHostRpcService),Fe(2,R.IExtHostInitDataService)],P);let l=class{constructor(f,s,b){this._extensionPaths=f,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(k.MainContext.MainThreadTelemetry);const o=b.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,r)=>{const n=t.URI.parse(i);return r?this.callOriginal(i,r):n.scheme==="http"||n.scheme==="https"?o.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?o.$openUri(n,i,{}):this.callOriginal(i,r)}}load(f,s,b){const o=this._extensionPaths.findSubstr(s);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=b(f),this._impl}callOriginal(f,s){return this.sendNoForwardTelemetry(),this._original(f,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};l=Be([Fe(2,_.IExtHostRpcService)],l)}),define(we[271],be([1,0,13,16,71,6,2,5,264,11,61,80,26,188,14,64,40,34]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(c,f,s,b,o){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new _.RPCProtocol(c,null,b),f=P._transform(f,this._rpcProtocol);const i=new I.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());i.set(p.IExtHostInitDataService,{_serviceBrand:void 0,...f,messagePorts:o}),i.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),i.set(d.IURITransformerService,new d.URITransformerService(b)),i.set(w.IHostUtils,s);const r=new E.InstantiationService(i,!0);this._disposables.add(r.invokeFunction(u=>u.get(C.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(u=>u.get(w.IExtHostExtensionService))),this._logService=r.invokeFunction(u=>u.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",f),this._extensionService=r.invokeFunction(u=>u.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(m,T)=>{let O="",L,y;for(const H of T)O+=`
	at ${H.toString()}`,y=H.getFileName(),!L&&y&&(L=u.findSubstr(S.URI.file(y)));return n.set(m,L),`${m.name||"Error"}: ${m.message||""}${O}`}});const a=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),g=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(u=>{const m=t.transformErrorForSerialization(u),T=n.get(u);T?a.$onExtensionRuntimeError(T.identifier,m):g.$onUnexpectedError(m)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();Promise.race([(0,h.timeout)(5e3),f]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(c,f){c.extensions.forEach(b=>b.extensionLocation=S.URI.revive(f.transformIncomingURIs(b.extensionLocation))),c.environment.appRoot=S.URI.revive(f.transformIncomingURIs(c.environment.appRoot));const s=c.environment.extensionDevelopmentLocationURI;return s&&(c.environment.extensionDevelopmentLocationURI=s.map(b=>S.URI.revive(f.transformIncomingURIs(b)))),c.environment.extensionTestsLocationURI=S.URI.revive(f.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(f.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(f.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(f.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(f.transformIncomingURIs(c.logFile)),c.workspace=f.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=P}),define(we[272],be([1,0,173,60,12,7,211,35,40,45,36,34,14,54,195,13,212,53,187]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let l=class extends E.ExtHostDebugServiceBase{constructor(o,i,r,n,a,g,u){super(o,i,r,n,a,u);this._terminalService=g,this._integratedTerminalInstances=new s}createDebugAdapter(o,i){switch(o.type){case"server":return new S.SocketDebugAdapter(o);case"pipeServer":return new S.NamedPipeDebugAdapter(o);case"executable":return new S.ExecutableDebugAdapter(o,i.type)}return super.createDebugAdapter(o,i)}daExecutableFromPackage(o,i){const r=S.ExecutableDebugAdapter.platformAdapterExecutable(i.getAllExtensionDescriptions(),o.type);if(r)return new A.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new v.SignService}async $runInTerminal(o,i){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const r=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),g=o.title||h.localize(0,null),u=JSON.stringify({shell:n,shellArgs:a});let m=await this._integratedTerminalInstances.checkout(u,g),T,O=!1;if(m)T=o.cwd;else{const M={shellPath:n,shellArgs:a,cwd:o.cwd,name:g,iconPath:new A.ThemeIcon("debug")};O=!0,m=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(m,u)}m.show(!0);const L=await m.processId;O?await new Promise(M=>setTimeout(M,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?m.sendText("cls"):n.indexOf("bash")>=0?m.sendText("clear"):k.isWindows?m.sendText("cls"):m.sendText("clear"));const y=(0,w.prepareCommand)(n,o.args,T,o.env);m.sendText(y);const H=this.onDidTerminateDebugSession(M=>{M.id===i&&(this._integratedTerminalInstances.free(m),H.dispose())});return L}else if(o.kind==="external")return f(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,i)}createVariableResolver(o,i,r){return new E.ExtHostVariableResolverService(o,i,r,this._editorTabs,this._workspaceService,(0,t.homedir)())}};l=Be([Fe(0,p.IExtHostRpcService),Fe(1,D.IExtHostWorkspace),Fe(2,_.IExtHostExtensionService),Fe(3,R.IExtHostDocumentsAndEditors),Fe(4,F.IExtHostConfiguration),Fe(5,I.IExtHostTerminalService),Fe(6,C.IExtHostEditorTabs)],l),e.ExtHostDebugService=l;let c;function f(b,o){if(!c)if(k.isWindows)c=new P.WindowsExternalTerminalService;else if(k.isMacintosh)c=new P.MacExternalTerminalService;else if(k.isLinux)c=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const i=o.getConfiguration("terminal");return c.runInTerminal(b.title,b.cwd,b.args,b.env||{},i.external||{})}e.runInExternalTerminal=f;class s{constructor(){this._terminalInstances=new Map}async checkout(o,i){const n=[...this._terminalInstances.entries()].map(([a,g])=>(0,d.createCancelablePromise)(async u=>{if(a.name!==i||g.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await a.processId))return null;const m=Date.now();return g.lastUsedAt+s.minUseDelay>m||u.isCancellationRequested||g.config!==o?null:(g.lastUsedAt=m,a)}));return await(0,d.firstParallel)(n,a=>!!a)}insert(o,i){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:i})}free(o){const i=this._terminalInstances.get(o);i&&(i.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}s.minUseDelay=1e3}),define(we[273],be([1,0,9,2,112,35,54,45,36,43,34,14,26,70,10,11,65,53,23,60]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends E.ExtHostTaskBase{constructor(s,b,o,i,r,n,a,g,u){super(s,b,o,i,r,n,a,g);this.workspaceService=o,this.editorTabs=u,b.remote.isRemote&&b.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:b.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,b){const o=b;if(!b.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const i=E.TaskHandleDTO.from(o,this.workspaceService),r=await this._proxy.$getTaskExecution(i);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(r,b);return this._proxy.$executeTask(i).catch(()=>{}),n}else{const i=E.TaskDTO.from(b,s);if(i===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,b,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),b);return this._proxy.$executeTask(i).catch(()=>{}),r}}provideTasksInternal(s,b,o,i){const r=[];if(i)for(let n of i){this.checkDeprecation(n,o),(!n.definition||!s[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(n,o.extension);a&&(r.push(a),E.CustomExecutionDTO.is(a.execution)&&b.push(this.addCustomExecution(a,n,!0)))}return{tasks:r,extension:o.extension}}async resolveTaskInternal(s){return s}async getVariableResolver(s){if(this._variableResolver===void 0){const b=await this._configurationService.getConfigProvider();this._variableResolver=new S.ExtHostVariableResolverService(s,this._editorService,b,this.editorTabs,this.workspaceService,(0,l.homedir)())}return this._variableResolver}async getAFolder(s){let b=s&&s.length>0?s[0]:void 0;if(!b){const o=t.URI.file((0,l.homedir)());b=new R.WorkspaceFolder({uri:o,name:P.basename(o),index:0})}return{uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,b){const o=t.URI.revive(s),i={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(o),n=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(n),g=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let u of b.variables)i.variables[u]=await a.resolveAsync(g,u);if(b.process!==void 0){let u;if(b.process.path!==void 0){u=b.process.path.split(h.delimiter);for(let m=0;m<u.length;m++)u[m]=await a.resolveAsync(g,u[m])}i.process=await k.win32.findExecutable(await a.resolveAsync(g,b.process.name),b.process.cwd!==void 0?await a.resolveAsync(g,b.process.cwd):void 0,u)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(s,b,o){return k.win32.findExecutable(s,b,o)}};c=Be([Fe(0,I.IExtHostRpcService),Fe(1,p.IExtHostInitDataService),Fe(2,A.IExtHostWorkspace),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,_.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,d.ILogService),Fe(7,w.IExtHostApiDeprecationService),Fe(8,C.IExtHostEditorTabs)],c),e.ExtHostTask=c}),define(we[137],be([1,0,17,13,21,49,32,10,9,23,18,2,31]),function(te,e,h,t,k,A,S,D,_,R,F,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(c,f,s,b){this.query=c,this.provider=f,this.fileUtils=s,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,f){const s=this.query.folderQueries||[],b=new k.CancellationTokenSource;return f.onCancellationRequested(()=>b.cancel()),new Promise((o,i)=>{this.collector=new d(c);let r=!1;const n=(a,g)=>{if(!r&&!this.isLimitHit){const u=this.resultSize(a);C(a)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,r=!0,b.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const m=this.resultSize(a);this.resultCount+=m,(m>0||!C(a))&&this.collector.add(a,g)}};Promise.all(s.map((a,g)=>this.searchInFolder(a,u=>n(u,g),b.token))).then(a=>{b.dispose(),this.collector.flush();const g=a.some(u=>!!u&&!!u.limitHit);o({limitHit:this.isLimitHit||g,messages:(0,h.flatten)(a.map(u=>u?.message?(0,F.isArray)(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},a=>{b.dispose();const g=(0,A.toErrorMessage)(a);i(new Error(g))})})}resultSize(c){return C(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,f){const s=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:s.slice(0,f),preview:{matches:b.slice(0,f),text:c.preview.text},uri:c.uri}}async searchInFolder(c,f,s){const b=new p.QueryGlobTester(this.query,c),o=[],i={report:a=>{if(!this.validateProviderResult(a))return;const g=c.folder.scheme===D.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(a.uri))):void 0,u=R.relativePath(c.folder,a.uri);if(u){const m=b.includedInQuery(u,_.basename(u),g);(0,t.isThenable)(m)?o.push(m.then(T=>{T&&f(a)})):m&&f(a)}}},r=this.getSearchOptionsForFolder(c),n=await this.provider.provideTextSearchResults(v(this.query.contentPattern),r,i,s);return o.length&&await Promise.all(o),n}validateProviderResult(c){if(C(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const f=(0,p.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),s=(0,p.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),b={folder:I.URI.from(c.folder),excludes:s,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=E;function v(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,f=>this.sendItems(f))}add(c,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!R.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(w(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function w(l){return C(l)?{preview:{matches:(0,h.mapArrayOrNot)(l.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:l.preview.text},ranges:(0,h.mapArrayOrNot)(l.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function C(l){return!!l.preview}e.extensionResultIsMatch=C;class P{constructor(c,f){this.maxBatchSize=c,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,f){!c||this.addItemToBatch(c,f)}addItems(c,f){!c||this.addItemsToBatch(c,f)}addItemToBatch(c,f){this.batch.push(c),this.batchSize+=f,this.onUpdate()}addItemsToBatch(c,f){this.batch=this.batch.concat(c),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(we[72],be([1,0,6,5,4,267,14,64,11,2,137]),function(te,e,h,t,k,A,S,D,_,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(d,w,C){this.extHostRpc=d,this._uriTransformer=w,this._logService=C,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,w){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const C=this._handlePool++;return this._textSearchProvider.set(C,w),this._proxy.$registerTextSearchProvider(C,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}registerFileSearchProvider(d,w){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const C=this._handlePool++;return this._fileSearchProvider.set(C,w),this._proxy.$registerFileSearchProvider(C,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(d,w,C,P){const l=p(C),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(l,c,f=>{this._proxy.$handleFileMatch(d,w,f.map(s=>s.resource))},P);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,w,C,P){const l=this._textSearchProvider.get(d);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=p(C);return this.createTextSearchManager(c,l).search(s=>this._proxy.$handleTextMatch(d,w,s),P)}$enableExtensionHostSearch(){}createTextSearchManager(d,w){return new F.TextSearchManager(d,w,{readdir:C=>Promise.resolve([]),toCanonicalName:C=>C},"textSearchProvider")}};I=Be([Fe(0,S.IExtHostRpcService),Fe(1,D.IURITransformerService),Fe(2,_.ILogService)],I),e.ExtHostSearch=I;function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>R.URI.revive(d))}}e.reviveQuery=p;function E(v){return{...v,folder:R.URI.revive(v.folder)}}}),define(we[274],be([1,0,61,135,35,133,36,39,45,34,70,54,72,87,51,65,136,66,44,86,124,53,134,11,226]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c,f,s,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(b.ILoggerService,s.ExtHostLoggerService),(0,h.registerSingleton)(b.ILogService,o.ExtHostLogService),(0,h.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,h.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,h.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,h.registerSingleton)(C.IExtHostConsumerFileSystem,C.ExtHostConsumerFileSystem),(0,h.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,h.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,h.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,h.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,h.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,h.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,h.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,h.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,h.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService),(0,h.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,h.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,h.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,h.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,h.registerSingleton)(f.IExtHostEditorTabs,f.ExtHostEditorTabs)}),define(we[88],be([1,0,17,11,31,69]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function S(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=S;function D(I,p,E,v){const d=(0,h.mapArrayOrNot)(E,_),w=new k.TextSearchMatch(p,d,v),C=w.preview.matches;return{ranges:(0,h.mapArrayOrNot)(d,R),uri:I,preview:{text:w.preview.text,matches:(0,h.mapArrayOrNot)(C,R)}}}e.createTextSearchResult=D;function _(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function R(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let F=class{constructor(p,E){this.prefix=p,this.logService=E}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};F=Be([Fe(1,t.ILogService)],F),e.OutputChannel=F}),define(we[275],be([1,0,38,9,78,30,12,8,88,276]),function(te,e,h,t,k,A,S,D,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=R.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,c,f,s){const b=p(l,c,f,s),o=c.folder.fsPath;return{cmd:h.spawn(F,b.args,{cwd:o}),rgDiskPath:F,siblingClauses:b.siblingClauses,rgArgs:b,cwd:o}}e.spawnRipgrepCmd=I;function p(l,c,f,s){const b=["--files","--hidden","--case-sensitive"];v([c],f,!1).forEach(i=>{const r=(0,_.anchorGlob)(i);if(b.push("-g",r),S.isMacintosh){const n=(0,k.normalizeNFD)(r);n!==r&&b.push("-g",n)}});const o=E([c],s,void 0,!1);return o.globArgs.forEach(i=>{const r=`!${(0,_.anchorGlob)(i)}`;if(b.push("-g",r),S.isMacintosh){const n=(0,k.normalizeNFD)(r);n!==r&&b.push("-g",n)}}),c.disregardIgnoreFiles!==!1?b.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&b.push("--no-ignore-parent"),c.ignoreSymlinks||b.push("--follow"),l.exists&&b.push("--quiet"),b.push("--no-config"),c.disregardGlobalIgnoreFiles&&b.push("--no-ignore-global"),{args:b,siblingClauses:o.siblingClauses}}function E(l,c,f,s=!0){const b=[];let o={};return l.forEach(i=>{const r=Object.assign({},i.excludePattern||{},c||{}),n=d(r,s?i.folder.fsPath:void 0,f);b.push(...n.globArgs),n.siblingClauses&&(o=Object.assign(o,n.siblingClauses))}),{globArgs:b,siblingClauses:o}}e.foldersToRgExcludeGlobs=E;function v(l,c,f=!0){const s=[];return l.forEach(b=>{const o=Object.assign({},c||{},b.includePattern||{}),i=d(o,f?b.folder.fsPath:void 0);s.push(...i.globArgs)}),s}e.foldersToIncludeGlobs=v;function d(l,c,f){const s=[],b={};return Object.keys(l).forEach(o=>{if(f&&f.has(o)||!o)return;const i=l[o];o=C(c?w(c,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),s.push(P(o))):i&&i.when&&(b[o]=i)}),{globArgs:s,siblingClauses:b}}function w(l,c){return t.isAbsolute(c)?c:t.join(l,c)}e.getAbsoluteGlob=w;function C(l){return l=D.rtrim(l,"\\"),D.rtrim(l,"/")}function P(l){return A.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=P}),define(we[277],be([1,0,38,59,9,102,17,49,32,78,30,12,46,8,18,28,31,275,98]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(o=>o())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&_.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&_.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const n=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),a=r.folder.fsPath;i.folderQueries.map(g=>g.folder.fsPath).filter(g=>g!==a).forEach(g=>{(0,F.isEqualOrParent)(g,a)&&(n[k.relative(a,g)]=!0)}),this.folderExcludePatterns.set(a,new s(n,a))})}cancel(){this.isCanceled=!0,l.forEach(i=>i())}walk(i,r,n,a,g){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return g(null,this.isLimitHit);r.forEach(u=>{const m=k.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,m)||this.matchFile(n,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(i,(u,m)=>{this.call(this.cmdTraversal,this,u,n,a,T=>{if(T){const O=(0,D.toErrorMessage)(T);console.error(O),this.errors.push(O),m(T,void 0)}else m(null,void 0)})},(u,m)=>{this.fileWalkSW.stop();const T=u?S.coalesce(u)[0]:null;g(T,this.isLimitHit)})}parallel(i,r,n){const a=new Array(i.length),g=new Array(i.length);let u=!1,m=0;if(i.length===0)return n(null,[]);i.forEach((T,O)=>{r(T,(L,y)=>{if(L?(u=!0,a[O]=null,g[O]=L):(a[O]=y,g[O]=null),++m===i.length)return n(u?g:null,a)})})}call(i,r,...n){try{i.apply(r,n)}catch(a){n[n.length-1](a)}}cmdTraversal(i,r,n,a){const g=i.folder.fsPath,u=I.isMacintosh;let m;const T=()=>m&&m.kill();l.add(T);let O=K=>{l.delete(T),O=()=>{},a(K)},L="";const y=this.initDirectoryTree();let H;const M=(0,C.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);m=M.cmd,H=!Object.keys(M.siblingClauses).length;const z=M.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let x=`${M.rgDiskPath} ${z}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),n({message:x}),this.cmdResultCount=0,this.collectStdout(m,"utf8",n,(K,B,G)=>{if(K){O(K);return}if(this.isLimitHit){O();return}const q=(L+(u?R.normalizeNFC(B||""):B)).split(`
`);if(G){const ee=q.length;q[ee-1]=q[ee-1].trim(),q[ee-1]||q.pop()}else L=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,H){for(const ee of q)if(this.matchFile(r,{base:g,relativePath:ee,searchPath:this.getSearchPath(i,ee)}),this.isLimitHit){T();break}(G||this.isLimitHit)&&O();return}this.addDirectoryEntries(i,y,g,q,r),G&&(this.matchDirectoryTree(y,g,r),O())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),n=r.getBasenameTerms(),a=r.getPathTerms(),g=["-L","."];if(n.length||a.length){g.push("-not","(","(");for(const u of n)g.push("-name",u),g.push("-o");for(const u of a)g.push("-path",u),g.push("-o");g.pop(),g.push(")","-prune",")")}return g.push("-type","f"),h.spawn("find",g,{cwd:i.folder.fsPath})}readStdout(i,r,n){let a="";this.collectStdout(i,r,()=>{},(g,u,m)=>{if(g){n(g);return}a+=u,m&&n(null,a)})}collectStdout(i,r,n,a){let g=(T,O,L)=>{(T||L)&&(g=()=>{},this.cmdSW&&this.cmdSW.stop()),a(T,O,L)},u=!1;i.stdout?(this.forwardData(i.stdout,r,g),i.stdout.once("data",()=>u=!0)):n({message:"stdout is null"});let m;i.stderr?m=this.collectData(i.stderr):n({message:"stderr is null"}),i.on("error",T=>{g(T)}),i.on("close",T=>{let O;!u&&(O=this.decodeData(m,r))&&b(O)?g(new Error(`command failed with error code ${T}: ${this.decodeData(m,r)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),g(null,"",!0))})}forwardData(i,r,n){const a=new A.StringDecoder(r);return i.on("data",g=>{n(null,a.write(g))}),a}collectData(i){const r=[];return i.on("data",n=>{r.push(n)}),r}decodeData(i,r){const n=new A.StringDecoder(r);return i.map(a=>n.write(a)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},n,a,g){a.indexOf(this.filePattern)!==-1&&this.matchFile(g,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const u=m=>{const T=k.basename(m),O=k.dirname(m);let L=r[O];L||(L=r[O]=[],u(O)),L.push({base:n,relativePath:m,basename:T,searchPath:this.getSearchPath(i,m)})};a.forEach(u)}matchDirectoryTree({rootEntries:i,pathToEntries:r},n,a){const g=this,u=this.folderExcludePatterns.get(n),m=this.filePattern;function T(O){g.directoriesWalked++;const L=_.hasSiblingFn(()=>O.map(y=>y.basename));for(let y=0,H=O.length;y<H;y++){const M=O[y],{relativePath:z,basename:x}=M;if(u.test(z,x,m!==x?L:void 0))continue;const K=r[z];if(K)T(K);else{if(g.filesWalked++,z===m)continue;g.matchFile(a,M)}if(g.isLimitHit)break}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,n,a,g){const u=i.folder,m=_.hasSiblingFn(()=>n);this.parallel(n,(T,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const L=r?[r,T].join(k.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test(L,T,this.config.filePattern!==T?m:void 0))return O(null);const y=[u.fsPath,L].join(k.sep);t.lstat(y,(H,M)=>{if(H||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(y,M,(z,x)=>z||this.isCanceled||this.isLimitHit?O(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(y,M,(K,B)=>K||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?O(null):(this.walkedPaths[B]=!0,d.Promises.readdir(y).then(G=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(i,L,G,a,X=>O(X||null))},G=>{O(null)})))):(this.filesWalked++,L===this.filePattern||this.maxFilesize&&v.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(a,{base:u.fsPath,relativePath:L,searchPath:this.getSearchPath(i,L)}),O(null,void 0)))})},T=>{const O=T&&S.coalesce(T);return g(O&&O.length>0?O[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,k.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,n){return r.isSymbolicLink()?t.stat(i,n):n(null,r)}realPathIfNeeded(i,r,n){return r.isSymbolicLink()?t.realpath(i,(a,g)=>a?n(a):n(null,g)):n(null,i)}getSearchPath(i,r){return i.folderName?k.join(i.folderName,r):r}}e.FileWalker=c;class f{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,r,n){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(a,g)=>{n(a,{limitHit:g,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class s{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,n;Object.keys(i).filter(a=>i[a]).forEach(a=>{k.isAbsolute(a)?(r=r||_.getEmptyExpression(),r[a]=i[a]):(n=n||_.getEmptyExpression(),n[a]=i[a])}),this.absoluteParsedExpr=r&&_.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=n&&_.parse(n,{trimForExclusions:!0})}test(i,r,n){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),r,n)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getPathTerms(this.relativeParsedExpr)),i}}function b(o){const i=o.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=b}),define(we[278],be([1,0,94,22]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===o)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,S=512,D=512*8,_=512*128;var R;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=F;class I{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((a,g)=>{te(["@vscode/iconv-lite-umd"],a,g)})).getDecoder(d(i));else{const n=new TextDecoder;r={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new I(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function p(o,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?D:S;return new Promise((n,a)=>{const g=(0,h.newWriteableStream)(y=>y.join("")),u=[];let m=0,T,O;const L=async()=>{try{const y=await b({buffer:t.VSBuffer.concat(u),bytesRead:m},i.guessEncoding);if(y.seemsBinary&&i.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);y.encoding=await i.overwriteEncoding(y.encoding),T=await I.create(y.encoding);const H=T.write(t.VSBuffer.concat(u).buffer);g.write(H),u.length=0,m=0,n({stream:g,detected:y})}catch(y){O?.dispose(),g.destroy(),a(y)}};O=(0,h.listenStream)(o,{onData:async y=>{T?g.write(T.write(y.buffer)):(u.push(y),m+=y.byteLength,m>=r&&(o.pause(),await L(),setTimeout(()=>o.resume())))},onError:y=>g.error(y),onEnd:async()=>{T||await L(),g.end(T?.end())}})})}e.toDecodeStream=p;async function E(o,i,r){const a=(await new Promise((m,T)=>{te(["@vscode/iconv-lite-umd"],m,T)})).getEncoder(d(i),r);let g=!1,u=!1;return{read(){if(u)return null;const m=o.read();if(typeof m!="string"){if(u=!0,!g&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const T=a.end();return T&&T.length>0?(g=!0,t.VSBuffer.wrap(T)):null}return g=!0,t.VSBuffer.wrap(a.write(m))}}}e.toEncodeReadable=E;async function v(o){return(await new Promise((r,n)=>{te(["@vscode/iconv-lite-umd"],r,n)})).encodingExists(d(o))}e.encodingExists=v;function d(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=d;function w(o,i){if(!o||i<e.UTF16be_BOM.length)return null;const r=o.readUInt8(0),n=o.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const a=o.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const C=["ascii","utf-16","utf-32"];async function P(o){const i=await new Promise((u,m)=>{te(["jschardet"],u,m)}),r=o.slice(0,_),n=f(r.buffer),a=i.detect(n);if(!a||!a.encoding)return null;const g=a.encoding.toLowerCase();return 0<=C.indexOf(g)?null:c(a.encoding)}const l={ibm866:"cp866",big5:"cp950"};function c(o){const i=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[i]||i}function f(o){let i="";for(let r=0;r<o.length;r++)i+=String.fromCharCode(o[r]);return i}function s(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=o.match(/windows(\d+)/);return i?"windows-"+i[1]:o}}}e.toCanonicalName=s;function b({buffer:o,bytesRead:i},r){let n=w(o,i),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&o){let g=!0,u=!0,m=!1;for(let T=0;T<i&&T<A;T++){const O=T%2==1,L=o.readUInt8(T)===0;if(L&&(m=!0),g&&(O&&!L||!O&&L)&&(g=!1),u&&(O&&L||!O&&!L)&&(u=!1),L&&!g&&!u)break}m&&(g?n=e.UTF16le:u?n=e.UTF16be:a=!0)}return r&&!a&&!n&&o?P(o.slice(0,i)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=b,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(we[138],be([1,0,278,28,137]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(D,_,R=t,F="searchProcess"){super(D,_,{readdir:I=>R.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,h.toCanonicalName)(I)},F)}}e.NativeTextSearchManager=A}),define(we[279],be([1,0,61,4]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const D=this._dragOperations.get(S);return this._dragOperations.delete(S),D}}addDragOperationTransfer(S,D){this._dragOperations.set(S,D)}}e.TreeViewsDragAndDropService=k,(0,h.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(we[280],be([1,0,171,23,2,3,6,13,7,18,17,15,21,205,279]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(P,l){if((0,R.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let c;return Array.isArray(P.highlights)&&(c=P.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),c=c.length?c:void 0),{label:P.label,highlights:c}}}class w{constructor(l,c,f){this._proxy=l,this.commands=c,this.logService=f,this.treeViews=new Map,this.treeDragAndDropService=new v.TreeViewsDragAndDropService;function s(b){return b&&b.$treeViewId&&b.$treeItemHandle}c.registerArgumentProcessor({processArgument:b=>s(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(o=>s(o)?this.convertArgument(o):o):b})}registerTreeDataProvider(l,c,f){const s=this.createTreeView(l,{treeDataProvider:c},f);return{dispose:()=>s.dispose()}}createTreeView(l,c,f){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=c.dragAndDropController?.dropMimeTypes,b=c.dragAndDropController?.dragMimeTypes,o=!!c.dragAndDropController?.handleDrag,i=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:s,dragMimeTypes:b,hasHandleDrag:o}),r=this.createExtHostTreeView(l,c,f);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(n){r.message=n},get title(){return r.title},set title(n){r.title=n},get description(){return r.description},set description(n){r.description=n},reveal:(n,a)=>r.reveal(n,a),dispose:async()=>{await i,this.treeViews.delete(l),r.dispose()}}}$getChildren(l,c){const f=this.treeViews.get(l);return f?f.getChildren(c):Promise.reject(new Error((0,h.localize)(0,null,l)))}async $handleDrop(l,c,f,s,b,o,i){const r=this.treeViews.get(l);if(!r)return Promise.reject(new Error((0,h.localize)(1,null,l)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(c);return o===l&&i&&await this.addAdditionalTransferItems(n,r,i,s,b),r.onDrop(n,f,s)}async addAdditionalTransferItems(l,c,f,s,b){const o=this.treeDragAndDropService.removeDragOperationTransfer(b);if(o)(await o)?.forEach((i,r)=>{i&&l.set(r,i)});else if(b&&c.handleDrag){const i=c.handleDrag(f,l,s);this.treeDragAndDropService.addDragOperationTransfer(b,i),await i}return l}async $handleDrag(l,c,f,s){const b=this.treeViews.get(l);if(!b)return Promise.reject(new Error((0,h.localize)(2,null,l)));const o=await this.addAdditionalTransferItems(new Map,b,c,s,f);if(!!o)return E.TreeDataTransferConverter.toTreeDataTransferDTO(o)}async $hasResolve(l){const c=this.treeViews.get(l);if(!c)throw new Error((0,h.localize)(3,null,l));return c.hasResolve}$resolve(l,c,f){const s=this.treeViews.get(l);if(!s)throw new Error((0,h.localize)(4,null,l));return s.resolveTreeItem(c,f)}$setExpanded(l,c,f){const s=this.treeViews.get(l);if(!s)throw new Error((0,h.localize)(5,null,l));s.setExpanded(c,f)}$setSelection(l,c){const f=this.treeViews.get(l);if(!f)throw new Error((0,h.localize)(6,null,l));f.setSelection(c)}$setVisible(l,c){const f=this.treeViews.get(l);if(!f)throw new Error((0,h.localize)(7,null,l));f.setVisible(c)}createExtHostTreeView(l,c,f){const s=new C(l,c,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(l,s),s}convertArgument(l){const c=this.treeViews.get(l.$treeViewId);return c?c.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=w;class C extends S.Disposable{constructor(l,c,f,s,b,o){super();if(this.viewId=l,this.proxy=f,this.commands=s,this.logService=b,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,o.contributes&&o.contributes.views)for(const n in o.contributes.views)for(const a of o.contributes.views[n])a.id===l&&(this._title=a.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,r;this._register(A.Event.debounce(this._onDidChangeData.event,(n,a)=>(n||(n={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(g=>r=g),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(a.element)?n.elements.push(...a.element):n.elements.push(a.element)),a.message&&(n.message=!0),n),200,!0)(({message:n,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=r;return i=null,this.refresh(a).then(()=>g())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,R.isUndefinedOrNull)(l))}async getChildren(l){const c=l?this.getExtensionElement(l):void 0;if(l&&!c)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let f=this.getChildrenNodes(l);return f||(f=await this.fetchChildrenNodes(c)),f?f.map(s=>s.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,c){c=c||{select:!0,focus:!1};const f=(0,R.isUndefinedOrNull)(c.select)?!0:c.select,s=(0,R.isUndefinedOrNull)(c.focus)?!1:c.focus,b=(0,R.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(o=>this.resolveTreeNode(l,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(r=>r.item)},{select:f,focus:s,expand:b})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:s,expand:b})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,c){const f=this.getExtensionElement(l);f&&(c?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(l){(0,F.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,c,f){const s=[];for(const b of l){const o=this.getExtensionElement(b);o&&s.push(o)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,c,f),c}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,c,f){const s=this.getExtensionElement(c);if(!!s)return(0,D.asPromise)(()=>this.dndController?.handleDrop(l,s,f))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,c){if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(l);if(f){const s=this.nodes.get(f);if(s){const b=await this.dataProvider.resolveTreeItem(s.extensionItem,f,c)??s.extensionItem;return s.item.tooltip=this.getTooltip(b.tooltip),s.item.command=this.getCommand(s.disposableStore,b.command),s.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(c=>c?this.resolveUnknownParentChain(c).then(f=>this.resolveTreeNode(c,f[f.length-1]).then(s=>(f.push(s),f))):Promise.resolve([]))}resolveParent(l){const c=this.nodes.get(l);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,c){const f=this.nodes.get(l);return f?Promise.resolve(f):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(s=>this.createHandle(l,s,c,!0)).then(s=>this.getChildren(c?c.item.handle:void 0).then(()=>{const b=this.getExtensionElement(s);if(b){const o=this.nodes.get(b);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(l){if(l){let c;if(typeof l=="string"){const f=this.getExtensionElement(l);c=f?this.nodes.get(f):void 0}else c=l;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const c=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=l?this.nodes.get(l):void 0,s=await this.dataProvider.getChildren(l);if(c.token.isCancellationRequested)return;const b=await Promise.all((0,F.coalesce)(s||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,f):null}));return c.token.isCancellationRequested?void 0:(0,F.coalesce)(b)}finally{c.dispose()}}refresh(l){if(l.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(l);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const c=new Set,f=l.map(b=>this.nodes.get(b));for(const b of f)if(b&&!c.has(b.item.handle)){let o=b;for(;o&&o.parent&&f.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&c.add(b.item.handle)}const s=[];return c.forEach(b=>{const o=this.elements.get(b);if(o){const i=this.nodes.get(o);i&&(!i.parent||!c.has(i.parent.item.handle))&&s.push(b)}}),s}refreshHandles(l){const c={};return Promise.all(l.map(f=>this.refreshNode(f).then(s=>{s&&(c[f]=s.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(l){const c=this.getExtensionElement(l);if(c){const f=this.nodes.get(c);if(f)return this.clearChildren(c),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(s=>{if(s){const b=this.createTreeNode(c,s,f.parent);return this.updateNodeCache(c,b,f,f.parent),f.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,c,f){const s=this.createTreeNode(l,c,f);if(c.id&&this.elements.has(s.item.handle))throw new Error((0,h.localize)(8,null,c.id));return this.addNodeToCache(l,s),this.addNodeToParentCache(s,f),s}getTooltip(l){return _.MarkdownString.isMarkdownString(l)?I.MarkdownString.from(l):l}getCommand(l,c){return c?this.commands.toInternal(c,l):void 0}createTreeNode(l,c,f){const s=new S.DisposableStore,b=this.createHandle(l,c,f),o=this.getLightIconPath(c);return{item:{handle:b,parentHandle:f?f.item.handle:void 0,label:d(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(s,c.command),contextValue:c.contextValue,icon:o,iconDark:this.getDarkIconPath(c)||o,themeIcon:this.getThemeIcon(c),collapsibleState:(0,R.isUndefinedOrNull)(c.collapsibleState)?_.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:f,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(l){return l.iconPath instanceof _.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:c,label:f,resourceUri:s},b,o){if(c)return`${C.ID_HANDLE_PREFIX}/${c}`;const i=d(f,this.extension),r=b?b.item.handle:C.LABEL_HANDLE_PREFIX;let n=i?i.label:s?(0,t.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const a=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,g=this.getChildrenNodes(b)||[];let u,m=0;do{if(u=`${r}/${m}:${n}`,o||!this.elements.has(u)||a===u)break;m++}while(m<=g.length);return u}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof _.ThemeIcon))return typeof l.iconPath=="string"||k.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof _.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return k.URI.isUri(l)?l:k.URI.file(l)}addNodeToCache(l,c){this.elements.set(c.item.handle,l),this.nodes.set(l,c)}updateNodeCache(l,c,f,s){this.elements.delete(c.item.handle),this.nodes.delete(l),c.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(l,c);const b=this.getChildrenNodes(s)||[],o=b.filter(i=>i.item.handle===f.item.handle)[0];o&&b.splice(b.indexOf(o),1,c)}addNodeToParentCache(l,c){c?(c.children||(c.children=[]),c.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const c=this.nodes.get(l);if(c){if(c.children)for(const f of c.children){const s=this.elements.get(f.item.handle);s&&this.clear(s)}c.children=void 0}}else this.clearAll()}clear(l){const c=this.nodes.get(l);if(c){if(c.children)for(const f of c.children){const s=this.elements.get(f.item.handle);s&&this.clear(s)}this.nodes.delete(l),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}C.LABEL_HANDLE_PREFIX="0",C.ID_HANDLE_PREFIX="1"}),define(we[281],be([1,0,21,16,3,47,2,113,109,149,108,42,5,132,231,230,39,232,36,233,234,235,219,236,45,40,237,238,241,242,243,135,221,248,249,250,87,34,252,280,15,7,255,68,136,35,74,208,240,121,133,70,54,72,11,64,14,26,244,203,51,65,228,253,202,67,66,258,256,257,229,44,251,254,86,53,124,246,69,247,10,117,245,200,239,6,29,209]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P,l,c,f,s,b,o,i,r,n,a,g,u,m,T,O,L,y,H,M,z,x,K,B,G,X,q,ee,ae,ue,Z,Y,se,de,ve,Te,Me,_e,Ee,$,U,N,W,j,re,he,Ce,Ae,We,ze,je,$e,Ue,Qe,et,Re,tt,ne,oe,J,pe,Se,Ne,He,Ye,st,pt,mt,Ve,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(it){const lt=it.get($.IExtHostInitDataService),Rt=it.get(Qe.IExtHostFileSystemInfo),It=it.get(We.IExtHostConsumerFileSystem),kt=it.get(i.IExtHostExtensionService),dt=it.get(ee.IExtHostWorkspace),Ot=it.get(oe.IExtHostTelemetry),Mt=it.get(P.IExtHostConfiguration),Ft=it.get(_e.IURITransformerService),fe=it.get(Ee.IExtHostRpcService),Ie=it.get(H.IExtHostStorage),ge=it.get(Ae.IExtensionStoragePaths),ie=it.get(Me.ILoggerService),ye=it.get(Me.ILogService),Le=it.get(W.IExtHostTunnelService),xe=it.get(j.IExtHostApiDeprecationService),Ge=it.get(q.IExtHostWindow),ct=it.get(tt.IExtHostSecretState),vt=it.get(ne.IExtHostEditorTabs);fe.set(p.ExtHostContext.ExtHostFileSystemInfo,Rt),fe.set(p.ExtHostContext.ExtHostLogLevelServiceShape,ie),fe.set(p.ExtHostContext.ExtHostWorkspace,dt),fe.set(p.ExtHostContext.ExtHostConfiguration,Mt),fe.set(p.ExtHostContext.ExtHostExtensionService,kt),fe.set(p.ExtHostContext.ExtHostStorage,Ie),fe.set(p.ExtHostContext.ExtHostTunnelService,Le),fe.set(p.ExtHostContext.ExtHostWindow,Ge),fe.set(p.ExtHostContext.ExtHostSecretState,ct),fe.set(p.ExtHostContext.ExtHostTelemetry,Ot),fe.set(p.ExtHostContext.ExtHostEditorTabs,vt);const St=fe.set(p.ExtHostContext.ExtHostDecorations,it.get(se.IExtHostDecorations)),Et=fe.set(p.ExtHostContext.ExtHostDocumentsAndEditors,it.get(o.IExtHostDocumentsAndEditors)),rt=fe.set(p.ExtHostContext.ExtHostCommands,it.get(w.IExtHostCommands)),ut=fe.set(p.ExtHostContext.ExtHostTerminalService,it.get(M.IExtHostTerminalService)),wt=fe.set(p.ExtHostContext.ExtHostDebugService,it.get(ve.IExtHostDebugService)),Nt=fe.set(p.ExtHostContext.ExtHostSearch,it.get(Te.IExtHostSearch)),ht=fe.set(p.ExtHostContext.ExtHostTask,it.get(de.IExtHostTask)),Pt=fe.set(p.ExtHostContext.ExtHostOutputService,it.get(m.IExtHostOutputService)),Ut=fe.set(p.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(fe)),Ct=fe.set(p.ExtHostContext.ExtHostDocuments,new b.ExtHostDocuments(fe,Et)),Bt=fe.set(p.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(fe,Et,ye)),xt=fe.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(ye,Ct,fe.getProxy(p.MainContext.MainThreadBulkEdits))),gt=fe.set(p.ExtHostContext.ExtHostNotebook,new U.ExtHostNotebookController(fe,rt,Et,Ct,ge)),ei=fe.set(p.ExtHostContext.ExtHostNotebookDocuments,new st.ExtHostNotebookDocuments(ye,gt)),Yt=fe.set(p.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(ye,fe,gt)),ti=fe.set(p.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(fe,lt,gt,rt,ye)),oi=fe.set(p.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(fe,gt)),Tt=fe.set(p.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(fe,Et)),ii=fe.set(p.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(fe.getProxy(p.MainContext.MainThreadTreeViews),rt,ye)),_i=fe.set(p.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(fe.getProxy(p.MainContext.MainThreadEditorInsets),Tt,lt)),Kt=fe.set(p.ExtHostContext.ExtHostDiagnostics,new l.ExtHostDiagnostics(fe,ye,Rt)),Xt=fe.set(p.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(fe,Ct,rt.converter,Ft)),at=fe.set(p.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(fe,Ft,Ct,rt,Kt,ye,xe)),ai=fe.set(p.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(fe,at)),Vt=fe.set(p.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(fe,ye,Et)),jt=fe.set(p.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(fe,dt,rt)),ni=fe.set(p.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(fe,rt,ye)),Si=fe.set(p.ExtHostContext.ExtHostComments,(0,C.createExtHostComments)(fe,rt,Ct)),gi=fe.set(p.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(fe.getProxy(p.MainContext.MainThreadProgress))),Ci=fe.set(p.ExtHostContext.ExtHosLabelService,new Z.ExtHostLabelService(fe)),pi=fe.set(p.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(fe)),ri=fe.set(p.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(fe)),li=fe.set(p.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(fe,rt)),Jt=fe.set(p.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(fe,{remote:lt.remote},dt,ye,xe)),ci=fe.set(p.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,Jt,dt)),yi=fe.set(p.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(fe,Ct,ge,Jt,ci)),Di=fe.set(p.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews(fe,Jt)),zt=fe.set(p.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(fe,rt)),Ii=fe.set(p.ExtHostContext.ExtHostUriOpeners,new Re.ExtHostUriOpeners(fe));fe.set(p.ExtHostContext.ExtHostInteractive,new pt.ExtHostInteractive(fe,gt,Et,rt));const ki=(0,ae.values)(p.ExtHostContext);fe.assertRegistered(ki);const Pi=new Ue.ExtHostBulkEdits(fe,Et),ui=new d.ExtHostClipboard(fe),di=new u.ExtHostMessageService(fe,ye),Qt=new c.ExtHostDialogs(fe),Ht=new y.ExtHostStatusBar(fe,rt.converter);return v.ExtHostApiCommands.register(rt),function(Oe,Lt,Zt){const ft=function(){let le=!Oe.isUnderDevelopment;function me(){le||(ye.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function ke(Je){if(Array.isArray(Je))Je.forEach(ke);else if(typeof Je=="string")me();else{const bt=Je;typeof bt.scheme=="undefined"&&me(),typeof bt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return Je}}(),Ti={getSession(le,me,ke){return ri.getSession(Oe,le,me,ke)},async hasSession(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,le,me,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(le,me,ke,Je){return ri.registerAuthenticationProvider(le,me,ke,Je)}},Ai={registerCommand(le,me,ke){return rt.registerCommand(!0,le,me,ke,void 0,Oe)},registerTextEditorCommand(le,me,ke){return rt.registerCommand(!0,le,(...Je)=>{const bt=Tt.getActiveTextEditor();if(!bt){ye.warn("Cannot execute "+le+" because there is no active text editor.");return}return bt.edit(Dt=>{me.apply(ke,[bt,Dt,...Je])}).then(Dt=>{Dt||ye.warn("Edits from command "+le+" were not applied.")},Dt=>{ye.warn("An error occurred while running command "+le,Dt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,me,ke)=>((0,Ve.checkProposedApiEnabled)(Oe,"diffCommand"),rt.registerCommand(!0,le,async(...Je)=>{const bt=Et.activeEditor(!0);if(!bt){ye.warn("Cannot execute "+le+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(bt.id);me.apply(ke,[Dt,...Je])},void 0,void 0,Oe)),executeCommand(le,...me){return rt.executeCommand(le,...me)},getCommands(le=!1){return rt.getCommands(le)}},vi={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return ui.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ot.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Oe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Oe,"telemetry"),Ot.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(lt.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,me){return Ge.openUri(le,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===lt.environment.appUriScheme)return Ut.createAppUri(le);try{return await Ge.asExternalUri(le,{allowTunneling:!!lt.remote.authority})}catch(me){if((0,He.matchesScheme)(le,Ne.Schemas.http)||(0,He.matchesScheme)(le,Ne.Schemas.https))return le;throw me}},get remoteName(){return(0,Y.getRemoteName)(lt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind}};lt.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=lt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Ri={createTestController(le,me,ke){return ke&&(0,Ve.checkProposedApiEnabled)(Oe,"testRefresh"),zt.createTestController(le,me,ke)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),zt.createTestObserver()},runTests(le){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),zt.runTests(le)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),zt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),zt.results}},Li={getExtension(le){const me=Lt.getExtensionDescription(le);if(me)return new i.Extension(kt,Oe.identifier,me,wi)},get all(){return Lt.getAllExtensionDescriptions().map(le=>new i.Extension(kt,Oe.identifier,le,wi))},get onDidChange(){return Lt.onDidChange}},hi={createDiagnosticCollection(le){return Kt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:le=>Kt.getDiagnostics(le),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(le,me){return Xt.changeLanguage(le.uri,me)},match(le,me){return(0,F.score)(K.LanguageSelector.from(le),me.uri,me.languageId,!0)},registerCodeActionsProvider(le,me,ke){return at.registerCodeActionProvider(Oe,ft(le),me,ke)},registerCodeLensProvider(le,me){return at.registerCodeLensProvider(Oe,ft(le),me)},registerDefinitionProvider(le,me){return at.registerDefinitionProvider(Oe,ft(le),me)},registerDeclarationProvider(le,me){return at.registerDeclarationProvider(Oe,ft(le),me)},registerImplementationProvider(le,me){return at.registerImplementationProvider(Oe,ft(le),me)},registerTypeDefinitionProvider(le,me){return at.registerTypeDefinitionProvider(Oe,ft(le),me)},registerHoverProvider(le,me){return at.registerHoverProvider(Oe,ft(le),me,Oe.identifier)},registerEvaluatableExpressionProvider(le,me){return at.registerEvaluatableExpressionProvider(Oe,ft(le),me,Oe.identifier)},registerInlineValuesProvider(le,me){return at.registerInlineValuesProvider(Oe,ft(le),me,Oe.identifier)},registerDocumentHighlightProvider(le,me){return at.registerDocumentHighlightProvider(Oe,ft(le),me)},registerLinkedEditingRangeProvider(le,me){return at.registerLinkedEditingRangeProvider(Oe,ft(le),me)},registerReferenceProvider(le,me){return at.registerReferenceProvider(Oe,ft(le),me)},registerRenameProvider(le,me){return at.registerRenameProvider(Oe,ft(le),me)},registerDocumentSymbolProvider(le,me,ke){return at.registerDocumentSymbolProvider(Oe,ft(le),me,ke)},registerWorkspaceSymbolProvider(le){return at.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,me){return at.registerDocumentFormattingEditProvider(Oe,ft(le),me)},registerDocumentRangeFormattingEditProvider(le,me){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(le),me)},registerOnTypeFormattingEditProvider(le,me,ke,...Je){return at.registerOnTypeFormattingEditProvider(Oe,ft(le),me,[ke].concat(Je))},registerDocumentSemanticTokensProvider(le,me,ke){return at.registerDocumentSemanticTokensProvider(Oe,ft(le),me,ke)},registerDocumentRangeSemanticTokensProvider(le,me,ke){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(le),me,ke)},registerSignatureHelpProvider(le,me,ke,...Je){return typeof ke=="object"?at.registerSignatureHelpProvider(Oe,ft(le),me,ke):at.registerSignatureHelpProvider(Oe,ft(le),me,typeof ke=="undefined"?[]:[ke,...Je])},registerCompletionItemProvider(le,me,...ke){return at.registerCompletionItemProvider(Oe,ft(le),me,ke)},registerInlineCompletionItemProvider(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(le),me)},registerDocumentLinkProvider(le,me){return at.registerDocumentLinkProvider(Oe,ft(le),me)},registerColorProvider(le,me){return at.registerColorProvider(Oe,ft(le),me)},registerFoldingRangeProvider(le,me){return at.registerFoldingRangeProvider(Oe,ft(le),me)},registerSelectionRangeProvider(le,me){return at.registerSelectionRangeProvider(Oe,le,me)},registerCallHierarchyProvider(le,me){return at.registerCallHierarchyProvider(Oe,le,me)},registerTypeHierarchyProvider(le,me){return at.registerTypeHierarchyProvider(Oe,le,me)},setLanguageConfiguration:(le,me)=>at.setLanguageConfiguration(Oe,le,me),getTokenInformationAtPosition(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"tokenInformation"),Xt.tokenAtPosition(le,me)},registerInlayHintsProvider(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"inlayHints"),at.registerInlayHintsProvider(Oe,le,me)},createLanguageStatusItem(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"languageStatus"),Xt.createLanguageStatusItem(Oe,le,me)}},Oi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(le,me,ke){const Je=await(S.URI.isUri(le)?Promise.resolve(bi.openTextDocument(le)):Promise.resolve(le));return Tt.showTextDocument(Je,me,ke)},createTextEditorDecorationType(le){return Tt.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,me,ke){return Tt.onDidChangeActiveTextEditor(le,me,ke)},onDidChangeVisibleTextEditors(le,me,ke){return Tt.onDidChangeVisibleTextEditors(le,me,ke)},onDidChangeTextEditorSelection(le,me,ke){return Tt.onDidChangeTextEditorSelection(le,me,ke)},onDidChangeTextEditorOptions(le,me,ke){return Tt.onDidChangeTextEditorOptions(le,me,ke)},onDidChangeTextEditorVisibleRanges(le,me,ke){return Tt.onDidChangeTextEditorVisibleRanges(le,me,ke)},onDidChangeTextEditorViewColumn(le,me,ke){return Tt.onDidChangeTextEditorViewColumn(le,me,ke)},onDidCloseTerminal(le,me,ke){return ut.onDidCloseTerminal(le,me,ke)},onDidOpenTerminal(le,me,ke){return ut.onDidOpenTerminal(le,me,ke)},onDidChangeActiveTerminal(le,me,ke){return ut.onDidChangeActiveTerminal(le,me,ke)},onDidChangeTerminalDimensions(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"terminalDimensions"),ut.onDidChangeTerminalDimensions(le,me,ke)},onDidChangeTerminalState(le,me,ke){return ut.onDidChangeTerminalState(le,me,ke)},onDidWriteTerminalData(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(le,me,ke)},get state(){return Ge.state},onDidChangeWindowState(le,me,ke){return Ge.onDidChangeWindowState(le,me,ke)},showInformationMessage(le,...me){return di.showMessage(Oe,A.default.Info,le,me[0],me.slice(1))},showWarningMessage(le,...me){return di.showMessage(Oe,A.default.Warning,le,me[0],me.slice(1))},showErrorMessage(le,...me){return di.showMessage(Oe,A.default.Error,le,me[0],me.slice(1))},showQuickPick(le,me,ke){return jt.showQuickPick(le,me,ke)},showWorkspaceFolderPick(le){return jt.showWorkspaceFolderPick(le)},showInputBox(le,me){return jt.showInput(le,me)},showOpenDialog(le){return Qt.showOpenDialog(le)},showSaveDialog(le){return Qt.showSaveDialog(le)},createStatusBarItem(le,me,ke){let Je,bt,Dt;return typeof le=="string"?(Je=le,bt=me,Dt=ke):(bt=le,Dt=me),Ht.createStatusBarEntry(Oe,Je,bt,Dt)},setStatusBarMessage(le,me){return Ht.setStatusBarMessage(le,me)},withScmProgress(le){return xe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),gi.withProgress(Oe,{location:B.ProgressLocation.SourceControl},(me,ke)=>le({report(Je){}}))},withProgress(le,me){return gi.withProgress(Oe,le,me)},createOutputChannel(le){return Pt.createOutputChannel(le,Oe)},createWebviewPanel(le,me,ke,Je){return ci.createWebviewPanel(Oe,le,me,ke,Je)},createWebviewTextEditorInset(le,me,ke,Je){return(0,Ve.checkProposedApiEnabled)(Oe,"editorInsets"),_i.createWebviewEditorInset(le,me,ke,Je,Oe)},createTerminal(le,me,ke){return typeof le=="object"?"pty"in le?ut.createExtensionTerminal(le):ut.createTerminalFromOptions(le):ut.createTerminal(le,me,ke)},registerTerminalLinkProvider(le){return ut.registerLinkProvider(le)},registerTerminalProfileProvider(le,me){return ut.registerProfileProvider(Oe,le,me)},registerTreeDataProvider(le,me){return ii.registerTreeDataProvider(le,me,Oe)},createTreeView(le,me){return ii.createTreeView(le,me,Oe)},registerWebviewPanelSerializer:(le,me)=>ci.registerWebviewPanelSerializer(Oe,le,me),registerCustomEditorProvider:(le,me,ke={})=>yi.registerCustomEditorProvider(Oe,le,me,ke),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return jt.createQuickPick(Oe)},createInputBox(){return jt.createInputBox(Oe.identifier)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(le,me,ke){return pi.onDidChangeActiveColorTheme(le,me,ke)},registerWebviewViewProvider(le,me,ke){return Di.registerWebviewViewProvider(Oe,le,me,ke?.webviewOptions)},get activeNotebookEditor(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeActiveNotebookEditor(le,me,ke)},get visibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(le,me,ke)},onDidChangeNotebookEditorVisibleRanges(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(le,me,ke)},showNotebookDocument(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.showNotebookDocument(le,me)},registerExternalUriOpener(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"externalUriOpener"),Ii.registerExternalUriOpener(Oe.identifier,le,me,ke)},get tabs(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.tabs},get activeTab(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,Ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),a.InlineCompletionController.get(le)}},bi={get rootPath(){return xe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return dt.getWorkspaceFolder(le)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(le){throw t.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,me,...ke)=>dt.updateWorkspaceFolders(Oe,le,me||0,...ke),onDidChangeWorkspaceFolders:function(le,me,ke){return dt.onDidChangeWorkspace(le,me,ke)},asRelativePath:(le,me)=>dt.getRelativePath(le,me),findFiles:(le,me,ke,Je)=>dt.findFiles(le,me,ke,Oe.identifier,Je),findTextInFiles:(le,me,ke,Je)=>{(0,Ve.checkProposedApiEnabled)(Oe,"findTextInFiles");let bt,Dt;return typeof me=="object"?(bt=me,Dt=ke):(bt={},Dt=me,Je=ke),dt.findTextInFiles(le,bt||{},Dt,Oe.identifier,Je)},saveAll:le=>dt.saveAll(le),applyEdit(le){return Pi.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,me,ke,Je)=>Vt.createFileSystemWatcher(dt,Oe,le,me,ke,Je),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let me;const ke=le;if(typeof le=="string")me=Promise.resolve(S.URI.file(le));else if(S.URI.isUri(le))me=Promise.resolve(le);else if(!ke||typeof ke=="object")me=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(Je=>Ct.ensureDocumentData(Je).then(bt=>bt.document))},onDidOpenTextDocument:(le,me,ke)=>Ct.onDidAddDocument(le,me,ke),onDidCloseTextDocument:(le,me,ke)=>Ct.onDidRemoveDocument(le,me,ke),onDidChangeTextDocument:(le,me,ke)=>Ct.onDidChangeDocument(le,me,ke),onDidSaveTextDocument:(le,me,ke)=>Ct.onDidSaveDocument(le,me,ke),onWillSaveTextDocument:(le,me,ke)=>xt.getOnWillSaveTextDocumentEvent(Oe)(le,me,ke),get notebookDocuments(){return gt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,me){let ke;if(S.URI.isUri(le))ke=le,await gt.openNotebookDocument(le);else if(typeof le=="string")ke=S.URI.revive(await gt.createNotebookDocument({viewType:le,content:me}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(le,me,ke,Je){return gt.registerNotebookSerializer(Oe,le,me,ke,(0,Ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)},registerNotebookContentProvider:(le,me,ke,Je)=>((0,Ve.checkProposedApiEnabled)(Oe,"notebookContentProvider"),gt.registerNotebookContentProvider(Oe,le,me,ke,(0,Ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)),onDidChangeConfiguration:(le,me,ke)=>Zt.onDidChangeConfiguration(le,me,ke),getConfiguration(le,me){return me=arguments.length===1?void 0:me,Zt.getConfiguration(le,me,Oe)},registerTextDocumentContentProvider(le,me){return Bt.registerTextDocumentContentProvider(le,me)},registerTaskProvider:(le,me)=>(xe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),ht.registerTaskProvider(Oe,le,me)),registerFileSystemProvider(le,me,ke){return(0,mt.combinedDisposable)(ai.registerFileSystemProvider(Oe,le,me,ke),It.addFileSystemProvider(le,me))},get fs(){return It.value},registerFileSearchProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,me)),registerTextSearchProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,me)),registerRemoteAuthorityResolver:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),kt.registerRemoteAuthorityResolver(le,me)),registerResourceLabelFormatter:le=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,me,ke)=>Vt.onDidCreateFile(le,me,ke),onDidDeleteFiles:(le,me,ke)=>Vt.onDidDeleteFile(le,me,ke),onDidRenameFiles:(le,me,ke)=>Vt.onDidRenameFile(le,me,ke),onWillCreateFiles:(le,me,ke)=>Vt.getOnWillCreateFileEvent(Oe)(le,me,ke),onWillDeleteFiles:(le,me,ke)=>Vt.getOnWillDeleteFileEvent(Oe)(le,me,ke),onWillRenameFiles:(le,me,ke)=>Vt.getOnWillRenameFileEvent(Oe)(le,me,ke),openTunnel:le=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.openTunnel(Oe,le).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(le,me,ke)=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.onDidChangeTunnels(le,me,ke)),registerPortAttributesProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"portsAttributes"),Le.registerPortsAttributesProvider(le,me)),registerTimelineProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"timeline"),li.registerTimelineProvider(le,me,Oe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:le=>((0,Ve.checkProposedApiEnabled)(Oe,"workspaceTrust"),dt.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,me,ke)=>dt.onDidGrantWorkspaceTrust(le,me,ke)},Fi={get inputBox(){return xe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(le,me,ke){return ni.createSourceControl(Oe,le,me,ke)}},Ni={createCommentController(le,me){return Si.createCommentController(Oe,le,me)}},Mi={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(le,me,ke){return wt.onDidStartDebugSession(le,me,ke)},onDidTerminateDebugSession(le,me,ke){return wt.onDidTerminateDebugSession(le,me,ke)},onDidChangeActiveDebugSession(le,me,ke){return wt.onDidChangeActiveDebugSession(le,me,ke)},onDidReceiveDebugSessionCustomEvent(le,me,ke){return wt.onDidReceiveDebugSessionCustomEvent(le,me,ke)},onDidChangeBreakpoints(le,me,ke){return wt.onDidChangeBreakpoints(le,me,ke)},registerDebugConfigurationProvider(le,me,ke){return wt.registerDebugConfigurationProvider(le,me,ke||ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,me){return wt.registerDebugAdapterDescriptorFactory(Oe,le,me)},registerDebugAdapterTrackerFactory(le,me){return wt.registerDebugAdapterTrackerFactory(le,me)},startDebugging(le,me,ke){return!ke||typeof ke=="object"&&"configuration"in ke?wt.startDebugging(le,me,{parentSession:ke}):wt.startDebugging(le,me,ke||{})},stopDebugging(le){return wt.stopDebugging(le)},addBreakpoints(le){return wt.addBreakpoints(le)},removeBreakpoints(le){return wt.removeBreakpoints(le)},asDebugSourceUri(le,me){return wt.asDebugSourceUri(le,me)}},Ui={registerTaskProvider:(le,me)=>ht.registerTaskProvider(Oe,le,me),fetchTasks:le=>ht.fetchTasks(le),executeTask:le=>ht.executeTask(Oe,le),get taskExecutions(){return ht.taskExecutions},onDidStartTask:(le,me,ke)=>ht.onDidStartTask(le,me,ke),onDidEndTask:(le,me,ke)=>ht.onDidEndTask(le,me,ke),onDidStartTaskProcess:(le,me,ke)=>ht.onDidStartTaskProcess(le,me,ke),onDidEndTaskProcess:(le,me,ke)=>ht.onDidEndTaskProcess(le,me,ke)},Bi={createNotebookController(le,me,ke,Je,bt){return ti.createNotebookController(Oe,le,me,ke,Je,(0,Ve.isProposedApiEnabled)(Oe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(le,me)=>gt.registerNotebookCellStatusBarItemProvider(Oe,le,me),get onDidSaveNotebookDocument(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return oi.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(le,me,ke)},onDidChangeNotebookCells(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeNotebookCells(le,me,ke)},onDidChangeNotebookCellExecutionState(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(le,me,ke)},onDidChangeCellOutputs(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeCellOutputs(le,me,ke)},onDidChangeCellMetadata(le,me,ke){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeCellMetadata(le,me,ke)},createConcatTextDocument(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(gt,Ct,le,me)}};return{version:lt.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:vi,extensions:Li,languages:hi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:Oi,workspace:bi,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:R.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:E.UIKind,Uri:S.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(we[282],be([1,0,283,292,293,2,294]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(I,p,E,v,d,w){const C=w.environment.useHostProxy,P=typeof C=="boolean"?C:!w.remote.isRemote,l=(0,S.createProxyResolver)({resolveProxy:f=>I.resolveProxy(f),getHttpProxySetting:()=>p.getConfiguration("http").get("proxy"),log:(f,s,...b)=>{switch(f){case S.LogLevel.Trace:v.trace(s,...b);break;case S.LogLevel.Debug:v.debug(s,...b);break;case S.LogLevel.Info:v.info(s,...b);break;case S.LogLevel.Warning:v.warn(s,...b);break;case S.LogLevel.Error:v.error(s,...b);break;case S.LogLevel.Critical:v.critical(s,...b);break;case S.LogLevel.Off:break;default:o(f,s,b);break}function o(i,r,...n){v.error("Unknown log level",i),v.error(r,...n)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:P,env:process.env}),c=_(p,l);return F(E,c)}e.connectProxyResolver=D;function _(I,p){const E={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(d=>{E.config=I.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(d=>{v.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},h,(0,S.createHttpPatch)(h,p,{config:"off"},v,!0)),on:Object.assign({},h,(0,S.createHttpPatch)(h,p,{config:"on"},v,!0)),override:Object.assign({},h,(0,S.createHttpPatch)(h,p,{config:"override"},v,!0)),onRequest:Object.assign({},h,(0,S.createHttpPatch)(h,p,E,v,!0)),default:Object.assign(h,(0,S.createHttpPatch)(h,p,E,v,!1))},https:{off:Object.assign({},t,(0,S.createHttpPatch)(t,p,{config:"off"},v,!0)),on:Object.assign({},t,(0,S.createHttpPatch)(t,p,{config:"on"},v,!0)),override:Object.assign({},t,(0,S.createHttpPatch)(t,p,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,S.createHttpPatch)(t,p,E,v,!0)),default:Object.assign(t,(0,S.createHttpPatch)(t,p,E,v,!1))},tls:Object.assign(k,(0,S.createTlsPatch)(k))}}const R=new Map;function F(I,p){return I.getExtensionPathIndex().then(E=>{const v=te.__$__nodeRequire("module"),d=v._load;v._load=function(C,P,l){if(C==="tls")return p.tls;if(C!=="http"&&C!=="https")return d.apply(this,arguments);const c=p[C],f=E.findSubstr(A.URI.file(P.filename));let s=R.get(f);if(s||R.set(f,s={}),!s[C]){let b=c.default;s[C]={...b}}return s[C]}})}}),define(we[139],be([1,0,38,295,102,17,74,32,9,8,2,31,69,296,276,88]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class C{constructor(u){this.outputChannel=u}provideTextSearchResults(u,m,T,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...m,folder:m.folder.toString()})}`),new Promise((L,y)=>{O.onCancellationRequested(()=>X());const H=b(u,m),M=m.folder.fsPath,z=H.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.outputChannel.appendLine(`${w} ${z}
 - cwd: ${M}`);let x=h.spawn(w,H,{cwd:M});x.on("error",Z=>{console.error(Z),this.outputChannel.appendLine("Error: "+(Z&&Z.message)),y((0,I.serializeSearchError)(new I.SearchError(Z&&Z.message,I.SearchErrorCode.rgProcessError)))});let K=!1;const B=new c(m.maxResults,M,m.previewOptions);B.on("result",Z=>{K=!0,ee="",T.report(Z)});let G=!1;const X=()=>{G=!0,x&&x.kill(),B&&B.cancel()};let q=!1;B.on("hitLimit",()=>{q=!0,X()});let ee="";x.stdout.on("data",Z=>{B.handleData(Z),K||(ee+=Z)});let ae=!1;x.stdout.once("data",()=>ae=!0);let ue="";x.stderr.on("data",Z=>{const Y=Z.toString();this.outputChannel.appendLine(Y),ue+=Y}),x.on("close",()=>{if(this.outputChannel.appendLine(ae?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(K?"Got result from parser":"No result from parser"),ee&&this.outputChannel.appendLine(`Got data without result: ${ee}`),this.outputChannel.appendLine(""),G)L({limitHit:q});else{B.flush(),x=null;let Z;ue&&!ae&&(Z=P(ue))?y((0,I.serializeSearchError)(new I.SearchError(Z.message,Z.code))):L({limitHit:q})}})})}}e.RipgrepTextSearchEngine=C;function P(g){const u=g.split(`
`),m=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new I.SearchError(l(u),I.SearchErrorCode.regexParseError);const T=m.match(/grep config error: unknown encoding: (.*)/);if(T)return new I.SearchError(`Unknown encoding: ${T[1]}`,I.SearchErrorCode.unknownEncoding);if(m.startsWith("error parsing glob"))return new I.SearchError(m.charAt(0).toUpperCase()+m.substr(1),I.SearchErrorCode.globParseError);if(m.startsWith("the literal"))return new I.SearchError(m.charAt(0).toUpperCase()+m.substr(1),I.SearchErrorCode.invalidLiteral);if(m.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(m,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function l(g){const u=["Regex parse error"],m=g.filter(T=>T.startsWith("PCRE2:"));if(m.length>=1){const T=m[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const O=T.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=l;class c extends t.EventEmitter{constructor(u,m,T){super();this.maxResults=u,this.rootFolder=m,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,m){return super.on(u,m),this}handleData(u){if(this.isDone)return;const m=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(m)}handleDecodedData(u){let m=u.indexOf(`
`);const T=this.remainder+u;if(m>=0)m+=this.remainder.length;else{this.remainder=T;return}let O=0;for(;m>=0;)this.handleLine(T.substring(O,m).trim()),O=m+1,m=T.indexOf(`
`,O);this.remainder=T.substring(O)}handleLine(u){if(this.isDone||!u)return;let m;try{m=JSON.parse(u)}catch{throw new Error(`malformed line from rg: ${u}`)}if(m.type==="match"){const T=f(m.data.path),O=F.URI.file(_.join(this.rootFolder,T)),L=this.createTextSearchMatch(m.data,O);this.onResult(L),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(m.type==="context"){const T=f(m.data.path),O=F.URI.file(_.join(this.rootFolder,T));this.createTextSearchContext(m.data,O).forEach(y=>this.onResult(y))}}createTextSearchMatch(u,m){const T=u.line_number-1,O=f(u.lines),L=Buffer.from(O);let y=0,H=0,M=T;u.submatches.length===0&&u.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const z=(0,A.coalesce)(u.submatches.map((x,K)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=f(x.match),G=L.slice(y,x.start).toString().length,X=H+G,q=s(B),ee=M,ae=q.numLines+ee,ue=q.numLines>0?q.lastLineLength:q.lastLineLength+X;return y=x.end,H=ue,M=ae,new p.Range(ee,X,ae,ue)}));return(0,d.createTextSearchResult)(m,O,z,this.previewOptions)}createTextSearchContext(u,m){const T=f(u.lines),O=u.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((L,y)=>({text:L,uri:m,lineNumber:O+y}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=c;function f(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function s(g){const u=/\n/g;let m=0,T=-1,O;for(;O=u.exec(g);)m++,T=O.index;const L=T>=0?g.length-T-1:g.length;return{numLines:m,lastLineLength:L}}function b(g,u){const m=["--hidden"];m.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:O}=(0,S.groupBy)(u.includes,y=>y.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const y=new Set;O.forEach(H=>{y.add(H)}),m.push("-g","!*"),y.forEach(H=>{o(H).map(d.anchorGlob).forEach(M=>{m.push("-g",M)})})}T&&T.length&&T.forEach(y=>{m.push("-g",y)}),u.excludes.map(d.anchorGlob).forEach(y=>m.push("-g",`!${y}`)),u.maxFileSize&&m.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?u.useParentIgnoreFiles||m.push("--no-ignore-parent"):m.push("--no-ignore"),u.followSymlinks&&m.push("--follow"),u.encoding&&u.encoding!=="utf8"&&m.push("--encoding",u.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,R.escapeRegExpCharacters)(g.pattern),g.isRegExp=!0),u.usePCRE2&&m.push("--pcre2"),m.push("--crlf"),g.isRegExp&&(g.pattern=i(g.pattern),m.push("--engine","auto"));let L;if(g.isWordMatch){const H=(0,R.createRegExp)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");m.push("--regexp",H)}else if(g.isRegExp){let y=n(g.pattern);y=a(y),m.push("--regexp",y)}else L=g.pattern,m.push("--fixed-strings");return m.push("--no-config"),u.useGlobalIgnoreFiles||m.push("--no-ignore-global"),m.push("--json"),g.isMultiline&&m.push("--multiline"),u.beforeContext&&m.push("--before-context",u.beforeContext+""),u.afterContext&&m.push("--after-context",u.afterContext+""),m.push("--"),L&&m.push(L),m.push("."),m}function o(g){const u=(0,D.splitGlobAware)(g,"/");return u.map((m,T)=>u.slice(0,T+1).join("/"))}e.spreadGlobComponents=o;function i(g){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(u);)g=g.replace(u,"$1\\x{$2}");const m=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(m);)g=g.replace(m,"$1\\x{$2}");return g}e.unicodeEscapesToPCRE2=i;const r=g=>g.type==="Assertion"&&g.kind==="lookbehind";function n(g){let u;try{u=new E.RegExpParser().parsePattern(g)}catch{return g}let m="",T=0;const O=(H,M,z)=>{m+=g.slice(T,H)+z,T=M},L=[];return new E.RegExpVisitor({onCharacterEnter(H){if(H.raw!=="\\n")return;const M=L[0];if(!M)O(H.start,H.end,"\\r?\\n");else if(!L.some(r))if(M.type==="CharacterClass")if(M.negate){const z=g.slice(M.start+2,H.start)+g.slice(H.end,M.end-1);M.parent?.type==="Quantifier"?O(M.start,M.end,z?`[^${z}]`:"."):O(M.start,M.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=g.slice(M.start+1,H.start)+g.slice(H.end,M.end-1);O(M.start,M.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else M.type==="Quantifier"&&O(H.start,H.end,"(?:\\r?\\n)")},onQuantifierEnter(H){L.unshift(H)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(H){L.unshift(H)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(H){L.unshift(H)},onCharacterClassLeave(){L.shift()},onAssertionEnter(H){r(H)&&L.push(H)},onAssertionLeave(H){L[0]===H&&L.shift()}}).visit(u),m+=g.slice(T),m}e.fixRegexNewline=n;function a(g){return g.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(we[284],be([1,0,21,139,118,10]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class S{constructor(R){this.outputChannel=R,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(R,F,I,p){const E=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===A.Schemas.userData){const v={...F,folder:F.folder.with({scheme:A.Schemas.file})},d=new k.Progress(w=>I.report({...w,uri:w.uri.with({scheme:F.folder.scheme})}));return this.withToken(p,w=>E.provideTextSearchResults(R,v,d,w))}else return this.withToken(p,v=>E.provideTextSearchResults(R,F,I,v))}async withToken(R,F){const I=D(R);this.inProgress.add(I);const p=await F(I.token);return this.inProgress.delete(I),p}dispose(){this.inProgress.forEach(R=>R.cancel())}}e.RipgrepSearchProvider=S;function D(_){const R=new h.CancellationTokenSource;return _.onCancellationRequested(()=>R.cancel()),R}}),define(we[285],be([1,0,28,139,138]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(_){this.query=_}search(_,R,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(E){F({message:E})}},p=new k.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(I),h);return new Promise((E,v)=>p.search(d=>{R(d.map(S))},_).then(d=>E({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function S(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((_,R)=>{if(R.ranges){const F=R;return _+(Array.isArray(F.ranges)?F.ranges.length:1)}else return _+1},0)}}}),define(we[286],be([1,0,17,13,16,3,98,9,46,2,42,31,277,285]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let f;const s=C(c),b=new A.Emitter({onFirstListenerDidAdd:()=>{f=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(p.Engine,s,i=>b.fire(i),o)),f.then(o=>b.fire(o),o=>b.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return b.event}textSearch(c){let f;const s=C(c),b=new A.Emitter({onFirstListenerDidAdd:()=>{f=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(s,i=>b.fire(i),o)),f.then(o=>b.fire(o),o=>b.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return b.event}ripgrepTextSearch(c,f,s){return c.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(c).search(s,f,f)}doFileSearch(c,f,s){return this.doFileSearchWithEngine(p.Engine,c,f,s)}doFileSearchWithEngine(c,f,s,b,o=v.BATCH_SIZE){let i=0;const r=a=>{Array.isArray(a)?(i+=a.length,s(a.map(g=>this.rawMatchToSearchItem(g)))):a.relativePath?(i++,s(this.rawMatchToSearchItem(a))):s(a)};if(f.sortByScore){let a=this.trySortedSearchFromCache(f,r,b);if(!a){const g=f.maxResults?Object.assign({},f,{maxResults:null}):f,u=new c(g);a=this.doSortedSearch(u,f,s,r,b)}return new Promise((g,u)=>{a.then(([m,T])=>{const O=T.map(L=>this.rawMatchToSearchItem(L));this.sendProgress(O,s,o),g(m)},u)})}const n=new c(f);return this.doSearch(n,r,o,b).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,D.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,f,s,b,o){const i=new A.Emitter;let r=(0,t.createCancelablePromise)(a=>{let g=[];const u=m=>{Array.isArray(m)?g=m:(b(m),i.fire(m))};return this.doSearch(c,u,-1,a).then(m=>[m,g])}),n;if(f.cacheKey){n=this.getOrCreateCache(f.cacheKey);const a={promise:r,event:i.event,resolved:!1};n.resultsToSearchCache[f.filePattern||""]=a,r.then(()=>{a.resolved=!0},g=>{delete n.resultsToSearchCache[f.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([a,g])=>{const u=n?n.scorerCache:Object.create(null),m=(typeof f.maxResults!="number"||f.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(f,g,u,o).then(T=>{const O=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:T.length},messages:a.messages,limitHit:a.limitHit||typeof f.maxResults=="number"&&g.length>f.maxResults},T]})})}getOrCreateCache(c){const f=this.caches[c];return f||(this.caches[c]=new d)}trySortedSearchFromCache(c,f,s){const b=c.cacheKey&&this.caches[c.cacheKey];if(!b)return;const o=this.getResultsFromCache(b,c.filePattern||"",f,s);if(o)return o.then(([i,r,n])=>{const a=_.StopWatch.create(!1);return this.sortResults(c,r,b.scorerCache,s).then(g=>{const u=a.elapsed(),m={fromCache:!0,detailStats:n,type:this.processType,resultCount:r.length,sortingTime:u};return[{type:"success",limitHit:i.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:m},g]})})}sortResults(c,f,s,b){const o=(0,S.prepareQuery)(c.filePattern||""),i=(n,a)=>(0,S.compareItemsByFuzzyScore)(n,a,o,!0,w,s),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return h.topAsync(f,i,r,1e4,b)}sendProgress(c,f,s){if(s&&s>0)for(let b=0;b<c.length;b+=s)f(c.slice(b,b+s));else f(c)}getResultsFromCache(c,f,s,b){const o=_.StopWatch.create(!1),i=f.indexOf(D.sep)>=0;let r;for(const u in c.resultsToSearchCache)if(f.startsWith(u)){if(i&&u.indexOf(D.sep)<0&&u!=="")continue;const m=c.resultsToSearchCache[u];r={promise:this.preventCancellation(m.promise),event:m.event,resolved:m.resolved};break}if(!r)return null;const n=o.elapsed(),a=_.StopWatch.create(!1),g=r.event(s);return b&&b.onCancellationRequested(()=>{g.dispose()}),r.promise.then(([u,m])=>{if(b&&b.isCancellationRequested)throw(0,k.canceled)();const T=[],O=(0,S.prepareQuery)(f).normalizedLowercase;for(const L of m)!(0,I.isFilePatternMatch)(L,O)||T.push(L);return[u,T,{cacheWasResolved:r.resolved,cacheLookupTime:n,cacheFilterTime:a.elapsed(),cacheEntryCount:m.length}]})}doSearch(c,f,s,b){return new Promise((o,i)=>{let r=[];b&&b.onCancellationRequested(()=>c.cancel()),c.search(n=>{n&&(s?(r.push(n),s>0&&r.length>=s&&(f(r),r=[])):f(n))},n=>{f(n)},(n,a)=>{r.length&&f(r),n?i(n):o(a)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,s){return c.then(f,s)}catch(f){return this.then(void 0,f)}finally(f){return c.finally(f)}}}}e.SearchService=v,v.BATCH_SIZE=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(l){return(0,D.basename)(l.relativePath)}getItemDescription(l){return(0,D.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function C(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(P),extraFileResources:l.extraFileResources&&l.extraFileResources.map(c=>R.URI.revive(c))}}function P(l){return{...l,folder:R.URI.revive(l.folder)}}}),define(we[287],be([1,0,6,10,2,28,11,26,14,72,64,31,286,284,88,138]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends R.ExtHostSearch{constructor(P,l,c,f){super(P,c,f);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new v.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new E.RipgrepSearchProvider(s)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const P=new v.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new E.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(t.Schemas.file,new p.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(P,l){const c=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(P)),(0,h.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(P,l,c,f){const s=(0,R.reviveQuery)(c);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,l,s,f):super.$provideFileSearchResults(P,l,c,f)}doInternalFileSearch(P,l,c,f){const s=b=>{if((0,I.isSerializedFileMatch)(b)&&(b=[b]),Array.isArray(b)){this._proxy.$handleFileMatch(P,l,b.map(o=>k.URI.file(o.path)));return}b.message&&this._logService.debug("ExtHostSearch",b.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,s,f)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,l){return new d.NativeTextSearchManager(P,l,void 0,"textSearchProvider")}};w=Be([Fe(0,_.IExtHostRpcService),Fe(1,D.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,S.ILogService)],w),e.NativeExtHostSearch=w}),define(we[140],be([1,0,297,127,60,22,16,3,6,9,12,33,104,105,298]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(m,T=""){this.debugLabel=T,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,S.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(m,T){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const T=O=>{this.traceSocketEvent("read",O),m(A.VSBuffer.wrap(O))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(m){const T=O=>{this.traceSocketEvent("close",{hadError:O}),m({type:0,hadError:O,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(m){const T=()=>{this.traceSocketEvent("nodeEndReceived"),m()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(m){if(!this.socket.destroyed)try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,S.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,S.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=d;var w;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var C;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(C||(C={}));class P extends _.Disposable{constructor(m,T,O,L){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:O?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new l(this,T,O,L,this._onData,(y,H)=>this._write(y,H))),this._register(this._flowManager.onError(y=>{console.error(y),(0,S.onUnexpectedError)(y),this._onClose.fire({type:0,hadError:!0,error:y})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(y=>this._acceptChunk(y))),this._register(this.socket.onClose(y=>this._onClose.fire(y)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(m,T){this.socket.traceSocketEvent(m,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._flowManager.writeMessage(m)}_write(m,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let O=2;m.byteLength<126?O+=0:m.byteLength<2**16?O+=2:O+=8;const L=A.VSBuffer.alloc(O);if(T?L.writeUInt8(194,0):L.writeUInt8(130,0),m.byteLength<126)L.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){L.writeUInt8(126,1);let y=1;L.writeUInt8(m.byteLength>>>8&255,++y),L.writeUInt8(m.byteLength>>>0&255,++y)}else{L.writeUInt8(127,1);let y=1;L.writeUInt8(0,++y),L.writeUInt8(0,++y),L.writeUInt8(0,++y),L.writeUInt8(0,++y),L.writeUInt8(m.byteLength>>>24&255,++y),L.writeUInt8(m.byteLength>>>16&255,++y),L.writeUInt8(m.byteLength>>>8&255,++y),L.writeUInt8(m.byteLength>>>0&255,++y)}this.socket.write(A.VSBuffer.concat([L,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),O=T.readUInt8(0),L=(O&128)>>>7,y=(O&64)>>>6,H=T.readUInt8(1),M=(H&128)>>>7,z=H&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(y)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),O=T.readUInt8(1),L=(O&128)>>>7;let y=O&127,H=1;y===126?y=T.readUInt8(++H)*2**8+T.readUInt8(++H):y===127&&(y=T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*2**24+T.readUInt8(++H)*2**16+T.readUInt8(++H)*2**8+T.readUInt8(++H));let M=0;L&&(M=T.readUInt8(++H)*2**24+T.readUInt8(++H)*2**16+T.readUInt8(++H)*2**8+T.readUInt8(++H)),this._state.state=3,this._state.readLen=y,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),s(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class l extends _.Disposable{constructor(m,T,O,L,y,H){super();this._tracer=m,this._onData=y,this._writeFn=H,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new c(this._tracer,L,O,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(m){this._writeQueue.push(m),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const m=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,m);this._writeFn(T,!0)}else this._writeFn(m,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(m,T){return new Promise((O,L)=>{m.write(T),m.flush(y=>O(y))})}acceptFrame(m,T,O){this._readQueue.push({data:m,isCompressed:T,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const m=this._readQueue.shift();if(this._zlibInflateStream&&m.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,m.data,m.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(m.data)}this._isProcessingReadQueue=!1}}_inflateFrame(m,T,O){return new Promise((L,y)=>{m.write(T),O&&m.write(A.VSBuffer.fromByteArray([0,0,255,255])),m.flush(H=>L(H))})}}class c extends _.Disposable{constructor(m,T,O,L){super();this._tracer=m,this._recordInflateBytes=T,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v.createInflateRaw(L),this._zlibInflate.on("error",y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibInflate.on("data",y=>{this._tracer.traceSocketEvent("zlibInflateData",y),this._pendingInflateData.push(A.VSBuffer.wrap(y))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(m){this._recordInflateBytes&&this._recordedInflateBytes.push(m.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",m),this._zlibInflate.write(m.buffer)}flush(m){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,m(T)})}}class f extends _.Disposable{constructor(m,T){super();this._tracer=m,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(m){this._tracer.traceSocketEvent("zlibDeflateWrite",m.buffer),this._zlibDeflate.write(m.buffer)}flush(m){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),m(T)})}}function s(u,m){if(m===0)return;let T=u.byteLength>>>2;for(let z=0;z<T;z++){const x=u.readUInt32BE(z*4);u.writeUInt32BE(x^m,z*4)}let O=T*4,L=u.byteLength-O;const y=m>>>24&255,H=m>>>16&255,M=m>>>8&255;L>=1&&u.writeUInt8(u.readUInt8(O)^y,O),L>=2&&u.writeUInt8(u.readUInt8(O+1)^H,O+1),L>=3&&u.writeUInt8(u.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const b={[2]:107,[1]:103};function o(){const u=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):m=(0,R.join)((0,k.tmpdir)(),`vscode-ipc-${u}.sock`),r(m),m}e.createRandomIPCHandle=o;function i(u,m,T){const O=(0,h.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${T}-${m}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${T}-${m}.sock`):L=(0,R.join)(u,`${T}-${m}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(u){const m=b[F.platform];typeof m=="number"&&u.length>=m&&console.warn(`WARNING: IPC handle "${u}" is longer than ${m} chars, try a shorter --user-data-dir`)}class n extends p.IPCServer{constructor(m){super(n.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const T=D.Event.fromNodeEventEmitter(m,"connection");return D.Event.map(T,O=>({protocol:new E.Protocol(new d(O,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function a(u){return new Promise((m,T)=>{const O=(0,t.createServer)();O.on("error",T),O.listen(u,()=>{O.removeListener("error",T),m(new n(O))})})}e.serve=a;function g(u,m){return new Promise((T,O)=>{const L=(0,t.createConnection)(u,()=>{L.removeListener("error",O),T(E.Client.fromSocket(new d(L,`ipc-client${m}`),m))});L.once("error",O)})}e.connect=g}),define(we[288],be([1,0,140,283,59,39,2,11,43]),function(te,e,h,t,k,A,S,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class R{constructor(p,E,v){this._commands=p,this.logService=E,this._ipcHandlePath=v,this._server=t.createServer((d,w)=>this.onRequest(d,w)),this.setup().catch(d=>(E.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,E){const v=(w,C)=>{E.writeHead(w,{"content-type":"application/json"}),E.end(JSON.stringify(C),P=>P&&this.logService.error(P))},d=[];p.setEncoding("utf8"),p.on("data",w=>d.push(w)),p.on("end",async()=>{try{const w=JSON.parse(d.join(""));let C;switch(w.type){case"open":C=await this.open(w);break;case"openExternal":C=await this.openExternal(w);break;case"status":C=await this.getStatus(w);break;case"extensionManagement":C=await this.manageExtensions(w);break;default:v(404,`Unknown message type: ${w.type}`);break}v(200,C)}catch(w){const C=w instanceof Error?w.message:JSON.stringify(w);v(500,C),this.logService.error("Error while processing pipe request",w)}})}async open(p){const{fileURIs:E,folderURIs:v,forceNewWindow:d,diffMode:w,addMode:C,forceReuseWindow:P,gotoLineMode:l,waitMarkerFilePath:c,remoteAuthority:f}=p,s=[];if(Array.isArray(v))for(const r of v)try{s.push({folderUri:S.URI.parse(r)})}catch{}if(Array.isArray(E))for(const r of E)try{(0,_.hasWorkspaceFileExtension)(r)?s.push({workspaceUri:S.URI.parse(r)}):s.push({fileUri:S.URI.parse(r)})}catch{}const b=c?S.URI.file(c):void 0,i={forceNewWindow:d,diffMode:w,addMode:C,gotoLineMode:l,forceReuseWindow:P,preferNewWindow:!P&&!b&&!C,waitMarkerFileURI:b,remoteAuthority:f};return this._commands.executeCommand("_remoteCLI.windowOpen",s,i),""}async openExternal(p){for(const E of p.uris){const v=S.URI.parse(E),d=v.scheme==="file"?v:E;await this._commands.executeCommand("_remoteCLI.openExternal",d)}}async manageExtensions(p){const E=d=>d?.map(w=>/\.vsix$/i.test(w)?S.URI.parse(w):w),v={list:p.list,install:E(p.install),uninstall:E(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",v)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=R;let F=class extends R{constructor(p,E){super(p,E,(0,h.createRandomIPCHandle)())}};F=Be([Fe(0,A.IExtHostCommands),Fe(1,D.ILogService)],F),e.CLIServer=F}),define(we[289],be([1,0,71,281,270,5,282,40,259,2,10,7,288,103]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends k.RequireInterceptor{_installInterceptor(){const C=this,P=te.__$__nodeRequire("module"),l=P._load;P._load=function(b,o,i){return b=f(b),C._factories.has(b)?C._factories.get(b).load(b,R.URI.file((0,E.realpathSync)(o.filename)),r=>l.apply(this,[r,o,i])):l.apply(this,arguments)};const c=P._resolveLookupPaths;P._resolveLookupPaths=(s,b)=>c.call(this,f(s),b);const f=s=>{for(let b of C._alternatives){let o=b(s);if(o){s=o;break}}return s}}}class d extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const C=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(p.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}await this._instaService.createInstance(v,C,this._registry).install(),h.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,S.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),h.mark("code/extHost/didInitProxyResolver");const c=process.send,f=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...s)=>s.length===0||!s[0]||s[0].type!=="__$console"?c.apply(process,s):(f.$logExtensionHostMessage(s[0]),!1)}_getEntryPoint(C){return C.main}_loadCommonJSModule(C,P,l){if(P.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let c=null;l.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{C&&h.mark(`code/extHost/willLoadExtensionCode/${C.value}`),c=te.__$__nodeRequire(P.fsPath)}catch(f){return Promise.reject(f)}finally{C&&h.mark(`code/extHost/didLoadExtensionCode/${C.value}`),l.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(C){if(!!this._initData.remote.isRemote)for(const P in C){const l=C[P];l===null?delete process.env[P]:process.env[P]=l}}}e.ExtHostExtensionService=d}),define(we[290],be([1,0,61,262,273,272,287,289,263,54,40,72,70,34,51,67,261,260,11]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(F.IExtHostExtensionService,D.ExtHostExtensionService),(0,h.registerSingleton)(P.ILoggerService,C.ExtHostLoggerService),(0,h.registerSingleton)(d.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,h.registerSingleton)(R.IExtHostDebugService,A.ExtHostDebugService),(0,h.registerSingleton)(I.IExtHostSearch,S.NativeExtHostSearch),(0,h.registerSingleton)(p.IExtHostTask,k.ExtHostTask),(0,h.registerSingleton)(E.IExtHostTerminalService,t.ExtHostTerminalService),(0,h.registerSingleton)(v.IExtHostTunnelService,_.ExtHostTunnelService)}),define(we[299],be([1,0,127,300,71,16,105,140,191,132,271,22,28,103,13,113,206,274,290]),function(te,e,h,t,k,A,S,D,_,R,F,I,p,E,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const C=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=te.__$__nodeRequire("module"),r=i._load;i._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const P=process.exit.bind(process);function l(i){process.exit=function(r){if(i)P(r);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(i){P()};function f(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let n=null,a=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const g=108e5,u=3e5,m=new v.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (1)"),g),T=new v.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (2)"),u);process.on("message",(L,y)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){y.setNoDelay(!0);const H=I.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let M;if(L.skipWebSocketFrames)M=new D.NodeSocket(y,"extHost-socket");else{const z=I.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));M=new D.WebSocketNodeSocket(new D.NodeSocket(y,"extHost-socket"),L.permessageDeflate,z,!1)}n?(m.cancel(),T.cancel(),n.beginAcceptReconnection(M,H),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(a),n=new S.PersistentProtocol(M,H),n.sendResume(),n.onDidDispose(()=>c("renderer disconnected")),i(n),n.onSocketClose(()=>{m.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;m.isScheduled()&&T.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,n)=>{const a=h.createConnection(i,()=>{a.removeListener("error",n),r(new S.PersistentProtocol(new D.NodeSocket(a,"extHost-renderer")))});a.once("error",n),a.on("close",()=>{c("renderer closed the socket")})})}}async function s(){const i=await f();return new class{constructor(){this._onMessage=new S.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{(0,R.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function b(i){return new Promise(r=>{const n=i.onMessage(a=>{n.dispose();const g=JSON.parse(a.toString()),u=g.commit,m=_.default.commit;u&&m&&u!==m&&P(55);let T=0;setInterval(function(){try{process.kill(g.parentPid,0),T=0}catch(L){L&&L.code==="EPERM"?(T++,T>=3&&c(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):c(`parent process ${g.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let O;try{O=te.__$__nodeRequire("native-watchdog"),O.start(g.parentPid)}catch(L){(0,A.onUnexpectedError)(L)}i.send((0,R.createMessageOfType)(0)),r({protocol:i,initData:g})});i.send((0,R.createMessageOfType)(1))})}async function o(){const i=[];process.on("unhandledRejection",(T,O)=>{i.push(O),setTimeout(()=>{const L=i.indexOf(O);L>=0&&O.catch(y=>{i.splice(L,1),(0,A.isCancellationError)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y&&y.stack&&console.warn(`stack trace: ${y.stack}`),T&&(0,A.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const O=i.indexOf(T);O>=0&&i.splice(O,1)}),process.on("uncaughtException",function(T){(0,A.onUnexpectedError)(T)}),k.mark("code/extHost/willConnectToRenderer");const r=await s();k.mark("code/extHost/didConnectToRenderer");const n=await b(r);k.mark("code/extHost/didWaitForInitData");const{initData:a}=n;l(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=C.useHostProxy!==void 0?C.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,d.boolean)(C.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(O){P(O)}exists(O){return p.Promises.exists(O)}realpath(O){return(0,E.realpath)(O)}};let u=null;a.remote.authority&&C.transformURIs&&(u=(0,w.createURITransformer)(a.remote.authority));const m=new F.ExtensionHostMain(n.protocol,a,g,u);c=T=>m.terminate(T)}e.startExtensionHostProcess=o,o().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8c36556a2c305327f5417dc7f93220f39ed608f/core/vs/workbench/api/node/extensionHostProcess.js.map
