/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ee=function(J){for(var e=[],o=0,I=J.length;o<I;o++)e[o]=ve[J[o]];return e};define(ve[42],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function o(I,_){if(!I)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=o}),define(ve[70],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const o=Object.prototype.hasOwnProperty;function I(M){const b=[];for(let l in M)o.call(M,l)&&b.push(M[l]);return b}e.values=I;function _(M,b){for(let l in M)if(o.call(M,l)&&b({key:l,value:M[l]},function(){delete M[l]})===!1)return}e.forEach=_;function B(M,b){const l=Object.create(null);for(const g of M){const a=b(g);let n=l[a];n||(n=l[a]=[]),n.push(g)}return l}e.groupBy=B;function y(M){const b=Object.create(null);return M&&M.forEach((l,g)=>{b[g]=l}),b}e.fromMap=y;function T(M,b){const l=[],g=[];for(let a of M)b.has(a)||l.push(a);for(let a of b)M.has(a)||g.push(a);return{removed:l,added:g}}e.diffSets=T;function C(M,b){const l=[],g=[];for(let[a,n]of M)b.has(a)||l.push(n);for(let[a,n]of b)M.has(a)||g.push(n);return{removed:l,added:g}}e.diffMaps=C;class R{constructor(){this.map=new Map}add(b,l){let g=this.map.get(b);g||(g=new Set,this.map.set(b,g)),g.add(l)}delete(b,l){const g=this.map.get(b);!g||(g.delete(l),g.size===0&&this.map.delete(b))}forEach(b,l){const g=this.map.get(b);!g||g.forEach(l)}}e.SetMap=R}),define(ve[52],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(y){return(T,C,R)=>{let M=null,b=null;if(typeof R.value=="function"?(M="value",b=R.value):typeof R.get=="function"&&(M="get",b=R.get),!b)throw new Error("not supported");R[M]=y(b,C)}}e.createDecorator=o;function I(y,T,C){let R=null,M=null;if(typeof C.value=="function"?(R="value",M=C.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(R="get",M=C.get),!M)throw new Error("not supported");const b=`$memoize$${T}`;C[R]=function(...l){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,l)}),this[b]}}e.memoize=I;function _(y,T,C){return o((R,M)=>{const b=`$debounce$${M}`,l=`$debounce$result$${M}`;return function(...g){this[l]||(this[l]=C?C():void 0),clearTimeout(this[b]),T&&(this[l]=T(this[l],...g),g=[this[l]]),this[b]=setTimeout(()=>{R.apply(this,g),this[l]=C?C():void 0},y)}})}e.debounce=_;function B(y,T,C){return o((R,M)=>{const b=`$throttle$timer$${M}`,l=`$throttle$result$${M}`,g=`$throttle$lastRun$${M}`,a=`$throttle$pending$${M}`;return function(...n){if(this[l]||(this[l]=C?C():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),T&&(this[l]=T(this[l],...n)),this[a])return;const d=this[g]+y;d<=Date.now()?(this[g]=Date.now(),R.apply(this,[this[l]]),this[l]=C?C():void 0):(this[a]=!0,this[b]=setTimeout(()=>{this[a]=!1,this[g]=Date.now(),R.apply(this,[this[l]]),this[l]=C?C():void 0},d-Date.now()))}})}e.throttle=B}),define(ve[53],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ve[100],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var I;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var B;(function(r){r.DEFAULT={allowTrailingComma:!0}})(B=e.ParseOptions||(e.ParseOptions={}));function y(r,P=!1){let u=0,i=r.length,s="",t=0,c=16,v=0;function h(q){let H=0,W=0;for(;H<q;){const Q=r.charCodeAt(u);if(Q>=48&&Q<=57)W=W*16+Q-48;else if(Q>=65&&Q<=70)W=W*16+Q-65+10;else if(Q>=97&&Q<=102)W=W*16+Q-97+10;else break;u++,H++}return H<q&&(W=-1),W}function p(q){u=q,s="",t=0,c=16,v=0}function k(){const q=u;if(r.charCodeAt(u)===48)u++;else for(u++;u<r.length&&R(r.charCodeAt(u));)u++;if(u<r.length&&r.charCodeAt(u)===46)if(u++,u<r.length&&R(r.charCodeAt(u)))for(u++;u<r.length&&R(r.charCodeAt(u));)u++;else return v=3,r.substring(q,u);let H=u;if(u<r.length&&(r.charCodeAt(u)===69||r.charCodeAt(u)===101))if(u++,(u<r.length&&r.charCodeAt(u)===43||r.charCodeAt(u)===45)&&u++,u<r.length&&R(r.charCodeAt(u))){for(u++;u<r.length&&R(r.charCodeAt(u));)u++;H=u}else v=3;return r.substring(q,H)}function A(){let q="",H=u;for(;;){if(u>=i){q+=r.substring(H,u),v=2;break}const W=r.charCodeAt(u);if(W===34){q+=r.substring(H,u),u++;break}if(W===92){if(q+=r.substring(H,u),u++,u>=i){v=2;break}switch(r.charCodeAt(u++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const V=h(4);V>=0?q+=String.fromCharCode(V):v=4;break}default:v=5}H=u;continue}if(W>=0&&W<=31)if(C(W)){q+=r.substring(H,u),v=2;break}else v=6;u++}return q}function x(){if(s="",v=0,t=u,u>=i)return t=i,c=17;let q=r.charCodeAt(u);if(T(q)){do u++,s+=String.fromCharCode(q),q=r.charCodeAt(u);while(T(q));return c=15}if(C(q))return u++,s+=String.fromCharCode(q),q===13&&r.charCodeAt(u)===10&&(u++,s+=`
`),c=14;switch(q){case 123:return u++,c=1;case 125:return u++,c=2;case 91:return u++,c=3;case 93:return u++,c=4;case 58:return u++,c=6;case 44:return u++,c=5;case 34:return u++,s=A(),c=10;case 47:{const H=u-1;if(r.charCodeAt(u+1)===47){for(u+=2;u<i&&!C(r.charCodeAt(u));)u++;return s=r.substring(H,u),c=12}if(r.charCodeAt(u+1)===42){u+=2;const W=i-1;let Q=!1;for(;u<W;){if(r.charCodeAt(u)===42&&r.charCodeAt(u+1)===47){u+=2,Q=!0;break}u++}return Q||(u++,v=1),s=r.substring(H,u),c=13}return s+=String.fromCharCode(q),u++,c=16}case 45:if(s+=String.fromCharCode(q),u++,u===i||!R(r.charCodeAt(u)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=k(),c=11;default:for(;u<i&&w(q);)u++,q=r.charCodeAt(u);if(t!==u){switch(s=r.substring(t,u),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(q),u++,c=16}}function w(q){if(T(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let q;do q=x();while(q>=12&&q<=15);return q}return{setPosition:p,getPosition:()=>u,scan:P?z:x,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>t,getTokenLength:()=>u-t,getTokenError:()=>v}}e.createScanner=y;function T(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function R(r){return r>=48&&r<=57}var M;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(M||(M={}));function b(r,P){const u=[],i=new Object;let s;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function v(h,p,k,A){t.value=h,t.offset=p,t.length=k,t.type=A,t.colonOffset=void 0,s=t}try{f(r,{onObjectBegin:(h,p)=>{if(P<=h)throw i;s=void 0,c=P>h,u.push("")},onObjectProperty:(h,p,k)=>{if(P<p||(v(h,p,k,"property"),u[u.length-1]=h,P<=p+k))throw i},onObjectEnd:(h,p)=>{if(P<=h)throw i;s=void 0,u.pop()},onArrayBegin:(h,p)=>{if(P<=h)throw i;s=void 0,u.push(0)},onArrayEnd:(h,p)=>{if(P<=h)throw i;s=void 0,u.pop()},onLiteralValue:(h,p,k)=>{if(P<p||(v(h,p,k,E(h)),P<=p+k))throw i},onSeparator:(h,p,k)=>{if(P<=p)throw i;if(h===":"&&s&&s.type==="property")s.colonOffset=p,c=!1,s=void 0;else if(h===","){const A=u[u.length-1];typeof A=="number"?u[u.length-1]=A+1:(c=!0,u[u.length-1]=""),s=void 0}}})}catch(h){if(h!==i)throw h}return{path:u,previousNode:s,isAtPropertyKey:c,matches:h=>{let p=0;for(let k=0;p<h.length&&k<u.length;k++)if(h[p]===u[k]||h[p]==="*")p++;else if(h[p]!=="**")return!1;return p===h.length}}}e.getLocation=b;function l(r,P=[],u=B.DEFAULT){let i=null,s=[];const t=[];function c(h){Array.isArray(s)?s.push(h):i!==null&&(s[i]=h)}return f(r,{onObjectBegin:()=>{const h={};c(h),t.push(s),s=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{s=t.pop()},onArrayBegin:()=>{const h=[];c(h),t.push(s),s=h,i=null},onArrayEnd:()=>{s=t.pop()},onLiteralValue:c,onError:(h,p,k)=>{P.push({error:h,offset:p,length:k})}},u),s[0]}e.parse=l;function g(r,P=[],u=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function t(h){return i.children.push(h),h}f(r,{onObjectBegin:h=>{i=t({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,p,k)=>{i=t({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:p,length:k,parent:i})},onObjectEnd:(h,p)=>{i.length=h+p-i.offset,i=i.parent,s(h+p)},onArrayBegin:(h,p)=>{i=t({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,p)=>{i.length=h+p-i.offset,i=i.parent,s(h+p)},onLiteralValue:(h,p,k)=>{t({type:E(h),offset:p,length:k,parent:i,value:h}),s(p+k)},onSeparator:(h,p,k)=>{i.type==="property"&&(h===":"?i.colonOffset=p:h===","&&s(p))},onError:(h,p,k)=>{P.push({error:h,offset:p,length:k})}},u);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=g;function a(r,P){if(!r)return;let u=r;for(let i of P)if(typeof i=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const t of u.children)if(Array.isArray(t.children)&&t.children[0].value===i){u=t.children[1],s=!0;break}if(!s)return}else{const s=i;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}e.findNodeAtLocation=a;function n(r){if(!r.parent||!r.parent.children)return[];const P=n(r.parent);if(r.parent.type==="property"){const u=r.parent.children[0].value;P.push(u)}else if(r.parent.type==="array"){const u=r.parent.children.indexOf(r);u!==-1&&P.push(u)}return P}e.getNodePath=n;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const P=Object.create(null);for(let u of r.children){const i=u.children[1];i&&(P[u.children[0].value]=d(i))}return P}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function S(r,P,u=!1){return P>=r.offset&&P<r.offset+r.length||u&&P===r.offset+r.length}e.contains=S;function N(r,P,u=!1){if(S(r,P,u)){const i=r.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=P;s++){const t=N(i[s],P,u);if(t)return t}return r}}e.findNodeAtOffset=N;function f(r,P,u=B.DEFAULT){const i=y(r,!1);function s(Se){return Se?()=>Se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Se){return Se?fe=>Se(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(P.onObjectBegin),v=t(P.onObjectProperty),h=s(P.onObjectEnd),p=s(P.onArrayBegin),k=s(P.onArrayEnd),A=t(P.onLiteralValue),x=t(P.onSeparator),w=s(P.onComment),z=t(P.onError),q=u&&u.disallowComments,H=u&&u.allowTrailingComma;function W(){for(;;){const Se=i.scan();switch(i.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:q||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(Se){case 12:case 13:q?Q(10):w();break;case 16:Q(1);break;case 15:case 14:break;default:return Se}}}function Q(Se,fe=[],ne=[]){if(z(Se),fe.length+ne.length>0){let me=i.getToken();for(;me!==17;){if(fe.indexOf(me)!==-1){W();break}else if(ne.indexOf(me)!==-1)break;me=W()}}}function V(Se){const fe=i.getTokenValue();return Se?A(fe):v(fe),W(),!0}function te(){switch(i.getToken()){case 11:{let Se=0;try{Se=JSON.parse(i.getTokenValue()),typeof Se!="number"&&(Q(2),Se=0)}catch{Q(2)}A(Se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return W(),!0}function oe(){return i.getToken()!==10?(Q(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(x(":"),W(),he()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function ie(){c(),W();let Se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Se||Q(4,[],[]),x(","),W(),i.getToken()===2&&H)break}else Se&&Q(6,[],[]);oe()||Q(4,[],[2,5]),Se=!0}return h(),i.getToken()!==2?Q(7,[2],[]):W(),!0}function ue(){p(),W();let Se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Se||Q(4,[],[]),x(","),W(),i.getToken()===4&&H)break}else Se&&Q(6,[],[]);he()||Q(4,[],[4,5]),Se=!0}return k(),i.getToken()!==4?Q(8,[4],[]):W(),!0}function he(){switch(i.getToken()){case 3:return ue();case 1:return ie();case 10:return V(!0);default:return te()}}return W(),i.getToken()===17?u.allowEmptyContent?!0:(Q(4,[],[]),!1):he()?(i.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=f;function m(r,P){let u=y(r),i=[],s,t=0,c;do switch(c=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:t!==c&&i.push(r.substring(t,c)),P!==void 0&&i.push(u.getTokenValue().replace(/[^\r\n]/g,P)),t=u.getPosition();break}while(s!==17);return i.join("")}e.stripComments=m;function E(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[101],Ee([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(ge,de){for(var L=0;L<de.length;L++){var F=de[L];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(ge,F.key,F)}}function o(ge,de,L){return de&&e(ge.prototype,de),L&&e(ge,L),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function I(ge,de){if(!!ge){if(typeof ge=="string")return _(ge,de);var L=Object.prototype.toString.call(ge).slice(8,-1);if(L==="Object"&&ge.constructor&&(L=ge.constructor.name),L==="Map"||L==="Set")return Array.from(ge);if(L==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(L))return _(ge,de)}}function _(ge,de){(de==null||de>ge.length)&&(de=ge.length);for(var L=0,F=new Array(de);L<de;L++)F[L]=ge[L];return F}function B(ge,de){var L=typeof Symbol!="undefined"&&ge[Symbol.iterator]||ge["@@iterator"];if(L)return(L=L.call(ge)).next.bind(L);if(Array.isArray(ge)||(L=I(ge))||de&&ge&&typeof ge.length=="number"){L&&(ge=L);var F=0;return function(){return F>=ge.length?{done:!0}:{done:!1,value:ge[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function T(ge){J.defaults=ge}var C=/[&<>"']/,R=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(de){return l[de]};function a(ge,de){if(de){if(C.test(ge))return ge.replace(R,g)}else if(M.test(ge))return ge.replace(b,g);return ge}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ge){return ge.replace(n,function(de,L){return L=L.toLowerCase(),L==="colon"?":":L.charAt(0)==="#"?L.charAt(1)==="x"?String.fromCharCode(parseInt(L.substring(2),16)):String.fromCharCode(+L.substring(1)):""})}var S=/(^|[^\[])\^/g;function N(ge,de){ge=ge.source||ge,de=de||"";var L={replace:function(D,O){return O=O.source||O,O=O.replace(S,"$1"),ge=ge.replace(D,O),L},getRegex:function(){return new RegExp(ge,de)}};return L}var f=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(ge,de,L){if(ge){var F;try{F=decodeURIComponent(d(L)).replace(f,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}de&&!m.test(L)&&(L=s(de,L));try{L=encodeURI(L).replace(/%25/g,"%")}catch{return null}return L}var r={},P=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ge,de){r[" "+ge]||(P.test(ge)?r[" "+ge]=ge+"/":r[" "+ge]=h(ge,"/",!0)),ge=r[" "+ge];var L=ge.indexOf(":")===-1;return de.substring(0,2)==="//"?L?de:ge.replace(u,"$1")+de:de.charAt(0)==="/"?L?de:ge.replace(i,"$1")+de:ge+de}var t={exec:function(){}};function c(ge){for(var de=1,L,F;de<arguments.length;de++){L=arguments[de];for(F in L)Object.prototype.hasOwnProperty.call(L,F)&&(ge[F]=L[F])}return ge}function v(ge,de){var L=ge.replace(/\|/g,function(O,$,X){for(var re=!1,pe=$;--pe>=0&&X[pe]==="\\";)re=!re;return re?"|":" |"}),F=L.split(/ \|/),D=0;if(F[0].trim()||F.shift(),F[F.length-1].trim()||F.pop(),F.length>de)F.splice(de);else for(;F.length<de;)F.push("");for(;D<F.length;D++)F[D]=F[D].trim().replace(/\\\|/g,"|");return F}function h(ge,de,L){var F=ge.length;if(F===0)return"";for(var D=0;D<F;){var O=ge.charAt(F-D-1);if(O===de&&!L)D++;else if(O!==de&&L)D++;else break}return ge.substr(0,F-D)}function p(ge,de){if(ge.indexOf(de[1])===-1)return-1;for(var L=ge.length,F=0,D=0;D<L;D++)if(ge[D]==="\\")D++;else if(ge[D]===de[0])F++;else if(ge[D]===de[1]&&(F--,F<0))return D;return-1}function k(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ge,de){if(de<1)return"";for(var L="";de>1;)de&1&&(L+=ge),de>>=1,ge+=ge;return L+ge}function x(ge,de,L,F){var D=de.href,O=de.title?a(de.title):null,$=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){F.state.inLink=!0;var X={type:"link",raw:L,href:D,title:O,text:$,tokens:F.inlineTokens($,[])};return F.state.inLink=!1,X}else return{type:"image",raw:L,href:D,title:O,text:a($)}}function w(ge,de){var L=ge.match(/^(\s+)(?:```)/);if(L===null)return de;var F=L[1];return de.split(`
`).map(function(D){var O=D.match(/^\s+/);if(O===null)return D;var $=O[0];return $.length>=F.length?D.slice(F.length):D}).join(`
`)}var z=function(){function ge(L){this.options=L||J.defaults}var de=ge.prototype;return de.space=function(F){var D=this.rules.block.newline.exec(F);if(D&&D[0].length>0)return{type:"space",raw:D[0]}},de.code=function(F){var D=this.rules.block.code.exec(F);if(D){var O=D[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:D[0],codeBlockStyle:"indented",text:this.options.pedantic?O:h(O,`
`)}}},de.fences=function(F){var D=this.rules.block.fences.exec(F);if(D){var O=D[0],$=w(O,D[3]||"");return{type:"code",raw:O,lang:D[2]?D[2].trim():D[2],text:$}}},de.heading=function(F){var D=this.rules.block.heading.exec(F);if(D){var O=D[2].trim();if(/#$/.test(O)){var $=h(O,"#");(this.options.pedantic||!$||/ $/.test($))&&(O=$.trim())}var X={type:"heading",raw:D[0],depth:D[1].length,text:O,tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},de.hr=function(F){var D=this.rules.block.hr.exec(F);if(D)return{type:"hr",raw:D[0]}},de.blockquote=function(F){var D=this.rules.block.blockquote.exec(F);if(D){var O=D[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:D[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},de.list=function(F){var D=this.rules.block.list.exec(F);if(D){var O,$,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et=D[1].trim(),ke=et.length>1,tt={type:"list",raw:"",ordered:ke,start:ke?+et.slice(0,-1):"",loose:!1,items:[]};et=ke?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=ke?et:"[*+-]");for(var G=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");F&&(Xe=!1,!(!(D=G.exec(F))||this.rules.block.hr.test(F)));){if(O=D[0],F=F.substring(O.length),Le=D[2].split(`
`,1)[0],ze=F.split(`
`,1)[0],this.options.pedantic?(re=2,Oe=Le.trimLeft()):(re=D[2].search(/[^ ]/),re=re>4?1:re,Oe=Le.slice(re),re+=D[1].length),Ce=!1,!Le&&/^ *$/.test(ze)&&(O+=ze+`
`,F=F.substring(ze.length+1),Xe=!0),!Xe)for(var Y=new RegExp("^ {0,"+Math.min(3,re-1)+"}(?:[*+-]|\\d{1,9}[.)])");F&&(xe=F.split(`
`,1)[0],Le=xe,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Y.test(Le));){if(Le.search(/[^ ]/)>=re||!Le.trim())Oe+=`
`+Le.slice(re);else if(!Ce)Oe+=`
`+Le;else break;!Ce&&!Le.trim()&&(Ce=!0),O+=xe+`
`,F=F.substring(xe.length+1)}tt.loose||(Me?tt.loose=!0:/\n *\n *$/.test(O)&&(Me=!0)),this.options.gfm&&($=/^\[[ xX]\] /.exec(Oe),$&&(X=$[0]!=="[ ] ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),tt.items.push({type:"list_item",raw:O,task:!!$,checked:X,loose:!1,text:Oe}),tt.raw+=O}tt.items[tt.items.length-1].raw=O.trimRight(),tt.items[tt.items.length-1].text=Oe.trimRight(),tt.raw=tt.raw.trimRight();var ce=tt.items.length;for(pe=0;pe<ce;pe++){this.lexer.state.top=!1,tt.items[pe].tokens=this.lexer.blockTokens(tt.items[pe].text,[]);var Re=tt.items[pe].tokens.filter(function(Ke){return Ke.type==="space"}),$e=Re.every(function(Ke){for(var Qe=Ke.raw.split(""),ht=0,_t=B(Qe),yt;!(yt=_t()).done;){var Tt=yt.value;if(Tt===`
`&&(ht+=1),ht>1)return!0}return!1});!tt.loose&&Re.length&&$e&&(tt.loose=!0,tt.items[pe].loose=!0)}return tt}},de.html=function(F){var D=this.rules.block.html.exec(F);if(D){var O={type:"html",raw:D[0],pre:!this.options.sanitizer&&(D[1]==="pre"||D[1]==="script"||D[1]==="style"),text:D[0]};return this.options.sanitize&&(O.type="paragraph",O.text=this.options.sanitizer?this.options.sanitizer(D[0]):a(D[0]),O.tokens=[],this.lexer.inline(O.text,O.tokens)),O}},de.def=function(F){var D=this.rules.block.def.exec(F);if(D){D[3]&&(D[3]=D[3].substring(1,D[3].length-1));var O=D[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:D[0],href:D[2],title:D[3]}}},de.table=function(F){var D=this.rules.block.table.exec(F);if(D){var O={type:"table",header:v(D[1]).map(function(Me){return{text:Me}}),align:D[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:D[3]?D[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=D[0];var $=O.align.length,X,re,pe,Ce;for(X=0;X<$;X++)/^ *-+: *$/.test(O.align[X])?O.align[X]="right":/^ *:-+: *$/.test(O.align[X])?O.align[X]="center":/^ *:-+ *$/.test(O.align[X])?O.align[X]="left":O.align[X]=null;for($=O.rows.length,X=0;X<$;X++)O.rows[X]=v(O.rows[X],O.header.length).map(function(Me){return{text:Me}});for($=O.header.length,re=0;re<$;re++)O.header[re].tokens=[],this.lexer.inlineTokens(O.header[re].text,O.header[re].tokens);for($=O.rows.length,re=0;re<$;re++)for(Ce=O.rows[re],pe=0;pe<Ce.length;pe++)Ce[pe].tokens=[],this.lexer.inlineTokens(Ce[pe].text,Ce[pe].tokens);return O}}},de.lheading=function(F){var D=this.rules.block.lheading.exec(F);if(D){var O={type:"heading",raw:D[0],depth:D[2].charAt(0)==="="?1:2,text:D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.paragraph=function(F){var D=this.rules.block.paragraph.exec(F);if(D){var O={type:"paragraph",raw:D[0],text:D[1].charAt(D[1].length-1)===`
`?D[1].slice(0,-1):D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.text=function(F){var D=this.rules.block.text.exec(F);if(D){var O={type:"text",raw:D[0],text:D[0],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.escape=function(F){var D=this.rules.inline.escape.exec(F);if(D)return{type:"escape",raw:D[0],text:a(D[1])}},de.tag=function(F){var D=this.rules.inline.tag.exec(F);if(D)return!this.lexer.state.inLink&&/^<a /i.test(D[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(D[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(D[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(D[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:D[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):a(D[0]):D[0]}},de.link=function(F){var D=this.rules.inline.link.exec(F);if(D){var O=D[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var $=h(O.slice(0,-1),"\\");if((O.length-$.length)%2==0)return}else{var X=p(D[2],"()");if(X>-1){var re=D[0].indexOf("!")===0?5:4,pe=re+D[1].length+X;D[2]=D[2].substring(0,X),D[0]=D[0].substring(0,pe).trim(),D[3]=""}}var Ce=D[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);Le&&(Ce=Le[1],Me=Le[3])}else Me=D[3]?D[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(O)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),x(D,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},D[0],this.lexer)}},de.reflink=function(F,D){var O;if((O=this.rules.inline.reflink.exec(F))||(O=this.rules.inline.nolink.exec(F))){var $=(O[2]||O[1]).replace(/\s+/g," ");if($=D[$.toLowerCase()],!$||!$.href){var X=O[0].charAt(0);return{type:"text",raw:X,text:X}}return x(O,$,O[0],this.lexer)}},de.emStrong=function(F,D,O){O===void 0&&(O="");var $=this.rules.inline.emStrong.lDelim.exec(F);if(!!$&&!($[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var X=$[1]||$[2]||"";if(!X||X&&(O===""||this.rules.inline.punctuation.exec(O))){var re=$[0].length-1,pe,Ce,Me=re,Le=0,ze=$[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,D=D.slice(-1*F.length+re);($=ze.exec(D))!=null;)if(pe=$[1]||$[2]||$[3]||$[4]||$[5]||$[6],!!pe){if(Ce=pe.length,$[3]||$[4]){Me+=Ce;continue}else if(($[5]||$[6])&&re%3&&!((re+Ce)%3)){Le+=Ce;continue}if(Me-=Ce,!(Me>0)){if(Ce=Math.min(Ce,Ce+Me+Le),Math.min(re,Ce)%2){var xe=F.slice(1,re+$.index+Ce);return{type:"em",raw:F.slice(0,re+$.index+Ce+1),text:xe,tokens:this.lexer.inlineTokens(xe,[])}}var Oe=F.slice(2,re+$.index+Ce-1);return{type:"strong",raw:F.slice(0,re+$.index+Ce+1),text:Oe,tokens:this.lexer.inlineTokens(Oe,[])}}}}}},de.codespan=function(F){var D=this.rules.inline.code.exec(F);if(D){var O=D[2].replace(/\n/g," "),$=/[^ ]/.test(O),X=/^ /.test(O)&&/ $/.test(O);return $&&X&&(O=O.substring(1,O.length-1)),O=a(O,!0),{type:"codespan",raw:D[0],text:O}}},de.br=function(F){var D=this.rules.inline.br.exec(F);if(D)return{type:"br",raw:D[0]}},de.del=function(F){var D=this.rules.inline.del.exec(F);if(D)return{type:"del",raw:D[0],text:D[2],tokens:this.lexer.inlineTokens(D[2],[])}},de.autolink=function(F,D){var O=this.rules.inline.autolink.exec(F);if(O){var $,X;return O[2]==="@"?($=a(this.options.mangle?D(O[1]):O[1]),X="mailto:"+$):($=a(O[1]),X=$),{type:"link",raw:O[0],text:$,href:X,tokens:[{type:"text",raw:$,text:$}]}}},de.url=function(F,D){var O;if(O=this.rules.inline.url.exec(F)){var $,X;if(O[2]==="@")$=a(this.options.mangle?D(O[0]):O[0]),X="mailto:"+$;else{var re;do re=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(re!==O[0]);$=a(O[0]),O[1]==="www."?X="http://"+$:X=$}return{type:"link",raw:O[0],text:$,href:X,tokens:[{type:"text",raw:$,text:$}]}}},de.inlineText=function(F,D){var O=this.rules.inline.text.exec(F);if(O){var $;return this.lexer.state.inRawBlock?$=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):a(O[0]):O[0]:$=a(this.options.smartypants?D(O[0]):O[0]),{type:"text",raw:O[0],text:$}}},ge}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=N(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=N(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=N(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=N(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=N(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=N(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=c({},q),q.gfm=c({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=N(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=N(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=c({},q.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:N(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=N(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=N(q._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=N(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=N(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=N(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=N(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=N(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=N(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=N(H.reflink).replace("label",H._label).replace("ref",q._label).getRegex(),H.nolink=N(H.nolink).replace("ref",q._label).getRegex(),H.reflinkSearch=N(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=c({},H),H.pedantic=c({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=c({},H.normal,{escape:N(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=N(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=c({},H.gfm,{br:N(H.br).replace("{2,}","*").getRegex(),text:N(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function W(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(ge){var de="",L,F,D=ge.length;for(L=0;L<D;L++)F=ge.charCodeAt(L),Math.random()>.5&&(F="x"+F.toString(16)),de+="&#"+F+";";return de}var V=function(){function ge(L){this.tokens=[],this.tokens.links=Object.create(null),this.options=L||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:q.normal,inline:H.normal};this.options.pedantic?(F.block=q.pedantic,F.inline=H.pedantic):this.options.gfm&&(F.block=q.gfm,this.options.breaks?F.inline=H.breaks:F.inline=H.gfm),this.tokenizer.rules=F}ge.lex=function(F,D){var O=new ge(D);return O.lex(F)},ge.lexInline=function(F,D){var O=new ge(D);return O.inlineTokens(F)};var de=ge.prototype;return de.lex=function(F){F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens);for(var D;D=this.inlineQueue.shift();)this.inlineTokens(D.src,D.tokens);return this.tokens},de.blockTokens=function(F,D){var O=this;D===void 0&&(D=[]),this.options.pedantic&&(F=F.replace(/^ +$/gm,""));for(var $,X,re,pe;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return($=Me.call({lexer:O},F,D))?(F=F.substring($.raw.length),D.push($),!0):!1}))){if($=this.tokenizer.space(F)){F=F.substring($.raw.length),$.raw.length===1&&D.length>0?D[D.length-1].raw+=`
`:D.push($);continue}if($=this.tokenizer.code(F)){F=F.substring($.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+$.raw,X.text+=`
`+$.text,this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push($);continue}if($=this.tokenizer.fences(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.heading(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.hr(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.blockquote(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.list(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.html(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.def(F)){F=F.substring($.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+$.raw,X.text+=`
`+$.raw,this.inlineQueue[this.inlineQueue.length-1].src=X.text):this.tokens.links[$.tag]||(this.tokens.links[$.tag]={href:$.href,title:$.title});continue}if($=this.tokenizer.table(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.lheading(F)){F=F.substring($.raw.length),D.push($);continue}if(re=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=F.slice(1),ze=void 0;O.options.extensions.startBlock.forEach(function(xe){ze=xe.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(re=F.substring(0,Me+1))}(),this.state.top&&($=this.tokenizer.paragraph(re))){X=D[D.length-1],pe&&X.type==="paragraph"?(X.raw+=`
`+$.raw,X.text+=`
`+$.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push($),pe=re.length!==F.length,F=F.substring($.raw.length);continue}if($=this.tokenizer.text(F)){F=F.substring($.raw.length),X=D[D.length-1],X&&X.type==="text"?(X.raw+=`
`+$.raw,X.text+=`
`+$.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push($);continue}if(F){var Ce="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,D},de.inline=function(F,D){this.inlineQueue.push({src:F,tokens:D})},de.inlineTokens=function(F,D){var O=this;D===void 0&&(D=[]);var $,X,re,pe=F,Ce,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(pe))!=null;)ze.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(pe=pe.slice(0,Ce.index)+"["+A("a",Ce[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(pe))!=null;)pe=pe.slice(0,Ce.index)+"["+A("a",Ce[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(pe))!=null;)pe=pe.slice(0,Ce.index)+"++"+pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Oe){return($=Oe.call({lexer:O},F,D))?(F=F.substring($.raw.length),D.push($),!0):!1}))){if($=this.tokenizer.escape(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.tag(F)){F=F.substring($.raw.length),X=D[D.length-1],X&&$.type==="text"&&X.type==="text"?(X.raw+=$.raw,X.text+=$.text):D.push($);continue}if($=this.tokenizer.link(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring($.raw.length),X=D[D.length-1],X&&$.type==="text"&&X.type==="text"?(X.raw+=$.raw,X.text+=$.text):D.push($);continue}if($=this.tokenizer.emStrong(F,pe,Le)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.codespan(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.br(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.del(F)){F=F.substring($.raw.length),D.push($);continue}if($=this.tokenizer.autolink(F,Q)){F=F.substring($.raw.length),D.push($);continue}if(!this.state.inLink&&($=this.tokenizer.url(F,Q))){F=F.substring($.raw.length),D.push($);continue}if(re=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Oe=1/0,Xe=F.slice(1),et=void 0;O.options.extensions.startInline.forEach(function(ke){et=ke.call({lexer:this},Xe),typeof et=="number"&&et>=0&&(Oe=Math.min(Oe,et))}),Oe<1/0&&Oe>=0&&(re=F.substring(0,Oe+1))}(),$=this.tokenizer.inlineText(re,W)){F=F.substring($.raw.length),$.raw.slice(-1)!=="_"&&(Le=$.raw.slice(-1)),Me=!0,X=D[D.length-1],X&&X.type==="text"?(X.raw+=$.raw,X.text+=$.text):D.push($);continue}if(F){var xe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return D},o(ge,null,[{key:"rules",get:function(){return{block:q,inline:H}}}]),ge}(),te=function(){function ge(L){this.options=L||J.defaults}var de=ge.prototype;return de.code=function(F,D,O){var $=(D||"").match(/\S*/)[0];if(this.options.highlight){var X=this.options.highlight(F,$);X!=null&&X!==F&&(O=!0,F=X)}return F=F.replace(/\n$/,"")+`
`,$?'<pre><code class="'+this.options.langPrefix+a($,!0)+'">'+(O?F:a(F,!0))+`</code></pre>
`:"<pre><code>"+(O?F:a(F,!0))+`</code></pre>
`},de.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},de.html=function(F){return F},de.heading=function(F,D,O,$){return this.options.headerIds?"<h"+D+' id="'+this.options.headerPrefix+$.slug(O)+'">'+F+"</h"+D+`>
`:"<h"+D+">"+F+"</h"+D+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(F,D,O){var $=D?"ol":"ul",X=D&&O!==1?' start="'+O+'"':"";return"<"+$+X+`>
`+F+"</"+$+`>
`},de.listitem=function(F){return"<li>"+F+`</li>
`},de.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(F){return"<p>"+F+`</p>
`},de.table=function(F,D){return D&&(D="<tbody>"+D+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+D+`</table>
`},de.tablerow=function(F){return`<tr>
`+F+`</tr>
`},de.tablecell=function(F,D){var O=D.header?"th":"td",$=D.align?"<"+O+' align="'+D.align+'">':"<"+O+">";return $+F+"</"+O+`>
`},de.strong=function(F){return"<strong>"+F+"</strong>"},de.em=function(F){return"<em>"+F+"</em>"},de.codespan=function(F){return"<code>"+F+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(F){return"<del>"+F+"</del>"},de.link=function(F,D,O){if(F=E(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var $='<a href="'+a(F)+'"';return D&&($+=' title="'+D+'"'),$+=">"+O+"</a>",$},de.image=function(F,D,O){if(F=E(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var $='<img src="'+F+'" alt="'+O+'"';return D&&($+=' title="'+D+'"'),$+=this.options.xhtml?"/>":">",$},de.text=function(F){return F},ge}(),oe=function(){function ge(){}var de=ge.prototype;return de.strong=function(F){return F},de.em=function(F){return F},de.codespan=function(F){return F},de.del=function(F){return F},de.html=function(F){return F},de.text=function(F){return F},de.link=function(F,D,O){return""+O},de.image=function(F,D,O){return""+O},de.br=function(){return""},ge}(),ie=function(){function ge(){this.seen={}}var de=ge.prototype;return de.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(F,D){var O=F,$=0;if(this.seen.hasOwnProperty(O)){$=this.seen[F];do $++,O=F+"-"+$;while(this.seen.hasOwnProperty(O))}return D||(this.seen[F]=$,this.seen[O]=0),O},de.slug=function(F,D){D===void 0&&(D={});var O=this.serialize(F);return this.getNextSafeSlug(O,D.dryrun)},ge}(),ue=function(){function ge(L){this.options=L||J.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new oe,this.slugger=new ie}ge.parse=function(F,D){var O=new ge(D);return O.parse(F)},ge.parseInline=function(F,D){var O=new ge(D);return O.parseInline(F)};var de=ge.prototype;return de.parse=function(F,D){D===void 0&&(D=!0);var O="",$,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et,ke,tt,G,Y,ce,Re,$e,Ke=F.length;for($=0;$<Ke;$++){if(Oe=F[$],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&($e=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Oe.type))){O+=$e||"";continue}switch(Oe.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,d(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(ze="",Le="",pe=Oe.header.length,X=0;X<pe;X++)Le+=this.renderer.tablecell(this.parseInline(Oe.header[X].tokens),{header:!0,align:Oe.align[X]});for(ze+=this.renderer.tablerow(Le),xe="",pe=Oe.rows.length,X=0;X<pe;X++){for(Me=Oe.rows[X],Le="",Ce=Me.length,re=0;re<Ce;re++)Le+=this.renderer.tablecell(this.parseInline(Me[re].tokens),{header:!1,align:Oe.align[re]});xe+=this.renderer.tablerow(Le)}O+=this.renderer.table(ze,xe);continue}case"blockquote":{xe=this.parse(Oe.tokens),O+=this.renderer.blockquote(xe);continue}case"list":{for(Xe=Oe.ordered,et=Oe.start,ke=Oe.loose,pe=Oe.items.length,xe="",X=0;X<pe;X++)G=Oe.items[X],Y=G.checked,ce=G.task,tt="",G.task&&(Re=this.renderer.checkbox(Y),ke?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Re+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Re+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Re}):tt+=Re),tt+=this.parse(G.tokens,ke),xe+=this.renderer.listitem(tt,ce,Y);O+=this.renderer.list(xe,Xe,et);continue}case"html":{O+=this.renderer.html(Oe.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(xe=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;$+1<Ke&&F[$+1].type==="text";)Oe=F[++$],xe+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);O+=D?this.renderer.paragraph(xe):xe;continue}default:{var Qe='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return O},de.parseInline=function(F,D){D=D||this.renderer;var O="",$,X,re,pe=F.length;for($=0;$<pe;$++){if(X=F[$],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(re=this.options.extensions.renderers[X.type].call({parser:this},X),re!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(X.type))){O+=re||"";continue}switch(X.type){case"escape":{O+=D.text(X.text);break}case"html":{O+=D.html(X.text);break}case"link":{O+=D.link(X.href,X.title,this.parseInline(X.tokens,D));break}case"image":{O+=D.image(X.href,X.title,X.text);break}case"strong":{O+=D.strong(this.parseInline(X.tokens,D));break}case"em":{O+=D.em(this.parseInline(X.tokens,D));break}case"codespan":{O+=D.codespan(X.text);break}case"br":{O+=D.br();break}case"del":{O+=D.del(this.parseInline(X.tokens,D));break}case"text":{O+=D.text(X.text);break}default:{var Ce='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return O},ge}();function he(ge,de,L){if(typeof ge=="undefined"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof de=="function"&&(L=de,de=null),de=c({},he.defaults,de||{}),k(de),L){var F=de.highlight,D;try{D=V.lex(ge,de)}catch(re){return L(re)}var O=function(pe){var Ce;if(!pe)try{de.walkTokens&&he.walkTokens(D,de.walkTokens),Ce=ue.parse(D,de)}catch(Me){pe=Me}return de.highlight=F,pe?L(pe):L(null,Ce)};if(!F||F.length<3||(delete de.highlight,!D.length))return O();var $=0;he.walkTokens(D,function(re){re.type==="code"&&($++,setTimeout(function(){F(re.text,re.lang,function(pe,Ce){if(pe)return O(pe);Ce!=null&&Ce!==re.text&&(re.text=Ce,re.escaped=!0),$--,$===0&&O()})},0))}),$===0&&O();return}try{var X=V.lex(ge,de);return de.walkTokens&&he.walkTokens(X,de.walkTokens),ue.parse(X,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+a(re.message+"",!0)+"</pre>";throw re}}he.options=he.setOptions=function(ge){return c(he.defaults,ge),T(he.defaults),he},he.getDefaults=y,he.defaults=J.defaults,he.use=function(){for(var ge=arguments.length,de=new Array(ge),L=0;L<ge;L++)de[L]=arguments[L];var F=c.apply(void 0,[{}].concat(de)),D=he.defaults.extensions||{renderers:{},childTokens:{}},O;de.forEach(function($){if($.extensions&&(O=!0,$.extensions.forEach(function(re){if(!re.name)throw new Error("extension name required");if(re.renderer){var pe=D.renderers?D.renderers[re.name]:null;pe?D.renderers[re.name]=function(){for(var Ce=arguments.length,Me=new Array(Ce),Le=0;Le<Ce;Le++)Me[Le]=arguments[Le];var ze=re.renderer.apply(this,Me);return ze===!1&&(ze=pe.apply(this,Me)),ze}:D.renderers[re.name]=re.renderer}if(re.tokenizer){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");D[re.level]?D[re.level].unshift(re.tokenizer):D[re.level]=[re.tokenizer],re.start&&(re.level==="block"?D.startBlock?D.startBlock.push(re.start):D.startBlock=[re.start]:re.level==="inline"&&(D.startInline?D.startInline.push(re.start):D.startInline=[re.start]))}re.childTokens&&(D.childTokens[re.name]=re.childTokens)})),$.renderer&&function(){var re=he.defaults.renderer||new te,pe=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Oe=new Array(xe),Xe=0;Xe<xe;Xe++)Oe[Xe]=arguments[Xe];var et=$.renderer[Le].apply(re,Oe);return et===!1&&(et=ze.apply(re,Oe)),et}};for(var Ce in $.renderer)pe(Ce);F.renderer=re}(),$.tokenizer&&function(){var re=he.defaults.tokenizer||new z,pe=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Oe=new Array(xe),Xe=0;Xe<xe;Xe++)Oe[Xe]=arguments[Xe];var et=$.tokenizer[Le].apply(re,Oe);return et===!1&&(et=ze.apply(re,Oe)),et}};for(var Ce in $.tokenizer)pe(Ce);F.tokenizer=re}(),$.walkTokens){var X=he.defaults.walkTokens;F.walkTokens=function(re){$.walkTokens.call(this,re),X&&X.call(this,re)}}O&&(F.extensions=D),he.setOptions(F)})},he.walkTokens=function(ge,de){for(var L=function(){var $=D.value;switch(de.call(he,$),$.type){case"table":{for(var X=B($.header),re;!(re=X()).done;){var pe=re.value;he.walkTokens(pe.tokens,de)}for(var Ce=B($.rows),Me;!(Me=Ce()).done;)for(var Le=Me.value,ze=B(Le),xe;!(xe=ze()).done;){var Oe=xe.value;he.walkTokens(Oe.tokens,de)}break}case"list":{he.walkTokens($.items,de);break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[$.type]?he.defaults.extensions.childTokens[$.type].forEach(function(Xe){he.walkTokens($[Xe],de)}):$.tokens&&he.walkTokens($.tokens,de)}},F=B(ge),D;!(D=F()).done;)L()},he.parseInline=function(ge,de){if(typeof ge=="undefined"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");de=c({},he.defaults,de||{}),k(de);try{var L=V.lexInline(ge,de);return de.walkTokens&&he.walkTokens(L,de.walkTokens),ue.parseInline(L,de)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+a(F.message+"",!0)+"</pre>";throw F}},he.Parser=ue,he.parser=ue.parse,he.Renderer=te,he.TextRenderer=oe,he.Lexer=V,he.lexer=V.lex,he.Tokenizer=z,he.Slugger=ie,he.parse=he;var Se=he.options,fe=he.setOptions,ne=he.use,me=he.walkTokens,Ie=he.parseInline,Ae=he,Ue=ue.parse,Ge=V.lex;J.Lexer=V,J.Parser=ue,J.Renderer=te,J.Slugger=ie,J.TextRenderer=oe,J.Tokenizer=z,J.getDefaults=y,J.lexer=Ge,J.marked=he,J.options=Se,J.parse=Ae,J.parseInline=Ie,J.parser=Ue,J.setOptions=fe,J.use=ne,J.walkTokens=me,Object.defineProperty(J,"__esModule",{value:!0})}),define(ve[102],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(T,C,R){return Math.min(Math.max(T,C),R)}e.clamp=o;function I(T,C){return(C+T%C)%C}e.rot=I;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class B{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=B;class y{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const R=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function J(_){const B=[];typeof _=="number"&&B.push("code/timeOrigin",_);function y(C){B.push(C,Date.now())}function T(){const C=[];for(let R=0;R<B.length;R+=2)C.push({name:B[R],startTime:B[R+1]});return C}return{mark:y,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const y of performance.getEntriesByType("mark"))B.push({name:y.name,startTime:Math.round(_+y.startTime)});return B}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function o(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=o(I))}(),define(ve[71],Ee([1,0,17]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var I;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(I=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function y(b){const l=(0,o.extname)(b),g=_[l.toLowerCase()];return g!==void 0?g:T(b)}e.getMediaOrTextMime=y;function T(b){const l=(0,o.extname)(b);return B[l.toLowerCase()]}e.getMediaMime=T;function C(b){for(const l in B)if(B[l]===b)return l}e.getExtensionForMimeType=C;const R=/^(.+)\/(.+?)(;.+)?$/;function M(b,l){const g=R.exec(b);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:l?void 0:b}e.normalizeMimeType=M}),define(ve[103],Ee([1,0,15,6]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(f){const m=f;return m?[m.on,m.pause,m.resume,m.destroy].every(E=>typeof E=="function"):!1}e.isReadableStream=_;function B(f){const m=f;return m?_(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=B;function y(f,m){return new T(f,m)}e.newWriteableStream=y;class T{constructor(m,E){this.reducer=m,this.options=E,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(E=>this.pendingWritePromises.push(E))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(E=>E(m))}emitError(m){this.listeners.error.length===0?(0,o.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(E=>E(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,E){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(E),this.resume();break;case"end":this.listeners.end.push(E),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(E),this.state.flowing&&this.flowErrors();break}}removeListener(m,E){if(this.state.destroyed)return;let r;switch(m){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const P=r.indexOf(E);P>=0&&r.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const E=[...this.pendingWritePromises];this.pendingWritePromises.length=0,E.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(f,m){const E=[];let r;for(;(r=f.read())!==null;)E.push(r);return m(E)}e.consumeReadable=C;function R(f,m,E){const r=[];let P;for(;(P=f.read())!==null&&r.length<E;)r.push(P);return P===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof P!="undefined"){const u=P;return P=void 0,u}return f.read()}}}e.peekReadable=R;function M(f,m){return new Promise((E,r)=>{const P=[];b(f,{onData:u=>{m&&P.push(u)},onError:u=>{m?r(u):E(void 0)},onEnd:()=>{E(m?m(P):void 0)}})})}e.consumeStream=M;function b(f,m){let E=!1;return f.on("error",r=>{E||m.onError(r)}),f.on("end",()=>{E||m.onEnd()}),f.on("data",r=>{E||m.onData(r)}),(0,I.toDisposable)(()=>E=!0)}e.listenStream=b;function l(f,m){return new Promise((E,r)=>{const P=new I.DisposableStore,u=[],i=c=>{if(u.push(c),u.length>m)return P.dispose(),f.pause(),E({stream:f,buffer:u,ended:!1})},s=c=>r(c),t=()=>E({stream:f,buffer:u,ended:!0});P.add((0,I.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),P.add((0,I.toDisposable)(()=>f.removeListener("end",t))),f.on("end",t),P.add((0,I.toDisposable)(()=>f.removeListener("data",i))),f.on("data",i)})}e.peekStream=l;function g(f,m){const E=y(m);return E.end(f),E}e.toStream=g;function a(){const f=y(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=a;function n(f){let m=!1;return{read:()=>m?null:(m=!0,f)}}e.toReadable=n;function d(f,m,E){const r=y(E);return b(f,{onData:P=>r.write(m.data(P)),onError:P=>r.error(m.error?m.error(P):P),onEnd:()=>r.end()}),r}e.transform=d;function S(f,m,E){let r=!1;return{read:()=>{const P=m.read();return r?P:(r=!0,P!==null?E([f,P]):f)}}}e.prefixedReadable=S;function N(f,m,E){let r=!1;const P=y(E);return b(m,{onData:u=>r?P.write(u):(r=!0,P.write(E([f,u]))),onError:u=>P.error(u),onEnd:()=>{r||(r=!0,P.write(f)),P.end()}}),P}e.prefixedStream=N}),define(ve[21],Ee([1,0,103]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let _,B;class y{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return I?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return I&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,h){return!(h?.dontUseNodeBuffer||!1)&&I?new y(Buffer.from(v)):(_||(_=new TextEncoder),new y(_.encode(v)))}static fromByteArray(v){const h=y.alloc(v.length);for(let p=0,k=v.length;p<k;p++)h.buffer[p]=v[p];return h}static concat(v,h){if(typeof h=="undefined"){h=0;for(let A=0,x=v.length;A<x;A++)h+=v[A].byteLength}const p=y.alloc(h);let k=0;for(let A=0,x=v.length;A<x;A++){const w=v[A];p.set(w,k),k+=w.byteLength}return p}clone(){const v=y.alloc(this.byteLength);return v.set(this),v}toString(){return I?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(v,h){return new y(this.buffer.subarray(v,h))}set(v,h){if(v instanceof y)this.buffer.set(v.buffer,h);else if(v instanceof Uint8Array)this.buffer.set(v,h);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),h);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return R(this.buffer,v)}writeUInt32BE(v,h){M(this.buffer,v,h)}readUInt32LE(v){return b(this.buffer,v)}writeUInt32LE(v,h){l(this.buffer,v,h)}readUInt8(v){return g(this.buffer,v)}writeUInt8(v,h){a(this.buffer,v,h)}}e.VSBuffer=y;function T(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=T;function C(c,v,h){c[h+0]=v&255,v=v>>>8,c[h+1]=v&255}e.writeUInt16LE=C;function R(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=R;function M(c,v,h){c[h+3]=v,v=v>>>8,c[h+2]=v,v=v>>>8,c[h+1]=v,v=v>>>8,c[h]=v}e.writeUInt32BE=M;function b(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=b;function l(c,v,h){c[h+0]=v&255,v=v>>>8,c[h+1]=v&255,v=v>>>8,c[h+2]=v&255,v=v>>>8,c[h+3]=v&255}e.writeUInt32LE=l;function g(c,v){return c[v]}e.readUInt8=g;function a(c,v,h){c[h]=v}e.writeUInt8=a;function n(c){return o.consumeReadable(c,v=>y.concat(v))}e.readableToBuffer=n;function d(c){return o.toReadable(c)}e.bufferToReadable=d;function S(c){return o.consumeStream(c,v=>y.concat(v))}e.streamToBuffer=S;async function N(c){return c.ended?y.concat(c.buffer):y.concat([...c.buffer,await S(c.stream)])}e.bufferedStreamToBuffer=N;function f(c){return o.toStream(c,v=>y.concat(v))}e.bufferToStream=f;function m(c){return o.transform(c,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}e.streamToBufferReadableStream=m;function E(c){return o.newWriteableStream(v=>y.concat(v),c)}e.newWriteableBufferStream=E;function r(c,v){return o.prefixedReadable(c,v,h=>y.concat(h))}e.prefixedBufferReadable=r;function P(c,v){return o.prefixedStream(c,v,h=>y.concat(h))}e.prefixedBufferStream=P;function u(c){let v=0,h=0,p=0;const k=new Uint8Array(Math.floor(c.length/4*3)),A=w=>{switch(h){case 3:k[p++]=v|w,h=0;break;case 2:k[p++]=v|w>>>2,v=w<<6,h=3;break;case 1:k[p++]=v|w>>>4,v=w<<4,h=2;break;default:v=w<<2,h=1}};for(let w=0;w<c.length;w++){const z=c.charCodeAt(w);if(z>=65&&z<=90)A(z-65);else if(z>=97&&z<=122)A(z-97+26);else if(z>=48&&z<=57)A(z-48+52);else if(z===43||z===45)A(62);else if(z===47||z===95)A(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${c[w]}`)}}const x=p;for(;h>0;)A(0);return y.wrap(k).slice(0,x)}e.decodeBase64=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},v=!0,h=!1){const p=h?s:i;let k="";const A=c.byteLength%3;let x=0;for(;x<c.byteLength-A;x+=3){const w=c[x+0],z=c[x+1],q=c[x+2];k+=p[w>>>2],k+=p[(w<<4|z>>>4)&63],k+=p[(z<<2|q>>>6)&63],k+=p[q&63]}if(A===1){const w=c[x+0];k+=p[w>>>2],k+=p[w<<4&63],v&&(k+="==")}else if(A===2){const w=c[x+0],z=c[x+1];k+=p[w>>>2],k+=p[(w<<4|z>>>4)&63],k+=p[z<<2&63],v&&(k+="=")}return k}e.encodeBase64=t});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[22],Ee([1,0,16,10]),function(J,e,o,I){"use strict";var _,B,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(u,i,s){let t=u.get(i);return t===void 0&&(t=s,u.set(i,t)),t}e.getOrSet=T;function C(u){const i=[];return u.forEach((s,t)=>{i.push(`${t} => ${s}`)}),`Map(${u.size}) {${i.join(", ")}}`}e.mapToString=C;function R(u){const i=[];return u.forEach(s=>{i.push(s)}),`Set(${u.size}) {${i.join(", ")}}`}e.setToString=R;class M{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return s-t}value(){return this._value[this._pos]}}e.StringIterator=M;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class l{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const t=this._value.charCodeAt(s);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,I.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class n{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(d||(d={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new a(i))}static forPaths(i=!1){return new S(new l(void 0,!i))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new b)}clear(){this._root=void 0}fill(i,s){if(s){const t=s.slice(0);(0,o.shuffle)(t);for(let c of t)this.set(c,i)}else{const t=i.slice(0);(0,o.shuffle)(t);for(let c of t)this.set(c[0],c[1])}}set(i,s){const t=this._iter.reset(i);let c;this._root||(this._root=new n,this._root.segment=t.value());const v=[];for(c=this._root;;){const p=t.cmp(c.segment);if(p>0)c.left||(c.left=new n,c.left.segment=t.value()),v.push([-1,c]),c=c.left;else if(p<0)c.right||(c.right=new n,c.right.segment=t.value()),v.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new n,c.mid.segment=t.value()),v.push([0,c]),c=c.mid;else break}const h=c.value;c.value=s,c.key=i;for(let p=v.length-1;p>=0;p--){const k=v[p][1];k.updateHeight();const A=k.balanceFactor();if(A<-1||A>1){const x=v[p][0],w=v[p+1][0];if(x===1&&w===1)v[p][1]=k.rotateLeft();else if(x===-1&&w===-1)v[p][1]=k.rotateRight();else if(x===1&&w===-1)k.right=v[p+1][1]=v[p+1][1].rotateRight(),v[p][1]=k.rotateLeft();else if(x===-1&&w===1)k.left=v[p+1][1]=v[p+1][1].rotateLeft(),v[p][1]=k.rotateRight();else throw new Error;if(p>0)switch(v[p-1][0]){case-1:v[p-1][1].left=v[p][1];break;case 1:v[p-1][1].right=v[p][1];break;case 0:v[p-1][1].mid=v[p][1];break}else this._root=v[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else break}return t}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const t=this._iter.reset(i),c=[];let v=this._root;for(;v;){const h=t.cmp(v.segment);if(h>0)c.push([-1,v]),v=v.left;else if(h<0)c.push([1,v]),v=v.right;else if(t.hasNext())t.next(),c.push([0,v]),v=v.mid;else break}if(!!v){if(s?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const h=this._min(v.right),{key:p,value:k,segment:A}=h;this._delete(h.key,!1),v.key=p,v.value=k,v.segment=A}else{const h=v.left??v.right;if(c.length>0){const[p,k]=c[c.length-1];switch(p){case-1:k.left=h;break;case 0:k.mid=h;break;case 1:k.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const p=c[h][1];p.updateHeight();const k=p.balanceFactor();if(k>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),c[h][1]=p.rotateLeft()):k<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),c[h][1]=p.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let t=this._root,c;for(;t;){const v=s.cmp(t.segment);if(v>0)t=t.left;else if(v<0)t=t.right;else if(s.hasNext())s.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(i){const s=this._iter.reset(i);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[s,t]of this)i(t,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const t=s.balanceFactor();return t<-1||t>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=S;class N{constructor(i,s){this.uri=i,this.value=s}}class f{constructor(i,s){this[_]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new N(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[t,c]of this.map)i(c.value,c.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=u=>u.toString();var m;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class E{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const t=this._map.get(i);if(!!t)return s!==0&&this.touch(t,s),t.value}set(i,s,t=0){let c=this._map.get(i);if(c)c.value=s,t!==0&&this.touch(c,t);else{switch(c={key:i,value:s,next:void 0,previous:void 0},t){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const t=this._state;let c=this._head;for(;c;){if(s?i.bind(s)(c.value,c.key,this):i(c.value,c.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const v={value:t.key,done:!1};return t=t.next,v}else return{value:void 0,done:!0}}};return c}values(){const i=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const v={value:t.value,done:!1};return t=t.next,v}else return{value:void 0,done:!0}}};return c}entries(){const i=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const v={value:[t.key,t.value],done:!1};return t=t.next,v}else return{value:void 0,done:!0}}};return c}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,t=this.size;for(;s&&t>i;)this._map.delete(s.key),s=s.next,t--;this._head=s,this._size=t,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,t=i.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const t=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(t.previous=c,c.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const t=i.next,c=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=c,c.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,t)=>{i.push([t,s])}),i}fromJSON(i){this.clear();for(const[s,t]of i)this.set(s,t)}}e.LinkedMap=E;class r extends E{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class P{constructor(i){y.set(this,void 0),je(this,y,i,"f")}get size(){return De(this,y,"f").size}forEach(i,s){De(this,y,"f").forEach(i,s)}get(i){return De(this,y,"f").get(i)}has(i){return De(this,y,"f").has(i)}entries(){return De(this,y,"f").entries()}keys(){return De(this,y,"f").keys()}values(){return De(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return De(this,y,"f").entries()}}e.ReadonlyMapView=P}),define(ve[104],Ee([1,0,22,10]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...D){return function(O,$){for(let X=0,re=D.length;X<re;X++){const pe=D[X](O,$);if(pe)return pe}return null}}e.or=_,e.matchesStrictPrefix=B.bind(void 0,!1),e.matchesPrefix=B.bind(void 0,!0);function B(D,O,$){if(!$||$.length<O.length)return null;let X;return D?X=I.startsWithIgnoreCase($,O):X=$.indexOf(O)===0,X?O.length>0?[{start:0,end:O.length}]:[]:null}function y(D,O){const $=O.toLowerCase().indexOf(D.toLowerCase());return $===-1?null:[{start:$,end:$+D.length}]}e.matchesContiguousSubString=y;function T(D,O){return C(D.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function C(D,O,$,X){if($===D.length)return[];if(X===O.length)return null;if(D[$]===O[X]){let re=null;return(re=C(D,O,$+1,X+1))?S({start:X,end:X+1},re):null}return C(D,O,$,X+1)}function R(D){return 97<=D&&D<=122}function M(D){return 65<=D&&D<=90}e.isUpper=M;function b(D){return 48<=D&&D<=57}function l(D){return D===32||D===9||D===10||D===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>g.add(D.charCodeAt(0)));function a(D){return l(D)||g.has(D)}function n(D,O){return D===O||a(D)&&a(O)}function d(D){return R(D)||M(D)||b(D)}function S(D,O){return O.length===0?O=[D]:D.end===O[0].start?O[0].start=D.start:O.unshift(D),O}function N(D,O){for(let $=O;$<D.length;$++){const X=D.charCodeAt($);if(M(X)||b(X)||$>0&&!d(D.charCodeAt($-1)))return $}return D.length}function f(D,O,$,X){if($===D.length)return[];if(X===O.length)return null;if(D[$]!==O[X].toLowerCase())return null;{let re=null,pe=X+1;for(re=f(D,O,$+1,X+1);!re&&(pe=N(O,pe))<O.length;)re=f(D,O,$+1,pe),pe++;return re===null?null:S({start:X,end:X+1},re)}}function m(D){let O=0,$=0,X=0,re=0,pe=0;for(let xe=0;xe<D.length;xe++)pe=D.charCodeAt(xe),M(pe)&&O++,R(pe)&&$++,d(pe)&&X++,b(pe)&&re++;const Ce=O/D.length,Me=$/D.length,Le=X/D.length,ze=re/D.length;return{upperPercent:Ce,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function E(D){const{upperPercent:O,lowerPercent:$}=D;return $===0&&O>.6}function r(D){const{upperPercent:O,lowerPercent:$,alphaPercent:X,numericPercent:re}=D;return $>.2&&O<.8&&X>.6&&re<.2}function P(D){let O=0,$=0,X=0,re=0;for(let pe=0;pe<D.length;pe++)X=D.charCodeAt(pe),M(X)&&O++,R(X)&&$++,l(X)&&re++;return(O===0||$===0)&&re===0?D.length<=30:O<=5}function u(D,O){if(!O||(O=O.trim(),O.length===0)||!P(D)||O.length>60)return null;const $=m(O);if(!r($)){if(!E($))return null;O=O.toLowerCase()}let X=null,re=0;for(D=D.toLowerCase();re<O.length&&(X=f(D,O,0,re))===null;)re=N(O,re+1);return X}e.matchesCamelCase=u;function i(D,O,$=!1){if(!O||O.length===0)return null;let X=null,re=0;for(D=D.toLowerCase(),O=O.toLowerCase();re<O.length&&(X=s(D,O,0,re,$))===null;)re=t(O,re+1);return X}e.matchesWords=i;function s(D,O,$,X,re){if($===D.length)return[];if(X===O.length)return null;if(n(D.charCodeAt($),O.charCodeAt(X))){let pe=null,Ce=X+1;if(pe=s(D,O,$+1,X+1,re),!re)for(;!pe&&(Ce=t(O,Ce))<O.length;)pe=s(D,O,$+1,Ce,re),Ce++;return pe===null?null:S({start:X,end:X+1},pe)}else return null}function t(D,O){for(let $=O;$<D.length;$++)if(a(D.charCodeAt($))||$>0&&a(D.charCodeAt($-1)))return $;return D.length}const c=_(e.matchesPrefix,u,y),v=_(e.matchesPrefix,u,T),h=new o.LRUCache(1e4);function p(D,O,$=!1){if(typeof D!="string"||typeof O!="string")return null;let X=h.get(D);X||(X=new RegExp(I.convertSimple2RegExpPattern(D),"i"),h.set(D,X));const re=X.exec(O);return re?[{start:re.index,end:re.index+re[0].length}]:$?v(D,O):c(D,O)}e.matchesFuzzy=p;function k(D,O){const $=Ae(D,D.toLowerCase(),0,O,O.toLowerCase(),0,!0);return $?x($):null}e.matchesFuzzy2=k;function A(D,O,$,X,re,pe){const Ce=Math.min(13,D.length);for(;$<Ce;$++){const Me=Ae(D,O,$,X,re,pe,!1);if(Me)return Me}return[0,pe]}e.anyScore=A;function x(D){if(typeof D=="undefined")return[];const O=[],$=D[1];for(let X=D.length-1;X>1;X--){const re=D[X]+$,pe=O[O.length-1];pe&&pe.end===re?pe.end=re+1:O.push({start:re,end:re+1})}return O}e.createMatches=x;const w=128;function z(){const D=[],O=[];for(let $=0;$<=w;$++)O[$]=0;for(let $=0;$<=w;$++)D.push(O.slice(0));return D}function q(D){const O=[];for(let $=0;$<=D;$++)O[$]=0;return O}const H=q(2*w),W=q(2*w),Q=z(),V=z(),te=z(),oe=!1;function ie(D,O,$,X,re){function pe(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ce=` |   |${X.split("").map(Me=>pe(Me,3)).join("|")}
`;for(let Me=0;Me<=$;Me++)Me===0?Ce+=" |":Ce+=`${O[Me-1]}|`,Ce+=D[Me].slice(0,re+1).map(Le=>pe(Le.toString(),3)).join("|")+`
`;return Ce}function ue(D,O,$,X){D=D.substr(O),$=$.substr(X),console.log(ie(V,D,D.length,$,$.length)),console.log(ie(te,D,D.length,$,$.length)),console.log(ie(Q,D,D.length,$,$.length))}function he(D,O){if(O<0||O>=D.length)return!1;const $=D.codePointAt(O);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise($)}}function Se(D,O){if(O<0||O>=D.length)return!1;switch(D.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function fe(D,O,$){return O[D]!==$[D]}function ne(D,O,$,X,re,pe,Ce=!1){for(;O<$&&re<pe;)D[O]===X[re]&&(Ce&&(H[O]=re),O+=1),re+=1;return O===$}e.isPatternInWord=ne;var me;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(me||(me={}));var Ie;(function(D){D.Default=[-100,0];function O($){return!$||$.length===2&&$[0]===-100&&$[1]===0}D.isDefault=O})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Ae(D,O,$,X,re,pe,Ce){const Me=D.length>w?w:D.length,Le=X.length>w?w:X.length;if($>=Me||pe>=Le||Me-$>Le-pe||!ne(O,$,Me,re,pe,Le,!0))return;Ue(Me,Le,$,pe,O,re);let ze=1,xe=1,Oe=$,Xe=pe;const et=[!1];for(ze=1,Oe=$;Oe<Me;ze++,Oe++){const ce=H[Oe],Re=W[Oe],$e=Oe+1<Me?W[Oe+1]:Le;for(xe=ce-pe+1,Xe=ce;Xe<$e;xe++,Xe++){let Ke=Number.MIN_SAFE_INTEGER,Qe=!1;Xe<=Re&&(Ke=Ge(D,O,Oe,$,X,re,Xe,Le,pe,Q[ze-1][xe-1]===0,et));let ht=0;Ke!==Number.MAX_SAFE_INTEGER&&(Qe=!0,ht=Ke+V[ze-1][xe-1]);const _t=Xe>ce,yt=_t?V[ze][xe-1]+(Q[ze][xe-1]>0?-5:0):0,Tt=Xe>ce+1&&Q[ze][xe-1]>0,Ve=Tt?V[ze][xe-2]+(Q[ze][xe-2]>0?-5:0):0;if(Tt&&(!_t||Ve>=yt)&&(!Qe||Ve>=ht))V[ze][xe]=Ve,te[ze][xe]=3,Q[ze][xe]=0;else if(_t&&(!Qe||yt>=ht))V[ze][xe]=yt,te[ze][xe]=2,Q[ze][xe]=0;else if(Qe)V[ze][xe]=ht,te[ze][xe]=1,Q[ze][xe]=Q[ze-1][xe-1]+1;else throw new Error("not possible")}}if(oe&&ue(D,$,X,pe),!et[0]&&!Ce)return;ze--,xe--;const ke=[V[ze][xe],pe];let tt=0,G=0;for(;ze>=1;){let ce=xe;do{const Re=te[ze][ce];if(Re===3)ce=ce-2;else if(Re===2)ce=ce-1;else break}while(ce>=1);tt>1&&O[$+ze-1]===re[pe+xe-1]&&!fe(ce+pe-1,X,re)&&tt+1>Q[ze][ce]&&(ce=xe),ce===xe?tt++:tt=1,G||(G=ce),ze--,xe=ce-1,ke.push(xe)}Le===Me&&(ke[0]+=2);const Y=G-Me;return ke[0]-=Y,ke}e.fuzzyScore=Ae;function Ue(D,O,$,X,re,pe){let Ce=D-1,Me=O-1;for(;Ce>=$&&Me>=X;)re[Ce]===pe[Me]&&(W[Ce]=Me,Ce--),Me--}function Ge(D,O,$,X,re,pe,Ce,Me,Le,ze,xe){if(O[$]!==pe[Ce])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return Ce===$-X?Oe=D[$]===re[Ce]?7:5:fe(Ce,re,pe)&&(Ce===0||!fe(Ce-1,re,pe))?(Oe=D[$]===re[Ce]?7:5,Xe=!0):he(pe,Ce)&&(Ce===0||!he(pe,Ce-1))?Oe=5:(he(pe,Ce-1)||Se(pe,Ce-1))&&(Oe=5,Xe=!0),Oe>1&&$===X&&(xe[0]=!0),Xe||(Xe=fe(Ce,re,pe)||he(pe,Ce-1)||Se(pe,Ce-1)),$===X?Ce>Le&&(Oe-=Xe?3:5):ze?Oe+=Xe?2:0:Oe+=Xe?0:1,Ce+1===Me&&(Oe-=Xe?3:5),Oe}function ge(D,O,$,X,re,pe,Ce){return L(D,O,$,X,re,pe,!0,Ce)}e.fuzzyScoreGracefulAggressive=ge;function de(D,O,$,X,re,pe,Ce){return L(D,O,$,X,re,pe,!1,Ce)}e.fuzzyScoreGraceful=de;function L(D,O,$,X,re,pe,Ce,Me){let Le=Ae(D,O,$,X,re,pe,Me);if(Le&&!Ce)return Le;if(D.length>=3){const ze=Math.min(7,D.length-1);for(let xe=$+1;xe<ze;xe++){const Oe=F(D,xe);if(Oe){const Xe=Ae(Oe,Oe.toLowerCase(),$,X,re,pe,Me);Xe&&(Xe[0]-=3,(!Le||Xe[0]>Le[0])&&(Le=Xe))}}}return Le}function F(D,O){if(O+1>=D.length)return;const $=D[O],X=D[O+1];if($!==X)return D.slice(0,O)+X+$+D.slice(O+2)}}),define(ve[105],Ee([1,0,106,104,10]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const B=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(o.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${B.source}`,"g");function C(d){return d.replace(T,(S,N)=>N?S:`\\${S}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${B.source}`,"g");function M(d){return d.replace(R,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=M;const b=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function l(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(b,(S,N,f,m)=>f?S:N||m||"")}e.stripIcons=l;function g(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:a(d,S)}e.parseLabelWithIcons=g;function a(d,S){const N=[];let f="";function m(c){if(c){f+=c;for(const v of c)N.push(P)}}let E=-1,r="",P=0,u,i,s=S;const t=d.length;for(m(d.substr(0,S));s<t;)u=d[s],i=d[s+1],u===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(E=s,m(r),r=e.iconStartMarker,s++):u===")"&&E!==-1?(P+=s-E+1,E=-1,r=""):E!==-1?y.test(u)?r+=u:(m(r),E=-1,r=""):m(u),s++;return m(r),{text:f,iconOffsets:N}}function n(d,S,N=!1){const{text:f,iconOffsets:m}=S;if(!m||m.length===0)return(0,I.matchesFuzzy)(d,f,N);const E=(0,_.ltrim)(f," "),r=f.length-E.length,P=(0,I.matchesFuzzy)(d,E,N);if(P)for(const u of P){const i=m[u.start+r]+r;u.start+=i,u.end+=i}return P}e.matchesFuzzyIconAware=n}),define(ve[34],Ee([1,0,10]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(I||(I={})),function(_){const B="error",y="warning",T="warn",C="info",R="ignore";function M(l){return l?o.equalsIgnoreCase(B,l)?_.Error:o.equalsIgnoreCase(y,l)||o.equalsIgnoreCase(T,l)?_.Warning:o.equalsIgnoreCase(C,l)?_.Info:_.Ignore:_.Ignore}_.fromValue=M;function b(l){switch(l){case _.Error:return B;case _.Warning:return y;case _.Info:return C;default:return R}}_.toString=b}(I||(I={})),e.default=I}),define(ve[35],Ee([1,0,17,23,10,13]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function T(s){return s.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=T;function C(s){return s.indexOf("/")===-1&&(s=T(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function R(s,t=o.posix.sep){if(!s)return"";const c=s.length,v=s.charCodeAt(0);if(y(v)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let p=3;const k=p;for(;p<c&&!y(s.charCodeAt(p));p++);if(k!==p&&!y(s.charCodeAt(p+1))){for(p+=1;p<c;p++)if(y(s.charCodeAt(p)))return s.slice(0,p+1).replace(/[\\/]/g,t)}}return t}else if(S(v)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+t:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(y(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=R;function M(s){if(!I.isWindows||!s||s.length<5)return!1;let t=s.charCodeAt(0);if(t!==92||(t=s.charCodeAt(1),t!==92))return!1;let c=2;const v=c;for(;c<s.length&&(t=s.charCodeAt(c),t!==92);c++);return!(v===c||(t=s.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=M;const b=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(s,t=I.isWindows){const c=t?b:l;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||t&&g.test(s)||s==="."||s===".."||t&&s[s.length-1]==="."||t&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=a;function n(s,t,c){const v=s===t;return!c||v?v:!s||!t?!1:(0,_.equalsIgnoreCase)(s,t)}e.isEqual=n;function d(s,t,c,v=o.sep){if(s===t)return!0;if(!s||!t||t.length>s.length)return!1;if(c){if(!(0,_.startsWithIgnoreCase)(s,t))return!1;if(t.length===s.length)return!0;let p=t.length;return t.charAt(t.length-1)===v&&p--,s.charAt(p)===v}return t.charAt(t.length-1)!==v&&(t+=v),s.indexOf(t)===0}e.isEqualOrParent=d;function S(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=S;function N(s,t){return I.isWindows&&s.endsWith(":")&&(s+=o.sep),(0,o.isAbsolute)(s)||(s=(0,o.join)(t,s)),s=(0,o.normalize)(s),I.isWindows?(s=(0,_.rtrim)(s,o.sep),s.endsWith(":")&&(s+=o.sep)):(s=(0,_.rtrim)(s,o.sep),s||(s=o.sep)),s}e.sanitizeFilePath=N;function f(s){const t=(0,o.normalize)(s);return I.isWindows?s.length>3?!1:m(t)&&(s.length===2||t.charCodeAt(2)===92):t===o.posix.sep}e.isRootOrDriveLetter=f;function m(s,t){return(t!==void 0?t:I.isWindows)?S(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function E(s){return m(s)?s[0]:void 0}e.getDriveLetter=E;function r(s,t,c){return t.length>s.length?-1:s===t?0:(c&&(s=s.toLowerCase(),t=t.toLowerCase()),s.indexOf(t))}e.indexOfPath=r;function P(s){const t=s.split(":");let c,v,h;for(const p of t){const k=Number(p);(0,B.isNumber)(k)?v===void 0?v=k:h===void 0&&(h=k):c=c?[c,p].join(":"):p}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:h!==void 0?h:v!==void 0?1:void 0}}e.parseLineAndColumnAware=P;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,t,c=8){let v="";for(let p=0;p<c;p++)v+=u.charAt(Math.floor(Math.random()*u.length));let h;return t?h=`${t}-${v}`:h=v,s?(0,o.join)(s,h):h}e.randomPath=i}),define(ve[54],Ee([1,0,21,10,2]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function B(M){return JSON.stringify(M,C)}e.stringify=B;function y(M){let b=JSON.parse(M);return b=R(b),b}e.parse=y;var T;(function(M){M[M.Uri=1]="Uri",M[M.Regexp=2]="Regexp",M[M.ScmResource=3]="ScmResource",M[M.ScmResourceGroup=4]="ScmResourceGroup",M[M.ScmProvider=5]="ScmProvider",M[M.CommentController=6]="CommentController",M[M.CommentThread=7]="CommentThread",M[M.CommentThreadReply=8]="CommentThreadReply",M[M.CommentNode=9]="CommentNode",M[M.CommentThreadNode=10]="CommentThreadNode",M[M.TimelineActionContext=11]="TimelineActionContext",M[M.NotebookCellActionContext=12]="NotebookCellActionContext",M[M.TestItemContext=13]="TestItemContext",M[M.Date=14]="Date"})(T=e.MarshalledId||(e.MarshalledId={}));function C(M,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,I.regExpFlags)(b)}:b}function R(M,b=0){if(!M||b>200)return M;if(typeof M=="object"){switch(M.$mid){case 1:return _.URI.revive(M);case 2:return new RegExp(M.source,M.flags);case 14:return new Date(M.source)}if(M instanceof o.VSBuffer||M instanceof Uint8Array)return M;if(Array.isArray(M))for(let l=0;l<M.length;++l)M[l]=R(M[l],b+1);else for(const l in M)Object.hasOwnProperty.call(M,l)&&(M[l]=R(M[l],b+1))}return M}e.revive=R}),define(ve[9],Ee([1,0,23,2]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(_=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,R,M){this._hosts[C]=R,this._ports[C]=M}setConnectionToken(C,R){this._connectionTokens[C]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let M=this._hosts[R];M&&M.indexOf(":")!==-1&&(M=`[${M}]`);const b=this._ports[R],l=this._connectionTokens[R];let g=`path=${encodeURIComponent(C.path)}`;return typeof l=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(l)}`),I.URI.from({scheme:o.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${M}:${b}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new B;class y{asBrowserUri(C,R){const M=this.toUri(C,R);return M.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===_.file&&(o.isNative||typeof o.globals.importScripts=="function"&&o.globals.origin===`${_.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?M.with({scheme:_.vscodeFileResource,authority:M.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):M}asFileUri(C,R){const M=this.toUri(C,R);return M.scheme===_.vscodeFileResource?M.with({scheme:_.file,authority:M.authority!==y.FALLBACK_AUTHORITY?M.authority:null,query:null,fragment:null}):M}toUri(C,R){return I.URI.isUri(C)?C:I.URI.parse(R.toUrl(C))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(ve[24],Ee([1,0,35,9,17,23,10,2]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=C;class R{constructor(a){this._ignorePathCasing=a}compare(a,n,d=!1){return a===n?0:(0,y.compare)(this.getComparisonKey(a,d),this.getComparisonKey(n,d))}isEqual(a,n,d=!1){return a===n?!0:!a||!n?!1:this.getComparisonKey(a,d)===this.getComparisonKey(n,d)}getComparisonKey(a,n=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,n,d=!1){if(a.scheme===n.scheme){if(a.scheme===I.Schemas.file)return o.isEqualOrParent(C(a),C(n),this._ignorePathCasing(a))&&a.query===n.query&&(d||a.fragment===n.fragment);if((0,e.isEqualAuthority)(a.authority,n.authority))return o.isEqualOrParent(a.path,n.path,this._ignorePathCasing(a),"/")&&a.query===n.query&&(d||a.fragment===n.fragment)}return!1}joinPath(a,...n){return T.URI.joinPath(a,...n)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return _.posix.basename(a.path)}extname(a){return _.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let n;return a.scheme===I.Schemas.file?n=T.URI.file(_.dirname(C(a))).path:(n=_.posix.dirname(a.path),a.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),n="/")),a.with({path:n})}normalizePath(a){if(!a.path.length)return a;let n;return a.scheme===I.Schemas.file?n=T.URI.file(_.normalize(C(a))).path:n=_.posix.normalize(a.path),a.with({path:n})}relativePath(a,n){if(a.scheme!==n.scheme||!(0,e.isEqualAuthority)(a.authority,n.authority))return;if(a.scheme===I.Schemas.file){const N=_.relative(C(a),C(n));return B.isWindows?o.toSlashes(N):N}let d=a.path||"/",S=n.path||"/";if(this._ignorePathCasing(a)){let N=0;for(const f=Math.min(d.length,S.length);N<f&&!(d.charCodeAt(N)!==S.charCodeAt(N)&&d.charAt(N).toLowerCase()!==S.charAt(N).toLowerCase());N++);d=S.substr(0,N)+d.substr(N)}return _.posix.relative(d,S)}resolvePath(a,n){if(a.scheme===I.Schemas.file){const d=T.URI.file(_.resolve(C(a),n));return a.with({authority:d.authority,path:d.path})}return n=o.toPosixPath(n),a.with({path:_.posix.resolve(a.path,n)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,n){return a===n||a!==void 0&&n!==void 0&&(0,y.equalsIgnoreCase)(a,n)}hasTrailingPathSeparator(a,n=_.sep){if(a.scheme===I.Schemas.file){const d=C(a);return d.length>o.getRoot(d).length&&d[d.length-1]===n}else{const d=a.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,n=_.sep){return(0,e.hasTrailingPathSeparator)(a,n)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,n=_.sep){let d=!1;if(a.scheme===I.Schemas.file){const S=C(a);d=S!==void 0&&S.length===o.getRoot(S).length&&S[S.length-1]===n}else{n="/";const S=a.path;d=S.length===1&&S.charCodeAt(S.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(a,n)?a.with({path:a.path+"/"}):a}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(g=>g.scheme===I.Schemas.file?!B.isLinux:!0),e.extUriIgnorePathCase=new R(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(g,a){const n=[];for(let d=0;d<g.length;d++){const S=a(g[d]);g.some((N,f)=>f===d?!1:(0,e.isEqualOrParent)(S,a(N)))||n.push(g[d])}return n}e.distinctParents=M;var b;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(n){const d=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(f=>{const[m,E]=f.split(":");m&&E&&d.set(m,E)});const N=n.path.substring(0,n.path.indexOf(";"));return N&&d.set(g.META_DATA_MIME,N),d}g.parseMetaData=a})(b=e.DataUri||(e.DataUri={}));function l(g,a,n){if(a){let d=g.path;return d&&d[0]!==_.posix.sep&&(d=_.posix.sep+d),g.with({scheme:n,authority:a,path:d})}return g.with({scheme:n})}e.toLocalResource=l}),define(ve[11],Ee([1,0,20,15,5,6,24,23]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=C;function R(fe){const ne=new o.CancellationTokenSource,me=fe(ne.token),Ie=new Promise((Ae,Ue)=>{const Ge=ne.token.onCancellationRequested(()=>{Ge.dispose(),ne.dispose(),Ue(new I.CancellationError)});Promise.resolve(me).then(ge=>{Ge.dispose(),ne.dispose(),Ae(ge)},ge=>{Ge.dispose(),ne.dispose(),Ue(ge)})});return new class{cancel(){ne.cancel()}then(Ae,Ue){return Ie.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return Ie.finally(Ae)}}}e.createCancelablePromise=R;function M(fe,ne,me){return new Promise((Ie,Ae)=>{const Ue=ne.onCancellationRequested(()=>{Ue.dispose(),Ie(me)});fe.then(Ie,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=M;function b(fe,ne){return new Promise((me,Ie)=>{const Ae=ne.onCancellationRequested(()=>{Ae.dispose(),Ie(new I.CancellationError)});fe.then(me,Ie).finally(()=>Ae.dispose())})}e.raceCancellationError=b;async function l(fe){let ne=-1;const me=fe.map((Ae,Ue)=>Ae.then(Ge=>(ne=Ue,Ge))),Ie=await Promise.race(me);return fe.forEach((Ae,Ue)=>{Ue!==ne&&Ae.cancel()}),Ie}e.raceCancellablePromises=l;function g(fe,ne,me){let Ie;const Ae=setTimeout(()=>{Ie?.(void 0),me?.()},ne);return Promise.race([fe.finally(()=>clearTimeout(Ae)),new Promise(Ue=>Ie=Ue)])}e.raceTimeout=g;function a(fe){return new Promise((ne,me)=>{const Ie=fe();C(Ie)?Ie.then(ne,me):ne(Ie)})}e.asPromise=a;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const Ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ie};this.queuedPromise=new Promise(Ie=>{this.activePromise.then(me,me).then(Ie)})}return new Promise((me,Ie)=>{this.queuedPromise.then(me,Ie)})}return this.activePromise=ne(),new Promise((me,Ie)=>{this.activePromise.then(Ae=>{this.activePromise=null,me(Ae)},Ae=>{this.activePromise=null,Ie(Ae)})})}}e.Throttler=n;class d{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(ne,me){const Ae=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ne)===Ae&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ae),Ae}}e.SequencerByKey=S;const N=(fe,ne)=>{let me=!0;const Ie=setTimeout(()=>{me=!1,ne()},fe);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Ie),me=!1}}},f=fe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,fe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,me=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ae,Ue)=>{this.doResolve=Ae,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ae=this.task;return this.task=null,Ae()}}));const Ie=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?f(Ie):N(me,Ie),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class E{constructor(ne){this.delayer=new m(ne),this.throttler=new n}trigger(ne,me){return this.delayer.trigger(()=>this.throttler.queue(ne),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class r{constructor(){this._isOpen=!1,this._promise=new Promise((ne,me)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class P extends r{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=P;function u(fe,ne){return ne?new Promise((me,Ie)=>{const Ae=setTimeout(()=>{Ue.dispose(),me()},fe),Ue=ne.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),Ie(new I.CancellationError)})}):R(me=>u(fe,me))}e.timeout=u;function i(fe,ne=0){const me=setTimeout(fe,ne);return(0,B.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=i;function s(fe){const ne=[];let me=0;const Ie=fe.length;function Ae(){return me<Ie?fe[me++]():null}function Ue(Ge){Ge!=null&&ne.push(Ge);const ge=Ae();return ge?ge.then(Ue):Promise.resolve(ne)}return Promise.resolve(null).then(Ue)}e.sequence=s;function t(fe,ne=Ie=>!!Ie,me=null){let Ie=0;const Ae=fe.length,Ue=()=>{if(Ie>=Ae)return Promise.resolve(me);const Ge=fe[Ie++];return Promise.resolve(Ge()).then(de=>ne(de)?Promise.resolve(de):Ue())};return Ue()}e.first=t;function c(fe,ne=Ie=>!!Ie,me=null){if(fe.length===0)return Promise.resolve(me);let Ie=fe.length;const Ae=()=>{Ie=-1;for(const Ue of fe)Ue.cancel?.()};return new Promise((Ue,Ge)=>{for(const ge of fe)ge.then(de=>{--Ie>=0&&ne(de)?(Ae(),Ue(de)):Ie===0&&Ue(me)}).catch(de=>{--Ie>=0&&(Ae(),Ge(de))})})}e.firstParallel=c;class v{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(ne){return this._size++,new Promise((me,Ie)=>{this.outstandingPromises.push({factory:ne,c:me,e:Ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const me=ne.factory();me.then(ne.c,ne.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class h extends v{constructor(){super(1)}}e.Queue=h;class p{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new te;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,me=y.extUri){const Ie=me.getComparisonKey(ne);let Ae=this.queues.get(Ie);return Ae||(Ae=new h,_.Event.once(Ae.onFinished)(()=>{Ae?.dispose(),this.queues.delete(Ie),this.onDidQueueFinish()}),this.queues.set(Ie,Ae)),Ae}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=p;class k{constructor(ne,me){this._token=-1,typeof ne=="function"&&typeof me=="number"&&this.setIfNotSet(ne,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},me)}setIfNotSet(ne,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},me))}}e.TimeoutTimer=k;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setInterval(()=>{ne()},me)}}e.IntervalTimer=A;class x{constructor(ne,me){this.timeoutToken=-1,this.runner=ne,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=x;class w{constructor(ne,me){me%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=w;class z extends x{constructor(ne,me){super(ne,me);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner&&this.runner(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class q extends B.Disposable{constructor(ne,me){super();this.options=ne,this.handler=me,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,T.setTimeout0)(()=>{if(ne)return;const me=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(fe,ne)=>{const me=requestIdleCallback(fe,typeof ne=="number"?{timeout:ne}:void 0);let Ie=!1;return{dispose(){Ie||(Ie=!0,cancelIdleCallback(me))}}}}();class H{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function W(fe,ne,me){let Ie;for(let Ae=0;Ae<me;Ae++)try{return await fe()}catch(Ue){Ie=Ue,await u(ne)}throw Ie}e.retry=W;class Q{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,me,Ie){return this._pending={taskId:ne,cancel:()=>Ie?.(),promise:me},me.then(()=>this.donePending(ne),()=>this.donePending(ne)),me}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let me,Ie;const Ae=new Promise((Ue,Ge)=>{me=Ue,Ie=Ge});this._next={run:ne,promise:Ae,promiseResolve:me,promiseReject:Ie}}return this._next.promise}}e.TaskSequentializer=Q;class V{constructor(ne,me=()=>Date.now()){this.interval=ne,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class te{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,me)=>{this.completeCallback=ne,this.errorCallback=me})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(me=>{this.completeCallback(ne),this.resolved=!0,me()})}error(ne){return new Promise(me=>{this.errorCallback(ne),this.rejected=!0,me()})}cancel(){new Promise(ne=>{this.errorCallback(new I.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=te;var oe;(function(fe){async function ne(Ie){let Ae;const Ue=await Promise.all(Ie.map(Ge=>Ge.then(ge=>ge,ge=>{Ae||(Ae=ge)})));if(typeof Ae!="undefined")throw Ae;return Ue}fe.settled=ne;function me(Ie){return new Promise(async(Ae,Ue)=>{try{await Ie(Ae,Ue)}catch(Ge){Ue(Ge)}})}fe.withAsyncBody=me})(oe=e.Promises||(e.Promises={}));var ie;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(ie||(ie={}));class ue{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const me={emitOne:Ie=>this.emitOne(Ie),emitMany:Ie=>this.emitMany(Ie),reject:Ie=>this.reject(Ie)};try{await Promise.resolve(ne(me)),this.resolve()}catch(Ie){this.reject(Ie)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}static fromArray(ne){return new ue(me=>{me.emitMany(ne)})}static fromPromise(ne){return new ue(async me=>{me.emitMany(await ne)})}static fromPromises(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>me.emitOne(await Ie)))})}static merge(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>{for await(const Ae of Ie)me.emitOne(Ae)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,me){return new ue(async Ie=>{for await(const Ae of ne)Ie.emitOne(me(Ae))})}map(ne){return ue.map(this,ne)}static filter(ne,me){return new ue(async Ie=>{for await(const Ae of ne)me(Ae)&&Ie.emitOne(Ae)})}filter(ne){return ue.filter(this,ne)}static coalesce(ne){return ue.filter(ne,me=>!!me)}coalesce(){return ue.coalesce(this)}static async toPromise(ne){const me=[];for await(const Ie of ne)me.push(Ie);return me}toPromise(){return ue.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class he extends ue{constructor(ne,me){super(me);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=he;function Se(fe){const ne=new o.CancellationTokenSource,me=fe(ne.token);return new he(ne,async Ie=>{const Ae=ne.token.onCancellationRequested(()=>{Ae.dispose(),ne.dispose(),Ie.reject(new I.CancellationError)});try{for await(const Ue of me){if(ne.token.isCancellationRequested)return;Ie.emitOne(Ue)}Ae.dispose(),ne.dispose()}catch(Ue){Ae.dispose(),ne.dispose(),Ie.reject(Ue)}})}e.createCancelableAsyncIterable=Se}),define(ve[107],Ee([1,0,11,17]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new o.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),B=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(h,p,k=!1){const A=h||"",x=p||"",w=_.value.collator.compare(A,x);return _.value.collatorIsNumeric&&w===0&&A!==x?A<x?-1:1:w}e.compareFileNames=T;function C(h,p){const k=B.value.collator;return h=h||"",p=p||"",E(k,h,p)}e.compareFileNamesDefault=C;function R(h,p){const k=B.value.collator;return h=h||"",p=p||"",i(h,p)||E(k,h,p)}e.compareFileNamesUpper=R;function M(h,p){const k=B.value.collator;return h=h||"",p=p||"",u(h,p)||E(k,h,p)}e.compareFileNamesLower=M;function b(h,p){return h=h||"",p=p||"",h===p?0:h<p?-1:1}e.compareFileNamesUnicode=b;function l(h,p,k=!1){k||(h=h&&h.toLowerCase(),p=p&&p.toLowerCase());const[A,x]=f(h),[w,z]=f(p);return A!==w?A<w?-1:1:x===z?0:x<z?-1:1}e.noIntlCompareFileNames=l;function g(h,p){const[k,A]=f(h),[x,w]=f(p);let z=_.value.collator.compare(A,w);if(z===0){if(_.value.collatorIsNumeric&&A!==w)return A<w?-1:1;if(z=_.value.collator.compare(k,x),_.value.collatorIsNumeric&&z===0&&k!==x)return k<x?-1:1}return z}e.compareFileExtensions=g;function a(h,p){h=h||"",p=p||"";const k=m(h),A=m(p),x=B.value.collator,w=y.value.collator;return E(w,k,A)||E(x,h,p)}e.compareFileExtensionsDefault=a;function n(h,p){h=h||"",p=p||"";const k=m(h),A=m(p),x=B.value.collator,w=y.value.collator;return E(w,k,A)||i(h,p)||E(x,h,p)}e.compareFileExtensionsUpper=n;function d(h,p){h=h||"",p=p||"";const k=m(h),A=m(p),x=B.value.collator,w=y.value.collator;return E(w,k,A)||u(h,p)||E(x,h,p)}e.compareFileExtensionsLower=d;function S(h,p){h=h||"",p=p||"";const k=m(h).toLowerCase(),A=m(p).toLowerCase();return k!==A?k<A?-1:1:h!==p?h<p?-1:1:0}e.compareFileExtensionsUnicode=S;const N=/^(.*?)(\.([^.]*))?$/;function f(h,p=!1){const k=h?N.exec(h):[];let A=[k&&k[1]||"",k&&k[3]||""];return p&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function m(h){const p=h?N.exec(h):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function E(h,p,k){let A=h.compare(p,k);return A!==0?A:p.length!==k.length?p.length<k.length?-1:1:0}function r(h){const p=h.charAt(0);return p.toLocaleUpperCase()!==p}function P(h){const p=h.charAt(0);return p.toLocaleLowerCase()!==p}function u(h,p){return r(h)&&P(p)?-1:P(h)&&r(p)?1:0}function i(h,p){return P(h)&&r(p)?-1:r(h)&&P(p)?1:0}function s(h,p,k=!1){return k||(h=h&&h.toLowerCase(),p=p&&p.toLowerCase()),h===p?0:h<p?-1:1}function t(h,p,k=!1){const A=h.split(I.sep),x=p.split(I.sep),w=A.length-1,z=x.length-1;let q,H;for(let W=0;;W++){if(q=w===W,H=z===W,q&&H)return T(A[W],x[W],k);if(q)return-1;if(H)return 1;const Q=s(A[W],x[W],k);if(Q!==0)return Q}}e.comparePaths=t;function c(h,p,k){const A=h.toLowerCase(),x=p.toLowerCase(),w=v(h,p,k);if(w)return w;const z=A.endsWith(k),q=x.endsWith(k);if(z!==q)return z?-1:1;const H=T(A,x);return H!==0?H:A.localeCompare(x)}e.compareAnything=c;function v(h,p,k){const A=h.toLowerCase(),x=p.toLowerCase(),w=A.startsWith(k),z=x.startsWith(k);if(w!==z)return w?-1:1;if(w&&z){if(A.length<x.length)return-1;if(A.length>x.length)return 1}return 0}e.compareByPrefix=v}),define(ve[29],Ee([1,0,11,35,22,17,23,10]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",M="[^/\\\\]",b=/\//g;function l(te){switch(te){case 0:return"";case 1:return`${M}*?`;default:return`(?:${R}|${M}+${R}|${R}${M}+)*?`}}function g(te,oe){if(!te)return[];const ie=[];let ue=!1,he=!1,Se="";for(const fe of te){switch(fe){case oe:if(!ue&&!he){ie.push(Se),Se="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":he=!0;break;case"]":he=!1;break}Se+=fe}return Se&&ie.push(Se),ie}e.splitGlobAware=g;function a(te){if(!te)return"";let oe="";const ie=g(te,e.GLOB_SPLIT);if(ie.every(ue=>ue===e.GLOBSTAR))oe=".*";else{let ue=!1;ie.forEach((he,Se)=>{if(he===e.GLOBSTAR){ue||(oe+=l(2),ue=!0);return}let fe=!1,ne="",me=!1,Ie="";for(const Ae of he){if(Ae!=="}"&&fe){ne+=Ae;continue}if(me&&(Ae!=="]"||!Ie)){let Ue;Ae==="-"?Ue=Ae:(Ae==="^"||Ae==="!")&&!Ie?Ue="^":Ae===e.GLOB_SPLIT?Ue="":Ue=(0,T.escapeRegExpCharacters)(Ae),Ie+=Ue;continue}switch(Ae){case"{":fe=!0;continue;case"[":me=!0;continue;case"}":{oe+=`(?:${g(ne,",").map(ge=>a(ge)).join("|")})`,fe=!1,ne="";break}case"]":oe+="["+Ie+"]",me=!1,Ie="";break;case"?":oe+=M;continue;case"*":oe+=l(1);continue;default:oe+=(0,T.escapeRegExpCharacters)(Ae)}}Se<ie.length-1&&(ie[Se+1]!==e.GLOBSTAR||Se+2<ie.length)&&(oe+=R),ue=!1})}return oe}const n=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,N=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,E=new _.LRUCache(1e4),r=function(){return!1},P=function(){return null};function u(te,oe){if(!te)return P;let ie;typeof te!="string"?ie=te.pattern:ie=te,ie=ie.trim();const ue=`${ie}_${!!oe.trimForExclusions}`;let he=E.get(ue);if(he)return i(he,te);let Se;if(n.test(ie)){const fe=ie.substr(4);he=function(ne,me){return typeof ne=="string"&&ne.endsWith(fe)?ie:null}}else(Se=d.exec(s(ie,oe)))?he=t(Se[1],ie):(oe.trimForExclusions?N:S).test(ie)?he=c(ie,oe):(Se=f.exec(s(ie,oe)))?he=v(Se[1].substr(1),ie,!0):(Se=m.exec(s(ie,oe)))?he=v(Se[1],ie,!1):he=h(ie);return E.set(ue,he),i(he,te)}function i(te,oe){return typeof oe=="string"?te:function(ie,ue){return(0,I.isEqualOrParent)(ie,oe.base,!y.isLinux)?te(ie.substr(oe.base.length+1),ue):null}}function s(te,oe){return oe.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function t(te,oe){const ie=`/${te}`,ue=`\\${te}`,he=function(fe,ne){return typeof fe!="string"?null:ne?ne===te?oe:null:fe===te||fe.endsWith(ie)||fe.endsWith(ue)?oe:null},Se=[te];return he.basenames=Se,he.patterns=[oe],he.allBasenames=Se,he}function c(te,oe){const ie=V(te.slice(1,-1).split(",").map(ne=>u(ne,oe)).filter(ne=>ne!==P),te),ue=ie.length;if(!ue)return P;if(ue===1)return ie[0];const he=function(ne,me){for(let Ie=0,Ae=ie.length;Ie<Ae;Ie++)if(ie[Ie](ne,me))return te;return null},Se=ie.find(ne=>!!ne.allBasenames);Se&&(he.allBasenames=Se.allBasenames);const fe=ie.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(he.allPaths=fe),he}function v(te,oe,ie){const ue=B.sep===B.posix.sep,he=ue?te:te.replace(b,B.sep),Se=B.sep+he,fe=B.posix.sep+te,ne=ie?function(me,Ie){return typeof me=="string"&&(me===he||me.endsWith(Se)||!ue&&(me===te||me.endsWith(fe)))?oe:null}:function(me,Ie){return typeof me=="string"&&(me===he||!ue&&me===te)?oe:null};return ne.allPaths=[(ie?"*/":"./")+te],ne}function h(te){try{const oe=new RegExp(`^${a(te)}$`);return function(ie){return oe.lastIndex=0,typeof ie=="string"&&oe.test(ie)?te:null}}catch{return P}}function p(te,oe,ie){return!te||typeof oe!="string"?!1:k(te)(oe,void 0,ie)}e.match=p;function k(te,oe={}){if(!te)return r;if(typeof te=="string"||z(te)){const ie=u(te,oe);if(ie===P)return r;const ue=function(he,Se){return!!ie(he,Se)};return ie.allBasenames&&(ue.allBasenames=ie.allBasenames),ie.allPaths&&(ue.allPaths=ie.allPaths),ue}return W(te,oe)}e.parse=k;function A(te){if(!te)return;let oe;return ie=>(oe||(oe=(te()||Promise.resolve([])).then(ue=>ue?w(ue):{})),oe.then(ue=>!!ue[ie]))}e.hasSiblingPromiseFn=A;function x(te){if(!te)return;let oe;return ie=>{if(!oe){const ue=te();oe=ue?w(ue):{}}return!!oe[ie]}}e.hasSiblingFn=x;function w(te){const oe={};for(const ie of te)oe[ie]=!0;return oe}function z(te){const oe=te;return oe?typeof oe.base=="string"&&typeof oe.pattern=="string":!1}e.isRelativePattern=z;function q(te){return te.allBasenames||[]}e.getBasenameTerms=q;function H(te){return te.allPaths||[]}e.getPathTerms=H;function W(te,oe){const ie=V(Object.getOwnPropertyNames(te).map(ne=>Q(ne,te[ne],oe)).filter(ne=>ne!==P)),ue=ie.length;if(!ue)return P;if(!ie.some(ne=>!!ne.requiresSiblings)){if(ue===1)return ie[0];const ne=function(Ae,Ue){for(let Ge=0,ge=ie.length;Ge<ge;Ge++){const de=ie[Ge](Ae,Ue);if(de)return de}return null},me=ie.find(Ae=>!!Ae.allBasenames);me&&(ne.allBasenames=me.allBasenames);const Ie=ie.reduce((Ae,Ue)=>Ue.allPaths?Ae.concat(Ue.allPaths):Ae,[]);return Ie.length&&(ne.allPaths=Ie),ne}const he=function(ne,me,Ie){let Ae;for(let Ue=0,Ge=ie.length;Ue<Ge;Ue++){const ge=ie[Ue];ge.requiresSiblings&&Ie&&(me||(me=(0,B.basename)(ne)),Ae||(Ae=me.substr(0,me.length-(0,B.extname)(ne).length)));const de=ge(ne,me,Ae,Ie);if(de)return de}return null},Se=ie.find(ne=>!!ne.allBasenames);Se&&(he.allBasenames=Se.allBasenames);const fe=ie.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(he.allPaths=fe),he}function Q(te,oe,ie){if(oe===!1)return P;const ue=u(te,ie);if(ue===P)return P;if(typeof oe=="boolean")return ue;if(oe){const he=oe.when;if(typeof he=="string"){const Se=(fe,ne,me,Ie)=>{if(!Ie||!ue(fe,ne))return null;const Ae=he.replace("$(basename)",me),Ue=Ie(Ae);return(0,o.isThenable)(Ue)?Ue.then(Ge=>Ge?te:null):Ue?te:null};return Se.requiresSiblings=!0,Se}}return ue}function V(te,oe){const ie=te.filter(ne=>!!ne.basenames);if(ie.length<2)return te;const ue=ie.reduce((ne,me)=>{const Ie=me.basenames;return Ie?ne.concat(Ie):ne},[]);let he;if(oe){he=[];for(let ne=0,me=ue.length;ne<me;ne++)he.push(oe)}else he=ie.reduce((ne,me)=>{const Ie=me.patterns;return Ie?ne.concat(Ie):ne},[]);const Se=function(ne,me){if(typeof ne!="string")return null;if(!me){let Ae;for(Ae=ne.length;Ae>0;Ae--){const Ue=ne.charCodeAt(Ae-1);if(Ue===47||Ue===92)break}me=ne.substr(Ae)}const Ie=ue.indexOf(me);return Ie!==-1?he[Ie]:null};Se.basenames=ue,Se.patterns=he,Se.allBasenames=ue;const fe=te.filter(ne=>!ne.basenames);return fe.push(Se),fe}}),define(ve[72],Ee([1,0,15,105,24,2]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(n="",d=!1){if(this.value=n,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(n,d=0){return this.value+=b(this.supportThemeIcons?(0,I.escapeIcons)(n):n).replace(/([ \t]+)/g,(S,N)=>"&nbsp;".repeat(N.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,d){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=T;function C(a){return R(a)?!a.value:Array.isArray(a)?a.every(C):!0}e.isEmptyMarkdownString=C;function R(a){return a instanceof T?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function M(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,_.isEqual)(B.URI.from(a.baseUri),B.URI.from(n.baseUri)))}e.markdownStringEqual=M;function b(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function l(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=l;function g(a){const n=[],d=a.split("|").map(N=>N.trim());a=d[0];const S=d[1];if(S){const N=/height=(\d+)/.exec(S),f=/width=(\d+)/.exec(S),m=N?N[1]:"",E=f?f[1]:"",r=isFinite(parseInt(E)),P=isFinite(parseInt(m));r&&n.push(`width="${E}"`),P&&n.push(`height="${m}"`)}return{href:a,dimensions:n}}e.parseHrefAndDimensions=g}),define(ve[73],Ee([1,0,35,9,17,23,24,10,2]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,s,t){if(typeof i=="string"&&(i=C.URI.file(i)),t){const v=t.getWorkspaceFolder(i);if(v){const h=t.getWorkspace().folders.length>1;let p;if((0,y.isEqual)(v.uri,i)?p="":p=(0,y.relativePath)(v.uri,i),h){const k=v.name?v.name:(0,y.basename)(v.uri);p=p?k+" \u2022 "+p:k}return p}}if(i.scheme!==I.Schemas.file&&i.scheme!==I.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,o.hasDriveLetter)(i.fsPath))return(0,_.normalize)(b(i.fsPath));let c=(0,_.normalize)(i.fsPath);return!B.isWindows&&s?.userHome&&(c=g(c,s.userHome.fsPath)),c}e.getPathLabel=R;function M(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const s=(0,y.basename)(i)||(i.scheme===I.Schemas.file?i.fsPath:i.path);return B.isWindows&&(0,o.isRootOrDriveLetter)(s)?b(s):s}e.getBaseLabel=M;function b(i,s){return(0,o.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let l=Object.create(null);function g(i,s){if(B.isWindows||!i||!s)return i;let t=l.original===s?l.normalized:void 0;return t||(t=`${(0,T.rtrim)(s,_.posix.sep)}${_.posix.sep}`,l={original:s,normalized:t}),(B.isLinux?i.startsWith(t):(0,T.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=g;function a(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=a;const n="\u2026",d="\\\\",S="~";function N(i,s=_.sep){const t=new Array(i.length);let c=!1;for(let v=0;v<i.length;v++){let h=i[v];if(h===""){t[v]=`.${s}`;continue}if(!h){t[v]=h;continue}c=!0;let p="";h.indexOf(d)===0?(p=h.substr(0,h.indexOf(d)+d.length),h=h.substr(h.indexOf(d)+d.length)):h.indexOf(s)===0?(p=h.substr(0,h.indexOf(s)+s.length),h=h.substr(h.indexOf(s)+s.length)):h.indexOf(S)===0&&(p=h.substr(0,h.indexOf(S)+S.length),h=h.substr(h.indexOf(S)+S.length));const k=h.split(s);for(let A=1;c&&A<=k.length;A++)for(let x=k.length-A;c&&x>=0;x--){c=!1;let w=k.slice(x,x+A).join(s);for(let z=0;!c&&z<i.length;z++)if(z!==v&&i[z]&&i[z].indexOf(w)>-1){const q=x+A===k.length,H=x>0&&i[z].indexOf(s)>-1?s+w:w,W=i[z].endsWith(H);c=!q||W}if(!c){let z="";(k[0].endsWith(":")||p!=="")&&(x===1&&(x=0,A++,w=k[0]+s+w),x>0&&(z=k[0]+s),z=p+z),x>0&&(z=z+n+s),z=z+w,x+A<k.length&&(z=z+s+n),t[v]=z}}c&&(t[v]=h)}return t}e.shorten=N;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function m(i,s=Object.create(null)){const t=[];let c=!1,v="";for(const h of i)if(h==="$"||c&&h==="{")v&&t.push({value:v,type:f.TEXT}),v="",c=!0;else if(h==="}"&&c){const p=s[v];if(typeof p=="string")p.length&&t.push({value:p,type:f.VARIABLE});else if(p){const k=t[t.length-1];(!k||k.type!==f.SEPARATOR)&&t.push({value:p.label,type:f.SEPARATOR})}v="",c=!1}else v+=h;return v&&!c&&t.push({value:v,type:f.TEXT}),t.filter((h,p)=>{if(h.type===f.SEPARATOR){const k=t[p-1],A=t[p+1];return[k,A].every(x=>x&&(x.type===f.VARIABLE||x.type===f.TEXT)&&x.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=m;function E(i,s){return B.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function r(i,s){return B.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):B.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function P(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=P;function u(i){const s=i.indexOf("/")!==-1?_.posix:_.win32,t=s.basename(i),c=s.dirname(i);return t.length?{name:t,parentPath:c}:{name:c,parentPath:""}}e.splitName=u}),define(ve[108],Ee([1,0,2]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(M){return M.toJSON()}class _{constructor(b){this._uriTransformer=b}transformIncoming(b){const l=this._uriTransformer.transformIncoming(b);return l===b?b:I(o.URI.from(l))}transformOutgoing(b){const l=this._uriTransformer.transformOutgoing(b);return l===b?b:I(o.URI.from(l))}transformOutgoingURI(b){const l=this._uriTransformer.transformOutgoing(b);return l===b?b:o.URI.from(l)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function B(M,b,l){if(!M||l>200)return null;if(typeof M=="object"){if(M instanceof o.URI)return b.transformOutgoing(M);for(let g in M)if(Object.hasOwnProperty.call(M,g)){const a=B(M[g],b,l+1);a!==null&&(M[g]=a)}}return null}function y(M,b){const l=B(M,b,0);return l===null?M:l}e.transformOutgoingURIs=y;function T(M,b,l,g){if(!M||g>200)return null;if(typeof M=="object"){if(M.$mid===1)return l?o.URI.revive(b.transformIncoming(M)):b.transformIncoming(M);for(let a in M)if(Object.hasOwnProperty.call(M,a)){const n=T(M[a],b,l,g+1);n!==null&&(M[a]=n)}}return null}function C(M,b){const l=T(M,b,!1,0);return l===null?M:l}e.transformIncomingURIs=C;function R(M,b){const l=T(M,b,!0,0);return l===null?M:l}e.transformAndReviveIncomingURIs=R}),define(ve[36],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(C){return o.test(C)}e.isUUID=I;const _=new Uint8Array(16),B=[];for(let C=0;C<256;C++)B.push(C.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(C){for(let R=0;R<C.length;R++)C[R]=Math.floor(Math.random()*256);return C};function T(){y(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let C=0,R="";return R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R+="-",R+=B[_[C++]],R+=B[_[C++]],R+="-",R+=B[_[C++]],R+=B[_[C++]],R+="-",R+=B[_[C++]],R+=B[_[C++]],R+="-",R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R+=B[_[C++]],R}e.generateUuid=T}),define(ve[109],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[74],Ee([1,0,29,17]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(B,y,T,C){if(Array.isArray(B)){let R=0;for(const M of B){const b=_(M,y,T,C);if(b===10)return b;b>R&&(R=b)}return R}else{if(typeof B=="string")return C?B==="*"?5:B===T?10:0:0;if(B){const{language:R,pattern:M,scheme:b,hasAccessToAllModels:l}=B;if(!C&&!l)return 0;let g=0;if(b)if(b===y.scheme)g=10;else if(b==="*")g=5;else return 0;if(R)if(R===T)g=10;else if(R==="*")g=Math.max(g,5);else return 0;if(M){let a;if(typeof M=="string"?a=M:a={...M,base:(0,I.normalize)(M.base)},a===y.fsPath||(0,o.match)(a,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=_}),define(ve[110],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class I{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let C=0,R=T.notIn.length;C<R;C++)switch(T.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,C){if(T.getTokenCount()===0)return!0;const R=T.findTokenIndexAtOffset(C-2),M=T.getStandardTokenType(R);return this.isOK(M)}_findNeutralCharacterInRange(T,C){for(let R=T;R<=C;R++){const M=String.fromCharCode(R);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class _{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of T)B(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),B(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),B(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),B(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&B(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=_;function B(y,T,C){y.has(T)?y.get(T).push(C):y.set(T,[C])}}),define(ve[75],Ee([1,0,21,23]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(_||(_={}));function B(b){for(let l=0,g=b.length;l<g;l+=4){const a=b[l+0],n=b[l+1],d=b[l+2],S=b[l+3];b[l+0]=S,b[l+1]=d,b[l+2]=n,b[l+3]=a}}function y(b){const l=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return I.isLittleEndian()||B(l),o.VSBuffer.wrap(l)}function T(b){const l=b.buffer;if(I.isLittleEndian()||B(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const g=new Uint8Array(l.byteLength);return g.set(l),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function C(b){const l=new Uint32Array(R(b));let g=0;if(l[g++]=b.id,b.type==="full")l[g++]=1,l[g++]=b.data.length,l.set(b.data,g),g+=b.data.length;else{l[g++]=2,l[g++]=b.deltas.length;for(const a of b.deltas)l[g++]=a.start,l[g++]=a.deleteCount,a.data?(l[g++]=a.data.length,l.set(a.data,g),g+=a.data.length):l[g++]=0}return y(l)}e.encodeSemanticTokensDto=C;function R(b){let l=0;if(l+=1+1,b.type==="full")l+=1+b.data.length;else{l+=1,l+=(1+1+1)*b.deltas.length;for(const g of b.deltas)g.data&&(l+=g.data.length)}return l}function M(b){const l=T(b);let g=0;const a=l[g++];if(l[g++]===1){const N=l[g++],f=l.subarray(g,g+N);return g+=N,{id:a,type:"full",data:f}}const d=l[g++],S=[];for(let N=0;N<d;N++){const f=l[g++],m=l[g++],E=l[g++];let r;E>0&&(r=l.subarray(g,g+E),g+=E),S[N]={start:f,deleteCount:m,data:r}}return{id:a,type:"delta",deltas:S}}e.decodeSemanticTokensDto=M}),define(ve[111],Ee([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[112],Ee([1,0,111]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,_=I*60,B=_*24,y=B*7,T=B*30,C=B*365;function R(b,l,g){typeof b!="number"&&(b=b.getTime());const a=Math.round((new Date().getTime()-b)/1e3);if(a<-30)return(0,o.localize)(0,null,R(new Date().getTime()+a*1e3,!1));if(a<30)return(0,o.localize)(1,null);let n;return a<I?(n=a,l?n===1?g?(0,o.localize)(2,null,n):(0,o.localize)(3,null,n):g?(0,o.localize)(4,null,n):(0,o.localize)(5,null,n):n===1?g?(0,o.localize)(6,null,n):(0,o.localize)(7,null,n):g?(0,o.localize)(8,null,n):(0,o.localize)(9,null,n)):a<_?(n=Math.floor(a/I),l?n===1?g?(0,o.localize)(10,null,n):(0,o.localize)(11,null,n):g?(0,o.localize)(12,null,n):(0,o.localize)(13,null,n):n===1?g?(0,o.localize)(14,null,n):(0,o.localize)(15,null,n):g?(0,o.localize)(16,null,n):(0,o.localize)(17,null,n)):a<B?(n=Math.floor(a/_),l?n===1?g?(0,o.localize)(18,null,n):(0,o.localize)(19,null,n):g?(0,o.localize)(20,null,n):(0,o.localize)(21,null,n):n===1?g?(0,o.localize)(22,null,n):(0,o.localize)(23,null,n):g?(0,o.localize)(24,null,n):(0,o.localize)(25,null,n)):a<y?(n=Math.floor(a/B),l?n===1?(0,o.localize)(26,null,n):(0,o.localize)(27,null,n):n===1?(0,o.localize)(28,null,n):(0,o.localize)(29,null,n)):a<T?(n=Math.floor(a/y),l?n===1?g?(0,o.localize)(30,null,n):(0,o.localize)(31,null,n):g?(0,o.localize)(32,null,n):(0,o.localize)(33,null,n):n===1?g?(0,o.localize)(34,null,n):(0,o.localize)(35,null,n):g?(0,o.localize)(36,null,n):(0,o.localize)(37,null,n)):a<C?(n=Math.floor(a/T),l?n===1?g?(0,o.localize)(38,null,n):(0,o.localize)(39,null,n):g?(0,o.localize)(40,null,n):(0,o.localize)(41,null,n):n===1?g?(0,o.localize)(42,null,n):(0,o.localize)(43,null,n):g?(0,o.localize)(44,null,n):(0,o.localize)(45,null,n)):(n=Math.floor(a/C),l?n===1?g?(0,o.localize)(46,null,n):(0,o.localize)(47,null,n):g?(0,o.localize)(48,null,n):(0,o.localize)(49,null,n):n===1?g?(0,o.localize)(50,null,n):(0,o.localize)(51,null,n):g?(0,o.localize)(52,null,n):(0,o.localize)(53,null,n))}e.fromNow=R;function M(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(ve[113],Ee([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[43],Ee([1,0,16,13,113]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function B(R,M){return M&&(R.stack||R.stacktrace)?_.localize(0,null,T(R),y(R.stack)||y(R.stacktrace)):T(R)}function y(R){return Array.isArray(R)?R.join(`
`):R}function T(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?_.localize(1,null,R.message):R.message||_.localize(2,null)}function C(R=null,M=!1){if(!R)return _.localize(3,null);if(Array.isArray(R)){const b=o.coalesce(R),l=C(b[0],M);return b.length>1?_.localize(4,null,l,b.length):l}if(I.isString(R))return R;if(R.detail){const b=R.detail;if(b.error)return B(b.error,M);if(b.exception)return B(b.exception,M)}return R.stack?B(R,M):R.message?R.message:_.localize(5,null)}e.toErrorMessage=C}),define(ve[114],Ee([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[115],Ee([1,0,114,23,116,16,26,109]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=R;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class b{constructor(Y,ce,Re,$e){this.id=Y,this.name=ce,this.defaultValue=Re,this.schema=$e}applyUpdate(Y,ce){return g(Y,ce)}compute(Y,ce,Re){return Re}}class l{constructor(Y,ce){this.newValue=Y,this.didChange=ce}}e.ApplyUpdateResult=l;function g(G,Y){if(typeof G!="object"||typeof Y!="object"||!G||!Y)return new l(Y,G!==Y);if(Array.isArray(G)||Array.isArray(Y)){const Re=Array.isArray(G)&&Array.isArray(Y)&&B.equals(G,Y);return new l(Y,Re)}let ce=!1;for(const Re in Y)if(Y.hasOwnProperty(Re)){const $e=g(G[Re],Y[Re]);$e.didChange&&(G[Re]=$e.newValue,ce=!0)}return new l(G,ce)}class a{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ce){return g(Y,ce)}validate(Y){return this.defaultValue}}class n{constructor(Y,ce,Re,$e){this.id=Y,this.name=ce,this.defaultValue=Re,this.schema=$e}applyUpdate(Y,ce){return g(Y,ce)}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,ce,Re){return Re}}function d(G,Y){return typeof G=="undefined"?Y:G==="false"?!1:Boolean(G)}e.boolean=d;class S extends n{constructor(Y,ce,Re,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Re);super(Y,ce,Re,$e)}validate(Y){return d(Y,this.defaultValue)}}function N(G,Y,ce,Re){if(typeof G=="undefined")return Y;let $e=parseInt(G,10);return isNaN($e)?Y:($e=Math.max(ce,$e),$e=Math.min(Re,$e),$e|0)}e.clampedInt=N;class f extends n{constructor(Y,ce,Re,$e,Ke,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="integer",Qe.default=Re,Qe.minimum=$e,Qe.maximum=Ke);super(Y,ce,Re,Qe);this.minimum=$e,this.maximum=Ke}static clampedInt(Y,ce,Re,$e){return N(Y,ce,Re,$e)}validate(Y){return f.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class m extends n{constructor(Y,ce,Re,$e,Ke){typeof Ke!="undefined"&&(Ke.type="number",Ke.default=Re);super(Y,ce,Re,Ke);this.validationFn=$e}static clamp(Y,ce,Re){return Y<ce?ce:Y>Re?Re:Y}static float(Y,ce){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return ce;const Re=parseFloat(Y);return isNaN(Re)?ce:Re}validate(Y){return this.validationFn(m.float(Y,this.defaultValue))}}class E extends n{static string(Y,ce){return typeof Y!="string"?ce:Y}constructor(Y,ce,Re,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Re);super(Y,ce,Re,$e)}validate(Y){return E.string(Y,this.defaultValue)}}function r(G,Y,ce){return typeof G!="string"||ce.indexOf(G)===-1?Y:G}e.stringSet=r;class P extends n{constructor(Y,ce,Re,$e,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="string",Ke.enum=$e,Ke.default=Re);super(Y,ce,Re,Ke);this._allowedValues=$e}validate(Y){return r(Y,this.defaultValue,this._allowedValues)}}class u extends b{constructor(Y,ce,Re,$e,Ke,Qe,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=Ke,ht.default=$e);super(Y,ce,Re,ht);this._allowedValues=Ke,this._convert=Qe}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function i(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ce,Re){return Re===0?Y.accessibilitySupport:Re}}class t extends b{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:o.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{insertSpace:d(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function v(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function p(G){switch(G){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=p;function k(G){switch(G){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class A extends a{constructor(){super(128)}compute(Y,ce,Re){const $e=["monaco-editor"];return ce.get(33)&&$e.push(ce.get(33)),Y.extraEditorClassName&&$e.push(Y.extraEditorClassName),ce.get(66)==="default"?$e.push("mouse-default"):ce.get(66)==="copy"&&$e.push("mouse-copy"),ce.get(100)&&$e.push("showUnused"),ce.get(126)&&$e.push("showDeprecated"),$e.join(" ")}}class x extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(Y,ce,Re){return Re&&Y.emptySelectionClipboard}}class w extends b{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:o.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:o.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{cursorMoveOnType:d(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":r(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":r(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ce.loop,this.defaultValue.loop)}}}class z extends b{constructor(){super(45,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?z.OFF:Y==="true"?z.ON:Y:Boolean(Y)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class q extends a{constructor(){super(44)}compute(Y,ce,Re){return Y.fontInfo}}class H extends n{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(Y){const ce=m.float(Y,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(ce,6,100)}compute(Y,ce,Re){return Y.fontInfo.fontSize}}class W extends b{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(f.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class Q extends b{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Re,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Re,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Re,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Re,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Re,description:o.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{multiple:r(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??r(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??r(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??r(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??r(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??r(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends b{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:o.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:d(ce.enabled,this.defaultValue.enabled),delay:f.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:d(ce.sticky,this.defaultValue.sticky),above:d(ce.above,this.defaultValue.above)}}}var te;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(te=e.RenderMinimap||(e.RenderMinimap={}));class oe extends a{constructor(){super(131)}compute(Y,ce,Re){return oe.computeLayout(ce,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ce=Y.height/Y.lineHeight,Re=Y.scrollBeyondLastLine?ce-1:0,$e=(Y.viewLineCount+Re)/(Y.pixelRatio*Y.height),Ke=Math.floor(Y.viewLineCount/$e);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Re,desiredRatio:$e,minimapLineCount:Ke}}static _computeMinimapLayout(Y,ce){const Re=Y.outerWidth,$e=Y.outerHeight,Ke=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ke*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Qe=ce.stableMinimapLayoutInput,ht=Qe&&Y.outerHeight===Qe.outerHeight&&Y.lineHeight===Qe.lineHeight&&Y.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Qe.pixelRatio&&Y.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&Y.minimap.enabled===Qe.minimap.enabled&&Y.minimap.side===Qe.minimap.side&&Y.minimap.size===Qe.minimap.size&&Y.minimap.showSlider===Qe.minimap.showSlider&&Y.minimap.renderCharacters===Qe.minimap.renderCharacters&&Y.minimap.maxColumn===Qe.minimap.maxColumn&&Y.minimap.scale===Qe.minimap.scale&&Y.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&Y.isViewportWrapping===Qe.isViewportWrapping,_t=Y.lineHeight,yt=Y.typicalHalfwidthCharacterWidth,Tt=Y.scrollBeyondLastLine,Ve=Y.minimap.renderCharacters;let pt=Ke>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Nt=Y.minimap.maxColumn,nt=Y.minimap.size,ot=Y.minimap.side,At=Y.verticalScrollbarWidth,Dt=Y.viewLineCount,Ct=Y.remainingWidth,lt=Y.isViewportWrapping,Ot=Ve?2:3;let Lt=Math.floor(Ke*$e);const Ft=Lt/Ke;let se=!1,_e=!1,le=Ot*pt,K=pt/Ke,be=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:it,desiredRatio:at,minimapLineCount:mt}=oe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Tt,height:$e,lineHeight:_t,pixelRatio:Ke});if(Dt/mt>1)se=!0,_e=!0,pt=1,le=1,K=pt/Ke;else{let ct=!1,It=pt+1;if(nt==="fit"){const Ut=Math.ceil((Dt+it)*le);lt&&ht&&Ct<=ce.stableFitRemainingWidth?(ct=!0,It=ce.stableFitMaxMinimapScale):ct=Ut>Lt}if(nt==="fill"||ct){se=!0;const Ut=pt;le=Math.min(_t*Ke,Math.max(1,Math.floor(1/at))),lt&&ht&&Ct<=ce.stableFitRemainingWidth&&(It=ce.stableFitMaxMinimapScale),pt=Math.min(It,Math.max(1,Math.floor(le/Ot))),pt>Ut&&(be=Math.min(2,pt/Ut)),K=pt/Ke/be,Lt=Math.ceil(Math.max(vt,Dt+it)*le),lt?(ce.stableMinimapLayoutInput=Y,ce.stableFitRemainingWidth=Ct,ce.stableFitMaxMinimapScale=pt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Te=Math.floor(Nt*K),Be=Math.min(Te,Math.max(0,Math.floor((Ct-At-2)*K/(yt+K)))+e.MINIMAP_GUTTER_WIDTH);let We=Math.floor(Ke*Be);const st=We/Ke;We=Math.floor(We*be);const ft=Ve?1:2,Et=ot==="left"?0:Re-Be-At;return{renderMinimap:ft,minimapLeft:Et,minimapWidth:Be,minimapHeightIsEditorHeight:se,minimapIsSampling:_e,minimapScale:pt,minimapLineHeight:le,minimapCanvasInnerWidth:We,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:st,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,ce){const Re=ce.outerWidth|0,$e=ce.outerHeight|0,Ke=ce.lineHeight|0,Qe=ce.lineNumbersDigitCount|0,ht=ce.typicalHalfwidthCharacterWidth,_t=ce.maxDigitWidth,yt=ce.pixelRatio,Tt=ce.viewLineCount,Ve=Y.get(123),pt=Ve==="inherit"?Y.get(122):Ve,Nt=pt==="inherit"?Y.get(118):pt,nt=Y.get(121),ot=Y.get(2),At=ce.isDominatedByLongLines,Dt=Y.get(50),Ct=Y.get(60).renderType!==0,lt=Y.get(61),Ot=Y.get(94),Lt=Y.get(65),Ft=Y.get(92),se=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,le=Ft.arrowSize,K=Ft.horizontalScrollbarSize,be=Y.get(58),Te=Y.get(37);let Be;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Wt=parseFloat(be.substr(0,be.length-2));Be=f.clampedInt(Wt*ht,0,0,1e3)}else Be=f.clampedInt(be,0,0,1e3);Te&&(Be+=16);let We=0;if(Ct){const Wt=Math.max(Qe,lt);We=Math.round(Wt*_t)}let st=0;Dt&&(st=Ke);let ft=0,Et=ft+st,vt=Et+We,it=vt+Be;const at=Re-st-We-Be;let mt=!1,Mt=!1,ct=-1;ot!==2&&(pt==="inherit"&&At?(mt=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(ct=nt));const It=oe._computeMinimapLayout({outerWidth:Re,outerHeight:$e,lineHeight:Ke,typicalHalfwidthCharacterWidth:ht,pixelRatio:yt,scrollBeyondLastLine:Ot,minimap:Lt,verticalScrollbarWidth:se,viewLineCount:Tt,remainingWidth:at,isViewportWrapping:Mt},ce.memory||new M);It.renderMinimap!==0&&It.minimapLeft===0&&(ft+=It.minimapWidth,Et+=It.minimapWidth,vt+=It.minimapWidth,it+=It.minimapWidth);const Ut=at-It.minimapWidth,bt=Math.max(1,Math.floor((Ut-se-2)/ht)),Bt=_e?le:0;return Mt&&(ct=Math.max(1,bt),Nt==="bounded"&&(ct=Math.min(ct,nt))),{width:Re,height:$e,glyphMarginLeft:ft,glyphMarginWidth:st,lineNumbersLeft:Et,lineNumbersWidth:We,decorationsLeft:vt,decorationsWidth:Be,contentLeft:it,contentWidth:Ut,minimap:It,viewportColumn:bt,isWordWrapMinified:mt,isViewportWrapping:Mt,wrappingColumn:ct,verticalScrollbarWidth:se,horizontalScrollbarHeight:K,overviewRuler:{top:Bt,width:se,height:$e-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=oe;class ie extends b{constructor(){const Y={enabled:!0};super(57,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:o.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:d(Y.enabled,this.defaultValue.enabled)}}}class ue extends b{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"boolean",default:Y.enabled,description:o.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:o.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:o.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:d(ce.enabled,this.defaultValue.enabled),fontSize:f.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class he extends m{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>m.clamp(Y,0,150),{markdownDescription:o.localize(47,null)})}compute(Y,ce,Re){return Y.fontInfo.lineHeight}}class Se extends b{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:o.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(49,null),o.localize(50,null),o.localize(51,null)],default:Y.size,description:o.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:o.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:o.localize(54,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:o.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:o.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:d(ce.enabled,this.defaultValue.enabled),size:r(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ce.side,this.defaultValue.side,["right","left"]),showSlider:r(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ce.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ce.scale,1,1,3),maxColumn:f.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(G){return G==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ne extends b{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{top:f.clampedInt(ce.top,0,0,1e3),bottom:f.clampedInt(ce.bottom,0,0,1e3)}}}class me extends b{constructor(){const Y={enabled:!0,cycle:!1};super(76,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:o.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:o.localize(61,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:d(ce.enabled,this.defaultValue.enabled),cycle:d(ce.cycle,this.defaultValue.cycle)}}}class Ie extends a{constructor(){super(129)}compute(Y,ce,Re){return Y.pixelRatio}}class Ae extends b{constructor(){const Y={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Y.strings,description:o.localize(62,null)},comments:{type:"boolean",default:Y.comments,description:o.localize(63,null)},other:{type:"boolean",default:Y.other,description:o.localize(64,null)}}}],default:Y,description:o.localize(65,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean")return Y;if(Y&&typeof Y=="object"){const ce=Y,Re={other:d(ce.other,this.defaultValue.other),comments:d(ce.comments,this.defaultValue.comments),strings:d(ce.strings,this.defaultValue.strings)};return Re.other&&Re.comments&&Re.strings?!0:!Re.other&&!Re.comments&&!Re.strings?!1:Re}return this.defaultValue}}var Ue;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ge extends b{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null),o.localize(69,null)],default:"on",description:o.localize(70,null)})}validate(Y){let ce=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(ce=4,Re=Y):Y==="interval"?ce=3:Y==="relative"?ce=2:Y==="on"?ce=1:ce=0),{renderType:ce,renderFn:Re}}}function ge(G){const Y=G.get(87);return Y==="editable"?G.get(81):Y!=="on"}e.filterValidationDecorations=ge;class de extends b{constructor(){const Y=[],ce={type:"number",description:o.localize(71,null)};super(91,"rulers",Y,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:o.localize(72,null),format:"color-hex"}}}]},default:Y,description:o.localize(73,null)})}validate(Y){if(Array.isArray(Y)){const ce=[];for(let Re of Y)if(typeof Re=="number")ce.push({column:f.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const $e=Re;ce.push({column:f.clampedInt($e.column,0,0,1e4),color:$e.color})}return ce.sort((Re,$e)=>Re.column-$e.column),ce}return this.defaultValue}}function L(G,Y){if(typeof G!="string")return Y;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends b{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(74,null),o.localize(75,null),o.localize(76,null)],default:"auto",description:o.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(78,null),o.localize(79,null),o.localize(80,null)],default:"auto",description:o.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:o.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:o.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:o.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y,Re=f.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=f.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:L(ce.vertical,this.defaultValue.vertical),horizontal:L(ce.horizontal,this.defaultValue.horizontal),useShadows:d(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:f.clampedInt(ce.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:f.clampedInt(ce.verticalSliderSize,$e,0,1e3),scrollByPage:d(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class D extends b{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:o.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:o.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:o.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:o.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:o.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:o.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:o.localize(91,null)}})}applyUpdate(Y,ce){let Re=!1;ce.allowedCharacters&&(y.equals(Y.allowedCharacters,ce.allowedCharacters)||(Y={...Y,allowedCharacters:ce.allowedCharacters},Re=!0)),ce.allowedLocales&&(y.equals(Y.allowedLocales,ce.allowedLocales)||(Y={...Y,allowedLocales:ce.allowedLocales},Re=!0));const $e=super.applyUpdate(Y,ce);return Re?new l($e.newValue,!0):$e}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{nonBasicASCII:re(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:re(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:re(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,ce){if(typeof Y!="object"||!Y)return ce;const Re={};for(const[$e,Ke]of Object.entries(Y))Ke===!0&&(Re[$e]=!0);return Re}}class O extends b{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:o.localize(92,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:d(ce.enabled,this.defaultValue.enabled),mode:r(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class $ extends b{constructor(){const Y={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,description:o.localize(93,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:d(Y.enabled,this.defaultValue.enabled)}}}class X extends b{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(94,null),o.localize(95,null),o.localize(96,null)],default:Y.bracketPairs,description:o.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(98,null),o.localize(99,null),o.localize(100,null)],default:Y.bracketPairsHorizontal,description:o.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:o.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:o.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Y.highlightActiveIndentation,description:o.localize(104,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{bracketPairs:re(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:re(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:d(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function re(G,Y,ce){const Re=ce.indexOf(G);return Re===-1?Y:ce[Re]}class pe extends b{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(105,null),o.localize(106,null)],default:Y.insertMode,description:o.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:o.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:o.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:o.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:o.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:o.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:o.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:o.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:o.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{insertMode:r(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(ce.preview,this.defaultValue.preview),previewMode:r(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ce.showMethods,this.defaultValue.showMethods),showFunctions:d(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:d(ce.showFields,this.defaultValue.showFields),showVariables:d(ce.showVariables,this.defaultValue.showVariables),showClasses:d(ce.showClasses,this.defaultValue.showClasses),showStructs:d(ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ce.showModules,this.defaultValue.showModules),showProperties:d(ce.showProperties,this.defaultValue.showProperties),showEvents:d(ce.showEvents,this.defaultValue.showEvents),showOperators:d(ce.showOperators,this.defaultValue.showOperators),showUnits:d(ce.showUnits,this.defaultValue.showUnits),showValues:d(ce.showValues,this.defaultValue.showValues),showConstants:d(ce.showConstants,this.defaultValue.showConstants),showEnums:d(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ce.showKeywords,this.defaultValue.showKeywords),showWords:d(ce.showWords,this.defaultValue.showWords),showColors:d(ce.showColors,this.defaultValue.showColors),showFiles:d(ce.showFiles,this.defaultValue.showFiles),showReferences:d(ce.showReferences,this.defaultValue.showReferences),showFolders:d(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(ce.showUsers,this.defaultValue.showUsers),showIssues:d(ce.showIssues,this.defaultValue.showIssues)}}}class Ce extends b{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(147,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends a{constructor(){super(130)}compute(Y,ce,Re){return ce.get(81)?!0:Y.tabFocusMode}}var Le;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class xe extends a{constructor(){super(132)}compute(Y,ce,Re){const $e=ce.get(131);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Oe="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Xe:I.isLinux?et:Oe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var tt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(148,null)})),acceptSuggestionOnEnter:ke(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(149,null),""],markdownDescription:o.localize(150,null)})),accessibilitySupport:ke(new s),accessibilityPageSize:ke(new f(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(151,null)})),ariaLabel:ke(new E(4,"ariaLabel",o.localize(152,null))),autoClosingBrackets:ke(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(153,null),o.localize(154,null),""],description:o.localize(155,null)})),autoClosingDelete:ke(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(156,null),""],description:o.localize(157,null)})),autoClosingOvertype:ke(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(158,null),""],description:o.localize(159,null)})),autoClosingQuotes:ke(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(160,null),o.localize(161,null),""],description:o.localize(162,null)})),autoIndent:ke(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[o.localize(163,null),o.localize(164,null),o.localize(165,null),o.localize(166,null),o.localize(167,null)],description:o.localize(168,null)})),automaticLayout:ke(new S(10,"automaticLayout",!1)),autoSurround:ke(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(169,null),o.localize(170,null),o.localize(171,null),""],description:o.localize(172,null)})),bracketPairColorization:ke(new $),bracketPairGuides:ke(new X),stickyTabStops:ke(new S(104,"stickyTabStops",!1,{description:o.localize(173,null)})),codeLens:ke(new S(14,"codeLens",!0,{description:o.localize(174,null)})),codeLensFontFamily:ke(new E(15,"codeLensFontFamily","",{description:o.localize(175,null)})),codeLensFontSize:ke(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(176,null)})),colorDecorators:ke(new S(17,"colorDecorators",!0,{description:o.localize(177,null)})),columnSelection:ke(new S(18,"columnSelection",!1,{description:o.localize(178,null)})),comments:ke(new t),contextmenu:ke(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new S(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(179,null)})),cursorBlinking:ke(new u(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:o.localize(180,null)})),cursorSmoothCaretAnimation:ke(new S(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(181,null)})),cursorStyle:ke(new u(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:o.localize(182,null)})),cursorSurroundingLines:ke(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(183,null)})),cursorSurroundingLinesStyle:ke(new P(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(184,null),o.localize(185,null)],description:o.localize(186,null)})),cursorWidth:ke(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(187,null)})),disableLayerHinting:ke(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new S(30,"domReadOnly",!1)),dragAndDrop:ke(new S(31,"dragAndDrop",!0,{description:o.localize(188,null)})),emptySelectionClipboard:ke(new x),extraEditorClassName:ke(new E(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new m(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:o.localize(189,null)})),find:ke(new w),fixedOverflowWidgets:ke(new S(36,"fixedOverflowWidgets",!1)),folding:ke(new S(37,"folding",!0,{description:o.localize(190,null)})),foldingStrategy:ke(new P(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(191,null),o.localize(192,null)],description:o.localize(193,null)})),foldingHighlight:ke(new S(39,"foldingHighlight",!0,{description:o.localize(194,null)})),foldingImportsByDefault:ke(new S(40,"foldingImportsByDefault",!1,{description:o.localize(195,null)})),foldingMaximumRegions:ke(new f(41,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(196,null)})),unfoldOnClickAfterEndOfLine:ke(new S(42,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(197,null)})),fontFamily:ke(new E(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(198,null)})),fontInfo:ke(new q),fontLigatures2:ke(new z),fontSize:ke(new H),fontWeight:ke(new W),formatOnPaste:ke(new S(48,"formatOnPaste",!1,{description:o.localize(199,null)})),formatOnType:ke(new S(49,"formatOnType",!1,{description:o.localize(200,null)})),glyphMargin:ke(new S(50,"glyphMargin",!0,{description:o.localize(201,null)})),gotoLocation:ke(new Q),hideCursorInOverviewRuler:ke(new S(52,"hideCursorInOverviewRuler",!1,{description:o.localize(202,null)})),hover:ke(new V),inDiffEditor:ke(new S(54,"inDiffEditor",!1)),letterSpacing:ke(new m(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>m.clamp(G,-5,20),{description:o.localize(203,null)})),lightbulb:ke(new ie),lineDecorationsWidth:ke(new n(58,"lineDecorationsWidth",10)),lineHeight:ke(new he),lineNumbers:ke(new Ge),lineNumbersMinChars:ke(new f(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new S(62,"linkedEditing",!1,{description:o.localize(204,null)})),links:ke(new S(63,"links",!0,{description:o.localize(205,null)})),matchBrackets:ke(new P(64,"matchBrackets","always",["always","near","never"],{description:o.localize(206,null)})),minimap:ke(new Se),mouseStyle:ke(new P(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new m(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:o.localize(207,null)})),mouseWheelZoom:ke(new S(68,"mouseWheelZoom",!1,{markdownDescription:o.localize(208,null)})),multiCursorMergeOverlapping:ke(new S(69,"multiCursorMergeOverlapping",!0,{description:o.localize(209,null)})),multiCursorModifier:ke(new u(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[o.localize(210,null),o.localize(211,null)],markdownDescription:o.localize(212,null)})),multiCursorPaste:ke(new P(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(213,null),o.localize(214,null)],markdownDescription:o.localize(215,null)})),occurrencesHighlight:ke(new S(72,"occurrencesHighlight",!0,{description:o.localize(216,null)})),overviewRulerBorder:ke(new S(73,"overviewRulerBorder",!0,{description:o.localize(217,null)})),overviewRulerLanes:ke(new f(74,"overviewRulerLanes",3,0,3)),padding:ke(new ne),parameterHints:ke(new me),peekWidgetDefaultFocus:ke(new P(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(218,null),o.localize(219,null)],description:o.localize(220,null)})),definitionLinkOpensInPeek:ke(new S(78,"definitionLinkOpensInPeek",!1,{description:o.localize(221,null)})),quickSuggestions:ke(new Ae),quickSuggestionsDelay:ke(new f(80,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(222,null)})),readOnly:ke(new S(81,"readOnly",!1)),renameOnType:ke(new S(82,"renameOnType",!1,{description:o.localize(223,null),markdownDeprecationMessage:o.localize(224,null)})),renderControlCharacters:ke(new S(83,"renderControlCharacters",!0,{description:o.localize(225,null),restricted:!0})),renderFinalNewline:ke(new S(84,"renderFinalNewline",!0,{description:o.localize(226,null)})),renderLineHighlight:ke(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(227,null)],description:o.localize(228,null)})),renderLineHighlightOnlyWhenFocus:ke(new S(86,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(229,null)})),renderValidationDecorations:ke(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(230,null),o.localize(231,null),o.localize(232,null),""],description:o.localize(233,null)})),revealHorizontalRightPadding:ke(new f(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new S(90,"roundedSelection",!0,{description:o.localize(234,null)})),rulers:ke(new de),scrollbar:ke(new F),scrollBeyondLastColumn:ke(new f(93,"scrollBeyondLastColumn",5,0,1073741824,{description:o.localize(235,null)})),scrollBeyondLastLine:ke(new S(94,"scrollBeyondLastLine",!0,{description:o.localize(236,null)})),scrollPredominantAxis:ke(new S(95,"scrollPredominantAxis",!0,{description:o.localize(237,null)})),selectionClipboard:ke(new S(96,"selectionClipboard",!0,{description:o.localize(238,null),included:I.isLinux})),selectionHighlight:ke(new S(97,"selectionHighlight",!0,{description:o.localize(239,null)})),selectOnLineNumbers:ke(new S(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[o.localize(240,null),o.localize(241,null)],description:o.localize(242,null)})),showUnused:ke(new S(100,"showUnused",!0,{description:o.localize(243,null)})),showDeprecated:ke(new S(126,"showDeprecated",!0,{description:o.localize(244,null)})),inlayHints:ke(new ue),snippetSuggestions:ke(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(245,null),o.localize(246,null),o.localize(247,null),o.localize(248,null)],description:o.localize(249,null)})),smartSelect:ke(new Ce),smoothScrolling:ke(new S(103,"smoothScrolling",!1,{description:o.localize(250,null)})),stopRenderingLineAfter:ke(new f(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new pe),inlineSuggest:ke(new O),suggestFontSize:ke(new f(107,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(251,null)})),suggestLineHeight:ke(new f(108,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(252,null)})),suggestOnTriggerCharacters:ke(new S(109,"suggestOnTriggerCharacters",!0,{description:o.localize(253,null)})),suggestSelection:ke(new P(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null),o.localize(256,null)],description:o.localize(257,null)})),tabCompletion:ke(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(258,null),o.localize(259,null),o.localize(260,null)],description:o.localize(261,null)})),tabIndex:ke(new f(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new D),unusualLineTerminators:ke(new P(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(262,null),o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),useShadowDOM:ke(new S(115,"useShadowDOM",!0)),useTabStops:ke(new S(116,"useTabStops",!0,{description:o.localize(266,null)})),wordSeparators:ke(new E(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:o.localize(267,null)})),wordWrap:ke(new P(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(268,null),o.localize(269,null),o.localize(270,null),o.localize(271,null)],description:o.localize(272,null)})),wordWrapBreakAfterCharacters:ke(new E(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new E(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new f(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(273,null)})),wordWrapOverride1:ke(new P(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new P(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new u(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[o.localize(274,null),o.localize(275,null),o.localize(276,null),o.localize(277,null)],description:o.localize(278,null)})),wrappingStrategy:ke(new P(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(279,null),o.localize(280,null)],description:o.localize(281,null)})),editorClassName:ke(new A),pixelRatio:ke(new Ie),tabFocusMode:ke(new Me),layoutInfo:ke(new oe),wrappingInfo:ke(new xe)}}),define(ve[117],Ee([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[118],Ee([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[119],Ee([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[120],Ee([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[121],Ee([18,19]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ve[122],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[123],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[124],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[125],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[126],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[127],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[128],Ee([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[129],Ee([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[130],Ee([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[131],Ee([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[132],Ee([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[133],Ee([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[134],Ee([18,19]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[135],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var o;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(o=e.EditorActivation||(e.EditorActivation={}));var I;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(I=e.EditorResolution||(e.EditorResolution={}));var _;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var B;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(B=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var y;(function(T){T.DEFAULT="api",T.NAVIGATION="navigation"})(y=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[136],Ee([1,0,118]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function B(l){return l=l.trim(),l==="*"||I.test(l)}e.isValidVersionStr=B;function y(l){if(!B(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=l.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=y;function T(l){if(!l)return null;let g=l.majorBase,a=l.majorMustEqual,n=l.minorBase,d=l.minorMustEqual,S=l.patchBase,N=l.patchMustEqual;l.hasCaret&&(g===0||(d=!1),N=!1);let f=0;if(l.preRelease){const m=_.exec(l.preRelease);if(m){const[,E,r,P]=m;f=Date.UTC(Number(E),Number(r)-1,Number(P))}}return{majorBase:g,majorMustEqual:a,minorBase:n,minorMustEqual:d,patchBase:S,patchMustEqual:N,isMinimum:l.hasGreaterEquals,notBefore:f}}e.normalizeVersion=T;function C(l,g,a){let n;typeof l=="string"?n=T(y(l)):n=l;let d;g instanceof Date?d=g.getTime():typeof g=="string"&&(d=new Date(g).getTime());let S;if(typeof a=="string"?S=T(y(a)):S=a,!n||!S)return!1;let N=n.majorBase,f=n.minorBase,m=n.patchBase,E=S.majorBase,r=S.minorBase,P=S.patchBase,u=S.notBefore,i=S.majorMustEqual,s=S.minorMustEqual,t=S.patchMustEqual;return S.isMinimum?N>E?!0:N<E?!1:f>r?!0:f<r||d&&d<u?!1:m>=P:(N===1&&E===0&&(!i||!s||!t)&&(E=1,r=0,P=0,i=!0,s=!1,t=!1),N<E?!1:N>E?!i:f<r?!1:f>r?!s:m<P?!1:m>P?!t:!(d&&d<u))}e.isValidVersion=C;function R(l,g,a,n){return a.isBuiltin||typeof a.main=="undefined"?!0:b(l,g,a.engines.vscode,n)}e.isValidExtensionVersion=R;function M(l,g,a){return l==="*"||b(g,a,l)}e.isEngineValid=M;function b(l,g,a,n=[]){let d=T(y(a));if(!d)return n.push(o.localize(0,null,a)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(o.localize(1,null,a)),!1}else if(!d.majorMustEqual)return n.push(o.localize(2,null,a)),!1;return C(l,g,d)?!0:(n.push(o.localize(3,null,l,a)),!1)}}),define(ve[76],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(_,B=[],y=!1){this.ctor=_,this.staticArguments=B,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=o}),define(ve[44],Ee([1,0,76]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function _(y,T,C){T instanceof o.SyncDescriptor||(T=new o.SyncDescriptor(T,[],C)),I.push([y,T])}e.registerSingleton=_;function B(){return I}e.getSingletonServiceDescriptors=B}),define(ve[137],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(B){this.incoming=new Map,this.outgoing=new Map,this.data=B}}e.Node=o;class I{constructor(B){this._hashFn=B,this._nodes=new Map}roots(){const B=[];for(let y of this._nodes.values())y.outgoing.size===0&&B.push(y);return B}insertEdge(B,y){const T=this.lookupOrInsertNode(B),C=this.lookupOrInsertNode(y);T.outgoing.set(this._hashFn(y),C),C.incoming.set(this._hashFn(B),T)}removeNode(B){const y=this._hashFn(B);this._nodes.delete(y);for(let T of this._nodes.values())T.outgoing.delete(y),T.incoming.delete(y)}lookupOrInsertNode(B){const y=this._hashFn(B);let T=this._nodes.get(y);return T||(T=new o(B),this._nodes.set(y,T)),T}lookup(B){return this._nodes.get(this._hashFn(B))}isEmpty(){return this._nodes.size===0}toString(){let B=[];for(let[y,T]of this._nodes)B.push(`${y}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return B.join(`
`)}findCycleSlow(){for(let[B,y]of this._nodes){const T=new Set([B]),C=this._findCycle(y,T);if(C)return C}}_findCycle(B,y){for(let[T,C]of B.outgoing){if(y.has(T))return[...y,T].join(" -> ");y.add(T);const R=this._findCycle(C,y);if(R)return R;y.delete(T)}}}e.Graph=I}),define(ve[3],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function T(C){return C[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=T})(o=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function I(y,T,C,R){T[o.DI_TARGET]===T?T[o.DI_DEPENDENCIES].push({id:y,index:C,optional:R}):(T[o.DI_DEPENDENCIES]=[{id:y,index:C,optional:R}],T[o.DI_TARGET]=T)}function _(y){if(o.serviceIds.has(y))return o.serviceIds.get(y);const T=function(C,R,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(T,C,M,!1)};return T.toString=()=>y,o.serviceIds.set(y,T),T}e.createDecorator=_;function B(y){return y}e.refineServiceDecorator=B}),define(ve[77],Ee([1,0,13,2,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function B(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof I.URI)}e.isConfigurationOverrides=B;function y(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||o.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=y;var T;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function R(d,S){const N=Object.create(null);for(let f in d)M(N,f,d[f],S);return N}e.toValuesTree=R;function M(d,S,N,f){const m=S.split("."),E=m.pop();let r=d;for(let P=0;P<m.length;P++){let u=m[P],i=r[u];switch(typeof i){case"undefined":i=r[u]=Object.create(null);break;case"object":break;default:f(`Ignoring ${S} as ${m.slice(0,P+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[E]=N}catch{f(`Ignoring ${S} as ${m.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${S} as ${m.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=M;function b(d,S){const N=S.split(".");l(d,N)}e.removeFromValueTree=b;function l(d,S){const N=S.shift();if(S.length===0){delete d[N];return}if(Object.keys(d).indexOf(N)!==-1){const f=d[N];typeof f=="object"&&!Array.isArray(f)&&(l(f,S),Object.keys(f).length===0&&delete d[N])}}function g(d,S,N){function f(r,P){let u=r;for(const i of P){if(typeof u!="object"||u===null)return;u=u[i]}return u}const m=S.split("."),E=f(d,m);return typeof E=="undefined"?N:E}e.getConfigurationValue=g;function a(d,S,N){Object.keys(S).forEach(f=>{f!=="__proto__"&&(f in d?o.isObject(d[f])&&o.isObject(S[f])?a(d[f],S[f],N):N&&(d[f]=S[f]):d[f]=S[f])})}e.merge=a;function n(d,S,N){const f=d.inspect(S),m=d.inspect(N);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:f.defaultValue}e.getMigratedSettingValue=n}),define(ve[45],Ee([1,0,23,10,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const B=new Map;B.set("false",!1),B.set("true",!0),B.set("isMac",o.isMacintosh),B.set("isLinux",o.isLinux),B.set("isWindows",o.isWindows),B.set("isWeb",o.isWeb),B.set("isMacNative",o.isMacintosh&&!o.isWeb),B.set("isEdge",o.isEdge),B.set("isFirefox",o.isFirefox),B.set("isChrome",o.isChrome),B.set("isSafari",o.isSafari);const y=Object.prototype.hasOwnProperty;var T;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return b.INSTANCE}static true(){return l.INSTANCE}static has(w){return g.create(w)}static equals(w,z){return a.create(w,z)}static notEquals(w,z){return S.create(w,z)}static regex(w,z){return u.create(w,z)}static in(w,z){return n.create(w,z)}static not(w){return N.create(w)}static and(...w){return t.create(w,null)}static or(...w){return c.create(w,null,!0)}static greater(w,z){return m.create(w,z)}static greaterEquals(w,z){return E.create(w,z)}static smaller(w,z){return r.create(w,z)}static smallerEquals(w,z){return P.create(w,z)}static deserialize(w,z=!1){if(!!w)return this._deserializeOrExpression(w,z)}static _deserializeOrExpression(w,z){let q=w.split("||");return c.create(q.map(H=>this._deserializeAndExpression(H,z)),null,!0)}static _deserializeAndExpression(w,z){let q=w.split("&&");return t.create(q.map(H=>this._deserializeOne(H,z)),null)}static _deserializeOne(w,z){if(w=w.trim(),w.indexOf("!=")>=0){let q=w.split("!=");return S.create(q[0].trim(),this._deserializeValue(q[1],z))}if(w.indexOf("==")>=0){let q=w.split("==");return a.create(q[0].trim(),this._deserializeValue(q[1],z))}if(w.indexOf("=~")>=0){let q=w.split("=~");return u.create(q[0].trim(),this._deserializeRegexValue(q[1],z))}if(w.indexOf(" in ")>=0){let q=w.split(" in ");return n.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const q=w.split(">=");return E.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const q=w.split(">");return m.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const q=w.split("<=");return P.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const q=w.split("<");return r.create(q[0].trim(),q[1].trim())}return/^\!\s*/.test(w)?N.create(w.substr(1).trim()):g.create(w)}static _deserializeValue(w,z){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let q=/^'([^']*)'$/.exec(w);return q?q[1].trim():w}static _deserializeRegexValue(w,z){if((0,I.isFalsyOrWhitespace)(w)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let q=w.indexOf("/"),H=w.lastIndexOf("/");if(q===H||q<0){if(z)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let W=w.slice(q+1,H),Q=w[H+1]==="i"?"i":"";try{return new RegExp(W,Q)}catch(V){if(z)throw new Error(`bad regexp-value '${w}', parse error: ${V}`);return console.warn(`bad regexp-value '${w}', parse error: ${V}`),null}}}e.ContextKeyExpr=C;function R(x,w){const z=x?x.substituteConstants():void 0,q=w?w.substituteConstants():void 0;return!z&&!q?!0:!z||!q?!1:z.equals(q)}e.expressionsAreEqualWithConstantSubstitution=R;function M(x,w){return x.cmp(w)}class b{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class l{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class g{constructor(w,z){this.key=w,this.negated=z,this.type=2}static create(w,z=null){const q=B.get(w);return typeof q=="boolean"?q?l.INSTANCE:b.INSTANCE:new g(w,z)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=B.get(this.key);return typeof w=="boolean"?w?l.INSTANCE:b.INSTANCE:this}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=N.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class a{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=4}static create(w,z,q=null){if(typeof z=="boolean")return z?g.create(w,q):N.create(w,q);const H=B.get(w);return typeof H=="boolean"?z===(H?"true":"false")?l.INSTANCE:b.INSTANCE:new a(w,z,q)}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=B.get(this.key);if(typeof w=="boolean"){const z=w?"true":"false";return this.value===z?l.INSTANCE:b.INSTANCE}return this}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=a;class n{constructor(w,z){this.key=w,this.valueKey=z,this.type=10,this.negated=null}static create(w,z){return new n(w,z)}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}substituteConstants(){return this}evaluate(w){const z=w.getValue(this.valueKey),q=w.getValue(this.key);return Array.isArray(z)?z.indexOf(q)>=0:typeof q=="string"&&typeof z=="object"&&z!==null?y.call(z,q):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=n;class d{constructor(w){this._actual=w,this.type=11}static create(w){return new d(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new d(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class S{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=5}static create(w,z,q=null){if(typeof z=="boolean")return z?N.create(w,q):g.create(w,q);const H=B.get(w);return typeof H=="boolean"?z===(H?"true":"false")?b.INSTANCE:l.INSTANCE:new S(w,z,q)}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=B.get(this.key);if(typeof w=="boolean"){const z=w?"true":"false";return this.value===z?b.INSTANCE:l.INSTANCE}return this}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class N{constructor(w,z){this.key=w,this.negated=z,this.type=3}static create(w,z=null){const q=B.get(w);return typeof q=="boolean"?q?b.INSTANCE:l.INSTANCE:new N(w,z)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=B.get(this.key);return typeof w=="boolean"?w?b.INSTANCE:l.INSTANCE:this}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=N;function f(x,w){if(typeof x=="string"){const z=parseFloat(x);isNaN(z)||(x=z)}return typeof x=="string"||typeof x=="number"?w(x):b.INSTANCE}class m{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=12}static create(w,z,q=null){return f(z,H=>new m(w,H,q))}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class E{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=13}static create(w,z,q=null){return f(z,H=>new E(w,H,q))}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=E;class r{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=14}static create(w,z,q=null){return f(z,H=>new r(w,H,q))}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class P{constructor(w,z,q){this.key=w,this.value=z,this.negated=q,this.type=15}static create(w,z,q=null){return f(z,H=>new P(w,H,q))}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return typeof this.value=="string"?!1:parseFloat(w.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=P;class u{constructor(w,z){this.key=w,this.regexp=z,this.type=7,this.negated=null}static create(w,z){return new u(w,z)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const z=this.regexp?this.regexp.source:"",q=w.regexp?w.regexp.source:"";return z<q?-1:z>q?1:0}equals(w){if(w.type===this.type){const z=this.regexp?this.regexp.source:"",q=w.regexp?w.regexp.source:"";return this.key===w.key&&z===q}return!1}substituteConstants(){return this}evaluate(w){let z=w.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=u;class i{constructor(w){this._actual=w,this.type=8}static create(w){return new i(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new i(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(x){let w=null;for(let z=0,q=x.length;z<q;z++){const H=x[z].substituteConstants();if(x[z]!==H&&w===null){w=[];for(let W=0;W<z;W++)w[W]=x[W]}w!==null&&(w[z]=H)}return w===null?x:w}class t{constructor(w,z){this.expr=w,this.negated=z,this.type=6}static create(w,z){return t._normalizeArr(w,z)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let z=0,q=this.expr.length;z<q;z++){const H=M(this.expr[z],w.expr[z]);if(H!==0)return H}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let z=0,q=this.expr.length;z<q;z++)if(!this.expr[z].equals(w.expr[z]))return!1;return!0}return!1}substituteConstants(){const w=s(this.expr);return w===this.expr?this:t.create(w,this.negated)}evaluate(w){for(let z=0,q=this.expr.length;z<q;z++)if(!this.expr[z].evaluate(w))return!1;return!0}static _normalizeArr(w,z){const q=[];let H=!1;for(const W of w)if(!!W){if(W.type===1){H=!0;continue}if(W.type===0)return b.INSTANCE;if(W.type===6){q.push(...W.expr);continue}q.push(W)}if(q.length===0&&H)return l.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(M);for(let W=1;W<q.length;W++)q[W-1].equals(q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0];for(;q.length>1;){const W=q[q.length-1];if(W.type!==9)break;q.pop();const Q=q.pop(),V=q.length===0,te=c.create(W.expr.map(oe=>t.create([oe,Q],null)),null,V);te&&(q.push(te),q.sort(M))}return q.length===1?q[0]:new t(q,z)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let z of this.expr)w.push(...z.keys());return w}map(w){return new t(this.expr.map(z=>z.map(w)),null)}negate(){if(!this.negated){const w=[];for(let z of this.expr)w.push(z.negate());this.negated=c.create(w,this,!0)}return this.negated}}class c{constructor(w,z){this.expr=w,this.negated=z,this.type=9}static create(w,z,q){return c._normalizeArr(w,z,q)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let z=0,q=this.expr.length;z<q;z++){const H=M(this.expr[z],w.expr[z]);if(H!==0)return H}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let z=0,q=this.expr.length;z<q;z++)if(!this.expr[z].equals(w.expr[z]))return!1;return!0}return!1}substituteConstants(){const w=s(this.expr);return w===this.expr?this:c.create(w,this.negated,!1)}evaluate(w){for(let z=0,q=this.expr.length;z<q;z++)if(this.expr[z].evaluate(w))return!0;return!1}static _normalizeArr(w,z,q){let H=[],W=!1;if(w){for(let Q=0,V=w.length;Q<V;Q++){const te=w[Q];if(!!te){if(te.type===0){W=!0;continue}if(te.type===1)return l.INSTANCE;if(te.type===9){H=H.concat(te.expr);continue}H.push(te)}}if(H.length===0&&W)return b.INSTANCE;H.sort(M)}if(H.length!==0){if(H.length===1)return H[0];for(let Q=1;Q<H.length;Q++)H[Q-1].equals(H[Q])&&(H.splice(Q,1),Q--);if(H.length===1)return H[0];if(q){for(let Q=0;Q<H.length;Q++)for(let V=Q+1;V<H.length;V++)k(H[Q],H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0]}return new c(H,z)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let z of this.expr)w.push(...z.keys());return w}map(w){return new c(this.expr.map(z=>z.map(w)),null)}negate(){if(!this.negated){let w=[];for(let z of this.expr)w.push(z.negate());for(;w.length>1;){const z=w.shift(),q=w.shift(),H=[];for(const Q of A(z))for(const V of A(q))H.push(t.create([Q,V],null));const W=w.length===0;w.unshift(c.create(H,null,W))}this.negated=w[0]}return this.negated}}class v extends g{constructor(w,z,q){super(w,null);this._defaultValue=z,typeof q=="object"?v._info.push({...q,key:w}):q!==!0&&v._info.push({key:w,description:q,type:z!=null?typeof z:void 0})}static all(){return v._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return a.create(this.key,w)}notEqualsTo(w){return S.create(this.key,w)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(x,w){return x<w?-1:x>w?1:0}function p(x,w,z,q){return x<z?-1:x>z?1:w<q?-1:w>q?1:0}function k(x,w){if(w.type===6&&x.type!==9&&x.type!==6){for(const H of w.expr)if(x.equals(H))return!0}const z=x.negate(),q=A(z).concat(A(w));q.sort(M);for(let H=0;H<q.length;H++){const Q=q[H].negate();for(let V=H+1;V<q.length;V++){const te=q[V];if(Q.equals(te))return!0}}return!1}e.implies=k;function A(x){return x.type===9?x.expr:[x]}}),define(ve[138],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[46],Ee([1,0,22,17,10,13,2,119,3]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(W){return W.create===!0}e.isFileOpenForWriteOptions=R;var M;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var b;(function(W){W[W.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var l;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=g;function a(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=a;function n(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=n;function d(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=d;function S(W){return g(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var N;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(N=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(Q,V){super(Q);this.code=V}}e.FileSystemProviderError=f;function m(W,Q){const V=new f(W.toString(),Q);return r(V,Q),V}e.createFileSystemProviderError=m;function E(W){return W||m((0,T.localize)(0,null),N.Unknown)}e.ensureFileSystemProviderError=E;function r(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=r;function P(W){if(!W)return N.Unknown;if(W instanceof f)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return N.Unknown;switch(Q[1]){case N.FileExists:return N.FileExists;case N.FileIsADirectory:return N.FileIsADirectory;case N.FileNotADirectory:return N.FileNotADirectory;case N.FileNotFound:return N.FileNotFound;case N.FileExceedsMemoryLimit:return N.FileExceedsMemoryLimit;case N.FileTooLarge:return N.FileTooLarge;case N.FileWriteLocked:return N.FileWriteLocked;case N.NoPermissions:return N.NoPermissions;case N.Unavailable:return N.Unavailable}return N.Unknown}e.toFileSystemProviderErrorCode=P;function u(W){if(W instanceof h)return W.fileOperationResult;switch(P(W)){case N.FileNotFound:return 1;case N.FileIsADirectory:return 0;case N.FileNotADirectory:return 10;case N.FileWriteLocked:return 5;case N.NoPermissions:return 6;case N.FileExists:return 4;case N.FileExceedsMemoryLimit:return 9;case N.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var i;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(Q,V,te){this.resource=Q,this.operation=V,this.target=te}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=s;var t;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class c{constructor(Q,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Q;const te=new Map;for(const oe of Q){const ie=te.get(oe.type);switch(ie?ie.push([oe.resource,oe]):te.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,ie]of te)switch(oe){case 1:this.added=o.TernarySearchTree.forUris(()=>V),this.added.fill(ie);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>V),this.updated.fill(ie);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>V),this.deleted.fill(ie);break}}contains(Q,...V){return this.doContains(Q,{includeChildren:!1},...V)}affects(Q,...V){return this.doContains(Q,{includeChildren:!0},...V)}doContains(Q,V,...te){if(!Q)return!1;const oe=te.length>0;return!!((!oe||te.includes(1))&&(this.added?.get(Q)||V.includeChildren&&this.added?.findSuperstr(Q))||(!oe||te.includes(0))&&(this.updated?.get(Q)||V.includeChildren&&this.updated?.findSuperstr(Q))||(!oe||te.includes(2))&&(this.deleted?.findSubstr(Q)||V.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function v(W,Q,V){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==I.sep&&(Q+=I.sep),V?(0,_.startsWithIgnoreCase)(W,Q):W.indexOf(Q)===0)}e.isParent=v;class h extends Error{constructor(Q,V,te){super(Q);this.fileOperationResult=V,this.options=te}}e.FileOperationError=h;class p extends h{constructor(Q,V,te){super(Q,2,te);this.stat=V}}e.NotModifiedSinceFileOperationError=p;var k;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=x;async function w(W,Q){if(!Q.hasProvider(y.URI.from({scheme:W.scheme})))return new Promise(V=>{const te=Q.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===W.scheme&&oe.added&&(te.dispose(),V())})})}e.whenProviderRegistered=w,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(Q){return(0,B.isNumber)(Q)||(Q=0),Q<z.KB?(0,T.localize)(1,null,Q.toFixed(0)):Q<z.MB?(0,T.localize)(2,null,(Q/z.KB).toFixed(2)):Q<z.GB?(0,T.localize)(3,null,(Q/z.MB).toFixed(2)):Q<z.TB?(0,T.localize)(4,null,(Q/z.GB).toFixed(2)):(0,T.localize)(5,null,(Q/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var q;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function H(W){return{maxFileSize:W===0?300*z.MB:16*z.GB,maxHeapSize:W===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=H}),define(ve[55],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(..._){this._entries=new Map;for(let[B,y]of _)this.set(B,y)}set(_,B){const y=this._entries.get(_);return this._entries.set(_,B),y}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=o}),define(ve[139],Ee([1,0,11,15,76,137,3,55]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class R extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class M{constructor(a=new T.ServiceCollection,n=!1,d){this._activeInstantiations=new Set,this._services=a,this._strict=n,this._parent=d,this._services.set(y.IInstantiationService,this)}createChild(a){return new M(a,this._strict,this)}invokeFunction(a,...n){let d=l.traceInvocation(a),S=!1;try{return a({get:f=>{if(S)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(f,d);if(!m)throw new Error(`[invokeFunction] unknown service '${f}'`);return m}},...n)}finally{S=!0,d.stop()}}createInstance(a,...n){let d,S;return a instanceof _.SyncDescriptor?(d=l.traceCreation(a.ctor),S=this._createInstance(a.ctor,a.staticArguments.concat(n),d)):(d=l.traceCreation(a),S=this._createInstance(a,n,d)),d.stop(),S}_createInstance(a,n=[],d){let S=y._util.getServiceDependencies(a).sort((m,E)=>m.index-E.index),N=[];for(const m of S){let E=this._getOrCreateServiceInstance(m.id,d);if(!E&&this._strict&&!m.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${m.id}.`);N.push(E)}let f=S.length>0?S[0].index:n.length;if(n.length!==f){console.warn(`[createInstance] First service dependency of ${a.name} at position ${f+1} conflicts with ${n.length} static arguments`);let m=f-n.length;m>0?n=n.concat(new Array(m)):n=n.slice(0,f)}return new a(...[...n,...N])}_setServiceInstance(a,n){if(this._services.get(a)instanceof _.SyncDescriptor)this._services.set(a,n);else if(this._parent)this._parent._setServiceInstance(a,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let n=this._services.get(a);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):n}_getOrCreateServiceInstance(a,n){let d=this._getServiceInstanceOrDescriptor(a);return d instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,d,n.branch(a,!0)):(n.branch(a,!1),d)}_safeCreateAndCacheServiceInstance(a,n,d){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,n,d)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,n,d){const S=new B.Graph(m=>m.id.toString());let N=0;const f=[{id:a,desc:n,_trace:d}];for(;f.length;){const m=f.pop();if(S.lookupOrInsertNode(m),N++>1e3)throw new R(S);for(let E of y._util.getServiceDependencies(m.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(E.id);if(!r&&!E.optional&&console.warn(`[createInstance] ${a} depends on ${E.id} which is NOT registered.`),r instanceof _.SyncDescriptor){const P={id:E.id,desc:r,_trace:m._trace.branch(E.id,!0)};S.insertEdge(m,P),f.push(P)}}}for(;;){const m=S.roots();if(m.length===0){if(!S.isEmpty())throw new R(S);break}for(const{data:E}of m){if(this._getServiceInstanceOrDescriptor(E.id)instanceof _.SyncDescriptor){const P=this._createServiceInstanceWithOwner(E.id,E.desc.ctor,E.desc.staticArguments,E.desc.supportsDelayedInstantiation,E._trace);this._setServiceInstance(E.id,P)}S.removeNode(E)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,n,d=[],S,N){if(this._services.get(a)instanceof _.SyncDescriptor)return this._createServiceInstance(n,d,S,N);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,n,d,S,N);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(a,n=[],d,S){if(d){const N=new o.IdleValue(()=>this._createInstance(a,n,S));return new Proxy(Object.create(null),{get(f,m){if(m in f)return f[m];let E=N.value,r=E[m];return typeof r!="function"||(r=r.bind(E),f[m]=r),r},set(f,m,E){return N.value[m]=E,!0}})}else return this._createInstance(a,n,S)}}e.InstantiationService=M;var b;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(b||(b={}));class l{constructor(a,n){this.type=a,this.name=n,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return C?new l(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(a){return C?new l(0,a.name):l._None}branch(a,n){let d=new l(2,a.toString());return this._dep.push([a,n,d]),d}stop(){let a=Date.now()-this._start;l._totals+=a;let n=!1;function d(N,f){let m=[],E=new Array(N+1).join("	");for(const[r,P,u]of f._dep)if(P&&u){n=!0,m.push(`${E}CREATES -> ${r}`);let i=d(N+1,u);i&&m.push(i)}else m.push(`${E}uses -> ${r}`);return m.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(a>2||n)&&console.log(S.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ve[12],Ee([1,0,43,5,6,23,3]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}var C;(function(P){P[P.Trace=0]="Trace",P[P.Debug=1]="Debug",P[P.Info=2]="Info",P[P.Warning=3]="Warning",P[P.Error=4]="Error",P[P.Critical=5]="Critical",P[P.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function R(P,u,i){switch(u){case C.Trace:P.trace(i);break;case C.Debug:P.debug(i);break;case C.Info:P.info(i);break;case C.Warning:P.warn(i);break;case C.Error:P.error(i);break;case C.Critical:P.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function M(P){let u="";for(let i=0;i<P.length;i++){let s=P[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}u+=(i>0?" ":"")+s}return u}e.format=M;class b extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(u){this.level!==u&&(this.level=u,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class l extends b{constructor(u){super();this.logAlways=u}checkLogLevel(u){return this.logAlways||this.getLevel()<=u}trace(u,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,M([u,...i]))}debug(u,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,M([u,...i]))}info(u,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,M([u,...i]))}warn(u,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,M([u,...i]))}error(u,...i){if(this.checkLogLevel(C.Error))if(u instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=u.stack,this.log(C.Error,M(s))}else this.log(C.Error,M([u,...i]))}critical(u,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,M([u,...i]))}flush(){}}e.AbstractMessageLogger=l;class g extends b{constructor(u=e.DEFAULT_LOG_LEVEL){super();this.setLevel(u),this.useColors=!B.isWindows}trace(u,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,u,...i):console.log(`[main ${T()}]`,u,...i))}debug(u,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,u,...i):console.log(`[main ${T()}]`,u,...i))}info(u,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,u,...i):console.log(`[main ${T()}]`,u,...i))}warn(u,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,u,...i):console.warn(`[main ${T()}]`,u,...i))}error(u,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,u,...i):console.error(`[main ${T()}]`,u,...i))}critical(u,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,u,...i):console.error(`[main ${T()}]`,u,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class a extends b{constructor(u=e.DEFAULT_LOG_LEVEL){super();this.setLevel(u)}trace(u,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",u,...i)}debug(u,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",u,...i)}info(u,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",u,...i)}warn(u,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",u,...i)}error(u,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",u,...i)}critical(u,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",u,...i)}dispose(){}flush(){}}e.ConsoleLogger=a;class n extends b{constructor(u,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=u,this.setLevel(i)}trace(u,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(u),...i])}debug(u,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(u),...i])}info(u,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(u),...i])}warn(u,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(u),...i])}error(u,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(u),...i])}critical(u,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(u),...i])}extractMessage(u){return typeof u=="string"?u:(0,o.toErrorMessage)(u,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=n;class d extends b{constructor(u){super();this.logServices=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const i of this.logServices)i.setLevel(u);super.setLevel(u)}trace(u,...i){for(const s of this.logServices)s.trace(u,...i)}debug(u,...i){for(const s of this.logServices)s.debug(u,...i)}info(u,...i){for(const s of this.logServices)s.info(u,...i)}warn(u,...i){for(const s of this.logServices)s.warn(u,...i)}error(u,...i){for(const s of this.logServices)s.error(u,...i)}critical(u,...i){for(const s of this.logServices)s.critical(u,...i)}flush(){for(const u of this.logServices)u.flush()}dispose(){for(const u of this.logServices)u.dispose()}}e.MultiplexLogService=d;class S extends _.Disposable{constructor(u){super();this.logger=u,this._register(u)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(u){this.logger.setLevel(u)}getLevel(){return this.logger.getLevel()}trace(u,...i){this.logger.trace(u,...i)}debug(u,...i){this.logger.debug(u,...i)}info(u,...i){this.logger.info(u,...i)}warn(u,...i){this.logger.warn(u,...i)}error(u,...i){this.logger.error(u,...i)}critical(u,...i){this.logger.critical(u,...i)}flush(){this.logger.flush()}}e.LogService=S;class N extends _.Disposable{constructor(u,i){super();this.logLevel=u,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(s))}))}getLogger(u){return this.loggers.get(u.toString())}createLogger(u,i){let s=this.loggers.get(u.toString());return s||(s=this.doCreateLogger(u,i?.always?C.Trace:this.logLevel,i),this.loggers.set(u.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(u=>u.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=N;class f{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(u){}getLevel(){return C.Info}trace(u,...i){}debug(u,...i){}info(u,...i){}warn(u,...i){}error(u,...i){}critical(u,...i){}dispose(){}flush(){}}e.NullLogService=f;function m(P){if(P.verbose)return C.Trace;if(typeof P.logLevel=="string"){const u=E(P.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function E(P){switch(P){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=E;function r(P){switch(P){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ve[78],Ee([1,0,34,120,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var B;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(B=e.MarkerTag||(e.MarkerTag={}));var y;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function R(a,n){return n-a}C.compare=R;const M=Object.create(null);M[C.Error]=(0,I.localize)(0,null),M[C.Warning]=(0,I.localize)(1,null),M[C.Info]=(0,I.localize)(2,null);function b(a){return M[a]||""}C.toString=b;function l(a){switch(a){case o.default.Error:return C.Error;case o.default.Warning:return C.Warning;case o.default.Info:return C.Info;case o.default.Ignore:return C.Hint}}C.fromSeverity=l;function g(a){switch(a){case C.Error:return o.default.Error;case C.Warning:return o.default.Warning;case C.Info:return o.default.Info;case C.Hint:return o.default.Ignore}}C.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(C){const R="";function M(l){return b(l,!0)}C.makeKey=M;function b(l,g){let a=[R];return l.source?a.push(l.source.replace("\xA6","\\\xA6")):a.push(R),l.code?typeof l.code=="string"?a.push(l.code.replace("\xA6","\\\xA6")):a.push(l.code.value.replace("\xA6","\\\xA6")):a.push(R),l.severity!==void 0&&l.severity!==null?a.push(y.toString(l.severity)):a.push(R),l.message&&g?a.push(l.message.replace("\xA6","\\\xA6")):a.push(R),l.startLineNumber!==void 0&&l.startLineNumber!==null?a.push(l.startLineNumber.toString()):a.push(R),l.startColumn!==void 0&&l.startColumn!==null?a.push(l.startColumn.toString()):a.push(R),l.endLineNumber!==void 0&&l.endLineNumber!==null?a.push(l.endLineNumber.toString()):a.push(R),l.endColumn!==void 0&&l.endColumn!==null?a.push(l.endColumn.toString()):a.push(R),a.push(R),a.join("\xA6")}C.makeKeyOptionalMessage=b})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ve[140],Ee([1,0,5,34,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,_.createDecorator)("notificationService");var B;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(B=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new C,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=T;class C{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=C}),define(ve[79],Ee([1,0,6,10,2,3]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,B.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,M){return _.URI.isUri(R)?(0,I.equalsIgnoreCase)(R.scheme,M):(0,I.startsWithIgnoreCase)(R,M+":")}e.matchesScheme=y;function T(R,...M){return M.some(b=>y(R,b))}e.matchesSomeScheme=T;function C(R){let M;const b=/^L?(\d+)(?:,(\d+))?/.exec(R.fragment);return b&&(M={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1}),M}e.selectionFragment=C});var Fe=this&&this.__decorate||function(J,e,o,I){var _=arguments.length,B=_<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,o):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(J,e,o,I);else for(var T=J.length-1;T>=0;T--)(y=J[T])&&(B=(_<3?y(B):_>3?y(e,o,B):y(e,o))||B);return _>3&&B&&Object.defineProperty(e,o,B),B},Ne=this&&this.__param||function(J,e){return function(o,I){e(o,I,J)}};define(ve[141],Ee([1,0,11,20,6,3]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,B.createDecorator)("progressService");var y;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let C=class extends _.Disposable{constructor(b,l){super();this.deferred=new o.DeferredPromise,l.withProgress(b,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};C=Fe([Ne(1,e.IProgressService)],C),e.UnmanagedProgress=C;class R extends _.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(b){this.stop();const l=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:g.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,B.createDecorator)("editorProgressService")}),define(ve[37],Ee([1,0,42,13]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(y,T){o.ok(I.isString(y)),o.ok(I.isObject(T)),o.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,T)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new _}),define(ve[142],Ee([1,0,5,37]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class B{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,R){this.schemasById[_(C)]=R,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new B;I.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[80],Ee([1,0,16,5,13,117,142,37]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const M=T.Registry.as(y.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(E,r=!0){this.registerConfigurations([E],r)}registerConfigurations(E,r=!0){const P=this.doRegisterConfigurations(E,r);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:P})}deregisterConfigurations(E){const r=this.doDeregisterConfigurations(E);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:E,remove:r}){const P=[];P.push(...this.doDeregisterConfigurations(r)),P.push(...this.doRegisterConfigurations(E,!1)),M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(P)})}registerDefaultConfigurations(E){const r=[],P=[];for(const{overrides:u,source:i}of E)for(const s in u)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const t={...this.configurationDefaultsOverrides.get(s)?.value||{},...u[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:t});const c={type:"object",default:t,description:B.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:_.isString(i)?void 0:i};P.push(...a(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:u[s],source:i});const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(E){const r=[];for(const{overrides:P,source:u}of E)for(const i in P){const s=this.configurationDefaultsOverrides.get(i),t=_.isString(u)?u:u?.id,c=_.isString(s?.source)?s?.source:s?.source?.id;if(t===c)if(r.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const r of E)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(E,r){const P=[];return E.forEach(u=>{P.push(...this.validateAndRegisterProperties(u,r,u.extensionInfo,u.restrictedProperties)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),P}doDeregisterConfigurations(E){const r=[],P=u=>{if(u.properties)for(const i in u.properties)r.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,u.properties[i]);u.allOf&&u.allOf.forEach(i=>P(i))};for(const u of E){P(u);const i=this.configurationContributors.indexOf(u);i!==-1&&this.configurationContributors.splice(i,1)}return r}validateAndRegisterProperties(E,r=!0,P,u,i=3){i=_.isUndefinedOrNull(E.scope)?i:E.scope;let s=[],t=E.properties;if(t)for(let v in t){if(r&&N(v)){delete t[v];continue}const h=t[v];if(h.source=P,h.defaultDefaultValue=t[v].default,this.updatePropertyDefaultValue(v,h),e.OVERRIDE_PROPERTY_REGEX.test(v)?h.scope=void 0:(h.scope=_.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=_.isUndefinedOrNull(h.restricted)?!!u?.includes(v):h.restricted),t[v].hasOwnProperty("included")&&!t[v].included){this.excludedConfigurationProperties[v]=t[v],delete t[v];continue}else this.configurationProperties[v]=t[v];!t[v].deprecationMessage&&t[v].markdownDeprecationMessage&&(t[v].deprecationMessage=t[v].markdownDeprecationMessage),s.push(v)}let c=E.allOf;if(c)for(let v of c)s.push(...this.validateAndRegisterProperties(v,r,P,u,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(E){const r=P=>{let u=P.properties;if(u)for(const s in u)this.updateSchema(s,u[s]);let i=P.allOf;i&&i.forEach(r)};r(E)}updateSchema(E,r){switch(e.allSettings.properties[E]=r,r.scope){case 1:e.applicationSettings.properties[E]=r;break;case 2:e.machineSettings.properties[E]=r;break;case 6:e.machineOverridableSettings.properties[E]=r;break;case 3:e.windowSettings.properties[E]=r;break;case 4:e.resourceSettings.properties[E]=r;break;case 5:e.resourceSettings.properties[E]=r,this.resourceLanguageSettingsSchema.properties[E]=r;break}}removeFromSchema(E,r){switch(delete e.allSettings.properties[E],r.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E],delete this.resourceLanguageSettingsSchema.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const r=`[${E}]`,P={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,P),e.allSettings.properties[r]=P,e.applicationSettings.properties[r]=P,e.machineSettings.properties[r]=P,e.machineOverridableSettings.properties[r]=P,e.windowSettings.properties[r]=P,e.resourceSettings.properties[r]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const E={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,r){const P=this.configurationDefaultsOverrides.get(E);let u=P?.value,i=P?.source;_.isUndefined(u)&&(u=r.defaultDefaultValue,i=void 0),_.isUndefined(u)&&(u=d(r.type)),r.default=u,r.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(m){const E=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let r=g.exec(m);for(;r?.length;){const P=r[1].trim();P&&E.push(P),r=g.exec(m)}}return(0,o.distinct)(E)}e.overrideIdentifiersFromKey=a;function n(m){return m.reduce((E,r)=>`${E}[${r}]`,"")}e.keyFromOverrideIdentifiers=n;function d(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const S=new b;T.Registry.add(e.Extensions.Configuration,S);function N(m){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?B.localize(7,null,m):S.getConfigurationProperties()[m]!==void 0?B.localize(8,null,m):null:B.localize(6,null)}e.validateProperty=N;function f(){const m=[],E=S.getConfigurationProperties();for(const r of Object.keys(E))m.push([r,E[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=f}),define(ve[143],Ee([1,0,16,5,100,6,22,26,13,2,77,80,37]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(u={},i=[],s=[]){this._contents=u,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(u){return u?(0,M.getConfigurationValue)(this.contents,u):this.contents}getOverrideValue(u,i){const s=this.getContentsForOverrideIdentifer(i);return s?u?(0,M.getConfigurationValue)(s,u):s:void 0}getKeysForOverrideIdentifier(u){const i=[];for(const s of this.overrides)s.identifiers.includes(u)&&i.push(...s.keys);return o.distinct(i)}getAllOverrideIdentifiers(){const u=[];for(const i of this.overrides)u.push(...i.identifiers);return o.distinct(u)}override(u){let i=this.overrideConfigurations.get(u);return i||(i=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,i)),i}merge(...u){const i=T.deepClone(this.contents),s=T.deepClone(this.overrides),t=[...this.keys];for(const c of u){this.mergeContents(i,c.contents);for(const v of c.overrides){const[h]=s.filter(p=>o.equals(p.identifiers,v.identifiers));h?(this.mergeContents(h.contents,v.contents),h.keys.push(...v.keys),h.keys=o.distinct(h.keys)):s.push(T.deepClone(v))}for(const v of c.keys)t.indexOf(v)===-1&&t.push(v)}return new g(i,t,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(u){const i=this.getContentsForOverrideIdentifer(u);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const t of o.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[t],v=i[t];v&&(typeof c=="object"&&typeof v=="object"?(c=T.deepClone(c),this.mergeContents(c,v)):c=v),s[t]=c}return new g(s,this.keys,this.overrides)}mergeContents(u,i){for(const s of Object.keys(i)){if(s in u&&C.isObject(u[s])&&C.isObject(i[s])){this.mergeContents(u[s],i[s]);continue}u[s]=T.deepClone(i[s])}}checkAndFreeze(u){return this.isFrozen&&!Object.isFrozen(u)?T.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let i=null,s=null;const t=c=>{c&&(s?this.mergeContents(s,c):s=T.deepClone(c))};for(const c of this.overrides)o.equals(c.identifiers,[u])?i=c.contents:c.identifiers.includes(u)&&t(c.contents);return t(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,i){this.addKey(u),(0,M.addToValueTree)(this.contents,u,i,s=>{throw new Error(s)})}removeValue(u){this.removeKey(u)&&(0,M.removeFromValueTree)(this.contents,u)}addKey(u){let i=this.keys.length;for(let s=0;s<i;s++)u.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,u)}removeKey(u){let i=this.keys.indexOf(u);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(u={}){const i=l.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),t=Object.create(null),c=[];for(const v in i){const h=u[v],p=h!==void 0?h:i[v].default;(0,M.addToValueTree)(t,v,p,k=>console.error(`Conflict in default settings: ${k}`))}for(const v of Object.keys(t))b.OVERRIDE_PROPERTY_REGEX.test(v)&&c.push({identifiers:(0,b.overrideIdentifiersFromKey)(v),keys:Object.keys(t[v]),contents:(0,M.toValuesTree)(t[v],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,s,c)}}e.DefaultConfigurationModel=a;class n{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,i){if(!C.isUndefinedOrNull(u)){const s=this.doParseContent(u);this.parseRaw(s,i)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,i){this._raw=u;const{contents:s,keys:t,overrides:c,restricted:v}=this.doParseRaw(u,i);this._configurationModel=new g(s,t,c),this._restrictedConfigurations=v||[]}doParseContent(u){let i={},s=null,t=[],c=[],v=[];function h(k){Array.isArray(t)?t.push(k):s!==null&&(t[s]=k)}let p={onObjectBegin:()=>{let k={};h(k),c.push(t),t=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{t=c.pop()},onArrayBegin:()=>{let k=[];h(k),c.push(t),t=k,s=null},onArrayEnd:()=>{t=c.pop()},onLiteralValue:h,onError:(k,A,x)=>{v.push({error:k,offset:A,length:x})}};if(u)try{_.visit(u,p),i=t[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(u,i){const s=l.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),t=this.filter(u,s,!0,i);u=t.raw;const c=(0,M.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),v=Object.keys(u),h=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:c,keys:v,overrides:h,restricted:t.restricted}}filter(u,i,s,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:u,restricted:[]};const c={},v=[];for(let h in u)if(b.OVERRIDE_PROPERTY_REGEX.test(h)&&s){const p=this.filter(u[h],i,!1,t);c[h]=p.raw,v.push(...p.restricted)}else{const p=i[h],k=p?typeof p.scope!="undefined"?p.scope:3:void 0;p?.restricted&&v.push(h),(k===void 0||t.scopes===void 0||t.scopes.includes(k))&&(t.skipRestricted&&p?.restricted||(c[h]=u[h]))}return{raw:c,restricted:v}}toOverrides(u,i){const s=[];for(const t of Object.keys(u))if(b.OVERRIDE_PROPERTY_REGEX.test(t)){const c={};for(const v in u[t])c[v]=u[t][v];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(t),keys:Object.keys(c),contents:(0,M.toValuesTree)(c,i)})}return s}}e.ConfigurationModelParser=n;class d extends B.Disposable{constructor(u,i,s,t){super();this.userSettingsResource=u,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class S{constructor(u,i,s=new g,t=new g,c=new y.ResourceMap,v=new g,h=new y.ResourceMap,p=!0){this._defaultConfiguration=u,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=v,this._memoryConfigurationByResource=h,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(u,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(u)}updateValue(u,i,s={}){let t;s.resource?(t=this._memoryConfigurationByResource.get(s.resource),t||(t=new g,this._memoryConfigurationByResource.set(s.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(u):t.setValue(u,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,i,s){const t=this.getConsolidateConfigurationModel(i,s),c=this.getFolderConfigurationModelForResource(i.resource,s),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this._defaultConfiguration.freeze().getValue(u),p=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.userConfiguration.freeze().getValue(u),k=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.localUserConfiguration.freeze().getValue(u),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.remoteUserConfiguration.freeze().getValue(u),x=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this._workspaceConfiguration.freeze().getValue(u):void 0,w=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(u):c.freeze().getValue(u):void 0,z=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(u):v.getValue(u),q=t.getValue(u),H=o.distinct(o.flatten(t.overrides.map(W=>W.identifiers))).filter(W=>t.getOverrideValue(u,W)!==void 0);return{defaultValue:h,userValue:p,userLocalValue:k,userRemoteValue:A,workspaceValue:x,workspaceFolderValue:w,memoryValue:z,value:q,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:c?.freeze().getValue(u),override:i.overrideIdentifier?c?.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:v.getValue(u),override:i.overrideIdentifier?v.getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(u){const i=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,i){this._folderConfigurations.set(u,i),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,i){const s=[];if(!i){const{added:t,updated:c,removed:v}=E(this._defaultConfiguration,u);i=[...t,...c,...v]}for(const t of i)for(const c of(0,b.overrideIdentifiersFromKey)(t)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=u.getKeysForOverrideIdentifier(c),p=[...h.filter(k=>v.indexOf(k)===-1),...v.filter(k=>h.indexOf(k)===-1),...v.filter(k=>!T.equals(this._defaultConfiguration.override(c).getValue(k),u.override(c).getValue(k)))];s.push([c,p])}return this.updateDefaultConfiguration(u),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(u){const{added:i,updated:s,removed:t,overrides:c}=E(this.localUserConfiguration,u),v=[...i,...s,...t];return v.length&&this.updateLocalUserConfiguration(u),{keys:v,overrides:c}}compareAndUpdateRemoteUserConfiguration(u){const{added:i,updated:s,removed:t,overrides:c}=E(this.remoteUserConfiguration,u);let v=[...i,...s,...t];return v.length&&this.updateRemoteUserConfiguration(u),{keys:v,overrides:c}}compareAndUpdateWorkspaceConfiguration(u){const{added:i,updated:s,removed:t,overrides:c}=E(this.workspaceConfiguration,u);let v=[...i,...s,...t];return v.length&&this.updateWorkspaceConfiguration(u),{keys:v,overrides:c}}compareAndUpdateFolderConfiguration(u,i){const s=this.folderConfigurations.get(u),{added:t,updated:c,removed:v,overrides:h}=E(s,i);let p=[...t,...c,...v];return(p.length||!s)&&this.updateFolderConfiguration(u,i),{keys:p,overrides:h}}compareAndDeleteFolderConfiguration(u){const i=this.folderConfigurations.get(u);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:s,updated:t,removed:c,overrides:v}=E(i,void 0);return{keys:[...s,...t,...c],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(u,i){let s=this.getConsolidatedConfigurationModelForResource(u,i);return u.overrideIdentifier?s.override(u.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:u},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&u){const t=i.getFolder(u);t&&(s=this.getFolderConsolidatedConfiguration(t.uri)||s);const c=this._memoryConfigurationByResource.get(u);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let i=this._foldersConsolidatedConfigurations.get(u);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(u);t?(i=s.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(u,i)):i=s}return i}getFolderConfigurationModelForResource(u,i){if(i&&u){const s=i.getFolder(u);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,i)=>{const{contents:s,overrides:t,keys:c}=this._folderConfigurations.get(i);return u.push([i,{contents:s,overrides:t,keys:c}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>u.add(i)),this.userConfiguration.freeze().keys.forEach(i=>u.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>u.add(s))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>u.add(s))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(u).forEach(t=>i.add(t))),[...i.values()]}static parse(u){const i=this.parseConfigurationModel(u.defaults),s=this.parseConfigurationModel(u.user),t=this.parseConfigurationModel(u.workspace),c=u.folders.reduce((v,h)=>(v.set(R.URI.revive(h[0]),this.parseConfigurationModel(h[1])),v),new y.ResourceMap);return new S(i,s,new g,t,c,new g,new y.ResourceMap,!1)}static parseConfigurationModel(u){return new g(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=S;function N(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const u=new Set,i=new Map;for(const t of P)t.keys.forEach(c=>u.add(c)),t.overrides.forEach(([c,v])=>{const h=(0,y.getOrSet)(i,c,new Set);v.forEach(p=>h.add(p))});const s=[];return i.forEach((t,c)=>s.push([c,[...t.values()]])),{keys:[...u.values()],overrides:s}}e.mergeChanges=N;class f{constructor(u,i,s,t){this.change=u,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=t,this._previousConfiguration=void 0;const c=new Set;u.keys.forEach(h=>c.add(h)),u.overrides.forEach(([,h])=>h.forEach(p=>c.add(p))),this.affectedKeys=[...c.values()];const v=new g;this.affectedKeys.forEach(h=>v.setValue(h,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(u,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(u,i,this.currentWorkspace);return!T.equals(s,t)}return!0}return!1}doesAffectedKeysTreeContains(u,i){let s=(0,M.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof s=="object"&&(t=Object.keys(s)[0]);){if(u=u[t],!u)return!1;s=s[t]}return!0}}e.ConfigurationChangeEvent=f;class m extends f{constructor(u,i,s,t){super({keys:u.allKeys(),overrides:[]},void 0,u,i);this.source=s,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=m;function E(P,u){const{added:i,removed:s,updated:t}=r(u,P),c=[],v=P?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const p=h.filter(k=>!v.includes(k));for(const k of p)c.push([k,u.getKeysForOverrideIdentifier(k)])}if(P){const p=v.filter(k=>!h.includes(k));for(const k of p)c.push([k,P.getKeysForOverrideIdentifier(k)])}if(u&&P){for(const p of v)if(h.includes(p)){const k=r({contents:P.getOverrideValue(void 0,p)||{},keys:P.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});c.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:s,updated:t,overrides:c}}function r(P,u){const i=P?u?P.keys.filter(c=>u.keys.indexOf(c)===-1):[...P.keys]:[],s=u?P?u.keys.filter(c=>P.keys.indexOf(c)===-1):[...u.keys]:[],t=[];if(P&&u){for(const c of u.keys)if(P.keys.indexOf(c)!==-1){const v=(0,M.getConfigurationValue)(u.contents,c),h=(0,M.getConfigurationValue)(P.contents,c);T.equals(v,h)||t.push(c)}}return{added:i,removed:s,updated:t}}}),define(ve[81],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,o.createDecorator)("remoteAuthorityResolverService");var I;(function(B){B.Unknown="Unknown",B.NotAvailable="NotAvailable",B.TemporarilyNotAvailable="TemporarilyNotAvailable",B.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(y,T=I.Unknown,C){super(y);this._message=y,this._code=T,this._detail=C,this.isHandled=T===I.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(y){return y instanceof _&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof _&&y._code===I.NoResolverFound}static isHandled(y){return y instanceof _&&y.isHandled}}e.RemoteAuthorityResolverError=_}),define(ve[82],Ee([1,0,9]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(B){return B.scheme===o.Schemas.vscodeRemote?B.authority:void 0}e.getRemoteAuthority=I;function _(B){if(!B)return;const y=B.indexOf("+");return y<0?B:B.substr(0,y)}e.getRemoteName=_}),define(ve[25],Ee([1,0,10,3,82]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function B(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=B;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g=="undefined"||g===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){let n=typeof g=="string"?g:g.value,d=typeof a=="string"?a:a.value;return o.equalsIgnoreCase(n,d)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function R(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function M(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=M;function b(l,g){if(g){const a=`onResolveRemoteAuthority:${(0,_.getRemoteName)(g)}`;return l.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[144],Ee([1,0,10,25]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(a,n){return a.uuid&&n.uuid?a.uuid===n.uuid:a.id===n.id?!0:(0,o.compareIgnoreCase)(a.id,n.id)===0}e.areSameExtensions=_;class B{constructor(n,d){this.version=d,this.id=n.id,this.uuid=n.uuid}key(){return`${this.id}-${this.version}`}equals(n){return n instanceof B?_(this,n)&&this.version===n.version:!1}}e.ExtensionIdentifierWithVersion=B;function y(a,n){return`${a}.${n}`}e.getExtensionId=y;function T(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function C(a,n){return T(y(a,n))}e.getGalleryExtensionId=C;function R(a,n){const d=[],S=N=>{for(const f of d)if(f.some(m=>_(n(m),n(N))))return f;return null};for(const N of a){const f=S(N);f?f.push(N):d.push([N])}return d}e.groupByExtension=R;function M(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=M;function b(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function l(a){const n=new Set;if(a.malicious)for(const d of a.malicious)n.add(d.id);return n}e.getMaliciousExtensionsSet=l;function g(a,n){const d=[],S=n.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const N=S.shift();if(N&&d.every(f=>!_(f.identifier,{id:N}))){const f=a.filter(m=>_(m.identifier,{id:N}));f.length===1&&(d.push(f[0]),S.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=g}),define(ve[145],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,B,y=5){let T;return T=B(C=>{const R=typeof C=="string"?C:C.data;let M=this._terminalBufferMap.get(_);if(M){M.data.push(R);return}const b=setTimeout(()=>this.flushBuffer(_),y);M={data:[R],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(_),T.dispose()}},this._terminalBufferMap.set(_,M)}),T}stopBuffering(_){const B=this._terminalBufferMap.get(_);B&&B.dispose()}flushBuffer(_){const B=this._terminalBufferMap.get(_);B&&(this._terminalBufferMap.delete(_),this._callback(_,B.data.join("")))}}e.TerminalDataBufferer=o}),define(ve[146],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var o;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(o=e.ColorScheme||(e.ColorScheme={}))}),define(ve[56],Ee([1,0,106,5,6,3,37,146]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,B.createDecorator)("themeService");var C;(function(d){function S(N){return N&&typeof N=="object"&&typeof N.id=="string"}d.isThemeColor=S})(C=e.ThemeColor||(e.ThemeColor={}));function R(d){return{id:d}}e.themeColorFromId=R;var M;(function(d){function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}d.isThemeIcon=S;const N=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const s=N.exec(i);if(!s)return;let[,t]=s;return{id:t}}d.fromString=f;function m(i){return{id:i}}d.fromId=m;function E(i,s){let t=i.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),s&&(t=`${t}~${s}`),{id:t}}d.modify=E;function r(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}d.getModifier=r;function P(i,s){return i.id===s.id&&i.color?.id===s.color?.id}d.isEqual=P;function u(i,s){return{id:i.id,color:s?R(s):void 0}}d.asThemeIcon=u,d.asClassNameArray=o.CSSIcon.asClassNameArray,d.asClassName=o.CSSIcon.asClassName,d.asCSSSelector=o.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function b(d){switch(d){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,_.toDisposable)(()=>{const N=this.themingParticipants.indexOf(S);this.themingParticipants.splice(N,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new l;y.Registry.add(e.Extensions.ThemingContribution,g);function a(d){return g.onColorThemeChange(d)}e.registerThemingParticipant=a;class n extends _.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(N=>this.onThemeChange(N)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,N){let f=this.theme.getColor(S);return f&&N&&(f=N(f,this.theme)),f?f.toString():null}}e.Themable=n}),define(ve[147],Ee([1,0,5,23,3,12]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var y;(function(a){a.Http="http",a.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=b;function l(a,n){return n?n!==1&&a<1024:!I.isWindows&&a<1024}e.isPortPrivileged=l;let g=class{constructor(n){this.logService=n,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],d=Array.from(this._tunnels.values());for(let S of d){const N=Array.from(S.values());for(let f of N){const m=await f.value;m&&n.push(m)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:d}of n.values())await d.then(S=>S?.dispose());n.clear()}this._tunnels.clear()}openTunnel(n,d,S,N,f=!1,m=T.Private,E){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${S} on local port ${N}.`),!n)return;d||(d="localhost");const r=this.retainOrCreateTunnel(n,d,S,N,f,m,E);return r?r.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(P);return(P.tunnelRemoteHost!==d||P.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const d=this._tunnels.get(n.tunnelRemoteHost);if(d){const S=d.get(n.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,S))}}}}async tryDisposeTunnel(n,d,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${d}.`);const N=S.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(d),N}}async closeTunnel(n,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${d} `);const S=this._tunnels.get(n);if(S&&S.has(d)){const N=S.get(d);N.refcount=0,await this.tryDisposeTunnel(n,d,N)}}addTunnelToMap(n,d,S){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(d,{refcount:1,value:S})}async removeEmptyTunnelFromMap(n,d){const S=this._tunnels.get(n);S&&(await S.get(d)||S.delete(d),S.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,d){let S=[n];M(n)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):b(n)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const N=S.map(f=>this._tunnels.get(f));for(const f of N){const m=f?.get(d);if(m)return m}}canTunnel(n){return!!R(n)}createWithProvider(n,d,S,N,f,m,E){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${S} on local port ${N}.`);const P={elevationRequired:f?l(N===void 0?S:N):!1},u={remoteAddress:{host:d,port:S},localAddressPort:N,privacy:m,public:m!==T.Private,protocol:E},i=n.forwardPort(u,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(d,S,i),i}};g=Fe([Ne(0,B.ILogService)],g),e.AbstractTunnelService=g}),define(ve[148],Ee([1,0,9]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(T){return T.scheme!==o.Schemas.file&&T.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=I;function _(T){if(T.folders.length)return T.folders.every(C=>I(C.uri))?T.folders[0].uri:void 0;if(T.configuration&&I(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=_;function B(T){return _(T)?.scheme}e.getVirtualWorkspaceScheme=B;function y(T){return _(T)!==void 0}e.isVirtualWorkspace=y}),define(ve[47],Ee([1,0,121,17,22,24,2,3]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function C(E){const r=E;return typeof r?.id=="string"&&y.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=C;function R(E){if(E.configuration)return{id:E.id,configPath:E.configuration};if(E.folders.length===1)return{id:E.id,uri:E.folders[0].uri}}e.toWorkspaceIdentifier=R;function M(E){const r=E;return typeof r?.id=="string"&&y.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=M;function b(E){const r=E;if(r?.uri)return{id:r.id,uri:y.URI.revive(r.uri)};const P=E;if(P?.configPath)return{id:P.id,configPath:y.URI.revive(P.configPath)};if(E?.id)return{id:E.id}}e.reviveIdentifier=b;var l;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(l=e.WorkbenchState||(e.WorkbenchState={}));function g(E){const r=E;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=g;function a(E){const r=E;return!!(r&&typeof r=="object"&&y.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class n{constructor(r,P,u,i,s){this._id=r,this._transient=u,this._configuration=i,this._ignorePathCasing=s,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=P}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r.with({scheme:r.scheme,authority:r.authority,path:r.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=n;class d{constructor(r,P){this.raw=P,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,B.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function S(E){return new d({uri:E,index:0,name:(0,B.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace";const N=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(E,r){return B.extUriBiasedIgnorePathCase.isEqualOrParent(E,r.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function m(E){return(typeof E=="string"?(0,I.extname)(E):(0,B.extname)(E))===N}e.hasWorkspaceFileExtension=m}),define(ve[57],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const B=this._idPool++;return this._data.set(B,_),this.logDebugInfo(),B}get(_,B){return this._data.has(_)?this._data.get(_)[B]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(ve[30],Ee([1,0,9,24,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class B{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(T=>{const C=this._providerInfo.get(T.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=B,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(ve[28],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ve[149],Ee([1,0,11]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,T,C){this._deferredPromises=new Map,this._id=y,this._shared=T,this._storage=C,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const M of R.values())M.complete()}catch(M){for(const b of R.values())b.error(M)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,T){let C=this._value[y];return typeof C=="undefined"&&(C=T),C}update(y,T){this._value[y]=T;let C=this._deferredPromises.get(y);if(C!==void 0)return C.p;const R=new o.DeferredPromise;return this._deferredPromises.set(y,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class _ extends I{constructor(y,T){super(y.identifier.value,!0,T);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=_}),define(ve[150],Ee([1,0,5,2,12]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let B=class{constructor(T,C){this._logService=T,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new o.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,C,R){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(T)).acceptModelChanged(C.value,R)}$acceptDirtyStateChanged(T,C){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(T)).acceptDirty(C)}$acceptModelSaved(T){const C=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(T));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(T,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,C);const R=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(T));R.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};B=Fe([Ne(0,_.ILogService)],B),e.ExtHostNotebookDocuments=B}),define(ve[14],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class I{constructor(B){this.getProxy=B.getProxy.bind(B),this.set=B.set.bind(B),this.assertRegistered=B.assertRegistered.bind(B),this.drain=B.drain.bind(B)}}e.ExtHostRpcService=I});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[151],Ee([1,0,25,5]),function(J,e,o,I){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class B{constructor(T,C){_.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(T.identifier),je(this,_,C,"f"),De(this,_,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(T){return De(this,_,"f").get(this._id,T)}store(T,C){return De(this,_,"f").store(this._id,T,C)}delete(T){return De(this,_,"f").delete(this._id,T)}}e.ExtensionSecrets=B,_=new WeakMap}),define(ve[83],Ee([1,0,3,5]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(y){this._level=y}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ve[48],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var o;(function(N){N[N.Upsert=0]="Upsert",N[N.RemoveChild=1]="RemoveChild",N[N.Invalidated=2]="Invalidated",N[N.SetProp=3]="SetProp",N[N.Bulk=4]="Bulk"})(o=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const I=new WeakMap,_=(N,f)=>{const m={controllerId:f};return I.set(N,m),m};e.createPrivateApiFor=_;const B=N=>I.get(N);e.getPrivateApiFor=B;const y=(N,f,m,E)=>{let r=m;return{enumerable:!0,configurable:!1,get(){return r},set(P){if(!E(r,P)){const u=r;r=P,N.listener?.({op:3,key:f,value:P,previous:u})}}}},T=(N,f)=>N===f,C={range:(N,f)=>N===f?!0:!N||!f?!1:N.isEqual(f),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(N,f)=>!(N.length!==f.length||N.some(m=>!f.find(E=>m.id===E.id)))},R=Object.keys(C),M=(N,f)=>({range:y(N,"range",void 0,C.range),label:y(N,"label",f,C.label),description:y(N,"description",void 0,C.description),sortText:y(N,"sortText",void 0,C.sortText),canResolveChildren:y(N,"canResolveChildren",!1,C.canResolveChildren),busy:y(N,"busy",!1,C.busy),error:y(N,"error",void 0,C.error),tags:y(N,"tags",[],C.tags)}),b=(N,f)=>{const m=new Map;for(const E of R)C[E](N[E],f[E])||m.set(E,f[E]);return m};e.diffTestItems=b;class l extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=l;class g extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class a extends Error{constructor(f,m,E){super(`TestItem with ID "${f}" is from controller "${m}" and cannot be added as a child of an item from controller "${E}".`)}}e.MixedTestItemController=a;const n=N=>{const f=(0,e.getPrivateApiFor)(N);let m=new Map;return{get size(){return m.size},forEach(E,r){for(const P of m.values())E.call(r,P,this)},replace(E){const r=new Map,P=new Set(m.keys()),u={op:4,ops:[]};for(const i of E){if(!(i instanceof d))throw new g(i.id);const s=(0,e.getPrivateApiFor)(i).controllerId;if(s!==f.controllerId)throw new a(i.id,s,f.controllerId);if(r.has(i.id))throw new l(i.id);r.set(i.id,i),P.delete(i.id),u.ops.push({op:0,item:i})}for(const i of P.keys())u.ops.push({op:1,id:i});f.listener?.(u),m=r},add(E){if(!(E instanceof d))throw new g(E.id);m.set(E.id,E),f.listener?.({op:0,item:E})},delete(E){m.delete(E)&&f.listener?.({op:1,id:E})},get(E){return m.get(E)},toJSON(){return Array.from(m.values())},[Symbol.iterator](){return m.values()}}};class d{constructor(f,m,E,r){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const P=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof S?void 0:P.parent}},children:{value:n(this),enumerable:!0,writable:!1},...M(P,E)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class S extends d{constructor(f,m){super(f,f,m,void 0)}}e.TestItemRootImpl=S}),define(ve[58],Ee([1,0,3,147,5,14]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(C){function R(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:b.protocol}}C.fromApiTunnel=R;function M(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==I.TunnelPrivacyId.ConstantPrivate&&b.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}C.fromServiceTunnel=M})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let T=class{constructor(R){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,M){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,M){return{dispose:()=>{}}}async $providePortAttributes(R,M,b,l,g){return[]}async $forwardPort(R,M){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Fe([Ne(0,B.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[7],Ee([1,0,16,15,72,22,71,10,13,2,36,46,81]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";var g,a,n,d,S,N,f,m,E,r,P,u,i,s,t,c,v,h,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function U(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(U,j),Object.setPrototypeOf(U.prototype,j.prototype),U}let x=S=class{constructor(U){g.set(this,void 0),je(this,g,U,"f")}static from(...U){let ee=U;return new S(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof De(this,g,"f")=="function"&&(De(this,g,"f").call(this),je(this,g,void 0,"f"))}};g=new WeakMap,x=S=Fe([A],x),e.Disposable=x;let w=N=class{constructor(U,ee){if(U<0)throw(0,I.illegalArgument)("line must be non-negative");if(ee<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=U,this._character=ee}static Min(...U){if(U.length===0)throw new TypeError;let ee=U[0];for(let we=1;we<U.length;we++){const He=U[we];He.isBefore(ee)&&(ee=He)}return ee}static Max(...U){if(U.length===0)throw new TypeError;let ee=U[0];for(let we=1;we<U.length;we++){const He=U[we];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(U){if(!U)return!1;if(U instanceof N)return!0;let{line:ee,character:we}=U;return typeof ee=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ee=0){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof U=="undefined"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ee=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ee===0?this:new N(this.line+we,this.character+ee)}with(U,ee=this.character){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof U=="undefined"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ee=typeof U.character=="number"?U.character:this.character),we===this.line&&ee===this.character?this:new N(we,ee)}toJSON(){return{line:this.line,character:this.character}}};w=N=Fe([A],w),e.Position=w;let z=f=class{constructor(U,ee,we,He){let qe,Je;if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new w(U,ee),Je=new w(we,He)):U instanceof w&&ee instanceof w&&(qe=U,Je=ee),!qe||!Je)throw new Error("Invalid arguments");qe.isBefore(Je)?(this._start=qe,this._end=Je):(this._start=Je,this._end=qe)}static isRange(U){return U instanceof f?!0:U?w.isPosition(U.start)&&w.isPosition(U.end):!1}get start(){return this._start}get end(){return this._end}contains(U){return U instanceof f?this.contains(U._start)&&this.contains(U._end):U instanceof w?!(U.isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ee=w.Max(U.start,this._start),we=w.Min(U.end,this._end);if(!ee.isAfter(we))return new f(ee,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ee=w.Min(U.start,this._start),we=w.Max(U.end,this.end);return new f(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ee=this.end){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return U?w.isPosition(U)?we=U:(we=U.start||this.start,ee=U.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new f(we,ee)}toJSON(){return[this.start,this.end]}};z=f=Fe([A],z),e.Range=z;let q=m=class extends z{constructor(U,ee,we,He){let qe,Je;if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new w(U,ee),Je=new w(we,He)):U instanceof w&&ee instanceof w&&(qe=U,Je=ee),!qe||!Je)throw new Error("Invalid arguments");super(qe,Je);this._anchor=qe,this._active=Je}static isSelection(U){return U instanceof m?!0:U?z.isRange(U)&&w.isPosition(U.anchor)&&w.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=m=Fe([A],q),e.Selection=q;class H{constructor(U,ee,we){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,I.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,I.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=H;class W extends Error{constructor(U,ee=l.RemoteAuthorityResolverErrorCode.Unknown,we){super(U);this._message=U,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(U,ee){return new W(U,l.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(U){return new W(U,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var Q;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var V;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=E=class{constructor(U,ee){this._range=U,this._newText=ee}static isTextEdit(U){return U instanceof E?!0:U?z.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ee){return new E(U,ee)}static insert(U,ee){return E.replace(new z(U,U),ee)}static delete(U){return E.replace(U,"")}static setEndOfLine(U){const ee=new E(new z(new w(0,0),new w(0,0)),"");return ee.newEol=U,ee}get range(){return this._range}set range(U){if(U&&!z.isRange(U))throw(0,I.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,I.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,I.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=E=Fe([A],te),e.TextEdit=te;var oe;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(oe=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ee,we,He){this._edits.push({_type:1,from:U,to:ee,options:we,metadata:He})}createFile(U,ee,we){this._edits.push({_type:1,from:void 0,to:U,options:ee,metadata:we})}deleteFile(U,ee,we){this._edits.push({_type:1,from:U,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(U,ee,we){this._edits.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(U,ee,we,He,qe){let Je,Ze,wt=[],Pt;if(Qt.isNotebookRange(ee)&&Ht.isNotebookCellDataArray(we)&&!Ht.isNotebookCellDataArray(He)?(Je=ee.start,Ze=ee.end,wt=we,Pt=He):typeof ee=="number"&&typeof we=="number"&&Ht.isNotebookCellDataArray(He)&&(Je=ee,Ze=we,wt=He,Pt=qe),Je===void 0||Ze===void 0)throw new Error("Invalid arguments");(Je!==Ze||wt.length>0)&&this._edits.push({_type:5,uri:U,index:Je,count:Ze-Je,cells:wt,metadata:Pt})}replaceNotebookCellMetadata(U,ee,we,He){this._edits.push({_type:3,metadata:He,uri:U,edit:{editType:8,index:ee,metadata:we}})}replace(U,ee,we,He){this._edits.push({_type:2,uri:U,edit:new te(ee,we),metadata:He})}insert(U,ee,we,He){this.replace(U,new z(ee,ee),we,He)}delete(U,ee,we){this.replace(U,ee,"",we)}has(U){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===U.toString())}set(U,ee){if(ee)for(const we of ee)we&&this._edits.push({_type:2,uri:U,edit:we});else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];He._type===2&&He.uri.toString()===U.toString()&&(this._edits[we]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(U){const ee=[];for(let we of this._edits)we._type===2&&we.uri.toString()===U.toString()&&ee.push(we.edit);return ee}entries(){const U=new B.ResourceMap;for(let ee of this._edits)if(ee._type===2){let we=U.get(ee.uri);we||(we=[ee.uri,[]],U.set(ee.uri,we)),we[1].push(ee.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Fe([A],ie),e.WorkspaceEdit=ie;let ue=r=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof r?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=r._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ee=this._tabstop++){if(typeof U=="function"){const we=new r;we._tabstop=this._tabstop,U(we),this._tabstop=we._tabstop,U=we.value}else U=r._escape(U);return this.value+="${",this.value+=ee,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ee=this._tabstop++){const we=U.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ee){if(typeof ee=="function"){const we=new r;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ue=r=Fe([A],ue),e.SnippetString=ue;var he;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=P=class{constructor(U,ee){if(this.uri=U,ee)if(ee instanceof z)this.range=ee;else if(ee instanceof w)this.range=new z(ee,ee);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof P?!0:U?z.isRange(U.range)&&R.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=P=Fe([A],fe),e.Location=fe;let ne=class{constructor(U,ee){this.location=U,this.message=ee}static is(U){return U?typeof U.message=="string"&&U.location&&z.isRange(U.location.range)&&R.URI.isUri(U.location.uri):!1}static isEqual(U,ee){return U===ee?!0:!U||!ee?!1:U.message===ee.message&&U.location.range.isEqual(ee.location.range)&&U.location.uri.toString()===ee.location.uri.toString()}};ne=Fe([A],ne),e.DiagnosticRelatedInformation=ne;let me=class{constructor(U,ee,we=Se.Error){if(!z.isRange(U))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=U,this.message=ee,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ee){return U===ee?!0:!U||!ee?!1:U.message===ee.message&&U.severity===ee.severity&&U.code===ee.code&&U.severity===ee.severity&&U.source===ee.source&&U.range.isEqual(ee.range)&&(0,o.equals)(U.tags,ee.tags)&&(0,o.equals)(U.relatedInformation,ee.relatedInformation,ne.isEqual)}};me=Fe([A],me),e.Diagnostic=me;let Ie=class{constructor(U,ee){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ee}};Ie=Fe([A],Ie),e.Hover=Ie;var Ae;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(U,ee=Ae.Text){this.range=U,this.kind=ee}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Ue=Fe([A],Ue),e.DocumentHighlight=Ue;var Ge;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ge=e.SymbolKind||(e.SymbolKind={}));var ge;(function(j){j[j.Deprecated=1]="Deprecated"})(ge=e.SymbolTag||(e.SymbolTag={}));let de=u=class{constructor(U,ee,we,He,qe){this.name=U,this.kind=ee,this.containerName=qe,typeof we=="string"&&(this.containerName=we),He instanceof fe?this.location=He:we instanceof z&&(this.location=new fe(He,we)),u.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ge[this.kind],location:this.location,containerName:this.containerName}}};de=u=Fe([A],de),e.SymbolInformation=de;let L=i=class{constructor(U,ee,we,He,qe){this.name=U,this.detail=ee,this.kind=we,this.range=He,this.selectionRange=qe,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};L=i=Fe([A],L),e.DocumentSymbol=L;var F;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let D=class{constructor(U,ee){this.title=U,this.kind=ee}};D=Fe([A],D),e.CodeAction=D;let O=s=class{constructor(U){this.value=U}append(U){return new s(this.value?this.value+s.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+s.sep)}};O.sep=".",O=s=Fe([A],O),e.CodeActionKind=O,O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll");let $=class{constructor(U,ee){if(this.range=U,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};$=Fe([A],$),e.SelectionRange=$;class X{constructor(U,ee,we,He,qe,Je){this.kind=U,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Je}}e.CallHierarchyItem=X;class re{constructor(U,ee){this.fromRanges=ee,this.from=U}}e.CallHierarchyIncomingCall=re;class pe{constructor(U,ee){this.fromRanges=ee,this.to=U}}e.CallHierarchyOutgoingCall=pe;var Ce;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ce=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(U,ee){this.range=U,this.command=ee}get isResolved(){return!!this.command}};Me=Fe([A],Me),e.CodeLens=Me;let Le=t=class{constructor(U,ee=!1){a.set(this,void 0),je(this,a,new _.MarkdownString(U,{supportThemeIcons:ee}),"f")}static isMarkdownString(U){return U instanceof t?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return De(this,a,"f").value}set value(U){De(this,a,"f").value=U}get isTrusted(){return De(this,a,"f").isTrusted}set isTrusted(U){De(this,a,"f").isTrusted=U}get supportThemeIcons(){return De(this,a,"f").supportThemeIcons}set supportThemeIcons(U){De(this,a,"f").supportThemeIcons=U}get supportHtml(){return De(this,a,"f").supportHtml}set supportHtml(U){De(this,a,"f").supportHtml=U}get baseUri(){return De(this,a,"f").baseUri}set baseUri(U){De(this,a,"f").baseUri=U}appendText(U){return De(this,a,"f").appendText(U),this}appendMarkdown(U){return De(this,a,"f").appendMarkdown(U),this}appendCodeblock(U,ee){return De(this,a,"f").appendCodeblock(ee??"",U),this}};a=new WeakMap,Le=t=Fe([A],Le),e.MarkdownString=Le;let ze=class{constructor(U,ee){this.label=U,this.documentation=ee}};ze=Fe([A],ze),e.ParameterInformation=ze;let xe=class{constructor(U,ee){this.label=U,this.documentation=ee,this.parameters=[]}};xe=Fe([A],xe),e.SignatureInformation=xe;let Oe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Oe=Fe([A],Oe),e.SignatureHelp=Oe;var Xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(U){this.value=U}};ke=Fe([A],ke),e.InlayHintLabelPart=ke;let tt=class{constructor(U,ee,we){this.position=U,this.label=ee,this.kind=we}};tt=Fe([A],tt),e.InlayHint=tt;var G;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(j){j[j.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Re=class{constructor(U,ee){this.label=U,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Re=Fe([A],Re),e.CompletionItem=Re;let $e=class{constructor(U=[],ee=!1){this.items=U,this.isIncomplete=ee}};$e=Fe([A],$e),e.CompletionList=$e;let Ke=class{constructor(U,ee,we){this.text=U,this.range=ee,this.command=we}};Ke=Fe([A],Ke),e.InlineSuggestion=Ke;let Qe=class{constructor(U){this.items=U}};Qe=Fe([A],Qe),e.InlineSuggestions=Qe;var ht;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var _t;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(_t=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function U(ee){switch(ee){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ot=class{constructor(U,ee){if(ee&&!R.URI.isUri(ee))throw(0,I.illegalArgument)("target");if(!z.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.target=ee}};ot=Fe([A],ot),e.DocumentLink=ot;let At=class{constructor(U,ee,we,He){this.red=U,this.green=ee,this.blue=we,this.alpha=He}};At=Fe([A],At),e.Color=At;let Dt=class{constructor(U,ee){if(ee&&!(ee instanceof At))throw(0,I.illegalArgument)("color");if(!z.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.color=ee}};Dt=Fe([A],Dt),e.ColorInformation=Dt;let Ct=class{constructor(U){if(!U||typeof U!="string")throw(0,I.illegalArgument)("label");this.label=U}};Ct=Fe([A],Ct),e.ColorPresentation=Ct;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(U,ee,we){if(this.startIndex=U,this.length=ee,this.tooltip=we,typeof U!="number"||U<0)throw(0,I.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,I.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class se{constructor(U){this.options=U,typeof U!="object"&&(0,I.illegalArgument)("options")}}e.TerminalProfile=se;var _e;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var le;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(le=e.TaskPanelKind||(e.TaskPanelKind={}));let K=c=class{constructor(U,ee){if(this.label=ee,typeof U!="string"||typeof ee!="string")throw(0,I.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};K.Clean=new c("clean","Clean"),K.Build=new c("build","Build"),K.Rebuild=new c("rebuild","Rebuild"),K.Test=new c("test","Test"),K=c=Fe([A],K),e.TaskGroup=K;function be(j){let U="";for(let ee=0;ee<j.length;ee++)U+=j[ee].replace(/,/g,",,")+",";return U}let Te=class{constructor(U,ee,we){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=U,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)U.push(ee);return be(U)}};Te=Fe([A],Te),e.ProcessExecution=Te;let Be=class{constructor(U,ee,we){if(this._args=[],Array.isArray(ee)){if(!U)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U,this._args=ee,this._options=we}else{if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)U.push(typeof ee=="string"?ee:ee.value);return be(U)}};Be=Fe([A],Be),e.ShellExecution=Be;var We;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(We=e.ShellQuoting||(e.ShellQuoting={}));var st;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(st=e.TaskScope||(e.TaskScope={}));class ft{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=ft;let Et=v=class{constructor(U,ee,we,He,qe,Je){this.__deprecated=!1,this._definition=this.definition=U;let Ze;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=He,Ze=qe,this.__deprecated=!0):ee===st.Global||ee===st.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Je):(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Je),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Te?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof Be?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,M.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ee=this._definition.type;(v.EmptyType===ee||v.ProcessType===ee||v.ShellType===ee||v.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=v=Fe([A],Et),e.Task=Et;var vt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let it=class{constructor(U,ee=at.None){this.collapsibleState=ee,R.URI.isUri(U)?this.resourceUri=U:this.label=U}};it=Fe([A],it),e.TreeItem=it;var at;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let mt=class{constructor(U){this.value=U}async asString(){return JSON.stringify(this.value)}};mt=Fe([A],mt),e.TreeDataTransferItem=mt;let Mt=class{constructor(){this._items=new Map}get(U){return this._items.get(U)}set(U,ee){this._items.set(U,ee)}forEach(U){this._items.forEach(U)}};Mt=Fe([A],Mt),e.TreeDataTransfer=Mt;let ct=class{constructor(U,ee){this.id=U,this.color=ee}};ct=Fe([A],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let It=class{constructor(U){this.id=U}};It=Fe([A],It),e.ThemeColor=It;var Ut;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(U,ee){if(typeof U!="string"&&(!U||!R.URI.isUri(U)&&!R.URI.isUri(U.uri)))throw(0,I.illegalArgument)("base");if(typeof ee!="string")throw(0,I.illegalArgument)("pattern");typeof U=="string"?this.baseUri=R.URI.file(U):R.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ee}get base(){return this._base}set base(U){this._base=U,this._baseUri=R.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=Fe([A],bt),e.RelativePattern=bt;let Bt=class{constructor(U,ee,we,He){this.enabled=typeof U=="boolean"?U:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,M.generateUuid)()),this._id}};Bt=Fe([A],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(U,ee,we,He,qe){super(ee,we,He,qe);if(U===null)throw(0,I.illegalArgument)("location");this.location=U}};Wt=Fe([A],Wt),e.SourceBreakpoint=Wt;let dt=class extends Bt{constructor(U,ee,we,He,qe){super(ee,we,He,qe);this.functionName=U}};dt=Fe([A],dt),e.FunctionBreakpoint=dt;let ei=class extends Bt{constructor(U,ee,we,He,qe,Je,Ze){super(He,qe,Je,Ze);if(!ee)throw(0,I.illegalArgument)("dataId");this.label=U,this.dataId=ee,this.canPersist=we}};ei=Fe([A],ei),e.DataBreakpoint=ei;let Yt=class{constructor(U,ee,we){this.command=U,this.args=ee||[],this.options=we}};Yt=Fe([A],Yt),e.DebugAdapterExecutable=Yt;let ti=class{constructor(U,ee){this.port=U,this.host=ee}};ti=Fe([A],ti),e.DebugAdapterServer=ti;let oi=class{constructor(U){this.path=U}};oi=Fe([A],oi),e.DebugAdapterNamedPipeServer=oi;let kt=class{constructor(U){this.implementation=U}};kt=Fe([A],kt),e.DebugAdapterInlineImplementation=kt;let ii=class{constructor(U,ee){this.range=U,this.expression=ee}};ii=Fe([A],ii),e.EvaluatableExpression=ii;var _i;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(_i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Gt=class{constructor(U,ee){this.range=U,this.text=ee}};Gt=Fe([A],Gt),e.InlineValueText=Gt;let Xt=class{constructor(U,ee,we=!0){this.range=U,this.variableName=ee,this.caseSensitiveLookup=we}};Xt=Fe([A],Xt),e.InlineValueVariableLookup=Xt;let rt=class{constructor(U,ee){this.range=U,this.expression=ee}};rt=Fe([A],rt),e.InlineValueEvaluatableExpression=rt;let ai=class{constructor(U,ee){this.frameId=U,this.stoppedLocation=ee}};ai=Fe([A],ai),e.InlineValueContext=ai;var Vt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=h=class extends Error{constructor(U,ee=b.FileSystemProviderErrorCode.Unknown,we){super(R.URI.isUri(U)?U.toString(!0):U);this.code=we?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(U){return new h(U,b.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,b.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,b.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,b.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,b.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,b.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};jt=h=Fe([A],jt),e.FileSystemError=jt;let ni=class{constructor(U,ee,we){this.start=U,this.end=ee,this.kind=we}};ni=Fe([A],ni),e.FoldingRange=ni;var Si;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(gi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(yi=e.CommentMode||(e.CommentMode={}));class pi{constructor(U,ee=[]){this.tokenTypes=U,this.tokenModifiers=ee}}e.SemanticTokensLegend=pi;function ri(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class li{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ee=0,we=U.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(U.tokenTypes[ee],ee);for(let ee=0,we=U.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(U.tokenModifiers[ee],ee)}}push(U,ee,we,He,qe){if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof qe=="number"||typeof qe=="undefined"))return typeof qe=="undefined"&&(qe=0),this._pushEncoded(U,ee,we,He,qe);if(z.isRange(U)&&typeof ee=="string"&&ri(we))return this._push(U,ee,we);throw(0,I.illegalArgument)()}_push(U,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=U.start.line,qe=U.start.character,Je=U.end.character-U.start.character,Ze=this._tokenTypeStrToInt.get(ee);let wt=0;if(we)for(const Pt of we){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);wt|=1<<xt>>>0}this._pushEncoded(He,qe,Je,Ze,wt)}_pushEncoded(U,ee,we,He,qe){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const wt=this._data.length/5|0;let Pt=0,xt=0;for(let zt=0;zt<wt;zt++){let qt=this._data[5*zt],fi=this._data[5*zt+1];qt===0?(qt=Pt,fi+=xt):qt+=Pt,this._data[5*zt]=qt,this._data[5*zt+1]=fi,Pt=qt,xt=fi}}let Je=U,Ze=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=qe,this._prevLine=U,this._prevChar=ee}static _sortAndDeltaEncode(U){let ee=[];const we=U.length/5|0;for(let Ze=0;Ze<we;Ze++)ee[Ze]=Ze;ee.sort((Ze,wt)=>{const Pt=U[5*Ze],xt=U[5*wt];if(Pt===xt){const zt=U[5*Ze+1],qt=U[5*wt+1];return zt-qt}return Pt-xt});const He=new Uint32Array(U.length);let qe=0,Je=0;for(let Ze=0;Ze<we;Ze++){const wt=5*ee[Ze],Pt=U[wt+0],xt=U[wt+1],zt=U[wt+2],qt=U[wt+3],fi=U[wt+4],zi=Pt-qe,Yi=zi===0?xt-Je:xt,mi=5*Ze;He[mi+0]=zi,He[mi+1]=Yi,He[mi+2]=zt,He[mi+3]=qt,He[mi+4]=fi,qe=Pt,Je=xt}return He}build(U){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),U):new Jt(li._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=li;class Jt{constructor(U,ee){this.resultId=ee,this.data=U}}e.SemanticTokens=Jt;class ci{constructor(U,ee,we){this.start=U,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=ci;class Di{constructor(U,ee){this.resultId=ee,this.edits=U}}e.SemanticTokensEdits=Di;var Ci;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ci=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new ct("arrow-left")},$t=Fe([A],$t),e.QuickInputButtons=$t;var Ii;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(U,ee,we){this.badge=U,this.tooltip=ee,this.color=we}static validate(U){if(U.badge){let ee=(0,T.nextCharLength)(U.badge,0);if(ee<U.badge.length&&(ee+=(0,T.nextCharLength)(U.badge,ee)),U.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let ui=class{constructor(U){this.kind=U}};ui=Fe([A],ui),e.ColorTheme=ui;var di;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(U,ee){if(U<0)throw(0,I.illegalArgument)("start must be positive");if(ee<0)throw(0,I.illegalArgument)("end must be positive");U<=ee?(this._start=U,this._end=ee):(this._start=ee,this._end=U)}static isNotebookRange(U){return U instanceof Qt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let ee=this._start,we=this._end;return U.start!==void 0&&(ee=U.start),U.end!==void 0&&(we=U.end),ee===this._start&&we===this._end?this:new Qt(ee,we)}}e.NotebookRange=Qt;class Ht{constructor(U,ee,we,He,qe,Je,Ze){this.kind=U,this.value=ee,this.languageId=we,this.mime=He,this.outputs=qe??[],this.metadata=Je,this.executionSummary=Ze,Ht.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ee=>Ht.isNotebookCellData(ee))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Ht;class Pe{constructor(U){this.cells=U}}e.NotebookData=Pe;class Rt{constructor(U,ee){this.data=U,this.mime=ee;const we=(0,y.normalizeMimeType)(ee,!0);if(!we)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(U){return U instanceof Rt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ee={name:U.name,message:U.message,stack:U.stack};return Rt.json(ee,"application/vnd.code.notebook.error")}static stdout(U){return Rt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Rt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ee="application/octet-stream"){return new Rt(U,ee)}static text(U,ee=y.Mimes.text){const we=De(Rt,n,"f",d).encode(String(U));return new Rt(we,ee)}static json(U,ee="application/json"){const we=JSON.stringify(U,void 0,"	");return Rt.text(we,ee)}}e.NotebookCellOutputItem=Rt,n=Rt,d={value:new TextEncoder};class Zt{constructor(U,ee,we){this.items=Zt.ensureUniqueMimeTypes(U,!0),typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,M.generateUuid)(),this.metadata=ee??we)}static isNotebookCellOutput(U){return U instanceof Zt?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,C.isArray)(U.items)}static ensureUniqueMimeTypes(U,ee=!1){const we=new Set,He=new Set;for(let qe=0;qe<U.length;qe++){const Je=U[qe],Ze=(0,y.normalizeMimeType)(Je.mime);if(!we.has(Ze)){we.add(Ze);continue}He.add(qe),ee&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return He.size===0?U:U.filter((qe,Je)=>!He.has(Je))}}e.NotebookCellOutput=Zt;var ut;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ut=e.NotebookCellKind||(e.NotebookCellKind={}));var Pi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Pi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ei{constructor(U,ee){this.text=U,this.alignment=ee}}e.NotebookCellStatusBarItem=Ei;var Ri;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Ri=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(U,ee=[]){this.uri=U,this.provides=(0,o.asArray)(ee)}}e.NotebookRendererScript=Oi;let hi=class{constructor(U,ee){this.label=U,this.timestamp=ee}};hi=Fe([A],hi),e.TimelineItem=hi;var Fi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var bi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(bi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Ni{constructor(U,ee){this.ranges=U,this.wordPattern=ee}}e.LinkedEditingRanges=Ni;class Li{constructor(U,ee){this._port=U,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Li;var Ui;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Ui=e.TestResultState||(e.TestResultState={}));var Bi;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Bi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(U=void 0,ee=void 0,we=void 0){this.include=U,this.exclude=ee,this.profile=we}};Z=Fe([A],Z),e.TestRunRequest=Z;let ae=p=class{constructor(U){this.message=U}static diff(U,ee,we){const He=new p(U);return He.expectedOutput=ee,He.actualOutput=we,He}};ae=p=Fe([A],ae),e.TestMessage=ae;let ye=class{constructor(U){this.id=U}};ye=Fe([A],ye),e.TestTag=ye;let Ye=class{constructor(U,ee){this.covered=U,this.total=ee}};Ye=Fe([A],Ye),e.CoveredCount=Ye;let gt=k=class{constructor(U,ee,we,He){this.uri=U,this.statementCoverage=ee,this.branchCoverage=we,this.functionCoverage=He}static fromDetails(U,ee){const we=new Ye(0,0),He=new Ye(0,0),qe=new Ye(0,0);for(const Ze of ee)if("branches"in Ze){we.total+=1,we.covered+=Ze.executionCount>0?1:0;for(const wt of Ze.branches)He.total+=1,He.covered+=wt.executionCount>0?1:0}else qe.total+=1,qe.covered+=Ze.executionCount>0?1:0;const Je=new k(U,we,He.total>0?He:void 0,qe.total>0?qe:void 0);return Je.detailedCoverage=ee,Je}};gt=k=Fe([A],gt),e.FileCoverage=gt;let St=class{constructor(U,ee,we=[]){this.executionCount=U,this.location=ee,this.branches=we}};St=Fe([A],St),e.StatementCoverage=St;let xi=class{constructor(U,ee){this.executionCount=U,this.location=ee}};xi=Fe([A],xi),e.BranchCoverage=xi;let $i=class{constructor(U,ee){this.executionCount=U,this.location=ee}};$i=Fe([A],$i),e.FunctionCoverage=$i;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(U,ee,we,He,qe,Je){this.kind=U,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Je}}e.TypeHierarchyItem=Qi}),define(ve[84],Ee([1,0,42,9,10,226,116,7,16]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function M(a,n){n?R.set(a,n):R.delete(a)}e.setWordDefinitionFor=M;function b(a){return R.get(a)}e.getWordDefinitionFor=b;class l extends B.MirrorTextModel{constructor(n,d,S,N,f,m,E,r){super(d,S,N,f);this._proxy=n,this._languageId=m,this._isDirty=E,this._notebook=r,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,C.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===I.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},get notebook(){return n._notebook},save(){return n._save()},getText(d){return d?n._getTextInRange(d):n.getText()},get eol(){return n._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(d){return n._lineAt(d)},offsetAt(d){return n._offsetAt(d)},positionAt(d){return n._positionAt(d)},validateRange(d){return n._validateRange(d)},validatePosition(d){return n._validatePosition(d)},getWordRangeAtPosition(d,S){return n._getWordRangeAtPosition(d,S)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,o.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,o.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const d=this._validateRange(n);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const S=this._eol,N=d.start.line,f=d.end.line,m=[];m.push(this._lines[N].substring(d.start.character));for(let E=N+1;E<f;E++)m.push(this._lines[E]);return m.push(this._lines[f].substring(0,d.end.character)),m.join(S)}_lineAt(n){let d;if(n instanceof T.Position?d=n.line:typeof n=="number"&&(d=n),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new g(d,this._lines[d],d===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(n),S=this._lines[d.index].length;return new T.Position(d.index,Math.min(d.remainder,S))}_validateRange(n){if(!(n instanceof T.Range))throw new Error("Invalid argument");const d=this._validatePosition(n.start),S=this._validatePosition(n.end);return d===n.start&&S===n.end?n:new T.Range(d.line,d.character,S.line,S.character)}_validatePosition(n){if(!(n instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:d,character:S}=n,N=!1;if(d<0)d=0,S=0,N=!0;else if(d>=this._lines.length)d=this._lines.length-1,S=this._lines[d].length,N=!0;else{const f=this._lines[d].length;S<0?(S=0,N=!0):S>f&&(S=f,N=!0)}return N?new T.Position(d,S):n}_getWordRangeAtPosition(n,d){const S=this._validatePosition(n);if(!d)d=b(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const N=(0,y.getWordAtText)(S.character+1,(0,y.ensureValidWordDefinition)(d),this._lines[S.line],0);if(N)return new T.Range(S.line,N.startColumn-1,S.line,N.endColumn-1)}}e.ExtHostDocumentData=l;class g{constructor(n,d,S){this._line=n,this._text=d,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ve[152],Ee([1,0,7,5,227,6,74,22,2,36]),function(J,e,o,I,_,B,y,T,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class M{constructor(l,g,a,n){this._notebook=a,this._selector=n,this._disposables=new B.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(S=>{const N=this._cellUris.get(S.document.uri);N!==void 0&&(this._cellLengths.setValue(N,this._cells[N].document.getText().length+1),this._cellLines.setValue(N,this._cells[N].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(S=>d(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const l=[],g=[];for(const a of this._notebook.getCells())a.kind===o.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),l.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(l){if(!l){let N="";for(const f of this._cells)N+=f.document.getText()+`
`;return N=N.slice(0,-1),N}if(l.isEmpty)return"";const g=this.locationAt(l.start),a=this.locationAt(l.end),n=this._cellUris.get(g.uri),d=this._cellUris.get(a.uri);if(n===void 0||d===void 0)return"";if(n===d)return this._cells[n].document.getText(new o.Range(g.range.start,a.range.end));const S=[this._cells[n].document.getText(new o.Range(g.range.start,new o.Position(this._cells[n].document.lineCount,0)))];for(let N=n+1;N<d;N++)S.push(this._cells[N].document.getText());return S.push(this._cells[d].document.getText(new o.Range(new o.Position(0,0),a.range.end))),S.join(`
`)}offsetAt(l){const g=this._cellLines.getIndexOf(l.line),a=this._cellLengths.getPrefixSum(g.index-1),n=this._cells[g.index].document.offsetAt(l.with(g.remainder));return a+n}positionAt(l){if(typeof l=="number"){const a=this._cellLengths.getIndexOf(l),n=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(n)}const g=this._cellUris.get(l.uri);if(g!==void 0){const a=this._cellLines.getPrefixSum(g-1);return new o.Position(a+l.range.start.line,l.range.start.character)}return new o.Position(0,0)}locationAt(l){o.Range.isRange(l)||(l=new o.Range(l,l));const g=this._cellLines.getIndexOf(l.start.line);let a=g;l.isEmpty||(a=this._cellLines.getIndexOf(l.end.line));const n=new o.Position(g.remainder,l.start.character),d=new o.Position(a.remainder,l.end.character),S=new o.Range(n,d),N=this._cells[g.index];return new o.Location(N.document.uri,N.document.validateRange(S))}contains(l){return this._cellUris.has(l)}validateRange(l){const g=this.validatePosition(l.start),a=this.validatePosition(l.end);return l.with(g,a)}validatePosition(l){const g=this._cellLines.getIndexOf(l.line),a=new o.Position(g.remainder,l.character),n=this._cells[g.index].document.validatePosition(a),d=this._cellLines.getPrefixSum(g.index-1);return new o.Position(d+n.line,n.character)}}e.ExtHostNotebookConcatDocument=M}),define(ve[153],Ee([1,0,7,14,5]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let B=class{constructor(T){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let C=T==="light"?o.ColorThemeKind.Light:T==="dark"?o.ColorThemeKind.Dark:o.ColorThemeKind.HighContrast;this._actual=new o.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostTheming=B}),define(ve[59],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class I{constructor(B){B?(this.transformIncoming=B.transformIncoming.bind(B),this.transformOutgoing=B.transformOutgoing.bind(B),this.transformOutgoingURI=B.transformOutgoingURI.bind(B),this.transformOutgoingScheme=B.transformOutgoingScheme.bind(B)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ve[154],Ee([1,0,21]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(C){let R=this.buffers.indexOf(C);return R<0&&(R=this.buffers.length,this.buffers.push(C)),R}}function _(T,C){if(C.serializeBuffersForPostMessage){const R=new I,M=(g,a)=>{if(a instanceof ArrayBuffer){const n=R.add(a);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(a)){const n=B(a);if(n){const d=R.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:n,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},b=JSON.stringify(T,M),l=R.buffers.map(g=>{const a=new Uint8Array(g);return o.VSBuffer.wrap(a)});return{message:b,buffers:l}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=_;function B(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(T,C){const R=C.map(l=>{const g=new ArrayBuffer(l.byteLength);return new Uint8Array(g).set(l.buffer),g}),M=C.length?(l,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const a=g,{index:n}=a,d=R[n];if(a.view)switch(a.view.type){case 1:return new Int8Array(d,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return g}:void 0;return{message:JSON.parse(T,M),arrayBuffers:R}}e.deserializeWebviewMessage=y}),define(ve[155],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var o;(function(I){function _(y){const T=new Map;return y.types.forEach((C,R)=>{T.set(C,{asString:async()=>y.items[R].asString,value:void 0})}),T}I.toITreeDataTransfer=_;async function B(y){const T={types:[],items:[]},C=Array.from(y.entries());for(const R of C)T.types.push(R[0]),T.items.push({asString:await R[1].asString()});return T}I.toTreeDataTransferDTO=B})(o=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[156],Ee([1,0,129,13,2,6,3,37,46,16,9]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(H){H[H.API=1]="API",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var l;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(l=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(H){const W=H;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}e.isEditorPaneWithSelection=g;function a(H,W,Q){for(const V of Q.visibleEditorPanes)if(V.group.id===W&&H.matches(V.input))return V.getViewState()}e.findViewStateForEditor=a;function n(H){if(P(H))return!1;const W=H;return _.URI.isUri(W?.resource)}e.isResourceEditorInput=n;function d(H){if(P(H))return!1;const W=H;return W?.original!==void 0&&W.modified!==void 0}e.isResourceDiffEditorInput=d;function S(H){if(P(H)||d(H))return!1;const W=H;return W?.primary!==void 0&&W.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function N(H){if(P(H))return!1;const W=H;return W?W.resource===void 0||W.resource.scheme===M.Schemas.untitled||W.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=N;var f;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var m;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m=e.SaveReason||(e.SaveReason={}));var E;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends B.Disposable{}e.AbstractEditorInput=r;function P(H){return H instanceof r}e.isEditorInput=P;function u(H){const W=H;return _.URI.isUri(W?.preferredResource)}function i(H){const W=H;return P(W?.primary)&&P(W?.secondary)}e.isSideBySideEditorInput=i;function s(H){const W=H;return P(W?.modified)&&P(W?.original)}e.isDiffEditorInput=s;function t(H){return P(H?.editor)}e.isEditorInputWithOptions=t;function c(H){const W=H;return t(H)&&W?.group!==void 0}e.isEditorInputWithOptionsAndGroup=c;function v(H){const W=H;return typeof W?.groupId=="number"&&P(W.editor)}e.isEditorIdentifier=v;var h;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var p;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(p=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var k;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(k=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(W,Q){if(!W)return;if(Q?.supportSideBySide){const{primary:te,secondary:oe}=this.getSideEditors(W);if(te&&oe){if(Q?.supportSideBySide===k.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===k.ANY)return this.getOriginalUri(te,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:Q.filterByScheme});W=Q.supportSideBySide===k.PRIMARY?te:oe}}if(d(W)||S(W))return;const V=u(W)?W.preferredResource:W.resource;return!V||!Q||!Q.filterByScheme?V:this.filterUri(V,Q.filterByScheme)}getSideEditors(W){return i(W)||S(W)?{primary:W.primary,secondary:W.secondary}:s(W)||d(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,Q){if(!W)return;if(Q?.supportSideBySide){const{primary:te,secondary:oe}=this.getSideEditors(W);if(te&&oe){if(Q?.supportSideBySide===k.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===k.ANY)return this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:Q.filterByScheme});W=Q.supportSideBySide===k.PRIMARY?te:oe}}if(d(W)||S(W))return;const V=W.resource;return!V||!Q||!Q.filterByScheme?V:this.filterUri(V,Q.filterByScheme)}filterUri(W,Q){if(Array.isArray(Q)){if(Q.some(V=>W.scheme===V))return W}else if(Q===W.scheme)return W}}e.EditorResourceAccessor=new A;var x;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(x=e.CloseDirection||(e.CloseDirection={}));class w{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(W){const Q=this.instantiationService=W.get(y.IInstantiationService);for(const[V,te]of this.editorSerializerConstructors)this.createEditorSerializer(V,te,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(W,Q,V){const te=V.createInstance(Q);this.editorSerializerInstances.set(W,te)}registerFileEditorFactory(W){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=W}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(W,Q){if(this.editorSerializerConstructors.has(W)||this.editorSerializerInstances.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.instantiationService?this.createEditorSerializer(W,Q,this.instantiationService):this.editorSerializerConstructors.set(W,Q),(0,B.toDisposable)(()=>{this.editorSerializerConstructors.delete(W),this.editorSerializerInstances.delete(W)})}getEditorSerializer(W){return this.editorSerializerInstances.get(typeof W=="string"?W:W.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new w);async function z(H,W){if(!H||!H.length)return[];const Q=await Promise.all(H.map(async V=>{const te=_.URI.revive(V.fileUri);if(!te||!await W.canHandleResource(te))return;let ie=V.exists,ue=V.type;if(typeof ie!="boolean"||typeof ue!="number")try{ue=(await W.resolve(te)).isDirectory?C.FileType.Directory:C.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&V.openOnlyIfExists||ue===C.FileType.Directory)return;const he={selection:ie?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let Se;return ie?Se={resource:te,options:he}:Se={resource:te,options:he,forceUntitled:!0},Se}));return(0,R.coalesce)(Q)}e.pathsToEditors=z;var q;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[60],Ee([1,0,9,2]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(T,C){return T.scheme===o.Schemas.http||T.scheme===o.Schemas.https?T:(C&&C.authority&&C.isRemote&&T.scheme===o.Schemas.file&&(T=I.URI.from({scheme:o.Schemas.vscodeRemote,authority:C.authority,path:T.path})),I.URI.from({scheme:o.Schemas.https,authority:`${T.scheme}+${B(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=_;function B(T){return T.replace(/./g,C=>{const R=C.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?C:"-"+R.toString(16).padStart(4,"0")})}function y(T){return T.replace(/-([0-9a-f]{4})/g,(C,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=y}),define(ve[157],Ee([1,0,5,6,60]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class B{constructor(T,C,R){this._proxy=T,this._editors=C,this._initData=R,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const M=C.getVisibleTextEditors();for(const b of this._insets.values())M.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,C,R,M,b){let l;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===T){l=f;break}if(!l)throw new Error("not a visible editor");const g=this,a=this._handlePool++,n=new o.Emitter,d=new o.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,_.asWebviewUri)(f,g._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(f){this._options=f,g._proxy.$setOptions(a,f)}get options(){return this._options}set html(f){this._html=f,g._proxy.$setHtml(a,f)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(f){return g._proxy.$postMessage(a,f)}},N=new class{constructor(){this.editor=T,this.line=C,this.height=R,this.webview=S,this.onDidDispose=d.event}dispose(){g._insets.has(a)&&(g._insets.delete(a),g._proxy.$disposeEditorInset(a),d.fire(),d.dispose(),n.dispose())}};return this._proxy.$createEditorInset(a,l.id,l.value.document.uri,C+1,R,M||{},b.identifier,b.extensionLocation),this._insets.set(a,{editor:T,inset:N,onDidReceiveMessage:n}),N}$onDidDispose(T){const C=this._insets.get(T);C&&C.inset.dispose()}$onDidReceiveMessage(T,C){const R=this._insets.get(T);R&&R.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=B}),define(ve[158],Ee([1,0,5,11,130]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class B{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,C,R,M){const b={command:T};if(C&&Object.keys(C).length>0&&(b.arguments=C),this.internalSend("request",b),typeof M=="number"){const l=setTimeout(()=>{clearTimeout(l);const g=this.pendingRequests.get(b.seq);if(g){this.pendingRequests.delete(b.seq);const a={type:"response",seq:0,request_seq:b.seq,success:!1,command:T,message:(0,_.localize)(0,null,M,T)};g(a)}},M)}return R&&this.pendingRequests.set(b.seq,R),b.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,C){return T.type!=="event"||C.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,I.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":{const C=T,R=this.pendingRequests.get(C.request_seq);R&&(this.pendingRequests.delete(C.request_seq),R(C));break}}}}internalSend(T,C){C.type=T,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((C,R)=>T.set(R,C)),await(0,I.timeout)(500),T.forEach((C,R)=>{C({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=B}),define(ve[159],Ee([1,0,131,45,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(49,null)});const B=b=>o.localize(50,null,b);e.debuggerDisabledMessage=B,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(51,null)};var y;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(y=e.State||(e.State={}));function T(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var C;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(C=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,_.createDecorator)(e.DEBUG_SERVICE_ID);var M;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(M=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[160],Ee([1,0,10,2,17,26,9]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function C(u,i,s){return u.replace(T,function(t,c){return i&&c.length>0&&c[0]!=="_"?t:s&&s.hasOwnProperty(c)?s[c]:t})}e.formatPII=C;function R(u){const i={};for(const s of Object.keys(u))s.startsWith("!")||(i[s]=u[s]);return i}e.filterExceptionsFromTelemetry=R;function M(u){return u.configuration.request==="attach"&&!b(u)&&(!u.parentSession||M(u.parentSession))}e.isSessionAttach=M;function b(u){let i=u.configuration.type;if(!!i)return i==="vslsShare"&&(i=u.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(i,"extensionhost")||(0,o.equalsIgnoreCase)(i,"pwa-extensionhost")?u:u.parentSession?b(u.parentSession):void 0}e.getExtensionHostDebugSession=b;function l(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=l;function g(u,i,s){let t,c=0;const v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=v.exec(u);){const p=h.index+1,k=p+h[0].length;if(p<=i&&k>=s){t=h[0],c=p;break}}if(t){const p=/\w+/g;let k=null;for(;(k=p.exec(t))&&!(k.index+1+c+k[0].length>=s););k&&(t=t.substring(0,p.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(u){return!!(u&&u.match(a))}e.isUri=n;function d(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(n(u.path))return I.URI.parse(u.path);if((0,_.isAbsolute)(u.path))return I.URI.file(u.path)}return u.path}function S(u){if(typeof u.path=="object"){const i=I.URI.revive(u.path);if(i)return i.scheme===y.Schemas.file?i.fsPath:i.toString()}return u.path}function N(u,i){const s=i?d:S,t=(0,B.deepClone)(u);return m(t,(c,v)=>{c&&v&&(v.path=s(v))}),t}e.convertToDAPaths=N;function f(u,i){const s=i?d:S,t=(0,B.deepClone)(u);return m(t,(c,v)=>{!c&&v&&(v.path=s(v))}),t}e.convertToVSCPaths=f;function m(u,i){switch(u.type){case"event":{const s=u;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=u;switch(s.command){case"setBreakpoints":i(!0,s.arguments.source);break;case"breakpointLocations":i(!0,s.arguments.source);break;case"source":i(!0,s.arguments.source);break;case"gotoTargets":i(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const s=u;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":s.body.sources.forEach(t=>i(!1,t));break;case"scopes":s.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":s.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=s;t.body&&t.body.instructions.forEach(c=>i(!1,c.location))}break;default:break}break}}}function E(u){return u.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):r(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:r(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=E;function r(u,i){return typeof u!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:u-i}async function P(u,i){const s=u.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===y.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(ve[85],Ee([1,0,29,161,71,9,17,23,45]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var M;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(M=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var S;(function(p){p.scheme=B.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function A(W,Q){return W.with({scheme:p.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==B.Schemas.file?W.scheme:""}`})}p.generate=A;function x(W){if(W.scheme!==p.scheme)return;const Q=k.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substring(Q[0].length)||B.Schemas.file,fragment:null})}:void 0}p.parse=x;function w(W,Q,V){return W.with({scheme:B.Schemas.vscodeNotebookCellOutput,fragment:`ch${Q.toString().padStart(7,"0")},${V??""},${W.scheme!==B.Schemas.file?W.scheme:""}`})}p.generateCellOutputUri=w;function z(W){if(W.scheme!==B.Schemas.vscodeNotebookCellOutput)return;const Q=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!Q)return;const V=Number(Q[1]),te=Q[2]&&Q[2]!==""?Q[2]:void 0,oe=Q[3];return{handle:V,outputId:te,notebook:W.with({scheme:oe||B.Schemas.file,fragment:null})}}p.parseCellOutputUri=z;function q(W,Q,V){return W.with({scheme:V,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==B.Schemas.file?W.scheme:""}`})}p.generateCellUri=q;function H(W,Q){if(W.scheme!==Q)return;const V=k.exec(W.fragment);return V?{handle:Number(V[1]),notebook:W.with({scheme:W.fragment.substring(V[0].length)||B.Schemas.file,fragment:null})}:void 0}p.parseCellUri=H})(S=e.CellUri||(e.CellUri={}));const N=new Map([["image/git",{alwaysSecure:!0,supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(p){return N.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=f;function m(p){return N.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=m;function E(p){return N.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=E;const r=p=>T.isWindows?p.replace(/\//g,"\\"):p;class P{constructor(k=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(k)].map(x=>({pattern:x,matches:o.parse(r(x))}))}sort(k){const A=new Map(I.Iterable.map(k,w=>[w,r(w)]));let x=[];for(const{matches:w}of this.order)for(const[z,q]of A)if(w(q)){x.push(z),A.delete(z);break}return A.size&&(x=x.concat([...A.keys()].sort((w,z)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(z)))),x}prioritize(k,A){const x=this.findIndex(k);if(x===-1){this.order.unshift({pattern:k,matches:o.parse(r(k))});return}const w=new Set(A.map(q=>this.findIndex(q,x)));w.delete(-1);const z=Array.from(w).sort();this.order.splice(x+1,0,...z.map(q=>this.order[q]));for(let q=z.length-1;q>=0;q--)this.order.splice(z[q],1)}toArray(){return this.order.map(k=>k.pattern)}findIndex(k,A=this.order.length){const x=r(k);for(let w=0;w<A;w++)if(this.order[w].matches(x))return w;return-1}}e.MimeTypeDisplayOrder=P;function u(p,k,A,x=(w,z)=>w===z){const w=[];function z(W,Q,V){if(Q===0&&V.length===0)return;const te=w[w.length-1];te&&te.start+te.deleteCount===W?(te.deleteCount+=Q,te.toInsert.push(...V)):w.push({start:W,deleteCount:Q,toInsert:V})}let q=0,H=0;for(;;){if(q===p.length){z(q,0,k.slice(H));break}if(H===k.length){z(q,p.length-q,[]);break}const W=p[q],Q=k[H];if(x(W,Q)){q+=1,H+=1;continue}A(Q)?(z(q,1,[]),q+=1):(z(q,0,[Q]),H+=1)}return w}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(p){p.default="default",p.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(p){const k=p;return!!((typeof k.include=="string"||o.isRelativePattern(k.include))&&(typeof k.exclude=="string"||o.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=s;function t(p,k,A){if(Array.isArray(p.viewType)&&p.viewType.indexOf(k)>=0||p.viewType===k)return!0;if(p.filenamePattern){const x=s(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,w=s(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(o.match(x,(0,y.basename)(A.fsPath).toLowerCase()))return!(w&&o.match(w,(0,y.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=t;class c{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)k[A]=this.textModel.cells[A].getHashValue();return k}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var v;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(k){return`${h._prefix}${k}`}static parse(k){if(k.startsWith(h._prefix))return k.substring(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(ve[162],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ve[163],Ee([1,0,3,45]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,o.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(B){B[B.Append=1]="Append",B[B.Replace=2]="Replace",B[B.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[164],Ee([1,0,132,3,45]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,o.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,o.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,o.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[165],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=o;function I(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=I}),define(ve[61],Ee([1,0,2,62]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var _;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(_=e.TestResultState||(e.TestResultState={}));var B;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(B=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(s){s.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),s.deserialize=t=>({range:I.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var T;(function(s){s[s.Error=0]="Error",s[s.Info=1]="Info"})(T=e.TestMessageType||(e.TestMessageType={}));var C;(function(s){s.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.deserialize(t.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));var R;(function(s){s.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&y.deserialize(t.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var M;(function(s){s.serialize=t=>t.type===0?C.serialize(t):R.serialize(t),s.deserialize=t=>t.type===0?C.deserialize(t):R.deserialize(t)})(M=e.ITestMessage||(e.ITestMessage={}));var b;(function(s){s.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(M.serialize)}),s.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(M.deserialize)})})(b=e.ITestTaskState||(e.ITestTaskState={}));const l="\0",g=(s,t)=>s+l+t;e.namespaceTestTag=g;const a=s=>{const t=s.indexOf(l);return{ctrlId:s.slice(0,t),tagId:s.slice(t+1)}};e.denamespaceTestTag=a;var n;(function(s){s.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),s.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?I.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(n=e.ITestItem||(e.ITestItem={}));var d;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(s){s.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.serialize(t.item)}),s.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.deserialize(t.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var N;(function(s){s.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},s.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?I.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(N=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(s,t)=>{t.expand!==void 0&&(s.expand=t.expand),t.item!==void 0&&(s.item=s.item?Object.assign(s.item,t.item):t.item)};e.applyTestItemUpdate=f;var m;(function(s){s.serialize=(t,c)=>({...S.serialize(t),children:c,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(b.serialize)})})(m=e.TestResultItem||(e.TestResultItem={}));var E;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var P;(function(s){s.deserialize=t=>t.op===0?{op:t.op,item:S.deserialize(t.item)}:t.op===1?{op:t.op,item:N.deserialize(t.item)}:t,s.serialize=t=>t.op===0?{op:t.op,item:S.serialize(t.item)}:t.op===1?{op:t.op,item:N.serialize(t.item)}:t})(P=e.TestsDiffOp||(e.TestsDiffOp={}));class u{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=u;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const v of t)switch(v.op){case 0:{const h=S.deserialize(v.item);if(h.parent){if(this.items.has(h.parent)){const p=this.items.get(h.parent);p.children.add(h.item.extId);const k=this.createItem(h,p);this.items.set(h.item.extId,k),c.add(k)}}else{const p=this.createItem(h);this.roots.add(p),this.items.set(h.item.extId,p),c.add(p)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=N.deserialize(v.item),p=this.items.get(h.extId);if(!p)break;h.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,h),c.update(p);break}case 2:{const h=this.items.get(v.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const p=[[v.itemId]];for(;p.length;)for(const k of p.pop()){const A=this.items.get(k);A&&(p.push(A.children),this.items.delete(k),c.remove(A,A!==h),A.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(v.itemId);break;case 3:this.updatePendingRoots(v.amount);break;case 5:this._tags.set(v.tag.id,v.tag);break;case 6:this._tags.delete(v.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new u}}e.AbstractIncrementalTestCollection=i}),define(ve[63],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(B){B.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(B){B[B.IsSame=0]="IsSame",B[B.Disconnected=1]="Disconnected",B[B.IsChild=2]="IsChild",B[B.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class _{constructor(y,T=y.length){if(this.path=y,this.viewEnd=T,y.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,T,C=y.parent){if(y.id===T)return new _([T]);let R=[y.id];for(let M=C;M&&M.id!==T;M=M.parent)R.push(M.id);return R.push(T),new _(R.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const T=y.indexOf("\0");return T===-1?y:y.slice(0,T)}static fromString(y){return new _(y.split("\0"))}static join(y,T){return new _([...y.path,T])}static joinToString(y,T){return y.toString()+"\0"+T}static compare(y,T){return y===T?0:T.startsWith(y+"\0")?2:y.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new _(this.path,y)}compare(y){if(typeof y=="string")return _.compare(this.toString(),y);for(let T=0;T<y.viewEnd&&T<this.viewEnd;T++)if(y.path[T]!==this.path[T])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=_}),define(ve[166],Ee([1,0,17,86,13,26,23,73,133]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(b,l,g,a){this._contributedVariables=new Map,this._context=b,this._labelService=l,this._userHomePromise=g,a&&(this._envVariablesPromise=a.then(n=>this.prepareEnv(n)))}prepareEnv(b){if(y.isWindows){const l=Object.create(null);return Object.keys(b).forEach(g=>{l[g.toLowerCase()]=b[g]}),l}return b}resolveWithEnvironment(b,l,g){return this.recursiveResolve(this.prepareEnv(b),l?l.uri:void 0,g)}async resolveAsync(b,l){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,b?b.uri:void 0,l)}async resolveAnyBase(b,l,g,a){const n=B.deepClone(l);y.isWindows&&n.windows?Object.keys(n.windows).forEach(S=>n[S]=n.windows[S]):y.isMacintosh&&n.osx?Object.keys(n.osx).forEach(S=>n[S]=n.osx[S]):y.isLinux&&n.linux&&Object.keys(n.linux).forEach(S=>n[S]=n.linux[S]),delete n.windows,delete n.osx,delete n.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,b?b.uri:void 0,n,g,a)}async resolveAnyAsync(b,l,g){return this.resolveAnyBase(b,l,g)}async resolveAnyMap(b,l,g){const a=new Map;return{newConfig:await this.resolveAnyBase(b,l,g,a),resolvedVariables:a}}resolveWithInteractionReplace(b,l,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,l,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,l){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,l)}recursiveResolve(b,l,g,a,n){if(_.isString(g))return this.resolveString(b,l,g,a,n);if(_.isArray(g))return g.map(d=>this.recursiveResolve(b,l,d,a,n));if(_.isObject(g)){let d=Object.create(null);return Object.keys(g).forEach(S=>{const N=this.resolveString(b,l,S,a,n);d[N]=this.recursiveResolve(b,l,g[S],a,n)}),d}return g}resolveString(b,l,g,a,n){return g.replace(R.VARIABLE_REGEXP,(S,N)=>{if(N.includes(R.VARIABLE_LHS))return S;let f=this.evaluateSingleVariable(b,S,N,l,a);return n&&n.set(N,f),f!==S&&_.isString(f)&&f.match(R.VARIABLE_REGEXP)&&(f=this.resolveString(b,l,f,a,n)),f})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,l,g,a,n){let d;const S=g.split(":");S.length>1&&(g=S[0],d=S[1]);const N=()=>{const E=this._context.getFilePath();if(E)return E;throw new Error((0,C.localize)(0,null,l))},f=()=>{const E=N();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,C.localize)(1,null,l,o.basename(E)))},m=()=>{if(d){const E=this._context.getFolderUri(d);if(E)return E;throw new Error((0,C.localize)(2,null,l,d))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,l)):new Error((0,C.localize)(4,null,l))};switch(g){case"env":if(d){if(b.env){const E=b.env[y.isWindows?d.toLowerCase():d];if(_.isString(E))return E}return""}throw new Error((0,C.localize)(5,null,l));case"config":if(d){const E=this._context.getConfigurationValue(a,d);if(_.isUndefinedOrNull(E))throw new Error((0,C.localize)(6,null,l,d));if(_.isObject(E))throw new Error((0,C.localize)(7,null,l,d));return E}throw new Error((0,C.localize)(8,null,l));case"command":return this.resolveFromMap(l,d,n,"command");case"input":return this.resolveFromMap(l,d,n,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return a||d?(0,T.normalizeDriveLetter)(this.fsPath(m())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(m()));case"userHome":{if(b.userHome)return b.userHome;throw new Error((0,C.localize)(9,null,l))}case"lineNumber":{const E=this._context.getLineNumber();if(E)return E;throw new Error((0,C.localize)(10,null,l))}case"selectedText":{const E=this._context.getSelectedText();if(E)return E;throw new Error((0,C.localize)(11,null,l))}case"file":return N();case"fileWorkspaceFolder":return f();case"relativeFile":return a||d?o.relative(this.fsPath(m()),N()):N();case"relativeFileDirname":{const E=o.dirname(N());if(a||d){const r=o.relative(this.fsPath(m()),E);return r.length===0?".":r}return E}case"fileDirname":return o.dirname(N());case"fileExtname":return o.extname(N());case"fileBasename":return o.basename(N());case"fileBasenameNoExtension":{const E=o.basename(N());return E.slice(0,E.length-o.extname(E).length)}case"fileDirnameBasename":return o.basename(o.dirname(N()));case"execPath":{const E=this._context.getExecPath();return E||l}case"execInstallFolder":{const E=this._context.getAppRoot();return E||l}case"pathSeparator":return o.sep;default:try{const E=d?`${g}:${d}`:g;return this.resolveFromMap(l,E,n,void 0)}catch{return l}}}}resolveFromMap(b,l,g,a){if(l&&g){const n=a===void 0?g[l]:g[a+":"+l];if(typeof n=="string")return n;throw new Error((0,C.localize)(12,null,b))}return b}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[87],Ee([1,0,3,156]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var _;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var B;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(B=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var T;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function R(a){const n=a;return(0,I.isEditorInput)(n?.editor)&&(0,I.isEditorInput)(n?.replacement)}e.isEditorReplacement=R;var M;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function l(a){const n=a;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=l;function g(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(ve[167],Ee([1,0,3,87]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(B){const y=B;return typeof B=="number"||(0,I.isEditorGroup)(y)}e.isPreferredGroup=_}),define(ve[8],Ee([1,0,16,21,72,101,54,26,13,2,62,88,135,78,48,85,61,63,167,7]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(se){function _e(K){const{selectionStartLineNumber:be,selectionStartColumn:Te,positionLineNumber:Be,positionColumn:We}=K,st=new f.Position(be-1,Te-1),ft=new f.Position(Be-1,We-1);return new f.Selection(st,ft)}se.to=_e;function le(K){const{anchor:be,active:Te}=K;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}se.from=le})(m=e.Selection||(e.Selection={}));var E;(function(se){function _e(K){if(!K)return;const{start:be,end:Te}=K;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}se.from=_e;function le(K){if(!K)return;const{startLineNumber:be,startColumn:Te,endLineNumber:Be,endColumn:We}=K;return new f.Range(be-1,Te-1,Be-1,We-1)}se.to=le})(E=e.Range||(e.Range={}));var r;(function(se){function _e(le){switch(le){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 3:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}se.to=_e})(r=e.TokenType||(e.TokenType={}));var P;(function(se){function _e(K){return new f.Position(K.lineNumber-1,K.column-1)}se.to=_e;function le(K){return{lineNumber:K.line+1,column:K.character+1}}se.from=le})(P=e.Position||(e.Position={}));var u;(function(se){function _e(be,Te){return(0,o.coalesce)((0,o.asArray)(be).map(Be=>le(Be,Te)))}se.from=_e;function le(be,Te){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:K(be.scheme,Te),pattern:ce.from(be.pattern)??void 0,exclusive:be.exclusive}}function K(be,Te){return Te&&typeof be=="string"?Te.transformOutgoingScheme(be):be}})(u=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(se){function _e(K){switch(K){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}se.from=_e;function le(K){switch(K){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}se.to=le})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(se){function _e(K){let be;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?be=String(K.code):be={value:String(K.code.value),target:K.code.target}),{...E.from(K.range),message:K.message,source:K.source,code:be,severity:c.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,o.coalesce)(K.tags.map(i.from)):void 0}}se.from=_e;function le(K){const be=new f.Diagnostic(E.to(K),K.message,c.to(K.severity));return be.source=K.source,be.code=(0,C.isString)(K.code)?K.code:K.code?.value,be.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),be.tags=K.tags&&(0,o.coalesce)(K.tags.map(i.to)),be}se.to=le})(s=e.Diagnostic||(e.Diagnostic={}));var t;(function(se){function _e(K){return{...E.from(K.location.range),message:K.message,resource:K.location.uri}}se.from=_e;function le(K){return new f.DiagnosticRelatedInformation(new f.Location(K.resource,E.to(K)),K.message)}se.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(se){function _e(K){switch(K){case f.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}se.from=_e;function le(K){switch(K){case g.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}se.to=le})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var v;(function(se){function _e(K){return typeof K=="number"&&K>=f.ViewColumn.One?K-1:K===f.ViewColumn.Beside?N.SIDE_GROUP:N.ACTIVE_GROUP}se.from=_e;function le(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}se.to=le})(v=e.ViewColumn||(e.ViewColumn={}));function h(se){return typeof se.range!="undefined"}function p(se){return se.length===0?!0:!!h(se[0])}e.isDecorationOptionsArr=p;var k;(function(se){function _e(We){return We.map(se.from)}se.fromMany=_e;function le(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let st;if(le(We)){const{language:it,value:at}=We;st={value:"```"+it+`
`+at+"\n```\n"}}else f.MarkdownString.isMarkdownString(We)?st={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?st={value:We}:st={value:""};const ft=Object.create(null);st.uris=ft;const Et=it=>{try{let at=R.URI.parse(it,!0);at=at.with({query:be(at.query,ft)}),ft[it]=at}catch{}return""},vt=new B.marked.Renderer;return vt.link=Et,vt.image=it=>typeof it=="string"?Et(_.parseHrefAndDimensions(it).href):"",(0,B.marked)(st.value,{renderer:vt}),st}se.from=K;function be(We,st){if(!We)return We;let ft;try{ft=(0,y.parse)(We)}catch{}if(!ft)return We;let Et=!1;return ft=(0,T.cloneAndChange)(ft,vt=>{if(R.URI.isUri(vt)){const it=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[it]=vt,Et=!0,it}else return}),Et?JSON.stringify(ft):We}function Te(We){const st=new f.MarkdownString(We.value,We.supportThemeIcons);return st.isTrusted=We.isTrusted,st.supportHtml=We.supportHtml,st.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,st}se.to=Te;function Be(We){if(!!We)return typeof We=="string"?We:se.from(We)}se.fromStrict=Be})(k=e.MarkdownString||(e.MarkdownString={}));function A(se){return p(se)?se.map(_e=>({range:E.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?k.fromMany(_e.hoverMessage):_e.hoverMessage?k.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):se.map(_e=>({range:E.from(_e)}))}e.fromRangeOrRangeWithMessage=A;function x(se){return typeof se=="undefined"?se:typeof se=="string"?R.URI.file(se):se}e.pathOrURIToURI=x;var w;(function(se){function _e(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?x(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}se.from=_e})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(se){function _e(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?x(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?w.from(le.before):void 0,after:le.after?w.from(le.after):void 0}}se.from=_e})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(se){function _e(le){if(typeof le=="undefined")return le;switch(le){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}se.from=_e})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(se){function _e(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?q.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?z.from(le.light):void 0,dark:le.dark?z.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?x(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?w.from(le.before):void 0,after:le.after?w.from(le.after):void 0}}se.from=_e})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(se){function _e(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:E.from(K.range)}}se.from=_e;function le(K){const be=new f.TextEdit(E.to(K.range),K.text);return be.newEol=typeof K.eol=="undefined"?void 0:et.to(K.eol),be}se.to=le})(W=e.TextEdit||(e.TextEdit={}));var Q;(function(se){function _e(K,be){const Te={edits:[]};if(K instanceof f.WorkspaceEdit)for(let Be of K._allEntries())Be._type===1?Te.edits.push({_type:1,oldUri:Be.from,newUri:Be.to,options:Be.options,metadata:Be.metadata}):Be._type===2?Te.edits.push({_type:2,resource:Be.uri,edit:W.from(Be.edit),modelVersionId:be?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Te.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,edit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:be?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Te.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,notebookVersionId:be?.getNotebookDocumentVersion(Be.uri),edit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(_t.from)}});return Te}se.from=_e;function le(K){const be=new f.WorkspaceEdit;for(const Te of K.edits)Te.edit?be.replace(R.URI.revive(Te.resource),E.to(Te.edit.range),Te.edit.text):be.renameFile(R.URI.revive(Te.oldUri),R.URI.revive(Te.newUri),Te.options);return be}se.to=le})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(se){const _e=Object.create(null);_e[f.SymbolKind.File]=0,_e[f.SymbolKind.Module]=1,_e[f.SymbolKind.Namespace]=2,_e[f.SymbolKind.Package]=3,_e[f.SymbolKind.Class]=4,_e[f.SymbolKind.Method]=5,_e[f.SymbolKind.Property]=6,_e[f.SymbolKind.Field]=7,_e[f.SymbolKind.Constructor]=8,_e[f.SymbolKind.Enum]=9,_e[f.SymbolKind.Interface]=10,_e[f.SymbolKind.Function]=11,_e[f.SymbolKind.Variable]=12,_e[f.SymbolKind.Constant]=13,_e[f.SymbolKind.String]=14,_e[f.SymbolKind.Number]=15,_e[f.SymbolKind.Boolean]=16,_e[f.SymbolKind.Array]=17,_e[f.SymbolKind.Object]=18,_e[f.SymbolKind.Key]=19,_e[f.SymbolKind.Null]=20,_e[f.SymbolKind.EnumMember]=21,_e[f.SymbolKind.Struct]=22,_e[f.SymbolKind.Event]=23,_e[f.SymbolKind.Operator]=24,_e[f.SymbolKind.TypeParameter]=25;function le(be){return typeof _e[be]=="number"?_e[be]:6}se.from=le;function K(be){for(const Te in _e)if(_e[Te]===be)return Number(Te);return f.SymbolKind.Property}se.to=K})(V=e.SymbolKind||(e.SymbolKind={}));var te;(function(se){function _e(K){switch(K){case f.SymbolTag.Deprecated:return 1}}se.from=_e;function le(K){switch(K){case 1:return f.SymbolTag.Deprecated}}se.to=le})(te=e.SymbolTag||(e.SymbolTag={}));var oe;(function(se){function _e(K){return{name:K.name,kind:V.from(K.kind),tags:K.tags&&K.tags.map(te.from),containerName:K.containerName,location:fe.from(K.location)}}se.from=_e;function le(K){const be=new f.SymbolInformation(K.name,V.to(K.kind),K.containerName,fe.to(K.location));return be.tags=K.tags&&K.tags.map(te.to),be}se.to=le})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ie;(function(se){function _e(K){const be={name:K.name||"!!MISSING: name!!",detail:K.detail,range:E.from(K.range),selectionRange:E.from(K.selectionRange),kind:V.from(K.kind),tags:K.tags?.map(te.from)??[]};return K.children&&(be.children=K.children.map(_e)),be}se.from=_e;function le(K){const be=new f.DocumentSymbol(K.name,K.detail,V.to(K.kind),E.to(K.range),E.to(K.selectionRange));return(0,o.isNonEmptyArray)(K.tags)&&(be.tags=K.tags.map(te.to)),K.children&&(be.children=K.children.map(le)),be}se.to=le})(ie=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(se){function _e(K){const be=new f.CallHierarchyItem(V.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),E.to(K.range),E.to(K.selectionRange));return be._sessionId=K._sessionId,be._itemId=K._itemId,be}se.to=_e;function le(K,be,Te){if(be=be??K._sessionId,Te=Te??K._itemId,be===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Te,name:K.name,detail:K.detail,kind:V.from(K.kind),uri:K.uri,range:E.from(K.range),selectionRange:E.from(K.selectionRange),tags:K.tags?.map(te.from)}}se.from=le})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(se){function _e(le){return new f.CallHierarchyIncomingCall(ue.to(le.from),le.fromRanges.map(K=>E.to(K)))}se.to=_e})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(se){function _e(le){return new f.CallHierarchyOutgoingCall(ue.to(le.to),le.fromRanges.map(K=>E.to(K)))}se.to=_e})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(se){function _e(K){return{range:K.range&&E.from(K.range),uri:K.uri}}se.from=_e;function le(K){return new f.Location(R.URI.revive(K.uri),E.to(K.range))}se.to=le})(fe=e.location||(e.location={}));var ne;(function(se){function _e(K){const be=K,Te=K;return{originSelectionRange:be.originSelectionRange?E.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Te.uri,range:E.from(be.targetRange?be.targetRange:Te.range),targetSelectionRange:be.targetSelectionRange?E.from(be.targetSelectionRange):void 0}}se.from=_e;function le(K){return{targetUri:R.URI.revive(K.uri),targetRange:E.to(K.range),targetSelectionRange:K.targetSelectionRange?E.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?E.to(K.originSelectionRange):void 0}}se.to=le})(ne=e.DefinitionLink||(e.DefinitionLink={}));var me;(function(se){function _e(K){return{range:E.from(K.range),contents:k.fromMany(K.contents)}}se.from=_e;function le(K){return new f.Hover(K.contents.map(k.to),E.to(K.range))}se.to=le})(me=e.Hover||(e.Hover={}));var Ie;(function(se){function _e(K){return{range:E.from(K.range),expression:K.expression}}se.from=_e;function le(K){return new f.EvaluatableExpression(E.to(K.range),K.expression)}se.to=le})(Ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ae;(function(se){function _e(K){if(K instanceof f.InlineValueText)return{type:"text",range:E.from(K.range),text:K.text};if(K instanceof f.InlineValueVariableLookup)return{type:"variable",range:E.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:E.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}se.from=_e;function le(K){switch(K.type){case"text":return{range:E.to(K.range),text:K.text};case"variable":return{range:E.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:E.to(K.range),expression:K.expression}}}se.to=le})(Ae=e.InlineValue||(e.InlineValue={}));var Ue;(function(se){function _e(K){return{frameId:K.frameId,stoppedLocation:E.from(K.stoppedLocation)}}se.from=_e;function le(K){return new f.InlineValueContext(K.frameId,E.to(K.stoppedLocation))}se.to=le})(Ue=e.InlineValueContext||(e.InlineValueContext={}));var Ge;(function(se){function _e(K){return{range:E.from(K.range),kind:K.kind}}se.from=_e;function le(K){return new f.DocumentHighlight(E.to(K.range),K.kind)}se.to=le})(Ge=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(se){function _e(le){switch(le){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}se.to=_e})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(se){function _e(le){return{triggerKind:ge.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}se.to=_e})(de=e.CompletionContext||(e.CompletionContext={}));var L;(function(se){function _e(K){switch(K){case f.CompletionItemTag.Deprecated:return 1}}se.from=_e;function le(K){switch(K){case 1:return f.CompletionItemTag.Deprecated}}se.to=le})(L=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(se){const _e=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function le(Te){return _e.get(Te)??9}se.from=le;const K=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function be(Te){return K.get(Te)??f.CompletionItemKind.Property}se.to=be})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var D;(function(se){function _e(le,K){const be=new f.CompletionItem(le.label);return be.insertText=le.insertText,be.kind=F.to(le.kind),be.tags=le.tags?.map(L.to),be.detail=le.detail,be.documentation=_.isMarkdownString(le.documentation)?k.to(le.documentation):le.documentation,be.sortText=le.sortText,be.filterText=le.filterText,be.preselect=le.preselect,be.commitCharacters=le.commitCharacters,M.Range.isIRange(le.range)?be.range=E.to(le.range):typeof le.range=="object"&&(be.range={inserting:E.to(le.range.insert),replacing:E.to(le.range.replace)}),be.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?be.insertText=new f.SnippetString(le.insertText):(be.insertText=le.insertText,be.textEdit=be.range instanceof f.Range?new f.TextEdit(be.range,be.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(be.additionalTextEdits=le.additionalTextEdits.map(Te=>W.to(Te))),be.command=K&&le.command?K.fromInternal(le.command):void 0,be}se.to=_e})(D=e.CompletionItem||(e.CompletionItem={}));var O;(function(se){function _e(K){return{label:K.label,documentation:k.fromStrict(K.documentation)}}se.from=_e;function le(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?k.to(K.documentation):K.documentation}}se.to=le})(O=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(se){function _e(K){return{label:K.label,documentation:k.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(O.from):[],activeParameter:K.activeParameter}}se.from=_e;function le(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?k.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(O.to):[],activeParameter:K.activeParameter}}se.to=le})($=e.SignatureInformation||(e.SignatureInformation={}));var X;(function(se){function _e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map($.from):[]}}se.from=_e;function le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map($.to):[]}}se.to=le})(X=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(se){function _e(le,K){const be=new f.InlayHint(P.to(K.position),typeof K.label=="string"?K.label:K.label.map(pe.to.bind(void 0,le)),Ce.to(K.kind));return be.tooltip=_.isMarkdownString(K.tooltip)?k.to(K.tooltip):K.tooltip,be.command=K.command&&le.fromInternal(K.command),be.paddingLeft=K.paddingLeft,be.paddingRight=K.paddingRight,be}se.to=_e})(re=e.InlayHint||(e.InlayHint={}));var pe;(function(se){function _e(le,K){const be=new f.InlayHintLabelPart(K.label);return be.tooltip=_.isMarkdownString(K.tooltip)?k.to(K.tooltip):K.tooltip,b.Command.is(K.command)&&(be.command=le.fromInternal(K.command)),K.location&&(be.location=fe.to(K.location)),be}se.to=_e})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(se){function _e(K){return K}se.from=_e;function le(K){return K}se.to=le})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(se){function _e(K){return{range:E.from(K.range),url:K.target,tooltip:K.tooltip}}se.from=_e;function le(K){let be;if(K.url)try{be=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new f.DocumentLink(E.to(K.range),be)}se.to=le})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(se){function _e(K){const be=new f.ColorPresentation(K.label);return K.textEdit&&(be.textEdit=W.to(K.textEdit)),K.additionalTextEdits&&(be.additionalTextEdits=K.additionalTextEdits.map(Te=>W.to(Te))),be}se.to=_e;function le(K){return{label:K.label,textEdit:K.textEdit?W.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(be=>W.from(be)):void 0}}se.from=le})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(se){function _e(K){return new f.Color(K[0],K[1],K[2],K[3])}se.to=_e;function le(K){return[K.red,K.green,K.blue,K.alpha]}se.from=le})(ze=e.Color||(e.Color={}));var xe;(function(se){function _e(K){return{range:E.from(K.range)}}se.from=_e;function le(K){return new f.SelectionRange(E.to(K.range))}se.to=le})(xe=e.SelectionRange||(e.SelectionRange={}));var Oe;(function(se){function _e(le){switch(le){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}se.to=_e})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(se){function _e(K){switch(K){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}se.from=_e;function le(K){switch(K){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}se.to=le})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(se){function _e(K){if(K===f.EndOfLine.CRLF)return 1;if(K===f.EndOfLine.LF)return 0}se.from=_e;function le(K){if(K===1)return f.EndOfLine.CRLF;if(K===0)return f.EndOfLine.LF}se.to=le})(et=e.EndOfLine||(e.EndOfLine={}));var ke;(function(se){function _e(le){if(typeof le=="object")return le.viewId;switch(le){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}se.from=_e})(ke=e.ProgressLocation||(e.ProgressLocation={}));var tt;(function(se){function _e(le){const K={start:le.start+1,end:le.end+1};return le.kind&&(K.kind=G.from(le.kind)),K}se.from=_e})(tt=e.FoldingRange||(e.FoldingRange={}));var G;(function(se){function _e(le){if(le)switch(le){case f.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}se.from=_e})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(se){function _e(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?E.from(le.selection):void 0,override:typeof le.override=="boolean"?l.EditorResolution.DISABLED:void 0}}se.from=_e})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(se){function _e(Te){return Te instanceof f.RelativePattern?Te.toJSON():typeof Te=="string"?Te:le(Te)||K(Te)?new f.RelativePattern(Te.baseUri??Te.base,Te.pattern).toJSON():Te}se.from=_e;function le(Te){const Be=Te;return Be?R.URI.isUri(Be.baseUri)&&typeof Be.pattern=="string":!1}function K(Te){const Be=Te;return Be?typeof Be.base=="string"&&typeof Be.pattern=="string":!1}function be(Te){return typeof Te=="string"?Te:new f.RelativePattern(R.URI.revive(Te.baseUri),Te.pattern)}se.to=be})(ce=e.GlobPattern||(e.GlobPattern={}));var Re;(function(se){function _e(le){if(le){if(Array.isArray(le))return le.map(_e);if(typeof le=="string")return le;{const K=le;return{language:K.language,scheme:K.scheme,pattern:ce.from(K.pattern),exclusive:K.exclusive}}}else return}se.from=_e})(Re=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(se){function _e(K){return{start:K.start,end:K.end}}se.from=_e;function le(K){return new f.NotebookRange(K.start,K.end)}se.to=le})($e=e.NotebookRange||(e.NotebookRange={}));var Ke;(function(se){function _e(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}se.to=_e;function le(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}se.from=le})(Ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Qe;(function(se){function _e(K){switch(K){case f.NotebookCellKind.Markup:return n.CellKind.Markup;case f.NotebookCellKind.Code:default:return n.CellKind.Code}}se.from=_e;function le(K){switch(K){case n.CellKind.Markup:return f.NotebookCellKind.Markup;case n.CellKind.Code:default:return f.NotebookCellKind.Code}}se.to=le})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(se){function _e(K){const be={metadata:K.metadata??Object.create(null),cells:[]};for(let Te of K.cells)f.NotebookCellData.validate(Te),be.cells.push(_t.from(Te));return be}se.from=_e;function le(K){const be=new f.NotebookData(K.cells.map(_t.to));return(0,C.isEmptyObject)(K.metadata)||(be.metadata=K.metadata),be}se.to=le})(ht=e.NotebookData||(e.NotebookData={}));var _t;(function(se){function _e(K){return{cellKind:Qe.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ke.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Tt.from):[]}}se.from=_e;function le(K){return new f.NotebookCellData(Qe.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Tt.to):void 0,K.metadata,K.internalMetadata?Ke.to(K.internalMetadata):void 0)}se.to=le})(_t=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(se){function _e(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}se.from=_e;function le(K){return new f.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}se.to=le})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Tt;(function(se){function _e(K){return{outputId:K.id,items:K.items.map(yt.from),metadata:K.metadata}}se.from=_e;function le(K){const be=K.items.map(yt.to);return new f.NotebookCellOutput(be,K.outputId,K.metadata)}se.to=le})(Tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ve;(function(se){function _e(be){return K(be)?{include:(0,C.withNullAsUndefined)(ce.from(be.include)),exclude:(0,C.withNullAsUndefined)(ce.from(be.exclude))}:(0,C.withNullAsUndefined)(ce.from(be))}se.from=_e;function le(be){return K(be)?{include:ce.to(be.include),exclude:ce.to(be.exclude)}:ce.to(be)}se.to=le;function K(be){const Te=be;return Te?!!Te.include&&!!Te.exclude:!1}})(Ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pt;(function(se){function _e(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?w.from(le.top):void 0}}se.from=_e})(pt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Nt;(function(se){function _e(le,K,be){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Te,be),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}se.from=_e})(Nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(se){function _e(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}se.from=_e})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ot;(function(se){function _e(K){return{uri:K.uri,provides:K.provides}}se.from=_e;function le(K){return new f.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}se.to=le})(ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(se){function _e(K){return{message:k.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:E.from(K.location.range),uri:K.location.uri}}}se.from=_e;function le(K){const be=new f.TestMessage(typeof K.message=="string"?K.message:k.to(K.message));return be.actualOutput=K.actual,be.expectedOutput=K.expected,be.location=K.location?fe.to(K.location):void 0,be}se.to=le})(At=e.TestMessage||(e.TestMessage={}));var Dt;(function(se){se.namespace=d.namespaceTestTag,se.denamespace=d.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ct;(function(se){function _e(Te){const Be=(0,a.getPrivateApiFor)(Te).controllerId;return{extId:S.TestId.fromExtHostTestItem(Te,Be).toString(),label:Te.label,uri:R.URI.revive(Te.uri),busy:!1,tags:Te.tags.map(We=>Dt.namespace(Be,We.id)),range:M.Range.lift(E.from(Te.range)),description:Te.description||null,sortText:Te.sortText||null,error:Te.error&&k.fromStrict(Te.error)||null}}se.from=_e;function le(Te){return{parent:void 0,error:void 0,id:S.TestId.fromString(Te.extId).localId,label:Te.label,uri:R.URI.revive(Te.uri),tags:(Te.tags||[]).map(Be=>{const{tagId:We}=Dt.denamespace(Be);return new f.TestTag(We)}),range:E.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0,sortText:Te.sortText||void 0}}se.toPlain=le;function K(Te){const Be=S.TestId.fromString(Te.extId),We=new a.TestItemImpl(Be.controllerId,Be.localId,Te.label,R.URI.revive(Te.uri)||void 0);return We.range=E.to(Te.range||void 0),We.description=Te.description||void 0,We.sortText=Te.sortText||void 0,We}function be(Te){let Be;for(const We of Te.tests){const st=K(We.item);(0,a.getPrivateApiFor)(st).parent=Be,Be=st}return Be}se.toItemFromContext=be})(Ct=e.TestItem||(e.TestItem={})),function(se){function _e(K){return{id:K.id}}se.from=_e;function le(K){return new f.TestTag(K.id)}se.to=le}(Dt=e.TestTag||(e.TestTag={}));var lt;(function(se){const _e=(K,be)=>{const Te={...Ct.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(We=>We.type===0).map(At.to)})),children:K.children.map(Be=>be.get(Be)).filter(C.isDefined).map(Be=>_e(Be,be))};for(const Be of Te.children)Be.parent=Te;return Te};function le(K){const be=[],Te=new Map;for(const Be of K.items)Te.set(Be.item.extId,Be),K.request.targets.some(We=>We.controllerId===Be.controllerId&&We.testIds.includes(Be.item.extId))&&be.push(Be);return{completedAt:K.completedAt,results:be.map(Be=>_e(Be,Te))}}se.to=le})(lt=e.TestResults||(e.TestResults={}));var Ot;(function(se){function _e(Te){return{covered:Te.covered,total:Te.covered}}function le(Te){return"line"in Te?P.from(Te):E.from(Te)}function K(Te){return"branches"in Te?{count:Te.executionCount,location:le(Te.location),type:1,branches:Te.branches.length?Te.branches.map(Be=>({count:Be.executionCount,location:Be.location&&le(Be.location)})):void 0}:{type:0,count:Te.executionCount,location:le(Te.location)}}se.fromDetailed=K;function be(Te){return{uri:Te.uri,statement:_e(Te.statementCoverage),branch:Te.branchCoverage&&_e(Te.branchCoverage),function:Te.functionCoverage&&_e(Te.functionCoverage),details:Te.detailedCoverage?.map(K)}}se.fromFile=be})(Ot=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(se){function _e(le){switch(le){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}se.to=_e})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(se){function _e(K){const be=new f.TypeHierarchyItem(V.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),E.to(K.range),E.to(K.selectionRange));return be._sessionId=K._sessionId,be._itemId=K._itemId,be}se.to=_e;function le(K,be,Te){if(be=be??K._sessionId,Te=Te??K._itemId,be===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Te,kind:V.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:E.from(K.range),selectionRange:E.from(K.selectionRange),tags:K.tags?.map(te.from)}}se.from=le})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[168],Ee([1,0,2,15,7,8,228]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(R,M,b,l={timeout:1500,errors:3}){this._logService=R,this._documents=M,this._mainThreadBulkEdits=b,this._thresholds=l,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(M,b,l)=>{const a={dispose:this._callbacks.push([M,b,R])};return Array.isArray(l)&&l.push(a),a}}async $participateInSave(R,M){const b=o.URI.revive(R);let l=!1;const g=setTimeout(()=>l=!0,this._thresholds.timeout),a=[];try{for(let n of[...this._callbacks]){if(l)break;const d=this._documents.getDocument(b),S=await this._deliverEventAsyncAndBlameBadListeners(n,{document:d,reason:B.TextDocumentSaveReason.to(M)});a.push(S)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([R,M,b],l){const g=this._badListeners.get(R);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,R,M,l).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const n=this._badListeners.get(R);this._badListeners.set(R,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,M,b,l){const g=[],a=Date.now(),{document:n,reason:d}=l,{version:S}=n,N=Object.freeze({document:n,reason:d,waitUntil(f){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(f))}});try{M.apply(b,[N])}catch(f){return Promise.reject(f)}return Object.freeze(g),new Promise((f,m)=>{const E=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(E),f(r)}).catch(r=>{clearTimeout(E),m(r)})}).then(f=>{const m={edits:[]};for(const E of f)if(Array.isArray(E)&&E.every(r=>r instanceof _.TextEdit))for(const{newText:r,newEol:P,range:u}of E)m.edits.push({_type:2,resource:n.uri,edit:{range:u&&B.Range.from(u),text:r,eol:P&&B.EndOfLine.from(P)}});if(m.edits.length!==0)return S===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(ve[169],Ee([1,0,9,26,2,8,85]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(b,l,g,a){this.start=b,this.deletedCount=l,this.deletedItems=g,this.items=a}static asApiEvents(b){return b.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(g=>g.apiCell)}))}}class C{constructor(b,l,g){this.notebook=b,this._extHostDocument=l,this._cellData=g,this.handle=g.handle,this.uri=_.URI.revive(g.uri),this.cellKind=g.cellKind,this._outputs=g.outputs.map(B.NotebookCellOutput.to),this._internalMetadata=g.internalMetadata??{},this._metadata=Object.freeze(g.metadata??{}),this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(g.internalMetadata??{}))}static asModelAddData(b,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:B.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return b._mime},set mime(g){b._mime=g},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}})}return this._apiCell}setOutputs(b){this._outputs=b.map(B.NotebookCellOutput.to)}setOutputItems(b,l,g){const a=g.map(B.NotebookCellOutputItem.to),n=this._outputs.find(d=>d.id===b);n&&(l||(n.items.length=0),n.items.push(...a))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=C;class R{constructor(b,l,g,a,n,d){this._proxy=b,this._textDocumentsAndEditors=l,this._textDocuments=g,this._emitter=a,this.uri=n,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this;this._notebook={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===o.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(l){return l=b._validateIndex(l),b._cells[l].apiCell},getCells(l){return(l?b._getCells(l):b._cells).map(a=>a.apiCell)},save(){return b._save()}}}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,l){this._versionId=b.versionId,this._isDirty=l;for(const g of b.rawEvents)g.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1):g.kind===y.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx):g.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(g.index,g.outputs):g.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems):g.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(g.index,g.language):g.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(g.index,g.metadata):g.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(g.index,g.internalMetadata)}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let l=b.start|0,g=b.end|0;return l<0&&(l=0),g>this._cells.length&&(g=this._cells.length),b.with({start:l,end:g})}_getCells(b){b=this._validateRange(b);const l=[];for(let g=b.start;g<b.end;g++)l.push(this._cells[g]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,l){if(this._disposed)return;const g=[],a=[],n=[];b.reverse().forEach(d=>{const N=d[2].map(E=>{const r=new C(this,this._textDocumentsAndEditors,E);return l||a.push(C.asModelAddData(this.apiNotebook,E)),r}),f=new T(d[0],d[1],[],N),m=this._cells.splice(d[0],d[1],...N);for(const E of m)n.push(E.uri),f.deletedItems.push(E.apiCell);g.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:n}),l||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:T.asApiEvents(g)}))}_moveCell(b,l){const g=this._cells.splice(b,1);this._cells.splice(l,0,...g);const a=[new T(b,1,g.map(n=>n.apiCell),[]),new T(l,0,[],g)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:T.asApiEvents(a)}))}_setCellOutputs(b,l){const g=this._cells[b];g.setOutputs(l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_setCellOutputItems(b,l,g,a){const n=this._cells[b];n.setOutputItems(l,g,a),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[n.apiCell]}))}_changeCellLanguage(b,l){const g=this._cells[b];g.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(g.uri,l)}_changeCellMime(b,l){const g=this._cells[b];g.apiCell.mime=l}_changeCellMetadata(b,l){const g=this._cells[b],a=g.apiCell.metadata;g.setMetadata(l);const n=g.apiCell.metadata;(0,I.equals)(a,n)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:g.apiCell}))}_changeCellInternalMetadata(b,l){this._cells[b].setInternalMetadata(l)}getCellFromApiCell(b){return this._cells.find(l=>l.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(l=>l.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ve[89],Ee([1,0,7,8,15]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class B{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:R})}replaceCells(C,R,M){this._throwIfFinalized(),!(C===R&&M.length===0)&&this._collectedEdits.push({editType:1,index:C,count:R-C,cells:M.map(I.NotebookCellData.from)})}}class y{constructor(C,R,M,b,l,g){this.id=C,this._proxy=R,this.notebookData=M,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=b,this._viewColumn=g}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(R){if(!Array.isArray(R)||!R.every(o.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");C._selections=R,C._trySetSelections(R)},get visibleRanges(){return C._visibleRanges},revealRange(R,M){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(R),M??o.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(R){const M=new B(this.document.version);return R(M),C._applyEdit(M.finalize())},setDecorations(R,M){return C.setDecorations(R,M)}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(I.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const R=[];let M=-1;for(let b=0;b<C.cellEdits.length;b++){if(M<0){R.push(C.cellEdits[b]),M++;continue}const g=R[M],a=C.cellEdits[b];if(g.editType===1&&a.editType===1&&g.index===a.index){g.cells.push(...C.cellEdits[b].cells),g.count+=C.cellEdits[b].count;continue}R.push(C.cellEdits[b]),M++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,R)}setDecorations(C,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return R.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(R),C.key)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(ve[170],Ee([1,0,8,141,124,20,52,15]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,g,a){const n=this._handles++,{title:d,location:S,cancellable:N}=g,f={label:(0,_.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(n,{location:o.ProgressLocation.from(S),title:d,source:f,cancellable:N},l.isUnderDevelopment?void 0:l.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(n,a,!!N)}_withProgress(l,g,a){let n;a&&(n=new B.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,n));const d=N=>{this._proxy.$progressEnd(N),this._mapHandleToCancellationSource.delete(N),n&&n.dispose()};let S;try{S=g(new M(this._proxy,l),a&&n?n.token:B.CancellationToken.None)}catch(N){throw d(l),N}return S.then(N=>d(l),N=>d(l)),S}$acceptProgressCanceled(l){const g=this._mapHandleToCancellationSource.get(l);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=C;function R(b,l){return b.message=l.message,typeof l.increment=="number"&&(typeof b.increment=="number"?b.increment+=l.increment:b.increment=l.increment),b}class M extends I.Progress{constructor(l,g){super(a=>this.throttledReport(a));this._proxy=l,this._handle=g}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}Fe([(0,y.throttle)(100,(b,l)=>R(b,l),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(ve[90],Ee([1,0,42,15,53,8,7]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(l,g,a){const n=T._Keys.nextId();l.$registerTextEditorDecorationType(g.identifier,n,B.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=T,T._Keys=new _.IdGenerator("TextEditorDecorationType");class C{constructor(l,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,g){this._throwIfFinalized();let a=null;if(l instanceof y.Position)a=new y.Range(l,l);else if(l instanceof y.Range)a=l;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(l,g){this._throwIfFinalized(),this._pushEdit(new y.Range(l,l),g,!0)}delete(l){this._throwIfFinalized();let g=null;if(l instanceof y.Range)g=l;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(l,g,a){const n=this._document.validateRange(l);this._collectedEdits.push({range:n,text:g,forceMoveMarkers:a})}setEndOfLine(l){if(this._throwIfFinalized(),l!==y.EndOfLine.LF&&l!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=C;class R{constructor(l,g,a,n){this._proxy=l,this._id=g,this._accept(a),this._logService=n;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(S){d._setTabSize(S)},get insertSpaces(){return d._insertSpaces},set insertSpaces(S){d._setInsertSpaces(S)},get cursorStyle(){return d._cursorStyle},set cursorStyle(S){d._setCursorStyle(S)},get lineNumbers(){return d._lineNumbers},set lineNumbers(S){d._setLineNumbers(S)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=B.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const g=Math.floor(l);return g>0?g:null}if(typeof l=="string"){const g=parseInt(l,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(l){const g=this._validateTabSize(l);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const g=this._validateInsertSpaces(l);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:B.TextEditorLineNumbersStyle.from(l)})))}assign(l){const g={};let a=!1;if(typeof l.tabSize!="undefined"){const n=this._validateTabSize(l.tabSize);n==="auto"?(a=!0,g.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,a=!0,g.tabSize=n)}if(typeof l.insertSpaces!="undefined"){const n=this._validateInsertSpaces(l.insertSpaces);n==="auto"?(a=!0,g.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,a=!0,g.insertSpaces=n)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,a=!0,g.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,a=!0,g.lineNumbers=B.TextEditorLineNumbersStyle.from(l.lineNumbers)),a&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(l,g){g.catch(a=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(a)})}}e.ExtHostTextEditorOptions=R;class M{constructor(l,g,a,n,d,S,N,f){this.id=l,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new R(this._proxy,this.id,S,a),this._visibleRanges=N,this._viewColumn=f;const m=this;this.value=Object.freeze({get document(){return n.getValue()},set document(E){throw(0,I.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(E){if(!(E instanceof y.Selection))throw(0,I.illegalArgument)("selection");m._selections=[E],m._trySetSelection()},get selections(){return m._selections},set selections(E){if(!Array.isArray(E)||E.some(r=>!(r instanceof y.Selection)))throw(0,I.illegalArgument)("selections");m._selections=E,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(E){throw(0,I.readonly)("visibleRanges")},get options(){return m._options.value},set options(E){m._disposed||m._options.assign(E)},get viewColumn(){return m._viewColumn},set viewColumn(E){throw(0,I.readonly)("viewColumn")},edit(E,r={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new C(n.getValue(),r);return E(P),m._applyEdit(P)},insertSnippet(E,r,P={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!r||Array.isArray(r)&&r.length===0)u=m._selections.map(i=>B.Range.from(i));else if(r instanceof y.Position){const{lineNumber:i,column:s}=B.Position.from(r);u=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(r instanceof y.Range)u=[B.Range.from(r)];else{u=[];for(const i of r)if(i instanceof y.Range)u.push(B.Range.from(i));else{const{lineNumber:s,column:t}=B.Position.from(i);u.push({startLineNumber:s,startColumn:t,endLineNumber:s,endColumn:t})}}return g.$tryInsertSnippet(l,E.value,u,P)},setDecorations(E,r){const P=r.length===0;P&&!m._hasDecorationsForKey.has(E.key)||(P?m._hasDecorationsForKey.delete(E.key):m._hasDecorationsForKey.add(E.key),m._runOnProxy(()=>{if(B.isDecorationOptionsArr(r))return g.$trySetDecorations(l,E.key,B.fromRangeOrRangeWithMessage(r));{const u=new Array(4*r.length);for(let i=0,s=r.length;i<s;i++){const t=r[i];u[4*i]=t.start.line+1,u[4*i+1]=t.start.character+1,u[4*i+2]=t.end.line+1,u[4*i+3]=t.end.character+1}return g.$trySetDecorationsFast(l,E.key,u)}}))},revealRange(E,r){m._runOnProxy(()=>g.$tryRevealRange(l,B.Range.from(E),r||y.TextEditorRevealType.Default))},show(E){g.$tryShowEditor(l,B.ViewColumn.from(E))},hide(){g.$tryHideEditor(l)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,o.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,o.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,o.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,o.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(B.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const g=l.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(d=>d.range);a.sort((d,S)=>d.end.line===S.end.line?d.end.character===S.end.character?d.start.line===S.start.line?d.start.character-S.start.character:d.start.line-S.start.line:d.end.character-S.end.character:d.end.line-S.end.line);for(let d=0,S=a.length-1;d<S;d++){const N=a[d].end;if(a[d+1].start.isBefore(N))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=g.edits.map(d=>({range:B.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,n,{setEndOfLine:typeof g.setEndOfLine=="number"?B.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=M}),define(ve[171],Ee([1,0,11,5,6,13,48,8,61,63]),function(J,e,o,I,_,B,y,T,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class M extends _.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.root=new y.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const g=this.diff[this.diff.length-1];if(g&&l.op===1){if(g.op===1&&g.item.extId===l.item.extId){(0,C.applyTestItemUpdate)(g.item,l.item);return}if(g.op===0&&g.item.item.extId===l.item.extId){(0,C.applyTestItemUpdate)(g.item,l.item);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,g){const a=this.tree.get(l);if(!!a){if((a.expandLevels===void 0||g>a.expandLevels)&&(a.expandLevels=g),a.expand===1){const n=this.resolveChildren(a);return n.isOpen()?this.expandChildren(a,g-1):n.wait().then(()=>this.expandChildren(a,g-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,g-1)):this.expandChildren(a,g-1)}}dispose(){for(const l of this.tree.values())(0,y.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:l.fullId.toString()});break;case 1:this.removeItem(R.TestId.joinToString(l.fullId,g.id));break;case 0:this.upsertItem(g.item,l);break;case 4:for(const a of g.ops)this.onTestItemEvent(l,a);break;case 3:{const{key:a,value:n,previous:d}=g,S=l.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(n,d,S);break;case"range":this.pushDiff({op:1,item:{extId:S,item:{range:T.Range.from(n)}}});break;case"error":this.pushDiff({op:1,item:{extId:S,item:{error:T.MarkdownString.fromStrict(n)||null}}});break;default:this.pushDiff({op:1,item:{extId:S,item:{[a]:n??null}}});break}break}default:(0,B.assertNever)(g)}}upsertItem(l,g){if(!(l instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const a=R.TestId.fromExtHostTestItem(l,this.root.id,g?.actual),n=(0,y.getPrivateApiFor)(l);n.parent&&n.parent!==g?.actual&&n.parent.children.delete(l.id);let d=this.tree.get(a.toString());if(!d){d={fullId:a,actual:l,parent:g?a.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(l,g),this.pushDiff({op:0,item:{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:T.TestItem.from(l)}}),this.connectItemAndChildren(l,d,g);return}if(d.actual===l){this.connectItem(l,d,g);return}const S=d.actual.children,N=d.actual,f=(0,y.diffTestItems)(N,l);(0,y.getPrivateApiFor)(N).listener=void 0,d.actual=l,d.expand=0;for(const[m,E]of f)this.onTestItemEvent(d,{op:3,key:m,value:E,previous:N[m]});this.connectItemAndChildren(l,d,g);for(const m of S)l.children.get(m.id)||this.removeItem(R.TestId.joinToString(a,m.id))}diffTagRefs(l,g,a){const n=new Set(g.map(d=>d.id));for(const d of l)n.delete(d.id)||this.incrementTagRefs(d);this.pushDiff({op:1,item:{extId:a,item:{tags:l.map(d=>T.TestTag.namespace(this.controllerId,d.id))}}}),n.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const g=this.tags.get(l.id);g?g.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff({op:5,tag:{id:T.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}}))}decrementTagRefs(l){const g=this.tags.get(l);g&&!--g.refCount&&(this.tags.delete(l),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.controllerId,l)}))}setItemParent(l,g){(0,y.getPrivateApiFor)(l).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(l,g,a){this.setItemParent(l,a);const n=(0,y.getPrivateApiFor)(l);n.parent=a?.actual,n.listener=d=>this.onTestItemEvent(g,d),this.updateExpandability(g)}connectItemAndChildren(l,g,a){this.connectItem(l,g,a);for(const n of l.children)this.upsertItem(n,g)}updateExpandability(l){let g;this._resolveHandler?l.resolveBarrier?g=l.resolveBarrier.isOpen()?3:2:g=l.actual.canResolveChildren?1:0:g=0,g!==l.expand&&(l.expand=g,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:g}}),g===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,g){if(g<0)return;const a=[];for(const n of l.actual.children){const d=this.expand(R.TestId.joinToString(l.fullId,n.id),g);(0,o.isThenable)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const d=new o.Barrier;return d.open(),d}l.expand=2,this.pushExpandStateUpdate(l);const g=l.resolveBarrier=new o.Barrier,a=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=d.stack||d.message||String(d))};let n;try{n=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(d){a(d)}return(0,o.isThenable)(n)?n.catch(a).then(()=>{g.open(),this.updateExpandability(l)}):(g.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}removeItem(l){const g=this.tree.get(l);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:l});const a=[g];for(;a.length;){const n=a.pop();if(!!n){(0,y.getPrivateApiFor)(n.actual).listener=void 0;for(const d of n.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(n.fullId.toString());for(const d of n.actual.children)a.push(this.tree.get(R.TestId.joinToString(n.fullId,d.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=M}),define(ve[172],Ee([1,0,3,138]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(I.IEnvironmentService)}),define(ve[173],Ee([1,0,25,5,17]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class B{constructor(M){this.removedDueToLooping=M}}e.DeltaExtensionsResult=B;class y{constructor(M){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=M,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const M of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(M.identifier))){console.error("Extension `"+M.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(M.identifier),M),this._extensionsArr.push(M),Array.isArray(M.activationEvents))for(let b of M.activationEvents)b==="onUri"&&(b=`onUri:${o.ExtensionIdentifier.toKey(M.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(M)}}keepOnly(M){const b=new Set;M.forEach(l=>b.add(o.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>b.has(o.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(M,b){M.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(M));const l=y._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(l.map(g=>g.identifier)),b.length>0){const g=new Set;b.forEach(a=>g.add(o.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(o.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new B(l)}static _findLoopingExtensions(M){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,S){this.addNode(d),this.addNode(S),this._arcs.has(d)?this._arcs.get(d).push(S):this._arcs.set(d,[S])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,S){const N=b.getArcs(d);for(let f=0;f<N.length;f++)if(!S.has(N[f]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let d of M){const S=o.ExtensionIdentifier.toKey(d.identifier);if(l.set(S,d),d.extensionDependencies)for(let N of d.extensionDependencies){const f=o.ExtensionIdentifier.toKey(N);b.addArc(S,f)}}let g=new Set;b.getNodes().filter(d=>b.getArcs(d).length===0).forEach(d=>g.add(d));let a=b.getNodes().filter(d=>!g.has(d)),n;do{n=!1;for(let d=0;d<a.length;d++){const S=a[d];b.hasOnlyGoodArcs(S,g)&&(a.splice(d,1),d--,g.add(S),n=!0)}}while(n);return a.map(d=>l.get(d))}containsActivationEvent(M){return this._activationMap.has(M)}containsExtension(M){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(M))}getExtensionDescriptionsForActivationEvent(M){const b=this._activationMap.get(M);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(M){const b=this._extensionsMap.get(o.ExtensionIdentifier.toKey(M));return b||void 0}}e.ExtensionDescriptionRegistry=y;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function C(R,M){const b=R.isBuiltin?0:R.isUnderDevelopment?2:1,l=M.isBuiltin?0:M.isUnderDevelopment?2:1;if(b!==l)return b-l;const g=_.posix.basename(R.extensionLocation.path),a=_.posix.basename(M.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(ve[91],Ee([1,0,21]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var _;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(_=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var B;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(B=e.MessageType||(e.MessageType={}));function y(C){const R=o.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function T(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T}),define(ve[27],Ee([1,0,5,2,3,25,144]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new B.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var T;(function(m){m[m.None=0]="None",m[m.LocalProcess=1]="LocalProcess",m[m.LocalWebWorker=2]="LocalWebWorker",m[m.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(m){switch(m){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class R{constructor(E){this.dependency=E}}e.MissingExtensionDependency=R;var M;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(M=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(m){switch(m){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function l(m,E){return m.enabledApiProposals?m.enabledApiProposals.includes(E):!1}e.isProposedApiEnabled=l;function g(m,E){if(!l(m,E))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${E}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${E}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.checkProposedApiEnabled=g;class a{constructor(E,r,P,u){this.codeLoadingTime=E,this.activateCallTime=r,this.activateResolvedTime=P,this.activationReason=u}}e.ActivationTimes=a;class n{constructor(E,r){this.description=E,this.value=r}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var d;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function S(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=S;function N(m,E){return{identifier:new B.ExtensionIdentifier((0,y.getExtensionId)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!E,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid}}e.toExtensionDescription=N;class f{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,r){return Promise.resolve()}}e.NullExtensionService=f}),define(ve[174],Ee([1,0,15,25,27,12]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class T{constructor(n,d,S,N){this.startup=n,this.codeLoadingTime=d,this.activateCallTime=S,this.activateResolvedTime=N}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,d){return n===-1||d===-1?-1:d-n}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class R{constructor(n,d,S,N,f,m){this.activationFailed=n,this.activationFailedError=d,this.activationTimes=S,this.module=N,this.exports=f,this.subscriptions=m}}e.ActivatedExtension=R;class M extends R{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=M;class b extends R{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class l extends R{constructor(n){super(!0,n,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let g=class{constructor(n,d,S,N,f){this._logService=f,this._isDisposed=!1,this._registry=n,this._resolvedExtensionsSet=new Set,d.forEach(m=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(m))),this._hostExtensionsMap=new Map,S.forEach(m=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(m),m)),this._host=N,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(n){const d=I.ExtensionIdentifier.toKey(n);return this._activatedExtensions.has(d)}getActivatedExtension(n){const d=I.ExtensionIdentifier.toKey(n),S=this._activatedExtensions.get(d);if(!S)throw new Error("Extension `"+n.value+"` is not known or not activated");return S}activateByEvent(n,d){if(this._alreadyActivatedEvents[n])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(n);return this._activateExtensions(S.map(N=>({id:N.identifier,reason:{startup:d,extensionId:N.identifier,activationEvent:n}}))).then(()=>{this._alreadyActivatedEvents[n]=!0})}activateById(n,d){const S=this._registry.getExtensionDescription(n);if(!S)throw new Error("Extension `"+n+"` is not known");return this._activateExtensions([{id:S.identifier,reason:d}])}_handleActivateRequest(n,d,S){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n.id))){d[I.ExtensionIdentifier.toKey(n.id)]=n;return}const N=this._registry.getExtensionDescription(n.id);if(!N){const E=new Error(`Cannot activate unknown extension '${n.id.value}'`);this._host.onExtensionActivationError(n.id,E,new _.MissingExtensionDependency(n.id.value)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(n.id),new l(E));return}const f=typeof N.extensionDependencies=="undefined"?[]:N.extensionDependencies;let m=!0;for(let E=0,r=f.length;E<r;E++){const P=f[E];if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(P)))continue;const u=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(P));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const c=N.displayName||N.identifier.value,v=this._registry.getExtensionDescription(P),h=v&&v.displayName||P,p=new Error(`Cannot activate the '${c}' extension because its dependency '${h}' failed to activate`);p.detail=u.activationFailedError,this._host.onExtensionActivationError(N.identifier,p,null),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(N.identifier),new l(p));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(P))){m=!1,d[I.ExtensionIdentifier.toKey(P)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(P)),reason:n.reason};continue}const i=this._registry.getExtensionDescription(P);if(i){if(!i.main&&!i.browser)continue;m=!1,d[I.ExtensionIdentifier.toKey(P)]={id:i.identifier,reason:n.reason};continue}const s=N.displayName||N.identifier.value,t=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${P}'`);this._host.onExtensionActivationError(N.identifier,t,new _.MissingExtensionDependency(P)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(N.identifier),new l(t));return}m?d[I.ExtensionIdentifier.toKey(N.identifier)]=n:S.push(n)}_activateExtensions(n){if(n.length===0||(n=n.filter(f=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(f.id))),n.length===0))return Promise.resolve(void 0);const d=Object.create(null),S=[];for(let f=0,m=n.length;f<m;f++)this._handleActivateRequest(n[f],d,S);for(let f=0,m=S.length;f<m;f++){const E=I.ExtensionIdentifier.toKey(S[f].id);d[E]&&delete d[E]}const N=Object.keys(d).map(f=>d[f]);return S.length===0?Promise.all(N.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(N).then(f=>this._activateExtensions(S))}_activateExtension(n,d){const S=I.ExtensionIdentifier.toKey(n);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const N=this._activatingExtensions.get(S);if(N)return N;const f=this._host.actualActivateExtension(n,d).then(void 0,m=>{const E=new Error;return m&&m.name&&(E.name=m.name),m&&m.message?E.message=`Activating extension '${n.value}' failed: ${m.message}.`:E.message=`Activating extension '${n.value}' failed: ${m}.`,m&&m.stack&&(E.stack=m.stack),this._isDisposed&&o.isCancellationError(m)?new l(m):(this._host.onExtensionActivationError(n,E,null),this._logService.error(`Activating extension ${n.value} failed due to an error:`),this._logService.error(m),new l(m))}).then(m=>{this._activatedExtensions.set(S,m),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,f),f}};g=Fe([Ne(4,B.ILogService)],g),e.ExtensionsActivator=g}),define(ve[175],Ee([1,0,12,28,27]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let B=class extends o.LogService{constructor(T,C){super(T.createLogger(C.logFile,{name:_.ExtensionHostLogFileName}))}};B=Fe([Ne(0,o.ILoggerService),Ne(1,I.IExtHostInitDataService)],B),e.ExtHostLogService=B}),define(ve[176],Ee([1,0,15]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((B,y)=>{this._actualOk=B,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(B){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=B,this._actual&&this._actualOk(B))}resolveErr(B){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=B,this._actual?this._actualErr(B):(0,o.onUnexpectedError)(B))}then(B,y){return this._ensureActual().then(B,y)}catch(B){return this._ensureActual().then(void 0,B)}finally(B){return this._ensureActual().finally(B)}}e.LazyPromise=I}),define(ve[38],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(C){this._proxyIdentifierBrand=void 0,this.sid=C,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const I=[];function _(T){const C=new o(T);return I[C.nid]=C,C}e.createProxyIdentifier=_;function B(T){return I[T].sid}e.getStringIdentifierForProxy=B;class y{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=y}),define(ve[4],Ee([1,0,54,2,38]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var B;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(B=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(S){S[S.Editable=0]="Editable",S[S.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(S){S[S.Int8Array=1]="Int8Array",S[S.Uint8Array=2]="Uint8Array",S[S.Uint8ClampedArray=3]="Uint8ClampedArray",S[S.Int16Array=4]="Int16Array",S[S.Uint16Array=5]="Uint16Array",S[S.Int32Array=6]="Int32Array",S[S.Uint32Array=7]="Uint32Array",S[S.Float32Array=8]="Float32Array",S[S.Float64Array=9]="Float64Array",S[S.BigInt64Array=10]="BigInt64Array",S[S.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(S){S[S.Text=1]="Text",S[S.Error=2]="Error",S[S.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(S){S[S.None=0]="None",S[S.Process=1]="Process",S[S.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(N){return N._id=b._n++,N}}e.IdObject=b,b._n=0;var l;(function(S){S.label="a",S.kind="b",S.detail="c",S.documentation="d",S.sortText="e",S.filterText="f",S.preselect="g",S.insertText="h",S.insertTextRules="i",S.range="j",S.commitCharacters="k",S.additionalTextEdits="l",S.command="m",S.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(S){S.defaultRanges="a",S.completions="b",S.isIncomplete="c",S.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var a;(function(S){S[S.File=1]="File",S[S.Text=2]="Text",S[S.Cell=3]="Cell"})(a=e.WorkspaceEditType||(e.WorkspaceEditType={}));function n(S){if(S&&S.edits)for(const N of S.edits)typeof N.resource=="object"?N.resource=I.URI.revive(N.resource):(N.newUri=I.URI.revive(N.newUri),N.oldUri=I.URI.revive(N.oldUri)),N.metadata&&N.metadata.iconPath&&(N.metadata=(0,o.revive)(N.metadata));return S}e.reviveWorkspaceEditDto=n;var d;(function(S){S[S.Workspace=0]="Workspace",S[S.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[64],Ee([1,0,4,5,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class B{constructor(T){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,C){return this._proxy.$getPassword(T,C)}store(T,C,R){return this._proxy.$setPassword(T,C,R)}delete(T,C){return this._proxy.$deletePassword(T,C)}}e.ExtHostSecretState=B,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ve[65],Ee([1,0,3,12,4,14]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(C,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(_.MainContext.MainThreadTelemetry)}report(C,R,M){const b=this.getUsageKey(C,R);this._reportedUsages.has(b)||(this._reportedUsages.add(b),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${M}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:C}))}getUsageKey(C,R){return`${C}-${R.identifier.value}`}};y=Fe([Ne(0,B.IExtHostRpcService),Ne(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(T,C,R){}})}),define(ve[177],Ee([1,0,5,4,7,25]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,R,M,b={}){const l=B.ExtensionIdentifier.toKey(C.identifier),g=this._inFlightRequests.get(l)||[],a=[...M].sort().join(" ");let n=g.find(d=>d.scopes===a);if(n)return n.result;{const d=this._getSession(C,l,R,M,b);n={scopes:a,result:d},g.push(n),this._inFlightRequests.set(l,g);try{await d}finally{const S=g.findIndex(N=>N.scopes===a);S>-1&&(g.splice(S),this._inFlightRequests.set(l,g))}return d}}async _getSession(C,R,M,b,l={}){await this._proxy.$ensureProvider(M);const g=C.displayName||C.name;return this._proxy.$getSession(M,b,R,g,l)}async removeSession(C,R){const M=this._authenticationProviders.get(C);return M?M.provider.removeSession(R):this._proxy.$removeSession(C,R)}registerAuthenticationProvider(C,R,M,b){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:R,provider:M,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===C)||this._providers.push({id:C,label:R});const l=M.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(C,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,R,b?.supportsMultipleAccounts??!1),new _.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(C);const g=this._providers.findIndex(a=>a.id===C);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,R){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,R){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,R){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,R){return this._onDidChangeSessions.fire({provider:{id:C,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[178],Ee([1,0,4,14,8]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let B=class{constructor(T,C){this._proxy=T.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>C.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T){const C=_.WorkspaceEdit.from(T,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(C)}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostBulkEdits=B}),define(ve[179],Ee([1,0,4]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(B){const y=B.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(T){return y.$writeText(T)}})}}e.ExtHostClipboard=I});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[39],Ee([1,0,13,7,8,26,4,16,12,54,62,229,2,6,3,14,48,21,38,43]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,c){m.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,je(this,m,t.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new r(this,v=>{const h=this._apiCommands.get(v);return h?.result===u.Void?h:void 0},c),this._argumentProcessors=[{processArgument(v){return(0,R.revive)(v)}},{processArgument(v){return(0,B.cloneAndChange)(v,function(h){if(M.Range.isIRange(h))return _.Range.to(h);if(b.Position.isIPosition(h))return _.Position.to(h);if(M.Range.isIRange(h.range)&&l.URI.isUri(h.uri))return _.location.to(h);if(h instanceof S.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const c=this.registerCommand(!1,t.id,async(...v)=>{const h=t.args.map((k,A)=>{if(!k.validate(v[A]))throw new Error(`Invalid argument '${k.name}' when running '${t.id}', received: ${v[A]}`);return k.convert(v[A])}),p=await this.executeCommand(t.internalId,...h);return t.result.convert(p,v,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{c.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,c,v,h,p,k){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:v,thisArg:h,description:p,extension:k}),t&&De(this,m,"f").$registerCommand(c),new I.Disposable(()=>{this._commands.delete(c)&&t&&De(this,m,"f").$unregisterCommand(c)})}executeCommand(t,...c){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,c,!0)}async _doExecuteCommand(t,c,v){if(this._commands.has(t))return this._executeContributedCommand(t,c,!1);{let h=!1;const p=(0,B.cloneAndChange)(c,function(k){if(k instanceof I.Position)return _.Position.from(k);if(k instanceof I.Range)return _.Range.from(k);if(k instanceof I.Location)return _.location.from(k);if(I.NotebookRange.isNotebookRange(k))return _.NotebookRange.from(k);if(k instanceof ArrayBuffer)return h=!0,S.VSBuffer.wrap(new Uint8Array(k));if(k instanceof Uint8Array)return h=!0,S.VSBuffer.wrap(k);if(!Array.isArray(k))return k});try{const k=await De(this,m,"f").$executeCommand(t,h?new N.SerializableObjectWithBuffers(p):p,v);return(0,R.revive)(k)}catch(k){if(k instanceof Error&&k.message==="$executeCommand:retry")return this._doExecuteCommand(t,c,!1);throw k}}}async _executeContributedCommand(t,c,v){const h=this._commands.get(t);if(!h)throw new Error("Unknown command");let{callback:p,thisArg:k,description:A}=h;if(A)for(let x=0;x<A.args.length;x++)try{(0,o.validateConstraint)(c[x],A.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${A.args[x].name}' - ${A.args[x].description}`)}try{return await p.apply(k,c)}catch(x){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...c);w&&(t=w.command)}throw this._logService.error(x,t,h.extension?.identifier),v?new class extends Error{constructor(){super((0,f.toErrorMessage)(x));this.id=t,this.source=h.extension?.displayName??h.extension?.name}}:x}}$executeContributedCommand(t,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(c=c.map(v=>this._argumentProcessors.reduce((h,p)=>p.processArgument(h),v)),this._executeContributedCommand(t,c,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),De(this,m,"f").$getCommands().then(c=>(t&&(c=c.filter(v=>v[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[c,v]of this._commands){let{description:h}=v;h&&(t[c]=h)}return Promise.resolve(t)}};m=new WeakMap,E=Fe([Ne(0,n.IExtHostRpcService),Ne(1,C.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class r{constructor(t,c,v){this._commands=t,this._lookupApiCommand=c,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,c){if(!t)return;const v={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return v;const h=this._lookupApiCommand(t.command);if(h)v.id=h.internalId,v.arguments=h.args.map((p,k)=>p.convert(t.arguments&&t.arguments[k]));else if((0,T.isNonEmptyArray)(t.arguments)){const p=++this._cachIdPool;this._cache.set(p,t),c.add((0,g.toDisposable)(()=>{this._cache.delete(p),this._logService.trace("CommandsConverter#DISPOSE",p)})),v.$ident=p,v.id=this.delegatingCommandId,v.arguments=[p],this._logService.trace("CommandsConverter#CREATE",t.command,p)}return v}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const c=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=r;class P{constructor(t,c,v,h){this.name=t,this.description=c,this.validate=v,this.convert=h}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,c){return new P(t??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",s=>l.URI.isUri(s),s=>s),P.Position=new P("position","A position in a text document",s=>I.Position.isPosition(s),_.Position.from),P.Range=new P("range","A range in a text document",s=>I.Range.isRange(s),_.Range.from),P.Selection=new P("selection","A selection in a text document",s=>I.Selection.isSelection(s),_.Selection.from),P.Number=new P("number","",s=>typeof s=="number",s=>s),P.String=new P("string","",s=>typeof s=="string",s=>s),P.CallHierarchyItem=new P("item","A call hierarchy item",s=>s instanceof I.CallHierarchyItem,_.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",s=>s instanceof I.TypeHierarchyItem,_.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",s=>s instanceof d.TestItemImpl,_.TestItem.from);class u{constructor(t,c){this.description=t,this.convert=c}}e.ApiCommandResult=u,u.Void=new u("no result",s=>s);class i{constructor(t,c,v,h,p){this.id=t,this.internalId=c,this.description=v,this.args=h,this.result=p}}e.ApiCommand=i}),define(ve[180],Ee([1,0,2,8,7,88,39,16,75,79,9]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,T.isFalsyOrEmpty)(n))return;class S extends _.SymbolInformation{static to(f){const m=new S(f.name,I.SymbolKind.to(f.kind),f.containerName||"",new _.Location(d[0],I.Range.to(f.range)));return m.detail=f.detail,m.range=m.location.range,m.selectionRange=I.Range.to(f.selectionRange),m.children=f.children?f.children.map(S.to):[],m}}return n.map(S.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new y.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",a)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",a)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",a)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",a)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>_.Position.isPosition(d)),n=>n.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let S;for(const N of d.reverse())S=new _.SelectionRange(I.Range.to(N),S);return S}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(I.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:I.Range.to(n.range),placeholder:n.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return I.WorkspaceEdit.to(n)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new _.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,C.decodeSemanticTokensDto)(n);if(d.type==="full")return new _.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new _.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,C.decodeSemanticTokensDto)(n);if(d.type==="full")return new _.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,S)=>{if(!n)return new _.CompletionList([]);const N=n.suggestions.map(f=>I.CompletionItem.to(f,S));return new _.CompletionList(N,n.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return I.SignatureHelp.to(n)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,S)=>g(N=>new _.CodeLens(I.Range.to(N.range),N.command&&S.fromInternal(N.command)))(n))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>_.Range.isRange(n),n=>_.Selection.isSelection(n)?I.Selection.from(n):I.Range.from(n)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,S)=>g(N=>{if(N._isSynthetic){if(!N.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(N.command)}else{const f=new _.CodeAction(N.title,N.kind?new _.CodeActionKind(N.kind):void 0);return N.edit&&(f.edit=I.WorkspaceEdit.to(N.edit)),N.command&&(f.command=S.fromInternal(N.command)),f.isPreferred=N.isPreferred,f}})(n))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new _.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",n=>n instanceof _.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:I.Range.from(n.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,d,S)=>n.map(I.InlayHint.to.bind(void 0,S)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>o.URI.isUri(n)||typeof n=="string"&&(0,R.matchesSomeScheme)(n,M.Schemas.http,M.Schemas.https),n=>n),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class l{static register(d){b.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=l;function g(n){return d=>{if(Array.isArray(d))return d.map(n)}}function a(n){if(!Array.isArray(n))return;const d=[];for(const S of n)B.isLocationLink(S)?d.push(I.DefinitionLink.to(S)):d.push(I.location.to(S));return d}}),define(ve[181],Ee([1,0,11,52,5,6,2,88,25,8,7,27,4]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function g(a,n,d){const S=a.getProxy(l.MainContext.MainThreadComments);class N{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,n.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const t=this._commentControllers.get(s.handle);return t||s}else if(s&&s.$mid===7){const t=this._commentControllers.get(s.commentControlHandle);if(!t)return s;const c=t.getCommentThread(s.commentThreadHandle);return c||s}else if(s&&s.$mid===8){const t=this._commentControllers.get(s.thread.commentControlHandle);if(!t)return s;const c=t.getCommentThread(s.thread.commentThreadHandle);return c?{thread:c,text:s.text}:s}else if(s&&s.$mid===9){const t=this._commentControllers.get(s.thread.commentControlHandle);if(!t)return s;const c=t.getCommentThread(s.thread.commentThreadHandle);if(!c)return s;let v=s.commentUniqueId,h=c.getCommentByUniqueId(v);return h||s}else if(s&&s.$mid===10){const t=this._commentControllers.get(s.thread.commentControlHandle);if(!t)return s;const c=t.getCommentThread(s.thread.commentThreadHandle);if(!c)return s;let v=s.text,h=s.commentUniqueId,p=c.getCommentByUniqueId(h);return p?(p.body=v,p):s}return s}})}createCommentController(s,t,c){const v=N.handlePool++,h=new m(s,v,t,c);this._commentControllers.set(h.handle,h);const p=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(s.identifier))||[];return p.push(h),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(s.identifier),p),h.value}$createCommentThreadTemplate(s,t,c){const v=this._commentControllers.get(s);!v||v.$createCommentThreadTemplate(t,c)}async $updateCommentThreadTemplate(s,t,c){const v=this._commentControllers.get(s);!v||v.$updateCommentThreadTemplate(t,c)}$deleteCommentThread(s,t){const c=this._commentControllers.get(s);c&&c.$deleteCommentThread(t)}$provideCommentingRanges(s,t,c){const v=this._commentControllers.get(s);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const h=d.getDocument(y.URI.revive(t));return(0,o.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(h,c)).then(p=>p?p.map(k=>R.Range.from(k)):void 0)}$toggleReaction(s,t,c,v,h){const p=this._commentControllers.get(s);return!p||!p.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const k=p.getCommentThread(t);if(k){const A=k.getCommentByUniqueId(v.uniqueIdInThread);if(p!==void 0&&A&&p.reactionHandler)return p.reactionHandler(A,P(h))}return Promise.resolve(void 0)})}dispose(){}}N.handlePool=0;class f{constructor(s,t,c,v,h,p,k){this._commentControllerHandle=t,this._id=c,this._uri=v,this._range=h,this._comments=p,this.extensionDescription=k,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputDisposables.value=new B.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),S.$createCommentThread(t,this.handle,this._id,this._uri,R.Range.from(this._range),k.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=p,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(t,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(x){A.range=x},get comments(){return A.comments},set comments(x){A.comments=x},get collapsibleState(){return A.collapsibleState},set collapsibleState(x){A.collapsibleState=x},get canReply(){return A.canReply},set canReply(x){A.canReply=x},get contextValue(){return A.contextValue},set contextValue(x){A.contextValue=x},get label(){return A.label},set label(x){A.label=x},dispose:()=>{A.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new B.DisposableStore);const s=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),t={};s("range")&&(t.range=R.Range.from(this._range)),s("label")&&(t.label=this.label),s("contextValue")&&(t.contextValue=this.contextValue??null),s("comments")&&(t.comments=this._comments.map(c=>E(this,c,this._commentsMap))),s("collapsibleState")&&(t.collapseState=u(this._collapseState)),s("canReply")&&(t.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,t)}getCommentByUniqueId(s){for(let t of this._commentsMap){let c=t[0],v=t[1];if(s===v)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}f._handlePool=0,Fe([(0,I.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class m{constructor(s,t,c,v){this._extension=s,this._handle=t,this._id=c,this._label=v,this._threads=new Map,S.$registerCommentController(this.handle,c,v);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(p){h.options=p},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(p){h.commentingRangeProvider=p},get reactionHandler(){return h.reactionHandler},set reactionHandler(p){h.reactionHandler=p},createCommentThread(p,k,A){return h.createCommentThread(p,k,A).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(s){this._commentingRangeProvider=s,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,t,c,v){if(typeof s=="string"){const h=new f(this.id,this.handle,s,t,c,v,this._extension);return this._threads.set(h.handle,h),h}else{const h=new f(this.id,this.handle,void 0,s,t,c,this._extension);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(s,t){const c=new f(this.id,this.handle,void 0,y.URI.revive(s),R.Range.to(t),[],this._extension);return c.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(s,t){let c=this._threads.get(s);c&&(c.range=R.Range.to(t))}$deleteCommentThread(s){let t=this._threads.get(s);t&&t.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function E(i,s,t){let c=t.get(s);c||(c=++i.commentHandle,t.set(s,c));const v=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;s.timestamp&&(0,b.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let h;return s.timestamp&&(h={source:s.timestamp,$mid:14}),{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:c,body:typeof s.body=="string"?s.body:R.MarkdownString.from(s.body),userName:s.author.name,userIconPath:v,label:s.label,commentReactions:s.reactions?s.reactions.map(p=>r(p)):void 0,timestamp:h}}function r(i){return{label:i.label,iconPath:i.iconPath?R.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function P(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?y.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function u(i){if(i!==void 0)switch(i){case M.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new N}e.createExtHostComments=g}),define(ve[92],Ee([1,0,2,4,7,3,14,12,16,10,17]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class wi{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const n=wi._handlePool++;this._provider.set(n,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(n,a.value);const d=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(n,null);return}let N=(0,C.asArray)(S);if(N.length<=wi._maxEventSize){this._proxy.$onDidChange(n,N);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,N.length);const f=N.map(r=>({uri:r,rank:(0,R.count)(r.path,"/")})),m=(0,C.groupBy)(f,(r,P)=>r.rank-P.rank||(0,R.compare)(r.uri.path,P.uri.path));let E=[];e:for(let r of m){let P;for(let u of r){let i=(0,M.dirname)(u.uri.path);if(P!==i&&(P=i,E.push(u.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(n,E)});return new _.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(g,a,n){if(!this._provider.has(g))return Object.create(null);const d=Object.create(null),{provider:S,extensionId:N}=this._provider.get(g);return await Promise.all(a.map(async f=>{try{const{uri:m,id:E}=f,r=await Promise.resolve(S.provideFileDecoration(o.URI.revive(m),n));if(!r)return;try{_.FileDecoration.validate(r),d[E]=[r.propagate,r.tooltip,r.badge,r.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${N.value}': ${P}`)}}catch(m){this._logService.error(m)}})),d}};b._handlePool=0,b._maxEventSize=250,b=Fe([Ne(0,y.IExtHostRpcService),Ne(1,T.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,B.createDecorator)("IExtHostDecorations")});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[182],Ee([1,0,122,78,2,4,7,8,5,12,22,30]),function(J,e,o,I,_,B,y,T,C,R,M,b){"use strict";var l,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(N,f,m,E,r,P){this._name=N,this._owner=f,this._maxDiagnosticsPerFile=m,l.set(this,void 0),g.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,je(this,a,new M.ResourceMap(u=>E.getComparisonKey(u)),"f"),je(this,l,r,"f"),je(this,g,P,"f")}dispose(){this._isDisposed||(De(this,g,"f").fire([...De(this,a,"f").keys()]),De(this,l,"f")&&De(this,l,"f").$clear(this._owner),De(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(N,f){if(!N){this.clear();return}this._checkDisposed();let m=[];if(_.URI.isUri(N)){if(!f){this.delete(N);return}De(this,a,"f").set(N,f.slice()),m=[N]}else if(Array.isArray(N)){m=[];let r;N=[...N].sort(n._compareIndexedTuplesByUri);for(const P of N){const[u,i]=P;if((!r||u.toString()!==r.toString())&&(r&&De(this,a,"f").get(r).length===0&&De(this,a,"f").delete(r),r=u,m.push(u),De(this,a,"f").set(u,[])),i){const s=De(this,a,"f").get(u);s&&s.push(...i)}else{const s=De(this,a,"f").get(u);s&&(s.length=0)}}}if(De(this,g,"f").fire(m),!De(this,l,"f"))return;const E=[];for(let r of m){let P=[];const u=De(this,a,"f").get(r);if(u)if(u.length>this._maxDiagnosticsPerFile){P=[];const i=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let t of u)if(t.severity===i[s]&&P.push(T.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;P.push({severity:I.MarkerSeverity.Info,message:(0,o.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=u.map(i=>T.Diagnostic.from(i));E.push([r,P])}De(this,l,"f").$changeMany(this._owner,E)}delete(N){this._checkDisposed(),De(this,g,"f").fire([N]),De(this,a,"f").delete(N),De(this,l,"f")&&De(this,l,"f").$changeMany(this._owner,[[N,void 0]])}clear(){this._checkDisposed(),De(this,g,"f").fire([...De(this,a,"f").keys()]),De(this,a,"f").clear(),De(this,l,"f")&&De(this,l,"f").$clear(this._owner)}forEach(N,f){this._checkDisposed();for(let m of De(this,a,"f").keys())N.apply(f,[m,this.get(m),this])}get(N){this._checkDisposed();const f=De(this,a,"f").get(N);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(N){return this._checkDisposed(),Array.isArray(De(this,a,"f").get(N))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(N,f){return N[0].toString()<f[0].toString()?-1:N[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=n,l=new WeakMap,g=new WeakMap,a=new WeakMap;let d=class si{constructor(N,f,m){this._logService=f,this._fileSystemInfoService=m,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=N.getProxy(B.MainContext.MainThreadDiagnostics)}static _mapper(N){const f=new M.ResourceMap;for(const m of N)f.set(m,m);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(N,f){const{_collections:m,_proxy:E,_onDidChangeDiagnostics:r,_logService:P,_fileSystemInfoService:u}=this,i=new class{$changeMany(c,v){E.$changeMany(c,v),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",N.value,c,v.length===0?"CLEARING":v)}$clear(c){E.$clear(c),P.trace("[DiagnosticCollection] remove all (extension, owner)",N.value,c)}dispose(){E.dispose()}};let s;if(!f)f="_generated_diagnostic_collection_name_#"+si._idPool++,s=f;else if(!m.has(f))s=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do s=f+si._idPool++;while(m.has(s))}return new class extends n{constructor(){super(f,s,si._maxDiagnosticsPerFile,u.extUri,i,r);m.set(s,this)}dispose(){super.dispose(),m.delete(s)}}}getDiagnostics(N){if(N)return this._getDiagnostics(N);{const f=new Map,m=[];for(const E of this._collections.values())E.forEach((r,P)=>{let u=f.get(r.toString());typeof u=="undefined"&&(u=m.length,f.set(r.toString(),u),m.push([r,[]])),m[u][1]=m[u][1].concat(...P)});return m}}_getDiagnostics(N){let f=[];for(let m of this._collections.values())m.has(N)&&(f=f.concat(m.get(N)));return f}$acceptMarkersChange(N){if(!this._mirrorCollection){const f="_generated_mirror",m=new n(f,f,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,m),this._mirrorCollection=m}for(const[f,m]of N)this._mirrorCollection.set(_.URI.revive(f),m.map(T.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Fe([Ne(1,R.ILogService),Ne(2,b.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ve[183],Ee([1,0,2,4]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(T=>T?T.map(C=>o.URI.revive(C)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(T=>T?o.URI.revive(T):void 0)}}e.ExtHostDialogs=_}),define(ve[184],Ee([1,0,15,2,7,4,9,20,10]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(b,l,g){this._documentsAndEditors=l,this._logService=g,this._documentContentProviders=new Map,this._proxy=b.getProxy(B.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,l){if(Object.keys(y.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const g=R._handlePool++;this._documentContentProviders.set(g,l),this._proxy.$registerTextContentProvider(g,b);let a;return typeof l.onDidChange=="function"&&(a=l.onDidChange(n=>{if(n.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(g,n).then(d=>{if(!d&&typeof d!="string")return;const S=this._documentsAndEditors.getDocument(n);if(!S)return;const N=(0,C.splitLines)(d);if(!S.equalLines(N))return this._proxy.$onVirtualDocumentChange(n,d)},o.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(b,l){const g=this._documentContentProviders.get(b);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(l),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ve[185],Ee([1,0,5,6,2,4,84,8,13,26,7]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(g,a){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(B.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const d of n)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const d of n)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const a=this._documentsAndEditors.getDocument(g);if(a)return a}getDocument(g){const a=this.getDocumentData(g);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return a.document}ensureDocumentData(g){const a=this._documentsAndEditors.getDocument(g);if(a)return Promise.resolve(a);let n=this._documentLoader.get(g.toString());return n||(n=this._proxy.$tryOpenDocument(g).then(d=>{this._documentLoader.delete(g.toString());const S=_.URI.revive(d);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(g.toString()),Promise.reject(d))),this._documentLoader.set(g.toString(),n)),n}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(a=>_.URI.revive(a))}$acceptModelLanguageChanged(g,a){const n=_.URI.revive(g),d=this._documentsAndEditors.getDocument(n);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(a),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(g){const a=_.URI.revive(g),n=this._documentsAndEditors.getDocument(a);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(g,a){const n=_.URI.revive(g),d=this._documentsAndEditors.getDocument(n);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,a,n){const d=_.URI.revive(g),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(n),S.onEvents(a);let N;a.isUndoing?N=M.TextDocumentChangeReason.Undo:a.isRedoing&&(N=M.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:S.document,contentChanges:a.changes.map(f=>({range:T.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:N}))}setWordDefinitionFor(g,a){(0,y.setWordDefinitionFor)(g,a)}}e.ExtHostDocuments=b}),define(ve[49],Ee([1,0,42,5,6,2,3,4,84,14,90,8,12,22,9,161,230]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let N=class{constructor(m,E){this._extHostRpc=m,this._logService=E,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const E=[],r=[],P=[];if(m.removedDocuments)for(const u of m.removedDocuments){const i=B.URI.revive(u),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),E.push(s.value))}if(m.addedDocuments)for(const u of m.addedDocuments){const i=B.URI.revive(u.uri);let s=this._documents.get(i);if(s&&i.scheme!==a.Schemas.vscodeNotebookCell&&i.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new S(new C.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this._documents.set(i,s),r.push(s.value)),s.ref()}if(m.removedEditors)for(const u of m.removedEditors){const i=this._editors.get(u);this._editors.delete(u),i&&P.push(i)}if(m.addedEditors)for(const u of m.addedEditors){const i=B.URI.revive(u.documentUri);o.ok(this._documents.has(i),`document '${i}' does not exist`),o.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const s=this._documents.get(i).value,t=new M.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>s.document),u.selections.map(b.Selection.to),u.options,u.visibleRanges.map(c=>b.Range.to(c)),typeof u.editorPosition=="number"?b.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,t)}m.newActiveEditor!==void 0&&(o.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,_.dispose)(E),(0,_.dispose)(P),m.removedDocuments&&this._onDidRemoveDocuments.fire(E),m.addedDocuments&&this._onDidAddDocuments.fire(r),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){return this._documents.get(m)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const E=this._editors.get(this._activeEditorId);return m?E:E?.value}allEditors(){return[...this._editors.values()]}};N=Fe([Ne(0,R.IExtHostRpcService),Ne(1,l.ILogService)],N),e.ExtHostDocumentsAndEditors=N,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[66],Ee([1,0,8,4,2,5,3,14,11]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");let R=class{constructor(b){this._onDidChangeTabs=new B.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new B.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(I.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let l=-1;this._tabs=b.map((a,n)=>(a.isActive&&(l=n),Object.freeze({label:a.label,viewColumn:o.ViewColumn.to(a.viewColumn),index:n,resource:_.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:d,viewId:S})=>({resource:_.URI.revive(d),viewId:S})),viewId:a.editorId,isActive:a.isActive,move:async(d,S)=>{this._proxy.$moveTab(a,d,o.ViewColumn.from(S)),await(0,C.raceTimeout)(B.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,C.raceTimeout)(B.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,n)=>a.viewColumn===n.viewColumn?a.index-n.index:a.viewColumn-n.viewColumn);const g=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==g&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Fe([Ne(0,T.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(ve[186],Ee([1,0,2,4,6,7,8,231,10,21,27]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const n=this._schemes.indexOf(a);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),n=[];let d,S,N=14,f=14;for(const m of a){let E=d?(0,C.commonPrefixLength)(d,m):0;for(E===0?S=1:S=f;E<m.length;E++)E+1===m.length?(N=f,f=9):f+=1,n.push([S,m.toUpperCase().charCodeAt(E),f]),n.push([S,m.toLowerCase().charCodeAt(E),f]),S=f;d=m,f=N}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new T.StateMachine(n)}}provideDocumentLinks(a){this._initStateMachine();const n=[],d=T.LinkComputer.computeLinks({getLineContent(S){return a.lineAt(S-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const S of d){const N=y.DocumentLink.to(S);N.target&&n.push(N)}return n}}class l{constructor(a,n){this._extHostLanguageFeatures=n,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(a,n,d,S={}){if(this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(a,"*",this._linkProvider));const N=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(N,d);let f=2;S.isCaseSensitive&&(f+=1024),S.isReadonly&&(f+=2048),typeof d.copy=="function"&&(f+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,M.checkProposedApiEnabled)(a,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(N,n,f).catch(E=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${n}`),console.error(E)});const m=d.onDidChangeFile(E=>{const r=[];for(const P of E){let{uri:u,type:i}=P;if(u.scheme!==n)continue;let s;switch(i){case B.FileChangeType.Changed:s=0;break;case B.FileChangeType.Created:s=1;break;case B.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:u,type:s})}this._proxy.$onFileSystemChange(N,r)});return(0,_.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(N),this._proxy.$unregisterProvider(N)})}static _asIStat(a){const{type:n,ctime:d,mtime:S,size:N,permissions:f}=a;return{type:n,ctime:d,mtime:S,size:N,permissions:f}}$stat(a,n){return Promise.resolve(this._getFsProvider(a).stat(o.URI.revive(n))).then(d=>l._asIStat(d))}$readdir(a,n){return Promise.resolve(this._getFsProvider(a).readDirectory(o.URI.revive(n)))}$readFile(a,n){return Promise.resolve(this._getFsProvider(a).readFile(o.URI.revive(n))).then(d=>R.VSBuffer.wrap(d))}$writeFile(a,n,d,S){return Promise.resolve(this._getFsProvider(a).writeFile(o.URI.revive(n),d.buffer,S))}$delete(a,n,d){return Promise.resolve(this._getFsProvider(a).delete(o.URI.revive(n),d))}$rename(a,n,d,S){return Promise.resolve(this._getFsProvider(a).rename(o.URI.revive(n),o.URI.revive(d),S))}$copy(a,n,d,S){const N=this._getFsProvider(a);if(!N.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(N.copy(o.URI.revive(n),o.URI.revive(d),S))}$mkdir(a,n){return Promise.resolve(this._getFsProvider(a).createDirectory(o.URI.revive(n)))}$watch(a,n,d,S){const N=this._getFsProvider(a).watch(o.URI.revive(d),S);this._watches.set(n,N)}$unwatch(a,n){const d=this._watches.get(n);d&&(d.dispose(),this._watches.delete(n))}$open(a,n,d){const S=this._getFsProvider(a);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(o.URI.revive(n),d))}$close(a,n){const d=this._getFsProvider(a);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(n))}$read(a,n,d,S){const N=this._getFsProvider(a);if(!N.read)throw new Error('FileSystemProvider does not implement "read"');const f=R.VSBuffer.alloc(S);return Promise.resolve(N.read(n,d,f.buffer,0,S)).then(m=>f.slice(0,m))}$write(a,n,d,S){const N=this._getFsProvider(a);if(!N.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(N.write(n,d,S.buffer,0,S.byteLength))}_getFsProvider(a){const n=this._fsProvider.get(a);if(!n){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return n}}e.ExtHostFileSystem=l}),define(ve[50],Ee([1,0,4,46,7,21,3,14,30,6]),function(J,e,o,I,_,B,y,T,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class Kt{constructor(l,g){this._fileSystemProvider=new Map,this._proxy=l.getProxy(o.MainContext.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(n){try{const d=a._fileSystemProvider.get(n.scheme);if(!d)return await a._proxy.$stat(n);await a._proxy.$ensureActivation(n.scheme);const S=await d.stat(n);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(d){Kt._handleError(d)}},async readDirectory(n){try{const d=a._fileSystemProvider.get(n.scheme);return d?(await a._proxy.$ensureActivation(n.scheme),(await d.readDirectory(n)).slice()):await a._proxy.$readdir(n)}catch(d){return Kt._handleError(d)}},async createDirectory(n){try{return await a._proxy.$mkdir(n)}catch(d){return Kt._handleError(d)}},async readFile(n){try{const d=a._fileSystemProvider.get(n.scheme);return d?(await a._proxy.$ensureActivation(n.scheme),(await d.readFile(n)).slice()):(await a._proxy.$readFile(n)).buffer}catch(d){return Kt._handleError(d)}},async writeFile(n,d){try{return await a._proxy.$writeFile(n,B.VSBuffer.wrap(d))}catch(S){return Kt._handleError(S)}},async delete(n,d){try{const S=a._fileSystemProvider.get(n.scheme);return S?(await a._proxy.$ensureActivation(n.scheme),await S.delete(n,{recursive:!1,...d})):await a._proxy.$delete(n,{recursive:!1,useTrash:!1,...d})}catch(S){return Kt._handleError(S)}},async rename(n,d,S){try{return await a._proxy.$rename(n,d,{overwrite:!1,...S})}catch(N){return Kt._handleError(N)}},async copy(n,d,S){try{return await a._proxy.$copy(n,d,{overwrite:!1,...S})}catch(N){return Kt._handleError(N)}},isWritableFileSystem(n){const d=g.getCapabilities(n);if(typeof d=="number")return!(d&2048)}})}static _handleError(l){if(l instanceof _.FileSystemError)throw l;if(!(l instanceof Error))throw new _.FileSystemError(String(l));if(l.name==="ENOPRO")throw _.FileSystemError.Unavailable(l.message);switch(l.name){case I.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(l.message);case I.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(l.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(l.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(l.message);case I.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(l.message);case I.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(l.message);default:throw new _.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,g){return this._fileSystemProvider.set(l,g),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(l))}};M=Fe([Ne(0,T.IExtHostRpcService),Ne(1,C.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[187],Ee([1,0,5,29,2,4,8,7]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(b,l,g,a,n,d,S,N){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const f=this.ensureWatching(b,g,n);this._config=0,d&&(this._config+=1),S&&(this._config+=2),N&&(this._config+=4);const m=(0,I.parse)(n),E=typeof n=="string",r=a(P=>{if(!d)for(let u of P.created){const i=_.URI.revive(u);m(i.fsPath)&&(!E||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!S)for(let u of P.changed){const i=_.URI.revive(u);m(i.fsPath)&&(!E||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!N)for(let u of P.deleted){const i=_.URI.revive(u);m(i.fsPath)&&(!E||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=T.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,l,g){let a=T.Disposable.from();if(typeof g=="string")return a;const n=b.getProxy(B.MainContext.MainThreadFileSystem);let d=!1;(g.pattern.includes(I.GLOBSTAR)||g.pattern.includes(I.GLOB_SPLIT))&&(d=!0);const S=Math.random();return n.$watch(l.identifier.value,S,g.baseUri,{recursive:d,excludes:[]}),T.Disposable.from({dispose:()=>n.$unwatch(S)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(b,l,g){this._mainContext=b,this._logService=l,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,l,g,a,n,d){return new C(this._mainContext,b,l,this._onFileSystemEvent.event,y.GlobPattern.from(g),a,n,d)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,l){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(g=>({oldUri:_.URI.revive(g.source),newUri:_.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(g=>_.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(g=>_.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,l){return(g,a,n)=>{const d=function(N){g.call(a,N)};return d.extension=b,l.event(d,void 0,n)}}async $onWillRunFileOperation(b,l,g,a){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))},g,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(n=>_.URI.revive(n.target))},g,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(n=>_.URI.revive(n.target))},g,a)}}async _fireWillEvent(b,l,g,a){const n=new Set,d=[];if(await b.fireAsync(l,a,async(N,f)=>{const m=Date.now(),E=await Promise.resolve(N);E instanceof T.WorkspaceEdit&&(d.push(E),n.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-m>g&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),a.isCancellationRequested||d.length===0)return;const S={edits:[]};for(let N of d){let{edits:f}=y.WorkspaceEdit.from(N,{getTextDocumentVersion:m=>this._extHostDocumentsAndEditors.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});S.edits=S.edits.concat(f)}return{edit:S,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=R}),define(ve[188],Ee([1,0,2,39]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(y,T,C,R){this._extHostNotebooks=T,this._textDocumentsAndEditors=C,this._commands=R;const M=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new I.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new I.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new I.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new I.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(M)}$willAddInteractiveDocument(y,T,C,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:C,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=_}),define(ve[189],Ee([1,0,6,4]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,y),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=_}),define(ve[190],Ee([1,0,2,26,8,7,4,10,62,16,13,232,20,6,75,53,57,191,15,5,11]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class E{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentSymbols(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentSymbols(D,F);if(!(0,R.isFalsyOrEmpty)(O))return O[0]instanceof B.DocumentSymbol?O.map(_.DocumentSymbol.from):E._asDocumentSymbolTree(O)}static _asDocumentSymbolTree(L){L=L.slice(0).sort((O,$)=>{let X=O.location.range.start.compareTo($.location.range.start);return X===0&&(X=$.location.range.end.compareTo(O.location.range.end)),X});const F=[],D=[];for(const O of L){const $={name:O.name||"!!MISSING: name!!",kind:_.SymbolKind.from(O.kind),tags:O.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:O.containerName,range:_.Range.from(O.location.range),selectionRange:_.Range.from(O.location.range),children:[]};for(;;){if(D.length===0){D.push($),F.push($);break}const X=D[D.length-1];if(C.Range.containsRange(X.range,$.range)&&!C.Range.equalsRange(X.range,$.range)){X.children&&X.children.push($),D.push($);break}D.pop()}}return F}}class r{constructor(L,F,D){this._documents=L,this._commands=F,this._provider=D,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideCodeLenses(D,F);if(!O||F.isCancellationRequested)return;const $=this._cache.add(O),X=new g.DisposableStore;this._disposables.set($,X);const re={cacheId:$,lenses:[]};for(let pe=0;pe<O.length;pe++)re.lenses.push({cacheId:[$,pe],range:_.Range.from(O[pe].range),command:this._commands.toInternal(O[pe].command,X)});return re}async resolveCodeLens(L,F){const D=L.cacheId&&this._cache.get(...L.cacheId);if(!D)return;let O;if(typeof this._provider.resolveCodeLens!="function"||D.isResolved?O=D:O=await this._provider.resolveCodeLens(D,F),O||(O=D),F.isCancellationRequested)return;const $=L.cacheId&&this._disposables.get(L.cacheId[0]);if(!!$)return L.command=this._commands.toInternal(O.command??r._badCmd,$),L}releaseCodeLenses(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(de){return Array.isArray(de)?de.map(_.DefinitionLink.from):de?[_.DefinitionLink.from(de)]:[]}class u{constructor(L,F){this._documents=L,this._provider=F}async provideDefinition(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideDefinition(O,$,D);return P(X)}}class i{constructor(L,F){this._documents=L,this._provider=F}async provideDeclaration(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideDeclaration(O,$,D);return P(X)}}class s{constructor(L,F){this._documents=L,this._provider=F}async provideImplementation(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideImplementation(O,$,D);return P(X)}}class t{constructor(L,F){this._documents=L,this._provider=F}async provideTypeDefinition(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideTypeDefinition(O,$,D);return P(X)}}class c{constructor(L,F){this._documents=L,this._provider=F}async provideHover(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideHover(O,$,D);if(!(!X||(0,R.isFalsyOrEmpty)(X.contents)))return X.range||(X.range=O.getWordRangeAtPosition($)),X.range||(X.range=new B.Range($,$)),_.Hover.from(X)}}class v{constructor(L,F){this._documents=L,this._provider=F}async provideEvaluatableExpression(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideEvaluatableExpression(O,$,D);if(X)return _.EvaluatableExpression.from(X)}}class h{constructor(L,F){this._documents=L,this._provider=F}async provideInlineValues(L,F,D,O){const $=this._documents.getDocument(L),X=await this._provider.provideInlineValues($,_.Range.to(F),_.InlineValueContext.to(D),O);if(Array.isArray(X))return X.map(re=>_.InlineValue.from(re))}}class p{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentHighlights(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideDocumentHighlights(O,$,D);if(Array.isArray(X))return X.map(_.DocumentHighlight.from)}}class k{constructor(L,F){this._documents=L,this._provider=F}async provideLinkedEditingRanges(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.provideLinkedEditingRanges(O,$,D);if(X&&Array.isArray(X.ranges))return{ranges:(0,R.coalesce)(X.ranges.map(_.Range.from)),wordPattern:X.wordPattern}}}class A{constructor(L,F){this._documents=L,this._provider=F}async provideReferences(L,F,D,O){const $=this._documents.getDocument(L),X=_.Position.to(F),re=await this._provider.provideReferences($,X,D,O);if(Array.isArray(re))return re.map(_.location.from)}}class x{constructor(L,F,D,O,$,X,re){this._documents=L,this._commands=F,this._diagnostics=D,this._provider=O,this._logService=$,this._extension=X,this._apiDeprecation=re,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(L,F,D,O){const $=this._documents.getDocument(L),X=b.Selection.isISelection(F)?_.Selection.to(F):_.Range.to(F),re=[];for(const xe of this._diagnostics.getDiagnostics(L))if(X.intersection(xe.range)&&re.push(xe)>x._maxCodeActionsPerFile)break;const pe={diagnostics:re,only:D.only?new B.CodeActionKind(D.only):void 0,triggerKind:_.CodeActionTriggerKind.to(D.trigger)},Ce=await this._provider.provideCodeActions($,X,pe,O);if(!(0,R.isNonEmptyArray)(Ce)||O.isCancellationRequested)return;const Me=this._cache.add(Ce),Le=new g.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let xe=0;xe<Ce.length;xe++){const Oe=Ce[xe];!Oe||(x._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,Le)})):(pe.only&&(Oe.kind?pe.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,xe],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,Le),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(_.Diagnostic.from),edit:Oe.edit&&_.WorkspaceEdit.from(Oe.edit),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(L,F){const[D,O]=L,$=this._cache.get(D,O);if(!$||x._isCommand($)||!this._provider.resolveCodeAction)return;const X=await this._provider.resolveCodeAction($,F)??$;return X?.edit?_.WorkspaceEdit.from(X.edit):void 0}releaseCodeActions(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}static _isCommand(L){return typeof L.command=="string"&&typeof L.title=="string"}}x._maxCodeActionsPerFile=1e3;class w{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentFormattingEdits(L,F,D){const O=this._documents.getDocument(L),$=await this._provider.provideDocumentFormattingEdits(O,F,D);if(Array.isArray($))return $.map(_.TextEdit.from)}}class z{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeFormattingEdits(L,F,D,O){const $=this._documents.getDocument(L),X=_.Range.to(F),re=await this._provider.provideDocumentRangeFormattingEdits($,X,D,O);if(Array.isArray(re))return re.map(_.TextEdit.from)}}class q{constructor(L,F){this._documents=L,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,F,D,O,$){const X=this._documents.getDocument(L),re=_.Position.to(F),pe=await this._provider.provideOnTypeFormattingEdits(X,re,D,O,$);if(Array.isArray(pe))return pe.map(_.TextEdit.from)}}class H{constructor(L,F){this._provider=L,this._logService=F,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(L,F){const D=await this._provider.provideWorkspaceSymbols(L,F);if(!(0,R.isNonEmptyArray)(D))return{symbols:[]};const O=this._cache.add(D),$={cacheId:O,symbols:[]};for(let X=0;X<D.length;X++){const re=D[X];if(!re||!re.name){this._logService.warn("INVALID SymbolInformation",re);continue}$.symbols.push({..._.WorkspaceSymbol.from(re),cacheId:[O,X]})}return $}async resolveWorkspaceSymbol(L,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const D=this._cache.get(...L.cacheId);if(D){const O=await this._provider.resolveWorkspaceSymbol(D,F);return O&&(0,I.mixin)(L,_.WorkspaceSymbol.from(O),!0)}}releaseWorkspaceSymbols(L){this._cache.delete(L)}}class W{constructor(L,F,D){this._documents=L,this._provider=F,this._logService=D}static supportsResolving(L){return typeof L.prepareRename=="function"}async provideRenameEdits(L,F,D,O){const $=this._documents.getDocument(L),X=_.Position.to(F);try{const re=await this._provider.provideRenameEdits($,X,D,O);return re?_.WorkspaceEdit.from(re):void 0}catch(re){const pe=W._asMessage(re);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(re)}}async resolveRenameLocation(L,F,D){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const O=this._documents.getDocument(L),$=_.Position.to(F);try{const X=await this._provider.prepareRename(O,$,D);let re,pe;if(B.Range.isRange(X)?(re=X,pe=O.getText(X)):(0,M.isObject)(X)&&(re=X.range,pe=X.placeholder),!re||!pe)return;if(re.start.line>$.line||re.end.line<$.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(re),text:pe}}catch(X){const re=W._asMessage(X);return re?{rejectReason:re,range:void 0,text:void 0}:Promise.reject(X)}}static _asMessage(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Q{constructor(L,F){this.resultId=L,this.tokens=F}}class V{constructor(L,F){this._documents=L,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(L,F,D){const O=this._documents.getDocument(L),$=F!==0?this._previousResults.get(F):null;let X=typeof $?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(O,$.resultId,D):await this._provider.provideDocumentSemanticTokens(O,D);return $&&this._previousResults.delete(F),X?(X=V._fixProvidedSemanticTokens(X),this._send(V._convertToEdits($,X),X)):null}async releaseDocumentSemanticColoring(L){this._previousResults.delete(L)}static _fixProvidedSemanticTokens(L){return V._isSemanticTokens(L)?V._isCorrectSemanticTokens(L)?L:new B.SemanticTokens(new Uint32Array(L.data),L.resultId):V._isSemanticTokensEdits(L)?V._isCorrectSemanticTokensEdits(L)?L:new B.SemanticTokensEdits(L.edits.map(F=>new B.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),L.resultId):L}static _isSemanticTokens(L){return L&&!!L.data}static _isCorrectSemanticTokens(L){return L.data instanceof Uint32Array}static _isSemanticTokensEdits(L){return L&&Array.isArray(L.edits)}static _isCorrectSemanticTokensEdits(L){for(const F of L.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(L,F){if(!V._isSemanticTokens(F)||!L||!L.tokens)return F;const D=L.tokens,O=D.length,$=F.data,X=$.length;let re=0;const pe=Math.min(O,X);for(;re<pe&&D[re]===$[re];)re++;if(re===O&&re===X)return new B.SemanticTokensEdits([],F.resultId);let Ce=0;const Me=pe-re;for(;Ce<Me&&D[O-Ce-1]===$[X-Ce-1];)Ce++;return new B.SemanticTokensEdits([{start:re,deleteCount:O-re-Ce,data:$.subarray(re,X-Ce)}],F.resultId)}_send(L,F){if(V._isSemanticTokens(L)){const D=this._nextResultId++;return this._previousResults.set(D,new Q(L.resultId,L.data)),(0,a.encodeSemanticTokensDto)({id:D,type:"full",data:L.data})}if(V._isSemanticTokensEdits(L)){const D=this._nextResultId++;return V._isSemanticTokens(F)?this._previousResults.set(D,new Q(F.resultId,F.data)):this._previousResults.set(D,new Q(L.resultId)),(0,a.encodeSemanticTokensDto)({id:D,type:"delta",deltas:(L.edits||[]).map(O=>({start:O.start,deleteCount:O.deleteCount,data:O.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class te{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeSemanticTokens(L,F,D){const O=this._documents.getDocument(L),$=await this._provider.provideDocumentRangeSemanticTokens(O,_.Range.to(F),D);return $?this._send($):null}_send(L){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:L.data})}}e.DocumentRangeSemanticTokensAdapter=te;class oe{constructor(L,F,D,O,$){this._documents=L,this._commands=F,this._provider=D,this._apiDeprecation=O,this._extension=$,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}async provideCompletionItems(L,F,D,O){const $=this._documents.getDocument(L),X=_.Position.to(F),re=$.getWordRangeAtPosition(X)||new B.Range(X,X),pe=re.with({end:X}),Ce=new S.StopWatch(!0),Me=await this._provider.provideCompletionItems($,X,O,_.CompletionContext.to(D));if(!Me||O.isCancellationRequested)return;const Le=Array.isArray(Me)?new B.CompletionList(Me):Me,ze=oe.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),xe=new g.DisposableStore;this._disposables.set(ze,xe);const Oe=[],Xe={x:ze,b:Oe,a:{replace:_.Range.from(re),insert:_.Range.from(pe)},c:Le.isIncomplete||void 0,d:Ce.elapsed()};for(let et=0;et<Le.items.length;et++){const ke=Le.items[et],tt=this._convertCompletionItem(ke,[ze,et],pe,re);Oe.push(tt)}return Xe}async resolveCompletionItem(L,F){if(typeof this._provider.resolveCompletionItem!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveCompletionItem(D,F);if(!!O)return this._convertCompletionItem(O,L)}releaseCompletionItems(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_convertCompletionItem(L,F,D,O){const $=this._disposables.get(F[0]);if(!$)throw Error("DisposableStore is missing...");const X={x:F,a:L.label,b:L.kind!==void 0?_.CompletionItemKind.from(L.kind):void 0,n:L.tags&&L.tags.map(_.CompletionItemTag.from),c:L.detail,d:typeof L.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters,l:L.additionalTextEdits&&L.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(L.command,$)};L.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),X.h=L.textEdit.newText):typeof L.insertText=="string"?X.h=L.insertText:L.insertText instanceof B.SnippetString&&(X.h=L.insertText.value,X.i|=4);let re;return L.textEdit?re=L.textEdit.range:L.range&&(re=L.range),B.Range.isRange(re)?X.j=_.Range.from(re):re&&(!D?.isEqual(re.inserting)||!O?.isEqual(re.replacing))&&(X.j={insert:_.Range.from(re.inserting),replace:_.Range.from(re.replacing)}),X}}class ie{constructor(L,F,D){this._documents=L,this._provider=F,this._commands=D,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(L,F,D,O){const $=this._documents.getDocument(L),X=_.Position.to(F),re=await this._provider.provideInlineCompletionItems($,X,{selectedCompletionInfo:D.selectedSuggestionInfo?{range:_.Range.to(D.selectedSuggestionInfo.range),text:D.selectedSuggestionInfo.text,isSnippetText:D.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(D.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:D.triggerKind},O);if(!re||O.isCancellationRequested)return;const pe=(0,M.isArray)(re)?{items:re}:re,Ce=this._cache.add(pe.items);let Me;return{pid:Ce,items:pe.items.map((Le,ze)=>{let xe;return Le.command&&(Me||(Me=new g.DisposableStore,this._disposables.set(Ce,Me)),xe=this._commands.toInternal(Le.command,Me)),{text:Le.text,range:Le.range?_.Range.from(Le.range):void 0,command:xe,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(L){this._cache.delete(L);const F=this._disposables.get(L);F&&F.clear(),this._disposables.delete(L)}handleDidShowCompletionItem(L,F){const D=this._cache.get(L,F);D&&ue.get(this._provider).fireOnDidShowCompletionItem({completionItem:D})}}class ue{constructor(){this._onDidShowCompletionItemEmitter=new f.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(L){let F=ue.map.get(L);return F||(F=new ue,ue.map.set(L,F)),F}fireOnDidShowCompletionItem(L){this._onDidShowCompletionItemEmitter.fire(L)}}e.InlineCompletionController=ue,ue.map=new WeakMap;class he{constructor(L,F){this._documents=L,this._provider=F,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(L,F,D,O){const $=this._documents.getDocument(L),X=_.Position.to(F),re=this.reviveContext(D),pe=await this._provider.provideSignatureHelp($,X,O,re);if(pe){const Ce=this._cache.add([pe]);return{..._.SignatureHelp.from(pe),id:Ce}}}reviveContext(L){let F;if(L.activeSignatureHelp){const D=_.SignatureHelp.to(L.activeSignatureHelp),O=this._cache.get(L.activeSignatureHelp.id,0);O?(F=O,F.activeSignature=D.activeSignature,F.activeParameter=D.activeParameter):F=D}return{...L,activeSignatureHelp:F}}releaseSignatureHelp(L){this._cache.delete(L)}}class Se{constructor(L,F,D,O,$){this._documents=L,this._commands=F,this._provider=D,this._logService=O,this._extension=$,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(L,F,D){const O=this._documents.getDocument(L),$=_.Range.to(F),X=await this._provider.provideInlayHints(O,$,D);if(!Array.isArray(X)||X.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(D.isCancellationRequested)return;const re=this._cache.add(X);this._disposables.set(re,new g.DisposableStore);const pe={hints:[],cacheId:re};for(let Ce=0;Ce<X.length;Ce++)this._isValidInlayHint(X[Ce],$)&&pe.hints.push(this._convertInlayHint(X[Ce],[re,Ce]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),pe}async resolveInlayHint(L,F){if(typeof this._provider.resolveInlayHint!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveInlayHint(D,F);if(!!O&&!!this._isValidInlayHint(O))return this._convertInlayHint(O,L)}releaseHints(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_isValidInlayHint(L,F){return L.label.length===0||Array.isArray(L.label)&&L.label.every(D=>D.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(F&&!F.contains(L.position))}_convertInlayHint(L,F){const D=this._disposables.get(F[0]);if(!D)throw Error("DisposableStore is missing...");const O={label:"",cacheId:F,tooltip:_.MarkdownString.fromStrict(L.tooltip),command:L.command&&this._commands.toInternal(L.command,D),position:_.Position.from(L.position),kind:_.InlayHintKind.from(L.kind??B.InlayHintKind.Other),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?O.label=L.label:O.label=L.label.map($=>{let X={label:$.value};return X.tooltip=_.MarkdownString.fromStrict($.tooltip),B.Location.isLocation($.location)&&(X.location=_.location.from($.location)),$.command&&(X.command=this._commands.toInternal($.command,D)),X}),O}}class fe{constructor(L,F){this._documents=L,this._provider=F,this._cache=new d.Cache("DocumentLink")}async provideLinks(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentLinks(D,F);if(!(!Array.isArray(O)||O.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:O.filter(fe._validateLink).map(_.DocumentLink.from)};{const $=this._cache.add(O),X={links:[],cacheId:$};for(let re=0;re<O.length;re++){if(!fe._validateLink(O[re]))continue;const pe=_.DocumentLink.from(O[re]);pe.cacheId=[$,re],X.links.push(pe)}return X}}}static _validateLink(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,F){if(typeof this._provider.resolveDocumentLink!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveDocumentLink(D,F);if(!(!O||!fe._validateLink(O)))return _.DocumentLink.from(O)}releaseLinks(L){this._cache.delete(L)}}class ne{constructor(L,F){this._documents=L,this._provider=F}async provideColors(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentColors(D,F);return Array.isArray(O)?O.map(X=>({color:_.Color.from(X.color),range:_.Range.from(X.range)})):[]}async provideColorPresentations(L,F,D){const O=this._documents.getDocument(L),$=_.Range.to(F.range),X=_.Color.to(F.color),re=await this._provider.provideColorPresentations(X,{document:O,range:$},D);if(!!Array.isArray(re))return re.map(_.ColorPresentation.from)}}class me{constructor(L,F){this._documents=L,this._provider=F}async provideFoldingRanges(L,F,D){const O=this._documents.getDocument(L),$=await this._provider.provideFoldingRanges(O,F,D);if(!!Array.isArray($))return $.map(_.FoldingRange.from)}}class Ie{constructor(L,F,D){this._documents=L,this._provider=F,this._logService=D}async provideSelectionRanges(L,F,D){const O=this._documents.getDocument(L),$=F.map(_.Position.to),X=await this._provider.provideSelectionRanges(O,$,D);if(!(0,R.isNonEmptyArray)(X))return[];if(X.length!==$.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const re=[];for(let pe=0;pe<$.length;pe++){const Ce=[];re.push(Ce);let Me=$[pe],Le=X[pe];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(_.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return re}}class Ae{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.prepareCallHierarchy(O,$,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(pe=>this._cacheAndConvertItem(re,pe)):[this._cacheAndConvertItem(re,X)]}async provideCallsTo(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing call hierarchy item");const $=await this._provider.provideCallHierarchyIncomingCalls(O,D);if(!!$)return $.map(X=>({from:this._cacheAndConvertItem(L,X.from),fromRanges:X.fromRanges.map(re=>_.Range.from(re))}))}async provideCallsFrom(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing call hierarchy item");const $=await this._provider.provideCallHierarchyOutgoingCalls(O,D);if(!!$)return $.map(X=>({to:this._cacheAndConvertItem(L,X.to),fromRanges:X.fromRanges.map(re=>_.Range.from(re))}))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const D=this._cache.get(L),O=_.CallHierarchyItem.from(F,L,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ue{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,D){const O=this._documents.getDocument(L),$=_.Position.to(F),X=await this._provider.prepareTypeHierarchy(O,$,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(pe=>this._cacheAndConvertItem(re,pe)):[this._cacheAndConvertItem(re,X)]}async provideSupertypes(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing type hierarchy item");const $=await this._provider.provideTypeHierarchySupertypes(O,D);if(!!$)return $.map(X=>this._cacheAndConvertItem(L,X))}async provideSubtypes(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing type hierarchy item");const $=await this._provider.provideTypeHierarchySubtypes(O,D);if(!!$)return $.map(X=>this._cacheAndConvertItem(L,X))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const D=this._cache.get(L),O=_.TypeHierarchyItem.from(F,L,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ge{constructor(L,F){this.adapter=L,this.extension=F}}class ge{constructor(L,F,D,O,$,X,re){this._adapter=new Map,this._uriTransformer=F,this._proxy=L.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=D,this._commands=O,this._diagnostics=$,this._logService=X,this._apiDeprecation=re}_transformDocumentSelector(L){return _.DocumentSelector.from(L,this._uriTransformer)}_createDisposable(L){return new B.Disposable(()=>{this._adapter.delete(L),this._proxy.$unregister(L)})}_nextHandle(){return ge._handlePool++}async _withAdapter(L,F,D,O,$){const X=this._adapter.get(L);if(!X||!(X.adapter instanceof F))return O;const re=Date.now();this._logService.trace(`[${X.extension.identifier.value}] INVOKE provider '${D.toString().replace(/[\r\n]/g,"")}'`);const pe=D(X.adapter,X.extension);return Promise.resolve(pe).catch(Ce=>{(0,N.isCancellationError)(Ce)||(this._logService.error(`[${X.extension.identifier.value}] provider FAILED`),this._logService.error(Ce))}).finally(()=>{this._logService.trace(`[${X.extension.identifier.value}] provider DONE after ${Date.now()-re}ms`)}),l.CancellationToken.isCancellationToken($)?(0,m.raceCancellationError)(pe,$):pe}_addNewAdapter(L,F){const D=this._nextHandle();return this._adapter.set(D,new Ge(L,F)),D}static _extLabel(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,F,D,O){const $=this._addNewAdapter(new E(this._documents,D),L),X=O&&O.label||ge._extLabel(L);return this._proxy.$registerDocumentSymbolProvider($,this._transformDocumentSelector(F),X),this._createDisposable($)}$provideDocumentSymbols(L,F,D){return this._withAdapter(L,E,O=>O.provideDocumentSymbols(o.URI.revive(F),D),void 0,D)}registerCodeLensProvider(L,F,D){const O=this._nextHandle(),$=typeof D.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(O,new Ge(new r(this._documents,this._commands.converter,D),L)),this._proxy.$registerCodeLensSupport(O,this._transformDocumentSelector(F),$);let X=this._createDisposable(O);if($!==void 0){const re=D.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent($));X=B.Disposable.from(X,re)}return X}$provideCodeLenses(L,F,D){return this._withAdapter(L,r,O=>O.provideCodeLenses(o.URI.revive(F),D),void 0,D)}$resolveCodeLens(L,F,D){return this._withAdapter(L,r,O=>O.resolveCodeLens(F,D),void 0,void 0)}$releaseCodeLenses(L,F){this._withAdapter(L,r,D=>Promise.resolve(D.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(L,F,D){const O=this._addNewAdapter(new u(this._documents,D),L);return this._proxy.$registerDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDefinition(L,F,D,O){return this._withAdapter(L,u,$=>$.provideDefinition(o.URI.revive(F),D,O),[],O)}registerDeclarationProvider(L,F,D){const O=this._addNewAdapter(new i(this._documents,D),L);return this._proxy.$registerDeclarationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDeclaration(L,F,D,O){return this._withAdapter(L,i,$=>$.provideDeclaration(o.URI.revive(F),D,O),[],O)}registerImplementationProvider(L,F,D){const O=this._addNewAdapter(new s(this._documents,D),L);return this._proxy.$registerImplementationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideImplementation(L,F,D,O){return this._withAdapter(L,s,$=>$.provideImplementation(o.URI.revive(F),D,O),[],O)}registerTypeDefinitionProvider(L,F,D){const O=this._addNewAdapter(new t(this._documents,D),L);return this._proxy.$registerTypeDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideTypeDefinition(L,F,D,O){return this._withAdapter(L,t,$=>$.provideTypeDefinition(o.URI.revive(F),D,O),[],O)}registerHoverProvider(L,F,D,O){const $=this._addNewAdapter(new c(this._documents,D),L);return this._proxy.$registerHoverProvider($,this._transformDocumentSelector(F)),this._createDisposable($)}$provideHover(L,F,D,O){return this._withAdapter(L,c,$=>$.provideHover(o.URI.revive(F),D,O),void 0,O)}registerEvaluatableExpressionProvider(L,F,D,O){const $=this._addNewAdapter(new v(this._documents,D),L);return this._proxy.$registerEvaluatableExpressionProvider($,this._transformDocumentSelector(F)),this._createDisposable($)}$provideEvaluatableExpression(L,F,D,O){return this._withAdapter(L,v,$=>$.provideEvaluatableExpression(o.URI.revive(F),D,O),void 0,O)}registerInlineValuesProvider(L,F,D,O){const $=typeof D.onDidChangeInlineValues=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new h(this._documents,D),L);this._proxy.$registerInlineValuesProvider(X,this._transformDocumentSelector(F),$);let re=this._createDisposable(X);if($!==void 0){const pe=D.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent($));re=B.Disposable.from(re,pe)}return re}$provideInlineValues(L,F,D,O,$){return this._withAdapter(L,h,X=>X.provideInlineValues(o.URI.revive(F),D,O,$),void 0,$)}registerDocumentHighlightProvider(L,F,D){const O=this._addNewAdapter(new p(this._documents,D),L);return this._proxy.$registerDocumentHighlightProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentHighlights(L,F,D,O){return this._withAdapter(L,p,$=>$.provideDocumentHighlights(o.URI.revive(F),D,O),void 0,O)}registerLinkedEditingRangeProvider(L,F,D){const O=this._addNewAdapter(new k(this._documents,D),L);return this._proxy.$registerLinkedEditingRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideLinkedEditingRanges(L,F,D,O){return this._withAdapter(L,k,async $=>{const X=await $.provideLinkedEditingRanges(o.URI.revive(F),D,O);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?ge._serializeRegExp(X.wordPattern):void 0}},void 0,O)}registerReferenceProvider(L,F,D){const O=this._addNewAdapter(new A(this._documents,D),L);return this._proxy.$registerReferenceSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideReferences(L,F,D,O,$){return this._withAdapter(L,A,X=>X.provideReferences(o.URI.revive(F),D,O,$),void 0,$)}registerCodeActionProvider(L,F,D,O){const $=new g.DisposableStore,X=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,D,this._logService,L,this._apiDeprecation),L);return this._proxy.$registerQuickFixSupport(X,this._transformDocumentSelector(F),{providedKinds:O?.providedCodeActionKinds?.map(re=>re.value),documentation:O?.documentation?.map(re=>({kind:re.kind.value,command:this._commands.converter.toInternal(re.command,$)}))},ge._extLabel(L),Boolean(D.resolveCodeAction)),$.add(this._createDisposable(X)),$}$provideCodeActions(L,F,D,O,$){return this._withAdapter(L,x,X=>X.provideCodeActions(o.URI.revive(F),D,O,$),void 0,$)}$resolveCodeAction(L,F,D){return this._withAdapter(L,x,O=>O.resolveCodeAction(F,D),void 0,void 0)}$releaseCodeActions(L,F){this._withAdapter(L,x,D=>Promise.resolve(D.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(L,F,D){const O=this._addNewAdapter(new w(this._documents,D),L);return this._proxy.$registerDocumentFormattingSupport(O,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(O)}$provideDocumentFormattingEdits(L,F,D,O){return this._withAdapter(L,w,$=>$.provideDocumentFormattingEdits(o.URI.revive(F),D,O),void 0,O)}registerDocumentRangeFormattingEditProvider(L,F,D){const O=this._addNewAdapter(new z(this._documents,D),L);return this._proxy.$registerRangeFormattingSupport(O,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(O)}$provideDocumentRangeFormattingEdits(L,F,D,O,$){return this._withAdapter(L,z,X=>X.provideDocumentRangeFormattingEdits(o.URI.revive(F),D,O,$),void 0,$)}registerOnTypeFormattingEditProvider(L,F,D,O){const $=this._addNewAdapter(new q(this._documents,D),L);return this._proxy.$registerOnTypeFormattingSupport($,this._transformDocumentSelector(F),O,L.identifier),this._createDisposable($)}$provideOnTypeFormattingEdits(L,F,D,O,$,X){return this._withAdapter(L,q,re=>re.provideOnTypeFormattingEdits(o.URI.revive(F),D,O,$,X),void 0,X)}registerWorkspaceSymbolProvider(L,F){const D=this._addNewAdapter(new H(F,this._logService),L);return this._proxy.$registerNavigateTypeSupport(D,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(D)}$provideWorkspaceSymbols(L,F,D){return this._withAdapter(L,H,O=>O.provideWorkspaceSymbols(F,D),{symbols:[]},D)}$resolveWorkspaceSymbol(L,F,D){return this._withAdapter(L,H,O=>O.resolveWorkspaceSymbol(F,D),void 0,void 0)}$releaseWorkspaceSymbols(L,F){this._withAdapter(L,H,D=>D.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(L,F,D){const O=this._addNewAdapter(new W(this._documents,D,this._logService),L);return this._proxy.$registerRenameSupport(O,this._transformDocumentSelector(F),W.supportsResolving(D)),this._createDisposable(O)}$provideRenameEdits(L,F,D,O,$){return this._withAdapter(L,W,X=>X.provideRenameEdits(o.URI.revive(F),D,O,$),void 0,$)}$resolveRenameLocation(L,F,D,O){return this._withAdapter(L,W,$=>$.resolveRenameLocation(o.URI.revive(F),D,O),void 0,O)}registerDocumentSemanticTokensProvider(L,F,D,O){const $=this._addNewAdapter(new V(this._documents,D),L),X=typeof D.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider($,this._transformDocumentSelector(F),O,X);let re=this._createDisposable($);if(X){const pe=D.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(X));re=B.Disposable.from(re,pe)}return re}$provideDocumentSemanticTokens(L,F,D,O){return this._withAdapter(L,V,$=>$.provideDocumentSemanticTokens(o.URI.revive(F),D,O),null,O)}$releaseDocumentSemanticTokens(L,F){this._withAdapter(L,V,D=>D.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,F,D,O){const $=this._addNewAdapter(new te(this._documents,D),L);return this._proxy.$registerDocumentRangeSemanticTokensProvider($,this._transformDocumentSelector(F),O),this._createDisposable($)}$provideDocumentRangeSemanticTokens(L,F,D,O){return this._withAdapter(L,te,$=>$.provideDocumentRangeSemanticTokens(o.URI.revive(F),D,O),null,O)}registerCompletionItemProvider(L,F,D,O){const $=this._addNewAdapter(new oe(this._documents,this._commands.converter,D,this._apiDeprecation,L),L);return this._proxy.$registerSuggestSupport($,this._transformDocumentSelector(F),O,oe.supportsResolving(D),`${L.identifier.value}(${O.join("")})`),this._createDisposable($)}$provideCompletionItems(L,F,D,O,$){return this._withAdapter(L,oe,X=>X.provideCompletionItems(o.URI.revive(F),D,O,$),void 0,$)}$resolveCompletionItem(L,F,D){return this._withAdapter(L,oe,O=>O.resolveCompletionItem(F,D),void 0,D)}$releaseCompletionItems(L,F){this._withAdapter(L,oe,D=>D.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(L,F,D){const O=this._addNewAdapter(new ie(this._documents,D,this._commands.converter),L);return this._proxy.$registerInlineCompletionsSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideInlineCompletions(L,F,D,O,$){return this._withAdapter(L,ie,X=>X.provideInlineCompletions(o.URI.revive(F),D,O,$),void 0,$)}$handleInlineCompletionDidShow(L,F,D){this._withAdapter(L,ie,async O=>{O.handleDidShowCompletionItem(F,D)},void 0,void 0)}$freeInlineCompletionsList(L,F){this._withAdapter(L,ie,async D=>{D.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(L,F,D,O){const $=Array.isArray(O)?{triggerCharacters:O,retriggerCharacters:[]}:O,X=this._addNewAdapter(new he(this._documents,D),L);return this._proxy.$registerSignatureHelpProvider(X,this._transformDocumentSelector(F),$),this._createDisposable(X)}$provideSignatureHelp(L,F,D,O,$){return this._withAdapter(L,he,X=>X.provideSignatureHelp(o.URI.revive(F),D,O,$),void 0,$)}$releaseSignatureHelp(L,F){this._withAdapter(L,he,D=>D.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(L,F,D){const O=typeof D.onDidChangeInlayHints=="function"?this._nextHandle():void 0,$=this._addNewAdapter(new Se(this._documents,this._commands.converter,D,this._logService,L),L);this._proxy.$registerInlayHintsProvider($,this._transformDocumentSelector(F),typeof D.resolveInlayHint=="function",O,ge._extLabel(L));let X=this._createDisposable($);if(O!==void 0){const re=D.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(O));X=B.Disposable.from(X,re)}return X}$provideInlayHints(L,F,D,O){return this._withAdapter(L,Se,$=>$.provideInlayHints(o.URI.revive(F),D,O),void 0,O)}$resolveInlayHint(L,F,D){return this._withAdapter(L,Se,O=>O.resolveInlayHint(F,D),void 0,D)}$releaseInlayHints(L,F){this._withAdapter(L,Se,D=>D.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(L,F,D){const O=this._addNewAdapter(new fe(this._documents,D),L);return this._proxy.$registerDocumentLinkProvider(O,this._transformDocumentSelector(F),typeof D.resolveDocumentLink=="function"),this._createDisposable(O)}$provideDocumentLinks(L,F,D){return this._withAdapter(L,fe,O=>O.provideLinks(o.URI.revive(F),D),void 0,D)}$resolveDocumentLink(L,F,D){return this._withAdapter(L,fe,O=>O.resolveLink(F,D),void 0,void 0)}$releaseDocumentLinks(L,F){this._withAdapter(L,fe,D=>D.releaseLinks(F),void 0,void 0)}registerColorProvider(L,F,D){const O=this._addNewAdapter(new ne(this._documents,D),L);return this._proxy.$registerDocumentColorProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentColors(L,F,D){return this._withAdapter(L,ne,O=>O.provideColors(o.URI.revive(F),D),[],D)}$provideColorPresentations(L,F,D,O){return this._withAdapter(L,ne,$=>$.provideColorPresentations(o.URI.revive(F),D,O),void 0,O)}registerFoldingRangeProvider(L,F,D){const O=this._nextHandle(),$=typeof D.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(O,new Ge(new me(this._documents,D),L)),this._proxy.$registerFoldingRangeProvider(O,this._transformDocumentSelector(F),$);let X=this._createDisposable(O);if($!==void 0){const re=D.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent($));X=B.Disposable.from(X,re)}return X}$provideFoldingRanges(L,F,D,O){return this._withAdapter(L,me,$=>$.provideFoldingRanges(o.URI.revive(F),D,O),void 0,O)}registerSelectionRangeProvider(L,F,D){const O=this._addNewAdapter(new Ie(this._documents,D,this._logService),L);return this._proxy.$registerSelectionRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideSelectionRanges(L,F,D,O){return this._withAdapter(L,Ie,$=>$.provideSelectionRanges(o.URI.revive(F),D,O),[],O)}registerCallHierarchyProvider(L,F,D){const O=this._addNewAdapter(new Ae(this._documents,D),L);return this._proxy.$registerCallHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareCallHierarchy(L,F,D,O){return this._withAdapter(L,Ae,$=>Promise.resolve($.prepareSession(o.URI.revive(F),D,O)),void 0,O)}$provideCallHierarchyIncomingCalls(L,F,D,O){return this._withAdapter(L,Ae,$=>$.provideCallsTo(F,D,O),void 0,O)}$provideCallHierarchyOutgoingCalls(L,F,D,O){return this._withAdapter(L,Ae,$=>$.provideCallsFrom(F,D,O),void 0,O)}$releaseCallHierarchy(L,F){this._withAdapter(L,Ae,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(L,F,D){const O=this._addNewAdapter(new Ue(this._documents,D),L);return this._proxy.$registerTypeHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareTypeHierarchy(L,F,D,O){return this._withAdapter(L,Ue,$=>Promise.resolve($.prepareSession(o.URI.revive(F),D,O)),void 0,O)}$provideTypeHierarchySupertypes(L,F,D,O){return this._withAdapter(L,Ue,$=>$.provideSupertypes(F,D,O),void 0,O)}$provideTypeHierarchySubtypes(L,F,D,O){return this._withAdapter(L,Ue,$=>$.provideSubtypes(F,D,O),void 0,O)}$releaseTypeHierarchy(L,F){this._withAdapter(L,Ue,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}static _serializeRegExp(L){return{pattern:L.source,flags:(0,T.regExpFlags)(L)}}static _serializeIndentationRule(L){return{decreaseIndentPattern:ge._serializeRegExp(L.decreaseIndentPattern),increaseIndentPattern:ge._serializeRegExp(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?ge._serializeRegExp(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?ge._serializeRegExp(L.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(L){return{beforeText:ge._serializeRegExp(L.beforeText),afterText:L.afterText?ge._serializeRegExp(L.afterText):void 0,previousLineText:L.previousLineText?ge._serializeRegExp(L.previousLineText):void 0,action:L.action}}static _serializeOnEnterRules(L){return L.map(ge._serializeOnEnterRule)}setLanguageConfiguration(L,F,D){let{wordPattern:O}=D;if(O&&(0,T.regExpLeadsToEndlessLoop)(O))throw new Error(`Invalid language configuration: wordPattern '${O}' is not allowed to match the empty string.`);O?this._documents.setWordDefinitionFor(F,O):this._documents.setWordDefinitionFor(F,void 0),D.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),D.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const $=this._nextHandle(),X={comments:D.comments,brackets:D.brackets,wordPattern:D.wordPattern?ge._serializeRegExp(D.wordPattern):void 0,indentationRules:D.indentationRules?ge._serializeIndentationRule(D.indentationRules):void 0,onEnterRules:D.onEnterRules?ge._serializeOnEnterRules(D.onEnterRules):void 0,__electricCharacterSupport:D.__electricCharacterSupport,__characterPairSupport:D.__characterPairSupport};return this._proxy.$setLanguageConfiguration($,F,X),this._createDisposable($)}$setWordDefinitions(L){for(const F of L)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.ExtHostLanguageFeatures=ge,ge._handlePool=0}),define(ve[192],Ee([1,0,4,8,7,34,11,6]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(M,b,l,g){this._documents=b,this._commands=l,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=M.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this._languageIds=M}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(M,b){await this._proxy.$changeLanguage(M,b);const l=this._documents.getDocumentData(M);if(!l)throw new Error(`document '${M.toString}' NOT found`);return l.document}async tokenAtPosition(M,b){const l=M.version,g=I.Position.from(b),a=await this._proxy.$tokensAtPosition(M.uri,g),n={type:_.StandardTokenType.Other,range:M.getWordRangeAtPosition(b)??new _.Range(b.line,b.character,b.line,b.character)};if(!a)return n;const d={range:I.Range.to(a.range),type:I.TokenType.to(a.type)};return!d.range.contains(b)||l!==M.version?n:d}createLanguageStatusItem(M,b,l){const g=this._handlePool++,a=this._proxy,n=this._ids,d=`${M.identifier.value}/${b}`;if(n.has(d))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);n.add(d);const S={selector:l,id:b,name:M.displayName??M.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let N,f=new T.DisposableStore;const m=()=>{N?.dispose(),N=(0,y.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(g,{id:d,name:S.name??M.displayName??M.name,source:M.displayName??M.name,selector:I.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===_.LanguageStatusSeverity.Error?B.default.Error:S.severity===_.LanguageStatusSeverity.Warning?B.default.Warning:B.default.Info,command:S.command&&this._commands.toInternal(S.command,f),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},E={dispose(){f.dispose(),N?.dispose(),a.$removeLanguageStatus(g),n.delete(d)},get id(){return S.id},get name(){return S.name},set name(r){S.name=r,m()},get selector(){return S.selector},set selector(r){S.selector=r,m()},get text(){return S.text},set text(r){S.text=r,m()},get detail(){return S.detail},set detail(r){S.detail=r,m()},get severity(){return S.severity},set severity(r){S.severity=r,m()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(r){S.accessibilityInformation=r,m()},get command(){return S.command},set command(r){S.command=r,m()},get busy(){return S.busy},set busy(r){S.busy=r,m()}};return m(),E}}e.ExtHostLanguages=C}),define(ve[193],Ee([1,0,12,4,28,14,5]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends o.AbstractLoggerService{constructor(M,b){const l=new y.Emitter;super(b.logLevel,l.event);this._proxy=M.getProxy(I.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(M){this._onDidChangeLogLevel.fire(M)}doCreateLogger(M,b,l){return new C(this._proxy,M,b,l)}};T=Fe([Ne(0,B.IExtHostRpcService),Ne(1,_.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class C extends o.AbstractMessageLogger{constructor(M,b,l,g){super(g?.always);this.proxy=M,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(b,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(M,b){const l=[[M,b]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(M){this.proxy.$log(this.file,M)}}}),define(ve[194],Ee([1,0,4,12,27]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function B(T){return T&&T.title}let y=class{constructor(C,R){this._logService=R,this._proxy=C.getProxy(o.MainContext.MainThreadMessageService)}showMessage(C,R,M,b,l){const g={source:{identifier:C.identifier,label:C.displayName||C.name}};let a;typeof b=="string"||B(b)?a=[b,...l]:(g.modal=b?.modal,g.useCustom=b?.useCustom,g.detail=b?.detail,a=l),g.useCustom&&(0,_.checkProposedApiEnabled)(C,"resolvers");const n=[];for(let d=0;d<a.length;d++){const S=a[d];if(typeof S=="string")n.push({title:S,handle:d,isCloseAffordance:!1});else if(typeof S=="object"){let{title:N,isCloseAffordance:f}=S;n.push({title:N,isCloseAffordance:!!f,handle:d})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(R,M,g,n).then(d=>{if(typeof d=="number")return a[d]})}};y=Fe([Ne(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ve[195],Ee([1,0,21,5,93,6,22,10,13,2,57,4,8,7,38,169,89]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(f,m,E,r,P){this._textDocumentsAndEditors=E,this._textDocuments=r,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new M.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const i=u.notebookEditor?.notebookUri,s=u.cell.handle,c=this._documents.get(i)?.getCell(s);if(c)return c.apiCell}return u}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){const m=this._editors.get(f);if(!m)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(f){for(const[m,E]of this._editors)if(E.apiEditor===f)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,m){const E=this._documents.get(f);if(!E&&!m)throw new Error(`NO notebook document for '${f}'`);return E}_getProviderData(f){const m=this._notebookContentProviders.get(f);if(!m)throw new Error(`NO provider for '${f}'`);return m}registerNotebookContentProvider(f,m,E,r,P){if((0,T.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:f,provider:E});let u;return E.onDidChangeNotebookContentOptions&&(u=E.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(m,i)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},m,l.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(f,P)),new g.Disposable(()=>{u?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(f,m){if(!m)return;const E=m.filenamePattern.map(r=>l.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(m.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:m.displayName,filenamePattern:E,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,m,E){const r=S._notebookStatusBarItemProviderHandlePool++,P=typeof E.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,P,m);let u;return P!==void 0&&(u=E.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(P))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,P),u&&u.dispose()})}async createNotebookDocument(f){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&l.NotebookData.from(f.content)});return R.URI.revive(m)}async openNotebookDocument(f){const m=this._documents.get(f);if(m)return m.apiNotebook;const E=await this._notebookDocumentsProxy.$tryOpenNotebook(f),r=this._documents.get(R.URI.revive(E));return(0,C.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(f,m){R.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let E;typeof m=="object"?E={position:l.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(l.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:E={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,E),P=r&&this._editors.get(r)?.apiEditor;if(P)return P;throw r?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,m,E,r){const P=this._notebookStatusBarItemProviders.get(f),u=R.URI.revive(m),i=this._documents.get(u);if(!i||!P)return;const s=i.getCellFromIndex(E);if(!s)return;const t=await P.provideCellStatusBarItems(s.apiCell,r);if(!t)return;const c=new B.DisposableStore,v=this._statusBarCache.add([c]),p=(Array.isArray(t)?t:[t]).map(k=>l.NotebookStatusBarItem.from(k,this._commandsConverter,c));return{cacheId:v,items:p}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,m,E,r,P){if((0,T.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,E),this._notebookProxy.$registerNotebookSerializer(u,{id:f.identifier,location:f.extensionLocation},m,l.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(f,P)),(0,B.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(f,m,E){const r=this._notebookSerializer.get(f);if(!r)throw new Error("NO serializer found");const P=await r.deserializeNotebook(m.buffer,E);return new a.SerializableObjectWithBuffers(l.NotebookData.from(P))}async $notebookToData(f,m,E){const r=this._notebookSerializer.get(f);if(!r)throw new Error("NO serializer found");const P=await r.serializeNotebook(l.NotebookData.to(m.value),E);return o.VSBuffer.wrap(P)}async $openNotebook(f,m,E,r,P){const{provider:u}=this._getProviderData(f),i=await u.openNotebook(R.URI.revive(m),{backupId:E,untitledDocumentData:r?.buffer},P);return new a.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(f,m,E){const r=this.getNotebookDocument(R.URI.revive(m)),{provider:P}=this._getProviderData(f);return await P.saveNotebook(r.apiNotebook,E),!0}async $saveNotebookAs(f,m,E,r){const P=this.getNotebookDocument(R.URI.revive(m)),{provider:u}=this._getProviderData(f);return await u.saveNotebookAs(R.URI.revive(E),P.apiNotebook,r),!0}async $backupNotebook(f,m,E){const r=this.getNotebookDocument(R.URI.revive(m)),P=this._getProviderData(f),u=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),i=String((0,_.hash)([r.uri.toString(),this._backupIdPool++])),s=R.URI.joinPath(u,i),t=await P.provider.backupNotebook(r.apiNotebook,{destination:s},E);return r.updateBackup(t),t.id}_createExtHostEditor(f,m,E){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const r=new d.ExtHostNotebookEditor(m,this._notebookEditorsProxy,f,E.visibleRanges.map(l.NotebookRange.to),E.selections.map(l.NotebookRange.to),typeof E.viewColumn=="number"?l.ViewColumn.to(E.viewColumn):void 0);this._editors.set(m,r)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const E of f.value.removedDocuments){const r=R.URI.revive(E),P=this._documents.get(r);P&&(P.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===r.toString()&&this._editors.delete(u.id)}if(f.value.addedDocuments){const E=[];for(const r of f.value.addedDocuments){const P=R.URI.revive(r.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const u=this,i=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){u._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){u._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){u._onDidChangeCellMetadata.fire(s)}},P,r);E.push(...r.cells.map(s=>n.ExtHostCell.asModelAddData(i.apiNotebook,s))),this._documents.get(P)?.dispose(),this._documents.set(P,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(f.value.addedEditors)for(const E of f.value.addedEditors){if(this._editors.has(E.id))return;const r=R.URI.revive(E.documentUri),P=this._documents.get(r);P&&this._createExtHostEditor(P,E.id,E)}const m=[];if(f.value.removedEditors)for(const E of f.value.removedEditors){const r=this._editors.get(E);r&&(this._editors.delete(E),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),m.push(r))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const E=new Set;this._visibleNotebookEditors.forEach(r=>E.add(r.id));for(const r of this._editors.values()){const P=E.has(r.id);r._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(ve[196],Ee([1,0,5,53,12,4,14,8]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(b,l){const g=C._Keys.nextId();b.$registerNotebookEditorDecorationType(g,T.NotebookDecorationRenderOptions.from(l)),this.value={key:g,dispose(){b.$removeNotebookEditorDecorationType(g)}}}}C._Keys=new I.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(b,l,g){this._logService=b,this._extHostRpc=l,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new C(this._extHostRpc.getProxy(B.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,l);const g=this._notebooksAndEditors.getEditorById(b);l.visibleRanges&&g._acceptVisibleRanges(l.visibleRanges.ranges.map(T.NotebookRange.to)),l.selections&&g._acceptSelections(l.selections.selections.map(T.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const l in b)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(T.ViewColumn.to(b[l]))}};R=Fe([Ne(0,_.ILogService),Ne(1,y.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ve[197],Ee([1,0,16,11,20,5,6,22,2,25,12,4,39,8,7,60,162,27,38]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let f=class{constructor(i,s,t,c,v){this._initData=s,this._extHostNotebook=t,this._commands=c,this._logService=v,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new B.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(b.MainContext.MainThreadNotebookKernels);const h=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",p=>!0,p=>{if(p&&"notebookEditor"in p&&"id"in p){const k=this._extHostNotebook.getIdByEditor(p.notebookEditor);return{id:p.id,extension:p.extension,notebookEditorId:k}}else if(p&&"notebookEditor"in p){const k=this._extHostNotebook.getIdByEditor(p.notebookEditor);if(k===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${p.notebookEditor.document.uri.toString()}`);return{notebookEditorId:k}}return p})],l.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,s,t,c,v,h){for(const ue of this._kernelData.values())if(ue.controller.id===s&&R.ExtensionIdentifier.equals(i.identifier,ue.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const p=this._handlePool++,k=this;this._logService.trace(`NotebookController[${p}], CREATED by ${i.identifier.value}, ${s}`);const A=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${i.identifier}'`);let x=!1;const w=new y.DisposableStore,z=new B.Emitter,q=new B.Emitter,H={id:P(i,s),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:c||i.identifier.value,preloads:h?h.map(g.NotebookRendererScript.from):[]};let W=v??A,Q;this._proxy.$addKernel(p,H).catch(ue=>{console.log(ue),x=!0});let V=0;const te=()=>{if(x)return;const ue=++V;Promise.resolve().then(()=>{ue===V&&this._proxy.$updateKernel(p,H)})},oe=new T.ResourceMap,ie={get id(){return s},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return H.label},set label(ue){H.label=ue??i.displayName??i.name,te()},get detail(){return H.detail??""},set detail(ue){H.detail=ue,te()},get description(){return H.description??""},set description(ue){H.description=ue,te()},get kind(){return(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),H.kind??""},set kind(ue){(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),H.kind=ue,te()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ue){H.supportedLanguages=ue,te()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){H.supportsExecutionOrder=ue,te()},get rendererScripts(){return H.preloads?H.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ue){W=ue??A},get interruptHandler(){return Q},set interruptHandler(ue){Q=ue,H.supportsInterrupt=Boolean(ue),te()},createNotebookCellExecution(ue){if(x)throw new Error("notebook controller is DISPOSED");if(!oe.has(ue.notebook.uri))throw k._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(oe.keys()).map(he=>he.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return k._createNotebookCellExecution(ue,P(i,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${p}], DISPOSED`),x=!0,this._kernelData.delete(p),w.dispose(),z.dispose(),q.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(ue,he){k._proxy.$updateNotebookPriority(p,ue.uri,he)},onDidReceiveMessage:q.event,postMessage(ue,he){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),k._proxy.$postMessage(p,he&&k._extHostNotebook.getIdByEditor(he),ue)},asWebviewUri(ue){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),(0,n.asWebviewUri)(ue,k._initData.remote)}};return this._kernelData.set(p,{extensionId:i.identifier,controller:ie,onDidReceiveMessage:q,onDidChangeSelection:z,associatedNotebooks:oe}),ie}$acceptNotebookAssociation(i,s,t){const c=this._kernelData.get(i);if(c){const v=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));t?c.associatedNotebooks.set(v.uri,!0):c.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,v.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:v.apiNotebook})}}async $executeCells(i,s,t){const c=this._kernelData.get(i);if(!c)return;const v=this._extHostNotebook.getNotebookDocument(C.URI.revive(s)),h=[];for(const p of t){const k=v.getCell(p);k&&h.push(k.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,v.uri.toString(),h.length),await c.controller.executeHandler.call(c.controller,h,v.apiNotebook,c.controller)}catch(p){this._logService.error(`NotebookController[${i}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(i,s,t){const c=this._kernelData.get(i);if(!c)return;const v=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,v.apiNotebook);else for(const h of t){const p=v.getCell(h);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,t){const c=this._kernelData.get(i);if(!c)return;const v=this._extHostNotebook.getEditorById(s);c.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:t}))}$cellExecutionChanged(i,s,t){const v=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)).getCell(s);v&&this._onDidChangeCellExecutionState.fire({cell:v.apiCell,state:t??a.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const v=new E(s,c,this._proxy);this._activeExecutions.set(c.uri,v);const h=v.onDidChangeState(()=>{v.state===m.Resolved&&(v.dispose(),h.dispose(),this._activeExecutions.delete(c.uri))});return v.asApiObject()}};f=Fe([Ne(4,M.ILogService)],f),e.ExtHostNotebookKernels=f;var m;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(m||(m={}));class E extends y.Disposable{constructor(i,s,t){super();this._cell=s,this._proxy=t,this._handle=E.HANDLE++,this._onDidChangeState=new B.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=m.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new r(10,c=>this.update(c)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const s=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new N.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===m.Init)throw new Error("Must call start before modifying cell output");if(this._state===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(s=>{const t=a.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return t===s.items?g.NotebookCellOutput.from(s):g.NotebookCellOutput.from({items:t,id:s.id,metadata:s.metadata})})}async updateOutputs(i,s,t){const c=this.validateAndConvertOutputs((0,o.asArray)(i));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,append:t,outputs:c})}async updateOutputItems(i,s,t){return i=a.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(i),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:i.map(g.NotebookCellOutputItem.from),outputId:s.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===m.Resolved||i._state===m.Started)throw new Error("Cannot call start again");i._state=m.Started,i._onDidChangeState.fire(),i.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(i._state===m.Resolved)throw new Error("Cannot call resolve twice");i._state=m.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new N.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!0)},replaceOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!1)},appendOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!1)}})}}E.HANDLE=0;class r{constructor(i,s){this.delay=i,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>i.complete())}}function P(u,i){return`${u.identifier.value}/${i}`}}),define(ve[198],Ee([1,0,5,4,89,27]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(C,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,R,M){const b=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(R)?.fire({editor:b.apiEditor,message:M})}createRendererMessaging(C,R){if(!C.contributes?.notebookRenderer?.some(g=>g.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const M=(0,B.isProposedApiEnabled)(C,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(g,a,n)=>{const d=M?g:S=>{const N={};b.set(N,S.editor),g({editor:N,message:S.message})};return this.getOrCreateEmitterFor(R).event(d,a,n)},postMessage:(g,a)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,a]=[a,g]);const n=M?a:b.get(a),d=n&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(n);return this.proxy.$postMessage(d?.id,R,g)}}}getOrCreateEmitterFor(C){let R=this._rendererMessageEmitters.get(C);return R||(R=new o.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,R),R)}}e.ExtHostNotebookRenderers=y}),define(ve[94],Ee([1,0,4,6,3,14,12,163,50,28,30,112,21]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends I.Disposable{constructor(d,S,N,f){super();this.id=d,this.name=S,this.logger=N,this.proxy=f,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,d)}replace(d){const S=this.offset;this.write(d),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(d,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:S))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=l.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let a=class{constructor(d,S,N,f,m){this.extHostFileSystem=N,this.extHostFileSystemInfo=f,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[S,N]of this.channels)N.visible=S===this.visibleChannelId}createOutputChannel(d,S){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const N=this.doCreateOutputChannel(d,S);return N.then(f=>{this.channels.set(f.id,f),f.visible=f.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,N)}async doCreateOutputChannel(d,S){const N=await this.createOutputDirectory(),f=this.extHostFileSystemInfo.extUri.joinPath(N,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.loggerService.createLogger(f,{always:!0,donotRotate:!0,donotUseFormatters:!0}),E=await this.proxy.$register(d,!1,f,S.identifier.value);return new g(E,d,m,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,S){let N=!1;const f=()=>{if(N)throw new Error("Channel has been closed")};return{get name(){return d},append(m){f(),S.then(E=>E.append(m))},appendLine(m){f(),S.then(E=>E.appendLine(m))},clear(){f(),S.then(m=>m.clear())},replace(m){f(),S.then(E=>E.replace(m))},show(m,E){f(),S.then(r=>r.show(m,E))},hide(){f(),S.then(m=>m.hide())},dispose(){N=!0,S.then(m=>m.dispose())}}}};a=Fe([Ne(0,B.IExtHostRpcService),Ne(1,R.IExtHostInitDataService),Ne(2,C.IExtHostConsumerFileSystem),Ne(3,M.IExtHostFileSystemInfo),Ne(4,y.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(ve[199],Ee([1,0,11,20,5,6,4,2,7,15,16,34,56]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(a,n,d){const S=a.getProxy(y.MainContext.MainThreadQuickOpen);class N{constructor(t,c){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=c}showQuickPick(t,c,v=I.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(t),p=++this._instances,k=S.$show(p,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},v),A={},x=k.then(()=>A);return Promise.race([x,h]).then(w=>{if(w!==A)return h.then(z=>{const q=[];for(let H=0;H<z.length;H++){const W=z[H];typeof W=="string"?q.push({label:W,handle:H}):W.kind===C.QuickPickItemKind.Separator?q.push({type:"separator",label:W.label}):q.push({label:W.label,description:W.description,detail:W.detail,picked:W.picked,alwaysShow:W.alwaysShow,handle:H})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{c.onDidSelectItem(z[H])}),S.$setItems(p,q),k.then(H=>{if(typeof H=="number")return z[H];if(Array.isArray(H))return H.map(W=>z[W])})})}).then(void 0,w=>{if(!(0,R.isCancellationError)(w))return S.$setError(p,w),Promise.reject(w)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,c=I.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,S.$input(t,typeof this._validateInput=="function",c).then(void 0,v=>{if(!(0,R.isCancellationError)(v))return Promise.reject(v)})}$validateInput(t){return this._validateInput?(0,o.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,c=I.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!v)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(p=>p.uri.toString()===v.uri.toString())}createQuickPick(t){const c=new u(t,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(t){const c=new i(t,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(t,c){const v=this._sessions.get(t);v&&v._fireDidChangeValue(c)}$onDidAccept(t){const c=this._sessions.get(t);c&&c._fireDidAccept()}$onDidChangeActive(t,c){const v=this._sessions.get(t);v instanceof u&&v._fireDidChangeActive(c)}$onDidChangeSelection(t,c){const v=this._sessions.get(t);v instanceof u&&v._fireDidChangeSelection(c)}$onDidTriggerButton(t,c){const v=this._sessions.get(t);v&&v._fireDidTriggerButton(c)}$onDidTriggerItemButton(t,c,v){const h=this._sessions.get(t);h instanceof u&&h._fireDidTriggerItemButton(c,v)}$onDidHide(t){const c=this._sessions.get(t);c&&c._fireDidHide()}}class f{constructor(t,c){this._extensionId=t,this._onDidDispose=c,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((c,v)=>{const h=c===C.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(h,c)}),this.update({buttons:t.map((c,v)=>({...P(c),tooltip:c.tooltip,handle:c===C.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const c=this._handlesToButtons.get(t);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,B.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(t){if(!this._disposed){for(const c of Object.keys(t)){const v=t[c];this._pendingUpdate[c]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}f._nextId=1;function m(s){if(s instanceof C.ThemeIcon)return{id:s.id};const t=r(s),c=E(s);return{dark:typeof t=="string"?T.URI.file(t):t,light:typeof c=="string"?T.URI.file(c):c}}function E(s){return typeof s=="object"&&"light"in s?s.light:s}function r(s){return typeof s=="object"&&"dark"in s?s.dark:s}function P(s){const t=m(s.iconPath);let c,v;return"id"in t?v=l.ThemeIcon.asClassName(t):c=t,{iconPath:c,iconClass:v}}class u extends f{constructor(t,c){super(t.identifier,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((v,h)=>{this._handlesToItems.set(h,v),this._itemsToHandles.set(v,h)});const c=[];for(let v=0;v<t.length;v++){const h=t[v];h.kind===C.QuickPickItemKind.Separator?c.push({type:"separator",label:h.label}):c.push({handle:v,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((p,k)=>({...P(p),tooltip:p.tooltip,handle:k}))})}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(t){const c=(0,M.coalesce)(t.map(v=>this._handlesToItems.get(v)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(t){const c=(0,M.coalesce)(t.map(v=>this._handlesToItems.get(v)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(t,c){const v=this._handlesToItems.get(t);if(!v||!v.buttons||!v.buttons.length)return;const h=v.buttons[c];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:v})}}class i extends f{constructor(t,c){super(t,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?b.default.Error:b.default.Ignore})}}return new N(n,d)}e.createExtHostQuickOpen=g});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[200],Ee([1,0,2,5,52,6,11,4,16,107,12,25,56,8,27]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a){"use strict";var n,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(v){if(v)return typeof v.iconPath=="string"?o.URI.file(v.iconPath):o.URI.isUri(v.iconPath)||l.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function N(v,h){if(!v.iconPath&&!h.iconPath)return 0;if(v.iconPath){if(!h.iconPath)return 1}else return-1;const p=typeof v.iconPath=="string"?v.iconPath:o.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,k=typeof h.iconPath=="string"?h.iconPath:o.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,R.comparePaths)(p,k)}function f(v,h){let p=0;if(v.strikeThrough!==h.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==h.faded)return v.faded?1:-1;if(v.tooltip!==h.tooltip)return(v.tooltip||"").localeCompare(h.tooltip||"");if(p=N(v,h),p!==0)return p;if(v.light&&h.light)p=N(v.light,h.light);else{if(v.light)return 1;if(h.light)return-1}if(p!==0)return p;if(v.dark&&h.dark)p=N(v.dark,h.dark);else{if(v.dark)return 1;if(h.dark)return-1}return p}function m(v,h){if(v.command!==h.command)return v.command<h.command?-1:1;if(v.title!==h.title)return v.title<h.title?-1:1;if(v.tooltip!==h.tooltip){if(v.tooltip!==void 0&&h.tooltip!==void 0)return v.tooltip<h.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(v.arguments===h.arguments)return 0;if(v.arguments)if(h.arguments){if(v.arguments.length!==h.arguments.length)return v.arguments.length-h.arguments.length}else return 1;else return-1;for(let p=0;p<v.arguments.length;p++){const k=v.arguments[p],A=h.arguments[p];if(k!==A)return k<A?-1:1}return 0}function E(v,h){let p=(0,R.comparePaths)(v.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(p!==0)return p;if(v.command&&h.command)p=m(v.command,h.command);else{if(v.command)return 1;if(h.command)return-1}if(p!==0)return p;if(v.decorations&&h.decorations)p=f(v.decorations,h.decorations);else{if(v.decorations)return 1;if(h.decorations)return-1}return p}function r(v,h){for(let p=0;p<v.length;p++)if(v[p]!==h[p])return!1;return!0}function P(v,h){return v.command===h.command&&v.title===h.title&&v.tooltip===h.tooltip&&(v.arguments&&h.arguments?r(v.arguments,h.arguments):v.arguments===h.arguments)}function u(v,h){return(0,C.equals)(v,h,P)}class i{constructor(h,p,k){this._extension=h,this._sourceControlHandle=k,n.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0,je(this,n,p,"f")}get value(){return this._value}set value(h){h=h??"",De(this,n,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){De(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,De(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,De(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,p){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,n,"f").$showValidationMessage(this._sourceControlHandle,h,p)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,n=new WeakMap;class s{constructor(h,p,k,A,x){this._proxy=h,this._commands=p,this._sourceControlHandle=k,this._id=A,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,p){const k=this._resourceStatesCommandsMap.get(h);return k?(0,y.asPromise)(()=>this._commands.executeCommand(k.command,...k.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(E),k=(0,C.sortedDiff)(this._resourceSnapshot,h,E).map(w=>{const z=w.toInsert.map(q=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,q);const W=q.resourceUri;let Q;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const me=new B.DisposableStore;Q=this._commands.converter.toInternal(q.command,me),this._resourceStatesDisposablesMap.set(H,me)}else this._resourceStatesCommandsMap.set(H,q.command);const V=S(q.decorations),te=q.decorations&&S(q.decorations.light)||V,oe=q.decorations&&S(q.decorations.dark)||V,ie=[te,oe],ue=q.decorations&&q.decorations.tooltip||"",he=q.decorations&&!!q.decorations.strikeThrough,Se=q.decorations&&!!q.decorations.faded,fe=q.contextValue||"";return{rawResource:[H,W,ie,ue,he,Se,fe,Q],handle:H}});return{start:w.start,deleteCount:w.deleteCount,toInsert:z}}),A=k.map(({start:w,deleteCount:z,toInsert:q})=>[w,z,q.map(H=>H.rawResource)]),x=k.reverse();for(const{start:w,deleteCount:z,toInsert:q}of x){const H=q.map(Q=>Q.handle),W=this._handlesSnapshot.splice(w,z,...H);for(const Q of W)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=h,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class t{constructor(h,p,k,A,x,w){this._extension=h,this._commands=k,this._id=A,this._label=x,this._rootUri=w,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new B.MutableDisposable,this._statusBarDisposables=new B.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,je(this,d,p,"f"),this._inputBox=new i(h,De(this,d,"f"),this.handle),De(this,d,"f").$registerSourceControl(this.handle,A,x,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,De(this,d,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,De(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,De(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new B.DisposableStore,this._acceptInputCommand=h;const p=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);De(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:p})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new B.DisposableStore,this._actionButton=h;const p=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;De(this,d,"f").$updateSourceControl(this.handle,{actionButton:p??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&u(this._statusBarCommands,h))return;this._statusBarDisposables.value=new B.DisposableStore,this._statusBarCommands=h;const p=(h||[]).map(k=>this._commands.converter.toInternal(k,this._statusBarDisposables.value));De(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(h,p){const k=new s(De(this,d,"f"),this._commands,this.handle,h,p),A=I.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,A),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const h=[],p=[];for(const[k,A]of this.createdResourceGroups){A.dispose();const x=k.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(k),this.eventuallyUpdateResourceStates()});I.Event.once(k.onDidDispose)(()=>{this.updatedResourceGroups.delete(k),x.dispose(),this._groups.delete(k.handle),De(this,d,"f").$unregisterGroup(this.handle,k.handle)}),h.push([k.handle,k.id,k.label,k.features]);const w=k._takeResourceStateSnapshot();w.length>0&&p.push([k.handle,w]),this._groups.set(k.handle,k)}De(this,d,"f").$registerGroups(this.handle,h,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(p=>{const k=p._takeResourceStateSnapshot();k.length!==0&&h.push([p.handle,k])}),h.length>0&&De(this,d,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),De(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,Fe([(0,_.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Fe([(0,_.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Wi{constructor(h,p,k){this._commands=p,this.logService=k,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=h.getProxy(T.MainContext.MainThreadSCM),this._telemetry=h.getProxy(T.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const x=this._sourceControls.get(A.sourceControlHandle);if(!x)return A;const w=x.getResourceGroup(A.groupHandle);return w?w.getResourceState(A.handle):A}else if(A&&A.$mid===4){const x=this._sourceControls.get(A.sourceControlHandle);return x?x.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const x=this._sourceControls.get(A.handle);return x||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,p,k,A){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,p,k,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const x=Wi._handlePool++,w=new t(h,this._proxy,this._commands,p,k,A);this._sourceControls.set(x,w);const z=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(h.identifier))||[];return z.push(w),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(h.identifier),z),w}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const p=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(h.identifier)),k=p&&p[p.length-1];return k&&k.inputBox}$provideOriginalResource(h,p,k){const A=o.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,A.toString());const x=this._sourceControls.get(h);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(A,k)).then(w=>w||null)}$onInputBoxValueChange(h,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const k=this._sourceControls.get(h);return k&&k.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(h,p,k,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,p,k);const x=this._sourceControls.get(h);if(!x)return Promise.resolve(void 0);const w=x.getResourceGroup(p);return w?w.$executeResourceCommand(k,A):Promise.resolve(void 0)}$validateInput(h,p,k){this.logService.trace("ExtHostSCM#$validateInput",h);const A=this._sourceControls.get(h);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>A.inputBox.validateInput(p,k)).then(x=>{if(!x)return Promise.resolve(void 0);const w=g.MarkdownString.fromStrict(x.message);return w?Promise.resolve([w,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};c._handlePool=0,c=Fe([Ne(2,M.ILogService)],c),e.ExtHostSCM=c});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[201],Ee([1,0,7,4,125,6,8,13]),function(J,e,o,I,_,B,y,T){"use strict";var C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(a,n,d,S,N=o.StatusBarAlignment.Left,f){C.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new B.DisposableStore,je(this,C,a,"f"),je(this,R,n,"f"),this._entryId=M.ID_GEN++,this._extension=d,this._id=S,this._alignment=N,this._priority=this.validatePriority(f)}validatePriority(a){if(!!(0,T.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!M.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:De(this,R,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:De(this,R,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let n;this._name?n=this._name:n=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=M.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=y.MarkdownString.fromStrict(this._tooltip);De(this,C,"f").$setEntry(this._entryId,a,n,this._text,S,this._command?.internal,d,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=M,C=new WeakMap,R=new WeakMap,M.ID_GEN=0,M.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const n={message:a};return this._messages.unshift(n),this._update(),new o.Disposable(()=>{const d=this._messages.indexOf(n);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(a,n){this._proxy=a.getProxy(I.MainContext.MainThreadStatusBar),this._commands=n,this._statusMessage=new b(this)}createStatusBarEntry(a,n,d,S){return new M(this._proxy,this._commands,a,n,d,S)}setStatusBarMessage(a,n){const d=this._statusMessage.setMessage(a);let S;return typeof n=="number"?S=setTimeout(()=>d.dispose(),n):typeof n!="undefined"&&n.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=l}),define(ve[67],Ee([1,0,4,5,3]),function(J,e,o,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class B{constructor(T){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,C){this._proxy.$registerExtensionStorageKeysToSync(T,C)}initializeExtensionStorage(T,C,R){return this._proxy.$initializeExtensionStorage(T,C).then(M=>M||R)}setValue(T,C,R){return this._proxy.$setValue(T,C,R)}$acceptValue(T,C,R){this._onDidChangeStorage.fire({shared:T,key:C,value:R})}}e.ExtHostStorage=B,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ve[68],Ee([1,0,3,28,12,50,2]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let T=class{constructor(R,M,b){this._logService=M,this._extHostFileSystem=b,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(R){return y.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,M=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(M),this._logService.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",M),await this._extHostFileSystem.value.createDirectory(M),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),M}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(R){if(this._value)return y.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return y.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Fe([Ne(0,I.IExtHostInitDataService),Ne(1,_.ILogService),Ne(2,B.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(ve[40],Ee([1,0,5,4,3,2,14,6,7,126,15,165,20,36,145,56,13,11]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class N{constructor(t,c,v,h){this._proxy=t,this._id=c,this._creationOptions=v,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(k=>this._pidPromiseComplete=k);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},get state(){return p._state},sendText(k,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,k,A)},show(k){p._checkDisposed(),p._proxy.$show(p._id,k)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(u(t.iconPath)),color:n.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,v,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:n.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=N;class f{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let m=1,E=class extends T.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[v,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const v=new N(this._proxy,(0,g.generateUuid)(),t,t.name),h=new f(t.pty);return v.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,u(t.iconPath),i(t.color)).then(p=>{const k=this._setupExtHostProcessListeners(p,h);this._terminalProcessDisposables[p]=k}),this._terminals.push(v),v.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const v=t.location.parentTerminal;if(v){const h=this._terminals.find(p=>p.value===v);h&&(c.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new f(c),p=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=p}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(t);v&&(this._activeTerminal=v,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const v=this._getTerminalById(t);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:c})}async $acceptTerminalDimensions(t,c,v){const h=this._getTerminalById(t);h&&h.setDimensions(c,v)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,v){this._terminalProcesses.get(t)?.resize(c,v)}async $acceptTerminalTitleChange(t,c){const v=this._getTerminalById(t);v&&(v.name=c)}async $acceptTerminalClosed(t,c){const v=this._getTerminalObjectIndexById(this._terminals,t);if(v!==null){const h=this._terminals.splice(v,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,c,v,h){if(c){const A=this._getTerminalObjectIndexById(this._terminals,c);if(A!==null){this._terminals[A]._id=t,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:B.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},k=new N(this._proxy,t,p,v);this._terminals.push(k),this._onDidOpenTerminal.fire(k.value),k.isOpen=!0}async $acceptTerminalProcessId(t,c){const v=this._getTerminalById(t);v&&v._setProcessId(c)}async $startExtensionTerminal(t,c){const v=this._getTerminalById(t);if(!v)return{message:(0,R.localize)(0,null,t)};v.isOpen||await new Promise(p=>{const k=this.onDidOpenTerminal(async A=>{A===v.value&&(k.dispose(),p())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const v=new T.DisposableStore;v.add(c.onProcessReady(p=>this._proxy.$sendProcessReady(t,p.pid,p.cwd))),v.add(c.onDidChangeProperty(p=>this._proxy.$sendProcessProperty(t,p))),this._bufferer.startBuffering(t,c.onProcessData),v.add(c.onProcessExit(p=>this._onProcessExit(t,p))),this._terminalProcesses.set(t,c);const h=this._extensionTerminalAwaitingStart[t];return h&&c instanceof f&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),v}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,v){try{this._terminalProcesses.get(t)?.resize(c,v)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,v){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,v),this._proxy.$registerProfileProvider(c,t.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const v=new l.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(t,c){const v=this._getTerminalById(t);if(!v)return[];this._terminalLinkCache.delete(t);const h=this._terminalLinkCancellationSource.get(t);h&&h.dispose(!0);const p=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,p);const k=[],A={terminal:v.value,line:c},x=[];for(const q of this._linkProviders)x.push(S.Promises.withAsyncBody(async H=>{p.token.onCancellationRequested(()=>H({provider:q,links:[]}));const W=await q.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||H({provider:q,links:W})}));const w=await Promise.all(x);if(p.token.isCancellationRequested)return[];const z=new Map;for(const q of w)q&&q.links.length>0&&k.push(...q.links.map(H=>{const W={id:m++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return z.set(W.id,{provider:q.provider,link:H}),W}));return this._terminalLinkCache.set(t,z),k}$activateLink(t,c){const v=this._terminalLinkCache.get(t)?.get(c);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const v=this._terminalProcessDisposables[t];v&&(v.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const v=this._getTerminalObjectIndexById(t,c);return v!==null?t[v]:null}_getTerminalObjectIndexById(t,c){let v=null;return t.some((h,p)=>h._id===c?(v=p,!0):!1),v}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new r,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const v=(0,b.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const v=c[0],h=new r(c[1]);this._setEnvironmentVariableCollection(v,h)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};E=Fe([Ne(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class r{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const v=this.map.get(t);(!v||v.value!==c.value||v.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((v,h)=>t.call(c,h,v,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let P=class extends E{constructor(t){super(!1,t)}createTerminal(t,c,v){throw new M.NotSupportedError}createTerminalFromOptions(t,c){throw new M.NotSupportedError}};P=Fe([Ne(0,y.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function u(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function i(s){return n.ThemeColor.isThemeColor(s)?s:void 0}});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[202],Ee([1,0,16,21,20,5,233,93,6,26,13,36,4,14,48,8,7,171,61,63]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let E=class{constructor(A,x){this.resultsChangedEmitter=new B.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(l.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new P(this.proxy),x.registerArgumentProcessor({processArgument:w=>w?.$mid===13?n.TestItem.toItemFromContext(w):w})}createTestController(A,x,w){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const z=new C.DisposableStore,q=z.add(new S.SingleUseTestCollection(A));q.root.label=x;const H=new Map,W=this.proxy,Q={items:q.root.children,get label(){return x},set label(te){x=te,q.root.label=te,W.$updateController(A,{label:x})},get refreshHandler(){return w},set refreshHandler(te){w=te,W.$updateController(A,{canRefresh:!!te})},get id(){return A},createRunProfile:(te,oe,ie,ue,he)=>{let Se=(0,T.hash)(te);for(;H.has(Se);)Se++;const fe=new h(this.proxy,A,Se,te,oe,ie,ue,he);return H.set(Se,fe),fe},createTestItem(te,oe,ie){return new a.TestItemImpl(A,te,oe,ie)},createTestRun:(te,oe,ie=!0)=>this.runTracker.createTestRun(A,q,te,oe,ie),set resolveHandler(te){q.resolveHandler=te},get resolveHandler(){return q.resolveHandler},dispose:()=>{z.dispose()}};W.$registerTestController(A,x,!!w),z.add((0,C.toDisposable)(()=>W.$unregisterTestController(A)));const V={controller:Q,collection:q,profiles:H};return this.controllers.set(A,V),z.add((0,C.toDisposable)(()=>this.controllers.delete(A))),z.add(q.onDidGenerateDiff(te=>W.$publishDiff(A,te.map(N.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.observer.checkout()}async runTests(A,x=_.CancellationToken.None){const w=u(A);if(!w)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(w.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(q=>q.id)??[z.collection.root.id],profileGroup:p[w.kind],profileId:w.profileId,controllerId:w.controllerId}],exclude:A.exclude?.map(q=>q.id)},x)}$provideFileCoverage(A,x,w){return(0,o.mapFind)(this.runTracker.trackers,q=>q.id===A?q.getCoverage(x):void 0)?.provideFileCoverage(w)??Promise.resolve([])}$resolveFileCoverage(A,x,w,z){return(0,o.mapFind)(this.runTracker.trackers,H=>H.id===A?H.getCoverage(x):void 0)?.resolveFileCoverage(w,z)??Promise.resolve([])}$configureRunProfile(A,x){this.controllers.get(A)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(A,x){await this.controllers.get(A)?.controller.refreshHandler?.(x)}$publishTestResults(A){this.results=Object.freeze(A.map(x=>(0,R.deepFreeze)(n.TestResults.to(x))).concat(this.results).sort((x,w)=>w.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,x){const w=this.controllers.get(f.TestId.fromString(A).controllerId)?.collection;w&&(await w.expand(A,x<0?1/0:x),w.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A.map(N.TestsDiffOp.deserialize))}async $runControllerTests(A,x){const w=this.controllers.get(A.controllerId);if(!w)return;const{collection:z,profiles:q}=w,H=q.get(A.profileId);if(!H)return;const W=A.testIds.map(oe=>z.tree.get(oe)).filter(M.isDefined),Q=A.excludeExtIds.map(oe=>w.collection.tree.get(oe)).filter(M.isDefined).filter(oe=>W.some(ie=>ie.fullId.compare(oe.fullId)===2));if(!W.length)return;const V=new d.TestRunRequest(W.some(oe=>oe.actual instanceof a.TestItemRootImpl)?void 0:W.map(oe=>oe.actual),Q.map(oe=>oe.actual),H),te=this.runTracker.prepareForMainThreadTestRun(V,i.fromInternal(A,w.collection),x);try{await H.runHandler(V,x)}finally{te.isRunning&&!x.isCancellationRequested&&await B.Event.toPromise(te.onEnd),te.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};E=Fe([Ne(0,g.IExtHostRpcService)],E),e.ExtHostTesting=E;class r extends C.Disposable{constructor(A,x,w){super();this.dto=A,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new B.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(w)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:z}of this.tasks.values())z.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const x=this.dto.id,w=this.dto.controllerId,z=(0,b.generateUuid)(),q=new s(this.proxy,x,z),H=te=>(oe,...ie)=>{if(Q){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),te(oe,...ie))},W=(te,oe)=>{const ie=oe instanceof Array?oe.map(n.TestMessage.from):[n.TestMessage.from(oe)];if(te.uri&&te.range){const ue={range:n.Range.from(te.range),uri:te.uri};for(const he of ie)he.location=he.location||ue}this.proxy.$appendTestMessagesInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),ie)};let Q=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return q.coverageProvider},set coverageProvider(te){q.coverageProvider=te},enqueued:H(te=>{this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),1)}),skipped:H(te=>{this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),5)}),started:H(te=>{this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),2)}),errored:H((te,oe,ie)=>{W(te,oe),this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),6,ie)}),failed:H((te,oe,ie)=>{W(te,oe),this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,w).toString(),4,ie)}),passed:H((te,oe)=>{this.proxy.$updateTestStateInRun(x,z,f.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,oe)}),appendOutput:(te,oe,ie)=>{Q||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(x,z,I.VSBuffer.fromString(te),oe&&n.location.from(oe),ie&&f.TestId.fromExtHostTestItem(ie,w).toString()))},end:()=>{Q||(Q=!0,this.proxy.$finishedTestRunTask(x,z),this.tasks.delete(z),this.isRunning||this.dispose())}};return this.tasks.set(z,{run:V,coverage:q}),this.proxy.$startedTestRunTask(x,{id:z,name:A,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof a.TestItemImpl))throw new a.InvalidTestItemError(A.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const x=[],w=this.dto.colllection.root;for(;;){const z=n.TestItem.from(A);if(x.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),A===w))break;A=A.parent||w}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class P{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,x,w){return this.getTracker(A,x,w)}cancelRunById(A){for(const x of this.tracked.values())if(x.id===A){x.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,x,w,z,q){const H=this.tracked.get(w);if(H)return H.createRun(z);const W=i.fromPublic(A,x,w,q),Q=u(w);this.proxy.$startedExtensionTestRun({controllerId:A,profile:Q&&{group:p[Q.kind],id:Q.profileId},exclude:w.exclude?.map(te=>te.id)??[],id:W.id,include:w.include?.map(te=>te.id)??[x.root.id],persist:q});const V=this.getTracker(w,W);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),V.createRun(z)}getTracker(A,x,w){const z=new r(x,this.proxy,w);return this.tracked.set(A,z),z.onEnd(()=>this.tracked.delete(A)),z}}e.TestRunCoordinator=P;const u=k=>{if(!!k.profile){if(!(k.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class i{constructor(A,x,w,z,q,H){this.controllerId=A,this.id=x,this.isPersisted=q,this.colllection=H,this.includePrefix=w.map(W=>W+"\0"),this.excludePrefix=z.map(W=>W+"\0")}static fromPublic(A,x,w,z){return new i(A,(0,b.generateUuid)(),w.include?.map(q=>f.TestId.fromExtHostTestItem(q,A).toString())??[A],w.exclude?.map(q=>f.TestId.fromExtHostTestItem(q,A).toString())??[],z,x)}static fromInternal(A,x){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,x)}isIncluded(A){const x=f.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const w of this.excludePrefix)if(x===w||x.startsWith(w))return!1;for(const w of this.includePrefix)if(x===w||x.startsWith(w))return!0;return!1}}e.TestRunDto=i;class s{constructor(A,x,w){this.proxy=A,this.runId=x,this.taskId=w}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(A,x){const w=await this.fileCoverage;let z=w?.[A];return!this._coverageProvider||!w||!z?[]:(z.detailedCoverage||(z=w[A]=await this._coverageProvider.resolveFileCoverage?.(z,x)??z),z.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class t extends N.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,n.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:x,removed:w}=this;return{get added(){return[...A].map(z=>z.revived)},get updated(){return[...x].map(z=>z.revived)},get removed(){return[...w].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends N.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new B.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,x){return{...A,revived:n.TestItem.toPlain(A.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new t(this.changeEmitter)}}e.MirroredTestCollection=c;class v{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(x=>x.revived)},dispose:(0,y.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class h{constructor(A,x,w,z,q,H,W=!1,Q=void 0){this.controllerId=x,this.profileId=w,this._label=z,this.kind=q,this.runHandler=H,this._isDefault=W,this._tag=Q,m.set(this,void 0),je(this,m,A,"f");const V=p[q];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);De(this,m,"f").$publishTestRunProfile({profileId:w,controllerId:x,tag:Q?n.TestTag.namespace(this.controllerId,Q.id):null,label:z,group:V,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,De(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,De(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,De(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?n.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,De(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){De(this,m,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,m=new WeakMap;const p={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ve[203],Ee([1,0,5,16,4,90,8,7]),function(J,e,o,I,_,B,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(M,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new o.Emitter,this._onDidChangeTextEditorOptions=new o.Emitter,this._onDidChangeTextEditorVisibleRanges=new o.Emitter,this._onDidChangeTextEditorViewColumn=new o.Emitter,this._onDidChangeActiveTextEditor=new o.Emitter,this._onDidChangeVisibleTextEditors=new o.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=M.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(M){const b=this._extHostDocumentsAndEditors.allEditors();return M?b:b.map(l=>l.value)}async showTextDocument(M,b,l){let g;typeof b=="number"?g={position:y.ViewColumn.from(b),preserveFocus:l}:typeof b=="object"?g={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?y.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(M.uri,g),n=a&&this._extHostDocumentsAndEditors.getEditor(a);if(n)return n.value;throw a?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,b){return new B.TextEditorDecorationType(this._proxy,M,b).value}$acceptEditorPropertiesChanged(M,b){const l=this._extHostDocumentsAndEditors.getEditor(M);if(!l)throw new Error("unknown text editor");if(b.options&&l._acceptOptions(b.options),b.selections){const g=b.selections.selections.map(y.Selection.to);l._acceptSelections(g)}if(b.visibleRanges){const g=I.coalesce(b.visibleRanges.map(y.Range.to));l._acceptVisibleRanges(g)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...b.options,lineNumbers:y.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const g=T.TextEditorSelectionChangeKind.fromValue(b.selections.source),a=b.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:a,kind:g})}if(b.visibleRanges){const g=I.coalesce(b.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:g})}}$acceptEditorPositionData(M){for(const b in M){const l=this._extHostDocumentsAndEditors.getEditor(b);if(!l)throw new Error("Unknown text editor");const g=y.ViewColumn.to(M[b]);l.value.viewColumn!==g&&(l._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:g}))}}getDiffInformation(M){return Promise.resolve(this._proxy.$getDiffInformation(M))}}e.ExtHostEditors=C}),define(ve[204],Ee([1,0,2,3,4,6,7]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class T{constructor(M,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=M.getProxy(_.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const g=l.uri===void 0?void 0:o.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(C(g))?.get(l.handle)}return l}})}async $getTimeline(M,b,l,g,a){return this._providers.get(M)?.provideTimeline(o.URI.revive(b),l,g,a)}registerTimelineProvider(M,b,l,g){const a=new B.DisposableStore,n=this.convertTimelineItem(b.id,g,a).bind(this);let d;b.onDidChange&&(d=b.onDidChange(N=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...N,id:b.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:M,onDidChange:void 0,async provideTimeline(N,f,m,E){E?.resetCache&&(a.clear(),S.get(b.id)?.clear());const r=await b.provideTimeline(N,f,m);if(r==null)return;const P=n(N,E);return{...r,source:b.id,items:r.items.map(P)}},dispose(){for(const N of S.values())N.get(b.id)?.clear();d?.dispose(),a.dispose()}})}convertTimelineItem(M,b,l){return(g,a)=>{let n;if(a?.cacheResults){let d=this._itemsBySourceAndUriMap.get(M);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(M,d));const S=C(g);n=d.get(S),n===void 0&&(n=new Map,d.set(S,n))}return d=>{const{iconPath:S,...N}=d,f=`${M}|${d.id??d.timestamp}`;n?.set(f,d);let m,E,r;return d.iconPath&&(S instanceof y.ThemeIcon?r={id:S.id,color:S.color}:o.URI.isUri(S)?(m=S,E=S):{light:m,dark:E}=S),{...N,id:N.id??void 0,handle:f,source:M,command:d.command?b.toInternal(d.command,l):void 0,icon:m,iconDark:E,themeIcon:r,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(M){if(this._providers.get(M.id))throw new Error(`Timeline Provider ${M.id} already exists.`);return this._proxy.$registerTimelineProvider({id:M.id,label:M.label,scheme:M.scheme}),this._providers.set(M.id,M),(0,B.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(M.id)?.clear();this._providers.delete(M.id),this._proxy.$unregisterTimelineProvider(M.id),M.dispose()})}}e.ExtHostTimeline=T;function C(R){return R?.toString()}}),define(ve[205],Ee([1,0,6,9,2,4]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(C){this._openers=new Map,this._proxy=C.getProxy(B.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,R,M,b){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const l=b.schemes.find(g=>!y.supportedSchemes.has(g));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,M),this._proxy.$registerUriOpener(R,b.schemes,C,b.label),(0,o.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(C,R,M){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener with id: ${C}`);const l=_.URI.revive(R);return b.canOpenExternalUri(l,M)}async $openUri(C,R,M){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener id: '${C}'`);return b.openExternalUri(_.URI.revive(R.resolvedUri),{sourceUri:_.URI.revive(R.sourceUri)},M)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ve[206],Ee([1,0,4,2,6,15,25]),function(J,e,o,I,_,B,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(R,M){if(this.handles.has(y.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const b=T.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(R)),this.handlers.set(b,M),this._proxy.$registerUriHandler(b,R),(0,_.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(R)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(R,M){const b=this.handlers.get(R);if(!b)return Promise.resolve(void 0);try{b.handleUri(I.URI.revive(M))}catch(l){(0,B.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(R){return I.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=T,T.HandlePool=0});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[51],Ee([1,0,5,9,2,136,154,60,4]),function(J,e,o,I,_,B,y,T,C){"use strict";var R,M,b,l,g,a,n,d,S,N,f,m;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class E{constructor(v,h,p,k,A,x,w){R.set(this,void 0),M.set(this,void 0),b.set(this,void 0),l.set(this,void 0),g.set(this,void 0),a.set(this,void 0),n.set(this,""),d.set(this,void 0),S.set(this,!1),N.set(this,!1),f.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,m.set(this,new o.Emitter),this._onDidDispose=De(this,m,"f").event,je(this,R,v,"f"),je(this,M,h,"f"),je(this,d,p,"f"),je(this,l,k,"f"),je(this,g,A,"f"),je(this,a,x,"f"),je(this,f,r(x),"f"),je(this,b,w,"f")}dispose(){je(this,S,!0,"f"),De(this,m,"f").fire(),De(this,m,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return je(this,N,!0,"f"),(0,T.asWebviewUri)(v,De(this,l,"f").remote)}get cspSource(){const v=De(this,a,"f").extensionLocation;if(v.scheme===I.Schemas.https||v.scheme===I.Schemas.http){let h=v.toString();return h.endsWith("/")||(h+="/"),h+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,n,"f")}set html(v){this.assertNotDisposed(),De(this,n,"f")!==v&&(je(this,n,v,"f"),!De(this,N,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(je(this,N,!0,"f"),De(this,b,"f").report("Webview vscode-resource: uris",De(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,M,"f").$setHtml(De(this,R,"f"),v))}get options(){return this.assertNotDisposed(),De(this,d,"f")}set options(v){this.assertNotDisposed(),De(this,M,"f").$setOptions(De(this,R,"f"),i(De(this,a,"f"),De(this,g,"f"),v)),je(this,d,v,"f")}async postMessage(v){if(De(this,S,"f"))return!1;const h=(0,y.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:De(this,f,"f")});return De(this,M,"f").$postMessage(De(this,R,"f"),h.message,...h.buffers)}assertNotDisposed(){if(De(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=E,R=new WeakMap,M=new WeakMap,b=new WeakMap,l=new WeakMap,g=new WeakMap,a=new WeakMap,n=new WeakMap,d=new WeakMap,S=new WeakMap,N=new WeakMap,f=new WeakMap,m=new WeakMap;function r(c){try{const v=(0,B.normalizeVersion)((0,B.parseVersion)(c.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class P{constructor(v,h,p,k,A){this.initData=h,this.workspace=p,this._logService=k,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=v.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(v,h,p){const k=this.getWebview(v);if(k){const{message:A}=(0,y.deserializeWebviewMessage)(h,p.value);k._onMessageEmitter.fire(A)}}$onMissingCsp(v,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,h,p){const k=new E(v,this._webviewProxy,s(h),this.initData,this.workspace,p,this._deprecationService);return this._webviews.set(v,k),k._onDidDispose(()=>{this._webviews.delete(v)}),k}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=P;function u(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=u;function i(c,v,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(c,v)}}e.serializeWebviewOptions=i;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(v=>_.URI.from(v))}}e.reviveOptions=s;function t(c,v){return[...(v?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(ve[207],Ee([1,0,20,93,6,9,24,2,8,51,57,4,7]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(r,P){this.document=r,this._storagePath=P,this._backupCounter=1,this._edits=new M.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,P){await this.getEdit(r).undo(),P||this.disposeBackup()}async redo(r,P){await this.getEdit(r).redo(),P||this.disposeBackup()}disposeEdits(r){for(const P of r)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=m(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const P=this._edits.get(r,0);if(!P)throw new Error("No edit found");return P}}class a{constructor(){this._documents=new Map}get(r,P){return this._documents.get(this.key(r,P))}add(r,P,u){const i=this.key(r,P.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${r} resource:${P.uri}`);const s=new g(P,u);return this._documents.set(i,s),s}delete(r,P){const u=this.key(r,P.uri);this._documents.delete(u)}key(r,P){return`${r}@@@${P}`}}var n;(function(E){E[E.Text=0]="Text",E[E.Custom=1]="Custom"})(n||(n={}));class d{constructor(){this._providers=new Map}addTextProvider(r,P,u){return this.add(0,r,P,u)}addCustomProvider(r,P,u){return this.add(1,r,P,u)}get(r){return this._providers.get(r)}add(r,P,u,i){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:r,extension:u,provider:i}),new l.Disposable(()=>this._providers.delete(P))}}class S{constructor(r,P,u,i,s){this._extHostDocuments=P,this._extensionStoragePaths=u,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new d,this._documents=new a,this._proxy=r.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,P,u,i){const s=new _.DisposableStore;return N(u)?(s.add(this._editorProviders.addTextProvider(P,r,u)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(r),P,i.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(r))):(s.add(this._editorProviders.addCustomProvider(P,r,u)),this.supportEditing(u)&&s.add(u.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(P,t.document.uri);if(f(t)){const v=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,P,v,t.label)}else this._proxy.$onContentChange(t.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(r),P,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(r))),l.Disposable.from(s,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(r,P,u,i,s){const t=this._editorProviders.get(P);if(!t)throw new Error(`No provider found for '${P}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${P}'`);const c=T.URI.revive(r),v=await t.provider.openCustomDocument(c,{backupId:u,untitledDocumentData:i?.buffer},s);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(P,v,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(r,P){const u=this._editorProviders.get(P);if(!u)throw new Error(`No provider found for '${P}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${P}'`);const i=T.URI.revive(r),{document:s}=this.getCustomDocumentEntry(P,i);this._documents.delete(P,s),s.dispose()}async $resolveWebviewEditor(r,P,u,i,s,t){const c=this._editorProviders.get(u);if(!c)throw new Error(`No provider found for '${u}'`);const v=C.ViewColumn.to(s),h=this._extHostWebview.createNewWebview(P,i.webviewOptions,c.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(P,u,i.title,v,i.panelOptions,h),k=T.URI.revive(r);switch(c.type){case 1:{const{document:A}=this.getCustomDocumentEntry(u,k);return c.provider.resolveCustomEditor(A,p,t)}case 0:{const A=this._extHostDocuments.getDocument(k);return c.provider.resolveCustomTextEditor(A,p,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,P,u){this.getCustomDocumentEntry(P,r).disposeEdits(u)}async $onMoveCustomEditor(r,P,u){const i=this._editorProviders.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this._extHostWebviewPanels.getWebviewPanel(r);if(!s)throw new Error("No webview found");const t=T.URI.revive(P),c=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(c,s,o.CancellationToken.None)}async $undo(r,P,u,i){return this.getCustomDocumentEntry(P,r).undo(u,i)}async $redo(r,P,u,i){return this.getCustomDocumentEntry(P,r).redo(u,i)}async $revert(r,P,u){const i=this.getCustomDocumentEntry(P,r);await this.getCustomEditorProvider(P).revertCustomDocument(i.document,u),i.disposeBackup()}async $onSave(r,P,u){const i=this.getCustomDocumentEntry(P,r);await this.getCustomEditorProvider(P).saveCustomDocument(i.document,u),i.disposeBackup()}async $onSaveAs(r,P,u,i){const s=this.getCustomDocumentEntry(P,r);return this.getCustomEditorProvider(P).saveCustomDocumentAs(s.document,T.URI.revive(u),i)}async $backup(r,P,u){const i=this.getCustomDocumentEntry(P,r),t=await this.getCustomEditorProvider(P).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},u);return i.updateBackup(t),t.id}getCustomDocumentEntry(r,P){const u=this._documents.get(r,T.URI.revive(P));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(r){const u=this._editorProviders.get(r)?.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function N(E){return typeof E.resolveCustomTextEditor=="function"}function f(E){return typeof E.undo=="function"&&typeof E.redo=="function"}function m(E){const r=E.scheme===B.Schemas.file||E.scheme===B.Schemas.untitled?E.fsPath:E.toString();return(0,I.hash)(r)+""}});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[208],Ee([1,0,5,6,2,36,8,51,4,7]),function(J,e,o,I,_,B,y,T,C,R){"use strict";var M,b,l,g,a,n,d,S,N,f,m,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends I.Disposable{constructor(t,c,v,h,p,k,A){super();M.set(this,void 0),b.set(this,void 0),l.set(this,void 0),g.set(this,void 0),a.set(this,void 0),n.set(this,void 0),d.set(this,void 0),S.set(this,void 0),N.set(this,!0),f.set(this,!0),m.set(this,!1),E.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,E,"f").event,r.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=De(this,r,"f").event,je(this,M,t,"f"),je(this,b,c,"f"),je(this,l,v,"f"),je(this,a,k,"f"),je(this,S,p,"f"),je(this,n,h,"f"),je(this,g,A,"f")}dispose(){De(this,m,"f")||(je(this,m,!0,"f"),De(this,E,"f").fire(),De(this,b,"f").$disposeWebview(De(this,M,"f")),De(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,g,"f")}get viewType(){return this.assertNotDisposed(),De(this,l,"f")}get title(){return this.assertNotDisposed(),De(this,n,"f")}set title(t){this.assertNotDisposed(),De(this,n,"f")!==t&&(je(this,n,t,"f"),De(this,b,"f").$setTitle(De(this,M,"f"),t))}get iconPath(){return this.assertNotDisposed(),De(this,d,"f")}set iconPath(t){this.assertNotDisposed(),De(this,d,"f")!==t&&(je(this,d,t,"f"),De(this,b,"f").$setIconPath(De(this,M,"f"),_.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return De(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,S,"f")=="number"&&De(this,S,"f")<0))return De(this,S,"f")}get active(){return this.assertNotDisposed(),De(this,f,"f")}get visible(){return this.assertNotDisposed(),De(this,N,"f")}_updateViewState(t){De(this,m,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(je(this,f,t.active,"f"),je(this,N,t.visible,"f"),je(this,S,t.viewColumn,"f"),De(this,r,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),De(this,b,"f").$reveal(De(this,M,"f"),{viewColumn:typeof t=="undefined"?void 0:y.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(De(this,m,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,b=new WeakMap,l=new WeakMap,g=new WeakMap,a=new WeakMap,n=new WeakMap,d=new WeakMap,S=new WeakMap,N=new WeakMap,f=new WeakMap,m=new WeakMap,E=new WeakMap,r=new WeakMap;class u{constructor(t,c,v){this.webviews=c,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,B.generateUuid)()}createWebviewPanel(t,c,v,h,p={}){const k=typeof h=="object"?h.viewColumn:h,A={viewColumn:y.ViewColumn.from(k),preserveFocus:typeof h=="object"&&!!h.preserveFocus},x=(0,T.shouldSerializeBuffersForPostMessage)(t),w=u.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(t),w,c,{title:v,panelOptions:i(p),webviewOptions:(0,T.serializeWebviewOptions)(t,this.workspace,p),serializeBuffersForPostMessage:x},A);const z=this.webviews.createNewWebview(w,p,t);return this.createNewWebviewPanel(w,c,v,k,p,z)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((v,h)=>{const p=t[v],k=t[h];return p.active?1:k.active?-1:+p.visible-+k.visible});for(const v of c){const h=this.getWebviewPanel(v);if(!h)continue;const p=t[v];h._updateViewState({active:p.active,visible:p.visible,viewColumn:y.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,v){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:v,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,v,h){const p=this._serializers.get(c);if(!p)throw new Error(`No serializer found for '${c}'`);const{serializer:k,extension:A}=p,x=this.webviews.createNewWebview(t,v.webviewOptions,A),w=this.createNewWebviewPanel(t,c,v.title,h,v.panelOptions,x);await k.deserializeWebviewPanel(w,v.state)}createNewWebviewPanel(t,c,v,h,p,k){const A=new P(t,this._proxy,c,v,h,p,k);return this._webviewPanels.set(t,A),A}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=u;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[209],Ee([1,0,5,6,51,4,7]),function(J,e,o,I,_,B,y){"use strict";var T,C,R,M,b,l,g,a,n,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends I.Disposable{constructor(m,E,r,P,u,i){super();T.set(this,void 0),C.set(this,void 0),R.set(this,void 0),M.set(this,void 0),b.set(this,!1),l.set(this,void 0),g.set(this,void 0),a.set(this,void 0),n.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=De(this,n,"f").event,d.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,d,"f").event,je(this,R,r,"f"),je(this,g,P,"f"),je(this,T,m,"f"),je(this,C,E,"f"),je(this,M,u,"f"),je(this,l,i,"f")}dispose(){De(this,b,"f")||(je(this,b,!0,"f"),De(this,d,"f").fire(),De(this,M,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,g,"f")}set title(m){this.assertNotDisposed(),De(this,g,"f")!==m&&(je(this,g,m,"f"),De(this,C,"f").$setWebviewViewTitle(De(this,T,"f"),m))}get description(){return this.assertNotDisposed(),De(this,a,"f")}set description(m){this.assertNotDisposed(),De(this,a,"f")!==m&&(je(this,a,m,"f"),De(this,C,"f").$setWebviewViewDescription(De(this,T,"f"),m))}get visible(){return De(this,l,"f")}get webview(){return De(this,M,"f")}get viewType(){return De(this,R,"f")}_setVisible(m){m===De(this,l,"f")||De(this,b,"f")||(je(this,l,m,"f"),De(this,n,"f").fire())}show(m){this.assertNotDisposed(),De(this,C,"f").$show(De(this,T,"f"),!!m)}assertNotDisposed(){if(De(this,b,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,R=new WeakMap,M=new WeakMap,b=new WeakMap,l=new WeakMap,g=new WeakMap,a=new WeakMap,n=new WeakMap,d=new WeakMap;class N{constructor(m,E){this._extHostWebview=E,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(B.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,E,r,P){if(this._viewProviders.has(E))throw new Error(`View provider for '${E}' already registered`);return this._viewProviders.set(E,{provider:r,extension:m}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(m),E,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(E),this._proxy.$unregisterWebviewViewProvider(E)})}async $resolveWebviewView(m,E,r,P,u){const i=this._viewProviders.get(E);if(!i)throw new Error(`No view provider found for '${E}'`);const{provider:s,extension:t}=i,c=this._extHostWebview.createNewWebview(m,{},t),v=new S(m,this._proxy,E,r,c,!0);this._webviewViews.set(m,v),await s.resolveWebviewView(v,{state:P},u)}async $onDidChangeWebviewViewVisibility(m,E){this.getWebviewView(m)._setVisible(E)}async $disposeWebviewView(m){const E=this.getWebviewView(m);this._webviewViews.delete(m),E.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const E=this._webviewViews.get(m);if(!E)throw new Error("No webview found");return E}}e.ExtHostWebviewViews=N}),define(ve[95],Ee([1,0,5,4,2,9,10,3,14]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Vi{constructor(b){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Vi.InitialState,this._proxy=b.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,l){let g;if(typeof b=="string"){g=b;try{b=_.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,y.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===B.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,g,l)}async asExternalUri(b,l){if((0,y.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(b,l);return _.URI.from(g)}};R.InitialState={focused:!0},R=Fe([Ne(0,C.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(ve[210],Ee([1,0,11,21,20,15,5,6,108,176,38]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(p,k){try{return JSON.stringify(p,k)}catch{return"null"}}const g="$$ref$$",a={[g]:-1};class n{constructor(k,A){this.jsonString=k,this.referencedBuffers=A}}function d(p,k=null,A=!1){const x=[];return{jsonString:(A?l:JSON.stringify)(p,(z,q)=>{if(typeof q=="undefined")return a;if(typeof q=="object"){if(q instanceof I.VSBuffer){const H=x.push(q)-1;return{[g]:H}}if(k)return k(z,q)}return q}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=d;function S(p,k,A){return JSON.parse(p,(x,w)=>{if(w){const z=w[g];if(typeof z=="number")return k[z];if(A&&w.$mid===1)return A.transformIncoming(w)}return w})}e.parseJsonAndRestoreBufferRefs=S;function N(p,k){return JSON.stringify(p,k)}function f(p){return p?(k,A)=>A&&A.$mid===1?p.transformOutgoing(A):A:null}var m;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},P=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(k,A=null,x=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=A,this._uriTransformer=x,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,z=M.ProxyIdentifier.count;w<z;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{this._pendingRPCReplies[k].resolveErr(B.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,C.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:A,sid:x}=k;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,x)),this._proxies[A]}_createProxy(k,A){let x={get:(w,z)=>(typeof z=="string"&&!w[z]&&z.charCodeAt(0)===36&&(w[z]=(...q)=>this._remoteCall(k,z,q)),z===u?A:w[z])};return new Proxy(Object.create(null),x)}set(k,A){return this._locals[k.nid]=A,A}assertRegistered(k){for(let A=0,x=k.length;A<x;A++){const w=k[A];if(!this._locals[w.nid])throw new Error(`Missing proxy instance ${w.sid}`)}}_receiveOneMessage(k){if(this._isDisposed)return;const A=k.byteLength,x=s.read(k,0),w=x.readUInt8(),z=x.readUInt32();switch(w){case 1:case 2:{let{rpcId:q,method:H,args:W}=c.deserializeRequestJSONArgs(x);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,z,q,H,W,w===2);break}case 3:case 4:{let{rpcId:q,method:H,args:W}=c.deserializeRequestMixedArgs(x);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,z,q,H,W,w===4);break}case 5:{this._logger&&this._logger.logIncoming(A,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(A,z);break}case 7:{this._receiveReply(A,z,void 0);break}case 9:{let q=c.deserializeReplyOKJSON(x);this._uriTransformer&&(q=(0,C.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReply(A,z,q);break}case 10:{const q=c.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(A,z,q);break}case 8:{let q=c.deserializeReplyOKVSBuffer(x);this._receiveReply(A,z,q);break}case 11:{let q=c.deserializeReplyErrError(x);this._uriTransformer&&(q=(0,C.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReplyErr(A,z,q);break}case 12:{this._receiveReplyErr(A,z,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,A,x,w,z,q){this._logger&&this._logger.logIncoming(k,A,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(x)}.${w}(`,z);const H=String(A);let W,Q;if(q){const te=new _.CancellationTokenSource;z.push(te.token),W=this._invokeHandler(x,w,z),Q=()=>te.cancel()}else W=this._invokeHandler(x,w,z),Q=r;this._cancelInvokedHandlers[H]=Q;const V=c.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(V.byteLength,A,1,"ack"),this._protocol.send(V),W.then(te=>{delete this._cancelInvokedHandlers[H];const oe=c.serializeReplyOK(A,te,this._uriReplacer);this._logger&&this._logger.logOutgoing(oe.byteLength,A,1,"reply:",te),this._protocol.send(oe)},te=>{delete this._cancelInvokedHandlers[H];const oe=c.serializeReplyErr(A,te);this._logger&&this._logger.logOutgoing(oe.byteLength,A,1,"replyErr:",te),this._protocol.send(oe)})}_receiveCancel(k,A){this._logger&&this._logger.logIncoming(k,A,1,"receiveCancel");const x=String(A);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(k,A,x){this._logger&&this._logger.logIncoming(k,A,0,"receiveReply:",x);const w=String(A);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const z=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],z.resolveOk(x)}_receiveReplyErr(k,A,x){this._logger&&this._logger.logIncoming(k,A,0,"receiveReplyErr:",x);const w=String(A);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const z=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let q;x&&(x.$isError?(q=new Error,q.name=x.name,q.message=x.message,q.stack=x.stack):q=x),z.resolveErr(q)}_invokeHandler(k,A,x){try{return Promise.resolve(this._doInvokeHandler(k,A,x))}catch(w){return Promise.reject(w)}}_doInvokeHandler(k,A,x){const w=this._locals[k];if(!w)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(k));let z=w[A];if(typeof z!="function")throw new Error("Unknown method "+A+" on actor "+(0,M.getStringIdentifierForProxy)(k));return z.apply(w,x)}_remoteCall(k,A,x){if(this._isDisposed)return Promise.reject(B.canceled());let w=null;if(x.length>0&&_.CancellationToken.isCancellationToken(x[x.length-1])&&(w=x.pop()),w&&w.isCancellationRequested)return Promise.reject(B.canceled());const z=c.serializeRequestArguments(x,this._uriReplacer),q=++this._lastMessageId,H=String(q),W=new R.LazyPromise;w&&w.onCancellationRequested(()=>{const V=c.serializeCancel(q);this._logger&&this._logger.logOutgoing(V.byteLength,q,0,"cancel"),this._protocol.send(c.serializeCancel(q))}),this._pendingRPCReplies[H]=W,this._onWillSendRequest(q);const Q=c.serializeRequest(q,k,A,z,!!w);return this._logger&&this._logger.logOutgoing(Q.byteLength,q,0,`request: ${(0,M.getStringIdentifierForProxy)(k)}.${A}(`,x),this._protocol.send(Q),W}}e.RPCProtocol=i,b=P,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(k,A){this._buff=k,this._offset=A}static alloc(k,A,x){let w=new s(I.VSBuffer.alloc(x+1+4),0);return w.writeUInt8(k),w.writeUInt32(A),w}static read(k,A){return new s(k,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,x}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,x}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,A}static sizeMixedArray(k){let A=0;A+=1;for(let x=0,w=k.length;x<w;x++){const z=k[x];switch(A+=1,z.type){case 1:A+=this.sizeLongString(z.value);break;case 2:A+=this.sizeVSBuffer(z.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(z.value);for(let q=0;q<z.buffers.length;++q)A+=this.sizeVSBuffer(z.buffers[q]);break;case 4:break}}return A}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let A=0,x=k.length;A<x;A++){const w=k[A];switch(w.type){case 1:this.writeUInt8(1),this.writeLongString(w.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(w.value);break;case 3:this.writeUInt8(3),this.writeUInt32(w.buffers.length),this.writeLongString(w.value);for(let z=0;z<w.buffers.length;++z)this.writeBuffer(w.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(k);for(let x=0;x<k;x++)switch(this.readUInt8()){case 1:A[x]=this.readLongString();break;case 2:A[x]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),q=this.readLongString(),H=[];for(let W=0;W<z;++W)H.push(this.readVSBuffer());A[x]=new M.SerializableObjectWithBuffers(S(q,H,null));break}case 4:A[x]=void 0;break}return A}}s.sizeUInt32=4;var t;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(k){for(let A=0,x=k.length;A<x;A++)if(k[A]instanceof I.VSBuffer||k[A]instanceof M.SerializableObjectWithBuffers||typeof k[A]=="undefined")return!0;return!1}static serializeRequestArguments(k,A){if(this._useMixedArgSerialization(k)){const x=[];for(let w=0,z=k.length;w<z;w++){const q=k[w];if(q instanceof I.VSBuffer)x[w]={type:2,value:q};else if(typeof q=="undefined")x[w]={type:4};else if(q instanceof M.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:W}=d(q.value,A);x[w]={type:3,value:I.VSBuffer.fromString(H),buffers:W}}else x[w]={type:1,value:I.VSBuffer.fromString(N(q,A))}}return{type:1,args:x}}return{type:0,args:N(k,A)}}static serializeRequest(k,A,x,w,z){switch(w.type){case 0:return this._requestJSONArgs(k,A,x,w.args,z);case 1:return this._requestMixedArgs(k,A,x,w.args,z)}}static _requestJSONArgs(k,A,x,w,z){const q=I.VSBuffer.fromString(x),H=I.VSBuffer.fromString(w);let W=0;W+=s.sizeUInt8(),W+=s.sizeShortString(q),W+=s.sizeLongString(H);let Q=s.alloc(z?2:1,k,W);return Q.writeUInt8(A),Q.writeShortString(q),Q.writeLongString(H),Q.buffer}static deserializeRequestJSONArgs(k){const A=k.readUInt8(),x=k.readShortString(),w=k.readLongString();return{rpcId:A,method:x,args:JSON.parse(w)}}static _requestMixedArgs(k,A,x,w,z){const q=I.VSBuffer.fromString(x);let H=0;H+=s.sizeUInt8(),H+=s.sizeShortString(q),H+=s.sizeMixedArray(w);let W=s.alloc(z?4:3,k,H);return W.writeUInt8(A),W.writeShortString(q),W.writeMixedArray(w),W.buffer}static deserializeRequestMixedArgs(k){const A=k.readUInt8(),x=k.readShortString(),w=k.readMixedArray(),z=new Array(w.length);for(let q=0,H=w.length;q<H;q++){const W=w[q];typeof W=="string"?z[q]=JSON.parse(W):z[q]=W}return{rpcId:A,method:x,args:z}}static serializeAcknowledged(k){return s.alloc(5,k,0).buffer}static serializeCancel(k){return s.alloc(6,k,0).buffer}static serializeReplyOK(k,A,x){if(typeof A=="undefined")return this._serializeReplyOKEmpty(k);if(A instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(k,A);if(A instanceof M.SerializableObjectWithBuffers){const{jsonString:w,referencedBuffers:z}=d(A.value,x,!0);return this._serializeReplyOKJSONWithBuffers(k,w,z)}else return this._serializeReplyOKJSON(k,l(A,x))}static _serializeReplyOKEmpty(k){return s.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,A){let x=0;x+=s.sizeVSBuffer(A);let w=s.alloc(8,k,x);return w.writeVSBuffer(A),w.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,A){const x=I.VSBuffer.fromString(A);let w=0;w+=s.sizeLongString(x);let z=s.alloc(9,k,w);return z.writeLongString(x),z.buffer}static _serializeReplyOKJSONWithBuffers(k,A,x){const w=I.VSBuffer.fromString(A);let z=0;z+=s.sizeUInt32,z+=s.sizeLongString(w);for(const H of x)z+=s.sizeVSBuffer(H);let q=s.alloc(10,k,z);q.writeUInt32(x.length),q.writeLongString(w);for(const H of x)q.writeBuffer(H);return q.buffer}static deserializeReplyOKJSON(k){const A=k.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(k,A){const x=k.readUInt32(),w=k.readLongString(),z=[];for(let q=0;q<x;++q)z.push(k.readVSBuffer());return new M.SerializableObjectWithBuffers(S(w,z,A))}static serializeReplyErr(k,A){return A?this._serializeReplyErrEror(k,A):this._serializeReplyErrEmpty(k)}static _serializeReplyErrEror(k,A){const x=I.VSBuffer.fromString(l(B.transformErrorForSerialization(A),null));let w=0;w+=s.sizeLongString(x);let z=s.alloc(11,k,w);return z.writeLongString(x),z.buffer}static deserializeReplyErrError(k){const A=k.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(k){return s.alloc(12,k,0).buffer}}var v;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var h;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(h||(h={}))}),define(ve[211],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(B){const y=T=>{self.removeEventListener("message",y);const C=T.data;Object.defineProperties(self,{postMessage:{value(R,M){C.postMessage(R,M)}},onmessage:{get(){return C.onmessage},set(R){C.onmessage=R}}}),C.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(B)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(B,y,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${o})('${y}'))`,R=new Blob([C],{type:"application/javascript"}),M=URL.createObjectURL(R),b=new MessageChannel,l=M,g={type:"_newWorker",id:l,port:b.port2,url:M,options:T};B(g,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:l};b.port1.postMessage(a),URL.revokeObjectURL(M),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(a){b.port1.onmessage=a}},onmessageerror:{get(){return b.port1.onmessageerror},set(a){b.port1.onmessageerror=a}}}),b.port1.addEventListener("messageerror",a=>{const n=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(n)}),b.port1.addEventListener("message",a=>{const n=new MessageEvent("message",{data:a.data});this.dispatchEvent(n)}),b.port1.start()}}e.NestedWorker=I}),define(ve[212],Ee([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ve[213],Ee([1,0,35,9,17,23,24,2,3,148,47,172,212]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let g=class ji{constructor(n,d,S,N){this.localUserHome=n,this.remoteAgentService=d,this.environmentService=S,this.contextService=N,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||B.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome||n})()}hasValidBasename(n,d,S){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(N=>this.doHasValidBasename(n,N,d)):this.doHasValidBasename(n,d,S)}doHasValidBasename(n,d,S){return n.scheme===I.Schemas.file||n.scheme===I.Schemas.vscodeRemote?(0,o.isValidBasename)(S??(0,y.basename)(n),d===1):!0}get defaultUriScheme(){return ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,d){if(n.remoteAuthority)return I.Schemas.vscodeRemote;const S=(0,R.getVirtualWorkspaceScheme)(d.getWorkspace());if(S)return S;const N=d.getWorkspace().folders[0];if(N)return N.uri.scheme;const f=d.getWorkspace().configuration;return f?f.scheme:I.Schemas.file}async userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?_.win32:_.posix)}async fileURI(n){let d="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const N=n.indexOf("/",2);N===-1?(d=n.substring(2),n="/"):(d=n.substring(2,N),n=n.substring(N)||"/")}return T.URI.from({scheme:I.Schemas.file,authority:d,path:n,query:"",fragment:""})}};g=Fe([Ne(1,l.IRemoteAgentService),Ne(2,b.IWorkbenchEnvironmentService),Ne(3,M.IWorkspaceContextService)],g),e.AbstractPathService=g}),define(ve[96],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(y,T){this.line=y,this.character=T}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,T){return new o(0,0)}with(y){return new o(0,0)}}e.Position=o;class I{constructor(y,T,C,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(y,T),this.end=new o(C,R)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var _;(function(B){B[B.Information=1]="Information",B[B.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],Ee([1,0,16,29,26,35,10,3,17,15,96,11]),function(J,e,o,I,_,B,y,T,C,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",g=" characters skipped \u27EB",a=(l.length+g.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var n;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function S(V){return!!V.preview}e.resultIsMatch=S;function N(V){return!!V.resource}e.isFileMatch=N;function f(V){return!!V.message}e.isProgressMessage=f;var m;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class E{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=E;class r{constructor(te,oe,ie){this.ranges=oe;const ue=Array.isArray(oe)?oe:[oe];if(ie&&ie.matchLines===1&&P(ue)){te=(0,y.getNLines)(te,ie.matchLines);let he="",Se=0,fe=0;const ne=Math.floor(ie.charsPerLine/5),me=[];for(const Ie of ue){const Ae=Math.max(Ie.startColumn-ne,0),Ue=Ie.startColumn+ie.charsPerLine;if(Ae>fe+ne+a){const Ge=l+(Ae-fe)+g;he+=Ge+te.slice(Ae,Ue),Se+=Ae-(fe+Ge.length)}else he+=te.slice(fe,Ue);me.push(new i(0,Ie.startColumn-Se,Ie.endColumn-Se)),fe=Ue}this.preview={text:he,matches:Array.isArray(this.ranges)?me:me[0]}}else{const he=Array.isArray(oe)?oe[0].startLineNumber:oe.startLineNumber;this.preview={text:te,matches:(0,o.mapArrayOrNot)(oe,Se=>new u(Se.startLineNumber-he,Se.startColumn,Se.endLineNumber-he,Se.endColumn))}}}}e.TextSearchMatch=r;function P(V){const te=V[0].startLineNumber;for(const oe of V)if(oe.startLineNumber!==te||oe.endLineNumber!==te)return!1;return!0}class u{constructor(te,oe,ie,ue){this.startLineNumber=te,this.startColumn=oe,this.endLineNumber=ie,this.endColumn=ue}}e.SearchRange=u;class i extends u{constructor(te,oe,ie){super(te,oe,te,ie)}}e.OneLineRange=i;var s;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function t(V,te=!0){const oe=V&&V.files&&V.files.exclude,ie=te&&V&&V.search&&V.search.exclude;if(!oe&&!ie)return;if(!oe||!ie)return oe||ie;let ue=Object.create(null);return ue=_.mixin(ue,_.deepClone(oe)),ue=_.mixin(ue,_.deepClone(ie),!0),ue}e.getExcludes=t;function c(V,te){return V.excludePattern&&I.match(V.excludePattern,te)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&I.match(V.includePattern,te)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(oe=>{const ie=oe.folder.fsPath;if(B.isEqualOrParent(te,ie)){const ue=C.relative(ie,te);return!oe.includePattern||!!I.match(oe.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(te,oe){super(te);this.code=oe}}e.SearchError=h;function p(V){const te=V.message;if((0,R.isCancellationError)(V))return new h(te,v.canceled);try{const oe=JSON.parse(te);return new h(oe.message,oe.code)}catch{return new h(te,v.other)}}e.deserializeSearchError=p;function k(V){const te={message:V.message,code:V.code};return new Error(JSON.stringify(te))}e.serializeSearchError=k;function A(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=A;function x(V){return V.type==="success"}e.isSerializedSearchSuccess=x;function w(V){return!!V.path}e.isSerializedFileMatch=w;function z(V,te){const oe=V.searchPath?V.searchPath:V.relativePath;return(0,y.fuzzyContains)(oe,te)}e.isFilePatternMatch=z;class q{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=q;function H(V,te){const oe={...V||{},...te||{}};return Object.keys(oe).filter(ie=>{const ue=oe[ie];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=H;class W{constructor(te,oe){this._parsedIncludeExpression=null,this._excludeExpression={...te.excludePattern||{},...oe.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let ie=te.includePattern;oe.includePattern&&(ie?ie={...ie,...oe.includePattern}:ie=oe.includePattern),ie&&(this._parsedIncludeExpression=I.parse(ie))}matchesExcludesSync(te,oe,ie){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,oe,ie))}includedInQuerySync(te,oe,ie){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,oe,ie)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(te,oe,ie))}includedInQuery(te,oe,ie){const ue=this._parsedExcludeExpression(te,oe,ie),he=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(te,oe,ie):!0;return(0,b.isThenable)(ue)?ue.then(Se=>Se?!1:he()):he()}hasSiblingExcludeClauses(){return Q(this._excludeExpression)}}e.QueryGlobTester=W;function Q(V){for(const te in V)if(typeof V[te]!="boolean")return!0;return!1}}),define(ve[31],Ee([1,0,16,11,20,5,22,9,102,24,10,13,2,128,3,12,140,47,30,28,14,8,7,41,4]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m,E,r,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,x,w){return new R.ExtUri(z=>v(z,w)).isEqual(A,x)}function s(A,x,w){return i(A.uri,x.uri,w)?0:(0,M.compare)(A.uri.toString(),x.uri.toString())}function t(A,x,w){return A.index!==x.index?A.index<x.index?-1:1:i(A.uri,x.uri,w)?(0,M.compare)(A.name,x.name):(0,M.compare)(A.uri.toString(),x.uri.toString())}function c(A,x,w,z){const q=A.slice(0).sort((W,Q)=>w(W,Q,z)),H=x.slice(0).sort((W,Q)=>w(W,Q,z));return(0,o.delta)(q,H,(W,Q)=>w(W,Q,z))}function v(A,x){const w=x.getCapabilities(A.scheme);return!(w&&w&1024)}class h extends S.Workspace{constructor(x,w,z,q,H,W,Q){super(x,z.map(V=>new S.WorkspaceFolder(V)),q,H,Q);this._name=w,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(Q),z.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(x,w,z,q){if(!x)return{workspace:null,added:[],removed:[]};const{id:H,name:W,folders:Q,configuration:V,transient:te,isUntitled:oe}=x,ie=[],ue=w;w?Q.forEach((ne,me)=>{const Ie=l.URI.revive(ne.uri),Ae=h._findFolder(z||w,Ie,q);Ae?(Ae.name=ne.name,Ae.index=ne.index,ie.push(Ae)):ie.push({uri:Ie,name:ne.name,index:me})}):ie.push(...Q.map(({uri:ne,name:me,index:Ie})=>({uri:l.URI.revive(ne),name:me,index:Ie}))),ie.sort((ne,me)=>ne.index<me.index?-1:1);const he=new h(H,W,ie,!!te,V?l.URI.revive(V):null,!!oe,ne=>v(ne,q)),{added:Se,removed:fe}=c(ue?ue.workspaceFolders:[],he.workspaceFolders,s,q);return{workspace:he,added:Se,removed:fe}}static _findFolder(x,w,z){for(let q=0;q<x.folders.length;q++){const H=x.workspaceFolders[q];if(i(H.uri,w,z))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,w){return w&&this._structure.get(x)&&(x=(0,R.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let p=class{constructor(x,w,z,q){this._onDidChangeWorkspace=new B.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new B.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=z,this._requestIdProvider=new C.Counter,this._barrier=new I.Barrier,this._proxy=x.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(u.MainContext.MainThreadMessageService);const H=w.workspace;this._confirmedWorkspace=H?new h(H.id,H.name,[],!!H.transient,H.configuration?l.URI.revive(H.configuration):null,!!H.isUntitled,W=>v(W,z)):void 0}$initializeWorkspace(x,w){this._trusted=w,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:T.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,w,z,...q){const H=[];if(Array.isArray(q)&&q.forEach(oe=>{l.URI.isUri(oe.uri)&&!H.some(ie=>i(ie.uri,oe.uri,this._extHostFileSystemInfo))&&H.push({uri:oe.uri,name:oe.name||(0,R.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[w,z].some(oe=>typeof oe!="number"||oe<0)||z===0&&H.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(w+z>W.length)return!1;const Q=W.slice(0);Q.splice(w,z,...H.map(oe=>({uri:oe.uri,name:oe.name||(0,R.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<Q.length;oe++){const ie=Q[oe];if(Q.some((ue,he)=>he!==oe&&i(ie.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((oe,ie)=>oe.index=ie);const{added:V,removed:te}=c(W,Q,t,this._extHostFileSystemInfo);if(V.length===0&&te.length===0)return!1;if(this._proxy){const oe=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(oe,w,z,H).then(void 0,ie=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(d.Severity.Error,(0,g.localize)(0,null,oe,ie.toString()),ue,[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(x,w){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,w)}async getWorkspaceFolder2(x,w){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,w)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,w){let z,q="";if(typeof x=="string"?(z=l.URI.file(x),q=x):typeof x!="undefined"&&(z=x,q=x.fsPath),!z)return q;const H=this.getWorkspaceFolder(z,!0);if(!H)return q;typeof w=="undefined"&&this._actualWorkspace&&(w=this._actualWorkspace.folders.length>1);let W=(0,R.relativePath)(H.uri,z);return w&&H.name&&(W=`${H.name}/${W}`),W}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:w,added:z,removed:q}=h.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=w||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:q}))}findFiles(x,w,z,q,H=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let W;if(w===null?W=!1:w&&(typeof w=="string"?W=w:W=w.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:V}=k(E.GlobPattern.from(x));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(Q),(0,b.withUndefinedAsNull)(V),(0,b.withUndefinedAsNull)(W),(0,b.withUndefinedAsNull)(z),H).then(te=>Array.isArray(te)?te.map(oe=>l.URI.revive(oe)):[])}async findTextInFiles(x,w,z,q,H=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),Q=typeof w.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:w.previewOptions,{includePattern:V,folder:te}=k(E.GlobPattern.from(w.include)),oe=typeof w.exclude=="string"?w.exclude:w.exclude?w.exclude.pattern:void 0,ie={ignoreSymlinks:typeof w.followSymlinks=="boolean"?!w.followSymlinks:void 0,disregardIgnoreFiles:typeof w.useIgnoreFiles=="boolean"?!w.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof w.useGlobalIgnoreFiles=="boolean"?!w.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof w.useParentIgnoreFiles=="boolean"?!w.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof w.useDefaultExcludes=="boolean"?!w.useDefaultExcludes:!0,fileEncoding:w.encoding,maxResults:w.maxResults,previewOptions:Q,afterContext:w.afterContext,beforeContext:w.beforeContext,includePattern:V,excludePattern:oe},ue=!1;if(this._activeSearchCallbacks[W]=he=>{if(ue)return;const Se=l.URI.revive(he.resource);he.results.forEach(fe=>{(0,P.resultIsMatch)(fe)?z({uri:Se,preview:{text:fe.preview.text,matches:(0,o.mapArrayOrNot)(fe.preview.matches,ne=>new r.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,o.mapArrayOrNot)(fe.ranges,ne=>new r.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):z({uri:Se,text:fe.text,lineNumber:fe.lineNumber})})},H.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(x,(0,b.withUndefinedAsNull)(te),ie,W,H);return delete this._activeSearchCallbacks[W],he||{}}catch(he){throw delete this._activeSearchCallbacks[W],he}}$handleTextSearchResult(x,w){this._activeSearchCallbacks[w]&&this._activeSearchCallbacks[w](x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};p=Fe([Ne(0,m.IExtHostRpcService),Ne(1,f.IExtHostInitDataService),Ne(2,N.IExtHostFileSystemInfo),Ne(3,n.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function k(A){let x,w;return A&&(typeof A=="string"?x=A:(x=A.pattern,w=l.URI.revive(A.baseUri))),{includePattern:x,folder:w}}}),define(ve[32],Ee([1,0,26,5,31,4,7,143,80,13,11,3,14,12,2]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(P,u){if(u){const i=u.split(".");let s=P;for(let t=0;s&&t<i.length;t++)s=s[i[t]];return s}}function d(P){return P instanceof a.URI}function S(P){return P&&P.uri instanceof a.URI&&P.languageId&&typeof P.languageId=="string"}function N(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function f(P){return P&&P.uri instanceof a.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function m(P){if(d(P))return{resource:P};if(S(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(N(P))return{overrideIdentifier:P.languageId};if(f(P))return{resource:P.uri};if(P===null)return{resource:null}}let E=class{constructor(u,i,s){this._proxy=u.getProxy(B.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new M.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new r(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,i))}};E=Fe([Ne(0,l.IExtHostRpcService),Ne(1,_.IExtHostWorkspace),Ne(2,g.ILogService)],E),e.ExtHostConfiguration=E;class r{constructor(u,i,s,t){this._onDidChangeConfiguration=new I.Emitter,this._proxy=u,this._logService=t,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(u,i,s){const t=m(i)||{},c=this._toReadonlyValue(u?n(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,t,s?.identifier);function v(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(p){return typeof n(c,p)!="undefined"},get:(p,k)=>{this._validateConfigurationAccess(u?`${u}.${p}`:p,t,s?.identifier);let A=n(c,p);if(typeof A=="undefined")A=k;else{let x;const w=(z,q)=>{let H;const W=()=>{x=x||(0,o.deepClone)(c),H=H||n(x,q)};return(0,R.isObject)(z)?new Proxy(z,{get:(Q,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return W(),()=>H;if(x)return H=H||n(x,q),H[V];const te=Q[V];return typeof V=="string"?w(te,`${q}.${V}`):te},set:(Q,V,te)=>(W(),H&&(H[V]=te),!0),deleteProperty:(Q,V)=>(W(),H&&delete H[V],!0),defineProperty:(Q,V,te)=>(W(),H&&Object.defineProperty(H,V,te),!0)}):z};A=w(A,p)}return A},update:(p,k,A,x)=>{p=u?`${u}.${p}`:p;const w=v(A);return k!==void 0?this._proxy.$updateConfigurationOption(w,p,k,t,x):this._proxy.$removeConfigurationOption(w,p,t,x)},inspect:p=>{p=u?`${u}.${p}`:p;const k=(0,o.deepClone)(this._configuration.inspect(p,t,this._extHostWorkspace.workspace));if(k)return{key:p,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof c=="object"&&(0,o.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(u){const i=s=>(0,R.isObject)(s)?new Proxy(s,{get:(t,c)=>i(t[c]),set:(t,c,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(u)}_validateConfigurationAccess(u,i,s){const t=C.OVERRIDE_PROPERTY_REGEX.test(u)?4:this._configurationScopes.get(u),c=s?`[${s.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,i){const s=new T.ConfigurationChangeEvent(u,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>s.affectsConfiguration(t,m(c))})}_toMap(u){return u.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[97],Ee([1,0,2,11,5,4,7,31,49,32,20,40,14,28,3,9,23,12,65,164,15]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(q){function H(Q){if(Q!=null)return Q}q.from=H;function W(Q){if(Q!=null)return Q}q.to=W})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(q){function H(Q){if(Q!=null)return Q}q.from=H;function W(Q){if(Q!=null)return Q}q.to=W})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(q){function H(Q){if(Q!=null)return Q}q.from=H;function W(Q){if(Q!=null)return Q}q.to=W})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(q){function H(V){if(V){const te=V;return te&&!!te.process}else return!1}q.is=H;function W(V){if(V==null)return;const te={process:V.process,args:V.args};return V.options&&(te.options=u.from(V.options)),te}q.from=W;function Q(V){if(V!=null)return new y.ProcessExecution(V.process,V.args,V.options)}q.to=Q})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(q){function H(Q){if(Q!=null)return Q}q.from=H;function W(Q){if(Q!=null)return Q}q.to=W})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(q){function H(V){if(V){const te=V;return te&&(!!te.commandLine||!!te.command)}else return!1}q.is=H;function W(V){if(V==null)return;const te={};return V.commandLine!==void 0?te.commandLine=V.commandLine:(te.command=V.command,te.args=V.args),V.options&&(te.options=s.from(V.options)),te}q.from=W;function Q(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new y.ShellExecution(V.commandLine,V.options):new y.ShellExecution(V.command,V.args?V.args:[],V.options)}q.to=Q})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(q){function H(V){if(V){let te=V;return te&&te.customExecution==="customExecution"}else return!1}q.is=H;function W(V){return{customExecution:"customExecution"}}q.from=W;function Q(V,te){return te.get(V)}q.to=Q})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(q){function H(W,Q){let V;return W.scope!==void 0&&typeof W.scope!="number"?V=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===y.TaskScope.Workspace&&Q&&Q.workspaceFile?V=Q.workspaceFile:V=f.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:V}}q.from=H})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(q){function H(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}q.from=H})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(q){function H(V,te){if(V==null)return[];const oe=[];for(let ie of V){const ue=W(ie,te);ue&&oe.push(ue)}return oe}q.fromMany=H;function W(V,te){if(V==null)return;let oe;V.execution instanceof y.ProcessExecution?oe=i.from(V.execution):V.execution instanceof y.ShellExecution?oe=t.from(V.execution):V.execution&&V.execution instanceof y.CustomExecution&&(oe=c.from(V.execution));const ie=r.from(V.definition);let ue;return V.scope?typeof V.scope=="number"?ue=V.scope:ue=V.scope.uri:ue=y.TaskScope.Workspace,!ie||!ue?void 0:{_id:V._id,definition:ie,name:V.name,source:{extensionId:te.identifier.value,label:V.source,scope:ue},execution:oe,isBackground:V.isBackground,group:h.from(V.group),presentationOptions:P.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}q.from=W;async function Q(V,te,oe){if(V==null)return;let ie;i.is(V.execution)?ie=i.to(V.execution):t.is(V.execution)?ie=t.to(V.execution):c.is(V.execution)&&(ie=c.to(V._id,oe));const ue=r.to(V.definition);let he;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?he=V.source.scope:he=await te.resolveWorkspaceFolder(o.URI.revive(V.source.scope)):he=y.TaskScope.Workspace),!ue||!he)return;const Se=new y.Task(ue,he,V.name,V.source.label,ie,V.problemMatchers);return V.isBackground!==void 0&&(Se.isBackground=V.isBackground),V.group!==void 0&&(Se.group=y.TaskGroup.from(V.group._id),Se.group&&V.group.isDefault&&(Se.group=new y.TaskGroup(Se.group.id,Se.group.label),V.group.isDefault&&(Se.group.isDefault=V.group.isDefault))),V.presentationOptions&&(Se.presentationOptions=P.to(V.presentationOptions)),V._id&&(Se._id=V._id),V.detail&&(Se.detail=V.detail),Se}q.to=Q})(p=e.TaskDTO||(e.TaskDTO={}));var k;(function(q){function H(Q){return Q}q.from=H;function W(Q){if(!!Q)return Object.assign(Object.create(null),Q)}q.to=W})(k=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(H,W,Q){this._id=W,this._task=Q,E.set(this,void 0),je(this,E,H,"f")}get task(){return this._task}terminate(){De(this,E,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}E=new WeakMap;var x;(function(q){function H(W){return{id:W._id,task:void 0}}q.from=H})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let w=class{constructor(H,W,Q,V,te,oe,ie,ue){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=H.getProxy(B.MainContext.MainThreadTask),this._workspaceProvider=Q,this._editorService=V,this._configurationService=te,this._terminalService=oe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ie,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,W,Q){if(!Q)return new y.Disposable(()=>{});const V=this.nextHandle();return this._handlers.set(V,{type:W,provider:Q,extension:H}),this._proxy.$registerTaskProvider(V,W),new y.Disposable(()=>{this._handlers.delete(V),this._proxy.$unregisterTaskProvider(V)})}registerTaskSystem(H,W){this._proxy.$registerTaskSystem(H,W)}fetchTasks(H){return this._proxy.$fetchTasks(k.from(H)).then(async W=>{const Q=[];for(let V of W){const te=await p.to(V,this._workspaceProvider,this._providedCustomExecutions2);te&&Q.push(te)}return Q})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(W=>H.push(W)),H}terminateTask(H){if(!(H instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,W,Q){const V=this._providedCustomExecutions2.get(H.id);V&&(this._activeCustomExecutions2.set(H.id,V),this._terminalService.attachPtyToTerminal(W,await V.callback(Q))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const W=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const W=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:W,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const W=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:H.exitCode})}$provideTasks(H,W){const Q=this._handlers.get(H);if(!Q)return Promise.reject(new Error("no handler found"));const V=[],te=(0,I.asPromise)(()=>Q.provider.provideTasks(M.CancellationToken.None)).then(oe=>this.provideTasksInternal(W,V,Q,oe));return new Promise(oe=>{te.then(ie=>{Promise.all(V).then(()=>{oe(ie)})})})}async $resolveTask(H,W){const Q=this._handlers.get(H);if(!Q)return Promise.reject(new Error("no handler found"));if(W.definition.type!==Q.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${Q.type}].`);const V=await p.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const te=await Q.provider.resolveTask(V,M.CancellationToken.None);if(!te)return;this.checkDeprecation(te,Q);const oe=p.from(te,Q.extension);if(!oe)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(oe.execution)&&await this.addCustomExecution(oe,te,!0),await this.resolveTaskInternal(oe)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,W,Q){const V=await this._proxy.$createTaskId(H);!Q&&!this._providedCustomExecutions2.has(V)&&(this._notProvidedCustomExecutions.add(V),this._activeCustomExecutions2.set(V,W.execution)),this._providedCustomExecutions2.set(V,W.execution)}async getTaskExecution(H,W){if(typeof H=="string"){const te=this._taskExecutionPromises.get(H);if(!te)throw new Error("Unexpected: The specified task is missing an execution");return te}let Q=this._taskExecutionPromises.get(H.id);if(Q)return Q;const V=new Promise((te,oe)=>{function ie(ue,he,Se){Se?te(new A(ue,he.id,Se)):oe("Unexpected: Task does not exist.")}W?ie(this,H,W):p.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>ie(this,H,ue))});return this._taskExecutionPromises.set(H.id,V),V.then(te=>(this._taskExecutions.set(H.id,te),te),te=>Promise.reject(te))}checkDeprecation(H,W){H._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let Q=this._notProvidedCustomExecutions.values(),V=Q.next();for(;!V.done;)!this._activeCustomExecutions2.has(V.value)&&this._lastStartedTask!==V.value&&(this._providedCustomExecutions2.delete(V.value),this._notProvidedCustomExecutions.delete(V.value)),V=Q.next()}};w=Fe([Ne(0,l.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,T.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,N.IExtHostApiDeprecationService)],w),e.ExtHostTaskBase=w;let z=class extends w{constructor(H,W,Q,V,te,oe,ie,ue){super(H,W,Q,V,te,oe,ie,ue);this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(H,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const Q=p.from(W,H);if(Q===void 0)throw new Error("Task is not valid");if(c.is(Q.execution))await this.addCustomExecution(Q,W,!1);else throw new m.NotSupportedError;const V=await this.getTaskExecution(await this._proxy.$getTaskExecution(Q),W);return this._proxy.$executeTask(Q).catch(te=>{throw new Error(te)}),V}provideTasksInternal(H,W,Q,V){const te=[];if(V)for(let oe of V){this.checkDeprecation(oe,Q),(!oe.definition||!H[oe.definition.type])&&this._logService.warn(`The task [${oe.source}, ${oe.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=p.from(oe,Q.extension);ie&&c.is(ie.execution)?(te.push(ie),W.push(this.addCustomExecution(ie,oe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:te,extension:Q.extension}}async resolveTaskInternal(H){if(c.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,W,Q){}};z=Fe([Ne(0,l.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,T.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,N.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(ve[214],Ee([1,0,17,20,43,29,24,191,41]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(l,g,a){this.config=l,this.provider=g,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&B.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&B.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const g=this.config.folderQueries||[];return new Promise((a,n)=>{const d=S=>{this.resultCount++,l(S)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const N=S.toString(),f=o.basename(N);this.globalExcludePattern&&this.globalExcludePattern(N,f)||this.matchFile(d,{base:S,basename:f})}),Promise.all(g.map(S=>this.searchInFolder(S,d))).then(S=>{a({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{n(new Error((0,_.toErrorMessage)(S)))})})}async searchInFolder(l,g){const a=new I.CancellationTokenSource,n=this.getSearchOptionsForFolder(l),d=this.initDirectoryTree(),S=new C.QueryGlobTester(this.config,l),N=!S.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(a),f=T.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,a.token),E=f.elapsed(),r=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(P=>{const u=o.posix.relative(l.folder.path,P.path);if(N){const i=o.basename(P.path);this.matchFile(g,{base:l.folder,relativePath:u,basename:i});return}this.addDirectoryEntries(d,l.folder,u,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,S,g),{providerTime:E,postProcessTime:r.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(l){const g=(0,C.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),a=(0,C.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:a,includes:g,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},g,a,n){if(a===this.filePattern){const S=o.basename(this.filePattern);this.matchFile(n,{base:g,relativePath:this.filePattern,basename:S})}function d(S){const N=o.basename(S),f=o.dirname(S);let m=l[f];m||(m=l[f]=[],d(f)),m.push({base:g,relativePath:S,basename:N})}d(a)}matchDirectoryTree({rootEntries:l,pathToEntries:g},a,n){const d=this,S=this.filePattern;function N(f){const m=B.hasSiblingFn(()=>f.map(E=>E.basename));for(let E=0,r=f.length;E<r;E++){const P=f[E],{relativePath:u,basename:i}=P;if(a.matchesExcludesSync(u,i,S!==i?m:void 0))continue;const s=g[u];if(s)N(s);else{if(u===S)continue;d.matchFile(n,P)}if(d.isLimitHit)break}}N(l)}matchFile(l,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(g))}}class M{constructor(){this.sessions=new Map}fileSearch(l,g,a,n){const d=this.getSessionTokenSource(l.cacheKey),S=new R(l,g,d&&d.token);let N=0;const f=m=>{N+=m.length,a(m.map(E=>this.rawMatchToSearchItem(E)))};return this.doSearch(S,M.BATCH_SIZE,f,n).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:N,detailStats:m.stats}}))}clearCache(l){const g=this.getSessionTokenSource(l);g&&g.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new I.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:y.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,g,a,n){n.onCancellationRequested(()=>{l.cancel()});const d=N=>{N&&(S.push(N),g>0&&S.length>=g&&(a(S),S=[]))};let S=[];return l.search(d).then(N=>(S.length&&a(S),N),N=>(S.length&&a(S),Promise.reject(N)))}}e.FileSearchManager=M,M.BATCH_SIZE=512}),define(ve[215],Ee([1,0,16,70,29,73,22,9,17,24,10,13,2,234,134,77,12,47,87,213,41]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let E=class{constructor(h,p,k,A,x){this.configurationService=h,this.workspaceContextService=p,this.editorGroupsService=k,this.logService=A,this.pathService=x}text(h,p,k={}){h=this.getContentPattern(h,k);const A=this.configurationService.getValue(),x=p&&p.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(p?.map(S.toWorkspaceFolder),k),type:2,contentPattern:h,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:A.search.usePCRE2||x||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}getContentPattern(h,p){const k=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const A={...h,wordSeparators:k.editor.wordSeparators};return this.isCaseSensitive(h,p)&&(A.isCaseSensitive=!0),this.isMultiline(h)&&(A.isMultiline=!0),A}file(h,p={}){return{...this.commonQuery(h,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}handleIncludeExclude(h,p){return h?(h=Array.isArray(h)?h.map(s):s(h),p?this.parseSearchPaths(h):{pattern:P(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],p={}){const k=this.handleIncludeExclude(p.includePattern,p.expandPatterns),A=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),x=h.length>1,w=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,p,A)):h.map(H=>this.getFolderQueryForRoot(H,p,A,x))).filter(H=>!!H),z={_reason:p._reason,folderQueries:w,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:A.pattern,includePattern:k.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const H=o.coalesce(o.flatten(this.editorGroupsService.groups.map(V=>V.editors.map(te=>te.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const W=H.filter(V=>(0,m.pathIncludedInQuery)(z,V.fsPath)),Q=this.commonQueryFromFileList(W);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...z,...Q}}const q=p.extraFileResources&&p.extraFileResources.filter(H=>(0,m.pathIncludedInQuery)(z,H.fsPath));return z.extraFileResources=q&&q.length?q:void 0,z}commonQueryFromFileList(h){const p=[],k=new y.ResourceMap,A={};let x=!1;return h.forEach(w=>{if(w.scheme===T.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(w)){const q=this.workspaceContextService.getWorkspaceFolder(w)?.uri??w.with({path:C.dirname(w.fsPath)});let H=k.get(q);H||(x=!0,H={folder:q,includePattern:{}},p.push(H),k.set(q,H));const W=C.relative(q.fsPath,w.fsPath);(0,b.assertIsDefined)(H.includePattern)[W.replace(/\\/g,"/")]=!0}else w.fsPath&&(x=!0,A[w.fsPath]=!0)}),{folderQueries:p,includePattern:A,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(h,p){if(p.isSmartCase){if(h.isRegExp){if(M.containsUppercaseCharacter(h.pattern,!0))return!0}else if(M.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,g.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const p=Q=>C.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),A=(Array.isArray(h)?h:u(h)).map(Q=>{const V=this.pathService.resolvedUserHome;return V?(0,B.untildify)(Q,V.scheme===T.Schemas.file?V.fsPath:V.path):Q}),x=I.groupBy(A,Q=>p(Q)?"searchPaths":"exprSegments"),w=(x.exprSegments||[]).map(Q=>M.rtrim(Q,"/")).map(Q=>M.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),i(Q))),z={},q=this.expandSearchPathPatterns(x.searchPaths||[]);q&&q.length&&(z.searchPaths=q);const H=o.flatten(w),W=P(...H);return W&&(z.pattern=W),z}getExcludesForFolder(h,p){return p.disregardExcludeSettings?void 0:(0,m.getExcludes)(h,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const p=o.flatten(h.map(A=>{let{pathPortion:x,globPortion:w}=r(A);w&&(w=t(w));const z=this.expandOneSearchPath(x);return o.flatten(z.map(q=>this.resolveOneSearchPathPattern(q,w)))})),k=new Map;return p.forEach(A=>{const x=A.searchPath.toString(),w=k.get(x);w?A.pattern&&(w.pattern=w.pattern||{},w.pattern[A.pattern]=!0):k.set(x,{searchPath:A.searchPath,pattern:A.pattern?P(A.pattern):void 0})}),Array.from(k.values())}expandOneSearchPath(h){if(C.isAbsolute(h)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==T.Schemas.file?[{searchPath:p[0].uri.with({path:h})}]:[{searchPath:l.URI.file(C.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=s(h),h.startsWith("../")||h===".."){const A=C.posix.resolve(p.path,h);return[{searchPath:p.with({path:A})}]}const k=t(h);return[{searchPath:p,pattern:k}]}else{if(h==="./"||h===".\\")return[];{const p=h.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(x=>{const w=p.match(new RegExp(`^${M.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return w?{match:w,folder:x}:null}).filter(b.isDefined);if(A.length)return A.map(x=>{const w=x.match[1];return{searchPath:x.folder.uri,pattern:w&&t(w)}});{const x=h.match(/\.[\/\\](.+)[\/\\]?/),w=x?x[1]:h,z=a.localize(0,null,w);throw new Error(z)}}}}resolveOneSearchPathPattern(h,p){const k=h.pattern&&p?`${h.pattern}/${p}`:h.pattern||p,A=[{searchPath:h.searchPath,pattern:k}];return k&&!k.endsWith("**")&&A.push({searchPath:h.searchPath,pattern:k+"/**"}),A}getFolderQueryForSearchPath(h,p,k){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(h.searchPath),p,k,!1);return A?{...A,includePattern:h.pattern}:null}getFolderQueryForRoot(h,p,k,A){let x;const w=l.URI.isUri(h)?h:h.uri;if(k.searchPaths){const Q=k.searchPaths.filter(V=>(0,R.isEqual)(V.searchPath,w))[0];if(Q&&!Q.pattern)return null;Q&&(x=Q.pattern)}const z=this.configurationService.getValue({resource:w}),H={...this.getExcludesForFolder(z,p)||{},...x||{}},W=l.URI.isUri(h)?(0,R.basename)(h):h.name;return{folder:w,folderName:A?W:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!z.search.followSymlinks}}};E=Fe([Ne(0,n.IConfigurationService),Ne(1,S.IWorkspaceContextService),Ne(2,N.IEditorGroupsService),Ne(3,d.ILogService),Ne(4,f.IPathService)],E),e.QueryBuilder=E;function r(v){const h=v.match(/[\*\{\}\(\)\[\]\?]/);if(h){const p=h.index,k=v.substr(0,p).match(/[/|\\][^/\\]*$/);if(k){let A=v.substr(0,k.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:v.substr((k.index||0)+1)}}}return{pathPortion:v}}function P(...v){return v.length?v.reduce((h,p)=>(h[p]=!0,h),Object.create(null)):void 0}function u(v){return _.splitGlobAware(v,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(v){return[`**/${v}/**`,`**/${v}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function s(v){return v.replace(/\\/g,"/")}function t(v){return s(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(v,h){v=o.distinct(v,A=>A.toString());const p=[],k=h.getWorkspace();return v&&v.forEach(A=>{let x;if(h.getWorkbenchState()===2)x=(0,R.relativePath)(k.folders[0].uri,A),x&&x!=="."&&(x="./"+x);else{const w=h.getWorkspaceFolder(A);if(w){const z=w.name;if(k.folders.filter(H=>H.name===z).length===1){const H=(0,R.relativePath)(w.uri,A);H===""?x=`./${w.name}`:x=`./${w.name}/${H}`}else x=A.fsPath}}x&&p.push(x)}),p}e.resolveResourcesForSearchIncludes=c}),define(ve[216],Ee([1,0,24,2,20,15,3,215,41,47]),function(J,e,o,I,_,B,y,T,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function b(n,d){const S=d.activationEvents;if(!S)return Promise.resolve(void 0);const N=[],f=[];for(const i of S)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||n.forceUsingSearch?f.push(s):N.push(s)}if(N.length===0&&f.length===0)return Promise.resolve(void 0);let m;const E=new Promise((i,s)=>{m=i}),r=i=>m({activationEvent:i}),P=Promise.all(N.map(i=>l(n,i,r))).then(()=>{}),u=g(n,d.identifier,f,r);return Promise.all([P,u]).then(()=>{m(void 0)}),E}e.checkActivateWorkspaceContainsExtension=b;async function l(n,d,S){for(const N of n.folders)if(await n.exists(o.joinPath(I.URI.revive(N),d))){S(`workspaceContains:${d}`);return}}async function g(n,d,S,N){if(S.length===0)return Promise.resolve(void 0);const f=new _.CancellationTokenSource,m=n.checkExists(n.folders,S,f.token),E=setTimeout(async()=>{f.cancel(),n.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},M);let r=!1;try{r=await m}catch(P){B.isCancellationError(P)||B.onUnexpectedError(P)}f.dispose(),clearTimeout(E),r&&N(`workspaceContains:${S.join(",")}`)}function a(n,d,S,N){const f=n.get(y.IInstantiationService),m=n.get(C.ISearchService),r=f.createInstance(T.QueryBuilder).file(d.map(P=>(0,R.toWorkspaceFolder)(I.URI.revive(P))),{_reason:"checkExists",includePattern:S,exists:!0});return m.fileSearch(r,N).then(P=>!!P.limitHit,P=>B.isCancellationError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=a});var je=this&&this.__classPrivateFieldSet||function(J,e,o,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(J,o):_?_.value=o:e.set(J,o),o},De=this&&this.__classPrivateFieldGet||function(J,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(J):I?I.value:e.get(J)};define(ve[33],Ee([1,0,123,17,69,24,11,6,22,2,12,4,32,174,67,31,27,173,15,25,21,149,7,81,3,28,68,14,55,58,40,5,216,64,151,9]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m,E,r,P,u,i,s,t,c,v,h,p,k,A,x,w){"use strict";var z,q,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let W=class qi extends T.Disposable{constructor(ie,ue,he,Se,fe,ne,me,Ie,Ae,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ue,this._extHostContext=he,this._initData=me,this._extHostWorkspace=Se,this._extHostConfiguration=fe,this._logService=ne,this._extHostTunnelService=Ae,this._extHostTerminalService=Ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=ie.createChild(new c.ServiceCollection([a.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Ge=new Set;this._initData.hostExtensions.forEach(ge=>Ge.add(f.ExtensionIdentifier.toKey(ge))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ge,de,L)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ge,N.transformErrorForSerialization(de),L)},actualActivateExtension:async(ge,de)=>{if(Ge.has(f.ExtensionIdentifier.toKey(ge)))return await this._mainThreadExtensionsProxy.$activateExtension(ge,de),new g.HostExtension;const L=this._registry.getExtensionDescription(ge);return this._activateExtension(L,de)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){N.onUnexpectedError(ie)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(ie)}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}_activateByEvent(ie,ue){return this._activator.activateByEvent(ie,ue)}_activateById(ie,ue){return this._activator.activateById(ie,ue)}activateByIdWithErrors(ie,ue){return this._activateById(ie,ue).then(()=>{const he=this._activator.getActivatedExtension(ie);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._registry)}getExtensionExports(ie){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ie).exports:null}async _realPathExtensionUri(ie){if(ie.scheme!==w.Schemas.file)return ie;const ue=await this._hostUtils.realpath(ie.fsPath);return R.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const ie=C.TernarySearchTree.forUris(ue=>B.extUriBiasedIgnorePathCase.ignorePathCasing(ue));for(const ue of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ue)){const he=await this._realPathExtensionUri(ue.extensionLocation);ie.set(he,ue)}return ie})()),this._extensionPathIndex}_deactivate(ie){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return ue;const he=this._activator.getActivatedExtension(ie);if(!he)return ue;try{typeof he.module.deactivate=="function"&&(ue=Promise.resolve(he.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(Se)}try{(0,T.dispose)(he.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(Se)}return ue}async _activateExtension(ie,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,ue).then(he=>{const Se=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,ue),this._logExtensionActivationTimes(ie,ue,"success",Se),he},he=>{throw this._logExtensionActivationTimes(ie,ue,"failure"),he})}_logExtensionActivationTimes(ie,ue,he,Se){const fe=Q(ie,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...Se||{},outcome:he})}_doActivateExtension(ie,ue){const he=Q(ie,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const Se=this._getEntryPoint(ie);if(!Se)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${ie.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const fe=new g.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(ie.identifier,(0,B.joinPath)(ie.extensionLocation,Se),fe),this._loadExtensionContext(ie)]).then(ne=>(_.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),qi._callActivate(this._logService,ie.identifier,ne[0],ne[1],fe))).then(ne=>(_.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ne))}_loadExtensionContext(ie){const ue=new E.ExtensionGlobalMemento(ie,this._storage),he=new E.ExtensionMemento(ie.identifier.value,!1,this._storage),Se=new x.ExtensionSecrets(ie,this._secretState),fe=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ne=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([ue.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let Ie,Ae;const Ue=(0,d.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:he,secrets:Se,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(Ge){return I.join(ie.extensionLocation.fsPath,Ge)},get storagePath(){return me._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(ie).fsPath},get logPath(){return I.join(me._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return R.URI.joinPath(me._initData.logsLocation,ie.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(ie)},get globalStorageUri(){return me._storagePath.globalValue(ie)},get extensionMode(){return fe},get extension(){return Ie===void 0&&(Ie=new V(me,ie.identifier,ie,ne)),Ie},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!Ae){if(!Ue)return;const Ge=p.Event.buffer(p.Event.fromDOMEventEmitter(Ue,"message",ge=>ge.data));Ue.start(),Ae={onDidReceiveMessage:Ge,postMessage:Ue.postMessage.bind(Ue)}}return Ae}})})}static _callActivate(ie,ue,he,Se,fe){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,ue,he,Se,fe).then(ne=>new g.ActivatedExtension(!1,null,fe.build(),he,ne,Se.subscriptions))}static _callActivateOptional(ie,ue,he,Se,fe){if(typeof he.activate=="function")try{fe.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const ne=typeof global=="object"?global:self,me=he.activate.apply(ne,[Se]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(me).then(Ie=>(fe.activateResolveStop(),Ie))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(he)}_activateOneStartupFinished(ie,ue){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:ue}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const ie of this._registry.getAllExtensionDescriptions())if(ie.activationEvents)for(const ue of ie.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(ie,ue)}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(ue),Se=Promise.all([ie,he]).then(()=>{});return Promise.race([Se,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(ie,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,ue){if(this.isActivated(ue.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:ie.map(ne=>ne.uri),forceUsingSearch:he,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,Ie)},fe=await(0,k.checkActivateWorkspaceContainsExtension)(Se,ue);if(!!fe)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:fe.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:ue}=this._initData.environment;if(!ie||!ue)throw new Error(o.localize(0,null));const he=await this._loadCommonJSModule(null,ue,new g.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(o.localize(1,null,ue.toString()));return new Promise((Se,fe)=>{const ne=(Ae,Ue)=>{Ae?fe(Ae):Se(typeof Ue=="number"&&Ue>0?1:0)},me=(0,B.originalFSPath)(ue),Ie=he.run(me,ne);Ie&&Ie.then&&Ie.then(()=>{Se(0)}).catch(Ae=>{fe(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}async $extensionTestsExit(ie){this._logService.info(`Extension host terminating: test runner requested exit with code ${ie}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ie}`),this._logService.flush(),this._hostUtils.exit(ie)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,ue){return this._resolvers[ie]=ue,(0,T.toDisposable)(()=>{delete this._resolvers[ie]})}async _activateAndGetResolver(ie){const ue=ie.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const he=ie.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(ie,ue){this._logService.info(`$resolveAuthority invoked for authority (${te(ie)})`);const{authorityPrefix:he,resolver:Se}=await this._activateAndGetResolver(ie);if(!Se)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${he}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Se)),_.mark(`code/extHost/willResolveAuthority/${he}`);const fe=await Se.resolve(ie,{resolveAttempt:ue});_.mark(`code/extHost/didResolveAuthorityOK/${he}`);const ne={authority:ie,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},me={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(_.mark(`code/extHost/didResolveAuthorityError/${he}`),fe instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(ie,ue){this._logService.info(`$getCanonicalURI invoked for authority (${te(ie)})`);const{authorityPrefix:he,resolver:Se}=await this._activateAndGetResolver(ie);if(!Se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${he}`);const fe=R.URI.revive(ue);if(typeof Se.getCanonicalURI=="undefined")return fe;const ne=await(0,y.asPromise)(()=>Se.getCanonicalURI(fe));return ne||fe}$startExtensionHost(ie){return this._registry.keepOnly(ie),this._startExtensionHost()}$activateByEvent(ie,ue){return ue===1?this._activateByEvent(ie,!1):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(ie,!1))}async $activate(ie,ue){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(ie)?(await this._activateById(ie,ue),!0):!1}async $deltaExtensions(ie,ue){ie.forEach(Se=>Se.extensionLocation=R.URI.revive(Se.extensionLocation));const he=await this.getExtensionPathIndex();return await Promise.all(ue.map(async Se=>{const fe=this._registry.getExtensionDescription(Se);fe&&he.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(ie.map(async Se=>{const fe=await this._realPathExtensionUri(Se.extensionLocation);he.set(fe,Se)})),this._registry.deltaExtensions(ie,ue),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){let ue=m.VSBuffer.alloc(ie),he=Math.random()%256;for(let Se=0;Se<ie;Se++)ue.writeUInt8(he,Se);return ue}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};W=Fe([Ne(0,u.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,t.IExtHostRpcService),Ne(3,n.IExtHostWorkspace),Ne(4,l.IExtHostConfiguration),Ne(5,M.ILogService),Ne(6,i.IExtHostInitDataService),Ne(7,s.IExtensionStoragePaths),Ne(8,v.IExtHostTunnelService),Ne(9,h.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function Q(oe,ie){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class V{constructor(ie,ue,he,Se){z.set(this,void 0),q.set(this,void 0),H.set(this,void 0),je(this,z,ie,"f"),je(this,q,ue,"f"),je(this,H,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=I.normalize((0,B.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=Se}get isActive(){return De(this,z,"f").isActivated(De(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,z,"f").getExtensionExports(De(this,H,"f"))}activate(){return De(this,z,"f").activateByIdWithErrors(De(this,H,"f"),{startup:!1,extensionId:De(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=V,z=new WeakMap,q=new WeakMap,H=new WeakMap;function te(oe){const ie=oe.indexOf("+");return ie===-1?oe:oe.substring(0,ie)}}),define(ve[98],Ee([1,0,17,2,5,11,4,7,158,31,33,49,166,32,160,14,3,13,86,66]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let m=class{constructor(c,v,h,p,k,A){this._workspaceService=v,this._extensionService=h,this._editorsService=p,this._configurationService=k,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(w=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,v){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let p=`debug:${encodeURIComponent(h.path||"")}`,k="?";return v&&(p+=`${k}session=${encodeURIComponent(v.id)}`,k="&"),p+=`${k}ref=${h.sourceReference}`,I.URI.parse(p)}else{if(h.path)return I.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const v=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const p=h.contributes.debuggers;if(p&&p.length>0)for(const k of p)(0,a.isDebuggerMainContribution)(k)&&v.push(k.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(v=>c.push(v)),c}addBreakpoints(c){this.startBreakpoints();const v=c.filter(k=>{const A=k.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,k),!0)});this.fireBreakpointChanges(v,[],[]);const h=[],p=new Map;for(const k of v)if(k instanceof T.SourceBreakpoint){let A=p.get(k.location.uri.toString());A||(A={type:"sourceMulti",uri:k.location.uri,lines:[]},p.set(k.location.uri.toString(),A),h.push(A)),A.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof T.FunctionBreakpoint&&h.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const v=c.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],v,[]);const h=v.filter(A=>A instanceof T.SourceBreakpoint).map(A=>A.id),p=v.filter(A=>A instanceof T.FunctionBreakpoint).map(A=>A.id),k=v.filter(A=>A instanceof T.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(h,p,k)}startDebugging(c,v,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,v,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,v,h){if(!v)return new T.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:p,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,p),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(c,v,h){if(!h)return new T.Disposable(()=>{});if(!this.definesDebugType(c,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:p,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,p),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(c,v){if(!v)return new T.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:v}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==v)})}async $runInTerminal(c,v){return Promise.resolve(void 0)}async $substituteVariables(c,v){if(!this._variableResolver){const[k,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,A)}let h;const p=await this.getFolder(c);return p&&(h={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,v)}createDebugAdapter(c,v){if(c.type==="implementation")return new i(c.implementation)}createSignService(){}async $startDASession(c,v){const h=this,p=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const A=this.convertToDto(k),x=this.createDebugAdapter(A,p);if(!x)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const w=x;return this._debugAdapters.set(c,w),this.getDebugAdapterTrackers(p).then(z=>(z&&this._debugAdaptersTrackers.set(c,z),w.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const H=q,W={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Q=await this._signService.sign(H.arguments.value);W.body={signature:Q},w.sendResponse(W)}else throw new Error("no signer")}catch(Q){W.success=!1,W.message=Q.message,w.sendResponse(W)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(q),q=(0,a.convertToVSCPaths)(q,!0),h._debugServiceProxy.$acceptDAMessage(c,q)}),w.onError(q=>{z&&z.onError&&z.onError(q),this._debugServiceProxy.$acceptDAError(c,q.name,q.message,q.stack)}),w.onExit(q=>{z&&z.onExit&&z.onExit((0,S.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,S.withNullAsUndefined)(q),void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),w.startSession()))})}$sendDAMessage(c,v){v=(0,a.convertToDAPaths)(v,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(v);const p=this._debugAdapters.get(c);p&&p.sendMessage(v)}$stopDASession(c){const v=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),v&&v.onWillStopSession&&v.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const v=[],h=[],p=[];if(c.added)for(const k of c.added){const A=k.id;if(A&&!this._breakpoints.has(A)){let x;if(k.type==="function")x=new T.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")x=new T.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const w=I.URI.revive(k.uri);x=new T.SourceBreakpoint(new T.Location(w,new T.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}x._id=A,this._breakpoints.set(A,x),v.push(x)}}if(c.removed)for(const k of c.removed){const A=this._breakpoints.get(k);A&&(this._breakpoints.delete(k),h.push(A))}if(c.changed){for(const k of c.changed)if(k.id){const A=this._breakpoints.get(k.id);if(A){if(A instanceof T.FunctionBreakpoint&&k.type==="function"){const x=A;x.enabled=k.enabled,x.condition=k.condition,x.hitCondition=k.hitCondition,x.logMessage=k.logMessage,x.functionName=k.functionName}else if(A instanceof T.SourceBreakpoint&&k.type==="source"){const x=A;x.enabled=k.enabled,x.condition=k.condition,x.hitCondition=k.hitCondition,x.logMessage=k.logMessage,x.location=new T.Location(I.URI.revive(k.uri),new T.Position(k.line,k.character))}p.push(A)}}}this.fireBreakpointChanges(v,h,p)}$provideDebugConfigurations(c,v,h){return(0,B.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(v);return p.provideDebugConfigurations(k,h)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(c,v,h,p){return(0,B.asPromise)(async()=>{const k=this.getConfigProviderByHandle(c);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(v);return k.resolveDebugConfiguration(A,h,p)})}$resolveDebugConfigurationWithSubstitutedVariables(c,v,h,p){return(0,B.asPromise)(async()=>{const k=this.getConfigProviderByHandle(c);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(v);return k.resolveDebugConfigurationWithSubstitutedVariables(A,h,p)})}async $provideDebugAdapter(c,v){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(v);return this.getAdapterDescriptor(h,p).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(c){const v=await this.getSession(c);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(c){const v=await this.getSession(c);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,v){const h=await this.getSession(c);h&&h._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(c,v){const p={session:await this.getSession(c),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(c){if(c instanceof T.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof T.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const v=this._adapterFactories.filter(h=>h.type===c);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(c){const v=this._adapterFactories.filter(h=>h.handle===c);if(v.length>0)return v[0].factory}getConfigProviderByHandle(c){const v=this._configProviders.filter(h=>h.handle===c);if(v.length>0)return v[0].provider}definesDebugType(c,v){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const p of h)if(p.label&&p.type&&p.type===v)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,p=this._trackerFactories.filter(k=>k.type===h||k.type==="*").map(k=>(0,B.asPromise)(()=>k.factory.createDebugAdapterTracker(c)).then(A=>A,A=>null));return Promise.race([Promise.all(p).then(k=>{const A=k.filter(x=>!!x);if(A.length>0)return new u(A)}),new Promise((k,A)=>{const x=setTimeout(()=>{clearTimeout(x),A(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(c,v){const h=v.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new T.DebugAdapterServer(h));if(c){const k=await this._extensionService.getExtensionRegistry();return(0,B.asPromise)(()=>c.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,k))).then(A=>{if(A)return A})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,p))}daExecutableFromPackage(c,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,v,h){(c.length>0||v.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:v,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const v=this._debugSessions.get(c);if(v)return v}else{let v=this._debugSessions.get(c.id);if(!v){const h=await this.getFolder(c.folderUri),p=c.parent?this._debugSessions.get(c.parent):void 0;v=new E(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,p),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(c){if(c){const v=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};m=Fe([Ne(0,n.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,M.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,f.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class E{constructor(c,v,h,p,k,A,x){this._debugServiceProxy=c,this._id=v,this._type=h,this._name=p,this._workspaceFolder=k,this._configuration=A,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,v)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=E;class r{constructor(c){this.value=Object.freeze({append(v){c.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=r;class P extends l.AbstractVariableResolverService{constructor(c,v,h,p,k,A){function x(){if(v){const w=v.activeEditor();if(w)return w.document.uri;const z=p.tabs.filter(q=>q.isActive);if(z.length>0){const q=z[0].resource;return q&&(q.primary||q.secondary)?q.primary??q.secondary:z[0].resource}}}super({getFolderUri:w=>{const z=c.filter(q=>q.name===w);if(z&&z.length>0)return z[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(w,z)=>h.getConfiguration(void 0,w).get(z),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const w=x();if(w)return o.normalize(w.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const w=x();if(w){const z=k.getWorkspaceFolder(w);if(z)return o.normalize(z.uri.fsPath)}}},getSelectedText:()=>{if(v){const w=v.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(v){const w=v.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,A?Promise.resolve(A):void 0,Promise.resolve(N.env))}}e.ExtHostVariableResolverService=P;class u{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(v=>v.onError?v.onError(c):void 0)}onExit(c,v){this.trackers.forEach(h=>h.onExit?h.onExit(c,v):void 0)}}class i extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends m{constructor(c,v,h,p,k,A){super(c,v,h,p,k,A)}createVariableResolver(c,v,h){return new P(c,v,h,this._editorTabs)}};s=Fe([Ne(0,n.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,M.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,f.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(ve[217],Ee([1,0,69,2,4,32,27,25,14,28,3,33,86,12,10]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(E,r,P,u,i,s,t){this._apiFactory=E,this._extensionRegistry=r,this._instaService=P,this._extHostConfiguration=u,this._extHostExtensionService=i,this._initData=s,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const E=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new S(this._apiFactory,r,this._extensionRegistry,E,this._logService)),this.register(this._instaService.createInstance(N,r)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,r,this._initData.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(let r of E.nodeModuleName)this._factories.set(r,E);else this._factories.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this._alternatives.push(r=>E.alternativeModuleName(r))}};n=Fe([Ne(2,M.IInstantiationService),Ne(3,B.IExtHostConfiguration),Ne(4,b.IExtHostExtensionService),Ne(5,R.IExtHostInitDataService),Ne(6,g.ILogService)],n),e.RequireInterceptor=n;let d=class Hi{constructor(E){if(E.environment.appRoot&&Hi.aliased.size){const r=(0,a.escapeRegExpCharacters)(this.forceForwardSlashes(E.environment.appRoot.fsPath)),P="[a-z0-9_.-]",u=`@${P}+\\/${P}+|${P}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${i}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(E){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(E));if(!r)return;const[,P,u,i]=r,s=Hi.aliased.get(u);if(s!==void 0)return console.warn(`${u} as been renamed to ${s}, please update your imports`),P+s+i}forceForwardSlashes(E){return E.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=Fe([Ne(0,R.IExtHostInitDataService)],d);class S{constructor(E,r,P,u,i){this._apiFactory=E,this._extensionPaths=r,this._extensionRegistry=P,this._configProvider=u,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(E,r){const P=this._extensionPaths.findSubstr(r);if(P){let u=this._extApiImpl.get(T.ExtensionIdentifier.toKey(P.identifier));return u||(u=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(P.identifier),u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((i,s)=>u+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let N=class{constructor(E,r,P){this._extensionPaths=E,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(_.MainContext.MainThreadTelemetry);const{environment:u}=P,i=r.getProxy(_.MainContext.MainThreadKeytar);if(u.appRoot){let s=u.appRoot.fsPath;l.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,t)=>i.$getPassword(s,t),setPassword:(s,t,c)=>i.$setPassword(s,t,c),deletePassword:(s,t)=>i.$deletePassword(s,t),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(E,r){const P=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(E){const r=E.length;if(r<=7||!this.alternativeNames)return;const P=r-7;if((E.charAt(P)==="/"||E.charAt(P)==="\\")&&E.endsWith("keytar")&&(E=E.replace(/\\/g,"/"),this.alternativeNames.has(E)))return"keytar"}};N=Fe([Ne(1,C.IExtHostRpcService),Ne(2,R.IExtHostInitDataService)],N);let f=class{constructor(E,r,P){this._extensionPaths=E,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(_.MainContext.MainThreadTelemetry);const u=P.getProxy(_.MainContext.MainThreadWindow);this._impl=(i,s)=>{const t=I.URI.parse(i);return s?this.callOriginal(i,s):t.scheme==="http"||t.scheme==="https"?u.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?u.$openUri(t,i,{}):this.callOriginal(i,s)}}load(E,r,P){const u=this._extensionPaths.findSubstr(r);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=P(E),this._impl}callOriginal(E,r){return this.sendNoForwardTelemetry(),this._original(E,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=Fe([Ne(2,C.IExtHostRpcService)],f)}),define(ve[218],Ee([1,0,11,15,69,6,2,4,210,12,44,55,28,139,14,59,33,40]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class N{constructor(m,E,r,P,u){this._disposables=new B.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new C.RPCProtocol(m,null,P),E=N._transform(E,this._rpcProtocol);const i=new b.ServiceCollection(...(0,M.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:u}),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),i.set(n.IURITransformerService,new n.URITransformerService(P)),i.set(d.IHostUtils,r);const s=new g.InstantiationService(i,!0);this._disposables.add(s.invokeFunction(h=>h.get(S.IExtHostTerminalService))),this._disposables.add(s.invokeFunction(h=>h.get(d.IExtHostExtensionService))),this._logService=s.invokeFunction(h=>h.get(R.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=s.invokeFunction(h=>h.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(p,k)=>{let A="",x,w;for(const z of k)A+=`
	at ${z.toString()}`,w=z.getFileName(),!x&&w&&(x=h.findSubstr(y.URI.file(w)));return t.set(p,x),`${p.name||"Error"}: ${p.message||""}${A}`}});const c=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),v=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(h=>{const p=I.transformErrorForSerialization(h),k=t.get(h);k?c.$onExtensionRuntimeError(k.identifier,p):v.$onUnexpectedError(p)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const E=this._extensionService.deactivateAll();Promise.race([(0,o.timeout)(5e3),E]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(m,E){m.extensions.forEach(P=>P.extensionLocation=y.URI.revive(E.transformIncomingURIs(P.extensionLocation))),m.environment.appRoot=y.URI.revive(E.transformIncomingURIs(m.environment.appRoot));const r=m.environment.extensionDevelopmentLocationURI;return r&&(m.environment.extensionDevelopmentLocationURI=r.map(P=>y.URI.revive(E.transformIncomingURIs(P)))),m.environment.extensionTestsLocationURI=y.URI.revive(E.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=y.URI.revive(E.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=y.URI.revive(E.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=y.URI.revive(E.transformIncomingURIs(m.logsLocation)),m.logFile=y.URI.revive(E.transformIncomingURIs(m.logFile)),m.workspace=E.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=N}),define(ve[219],Ee([1,0,16,11,20,43,29,9,17,24,13,2,41]),function(J,e,o,I,_,B,y,T,C,R,M,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class g{constructor(m,E,r,P){this.query=m,this.provider=E,this.fileUtils=r,this.processType=P,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,E){const r=this.query.folderQueries||[],P=new _.CancellationTokenSource;return E.onCancellationRequested(()=>P.cancel()),new Promise((u,i)=>{this.collector=new n(m);let s=!1;const t=(c,v)=>{if(!s&&!this.isLimitHit){const h=this.resultSize(c);S(c)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,s=!0,P.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const p=this.resultSize(c);this.resultCount+=p,(p>0||!S(c))&&this.collector.add(c,v)}};Promise.all(r.map((c,v)=>this.searchInFolder(c,h=>t(h,v),P.token))).then(c=>{P.dispose(),this.collector.flush();const v=c.some(h=>!!h&&!!h.limitHit);u({limitHit:this.isLimitHit||v,messages:(0,o.flatten)(c.map(h=>h?.message?(0,M.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},c=>{P.dispose();const v=(0,B.toErrorMessage)(c);i(new Error(v))})})}resultSize(m){return S(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,E){const r=Array.isArray(m.ranges)?m.ranges:[m.ranges],P=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:r.slice(0,E),preview:{matches:P.slice(0,E),text:m.preview.text},uri:m.uri}}async searchInFolder(m,E,r){const P=new l.QueryGlobTester(this.query,m),u=[],i={report:c=>{if(!this.validateProviderResult(c))return;const v=m.folder.scheme===T.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(c.uri))):void 0,h=R.relativePath(m.folder,c.uri);if(h){const p=P.includedInQuery(h,C.basename(h),v);(0,I.isThenable)(p)?u.push(p.then(k=>{k&&E(c)})):p&&E(c)}}},s=this.getSearchOptionsForFolder(m),t=await this.provider.provideTextSearchResults(a(this.query.contentPattern),s,i,r);return u.length&&await Promise.all(u),t}validateProviderResult(m){if(S(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const E=(0,l.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),r=(0,l.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),P={folder:b.URI.from(m.folder),excludes:r,includes:E,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return P.usePCRE2=this.query.usePCRE2,P}}e.TextSearchManager=g;function a(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class n{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new N(512,E=>this.sendItems(E))}add(m,E){this._currentFileMatch&&(this._currentFolderIdx!==E||!R.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=E,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(d(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=n;function d(f){return S(f)?{preview:{matches:(0,o.mapArrayOrNot)(f.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:f.preview.text},ranges:(0,o.mapArrayOrNot)(f.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function S(f){return!!f.preview}e.extensionResultIsMatch=S;class N{constructor(m,E){this.maxBatchSize=m,this.cb=E,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,E){!m||this.addItemToBatch(m,E)}addItems(m,E){!m||this.addItemsToBatch(m,E)}addItemToBatch(m,E){this.batch.push(m),this.batchSize+=E,this.onUpdate()}addItemsToBatch(m,E){this.batch=this.batch.concat(m),this.batchSize+=E,this.onUpdate()}onUpdate(){this.totalNumberCompleted<N.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},N.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=N,N.TIMEOUT=4e3,N.START_BATCH_AFTER_COUNT=50}),define(ve[99],Ee([1,0,6,4,3,214,14,59,12,2,219]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let b=class{constructor(n,d,S){this.extHostRpc=n,this._uriTransformer=d,this._logService=S,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new B.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,d){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const S=this._handlePool++;return this._textSearchProvider.set(S,d),this._proxy.$registerTextSearchProvider(S,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(n,d){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const S=this._handlePool++;return this._fileSearchProvider.set(S,d),this._proxy.$registerFileSearchProvider(S,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(n,d,S,N){const f=l(S),m=this._fileSearchProvider.get(n);if(m)return this._fileSearchManager.fileSearch(f,m,E=>{this._proxy.$handleFileMatch(n,d,E.map(r=>r.resource))},N);throw new Error("unknown provider: "+n)}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,d,S,N){const f=this._textSearchProvider.get(n);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const m=l(S);return this.createTextSearchManager(m,f).search(r=>this._proxy.$handleTextMatch(n,d,r),N)}$enableExtensionHostSearch(){}createTextSearchManager(n,d){return new M.TextSearchManager(n,d,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};b=Fe([Ne(0,y.IExtHostRpcService),Ne(1,T.IURITransformerService),Ne(2,C.ILogService)],b),e.ExtHostSearch=b;function l(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(n=>R.URI.revive(n))}}e.reviveQuery=l;function g(a){return{...a,folder:R.URI.revive(a.folder)}}}),define(ve[220],Ee([1,0,44,94,31,92,32,39,49,40,97,98,99,67,58,65,95,50,30,64,83,66,193,12,175]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m,E,r,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(P.ILoggerService,r.ExtHostLoggerService),(0,o.registerSingleton)(P.ILogService,u.ExtHostLogService),(0,o.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService),(0,o.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,o.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,o.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,o.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,o.registerSingleton)(B.IExtHostDecorations,B.ExtHostDecorations),(0,o.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,o.registerSingleton)(N.IExtHostFileSystemInfo,N.ExtHostFileSystemInfo),(0,o.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,o.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,o.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,o.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask),(0,o.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,o.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,o.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,o.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,o.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,o.registerSingleton)(E.IExtHostEditorTabs,E.ExtHostEditorTabs)}),define(ve[221],Ee([1,0,44,3]),function(J,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,I.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const T=this._dragOperations.get(y);return this._dragOperations.delete(y),T}}addDragOperationTransfer(y,T){this._dragOperations.set(y,T)}}e.TreeViewsDragAndDropService=_,(0,o.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(ve[222],Ee([1,0,127,24,2,5,6,11,7,13,16,8,20,155,221]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(N,f){if((0,R.isString)(N))return{label:N};if(N&&typeof N=="object"&&typeof N.label=="string"){let m;return Array.isArray(N.highlights)&&(m=N.highlights.filter(E=>E.length===2&&typeof E[0]=="number"&&typeof E[1]=="number"),m=m.length?m:void 0),{label:N.label,highlights:m}}}class d{constructor(f,m,E){this._proxy=f,this.commands=m,this.logService=E,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeViewsDragAndDropService;function r(P){return P&&P.$treeViewId&&P.$treeItemHandle}m.registerArgumentProcessor({processArgument:P=>r(P)?this.convertArgument(P):Array.isArray(P)&&P.length>0?P.map(u=>r(u)?this.convertArgument(u):u):P})}registerTreeDataProvider(f,m,E){const r=this.createTreeView(f,{treeDataProvider:m},E);return{dispose:()=>r.dispose()}}createTreeView(f,m,E){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=m.dragAndDropController?.dropMimeTypes,P=m.dragAndDropController?.dragMimeTypes,u=!!m.dragAndDropController?.handleDrag,i=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:r,dragMimeTypes:P,hasHandleDrag:u}),s=this.createExtHostTreeView(f,m,E);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(t){s.message=t},get title(){return s.title},set title(t){s.title=t},get description(){return s.description},set description(t){s.description=t},reveal:(t,c)=>s.reveal(t,c),dispose:async()=>{await i,this.treeViews.delete(f),s.dispose()}}}$getChildren(f,m){const E=this.treeViews.get(f);return E?E.getChildren(m):Promise.reject(new Error((0,o.localize)(0,null,f)))}async $handleDrop(f,m,E,r,P,u,i){const s=this.treeViews.get(f);if(!s)return Promise.reject(new Error((0,o.localize)(1,null,f)));const t=g.TreeDataTransferConverter.toITreeDataTransfer(m);return u===f&&i&&await this.addAdditionalTransferItems(t,s,i,r,P),s.onDrop(t,E,r)}async addAdditionalTransferItems(f,m,E,r,P){const u=this.treeDragAndDropService.removeDragOperationTransfer(P);if(u)(await u)?.forEach((i,s)=>{i&&f.set(s,i)});else if(P&&m.handleDrag){const i=m.handleDrag(E,f,r);this.treeDragAndDropService.addDragOperationTransfer(P,i),await i}return f}async $handleDrag(f,m,E,r){const P=this.treeViews.get(f);if(!P)return Promise.reject(new Error((0,o.localize)(2,null,f)));const u=await this.addAdditionalTransferItems(new Map,P,m,r,E);if(!!u)return g.TreeDataTransferConverter.toTreeDataTransferDTO(u)}async $hasResolve(f){const m=this.treeViews.get(f);if(!m)throw new Error((0,o.localize)(3,null,f));return m.hasResolve}$resolve(f,m,E){const r=this.treeViews.get(f);if(!r)throw new Error((0,o.localize)(4,null,f));return r.resolveTreeItem(m,E)}$setExpanded(f,m,E){const r=this.treeViews.get(f);if(!r)throw new Error((0,o.localize)(5,null,f));r.setExpanded(m,E)}$setSelection(f,m){const E=this.treeViews.get(f);if(!E)throw new Error((0,o.localize)(6,null,f));E.setSelection(m)}$setVisible(f,m){const E=this.treeViews.get(f);if(!E)throw new Error((0,o.localize)(7,null,f));E.setVisible(m)}createExtHostTreeView(f,m,E){const r=new S(f,m,this._proxy,this.commands.converter,this.logService,E);return this.treeViews.set(f,r),r}convertArgument(f){const m=this.treeViews.get(f.$treeViewId);return m?m.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=d;class S extends y.Disposable{constructor(f,m,E,r,P,u){super();if(this.viewId=f,this.proxy=E,this.commands=r,this.logService=P,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new B.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new B.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new B.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new B.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new B.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,u.contributes&&u.contributes.views)for(const t in u.contributes.views)for(const c of u.contributes.views[t])c.id===f&&(this._title=c.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(t=>this._onDidChangeData.fire({message:!1,element:t}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,s;this._register(B.Event.debounce(this._onDidChangeData.event,(t,c)=>(t||(t={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(v=>s=v),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(c.element)?t.elements.push(...c.element):t.elements.push(c.element)),c.message&&(t.message=!0),t),200,!0)(({message:t,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=s;return i=null,this.refresh(c).then(()=>v())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,R.isUndefinedOrNull)(f))}async getChildren(f){const m=f?this.getExtensionElement(f):void 0;if(f&&!m)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let E=this.getChildrenNodes(f);return E||(E=await this.fetchChildrenNodes(m)),E?E.map(r=>r.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,m){m=m||{select:!0,focus:!1};const E=(0,R.isUndefinedOrNull)(m.select)?!0:m.select,r=(0,R.isUndefinedOrNull)(m.focus)?!1:m.focus,P=(0,R.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(u=>this.resolveTreeNode(f,u[u.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:u.map(s=>s.item)},{select:E,focus:r,expand:P})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:E,focus:r,expand:P})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,m){const E=this.getExtensionElement(f);E&&(m?this._onDidExpandElement.fire(Object.freeze({element:E})):this._onDidCollapseElement.fire(Object.freeze({element:E})))}setSelection(f){(0,M.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(f,m,E){const r=[];for(const P of f){const u=this.getExtensionElement(P);u&&r.push(u)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,m,E),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(f,m,E){const r=this.getExtensionElement(m);if(!!r)return(0,T.asPromise)(()=>this.dndController?.handleDrop(f,r,E))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,m){if(!this.dataProvider.resolveTreeItem)return;const E=this.elements.get(f);if(E){const r=this.nodes.get(E);if(r){const P=await this.dataProvider.resolveTreeItem(r.extensionItem,E,m)??r.extensionItem;return r.item.tooltip=this.getTooltip(P.tooltip),r.item.command=this.getCommand(r.disposableStore,P.command),r.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(m=>m?this.resolveUnknownParentChain(m).then(E=>this.resolveTreeNode(m,E[E.length-1]).then(r=>(E.push(r),E))):Promise.resolve([]))}resolveParent(f){const m=this.nodes.get(f);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,m){const E=this.nodes.get(f);return E?Promise.resolve(E):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(r=>this.createHandle(f,r,m,!0)).then(r=>this.getChildren(m?m.item.handle:void 0).then(()=>{const P=this.getExtensionElement(r);if(P){const u=this.nodes.get(P);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(f){if(f){let m;if(typeof f=="string"){const E=this.getExtensionElement(f);m=E?this.nodes.get(E):void 0}else m=f;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const m=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const E=f?this.nodes.get(f):void 0,r=await this.dataProvider.getChildren(f);if(m.token.isCancellationRequested)return;const P=await Promise.all((0,M.coalesce)(r||[]).map(async u=>{const i=await this.dataProvider.getTreeItem(u);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(u,i,E):null}));return m.token.isCancellationRequested?void 0:(0,M.coalesce)(P)}finally{m.dispose()}}refresh(f){if(f.some(E=>!E))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const E=this.getHandlesToRefresh(f);if(E.length)return this.refreshHandles(E)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const m=new Set,E=f.map(P=>this.nodes.get(P));for(const P of E)if(P&&!m.has(P.item.handle)){let u=P;for(;u&&u.parent&&E.findIndex(i=>u&&u.parent&&i&&i.item.handle===u.parent.item.handle)===-1;){const i=this.elements.get(u.parent.item.handle);u=i?this.nodes.get(i):void 0}u&&!u.parent&&m.add(P.item.handle)}const r=[];return m.forEach(P=>{const u=this.elements.get(P);if(u){const i=this.nodes.get(u);i&&(!i.parent||!m.has(i.parent.item.handle))&&r.push(P)}}),r}refreshHandles(f){const m={};return Promise.all(f.map(E=>this.refreshNode(E).then(r=>{r&&(m[E]=r.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(f){const m=this.getExtensionElement(f);if(m){const E=this.nodes.get(m);if(E)return this.clearChildren(m),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(r=>{if(r){const P=this.createTreeNode(m,r,E.parent);return this.updateNodeCache(m,P,E,E.parent),E.dispose(),P}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,m,E){const r=this.createTreeNode(f,m,E);if(m.id&&this.elements.has(r.item.handle))throw new Error((0,o.localize)(8,null,m.id));return this.addNodeToCache(f,r),this.addNodeToParentCache(r,E),r}getTooltip(f){return C.MarkdownString.isMarkdownString(f)?b.MarkdownString.from(f):f}getCommand(f,m){return m?this.commands.toInternal(m,f):void 0}createTreeNode(f,m,E){const r=new y.DisposableStore,P=this.createHandle(f,m,E),u=this.getLightIconPath(m);return{item:{handle:P,parentHandle:E?E.item.handle:void 0,label:n(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(r,m.command),contextValue:m.contextValue,icon:u,iconDark:this.getDarkIconPath(m)||u,themeIcon:this.getThemeIcon(m),collapsibleState:(0,R.isUndefinedOrNull)(m.collapsibleState)?C.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:E,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(f){return f.iconPath instanceof C.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:m,label:E,resourceUri:r},P,u){if(m)return`${S.ID_HANDLE_PREFIX}/${m}`;const i=n(E,this.extension),s=P?P.item.handle:S.LABEL_HANDLE_PREFIX;let t=i?i.label:r?(0,I.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const c=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,v=this.getChildrenNodes(P)||[];let h,p=0;do{if(h=`${s}/${p}:${t}`,u||!this.elements.has(h)||c===h)break;p++}while(p<=v.length);return h}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon))return typeof f.iconPath=="string"||_.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return _.URI.isUri(f)?f:_.URI.file(f)}addNodeToCache(f,m){this.elements.set(m.item.handle,f),this.nodes.set(f,m)}updateNodeCache(f,m,E,r){this.elements.delete(m.item.handle),this.nodes.delete(f),m.item.handle!==E.item.handle&&this.elements.delete(E.item.handle),this.addNodeToCache(f,m);const P=this.getChildrenNodes(r)||[],u=P.filter(i=>i.item.handle===E.item.handle)[0];u&&P.splice(P.indexOf(u),1,m)}addNodeToParentCache(f,m){m?(m.children||(m.children=[]),m.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const m=this.nodes.get(f);if(m){if(m.children)for(const E of m.children){const r=this.elements.get(E.item.handle);r&&this.clear(r)}m.children=void 0}}else this.clearAll()}clear(f){const m=this.nodes.get(f);if(m){if(m.children)for(const E of m.children){const r=this.elements.get(E.item.handle);r&&this.clear(r)}this.nodes.delete(f),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(ve[223],Ee([1,0,20,15,5,34,2,115,235,110,74,46,4,91,180,179,39,181,32,182,183,184,168,185,49,33,186,187,190,192,194,94,170,199,200,201,67,40,203,222,8,7,206,51,95,31,70,157,189,82,92,97,98,99,12,59,14,28,195,153,58,65,177,204,152,68,50,209,207,208,178,30,202,205,64,66,83,197,96,198,9,79,196,150,188,6,27,159]),function(J,e,o,I,_,B,y,T,C,R,M,b,l,g,a,n,d,S,N,f,m,E,r,P,u,i,s,t,c,v,h,p,k,A,x,w,z,q,H,W,Q,V,te,oe,ie,ue,he,Se,fe,ne,me,Ie,Ae,Ue,Ge,ge,de,L,F,D,O,$,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et,ke,tt,G,Y,ce,Re,$e,Ke,Qe,ht,_t,yt,Tt,Ve,pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ot=nt.get(L.IExtHostInitDataService),At=nt.get(Xe.IExtHostFileSystemInfo),Dt=nt.get(Me.IExtHostConsumerFileSystem),Ct=nt.get(i.IExtHostExtensionService),lt=nt.get(ue.IExtHostWorkspace),Ot=nt.get(Y.IExtHostTelemetry),Lt=nt.get(N.IExtHostConfiguration),Ft=nt.get(ge.IURITransformerService),se=nt.get(de.IExtHostRpcService),_e=nt.get(z.IExtHostStorage),le=nt.get(Ce.IExtensionStoragePaths),K=nt.get(Ge.ILoggerService),be=nt.get(Ge.ILogService),Te=nt.get(O.IExtHostTunnelService),Be=nt.get($.IExtHostApiDeprecationService),We=nt.get(ie.IExtHostWindow),st=nt.get(tt.IExtHostSecretState),ft=nt.get(G.IExtHostEditorTabs);se.set(l.ExtHostContext.ExtHostFileSystemInfo,At),se.set(l.ExtHostContext.ExtHostLogLevelServiceShape,K),se.set(l.ExtHostContext.ExtHostWorkspace,lt),se.set(l.ExtHostContext.ExtHostConfiguration,Lt),se.set(l.ExtHostContext.ExtHostExtensionService,Ct),se.set(l.ExtHostContext.ExtHostStorage,_e),se.set(l.ExtHostContext.ExtHostTunnelService,Te),se.set(l.ExtHostContext.ExtHostWindow,We),se.set(l.ExtHostContext.ExtHostSecretState,st),se.set(l.ExtHostContext.ExtHostTelemetry,Ot),se.set(l.ExtHostContext.ExtHostEditorTabs,ft);const Et=se.set(l.ExtHostContext.ExtHostDecorations,nt.get(me.IExtHostDecorations)),vt=se.set(l.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(u.IExtHostDocumentsAndEditors)),it=se.set(l.ExtHostContext.ExtHostCommands,nt.get(d.IExtHostCommands)),at=se.set(l.ExtHostContext.ExtHostTerminalService,nt.get(q.IExtHostTerminalService)),mt=se.set(l.ExtHostContext.ExtHostDebugService,nt.get(Ae.IExtHostDebugService)),Mt=se.set(l.ExtHostContext.ExtHostSearch,nt.get(Ue.IExtHostSearch)),ct=se.set(l.ExtHostContext.ExtHostTask,nt.get(Ie.IExtHostTask)),It=se.set(l.ExtHostContext.ExtHostOutputService,nt.get(p.IExtHostOutputService)),Ut=se.set(l.ExtHostContext.ExtHostUrls,new te.ExtHostUrls(se)),bt=se.set(l.ExtHostContext.ExtHostDocuments,new P.ExtHostDocuments(se,vt)),Bt=se.set(l.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(se,vt,be)),Wt=se.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(be,bt,se.getProxy(l.MainContext.MainThreadBulkEdits))),dt=se.set(l.ExtHostContext.ExtHostNotebook,new F.ExtHostNotebookController(se,it,vt,bt,le)),ei=se.set(l.ExtHostContext.ExtHostNotebookDocuments,new _t.ExtHostNotebookDocuments(be,dt)),Yt=se.set(l.ExtHostContext.ExtHostNotebookEditors,new ht.ExtHostNotebookEditors(be,se,dt)),ti=se.set(l.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(se,ot,dt,it,be)),oi=se.set(l.ExtHostContext.ExtHostNotebookRenderers,new $e.ExtHostNotebookRenderers(se,dt)),kt=se.set(l.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(se,vt)),ii=se.set(l.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(se.getProxy(l.MainContext.MainThreadTreeViews),it,be)),_i=se.set(l.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(se.getProxy(l.MainContext.MainThreadEditorInsets),kt,ot)),Gt=se.set(l.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(se,be,At)),Xt=se.set(l.ExtHostContext.ExtHostLanguages,new v.ExtHostLanguages(se,bt,it.converter,Ft)),rt=se.set(l.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(se,Ft,bt,it,Gt,be,Be)),ai=se.set(l.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(se,rt)),Vt=se.set(l.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(se,be,vt)),jt=se.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(se,lt,it)),ni=se.set(l.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(se,it,be)),Si=se.set(l.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(se,it,bt)),gi=se.set(l.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(se.getProxy(l.MainContext.MainThreadProgress))),yi=se.set(l.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(se)),pi=se.set(l.ExtHostContext.ExtHostTheming,new D.ExtHostTheming(se)),ri=se.set(l.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(se)),li=se.set(l.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(se,it)),Jt=se.set(l.ExtHostContext.ExtHostWebviews,new oe.ExtHostWebviews(se,{remote:ot.remote},lt,be,Be)),ci=se.set(l.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(se,Jt,lt)),Di=se.set(l.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(se,bt,le,Jt,ci)),Ci=se.set(l.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(se,Jt)),$t=se.set(l.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(se,it)),Ii=se.set(l.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(se));se.set(l.ExtHostContext.ExtHostInteractive,new yt.ExtHostInteractive(se,dt,vt,it));const ki=(0,he.values)(l.ExtHostContext);se.assertRegistered(ki);const Ti=new Oe.ExtHostBulkEdits(se,vt),ui=new n.ExtHostClipboard(se),di=new h.ExtHostMessageService(se,be),Qt=new m.ExtHostDialogs(se),Ht=new w.ExtHostStatusBar(se,it.converter);return a.ExtHostApiCommands.register(it),function(Pe,Rt,Zt){const ut=function(){let Z=!Pe.isUnderDevelopment;function ae(){Z||(be.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function ye(Ye){if(Array.isArray(Ye))Ye.forEach(ye);else if(typeof Ye=="string")ae();else{const gt=Ye;typeof gt.scheme=="undefined"&&ae(),typeof gt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return Ye}}(),Pi={getSession(Z,ae,ye){return ri.getSession(Pe,Z,ae,ye)},async hasSession(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,Z,ae,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,ae,ye,Ye){return ri.registerAuthenticationProvider(Z,ae,ye,Ye)}},Ai={registerCommand(Z,ae,ye){return it.registerCommand(!0,Z,ae,ye,void 0,Pe)},registerTextEditorCommand(Z,ae,ye){return it.registerCommand(!0,Z,(...Ye)=>{const gt=kt.getActiveTextEditor();if(!gt){be.warn("Cannot execute "+Z+" because there is no active text editor.");return}return gt.edit(St=>{ae.apply(ye,[gt,St,...Ye])}).then(St=>{St||be.warn("Edits from command "+Z+" were not applied.")},St=>{be.warn("An error occurred while running command "+Z,St)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Z,ae,ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"diffCommand"),it.registerCommand(!0,Z,async(...Ye)=>{const gt=vt.activeEditor(!0);if(!gt){be.warn("Cannot execute "+Z+" because there is no active text editor.");return}const St=await kt.getDiffInformation(gt.id);ae.apply(ye,[St,...Ye])},void 0,void 0,Pe)),executeCommand(Z,...ae){return it.executeCommand(Z,...ae)},getCommands(Z=!1){return it.getCommands(Z)}},vi={get machineId(){return ot.telemetryInfo.machineId},get sessionId(){return ot.telemetryInfo.sessionId},get language(){return ot.environment.appLanguage},get appName(){return ot.environment.appName},get appRoot(){return ot.environment.appRoot?.fsPath??""},get appHost(){return ot.environment.appHost},get uriScheme(){return ot.environment.appUriScheme},get clipboard(){return ui.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ot.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ot.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const Z=Date.now()-new Date(ot.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ae){return We.openUri(Z,{allowTunneling:!!ot.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ot.environment.appUriScheme)return Ut.createAppUri(Z);try{return await We.asExternalUri(Z,{allowTunneling:!!ot.remote.authority})}catch(ae){if((0,Qe.matchesScheme)(Z,Ke.Schemas.http)||(0,Qe.matchesScheme)(Z,Ke.Schemas.https))return Z;throw ae}},get remoteName(){return(0,ne.getRemoteName)(ot.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),ot.remote.authority},get uiKind(){return ot.uiKind}};ot.environment.extensionTestsLocationURI||Object.freeze(vi);const Ei=ot.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Ri={createTestController(Z,ae,ye){return ye&&(0,Ve.checkProposedApiEnabled)(Pe,"testRefresh"),$t.createTestController(Z,ae,ye)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.createTestObserver()},runTests(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.runTests(Z)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.results}},Oi={getExtension(Z){const ae=Rt.getExtensionDescription(Z);if(ae)return new i.Extension(Ct,Pe.identifier,ae,Ei)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new i.Extension(Ct,Pe.identifier,Z,Ei))},get onDidChange(){return Rt.onDidChange}},hi={createDiagnosticCollection(Z){return Gt.createDiagnosticCollection(Pe.identifier,Z)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:Z=>Gt.getDiagnostics(Z),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(Z,ae){return Xt.changeLanguage(Z.uri,ae)},match(Z,ae){return(0,M.score)(Q.LanguageSelector.from(Z),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(Z,ae,ye){return rt.registerCodeActionProvider(Pe,ut(Z),ae,ye)},registerCodeLensProvider(Z,ae){return rt.registerCodeLensProvider(Pe,ut(Z),ae)},registerDefinitionProvider(Z,ae){return rt.registerDefinitionProvider(Pe,ut(Z),ae)},registerDeclarationProvider(Z,ae){return rt.registerDeclarationProvider(Pe,ut(Z),ae)},registerImplementationProvider(Z,ae){return rt.registerImplementationProvider(Pe,ut(Z),ae)},registerTypeDefinitionProvider(Z,ae){return rt.registerTypeDefinitionProvider(Pe,ut(Z),ae)},registerHoverProvider(Z,ae){return rt.registerHoverProvider(Pe,ut(Z),ae,Pe.identifier)},registerEvaluatableExpressionProvider(Z,ae){return rt.registerEvaluatableExpressionProvider(Pe,ut(Z),ae,Pe.identifier)},registerInlineValuesProvider(Z,ae){return rt.registerInlineValuesProvider(Pe,ut(Z),ae,Pe.identifier)},registerDocumentHighlightProvider(Z,ae){return rt.registerDocumentHighlightProvider(Pe,ut(Z),ae)},registerLinkedEditingRangeProvider(Z,ae){return rt.registerLinkedEditingRangeProvider(Pe,ut(Z),ae)},registerReferenceProvider(Z,ae){return rt.registerReferenceProvider(Pe,ut(Z),ae)},registerRenameProvider(Z,ae){return rt.registerRenameProvider(Pe,ut(Z),ae)},registerDocumentSymbolProvider(Z,ae,ye){return rt.registerDocumentSymbolProvider(Pe,ut(Z),ae,ye)},registerWorkspaceSymbolProvider(Z){return rt.registerWorkspaceSymbolProvider(Pe,Z)},registerDocumentFormattingEditProvider(Z,ae){return rt.registerDocumentFormattingEditProvider(Pe,ut(Z),ae)},registerDocumentRangeFormattingEditProvider(Z,ae){return rt.registerDocumentRangeFormattingEditProvider(Pe,ut(Z),ae)},registerOnTypeFormattingEditProvider(Z,ae,ye,...Ye){return rt.registerOnTypeFormattingEditProvider(Pe,ut(Z),ae,[ye].concat(Ye))},registerDocumentSemanticTokensProvider(Z,ae,ye){return rt.registerDocumentSemanticTokensProvider(Pe,ut(Z),ae,ye)},registerDocumentRangeSemanticTokensProvider(Z,ae,ye){return rt.registerDocumentRangeSemanticTokensProvider(Pe,ut(Z),ae,ye)},registerSignatureHelpProvider(Z,ae,ye,...Ye){return typeof ye=="object"?rt.registerSignatureHelpProvider(Pe,ut(Z),ae,ye):rt.registerSignatureHelpProvider(Pe,ut(Z),ae,typeof ye=="undefined"?[]:[ye,...Ye])},registerCompletionItemProvider(Z,ae,...ye){return rt.registerCompletionItemProvider(Pe,ut(Z),ae,ye)},registerInlineCompletionItemProvider(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),rt.registerInlineCompletionsProvider(Pe,ut(Z),ae)},registerDocumentLinkProvider(Z,ae){return rt.registerDocumentLinkProvider(Pe,ut(Z),ae)},registerColorProvider(Z,ae){return rt.registerColorProvider(Pe,ut(Z),ae)},registerFoldingRangeProvider(Z,ae){return rt.registerFoldingRangeProvider(Pe,ut(Z),ae)},registerSelectionRangeProvider(Z,ae){return rt.registerSelectionRangeProvider(Pe,Z,ae)},registerCallHierarchyProvider(Z,ae){return rt.registerCallHierarchyProvider(Pe,Z,ae)},registerTypeHierarchyProvider(Z,ae){return rt.registerTypeHierarchyProvider(Pe,Z,ae)},setLanguageConfiguration:(Z,ae)=>rt.setLanguageConfiguration(Pe,Z,ae),getTokenInformationAtPosition(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"tokenInformation"),Xt.tokenAtPosition(Z,ae)},registerInlayHintsProvider(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"inlayHints"),rt.registerInlayHintsProvider(Pe,Z,ae)},createLanguageStatusItem(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"languageStatus"),Xt.createLanguageStatusItem(Pe,Z,ae)}},Fi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(Z,ae,ye){const Ye=await(y.URI.isUri(Z)?Promise.resolve(bi.openTextDocument(Z)):Promise.resolve(Z));return kt.showTextDocument(Ye,ae,ye)},createTextEditorDecorationType(Z){return kt.createTextEditorDecorationType(Pe,Z)},onDidChangeActiveTextEditor(Z,ae,ye){return kt.onDidChangeActiveTextEditor(Z,ae,ye)},onDidChangeVisibleTextEditors(Z,ae,ye){return kt.onDidChangeVisibleTextEditors(Z,ae,ye)},onDidChangeTextEditorSelection(Z,ae,ye){return kt.onDidChangeTextEditorSelection(Z,ae,ye)},onDidChangeTextEditorOptions(Z,ae,ye){return kt.onDidChangeTextEditorOptions(Z,ae,ye)},onDidChangeTextEditorVisibleRanges(Z,ae,ye){return kt.onDidChangeTextEditorVisibleRanges(Z,ae,ye)},onDidChangeTextEditorViewColumn(Z,ae,ye){return kt.onDidChangeTextEditorViewColumn(Z,ae,ye)},onDidCloseTerminal(Z,ae,ye){return at.onDidCloseTerminal(Z,ae,ye)},onDidOpenTerminal(Z,ae,ye){return at.onDidOpenTerminal(Z,ae,ye)},onDidChangeActiveTerminal(Z,ae,ye){return at.onDidChangeActiveTerminal(Z,ae,ye)},onDidChangeTerminalDimensions(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(Z,ae,ye)},onDidChangeTerminalState(Z,ae,ye){return at.onDidChangeTerminalState(Z,ae,ye)},onDidWriteTerminalData(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(Z,ae,ye)},get state(){return We.state},onDidChangeWindowState(Z,ae,ye){return We.onDidChangeWindowState(Z,ae,ye)},showInformationMessage(Z,...ae){return di.showMessage(Pe,B.default.Info,Z,ae[0],ae.slice(1))},showWarningMessage(Z,...ae){return di.showMessage(Pe,B.default.Warning,Z,ae[0],ae.slice(1))},showErrorMessage(Z,...ae){return di.showMessage(Pe,B.default.Error,Z,ae[0],ae.slice(1))},showQuickPick(Z,ae,ye){return jt.showQuickPick(Z,ae,ye)},showWorkspaceFolderPick(Z){return jt.showWorkspaceFolderPick(Z)},showInputBox(Z,ae){return jt.showInput(Z,ae)},showOpenDialog(Z){return Qt.showOpenDialog(Z)},showSaveDialog(Z){return Qt.showSaveDialog(Z)},createStatusBarItem(Z,ae,ye){let Ye,gt,St;return typeof Z=="string"?(Ye=Z,gt=ae,St=ye):(gt=Z,St=ae),Ht.createStatusBarEntry(Pe,Ye,gt,St)},setStatusBarMessage(Z,ae){return Ht.setStatusBarMessage(Z,ae)},withScmProgress(Z){return Be.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),gi.withProgress(Pe,{location:V.ProgressLocation.SourceControl},(ae,ye)=>Z({report(Ye){}}))},withProgress(Z,ae){return gi.withProgress(Pe,Z,ae)},createOutputChannel(Z){return It.createOutputChannel(Z,Pe)},createWebviewPanel(Z,ae,ye,Ye){return ci.createWebviewPanel(Pe,Z,ae,ye,Ye)},createWebviewTextEditorInset(Z,ae,ye,Ye){return(0,Ve.checkProposedApiEnabled)(Pe,"editorInsets"),_i.createWebviewEditorInset(Z,ae,ye,Ye,Pe)},createTerminal(Z,ae,ye){return typeof Z=="object"?"pty"in Z?at.createExtensionTerminal(Z):at.createTerminalFromOptions(Z):at.createTerminal(Z,ae,ye)},registerTerminalLinkProvider(Z){return at.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,ae){return at.registerProfileProvider(Pe,Z,ae)},registerTreeDataProvider(Z,ae){return ii.registerTreeDataProvider(Z,ae,Pe)},createTreeView(Z,ae){return ii.createTreeView(Z,ae,Pe)},registerWebviewPanelSerializer:(Z,ae)=>ci.registerWebviewPanelSerializer(Pe,Z,ae),registerCustomEditorProvider:(Z,ae,ye={})=>Di.registerCustomEditorProvider(Pe,Z,ae,ye),registerFileDecorationProvider(Z){return Et.registerFileDecorationProvider(Z,Pe.identifier)},registerUriHandler(Z){return Ut.registerUriHandler(Pe.identifier,Z)},createQuickPick(){return jt.createQuickPick(Pe)},createInputBox(){return jt.createInputBox(Pe.identifier)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(Z,ae,ye){return pi.onDidChangeActiveColorTheme(Z,ae,ye)},registerWebviewViewProvider(Z,ae,ye){return Ci.registerWebviewViewProvider(Pe,Z,ae,ye?.webviewOptions)},get activeNotebookEditor(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeActiveNotebookEditor(Z,ae,ye)},get visibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(Z,ae,ye)},onDidChangeNotebookEditorVisibleRanges(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(Z,ae,ye)},showNotebookDocument(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.showNotebookDocument(Z,ae)},registerExternalUriOpener(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"externalUriOpener"),Ii.registerExternalUriOpener(Pe.identifier,Z,ae,ye)},get tabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.tabs},get activeTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.activeTab},get onDidChangeTabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),c.InlineCompletionController.get(Z)}},bi={get rootPath(){return Be.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(Z){throw I.readonly()},getWorkspaceFolder(Z){return lt.getWorkspaceFolder(Z)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(Z){throw I.readonly()},get workspaceFile(){return lt.workspaceFile},set workspaceFile(Z){throw I.readonly()},updateWorkspaceFolders:(Z,ae,...ye)=>lt.updateWorkspaceFolders(Pe,Z,ae||0,...ye),onDidChangeWorkspaceFolders:function(Z,ae,ye){return lt.onDidChangeWorkspace(Z,ae,ye)},asRelativePath:(Z,ae)=>lt.getRelativePath(Z,ae),findFiles:(Z,ae,ye,Ye)=>lt.findFiles(Z,ae,ye,Pe.identifier,Ye),findTextInFiles:(Z,ae,ye,Ye)=>{(0,Ve.checkProposedApiEnabled)(Pe,"findTextInFiles");let gt,St;return typeof ae=="object"?(gt=ae,St=ye):(gt={},St=ae,Ye=ye),lt.findTextInFiles(Z,gt||{},St,Pe.identifier,Ye)},saveAll:Z=>lt.saveAll(Z),applyEdit(Z){return Ti.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ae,ye,Ye)=>Vt.createFileSystemWatcher(lt,Pe,Z,ae,ye,Ye),get textDocuments(){return bt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw I.readonly()},openTextDocument(Z){let ae;const ye=Z;if(typeof Z=="string")ae=Promise.resolve(y.URI.file(Z));else if(y.URI.isUri(Z))ae=Promise.resolve(Z);else if(!ye||typeof ye=="object")ae=bt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(Ye=>bt.ensureDocumentData(Ye).then(gt=>gt.document))},onDidOpenTextDocument:(Z,ae,ye)=>bt.onDidAddDocument(Z,ae,ye),onDidCloseTextDocument:(Z,ae,ye)=>bt.onDidRemoveDocument(Z,ae,ye),onDidChangeTextDocument:(Z,ae,ye)=>bt.onDidChangeDocument(Z,ae,ye),onDidSaveTextDocument:(Z,ae,ye)=>bt.onDidSaveDocument(Z,ae,ye),onWillSaveTextDocument:(Z,ae,ye)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(Z,ae,ye),get notebookDocuments(){return dt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,ae){let ye;if(y.URI.isUri(Z))ye=Z,await dt.openNotebookDocument(Z);else if(typeof Z=="string")ye=y.URI.revive(await dt.createNotebookDocument({viewType:Z,content:ae}));else throw new Error("Invalid arguments");return dt.getNotebookDocument(ye).apiNotebook},get onDidOpenNotebookDocument(){return dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return dt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,ae,ye,Ye){return dt.registerNotebookSerializer(Pe,Z,ae,ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ye:void 0)},registerNotebookContentProvider:(Z,ae,ye,Ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"notebookContentProvider"),dt.registerNotebookContentProvider(Pe,Z,ae,ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ye:void 0)),onDidChangeConfiguration:(Z,ae,ye)=>Zt.onDidChangeConfiguration(Z,ae,ye),getConfiguration(Z,ae){return ae=arguments.length===1?void 0:ae,Zt.getConfiguration(Z,ae,Pe)},registerTextDocumentContentProvider(Z,ae){return Bt.registerTextDocumentContentProvider(Z,ae)},registerTaskProvider:(Z,ae)=>(Be.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),ct.registerTaskProvider(Pe,Z,ae)),registerFileSystemProvider(Z,ae,ye){return(0,Tt.combinedDisposable)(ai.registerFileSystemProvider(Pe,Z,ae,ye),Dt.addFileSystemProvider(Z,ae))},get fs(){return Dt.value},registerFileSearchProvider:(Z,ae)=>((0,Ve.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(Z,ae)),registerTextSearchProvider:(Z,ae)=>((0,Ve.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(Z,ae)),registerRemoteAuthorityResolver:(Z,ae)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Ct.registerRemoteAuthorityResolver(Z,ae)),registerResourceLabelFormatter:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),yi.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ae,ye)=>Vt.onDidCreateFile(Z,ae,ye),onDidDeleteFiles:(Z,ae,ye)=>Vt.onDidDeleteFile(Z,ae,ye),onDidRenameFiles:(Z,ae,ye)=>Vt.onDidRenameFile(Z,ae,ye),onWillCreateFiles:(Z,ae,ye)=>Vt.getOnWillCreateFileEvent(Pe)(Z,ae,ye),onWillDeleteFiles:(Z,ae,ye)=>Vt.getOnWillDeleteFileEvent(Pe)(Z,ae,ye),onWillRenameFiles:(Z,ae,ye)=>Vt.getOnWillRenameFileEvent(Pe)(Z,ae,ye),openTunnel:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.openTunnel(Pe,Z).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.getTunnels()},onDidChangeTunnels:(Z,ae,ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.onDidChangeTunnels(Z,ae,ye)),registerPortAttributesProvider:(Z,ae)=>((0,Ve.checkProposedApiEnabled)(Pe,"portsAttributes"),Te.registerPortsAttributesProvider(Z,ae)),registerTimelineProvider:(Z,ae)=>((0,Ve.checkProposedApiEnabled)(Pe,"timeline"),li.registerTimelineProvider(Z,ae,Pe.identifier,it.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"workspaceTrust"),lt.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ae,ye)=>lt.onDidGrantWorkspaceTrust(Z,ae,ye)},Mi={get inputBox(){return Be.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(Z,ae,ye){return ni.createSourceControl(Pe,Z,ae,ye)}},Ni={createCommentController(Z,ae){return Si.createCommentController(Pe,Z,ae)}},Li={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(Z,ae,ye){return mt.onDidStartDebugSession(Z,ae,ye)},onDidTerminateDebugSession(Z,ae,ye){return mt.onDidTerminateDebugSession(Z,ae,ye)},onDidChangeActiveDebugSession(Z,ae,ye){return mt.onDidChangeActiveDebugSession(Z,ae,ye)},onDidReceiveDebugSessionCustomEvent(Z,ae,ye){return mt.onDidReceiveDebugSessionCustomEvent(Z,ae,ye)},onDidChangeBreakpoints(Z,ae,ye){return mt.onDidChangeBreakpoints(Z,ae,ye)},registerDebugConfigurationProvider(Z,ae,ye){return mt.registerDebugConfigurationProvider(Z,ae,ye||pt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ae){return mt.registerDebugAdapterDescriptorFactory(Pe,Z,ae)},registerDebugAdapterTrackerFactory(Z,ae){return mt.registerDebugAdapterTrackerFactory(Z,ae)},startDebugging(Z,ae,ye){return!ye||typeof ye=="object"&&"configuration"in ye?mt.startDebugging(Z,ae,{parentSession:ye}):mt.startDebugging(Z,ae,ye||{})},stopDebugging(Z){return mt.stopDebugging(Z)},addBreakpoints(Z){return mt.addBreakpoints(Z)},removeBreakpoints(Z){return mt.removeBreakpoints(Z)},asDebugSourceUri(Z,ae){return mt.asDebugSourceUri(Z,ae)}},Ui={registerTaskProvider:(Z,ae)=>ct.registerTaskProvider(Pe,Z,ae),fetchTasks:Z=>ct.fetchTasks(Z),executeTask:Z=>ct.executeTask(Pe,Z),get taskExecutions(){return ct.taskExecutions},onDidStartTask:(Z,ae,ye)=>ct.onDidStartTask(Z,ae,ye),onDidEndTask:(Z,ae,ye)=>ct.onDidEndTask(Z,ae,ye),onDidStartTaskProcess:(Z,ae,ye)=>ct.onDidStartTaskProcess(Z,ae,ye),onDidEndTaskProcess:(Z,ae,ye)=>ct.onDidEndTaskProcess(Z,ae,ye)},Bi={createNotebookController(Z,ae,ye,Ye,gt){return ti.createNotebookController(Pe,Z,ae,ye,Ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,ae)=>dt.registerNotebookCellStatusBarItemProvider(Pe,Z,ae),get onDidSaveNotebookDocument(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return oi.createRendererMessaging(Pe,Z)},onDidChangeNotebookDocumentMetadata(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(Z,ae,ye)},onDidChangeNotebookCells(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeNotebookCells(Z,ae,ye)},onDidChangeNotebookCellExecutionState(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(Z,ae,ye)},onDidChangeCellOutputs(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeCellOutputs(Z,ae,ye)},onDidChangeCellMetadata(Z,ae,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeCellMetadata(Z,ae,ye)},createConcatTextDocument(Z,ae){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new pe.ExtHostNotebookConcatDocument(dt,bt,Z,ae)}};return{version:ot.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:vi,extensions:Oi,languages:hi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:Fi,workspace:bi,Breakpoint:V.Breakpoint,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:pt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestions,Hover:V.Hover,IndentAction:R.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:g.UIKind,Uri:y.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Re.TextSearchCompleteMessageType,TreeDataTransfer:V.TreeDataTransfer,TreeDataTransferItem:V.TreeDataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(ve[224],Ee([1,0,223,33,217,7,11,4,9]),function(J,e,o,I,_,B,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends _.RequireInterceptor{_installInterceptor(){}getModule(a,n){for(let d of this._alternatives){let S=d(a);if(S){a=S;break}}if(this._factories.has(a))return this._factories.get(a).load(a,n,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=B.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);l(a,this._initData.environment.isExtensionDevelopmentDebug);const n=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,n,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,n,d){n=n.with({path:b(n.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const S=await fetch(C.FileAccess.asBrowserUri(n).toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),S.status!==200)throw new Error(S.statusText);const N=await S.text(),f=`${n.toString(!0)}#vscode-extension`,m=`${N}
//# sourceURL=${f}`;let E;try{E=new Function("module","exports","require",m)}catch(i){throw console.error(a?`Loading code for extension ${a.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${n.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const r={},P={exports:r},u=i=>{const s=this._fakeModules.getModule(i,n);if(s===void 0)throw new Error(`Cannot load module '${i}'`);return s};try{return d.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),E(P,r,u),P.exports!==r?P.exports:r}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(a){}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const n=Date.now()+a;for(;Date.now()<n&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}e.ExtHostExtensionService=M;function b(g,a){return g.endsWith(a)?g:g+a}function l(g,a){n("info","log"),n("log","log"),n("warn","warn"),n("error","error");function n(N,f){const m=console[N];console[N]=function(){g.$logExtensionHostMessage({type:"__$console",severity:f,arguments:S(arguments)}),a&&m.apply(console,arguments)}}const d=1e5;function S(N){const f=[],m=[];if(N.length)for(let E=0;E<N.length;E++){if(typeof N[E]=="undefined")N[E]="undefined";else if(N[E]instanceof Error){const r=N[E];r.stack?N[E]=r.stack:N[E]=r.toString()}m.push(N[E])}try{const E=JSON.stringify(m,function(r,P){if(P&&typeof P=="object"){if(f.indexOf(P)!==-1)return"[Circular]";f.push(P)}return P});return E.length>d?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}}),define(ve[225],Ee([1,0,44,33,68,224]),function(J,e,o,I,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(I.IExtHostExtensionService,B.ExtHostExtensionService),(0,o.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(ve[236],Ee([1,0,21,5,91,218,211,17,69,9,2,220,225]),function(J,e,o,I,_,B,y,T,C,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const g=fetch.bind(self);if(self.fetch=function(m,E){return m instanceof Request||/^file:/i.test(String(m))&&(m=R.FileAccess.asBrowserUri(M.URI.parse(String(m))).toString(!0)),g(m,E)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,E,r,P,u){return/^file:/i.test(E.toString())&&(E=R.FileAccess.asBrowserUri(M.URI.parse(E.toString())).toString(!0)),super.open(m,E,r??!0,P,u)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const m=self.Worker;Worker=function(E,r){/^file:/i.test(E.toString())&&(E=R.FileAccess.asBrowserUri(M.URI.parse(E.toString())).toString(!0));const u=`(${function(c){function v(k){return typeof k=="string"||k instanceof URL?String(k).replace(/^file:\/\//i,"vscode-file://vscode-app"):k}const h=fetch.bind(self);self.fetch=function(k,A){return k instanceof Request?h(k,A):h(v(k),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,A,x,w,z){return super.open(k,v(A),x??!0,w,z)}};const p=importScripts.bind(self);self.importScripts=(...k)=>{p(...k.map(v))},p(c)}.toString()}('${E}'))`;r=r||{},r.name=r.name||T.basename(E.toString());const i=new Blob([u],{type:"application/javascript"}),s=URL.createObjectURL(i);return new m(s,r)}}else self.Worker=class extends y.NestedWorker{constructor(m,E){super(l,m,{name:T.basename(m.toString()),...E})}};const a=new class{constructor(){this.pid=void 0}exit(m){b()}async exists(m){return!0}async realpath(m){return m}};class n{constructor(){const E=new MessageChannel,r=new I.Emitter;let P=!1;l(E.port2,[E.port2]),E.port1.onmessage=u=>{const{data:i}=u;if(!(i instanceof ArrayBuffer)){console.warn("UNKNOWN data received",i);return}const s=o.VSBuffer.wrap(new Uint8Array(i,0,i.byteLength));if((0,_.isMessageOfType)(s,2)){P=!0,S("received terminate message from renderer");return}r.fire(s)},this.protocol={onMessage:r.event,send:u=>{if(!P){const i=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);E.port1.postMessage(i,[i])}}}}}function d(m){return new Promise(E=>{const r=m.onMessage(P=>{r.dispose();const u=JSON.parse(P.toString());m.send((0,_.createMessageOfType)(0)),E({protocol:m,initData:u})});m.send((0,_.createMessageOfType)(1))})}let S=m=>b();function N(m){return!!m&&typeof m=="object"&&m.type==="vscode.init"&&m.data instanceof Map}function f(){C.mark("code/extHost/willConnectToRenderer");const m=new n;return{onmessage(E){!N(E)||d(m.protocol).then(r=>{C.mark("code/extHost/didWaitForInitData");const P=new B.ExtensionHostMain(r.protocol,r.initData,a,null,E.data);S=u=>P.terminate(u)})}}}e.create=f})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8c36556a2c305327f5417dc7f93220f39ed608f/core/vs/workbench/api/worker/extensionHostWorker.js.map
